/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/resources","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/base/common/network","vs/platform/telemetry/common/telemetry","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/request/common/request","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ae=function(_){for(var e=[],R=0,i=_.length;R<i;R++)e[R]=re[_[R]];return e};define(re[52],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function R(k){return k?k.replace(/\$\((.*?)\)/g,(L,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=R;class i{constructor(L,P,I){this.id=L,this.definition=P,this.description=I,i.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i.a}}e.Codicon=i,i.a=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);var D;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const L=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function P(E){if(E instanceof i)return["codicon","codicon-"+E.id];const b=L.exec(E.id);if(!b)return P(i.error);const[,v,p]=b,d=["codicon","codicon-"+v];return p&&d.push("codicon-modifier-"+p.substring(1)),d}k.asClassNameArray=P;function I(E){return P(E).join(" ")}k.asClassName=I;function S(E){return"."+P(E).join(".")}k.asCSSSelector=S})(D=e.CSSIcon||(e.CSSIcon={}))}),define(re[63],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function R(L){return(P,I,S)=>{let E=null,b=null;if(typeof S.value=="function"?(E="value",b=S.value):typeof S.get=="function"&&(E="get",b=S.get),!b)throw new Error("not supported");S[E]=L(b,I)}}function i(L,P,I){let S=null,E=null;if(typeof I.value=="function"?(S="value",E=I.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(S="get",E=I.get),!E)throw new Error("not supported");const b=`$memoize$${P}`;I[S]=function(...v){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,v)}),this[b]}}e.memoize=i;function D(L,P,I){return R((S,E)=>{const b=`$debounce$${E}`,v=`$debounce$result$${E}`;return function(...p){this[v]||(this[v]=I?I():void 0),clearTimeout(this[b]),P&&(this[v]=P(this[v],...p),p=[this[v]]),this[b]=setTimeout(()=>{S.apply(this,p),this[v]=I?I():void 0},L)}})}e.debounce=D;function k(L,P,I){return R((S,E)=>{const b=`$throttle$timer$${E}`,v=`$throttle$result$${E}`,p=`$throttle$lastRun$${E}`,d=`$throttle$pending$${E}`;return function(...g){if(this[v]||(this[v]=I?I():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...g)),this[d])return;const w=this[p]+L;w<=Date.now()?(this[p]=Date.now(),S.apply(this,[this[v]]),this[v]=I?I():void 0):(this[d]=!0,this[b]=setTimeout(()=>{this[d]=!1,this[p]=Date.now(),S.apply(this,[this[v]]),this[v]=I?I():void 0},w-Date.now()))}})}e.throttle=k}),define(re[9],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?c.isErrorNoTelemetry(n)?new c(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(r=>{r(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.ErrorHandler=R,e.errorHandler=new R;function i(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=i;function D(f){I(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=D;function k(f){I(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=k;function L(f){if(f instanceof Error){const{name:n,message:r}=f,t=f.stacktrace||f.stack;return{$isError:!0,name:n,message:r,stack:t,noTelemetry:c.isErrorNoTelemetry(f)}}return f}e.transformErrorForSerialization=L;const P="Canceled";function I(f){return f instanceof S?!0:f instanceof Error&&f.name===P&&f.message===P}e.isCancellationError=I;class S extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=S;function E(){const f=new Error(P);return f.name=f.message,f}e.canceled=E;function b(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=b;function v(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=v;function p(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function d(f){const n=new Error(`${f} has been disposed`);return n.name="DISPOSED",n}e.disposed=d;function g(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=g;class w extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=w;class u extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=u;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=m;class c extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof c)return n;const r=new c;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=c;class h extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(re[19],ae([0,1,9]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function i(x,te=0){return x[x.length-(1+te)]}e.tail=i;function D(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}e.tail2=D;function k(x,te,se=(le,ue)=>le===ue){if(x===te)return!0;if(!x||!te||x.length!==te.length)return!1;for(let le=0,ue=x.length;le<ue;le++)if(!se(x[le],te[le]))return!1;return!0}e.equals=k;function L(x,te){const se=x.length-1;te<se&&(x[te]=x[se]),x.pop()}e.removeFastWithoutKeepingOrder=L;function P(x,te,se){return I(x.length,le=>se(x[le],te))}e.binarySearch=P;function I(x,te){let se=0,le=x-1;for(;se<=le;){const ue=(se+le)/2|0,ye=te(ue);if(ye<0)se=ue+1;else if(ye>0)le=ue-1;else return ue}return-(se+1)}e.binarySearch2=I;function S(x,te){let se=0,le=x.length;if(le===0)return 0;for(;se<le;){const ue=Math.floor((se+le)/2);te(x[ue])?le=ue:se=ue+1}return se}e.findFirstInSorted=S;function E(x,te,se){if(x=x|0,x>=te.length)throw new TypeError("invalid index");const le=te[Math.floor(te.length*Math.random())],ue=[],ye=[],Se=[];for(const be of te){const Ce=se(be,le);Ce<0?ue.push(be):Ce>0?ye.push(be):Se.push(be)}return x<ue.length?E(x,ue,se):x<ue.length+Se.length?Se[0]:E(x-(ue.length+Se.length),ye,se)}e.quickSelect=E;function b(x,te){const se=[];let le;for(const ue of x.slice(0).sort(te))!le||te(le[0],ue)!==0?(le=[ue],se.push(le)):le.push(ue);return se}e.groupBy=b;function v(x,te,se){const le=[];function ue(be,Ce,Te){if(Ce===0&&Te.length===0)return;const Fe=le[le.length-1];Fe&&Fe.start+Fe.deleteCount===be?(Fe.deleteCount+=Ce,Fe.toInsert.push(...Te)):le.push({start:be,deleteCount:Ce,toInsert:Te})}let ye=0,Se=0;for(;;){if(ye===x.length){ue(ye,0,te.slice(Se));break}if(Se===te.length){ue(ye,x.length-ye,[]);break}const be=x[ye],Ce=te[Se],Te=se(be,Ce);Te===0?(ye+=1,Se+=1):Te<0?(ue(ye,1,[]),ye+=1):Te>0&&(ue(ye,0,[Ce]),Se+=1)}return le}e.sortedDiff=v;function p(x,te,se){const le=v(x,te,se),ue=[],ye=[];for(const Se of le)ue.push(...x.slice(Se.start,Se.start+Se.deleteCount)),ye.push(...Se.toInsert);return{removed:ue,added:ye}}e.delta=p;function d(x,te,se){if(se===0)return[];const le=x.slice(0,se).sort(te);return w(x,te,le,se,x.length),le}e.top=d;function g(x,te,se,le,ue){return se===0?Promise.resolve([]):new Promise((ye,Se)=>{(async()=>{const be=x.length,Ce=x.slice(0,se).sort(te);for(let Te=se,Fe=Math.min(se+le,be);Te<be;Te=Fe,Fe=Math.min(Fe+le,be)){if(Te>se&&await new Promise(Ye=>setTimeout(Ye)),ue&&ue.isCancellationRequested)throw new R.CancellationError;w(x,te,Ce,Te,Fe)}return Ce})().then(ye,Se)})}e.topAsync=g;function w(x,te,se,le,ue){for(const ye=se.length;le<ue;le++){const Se=x[le];if(te(Se,se[ye-1])<0){se.pop();const be=S(se,Ce=>te(Se,Ce)<0);se.splice(be,0,Se)}}}function u(x){return x.filter(te=>!!te)}e.coalesce=u;function m(x){let te=0;for(let se=0;se<x.length;se++)x[se]&&(x[te]=x[se],te+=1);x.length=te}e.coalesceInPlace=m;function c(x,te,se){x.splice(se,0,x.splice(te,1)[0])}e.move=c;function h(x){return!Array.isArray(x)||x.length===0}e.isFalsyOrEmpty=h;function f(x){return Array.isArray(x)&&x.length>0}e.isNonEmptyArray=f;function n(x,te=se=>se){const se=new Set;return x.filter(le=>{const ue=te(le);return se.has(ue)?!1:(se.add(ue),!0)})}e.distinct=n;function r(x){const te=new Set;return se=>{const le=x(se);return te.has(le)?!1:(te.add(le),!0)}}e.uniqueFilter=r;function t(x,te){const se=a(x,te);if(se!==-1)return x[se]}e.findLast=t;function a(x,te){for(let se=x.length-1;se>=0;se--){const le=x[se];if(te(le))return se}return-1}e.lastIndex=a;function s(x,te){return x.length>0?x[0]:te}e.firstOrDefault=s;function l(x,te){return x.length>0?x[x.length-1]:te}e.lastOrDefault=l;function o(x,te,se=(le,ue)=>le===ue){let le=0;for(let ue=0,ye=Math.min(x.length,te.length);ue<ye&&se(x[ue],te[ue]);ue++)le++;return le}e.commonPrefixLength=o;function y(x){return[].concat(...x)}e.flatten=y;function C(x,te){let se=typeof te=="number"?x:0;typeof te=="number"?se=x:(se=0,te=x);const le=[];if(se<=te)for(let ue=se;ue<te;ue++)le.push(ue);else for(let ue=se;ue>te;ue--)le.push(ue);return le}e.range=C;function T(x,te,se){return x.reduce((le,ue)=>(le[te(ue)]=se?se(ue):ue,le),Object.create(null))}e.index=T;function W(x,te){return x.push(te),()=>O(x,te)}e.insert=W;function O(x,te){const se=x.indexOf(te);if(se>-1)return x.splice(se,1),te}e.remove=O;function j(x,te,se){const le=x.slice(0,te),ue=x.slice(te);return le.concat(se,ue)}e.arrayInsert=j;function F(x,te){let se;if(typeof te=="number"){let le=te;se=()=>{const ue=Math.sin(le++)*179426549;return ue-Math.floor(ue)}}else se=Math.random;for(let le=x.length-1;le>0;le-=1){const ue=Math.floor(se()*(le+1)),ye=x[le];x[le]=x[ue],x[ue]=ye}}e.shuffle=F;function A(x,te){const se=x.indexOf(te);se>-1&&(x.splice(se,1),x.unshift(te))}e.pushToStart=A;function M(x,te){const se=x.indexOf(te);se>-1&&(x.splice(se,1),x.push(te))}e.pushToEnd=M;function B(x,te){for(const se of te)x.push(se)}e.pushMany=B;function G(x,te){return Array.isArray(x)?x.map(te):te(x)}e.mapArrayOrNot=G;function V(x){return Array.isArray(x)?x:[x]}e.asArray=V;function Q(x){return x[Math.floor(Math.random()*x.length)]}e.getRandomElement=Q;function $(x,te){for(const se of x){const le=te(se);if(le!==void 0)return le}}e.mapFind=$;function z(x,te,se){const le=ee(x,te),ue=x.length,ye=se.length;x.length=ue+ye;for(let Se=ue-1;Se>=le;Se--)x[Se+ye]=x[Se];for(let Se=0;Se<ye;Se++)x[Se+le]=se[Se]}e.insertInto=z;function Y(x,te,se,le){const ue=ee(x,te),ye=x.splice(ue,se);return z(x,ue,le),ye}e.splice=Y;function ee(x,te){return te<0?Math.max(te+x.length,0):Math.min(te,x.length)}var oe;(function(x){function te(ue){return ue<0}x.isLessThan=te;function se(ue){return ue>0}x.isGreaterThan=se;function le(ue){return ue===0}x.isNeitherLessOrGreaterThan=le,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(oe=e.CompareResult||(e.CompareResult={}));function X(x,te){return(se,le)=>te(x(se),x(le))}e.compareBy=X;function Z(...x){return(te,se)=>{for(const le of x){const ue=le(te,se);if(!oe.isNeitherLessOrGreaterThan(ue))return ue}return oe.neitherLessOrGreaterThan}}e.tieBreakComparators=Z;const U=(x,te)=>x-te;e.numberComparator=U;function N(x,te){if(x.length===0)return;let se=x[0];for(let le=1;le<x.length;le++){const ue=x[le];te(ue,se)>0&&(se=ue)}return se}e.findMaxBy=N;function H(x,te){if(x.length===0)return;let se=x[0];for(let le=1;le<x.length;le++){const ue=x[le];te(ue,se)>=0&&(se=ue)}return se}e.findLastMaxBy=H;function q(x,te){return N(x,(se,le)=>-te(se,le))}e.findMinBy=q;class J{constructor(te){this.f=te,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(te){let se=this.c;for(;se<this.f.length&&te(this.f[se]);)se++;const le=se===this.c?null:this.f.slice(this.c,se);return this.c=se,le}takeFromEndWhile(te){let se=this.d;for(;se>=0&&te(this.f[se]);)se--;const le=se===this.d?null:this.f.slice(se+1,this.d+1);return this.d=se,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const te=this.f[this.c];return this.c++,te}removeLast(){const te=this.f[this.d];return this.d--,te}takeCount(te){const se=this.f.slice(this.c,this.c+te);return this.c+=te,se}}e.ArrayQueue=J;class ne{constructor(te){this.iterate=te}forEach(te){this.iterate(se=>(te(se),!0))}toArray(){const te=[];return this.iterate(se=>(te.push(se),!0)),te}filter(te){return new ne(se=>this.iterate(le=>te(le)?se(le):!0))}map(te){return new ne(se=>this.iterate(le=>se(te(le))))}some(te){let se=!1;return this.iterate(le=>(se=te(le),!se)),se}findFirst(te){let se;return this.iterate(le=>te(le)?(se=le,!1):!0),se}findLast(te){let se;return this.iterate(le=>(te(le)&&(se=le),!0)),se}findLastMaxBy(te){let se,le=!0;return this.iterate(ue=>((le||oe.isGreaterThan(te(ue,se)))&&(le=!1,se=ue),!0)),se}}e.CallbackIterable=ne,ne.empty=new ne(x=>{})}),define(re[127],ae([0,1,9]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function i(I,S){if(!I)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=i;function D(I,S="Unreachable"){throw new Error(S)}e.assertNever=D;function k(I){if(!I)throw new R.BugIndicatingError("Assertion Failed")}e.assert=k;function L(I){if(!I()){debugger;I(),(0,R.onUnexpectedError)(new R.BugIndicatingError("Assertion Failed"))}}e.assertFn=L;function P(I,S){let E=0;for(;E<I.length-1;){const b=I[E],v=I[E+1];if(!S(b,v))return!1;E++}return!0}e.checkAdjacentItems=P}),define(re[81],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(i){const D=this;let k=!1,L;return function(){return k||(k=!0,L=i.apply(D,arguments)),L}}e.once=R}),define(re[64],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(i){function D(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}i.is=D;const k=Object.freeze([]);function L(){return k}i.empty=L;function*P(h){yield h}i.single=P;function I(h){return D(h)?h:P(h)}i.wrap=I;function S(h){return h||k}i.from=S;function E(h){return!h||h[Symbol.iterator]().next().done===!0}i.isEmpty=E;function b(h){return h[Symbol.iterator]().next().value}i.first=b;function v(h,f){for(const n of h)if(f(n))return!0;return!1}i.some=v;function p(h,f){for(const n of h)if(f(n))return n}i.find=p;function*d(h,f){for(const n of h)f(n)&&(yield n)}i.filter=d;function*g(h,f){let n=0;for(const r of h)yield f(r,n++)}i.map=g;function*w(...h){for(const f of h)for(const n of f)yield n}i.concat=w;function u(h,f,n){let r=n;for(const t of h)r=f(r,t);return r}i.reduce=u;function*m(h,f,n=h.length){for(f<0&&(f+=h.length),n<0?n+=h.length:n>h.length&&(n=h.length);f<n;f++)yield h[f]}i.slice=m;function c(h,f=Number.POSITIVE_INFINITY){const n=[];if(f===0)return[n,h];const r=h[Symbol.iterator]();for(let t=0;t<f;t++){const a=r.next();if(a.done)return[n,i.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return r}}]}i.consume=c})(R=e.Iterable||(e.Iterable={}))}),define(re[35],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var i;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(n){n.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function L(n,r=!1){let t=0;const a=n.length;let s="",l=0,o=16,y=0;function C(M){let B=0,G=0;for(;B<M;){const V=n.charCodeAt(t);if(V>=48&&V<=57)G=G*16+V-48;else if(V>=65&&V<=70)G=G*16+V-65+10;else if(V>=97&&V<=102)G=G*16+V-97+10;else break;t++,B++}return B<M&&(G=-1),G}function T(M){t=M,s="",l=0,o=16,y=0}function W(){const M=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&S(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&S(n.charCodeAt(t)))for(t++;t<n.length&&S(n.charCodeAt(t));)t++;else return y=3,n.substring(M,t);let B=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&S(n.charCodeAt(t))){for(t++;t<n.length&&S(n.charCodeAt(t));)t++;B=t}else y=3;return n.substring(M,B)}function O(){let M="",B=t;for(;;){if(t>=a){M+=n.substring(B,t),y=2;break}const G=n.charCodeAt(t);if(G===34){M+=n.substring(B,t),t++;break}if(G===92){if(M+=n.substring(B,t),t++,t>=a){y=2;break}switch(n.charCodeAt(t++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const Q=C(4);Q>=0?M+=String.fromCharCode(Q):y=4;break}default:y=5}B=t;continue}if(G>=0&&G<=31)if(I(G)){M+=n.substring(B,t),y=2;break}else y=6;t++}return M}function j(){if(s="",y=0,l=t,t>=a)return l=a,o=17;let M=n.charCodeAt(t);if(P(M)){do t++,s+=String.fromCharCode(M),M=n.charCodeAt(t);while(P(M));return o=15}if(I(M))return t++,s+=String.fromCharCode(M),M===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),o=14;switch(M){case 123:return t++,o=1;case 125:return t++,o=2;case 91:return t++,o=3;case 93:return t++,o=4;case 58:return t++,o=6;case 44:return t++,o=5;case 34:return t++,s=O(),o=10;case 47:{const B=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<a&&!I(n.charCodeAt(t));)t++;return s=n.substring(B,t),o=12}if(n.charCodeAt(t+1)===42){t+=2;const G=a-1;let V=!1;for(;t<G;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,V=!0;break}t++}return V||(t++,y=1),s=n.substring(B,t),o=13}return s+=String.fromCharCode(M),t++,o=16}case 45:if(s+=String.fromCharCode(M),t++,t===a||!S(n.charCodeAt(t)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=W(),o=11;default:for(;t<a&&F(M);)t++,M=n.charCodeAt(t);if(l!==t){switch(s=n.substring(l,t),s){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return s+=String.fromCharCode(M),t++,o=16}}function F(M){if(P(M)||I(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function A(){let M;do M=j();while(M>=12&&M<=15);return M}return{setPosition:T,getPosition:()=>t,scan:r?A:j,getToken:()=>o,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>t-l,getTokenError:()=>y}}e.createScanner=L;function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function I(n){return n===10||n===13||n===8232||n===8233}function S(n){return n>=48&&n<=57}var E;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(E||(E={}));function b(n,r){const t=[],a=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function y(C,T,W,O){l.value=C,l.offset=T,l.length=W,l.type=O,l.colonOffset=void 0,s=l}try{c(n,{onObjectBegin:(C,T)=>{if(r<=C)throw a;s=void 0,o=r>C,t.push("")},onObjectProperty:(C,T,W)=>{if(r<T||(y(C,T,W,"property"),t[t.length-1]=C,r<=T+W))throw a},onObjectEnd:(C,T)=>{if(r<=C)throw a;s=void 0,t.pop()},onArrayBegin:(C,T)=>{if(r<=C)throw a;s=void 0,t.push(0)},onArrayEnd:(C,T)=>{if(r<=C)throw a;s=void 0,t.pop()},onLiteralValue:(C,T,W)=>{if(r<T||(y(C,T,W,f(C)),r<=T+W))throw a},onSeparator:(C,T,W)=>{if(r<=T)throw a;if(C===":"&&s&&s.type==="property")s.colonOffset=T,o=!1,s=void 0;else if(C===","){const O=t[t.length-1];typeof O=="number"?t[t.length-1]=O+1:(o=!0,t[t.length-1]=""),s=void 0}}})}catch(C){if(C!==a)throw C}return{path:t,previousNode:s,isAtPropertyKey:o,matches:C=>{let T=0;for(let W=0;T<C.length&&W<t.length;W++)if(C[T]===t[W]||C[T]==="*")T++;else if(C[T]!=="**")return!1;return T===C.length}}}e.getLocation=b;function v(n,r=[],t=k.DEFAULT){let a=null,s=[];const l=[];function o(C){Array.isArray(s)?s.push(C):a!==null&&(s[a]=C)}return c(n,{onObjectBegin:()=>{const C={};o(C),l.push(s),s=C,a=null},onObjectProperty:C=>{a=C},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const C=[];o(C),l.push(s),s=C,a=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:o,onError:(C,T,W)=>{r.push({error:C,offset:T,length:W})}},t),s[0]}e.parse=v;function p(n,r=[],t=k.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(C){a.type==="property"&&(a.length=C-a.offset,a=a.parent)}function l(C){return a.children.push(C),C}c(n,{onObjectBegin:C=>{a=l({type:"object",offset:C,length:-1,parent:a,children:[]})},onObjectProperty:(C,T,W)=>{a=l({type:"property",offset:T,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:C,offset:T,length:W,parent:a})},onObjectEnd:(C,T)=>{a.length=C+T-a.offset,a=a.parent,s(C+T)},onArrayBegin:(C,T)=>{a=l({type:"array",offset:C,length:-1,parent:a,children:[]})},onArrayEnd:(C,T)=>{a.length=C+T-a.offset,a=a.parent,s(C+T)},onLiteralValue:(C,T,W)=>{l({type:f(C),offset:T,length:W,parent:a,value:C}),s(T+W)},onSeparator:(C,T,W)=>{a.type==="property"&&(C===":"?a.colonOffset=T:C===","&&s(T))},onError:(C,T,W)=>{r.push({error:C,offset:T,length:W})}},t);const y=a.children[0];return y&&delete y.parent,y}e.parseTree=p;function d(n,r){if(!n)return;let t=n;for(const a of r)if(typeof a=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const l of t.children)if(Array.isArray(l.children)&&l.children[0].value===a){t=l.children[1],s=!0;break}if(!s)return}else{const s=a;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=d;function g(n){if(!n.parent||!n.parent.children)return[];const r=g(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;r.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&r.push(t)}return r}e.getNodePath=g;function w(n){switch(n.type){case"array":return n.children.map(w);case"object":{const r=Object.create(null);for(const t of n.children){const a=t.children[1];a&&(r[t.children[0].value]=w(a))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=w;function u(n,r,t=!1){return r>=n.offset&&r<n.offset+n.length||t&&r===n.offset+n.length}e.contains=u;function m(n,r,t=!1){if(u(n,r,t)){const a=n.children;if(Array.isArray(a))for(let s=0;s<a.length&&a[s].offset<=r;s++){const l=m(a[s],r,t);if(l)return l}return n}}e.findNodeAtOffset=m;function c(n,r,t=k.DEFAULT){const a=L(n,!1);function s(X){return X?()=>X(a.getTokenOffset(),a.getTokenLength()):()=>!0}function l(X){return X?Z=>X(Z,a.getTokenOffset(),a.getTokenLength()):()=>!0}const o=s(r.onObjectBegin),y=l(r.onObjectProperty),C=s(r.onObjectEnd),T=s(r.onArrayBegin),W=s(r.onArrayEnd),O=l(r.onLiteralValue),j=l(r.onSeparator),F=s(r.onComment),A=l(r.onError),M=t&&t.disallowComments,B=t&&t.allowTrailingComma;function G(){for(;;){const X=a.scan();switch(a.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:M||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(X){case 12:case 13:M?V(10):F();break;case 16:V(1);break;case 15:case 14:break;default:return X}}}function V(X,Z=[],U=[]){if(A(X),Z.length+U.length>0){let N=a.getToken();for(;N!==17;){if(Z.indexOf(N)!==-1){G();break}else if(U.indexOf(N)!==-1)break;N=G()}}}function Q(X){const Z=a.getTokenValue();return X?O(Z):y(Z),G(),!0}function $(){switch(a.getToken()){case 11:{let X=0;try{X=JSON.parse(a.getTokenValue()),typeof X!="number"&&(V(2),X=0)}catch{V(2)}O(X);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return G(),!0}function z(){return a.getToken()!==10?(V(3,[],[2,5]),!1):(Q(!1),a.getToken()===6?(j(":"),G(),oe()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function Y(){o(),G();let X=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(X||V(4,[],[]),j(","),G(),a.getToken()===2&&B)break}else X&&V(6,[],[]);z()||V(4,[],[2,5]),X=!0}return C(),a.getToken()!==2?V(7,[2],[]):G(),!0}function ee(){T(),G();let X=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(X||V(4,[],[]),j(","),G(),a.getToken()===4&&B)break}else X&&V(6,[],[]);oe()||V(4,[],[4,5]),X=!0}return W(),a.getToken()!==4?V(8,[4],[]):G(),!0}function oe(){switch(a.getToken()){case 3:return ee();case 1:return Y();case 10:return Q(!0);default:return $()}}return G(),a.getToken()===17?t.allowEmptyContent?!0:(V(4,[],[]),!1):oe()?(a.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=c;function h(n,r){const t=L(n),a=[];let s,l=0,o;do switch(o=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:l!==o&&a.push(n.substring(l,o)),r!==void 0&&a.push(t.getTokenValue().replace(/[^\r\n]/g,r)),l=t.getPosition();break}while(s!==17);return a.join("")}e.stripComments=h;function f(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(re[42],ae([0,1,35]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(S,E,b){let v,p,d,g,w;if(E){for(g=E.offset,w=g+E.length,d=g;d>0&&!I(S,d-1);)d--;let o=w;for(;o<S.length&&!I(S,o);)o++;p=S.substring(d,o),v=L(p,b)}else p=S,v=0,d=0,g=0,w=S.length;const u=P(b,S);let m=!1,c=0,h;b.insertSpaces?h=k(" ",b.tabSize||4):h="	";const f=(0,R.createScanner)(p,!1);let n=!1;function r(){return u+k(h,v+c)}function t(){let o=f.scan();for(m=!1;o===15||o===14;)m=m||o===14,o=f.scan();return n=o===16||f.getTokenError()!==0,o}const a=[];function s(o,y,C){!n&&y<w&&C>g&&S.substring(y,C)!==o&&a.push({offset:y,length:C-y,content:o})}let l=t();if(l!==17){const o=f.getTokenOffset()+d,y=k(h,v);s(y,d,o)}for(;l!==17;){let o=f.getTokenOffset()+f.getTokenLength()+d,y=t(),C="";for(;!m&&(y===12||y===13);){const W=f.getTokenOffset()+d;s(" ",o,W),o=f.getTokenOffset()+f.getTokenLength()+d,C=y===12?r():"",y=t()}if(y===2)l!==1&&(c--,C=r());else if(y===4)l!==3&&(c--,C=r());else{switch(l){case 3:case 1:c++,C=r();break;case 5:case 12:C=r();break;case 13:m?C=r():C=" ";break;case 6:C=" ";break;case 10:if(y===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?C=" ":y!==5&&y!==17&&(n=!0);break;case 16:n=!0;break}m&&(y===12||y===13)&&(C=r())}const T=f.getTokenOffset()+d;s(C,o,T),l=y}return a}e.format=i;function D(S,E){const b=JSON.stringify(S,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?b.replace(/\r\n|\r|\n/g,E.eol):b}e.toFormattedString=D;function k(S,E){let b="";for(let v=0;v<E;v++)b+=S;return b}function L(S,E){let b=0,v=0;const p=E.tabSize||4;for(;b<S.length;){const d=S.charAt(b);if(d===" ")v++;else if(d==="	")v+=p;else break;b++}return Math.floor(v/p)}function P(S,E){for(let b=0;b<E.length;b++){const v=E.charAt(b);if(v==="\r")return b+1<E.length&&E.charAt(b+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=P;function I(S,E){return`\r
`.indexOf(S.charAt(E))!==-1}e.isEOL=I}),define(re[82],ae([0,1,35,42]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(S,E,b){return k(S,E,void 0,b)}e.removeProperty=D;function k(S,E,b,v,p){const d=E.slice(),g=[],w=(0,R.parseTree)(S,g);let u,m;for(;d.length>0&&(m=d.pop(),u=(0,R.findNodeAtLocation)(w,d),u===void 0&&b!==void 0);)typeof m=="string"?b={[m]:b}:b=[b];if(u)if(u.type==="object"&&typeof m=="string"&&Array.isArray(u.children)){const c=(0,R.findNodeAtLocation)(u,[m]);if(c!==void 0)if(b===void 0){if(!c.parent)throw new Error("Malformed AST");const h=u.children.indexOf(c.parent);let f,n=c.parent.offset+c.parent.length;if(h>0){const r=u.children[h-1];f=r.offset+r.length}else f=u.offset+1,u.children.length>1&&(n=u.children[1].offset);return L(S,{offset:f,length:n-f,content:""},v)}else return L(S,{offset:c.offset,length:c.length,content:JSON.stringify(b)},v);else{if(b===void 0)return[];const h=`${JSON.stringify(m)}: ${JSON.stringify(b)}`,f=p?p(u.children.map(r=>r.children[0].value)):u.children.length;let n;if(f>0){const r=u.children[f-1];n={offset:r.offset+r.length,length:0,content:","+h}}else u.children.length===0?n={offset:u.offset+1,length:0,content:h}:n={offset:u.offset+1,length:0,content:h+","};return L(S,n,v)}}else if(u.type==="array"&&typeof m=="number"&&Array.isArray(u.children))if(b!==void 0){const c=`${JSON.stringify(b)}`;let h;if(u.children.length===0||m===0)h={offset:u.offset+1,length:0,content:u.children.length===0?c:c+","};else{const f=m===-1||m>u.children.length?u.children.length:m,n=u.children[f-1];h={offset:n.offset+n.length,length:0,content:","+c}}return L(S,h,v)}else{const c=m,h=u.children[c];let f;if(u.children.length===1)f={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===c){const n=u.children[c-1],r=n.offset+n.length,t=u.offset+u.length;f={offset:r,length:t-2-r,content:""}}else f={offset:h.offset,length:u.children[c+1].offset-h.offset,content:""};return L(S,f,v)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${u.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return L(S,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(b)},v)}}e.setProperty=k;function L(S,E,b){let v=P(S,E),p=E.offset,d=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;p>0&&!(0,i.isEOL)(v,p-1);)p--;for(;d<v.length&&!(0,i.isEOL)(v,d);)d++}const g=(0,i.format)(v,{offset:p,length:d-p},b);for(let u=g.length-1;u>=0;u--){const m=g[u];v=P(v,m),p=Math.min(p,m.offset),d=Math.max(d,m.offset+m.length),d+=m.content.length-m.length}const w=S.length-(v.length-d)-p;return[{offset:p,length:w,content:v.substring(p,d)}]}e.withFormatting=L;function P(S,E){return S.substring(0,E.offset)+E.content+S.substring(E.offset+E.length)}e.applyEdit=P;function I(S,E){const b=E.slice(0).sort((p,d)=>{const g=p.offset-d.offset;return g===0?p.length-d.length:g});let v=S.length;for(let p=b.length-1;p>=0;p--){const d=b[p];if(d.offset+d.length<=v)S=P(S,d);else throw new Error("Overlapping edit");v=d.offset}return S}e.applyEdits=I}),define(re[128],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class R{constructor(D){this.d=D,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(D){return new R(()=>D(this.getValue()))}}e.Lazy=R}),define(re[2],ae([0,1,81,64]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let k=null;function L(l){k=l}if(e.setDisposableTracker=L,D){const l="__is_disposable_tracked__";L(new class{trackDisposable(o){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[l]||console.log(y)},3e3)}setParent(o,y){if(o&&o!==m.None)try{o[l]=!0}catch{}}markAsDisposed(o){if(o&&o!==m.None)try{o[l]=!0}catch{}}markAsSingleton(o){}})}function P(l){return k?.trackDisposable(l),l}function I(l){k?.markAsDisposed(l)}function S(l,o){k?.setParent(l,o)}function E(l,o){if(!!k)for(const y of l)k.setParent(y,o)}function b(l){return k?.markAsSingleton(l),l}e.markAsSingleton=b;function v(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=v;function p(l){if(i.Iterable.is(l)){const o=[];for(const y of l)if(y)try{y.dispose()}catch(C){o.push(C)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=p;function d(l){for(const o of l)v(o)&&o.dispose();return[]}e.disposeIfDisposable=d;function g(...l){const o=w(()=>p(l));return E(l,o),o}e.combinedDisposable=g;function w(l){const o=P({dispose:(0,R.once)(()=>{I(o),l()})});return o}e.toDisposable=w;class u{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(I(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{p(this.c)}finally{this.c.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return S(o,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(o),o}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this.q=new u,P(this),S(this.q,this)}dispose(){I(this),this.q.dispose()}B(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(o)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class c{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&S(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&S(o,null),o}}e.MutableDisposable=c;class h{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=h;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(o){let y=o;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,I(this))},this}}e.SafeDisposable=f;class n{constructor(){this.a=new Map}acquire(o,...y){let C=this.a.get(o);C||(C={counter:0,object:this.b(o,...y)},this.a.set(o,C));const{object:T}=C,W=(0,R.once)(()=>{--C.counter===0&&(this.c(o,C.object),this.a.delete(o))});return C.counter++,{object:T,dispose:W}}}e.ReferenceCollection=n;class r{constructor(o){this.a=o}async acquire(o,...y){const C=this.a.acquire(o,...y);try{return{object:await C.object,dispose:()=>C.dispose()}}catch(T){throw C.dispose(),T}}}e.AsyncReferenceCollection=r;class t{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=t;function a(l){const o=new u;try{l(o)}finally{o.dispose()}}e.disposeOnReturn=a;class s{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{p(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,y,C=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),C||this.a.get(o)?.dispose(),this.a.set(o,y)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(re[83],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(k){this.element=k,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class i{constructor(){this.a=R.Undefined,this.b=R.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===R.Undefined}clear(){let k=this.a;for(;k!==R.Undefined;){const L=k.next;k.prev=R.Undefined,k.next=R.Undefined,k=L}this.a=R.Undefined,this.b=R.Undefined,this.c=0}unshift(k){return this.d(k,!1)}push(k){return this.d(k,!0)}d(k,L){const P=new R(k);if(this.a===R.Undefined)this.a=P,this.b=P;else if(L){const S=this.b;this.b=P,P.prev=S,S.next=P}else{const S=this.a;this.a=P,P.next=S,S.prev=P}this.c+=1;let I=!1;return()=>{I||(I=!0,this.e(P))}}shift(){if(this.a!==R.Undefined){const k=this.a.element;return this.e(this.a),k}}pop(){if(this.b!==R.Undefined){const k=this.b.element;return this.e(this.b),k}}e(k){if(k.prev!==R.Undefined&&k.next!==R.Undefined){const L=k.prev;L.next=k.next,k.next.prev=L}else k.prev===R.Undefined&&k.next===R.Undefined?(this.a=R.Undefined,this.b=R.Undefined):k.next===R.Undefined?(this.b=this.b.prev,this.b.next=R.Undefined):k.prev===R.Undefined&&(this.a=this.a.next,this.a.prev=R.Undefined);this.c-=1}*[Symbol.iterator](){let k=this.a;for(;k!==R.Undefined;)yield k.element,k=k.next}}e.LinkedList=i}),define(re[37],ae([0,1]),function(_,e){"use strict";var R,i,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function k(d,g,w){let u=d.get(g);return u===void 0&&(u=w,d.set(g,u)),u}e.getOrSet=k;function L(d){const g=[];return d.forEach((w,u)=>{g.push(`${u} => ${w}`)}),`Map(${d.size}) {${g.join(", ")}}`}e.mapToString=L;function P(d){const g=[];return d.forEach(w=>{g.push(w)}),`Set(${d.size}) {${g.join(", ")}}`}e.setToString=P;class I{constructor(g,w){this.uri=g,this.value=w}}class S{constructor(g,w){this[R]="ResourceMap",g instanceof S?(this.b=new Map(g.b),this.c=w??S.a):(this.b=new Map,this.c=g??S.a)}set(g,w){return this.b.set(this.c(g),new I(g,w)),this}get(g){return this.b.get(this.c(g))?.value}has(g){return this.b.has(this.c(g))}get size(){return this.b.size}clear(){this.b.clear()}delete(g){return this.b.delete(this.c(g))}forEach(g,w){typeof w<"u"&&(g=g.bind(w));for(const[u,m]of this.b)g(m.value,m.uri,this)}*values(){for(const g of this.b.values())yield g.value}*keys(){for(const g of this.b.values())yield g.uri}*entries(){for(const g of this.b.values())yield[g.uri,g.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,g]of this.b)yield[g.uri,g.value]}}e.ResourceMap=S,S.a=d=>d.toString();class E{constructor(g,w){this[i]="ResourceSet",!g||typeof g=="function"?this.a=new S(g):(this.a=new S(w),g.forEach(this.add,this))}get size(){return this.a.size}add(g){return this.a.set(g,g),this}clear(){this.a.clear()}delete(g){return this.a.delete(g)}forEach(g,w){this.a.forEach((u,m)=>g.call(w,m,m,this))}has(g){return this.a.has(g)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=E;var b;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class v{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(g){return this.a.has(g)}get(g,w=0){const u=this.a.get(g);if(!!u)return w!==0&&this.j(u,w),u.value}set(g,w,u=0){let m=this.a.get(g);if(m)m.value=w,u!==0&&this.j(m,u);else{switch(m={key:g,value:w,next:void 0,previous:void 0},u){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(g,m),this.d++}return this}delete(g){return!!this.remove(g)}remove(g){const w=this.a.get(g);if(!!w)return this.a.delete(g),this.i(w),this.d--,w.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const g=this.b;return this.a.delete(g.key),this.i(g),this.d--,g.value}forEach(g,w){const u=this.e;let m=this.b;for(;m;){if(w?g.bind(w)(m.value,m.key,this):g(m.value,m.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const g=this,w=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(g.e!==w)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.key,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return m}values(){const g=this,w=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(g.e!==w)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.value,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return m}entries(){const g=this,w=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(g.e!==w)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:[u.key,u.value],done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return m}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(g){if(g>=this.size)return;if(g===0){this.clear();return}let w=this.b,u=this.size;for(;w&&u>g;)this.a.delete(w.key),w=w.next,u--;this.b=w,this.d=u,w&&(w.previous=void 0),this.e++}g(g){if(!this.b&&!this.c)this.c=g;else if(this.b)g.next=this.b,this.b.previous=g;else throw new Error("Invalid list");this.b=g,this.e++}h(g){if(!this.b&&!this.c)this.b=g;else if(this.c)g.previous=this.c,this.c.next=g;else throw new Error("Invalid list");this.c=g,this.e++}i(g){if(g===this.b&&g===this.c)this.b=void 0,this.c=void 0;else if(g===this.b){if(!g.next)throw new Error("Invalid list");g.next.previous=void 0,this.b=g.next}else if(g===this.c){if(!g.previous)throw new Error("Invalid list");g.previous.next=void 0,this.c=g.previous}else{const w=g.next,u=g.previous;if(!w||!u)throw new Error("Invalid list");w.previous=u,u.next=w}g.next=void 0,g.previous=void 0,this.e++}j(g,w){if(!this.b||!this.c)throw new Error("Invalid list");if(!(w!==1&&w!==2)){if(w===1){if(g===this.b)return;const u=g.next,m=g.previous;g===this.c?(m.next=void 0,this.c=m):(u.previous=m,m.next=u),g.previous=void 0,g.next=this.b,this.b.previous=g,this.b=g,this.e++}else if(w===2){if(g===this.c)return;const u=g.next,m=g.previous;g===this.b?(u.previous=void 0,this.b=u):(u.previous=m,m.next=u),g.next=void 0,g.previous=this.c,this.c.next=g,this.c=g,this.e++}}}toJSON(){const g=[];return this.forEach((w,u)=>{g.push([u,w])}),g}fromJSON(g){this.clear();for(const[w,u]of g)this.set(w,u)}}e.LinkedMap=v;class p extends v{constructor(g,w=1){super(),this.k=g,this.l=Math.min(Math.max(0,w),1)}get limit(){return this.k}set limit(g){this.k=g,this.m()}get ratio(){return this.l}set ratio(g){this.l=Math.min(Math.max(0,g),1),this.m()}get(g,w=2){return super.get(g,w)}peek(g){return super.get(g,0)}set(g,w){return super.set(g,w,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=p}),define(re[84],ae([0,1,37]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new R.LRUCache(1e4);function D(S){return I(S,"NFC",i)}e.normalizeNFC=D;const k=new R.LRUCache(1e4);function L(S){return I(S,"NFD",k)}e.normalizeNFD=L;const P=/[^\u0000-\u0080]/;function I(S,E,b){if(!S)return S;const v=b.get(S);if(v)return v;let p;return P.test(S)?p=S.normalize(E):p=S,b.set(S,p),p}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(E){return L(E).replace(S,"")}}()}),function(){function _(D){const k=[];typeof D=="number"&&k.push("code/timeOrigin",D);function L(I){k.push(I,Date.now())}function P(){const I=[];for(let S=0;S<k.length;S+=2)I.push({name:k[S],startTime:k[S+1]});return I}return{mark:L,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const L of performance.getEntriesByType("mark"))k.push({name:L.name,startTime:Math.round(D+L.startTime)});return k}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function R(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=R(i))}(),function(_,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var i in R)(typeof exports=="object"?exports:_)[i]=R[i]}}(typeof self<"u"?self:this,function(){return function(_){var e={};function R(i){if(e[i])return e[i].exports;var D=e[i]={i,l:!1,exports:{}};return _[i].call(D.exports,D,D.exports,R),D.l=!0,D.exports}return R.m=_,R.c=e,R.d=function(i,D,k){R.o(i,D)||Object.defineProperty(i,D,{enumerable:!0,get:k})},R.r=function(i){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},R.t=function(i,D){if(1&D&&(i=R(i)),8&D||4&D&&typeof i=="object"&&i&&i.__esModule)return i;var k=Object.create(null);if(R.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:i}),2&D&&typeof i!="string")for(var L in i)R.d(k,L,function(P){return i[P]}.bind(null,L));return k},R.n=function(i){var D=i&&i.__esModule?function(){return i.default}:function(){return i};return R.d(D,"a",D),D},R.o=function(i,D){return Object.prototype.hasOwnProperty.call(i,D)},R.p="",R(R.s=0)}([function(_,e,R){(function(i){var D;e=_.exports=U,D=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],I=e.src=[],S=0,E=S++;I[E]="0|[1-9]\\d*";var b=S++;I[b]="[0-9]+";var v=S++;I[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=S++;I[p]="("+I[E]+")\\.("+I[E]+")\\.("+I[E]+")";var d=S++;I[d]="("+I[b]+")\\.("+I[b]+")\\.("+I[b]+")";var g=S++;I[g]="(?:"+I[E]+"|"+I[v]+")";var w=S++;I[w]="(?:"+I[b]+"|"+I[v]+")";var u=S++;I[u]="(?:-("+I[g]+"(?:\\."+I[g]+")*))";var m=S++;I[m]="(?:-?("+I[w]+"(?:\\."+I[w]+")*))";var c=S++;I[c]="[0-9A-Za-z-]+";var h=S++;I[h]="(?:\\+("+I[c]+"(?:\\."+I[c]+")*))";var f=S++,n="v?"+I[p]+I[u]+"?"+I[h]+"?";I[f]="^"+n+"$";var r="[v=\\s]*"+I[d]+I[m]+"?"+I[h]+"?",t=S++;I[t]="^"+r+"$";var a=S++;I[a]="((?:<|>)?=?)";var s=S++;I[s]=I[b]+"|x|X|\\*";var l=S++;I[l]=I[E]+"|x|X|\\*";var o=S++;I[o]="[v=\\s]*("+I[l]+")(?:\\.("+I[l]+")(?:\\.("+I[l]+")(?:"+I[u]+")?"+I[h]+"?)?)?";var y=S++;I[y]="[v=\\s]*("+I[s]+")(?:\\.("+I[s]+")(?:\\.("+I[s]+")(?:"+I[m]+")?"+I[h]+"?)?)?";var C=S++;I[C]="^"+I[a]+"\\s*"+I[o]+"$";var T=S++;I[T]="^"+I[a]+"\\s*"+I[y]+"$";var W=S++;I[W]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=S++;I[O]="(?:~>?)";var j=S++;I[j]="(\\s*)"+I[O]+"\\s+",P[j]=new RegExp(I[j],"g");var F=S++;I[F]="^"+I[O]+I[o]+"$";var A=S++;I[A]="^"+I[O]+I[y]+"$";var M=S++;I[M]="(?:\\^)";var B=S++;I[B]="(\\s*)"+I[M]+"\\s+",P[B]=new RegExp(I[B],"g");var G=S++;I[G]="^"+I[M]+I[o]+"$";var V=S++;I[V]="^"+I[M]+I[y]+"$";var Q=S++;I[Q]="^"+I[a]+"\\s*("+r+")$|^$";var $=S++;I[$]="^"+I[a]+"\\s*("+n+")$|^$";var z=S++;I[z]="(\\s*)"+I[a]+"\\s*("+r+"|"+I[o]+")",P[z]=new RegExp(I[z],"g");var Y=S++;I[Y]="^\\s*("+I[o]+")\\s+-\\s+("+I[o]+")\\s*$";var ee=S++;I[ee]="^\\s*("+I[y]+")\\s+-\\s+("+I[y]+")\\s*$";var oe=S++;I[oe]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)D(X,I[X]),P[X]||(P[X]=new RegExp(I[X]));function Z(ce,de){if(ce instanceof U)return ce;if(typeof ce!="string"||ce.length>k||!(de?P[t]:P[f]).test(ce))return null;try{return new U(ce,de)}catch{return null}}function U(ce,de){if(ce instanceof U){if(ce.loose===de)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof U))return new U(ce,de);D("SemVer",ce,de),this.loose=de;var ge=ce.trim().match(de?P[t]:P[f]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Pe=+Ee;if(Pe>=0&&Pe<L)return Pe}return Ee}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=Z,e.valid=function(ce,de){var ge=Z(ce,de);return ge?ge.version:null},e.clean=function(ce,de){var ge=Z(ce.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(ce){return D("SemVer.compare",this.version,this.loose,ce),ce instanceof U||(ce=new U(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},U.prototype.compareMain=function(ce){return ce instanceof U||(ce=new U(ce,this.loose)),H(this.major,ce.major)||H(this.minor,ce.minor)||H(this.patch,ce.patch)},U.prototype.comparePre=function(ce){if(ce instanceof U||(ce=new U(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],Ee=ce.prerelease[de];if(D("prerelease compare",de,ge,Ee),ge===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ee)return H(ge,Ee)}while(++de)},U.prototype.inc=function(ce,de){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,de,ge,Ee){typeof ge=="string"&&(Ee=ge,ge=void 0);try{return new U(ce,ge).inc(de,Ee).version}catch{return null}},e.diff=function(ce,de){if(x(ce,de))return null;var ge=Z(ce),Ee=Z(de);if(ge.prerelease.length||Ee.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ee[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ee[Pe])return Pe},e.compareIdentifiers=H;var N=/^[0-9]+$/;function H(ce,de){var ge=N.test(ce),Ee=N.test(de);return ge&&Ee&&(ce=+ce,de=+de),ge&&!Ee?-1:Ee&&!ge?1:ce<de?-1:ce>de?1:0}function q(ce,de,ge){return new U(ce,ge).compare(new U(de,ge))}function J(ce,de,ge){return q(ce,de,ge)>0}function ne(ce,de,ge){return q(ce,de,ge)<0}function x(ce,de,ge){return q(ce,de,ge)===0}function te(ce,de,ge){return q(ce,de,ge)!==0}function se(ce,de,ge){return q(ce,de,ge)>=0}function le(ce,de,ge){return q(ce,de,ge)<=0}function ue(ce,de,ge,Ee){var Pe;switch(de){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce!==ge;break;case"":case"=":case"==":Pe=x(ce,ge,Ee);break;case"!=":Pe=te(ce,ge,Ee);break;case">":Pe=J(ce,ge,Ee);break;case">=":Pe=se(ce,ge,Ee);break;case"<":Pe=ne(ce,ge,Ee);break;case"<=":Pe=le(ce,ge,Ee);break;default:throw new TypeError("Invalid operator: "+de)}return Pe}function ye(ce,de){if(ce instanceof ye){if(ce.loose===de)return ce;ce=ce.value}if(!(this instanceof ye))return new ye(ce,de);D("comparator",ce,de),this.loose=de,this.parse(ce),this.semver===Se?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ce,de){return H(de,ce)},e.major=function(ce,de){return new U(ce,de).major},e.minor=function(ce,de){return new U(ce,de).minor},e.patch=function(ce,de){return new U(ce,de).patch},e.compare=q,e.compareLoose=function(ce,de){return q(ce,de,!0)},e.rcompare=function(ce,de,ge){return q(de,ce,ge)},e.sort=function(ce,de){return ce.sort(function(ge,Ee){return e.compare(ge,Ee,de)})},e.rsort=function(ce,de){return ce.sort(function(ge,Ee){return e.rcompare(ge,Ee,de)})},e.gt=J,e.lt=ne,e.eq=x,e.neq=te,e.gte=se,e.lte=le,e.cmp=ue,e.Comparator=ye;var Se={};function be(ce,de){if(ce instanceof be)return ce.loose===de?ce:new be(ce.raw,de);if(ce instanceof ye)return new be(ce.value,de);if(!(this instanceof be))return new be(ce,de);if(this.loose=de,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ce(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Te(ce,de,ge,Ee,Pe,Ae,De,je,Oe,Ue,ze,ke,Ne){return((de=Ce(ge)?"":Ce(Ee)?">="+ge+".0.0":Ce(Pe)?">="+ge+"."+Ee+".0":">="+de)+" "+(je=Ce(Oe)?"":Ce(Ue)?"<"+(+Oe+1)+".0.0":Ce(ze)?"<"+Oe+"."+(+Ue+1)+".0":ke?"<="+Oe+"."+Ue+"."+ze+"-"+ke:"<="+je)).trim()}function Fe(ce,de){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<ce.length;ge++)if(D(ce[ge].semver),ce[ge].semver!==Se&&ce[ge].semver.prerelease.length>0){var Ee=ce[ge].semver;if(Ee.major===de.major&&Ee.minor===de.minor&&Ee.patch===de.patch)return!0}return!1}return!0}function Ye(ce,de,ge){try{de=new be(de,ge)}catch{return!1}return de.test(ce)}function Be(ce,de,ge,Ee){var Pe,Ae,De,je,Oe;switch(ce=new U(ce,Ee),de=new be(de,Ee),ge){case">":Pe=J,Ae=le,De=ne,je=">",Oe=">=";break;case"<":Pe=ne,Ae=se,De=J,je="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ye(ce,de,Ee))return!1;for(var Ue=0;Ue<de.set.length;++Ue){var ze=de.set[Ue],ke=null,Ne=null;if(ze.forEach(function(ie){ie.semver===Se&&(ie=new ye(">=0.0.0")),ke=ke||ie,Ne=Ne||ie,Pe(ie.semver,ke.semver,Ee)?ke=ie:De(ie.semver,Ne.semver,Ee)&&(Ne=ie)}),ke.operator===je||ke.operator===Oe||(!Ne.operator||Ne.operator===je)&&Ae(ce,Ne.semver)||Ne.operator===Oe&&De(ce,Ne.semver))return!1}return!0}ye.prototype.parse=function(ce){var de=this.loose?P[Q]:P[$],ge=ce.match(de);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new U(ge[2],this.loose):this.semver=Se},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(ce){return D("Comparator.test",ce,this.loose),this.semver===Se||(typeof ce=="string"&&(ce=new U(ce,this.loose)),ue(ce,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(ce,de){if(!(ce instanceof ye))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(ce.value,de),Ye(this.value,ge,de);if(ce.operator==="")return ge=new be(this.value,de),Ye(ce.semver,ge,de);var Ee=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ae=this.semver.version===ce.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),je=ue(this.semver,"<",ce.semver,de)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Oe=ue(this.semver,">",ce.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ee||Pe||Ae&&De||je||Oe},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ce){var de=this.loose;ce=ce.trim(),D("range",ce,de);var ge=de?P[ee]:P[Y];ce=ce.replace(ge,Te),D("hyphen replace",ce),ce=ce.replace(P[z],"$1$2$3"),D("comparator trim",ce,P[z]),ce=(ce=(ce=ce.replace(P[j],"$1~")).replace(P[B],"$1^")).split(/\s+/).join(" ");var Ee=de?P[Q]:P[$],Pe=ce.split(" ").map(function(Ae){return function(De,je){return D("comp",De),De=function(Oe,Ue){return Oe.trim().split(/\s+/).map(function(ze){return function(ke,Ne){D("caret",ke,Ne);var ie=Ne?P[V]:P[G];return ke.replace(ie,function(he,fe,me,we,Ie){var Re;return D("caret",ke,he,fe,me,we,Ie),Ce(fe)?Re="":Ce(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ce(we)?Re=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":Ie?(D("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+me+"."+(+we+1):">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+we+Ie+" <"+(+fe+1)+".0.0"):(D("no pr"),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+we+" <"+fe+"."+me+"."+(+we+1):">="+fe+"."+me+"."+we+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+we+" <"+(+fe+1)+".0.0"),D("caret return",Re),Re})}(ze,Ue)}).join(" ")}(De,je),D("caret",De),De=function(Oe,Ue){return Oe.trim().split(/\s+/).map(function(ze){return function(ke,Ne){var ie=Ne?P[A]:P[F];return ke.replace(ie,function(he,fe,me,we,Ie){var Re;return D("tilde",ke,he,fe,me,we,Ie),Ce(fe)?Re="":Ce(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ce(we)?Re=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":Ie?(D("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+(+me+1)+".0"):Re=">="+fe+"."+me+"."+we+" <"+fe+"."+(+me+1)+".0",D("tilde return",Re),Re})}(ze,Ue)}).join(" ")}(De,je),D("tildes",De),De=function(Oe,Ue){return D("replaceXRanges",Oe,Ue),Oe.split(/\s+/).map(function(ze){return function(ke,Ne){ke=ke.trim();var ie=Ne?P[T]:P[C];return ke.replace(ie,function(he,fe,me,we,Ie,Re){D("xRange",ke,he,fe,me,we,Ie,Re);var He=Ce(me),$e=He||Ce(we),Le=$e||Ce(Ie);return fe==="="&&Le&&(fe=""),He?he=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Le?($e&&(we=0),Le&&(Ie=0),fe===">"?(fe=">=",$e?(me=+me+1,we=0,Ie=0):Le&&(we=+we+1,Ie=0)):fe==="<="&&(fe="<",$e?me=+me+1:we=+we+1),he=fe+me+"."+we+"."+Ie):$e?he=">="+me+".0.0 <"+(+me+1)+".0.0":Le&&(he=">="+me+"."+we+".0 <"+me+"."+(+we+1)+".0"),D("xRange return",he),he})}(ze,Ue)}).join(" ")}(De,je),D("xrange",De),De=function(Oe,Ue){return D("replaceStars",Oe,Ue),Oe.trim().replace(P[oe],"")}(De,je),D("stars",De),De}(Ae,de)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ae){return!!Ae.match(Ee)})),Pe=Pe.map(function(Ae){return new ye(Ae,de)})},be.prototype.intersects=function(ce,de){if(!(ce instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ee){return ce.set.some(function(Pe){return Pe.every(function(Ae){return Ee.intersects(Ae,de)})})})})},e.toComparators=function(ce,de){return new be(ce,de).set.map(function(ge){return ge.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new U(ce,this.loose));for(var de=0;de<this.set.length;de++)if(Fe(this.set[de],ce))return!0;return!1},e.satisfies=Ye,e.maxSatisfying=function(ce,de,ge){var Ee=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ee&&Pe.compare(De)!==-1||(Pe=new U(Ee=De,ge)))}),Ee},e.minSatisfying=function(ce,de,ge){var Ee=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ee&&Pe.compare(De)!==1||(Pe=new U(Ee=De,ge)))}),Ee},e.validRange=function(ce,de){try{return new be(ce,de).range||"*"}catch{return null}},e.ltr=function(ce,de,ge){return Be(ce,de,"<",ge)},e.gtr=function(ce,de,ge){return Be(ce,de,">",ge)},e.outside=Be,e.prerelease=function(ce,de){var ge=Z(ce,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,de,ge){return ce=new be(ce,ge),de=new be(de,ge),ce.intersects(de)},e.coerce=function(ce){if(ce instanceof U)return ce;if(typeof ce!="string")return null;var de=ce.match(P[W]);return de==null?null:Z((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,R(1))},function(_,e){var R,i,D=_.exports={};function k(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function P(w){if(R===setTimeout)return setTimeout(w,0);if((R===k||!R)&&setTimeout)return R=setTimeout,setTimeout(w,0);try{return R(w,0)}catch{try{return R.call(null,w,0)}catch{return R.call(this,w,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:k}catch{R=k}try{i=typeof clearTimeout=="function"?clearTimeout:L}catch{i=L}})();var I,S=[],E=!1,b=-1;function v(){E&&I&&(E=!1,I.length?S=I.concat(S):b=-1,S.length&&p())}function p(){if(!E){var w=P(v);E=!0;for(var u=S.length;u;){for(I=S,S=[];++b<u;)I&&I[b].run();b=-1,u=S.length}I=null,E=!1,function(m){if(i===clearTimeout)return clearTimeout(m);if((i===L||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(m);try{i(m)}catch{try{return i.call(null,m)}catch{return i.call(this,m)}}}(w)}}function d(w,u){this.fun=w,this.array=u}function g(){}D.nextTick=function(w){var u=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)u[m-1]=arguments[m];S.push(new d(w,u)),S.length!==1||E||P(p)},d.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=g,D.addListener=g,D.once=g,D.off=g,D.removeListener=g,D.removeAllListeners=g,D.emit=g,D.prependListener=g,D.prependOnceListener=g,D.listeners=function(w){return[]},D.binding=function(w){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(w){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(re[129],ae([0,1]),function(_,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class i{constructor(P,I,S){this.level=P,this.key=I,this.value=S,this.forward=[]}}const D=void 0;class k{constructor(P,I=2**16){this.comparator=P,this[R]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(I)|0),this.e=new i(this.c,D,D)}get size(){return this.f}clear(){this.e=new i(this.c,D,D)}has(P){return Boolean(k.g(this,P,this.comparator))}get(P){return k.g(this,P,this.comparator)?.value}set(P,I){return k.h(this,P,I,this.comparator)&&(this.f+=1),this}delete(P){const I=k.k(this,P,this.comparator);return I&&(this.f-=1),I}forEach(P,I){let S=this.e.forward[0];for(;S;)P.call(I,S.value,S.key,this),S=S.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",I=this.e.forward[0];for(;I;)P+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return P}static g(P,I,S){let E=P.e;for(let b=P.d-1;b>=0;b--)for(;E.forward[b]&&S(E.forward[b].key,I)<0;)E=E.forward[b];if(E=E.forward[0],E&&S(E.key,I)===0)return E}static h(P,I,S,E){const b=[];let v=P.e;for(let p=P.d-1;p>=0;p--){for(;v.forward[p]&&E(v.forward[p].key,I)<0;)v=v.forward[p];b[p]=v}if(v=v.forward[0],v&&E(v.key,I)===0)return v.value=S,!1;{const p=k.j(P);if(p>P.d){for(let d=P.d;d<p;d++)b[d]=P.e;P.d=p}v=new i(p,I,S);for(let d=0;d<p;d++)v.forward[d]=b[d].forward[d],b[d].forward[d]=v;return!0}}static j(P,I=.5){let S=1;for(;Math.random()<I&&S<P.c;)S+=1;return S}static k(P,I,S){const E=[];let b=P.e;for(let v=P.d-1;v>=0;v--){for(;b.forward[v]&&S(b.forward[v].key,I)<0;)b=b.forward[v];E[v]=b}if(b=b.forward[0],!b||S(b.key,I)!==0)return!1;for(let v=0;v<P.d&&E[v].forward[v]===b;v++)E[v].forward[v]=b.forward[v];for(;P.d>0&&P.e.forward[P.d-1]===D;)P.d-=1;return!0}}e.SkipList=k}),define(re[43],ae([0,1,9,2]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(h){const f=h;return f?typeof f.read=="function":!1}e.isReadable=D;function k(h){const f=h;return f?[f.on,f.pause,f.resume,f.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=k;function L(h){const f=h;return f?k(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=L;function P(h,f){return new I(h,f)}e.newWriteableStream=P;class I{constructor(f,n){this.e=f,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(n=>n(f))}h(f){this.c.error.length===0?(0,R.onUnexpectedError)(f):this.c.error.slice(0).forEach(n=>n(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,n){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(f,n){if(this.a.destroyed)return;let r;switch(f){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(n);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(h,f){const n=[];let r;for(;(r=h.read())!==null;)n.push(r);return f(n)}e.consumeReadable=S;function E(h,f,n){const r=[];let t;for(;(t=h.read())!==null&&r.length<n;)r.push(t);return t===null&&r.length>0?f(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const a=t;return t=void 0,a}return h.read()}}}e.peekReadable=E;function b(h,f){return new Promise((n,r)=>{const t=[];v(h,{onData:a=>{f&&t.push(a)},onError:a=>{f?r(a):n(void 0)},onEnd:()=>{n(f?f(t):void 0)}})})}e.consumeStream=b;function v(h,f){let n=!1;return h.on("error",r=>{n||f.onError(r)}),h.on("end",()=>{n||f.onEnd()}),h.on("data",r=>{n||f.onData(r)}),(0,i.toDisposable)(()=>n=!0)}e.listenStream=v;function p(h,f){return new Promise((n,r)=>{const t=new i.DisposableStore,a=[],s=y=>{if(a.push(y),a.length>f)return t.dispose(),h.pause(),n({stream:h,buffer:a,ended:!1})},l=y=>r(y),o=()=>n({stream:h,buffer:a,ended:!0});t.add((0,i.toDisposable)(()=>h.removeListener("error",l))),h.on("error",l),t.add((0,i.toDisposable)(()=>h.removeListener("end",o))),h.on("end",o),t.add((0,i.toDisposable)(()=>h.removeListener("data",s))),h.on("data",s)})}e.peekStream=p;function d(h,f){const n=P(f);return n.end(h),n}e.toStream=d;function g(){const h=P(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=g;function w(h){let f=!1;return{read:()=>f?null:(f=!0,h)}}e.toReadable=w;function u(h,f,n){const r=P(n);return v(h,{onData:t=>r.write(f.data(t)),onError:t=>r.error(f.error?f.error(t):t),onEnd:()=>r.end()}),r}e.transform=u;function m(h,f,n){let r=!1;return{read:()=>{const t=f.read();return r?t:(r=!0,t!==null?n([h,t]):h)}}}e.prefixedReadable=m;function c(h,f,n){let r=!1;const t=P(n);return v(f,{onData:a=>r?t.write(a):(r=!0,t.write(n([h,a]))),onError:a=>t.error(a),onEnd:()=>{r||(r=!0,t.write(h)),t.end()}}),t}e.prefixedStream=c}),define(re[17],ae([0,1,43]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer<"u";let D,k;class L{static alloc(y){return i?new L(Buffer.allocUnsafe(y)):new L(new Uint8Array(y))}static wrap(y){return i&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new L(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&i?new L(Buffer.from(y)):(D||(D=new TextEncoder),new L(D.encode(y)))}static fromByteArray(y){const C=L.alloc(y.length);for(let T=0,W=y.length;T<W;T++)C.buffer[T]=y[T];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let O=0,j=y.length;O<j;O++)C+=y[O].byteLength}const T=L.alloc(C);let W=0;for(let O=0,j=y.length;O<j;O++){const F=y[O];T.set(F,W),W+=F.byteLength}return T}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=L.alloc(this.byteLength);return y.set(this),y}toString(){return i?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(y,C){return new L(this.buffer.subarray(y,C))}set(y,C){if(y instanceof L)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return S(this.buffer,y)}writeUInt32BE(y,C){E(this.buffer,y,C)}readUInt32LE(y){return b(this.buffer,y)}writeUInt32LE(y,C){v(this.buffer,y,C)}readUInt8(y){return p(this.buffer,y)}writeUInt8(y,C){d(this.buffer,y,C)}}e.VSBuffer=L;function P(o,y){return o[y+0]<<0>>>0|o[y+1]<<8>>>0}e.readUInt16LE=P;function I(o,y,C){o[C+0]=y&255,y=y>>>8,o[C+1]=y&255}e.writeUInt16LE=I;function S(o,y){return o[y]*2**24+o[y+1]*2**16+o[y+2]*2**8+o[y+3]}e.readUInt32BE=S;function E(o,y,C){o[C+3]=y,y=y>>>8,o[C+2]=y,y=y>>>8,o[C+1]=y,y=y>>>8,o[C]=y}e.writeUInt32BE=E;function b(o,y){return o[y+0]<<0>>>0|o[y+1]<<8>>>0|o[y+2]<<16>>>0|o[y+3]<<24>>>0}e.readUInt32LE=b;function v(o,y,C){o[C+0]=y&255,y=y>>>8,o[C+1]=y&255,y=y>>>8,o[C+2]=y&255,y=y>>>8,o[C+3]=y&255}e.writeUInt32LE=v;function p(o,y){return o[y]}e.readUInt8=p;function d(o,y,C){o[C]=y}e.writeUInt8=d;function g(o){return R.consumeReadable(o,y=>L.concat(y))}e.readableToBuffer=g;function w(o){return R.toReadable(o)}e.bufferToReadable=w;function u(o){return R.consumeStream(o,y=>L.concat(y))}e.streamToBuffer=u;async function m(o){return o.ended?L.concat(o.buffer):L.concat([...o.buffer,await u(o.stream)])}e.bufferedStreamToBuffer=m;function c(o){return R.toStream(o,y=>L.concat(y))}e.bufferToStream=c;function h(o){return R.transform(o,{data:y=>typeof y=="string"?L.fromString(y):L.wrap(y)},y=>L.concat(y))}e.streamToBufferReadableStream=h;function f(o){return R.newWriteableStream(y=>L.concat(y),o)}e.newWriteableBufferStream=f;function n(o,y){return R.prefixedReadable(o,y,C=>L.concat(C))}e.prefixedBufferReadable=n;function r(o,y){return R.prefixedStream(o,y,C=>L.concat(C))}e.prefixedBufferStream=r;function t(o){let y=0,C=0,T=0;const W=new Uint8Array(Math.floor(o.length/4*3)),O=F=>{switch(C){case 3:W[T++]=y|F,C=0;break;case 2:W[T++]=y|F>>>2,y=F<<6,C=3;break;case 1:W[T++]=y|F>>>4,y=F<<4,C=2;break;default:y=F<<2,C=1}};for(let F=0;F<o.length;F++){const A=o.charCodeAt(F);if(A>=65&&A<=90)O(A-65);else if(A>=97&&A<=122)O(A-97+26);else if(A>=48&&A<=57)O(A-48+52);else if(A===43||A===45)O(62);else if(A===47||A===95)O(63);else{if(A===61)break;throw new SyntaxError(`Unexpected base64 character ${o[F]}`)}}const j=T;for(;C>0;)O(0);return L.wrap(W).slice(0,j)}e.decodeBase64=t;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:o},y=!0,C=!1){const T=C?s:a;let W="";const O=o.byteLength%3;let j=0;for(;j<o.byteLength-O;j+=3){const F=o[j+0],A=o[j+1],M=o[j+2];W+=T[F>>>2],W+=T[(F<<4|A>>>4)&63],W+=T[(A<<2|M>>>6)&63],W+=T[M&63]}if(O===1){const F=o[j+0];W+=T[F>>>2],W+=T[F<<4&63],y&&(W+="==")}else if(O===2){const F=o[j+0],A=o[j+1];W+=T[F>>>2],W+=T[(F<<4|A>>>4)&63],W+=T[A<<2&63],y&&(W+="=")}return W}e.encodeBase64=l}),define(re[15],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function R(r){return typeof r=="string"}e.isString=R;function i(r){return Array.isArray(r)&&r.every(t=>R(t))}e.isStringArray=i;function D(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=D;function k(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}e.isTypedArray=k;function L(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=L;function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=P;function I(r){return r===!0||r===!1}e.isBoolean=I;function S(r){return typeof r>"u"}e.isUndefined=S;function E(r){return!b(r)}e.isDefined=E;function b(r){return S(r)||r===null}e.isUndefinedOrNull=b;function v(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=v;function p(r){if(b(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=p;function d(...r){const t=[];for(let a=0;a<r.length;a++){const s=r[a];if(b(s))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);t.push(s)}return t}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function w(r){if(!D(r))return!1;for(const t in r)if(g.call(r,t))return!1;return!0}e.isEmptyObject=w;function u(r){return typeof r=="function"}e.isFunction=u;function m(...r){return r.length>0&&r.every(u)}e.areFunctions=m;function c(r,t){const a=Math.min(r.length,t.length);for(let s=0;s<a;s++)h(r[s],t[s])}e.validateConstraints=c;function h(r,t){if(R(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(r instanceof t)return}catch{}if(!b(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function f(r){return r===null?void 0:r}e.withNullAsUndefined=f;function n(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=n}),define(re[32],ae([0,1,15]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const m=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([c,h])=>{m[c]=h&&typeof h=="object"?i(h):h}),m}e.deepClone=i;function D(u){if(!u||typeof u!="object")return u;const m=[u];for(;m.length>0;){const c=m.shift();Object.freeze(c);for(const h in c)if(k.call(c,h)){const f=c[h];typeof f=="object"&&!Object.isFrozen(f)&&!(0,R.isTypedArray)(f)&&m.push(f)}}return u}e.deepFreeze=D;const k=Object.prototype.hasOwnProperty;function L(u,m){return P(u,m,new Set)}e.cloneAndChange=L;function P(u,m,c){if((0,R.isUndefinedOrNull)(u))return u;const h=m(u);if(typeof h<"u")return h;if(Array.isArray(u)){const f=[];for(const n of u)f.push(P(n,m,c));return f}if((0,R.isObject)(u)){if(c.has(u))throw new Error("Cannot clone recursive data-structure");c.add(u);const f={};for(const n in u)k.call(u,n)&&(f[n]=P(u[n],m,c));return c.delete(u),f}return u}function I(u,m,c=!0){return(0,R.isObject)(u)?((0,R.isObject)(m)&&Object.keys(m).forEach(h=>{h in u?c&&((0,R.isObject)(u[h])&&(0,R.isObject)(m[h])?I(u[h],m[h],c):u[h]=m[h]):u[h]=m[h]}),u):m}e.mixin=I;function S(u,m){if(u===m)return!0;if(u==null||m===null||m===void 0||typeof u!=typeof m||typeof u!="object"||Array.isArray(u)!==Array.isArray(m))return!1;let c,h;if(Array.isArray(u)){if(u.length!==m.length)return!1;for(c=0;c<u.length;c++)if(!S(u[c],m[c]))return!1}else{const f=[];for(h in u)f.push(h);f.sort();const n=[];for(h in m)n.push(h);if(n.sort(),!S(f,n))return!1;for(c=0;c<f.length;c++)if(!S(u[f[c]],m[f[c]]))return!1}return!0}e.equals=S;function E(u){const m=new Set;return JSON.stringify(u,(c,h)=>{if((0,R.isObject)(h)||Array.isArray(h)){if(m.has(h))return"[Circular]";m.add(h)}return h})}e.safeStringify=E;function b(u,m){const c=Object.create(null);return!u||!m||Object.keys(m).forEach(f=>{const n=u[f],r=m[f];S(n,r)||(c[f]=r)}),c}e.distinct=b;function v(u,m){const c=m.toLowerCase(),h=Object.keys(u).find(f=>f.toLowerCase()===c);return h?u[h]:u[m]}e.getCaseInsensitive=v;function p(u,m){const c=Object.create(null);for(const[h,f]of Object.entries(u))m(h,f)&&(c[h]=f);return c}e.filter=p;function d(u){let m=[],c=Object.getPrototypeOf(u);for(;Object.prototype!==c;)m=m.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return m}e.getAllPropertyNames=d;function g(u){const m=[];for(const c of d(u))typeof u[c]=="function"&&m.push(c);return m}e.getAllMethodNames=g;function w(u,m){const c=f=>function(){const n=Array.prototype.slice.call(arguments,0);return m(f,n)},h={};for(const f of u)h[f]=c(f);return h}e.createProxyObject=w}),define(re[30],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(D){return R.test(D)}e.isUUID=i,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(P){for(let I=0;I<P.length;I++)P[I]=Math.floor(Math.random()*256);return P};const k=new Uint8Array(16),L=[];for(let P=0;P<256;P++)L.push(P.toString(16).padStart(2,"0"));return function(){D(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let I=0,S="";return S+=L[k[I++]],S+=L[k[I++]],S+=L[k[I++]],S+=L[k[I++]],S+="-",S+=L[k[I++]],S+=L[k[I++]],S+="-",S+=L[k[I++]],S+=L[k[I++]],S+="-",S+=L[k[I++]],S+=L[k[I++]],S+="-",S+=L[k[I++]],S+=L[k[I++]],S+=L[k[I++]],S+=L[k[I++]],S+=L[k[I++]],S+=L[k[I++]],S}}()}),define(re[130],ae([0,1,34]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(L){const P=L.replace(/\-/g,":").toLowerCase();return!i.has(P)}function k(){const L=(0,R.networkInterfaces)();for(const P in L){const I=L[P];if(I){for(const{mac:S}of I)if(D(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=k}),define(re[131],ae([0,1,85]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function i(P,I,S,E=1){let b=!1;return new Promise(v=>{const p=setTimeout(()=>{if(!b)return b=!0,v(0)},S);D(P,I,E,d=>{if(!b)return b=!0,clearTimeout(p),v(d)})})}e.findFreePort=i;function D(P,I,S,E){if(I===0)return E(0);const b=new R.Socket;b.once("connect",()=>(L(b),D(P+S,I-1,S,E))),b.once("data",()=>{}),b.once("error",v=>(L(b),v.code!=="ECONNREFUSED"?D(P+S,I-1,S,E):E(P))),b.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(P,I,S,E="127.0.0.1"){let b=!1,v,p=1;const d=R.createServer({pauseOnConnect:!0});function g(w,u){b||(b=!0,d.removeAllListeners(),d.close(),v&&clearTimeout(v),u(w))}return new Promise(w=>{v=setTimeout(()=>{g(0,w)},S),d.on("listening",()=>{g(P,w)}),d.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&p<I?(P++,p++,d.listen(P,E)):g(0,w)}),d.on("close",()=>{g(0,w)}),d.listen(P,E)})}e.findFreePortFaster=k;function L(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(I){console.error(I)}}}),define(re[132],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const R="Offline";function i(k){return k instanceof D?!0:k instanceof Error&&k.name===R&&k.message===R}e.isOfflineError=i;class D extends Error{constructor(){super(R),this.name=this.message}}e.OfflineError=D}),define(re[133],ae([0,1,17,9,132]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function k(I,S){if(!navigator.onLine)throw new D.OfflineError;I.proxyAuthorization&&(I.headers={...I.headers||{},"Proxy-Authorization":I.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((b,v)=>{E.open(I.type||"GET",I.url||"",!0,I.user,I.password),L(E,I),E.responseType="arraybuffer",E.onerror=p=>v(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=p=>{b({res:{statusCode:E.status,headers:P(E)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=p=>v(new Error(`XHR timeout: ${I.timeout}ms`)),I.timeout&&(E.timeout=I.timeout),E.send(I.data),S.onCancellationRequested(()=>{E.abort(),v((0,i.canceled)())})})}e.request=k;function L(I,S){if(S.headers){e:for(const E in S.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}I.setRequestHeader(E,S.headers[E])}}}function P(I){const S=Object.create(null);for(const E of I.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const b=E.indexOf(":");S[E.substr(0,b).trim().toLowerCase()]=E.substr(b+1).trim()}return S}}),define(re[134],ae([10,11]),function(_,e){return _.create("vs/base/common/date",e)}),define(re[65],ae([0,1,134]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,D=i*60,k=D*24,L=k*7,P=k*30,I=k*365;function S(b,v,p){typeof b!="number"&&(b=b.getTime());const d=Math.round((new Date().getTime()-b)/1e3);if(d<-30)return(0,R.localize)(0,null,S(new Date().getTime()+d*1e3,!1));if(d<30)return(0,R.localize)(1,null);let g;return d<i?(g=d,v?g===1?p?(0,R.localize)(2,null,g):(0,R.localize)(3,null,g):p?(0,R.localize)(4,null,g):(0,R.localize)(5,null,g):g===1?p?(0,R.localize)(6,null,g):(0,R.localize)(7,null,g):p?(0,R.localize)(8,null,g):(0,R.localize)(9,null,g)):d<D?(g=Math.floor(d/i),v?g===1?p?(0,R.localize)(10,null,g):(0,R.localize)(11,null,g):p?(0,R.localize)(12,null,g):(0,R.localize)(13,null,g):g===1?p?(0,R.localize)(14,null,g):(0,R.localize)(15,null,g):p?(0,R.localize)(16,null,g):(0,R.localize)(17,null,g)):d<k?(g=Math.floor(d/D),v?g===1?p?(0,R.localize)(18,null,g):(0,R.localize)(19,null,g):p?(0,R.localize)(20,null,g):(0,R.localize)(21,null,g):g===1?p?(0,R.localize)(22,null,g):(0,R.localize)(23,null,g):p?(0,R.localize)(24,null,g):(0,R.localize)(25,null,g)):d<L?(g=Math.floor(d/k),v?g===1?(0,R.localize)(26,null,g):(0,R.localize)(27,null,g):g===1?(0,R.localize)(28,null,g):(0,R.localize)(29,null,g)):d<P?(g=Math.floor(d/L),v?g===1?p?(0,R.localize)(30,null,g):(0,R.localize)(31,null,g):p?(0,R.localize)(32,null,g):(0,R.localize)(33,null,g):g===1?p?(0,R.localize)(34,null,g):(0,R.localize)(35,null,g):p?(0,R.localize)(36,null,g):(0,R.localize)(37,null,g)):d<I?(g=Math.floor(d/P),v?g===1?p?(0,R.localize)(38,null,g):(0,R.localize)(39,null,g):p?(0,R.localize)(40,null,g):(0,R.localize)(41,null,g):g===1?p?(0,R.localize)(42,null,g):(0,R.localize)(43,null,g):p?(0,R.localize)(44,null,g):(0,R.localize)(45,null,g)):(g=Math.floor(d/I),v?g===1?p?(0,R.localize)(46,null,g):(0,R.localize)(47,null,g):p?(0,R.localize)(48,null,g):(0,R.localize)(49,null,g):g===1?p?(0,R.localize)(50,null,g):(0,R.localize)(51,null,g):p?(0,R.localize)(52,null,g):(0,R.localize)(53,null,g))}e.fromNow=S;function E(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=E}),define(re[135],ae([10,11]),function(_,e){return _.create("vs/base/common/errorMessage",e)}),define(re[38],ae([0,1,19,15,135]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function k(b,v){return v&&(b.stack||b.stacktrace)?D.localize(0,null,P(b),L(b.stack)||L(b.stacktrace)):P(b)}function L(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?D.localize(1,null,b.message):b.message||D.localize(2,null)}function I(b=null,v=!1){if(!b)return D.localize(3,null);if(Array.isArray(b)){const p=R.coalesce(b),d=I(p[0],v);return p.length>1?D.localize(4,null,d,p.length):d}if(i.isString(b))return b;if(b.detail){const p=b.detail;if(p.error)return k(p.error,v);if(p.exception)return k(p.exception,v)}return b.stack?k(b,v):b.message?b.message:D.localize(5,null)}e.toErrorMessage=I;function S(b){const v=b;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=S;function E(b,v){let p;return typeof b=="string"?p=new Error(b):p=b,p.actions=v,p}e.createErrorWithActions=E}),define(re[136],ae([10,11]),function(_,e){return _.create("vs/base/common/jsonErrorMessages",e)}),define(re[137],ae([0,1,136]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function i(D){switch(D){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}e.getParseErrorMessage=i}),define(re[138],ae([10,11]),function(_,e){return _.create("vs/base/common/platform",e)}),define(re[5],ae([0,1,138]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let i=!1,D=!1,k=!1,L=!1,P=!1,I=!1,S=!1,E=!1,b=!1,v=!1,p,d=e.LANGUAGE_DEFAULT,g,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const m=typeof u?.versions?.electron=="string",c=m&&u?.type==="renderer";if(typeof navigator=="object"&&!c)w=navigator.userAgent,i=w.indexOf("Windows")>=0,D=w.indexOf("Macintosh")>=0,E=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=w.indexOf("Linux")>=0,v=w?.indexOf("Mobi")>=0,I=!0,p=R.getConfiguredDefaultLocale(R.localize(0,null))||e.LANGUAGE_DEFAULT,d=p;else if(typeof u=="object"){i=u.platform==="win32",D=u.platform==="darwin",k=u.platform==="linux",L=k&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,S=m,b=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const o=u.env.VSCODE_NLS_CONFIG;if(o)try{const y=JSON.parse(o),C=y.availableLanguages["*"];p=y.locale,d=C||e.LANGUAGE_DEFAULT,g=y._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var h;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function f(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=f;let n=0;D?n=1:i?n=3:k&&(n=2),e.isWindows=i,e.isMacintosh=D,e.isLinux=k,e.isLinuxSnap=L,e.isNative=P,e.isElectron=S,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=E,e.isMobile=v,e.isCI=b,e.platform=n,e.userAgent=w,e.language=d;var r;(function(o){function y(){return e.language}o.value=y;function C(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=C;function T(){return e.language==="en"}o.isDefault=T})(r=e.Language||(e.Language={})),e.locale=p,e.translationsConfigFile=g,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let T=0,W=o.length;T<W;T++){const O=o[T];if(O.id===C.data.vscodeScheduleAsyncWork){o.splice(T,1),O.callback();return}}});let y=0;return C=>{const T=++y;o.push({id:T,callback:C}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return o=>setTimeout(o)})();var t;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||E?2:i?1:3;let a=!0,s=!1;function l(){if(!s){s=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,a=new Uint16Array(o.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[36],ae([0,1,5]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof R.globals.vscode<"u"&&typeof R.globals.vscode.process<"u"){const D=R.globals.vscode.process;i={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(re[12],ae([0,1,36]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,D=97,k=90,L=122,P=46,I=47,S=92,E=58,b=63;class v extends Error{constructor(h,f,n){let r;typeof f=="string"&&f.indexOf("not ")===0?(r="must not be",f=f.replace(/^not /,"")):r="must be";const t=h.indexOf(".")!==-1?"property":"argument";let a=`The "${h}" ${t} ${r} of type ${f}`;a+=`. Received type ${typeof n}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function p(c,h){if(typeof c!="string")throw new v(h,"string",c)}function d(c){return c===I||c===S}function g(c){return c===I}function w(c){return c>=i&&c<=k||c>=D&&c<=L}function u(c,h,f,n){let r="",t=0,a=-1,s=0,l=0;for(let o=0;o<=c.length;++o){if(o<c.length)l=c.charCodeAt(o);else{if(n(l))break;l=I}if(n(l)){if(!(a===o-1||s===1))if(s===2){if(r.length<2||t!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const y=r.lastIndexOf(f);y===-1?(r="",t=0):(r=r.slice(0,y),t=r.length-1-r.lastIndexOf(f)),a=o,s=0;continue}else if(r.length!==0){r="",t=0,a=o,s=0;continue}}h&&(r+=r.length>0?`${f}..`:"..",t=2)}else r.length>0?r+=`${f}${c.slice(a+1,o)}`:r=c.slice(a+1,o),t=o-a-1;a=o,s=0}else l===P&&s!==-1?++s:s=-1}return r}function m(c,h){if(h===null||typeof h!="object")throw new v("pathObject","Object",h);const f=h.dir||h.root,n=h.base||`${h.name||""}${h.ext||""}`;return f?f===h.root?`${f}${n}`:`${f}${c}${n}`:n}e.win32={resolve(...c){let h="",f="",n=!1;for(let r=c.length-1;r>=-1;r--){let t;if(r>=0){if(t=c[r],p(t,"path"),t.length===0)continue}else h.length===0?t=R.cwd():(t=R.env[`=${h}`]||R.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==h.toLowerCase()&&t.charCodeAt(2)===S)&&(t=`${h}\\`));const a=t.length;let s=0,l="",o=!1;const y=t.charCodeAt(0);if(a===1)d(y)&&(s=1,o=!0);else if(d(y))if(o=!0,d(t.charCodeAt(1))){let C=2,T=C;for(;C<a&&!d(t.charCodeAt(C));)C++;if(C<a&&C!==T){const W=t.slice(T,C);for(T=C;C<a&&d(t.charCodeAt(C));)C++;if(C<a&&C!==T){for(T=C;C<a&&!d(t.charCodeAt(C));)C++;(C===a||C!==T)&&(l=`\\\\${W}\\${t.slice(T,C)}`,s=C)}}}else s=1;else w(y)&&t.charCodeAt(1)===E&&(l=t.slice(0,2),s=2,a>2&&d(t.charCodeAt(2))&&(o=!0,s=3));if(l.length>0)if(h.length>0){if(l.toLowerCase()!==h.toLowerCase())continue}else h=l;if(n){if(h.length>0)break}else if(f=`${t.slice(s)}\\${f}`,n=o,o&&h.length>0)break}return f=u(f,!n,"\\",d),n?`${h}\\${f}`:`${h}${f}`||"."},normalize(c){p(c,"path");const h=c.length;if(h===0)return".";let f=0,n,r=!1;const t=c.charCodeAt(0);if(h===1)return g(t)?"\\":c;if(d(t))if(r=!0,d(c.charCodeAt(1))){let s=2,l=s;for(;s<h&&!d(c.charCodeAt(s));)s++;if(s<h&&s!==l){const o=c.slice(l,s);for(l=s;s<h&&d(c.charCodeAt(s));)s++;if(s<h&&s!==l){for(l=s;s<h&&!d(c.charCodeAt(s));)s++;if(s===h)return`\\\\${o}\\${c.slice(l)}\\`;s!==l&&(n=`\\\\${o}\\${c.slice(l,s)}`,f=s)}}}else f=1;else w(t)&&c.charCodeAt(1)===E&&(n=c.slice(0,2),f=2,h>2&&d(c.charCodeAt(2))&&(r=!0,f=3));let a=f<h?u(c.slice(f),!r,"\\",d):"";return a.length===0&&!r&&(a="."),a.length>0&&d(c.charCodeAt(h-1))&&(a+="\\"),n===void 0?r?`\\${a}`:a:r?`${n}\\${a}`:`${n}${a}`},isAbsolute(c){p(c,"path");const h=c.length;if(h===0)return!1;const f=c.charCodeAt(0);return d(f)||h>2&&w(f)&&c.charCodeAt(1)===E&&d(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let h,f;for(let t=0;t<c.length;++t){const a=c[t];p(a,"path"),a.length>0&&(h===void 0?h=f=a:h+=`\\${a}`)}if(h===void 0)return".";let n=!0,r=0;if(typeof f=="string"&&d(f.charCodeAt(0))){++r;const t=f.length;t>1&&d(f.charCodeAt(1))&&(++r,t>2&&(d(f.charCodeAt(2))?++r:n=!1))}if(n){for(;r<h.length&&d(h.charCodeAt(r));)r++;r>=2&&(h=`\\${h.slice(r)}`)}return e.win32.normalize(h)},relative(c,h){if(p(c,"from"),p(h,"to"),c===h)return"";const f=e.win32.resolve(c),n=e.win32.resolve(h);if(f===n||(c=f.toLowerCase(),h=n.toLowerCase(),c===h))return"";let r=0;for(;r<c.length&&c.charCodeAt(r)===S;)r++;let t=c.length;for(;t-1>r&&c.charCodeAt(t-1)===S;)t--;const a=t-r;let s=0;for(;s<h.length&&h.charCodeAt(s)===S;)s++;let l=h.length;for(;l-1>s&&h.charCodeAt(l-1)===S;)l--;const o=l-s,y=a<o?a:o;let C=-1,T=0;for(;T<y;T++){const O=c.charCodeAt(r+T);if(O!==h.charCodeAt(s+T))break;O===S&&(C=T)}if(T!==y){if(C===-1)return n}else{if(o>y){if(h.charCodeAt(s+T)===S)return n.slice(s+T+1);if(T===2)return n.slice(s+T)}a>y&&(c.charCodeAt(r+T)===S?C=T:T===2&&(C=3)),C===-1&&(C=0)}let W="";for(T=r+C+1;T<=t;++T)(T===t||c.charCodeAt(T)===S)&&(W+=W.length===0?"..":"\\..");return s+=C,W.length>0?`${W}${n.slice(s,l)}`:(n.charCodeAt(s)===S&&++s,n.slice(s,l))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const h=e.win32.resolve(c);if(h.length<=2)return c;if(h.charCodeAt(0)===S){if(h.charCodeAt(1)===S){const f=h.charCodeAt(2);if(f!==b&&f!==P)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(w(h.charCodeAt(0))&&h.charCodeAt(1)===E&&h.charCodeAt(2)===S)return`\\\\?\\${h}`;return c},dirname(c){p(c,"path");const h=c.length;if(h===0)return".";let f=-1,n=0;const r=c.charCodeAt(0);if(h===1)return d(r)?c:".";if(d(r)){if(f=n=1,d(c.charCodeAt(1))){let s=2,l=s;for(;s<h&&!d(c.charCodeAt(s));)s++;if(s<h&&s!==l){for(l=s;s<h&&d(c.charCodeAt(s));)s++;if(s<h&&s!==l){for(l=s;s<h&&!d(c.charCodeAt(s));)s++;if(s===h)return c;s!==l&&(f=n=s+1)}}}}else w(r)&&c.charCodeAt(1)===E&&(f=h>2&&d(c.charCodeAt(2))?3:2,n=f);let t=-1,a=!0;for(let s=h-1;s>=n;--s)if(d(c.charCodeAt(s))){if(!a){t=s;break}}else a=!1;if(t===-1){if(f===-1)return".";t=f}return c.slice(0,t)},basename(c,h){h!==void 0&&p(h,"ext"),p(c,"path");let f=0,n=-1,r=!0,t;if(c.length>=2&&w(c.charCodeAt(0))&&c.charCodeAt(1)===E&&(f=2),h!==void 0&&h.length>0&&h.length<=c.length){if(h===c)return"";let a=h.length-1,s=-1;for(t=c.length-1;t>=f;--t){const l=c.charCodeAt(t);if(d(l)){if(!r){f=t+1;break}}else s===-1&&(r=!1,s=t+1),a>=0&&(l===h.charCodeAt(a)?--a===-1&&(n=t):(a=-1,n=s))}return f===n?n=s:n===-1&&(n=c.length),c.slice(f,n)}for(t=c.length-1;t>=f;--t)if(d(c.charCodeAt(t))){if(!r){f=t+1;break}}else n===-1&&(r=!1,n=t+1);return n===-1?"":c.slice(f,n)},extname(c){p(c,"path");let h=0,f=-1,n=0,r=-1,t=!0,a=0;c.length>=2&&c.charCodeAt(1)===E&&w(c.charCodeAt(0))&&(h=n=2);for(let s=c.length-1;s>=h;--s){const l=c.charCodeAt(s);if(d(l)){if(!t){n=s+1;break}continue}r===-1&&(t=!1,r=s+1),l===P?f===-1?f=s:a!==1&&(a=1):f!==-1&&(a=-1)}return f===-1||r===-1||a===0||a===1&&f===r-1&&f===n+1?"":c.slice(f,r)},format:m.bind(null,"\\"),parse(c){p(c,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return h;const f=c.length;let n=0,r=c.charCodeAt(0);if(f===1)return d(r)?(h.root=h.dir=c,h):(h.base=h.name=c,h);if(d(r)){if(n=1,d(c.charCodeAt(1))){let C=2,T=C;for(;C<f&&!d(c.charCodeAt(C));)C++;if(C<f&&C!==T){for(T=C;C<f&&d(c.charCodeAt(C));)C++;if(C<f&&C!==T){for(T=C;C<f&&!d(c.charCodeAt(C));)C++;C===f?n=C:C!==T&&(n=C+1)}}}}else if(w(r)&&c.charCodeAt(1)===E){if(f<=2)return h.root=h.dir=c,h;if(n=2,d(c.charCodeAt(2))){if(f===3)return h.root=h.dir=c,h;n=3}}n>0&&(h.root=c.slice(0,n));let t=-1,a=n,s=-1,l=!0,o=c.length-1,y=0;for(;o>=n;--o){if(r=c.charCodeAt(o),d(r)){if(!l){a=o+1;break}continue}s===-1&&(l=!1,s=o+1),r===P?t===-1?t=o:y!==1&&(y=1):t!==-1&&(y=-1)}return s!==-1&&(t===-1||y===0||y===1&&t===s-1&&t===a+1?h.base=h.name=c.slice(a,s):(h.name=c.slice(a,t),h.base=c.slice(a,s),h.ext=c.slice(t,s))),a>0&&a!==n?h.dir=c.slice(0,a-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let h="",f=!1;for(let n=c.length-1;n>=-1&&!f;n--){const r=n>=0?c[n]:R.cwd();p(r,"path"),r.length!==0&&(h=`${r}/${h}`,f=r.charCodeAt(0)===I)}return h=u(h,!f,"/",g),f?`/${h}`:h.length>0?h:"."},normalize(c){if(p(c,"path"),c.length===0)return".";const h=c.charCodeAt(0)===I,f=c.charCodeAt(c.length-1)===I;return c=u(c,!h,"/",g),c.length===0?h?"/":f?"./":".":(f&&(c+="/"),h?`/${c}`:c)},isAbsolute(c){return p(c,"path"),c.length>0&&c.charCodeAt(0)===I},join(...c){if(c.length===0)return".";let h;for(let f=0;f<c.length;++f){const n=c[f];p(n,"path"),n.length>0&&(h===void 0?h=n:h+=`/${n}`)}return h===void 0?".":e.posix.normalize(h)},relative(c,h){if(p(c,"from"),p(h,"to"),c===h||(c=e.posix.resolve(c),h=e.posix.resolve(h),c===h))return"";const f=1,n=c.length,r=n-f,t=1,a=h.length-t,s=r<a?r:a;let l=-1,o=0;for(;o<s;o++){const C=c.charCodeAt(f+o);if(C!==h.charCodeAt(t+o))break;C===I&&(l=o)}if(o===s)if(a>s){if(h.charCodeAt(t+o)===I)return h.slice(t+o+1);if(o===0)return h.slice(t+o)}else r>s&&(c.charCodeAt(f+o)===I?l=o:o===0&&(l=0));let y="";for(o=f+l+1;o<=n;++o)(o===n||c.charCodeAt(o)===I)&&(y+=y.length===0?"..":"/..");return`${y}${h.slice(t+l)}`},toNamespacedPath(c){return c},dirname(c){if(p(c,"path"),c.length===0)return".";const h=c.charCodeAt(0)===I;let f=-1,n=!0;for(let r=c.length-1;r>=1;--r)if(c.charCodeAt(r)===I){if(!n){f=r;break}}else n=!1;return f===-1?h?"/":".":h&&f===1?"//":c.slice(0,f)},basename(c,h){h!==void 0&&p(h,"ext"),p(c,"path");let f=0,n=-1,r=!0,t;if(h!==void 0&&h.length>0&&h.length<=c.length){if(h===c)return"";let a=h.length-1,s=-1;for(t=c.length-1;t>=0;--t){const l=c.charCodeAt(t);if(l===I){if(!r){f=t+1;break}}else s===-1&&(r=!1,s=t+1),a>=0&&(l===h.charCodeAt(a)?--a===-1&&(n=t):(a=-1,n=s))}return f===n?n=s:n===-1&&(n=c.length),c.slice(f,n)}for(t=c.length-1;t>=0;--t)if(c.charCodeAt(t)===I){if(!r){f=t+1;break}}else n===-1&&(r=!1,n=t+1);return n===-1?"":c.slice(f,n)},extname(c){p(c,"path");let h=-1,f=0,n=-1,r=!0,t=0;for(let a=c.length-1;a>=0;--a){const s=c.charCodeAt(a);if(s===I){if(!r){f=a+1;break}continue}n===-1&&(r=!1,n=a+1),s===P?h===-1?h=a:t!==1&&(t=1):h!==-1&&(t=-1)}return h===-1||n===-1||t===0||t===1&&h===n-1&&h===f+1?"":c.slice(h,n)},format:m.bind(null,"/"),parse(c){p(c,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return h;const f=c.charCodeAt(0)===I;let n;f?(h.root="/",n=1):n=0;let r=-1,t=0,a=-1,s=!0,l=c.length-1,o=0;for(;l>=n;--l){const y=c.charCodeAt(l);if(y===I){if(!s){t=l+1;break}continue}a===-1&&(s=!1,a=l+1),y===P?r===-1?r=l:o!==1&&(o=1):r!==-1&&(o=-1)}if(a!==-1){const y=t===0&&f?1:t;r===-1||o===0||o===1&&r===a-1&&r===t+1?h.base=h.name=c.slice(y,a):(h.name=c.slice(y,r),h.base=c.slice(y,a),h.ext=c.slice(r,a))}return t>0?h.dir=c.slice(0,t-1):f&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(re[139],ae([0,1,12]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(E){const b=(0,R.extname)(E),v=i[b.toLowerCase()];return v!==void 0?v:L(E)}e.getMediaOrTextMime=k;function L(E){const b=(0,R.extname)(E);return D[b.toLowerCase()]}e.getMediaMime=L;function P(E){for(const b in D)if(D[b]===E)return b}e.getExtensionForMimeType=P;const I=/^(.+)\/(.+?)(;.+)?$/;function S(E,b){const v=I.exec(E);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:b?void 0:E}e.normalizeMimeType=S}),define(re[86],ae([0,1,5]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(i=e.Source||(e.Source={}));var D;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(P,...I){const S=I.reduce((v,p)=>(v[p]=!0,v),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(v=>!S[v]).forEach(v=>{for(let p=0;p<E.length;p++)if(v.search(E[p])!==-1){delete P[v];break}})}e.sanitizeProcessEnvironment=k;function L(P){!P||(delete P.DEBUG,R.isMacintosh&&delete P.DYLD_LIBRARY_PATH,R.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=L}),define(re[140],ae([0,1,5]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=R.globals.performance&&typeof R.globals.performance.now=="function";class D{static create(L=!0){return new D(L)}constructor(L){this.a=i&&L,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?R.globals.performance.now():Date.now()}}e.StopWatch=D}),define(re[3],ae([0,1,9,81,2,83,140]),function(_,e,R,i,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,I=!1;var S;(function(l){l.None=()=>D.Disposable.None;function o(q){if(I){const{onDidAddListener:J}=q,ne=d.create();let x=0;q.onDidAddListener=()=>{++x===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ne.print()),J?.()}}}function y(q,J){return B(q,()=>{},0,void 0,void 0,J)}l.defer=y;function C(q){return(J,ne=null,x)=>{let te=!1,se;return se=q(le=>{if(!te)return se?se.dispose():te=!0,J.call(ne,le)},null,x),te&&se.dispose(),se}}l.once=C;function T(q,J,ne){return M((x,te=null,se)=>q(le=>x.call(te,J(le)),null,se),ne)}l.map=T;function W(q,J,ne){return M((x,te=null,se)=>q(le=>{J(le),x.call(te,le)},null,se),ne)}l.forEach=W;function O(q,J,ne){return M((x,te=null,se)=>q(le=>J(le)&&x.call(te,le),null,se),ne)}l.filter=O;function j(q){return q}l.signal=j;function F(...q){return(J,ne=null,x)=>(0,D.combinedDisposable)(...q.map(te=>te(se=>J.call(ne,se),null,x)))}l.any=F;function A(q,J,ne,x){let te=ne;return T(q,se=>(te=J(te,se),te),x)}l.reduce=A;function M(q,J){let ne;const x={onWillAddFirstListener(){ne=q(te.fire,te)},onDidRemoveLastListener(){ne?.dispose()}};J||o(x);const te=new w(x);return J?.add(te),te.event}function B(q,J,ne=100,x=!1,te,se){let le,ue,ye,Se=0;const be={leakWarningThreshold:te,onWillAddFirstListener(){le=q(Te=>{Se++,ue=J(ue,Te),x&&!ye&&(Ce.fire(ue),ue=void 0),clearTimeout(ye),ye=setTimeout(()=>{const Fe=ue;ue=void 0,ye=void 0,(!x||Se>1)&&Ce.fire(Fe),Se=0},ne)})},onDidRemoveLastListener(){le.dispose()}};se||o(be);const Ce=new w(be);return se?.add(Ce),Ce.event}l.debounce=B;function G(q,J=0,ne){return l.debounce(q,(x,te)=>x?(x.push(te),x):[te],J,void 0,void 0,ne)}l.accumulate=G;function V(q,J=(x,te)=>x===te,ne){let x=!0,te;return O(q,se=>{const le=x||!J(se,te);return x=!1,te=se,le},ne)}l.latch=V;function Q(q,J,ne){return[l.filter(q,J,ne),l.filter(q,x=>!J(x),ne)]}l.split=Q;function $(q,J=!1,ne=[]){let x=ne.slice(),te=q(ue=>{x?x.push(ue):le.fire(ue)});const se=()=>{x?.forEach(ue=>le.fire(ue)),x=null},le=new w({onWillAddFirstListener(){te||(te=q(ue=>le.fire(ue)))},onDidAddFirstListener(){x&&(J?setTimeout(se):se())},onDidRemoveLastListener(){te&&te.dispose(),te=null}});return le.event}l.buffer=$;class z{constructor(J){this.event=J,this.c=new D.DisposableStore}map(J){return new z(T(this.event,J,this.c))}forEach(J){return new z(W(this.event,J,this.c))}filter(J){return new z(O(this.event,J,this.c))}reduce(J,ne){return new z(A(this.event,J,ne,this.c))}latch(){return new z(V(this.event,void 0,this.c))}debounce(J,ne=100,x=!1,te){return new z(B(this.event,J,ne,x,te,this.c))}on(J,ne,x){return this.event(J,ne,x)}once(J,ne,x){return C(this.event)(J,ne,x)}dispose(){this.c.dispose()}}function Y(q){return new z(q)}l.chain=Y;function ee(q,J,ne=x=>x){const x=(...ue)=>le.fire(ne(...ue)),te=()=>q.on(J,x),se=()=>q.removeListener(J,x),le=new w({onWillAddFirstListener:te,onDidRemoveLastListener:se});return le.event}l.fromNodeEventEmitter=ee;function oe(q,J,ne=x=>x){const x=(...ue)=>le.fire(ne(...ue)),te=()=>q.addEventListener(J,x),se=()=>q.removeEventListener(J,x),le=new w({onWillAddFirstListener:te,onDidRemoveLastListener:se});return le.event}l.fromDOMEventEmitter=oe;function X(q){return new Promise(J=>C(q)(J))}l.toPromise=X;function Z(q,J){return J(void 0),q(ne=>J(ne))}l.runAndSubscribe=Z;function U(q,J){let ne=null;function x(se){ne?.dispose(),ne=new D.DisposableStore,J(se,ne)}x(void 0);const te=q(se=>x(se));return(0,D.toDisposable)(()=>{te.dispose(),ne?.dispose()})}l.runAndSubscribeWithStore=U;class N{constructor(J,ne){this.obs=J,this.c=0,this.d=!1;const x={onWillAddFirstListener:()=>{J.addObserver(this)},onDidRemoveLastListener:()=>{J.removeObserver(this)}};ne||o(x),this.emitter=new w(x),ne&&ne.add(this.emitter)}beginUpdate(J){this.c++}handleChange(J,ne){this.d=!0}endUpdate(J){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function H(q,J){return new N(q,J).emitter.event}l.fromObservable=H})(S=e.Event||(e.Event={}));class E{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${E.c++}`,E.all.add(this)}start(o){this.d=new L.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=E,E.all=new Set,E.c=0;let b=-1;function v(l){const o=b;return b=l,{dispose(){b=o}}}e.setGlobalLeakWarningThreshold=v;class p{constructor(o,y=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=y,this.d=0}dispose(){this.c?.clear()}check(o,y){const C=this.threshold;if(C<=0||y<C)return;this.c||(this.c=new Map);const T=this.c.get(o.value)||0;if(this.c.set(o.value,T+1),this.d-=1,this.d<=0){this.d=C*.5;let W,O=0;for(const[j,F]of this.c)(!W||O<F)&&(W=j,O=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${O}):`),console.warn(W)}return()=>{const W=this.c.get(o.value)||0;this.c.set(o.value,W-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(o,y,C){this.callback=o,this.callbackThis=y,this.stack=C,this.subscription=new D.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class w{constructor(o){this.j=!1,this.d=o,this.f=b>0||this.d?.leakWarningThreshold?new p(this.d?.leakWarningThreshold??b):void 0,this.g=this.d?._profName?new E(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const o=Array.from(this.q);queueMicrotask(()=>{for(const y of o)y.subscription.isset()&&(y.subscription.unset(),y.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,y,C)=>{if(this.q||(this.q=new k.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.Disposable.None;const T=this.q.isEmpty();T&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let W,O;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(O=d.create(),W=this.f.check(O,this.q.size+1)),P&&(O=O??d.create());const j=new g(o,y,O),F=this.q.push(j);T&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,y);const A=j.subscription.set(()=>{W?.(),this.j||(F(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return C instanceof D.DisposableStore?C.add(A):Array.isArray(C)&&C.push(A),A}),this.l}fire(o){if(this.q){this.m||(this.m=new m);for(const y of this.q)this.m.push(this,y,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=w;class u{constructor(){this.c=new k.LinkedList}get size(){return this.c.size}push(o,y,C){this.c.push(new c(o,y,C))}clear(o){const y=new k.LinkedList;for(const C of this.c)C.emitter!==o&&y.push(C);this.c=y}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(y){(0,R.onUnexpectedError)(y)}}}}e.EventDeliveryQueue=u;class m extends u{clear(o){this.c.clear()}}class c{constructor(o,y,C){this.emitter=o,this.listener=y,this.event=C}}class h extends w{async fireAsync(o,y,C){if(!!this.q){this.c||(this.c=new k.LinkedList);for(const T of this.q)this.c.push([T,o]);for(;this.c.size>0&&!y.isCancellationRequested;){const[T,W]=this.c.shift(),O=[],j={...W,token:y,waitUntil:F=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");C&&(F=C(F,T.callback)),O.push(F)}};try{T.invoke(j)}catch(F){(0,R.onUnexpectedError)(F);continue}Object.freeze(O),await Promise.allSettled(O).then(F=>{for(const A of F)A.status==="rejected"&&(0,R.onUnexpectedError)(A.reason)})}}}}e.AsyncEmitter=h;class f extends w{constructor(o){super(o),this.h=0,this.s=new k.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}e.PauseableEmitter=f;class n extends f{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}e.DebounceEmitter=n;class r extends w{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){!this.hasListeners()||(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(y=>super.fire(y)),this.c=[]}))}}e.MicrotaskEmitter=r;class t{constructor(){this.d=!1,this.f=[],this.c=new w({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const y={event:o,listener:null};this.f.push(y),this.d&&this.j(y);const C=()=>{this.d&&this.k(y);const T=this.f.indexOf(y);this.f.splice(T,1)};return(0,D.toDisposable)((0,i.once)(C))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(y=>this.c.fire(y))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class a{constructor(){this.c=[]}wrapEvent(o){return(y,C,T)=>o(W=>{const O=this.c[this.c.length-1];O?O.push(()=>y.call(C,W)):y.call(C,W)},void 0,T)}bufferEvents(o){const y=[];this.c.push(y);const C=o();return this.c.pop(),y.forEach(T=>T()),C}}e.EventBufferer=a;class s{constructor(){this.c=!1,this.d=S.None,this.f=D.Disposable.None,this.g=new w({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(re[22],ae([0,1,3]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(P,I){const S=setTimeout(P.bind(I),0);return{dispose(){clearTimeout(S)}}});var D;(function(P){function I(S){return S===P.None||S===P.Cancelled||S instanceof k?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}P.isCancellationToken=I,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(D=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new R.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(I){this.a=void 0,this.b=void 0,this.b=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new k),this.a}cancel(){this.a?this.a instanceof k&&this.a.cancel():this.a=D.Cancelled}dispose(I=!1){I&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof k&&this.a.dispose():this.a=D.None}}e.CancellationTokenSource=L}),define(re[141],ae([0,1,22]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new R.CancellationTokenSource,I=this.b(P.token);return this.a={promise:I,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=i;class D{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const I=JSON.stringify(P);return this.b!==I&&(this.b=I,this.a=this.c(P)),this.a}}e.LRUCachedFunction=D;class k{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const I=this.b(P);return this.a.set(P,I),I}}e.CachedFunction=k}),define(re[87],ae([0,1,3,2]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const D=L=>({onDidChange:R.Event.None,value:L});e.staticObservableValue=D;class k extends i.Disposable{get value(){return this.b}set value(P){P!==this.b&&(this.b=P,this.a.fire(P))}constructor(P){super(),this.b=P,this.a=this.B(new R.Emitter),this.onDidChange=this.a.event}}e.MutableObservableValue=k}),define(re[27],ae([0,1,141,128]),function(_,e,R,i){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function k(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=k;const L=/{(\d+)}/g;function P(ie,...he){return he.length===0?ie:ie.replace(L,function(fe,me){const we=parseInt(me,10);return isNaN(we)||we<0||we>=he.length?fe:he[we]})}e.format=P;const I=/{([^}]+)}/g;function S(ie,he){return ie.replace(I,(fe,me)=>he[me]??fe)}e.format2=S;function E(ie){return ie.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=E;function b(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function v(ie,he){let fe=0;const me=he.charCodeAt(0);for(let we=ie.length-1;we>=0;we--)ie.charCodeAt(we)===me&&fe++;return fe}e.count=v;function p(ie,he,fe="\u2026"){return ie.length<=he?ie:`${ie.substr(0,he)}${fe}`}e.truncate=p;function d(ie,he=" "){const fe=g(ie,he);return w(fe,he)}e.trim=d;function g(ie,he){if(!ie||!he)return ie;const fe=he.length;if(fe===0||ie.length===0)return ie;let me=0;for(;ie.indexOf(he,me)===me;)me=me+fe;return ie.substring(me)}e.ltrim=g;function w(ie,he){if(!ie||!he)return ie;const fe=he.length,me=ie.length;if(fe===0||me===0)return ie;let we=me,Ie=-1;for(;Ie=ie.lastIndexOf(he,we-1),!(Ie===-1||Ie+fe!==we);){if(Ie===0)return"";we=Ie}return ie.substring(0,we)}e.rtrim=w;function u(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function m(ie){return ie.replace(/\*/g,"")}e.stripWildcards=m;function c(ie,he,fe={}){if(!ie)throw new Error("Cannot create regex from empty string");he||(ie=b(ie)),fe.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let me="";return fe.global&&(me+="g"),fe.matchCase||(me+="i"),fe.multiline&&(me+="m"),fe.unicode&&(me+="u"),new RegExp(ie,me)}e.createRegExp=c;function h(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function f(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function n(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.regExpFlags=n;function r(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=r;function t(ie){for(let he=0,fe=ie.length;he<fe;he++){const me=ie.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function a(ie,he=0,fe=ie.length){for(let me=he;me<fe;me++){const we=ie.charCodeAt(me);if(we!==32&&we!==9)return ie.substring(he,me)}return ie.substring(he,fe)}e.getLeadingWhitespace=a;function s(ie,he=ie.length-1){for(let fe=he;fe>=0;fe--){const me=ie.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.lastNonWhitespaceIndex=s;function l(ie,he,fe){const me=[];let we=0;for(const Ie of ie.matchAll(he)){if(me.push(ie.slice(we,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");we=Ie.index+Ie[0].length,me.push(fe(Ie[0],...Ie.slice(1),Ie.index,ie,Ie.groups))}return me.push(ie.slice(we)),Promise.all(me).then(Ie=>Ie.join(""))}e.replaceAsync=l;function o(ie,he){return ie<he?-1:ie>he?1:0}e.compare=o;function y(ie,he,fe=0,me=ie.length,we=0,Ie=he.length){for(;fe<me&&we<Ie;fe++,we++){const $e=ie.charCodeAt(fe),Le=he.charCodeAt(we);if($e<Le)return-1;if($e>Le)return 1}const Re=me-fe,He=Ie-we;return Re<He?-1:Re>He?1:0}e.compareSubstring=y;function C(ie,he){return T(ie,he,0,ie.length,0,he.length)}e.compareIgnoreCase=C;function T(ie,he,fe=0,me=ie.length,we=0,Ie=he.length){for(;fe<me&&we<Ie;fe++,we++){let $e=ie.charCodeAt(fe),Le=he.charCodeAt(we);if($e===Le)continue;if($e>=128||Le>=128)return y(ie.toLowerCase(),he.toLowerCase(),fe,me,we,Ie);O($e)&&($e-=32),O(Le)&&(Le-=32);const qe=$e-Le;if(qe!==0)return qe}const Re=me-fe,He=Ie-we;return Re<He?-1:Re>He?1:0}e.compareSubstringIgnoreCase=T;function W(ie){return ie>=48&&ie<=57}e.isAsciiDigit=W;function O(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=O;function j(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=j;function F(ie,he){return ie.length===he.length&&T(ie,he)===0}e.equalsIgnoreCase=F;function A(ie,he){const fe=he.length;return he.length>ie.length?!1:T(ie,he,0,fe)===0}e.startsWithIgnoreCase=A;function M(ie,he){const fe=Math.min(ie.length,he.length);let me;for(me=0;me<fe;me++)if(ie.charCodeAt(me)!==he.charCodeAt(me))return me;return fe}e.commonPrefixLength=M;function B(ie,he){const fe=Math.min(ie.length,he.length);let me;const we=ie.length-1,Ie=he.length-1;for(me=0;me<fe;me++)if(ie.charCodeAt(we-me)!==he.charCodeAt(Ie-me))return me;return fe}e.commonSuffixLength=B;function G(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=G;function V(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=V;function Q(ie,he){return(ie-55296<<10)+(he-56320)+65536}e.computeCodePoint=Q;function $(ie,he,fe){const me=ie.charCodeAt(fe);if(G(me)&&fe+1<he){const we=ie.charCodeAt(fe+1);if(V(we))return Q(me,we)}return me}e.getNextCodePoint=$;function z(ie,he){const fe=ie.charCodeAt(he-1);if(V(fe)&&he>1){const me=ie.charCodeAt(he-2);if(G(me))return Q(me,fe)}return fe}class Y{get offset(){return this.e}constructor(he,fe=0){this.c=he,this.d=he.length,this.e=fe}setOffset(he){this.e=he}prevCodePoint(){const he=z(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=$(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.CodePointIterator=Y;class ee{get offset(){return this.c.offset}constructor(he,fe=0){this.c=new Y(he,fe)}nextGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let we=he.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.nextCodePoint());if(Ee(we,Re)){fe.setOffset(Ie);break}we=Re}return fe.offset-me}prevGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let we=he.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.prevCodePoint());if(Ee(Re,we)){fe.setOffset(Ie);break}we=Re}return me-fe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=ee;function oe(ie,he){return new ee(ie,he).nextGraphemeLength()}e.nextCharLength=oe;function X(ie,he){return new ee(ie,he).prevGraphemeLength()}e.prevCharLength=X;function Z(ie,he){he>0&&V(ie.charCodeAt(he))&&he--;const fe=he+oe(ie,he);return[fe-X(ie,fe),fe]}e.getCharContainingOffset=Z;function U(ie){const he=new ee(ie);let fe=0;for(;!he.eol();)fe++,he.nextGraphemeLength();return fe}e.charCount=U;let N;function H(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(ie){return N||(N=H()),N.test(ie)}e.containsRTL=q;const J=/^[\t\n\r\x20-\x7E]*$/;function ne(ie){return J.test(ie)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function x(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=x;function te(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=te;function se(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=se;function le(ie,he){if(ie.length<he)return ie;const fe=/\b/g;let me=0;for(;fe.test(ie)&&!(ie.length-fe.lastIndex<he);)me=fe.lastIndex,fe.lastIndex+=1;return ie.substring(me).replace(/^\s/,"")}e.lcut=le;const ue=/\x1B\x5B[12]?K/g,ye=/\x1b\[\d+m/g,Se=/\x1b\[0?m/g;function be(ie){return ie&&(ie=ie.replace(ue,""),ie=ie.replace(ye,""),ie=ie.replace(Se,"")),ie}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Te(ie){return Ce(ie)?ie.substr(1):ie}e.stripUTF8BOM=Te;function Fe(ie,he){if(!ie||!he||ie.length<he.length)return!1;const fe=he.length,me=ie.toLowerCase();let we=0,Ie=-1;for(;we<fe;){const Re=me.indexOf(he[we],Ie+1);if(Re<0)return!1;Ie=Re,we++}return!0}e.fuzzyContains=Fe;function Ye(ie,he=!1){return ie?(he&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=Ye;function Be(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=Be;function ce(ie,he=1){if(he===0)return"";let fe=-1;do fe=ie.indexOf(`
`,fe+1),he--;while(he>0&&fe>=0);return fe===-1?ie:(ie[fe-1]==="\r"&&fe--,ie.substr(0,fe))}e.getNLines=ce;function de(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.singleLetterHash=de;function ge(ie){return Ae.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=ge;function Ee(ie,he){return ie===0?he!==5&&he!==7:ie===2&&he===3?!1:ie===4||ie===2||ie===3||he===4||he===2||he===3?!0:!(ie===8&&(he===8||he===9||he===11||he===12)||(ie===11||ie===9)&&(he===9||he===10)||(ie===12||ie===10)&&he===10||he===5||he===13||he===7||ie===1||ie===13&&he===14||ie===6&&he===6)}var Pe;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ae{static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const fe=this.d,me=fe.length/3;let we=1;for(;we<=me;)if(he<fe[3*we])we=2*we;else if(he>fe[3*we+1])we=2*we+1;else return fe[3*we+2];return 0}}Ae.c=null;function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(ie,he){if(ie===0)return 0;const fe=Oe(ie,he);if(fe!==void 0)return fe;const me=new Y(he,ie);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=je;function Oe(ie,he){const fe=new Y(he,ie);let me=fe.prevCodePoint();for(;Ue(me)||me===65039||me===8419;){if(fe.offset===0)return;me=fe.prevCodePoint()}if(!se(me))return;let we=fe.offset;return we>0&&fe.prevCodePoint()===8205&&(we=fe.offset),we}function Ue(ie){return 127995<=ie&&ie<=127999}var ze;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(he){return ke.d.get(Array.from(he))}static getLocales(){return ke.e.getValue()}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=ke,D=ke,ke.c=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.d=new R.LRUCachedFunction(ie=>{function he(Le){const qe=new Map;for(let Ge=0;Ge<Le.length;Ge+=2)qe.set(Le[Ge],Le[Ge+1]);return qe}function fe(Le,qe){const Ge=new Map(Le);for(const[et,at]of qe)Ge.set(et,at);return Ge}function me(Le,qe){if(!Le)return qe;const Ge=new Map;for(const[et,at]of Le)qe.has(et)&&Ge.set(et,at);return Ge}const we=D.c.getValue();let Ie=ie.filter(Le=>!Le.startsWith("_")&&Le in we);Ie.length===0&&(Ie=["_default"]);let Re;for(const Le of Ie){const qe=he(we[Le]);Re=me(Re,qe)}const He=he(we._common),$e=fe(He,Re);return new ke($e)}),ke.e=new i.Lazy(()=>Object.keys(ke.c.getValue()).filter(ie=>!ie.startsWith("_")));class Ne{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ne.c())),this.d}static isInvisibleCharacter(he){return Ne.e().has(he)}static get codePoints(){return Ne.e()}}e.InvisibleCharacters=Ne,Ne.d=void 0}),define(re[48],ae([0,1,12,5,27,15]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function L(s){return s===47||s===92}e.isPathSeparator=L;function P(s){return s.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=P;function I(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=I;function S(s,l=R.posix.sep){if(!s)return"";const o=s.length,y=s.charCodeAt(0);if(L(y)){if(L(s.charCodeAt(1))&&!L(s.charCodeAt(2))){let T=3;const W=T;for(;T<o&&!L(s.charCodeAt(T));T++);if(W!==T&&!L(s.charCodeAt(T+1))){for(T+=1;T<o;T++)if(L(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,l)}}return l}else if(u(y)&&s.charCodeAt(1)===58)return L(s.charCodeAt(2))?s.slice(0,2)+l:s.slice(0,2);let C=s.indexOf("://");if(C!==-1){for(C+=3;C<o;C++)if(L(s.charCodeAt(C)))return s.slice(0,C+1)}return""}e.getRoot=S;function E(s){if(!i.isWindows||!s||s.length<5)return!1;let l=s.charCodeAt(0);if(l!==92||(l=s.charCodeAt(1),l!==92))return!1;let o=2;const y=o;for(;o<s.length&&(l=s.charCodeAt(o),l!==92);o++);return!(y===o||(l=s.charCodeAt(o+1),isNaN(l)||l===92))}e.isUNC=E;const b=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,l=i.isWindows){const o=l?b:v;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||l&&p.test(s)||s==="."||s===".."||l&&s[s.length-1]==="."||l&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function g(s,l,o){const y=s===l;return!o||y?y:!s||!l?!1:(0,D.equalsIgnoreCase)(s,l)}e.isEqual=g;function w(s,l,o,y=R.sep){if(s===l)return!0;if(!s||!l||l.length>s.length)return!1;if(o){if(!(0,D.startsWithIgnoreCase)(s,l))return!1;if(l.length===s.length)return!0;let T=l.length;return l.charAt(l.length-1)===y&&T--,s.charAt(T)===y}return l.charAt(l.length-1)!==y&&(l+=y),s.indexOf(l)===0}e.isEqualOrParent=w;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function m(s,l){return i.isWindows&&s.endsWith(":")&&(s+=R.sep),(0,R.isAbsolute)(s)||(s=(0,R.join)(l,s)),s=(0,R.normalize)(s),i.isWindows?(s=(0,D.rtrim)(s,R.sep),s.endsWith(":")&&(s+=R.sep)):(s=(0,D.rtrim)(s,R.sep),s||(s=R.sep)),s}e.sanitizeFilePath=m;function c(s){const l=(0,R.normalize)(s);return i.isWindows?s.length>3?!1:h(l)&&(s.length===2||l.charCodeAt(2)===92):l===R.posix.sep}e.isRootOrDriveLetter=c;function h(s,l=i.isWindows){return l?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function f(s){return h(s)?s[0]:void 0}e.getDriveLetter=f;function n(s,l,o){return l.length>s.length?-1:s===l?0:(o&&(s=s.toLowerCase(),l=l.toLowerCase()),s.indexOf(l))}e.indexOfPath=n;function r(s){const l=s.split(":");let o,y,C;for(const T of l){const W=Number(T);(0,k.isNumber)(W)?y===void 0?y=W:C===void 0&&(C=W):o=o?[o,T].join(":"):T}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:y!==void 0?y:void 0,column:C!==void 0?C:y!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(s,l,o=8){let y="";for(let T=0;T<o;T++)y+=t.charAt(Math.floor(Math.random()*t.length));let C;return l?C=`${l}-${y}`:C=y,s?(0,R.join)(s,C):C}e.randomPath=a}),define(re[66],ae([0,1,27]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(u){return D(u,0)}e.hash=i;function D(u,m){switch(typeof u){case"object":return u===null?k(349,m):Array.isArray(u)?I(u,m):S(u,m);case"string":return P(u,m);case"boolean":return L(u,m);case"number":return k(u,m);case"undefined":return k(937,m);default:return k(617,m)}}e.doHash=D;function k(u,m){return(m<<5)-m+u|0}e.numberHash=k;function L(u,m){return k(u?433:863,m)}function P(u,m){m=k(149417,m);for(let c=0,h=u.length;c<h;c++)m=k(u.charCodeAt(c),m);return m}e.stringHash=P;function I(u,m){return m=k(104579,m),u.reduce((c,h)=>D(h,c),m)}function S(u,m){return m=k(181387,m),Object.keys(u).sort().reduce((c,h)=>(c=P(h,c),D(u[h],c)),m)}class E{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=D(m,this.g),this.g}}e.Hasher=E;var b;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function v(u,m,c=32){const h=c-m,f=~((1<<h)-1);return(u<<m|(f&u)>>>h)>>>0}function p(u,m=0,c=u.byteLength,h=0){for(let f=0;f<c;f++)u[m+f]=h}function d(u,m,c="0"){for(;u.length<m;)u=c+u;return u}function g(u,m=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(c=>c.toString(16).padStart(2,"0")).join(""):d((u>>>0).toString(16),m/4)}e.toHexString=g;class w{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const c=m.length;if(c===0)return;const h=this.p;let f=this.r,n=this.u,r,t;for(n!==0?(r=n,t=-1,n=0):(r=m.charCodeAt(0),t=0);;){let a=r;if(R.isHighSurrogate(r))if(t+1<c){const s=m.charCodeAt(t+1);R.isLowSurrogate(s)?(t++,a=R.computeCodePoint(r,s)):a=65533}else{n=r;break}else R.isLowSurrogate(r)&&(a=65533);if(f=this.w(h,f,a),t++,t<c)r=m.charCodeAt(t);else break}this.r=f,this.u=n}w(m,c,h){return h<128?m[c++]=h:h<2048?(m[c++]=192|(h&1984)>>>6,m[c++]=128|(h&63)>>>0):h<65536?(m[c++]=224|(h&61440)>>>12,m[c++]=128|(h&4032)>>>6,m[c++]=128|(h&63)>>>0):(m[c++]=240|(h&1835008)>>>18,m[c++]=128|(h&258048)>>>12,m[c++]=128|(h&4032)>>>6,m[c++]=128|(h&63)>>>0),c>=64&&(this.y(),c-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),c}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=w.g,c=this.q;for(let o=0;o<64;o+=4)m.setUint32(o,c.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)m.setUint32(o,v(m.getUint32(o-12,!1)^m.getUint32(o-32,!1)^m.getUint32(o-56,!1)^m.getUint32(o-64,!1),1),!1);let h=this.h,f=this.l,n=this.m,r=this.n,t=this.o,a,s,l;for(let o=0;o<80;o++)o<20?(a=f&n|~f&r,s=1518500249):o<40?(a=f^n^r,s=1859775393):o<60?(a=f&n|f&r|n&r,s=2400959708):(a=f^n^r,s=3395469782),l=v(h,5)+a+t+s+m.getUint32(o*4,!1)&4294967295,t=r,r=n,n=v(f,30),f=h,h=l;this.h=this.h+h&4294967295,this.l=this.l+f&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=w,w.g=new DataView(new ArrayBuffer(320))}),define(re[88],ae([0,1,27]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(i||(i={})),function(D){const k="error",L="warning",P="warn",I="info",S="ignore";function E(v){return v?R.equalsIgnoreCase(k,v)?D.Error:R.equalsIgnoreCase(L,v)||R.equalsIgnoreCase(P,v)?D.Warning:R.equalsIgnoreCase(I,v)?D.Info:D.Ignore:D.Ignore}D.fromValue=E;function b(v){switch(v){case D.Error:return k;case D.Warning:return L;case D.Info:return I;default:return S}}D.toString=b}(i||(i={})),e.default=i}),define(re[49],ae([0,1,19,27]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const d=p.charCodeAt(0),g=this.b.charCodeAt(this.c);return d-g}value(){return this.b[this.c]}}e.StringIterator=D;class k{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,i.compareSubstring)(p,this.b,0,p.length,this.c,this.d):(0,i.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=k;class L{constructor(p=!0,d=!0){this.f=p,this.g=d}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let d=p.length-1;d>=0;d--,this.c--){const g=this.b.charCodeAt(d);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,i.compareSubstring)(p,this.b,0,p.length,this.d,this.e):(0,i.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=L;var P;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(P||(P={}));class I{constructor(p,d){this.f=p,this.g=d,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,i.compareIgnoreCase)(p,this.c.scheme);if(this.d[this.e]===2)return(0,i.compareIgnoreCase)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,i.compare)(p,this.c.query);if(this.d[this.e]===5)return(0,i.compare)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=I;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(E||(E={}));class b{static forUris(p=()=>!1,d=()=>!1){return new b(new I(p,d))}static forPaths(p=!1){return new b(new L(void 0,!p))}static forStrings(){return new b(new D)}static forConfigKeys(){return new b(new k)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,d){if(d){const g=d.slice(0);(0,R.shuffle)(g);for(const w of g)this.set(w,p)}else{const g=p.slice(0);(0,R.shuffle)(g);for(const w of g)this.set(w[0],w[1])}}set(p,d){const g=this.b.reset(p);let w;this.c||(this.c=new S,this.c.segment=g.value());const u=[];for(w=this.c;;){const c=g.cmp(w.segment);if(c>0)w.left||(w.left=new S,w.left.segment=g.value()),u.push([-1,w]),w=w.left;else if(c<0)w.right||(w.right=new S,w.right.segment=g.value()),u.push([1,w]),w=w.right;else if(g.hasNext())g.next(),w.mid||(w.mid=new S,w.mid.segment=g.value()),u.push([0,w]),w=w.mid;else break}const m=w.value;w.value=d,w.key=p;for(let c=u.length-1;c>=0;c--){const h=u[c][1];h.updateHeight();const f=h.balanceFactor();if(f<-1||f>1){const n=u[c][0],r=u[c+1][0];if(n===1&&r===1)u[c][1]=h.rotateLeft();else if(n===-1&&r===-1)u[c][1]=h.rotateRight();else if(n===1&&r===-1)h.right=u[c+1][1]=u[c+1][1].rotateRight(),u[c][1]=h.rotateLeft();else if(n===-1&&r===1)h.left=u[c+1][1]=u[c+1][1].rotateLeft(),u[c][1]=h.rotateRight();else throw new Error;if(c>0)switch(u[c-1][0]){case-1:u[c-1][1].left=u[c][1];break;case 1:u[c-1][1].right=u[c][1];break;case 0:u[c-1][1].mid=u[c][1];break}else this.c=u[0][1]}}return m}get(p){return this.d(p)?.value}d(p){const d=this.b.reset(p);let g=this.c;for(;g;){const w=d.cmp(g.segment);if(w>0)g=g.left;else if(w<0)g=g.right;else if(d.hasNext())d.next(),g=g.mid;else break}return g}has(p){const d=this.d(p);return!(d?.value===void 0&&d?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,d){const g=this.b.reset(p),w=[];let u=this.c;for(;u;){const m=g.cmp(u.segment);if(m>0)w.push([-1,u]),u=u.left;else if(m<0)w.push([1,u]),u=u.right;else if(g.hasNext())g.next(),w.push([0,u]),u=u.mid;else break}if(!!u){if(d?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const m=this.f(u.right);if(m.key){const{key:c,value:h,segment:f}=m;this.e(m.key,!1),u.key=c,u.value=h,u.segment=f}}else{const m=u.left??u.right;if(w.length>0){const[c,h]=w[w.length-1];switch(c){case-1:h.left=m;break;case 0:h.mid=m;break;case 1:h.right=m;break}}else this.c=m}for(let m=w.length-1;m>=0;m--){const c=w[m][1];c.updateHeight();const h=c.balanceFactor();if(h>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),w[m][1]=c.rotateLeft()):h<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),w[m][1]=c.rotateRight()),m>0)switch(w[m-1][0]){case-1:w[m-1][1].left=w[m][1];break;case 1:w[m-1][1].right=w[m][1];break;case 0:w[m-1][1].mid=w[m][1];break}else this.c=w[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const d=this.b.reset(p);let g=this.c,w;for(;g;){const u=d.cmp(g.segment);if(u>0)g=g.left;else if(u<0)g=g.right;else if(d.hasNext())d.next(),w=g.value||w,g=g.mid;else break}return g&&g.value||w}findSuperstr(p){const d=this.b.reset(p);let g=this.c;for(;g;){const w=d.cmp(g.segment);if(w>0)g=g.left;else if(w<0)g=g.right;else if(d.hasNext())d.next(),g=g.mid;else return g.mid?this.g(g.mid):void 0}}forEach(p){for(const[d,g]of this)p(g,d)}*[Symbol.iterator](){yield*this.g(this.c)}g(p){const d=[];return this.h(p,d),d[Symbol.iterator]()}h(p,d){!p||(p.left&&this.h(p.left,d),p.value&&d.push([p.key,p.value]),p.mid&&this.h(p.mid,d),p.right&&this.h(p.right,d))}_isBalanced(){const p=d=>{if(!d)return!0;const g=d.balanceFactor();return g<-1||g>1?!1:p(d.left)&&p(d.right)};return p(this.c)}}e.TernarySearchTree=b}),define(re[8],ae([0,1,12,5]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,k=/^\//,L=/^\/\//;function P(t,a){if(!t.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!D.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!k.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(t,a){return!t&&!a?"file":t}function S(t,a){switch(t){case"https":case"http":case"file":a?a[0]!==b&&(a=b+a):a=b;break}return a}const E="",b="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{static isUri(a){return a instanceof p?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,s,l,o,y,C=!1){typeof a=="object"?(this.scheme=a.scheme||E,this.authority=a.authority||E,this.path=a.path||E,this.query=a.query||E,this.fragment=a.fragment||E):(this.scheme=I(a,C),this.authority=s||E,this.path=S(this.scheme,l||E),this.query=o||E,this.fragment=y||E,P(this,C))}get fsPath(){return c(this,!1)}with(a){if(!a)return this;let{scheme:s,authority:l,path:o,query:y,fragment:C}=a;return s===void 0?s=this.scheme:s===null&&(s=E),l===void 0?l=this.authority:l===null&&(l=E),o===void 0?o=this.path:o===null&&(o=E),y===void 0?y=this.query:y===null&&(y=E),C===void 0?C=this.fragment:C===null&&(C=E),s===this.scheme&&l===this.authority&&o===this.path&&y===this.query&&C===this.fragment?this:new g(s,l,o,y,C)}static parse(a,s=!1){const l=v.exec(a);return l?new g(l[2]||E,r(l[4]||E),r(l[5]||E),r(l[7]||E),r(l[9]||E),s):new g(E,E,E,E,E)}static file(a){let s=E;if(i.isWindows&&(a=a.replace(/\\/g,b)),a[0]===b&&a[1]===b){const l=a.indexOf(b,2);l===-1?(s=a.substring(2),a=b):(s=a.substring(2,l),a=a.substring(l)||b)}return new g("file",s,a,E,E)}static from(a){const s=new g(a.scheme,a.authority,a.path,a.query,a.fragment);return P(s,!0),s}static joinPath(a,...s){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return i.isWindows&&a.scheme==="file"?l=p.file(R.win32.join(c(a,!0),...s)).path:l=R.posix.join(a.path,...s),a.with({path:l})}toString(a=!1){return h(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof p)return a;{const s=new g(a);return s._formatted=a.external,s._fsPath=a._sep===d?a.fsPath:null,s}}else return a}}e.URI=p;const d=i.isWindows?1:void 0;class g extends p{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(a=!1){return a?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=d),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(t,a){let s,l=-1;for(let o=0;o<t.length;o++){const y=t.charCodeAt(o);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||a&&y===47)l!==-1&&(s+=encodeURIComponent(t.substring(l,o)),l=-1),s!==void 0&&(s+=t.charAt(o));else{s===void 0&&(s=t.substr(0,o));const C=w[y];C!==void 0?(l!==-1&&(s+=encodeURIComponent(t.substring(l,o)),l=-1),s+=C):l===-1&&(l=o)}}return l!==-1&&(s+=encodeURIComponent(t.substring(l))),s!==void 0?s:t}function m(t){let a;for(let s=0;s<t.length;s++){const l=t.charCodeAt(s);l===35||l===63?(a===void 0&&(a=t.substr(0,s)),a+=w[l]):a!==void 0&&(a+=t[s])}return a!==void 0?a:t}function c(t,a){let s;return t.authority&&t.path.length>1&&t.scheme==="file"?s=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?a?s=t.path.substr(1):s=t.path[1].toLowerCase()+t.path.substr(2):s=t.path,i.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=c;function h(t,a){const s=a?m:u;let l="",{scheme:o,authority:y,path:C,query:T,fragment:W}=t;if(o&&(l+=o,l+=":"),(y||o==="file")&&(l+=b,l+=b),y){let O=y.indexOf("@");if(O!==-1){const j=y.substr(0,O);y=y.substr(O+1),O=j.indexOf(":"),O===-1?l+=s(j,!1):(l+=s(j.substr(0,O),!1),l+=":",l+=s(j.substr(O+1),!1)),l+="@"}y=y.toLowerCase(),O=y.indexOf(":"),O===-1?l+=s(y,!1):(l+=s(y.substr(0,O),!1),l+=y.substr(O))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const O=C.charCodeAt(1);O>=65&&O<=90&&(C=`/${String.fromCharCode(O+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const O=C.charCodeAt(0);O>=65&&O<=90&&(C=`${String.fromCharCode(O+32)}:${C.substr(2)}`)}l+=s(C,!0)}return T&&(l+="?",l+=s(T,!1)),W&&(l+="#",l+=a?W:u(W,!1)),l}function f(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+f(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(n)?t.replace(n,a=>f(a)):t}}),define(re[142],ae([0,1,8]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function i(S){const E=S;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.isRemoteConsoleLog=i;function D(S){const E=[];let b;try{const v=JSON.parse(S.arguments),p=v[v.length-1];p&&p.__$stack&&(v.pop(),b=p.__$stack),E.push(...v)}catch{E.push("Unable to log remote console arguments",S.arguments)}return{args:E,stack:b}}e.parse=D;function k(S){if(typeof S!="string")return k(D(S).stack);const E=S;if(E){const b=L(E),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(v&&v.length===4)return{uri:R.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=k;function L(S){if(!S)return S;const E=S.indexOf(`
`);return E===-1?S:S.substring(0,E)}function P(S,E){const{args:b,stack:v}=D(S),p=typeof b[0]=="string"&&b.length===1;let d=L(v);d&&(d=`(${d.trim()})`);let g=[];if(typeof b[0]=="string"?d&&p?g=[`%c[${E}] %c${b[0]} %c${d}`,I("blue"),I(""),I("grey")]:g=[`%c[${E}] %c${b[0]}`,I("blue"),I(""),...b.slice(1)]:g=[`%c[${E}]%`,I("blue"),...b],d&&!p&&g.push(d),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,g)}e.log=P;function I(S){return`color: ${S}`}}),define(re[67],ae([0,1,17,27,8]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(S){return JSON.stringify(S,P)}e.stringify=k;function L(S){let E=JSON.parse(S);return E=I(E),E}e.parse=L;function P(S,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,i.regExpFlags)(E)}:E}function I(S,E=0){if(!S||E>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return D.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 15:return new Date(S.source)}if(S instanceof R.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let b=0;b<S.length;++b)S[b]=I(S[b],E+1);else for(const b in S)Object.hasOwnProperty.call(S,b)&&(S[b]=I(S[b],E+1))}return S}e.revive=I}),define(re[23],ae([0,1,5,8]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls",I.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(S){this.d=S}setDelegate(S){this.e=S}setServerRootPath(S){this.f=`${S}/${D.vscodeRemoteResource}`}set(S,E,b){this.a[S]=E,this.b[S]=b}setConnectionToken(S,E){this.c[S]=E}getPreferredWebSchema(){return this.d}rewrite(S){if(this.e)return this.e(S);const E=S.authority;let b=this.a[E];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const v=this.b[E],p=this.c[E];let d=`path=${encodeURIComponent(S.path)}`;return typeof p=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),i.URI.from({scheme:R.isWeb?this.d:D.vscodeRemoteResource,authority:`${b}:${v}`,path:this.f,query:d})}}e.RemoteAuthorities=new k,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class L{asBrowserUri(S){const E=this.b(S,_);return this.uriToBrowserUri(E)}uriToBrowserUri(S){return S.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(S):S.scheme===D.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${D.vscodeFileResource}://${L.a}`)?S.with({scheme:D.vscodeFileResource,authority:S.authority||L.a,query:null,fragment:null}):S}asFileUri(S){const E=this.b(S,_);return this.uriToFileUri(E)}uriToFileUri(S){return S.scheme===D.vscodeFileResource?S.with({scheme:D.file,authority:S.authority!==L.a?S.authority:null,query:null,fragment:null}):S}b(S,E){return i.URI.isUri(S)?S:i.URI.parse(E.toUrl(S))}}L.a="vscode-app",e.FileAccess=new L;var P;(function(I){const S=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);I.CoopAndCoep=Object.freeze(S.get("3"));const E="vscode-coi";function b(p){let d;typeof p=="string"?d=new URL(p).searchParams:p instanceof URL?d=p.searchParams:i.URI.isUri(p)&&(d=new URL(p.toString(!0)).searchParams);const g=d?.get(E);if(!!g)return S.get(g)}I.getHeadersFromQuery=b;function v(p,d,g){if(!globalThis.crossOriginIsolated)return;const w=d&&g?"3":g?"2":"1";p instanceof URLSearchParams?p.set(E,w):p[E]=w}I.addSearchParam=v})(P=e.COI||(e.COI={}))}),define(re[20],ae([0,1,48,23,12,5,27,8]),function(_,e,R,i,D,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(p){return(0,P.uriToFsPath)(p,!0)}e.originalFSPath=I;class S{constructor(d){this.a=d}compare(d,g,w=!1){return d===g?0:(0,L.compare)(this.getComparisonKey(d,w),this.getComparisonKey(g,w))}isEqual(d,g,w=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,w)===this.getComparisonKey(g,w)}getComparisonKey(d,g=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,g,w=!1){if(d.scheme===g.scheme){if(d.scheme===i.Schemas.file)return R.isEqualOrParent(I(d),I(g),this.a(d))&&d.query===g.query&&(w||d.fragment===g.fragment);if((0,e.isEqualAuthority)(d.authority,g.authority))return R.isEqualOrParent(d.path,g.path,this.a(d),"/")&&d.query===g.query&&(w||d.fragment===g.fragment)}return!1}joinPath(d,...g){return P.URI.joinPath(d,...g)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return D.posix.basename(d.path)}extname(d){return D.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===i.Schemas.file?g=P.URI.file(D.dirname(I(d))).path:(g=D.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===i.Schemas.file?g=P.URI.file(D.normalize(I(d))).path:g=D.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(d.scheme!==g.scheme||!(0,e.isEqualAuthority)(d.authority,g.authority))return;if(d.scheme===i.Schemas.file){const m=D.relative(I(d),I(g));return k.isWindows?R.toSlashes(m):m}let w=d.path||"/";const u=g.path||"/";if(this.a(d)){let m=0;for(const c=Math.min(w.length,u.length);m<c&&!(w.charCodeAt(m)!==u.charCodeAt(m)&&w.charAt(m).toLowerCase()!==u.charAt(m).toLowerCase());m++);w=u.substr(0,m)+w.substr(m)}return D.posix.relative(w,u)}resolvePath(d,g){if(d.scheme===i.Schemas.file){const w=P.URI.file(D.resolve(I(d),g));return d.with({authority:w.authority,path:w.path})}return g=R.toPosixPath(g),d.with({path:D.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||d!==void 0&&g!==void 0&&(0,L.equalsIgnoreCase)(d,g)}hasTrailingPathSeparator(d,g=D.sep){if(d.scheme===i.Schemas.file){const w=I(d);return w.length>R.getRoot(w).length&&w[w.length-1]===g}else{const w=d.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=D.sep){return(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=D.sep){let w=!1;if(d.scheme===i.Schemas.file){const u=I(d);w=u!==void 0&&u.length===R.getRoot(u).length&&u[u.length-1]===g}else{g="/";const u=d.path;w=u.length===1&&u.charCodeAt(u.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(p=>p.scheme===i.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new S(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function E(p,d){const g=[];for(let w=0;w<p.length;w++){const u=d(p[w]);p.some((m,c)=>c===w?!1:(0,e.isEqualOrParent)(u,d(m)))||g.push(p[w])}return g}e.distinctParents=E;var b;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function d(g){const w=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(c=>{const[h,f]=c.split(":");h&&f&&w.set(h,f)});const m=g.path.substring(0,g.path.indexOf(";"));return m&&w.set(p.META_DATA_MIME,m),w}p.parseMetaData=d})(b=e.DataUri||(e.DataUri={}));function v(p,d,g){if(d){let w=p.path;return w&&w[0]!==D.posix.sep&&(w=D.posix.sep+w),p.with({scheme:g,authority:d,path:w})}return p.with({scheme:g})}e.toLocalResource=v}),define(re[6],ae([0,1,22,9,3,2,20,5]),function(_,e,R,i,D,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(Z){return!!Z&&typeof Z.then=="function"}e.isThenable=I;function S(Z){const U=new R.CancellationTokenSource,N=Z(U.token),H=new Promise((q,J)=>{const ne=U.token.onCancellationRequested(()=>{ne.dispose(),U.dispose(),J(new i.CancellationError)});Promise.resolve(N).then(x=>{ne.dispose(),U.dispose(),q(x)},x=>{ne.dispose(),U.dispose(),J(x)})});return new class{cancel(){U.cancel()}then(q,J){return H.then(q,J)}catch(q){return this.then(void 0,q)}finally(q){return H.finally(q)}}}e.createCancelablePromise=S;function E(Z,U,N){return new Promise((H,q)=>{const J=U.onCancellationRequested(()=>{J.dispose(),H(N)});Z.then(H,q).finally(()=>J.dispose())})}e.raceCancellation=E;function b(Z,U){return new Promise((N,H)=>{const q=U.onCancellationRequested(()=>{q.dispose(),H(new i.CancellationError)});Z.then(N,H).finally(()=>q.dispose())})}e.raceCancellationError=b;async function v(Z){let U=-1;const N=Z.map((q,J)=>q.then(ne=>(U=J,ne))),H=await Promise.race(N);return Z.forEach((q,J)=>{J!==U&&q.cancel()}),H}e.raceCancellablePromises=v;function p(Z,U,N){let H;const q=setTimeout(()=>{H?.(void 0),N?.()},U);return Promise.race([Z.finally(()=>clearTimeout(q)),new Promise(J=>H=J)])}e.raceTimeout=p;function d(Z){return new Promise((U,N)=>{const H=Z();I(H)?H.then(U,N):U(H)})}e.asPromise=d;class g{constructor(){this.a=null,this.b=null,this.d=null}queue(U){if(this.a){if(this.d=U,!this.b){const N=()=>{this.b=null;const H=this.queue(this.d);return this.d=null,H};this.b=new Promise(H=>{this.a.then(N,N).then(H)})}return new Promise((N,H)=>{this.b.then(N,H)})}return this.a=U(),new Promise((N,H)=>{this.a.then(q=>{this.a=null,N(q)},q=>{this.a=null,H(q)})})}}e.Throttler=g;class w{constructor(){this.a=Promise.resolve(null)}queue(U){return this.a=this.a.then(()=>U(),()=>U())}}e.Sequencer=w;class u{constructor(){this.a=new Map}queue(U,N){const q=(this.a.get(U)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.a.get(U)===q&&this.a.delete(U)});return this.a.set(U,q),q}}e.SequencerByKey=u;const m=(Z,U)=>{let N=!0;const H=setTimeout(()=>{N=!1,U()},Z);return{isTriggered:()=>N,dispose:()=>{clearTimeout(H),N=!1}}},c=Z=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,Z())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(U){this.defaultDelay=U,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(U,N=this.defaultDelay){this.g=U,this.h(),this.b||(this.b=new Promise((q,J)=>{this.d=q,this.f=J}).then(()=>{if(this.b=null,this.d=null,this.g){const q=this.g;return this.g=null,q()}}));const H=()=>{this.a=null,this.d?.(null)};return this.a=N===e.MicrotaskDelay?c(H):m(N,H),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=h;class f{constructor(U){this.a=new h(U),this.b=new g}trigger(U,N){return this.a.trigger(()=>this.b.queue(U),N)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=f;class n{constructor(){this.a=!1,this.b=new Promise((U,N)=>{this.d=U})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class r extends n{constructor(U){super(),this.f=setTimeout(()=>this.open(),U)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function t(Z,U){return U?new Promise((N,H)=>{const q=setTimeout(()=>{J.dispose(),N()},Z),J=U.onCancellationRequested(()=>{clearTimeout(q),J.dispose(),H(new i.CancellationError)})}):S(N=>t(Z,N))}e.timeout=t;function a(Z,U=0){const N=setTimeout(Z,U);return(0,k.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=a;function s(Z){const U=[];let N=0;const H=Z.length;function q(){return N<H?Z[N++]():null}function J(ne){ne!=null&&U.push(ne);const x=q();return x?x.then(J):Promise.resolve(U)}return Promise.resolve(null).then(J)}e.sequence=s;function l(Z,U=H=>!!H,N=null){let H=0;const q=Z.length,J=()=>{if(H>=q)return Promise.resolve(N);const ne=Z[H++];return Promise.resolve(ne()).then(te=>U(te)?Promise.resolve(te):J())};return J()}e.first=l;function o(Z,U=H=>!!H,N=null){if(Z.length===0)return Promise.resolve(N);let H=Z.length;const q=()=>{H=-1;for(const J of Z)J.cancel?.()};return new Promise((J,ne)=>{for(const x of Z)x.then(te=>{--H>=0&&U(te)?(q(),J(te)):H===0&&J(N)}).catch(te=>{--H>=0&&(q(),ne(te))})})}e.firstParallel=o;class y{constructor(U){this.a=0,this.d=U,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(U){return this.a++,new Promise((N,H)=>{this.f.push({factory:U,c:N,e:H}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const U=this.f.shift();this.b++;const N=U.factory();N.then(U.c,U.e),N.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=y;class C extends y{constructor(){super(1)}}e.Queue=C;class T{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const U=new $;return this.b.add(U),U.p}d(){for(const[,U]of this.a)if(U.size>0)return!1;return!0}queueFor(U,N=L.extUri){const H=N.getComparisonKey(U);let q=this.a.get(H);return q||(q=new C,D.Event.once(q.onDrained)(()=>{q?.dispose(),this.a.delete(H),this.f()}),this.a.set(H,q)),q}f(){!this.d()||this.g()}g(){for(const U of this.b)U.complete();this.b.clear()}dispose(){for(const[,U]of this.a)U.dispose();this.a.clear(),this.g()}}e.ResourceQueue=T;class W{constructor(U,N){this.a=-1,typeof U=="function"&&typeof N=="number"&&this.setIfNotSet(U,N)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(U,N){this.cancel(),this.a=setTimeout(()=>{this.a=-1,U()},N)}setIfNotSet(U,N){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,U()},N))}}e.TimeoutTimer=W;class O{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(U,N){this.cancel(),this.a=setInterval(()=>{U()},N)}}e.IntervalTimer=O;class j{constructor(U,N){this.b=-1,this.a=U,this.d=N,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(U=this.d){this.cancel(),this.b=setTimeout(this.f,U)}get delay(){return this.d}set delay(U){this.d=U}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=j;class F{constructor(U,N){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.a=U,this.b=N,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(U=this.b){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(U/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=F;class A extends j{constructor(U,N){super(U,N),this.j=[]}work(U){this.j.push(U),this.isScheduled()||this.schedule()}h(){const U=this.j;this.j=[],this.a?.(U)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=A;class M extends k.Disposable{constructor(U,N){super(),this.g=U,this.h=N,this.a=[],this.b=this.B(new k.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(U){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+U.length>this.g.maxBufferedWork)return!1}else if(this.pending+U.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...U),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Z=>{(0,P.setTimeout0)(()=>{if(U)return;const N=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.runWhenIdle=(Z,U)=>{const N=requestIdleCallback(Z,typeof U=="number"?{timeout:U}:void 0);let H=!1;return{dispose(){H||(H=!0,cancelIdleCallback(N))}}}}();class B{constructor(U){this.d=!1,this.a=()=>{try{this.f=U()}catch(N){this.g=N}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=B;async function G(Z,U,N){let H;for(let q=0;q<N;q++)try{return await Z()}catch(J){H=J,await t(U)}throw H}e.retry=G;class V{hasPending(U){return this.a?typeof U=="number"?this.a.taskId===U:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(U,N,H){return this.a={taskId:U,cancel:()=>H?.(),promise:N},N.then(()=>this.d(U),()=>this.d(U)),N}d(U){this.a&&U===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const U=this.b;this.b=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this.b)this.b.run=U;else{let N,H;const q=new Promise((J,ne)=>{N=J,H=ne});this.b={run:U,promise:q,promiseResolve:N,promiseReject:H}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=V;class Q{constructor(U,N=()=>Date.now()){this.d=U,this.f=N,this.a=0,this.b=0}increment(){const U=this.f();return U-this.a>this.d&&(this.a=U,this.b=0),this.b++,this.b}}e.IntervalCounter=Q;class ${get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((U,N)=>{this.a=U,this.b=N})}complete(U){return new Promise(N=>{this.a(U),this.f=!0,N()})}error(U){return new Promise(N=>{this.b(U),this.d=!0,N()})}cancel(){new Promise(U=>{this.b(new i.CancellationError),this.d=!0,U()})}}e.DeferredPromise=$;var z;(function(Z){async function U(H){let q;const J=await Promise.all(H.map(ne=>ne.then(x=>x,x=>{q||(q=x)})));if(typeof q<"u")throw q;return J}Z.settled=U;function N(H){return new Promise(async(q,J)=>{try{await H(q,J)}catch(ne){J(ne)}})}Z.withAsyncBody=N})(z=e.Promises||(e.Promises={}));var Y;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(Y||(Y={}));class ee{static fromArray(U){return new ee(N=>{N.emitMany(U)})}static fromPromise(U){return new ee(async N=>{N.emitMany(await U)})}static fromPromises(U){return new ee(async N=>{await Promise.all(U.map(async H=>N.emitOne(await H)))})}static merge(U){return new ee(async N=>{await Promise.all(U.map(async H=>{for await(const q of H)N.emitOne(q)}))})}constructor(U){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const N={emitOne:H=>this.g(H),emitMany:H=>this.h(H),reject:H=>this.k(H)};try{await Promise.resolve(U(N)),this.j()}catch(H){this.k(H)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(U<this.b.length)return{done:!1,value:this.b[U++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(U,N){return new ee(async H=>{for await(const q of U)H.emitOne(N(q))})}map(U){return ee.map(this,U)}static filter(U,N){return new ee(async H=>{for await(const q of U)N(q)&&H.emitOne(q)})}filter(U){return ee.filter(this,U)}static coalesce(U){return ee.filter(U,N=>!!N)}coalesce(){return ee.coalesce(this)}static async toPromise(U){const N=[];for await(const H of U)N.push(H);return N}toPromise(){return ee.toPromise(this)}g(U){this.a===0&&(this.b.push(U),this.f.fire())}h(U){this.a===0&&(this.b=this.b.concat(U),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(U){this.a===0&&(this.a=2,this.d=U,this.f.fire())}}e.AsyncIterableObject=ee,ee.EMPTY=ee.fromArray([]);class oe extends ee{constructor(U,N){super(N),this.l=U}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=oe;function X(Z){const U=new R.CancellationTokenSource,N=Z(U.token);return new oe(U,async H=>{const q=U.token.onCancellationRequested(()=>{q.dispose(),U.dispose(),H.reject(new i.CancellationError)});try{for await(const J of N){if(U.token.isCancellationRequested)return;H.emitOne(J)}q.dispose(),U.dispose()}catch(J){q.dispose(),U.dispose(),H.reject(J)}})}e.createCancelableAsyncIterable=X}),define(re[89],ae([0,1,19,6,48,37,12,5,27]),function(_,e,R,i,D,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",b="[^/\\\\]",v=/\//g;function p($,z){switch($){case 0:return"";case 1:return`${b}*?`;default:return`(?:${E}|${b}+${E}${z?`|${E}${b}+`:""})*?`}}function d($,z){if(!$)return[];const Y=[];let ee=!1,oe=!1,X="";for(const Z of $){switch(Z){case z:if(!ee&&!oe){Y.push(X),X="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}X+=Z}return X&&Y.push(X),Y}e.splitGlobAware=d;function g($){if(!$)return"";let z="";const Y=d($,e.GLOB_SPLIT);if(Y.every(ee=>ee===e.GLOBSTAR))z=".*";else{let ee=!1;Y.forEach((oe,X)=>{if(oe===e.GLOBSTAR){if(ee)return;z+=p(2,X===Y.length-1)}else{let Z=!1,U="",N=!1,H="";for(const q of oe){if(q!=="}"&&Z){U+=q;continue}if(N&&(q!=="]"||!H)){let J;q==="-"?J=q:(q==="^"||q==="!")&&!H?J="^":q===e.GLOB_SPLIT?J="":J=(0,I.escapeRegExpCharacters)(q),H+=J;continue}switch(q){case"{":Z=!0;continue;case"[":N=!0;continue;case"}":{z+=`(?:${d(U,",").map(x=>g(x)).join("|")})`,Z=!1,U="";break}case"]":{z+="["+H+"]",N=!1,H="";break}case"?":z+=b;continue;case"*":z+=p(1);continue;default:z+=(0,I.escapeRegExpCharacters)(q)}}X<Y.length-1&&(Y[X+1]!==e.GLOBSTAR||X+2<Y.length)&&(z+=E)}ee=oe===e.GLOBSTAR})}return z}const w=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new k.LRUCache(1e4),r=function(){return!1},t=function(){return null};function a($,z){if(!$)return t;let Y;typeof $!="string"?Y=$.pattern:Y=$,Y=Y.trim();const ee=`${Y}_${!!z.trimForExclusions}`;let oe=n.get(ee);if(oe)return s(oe,$);let X;return w.test(Y)?oe=o(Y.substr(4),Y):(X=u.exec(l(Y,z)))?oe=y(X[1],Y):(z.trimForExclusions?c:m).test(Y)?oe=C(Y,z):(X=h.exec(l(Y,z)))?oe=T(X[1].substr(1),Y,!0):(X=f.exec(l(Y,z)))?oe=T(X[1],Y,!1):oe=W(Y),n.set(ee,oe),s(oe,$)}function s($,z){if(typeof z=="string")return $;const Y=function(ee,oe){return(0,D.isEqualOrParent)(ee,z.base,!P.isLinux)?$((0,I.ltrim)(ee.substr(z.base.length),L.sep),oe):null};return Y.allBasenames=$.allBasenames,Y.allPaths=$.allPaths,Y.basenames=$.basenames,Y.patterns=$.patterns,Y}function l($,z){return z.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function o($,z){return function(Y,ee){return typeof Y=="string"&&Y.endsWith($)?z:null}}function y($,z){const Y=`/${$}`,ee=`\\${$}`,oe=function(Z,U){return typeof Z!="string"?null:U?U===$?z:null:Z===$||Z.endsWith(Y)||Z.endsWith(ee)?z:null},X=[$];return oe.basenames=X,oe.patterns=[z],oe.allBasenames=X,oe}function C($,z){const Y=V($.slice(1,-1).split(",").map(U=>a(U,z)).filter(U=>U!==t),$),ee=Y.length;if(!ee)return t;if(ee===1)return Y[0];const oe=function(U,N){for(let H=0,q=Y.length;H<q;H++)if(Y[H](U,N))return $;return null},X=Y.find(U=>!!U.allBasenames);X&&(oe.allBasenames=X.allBasenames);const Z=Y.reduce((U,N)=>N.allPaths?U.concat(N.allPaths):U,[]);return Z.length&&(oe.allPaths=Z),oe}function T($,z,Y){const ee=L.sep===L.posix.sep,oe=ee?$:$.replace(v,L.sep),X=L.sep+oe,Z=L.posix.sep+$;let U;return Y?U=function(N,H){return typeof N=="string"&&(N===oe||N.endsWith(X)||!ee&&(N===$||N.endsWith(Z)))?z:null}:U=function(N,H){return typeof N=="string"&&(N===oe||!ee&&N===$)?z:null},U.allPaths=[(Y?"*/":"./")+$],U}function W($){try{const z=new RegExp(`^${g($)}$`);return function(Y){return z.lastIndex=0,typeof Y=="string"&&z.test(Y)?$:null}}catch{return t}}function O($,z,Y){return!$||typeof z!="string"?!1:j($)(z,void 0,Y)}e.match=O;function j($,z={}){if(!$)return r;if(typeof $=="string"||F($)){const Y=a($,z);if(Y===t)return r;const ee=function(oe,X){return!!Y(oe,X)};return Y.allBasenames&&(ee.allBasenames=Y.allBasenames),Y.allPaths&&(ee.allPaths=Y.allPaths),ee}return B($,z)}e.parse=j;function F($){const z=$;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}e.isRelativePattern=F;function A($){return $.allBasenames||[]}e.getBasenameTerms=A;function M($){return $.allPaths||[]}e.getPathTerms=M;function B($,z){const Y=V(Object.getOwnPropertyNames($).map(U=>G(U,$[U],z)).filter(U=>U!==t)),ee=Y.length;if(!ee)return t;if(!Y.some(U=>!!U.requiresSiblings)){if(ee===1)return Y[0];const U=function(q,J){let ne;for(let x=0,te=Y.length;x<te;x++){const se=Y[x](q,J);if(typeof se=="string")return se;(0,i.isThenable)(se)&&(ne||(ne=[]),ne.push(se))}return ne?(async()=>{for(const x of ne){const te=await x;if(typeof te=="string")return te}return null})():null},N=Y.find(q=>!!q.allBasenames);N&&(U.allBasenames=N.allBasenames);const H=Y.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return H.length&&(U.allPaths=H),U}const oe=function(U,N,H){let q,J;for(let ne=0,x=Y.length;ne<x;ne++){const te=Y[ne];te.requiresSiblings&&H&&(N||(N=(0,L.basename)(U)),q||(q=N.substr(0,N.length-(0,L.extname)(U).length)));const se=te(U,N,q,H);if(typeof se=="string")return se;(0,i.isThenable)(se)&&(J||(J=[]),J.push(se))}return J?(async()=>{for(const ne of J){const x=await ne;if(typeof x=="string")return x}return null})():null},X=Y.find(U=>!!U.allBasenames);X&&(oe.allBasenames=X.allBasenames);const Z=Y.reduce((U,N)=>N.allPaths?U.concat(N.allPaths):U,[]);return Z.length&&(oe.allPaths=Z),oe}function G($,z,Y){if(z===!1)return t;const ee=a($,Y);if(ee===t)return t;if(typeof z=="boolean")return ee;if(z){const oe=z.when;if(typeof oe=="string"){const X=(Z,U,N,H)=>{if(!H||!ee(Z,U))return null;const q=oe.replace("$(basename)",N),J=H(q);return(0,i.isThenable)(J)?J.then(ne=>ne?$:null):J?$:null};return X.requiresSiblings=!0,X}}return ee}function V($,z){const Y=$.filter(U=>!!U.basenames);if(Y.length<2)return $;const ee=Y.reduce((U,N)=>{const H=N.basenames;return H?U.concat(H):U},[]);let oe;if(z){oe=[];for(let U=0,N=ee.length;U<N;U++)oe.push(z)}else oe=Y.reduce((U,N)=>{const H=N.patterns;return H?U.concat(H):U},[]);const X=function(U,N){if(typeof U!="string")return null;if(!N){let q;for(q=U.length;q>0;q--){const J=U.charCodeAt(q-1);if(J===47||J===92)break}N=U.substr(q)}const H=ee.indexOf(N);return H!==-1?oe[H]:null};X.basenames=ee,X.patterns=oe,X.allBasenames=ee;const Z=$.filter(U=>!U.basenames);return Z.push(X),Z}function Q($,z){return(0,R.equals)($,z,(Y,ee)=>typeof Y=="string"&&typeof ee=="string"?Y===ee:typeof Y!="string"&&typeof ee!="string"?Y.base===ee.base&&Y.pattern===ee.pattern:!1)}e.patternsEquals=Q}),define(re[143],ae([0,1,8]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(E){return E.toJSON()}class D{constructor(b){this.a=b}transformIncoming(b){const v=this.a.transformIncoming(b);return v===b?b:i(R.URI.from(v))}transformOutgoing(b){const v=this.a.transformOutgoing(b);return v===b?b:i(R.URI.from(v))}transformOutgoingURI(b){const v=this.a.transformOutgoing(b);return v===b?b:R.URI.from(v)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function k(E,b,v){if(!E||v>200)return null;if(typeof E=="object"){if(E instanceof R.URI)return b.transformOutgoing(E);for(const p in E)if(Object.hasOwnProperty.call(E,p)){const d=k(E[p],b,v+1);d!==null&&(E[p]=d)}}return null}function L(E,b){const v=k(E,b,0);return v===null?E:v}e.transformOutgoingURIs=L;function P(E,b,v,p){if(!E||p>200)return null;if(typeof E=="object"){if(E.$mid===1)return v?R.URI.revive(b.transformIncoming(E)):b.transformIncoming(E);for(const d in E)if(Object.hasOwnProperty.call(E,d)){const g=P(E[d],b,v,p+1);g!==null&&(E[d]=g)}}return null}function I(E,b){const v=P(E,b,!1,0);return v===null?E:v}e.transformIncomingURIs=I;function S(E,b){const v=P(E,b,!0,0);return v===null?E:v}e.transformAndReviveIncomingURIs=S}),define(re[144],ae([0,1,34,9,49,30,130]),function(_,e,R,i,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(E){return this.a||(this.a=D.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(E)}value(){if(this.b===void 0){let E=0,b=0;const v=(0,R.networkInterfaces)();for(const p in v){const d=v[p];if(d)for(const{mac:g,internal:w}of d)w||(b+=1,this.c(g.toUpperCase())&&(E+=1))}this.b=b>0?E/b:0}return this.b}};let P;async function I(){return P||(P=(async()=>await S()||k.generateUuid())()),P}e.getMachineId=I;async function S(){try{const E=await new Promise((v,p)=>{_(["crypto"],v,p)}),b=(0,L.getMac)();return E.createHash("sha256").update(b,"utf8").digest("hex")}catch(E){i.onUnexpectedError(E);return}}}),define(re[28],ae([0,1,53,34,283,6,48,84,12,5,20,8]),function(_,e,R,i,D,k,L,P,I,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function p(B,G=v.UNLINK){if((0,L.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return G===v.UNLINK?g(B):d(B)}async function d(B){try{const G=(0,L.randomPath)((0,i.tmpdir)());try{await R.promises.rename(B,G)}catch(V){return V.code==="ENOENT"?void 0:g(B)}g(G).catch(V=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function g(B){return(0,D.promisify)(R.rm)(B,{recursive:!0,force:!0,maxRetries:3})}function w(B){if((0,L.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(B,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function u(B,G){return h(await(G?m(B):(0,D.promisify)(R.readdir)(B)))}async function m(B){try{return await(0,D.promisify)(R.readdir)(B,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const G=[],V=await u(B);for(const Q of V){let $=!1,z=!1,Y=!1;try{const ee=await e.Promises.lstat((0,I.join)(B,Q));$=ee.isFile(),z=ee.isDirectory(),Y=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}G.push({name:Q,isFile:()=>$,isDirectory:()=>z,isSymbolicLink:()=>Y})}return G}function c(B){return h(R.readdirSync(B))}e.readdirSync=c;function h(B){return B.map(G=>typeof G=="string"?S.isMacintosh?(0,P.normalizeNFC)(G):G:(G.name=S.isMacintosh?(0,P.normalizeNFC)(G.name):G.name,G))}async function f(B){const G=await u(B),V=[];for(const Q of G)await r.existsDirectory((0,I.join)(B,Q))&&V.push(Q);return V}function n(B,G=1e3){return new Promise(V=>{let Q=!1;const $=setInterval(()=>{Q||(Q=!0,R.access(B,z=>{Q=!1,z&&(clearInterval($),V(void 0))}))},G)})}e.whenDeleted=n;var r;(function(B){async function G($){let z;try{if(z=await e.Promises.lstat($),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat($),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(S.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw ee}throw Y}}B.stat=G;async function V($){try{const{stat:z,symbolicLink:Y}=await B.stat($);return z.isFile()&&Y?.dangling!==!0}catch{}return!1}B.existsFile=V;async function Q($){try{const{stat:z,symbolicLink:Y}=await B.stat($);return z.isDirectory()&&Y?.dangling!==!0}catch{}return!1}B.existsDirectory=Q})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new k.ResourceQueue;function a(B,G,V){return t.queueFor(b.URI.file(B),E.extUriBiasedIgnorePathCase).queue(()=>{const Q=C(V);return new Promise(($,z)=>o(B,G,Q,Y=>Y?z(Y):$()))})}let s=!0;function l(B){s=B}e.configureFlushOnWrite=l;function o(B,G,V,Q){if(!s)return R.writeFile(B,G,{mode:V.mode,flag:V.flag},Q);R.open(B,V.flag,V.mode,($,z)=>{if($)return Q($);R.writeFile(z,G,Y=>{if(Y)return R.close(z,()=>Q(Y));R.fdatasync(z,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),l(!1)),R.close(z,oe=>Q(oe))))})})}function y(B,G,V){const Q=C(V);if(!s)return R.writeFileSync(B,G,{mode:Q.mode,flag:Q.flag});const $=R.openSync(B,Q.flag,Q.mode);try{R.writeFileSync($,G);try{R.fdatasyncSync($)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),l(!1)}}finally{R.closeSync($)}}e.writeFileSync=y;function C(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function T(B,G){if(B!==G)try{await e.Promises.rename(B,G)}catch(V){if(B.toLowerCase()!==G.toLowerCase()&&V.code==="EXDEV"||B.endsWith("."))await W(B,G,{preserveSymlinks:!1}),await p(B,v.MOVE);else throw V}}async function W(B,G,V){return j(B,G,{root:{source:B,target:G},options:V,handledSourcePaths:new Set})}const O=511;async function j(B,G,V){if(V.handledSourcePaths.has(B))return;V.handledSourcePaths.add(B);const{stat:Q,symbolicLink:$}=await r.stat(B);if($){if(V.options.preserveSymlinks)try{return await M(B,G,V)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if($.dangling)return}return Q.isDirectory()?F(B,G,Q.mode&O,V):A(B,G,Q.mode&O)}async function F(B,G,V,Q){await e.Promises.mkdir(G,{recursive:!0,mode:V});const $=await u(B);for(const z of $)await j((0,I.join)(B,z),(0,I.join)(G,z),Q)}async function A(B,G,V){await e.Promises.copyFile(B,G),await e.Promises.chmod(G,V)}async function M(B,G,V){let Q=await e.Promises.readlink(B);(0,L.isEqualOrParent)(Q,V.root.source,!S.isLinux)&&(Q=(0,I.join)(V.root.target,Q.substr(V.root.source.length+1))),await e.Promises.symlink(Q,G)}e.Promises=new class{get access(){return(0,D.promisify)(R.access)}get stat(){return(0,D.promisify)(R.stat)}get lstat(){return(0,D.promisify)(R.lstat)}get utimes(){return(0,D.promisify)(R.utimes)}get read(){return(B,G,V,Q,$)=>new Promise((z,Y)=>{R.read(B,G,V,Q,$,(ee,oe,X)=>ee?Y(ee):z({bytesRead:oe,buffer:X}))})}get readFile(){return(0,D.promisify)(R.readFile)}get write(){return(B,G,V,Q,$)=>new Promise((z,Y)=>{R.write(B,G,V,Q,$,(ee,oe,X)=>ee?Y(ee):z({bytesWritten:oe,buffer:X}))})}get appendFile(){return(0,D.promisify)(R.appendFile)}get fdatasync(){return(0,D.promisify)(R.fdatasync)}get truncate(){return(0,D.promisify)(R.truncate)}get rename(){return(0,D.promisify)(R.rename)}get copyFile(){return(0,D.promisify)(R.copyFile)}get open(){return(0,D.promisify)(R.open)}get close(){return(0,D.promisify)(R.close)}get symlink(){return(0,D.promisify)(R.symlink)}get readlink(){return(0,D.promisify)(R.readlink)}get chmod(){return(0,D.promisify)(R.chmod)}get mkdir(){return(0,D.promisify)(R.mkdir)}get unlink(){return(0,D.promisify)(R.unlink)}get rmdir(){return(0,D.promisify)(R.rmdir)}get realpath(){return(0,D.promisify)(R.realpath)}async exists(B){try{return await e.Promises.access(B),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return f}get writeFile(){return a}get rm(){return p}get move(){return T}get copy(){return W}}}),define(re[145],ae([0,1,53,12,5,27,28]),function(_,e,R,i,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(v){if(D.isLinux)return v;const p=(0,i.dirname)(v);if(v===p)return v;const d=((0,i.basename)(v)||v).toLowerCase();try{const w=(0,L.readdirSync)(p).filter(u=>u.toLowerCase()===d);if(w.length===1){const u=P(p);if(u)return(0,i.join)(u,w[0])}else if(w.length>1){const u=w.indexOf(d);if(u>=0){const m=P(p);if(m)return(0,i.join)(m,w[u])}}}catch{}return null}e.realcaseSync=P;async function I(v){if(D.isLinux)return v;const p=(0,i.dirname)(v);if(v===p)return v;const d=((0,i.basename)(v)||v).toLowerCase();try{const w=(await L.Promises.readdir(p)).filter(u=>u.toLowerCase()===d);if(w.length===1){const u=await I(p);if(u)return(0,i.join)(u,w[0])}else if(w.length>1){const u=w.indexOf(d);if(u>=0){const m=await I(p);if(m)return(0,i.join)(m,w[u])}}}catch{}return null}e.realcase=I;async function S(v){try{return await L.Promises.realpath(v)}catch{const d=b(v);return await L.Promises.access(d,R.constants.R_OK),d}}e.realpath=S;function E(v){try{return R.realpathSync(v)}catch{const d=b(v);return R.accessSync(d,R.constants.R_OK),d}}e.realpathSync=E;function b(v){return(0,k.rtrim)((0,i.normalize)(v),i.sep)}}),define(re[90],ae([0,1,34,12,28]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,L=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var I;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(I||(I={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class b{constructor(f,n,r){this.exePath=f,this.displayName=n,this.a=r}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:h=!1}={}){return h?S===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:h=!1,findPreview:f=!1}={}){const n=v({useAlternateBitness:h});if(!n)return null;const r=i.join(n,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(r))return null;let t=-1,a=null;for(const o of await D.Promises.readdir(r)){let y=-1;if(f){const T=o.indexOf("-");if(T<0)continue;const W=o.substring(0,T);if(!k.test(W)||o.substring(T+1)!=="preview")continue;y=parseInt(W,10)}else{if(!k.test(o))continue;y=parseInt(o,10)}if(y<=t)continue;const C=i.join(r,o,"pwsh.exe");!await D.SymlinkSupport.existsFile(C)||(a=C,t=y)}if(!a)return null;const s=n.includes("x86")?" (x86)":"",l=f?" Preview":"";return new b(a,`PowerShell${l}${s}`,!0)}async function d({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const f=i.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=h?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(f))if(n.test(t)){const a=i.join(f,t,"pwsh.exe");return new b(a,r)}return null}function g(){const h=i.join(R.homedir(),".dotnet","tools","pwsh.exe");return new b(h,".NET Core PowerShell Global Tool")}function w(){const h=i.join(process.env.windir,S===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(h,"Windows PowerShell",!0)}async function*u(){let h=await p();h&&(yield h),h=await p({useAlternateBitness:!0}),h&&(yield h),h=await d(),h&&(yield h),h=g(),h&&(yield h),h=await p({findPreview:!0}),h&&(yield h),h=await d({findPreview:!0}),h&&(yield h),h=await p({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=w(),h&&(yield h)}async function*m(){for await(const h of u())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=m;async function c(){for await(const h of m())return h;return null}e.getFirstAvailablePowerShellInstallation=c}),define(re[91],ae([0,1,12,5,36,86,15,28]),function(_,e,R,i,D,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function I(b=D.env){return b.comspec||"cmd.exe"}e.getWindowsShell=I;function S(b){let v=[],p=!1;const d=function(g){if(p){v.push(g);return}(!b.send(g,u=>{if(u&&console.error(u),p=!1,v.length>0){const m=v.slice(0);v=[],m.forEach(c=>d(c))}})||i.isWindows)&&(p=!0)};return{send:d}}e.createQueuedSender=S;var E;(function(b){async function v(p,d,g){if(R.isAbsolute(p))return p;if(d===void 0&&(d=D.cwd()),R.dirname(p)!=="."||(g===void 0&&L.isString(D.env.PATH)&&(g=D.env.PATH.split(R.delimiter)),g===void 0||g.length===0))return R.join(d,p);async function u(m){if(await P.Promises.exists(m)){let c;try{c=await P.Promises.stat(m)}catch(h){h.message.startsWith("EACCES")&&(c=await P.Promises.lstat(m))}return c?!c.isDirectory():!1}return!1}for(const m of g){let c;if(R.isAbsolute(m)?c=R.join(m,p):c=R.join(d,m,p),await u(c))return c;let h=c+".com";if(await u(h)||(h=c+".exe",await u(h)))return h}return R.join(d,p)}b.findExecutable=v})(E=e.win32||(e.win32={}))}),define(re[146],ae([0,1,50,23]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(L){return new Promise((P,I)=>{let S;const E=new Map;function b(p,d,g,w,u){const m=E.get(d);if(p===L||m){const c={name:v(g),cmd:g,pid:p,ppid:d,load:w,mem:u};E.set(p,c),p===L&&(S=c),m&&(m.children||(m.children=[]),m.children.push(c),m.children.length>1&&(m.children=m.children.sort((h,f)=>h.pid-f.pid)))}}function v(p){const d=/--vscode-window-kind=shared-process/,g=/--vscode-window-kind=issue-reporter/,w=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,m=/--utility-sub-type=node.mojom.NodeService/,c=/--crashes-directory/,h=/\\pipe\\winpty-control/,f=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(c.exec(p))return"electron-crash-reporter";if(h.exec(p))return"winpty-process";if(f.exec(p))return"console-window-host (Windows internal process)";let r=n.exec(p);if(r&&r.length===2){if(r[1]==="renderer")return d.exec(p)?"shared-process":g.exec(p)?"issue-reporter":w.exec(p)?"process-explorer":"window";if(r[1]==="utility"){if(u.exec(p))return"utility-network-service";if(m.exec(p))return"extension-host"}return r[1]}const t=/[a-zA-Z-]+\.js/g;let a="";do r=t.exec(p),r&&(a+=r+" ");while(r);return a&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${a}`:p}if(process.platform==="win32"){const p=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,g)=>{_(["windows-process-tree"],d,g)}).then(d=>{d.getProcessList(L,g=>{if(!g){I(new Error(`Root process ${L} not found`));return}d.getProcessCpuUsage(g,w=>{const u=new Map;w.forEach(m=>{const c=p(m.commandLine||"");u.set(m.pid,{name:v(c),cmd:c,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),S=u.get(L),S?(u.forEach(m=>{const c=u.get(m.ppid);c&&(c.children||(c.children=[]),c.children.push(m))}),u.forEach(m=>{m.children&&(m.children=m.children.sort((c,h)=>c.pid-h.pid))}),P(S)):I(new Error(`Root process ${L} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let p=function(){let d=[S];const g=[];for(;d.length;){const u=d.shift();u&&(g.push(u.pid),u.children&&(d=d.concat(u.children)))}let w=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+g.join(" "),(0,R.exec)(w,{},(u,m,c)=>{if(u||c)I(u||new Error(c.toString()));else{const h=m.toString().split(`
`);for(let f=0;f<g.length;f++){const n=E.get(g[f]);n.load=parseFloat(h[f])}if(!S){I(new Error(`Root process ${L} not found`));return}P(S)}})};(0,R.exec)("which ps",{},(d,g,w)=>{if(d||w)if(process.platform!=="linux")I(d||new Error(w.toString()));else{const u=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,R.exec)(u,{},(m,c,h)=>{m||h?I(m||new Error(h.toString())):(k(c,b),p())})}else{const u=g.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${u} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,h,f)=>{c||f&&!f.includes("screen size is bogus")?I(c||new Error(f.toString())):(k(h,b),process.platform==="linux"?p():S?P(S):I(new Error(`Root process ${L} not found`)))})}})}})}e.listProcesses=D;function k(L,P){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=L.toString().split(`
`);for(const E of S){const b=I.exec(E.trim());b&&b.length===6&&P(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(re[147],ae([0,1,34,5,90,91]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function L(p,d){return p===1?i.isWindows?b():k.getWindowsShell(d):S(p,d)}e.getSystemShell=L;function P(p,d){return p===1?i.isWindows?v(d):k.getWindowsShell(d):S(p,d)}e.getSystemShellSync=P;let I=null;function S(p,d){if(i.isLinux&&p===2||i.isMacintosh&&p===3)return"/bin/bash";if(!I){let g;if(i.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=(0,R.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}I=g}return I}let E=null;async function b(){return E||(E=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),E}function v(p){if(E)return E;const d=i.isWindows&&parseFloat((0,R.release)())>=10,g=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${p.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?w:k.getWindowsShell(p)}});var pe=this&&this.__decorate||function(_,e,R,i){var D=arguments.length,k=D<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,R):i,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(_,e,R,i);else for(var P=_.length-1;P>=0;P--)(L=_[P])&&(k=(D<3?L(k):D>3?L(e,R,k):L(e,R))||k);return D>3&&k&&Object.defineProperty(e,R,k),k};define(re[39],ae([0,1,19,6,17,22,63,9,3,2,67,27,15]),function(_,e,R,i,D,k,L,P,I,S,E,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var p;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(p||(p={}));function d($){switch($){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(g||(g={}));function w($){switch($){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(u||(u={}));class m{constructor(z){this.b=z,this.a=0}read(z){const Y=this.b.slice(this.a,this.a+z);return this.a+=Y.byteLength,Y}}class c{constructor(){this.a=[]}get buffer(){return D.VSBuffer.concat(this.a)}write(z){this.a.push(z)}}var h;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object"})(h||(h={}));function f($){const z=D.VSBuffer.alloc(4);return z.writeUInt32BE($,0),z}function n($){return $.read(4).readUInt32BE(0)}function r($){const z=D.VSBuffer.alloc(1);return z.writeUInt8($,0),z}const t={Undefined:r(h.Undefined),String:r(h.String),Buffer:r(h.Buffer),VSBuffer:r(h.VSBuffer),Array:r(h.Array),Object:r(h.Object)},a=typeof Buffer<"u";function s($,z){if(typeof z>"u")$.write(t.Undefined);else if(typeof z=="string"){const Y=D.VSBuffer.fromString(z);$.write(t.String),$.write(f(Y.byteLength)),$.write(Y)}else if(a&&Buffer.isBuffer(z)){const Y=D.VSBuffer.wrap(z);$.write(t.Buffer),$.write(f(Y.byteLength)),$.write(Y)}else if(z instanceof D.VSBuffer)$.write(t.VSBuffer),$.write(f(z.byteLength)),$.write(z);else if(Array.isArray(z)){$.write(t.Array),$.write(f(z.length));for(const Y of z)s($,Y)}else{const Y=D.VSBuffer.fromString(JSON.stringify(z));$.write(t.Object),$.write(f(Y.byteLength)),$.write(Y)}}function l($){switch($.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return $.read(n($)).toString();case h.Buffer:return $.read(n($)).buffer;case h.VSBuffer:return $.read(n($));case h.Array:{const Y=n($),ee=[];for(let oe=0;oe<Y;oe++)ee.push(l($));return ee}case h.Object:return JSON.parse($.read(n($)).toString())}}class o{constructor(z,Y,ee=null,oe=1e3){this.h=z,this.j=Y,this.k=ee,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.p(X)),this.m({type:200})}registerChannel(z,Y){this.b.set(z,Y),setTimeout(()=>this.v(z),0)}m(z){switch(z.type){case 200:{const Y=this.n([z.type]);this.k?.logOutgoing(Y,0,1,w(z.type));return}case 201:case 202:case 204:case 203:{const Y=this.n([z.type,z.id],z.data);this.k?.logOutgoing(Y,z.id,1,w(z.type),z.data);return}}}n(z,Y=void 0){const ee=new c;return s(ee,z),s(ee,Y),this.o(ee.buffer)}o(z){try{return this.h.send(z),z.byteLength}catch{return 0}}p(z){const Y=new m(z),ee=l(Y),oe=l(Y),X=ee[0];switch(X){case 100:return this.k?.logIncoming(z.byteLength,ee[1],1,`${d(X)}: ${ee[2]}.${ee[3]}`,oe),this.q({type:X,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 102:return this.k?.logIncoming(z.byteLength,ee[1],1,`${d(X)}: ${ee[2]}.${ee[3]}`,oe),this.s({type:X,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 101:return this.k?.logIncoming(z.byteLength,ee[1],1,`${d(X)}`),this.t({type:X,id:ee[1]});case 103:return this.k?.logIncoming(z.byteLength,ee[1],1,`${d(X)}`),this.t({type:X,id:ee[1]})}}q(z){const Y=this.b.get(z.channelName);if(!Y){this.u(z);return}const ee=new k.CancellationTokenSource;let oe;try{oe=Y.call(this.j,z.name,z.arg,ee.token)}catch(U){oe=Promise.reject(U)}const X=z.id;oe.then(U=>{this.m({id:X,data:U,type:201}),this.d.delete(z.id)},U=>{U instanceof Error?this.m({id:X,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:X,data:U,type:203}),this.d.delete(z.id)});const Z=(0,S.toDisposable)(()=>ee.cancel());this.d.set(z.id,Z)}s(z){const Y=this.b.get(z.channelName);if(!Y){this.u(z);return}const ee=z.id,X=Y.listen(this.j,z.name,z.arg)(Z=>this.m({id:ee,data:Z,type:204}));this.d.set(z.id,X)}t(z){const Y=this.d.get(z.id);Y&&(Y.dispose(),this.d.delete(z.id))}u(z){let Y=this.g.get(z.channelName);Y||(Y=[],this.g.set(z.channelName,Y));const ee=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Y.push({request:z,timeoutTimer:ee})}v(z){const Y=this.g.get(z);if(Y){for(const ee of Y)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.q(ee.request);break;case 102:this.s(ee.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=o;var y;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class C{constructor(z,Y=null){this.l=z,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new I.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.r(ee)),this.j=Y}getChannel(z){const Y=this;return{call(ee,oe,X){return Y.a?Promise.reject(new P.CancellationError):Y.m(z,ee,oe,X)},listen(ee,oe){return Y.a?I.Event.None:Y.n(z,ee,oe)}}}m(z,Y,ee,oe=k.CancellationToken.None){const X=this.g++,U={id:X,type:100,channelName:z,name:Y,arg:ee};if(oe.isCancellationRequested)return Promise.reject(new P.CancellationError);let N;return new Promise((q,J)=>{if(oe.isCancellationRequested)return J(new P.CancellationError);const ne=()=>{const le=ue=>{switch(ue.type){case 201:this.f.delete(X),q(ue.data);break;case 202:{this.f.delete(X);const ye=new Error(ue.data.message);ye.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ye.name=ue.data.name,J(ye);break}case 203:this.f.delete(X),J(ue.data);break}};this.f.set(X,le),this.o(U)};let x=null;this.b===u.Idle?ne():(x=(0,i.createCancelablePromise)(le=>this.t()),x.then(()=>{x=null,ne()}));const te=()=>{x?(x.cancel(),x=null):this.o({id:X,type:101}),J(new P.CancellationError)},se=oe.onCancellationRequested(te);N=(0,S.combinedDisposable)((0,S.toDisposable)(te),se),this.d.add(N)}).finally(()=>{this.d.delete(N)})}n(z,Y,ee){const oe=this.g++,Z={id:oe,type:102,channelName:z,name:Y,arg:ee};let U=null;const N=new I.Emitter({onWillAddFirstListener:()=>{U=(0,i.createCancelablePromise)(q=>this.t()),U.then(()=>{U=null,this.d.add(N),this.o(Z)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(N),this.o({id:oe,type:103}))}}),H=q=>N.fire(q.data);return this.f.set(oe,H),N.event}o(z){switch(z.type){case 100:case 102:{const Y=this.p([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(Y,z.id,0,`${d(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const Y=this.p([z.type,z.id]);this.j?.logOutgoing(Y,z.id,0,d(z.type));return}}}p(z,Y=void 0){const ee=new c;return s(ee,z),s(ee,Y),this.q(ee.buffer)}q(z){try{return this.l.send(z),z.byteLength}catch{return 0}}r(z){const Y=new m(z),ee=l(Y),oe=l(Y),X=ee[0];switch(X){case 200:return this.j?.logIncoming(z.byteLength,0,0,w(X)),this.s({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(z.byteLength,ee[1],0,w(X),oe),this.s({type:ee[0],id:ee[1],data:oe})}}s(z){if(z.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}t(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.dispose)(this.d.values()),this.d.clear()}}pe([L.memoize],C.prototype,"onDidInitializePromise",null),e.ChannelClient=C;class T{get connections(){const z=[];return this.f.forEach(Y=>z.push(Y)),z}constructor(z){this.a=new Map,this.f=new Set,this.g=new I.Emitter,this.onDidAddConnection=this.g.event,this.h=new I.Emitter,this.onDidRemoveConnection=this.h.event,z(({protocol:Y,onDidClientDisconnect:ee})=>{I.Event.once(Y.onMessage)(X=>{const Z=new m(X),U=l(Z),N=new o(Y,U),H=new C(Y);this.a.forEach((J,ne)=>N.registerChannel(ne,J));const q={channelServer:N,channelClient:H,ctx:U};this.f.add(q),this.g.fire(q),ee(()=>{N.dispose(),H.dispose(),this.f.delete(q),this.h.fire(q)})})})}getChannel(z,Y){const ee=this;return{call(oe,X,Z){let U;if((0,v.isFunction)(Y)){const H=(0,R.getRandomElement)(ee.connections.filter(Y));U=H?Promise.resolve(H):I.Event.toPromise(I.Event.filter(ee.onDidAddConnection,Y))}else U=Y.routeCall(ee,oe,X);const N=U.then(H=>H.channelClient.getChannel(z));return O(N).call(oe,X,Z)},listen(oe,X){if((0,v.isFunction)(Y))return ee.j(z,Y,oe,X);const Z=Y.routeEvent(ee,oe,X).then(U=>U.channelClient.getChannel(z));return O(Z).listen(oe,X)}}}j(z,Y,ee,oe){const X=this;let Z=new S.DisposableStore;const U=new I.Emitter({onWillAddFirstListener:()=>{Z=new S.DisposableStore;const N=new I.EventMultiplexer,H=new Map,q=ne=>{const te=ne.channelClient.getChannel(z).listen(ee,oe),se=N.add(te);H.set(ne,se)},J=ne=>{const x=H.get(ne);!x||(x.dispose(),H.delete(ne))};X.connections.filter(Y).forEach(q),I.Event.filter(X.onDidAddConnection,Y)(q,void 0,Z),X.onDidRemoveConnection(J,void 0,Z),N.event(U.fire,U,Z),Z.add(N)},onDidRemoveLastListener:()=>{Z.dispose()}});return U.event}registerChannel(z,Y){this.a.set(z,Y),this.f.forEach(ee=>{ee.channelServer.registerChannel(z,Y)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=T;class W{constructor(z,Y,ee=null){const oe=new c;s(oe,Y),z.send(oe.buffer),this.a=new C(z,ee),this.d=new o(z,Y,ee)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,Y){this.d.registerChannel(z,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=W;function O($){return{call(z,Y,ee){return $.then(oe=>oe.call(z,Y,ee))},listen(z,Y){const ee=new I.Relay;return $.then(oe=>ee.input=oe.listen(z,Y)),ee.event}}}e.getDelayedChannel=O;function j($){let z=!1;return{call(Y,ee,oe){return z?$.call(Y,ee,oe):(0,i.timeout)(0).then(()=>z=!0).then(()=>$.call(Y,ee,oe))},listen(Y,ee){if(z)return $.listen(Y,ee);const oe=new I.Relay;return(0,i.timeout)(0).then(()=>z=!0).then(()=>oe.input=$.listen(Y,ee)),oe.event}}}e.getNextTickChannel=j;class F{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const Y of z.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await I.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.StaticRouter=F;var A;(function($){function z(X,Z){const U=X,N=Z&&Z.disableMarshalling,H=new Map;for(const q in U)ee(q)&&H.set(q,I.Event.buffer(U[q],!0));return new class{listen(q,J,ne){const x=H.get(J);if(x)return x;if(oe(J)){const te=U[J];if(typeof te=="function")return te.call(U,ne)}throw new Error(`Event not found: ${J}`)}call(q,J,ne){const x=U[J];if(typeof x=="function"){if(!N&&Array.isArray(ne))for(let te=0;te<ne.length;te++)ne[te]=(0,E.revive)(ne[te]);return x.apply(U,ne)}throw new Error(`Method not found: ${J}`)}}}$.fromService=z;function Y(X,Z){const U=Z&&Z.disableMarshalling;return new Proxy({},{get(N,H){if(typeof H=="string")return Z?.properties?.has(H)?Z.properties.get(H):oe(H)?function(q){return X.listen(H,q)}:ee(H)?X.listen(H):async function(...q){let J;Z&&!(0,v.isUndefinedOrNull)(Z.context)?J=[Z.context,...q]:J=q;const ne=await X.call(H,J);return U?ne:(0,E.revive)(ne)};throw new Error(`Property not found: ${String(H)}`)}})}$.toService=Y;function ee(X){return X[0]==="o"&&X[1]==="n"&&b.isUpperAsciiLetter(X.charCodeAt(2))}function oe(X){return/^onDynamic/.test(X)&&b.isUpperAsciiLetter(X.charCodeAt(9))}})(A=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){const z=$.toString();if(z!=="[object Object]")return z}return $}function G($){return Array.isArray($)?$.map(B):B($)}function V($,z,Y,ee,oe,X,Z){Z=G(Z);const U=M[oe],N=U[ee%U.length];let H=[`%c[${$}]%c[${String(z).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(X)?(H=H.concat(Z),H.push(")")):H.push(Z),console.log.apply(console,H)}class Q{constructor(z,Y){this.d=z,this.f=Y,this.a=0,this.b=0}logOutgoing(z,Y,ee,oe,X){this.b+=z,V(this.d,this.b,z,Y,ee,oe,X)}logIncoming(z,Y,ee,oe,X){this.a+=z,V(this.f,this.a,z,Y,ee,oe,X)}}e.IPCLogger=Q}),define(re[148],ae([0,1,17,3,39]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(I){this.a=I,this.onMessage=i.Event.fromDOMEventEmitter(this.a,"message",S=>R.VSBuffer.wrap(S.data)),I.start()}send(I){this.a.postMessage(I.buffer)}disconnect(){this.a.close()}}e.Protocol=k;class L extends D.IPCClient{constructor(I,S){const E=new k(I);super(E,S),this.b=E}dispose(){this.b.disconnect()}}e.Client=L}),define(re[92],ae([0,1,17,3,2,39]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(L=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(a){a.enableDiagnostics=!1,a.records=[];const s=new WeakMap;let l=0;function o(C,T){if(!s.has(C)){const W=String(++l);s.set(C,W)}return s.get(C)}function y(C,T,W,O){if(!a.enableDiagnostics)return;const j=o(C,T);if(O instanceof R.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const F=R.VSBuffer.alloc(O.byteLength);F.set(O),a.records.push({timestamp:Date.now(),id:j,label:T,type:W,buff:F})}else a.records.push({timestamp:Date.now(),id:j,label:T,type:W,data:O})}a.traceSocketEvent=y})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var I;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I=e.SocketCloseEventType||(e.SocketCloseEventType={}));let S=null;function E(){return S||(S=R.VSBuffer.alloc(0)),S}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,l){if(s===0)return E();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const T=this.a[0];return l&&(this.a.shift(),this.b-=s),T}if(this.a[0].byteLength>s){const T=this.a[0].slice(0,s);return l&&(this.a[0]=this.a[0].slice(s),this.b-=s),T}const o=R.VSBuffer.alloc(s);let y=0,C=0;for(;s>0;){const T=this.a[C];if(T.byteLength>s){const W=T.slice(0,s);o.set(W,y),y+=s,l&&(this.a[C]=T.slice(s),this.b-=s),s-=s}else o.set(T,y),y+=T.byteLength,l?(this.a.shift(),this.b-=T.byteLength):C++,s-=T.byteLength}return o}}e.ChunkStream=b;var v;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume",a[a.KeepAlive=9]="KeepAlive"})(v||(v={}));function p(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(s,l,o,y){this.type=s,this.id=l,this.ack=o,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends D.Disposable{constructor(s){super(),this.f=this.B(new i.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new b,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,y=this.g.id,C=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new g(o,y,C,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=R.VSBuffer.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:p(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(l,s.data)}g(s,l){const o=this.f===0;return this.d.push(s,l),this.f+=s.byteLength+l.byteLength,o}h(){const s=R.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,l){this.g(s,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class m extends D.Disposable{constructor(s){super(),this.f=new i.Emitter,this.onMessage=this.f.event,this.g=new i.Emitter,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new u(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new g(1,0,0,s))}}e.Protocol=m;class c extends k.IPCClient{static fromSocket(s,l){return new c(new m(s),l)}get onDidDispose(){return this.b.onDidDispose}constructor(s,l,o=null){super(s,l,o),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.Client=c;class h{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new i.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.BufferedEmitter=h;class f{constructor(s){this.data=s,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let s=0,l=this.a;for(;l;)l=l.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let l=0,o=this.a;for(;o;)s[l++]=o.data,o=o.next;return s}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const l=new f(s);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const s=Date.now();for(let l=0;l<r.a;l++)this.c[l]=s-1e3*l;setInterval(()=>{for(let l=r.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),l=(1+r.a)*1e3;let o=0;for(let y=0;y<r.a;y++)s-this.c[y]<=l&&o++;return 1-o/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;class t{get unacknowledgedCount(){return this.c-this.d}constructor(s,l=null,o=r.getInstance()){this.t=new h,this.onControlMessage=this.t.event,this.u=new h,this.onMessage=this.u.event,this.v=new h,this.onDidDispose=this.v.event,this.w=new h,this.onSocketClose=this.w.event,this.x=new h,this.onSocketTimeout=this.x.event,this.s=o,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=s,this.p=new u(this.o),this.r.push(this.p),this.q=new w(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(y=>this.y(y))),this.r.push(this.o.onClose(y=>this.w.fire(y))),l&&this.q.acceptChunk(l),this.l=setInterval(()=>{this.D()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,D.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const s=new g(5,0,0,E());this.p.write(s),this.p.flush()}sendPause(){const s=new g(7,0,0,E());this.p.write(s)}sendResume(){const s=new g(8,0,0,E());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,l){this.a=!0,this.r=(0,D.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=new u(this.o),this.r.push(this.p),this.q=new w(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(o=>this.y(o))),this.r.push(this.o.onClose(o=>this.w.fire(o))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new g(3,0,this.h,E());this.p.write(s);const l=this.b.toArray();for(let o=0,y=l.length;o<y;o++)this.p.write(l[o]);this.B()}acceptDisconnect(){this.v.fire()}y(s){if(s.ack>this.d){this.d=s.ack;do{const l=this.b.peek();if(l&&l.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new g(6,0,0,E())))}else this.g=s.id,this.j=Date.now(),this.A(),this.u.fire(s.data);break}case 2:{this.t.fire(s.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const l=this.b.toArray();for(let o=0,y=l.length;o<y;o++)this.p.write(l[o]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const l=++this.c;this.h=this.g;const o=new g(1,l,this.h,s);this.b.push(o),this.a||(this.p.write(o),this.B())}sendControl(s){const l=new g(2,0,0,s);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),l=Date.now()-s.writtenTime,o=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(l>=2e4&&o>=2e4&&y>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:o});return}const C=Math.max(2e4-l,2e4-o,2e4-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},C)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new g(3,0,this.h,E());this.p.write(s)}D(){const s=new g(9,0,0,E());this.p.write(s)}}e.PersistentProtocol=t}),define(re[149],ae([0,1,93,3,39,148]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class L extends D.IPCServer{static b(){const I=i.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(S,E)=>E);return i.Event.map(I,S=>{const{port1:E,port2:b}=new MessageChannel,p={protocol:new k.Protocol(E),onDidClientDisconnect:i.Event.fromDOMEventEmitter(E,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",S,[b]),p})}constructor(){super(L.b())}}e.Server=L}),define(re[68],ae([0,1,50,6,17,22,142,9,3,2,32,91,86,39]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends p.ChannelServer{constructor(u){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",m=>D.VSBuffer.wrap(Buffer.from(m,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=d;class g{constructor(u,m){this.i=u,this.j=m,this.c=new Set,this.g=new Map,this.h=new I.Emitter,this.onDidProcessExit=this.h.event;const c=m&&m.timeout?m.timeout:6e4;this.b=new i.Delayer(c),this.d=null,this.f=null}getChannel(u){const m=this;return{call(c,h,f){return m.k(u,c,h,f)},listen(c,h){return m.l(u,c,h)}}}k(u,m,c,h=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const f=this.n(u),n=(0,i.createCancelablePromise)(a=>f.call(m,c,a)),r=h.onCancellationRequested(()=>n.cancel()),t=(0,S.toDisposable)(()=>n.cancel());return this.c.add(t),n.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(u,m,c){if(!this.b)return I.Event.None;this.b.cancel();let h;const f=new I.Emitter({onWillAddFirstListener:()=>{h=this.n(u).listen(m,c)(f.fire,f),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return f.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,v.removeDangerousEnvVariables)(m.env),this.d=(0,R.fork)(this.i,u,m);const c=new I.Emitter;I.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,L.isRemoteConsoleLog)(s)){(0,L.log)(s,`IPC Library: ${this.j.serverName}`);return}c.fire(D.VSBuffer.wrap(Buffer.from(s,"base64")))});const f=this.j.useQueue?(0,b.createQueuedSender)(this.d):this.d,n=s=>this.d&&this.d.connected&&f.send(s.buffer.toString("base64")),r=c.event,t={send:n,onMessage:r};this.f=new p.ChannelClient(t);const a=()=>this.o();process.once("exit",a),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,l)=>{process.removeListener("exit",a),this.c.forEach(o=>(0,S.dispose)(o)),this.c.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:l})})}return this.f}n(u){let m=this.g.get(u);return m||(m=this.m.getChannel(u),this.g.set(u,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=g}),define(re[150],ae([0,1,17,9,3,2,12,5,30,39,92]),function(_,e,R,i,D,k,L,P,I,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function b(){return{crypto:_.__$__nodeRequire("crypto"),zlib:_.__$__nodeRequire("zlib"),net:_.__$__nodeRequire("net"),os:_.__$__nodeRequire("os")}}class v{traceSocketEvent(o,y){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,y)}constructor(o,y=""){this.f=!0,this.debugLabel=y,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,i.onUnexpectedError)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(o){const y=C=>{this.traceSocketEvent("read",C),o(R.VSBuffer.wrap(C))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(o){const y=C=>{o({type:0,hadError:C,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(o){const y=()=>{o()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(o){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,i.onUnexpectedError)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,i.onUnexpectedError)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.NodeSocket=v;var p;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var d;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(d||(d={}));class g extends k.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(o,y){this.socket.traceSocketEvent(o,y)}constructor(o,y,C,T){super(),this.f=this.B(new D.Emitter),this.g=this.B(new D.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:C?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new w(this,y,C,T,this.f,(W,O)=>this.k(W,O))),this.B(this.a.onError(W=>{console.error(W),(0,i.onUnexpectedError)(W),this.g.fire({type:0,hadError:!0,error:W})})),this.b=new E.ChunkStream,this.B(this.socket.onData(W=>this.l(W))),this.B(this.socket.onClose(W=>this.g.fire(W)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this.f.event(o)}onClose(o){return this.g.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this.a.writeMessage(o)}k(o,y){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let C=2;o.byteLength<126?C+=0:o.byteLength<2**16?C+=2:C+=8;const T=R.VSBuffer.alloc(C);if(y?T.writeUInt8(194,0):T.writeUInt8(130,0),o.byteLength<126)T.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){T.writeUInt8(126,1);let W=1;T.writeUInt8(o.byteLength>>>8&255,++W),T.writeUInt8(o.byteLength>>>0&255,++W)}else{T.writeUInt8(127,1);let W=1;T.writeUInt8(0,++W),T.writeUInt8(0,++W),T.writeUInt8(0,++W),T.writeUInt8(0,++W),T.writeUInt8(o.byteLength>>>24&255,++W),T.writeUInt8(o.byteLength>>>16&255,++W),T.writeUInt8(o.byteLength>>>8&255,++W),T.writeUInt8(o.byteLength>>>0&255,++W)}this.socket.write(R.VSBuffer.concat([T,o]))}end(){this.h=!0,this.socket.end()}l(o){if(o.byteLength!==0){for(this.b.acceptChunk(o);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),C=y.readUInt8(0),T=(C&128)>>>7,W=(C&64)>>>6,O=y.readUInt8(1),j=(O&128)>>>7,F=O&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(W)),this.j.firstFrameOfMessage=Boolean(T),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),C=y.readUInt8(1),T=(C&128)>>>7;let W=C&127,O=1;W===126?W=y.readUInt8(++O)*2**8+y.readUInt8(++O):W===127&&(W=y.readUInt8(++O)*0+y.readUInt8(++O)*0+y.readUInt8(++O)*0+y.readUInt8(++O)*0+y.readUInt8(++O)*2**24+y.readUInt8(++O)*2**16+y.readUInt8(++O)*2**8+y.readUInt8(++O));let j=0;T&&(j=y.readUInt8(++O)*2**24+y.readUInt8(++O)*2**16+y.readUInt8(++O)*2**8+y.readUInt8(++O)),this.j.state=3,this.j.readLen=W,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),c(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(y,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await D.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class w extends k.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.VSBuffer.alloc(0)}constructor(o,y,C,T,W,O){super(),this.k=o,this.l=W,this.m=O,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new D.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,y?(this.b=this.B(new u(this.k,T,C,{windowBits:15})),this.f=this.B(new m(this.k,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(o){this.g.push(o),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const o=this.g.shift();if(this.f){const y=await this.r(this.f,o);this.m(y,!0)}else this.m(o,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(o,y){return new Promise((C,T)=>{o.write(y),o.flush(W=>C(W))})}acceptFrame(o,y,C){this.h.push({data:o,isCompressed:y,isLastFrameOfMessage:C}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const o=this.h.shift();if(this.b&&o.isCompressed){const y=await this.u(this.b,o.data,o.isLastFrameOfMessage);this.l.fire(y)}else this.l.fire(o.data)}this.s=!1}}u(o,y,C){return new Promise((T,W)=>{o.write(y),C&&o.write(R.VSBuffer.fromByteArray([0,0,255,255])),o.flush(O=>T(O))})}}class u extends k.Disposable{get recordedInflateBytes(){return this.j?R.VSBuffer.concat(this.f):R.VSBuffer.alloc(0)}constructor(o,y,C,T){super(),this.h=o,this.j=y,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=b().zlib.createInflateRaw(T),this.b.on("error",W=>{this.h.traceSocketEvent("zlibInflateError",{message:W?.message,code:W?.code}),this.a.fire(W)}),this.b.on("data",W=>{this.h.traceSocketEvent("zlibInflateData",W),this.g.push(R.VSBuffer.wrap(W))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(o){this.j&&this.f.push(o.clone()),this.h.traceSocketEvent("zlibInflateWrite",o),this.b.write(o.buffer)}flush(o){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=R.VSBuffer.concat(this.g);this.g.length=0,o(y)})}}class m extends k.Disposable{constructor(o,y){super(),this.g=o,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.b=b().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(R.VSBuffer.wrap(C))})}write(o){this.g.traceSocketEvent("zlibDeflateWrite",o.buffer),this.b.write(o.buffer)}flush(o){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=R.VSBuffer.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),o(y)})}}function c(l,o){if(o===0)return;const y=l.byteLength>>>2;for(let F=0;F<y;F++){const A=l.readUInt32BE(F*4);l.writeUInt32BE(A^o,F*4)}const C=y*4,T=l.byteLength-C,W=o>>>24&255,O=o>>>16&255,j=o>>>8&255;T>=1&&l.writeUInt8(l.readUInt8(C)^W,C),T>=2&&l.writeUInt8(l.readUInt8(C+1)^O,C+1),T>=3&&l.writeUInt8(l.readUInt8(C+2)^j,C+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function f(){const l=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):o=(0,L.join)(b().os.tmpdir(),`vscode-ipc-${l}.sock`),r(o),o}e.createRandomIPCHandle=f;function n(l,o,y){const C=b().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${C}-${y}-${o}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-${C.substr(0,8)}-${y}-${o}.sock`):T=(0,L.join)(l,`${y}-${o}.sock`),r(T),T}e.createStaticIPCHandle=n;function r(l){const o=h[P.platform];typeof o=="number"&&l.length>=o&&console.warn(`WARNING: IPC handle "${l}" is longer than ${o} chars, try a shorter --user-data-dir`)}class t extends S.IPCServer{static b(o){const y=D.Event.fromNodeEventEmitter(o,"connection");return D.Event.map(y,C=>({protocol:new E.Protocol(new v(C,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(C,"close"))}))}constructor(o){super(t.b(o)),this.d=o}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=t;function a(l){return new Promise((o,y)=>{const C=b().net.createServer();C.on("error",y),C.listen(l,()=>{C.removeListener("error",y),o(new t(C))})})}e.serve=a;function s(l,o){return new Promise((y,C)=>{const T=b().net.createConnection(l,()=>{T.removeListener("error",C),y(E.Client.fromSocket(new v(T,`ipc-client${o}`),o))});T.once("error",C)})}e.connect=s}),define(re[69],ae([0,1,6,3,2,15]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var L;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=e.StorageHint||(e.StorageHint={}));function P(b){const v=b;return v?.changed instanceof Map||v?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var I;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class S extends D.Disposable{constructor(v,p=Object.create(null)){super(),this.m=v,this.n=p,this.b=this.B(new i.Emitter),this.onDidChangeStorage=this.b.event,this.c=I.None,this.f=new Map,this.g=new R.ThrottledDelayer(S.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(v=>this.r(v)))}r(v){v.changed?.forEach((p,d)=>this.s(d,p)),v.deleted?.forEach(p=>this.s(p,void 0))}s(v,p){if(this.c===I.Closed)return;let d=!1;(0,k.isUndefinedOrNull)(p)?d=this.f.delete(v):this.f.get(v)!==p&&(this.f.set(v,p),d=!0),d&&this.b.fire(v)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===I.None&&(this.c=I.Initialized,this.n.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(v,p){const d=this.f.get(v);return(0,k.isUndefinedOrNull)(d)?p:d}getBoolean(v,p){const d=this.get(v);return(0,k.isUndefinedOrNull)(d)?p:d==="true"}getNumber(v,p){const d=this.get(v);return(0,k.isUndefinedOrNull)(d)?p:parseInt(d,10)}async set(v,p){if(this.c===I.Closed)return;if((0,k.isUndefinedOrNull)(p))return this.delete(v);const d=String(p);if(this.f.get(v)!==d)return this.f.set(v,d),this.j.set(v,d),this.h.delete(v),this.b.fire(v),this.w()}async delete(v){if(!(this.c===I.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire(v),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=I.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(v).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(v){if(!!this.u)return this.w(v)}async w(v){return this.g.trigger(()=>this.v(),v)}async whenFlushed(){if(!!this.u)return new Promise(v=>this.l.push(v))}dispose(){this.g.dispose(),super.dispose()}}e.Storage=S,S.a=100;class E{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((p,d)=>this.a.set(d,p)),v.delete?.forEach(p=>this.a.delete(p))}async close(){}}e.InMemoryStorageDatabase=E}),define(re[151],ae([10,11]),function(_,e){return _.create("vs/base/node/zip",e)}),define(re[152],ae([10,11]),function(_,e){return _.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[153],ae([10,11]),function(_,e){return _.create("vs/platform/environment/node/argv",e)}),define(re[154],ae([10,11]),function(_,e){return _.create("vs/platform/environment/node/argvHelper",e)}),define(re[155],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[156],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[157],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[158],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[159],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(re[160],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[161],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[162],ae([10,11]),function(_,e){return _.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[163],ae([10,11]),function(_,e){return _.create("vs/platform/files/common/fileService",e)}),define(re[164],ae([10,11]),function(_,e){return _.create("vs/platform/files/common/files",e)}),define(re[165],ae([10,11]),function(_,e){return _.create("vs/platform/files/common/io",e)}),define(re[166],ae([10,11]),function(_,e){return _.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[167],ae([10,11]),function(_,e){return _.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[168],ae([10,11]),function(_,e){return _.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(re[169],ae([10,11]),function(_,e){return _.create("vs/platform/request/common/request",e)}),define(re[170],ae([10,11]),function(_,e){return _.create("vs/platform/shell/node/shellEnv",e)}),define(re[171],ae([10,11]),function(_,e){return _.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[172],ae([10,11]),function(_,e){return _.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[173],ae([10,11]),function(_,e){return _.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[174],ae([10,11]),function(_,e){return _.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[175],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[176],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[177],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[178],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[179],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[180],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[181],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(re[182],ae([10,11]),function(_,e){return _.create("vs/platform/workspace/common/workspace",e)}),define(re[94],ae([0,1,65,63,23,12,36,20,8]),function(_,e,R,i,D,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,k.dirname)(D.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return I.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.b.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return I.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return I.URI.file((0,k.join)(this.logsPath,"editSessions.log"))}get remoteTunnelLogResource(){return I.URI.file((0,k.join)(this.logsPath,"remoteTunnel.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(I.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=L.env.VSCODE_PORTABLE;return g?I.URI.file((0,k.join)(g,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,k.resolve)(g):(0,k.normalize)((0,k.join)(D.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?I.URI.file((0,k.resolve)(g)):I.URI.file((0,k.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,k.resolve)(g);const w=L.env.VSCODE_EXTENSIONS;if(w)return w;const u=L.env.VSCODE_PORTABLE;return u?(0,k.join)(u,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(w=>/^[^:/?#]+?:\/\//.test(w)?I.URI.parse(w):I.URI.file((0,k.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?I.URI.parse(g):I.URI.file((0,k.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(g))}get extensionLogLevel(){const g=[];for(const w of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(w);u&&u[1]&&u[2]&&g.push([u[1],u[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return I.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=L.env.VSCODE_PORTABLE;return g?I.URI.file((0,k.join)(g,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,w,u){this.a=g,this.b=w,this.c=u,this.editSessionId=this.args.editSessionId}}pe([i.memoize],S.prototype,"appRoot",null),pe([i.memoize],S.prototype,"userHome",null),pe([i.memoize],S.prototype,"userDataPath",null),pe([i.memoize],S.prototype,"appSettingsHome",null),pe([i.memoize],S.prototype,"tmpDir",null),pe([i.memoize],S.prototype,"cacheHome",null),pe([i.memoize],S.prototype,"stateResource",null),pe([i.memoize],S.prototype,"userRoamingDataHome",null),pe([i.memoize],S.prototype,"userDataSyncHome",null),pe([i.memoize],S.prototype,"userDataSyncLogResource",null),pe([i.memoize],S.prototype,"editSessionsLogResource",null),pe([i.memoize],S.prototype,"remoteTunnelLogResource",null),pe([i.memoize],S.prototype,"sync",null),pe([i.memoize],S.prototype,"machineSettingsResource",null),pe([i.memoize],S.prototype,"workspaceStorageHome",null),pe([i.memoize],S.prototype,"localHistoryHome",null),pe([i.memoize],S.prototype,"keyboardLayoutResource",null),pe([i.memoize],S.prototype,"argvResource",null),pe([i.memoize],S.prototype,"isExtensionDevelopment",null),pe([i.memoize],S.prototype,"untitledWorkspacesHome",null),pe([i.memoize],S.prototype,"installSourcePath",null),pe([i.memoize],S.prototype,"builtinExtensionsPath",null),pe([i.memoize],S.prototype,"extensionsPath",null),pe([i.memoize],S.prototype,"extensionDevelopmentLocationURI",null),pe([i.memoize],S.prototype,"extensionDevelopmentKind",null),pe([i.memoize],S.prototype,"extensionTestsLocationURI",null),pe([i.memoize],S.prototype,"debugExtensionHost",null),pe([i.memoize],S.prototype,"logLevel",null),pe([i.memoize],S.prototype,"extensionLogLevel",null),pe([i.memoize],S.prototype,"serviceMachineIdResource",null),pe([i.memoize],S.prototype,"telemetryLogResource",null),pe([i.memoize],S.prototype,"disableWorkspaceTrust",null),pe([i.memoize],S.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=S;function E(d,g){return p(d["inspect-extensions"],d["inspect-brk-extensions"],5870,g,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=E;function b(d,g){return p(d["inspect-search"],d["inspect-brk-search"],5876,g,d.extensionEnvironment)}e.parseSearchPort=b;function v(d,g){return p(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,g,d.extensionEnvironment)}e.parsePtyHostPort=v;function p(d,g,w,u,m,c){const f=Number(g||d)||(u?null:w),n=f?Boolean(!!g):!1;let r;if(c)try{r=JSON.parse(c)}catch{}return{port:f,break:n,debugId:m,env:r}}}),define(re[183],ae([0,1,284,5,153]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,D.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,D.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},category:{type:"string",cat:"e",description:(0,D.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,D.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,D.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const L={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(g,w,u=L){const m=g.find(l=>l.length>0&&l[0]!=="-"),c={},h=["_"],f=[],n={};let r;for(const l in w){const o=w[l];o.type==="subcommand"?l===m&&(r=o):(o.alias&&(c[l]=o.alias),o.type==="string"||o.type==="string[]"?(h.push(l),o.deprecates&&h.push(...o.deprecates)):o.type==="boolean"&&(f.push(l),o.deprecates&&f.push(...o.deprecates)),o.global&&(n[l]=o))}if(r&&m){const l=n;for(const T in r.options)l[T]=r.options[T];const o=g.filter(T=>T!==m),y=u.getSubcommandReporter?u.getSubcommandReporter(m):void 0,C=P(o,l,y);return{[m]:C,_:[]}}const t=R(g,{string:h,boolean:f,alias:c}),a={},s=t;a._=t._.map(l=>String(l)).filter(l=>l.length>0),delete s._;for(const l in w){const o=w[l];if(o.type==="subcommand")continue;o.alias&&delete s[o.alias];let y=s[l];if(o.deprecates)for(const C of o.deprecates)s.hasOwnProperty(C)&&(y||(y=s[C],y&&u.onDeprecatedOption(C,o.deprecationMessage||(0,D.localize)(36,null,l))),delete s[C]);if(typeof y<"u"){if(o.type==="string[]"){if(Array.isArray(y)||(y=[y]),!o.allowEmptyValue){const C=y.filter(T=>T.length>0);C.length!==y.length&&(u.onEmptyValue(l),y=C.length>0?C:void 0)}}else o.type==="string"&&(Array.isArray(y)?(y=y.pop(),u.onMultipleValues(l,y)):!y&&!o.allowEmptyValue&&(u.onEmptyValue(l),y=void 0));a[l]=y,o.deprecationMessage&&u.onDeprecatedOption(l,o.deprecationMessage)}delete s[l]}for(const l in s)u.onUnknownOption(l);return a}e.parseArgs=P;function I(g,w){let u="";return w.args&&(Array.isArray(w.args)?u=` <${w.args.join("> <")}>`:u=` <${w.args}>`),w.alias?`-${w.alias} --${g}${u}`:`--${g}${u}`}function S(g,w){const u=[];for(const m in g){const c=g[m],h=I(m,c);u.push([h,c.description])}return E(u,w)}e.formatOptions=S;function E(g,w){const m=g.reduce((f,n)=>Math.max(f,n[0].length),12)+2+1;if(w-m<25)return g.reduce((f,n)=>f.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const c=w-m-1,h=[];for(const f of g){const n=f[0],r=v(f[1],c),t=b(m-n.length-2);h.push("  "+n+t+r[0]);for(let a=1;a<r.length;a++)h.push(b(m)+r[a])}return h}function b(g){return" ".repeat(g)}function v(g,w){const u=[];for(;g.length;){const m=g.length<w?g.length:g.lastIndexOf(" ",w),c=g.slice(0,m).trim();g=g.slice(m),u.push(c)}return u}function p(g,w,u,m,c){const h=process.stdout.isTTY&&process.stdout.columns||80,f=c?.noInputFiles!==!0?`[${(0,D.localize)(37,null)}...]`:"",n=[`${g} ${u}`];n.push(""),n.push(`${(0,D.localize)(38,null)}: ${w} [${(0,D.localize)(39,null)}]${f}`),n.push(""),c?.noPipe!==!0&&(i.isWindows?n.push((0,D.localize)(40,null,w)):n.push((0,D.localize)(41,null,w)),n.push(""));const r={},t=[];for(const a in m){const s=m[a];if(s.type==="subcommand")s.description&&t.push({command:a,description:s.description});else if(s.description&&s.cat){let l=r[s.cat];l||(r[s.cat]=l={}),l[a]=s}}for(const a in r){const s=a,l=r[s];l&&(n.push(k[s]),n.push(...S(l,h)),n.push(""))}return t.length&&(n.push((0,D.localize)(42,null)),n.push(...E(t.map(a=>[a.command,a.description]),h)),n.push("")),n.join(`
`)}e.buildHelpMessage=p;function d(g,w){return`${g||(0,D.localize)(43,null)}
${w||(0,D.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=d}),define(re[184],ae([0,1,285,154,183]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const k=2048;function L(v,p){const d=(h,f)=>{console.warn((0,i.localize)(0,null,h,f))},g=h=>{console.warn((0,i.localize)(1,null,h))},w=(h,f)=>{console.warn((0,i.localize)(2,null,h,f))},u=h=>({onUnknownOption:f=>{h!=="tunnel"&&console.warn((0,i.localize)(3,null,f,h))},onMultipleValues:d,onEmptyValue:g,onDeprecatedOption:w,getSubcommandReporter:h!=="tunnel"?u:void 0}),m={onUnknownOption:h=>{console.warn((0,i.localize)(4,null,h))},onMultipleValues:d,onEmptyValue:g,onDeprecatedOption:w,getSubcommandReporter:u},c=(0,D.parseArgs)(v,D.OPTIONS,p?m:void 0);return c.goto&&c._.forEach(h=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(h),(0,i.localize)(5,null))),c["max-memory"]&&R(parseInt(c["max-memory"])>=k,`The max-memory argument cannot be specified lower than ${k} MB.`),c}function P(v){const p=v.findIndex(d=>!/^-/.test(d));if(p>-1)return[...v.slice(0,p),...v.slice(p+1)]}function I(v){let[,...p]=v;process.env.VSCODE_DEV&&(p=P(p)||[]);const d=!b(process.env);return L(p,d)}e.parseMainProcessArgv=I;function S(v){let[,,...p]=v;return process.env.VSCODE_DEV&&(p=P(p)||[]),L(p,!0)}e.parseCLIProcessArgv=S;function E(v,...p){const d=v.indexOf("--");return d===-1?v.push(...p):v.splice(d,0,...p),v}e.addArg=E;function b(v){return v.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),function(){"use strict";function _(e,R,i){function D(L,P){const I=k(L,P),S=[I];return e.isAbsolute(I)||S.unshift(i),e.resolve(...S)}function k(L,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,P);const E=L["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(b,"AppData","Roaming")}break;case"darwin":S=e.join(R.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,P)}return{getUserDataPath:D}}if(typeof define=="function")define(re[185],ae([286,34,36]),function(e,R,i){return _(e,R,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),R=require("os");module.exports=_(e,R,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[186],ae([0,1,34,94,185]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends i.AbstractNativeEnvironmentService{constructor(P,I){super(P,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,D.getUserDataPath)(P,I.nameShort)},I)}}e.NativeEnvironmentService=k}),define(re[187],ae([0,1,8]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const i=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,L=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function S(w){const u=w.match(L);return u?u[1]:null}function E(w){if(w.indexOf("://")===-1){const u=w.match(i);return u?S(u[2]):null}try{const u=R.URI.parse(w);if(u.authority)return S(u.authority)}catch{}return null}function b(w,u){const m=new Set;let c;for(;c=P.exec(w);){const f=E(c[1]);f&&m.add(f)}const h=new Set(u);return Array.from(m).map(f=>h.has(f)?f:f.replace(I,"a"))}e.getDomainsOfRemotes=b;function v(w){const u=w.match(k);return u?u[2]:null}function p(w,u,m){return w&&u?(m&&u.endsWith(".git")&&(u=u.substr(0,u.length-4)),u.indexOf("/")===0?`${w}${u}`:`${w}/${u}`):null}function d(w,u){if(w.indexOf("://")===-1){const m=w.match(D);if(m)return p(m[2],m[3],u)}try{const m=R.URI.parse(w);if(m.authority)return p(v(m.authority),m.path,u)}catch{}return null}function g(w,u=!1){const m=[];let c;for(;c=P.exec(w);){const h=d(c[1],u);h&&m.push(h)}return m}e.getRemotes=g}),define(re[188],ae([0,1,15,157]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(L,P,I){try{k(L,P,I)}catch(S){console.error(S?.message??S)}return L}e.localizeManifest=D;function k(L,P,I){const S=(E,b,v)=>{const p=E[b];if((0,R.isString)(p)){const d=p,g=d.length;if(g>1&&d[0]==="%"&&d[g-1]==="%"){const w=d.substr(1,g-2);let u=P[w];u===void 0&&I&&(u=I[w]);const m=typeof u=="string"?u:u?.message,c=I?.[w],h=typeof c=="string"?c:c?.message;if(!m){h||console.warn(`[${L.name}]: ${(0,i.localize)(0,null,w)}`);return}if(v&&(b==="title"||b==="category")&&h&&h!==m){const f={value:m,original:h};E[b]=f}else E[b]=m}}else if((0,R.isObject)(p))for(const d in p)p.hasOwnProperty(d)&&(d==="commands"?S(p,d,!0):S(p,d,v));else if(Array.isArray(p))for(let d=0;d<p.length;d++)S(p,d,v)};for(const E in L)L.hasOwnProperty(E)&&S(L,E)}}),define(re[189],ae([0,1,9]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class i{constructor(){this.a=new Map}register(k,L){this.a.set(k,L)}updateManifest(k){if(!(!Array.isArray(k.activationEvents)||!k.contributes)&&!(typeof k.main>"u"&&typeof k.browser>"u"))for(const L in k.contributes){const P=this.a.get(L);if(!P)continue;const I=k.contributes[L],S=Array.isArray(I)?I:[I];try{P(S,k.activationEvents)}catch(E){(0,R.onUnexpectedError)(E)}}}}e.ImplicitActivationEventsImpl=i,e.ImplicitActivationEvents=new i}),define(re[190],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(k){this.a=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,L,P,I){return this.a.call("promptImportantExtensionsInstallNotification",[k,L,P,I])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class i{constructor(k){this.a=k}listen(k,L){throw new Error(`Event not found: ${L}`)}call(k,L,P){switch(L){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${L}`)}}e.ExtensionRecommendationNotificationServiceChannel=i}),define(re[70],ae([0,1,20,88,162,54]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function I(u){return u=u.trim(),u==="*"||L.test(u)}e.isValidVersionStr=I;function S(u){if(!I(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=u.match(L);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=S;function E(u){if(!u)return null;const m=u.majorBase,c=u.majorMustEqual,h=u.minorBase;let f=u.minorMustEqual;const n=u.patchBase;let r=u.patchMustEqual;u.hasCaret&&(m===0||(f=!1),r=!1);let t=0;if(u.preRelease){const a=P.exec(u.preRelease);if(a){const[,s,l,o]=a;t=Date.UTC(Number(s),Number(l)-1,Number(o))}}return{majorBase:m,majorMustEqual:c,minorBase:h,minorMustEqual:f,patchBase:n,patchMustEqual:r,isMinimum:u.hasGreaterEquals,notBefore:t}}e.normalizeVersion=E;function b(u,m,c){let h;typeof u=="string"?h=E(S(u)):h=u;let f;m instanceof Date?f=m.getTime():typeof m=="string"&&(f=new Date(m).getTime());let n;if(typeof c=="string"?n=E(S(c)):n=c,!h||!n)return!1;const r=h.majorBase,t=h.minorBase,a=h.patchBase;let s=n.majorBase,l=n.minorBase,o=n.patchBase;const y=n.notBefore;let C=n.majorMustEqual,T=n.minorMustEqual,W=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:t>l?!0:t<l||f&&f<y?!1:a>=o:(r===1&&s===0&&(!C||!T||!W)&&(s=1,l=0,o=0,C=!0,T=!1,W=!1),r<s?!1:r>s?!C:t<l?!1:t>l?!T:a<o?!1:a>o?!W:!(f&&f<y))}e.isValidVersion=b;function v(u,m,c,h,f){const n=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return n.push([i.default.Error,D.localize(0,null)]),n;if(typeof h.name!="string")return n.push([i.default.Error,D.localize(1,null,"name")]),n;if(typeof h.version!="string")return n.push([i.default.Error,D.localize(2,null,"version")]),n;if(!h.engines)return n.push([i.default.Error,D.localize(3,null,"engines")]),n;if(typeof h.engines.vscode!="string")return n.push([i.default.Error,D.localize(4,null,"engines.vscode")]),n;if(typeof h.extensionDependencies<"u"&&!w(h.extensionDependencies))return n.push([i.default.Error,D.localize(5,null,"extensionDependencies")]),n;if(typeof h.activationEvents<"u"){if(!w(h.activationEvents))return n.push([i.default.Error,D.localize(6,null,"activationEvents")]),n;if(typeof h.main>"u"&&typeof h.browser>"u")return n.push([i.default.Error,D.localize(7,null,"activationEvents","main")]),n}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&n.push([i.default.Warning,D.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return n.push([i.default.Error,D.localize(9,null,"main")]),n;{const a=(0,R.joinPath)(c,h.main);(0,R.isEqualOrParent)(a,c)||n.push([i.default.Warning,D.localize(10,null,a.path,c.path)])}if(typeof h.activationEvents>"u")return n.push([i.default.Error,D.localize(11,null,"activationEvents","main")]),n}if(typeof h.browser<"u"){if(typeof h.browser!="string")return n.push([i.default.Error,D.localize(12,null,"browser")]),n;{const a=(0,R.joinPath)(c,h.browser);(0,R.isEqualOrParent)(a,c)||n.push([i.default.Warning,D.localize(13,null,a.path,c.path)])}if(typeof h.activationEvents>"u")return n.push([i.default.Error,D.localize(14,null,"activationEvents","browser")]),n}if(!k.valid(h.version))return n.push([i.default.Error,D.localize(15,null)]),n;const r=[];if(!p(u,m,h,f,r))for(const a of r)n.push([i.default.Error,a]);return n}e.validateExtensionManifest=v;function p(u,m,c,h,f){return h||typeof c.main>"u"&&typeof c.browser>"u"?!0:g(u,m,c.engines.vscode,f)}e.isValidExtensionVersion=p;function d(u,m,c){return u==="*"||g(m,c,u)}e.isEngineValid=d;function g(u,m,c,h=[]){const f=E(S(c));if(!f)return h.push(D.localize(16,null,c)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return h.push(D.localize(17,null,c)),!1}else if(!f.majorMustEqual)return h.push(D.localize(18,null,c)),!1;return b(u,m,f)?!0:(h.push(D.localize(19,null,u,c)),!1)}function w(u){if(!Array.isArray(u))return!1;for(let m=0,c=u.length;m<c;m++)if(typeof u[m]!="string")return!1;return!0}}),define(re[44],ae([0,1,17,30]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(k,L,P){let I=P&&P.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const E=(await L.readFile(k.serviceMachineIdResource)).value.toString();I=(0,i.isUUID)(E)?E:null}catch{I=null}if(!I){I=(0,i.generateUuid)();try{await L.writeFile(k.serviceMachineIdResource,R.VSBuffer.fromString(I))}catch{}}return P?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=D}),define(re[55],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(D,k=[],L=!1){this.ctor=D,this.staticArguments=k,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=R}),define(re[71],ae([0,1,55]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const i=[];var D;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function k(P,I,S){I instanceof R.SyncDescriptor||(I=new R.SyncDescriptor(I,[],Boolean(S))),i.push([P,I])}e.registerSingleton=k;function L(){return i}e.getSingletonServiceDescriptors=L}),define(re[191],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(k,L){this.key=k,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=R;class i{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const L of this.a.values())L.outgoing.size===0&&k.push(L);return k}insertEdge(k,L){const P=this.lookupOrInsertNode(k),I=this.lookupOrInsertNode(L);P.outgoing.set(I.key,I),I.incoming.set(P.key,P)}removeNode(k){const L=this.b(k);this.a.delete(L);for(const P of this.a.values())P.outgoing.delete(L),P.incoming.delete(L)}lookupOrInsertNode(k){const L=this.b(k);let P=this.a.get(L);return P||(P=new R(L,k),this.a.set(L,P)),P}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[L,P]of this.a)k.push(`${L}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,L]of this.a){const P=new Set([k]),I=this.c(L,P);if(I)return I}}c(k,L){for(const[P,I]of k.outgoing){if(L.has(P))return[...L,P].join(" -> ");L.add(P);const S=this.c(I,L);if(S)return S;L.delete(P)}}}e.Graph=i}),define(re[4],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function P(I){return I[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=P})(R=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function i(L,P,I){P[R.DI_TARGET]===P?P[R.DI_DEPENDENCIES].push({id:L,index:I}):(P[R.DI_DEPENDENCIES]=[{id:L,index:I}],P[R.DI_TARGET]=P)}function D(L){if(R.serviceIds.has(L))return R.serviceIds.get(L);const P=function(I,S,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(P,I,E)};return P.toString=()=>L,R.serviceIds.set(L,P),P}e.createDecorator=D;function k(L){return L}e.refineServiceDecorator=k}),define(re[192],ae([0,1,4]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(re[16],ae([0,1,15,8,4]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function k(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof i.URI)}e.isConfigurationOverrides=k;function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=L;var P;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function S(u,m){const c=Object.create(null);for(const h in u)E(c,h,u[h],m);return c}e.toValuesTree=S;function E(u,m,c,h){const f=m.split("."),n=f.pop();let r=u;for(let t=0;t<f.length;t++){const a=f[t];let s=r[a];switch(typeof s){case"undefined":s=r[a]=Object.create(null);break;case"object":break;default:h(`Ignoring ${m} as ${f.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=c}catch{h(`Ignoring ${m} as ${f.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${m} as ${f.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=E;function b(u,m){const c=m.split(".");v(u,c)}e.removeFromValueTree=b;function v(u,m){const c=m.shift();if(m.length===0){delete u[c];return}if(Object.keys(u).indexOf(c)!==-1){const h=u[c];typeof h=="object"&&!Array.isArray(h)&&(v(h,m),Object.keys(h).length===0&&delete u[c])}}function p(u,m,c){function h(r,t){let a=r;for(const s of t){if(typeof a!="object"||a===null)return;a=a[s]}return a}const f=m.split("."),n=h(u,f);return typeof n>"u"?c:n}e.getConfigurationValue=p;function d(u,m,c){Object.keys(m).forEach(h=>{h!=="__proto__"&&(h in u?R.isObject(u[h])&&R.isObject(m[h])?d(u[h],m[h],c):c&&(u[h]=m[h]):u[h]=m[h])})}e.merge=d;function g(u,m,c){const h=u.inspect(m),f=u.inspect(c);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:h.defaultValue}e.getMigratedSettingValue=g;function w(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(re[193],ae([0,1,5,27,4]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",R.isMacintosh),k.set("isLinux",R.isLinux),k.set("isWindows",R.isWindows),k.set("isWeb",R.isWeb),k.set("isMacNative",R.isMacintosh&&!R.isWeb),k.set("isEdge",R.isEdge),k.set("isFirefox",R.isFirefox),k.set("isChrome",R.isChrome),k.set("isSafari",R.isSafari);const L=Object.prototype.hasOwnProperty;var P;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return b.INSTANCE}static true(){return v.INSTANCE}static has(A){return p.create(A)}static equals(A,M){return d.create(A,M)}static notEquals(A,M){return u.create(A,M)}static regex(A,M){return t.create(A,M)}static in(A,M){return g.create(A,M)}static notIn(A,M){return w.create(A,M)}static not(A){return m.create(A)}static and(...A){return l.create(A,null,!0)}static or(...A){return o.create(A,null,!0)}static greater(A,M){return h.create(A,M)}static greaterEquals(A,M){return f.create(A,M)}static smaller(A,M){return n.create(A,M)}static smallerEquals(A,M){return r.create(A,M)}static deserialize(A,M=!1){if(!!A)return this.c(A,M)}static c(A,M){const B=A.split("||");return o.create(B.map(G=>this.d(G,M)),null,!0)}static d(A,M){const B=A.split("&&");return l.create(B.map(G=>this.f(G,M)),null,!0)}static f(A,M){if(A=A.trim(),A.indexOf("!=")>=0){const B=A.split("!=");return u.create(B[0].trim(),this.g(B[1],M))}if(A.indexOf("==")>=0){const B=A.split("==");return d.create(B[0].trim(),this.g(B[1],M))}if(A.indexOf("=~")>=0){const B=A.split("=~");return t.create(B[0].trim(),this.h(B[1],M))}if(A.indexOf(" not in ")>=0){const B=A.split(" not in ");return w.create(B[0].trim(),this.g(B[1],M))}if(A.indexOf(" in ")>=0){const B=A.split(" in ");return g.create(B[0].trim(),this.g(B[1],M))}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const B=A.split(">=");return f.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const B=A.split(">");return h.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const B=A.split("<=");return r.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const B=A.split("<");return n.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(A)?m.create(A.substr(1).trim()):p.create(A)}static g(A,M){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;const B=/^'([^']*)'$/.exec(A);return B?B[1].trim():A}static h(A,M){if((0,i.isFalsyOrWhitespace)(A)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const B=A.indexOf("/"),G=A.lastIndexOf("/");if(B===G||B<0){if(M)throw new Error(`bad regexp-value '${A}', missing /-enclosure`);return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null}const V=A.slice(B+1,G),Q=A[G+1]==="i"?"i":"";try{return new RegExp(V,Q)}catch($){if(M)throw new Error(`bad regexp-value '${A}', parse error: ${$}`);return console.warn(`bad regexp-value '${A}', parse error: ${$}`),null}}}e.ContextKeyExpr=I;function S(F,A){const M=F?F.substituteConstants():void 0,B=A?A.substituteConstants():void 0;return!M&&!B?!0:!M||!B?!1:M.equals(B)}e.expressionsAreEqualWithConstantSubstitution=S;function E(F,A){return F.cmp(A)}class b{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class v{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class p{static create(A,M=null){const B=k.get(A);return typeof B=="boolean"?B?v.INSTANCE:b.INSTANCE:new p(A,M)}constructor(A,M){this.key=A,this.c=M,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:C(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=k.get(this.key);return typeof A=="boolean"?A?v.INSTANCE:b.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=m.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=p;class d{static create(A,M,B=null){if(typeof M=="boolean")return M?p.create(A,B):m.create(A,B);const G=k.get(A);return typeof G=="boolean"?M===(G?"true":"false")?v.INSTANCE:b.INSTANCE:new d(A,M,B)}constructor(A,M,B){this.c=A,this.d=M,this.f=B,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:T(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=k.get(this.c);if(typeof A=="boolean"){const M=A?"true":"false";return this.d===M?v.INSTANCE:b.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=d;class g{static create(A,M){return new g(A,M)}constructor(A,M){this.d=A,this.f=M,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:T(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const M=A.getValue(this.f),B=A.getValue(this.d);return Array.isArray(M)?M.includes(B):typeof B=="string"&&typeof M=="object"&&M!==null?L.call(M,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=g;class w{static create(A,M){return new w(A,M)}constructor(A,M){this.d=A,this.f=M,this.type=11,this.c=g.create(A,M)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=w;class u{static create(A,M,B=null){if(typeof M=="boolean")return M?m.create(A,B):p.create(A,B);const G=k.get(A);return typeof G=="boolean"?M===(G?"true":"false")?b.INSTANCE:v.INSTANCE:new u(A,M,B)}constructor(A,M,B){this.c=A,this.d=M,this.f=B,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:T(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=k.get(this.c);if(typeof A=="boolean"){const M=A?"true":"false";return this.d===M?b.INSTANCE:v.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=u;class m{static create(A,M=null){const B=k.get(A);return typeof B=="boolean"?B?b.INSTANCE:v.INSTANCE:new m(A,M)}constructor(A,M){this.c=A,this.d=M,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:C(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=k.get(this.c);return typeof A=="boolean"?A?b.INSTANCE:v.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.ContextKeyNotExpr=m;function c(F,A){if(typeof F=="string"){const M=parseFloat(F);isNaN(M)||(F=M)}return typeof F=="string"||typeof F=="number"?A(F):b.INSTANCE}class h{static create(A,M,B=null){return c(M,G=>new h(A,G,B))}constructor(A,M,B){this.c=A,this.d=M,this.f=B,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:T(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=h;class f{static create(A,M,B=null){return c(M,G=>new f(A,G,B))}constructor(A,M,B){this.c=A,this.d=M,this.f=B,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:T(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=f;class n{static create(A,M,B=null){return c(M,G=>new n(A,G,B))}constructor(A,M,B){this.c=A,this.d=M,this.f=B,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:T(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=n;class r{static create(A,M,B=null){return c(M,G=>new r(A,G,B))}constructor(A,M,B){this.c=A,this.d=M,this.f=B,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:T(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class t{static create(A,M){return new t(A,M)}constructor(A,M){this.d=A,this.f=M,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const M=this.f?this.f.source:"",B=A.f?A.f.source:"";return M<B?-1:M>B?1:0}equals(A){if(A.type===this.type){const M=this.f?this.f.source:"",B=A.f?A.f.source:"";return this.d===A.d&&M===B}return!1}substituteConstants(){return this}evaluate(A){const M=A.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=a.create(this)),this.c}}e.ContextKeyRegexExpr=t;class a{static create(A){return new a(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(A){return new a(this.c.map(A))}negate(){return this.c}}e.ContextKeyNotRegexExpr=a;function s(F){let A=null;for(let M=0,B=F.length;M<B;M++){const G=F[M].substituteConstants();if(F[M]!==G&&A===null){A=[];for(let V=0;V<M;V++)A[V]=F[V]}A!==null&&(A[M]=G)}return A===null?F:A}class l{static create(A,M,B){return l.d(A,M,B)}constructor(A,M){this.expr=A,this.c=M,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let M=0,B=this.expr.length;M<B;M++){const G=E(this.expr[M],A.expr[M]);if(G!==0)return G}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let M=0,B=this.expr.length;M<B;M++)if(!this.expr[M].equals(A.expr[M]))return!1;return!0}return!1}substituteConstants(){const A=s(this.expr);return A===this.expr?this:l.create(A,this.c,!1)}evaluate(A){for(let M=0,B=this.expr.length;M<B;M++)if(!this.expr[M].evaluate(A))return!1;return!0}static d(A,M,B){const G=[];let V=!1;for(const Q of A)if(!!Q){if(Q.type===1){V=!0;continue}if(Q.type===0)return b.INSTANCE;if(Q.type===6){G.push(...Q.expr);continue}G.push(Q)}if(G.length===0&&V)return v.INSTANCE;if(G.length!==0){if(G.length===1)return G[0];G.sort(E);for(let Q=1;Q<G.length;Q++)G[Q-1].equals(G[Q])&&(G.splice(Q,1),Q--);if(G.length===1)return G[0];for(;G.length>1;){const Q=G[G.length-1];if(Q.type!==9)break;G.pop();const $=G.pop(),z=G.length===0,Y=o.create(Q.expr.map(ee=>l.create([ee,$],null,B)),null,z);Y&&(G.push(Y),G.sort(E))}if(G.length===1)return G[0];if(B){for(let Q=0;Q<G.length;Q++)for(let $=Q+1;$<G.length;$++)if(G[Q].negate().equals(G[$]))return b.INSTANCE;if(G.length===1)return G[0]}return new l(G,M)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const M of this.expr)A.push(...M.keys());return A}map(A){return new l(this.expr.map(M=>M.map(A)),null)}negate(){if(!this.c){const A=[];for(const M of this.expr)A.push(M.negate());this.c=o.create(A,this,!0)}return this.c}}class o{static create(A,M,B){return o.d(A,M,B)}constructor(A,M){this.expr=A,this.c=M,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let M=0,B=this.expr.length;M<B;M++){const G=E(this.expr[M],A.expr[M]);if(G!==0)return G}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let M=0,B=this.expr.length;M<B;M++)if(!this.expr[M].equals(A.expr[M]))return!1;return!0}return!1}substituteConstants(){const A=s(this.expr);return A===this.expr?this:o.create(A,this.c,!1)}evaluate(A){for(let M=0,B=this.expr.length;M<B;M++)if(this.expr[M].evaluate(A))return!0;return!1}static d(A,M,B){let G=[],V=!1;if(A){for(let Q=0,$=A.length;Q<$;Q++){const z=A[Q];if(!!z){if(z.type===0){V=!0;continue}if(z.type===1)return v.INSTANCE;if(z.type===9){G=G.concat(z.expr);continue}G.push(z)}}if(G.length===0&&V)return b.INSTANCE;G.sort(E)}if(G.length!==0){if(G.length===1)return G[0];for(let Q=1;Q<G.length;Q++)G[Q-1].equals(G[Q])&&(G.splice(Q,1),Q--);if(G.length===1)return G[0];if(B){for(let Q=0;Q<G.length;Q++)for(let $=Q+1;$<G.length;$++)if(G[Q].negate().equals(G[$]))return v.INSTANCE;if(G.length===1)return G[0]}return new o(G,M)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const M of this.expr)A.push(...M.keys());return A}map(A){return new o(this.expr.map(M=>M.map(A)),null)}negate(){if(!this.c){const A=[];for(const M of this.expr)A.push(M.negate());for(;A.length>1;){const M=A.shift(),B=A.shift(),G=[];for(const V of j(M))for(const Q of j(B))G.push(l.create([V,Q],null,!1));A.unshift(o.create(G,null,!1))}this.c=o.create(A,this,!0)}return this.c}}class y extends p{static all(){return y.d.values()}constructor(A,M,B){super(A,null),this.f=M,typeof B=="object"?y.d.push({...B,key:A}):B!==!0&&y.d.push({key:A,description:B,type:M!=null?typeof M:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return d.create(this.key,A)}notEqualsTo(A){return u.create(this.key,A)}}e.RawContextKey=y,y.d=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function C(F,A){return F<A?-1:F>A?1:0}function T(F,A,M,B){return F<M?-1:F>M?1:A<B?-1:A>B?1:0}function W(F,A){if(F.type===0||A.type===1)return!0;if(F.type===9)return A.type===9?O(F.expr,A.expr):!1;if(A.type===9){for(const M of A.expr)if(W(F,M))return!0;return!1}if(F.type===6){if(A.type===6)return O(A.expr,F.expr);for(const M of F.expr)if(W(M,A))return!0;return!1}return F.equals(A)}e.implies=W;function O(F,A){let M=0,B=0;for(;M<F.length&&B<A.length;){const G=F[M].cmp(A[B]);if(G<0)return!1;G===0&&M++,B++}return M===F.length}function j(F){return F.type===9?F.expr:[F]}}),define(re[95],ae([0,1,4]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function i(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=i;class D{async getPerformanceInfo(L,P){return{}}async getSystemInfo(L,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(L,P){return""}async getWorkspaceFileExtensions(L){return{extensions:[]}}async reportWorkspaceStats(L){}}e.NullDiagnosticsService=D}),define(re[96],ae([0,1,4]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(re[13],ae([0,1,4]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(re[29],ae([0,1,156,4]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY="DEFAULT_PROFILE_EXTENSIONS_MIGRATION";function D(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function k(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function L(u,m){switch(u){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=L;function P(u,m){return m==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function I(u,m,c){return P(m,c)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===c?!0:S(c).includes(u)}e.isTargetPlatformCompatible=I;function S(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function E(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=E;var b;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var v;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var p;(function(u){u.Install="install",u.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var d;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var g;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(m,c){super(m),this.code=c,this.name=c}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,R.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(re[194],ae([0,1,3,2,67,32,8,143,29]),function(_,e,R,i,D,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(w,u){return L.URI.revive(u?u.transformIncoming(w):w)}function E(w,u){return u?u.transformOutgoingURI(w):w}function b(w,u){u=u||P.DefaultURITransformer;const m=w.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...w,manifest:void 0},u),manifest:m}}function v(w,u){return u?(0,k.cloneAndChange)(w,m=>m instanceof L.URI?u.transformOutgoingURI(m):void 0):w}class p{constructor(u,m){this.a=u,this.b=m,this.onInstallExtension=R.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(u.onDidUninstallExtension,!0)}listen(u,m){const c=this.b(u);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,h=>h.map(f=>({...f,local:f.local?v(f.local,c):f.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(u,m,c){const h=this.b(u);switch(m){case"zip":return this.a.zip(b(c[0],h)).then(f=>E(f,h));case"unzip":return this.a.unzip(S(c[0],h));case"install":return this.a.install(S(c[0],h),(0,D.revive)(c[1]));case"getManifest":return this.a.getManifest(S(c[0],h));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(c[0]);case"installFromGallery":return this.a.installFromGallery(c[0],(0,D.revive)(c[1]));case"uninstall":return this.a.uninstall(b(c[0],h),(0,D.revive)(c[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(b(c[0],h));case"getInstalled":return this.a.getInstalled(c[0],L.URI.revive(c[1])).then(f=>f.map(n=>v(n,h)));case"getMetadata":return this.a.getMetadata(b(c[0],h));case"updateMetadata":return this.a.updateMetadata(b(c[0],h),c[1]).then(f=>v(f,h));case"updateExtensionScope":return this.a.updateExtensionScope(b(c[0],h),c[1]).then(f=>v(f,h));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(c[0],c[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=p;class d extends i.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}constructor(u){super(),this.j=u,this.c=this.B(new R.Emitter),this.f=this.B(new R.Emitter),this.g=this.B(new R.Emitter),this.h=this.B(new R.Emitter),this.B(this.j.listen("onInstallExtension")(m=>this.c.fire({identifier:m.identifier,source:this.k(m.source)?L.URI.revive(m.source):m.source,profileLocation:L.URI.revive(m.profileLocation)}))),this.B(this.j.listen("onDidInstallExtensions")(m=>this.f.fire(m.map(c=>({...c,local:c.local?b(c.local,null):c.local,source:this.k(c.source)?L.URI.revive(c.source):c.source,profileLocation:L.URI.revive(c.profileLocation)}))))),this.B(this.j.listen("onUninstallExtension")(m=>this.g.fire({identifier:m.identifier,profileLocation:L.URI.revive(m.profileLocation)}))),this.B(this.j.listen("onDidUninstallExtension")(m=>this.h.fire({...m,profileLocation:L.URI.revive(m.profileLocation)})))}k(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.l||(this.l=this.j.call("getTargetPlatform")),this.l}async canInstall(u){const m=await this.getTargetPlatform();return u.allTargetPlatforms.some(c=>(0,I.isTargetPlatformCompatible)(c,u.allTargetPlatforms,m))}zip(u){return Promise.resolve(this.j.call("zip",[u]).then(m=>L.URI.revive(m)))}unzip(u){return Promise.resolve(this.j.call("unzip",[u]))}install(u,m){return Promise.resolve(this.j.call("install",[u,m])).then(c=>b(c,null))}getManifest(u){return Promise.resolve(this.j.call("getManifest",[u]))}installFromGallery(u,m){return Promise.resolve(this.j.call("installFromGallery",[u,m])).then(c=>b(c,null))}uninstall(u,m){return Promise.resolve(this.j.call("uninstall",[u,m]))}reinstallFromGallery(u){return Promise.resolve(this.j.call("reinstallFromGallery",[u]))}getInstalled(u=null,m){return Promise.resolve(this.j.call("getInstalled",[u,m])).then(c=>c.map(h=>b(h,null)))}getMetadata(u){return Promise.resolve(this.j.call("getMetadata",[u]))}updateMetadata(u,m){return Promise.resolve(this.j.call("updateMetadata",[u,m])).then(c=>b(c,null))}updateExtensionScope(u,m){return Promise.resolve(this.j.call("updateExtensionScope",[u,m])).then(c=>b(c,null))}getExtensionsControlManifest(){return Promise.resolve(this.j.call("getExtensionsControlManifest"))}async download(u,m){const c=await this.j.call("download",[u,m]);return L.URI.revive(c)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=d;class g{constructor(u){this.a=u}listen(u,m){throw new Error("Invalid listen")}call(u,m,c){switch(m){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive(c[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.a.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=g}),define(re[97],ae([0,1,4]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,R.createDecorator)("IExtensionSignatureVerificationService");class i{b(){return this.a||(this.a=new Promise((k,L)=>_(["node-vsce-sign"],async P=>k(P),L))),this.a}async verify(k,L){let P;try{P=await this.b()}catch{return!1}return P.verify(k,L)}}e.ExtensionSignatureVerificationService=i}),define(re[98],ae([0,1,4]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var i;(function(L){L[L.FILE=1]="FILE",L[L.WORKSPACE=2]="WORKSPACE",L[L.EXE=3]="EXE"})(i=e.RecommendationSource||(e.RecommendationSource={}));function D(L){switch(L){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var k;(function(L){L.Ignored="ignored",L.Cancelled="cancelled",L.TooMany="toomany",L.IncompatibleWindow="incompatibleWindow",L.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[14],ae([0,1,49,12,27,15,8,164,4]),function(_,e,R,i,D,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function S(V){return V.create===!0}e.isFileOpenForWriteOptions=S;var E;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var b;(function(V){V[V.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var v;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=p;function d(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=d;function g(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=g;function w(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function u(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=u;function m(V){return p(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var c;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(c=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(Q,$){super(Q),this.code=$}}e.FileSystemProviderError=h;function f(V,Q){const $=new h(V.toString(),Q);return r($,Q),$}e.createFileSystemProviderError=f;function n(V){return V||f((0,P.localize)(0,null),c.Unknown)}e.ensureFileSystemProviderError=n;function r(V,Q){return V.name=Q?`${Q} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=r;function t(V){if(!V)return c.Unknown;if(V instanceof h)return V.code;const Q=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!Q)return c.Unknown;switch(Q[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.toFileSystemProviderErrorCode=t;function a(V){if(V instanceof T)return V.fileOperationResult;switch(t(V)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var s;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class l{constructor(Q,$,z){this.resource=Q,this.operation=$,this.target=z}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=l;var o;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class y{constructor(Q,$){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=Q;const z=new Map;for(const Y of Q){const ee=z.get(Y.type);switch(ee?ee.push([Y.resource,Y]):z.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,ee]of z)switch(Y){case 1:this.a=R.TernarySearchTree.forUris(()=>$),this.a.fill(ee);break;case 0:this.b=R.TernarySearchTree.forUris(()=>$),this.b.fill(ee);break;case 2:this.c=R.TernarySearchTree.forUris(()=>$),this.c.fill(ee);break}}contains(Q,...$){return this.d(Q,{includeChildren:!1},...$)}affects(Q,...$){return this.d(Q,{includeChildren:!0},...$)}d(Q,$,...z){if(!Q)return!1;const Y=z.length>0;return!!((!Y||z.includes(1))&&(this.a?.get(Q)||$.includeChildren&&this.a?.findSuperstr(Q))||(!Y||z.includes(0))&&(this.b?.get(Q)||$.includeChildren&&this.b?.findSuperstr(Q))||(!Y||z.includes(2))&&(this.c?.findSubstr(Q)||$.includeChildren&&this.c?.findSuperstr(Q)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=y;function C(V,Q,$){return!V||!Q||V===Q||Q.length>V.length?!1:(Q.charAt(Q.length-1)!==i.sep&&(Q+=i.sep),$?(0,D.startsWithIgnoreCase)(V,Q):V.indexOf(Q)===0)}e.isParent=C;class T extends Error{constructor(Q,$,z){super(Q),this.fileOperationResult=$,this.options=z}}e.FileOperationError=T;class W extends T{constructor(Q,$,z){super(Q,2,z),this.stat=$}}e.NotModifiedSinceFileOperationError=W;var O;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var j;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(j=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=F;async function A(V,Q){if(!Q.hasProvider(L.URI.from({scheme:V.scheme})))return new Promise($=>{const z=Q.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===V.scheme&&Y.added&&(z.dispose(),$())})})}e.whenProviderRegistered=A,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(Q){return(0,k.isNumber)(Q)||(Q=0),Q<M.KB?(0,P.localize)(1,null,Q.toFixed(0)):Q<M.MB?(0,P.localize)(2,null,(Q/M.KB).toFixed(2)):Q<M.GB?(0,P.localize)(3,null,(Q/M.MB).toFixed(2)):Q<M.TB?(0,P.localize)(4,null,(Q/M.GB).toFixed(2)):(0,P.localize)(5,null,(Q/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var B;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function G(V){return{maxFileSize:V===0?300*M.MB:16*M.GB,maxHeapSize:V===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=G});var K=this&&this.__param||function(_,e){return function(R,i){e(R,i,_)}};define(re[195],ae([0,1,99,43,14]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(P){this.a=P}async checksum(P){const I=(await this.a.readFileStream(P)).value;return new Promise((S,E)=>{const b=(0,R.createHash)("md5");(0,i.listenStream)(I,{onData:v=>b.update(v.buffer),onError:v=>E(v),onEnd:()=>S(b.digest("base64").replace(/=+$/,""))})})}};k=pe([K(0,D.IFileService)],k),e.ChecksumService=k}),define(re[196],ae([0,1,17,38,9,3,2,43,8,30,14]),function(_,e,R,i,D,k,L,P,I,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends L.Disposable{constructor(p,d){super(),this.a=p,this.b=d,this.onDidChangeCapabilities=k.Event.None,this.f=this.B(new k.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new k.Emitter),this.onDidWatchError=this.g.event,this.h=(0,S.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(p){return this.a.call("stat",[p])}readdir(p){return this.a.call("readdir",[p])}async readFile(p,d){const{buffer:g}=await this.a.call("readFile",[p,d]);return g}readFileStream(p,d,g){const w=(0,P.newWriteableStream)(m=>R.VSBuffer.concat(m.map(c=>R.VSBuffer.wrap(c))).buffer),u=this.a.listen("readFileStream",[p,d])(m=>{if(m instanceof R.VSBuffer)w.write(m.buffer);else{if(m==="end")w.end();else{let c=m;c instanceof Error||(c=(0,E.createFileSystemProviderError)((0,i.toErrorMessage)(c),E.FileSystemProviderErrorCode.Unknown)),w.error(c),w.end()}u.dispose()}});return g.onCancellationRequested(()=>{w.error((0,D.canceled)()),w.end(),u.dispose()}),w}writeFile(p,d,g){return this.a.call("writeFile",[p,R.VSBuffer.wrap(d),g])}open(p,d){return this.a.call("open",[p,d])}close(p){return this.a.call("close",[p])}async read(p,d,g,w,u){const[m,c]=await this.a.call("read",[p,d,u]);return g.set(m.buffer.slice(0,c),w),c}write(p,d,g,w,u){return this.a.call("write",[p,d,R.VSBuffer.wrap(g),w,u])}mkdir(p){return this.a.call("mkdir",[p])}delete(p,d){return this.a.call("delete",[p,d])}rename(p,d,g){return this.a.call("rename",[p,d,g])}copy(p,d,g){return this.a.call("copy",[p,d,g])}cloneFile(p,d){return this.a.call("cloneFile",[p,d])}i(){this.B(this.a.listen("fileChange",[this.h])(p=>{if(Array.isArray(p)){const d=p;this.f.fire(d.map(g=>({resource:I.URI.revive(g.resource),type:g.type})))}else{const d=p;this.g.fire(d)}}))}watch(p,d){const g=(0,S.generateUuid)();return this.a.call("watch",[this.h,g,p,d]),(0,L.toDisposable)(()=>this.a.call("unwatch",[this.h,g]))}}e.DiskFileSystemProviderClient=b}),define(re[100],ae([0,1,17,9,165,14]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function L(E,b,v,p,d,g){let w;try{await P(E,b,v,p,d,g)}catch(u){w=u}finally{w&&d.errorTransformer&&(w=d.errorTransformer(w)),typeof w<"u"&&v.error(w),v.end()}}e.readFileIntoStream=L;async function P(E,b,v,p,d,g){I(g);const w=await E.open(b,{create:!1});try{I(g);let u=0,m=0,c=d&&typeof d.length=="number"?d.length:void 0,h=R.VSBuffer.alloc(Math.min(d.bufferSize,typeof c=="number"?c:d.bufferSize)),f=d&&typeof d.position=="number"?d.position:0,n=0;do m=await E.read(w,f,h.buffer,n,h.byteLength-n),f+=m,n+=m,u+=m,typeof c=="number"&&(c-=m),n===h.byteLength&&(await v.write(p(h)),h=R.VSBuffer.alloc(Math.min(d.bufferSize,typeof c=="number"?c:d.bufferSize)),n=0);while(m>0&&(typeof c!="number"||c>0)&&I(g)&&S(u,d));if(n>0){let r=n;typeof c=="number"&&(r=Math.min(n,c)),v.write(p(h.slice(0,r)))}}catch(u){throw(0,k.ensureFileSystemProviderError)(u)}finally{await E.close(w)}}function I(E){if(E.isCancellationRequested)throw(0,i.canceled)();return!0}function S(E,b){if(b?.limits){if(typeof b.limits.memory=="number"&&E>b.limits.memory)throw(0,k.createFileSystemProviderError)((0,D.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&E>b.limits.size)throw(0,k.createFileSystemProviderError)((0,D.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[56],ae([0,1,89,2,12,5,8,14]),function(_,e,R,i,D,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(u){return u.recursive===!0}e.isRecursiveWatchRequest=I;class S extends i.Disposable{constructor(m,c,h,f){super(),this.h=m,this.i=c,this.j=h,this.k=f,this.c=this.B(new i.MutableDisposable),this.f=void 0,this.g=0}m(){const m=new i.DisposableStore;this.c.value=m,this.b=this.l(m),this.b.setVerboseLogging(this.j),m.add(this.b.onDidChangeFile(c=>this.h(c))),m.add(this.b.onDidLogMessage(c=>this.i(c))),m.add(this.b.onDidError(c=>this.n(c)))}n(m){this.k.restartOnError?this.g<S.a&&this.f?(this.r(`restarting watcher after error: ${m}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${m}`):this.r(m)}p(m){this.g++,this.m(),this.watch(m)}async watch(m){this.f=m,await this.b?.watch(m)}async setVerboseLogging(m){this.j=m,await this.b?.setVerboseLogging(m)}r(m){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${m}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=S,S.a=5;class E extends S{constructor(m,c,h){super(m,c,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=E;class b extends S{constructor(m,c,h){super(m,c,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function v(u){return u.map(m=>({type:m.type,resource:L.URI.file(m.path)}))}e.toFileChanges=v;function p(u){const m=new w;for(const c of u)m.processEvent(c);return m.coalesce()}e.coalesceEvents=p;function d(u,m){return typeof m=="string"&&!m.startsWith(R.GLOBSTAR)&&!(0,D.isAbsolute)(m)?{base:u,pattern:m}:m}e.normalizeWatcherPattern=d;function g(u,m){const c=[];for(const h of m)c.push((0,R.parse)(d(u,h)));return c}e.parseWatcherPatterns=g;class w{constructor(){this.a=new Set,this.b=new Map}c(m){return k.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const c=this.b.get(this.c(m));let h=!1;if(c){const f=c.type,n=m.type;c.path!==m.path&&(m.type===2||m.type===1)?h=!0:f===1&&n===2?(this.b.delete(this.c(m)),this.a.delete(c)):f===2&&n===1?c.type=0:f===1&&n===0||(c.type=n)}else h=!0;h&&(this.a.add(m),this.b.set(this.c(m),m))}coalesce(){const m=[],c=[];return Array.from(this.a).filter(h=>h.type!==2?(m.push(h),!1):!0).sort((h,f)=>h.path.length-f.path.length).filter(h=>c.some(f=>(0,P.isParent)(h.path,f,!k.isLinux))?!1:(c.push(h.path),!0)).concat(m)}}}),define(re[197],ae([0,1,53,6,22,48,2,84,12,5,145,28,56]),function(_,e,R,i,D,k,L,P,I,S,E,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class p extends L.Disposable{constructor(w,u,m,c){super(),this.k=w,this.l=u,this.m=m,this.n=c,this.c=new i.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.l(h)),this.f=this.B(new i.ThrottledDelayer(p.b)),this.g=[],this.h=(0,v.parseWatcherPatterns)(this.k.path,this.k.excludes),this.i=this.k.includes?(0,v.parseWatcherPatterns)(this.k.path,this.k.includes):void 0,this.j=new D.CancellationTokenSource,this.ready=this.r()}async r(){try{const w=await this.s(this.k);if(this.j.token.isCancellationRequested)return;const u=await b.Promises.stat(w);this.B(await this.t(w,u.isDirectory()))}catch(w){w.code!=="ENOENT"?this.w(w):this.C(w)}}async s(w){let u=w.path;try{u=await b.Promises.realpath(w.path),w.path===u&&(u=await(0,E.realcase)(w.path)??w.path),w.path!==u&&this.C(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${u})`)}catch{}return u}async t(w,u){if(S.isMacintosh&&(0,k.isEqualOrParent)(w,"/Volumes/",!0))return this.w(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.Disposable.None;const m=new D.CancellationTokenSource(this.j.token),c=new L.DisposableStore;try{const h=(0,I.basename)(w),f=(0,R.watch)(w);c.add((0,L.toDisposable)(()=>{f.removeAllListeners(),f.close()})),this.C(`Started watching: '${w}'`);const n=new Set;if(u)try{for(const t of await b.Promises.readdir(w))n.add(t)}catch(t){this.w(t)}const r=new Map;c.add((0,L.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),f.on("error",(t,a)=>{this.w(`Failed to watch ${w} for changes using fs.watch() (${t}, ${a})`),this.dispose()}),f.on("change",(t,a)=>{if(m.token.isCancellationRequested)return;this.C(`[raw] ["${t}"] ${a}`);let s="";if(a&&(s=a.toString(),S.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(u)if(t==="rename"){r.get(s)?.dispose();const l=setTimeout(async()=>{if(r.delete(s),s===h&&!await b.Promises.exists(w)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.v((0,I.join)(w,s));if(m.token.isCancellationRequested)return;let y;o?n.has(s)?y=0:(y=1,n.add(s)):(n.delete(s),y=2),this.u({path:(0,I.join)(this.k.path,s),type:y})},p.a);r.set(s,(0,L.toDisposable)(()=>clearTimeout(l)))}else{let l;n.has(s)?l=0:(l=1,n.add(s)),this.u({path:(0,I.join)(this.k.path,s),type:l})}else if(t==="rename"||s!==h){const l=setTimeout(async()=>{const o=await b.Promises.exists(w);m.token.isCancellationRequested||(o?(this.u({path:this.k.path,type:0},!0),c.add(await this.t(w,!1))):(await this.u({path:this.k.path,type:2},!0),this.dispose()))},p.a);c.clear(),c.add((0,L.toDisposable)(()=>clearTimeout(l)))}else this.u({path:this.k.path,type:0},!0)})}catch(h){await b.Promises.exists(w)&&!m.token.isCancellationRequested&&this.w(`Failed to watch ${w} for changes using fs.watch() (${h.toString()})`)}return(0,L.toDisposable)(()=>{m.dispose(!0),c.dispose()})}async u(w,u=!1){if(!this.j.token.isCancellationRequested){this.n&&this.C(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),!u&&this.h.some(m=>m(w.path))?this.n&&this.C(` >> ignored (excluded) ${w.path}`):!u&&this.i&&this.i.length>0&&!this.i.some(m=>m(w.path))?this.n&&this.C(` >> ignored (not included) ${w.path}`):this.g.push(w);try{await this.f.trigger(async()=>{const m=this.g;this.g=[];const c=(0,v.coalesceEvents)(m);if(c.length>0){if(this.n)for(const f of c)this.C(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.c.work(c)?this.c.pending>0&&this.C(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async v(w){if(S.isLinux)return b.Promises.exists(w);try{const u=(0,I.basename)(w);return(await b.Promises.readdir((0,I.dirname)(w))).some(c=>c===u)}catch(u){return this.C(u),!1}}setVerboseLogging(w){this.n=w}w(w){this.j.token.isCancellationRequested||this.m?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}y(w){this.j.token.isCancellationRequested||this.m?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}C(w){!this.j.token.isCancellationRequested&&this.n&&this.m?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.C(`stopping file watcher on ${this.k.path}`),this.j.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=p,p.a=100,p.b=50;async function d(g,w,u,m,c=512){const h=await b.Promises.open(g,"r"),f=Buffer.allocUnsafe(c),n=new D.CancellationTokenSource(m);let r,t=!1;const a={path:g,excludes:[],recursive:!1},s=new p(a,l=>{(async()=>{for(const{type:o}of l)if(o===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:y}=await b.Promises.read(h,f,0,c,null);if(!y||n.token.isCancellationRequested)break;w(f.slice(0,y))}}catch(y){r=new Error(y),n.dispose(!0)}finally{t=!1}}})()});return await s.ready,u(),new Promise((l,o)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await b.Promises.close(h)}catch(y){r=new Error(y)}r?o(r):l()})})}e.watchFileContents=d}),define(re[198],ae([0,1,3,89,2,5,197]),function(_,e,R,i,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new R.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new R.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=R.Event.None,this.c=new Map,this.f=!1}async watch(S){const E=this.i(S),b=E.filter(p=>{const d=this.c.get(p.path);return d?!(0,i.patternsEquals)(d.request.excludes,p.excludes)||!(0,i.patternsEquals)(d.request.includes,p.includes):!0}),v=Array.from(this.c.values()).filter(({request:p})=>!E.find(d=>d.path===p.path&&(0,i.patternsEquals)(d.excludes,p.excludes)&&(0,i.patternsEquals)(d.includes,p.includes))).map(({request:p})=>p.path);b.length&&this.j(`Request to start watching: ${b.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"})`).join(",")}`),v.length&&this.j(`Request to stop watching: ${v.join(",")}`);for(const p of v)this.h(p);for(const p of b)this.g(p)}g(S){const E=new L.NodeJSFileWatcherLibrary(S,v=>this.a.fire(v),v=>this.b.fire(v),this.f),b={request:S,instance:E};this.c.set(S.path,b)}async stop(){for(const[S]of this.c)this.h(S);this.c.clear()}h(S){const E=this.c.get(S);E&&(this.c.delete(S),E.instance.dispose())}i(S){const E=new Map;for(const b of S){const v=k.isLinux?b.path:b.path.toLowerCase();E.set(v,b)}return Array.from(E.values())}async setVerboseLogging(S){this.f=S;for(const[,E]of this.c)E.instance.setVerboseLogging(S)}j(S){this.f&&this.b.fire({type:"trace",message:this.k(S)})}k(S,E){return E?`[File Watcher (node.js)] ${S} (path: ${E.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=P}),define(re[199],ae([0,1,56,198]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends R.AbstractNonRecursiveWatcherClient{constructor(L,P,I){super(L,P,I),this.m()}l(){return new i.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(re[200],ae([0,1,23,39,68,56]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends k.AbstractUniversalWatcherClient{constructor(I,S,E){super(I,S,E),this.m()}l(I){const S=I.add(new D.Client(R.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(S.onDidProcessExit(({code:E,signal:b})=>this.n(`terminated by itself with code ${E}, signal: ${b}`))),i.ProxyChannel.toService((0,i.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(re[72],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...D){this.a=new Map;for(const[k,L]of D)this.set(k,L)}set(D,k){const L=this.a.get(D);return this.a.set(D,k),L}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=R}),define(re[201],ae([0,1,6,9,2,55,191,4,72,83]),function(_,e,R,i,D,k,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class b extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class v{constructor(w=new I.ServiceCollection,u=!1,m,c=E){this.f=w,this.g=u,this.h=m,this.i=c,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=c?m?._globalGraph??new L.Graph(h=>h):void 0}createChild(w){return new v(w,this.g,this,this.i)}invokeFunction(w,...u){const m=d.traceInvocation(this.i,w);let c=!1;try{return w({get:f=>{if(c)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(f,m);if(!n)throw new Error(`[invokeFunction] unknown service '${f}'`);return n}},...u)}finally{c=!0,m.stop()}}createInstance(w,...u){let m,c;return w instanceof k.SyncDescriptor?(m=d.traceCreation(this.i,w.ctor),c=this.j(w.ctor,w.staticArguments.concat(u),m)):(m=d.traceCreation(this.i,w),c=this.j(w,u,m)),m.stop(),c}j(w,u=[],m){const c=P._util.getServiceDependencies(w).sort((n,r)=>n.index-r.index),h=[];for(const n of c){const r=this.m(n.id,m);r||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${n.id}.`,!1),h.push(r)}const f=c.length>0?c[0].index:u.length;if(u.length!==f){console.trace(`[createInstance] First service dependency of ${w.name} at position ${f+1} conflicts with ${u.length} static arguments`);const n=f-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,f)}return Reflect.construct(w,u.concat(h))}k(w,u){if(this.f.get(w)instanceof k.SyncDescriptor)this.f.set(w,u);else if(this.h)this.h.k(w,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const u=this.f.get(w);return!u&&this.h?this.h.l(w):u}m(w,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const m=this.l(w);return m instanceof k.SyncDescriptor?this.q(w,m,u.branch(w,!0)):(u.branch(w,!1),m)}q(w,u,m){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,u,m)}finally{this.o.delete(w)}}r(w,u,m){const c=new L.Graph(n=>n.id.toString());let h=0;const f=[{id:w,desc:u,_trace:m}];for(;f.length;){const n=f.pop();if(c.lookupOrInsertNode(n),h++>1e3)throw new b(c);for(const r of P._util.getServiceDependencies(n.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${w} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof k.SyncDescriptor){const a={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};c.insertEdge(n,a),f.push(a)}}}for(;;){const n=c.roots();if(n.length===0){if(!c.isEmpty())throw new b(c);break}for(const{data:r}of n){if(this.l(r.id)instanceof k.SyncDescriptor){const a=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,a)}c.removeNode(r)}}return this.l(w)}s(w,u,m=[],c,h){if(this.f.get(w)instanceof k.SyncDescriptor)return this.t(w,u,m,c,h);if(this.h)return this.h.s(w,u,m,c,h);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(w,u,m=[],c,h){if(c){const f=new v(void 0,this.g,this,this.i);f.c=String(w);const n=new Map,r=new R.IdleValue(()=>{const t=f.j(u,m,h);for(const[a,s]of n){const l=t[a];if(typeof l=="function")for(const o of s)l.apply(t,o)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,a){if(!r.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let o=n.get(a);return o||(o=new S.LinkedList,n.set(a,o)),(C,T,W)=>{const O=o.push([C,T,W]);return(0,D.toDisposable)(O)}}if(a in t)return t[a];const s=r.value;let l=s[a];return typeof l!="function"||(l=l.bind(s),t[a]=l),l},set(t,a,s){return r.value[a]=s,!0}})}else return this.j(u,m,h)}u(w,u){if(u&&console.warn(w),this.g)throw new Error(w)}}e.InstantiationService=v;var p;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(p||(p={}));class d{static traceInvocation(w,u){return w?new d(1,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(w,u){return w?new d(0,u.name):d.c}constructor(w,u){this.type=w,this.name=u,this.g=Date.now(),this.h=[]}branch(w,u){const m=new d(2,w.toString());return this.h.push([w,u,m]),m}stop(){const w=Date.now()-this.g;d.f+=w;let u=!1;function m(h,f){const n=[],r=new Array(h+1).join("	");for(const[t,a,s]of f.h)if(a&&s){u=!0,n.push(`${r}CREATES -> ${t}`);const l=m(h+1,s);l&&n.push(l)}else n.push(`${r}uses -> ${t}`);return n.join(`
`)}const c=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(w>2||u)&&d.all.add(c.join(`
`))}}e.Trace=d,d.all=new Set,d.c=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d.f=0}),define(re[202],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(D,k){this.a=D,this.b=k}getChannel(D){return this.a.getChannel(D,this.b)}registerChannel(D,k){this.a.registerChannel(D,k)}}e.MessagePortMainProcessService=R}),define(re[57],ae([0,1,39,55,71,4]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class L{constructor(p,d,g,w){const u=g.getChannel(p);return P(d)?w.createInstance(new i.SyncDescriptor(d.channelClientCtor,[u])):R.ProxyChannel.toService(u,d?.proxyOptions)}}function P(v){return!!v?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let I=class extends L{constructor(p,d,g,w){super(p,d,g,w)}};I=pe([K(2,e.IMainProcessService),K(3,k.IInstantiationService)],I);function S(v,p,d){(0,D.registerSingleton)(v,new i.SyncDescriptor(I,[p,d],!0))}e.registerMainProcessRemoteService=S,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let E=class extends L{constructor(p,d,g,w){super(p,d,g,w)}};E=pe([K(2,e.ISharedProcessService),K(3,k.IInstantiationService)],E);function b(v,p,d){(0,D.registerSingleton)(v,new i.SyncDescriptor(E,[p,d],!0))}e.registerSharedProcessRemoteService=b}),define(re[73],ae([0,1,22,2,5,167,29,4]),function(_,e,R,i,D,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let I=class extends i.Disposable{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new R.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let b;try{b=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const p=b.firstPage.filter(d=>d.properties.localizedLanguages?.length&&d.tags.some(g=>g.startsWith("lp-"))).map(d=>{const g=d.properties.localizedLanguages?.[0],w=this.getLocale(d);return{...this.f(w,g,d),extensionId:d.identifier.id,galleryExtension:d}});return p.push({...this.f("en","English"),extensionId:"default"}),p}getLocale(E){return E.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}f(E,b,v){const p=b??E;let d;if(p!==E&&(d=`(${E})`),E.toLowerCase()===D.language.toLowerCase()&&(d??="",d+=(0,k.localize)(0,null)),v?.installCount){d??="";const g=v.installCount;let w;g>1e6?w=`${Math.floor(g/1e5)/10}M`:g>1e3?w=`${Math.floor(g/1e3)}K`:w=String(g),d+=` $(cloud-download) ${w}`}return{id:E,label:p,description:d}}};I=pe([K(0,L.IExtensionGalleryService)],I),e.LanguagePackBaseService=I}),define(re[203],ae([0,1,2,73]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends R.Disposable{constructor(L){super(),this.a=L,this.b()}b(){this.a.update()}};D=pe([K(0,i.ILanguagePackService)],D),e.LocalizationsUpdater=D}),define(re[7],ae([0,1,38,3,2,37,5,8,4]),function(_,e,R,i,D,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function S(){return new Date().toISOString()}var E;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function b(l,o,y){switch(o){case E.Trace:l.trace(y);break;case E.Debug:l.debug(y);break;case E.Info:l.info(y);break;case E.Warning:l.warn(y);break;case E.Error:l.error(y);break;default:throw new Error("Invalid log level")}}e.log=b;function v(l){let o="";for(let y=0;y<l.length;y++){let C=l[y];if(typeof C=="object")try{C=JSON.stringify(C)}catch{}o+=(y>0?" ":"")+C}return o}e.format=v;class p extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new i.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(o){this.b!==o&&(this.b=o,this.c.fire(this.b))}getLevel(){return this.b}}e.AbstractLogger=p;class d extends p{constructor(o){super(),this.g=o}h(o){return this.g||this.getLevel()<=o}trace(o,...y){this.h(E.Trace)&&this.f(E.Trace,v([o,...y]))}debug(o,...y){this.h(E.Debug)&&this.f(E.Debug,v([o,...y]))}info(o,...y){this.h(E.Info)&&this.f(E.Info,v([o,...y]))}warn(o,...y){this.h(E.Warning)&&this.f(E.Warning,v([o,...y]))}error(o,...y){if(this.h(E.Error))if(o instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=o.stack,this.f(E.Error,v(C))}else this.f(E.Error,v([o,...y]))}flush(){}}e.AbstractMessageLogger=d;class g extends p{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.f=!L.isWindows}trace(o,...y){this.getLevel()<=E.Trace&&(this.f?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,o,...y):console.log(`[main ${S()}]`,o,...y))}debug(o,...y){this.getLevel()<=E.Debug&&(this.f?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,o,...y):console.log(`[main ${S()}]`,o,...y))}info(o,...y){this.getLevel()<=E.Info&&(this.f?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,o,...y):console.log(`[main ${S()}]`,o,...y))}warn(o,...y){this.getLevel()<=E.Warning&&(this.f?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,o,...y):console.warn(`[main ${S()}]`,o,...y))}error(o,...y){this.getLevel()<=E.Error&&(this.f?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,o,...y):console.error(`[main ${S()}]`,o,...y))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class w extends p{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...y){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",o,...y)}debug(o,...y){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...y)}info(o,...y){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",o,...y)}warn(o,...y){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",o,...y)}error(o,...y){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",o,...y)}dispose(){}flush(){}}e.ConsoleLogger=w;class u extends p{constructor(o,y=e.DEFAULT_LOG_LEVEL){super(),this.f=o,this.setLevel(y)}trace(o,...y){this.getLevel()<=E.Trace&&this.f.log(E.Trace,[this.g(o),...y])}debug(o,...y){this.getLevel()<=E.Debug&&this.f.log(E.Debug,[this.g(o),...y])}info(o,...y){this.getLevel()<=E.Info&&this.f.log(E.Info,[this.g(o),...y])}warn(o,...y){this.getLevel()<=E.Warning&&this.f.log(E.Warning,[this.g(o),...y])}error(o,...y){this.getLevel()<=E.Error&&this.f.log(E.Error,[this.g(o),...y])}g(o){return typeof o=="string"?o:(0,R.toErrorMessage)(o,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class m extends p{constructor(o){super(),this.f=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const y of this.f)y.setLevel(o);super.setLevel(o)}trace(o,...y){for(const C of this.f)C.trace(o,...y)}debug(o,...y){for(const C of this.f)C.debug(o,...y)}info(o,...y){for(const C of this.f)C.info(o,...y)}warn(o,...y){for(const C of this.f)C.warn(o,...y)}error(o,...y){for(const C of this.f)C.error(o,...y)}flush(){for(const o of this.f)o.flush()}dispose(){for(const o of this.f)o.dispose()}}e.MultiplexLogService=m;class c extends D.Disposable{constructor(o){super(),this.b=o,this.B(o)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(o){this.b.setLevel(o)}getLevel(){return this.b.getLevel()}trace(o,...y){this.b.trace(o,...y)}debug(o,...y){this.b.debug(o,...y)}info(o,...y){this.b.info(o,...y)}warn(o,...y){this.b.warn(o,...y)}error(o,...y){this.b.error(o,...y)}flush(){this.b.flush()}}e.LogService=c;class h extends D.Disposable{constructor(o,y){super(),this.c=o,this.b=new k.ResourceMap,this.B(y(C=>this.setLevel(C)))}getLoggers(){return[...this.b.values()].map(({logger:o})=>o)}getLogger(o){return this.b.get(o)?.logger}createLogger(o,y,C){let T=this.b.get(o)?.logger;return T||(C=y?.always?E.Trace:C,T=this.f(o,C??this.c,y),this.b.set(o,{logger:T,logLevel:C})),T}setLevel(o,y){const C=P.URI.isUri(o)?o:void 0,T=C?y:o;if(C){const W=this.b.get(C);W&&W.logLevel!==T&&(W.logLevel=T,W.logger.setLevel(T))}else this.c=T,this.b.forEach(({logLevel:W,logger:O})=>{W===void 0&&O.setLevel(this.c)})}getLogLevel(o){return this.b.get(o)?.logLevel}dispose(){this.b.forEach(({logger:o})=>o.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=h;class f{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(o){}getLevel(){return E.Info}trace(o,...y){}debug(o,...y){}info(o,...y){}warn(o,...y){}error(o,...y){}critical(o,...y){}dispose(){}flush(){}}e.NullLogger=f;class n extends f{}e.NullLogService=n;class r extends h{constructor(){super(E.Info,i.Event.None)}f(o,y,C){return new f}}e.NullLoggerService=r;function t(l){if(l.verbose)return E.Trace;if(typeof l.logLevel=="string"){const o=s(l.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function a(l){switch(l){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=a;function s(l){switch(l){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=s}),define(re[204],ae([0,1,6,9,2,12,28,13,7]),function(_,e,R,i,D,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=class extends D.Disposable{constructor(b,v){super(),this.a=b,this.b=v,this.B(new R.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,k.basename)(this.a.logsPath),v=(0,k.dirname)(this.a.logsPath),g=(await L.Promises.readdir(v)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==b),w=g.slice(0,Math.max(0,g.length-9));w.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${w.join(", ")}'`),await Promise.all(w.map(u=>L.Promises.rm((0,k.join)(v,u)))))}catch(b){(0,i.onUnexpectedError)(b)}}};S=pe([K(0,P.IEnvironmentService),K(1,I.ILogService)],S),e.LogsDataCleaner=S}),define(re[205],ae([0,1,19,6,9,3,2,12,56,7]),function(_,e,R,i,D,k,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends L.Disposable{constructor(v,p){super(),this.a=v,this.b=p,this.c=this.B(new k.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new k.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new i.ThrottledDelayer(0)),this.s=[],this.t=this.B(new i.ThrottledDelayer(0))}watch(v,p){return p.recursive||this.b?.watcher?.forceUniversal?this.l(v,p):this.u(v,p)}l(v,p){const d={path:this.D(v),excludes:p.excludes,includes:p.includes,recursive:p.recursive},g=(0,R.insert)(this.j,d);return this.m(),(0,L.toDisposable)(()=>{g(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(v=>(0,D.onUnexpectedError)(v))}n(){this.h||(this.h=this.B(this.p(p=>this.c.fire((0,I.toFileChanges)(p)),p=>this.C(p),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const p of this.j)(0,I.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const p of this.j)(0,I.isRecursiveWatchRequest)(p)&&v.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(v,p){const d={path:this.D(v),excludes:p.excludes,includes:p.includes,recursive:!1},g=(0,R.insert)(this.s,d);return this.v(),(0,L.toDisposable)(()=>{g(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(v=>(0,D.onUnexpectedError)(v))}w(){return this.r||(this.r=this.B(this.y(v=>this.c.fire((0,I.toFileChanges)(v)),v=>this.C(v),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.r.watch(this.s)}C(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}D(v){return(0,P.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=E}),define(re[206],ae([0,1,19,6,17,22,3,66,64,2,49,23,207,20,43,163,14,100,7]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends S.Disposable{constructor(f){super(),this.b=f,this.a=256*1024,this.c=this.B(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new L.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new L.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new L.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new i.ResourceQueue)}registerProvider(f,n){if(this.h.has(f))throw new Error(`A filesystem provider for the scheme '${f}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${f}`);const r=new S.DisposableStore;return this.h.set(f,n),this.c.fire({added:!0,scheme:f,provider:n}),r.add(n.onDidChangeFile(t=>this.R.fire(new w.FileChangesEvent(t,!this.O(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(t=>this.S.fire(new Error(t)))),r.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:f}))),(0,S.toDisposable)(()=>{this.c.fire({added:!1,scheme:f,provider:n}),this.h.delete(f),(0,S.dispose)(r)})}getProvider(f){return this.h.get(f)}async activateProvider(f){const n=[];this.f.fire({scheme:f,join(r){n.push(r)}}),!this.h.has(f)&&await i.Promises.settled(n)}async canHandleResource(f){return await this.activateProvider(f.scheme),this.hasProvider(f)}hasProvider(f){return this.h.has(f.scheme)}hasCapability(f,n){const r=this.h.get(f.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return I.Iterable.map(this.h,([f,n])=>({scheme:f,capabilities:n.capabilities}))}async j(f){if(!(0,p.isAbsolutePath)(f))throw new w.FileOperationError((0,g.localize)(0,null,this.ob(f)),8);await this.activateProvider(f.scheme);const n=this.h.get(f.scheme);if(!n){const r=new Error;throw r.name="ENOPRO",r.message=(0,g.localize)(1,null,f.toString()),r}return n}async k(f){const n=await this.j(f);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n)||(0,w.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(f){const n=await this.j(f);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(f,n){try{return await this.n(f,n)}catch(r){throw(0,w.toFileSystemProviderErrorCode)(r)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,g.localize)(2,null,this.ob(f)),1):(0,w.ensureFileSystemProviderError)(r)}}async n(f,n){const r=await this.j(f),t=this.O(r),a=n?.resolveTo,s=n?.resolveSingleChildDescendants,l=n?.resolveMetadata,o=await r.stat(f);let y;return this.p(r,f,o,void 0,!!l,(C,T)=>(y||(y=E.TernarySearchTree.forUris(()=>!t),y.set(f,!0),a&&y.fill(!0,a)),y.get(C.resource)||y.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&s?T===1:!1))}async p(f,n,r,t,a,s){const{providerExtUri:l}=this.N(f),o={resource:n,name:l.basename(n),isFile:(r.type&w.FileType.File)!==0,isDirectory:(r.type&w.FileType.Directory)!==0,isSymbolicLink:(r.type&w.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&w.FilePermission.Readonly)||Boolean(f.capabilities&2048),etag:(0,w.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(o.isDirectory&&s(o,t)){try{const y=await f.readdir(n),C=await i.Promises.settled(y.map(async([T,W])=>{try{const O=l.joinPath(n,T),j=a?await f.stat(O):{type:W};return await this.p(f,O,j,y.length,a,s)}catch(O){return this.b.trace(O),null}}));o.children=(0,R.coalesce)(C)}catch(y){this.b.trace(y),o.children=[]}return o}return o}async resolveAll(f){return i.Promises.settled(f.map(async n=>{try{return{stat:await this.n(n.resource,n.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(f){const n=await this.j(f),r=await n.stat(f);return this.p(n,f,r,void 0,!0,()=>!1)}async exists(f){const n=await this.j(f);try{return!!await n.stat(f)}catch{return!1}}async canCreateFile(f,n){try{await this.r(f,n)}catch(r){return r}return!0}async r(f,n){if(!n?.overwrite&&await this.exists(f))throw new w.FileOperationError((0,g.localize)(3,null,this.ob(f)),3,n)}async createFile(f,n=D.VSBuffer.fromString(""),r){await this.r(f,r);const t=await this.writeFile(f,n);return this.m.fire(new w.FileOperationEvent(f,0,t)),t}async writeFile(f,n,r){const t=this.mb(await this.l(f),f),{providerExtUri:a}=this.N(t);try{await this.s(t,f,r)||await this.P(t,a.dirname(f));let l;if((0,w.hasReadWriteCapability)(t)&&!(n instanceof D.VSBuffer))if((0,d.isReadableStream)(n)){const o=await(0,d.peekStream)(n,3);o.ended?l=D.VSBuffer.concat(o.buffer):l=o}else l=(0,d.peekReadable)(n,o=>D.VSBuffer.concat(o),3);else l=n;!(0,w.hasOpenReadWriteCloseCapability)(t)||(0,w.hasReadWriteCapability)(t)&&l instanceof D.VSBuffer?await this.db(t,f,r,l):await this.Y(t,f,r,l instanceof D.VSBuffer?(0,D.bufferToReadable)(l):l),this.m.fire(new w.FileOperationEvent(f,4))}catch(s){throw new w.FileOperationError((0,g.localize)(4,null,this.ob(f),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),r)}return this.resolve(f,{resolveMetadata:!0})}async s(f,n,r){if(!!r?.unlock&&!(f.capabilities&8192))throw new Error((0,g.localize)(5,null,this.ob(n)));let a;try{a=await f.stat(n)}catch{return}if((a.type&w.FileType.Directory)!==0)throw new w.FileOperationError((0,g.localize)(6,null,this.ob(n)),0,r);if(this.nb(n,a),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==w.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&r.mtime<a.mtime&&r.etag!==(0,w.etag)({mtime:r.mtime,size:a.size}))throw new w.FileOperationError((0,g.localize)(7,null),3,r);return a}async readFile(f,n,r){const t=await this.k(f);return n?.atomic?this.t(t,f,n,r):this.u(t,f,n,r)}async t(f,n,r,t){return new Promise((a,s)=>{this.X.queueFor(n,this.N(f).providerExtUri).queue(async()=>{try{const l=await this.u(f,n,r,t);a(l)}catch(l){s(l)}})})}async u(f,n,r,t){const a=await this.v(f,n,{...r,preferUnbuffered:!0},t);return{...a,value:await(0,D.streamToBuffer)(a.value)}}async readFileStream(f,n,r){const t=await this.k(f);return this.v(t,f,n,r)}async v(f,n,r,t){const a=new k.CancellationTokenSource(t),s=this.F(n,r).then(o=>o,o=>{throw a.cancel(),o});let l;try{return typeof r?.etag=="string"&&r.etag!==w.ETAG_DISABLED&&await s,r?.atomic&&(0,w.hasFileAtomicReadCapability)(f)||!((0,w.hasOpenReadWriteCloseCapability)(f)||(0,w.hasFileReadStreamCapability)(f))||(0,w.hasReadWriteCapability)(f)&&r?.preferUnbuffered?l=this.D(f,n,r):(0,w.hasFileReadStreamCapability)(f)?l=this.w(f,n,a.token,r):l=this.C(f,n,a.token,r),{...await s,value:l}}catch(o){l&&await(0,d.consumeStream)(l);const y=(0,g.localize)(8,null,this.ob(n),(0,w.ensureFileSystemProviderError)(o).toString());throw o instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(y,o.stat,r):new w.FileOperationError(y,(0,w.toFileOperationResult)(o),r)}}w(f,n,r,t=Object.create(null)){const a=f.readFileStream(n,t,r);return(0,d.transform)(a,{data:s=>s instanceof D.VSBuffer?s:D.VSBuffer.wrap(s),error:s=>new w.FileOperationError((0,g.localize)(9,null,this.ob(n),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),t)},s=>D.VSBuffer.concat(s))}C(f,n,r,t=Object.create(null)){const a=(0,D.newWriteableBufferStream)();return(0,u.readFileIntoStream)(f,n,a,s=>s,{...t,bufferSize:this.a,errorTransformer:s=>new w.FileOperationError((0,g.localize)(10,null,this.ob(n),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),t)},r),a}D(f,n,r){const t=(0,d.newWriteableStream)(a=>D.VSBuffer.concat(a));return(async()=>{try{let a;r?.atomic&&(0,w.hasFileAtomicReadCapability)(f)?a=await f.readFile(n,{atomic:!0}):a=await f.readFile(n),typeof r?.position=="number"&&(a=a.slice(r.position)),typeof r?.length=="number"&&(a=a.slice(0,r.length)),this.G(n,a.byteLength,r),t.end(D.VSBuffer.wrap(a))}catch(a){t.error(a),t.end()}})(),t}async F(f,n){const r=await this.resolve(f,{resolveMetadata:!0});if(r.isDirectory)throw new w.FileOperationError((0,g.localize)(11,null,this.ob(f)),0,n);if(typeof n?.etag=="string"&&n.etag!==w.ETAG_DISABLED&&n.etag===r.etag)throw new w.NotModifiedSinceFileOperationError((0,g.localize)(12,null),r,n);return this.G(f,r.size,n),r}G(f,n,r){if(r?.limits){let t;if(typeof r.limits.memory=="number"&&n>r.limits.memory&&(t=9),typeof r.limits.size=="number"&&n>r.limits.size&&(t=7),typeof t=="number")throw new w.FileOperationError((0,g.localize)(13,null,this.ob(f)),t)}}async canMove(f,n,r){return this.H(f,n,"move",r)}async canCopy(f,n,r){return this.H(f,n,"copy",r)}async H(f,n,r,t){if(f.toString()!==n.toString())try{const a=r==="move"?this.mb(await this.l(f),f):await this.k(f),s=this.mb(await this.l(n),n);await this.M(a,f,s,n,r,t)}catch(a){return a}return!0}async move(f,n,r){const t=this.mb(await this.l(f),f),a=this.mb(await this.l(n),n),s=await this.I(t,f,a,n,"move",!!r),l=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new w.FileOperationEvent(f,s==="move"?2:3,l)),l}async copy(f,n,r){const t=await this.k(f),a=this.mb(await this.l(n),n),s=await this.I(t,f,a,n,"copy",!!r),l=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new w.FileOperationEvent(f,s==="copy"?3:2,l)),l}async I(f,n,r,t,a,s){if(n.toString()===t.toString())return a;const{exists:l,isSameResourceWithDifferentPathCase:o}=await this.M(f,n,r,t,a,s);if(l&&!o&&s&&await this.del(t,{recursive:!0}),await this.P(r,this.N(r).providerExtUri.dirname(t)),a==="copy"){if(f===r&&(0,w.hasFileFolderCopyCapability)(f))await f.copy(n,t,{overwrite:s});else{const y=await this.resolve(n);y.isDirectory?await this.L(f,y,r,t):await this.J(f,n,r,t)}return a}else return f===r?(await f.rename(n,t,{overwrite:s}),a):(await this.I(f,n,r,t,"copy",s),await this.del(n,{recursive:!0}),"copy")}async J(f,n,r,t){if((0,w.hasOpenReadWriteCloseCapability)(f)&&(0,w.hasOpenReadWriteCloseCapability)(r))return this.fb(f,n,r,t);if((0,w.hasOpenReadWriteCloseCapability)(f)&&(0,w.hasReadWriteCapability)(r))return this.lb(f,n,r,t);if((0,w.hasReadWriteCapability)(f)&&(0,w.hasOpenReadWriteCloseCapability)(r))return this.jb(f,n,r,t);if((0,w.hasReadWriteCapability)(f)&&(0,w.hasReadWriteCapability)(r))return this.hb(f,n,r,t)}async L(f,n,r,t){await r.mkdir(t),Array.isArray(n.children)&&await i.Promises.settled(n.children.map(async a=>{const s=this.N(r).providerExtUri.joinPath(t,a.name);return a.isDirectory?this.L(f,await this.resolve(a.resource),r,s):this.J(f,a.resource,r,s)}))}async M(f,n,r,t,a,s){let l=!1;if(f===r){const{providerExtUri:y,isPathCaseSensitive:C}=this.N(f);if(C||(l=y.isEqual(n,t)),l&&a==="copy")throw new Error((0,g.localize)(14,null,this.ob(n),this.ob(t)));if(!l&&y.isEqualOrParent(t,n))throw new Error((0,g.localize)(15,null,this.ob(n),this.ob(t)))}const o=await this.exists(t);if(o&&!l){if(!s)throw new w.FileOperationError((0,g.localize)(16,null,this.ob(n),this.ob(t)),4);if(f===r){const{providerExtUri:y}=this.N(f);if(y.isEqualOrParent(n,t))throw new Error((0,g.localize)(17,null,this.ob(n),this.ob(t)))}}return{exists:o,isSameResourceWithDifferentPathCase:l}}N(f){const n=this.O(f);return{providerExtUri:n?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:n}}O(f){return!!(f.capabilities&1024)}async createFolder(f){const n=this.mb(await this.j(f),f);await this.P(n,f);const r=await this.resolve(f,{resolveMetadata:!0});return this.m.fire(new w.FileOperationEvent(f,0,r)),r}async P(f,n){const r=[],{providerExtUri:t}=this.N(f);for(;!t.isEqual(n,t.dirname(n));)try{if(((await f.stat(n)).type&w.FileType.Directory)===0)throw new Error((0,g.localize)(18,null,this.ob(n)));break}catch(a){if((0,w.toFileSystemProviderErrorCode)(a)!==w.FileSystemProviderErrorCode.FileNotFound)throw a;r.push(t.basename(n)),n=t.dirname(n)}for(let a=r.length-1;a>=0;a--){n=t.joinPath(n,r[a]);try{await f.mkdir(n)}catch(s){if((0,w.toFileSystemProviderErrorCode)(s)!==w.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(f,n){try{await this.Q(f,n)}catch(r){return r}return!0}async Q(f,n){const r=this.mb(await this.j(f),f);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,g.localize)(19,null,this.ob(f)));let a;try{a=await r.stat(f)}catch{}if(a)this.nb(f,a);else throw new w.FileOperationError((0,g.localize)(20,null,this.ob(f)),1);if(!!!n?.recursive){const l=await this.resolve(f);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,g.localize)(21,null,this.ob(f)))}return r}async del(f,n){const r=await this.Q(f,n),t=!!n?.useTrash,a=!!n?.recursive;await r.delete(f,{recursive:a,useTrash:t}),this.m.fire(new w.FileOperationEvent(f,1))}async cloneFile(f,n){const r=await this.j(f),t=this.mb(await this.l(n),n);if(r===t&&this.N(r).providerExtUri.isEqual(f,n))return;if(r===t&&(0,w.hasFileCloneCapability)(r))return r.cloneFile(f,n);await this.P(t,this.N(t).providerExtUri.dirname(n));const a=this.X.queueFor(f,this.N(r).providerExtUri);return r===t&&(0,w.hasFileFolderCopyCapability)(r)?a.queue(()=>r.copy(f,n,{overwrite:!0})):a.queue(()=>this.J(r,f,t,n))}watch(f,n={recursive:!1,excludes:[]}){const r=new S.DisposableStore;let t=!1,a=()=>{t=!0};return r.add((0,S.toDisposable)(()=>a())),(async()=>{try{const s=await this.W(f,n);t?(0,S.dispose)(s):a=()=>(0,S.dispose)(s)}catch(s){this.b.error(s)}})(),r}async W(f,n){const r=await this.j(f),t=(0,P.hash)([this.N(r).providerExtUri.getComparisonKey(f),n]);let a=this.U.get(t);return a||(a={count:0,disposable:r.watch(f,n)},this.U.set(t,a)),a.count+=1,(0,S.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,S.dispose)(a.disposable),this.U.delete(t)))})}dispose(){super.dispose();for(const[,f]of this.U)(0,S.dispose)(f.disposable);this.U.clear()}async Y(f,n,r,t){return this.X.queueFor(n,this.N(f).providerExtUri).queue(async()=>{const a=await f.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,d.isReadableStream)(t)||(0,d.isReadableBufferedStream)(t)?await this.ab(f,a,t):await this.bb(f,a,t)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await f.close(a)}})}async ab(f,n,r){let t=0,a;if((0,d.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=D.VSBuffer.concat(r.buffer);await this.cb(f,n,s,s.byteLength,t,0),t+=s.byteLength}if(r.ended)return;a=r.stream}else a=r;return new Promise((s,l)=>{(0,d.listenStream)(a,{onData:async o=>{a.pause();try{await this.cb(f,n,o,o.byteLength,t,0)}catch(y){return l(y)}t+=o.byteLength,setTimeout(()=>a.resume())},onError:o=>l(o),onEnd:()=>s()})})}async bb(f,n,r){let t=0,a;for(;(a=r.read())!==null;)await this.cb(f,n,a,a.byteLength,t,0),t+=a.byteLength}async cb(f,n,r,t,a,s){let l=0;for(;l<t;)l+=await f.write(n,a+l,r.buffer,s+l,t-l)}async db(f,n,r,t){return this.X.queueFor(n,this.N(f).providerExtUri).queue(()=>this.eb(f,n,r,t))}async eb(f,n,r,t){let a;t instanceof D.VSBuffer?a=t:(0,d.isReadableStream)(t)?a=await(0,D.streamToBuffer)(t):(0,d.isReadableBufferedStream)(t)?a=await(0,D.bufferedStreamToBuffer)(t):a=(0,D.readableToBuffer)(t),await f.writeFile(n,a.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async fb(f,n,r,t){return this.X.queueFor(t,this.N(r).providerExtUri).queue(()=>this.gb(f,n,r,t))}async gb(f,n,r,t){let a,s;try{a=await f.open(n,{create:!1}),s=await r.open(t,{create:!0,unlock:!1});const l=D.VSBuffer.alloc(this.a);let o=0,y=0,C=0;do C=await f.read(a,o,l.buffer,y,l.byteLength-y),await this.cb(r,s,l,C,o,y),o+=C,y+=C,y===l.byteLength&&(y=0);while(C>0)}catch(l){throw(0,w.ensureFileSystemProviderError)(l)}finally{await i.Promises.settled([typeof a=="number"?f.close(a):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async hb(f,n,r,t){return this.X.queueFor(t,this.N(r).providerExtUri).queue(()=>this.ib(f,n,r,t))}async ib(f,n,r,t){return r.writeFile(t,await f.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async jb(f,n,r,t){return this.X.queueFor(t,this.N(r).providerExtUri).queue(()=>this.kb(f,n,r,t))}async kb(f,n,r,t){const a=await r.open(t,{create:!0,unlock:!1});try{const s=await f.readFile(n);await this.cb(r,a,D.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await r.close(a)}}async lb(f,n,r,t){const a=await(0,D.streamToBuffer)(this.C(f,n,k.CancellationToken.None));await this.db(r,t,void 0,a)}mb(f,n){if(f.capabilities&2048)throw new w.FileOperationError((0,g.localize)(22,null,this.ob(n)),6);return f}nb(f,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,g.localize)(23,null,this.ob(f)),6)}ob(f){return f.scheme===b.Schemas.file?f.fsPath:f.toString(!0)}};c=pe([K(0,m.ILogService)],c),e.FileService=c}),define(re[208],ae([0,1,53,287,6,37,17,3,48,2,12,5,20,43,28,166,14,100,205,38,200,199]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u,m,c,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,i.gracefulify)(R)}catch(r){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(r)}`)}})();class n extends m.AbstractDiskFileSystemProvider{constructor(t,a){super(t,a),this.onDidChangeCapabilities=P.Event.None,this.I=new k.ResourceMap(s=>v.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.M=new Map,this.N=new Map,this.O=new Map}get capabilities(){return this.G||(this.G=57374,b.isLinux&&(this.G|=1024)),this.G}async stat(t){try{const{stat:a,symbolicLink:s}=await d.SymlinkSupport.stat(this.D(t));return{type:this.H(a,s),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.ab(a)}}async readdir(t){try{const a=await d.Promises.readdir(this.D(t),{withFileTypes:!0}),s=[];return await Promise.all(a.map(async l=>{try{let o;l.isSymbolicLink()?o=(await this.stat((0,v.joinPath)(t,l.name))).type:o=this.H(l),s.push([l.name,o])}catch(o){this.a.trace(o)}})),s}catch(a){throw this.ab(a)}}H(t,a){let s;return a?.dangling?s=w.FileType.Unknown:t.isFile()?s=w.FileType.File:t.isDirectory()?s=w.FileType.Directory:s=w.FileType.Unknown,a&&(s|=w.FileType.SymbolicLink),s}async J(t){const a=this.D(t);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let s;for(;s=this.I.get(t);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await s.wait();const l=new D.Barrier;return this.I.set(t,l),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,S.toDisposable)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.I.get(t)===l&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.I.delete(t)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),l.open()})}async readFile(t,a){let s;try{a?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.D(t)})`),s=await this.J(t));const l=this.D(t);return await d.Promises.readFile(l)}catch(l){throw this.ab(l)}finally{s?.dispose()}}L(t){n.F&&this.a.trace(t)}readFileStream(t,a,s){const l=(0,p.newWriteableStream)(o=>L.VSBuffer.concat(o.map(y=>L.VSBuffer.wrap(y))).buffer);return(0,u.readFileIntoStream)(this,t,l,o=>o.buffer,{...a,bufferSize:256*1024},s),l}async writeFile(t,a,s){let l;try{const o=this.D(t);if(!s.create||!s.overwrite){if(await d.Promises.exists(o)){if(!s.overwrite)throw(0,w.createFileSystemProviderError)((0,g.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,w.createFileSystemProviderError)((0,g.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(l,0,a,0,a.byteLength)}catch(o){throw await this.bb(t,o)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(t){n.P=t}async open(t,a){const s=this.D(t);let l;(0,w.isFileOpenForWriteOptions)(a)&&(l=await this.J(t));let o;try{if((0,w.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:C}=await d.SymlinkSupport.stat(s);C.mode&128||await d.Promises.chmod(s,C.mode|128)}catch(C){this.a.trace(C)}let y;if((0,w.isFileOpenForWriteOptions)(a)){if(b.isWindows)try{await d.Promises.truncate(s,0),y="r+"}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}y||(y="w")}else y="r";o=await d.Promises.open(s,y)}catch(y){throw l?.dispose(),(0,w.isFileOpenForWriteOptions)(a)?await this.bb(t,y):this.ab(y)}if(this.M.set(o,0),(0,w.isFileOpenForWriteOptions)(a)&&this.O.set(o,t),l){const y=this.N.get(o);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${s})`),this.N.set(o,l),y&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${s})`),y.dispose())}return o}async close(t){const a=this.N.get(t);try{if(this.M.delete(t),this.O.delete(t)&&n.P)try{await d.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await d.Promises.close(t)}catch(s){throw this.ab(s)}finally{a&&(this.N.get(t)===a&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.N.delete(t)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),a.dispose())}}async read(t,a,s,l,o){const y=this.Q(t,a);let C=null;try{C=(await d.Promises.read(t,s,l,o,y)).bytesRead}catch(T){throw this.ab(T)}finally{this.R(t,y,C)}return C}Q(t,a){return a===this.M.get(t)?null:a}R(t,a,s){const l=this.M.get(t);typeof l=="number"&&(typeof a=="number"||(typeof s=="number"?this.M.set(t,l+s):this.M.delete(t)))}async write(t,a,s,l,o){return(0,D.retry)(()=>this.S(t,a,s,l,o),100,3)}async S(t,a,s,l,o){const y=this.Q(t,a);let C=null;try{C=(await d.Promises.write(t,s,l,o,y)).bytesWritten}catch(T){throw await this.bb(this.O.get(t),T)}finally{this.R(t,y,C)}return C}async mkdir(t){try{await d.Promises.mkdir(this.D(t))}catch(a){throw this.ab(a)}}async delete(t,a){try{const s=this.D(t);a.recursive?await d.Promises.rm(s,d.RimRafMode.MOVE):await d.Promises.unlink(s)}catch(s){throw this.ab(s)}}async rename(t,a,s){const l=this.D(t),o=this.D(a);if(l!==o)try{await this.U(t,a,"move",s.overwrite),await d.Promises.move(l,o)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,g.localize)(2,null,(0,E.basename)(l),(0,E.basename)((0,E.dirname)(o)),y.toString()))),this.ab(y)}}async copy(t,a,s){const l=this.D(t),o=this.D(a);if(l!==o)try{await this.U(t,a,"copy",s.overwrite),await d.Promises.copy(l,o,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,g.localize)(3,null,(0,E.basename)(l),(0,E.basename)((0,E.dirname)(o)),y.toString()))),this.ab(y)}}async U(t,a,s,l){const o=this.D(t),y=this.D(a);let C=!1;if(!!(this.capabilities&1024)||(C=(0,I.isEqual)(o,y,!0)),C&&s==="copy")throw(0,w.createFileSystemProviderError)((0,g.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!C&&await d.Promises.exists(y)){if(!l)throw(0,w.createFileSystemProviderError)((0,g.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}async cloneFile(t,a){return this.W(t,a,!1)}async W(t,a,s){const l=this.D(t),o=this.D(a),y=!!(this.capabilities&1024);if((0,I.isEqual)(l,o,!y))return;const C=new S.DisposableStore;try{const[T,W]=await Promise.all([this.J(t),this.J(a)]);C.add(T),C.add(W),s&&await d.Promises.mkdir((0,E.dirname)(o),{recursive:!0}),await d.Promises.copyFile(l,o)}catch(T){if(T.code==="ENOENT"&&!s)return this.W(t,a,!0);throw this.ab(T)}finally{C.dispose()}}p(t,a,s){return new h.UniversalWatcherClient(l=>t(l),l=>a(l),s)}y(t,a,s){return new f.NodeJSWatcherClient(l=>t(l),l=>a(l),s)}ab(t){if(t instanceof w.FileSystemProviderError)return t;let a;switch(t.code){case"ENOENT":a=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=w.FileSystemProviderErrorCode.NoPermissions;break;default:a=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(t,a)}async bb(t,a){let s=this.ab(a);if(t&&s.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await d.SymlinkSupport.stat(this.D(t));l.mode&128||(s=(0,w.createFileSystemProviderError)(a,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return s}}e.DiskFileSystemProvider=n,n.F=!1,n.P=!0}),define(re[101],ae([0,1,6,3,2,4,7]),function(_,e,R,i,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,k.createDecorator)("lifecycleSharedProcessService");let P=class extends D.Disposable{constructor(S){super(),this.c=S,this.a=void 0,this.b=this.B(new i.Emitter),this.onWillShutdown=this.b.event}fireOnWillShutdown(){if(this.a)return this.a;this.c.trace("Lifecycle#onWillShutdown.fire()");const S=[];return this.b.fire({join(E){S.push(E)}}),this.a=(async()=>{try{await R.Promises.settled(S)}catch(E){this.c.error(E)}})(),this.a}};P=pe([K(0,L.ILogService)],P),e.SharedProcessLifecycleService=P}),define(re[102],ae([0,1,3,8,7]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(v,p){this.a=v,this.b=p,this.onDidChangeLogLevel=R.Event.buffer(v.onDidChangeLogLevel,!0)}listen(v,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(v,p,d){switch(p){case"setLevel":return d[1]?this.b.setLevel(i.URI.revive(d[1]),d[0]):this.a.setLevel(d[0])}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=k;class L{constructor(v){this.a=v}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(v,p){L.setLevel(this.a,v,p)}static setLevel(v,p,d){return v.call("setLevel",[p,d])}}e.LogLevelChannelClient=L;class P{constructor(v){this.b=v,this.a=new Map}listen(v,p){throw new Error(`Event not found: ${p}`)}async call(v,p,d){switch(p){case"createLogger":this.c(i.URI.revive(d[0]),d[1]);return;case"log":return this.e(i.URI.revive(d[0]),d[1]);case"consoleLog":return this.d(d[0],d[1])}throw new Error(`Call not found: ${p}`)}c(v,p){this.a.set(v.toString(),this.b.createLogger(v,p))}d(v,p){let d=console.log;switch(v){case D.LogLevel.Error:d=console.error;break;case D.LogLevel.Warning:d=console.warn;break;case D.LogLevel.Info:d=console.info;break}d.call(console,...p)}e(v,p){const d=this.a.get(v.toString());if(!d)throw new Error("Create the logger before logging");for(const[g,w]of p)(0,D.log)(d,g,w)}}e.LoggerChannel=P;class I extends D.AbstractLoggerService{constructor(v,p,d){super(v,p),this.g=d}createConsoleMainLogger(){return new D.AdapterLogger({log:(v,p)=>{this.g.call("consoleLog",[v,p])}})}f(v,p,d){return new S(this.g,v,p,d)}}e.LoggerChannelClient=I;class S extends D.AbstractMessageLogger{constructor(v,p,d,g){super(g?.always),this.l=v,this.m=p,this.j=!1,this.k=[],this.setLevel(d),this.l.call("createLogger",[p,g]).then(()=>{this.p(this.k),this.j=!0})}f(v,p){const d=[[v,p]];this.j?this.p(d):this.k.push(...d)}p(v){this.l.call("log",[this.m,v])}}class E extends D.LogService{constructor(v,p){super(p),this.c=v,this.B(v.onDidChangeLogLevel(d=>p.setLevel(d)))}setLevel(v){super.setLevel(v),this.c.setLevel(v)}}e.FollowerLogService=E}),define(re[58],ae([0,1,4]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(re[59],ae([0,1,3,64,2,4]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,k.createDecorator)("policy");class L extends D.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new R.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(S){const E=Object.keys(this.f).length;return this.f={...S,...this.f},E!==Object.keys(this.f).length&&await this.i(S),i.Iterable.reduce(this.g.entries(),(b,[v,p])=>({...b,[v]:p}),{})}getPolicyValue(S){return this.g.get(S)}serialize(){return i.Iterable.reduce(Object.entries(this.f),(S,[E,b])=>({...S,[E]:{definition:b,value:this.g.get(E)}}),{})}}e.AbstractPolicyService=L;class P{constructor(){this.onDidChange=R.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(re[209],ae([0,1,3,2,59]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class k{constructor(I){this.b=I,this.a=new i.DisposableStore}listen(I,S){switch(S){case"onDidChange":return R.Event.map(this.b.onDidChange,E=>E.reduce((b,v)=>({...b,[v]:this.b.getPolicyValue(v)??null}),{}),this.a)}throw new Error(`Event not found: ${S}`)}call(I,S,E){switch(S){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(E)}throw new Error(`Call not found: ${S}`)}dispose(){this.a.dispose()}}e.PolicyChannel=k;class L extends D.AbstractPolicyService{constructor(I,S){super(),this.a=S;for(const E in I){const{definition:b,value:v}=I[E];this.f[E]=b,v!==void 0&&this.g.set(E,v)}this.a.listen("onDidChange")(E=>{for(const b in E){const v=E[b];v===null?this.g.delete(b):this.g.set(b,v)}this.h.fire(Object.keys(E))})}async i(I){const S=await this.a.call("updatePolicyDefinitions",I);for(const E in S)this.g.set(E,S[E])}}e.PolicyChannelClient=L}),define(re[103],ae([0,1,23,5,36,20]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;if(typeof i.globals.vscode<"u"&&typeof i.globals.vscode.context<"u"){const P=i.globals.vscode.context.configuration();if(P)L=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof _?.__$__nodeRequire=="function"){const P=(0,k.dirname)(R.FileAccess.asFileUri(""));if(L=_.__$__nodeRequire((0,k.joinPath)(P,"product.json").fsPath),D.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const I=_.__$__nodeRequire((0,k.joinPath)(P,"package.json").fsPath);Object.assign(L,{version:I.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(re[25],ae([0,1,4]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[210],ae([0,1,6,9,2,12,28,7,25]),function(_,e,R,i,D,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let S=class extends D.Disposable{constructor(b,v,p){super(),this.b=v,this.c=p,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this.B(new R.RunOnceScheduler(()=>{this.f(b)},3e4)).schedule()}async f(b){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const v=Date.now(),p=(0,k.dirname)(b),d=(0,k.basename)(b),g=await L.Promises.readdir(p);await Promise.all(g.map(async w=>{if(w===d)return;const u=(0,k.join)(p,w),m=await L.Promises.stat(u);if(m.isDirectory()&&v-m.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),L.Promises.rm(u)}))}catch(v){(0,i.onUnexpectedError)(v)}}};S=pe([K(1,I.IProductService),K(2,P.ILogService)],S),e.CodeCacheCleaner=S}),define(re[211],ae([0,1,6,9,2,12,28,13,7,25]),function(_,e,R,i,D,k,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let E=class extends D.Disposable{constructor(v,p,d){super(),this.b=v,this.c=p,this.f=d,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new R.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const v=Object.create(null),p=JSON.parse(await L.Promises.readFile((0,k.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const m of Object.keys(p)){const c=p[m];v[`${c.hash}.${m}`]=!0}const d=(0,k.join)(this.b.userDataPath,"clp");if(!await L.Promises.exists(d))return;const w=await L.Promises.readdir(d);for(const m of w){if(v[m]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${m}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${m}`),await L.Promises.rm((0,k.join)(d,m))}const u=Date.now();for(const m of Object.keys(v)){const c=(0,k.join)(d,m),h=await L.Promises.readdir(c);for(const f of h){if(f==="tcf.json")continue;const n=(0,k.join)(c,f),r=await L.Promises.stat(n);r.isDirectory()&&u-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.join)(m,f)}`),await L.Promises.rm(n))}}}catch(v){(0,i.onUnexpectedError)(v)}}};E=pe([K(0,P.INativeEnvironmentService),K(1,I.ILogService),K(2,S.IProductService)],E),e.LanguagePackCachedDataCleaner=E}),define(re[212],ae([0,1,12,4]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,i.createDecorator)("IV8InspectProfilingService");var D;(function(k){function L(I){return Boolean(I.samples&&I.timeDeltas)}k.isValidProfile=L;function P(I,S="noAbsolutePaths"){for(const E of I.nodes)E.callFrame&&E.callFrame.url&&((0,R.isAbsolute)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(E.callFrame.url))&&(E.callFrame.url=(0,R.join)(S,(0,R.basename)(E.callFrame.url)));return I}k.rewriteAbsolutePaths=P})(D=e.Utils||(e.Utils={}))}),define(re[213],ae([0,1,30]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class i{constructor(){this.a=new Map}async startProfiling(k){const P=await(await new Promise((S,E)=>{_(["v8-inspect-profiler"],S,E)})).startProfiling({port:k.port,checkForPaused:!0}),I=(0,R.generateUuid)();return this.a.set(I,P),I}async stopProfiling(k){const L=this.a.get(k);if(!L)throw new Error(`UNKNOWN session '${k}'`);const P=await L.stop();return this.a.delete(k),P.profile}}e.InspectProfilingService=i}),define(re[40],ae([0,1,127,15]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(L,P){R.ok(i.isString(L)),R.ok(i.isObject(P)),R.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,P)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.Registry=new D}),define(re[104],ae([0,1,3,40]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class k{constructor(){this.b=new R.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(I,S){this.a[D(I)]=S,this.b.fire(I)}notifySchemaChanged(I){this.b.fire(I)}getSchemaContributions(){return{schemas:this.a}}}const L=new k;i.Registry.add(e.Extensions.JSONContribution,L)}),define(re[45],ae([0,1,19,3,15,152,16,104,40]),function(_,e,R,i,D,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=I.Registry.as(P.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new i.Emitter,this.onDidSchemaChange=this.i.event,this.j=new i.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const t=this.k(n,r);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const r=this.l(n);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const t=[];t.push(...this.l(r)),t.push(...this.k(n,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,R.distinct)(t)})}registerDefaultConfigurations(n){const r=[],t=[];for(const{overrides:a,source:s}of n)for(const l in a)if(r.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const o=this.a.get(l),y=o?.valuesSources??new Map;if(s)for(const O of Object.keys(a[l]))y.set(O,s);const C={...o?.value||{},...a[l]};this.a.set(l,{source:s,value:C,valuesSources:y});const T=(0,L.getLanguageTagSettingPlainKey)(l),W={type:"object",default:C,description:k.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:C,source:D.isString(s)?void 0:s,defaultValueSource:s};t.push(...g(l)),this.d[l]=W,this.b.properties[l]=W}else{this.a.set(l,{value:a[l],source:s});const o=this.d[l];o&&(this.s(l,o),this.o(l,o))}this.registerOverrideIdentifiers(t),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const r=[];for(const{overrides:t,source:a}of n)for(const s in t){const l=this.a.get(s),o=D.isString(a)?a:a?.id,y=D.isString(l?.source)?l?.source:l?.source?.id;if(o===y)if(r.push(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const C=this.d[s];C&&(this.s(s,C),this.o(s,C))}}this.q(),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){for(const r of n)this.h.add(r);this.q()}k(n,r){const t=[];return n.forEach(a=>{t.push(...this.m(a,r,a.extensionInfo,a.restrictedProperties)),this.c.push(a),this.n(a)}),t}l(n){const r=[],t=a=>{if(a.properties)for(const s in a.properties){r.push(s);const l=this.d[s];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[s],this.p(s,a.properties[s])}a.allOf?.forEach(s=>t(s))};for(const a of n){t(a);const s=this.c.indexOf(a);s!==-1&&this.c.splice(s,1)}return r}m(n,r=!0,t,a,s=3){s=D.isUndefinedOrNull(n.scope)?s:n.scope;const l=[],o=n.properties;if(o)for(const C in o){const T=o[C];if(r&&c(C,T)){delete o[C];continue}if(T.source=t,T.defaultDefaultValue=o[C].default,this.s(C,T),e.OVERRIDE_PROPERTY_REGEX.test(C)?T.scope=void 0:(T.scope=D.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=D.isUndefinedOrNull(T.restricted)?!!a?.includes(C):T.restricted),o[C].hasOwnProperty("included")&&!o[C].included){this.f[C]=o[C],delete o[C];continue}else this.d[C]=o[C],o[C].policy?.name&&this.e.set(o[C].policy.name,C);!o[C].deprecationMessage&&o[C].markdownDeprecationMessage&&(o[C].deprecationMessage=o[C].markdownDeprecationMessage),l.push(C)}const y=n.allOf;if(y)for(const C of y)l.push(...this.m(C,r,t,a,s));return l}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(n){const r=t=>{const a=t.properties;if(a)for(const l in a)this.o(l,a[l]);t.allOf?.forEach(r)};r(n)}o(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.g.properties[n]=r;break}}p(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}q(){for(const n of this.h.values()){const r=`[${n}]`,t={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(r,t),e.allSettings.properties[r]=t,e.applicationSettings.properties[r]=t,e.machineSettings.properties[r]=t,e.machineOverridableSettings.properties[r]=t,e.windowSettings.properties[r]=t,e.resourceSettings.properties[r]=t}this.i.fire()}r(){const n={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}s(n,r){const t=this.a.get(n);let a=t?.value,s=t?.source;D.isUndefined(a)&&(a=r.defaultDefaultValue,s=void 0),D.isUndefined(a)&&(a=u(r.type)),r.default=a,r.defaultValueSource=s}}const p="\\[([^\\]]+)\\]",d=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(f){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let r=d.exec(f);for(;r?.length;){const t=r[1].trim();t&&n.push(t),r=d.exec(f)}}return(0,R.distinct)(n)}e.overrideIdentifiersFromKey=g;function w(f){return f.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=w;function u(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const m=new v;I.Registry.add(e.Extensions.Configuration,m);function c(f,n){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?k.localize(7,null,f):m.getConfigurationProperties()[f]!==void 0?k.localize(8,null,f):n.policy?.name&&m.getPolicyConfigurations().get(n.policy?.name)!==void 0?k.localize(9,null,f,n.policy?.name,m.getPolicyConfigurations().get(n.policy?.name)):null:k.localize(6,null)}e.validateProperty=c;function h(){const f=[],n=m.getConfigurationProperties();for(const r of Object.keys(n))f.push([r,n[r].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=h}),define(re[74],ae([0,1,19,3,35,2,37,32,15,8,16,45,40]),function(_,e,R,i,D,k,L,P,I,S,E,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class p{constructor(r={},t=[],a=[],s){this.c=r,this.d=t,this.f=a,this.raw=s,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(t=>{if(t instanceof p)return t;const a=new d("");return a.parseRaw(t),a.configurationModel});this.g=r.reduce((t,a)=>a===t?a:t.merge(a),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,E.getConfigurationValue)(this.contents,r):this.contents}inspect(r,t){const a=this.rawConfiguration.getValue(r),s=t?this.rawConfiguration.getOverrideValue(r,t):void 0,l=t?this.rawConfiguration.override(t).getValue(r):a;return{value:a,override:s,merged:l}}getOverrideValue(r,t){const a=this.l(t);return a?r?(0,E.getConfigurationValue)(a,r):a:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const a of this.overrides)a.identifiers.includes(r)&&t.push(...a.keys);return R.distinct(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return R.distinct(r)}override(r){let t=this.b.get(r);return t||(t=this.h(r),this.b.set(r,t)),t}merge(...r){const t=P.deepClone(this.contents),a=P.deepClone(this.overrides),s=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const o of r)if(l.push(...o.raw?.length?o.raw:[o]),!o.isEmpty()){this.j(t,o.contents);for(const y of o.overrides){const[C]=a.filter(T=>R.equals(T.identifiers,y.identifiers));C?(this.j(C.contents,y.contents),C.keys.push(...y.keys),C.keys=R.distinct(C.keys)):a.push(P.deepClone(y))}for(const y of o.keys)s.indexOf(y)===-1&&s.push(y)}return new p(t,s,a,l.every(o=>o instanceof p)?void 0:l)}freeze(){return this.a=!0,this}clone(){return new p(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}h(r){const t=this.l(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const a={};for(const s of R.distinct([...Object.keys(this.contents),...Object.keys(t)])){let l=this.contents[s];const o=t[s];o&&(typeof l=="object"&&typeof o=="object"?(l=P.deepClone(l),this.j(l,o)):l=o),a[s]=l}return new p(a,this.keys,this.overrides)}j(r,t){for(const a of Object.keys(t)){if(a in r&&I.isObject(r[a])&&I.isObject(t[a])){this.j(r[a],t[a]);continue}r[a]=P.deepClone(t[a])}}k(r){return this.a&&!Object.isFrozen(r)?P.deepFreeze(r):r}l(r){let t=null,a=null;const s=l=>{l&&(a?this.j(a,l):a=P.deepClone(l))};for(const l of this.overrides)R.equals(l.identifiers,[r])?t=l.contents:l.identifiers.includes(r)&&s(l.contents);return s(t),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,t){this.m(r),(0,E.addToValueTree)(this.contents,r,t,a=>{throw new Error(a)})}removeValue(r){this.n(r)&&(0,E.removeFromValueTree)(this.contents,r)}m(r){let t=this.keys.length;for(let a=0;a<t;a++)r.indexOf(this.keys[a])===0&&(t=a);this.keys.splice(t,1,r)}n(r){const t=this.keys.indexOf(r);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=p;class d{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,t){if(!I.isUndefinedOrNull(r)){const a=this.g(r);this.parseRaw(a,t)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,t){this.a=r;const{contents:a,keys:s,overrides:l,restricted:o,hasExcludedProperties:y}=this.h(r,t);this.b=new p(a,s,l,y?[r]:void 0),this.c=o||[]}g(r){let t={},a=null,s=[];const l=[],o=[];function y(T){Array.isArray(s)?s.push(T):a!==null&&(s[a]=T)}const C={onObjectBegin:()=>{const T={};y(T),l.push(s),s=T,a=null},onObjectProperty:T=>{a=T},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const T=[];y(T),l.push(s),s=T,a=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:y,onError:(T,W,O)=>{o.push({error:T,offset:W,length:O})}};if(r)try{D.visit(r,C),t=s[0]||{}}catch(T){console.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return t}h(r,t){const a=v.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),s=this.j(r,a,!0,t);r=s.raw;const l=(0,E.toValuesTree)(r,C=>console.error(`Conflict in settings file ${this.f}: ${C}`)),o=Object.keys(r),y=this.l(r,C=>console.error(`Conflict in settings file ${this.f}: ${C}`));return{contents:l,keys:o,overrides:y,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}j(r,t,a,s){let l=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:l};const o={},y=[];for(const C in r)if(b.OVERRIDE_PROPERTY_REGEX.test(C)&&a){const T=this.j(r[C],t,!1,s);o[C]=T.raw,l=l||T.hasExcludedProperties,y.push(...T.restricted)}else{const T=t[C],W=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&y.push(C),(W===void 0||s.scopes===void 0||s.scopes.includes(W))&&!(s.skipRestricted&&T?.restricted)?o[C]=r[C]:l=!0}return{raw:o,restricted:y,hasExcludedProperties:l}}l(r,t){const a=[];for(const s of Object.keys(r))if(b.OVERRIDE_PROPERTY_REGEX.test(s)){const l={};for(const o in r[s])l[o]=r[s][o];a.push({identifiers:(0,b.overrideIdentifiersFromKey)(s),keys:Object.keys(l),contents:(0,E.toValuesTree)(l,t)})}return a}}e.ConfigurationModelParser=d;class g extends k.Disposable{constructor(r,t,a,s){super(),this.f=r,this.g=t,this.h=s,this.c=this.B(new i.Emitter),this.onDidChange=this.c.event,this.a=new d(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(a.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(i.Event.any(i.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),i.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&a.isEqual(l.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=g;class w{constructor(r,t,a,s,l,o,y,C,T,W,O,j,F){this.a=r,this.b=t,this.value=a,this.overrideIdentifiers=s,this.c=l,this.d=o,this.f=y,this.g=C,this.h=T,this.j=W,this.k=O,this.l=j,this.m=F}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get A(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class u{constructor(r,t,a,s,l=new p,o=new p,y=new L.ResourceMap,C=new p,T=new L.ResourceMap,W=!0){this.c=r,this.d=t,this.f=a,this.g=s,this.h=l,this.j=o,this.l=y,this.m=C,this.n=T,this.p=W,this.a=null,this.b=new L.ResourceMap,this.q=null}getValue(r,t,a){return this.s(r,t,a).getValue(r)}updateValue(r,t,a={}){let s;a.resource?(s=this.n.get(a.resource),s||(s=new p,this.n.set(a.resource,s))):s=this.m,t===void 0?s.removeValue(r):s.setValue(r,t),a.resource||(this.a=null)}inspect(r,t,a){const s=this.s(r,t,a),l=R.distinct(s.overrides.map(C=>C.identifiers).flat()).filter(C=>s.getOverrideValue(r,C)!==void 0),o=this.w(t.resource,a),y=t.resource?this.n.get(t.resource)||this.m:this.m;return new w(r,t,s.getValue(r),l.length?l:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),a?this.j.freeze():void 0,o?o.freeze():void 0,y.inspect(r,t.overrideIdentifier))}keys(r){const t=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,t){this.l.set(r,t),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const a=[];if(!t){const{added:s,updated:l,removed:o}=h(this.c,r);t=[...s,...l,...o]}for(const s of t)for(const l of(0,b.overrideIdentifiersFromKey)(s)){const o=this.c.getKeysForOverrideIdentifier(l),y=r.getKeysForOverrideIdentifier(l),C=[...y.filter(T=>o.indexOf(T)===-1),...o.filter(T=>y.indexOf(T)===-1),...o.filter(T=>!P.equals(this.c.override(l).getValue(T),r.override(l).getValue(T)))];a.push([l,C])}return this.updateDefaultConfiguration(r),{keys:t,overrides:a}}compareAndUpdatePolicyConfiguration(r){const{added:t,updated:a,removed:s}=h(this.d,r),l=[...t,...a,...s];return l.length&&this.updatePolicyConfiguration(r),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:t,updated:a,removed:s,overrides:l}=h(this.applicationConfiguration,r),o=[...t,...a,...s];return o.length&&this.updateApplicationConfiguration(r),{keys:o,overrides:l}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:a,removed:s,overrides:l}=h(this.localUserConfiguration,r),o=[...t,...a,...s];return o.length&&this.updateLocalUserConfiguration(r),{keys:o,overrides:l}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:a,removed:s,overrides:l}=h(this.remoteUserConfiguration,r),o=[...t,...a,...s];return o.length&&this.updateRemoteUserConfiguration(r),{keys:o,overrides:l}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:a,removed:s,overrides:l}=h(this.workspaceConfiguration,r),o=[...t,...a,...s];return o.length&&this.updateWorkspaceConfiguration(r),{keys:o,overrides:l}}compareAndUpdateFolderConfiguration(r,t){const a=this.r.get(r),{added:s,updated:l,removed:o,overrides:y}=h(a,t),C=[...s,...l,...o];return(C.length||!a)&&this.updateFolderConfiguration(r,t),{keys:C,overrides:y}}compareAndDeleteFolderConfiguration(r){const t=this.r.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:a,updated:s,removed:l,overrides:o}=h(t,void 0);return{keys:[...a,...s,...l],overrides:o}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,t,a){let s=this.t(t,a);return t.overrideIdentifier&&(s=s.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(s=s.merge(this.d)),s}t({resource:r},t){let a=this.u();if(t&&r){const s=t.getFolder(r);s&&(a=this.v(s.uri)||a);const l=this.n.get(r);l&&(a=a.merge(l))}return a}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let t=this.b.get(r);if(!t){const a=this.u(),s=this.l.get(r);s?(t=a.merge(s),this.p&&(t=t.freeze()),this.b.set(r,t)):t=a}return t}w(r,t){if(t&&r){const a=t.getFolder(r);if(a)return this.l.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,t)=>{const{contents:a,overrides:s,keys:l}=this.l.get(t);return r.push([t,{contents:a,overrides:s,keys:l}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(t=>r.add(t)),this.userConfiguration.freeze().keys.forEach(t=>r.add(t)),this.j.freeze().keys.forEach(t=>r.add(t)),this.l.forEach(t=>t.freeze().keys.forEach(a=>r.add(a))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.j.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.l.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a))),[...r.values()]}y(r){const t=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(a=>t.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>t.add(a)),this.j.getKeysForOverrideIdentifier(r).forEach(a=>t.add(a)),this.l.forEach(a=>a.getKeysForOverrideIdentifier(r).forEach(s=>t.add(s))),[...t.values()]}static parse(r){const t=this.A(r.defaults),a=this.A(r.policy),s=this.A(r.application),l=this.A(r.user),o=this.A(r.workspace),y=r.folders.reduce((C,T)=>(C.set(S.URI.revive(T[0]),this.A(T[1])),C),new L.ResourceMap);return new u(t,a,s,l,new p,o,y,new p,new L.ResourceMap,!1)}static A(r){return new p(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=u;function m(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,t=new Map;for(const s of n)s.keys.forEach(l=>r.add(l)),s.overrides.forEach(([l,o])=>{const y=(0,L.getOrSet)(t,l,new Set);o.forEach(C=>y.add(C))});const a=[];return t.forEach((s,l)=>a.push([l,[...s.values()]])),{keys:[...r.values()],overrides:a}}e.mergeChanges=m;class c{constructor(r,t,a,s){this.change=r,this.b=t,this.c=a,this.d=s,this.f=void 0;const l=new Set;r.keys.forEach(y=>l.add(y)),r.overrides.forEach(([,y])=>y.forEach(C=>l.add(C))),this.affectedKeys=[...l.values()];const o=new p;this.affectedKeys.forEach(y=>o.setValue(y,{})),this.a=o.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=u.parse(this.b.data)),this.f}affectsConfiguration(r,t){if(this.g(this.a,r)){if(t){const a=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.b?.workspace):void 0,s=this.c.getValue(r,t,this.d);return!P.equals(a,s)}return!0}return!1}g(r,t){let a=(0,E.toValuesTree)({[t]:!0},()=>{}),s;for(;typeof a=="object"&&(s=Object.keys(a)[0]);){if(r=r[s],!r)return!1;a=a[s]}return!0}}e.ConfigurationChangeEvent=c;function h(n,r){const{added:t,removed:a,updated:s}=f(r?.rawConfiguration,n?.rawConfiguration),l=[],o=n?.getAllOverrideIdentifiers()||[],y=r?.getAllOverrideIdentifiers()||[];if(r){const C=y.filter(T=>!o.includes(T));for(const T of C)l.push([T,r.getKeysForOverrideIdentifier(T)])}if(n){const C=o.filter(T=>!y.includes(T));for(const T of C)l.push([T,n.getKeysForOverrideIdentifier(T)])}if(r&&n){for(const C of o)if(y.includes(C)){const T=f({contents:n.getOverrideValue(void 0,C)||{},keys:n.getKeysForOverrideIdentifier(C)},{contents:r.getOverrideValue(void 0,C)||{},keys:r.getKeysForOverrideIdentifier(C)});l.push([C,[...T.added,...T.removed,...T.updated]])}}return{added:t,removed:a,updated:s,overrides:l}}function f(n,r){const t=n?r?n.keys.filter(l=>r.keys.indexOf(l)===-1):[...n.keys]:[],a=r?n?r.keys.filter(l=>n.keys.indexOf(l)===-1):[...r.keys]:[],s=[];if(n&&r){for(const l of r.keys)if(n.keys.indexOf(l)!==-1){const o=(0,E.getConfigurationValue)(r.contents,l),y=(0,E.getConfigurationValue)(n.contents,l);P.equals(o,y)||s.push(l)}}return{added:t,removed:a,updated:s}}}),define(re[214],ae([0,1,19,3,2,32,15,16,74,45,7,59,40]),function(_,e,R,i,D,k,L,P,I,S,E,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class p extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new i.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new d(this.f())),this.b}async initialize(){return this.b=void 0,this.B(v.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:c})=>this.c(m,c))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(m,c){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}}e.DefaultConfiguration=p;class d extends I.ConfigurationModel{constructor(m={}){const c=v.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(c),f=Object.create(null),n=[];for(const r in c){const t=m[r],a=t!==void 0?t:c[r].default;(0,P.addToValueTree)(f,r,a,s=>console.error(`Conflict in default settings: ${s}`))}for(const r of Object.keys(f))S.OVERRIDE_PROPERTY_REGEX.test(r)&&n.push({identifiers:(0,S.overrideIdentifiersFromKey)(r),keys:Object.keys(f[r]),contents:(0,P.toValuesTree)(f[r],t=>console.error(`Conflict in default settings file: ${t}`))});super(f,h,n)}}e.DefaultConfigurationModel=d;class g{constructor(){this.onDidChangeConfiguration=i.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let w=class extends D.Disposable{get configurationModel(){return this.b}constructor(m,c,h){super(),this.c=m,this.f=c,this.g=h,this.a=this.B(new i.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new I.ConfigurationModel}async initialize(){return this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.i(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.j(await this.h(m),!0))),this.b}async h(m){const c={},h=[],f=v.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(const n of m){const r=f[n];if(!r){h.push(n);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.g.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}h.push(n),c[r.policy.name]={type:r.type}}}return(0,L.isEmptyObject)(c)||await this.f.updatePolicyDefinitions(c),h}i(m){const c=v.Registry.as(S.Extensions.Configuration).getPolicyConfigurations(),h=(0,R.coalesce)(m.map(f=>c.get(f)));this.j(h,!0)}j(m,c){const h=v.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),f=[],n=this.b.isEmpty();for(const r of m){const t=h[r]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(n?a!==void 0:!(0,k.equals)(this.b.getValue(r),a))&&f.push([r,a])}else this.b.getValue(r)!==void 0&&f.push([r,void 0])}if(f.length){const r=this.b;this.b=new I.ConfigurationModel;for(const t of r.keys)this.b.setValue(t,r.getValue(t));for(const[t,a]of f)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);c&&this.a.fire(this.b)}}};w=pe([K(1,b.IPolicyService),K(2,E.ILogService)],w),e.PolicyConfiguration=w}),define(re[215],ae([0,1,6,3,2,20,16,74,214,59]),function(_,e,R,i,D,k,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class E extends D.Disposable{constructor(v,p,d,g){super(),this.i=v,this.h=this.B(new i.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new I.DefaultConfiguration),this.c=d instanceof S.NullPolicyService?new I.NullPolicyConfiguration:this.B(new I.PolicyConfiguration(this.b,d,g)),this.f=this.B(new P.UserSettings(this.i,void 0,k.extUriBiasedIgnorePathCase,p)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:w,properties:u})=>this.k(w,u))),this.B(this.c.onDidChangeConfiguration(w=>this.l(w))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[v,p,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(v,p,new P.ConfigurationModel,d)}getConfigurationData(){return this.a.toData()}getValue(v,p){const d=typeof v=="string"?v:void 0,g=(0,L.isConfigurationOverrides)(v)?v:(0,L.isConfigurationOverrides)(p)?p:{};return this.a.getValue(d,g,void 0)}updateValue(v,p,d,g){return Promise.reject(new Error("not supported"))}inspect(v){return this.a.inspect(v,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const v=await this.f.loadConfiguration();this.j(v)}j(v){const p=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(v);this.m(d,p,2)}k(v,p){const d=this.a.toData(),g=this.a.compareAndUpdateDefaultConfiguration(v,p);this.m(g,d,7)}l(v){const p=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(v);this.m(d,p,7)}m(v,p,d){const g=new P.ConfigurationChangeEvent(v,{data:p},this.a);g.source=d,g.sourceConfig=this.n(d),this.h.fire(g)}n(v){switch(v){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=E}),define(re[216],ae([0,1,9,4]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var D;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends R.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof k&&P._code===D.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof k&&P._code===D.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof k&&P._code===D.NoResolverFound}static isHandled(P){return P instanceof k&&P.isHandled}constructor(P,I=D.Unknown,S){super(P),this._message=P,this._code=I,this._detail=S,this.isHandled=I===D.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}}e.RemoteAuthorityResolverError=k}),define(re[105],ae([0,1,23]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function i(S){return S.scheme===R.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=i;function D(S){if(!S)return;const E=S.indexOf("+");return E<0?S:S.substr(0,E)}e.getRemoteName=D;function k(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=k;function L(S){const{host:E,port:b}=I(S);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:E,port:b}}e.parseAuthorityWithPort=L;function P(S,E){let{host:b,port:v}=I(S);return typeof v>"u"&&(v=E),{host:b,port:v}}e.parseAuthorityWithOptionalPort=P;function I(S){const E=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const b=S.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const v=S.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:S,port:void 0}}}),define(re[46],ae([0,1,27,4,105]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=k;function L(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var I;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(I=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(g){this.value=g,this.c=g.toLowerCase()}static equals(g,w){if(typeof g>"u"||g===null)return typeof w>"u"||w===null;if(typeof w>"u"||w===null)return!1;if(typeof g=="string"||typeof w=="string"){const u=typeof g=="string"?g:g.value,m=typeof w=="string"?w:w.value;return R.equalsIgnoreCase(u,m)}return g.c===w.c}static toKey(g){return typeof g=="string"?g.toLowerCase():g.c}}e.ExtensionIdentifier=S;function E(d){return b(d)}e.isApplicationScopedExtension=E;function b(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function v(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function p(d,g){if(g){const w=`onResolveRemoteAuthority:${(0,D.getRemoteName)(g)}`;return d.activationEvents?.indexOf(w)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[33],ae([0,1,27,29,46,5,8,9,36]),function(_,e,R,i,D,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function S(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,R.compareIgnoreCase)(r.id,t.id)===0}e.areSameExtensions=S;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(t){const a=t.manifest?t.manifest.version:t.version,s=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new b(t.identifier,a,s)}static parse(t){const a=E.exec(t);return a&&a[1]&&a[2]?new b({id:a[1]},a[2],a[4]||void 0):null}constructor(t,a,s="undefined"){this.version=a,this.targetPlatform=s,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof b?S(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=b;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(r){const t=v.exec(r);return t&&t[1]?[g(t[1]),t[2]]:[g(r),void 0]}e.getIdAndVersion=p;function d(r,t){return`${r}.${t}`}e.getExtensionId=d;function g(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=g;function w(r,t){return g(d(r,t))}e.getGalleryExtensionId=w;function u(r,t){const a=[],s=l=>{for(const o of a)if(o.some(y=>S(t(y),t(l))))return o;return null};for(const l of r){const o=s(l);o?o.push(l):a.push([l])}return a}e.groupByExtension=u;function m(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=m;function c(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=c,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function h(r,t){const a=[],s=t.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const l=s.shift();if(l&&a.every(o=>!S(o.identifier,{id:l}))){const o=r.filter(y=>S(y.identifier,{id:l}));o.length===1&&(a.push(o[0]),s.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=h;async function f(r,t){if(!k.isLinux)return!1;let a;try{a=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){t.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(l))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=f;async function n(r,t){const a=await f(r,t),s=(0,i.getTargetPlatform)(a?"alpine":k.platform,I.arch);return t.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=n}),define(re[60],ae([0,1,6,17,2,3,37,8,33,14,4,7]),function(_,e,R,i,D,k,L,P,I,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let v=class extends D.Disposable{constructor(d,g){super(),this.h=d,this.i=g,this.a=this.B(new k.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new k.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new k.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new k.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new L.ResourceMap}scanProfileExtensions(d){return this.j(d)}async addExtensionsToProfile(d,g){const w=[],u=[];try{return await this.j(g,m=>{const c=[];for(const h of m)d.some(([f])=>(0,I.areSameExtensions)(f.identifier,h.identifier)&&f.manifest.version!==h.version)?w.push(h):c.push(h);for(const[h,f]of d)if(!c.some(n=>(0,I.areSameExtensions)(n.identifier,h.identifier)&&n.version===h.manifest.version)){const n={identifier:h.identifier,version:h.manifest.version,location:h.location,metadata:f};u.push(n),c.push(n)}return u.length&&this.a.fire({extensions:u,profileLocation:g}),w.length&&this.c.fire({extensions:w,profileLocation:g}),c}),u.length&&this.b.fire({extensions:u,profileLocation:g}),w.length&&this.f.fire({extensions:w,profileLocation:g}),u}catch(m){throw u.length&&this.b.fire({extensions:u,error:m,profileLocation:g}),w.length&&this.f.fire({extensions:w,error:m,profileLocation:g}),m}}async removeExtensionFromProfile(d,g){const w=[];this.c.fire({extensions:w,profileLocation:g});try{await this.j(g,u=>{const m=[];for(const c of u)(0,I.areSameExtensions)(c.identifier,d.identifier)?w.push(c):m.push(c);return w.length&&this.c.fire({extensions:w,profileLocation:g}),m}),w.length&&this.f.fire({extensions:w,profileLocation:g})}catch(u){throw w.length&&this.f.fire({extensions:w,error:u,profileLocation:g}),u}}async j(d,g){return this.k(d).queue(async()=>{let w=[];try{const u=await this.h.readFile(d),m=JSON.parse(u.value.toString());for(const c of m){if(!c.identifier){this.i.info("Ignoring invalid extension while scanning. Identifier does not exist.",c);continue}if(!c.location){this.i.info("Ignoring invalid extension while scanning. Location does not exist.",c);continue}if(!c.version){this.i.info("Ignoring invalid extension while scanning. Version does not exist.",c);continue}w.push({identifier:c.identifier,location:P.URI.revive(c.location),version:c.version,metadata:c.metadata})}}catch(u){u.fileOperationResult!==1&&this.i.error(u)}if(g){w=g(w);const u=w.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),metadata:m.metadata}));await this.h.writeFile(d,i.VSBuffer.fromString(JSON.stringify(u)))}return w})}k(d){let g=this.g.get(d);return g||(g=new R.Queue,this.g.set(d,g)),g}};v=pe([K(0,S.IFileService),K(1,b.ILogService)],v),e.ExtensionsProfileScannerService=v}),define(re[217],ae([0,1,22,33]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function D(k,L,P,I,S){try{const E=await k.getExtensionsControlManifest();if(!E.deprecated)return;const b=await k.getInstalled(1);for(const[v,p]of Object.entries(E.deprecated)){if(!p?.extension)continue;const{id:d,autoMigrate:g,preRelease:w}=p.extension;if(!g)continue;const u=b.find(c=>(0,i.areSameExtensions)(c.identifier,{id:v}));if(!u)continue;const m=(await L.getExtensions([{id:d,preRelease:w}],{targetPlatform:await k.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!m){S.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{S.info(`Migrating '${u.identifier.id}' extension to '${d}' extension...`);const c=!I.getDisabledExtensions().some(f=>(0,i.areSameExtensions)(f,u.identifier));await k.uninstall(u),S.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let h=b.find(f=>(0,i.areSameExtensions)(f.identifier,{id:d}));(!h||!h.isPreReleaseVersion&&c)&&(h=await k.installFromGallery(m,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),S.info(`Installed the pre-release extension '${h.identifier.id}'`),c||(await I.disableExtension(h.identifier),S.info(`Disabled the pre-release extension '${h.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),g.storage&&(P.addToMigrationList((0,i.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,i.getExtensionId)(h.manifest.publisher,h.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${u.identifier.id}' extension to '${d}' extension.`)}catch(c){S.error(c)}}}catch(E){S.error(E)}}e.migrateUnsupportedExtensions=D}),define(re[218],ae([0,1,6,9,2,23,5,20,54,30,28,16,13,29,33,97,14,7]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let m=class yt extends D.Disposable{constructor(h,f,n,r,t,a){super(),this.h=f,this.i=n,this.j=r,this.k=t,this.l=a,this.extensionsDownloadDir=h.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(h,f){await this.g;const n=(0,P.joinPath)(this.extensionsDownloadDir,this.u(h));try{await this.n(h,n,t=>this.i.download(h,t,f))}catch(t){throw new p.ExtensionManagementError(t.message,p.ExtensionManagementErrorCode.Download)}let r=!1;if(h.isSigned&&this.j.getValue("extensions.verifySignature")===!0){const t=await this.m(h);try{r=await this.k.verify(n.fsPath,t.fsPath),this.l.info(`Verified extension: ${h.identifier.id}`,r)}catch(a){throw await this.delete(t),await this.delete(n),new p.ExtensionManagementError(a.code,p.ExtensionManagementErrorCode.Signature)}}return{location:n,verified:r}}async m(h){await this.g;const f=(0,P.joinPath)(this.extensionsDownloadDir,`${this.u(h)}${yt.c}`);return await this.n(h,f,n=>this.i.downloadSignatureArchive(h,n)),f}async n(h,f,n){if(await this.h.exists(f))return;if(f.scheme!==k.Schemas.file){await n(f);return}const r=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,S.generateUuid)()}`);await this.h.exists(r)||await n(r);try{await this.r(r,f,Date.now()+2*60*1e3)}catch(t){try{await this.h.del(r)}catch{}if(t.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",h.identifier.id,f.path);else throw this.l.info(`Rename failed because of ${(0,i.getErrorMessage)(t)}. Deleted the file from downloaded location`,r.path),t}}async delete(h){await this.g,await this.h.del(h)}async r(h,f,n){try{await E.Promises.rename(h.fsPath,f.fsPath)}catch(r){if(L.isWindows&&r&&r.code==="EPERM"&&Date.now()<n)return this.l.info(`Failed renaming ${h} to ${f} with 'EPERM' error. Trying again...`),this.r(h,f,n);throw r}}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const h=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const f=[],n=[],r=[];for(const s of h.children)if(s.name.endsWith(yt.c))r.push(s.resource);else{const l=d.ExtensionKey.parse(s.name);l&&n.push([l,s])}const t=(0,d.groupByExtension)(n,([s])=>s),a=[];for(const s of t)s.sort((l,o)=>I.rcompare(l[0].version,o[0].version)),f.push(...s.slice(1).map(l=>l[1].resource)),a.push(s[0][1]);a.sort((s,l)=>s.mtime-l.mtime),f.push(...a.slice(0,Math.max(0,a.length-this.f)).map(s=>s.resource)),f.push(...r),await R.Promises.settled(f.map(s=>(this.l.trace("Deleting from cache",s.path),this.h.del(s))))}}catch(h){this.l.error(h)}}u(h){return this.f?d.ExtensionKey.create(h).toString().toLowerCase():(0,S.generateUuid)()}};m.c=".sigzip",m=pe([K(0,v.INativeEnvironmentService),K(1,w.IFileService),K(2,p.IExtensionGalleryService),K(3,b.IConfigurationService),K(4,g.IExtensionSignatureVerificationService),K(5,u.ILogService)],m),e.ExtensionsDownloader=m}),define(re[219],ae([0,1,2,12,28,46]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class L extends R.Disposable{constructor(I,S){super(),this.b=I,this.a=(0,i.join)(this.b.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this.B(S.onDidInstallExtensions(E=>this.c(E))),this.B(S.onDidUninstallExtension(E=>this.f(E)))}c(I){I.some(S=>!!S.local)&&this.invalidate()}f(I){I.error||this.invalidate()}invalidate(){D.Promises.rm(this.a,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=L}),define(re[220],ae([0,1,3,2,37,33,46]),function(_,e,R,i,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends i.Disposable{constructor(S,E,b,v,p,d){super(),this.f=S,this.g=E,this.h=b,this.i=v,this.j=p,this.k=d,this.a=this.B(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new i.DisposableMap),this.l().then(null,g=>d.error(g))}async l(){await this.f.migrateDefaultProfileExtensions(),await this.n(this.g.profiles,[]),this.m(),await this.C()}m(){this.B(this.g.onDidChangeProfiles(S=>this.n(S.added,S.removed))),this.B(this.h.onAddExtensions(S=>this.p(S))),this.B(this.h.onDidAddExtensions(S=>this.r(S))),this.B(this.h.onRemoveExtensions(S=>this.s(S))),this.B(this.h.onDidRemoveExtensions(S=>this.t(S))),this.B(this.j.onDidFilesChange(S=>this.u(S)))}async n(S,E){try{await Promise.all(E.map(b=>(this.c.deleteAndDispose(b.id),this.y(b.extensionsResource))))}catch(b){this.k.error(b)}try{S.length&&await Promise.all(S.map(b=>(this.c.set(b.id,(0,i.combinedDisposable)(this.j.watch(this.i.extUri.dirname(b.extensionsResource)),this.j.watch(b.extensionsResource))),this.w(b.extensionsResource))))}catch(b){this.k.error(b)}}async p(S){for(const E of S.extensions)this.D(this.G(E.identifier,E.version),S.profileLocation)}async r(S){for(const E of S.extensions){const b=this.G(E.identifier,E.version);S.error?this.F(b,S.profileLocation):this.D(b,S.profileLocation)}}async s(S){for(const E of S.extensions)this.F(this.G(E.identifier,E.version),S.profileLocation)}async t(S){let E=!1;for(const b of S.extensions){const v=this.G(b.identifier,b.version);S.error?this.D(v,S.profileLocation):(this.F(v,S.profileLocation),E=E||!this.b.has(v))}E&&await this.C()}u(S){for(const E of this.g.profiles)S.contains(E.extensionsResource,0,1)&&this.v(E.extensionsResource)}async v(S){const E=[],b=[],v=await this.h.scanProfileExtensions(S),p=new Set,d=new Set;for(const[g,w]of this.b)w.has(S)&&d.add(g);for(const g of v){const w=this.G(g.identifier,g.version);p.add(w),d.has(w)||(E.push(g.identifier),this.D(w,S))}for(const g of d)if(!p.has(g)){const w=this.H(g);w&&(b.push(w.identifier),this.F(g,S))}(E.length||b.length)&&this.a.fire({added:E.length?{extensions:E,profileLocation:S}:void 0,removed:b.length?{extensions:b,profileLocation:S}:void 0})}async w(S){const E=await this.h.scanProfileExtensions(S);for(const b of E)this.D(this.G(b.identifier,b.version),S)}async y(S){for(const E of[...this.b.keys()])this.F(E,S);await this.C()}async C(){const E=(await this.f.getAllUserInstalled()).filter(b=>!this.b.has(this.G(b.identifier,b.manifest.version)));E.length&&await this.f.markAsUninstalled(...E)}D(S,E){let b=this.b.get(S);b||this.b.set(S,b=new D.ResourceSet(v=>this.i.extUri.getComparisonKey(v))),b.add(E)}F(S,E){const b=this.b.get(S);b&&b.delete(E),b?.size||this.b.delete(S)}G(S,E){return`${L.ExtensionIdentifier.toKey(S.id)}@${E}`}H(S){const[E,b]=(0,k.getIdAndVersion)(S);return b?{identifier:{id:E},version:b}:void 0}}e.ExtensionsWatcher=P}),define(re[221],ae([0,1,99,19,6,2,23,12,28,13,29,33,7,73,5,8]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let w=class extends p.LanguagePackBaseService{constructor(h,f,n,r){super(n),this.h=h,this.i=r,this.g=this.B(new u(f,r)),this.h.registerParticipant({postInstall:async t=>this.j(t),postUninstall:async t=>this.k(t)})}async getBuiltInExtensionTranslationsUri(h){const n=(await this.g.getLanguagePacks())[d.Language.value()];if(!n){this.i.warn(`No language pack found for ${d.Language.value()}`);return}const r=n.translations[h];return r?g.URI.file(r):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),f=Object.keys(h).map(n=>{const r=h[n];return{...this.f(n,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return f.push({...this.f("en","English"),extensionId:"default"}),f.sort((n,r)=>n.label.localeCompare(r.label)),f}async j(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",h.identifier.id),await this.update())}async k(h){const f=await this.g.getLanguagePacks();Object.keys(f).some(n=>f[n]&&f[n].extensions.some(r=>(0,b.areSameExtensions)(r.extensionIdentifier,h.identifier)))&&(this.i.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,f]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),n=await this.g.update(f);return!(0,i.equals)(Object.keys(h),Object.keys(n))}};w=pe([K(0,E.IExtensionManagementService),K(1,S.INativeEnvironmentService),K(2,E.IExtensionGalleryService),K(3,v.ILogService)],w),e.NativeLanguagePackService=w;let u=class extends k.Disposable{constructor(h,f){super(),this.i=f,this.c={},this.f=(0,P.join)(h.userDataPath,"languagepacks.json"),this.g=new D.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.m(f=>{Object.keys(f).forEach(n=>delete f[n]),this.j(f,...h)}).then(()=>this.c)}j(h,...f){for(const n of f)n&&n.manifest&&n.manifest.contributes&&n.manifest.contributes.localizations&&n.manifest.contributes.localizations.length&&this.k(h,n);Object.keys(h).forEach(n=>this.l(h[n]))}k(h,f){const n=f.identifier,r=f.manifest.contributes&&f.manifest.contributes.localizations?f.manifest.contributes.localizations:[];for(const t of r)if(f.location.scheme===L.Schemas.file&&m(t)){let a=h[t.languageId];a||(a={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},h[t.languageId]=a);const s=a.extensions.filter(l=>(0,b.areSameExtensions)(l.extensionIdentifier,n))[0];s?s.version=f.manifest.version:a.extensions.push({extensionIdentifier:n,version:f.manifest.version});for(const l of t.translations)a.translations[l.id]=(0,P.join)(f.location.fsPath,l.path)}}l(h){if(h){const f=(0,R.createHash)("md5");for(const n of h.extensions)f.update(n.extensionIdentifier.uuid||n.extensionIdentifier.id).update(n.version);h.hash=f.digest("hex")}}m(h=()=>null){return this.g.queue(()=>{let f=null;return I.Promises.readFile(this.f,"utf8").then(void 0,n=>n.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(n)).then(n=>{try{return JSON.parse(n)}catch{return{}}}).then(n=>(f=h(n),n)).then(n=>{for(const t of Object.keys(n))n[t]||delete n[t];this.c=n,this.h=!0;const r=JSON.stringify(this.c);return this.i.debug("Writing language packs",r),I.Promises.writeFile(this.f,r)}).then(()=>f,n=>this.i.error(n))})}};u=pe([K(0,S.INativeEnvironmentService),K(1,v.ILogService)],u);function m(c){if(typeof c.languageId!="string"||!Array.isArray(c.translations)||c.translations.length===0)return!1;for(const h of c.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(c.languageName&&typeof c.languageName!="string"||c.localizedLanguageName&&typeof c.localizedLanguageName!="string")}}),define(re[222],ae([0,1,6,17,22,9,3,2,30,92,216,105]),function(_,e,R,i,D,k,L,P,I,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const v=30*1e3;var p;(function(X){X[X.Management=1]="Management",X[X.ExtensionHost=2]="ExtensionHost",X[X.Tunnel=3]="Tunnel"})(p=e.ConnectionType||(e.ConnectionType={}));function d(X){switch(X){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(X){const Z=new D.CancellationTokenSource;return setTimeout(()=>Z.cancel(),X),Z.token}function w(X,Z){if(X.isCancellationRequested||Z.isCancellationRequested)return D.CancellationToken.Cancelled;const U=new D.CancellationTokenSource;return X.onCancellationRequested(()=>U.cancel()),Z.onCancellationRequested(()=>U.cancel()),U.token}class u{get didTimeout(){return this.c==="timedout"}constructor(Z){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((U,N)=>{this.f=U,this.g=N}),Z.isCancellationRequested?this.h():this.d.add(Z.onCancellationRequested(()=>this.h()))}registerDisposable(Z){this.c==="pending"?this.d.add(Z):Z.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const Z=new Error("Time limit reached");return Z.code="ETIMEDOUT",Z.syscall="connect",Z}resolve(Z){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(Z))}reject(Z){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(Z))}}function m(X,Z){const U=new u(Z);return U.registerDisposable(X.onControlMessage(N=>{const H=JSON.parse(N.toString()),q=$(H);q?U.reject(q):U.resolve(H)})),U.promise}function c(X,Z,U,N,H,q,J,ne){const x=new u(ne);return Z.connect(U,N,H,q,J,(te,se)=>{x.didTimeout?(te&&X.error(te),se?.dispose()):te||!se?x.reject(te):x.resolve(se)}),x.promise}function h(X,Z){const U=new u(Z);return X.then(N=>{U.didTimeout||U.resolve(N)},N=>{U.didTimeout||U.reject(N)}),U.promise}async function f(X,Z,U,N){const H=ee(X,Z);X.logService.trace(`${H} 1/6. invoking socketFactory.connect().`);let q;try{q=await c(X.logService,X.socketFactory,X.host,X.port,(0,b.getRemoteServerRootPath)(X),`reconnectionToken=${X.reconnectionToken}&reconnection=${X.reconnectionProtocol?"true":"false"}`,`renderer-${d(Z)}-${X.reconnectionToken}`,N)}catch(se){throw X.logService.error(`${H} socketFactory.connect() failed or timed out. Error:`),X.logService.error(se),se}X.logService.trace(`${H} 2/6. socketFactory.connect() was successful.`);let J,ne;X.reconnectionProtocol?(X.reconnectionProtocol.beginAcceptReconnection(q,null),J=X.reconnectionProtocol,ne=!1):(J=new S.PersistentProtocol(q,null),ne=!0),X.logService.trace(`${H} 3/6. sending AuthRequest control message.`);const x=await h(X.signService.createNewMessage((0,I.generateUuid)()),N),te={type:"auth",auth:X.connectionToken||"00000000000000000000",data:x.data};J.sendControl(i.VSBuffer.fromString(JSON.stringify(te)));try{const se=await m(J,w(N,g(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(X.logService.trace(`${H} 4/6. received SignRequest control message.`),!await h(X.signService.validate(x,se.signedData),N)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const ue=await h(X.signService.sign(se.data),N),ye={type:"connectionType",commit:X.commit,signedData:ue,desiredConnectionType:Z};return U&&(ye.args=U),X.logService.trace(`${H} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(i.VSBuffer.fromString(JSON.stringify(ye))),{protocol:J,ownsProtocol:ne}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(X.logService.error(`${H} the handshake timed out. Error:`),X.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(X.logService.error(`${H} received error control message when negotiating connection. Error:`),X.logService.error(se)),ne&&Q(J),se}}async function n(X,Z,U,N){const H=Date.now(),q=ee(X,Z),{protocol:J,ownsProtocol:ne}=await f(X,Z,U,N),x=new u(N);return x.registerDisposable(J.onControlMessage(te=>{const se=JSON.parse(te.toString()),le=$(se);le?(X.logService.error(`${q} received error control message when negotiating connection. Error:`),X.logService.error(le),ne&&Q(J),x.reject(le)):(X.reconnectionProtocol?.endAcceptReconnection(),X.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${oe(H)}!`),x.resolve({protocol:J,firstMessage:se}))})),x.promise}async function r(X,Z){const{protocol:U}=await n(X,1,void 0,Z);return{protocol:U}}async function t(X,Z,U){const{protocol:N,firstMessage:H}=await n(X,2,Z,U),q=H&&H.debugPort;return{protocol:N,debugPort:q}}async function a(X,Z,U){const N=Date.now(),H=ee(X,3),{protocol:q}=await f(X,3,Z,U);return X.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${oe(N)}!`),q}async function s(X,Z,U){const{host:N,port:H,connectionToken:q}=await X.addressProvider.getAddress();return{commit:X.commit,quality:X.quality,host:N,port:H,connectionToken:q,reconnectionToken:Z,reconnectionProtocol:U,socketFactory:X.socketFactory,signService:X.signService,logService:X.logService}}async function l(X,Z,U){return y(X,async N=>{const{protocol:H}=await r(N,D.CancellationToken.None);return new G(X,Z,U,N.reconnectionToken,H)})}e.connectRemoteAgentManagement=l;async function o(X,Z){return y(X,async U=>{const{protocol:N,debugPort:H}=await t(U,Z,D.CancellationToken.None);return new V(X,Z,U.reconnectionToken,N,H)})}e.connectRemoteAgentExtensionHost=o;async function y(X,Z){for(let N=1;;N++)try{const H=(0,I.generateUuid)(),q=await s(X,H,null);return await Z(q)}catch(H){if(N<5)X.logService.error(`[remote-connection][attempt ${N}] An error occurred in initial connection! Will retry... Error:`),X.logService.error(H);else throw X.logService.error(`[remote-connection][attempt ${N}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),X.logService.error(H),B.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(H)),H}}async function C(X,Z,U){const N=await s(X,(0,I.generateUuid)(),null);return await a(N,{host:Z,port:U},D.CancellationToken.None)}e.connectRemoteAgentTunnel=C;function T(X){return(0,R.createCancelablePromise)(Z=>new Promise((U,N)=>{const H=setTimeout(U,X*1e3);Z.onCancellationRequested(()=>{clearTimeout(H),U()})}))}var W;(function(X){X[X.ConnectionLost=0]="ConnectionLost",X[X.ReconnectionWait=1]="ReconnectionWait",X[X.ReconnectionRunning=2]="ReconnectionRunning",X[X.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",X[X.ConnectionGain=4]="ConnectionGain"})(W=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class O{constructor(Z,U){this.reconnectionToken=Z,this.millisSinceLastIncomingData=U,this.type=0}}e.ConnectionLostEvent=O;class j{constructor(Z,U,N,H){this.reconnectionToken=Z,this.millisSinceLastIncomingData=U,this.durationSeconds=N,this.c=H,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=j;class F{constructor(Z,U,N){this.reconnectionToken=Z,this.millisSinceLastIncomingData=U,this.attempt=N,this.type=2}}e.ReconnectionRunningEvent=F;class A{constructor(Z,U,N){this.reconnectionToken=Z,this.millisSinceLastIncomingData=U,this.attempt=N,this.type=4}}e.ConnectionGainEvent=A;class M{constructor(Z,U,N,H){this.reconnectionToken=Z,this.millisSinceLastIncomingData=U,this.attempt=N,this.handled=H,this.type=3}}e.ReconnectionPermanentFailureEvent=M;class B extends P.Disposable{static triggerPermanentFailure(Z,U,N){this._permanentFailure=!0,this.f=Z,this.g=U,this.h=N,this.i.forEach(H=>H.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(Z=>Z.r())}static debugPauseSocketWriting(){this.i.forEach(Z=>Z.v())}get k(){return this.c||B._permanentFailure}constructor(Z,U,N,H,q){super(),this.m=Z,this.n=U,this.reconnectionToken=N,this.protocol=H,this.p=q,this.j=this.B(new L.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new A(this.reconnectionToken,0,0)),this.B(H.onSocketClose(J=>{const ne=Y(this.m,this.reconnectionToken,!0);J?J.type===0?(this.n.logService.info(`${ne} received socket close event (hadError: ${J.hadError}).`),J.error&&this.n.logService.error(J.error)):(this.n.logService.info(`${ne} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.n.logService.error(J.event)):this.n.logService.info(`${ne} received socket close event.`),this.r()})),this.B(H.onSocketTimeout(J=>{const ne=Y(this.m,this.reconnectionToken,!0);this.n.logService.info(`${ne} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.r()})),B.i.push(this),this.B((0,P.toDisposable)(()=>{const J=B.i.indexOf(this);J>=0&&B.i.splice(J,1)})),this.k&&this.u(B.f,B.g,B.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const Z=Y(this.m,this.reconnectionToken,!0);this.n.logService.info(`${Z} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const H=N<U.length?U[N]:U[U.length-1];try{if(H>0){const J=T(H);this.j.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H,J)),this.n.logService.info(`${Z} waiting for ${H} seconds before reconnecting...`);try{await J}catch{}}if(this.k){this.n.logService.error(`${Z} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this.n.logService.info(`${Z} resolving connection...`);const q=await s(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${Z} connecting to ${q.host}:${q.port}...`),await this.w(q,g(v)),this.n.logService.info(`${Z} reconnected!`),this.j.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${Z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(q),this.t(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this.n.logService.error(`${Z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(q),this.t(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(E.RemoteAuthorityResolverError.isTemporarilyNotAvailable(q)){this.n.logService.info(`${Z} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this.n.logService.info(`${Z} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(q);continue}if((0,k.isCancellationError)(q)){this.n.logService.info(`${Z} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(q);continue}if(q instanceof E.RemoteAuthorityResolverError){this.n.logService.error(`${Z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(q),this.t(this.protocol.getMillisSinceLastIncomingData(),N+1,E.RemoteAuthorityResolverError.isHandled(q));break}this.n.logService.error(`${Z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(q),this.t(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this.k)}t(Z,U,N){this.p?B.triggerPermanentFailure(Z,U,N):this.u(Z,U,N)}u(Z,U,N){this.j.fire(new M(this.reconnectionToken,Z,U,N)),Q(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=B,B._permanentFailure=!1,B.f=0,B.g=0,B.h=!1,B.i=[];class G extends B{constructor(Z,U,N,H,q){super(1,Z,H,q,!0),this.client=this.B(new S.Client(q,{remoteAuthority:U,clientId:N},Z.ipcLogger))}async w(Z,U){await r(Z,U)}}e.ManagementPersistentConnection=G;class V extends B{constructor(Z,U,N,H,q){super(2,Z,N,H,!1),this.y=U,this.debugPort=q}async w(Z,U){await t(Z,this.y,U)}}e.ExtensionHostPersistentConnection=V;function Q(X){try{X.acceptDisconnect();const Z=X.getSocket();X.dispose(),Z.dispose()}catch(Z){(0,k.onUnexpectedError)(Z)}}function $(X){if(X&&X.type==="error"){const Z=new Error(`Connection error: ${X.reason}`);return Z.code="VSCODE_CONNECTION_ERROR",Z}return null}function z(X,Z){for(;X.length<Z;)X+=" ";return X}function Y(X,Z,U){return`[remote-connection][${z(d(X),13)}][${Z.substr(0,5)}\u2026][${U?"reconnect":"initial"}]`}function ee(X,Z){return`${Y(Z,X.reconnectionToken,!!X.reconnectionProtocol)}[${X.host}:${X.port}]`}function oe(X){return`${Date.now()-X} ms`}}),define(re[223],ae([0,1,4]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[224],ae([0,1,85,150]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,k,L,P,I,S){const E=v=>S(v,void 0),b=R.createConnection({host:D,port:k},()=>{b.removeListener("error",E);const v=Buffer.alloc(16);for(let w=0;w<16;w++)v[w]=Math.round(Math.random()*256);const p=v.toString("base64"),d=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${k}${L}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${p}`];b.write(d.join(`\r
`)+`\r
\r
`);const g=w=>{w.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",g),S(void 0,new i.NodeSocket(b,I)))};b.on("data",g)});b.setNoDelay(!0),b.once("error",E)}}}),define(re[106],ae([0,1,4]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,R.createDecorator)("IRemoteTunnelService");var i;(function(D){D.disconnected={type:"disconnected"},D.uninitialized={type:"uninitialized"},D.connected=k=>({type:"connected",info:k}),D.connecting=k=>({type:"connecting",progress:k})})(i=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride"}),define(re[225],ae([0,1,133,16,7]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(P,I){this.a=P,this.b=I}async request(P,I){this.b.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.a.getValue("http.proxyAuthorization"));try{const S=await(0,R.request)(P,I);return this.b.trace("RequestService#request (browser) - success",P.url),S}catch(S){throw this.b.error("RequestService#request (browser) - error",P.url,S),S}}async resolveProxy(P){}};k=pe([K(0,i.IConfigurationService),K(1,D.ILogService)],k),e.RequestService=k}),define(re[47],ae([0,1,17,169,45,4,40]),function(_,e,R,i,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function P(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=P;function I(g){return g.res.statusCode===204}async function S(g){return I(g)?null:(await(0,R.streamToBuffer)(g.stream)).toString()}e.asText=S;async function E(g){if(!P(g))throw new Error("Server returned "+g.res.statusCode);return S(g)}e.asTextOrError=E;async function b(g){if(!P(g))throw new Error("Server returned "+g.res.statusCode);if(I(g))return null;const u=(await(0,R.streamToBuffer)(g.stream)).toString();try{return JSON.parse(u)}catch(m){throw m.message+=`:
`+u,m}}e.asJson=b;function v(g){d(g)}e.updateProxyConfigurationsScope=v;let p;function d(g){const w=L.Registry.as(D.Extensions.Configuration),u=p;p={id:"http",order:15,title:(0,i.localize)(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,i.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,i.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,i.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,i.localize)(4,null),(0,i.localize)(5,null),(0,i.localize)(6,null),(0,i.localize)(7,null)],default:"override",description:(0,i.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,i.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[p],remove:u?[u]:[]})}d(2)}),define(re[226],ae([0,1,22,23,14,47]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let L=class{constructor(I,S){this.a=I,this.b=S}async download(I,S,E=R.CancellationToken.None){if(I.scheme===i.Schemas.file||I.scheme===i.Schemas.vscodeRemote){await this.b.copy(I,S);return}const b={type:"GET",url:I.toString(!0)},v=await this.a.request(b,E);if(v.res.statusCode===200)await this.b.writeFile(S,v.stream);else{const p=await(0,k.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${p}`)}}};L=pe([K(0,k.IRequestService),K(1,D.IFileService)],L),e.DownloadService=L}),define(re[227],ae([0,1,19,22,2,20,187,14,7,25,47]),function(_,e,R,i,D,k,L,P,I,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let b=class extends D.Disposable{constructor(p,d,g,w){super(),this.b=p,this.c=d,this.f=g,this.g=w,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,u])=>this.a.set(u.configPath,u))}getConfigBasedTips(p){return this.h(p)}getAllWorkspacesTips(){return this.j()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async h(p){const d=[];for(const[g,w]of this.a)if(!(w.configScheme&&w.configScheme!==p.scheme))try{const u=await this.b.readFile((0,k.joinPath)(p,g)),m=new Map;Object.entries(w.recommendations).forEach(([h,f])=>{if((0,R.isNonEmptyArray)(f.remotes))for(const n of f.remotes)m.set(n,{extensionId:h,extensionName:f.name,configName:w.configName,important:!!f.important,isExtensionPack:!!f.isExtensionPack,whenNotInstalled:f.whenNotInstalled});else d.push({extensionId:h,extensionName:f.name,configName:w.configName,important:!!f.important,isExtensionPack:!!f.isExtensionPack,whenNotInstalled:f.whenNotInstalled})});const c=(0,L.getDomainsOfRemotes)(u.value.toString(),[...m.keys()]);for(const h of c){const f=m.get(h);f&&d.push(f)}}catch{}return d}async j(){if(!this.c.extensionsGallery?.recommendationsUrl)return[];try{const p=await this.f.request({type:"GET",url:this.c.extensionsGallery?.recommendationsUrl},i.CancellationToken.None);if(p.res.statusCode!==200)return[];const d=await(0,E.asJson)(p);return d?d.workspaceRecommendations||[]:[]}catch(p){return this.g.error(p),[]}}};b=pe([K(0,P.IFileService),K(1,S.IProductService),K(2,E.IRequestService),K(3,I.ILogService)],b),e.ExtensionTipsService=b}),define(re[228],ae([0,1,17,22]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(P){this.a=P}listen(P,I){throw new Error("Invalid listen")}call(P,I,S,E=i.CancellationToken.None){switch(I){case"request":return this.a.request(S[0],E).then(async({res:b,stream:v})=>{const p=await(0,R.streamToBuffer)(v);return[{statusCode:b.statusCode,headers:b.headers},p]});case"resolveProxy":return this.a.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class k{constructor(P){this.a=P}async request(P,I){const[S,E]=await this.a.call("request",[P],I);return{res:S,stream:(0,R.bufferToStream)(E)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=k}),define(re[229],ae([0,1,225,228]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class D{constructor(L,P,I){this.c=P,this.d=I,this.a=new R.RequestService(P,I),this.b=new i.RequestChannelClient(L.getChannel("request"))}request(L,P){return this.e().request(L,P)}async resolveProxy(L){return this.e().resolveProxy(L)}e(){return this.c.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.d.trace("Using main request service"),this.b):(this.d.trace("Using browser request service"),this.a)}}e.SharedProcessRequestService=D}),define(re[107],ae([0,1,66,4]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(k){return(0,R.hash)({moduleId:k.process.moduleId,windowId:k.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,i.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(re[230],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var R;(function(i){i.Spawn="vscode:shared-process->shared-process-worker=spawn",i.Terminate="vscode:shared-process->shared-process-worker=terminate",i.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",i.Ready="vscode:shared-process-worker->shared-process=ready",i.Ack="vscode:shared-process-worker->shared-process=ack",i.Trace="vscode:shared-process-worker->shared-process=trace",i.Info="vscode:shared-process-worker->shared-process=info",i.Warn="vscode:shared-process-worker->shared-process=warn",i.Error="vscode:shared-process-worker->shared-process=error"})(R=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(re[231],ae([0,1,93,6,22,3,2,23,30,7,107,230]),function(_,e,R,i,D,k,L,P,I,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let v=class{constructor(g){this.d=g,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(g){const w=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${w})`);const u=(0,E.hash)(g);this.b.has(u)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${w})`),this.f(g));const m=new D.CancellationTokenSource;let c,h,f;this.b.set(u,a=>{m.dispose(!0),c?.terminate(g,D.CancellationToken.None),h?.close(),f?.close(),this.b.delete(u);const s=this.c.get(u);s&&(this.c.delete(u),s({reason:a}))}),c=await this.e(g);const n=new Promise(a=>{this.c.set(u,a)});if(m.token.isCancellationRequested)return n;const{port1:r,port2:t}=new MessageChannel;return h=r,f=t,await c.spawn(g,f,m.token),m.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${w})`),R.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",g,[h])),n}e(g){let w=this.a.get(g.process.moduleId);if(!w){this.d.trace(`SharedProcess: creating new web worker (${g.process.moduleId})`);const u=new p(g.process.type,this.d);w=u.init(),u.onDidProcessSelfTerminate(({configuration:m,reason:c})=>{this.f(m,c)}),this.a.set(g.process.moduleId,w)}return w}async disposeWorker(g){return this.f(g)}f(g,w){const u=this.b.get((0,E.hash)(g));u&&(this.d.trace(`SharedProcess: disposeWorker (window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),u(w))}};v=pe([K(0,S.ILogService)],v),e.SharedProcessWorkerService=v;class p extends L.Disposable{constructor(g,w){super(),this.f=g,this.g=w,this.a=this.B(new k.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const g=new i.DeferredPromise,w=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return w.onerror=u=>{this.g.error(`SharedProcess: worker error (${this.f})`,u.message)},w.onmessageerror=u=>{this.g.error(`SharedProcess: worker message error (${this.f})`,u)},w.onmessage=u=>{const{id:m,message:c,configuration:h,nonce:f}=u.data;switch(m){case b.SharedProcessWorkerMessages.Ready:g.complete(w);break;case b.SharedProcessWorkerMessages.Ack:if(f){const n=this.c.get(f);n&&(this.c.delete(f),n())}break;case b.SharedProcessWorkerMessages.SelfTerminated:h&&c&&this.a.fire({configuration:h,reason:JSON.parse(c)});break;case b.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,c);break;case b.SharedProcessWorkerMessages.Info:c&&this.g.info(c);break;case b.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,c);break;case b.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,c);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,u)}},w.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),g.p}async i(g,w,u){const m=await this.b;if(!w.isCancellationRequested)return new Promise(c=>{const h=(0,I.generateUuid)();this.c.set(h,c);const f={...g,nonce:h};u?m.postMessage(f,[u]):m.postMessage(f),w.onCancellationRequested(()=>{this.c.delete(h)&&c()})})}spawn(g,w,u){const m={id:b.SharedProcessWorkerMessages.Spawn,configuration:g,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(m,u,w)}terminate(g,w){const u={id:b.SharedProcessWorkerMessages.Terminate,configuration:g};return this.i(u,w)}}}),define(re[232],ae([0,1,63,23,186]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class k extends D.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:i.Schemas.vscodeUserData})}}pe([R.memoize],k.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=k}),define(re[233],ae([0,1,50,12,170,22,38,9,5,30,147,184,6]),function(_,e,R,i,D,k,L,P,I,S,E,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let d;async function g(u,m,c){return m["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(c)&&!m["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(c)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=v.Promises.withAsyncBody(async(h,f)=>{const n=new k.CancellationTokenSource,r=setTimeout(()=>{n.dispose(!0),f(new Error((0,D.localize)(0,null)))},p);try{h(await w(u,n.token))}catch(t){!(0,P.isCancellationError)(t)&&!n.token.isCancellationRequested?f(new Error((0,D.localize)(1,null,(0,L.toErrorMessage)(t)))):h({})}finally{clearTimeout(r),n.dispose()}})),d)}e.getResolvedShellEnv=g;async function w(u,m){const c=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",c);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",h);const f=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(f+"(.*)"+f),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",r);const t=await(0,E.getSystemShell)(I.OS,r);return u.trace("getUnixShellEnvironment#shell",t),new Promise((a,s)=>{if(m.isCancellationRequested)return s((0,P.canceled)());const l=(0,i.basename)(t);let o,y;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(o=`& '${process.execPath}' ${C} -p '''${f}'' + JSON.stringify(process.env) + ''${f}'''`,y=["-Login","-Command"]):(o=`'${process.execPath}' ${C} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,l==="tcsh"?y=["-ic"]:y=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),o);const T=(0,R.spawn)(t,[...y,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});m.onCancellationRequested(()=>(T.kill(),s((0,P.canceled)()))),T.on("error",j=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(j)),s(j)});const W=[];T.stdout.on("data",j=>W.push(j));const O=[];T.stderr.on("data",j=>O.push(j)),T.on("close",(j,F)=>{const A=Buffer.concat(W).toString("utf8");u.trace("getUnixShellEnvironment#raw",A);const M=Buffer.concat(O).toString("utf8");if(M.trim()&&u.trace("getUnixShellEnvironment#stderr",M),j||F)return s(new Error((0,D.localize)(2,null,j,F)));const B=n.exec(A),G=B?B[1]:"{}";try{const V=JSON.parse(G);c?V.ELECTRON_RUN_AS_NODE=c:delete V.ELECTRON_RUN_AS_NODE,h?V.ELECTRON_NO_ATTACH_CONSOLE=h:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",V),a(V)}catch(V){u.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(V)),s(V)}})})}}),define(re[108],ae([0,1,4]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[234],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{constructor(){this.b=new Map}c(){return new Promise((D,k)=>_(["vsda"],D,k))}async createNewMessage(D){try{const k=await this.c(),L=new k.validator;if(L){const P=String(R.a++);return this.b.set(P,L),{id:P,data:L.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,k){if(!D.id)return!0;const L=this.b.get(D.id);if(!L)return!1;this.b.delete(D.id);try{return L.validate(k)==="ok"}catch{return!1}}async sign(D){try{const k=await this.c(),L=new k.signer;if(L)return L.sign(D)}catch{}return D}}e.SignService=R,R.a=1}),define(re[75],ae([0,1,3,2]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class D extends i.Disposable{constructor(b,v,p){super(),this.a=b,this.b=v,this.c=p}async getItems(){const b={profile:this.b,workspace:this.c},v=await this.a.call("getItems",b);return new Map(v)}updateItems(b){const v={profile:this.b,workspace:this.c};return b.insert&&(v.insert=Array.from(b.insert.entries())),b.delete&&(v.delete=Array.from(b.delete.values())),this.a.call("updateItems",v)}}class k extends D{constructor(b,v){super(b,v,void 0),this.f=this.B(new R.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(b=>this.h(b)))}h(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this.f.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}}class L extends k{constructor(b){super(b,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=L;class P extends k{constructor(b,v){super(b,v)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=P;class I extends D{constructor(b,v){super(b,void 0,v),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class S{constructor(b){this.a=b}isUsed(b){const v={payload:b,profile:void 0,workspace:void 0};return this.a.call("isUsed",v)}}e.StorageClient=S}),define(re[109],ae([0,1,5,36,8,30]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(S){if(R.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function P(S,E,b,v,p,d,g,w,u,m){const c=Object.create(null);c["common.machineId"]=g,c.sessionID=(0,k.generateUuid)()+Date.now(),c.commitHash=p,c.version=d,c["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,R.PlatformToString)(R.platform),c["common.nodePlatform"]=i.platform,c["common.nodeArch"]=v,c["common.product"]=m||"desktop",w&&(c["common.msftInternal"]=w);let h=0;const f=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),R.isLinuxSnap&&(c["common.snap"]="true");const n=L(b);n&&(c["common.platformDetail"]=n);try{const r=await S.readFile(D.URI.file(u));c["common.source"]=r.value.toString().slice(0,30)}catch{}return c}e.resolveCommonProperties=P;function I(S){const E=i.env.USERDNSDOMAIN;if(!E)return!1;const b=E.toLowerCase();return S.some(v=>b===v)}e.verifyMicrosoftInternalDomain=I}),define(re[24],ae([0,1,4]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var i;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(i=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(re[235],ae([0,1,34,6,35,23,12,5,8,144,28,146,95,14,25,24]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const w=new Map;async function u(n,r){const t=`${n}::${r.join(":")}`,a=w.get(t);if(a)return a;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,o=new Map,y=2e4;function C(W,O,j,F){const A=O.substring(W.length+1);return i.Promises.withAsyncBody(async M=>{let B;try{B=await E.Promises.readdir(O,{withFileTypes:!0})}catch{M();return}if(F.count>=y){F.count+=B.length,F.maxReached=!0,M();return}let G=B.length;if(G===0){M();return}let V=B;F.count+B.length>y&&(F.maxReached=!0,G=y-F.count,V=B.slice(0,G)),F.count+=B.length;for(const Q of V)if(Q.isDirectory()){if(j.includes(Q.name)||await C(W,(0,L.join)(O,Q.name),j,F),--G===0){M();return}}else{const $=Q.name.lastIndexOf(".");if($>=0){const z=Q.name.substring($+1);z&&l.set(z,(l.get(z)??0)+1)}for(const z of s)z.relativePathPattern?.test(A)!==!1&&z.filePattern.test(Q.name)&&o.set(z.tag,(o.get(z.tag)??0)+1);if(--G===0){M();return}}})}const T=i.Promises.withAsyncBody(async W=>{const O={count:0,maxReached:!1};await C(n,n,r,O);const j=await h(n);W({configFiles:m(o),fileTypes:m(l),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:j})});return w.set(t,T),T}e.collectWorkspaceStats=u;function m(n){return Array.from(n.entries(),([r,t])=>({name:r,count:t})).sort((r,t)=>t.count-r.count)}function c(){const n={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},r=R.cpus();return r&&r.length>0&&(n.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),n}e.getMachineInfo=c;async function h(n){try{const r=new Map,t=(0,L.join)(n,".vscode","launch.json"),a=await E.Promises.readFile(t),s=[],l=(0,D.parse)(a.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,D.getNodeType)(l)==="object"&&l.configurations)for(const o of l.configurations){const y=o.type;y&&(r.has(y)?r.set(y,r.get(y)+1):r.set(y,1))}return m(r)}catch{return[]}}e.collectLaunchConfigs=h;let f=class{constructor(r,t){this.c=r,this.d=t}f(r){const t=[];return t.push(`OS Version:       ${r.os}`),t.push(`CPUs:             ${r.cpus}`),t.push(`Memory (System):  ${r.memory}`),t.push(`VM:               ${r.vmHint}`),t.join(`
`)}g(r){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const a=R.cpus();return a&&a.length>0&&t.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),t.push(`Memory (System):  ${(R.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||t.push(`Load (avg):       ${R.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${r.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(r,t){return Promise.all([(0,b.listProcesses)(r.mainPID),this.k(r)]).then(async a=>{let[s,l]=a,o=this.m(r,s);return t.forEach(y=>{if((0,v.isRemoteDiagnosticError)(y))o+=`
${y.errorMessage}`,l+=`
${y.errorMessage}`;else if(o+=`

Remote: ${y.hostName}`,y.processes&&(o+=`
${this.m(r,y.processes)}`),y.workspaceMetadata){l+=`
|  Remote: ${y.hostName}`;for(const C of Object.keys(y.workspaceMetadata)){const T=y.workspaceMetadata[C];let W=`${T.fileCount} files`;T.maxFilesReached&&(W=`more than ${W}`),l+=`|    Folder (${C}): ${W}`,l+=this.h(T)}}}),{processInfo:o,workspaceInfo:l}})}async getSystemInfo(r,t){const{memory:a,vmHint:s,os:l,cpus:o}=c(),y={os:l,memory:a,cpus:o,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:t};return P.isWindows||(y.load=`${R.loadavg().map(C=>Math.round(C)).join(", ")}`),P.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(r,t){const a=[];return(0,b.listProcesses)(r.mainPID).then(async s=>(a.push(""),a.push(this.g(r)),a.push(""),a.push(this.m(r,s)),r.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.k(r))),t.forEach(l=>{if((0,v.isRemoteDiagnosticError)(l))a.push(`
${l.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${l.hostName}`),a.push(this.f(l.machineInfo)),l.processes&&a.push(this.m(r,l.processes)),l.workspaceMetadata)for(const o of Object.keys(l.workspaceMetadata)){const y=l.workspaceMetadata[o];let C=`${y.fileCount} files`;y.maxFilesReached&&(C=`more than ${C}`),a.push(`Folder (${o}): ${C}`),a.push(this.h(y))}}),a.push(""),a.push(""),a.join(`
`)))}h(r){const t=[];let s=0;const l=(T,W)=>{const O=` ${T}(${W})`;s+O.length>60?(t.push(o),o="|                 ",s=o.length):s+=O.length,o+=O};let o="|      File types:";const y=10,C=r.fileTypes.length>y?y:r.fileTypes.length;for(let T=0;T<C;T++){const W=r.fileTypes[T];l(W.name,W.count)}if(t.push(o),r.configFiles.length>=0&&(o="|      Conf files:",s=0,r.configFiles.forEach(T=>{l(T.name,T.count)}),t.push(o)),r.launchConfigFiles.length>0){let T="|      Launch Configs:";r.launchConfigFiles.forEach(W=>{T+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),t.push(T)}return t.join(`
`)}j(r){const t=Math.max(...Object.keys(r).map(a=>a.length));return Object.keys(r).map(a=>`${a}:  ${" ".repeat(t-a.length)}  ${r[a]}`).join(`
                  `)}k(r){const t=[],a=[];return r.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const o=I.URI.revive(l);if(o.scheme===k.Schemas.file){const y=o.fsPath;a.push(u(y,["node_modules",".git"]).then(C=>{let T=`${C.fileCount} files`;C.maxFilesReached&&(T=`more than ${T}`),t.push(`|    Folder (${(0,L.basename)(y)}): ${T}`),t.push(this.h(C))}).catch(C=>{t.push(`|      Error: Unable to collect workspace stats for folder ${y} (${C.toString()})`)}))}else t.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(r,t){const a=new Map;r.windows.forEach(l=>a.set(l.pid,l.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.n(r.mainPID,a,s,t,0),s.join(`
`)}n(r,t,a,s,l){const o=l===0;let y;o?y=s.pid===r?`${this.d.applicationName} main`:"remote agent":(y=`${"  ".repeat(l)} ${s.name}`,s.name==="window"&&(y=`${y} (${t.get(s.pid)})`));const C=process.platform==="win32"?s.mem:R.totalmem()*(s.mem/100);a.push(`${s.load.toFixed(0).padStart(5," ")}	${(C/p.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(s.children)&&s.children.forEach(T=>this.n(r,t,a,T,l+1))}async getWorkspaceFileExtensions(r){const t=new Set;for(const{uri:a}of r.folders){const s=I.URI.revive(a);if(s.scheme!==k.Schemas.file)continue;const l=s.fsPath;try{(await u(l,["node_modules",".git"])).fileTypes.forEach(y=>t.add(y.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(r){for(const{uri:t}of r.folders){const a=I.URI.revive(t);if(a.scheme!==k.Schemas.file)continue;const s=a.fsPath;try{const l=await u(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),l.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),l.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),l.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};f=pe([K(0,g.ITelemetryService),K(1,d.IProductService)],f),e.DiagnosticsService=f}),define(re[236],ae([0,1,106,3,24,13,2,7,12,50,25,5,6,101,16,168,34]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let u=class extends L.Disposable{constructor(c,h,f,n,r,t){super(),this.n=c,this.p=h,this.r=f,this.s=t,this.b=new i.Emitter,this.onDidTokenFailed=this.b.event,this.c=new i.Emitter,this.onDidChangeTunnelStatus=this.c.event,this.f=new i.Emitter,this.onDidChangeAccount=this.f.event,this.j=R.TunnelStates.disconnected,this.g=this.B(n.createLogger(f.remoteTunnelLogResource,{name:"remoteTunnel"})),this.k=new v.Delayer(100),this.B(r.onWillShutdown(a=>{this.i&&(this.i.cancel(),this.i=void 0),this.dispose()})),this.B(t.onDidChangeConfiguration(a=>{a.affectsConfiguration(R.CONFIGURATION_KEY_HOST_NAME)&&this.k.trigger(()=>this.u())}))}async getAccount(){return this.h}async updateAccount(c){if(c&&this.h?c.token!==this.h.token||c.authenticationProviderId!==this.h.authenticationProviderId:c!==this.h){this.h=c,this.f.fire(c),this.g.info(`Account updated: ${c?c.authenticationProviderId:"undefined"}`),this.n.publicLog2("remoteTunnel.enablement",{enabled:!!c});try{await this.k.trigger(()=>this.u())}catch(h){this.g.error(h)}}}t(){if(!this.l){let c;b.isMacintosh?c=this.r.appRoot:c=(0,I.dirname)((0,I.dirname)(this.r.appRoot)),this.l=(0,I.join)(c,"bin",`${this.p.tunnelApplicationName}${b.isWindows?".exe":""}`)}return this.l}async u(){if(this.i&&(this.i.cancel(),this.i=void 0),!this.h){this.v(R.TunnelStates.disconnected);return}const{token:c,authenticationProviderId:h}=this.h;this.v(R.TunnelStates.connecting((0,g.localize)(0,null)));const f=(s,l)=>{s=s.replaceAll(c,"*".repeat(4)),l?this.g.error(s):this.g.info(s)},n=this.w("login",["user","login","--provider",h,"--access-token",c],f);this.i=n;try{if(await n,this.i!==n)return}catch(s){this.g.error(s),this.i=void 0,this.b.fire(!0),this.v(R.TunnelStates.disconnected);return}const r=["--parent-process-id",String(process.pid),"--accept-server-license-terms"],t=this.y();t?r.push("--name",t):r.push("--random-name");const a=this.w("tunnel",r,(s,l)=>{l?this.g.error(s):this.g.info(s);const o=s.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(o){const y={link:o[1],domain:o[2],extensionId:"ms-vscode.remote-server",hostName:o[4]};this.v(R.TunnelStates.connected(y))}else s.match(/error refreshing token/)&&(a.cancel(),this.b.fire(!0),this.v(R.TunnelStates.disconnected))});this.i=a,a.finally(()=>{a===this.i&&(this.g.info("tunnel process terminated"),this.i=void 0,this.h=void 0,this.v(R.TunnelStates.disconnected))})}async getTunnelStatus(){return this.j}v(c){c!==this.j&&(this.j=c,this.c.fire(c))}w(c,h,f=()=>{}){return(0,v.createCancelablePromise)(n=>new Promise((r,t)=>{n.isCancellationRequested&&r();let a;if(n.onCancellationRequested(()=>{a&&(this.g.info(`${c} terminating (${a.pid})`),a.kill())}),process.env.VSCODE_DEV)f("Compiling tunnel CLI from sources and run",!1),f(`${c} Spawning: cargo run -- tunnel ${h.join(" ")}`,!1),a=(0,S.spawn)("cargo",["run","--","tunnel",...h],{cwd:(0,I.join)(this.r.appRoot,"cli")});else{f("Running tunnel CLI",!1);const s=this.t();f(`${c} Spawning: ${s} tunnel ${h.join(" ")}`,!1),a=(0,S.spawn)(s,["tunnel",...h],{cwd:(0,w.homedir)()})}a.stdout.on("data",s=>{if(a){const l=s.toString();f(l,!1)}}),a.stderr.on("data",s=>{if(a){const l=s.toString();f(l,!0)}}),a.on("exit",s=>{a&&(f(`${c} exit (${a.pid}):  + ${s}`,!1),a=void 0,s===0?r():t())}),a.on("error",s=>{a&&(f(`${c} error (${a.pid}):  + ${s}`,!0),a=void 0,t())})}))}y(){const c=this.s.getValue(R.CONFIGURATION_KEY_HOST_NAME);if(c&&c.match(/^([\w-]+)$/)&&c.length<=20)return c;const h=(0,w.hostname)();if(h&&h.match(/^([\w-]+)$/))return h.substring(0,20)}};u=pe([K(0,D.ITelemetryService),K(1,E.IProductService),K(2,k.INativeEnvironmentService),K(3,P.ILoggerService),K(4,p.ISharedProcessLifecycleService),K(5,d.IConfigurationService)],u),e.RemoteTunnelService=u}),define(re[110],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(k){this.b=k}listen(k,L){throw new Error(`Event not found: ${L}`)}call(k,L,{eventName:P,data:I}){return this.b.forEach(S=>S.log(P,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class i{constructor(k){this.b=k}log(k,L){return this.b.call("log",{eventName:k,data:L}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=i}),define(re[51],ae([0,1,32,87,15,16,109,24]),function(_,e,R,i,D,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class I{constructor(l){this.value=l}}e.TrustedTelemetryValue=I;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,i.staticObservableValue)(0)}publicLog(l,o){return Promise.resolve(void 0)}publicLog2(l,o){return this.publicLog(l,o)}publicLogError(l,o){return Promise.resolve(void 0)}publicLogError2(l,o){return this.publicLogError(l,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class E{async publicLog(l,o,y){}async publicLogError(l,o,y){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(s,l){return l.onDidChangeConfiguration(o=>{o.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(o.source),configurationKeys:c(o.sourceConfig)})})}e.configurationTelemetry=b;function v(s,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!s.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=v;function p(s,l){return!(l.isBuilt||l.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=p;function d(s){const l=s.getValue(P.TELEMETRY_SETTING_ID),o=s.getValue("telemetry.enableCrashReporter");if(s.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=d;function g(s){const l={},o={},y={};m(s,y);for(let C in y){C=C.length>150?C.substr(C.length-149):C;const T=y[C];typeof T=="number"?o[C]=T:typeof T=="boolean"?o[C]=T?1:0:typeof T=="string"?(T.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${T.length}`),l[C]=T.substring(0,8191)):typeof T<"u"&&T!==null&&(l[C]=T)}return{properties:l,measurements:o}}e.validateTelemetryData=g;const w=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function u(s){if(!s)return"none";for(const l of w)if(s.startsWith(`${l}+`))return l;return"other"}e.cleanRemoteAuthority=u;function m(s,l,o=0,y){if(!!s)for(const C of Object.getOwnPropertyNames(s)){const T=s[C],W=y?y+C:C;Array.isArray(T)?l[W]=(0,R.safeStringify)(T):T instanceof Date?l[W]=T.toISOString():(0,D.isObject)(T)?o<2?m(T,l,o+1,W+"."):l[W]=(0,R.safeStringify)(T):l[W]=T}}function c(s){if(!s)return[];const l=[];return h(l,"",s),l}function h(s,l,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(y=>h(s,l?`${l}.${y}`:y,o[y])):s.push(l)}function f(s,l){const o=s.msftInternalDomains||[],y=l.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(o)||y}e.isInternalTelemetry=f;function n(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=n;function r(s,l){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let o=s;const y=[];for(const O of l)for(;;){const j=O.exec(s);if(!j)break;y.push([j.index,O.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,T=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let W=0;for(o="";;){const O=T.exec(s);if(!O)break;const j=y.some(([F,A])=>O.index<A&&F<T.lastIndex);!C.test(O[0])&&!j&&(o+=s.substring(W,O.index)+"<REDACTED: user-file-path>",W=T.lastIndex)}return W<s.length&&(o+=s.substr(W)),o}function t(s){if(!s)return s;const l=s.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const y of o)if(y.regex.test(l))return`<REDACTED: ${y.label}>`;return s}function a(s,l){return(0,R.cloneAndChange)(s,o=>{if(o instanceof I)return o.value;if(typeof o=="string"){let y=o;y=r(y,l);for(const C of l)y=y.replace(C,"");return y=t(y),y}})}e.cleanData=a}),define(re[237],ae([0,1,44,51]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(k,L,P,I,S,E,b){const v={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${L.nameShort})`};if((0,i.supportsTelemetry)(L,P)&&(0,i.getTelemetryLevel)(I)===3){const p=await(0,R.getServiceMachineId)(P,S,E),{machineId:d}=await b.getTelemetryInfo();v["X-Market-User-Id"]=p,v["VSCode-SessionId"]=d}return v}e.resolveMarketplaceHeaders=D}),define(re[238],ae([0,1,9,32,51]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function L(I,S,E){const b=await new Promise((w,u)=>{_(["@microsoft/1ds-core-js"],w,u)}),v=await new Promise((w,u)=>{_(["@microsoft/1ds-post-js"],w,u)}),p=new b.AppInsightsCore,d=new v.PostChannel,g={instrumentationKey:I,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(E){g.extensionConfig={};const w={alwaysUseXhrOverride:!0,httpXHROverride:E};g.extensionConfig[d.identifier]=w}return p.initialize(g,[]),p.addTelemetryInitializer(w=>{S&&(w.ext=w.ext??{},w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),p}class P{constructor(S,E,b,v,p){this.d=S,this.e=E,this.f=b,this.g=p,this.c=k,this.f||(this.f={}),typeof v=="function"?this.a=v():this.a=v,this.b=null}h(S){if(!!this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=L(this.a,this.d,this.g)),this.b.then(E=>{S(E)},E=>{(0,R.onUnexpectedError)(E),console.error(E)})}}log(S,E){if(!this.a)return;E=(0,i.mixin)(E,this.f),E=(0,D.validateTelemetryData)(E);const b=this.e+"/"+S;try{this.h(v=>{v.pluginVersionString=E?.properties.version??"Unknown",v.track({name:b,baseData:{name:b,properties:E?.properties,measurements:E?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.h(E=>{E.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(re[111],ae([0,1,2,13,7,51]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let L=class extends R.Disposable{constructor(I,S,E=""){super(),this.b=E;const b=I.getLogger(S.telemetryLogResource);b?this.a=this.B(b):(this.a=this.B(I.createLogger(S.telemetryLogResource)),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(I,S){this.a.trace(`${this.b}telemetry/${I}`,(0,k.validateTelemetryData)(S))}};L=pe([K(0,D.ILoggerService),K(1,i.IEnvironmentService)],L),e.TelemetryLogAppender=L}),define(re[112],ae([0,1,2,32,87,5,27,171,16,45,103,25,40,24,51]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(m,c,h){this.j=c,this.k=h,this.d={},this.telemetryLevel=new D.MutableObservableValue(3),this.h=new R.DisposableStore,this.i=[],this.b=m.appenders,this.c=m.commonProperties||Promise.resolve({}),this.f=m.piiPaths||[],this.g=!!m.sendErrorTelemetry,this.i=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const f of this.f)this.i.push(new RegExp((0,L.escapeRegExpCharacters)(f),"gi")),f.indexOf("\\")>=0&&this.i.push(new RegExp((0,L.escapeRegExpCharacters)(f.replace(/\\/g,"/")),"gi"));this.l(),this.j.onDidChangeConfiguration(this.l,this,this.h)}setExperimentProperty(m,c){this.d[m]=c}l(){let m=(0,d.getTelemetryLevel)(this.j);const c=this.k.enabledTelemetryLevels;if(c){this.g=this.sendErrorTelemetry?c.error:!1;const h=c.usage?3:c.error?2:0;m=Math.min(m,h)}this.telemetryLevel.value=m}get sendErrorTelemetry(){return this.g}async getTelemetryInfo(){const m=await this.c,c=m.sessionID,h=m["common.machineId"],f=m["common.firstSessionDate"],n=m["common.msftInternal"];return{sessionId:c,machineId:h,firstSessionDate:f,msftInternal:n}}dispose(){this.h.dispose()}m(m,c,h){return this.telemetryLevel.value<c?Promise.resolve(void 0):this.c.then(f=>{h=(0,i.mixin)(h,this.d),h=(0,d.cleanData)(h,this.i),h=(0,i.mixin)(h,f),this.b.forEach(n=>n.log(m,h))},f=>{console.error(f)})}publicLog(m,c){return this.m(m,3,c)}publicLog2(m,c){return this.publicLog(m,c)}publicLogError(m,c){return this.g?this.m(m,2,c):Promise.resolve(void 0)}publicLogError2(m,c){return this.publicLogError(m,c)}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=pe([K(1,I.IConfigurationService),K(2,b.IProductService)],g),e.TelemetryService=g;function w(){const u=(0,P.localize)(0,null,E.default.nameLong),m=E.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=k.isWeb?"":(0,P.localize)(3,null),h=(0,P.localize)(4,null),f=(0,P.localize)(5,null),n=(0,P.localize)(6,null),r=(0,P.localize)(7,null),t=`
|       | ${h} | ${f} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,P.localize)(8,null);return`
${u} ${m} ${c}

&nbsp;

${r}
${t}

&nbsp;

${a}
`}v.Registry.as(S.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[p.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(S.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[p.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,P.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,P.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${p.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[239],ae([0,1,288,238]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends i.AbstractOneDataSystemAppender{constructor(L,P,I,S){const E={sendPOST:(b,v)=>{const p={method:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data)}};try{const d=R.request(b.urlString,p,g=>{g.on("data",function(w){v(g.statusCode??200,g.headers,w.toString())}),g.on("error",function(w){v(0,{})})});d.write(b.data),d.end()}catch{v(0,{})}}};super(L,P,I,S,E)}}e.OneDataSystemAppender=D}),define(re[240],ae([0,1,23,68,16,13,7,25,24,110,111,112]),function(_,e,R,i,D,k,L,P,I,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let v=class{constructor(d,g,w,u,m){this.b=d,this.c=g,this.d=w,this.e=u,this.f=m,this.a=new Map}async g(d){if(!this.a.has(d.id)){const{machineId:g,sessionId:w}=await this.c.getTelemetryInfo(),u=Object.create(null);u["common.vscodemachineid"]=g,u["common.vscodesessionid"]=w;const m=[d.id,JSON.stringify(u),d.aiKey],h=new i.Client(R.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),f=[new S.TelemetryAppenderClient(h),new E.TelemetryLogAppender(this.d,this.e,`[${d.id}] `)];this.a.set(d.id,new b.TelemetryService({appenders:f,sendErrorTelemetry:d.sendErrorTelemetry},this.b,this.f))}return this.a.get(d.id)}async publicLog(d,g,w){await(await this.g(d)).publicLog(g,w)}async publicLogError(d,g,w){await(await this.g(d)).publicLogError(g,w)}};v=pe([K(0,D.IConfigurationService),K(1,I.ITelemetryService),K(2,L.ILoggerService),K(3,k.IEnvironmentService),K(4,P.IProductService)],v),e.CustomEndpointTelemetryService=v}),define(re[241],ae([0,1,6,22,3,2,7]),function(_,e,R,i,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends k.Disposable{constructor(S,E){super(),this.h=E,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new D.Emitter),this.onCreateRequest=this.g.event,this.b=S===void 0?15e3:S}createRequest(S){return new Promise((E,b)=>{const v=++this.a;this.c.set(v,E),this.g.fire({requestId:v,...S});const p=new i.CancellationTokenSource;(0,R.timeout)(this.b,p.token).then(()=>b(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,k.toDisposable)(()=>p.cancel())])})}acceptReply(S,E){const b=this.c.get(S);b?(this.c.delete(S),(0,k.dispose)(this.f.get(S)||[]),this.f.delete(S),b(E)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${S}`)}};P=pe([K(1,L.ILogService)],P),e.RequestStore=P}),define(re[113],ae([0,1,4]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var i;(function(c){c.Shell="terminal.integrated.shell.",c.ShellArgs="terminal.integrated.shellArgs.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(i=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(c){c.ShellLinux="terminal.integrated.shell.linux",c.ShellMacOs="terminal.integrated.shell.osx",c.ShellWindows="terminal.integrated.shell.windows",c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationShellLinux="terminal.integrated.automationShell.linux",c.AutomationShellMacOs="terminal.integrated.automationShell.osx",c.AutomationShellWindows="terminal.integrated.automationShell.windows",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ShellArgsLinux="terminal.integrated.shellArgs.linux",c.ShellArgsMacOs="terminal.integrated.shellArgs.osx",c.ShellArgsWindows="terminal.integrated.shellArgs.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(c){c.FileName="ptyhost"})(k=e.TerminalLogConstants||(e.TerminalLogConstants={}));var L;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(L=e.PosixShellType||(e.PosixShellType={}));var P;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var S;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.Log="log",c.Heartbeat="heartbeat"})(S=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var E;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var v;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(v=e.TerminalLocation||(e.TerminalLocation={}));var p;(function(c){c.TerminalView="view",c.Editor="editor"})(p=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(d=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var g;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(g=e.FlowControlConstants||(e.FlowControlConstants={}));var w;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(w=e.ProfileSource||(e.ProfileSource={}));var u;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(u=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var m;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(m=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(re[242],ae([0,1,4]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(re[243],ae([0,1,34,23,32,12,5,36,27,15,28]),function(_,e,R,i,D,k,L,P,I,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let f=0;return h&&h.length===4&&(f=parseInt(h[3])),f}e.getWindowsBuildNumber=b;async function v(h,f,n,r=P.env,t=E.Promises.exists){if(k.isAbsolute(h))return await t(h)?h:void 0;if(f===void 0&&(f=P.cwd()),k.dirname(h)!=="."){const o=k.join(f,h);return await t(o)?o:void 0}const s=(0,D.getCaseInsensitive)(r,"PATH");if(n===void 0&&(0,S.isString)(s)&&(n=s.split(k.delimiter)),n===void 0||n.length===0){const o=k.join(f,h);return await t(o)?o:void 0}for(const o of n){let y;if(k.isAbsolute(o)?y=k.join(o,h):y=k.join(f,o,h),await t(y))return y;if(L.isWindows){let C=y+".com";if(await t(C)||(C=y+".exe",await t(C)))return C}}const l=k.join(f,h);return await t(l)?l:void 0}e.findExecutable=v;function p(h,f,n,r,t){if(!f.shellIntegration.enabled||!h.executable||h.isFeatureTerminal||h.hideFromUser||h.ignoreShellIntegration||L.isWindows&&!f.windowsEnableConpty)return;const a=h.args,s=P.platform==="win32"?k.basename(h.executable).toLowerCase():k.basename(h.executable),l=k.dirname(i.FileAccess.asFileUri("").fsPath);let o;const y={VSCODE_INJECTION:"1"};if(L.isWindows){if(s==="pwsh.exe")return!a||m(a)?o=e.shellIntegrationArgs.get(d.WindowsPwsh):u(a)&&(o=e.shellIntegrationArgs.get(d.WindowsPwshLogin)),o?(o=[...o],o[o.length-1]=(0,I.format)(o[o.length-1],l,""),{newArgs:o,envMixin:y}):void 0;r.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args);return}switch(s){case"bash":return!a||a.length===0?o=e.shellIntegrationArgs.get(d.Bash):c(a)&&(y.VSCODE_SHELL_LOGIN="1",o=e.shellIntegrationArgs.get(d.Bash)),o?(o=[...o],o[o.length-1]=(0,I.format)(o[o.length-1],l),{newArgs:o,envMixin:y}):void 0;case"pwsh":return!a||m(a)?o=e.shellIntegrationArgs.get(d.Pwsh):u(a)&&(o=e.shellIntegrationArgs.get(d.PwshLogin)),o?(o=[...o],o[o.length-1]=(0,I.format)(o[o.length-1],l,""),{newArgs:o,envMixin:y}):void 0;case"zsh":{if(!a||a.length===0?o=e.shellIntegrationArgs.get(d.Zsh):c(a)?o=e.shellIntegrationArgs.get(d.ZshLogin):(a===e.shellIntegrationArgs.get(d.Zsh)||a===e.shellIntegrationArgs.get(d.ZshLogin))&&(o=a),!o)return;o=[...o],o[o.length-1]=(0,I.format)(o[o.length-1],l);const C=k.join(R.tmpdir(),`${R.userInfo().username}-${t.applicationName}-zsh`);y.ZDOTDIR=C;const T=n?.ZDOTDIR??R.homedir()??"~";y.USER_ZDOTDIR=T;const W=[];return W.push({source:k.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:k.join(C,".zshrc")}),W.push({source:k.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:k.join(C,".zprofile")}),W.push({source:k.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:k.join(C,".zshenv")}),W.push({source:k.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:k.join(C,".zlogin")}),{newArgs:o,envMixin:y,filesToCopy:W}}}r.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args)}e.getShellIntegrationInjection=p;var d;(function(h){h.WindowsPwsh="windows-pwsh",h.WindowsPwshLogin="windows-pwsh-login",h.Pwsh="pwsh",h.PwshLogin="pwsh-login",h.Zsh="zsh",h.ZshLogin="zsh-login",h.Bash="bash"})(d=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(d.Zsh,["-i"]),e.shellIntegrationArgs.set(d.ZshLogin,["-il"]),e.shellIntegrationArgs.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const g=["-login","-l"],w=["-nol","-nologo"];function u(h){return typeof h=="string"?g.includes(h.toLowerCase()):h.length===1&&g.includes(h[0].toLowerCase())||h.length===2&&(g.includes(h[0].toLowerCase())||g.includes(h[1].toLowerCase()))&&(w.includes(h[0].toLowerCase())||w.includes(h[1].toLowerCase()))}function m(h){return typeof h=="string"?w.includes(h.toLowerCase()):h.length===0||h?.length===1&&w.includes(h[0].toLowerCase())}function c(h){return h==="string"&&g.includes(h.toLowerCase())||typeof h!="string"&&h.length===1&&g.includes(h[0].toLowerCase())}}),define(re[244],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var R;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST_DARK="hcDark",k.HIGH_CONTRAST_LIGHT="hcLight"})(R=e.ColorScheme||(e.ColorScheme={}));function i(k){return k===R.HIGH_CONTRAST_DARK||k===R.HIGH_CONTRAST_LIGHT}e.isHighContrast=i;function D(k){return k===R.DARK||k===R.HIGH_CONTRAST_DARK}e.isDark=D}),define(re[114],ae([0,1,52,3,2,4,40,244]),function(_,e,R,i,D,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var I;(function(w){function u(m){return m&&typeof m=="object"&&typeof m.id=="string"}w.isThemeColor=u})(I=e.ThemeColor||(e.ThemeColor={}));function S(w){return{id:w}}e.themeColorFromId=S;var E;(function(w){function u(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||I.isThemeColor(a.color))}w.isThemeIcon=u;const m=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function c(a){const s=m.exec(a);if(!s)return;const[,l]=s;return{id:l}}w.fromString=c;function h(a){return{id:a}}w.fromId=h;function f(a,s){let l=a.id;const o=l.lastIndexOf("~");return o!==-1&&(l=l.substring(0,o)),s&&(l=`${l}~${s}`),{id:l}}w.modify=f;function n(a){const s=a.id.lastIndexOf("~");if(s!==-1)return a.id.substring(s+1)}w.getModifier=n;function r(a,s){return a.id===s.id&&a.color?.id===s.color?.id}w.isEqual=r;function t(a,s){return{id:a.id,color:s?S(s):void 0}}w.asThemeIcon=t,w.asClassNameArray=R.CSSIcon.asClassNameArray,w.asClassName=R.CSSIcon.asClassName,w.asCSSSelector=R.CSSIcon.asCSSSelector})(E=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function b(w){switch(w){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.a=[],this.a=[],this.b=new i.Emitter}onColorThemeChange(u){return this.a.push(u),this.b.fire(u),(0,D.toDisposable)(()=>{const m=this.a.indexOf(u);this.a.splice(m,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const p=new v;L.Registry.add(e.Extensions.ThemingContribution,p);function d(w){return p.onColorThemeChange(w)}e.registerThemingParticipant=d;class g extends D.Disposable{constructor(u){super(),this.k=u,this.h=u.getColorTheme(),this.B(this.k.onDidColorThemeChange(m=>this.n(m)))}n(u){this.h=u,this.updateStyles()}updateStyles(){}w(u,m){let c=this.h.getColor(u);return c&&m&&(c=m(c,this.h)),c?c.toString():null}}e.Themable=g}),define(re[245],ae([0,1,52,8,173,114]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function L(v,p){const d=[{name:null,description:(0,D.localize)(0,null)}];return d.push(...v.map(g=>({name:g.profileName,description:P(g)}))),p&&d.push(...p.map(g=>({name:g.title,description:I(g)}))),{values:d.map(g=>g.name),markdownDescriptions:d.map(g=>g.description)}}e.createProfileSchemaEnums=L;function P(v){let p=`$(${k.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:R.Codicon.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?p+=`
- args: "${v.args}"`:p+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(p+=`
- overrideName: ${v.overrideName}`),v.color&&(p+=`
- color: ${v.color}`),v.env&&(p+=`
- env: ${JSON.stringify(v.env)}`),p}function I(v){return`$(${k.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:R.Codicon.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function S(v,p){if(!v&&!p)return!0;if(typeof v=="string"&&typeof p=="string")return v===p;if(Array.isArray(v)&&Array.isArray(p)){if(v.length!==p.length)return!1;for(let d=0;d<v.length;d++)if(v[d]!==p[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function E(v,p){if(!v&&!p)return!0;if(!v||!p)return!1;if(k.ThemeIcon.isThemeIcon(v)&&k.ThemeIcon.isThemeIcon(p))return v.id===p.id&&v.color===p.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof p=="object"&&"light"in p&&"dark"in p){const d=v,g=p;if((i.URI.isUri(d.light)||b(d.light))&&(i.URI.isUri(d.dark)||b(d.dark))&&(i.URI.isUri(g.light)||b(g.light))&&(i.URI.isUri(g.dark)||b(g.dark)))return d.light.path===g.light.path&&d.dark.path===g.dark.path}if(i.URI.isUri(v)&&i.URI.isUri(p)||b(v)||b(p)){const d=v,g=p;return d.path===g.path&&d.scheme===g.scheme}return!1}e.terminalIconsEqual=E;function b(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.isUriComponents=b}),define(re[246],ae([0,1,52,172,45,40,245]),function(_,e,R,i,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(R.Codicon.getAll(),h=>h.id),markdownEnumDescriptions:Array.from(R.Codicon.getAll(),h=>`$(${h.id})`)};const P={args:{description:(0,i.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,i.localize)(1,null),type:"boolean"},icon:{description:(0,i.localize)(2,null),...e.terminalIconSchema},color:{description:(0,i.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,i.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},S={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(6,null),type:["string"],items:{type:"string"}},...P}},E=(0,i.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),b=(0,i.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),v=(0,i.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,i.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,i.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),g=(0,i.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),w={id:"terminal",order:100,title:(0,i.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,i.localize)(26,null)}},{type:"string",markdownDescription:(0,i.localize)(27,null)}],default:[],markdownDeprecationMessage:v},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,i.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(30,null),type:"string"},id:{description:(0,i.localize)(31,null),type:"string"},title:{description:(0,i.localize)(32,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(34,null),type:"string"},id:{description:(0,i.localize)(35,null),type:"string"},title:{description:(0,i.localize)(36,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(38,null),type:"string"},id:{description:(0,i.localize)(39,null),type:"string"},title:{description:(0,i.localize)(40,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,i.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,i.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,i.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,i.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,i.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){k.Registry.as(D.Extensions.Configuration).registerConfiguration(w),c()}e.registerTerminalPlatformConfiguration=u;let m;function c(h,f){const n=k.Registry.as(D.Extensions.Configuration);let r;h&&(r=(0,L.createProfileSchemaEnums)(h?.profiles,f));const t=m;m={id:"terminal",order:100,title:(0,i.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:h?.os===3?r?.values:void 0,markdownEnumDescriptions:h?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:h?.os===2?r?.values:void 0,markdownEnumDescriptions:h?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:h?.os===1?r?.values:void 0,markdownEnumDescriptions:h?.os===1?r?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[m],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=c}),define(re[247],ae([0,1,50,52,12,5,28,90,243,114]),function(_,e,R,i,D,k,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let E,b=!0;function v(r,t,a,s,l=process.env,o,y,C,T){return o=o||{existsFile:L.SymlinkSupport.existsFile,readFile:L.Promises.readFile},k.isWindows?p(a,o,l,y,s.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:s.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:s.getValue("terminal.integrated.defaultProfile.windows"),T,C):h(o,y,a,r&&typeof r=="object"?{...r}:s.getValue(k.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:s.getValue(k.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),T,C,l)}e.detectAvailableProfiles=v;async function p(r,t,a,s,l,o,y,C,T){const W=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${W?"Sysnative":"System32"}`;let j=!1;(0,I.getWindowsBuildNumber)()>=16299&&(j=!0),await w(C);const F=new Map;r&&(F.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),F.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:i.Codicon.terminalCmd,isAutoDetected:!0})),f(o,F);const A=await d(F.entries(),y,t,a,s,T);if(r||l)try{const M=await m(`${O}\\${j?"wsl":"bash"}.exe`,y);for(const B of M)(!o||!(B.profileName in o))&&A.push(B)}catch{b&&(s?.info("WSL is not installed, so could not detect WSL profiles"),b=!1)}return A}async function d(r,t,a,s=process.env,l,o){const y=[];for(const[C,T]of r){if(T===null)continue;let W,O,j;if("source"in T){const M=E?.get(T.source);if(!M)continue;W=M.paths,O=T.args||M.args,T.icon?j=g(T.icon):M.icon&&(j=M.icon)}else W=Array.isArray(T.path)?T.path:[T.path],O=k.isWindows||Array.isArray(T.args)?T.args:void 0,j=g(T.icon);const F=await o?.(W)||W.slice(),A=await n(C,t,F,a,s,O,T.env,T.overrideName,T.isAutoDetected,l);A?(A.isAutoDetected=T.isAutoDetected,A.icon=j,A.color=T.color,y.push(A)):l?.debug("Terminal profile not validated",C,W)}return l?.debug("Validated terminal profiles",y),y}function g(r){return typeof r=="string"?{id:r}:r}async function w(r){E&&!r||(E=new Map,E.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),E.set("PowerShell",{profileName:"PowerShell",paths:r||await u(),icon:S.ThemeIcon.asThemeIcon(i.Codicon.terminalPowershell)}))}async function u(){const r=[];for await(const t of(0,P.enumeratePowerShellInstallations)())r.push(t.exePath);return r}async function m(r,t){const a=[],s=await new Promise((y,C)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(T,W)=>{if(T)return C("Problem occurred when getting wsl distros");y(W)})});if(!s)return[];const l=new RegExp(/[\r?\n]/),o=s.split(l).filter(y=>y.trim().length>0&&y!=="");for(const y of o){if(y===""||y.startsWith("docker-desktop"))continue;const C=`${y} (WSL)`,T={profileName:C,path:r,args:["-d",`${y}`],isDefault:C===t,icon:c(y),isAutoDetected:!1};a.push(T)}return a}function c(r){return r.includes("Ubuntu")?S.ThemeIcon.asThemeIcon(i.Codicon.terminalUbuntu):r.includes("Debian")?S.ThemeIcon.asThemeIcon(i.Codicon.terminalDebian):S.ThemeIcon.asThemeIcon(i.Codicon.terminalLinux)}async function h(r,t,a,s,l,o,y,C){const T=new Map;if(a){const W=(await r.readFile("/etc/shells")).toString(),O=o||W.split(`
`).filter(F=>F.trim().indexOf("#")!==0&&F.trim().length>0),j=new Map;for(const F of O){let A=(0,D.basename)(F),M=j.get(A)||0;M++,M>1&&(A=`${A} (${M})`),j.set(A,M),T.set(A,{path:F,isAutoDetected:!0})}}return f(s,T),await d(T.entries(),l,r,C,t,y)}function f(r,t){if(!!r)for(const[a,s]of Object.entries(r))s===null||!("path"in s)&&!("source"in s)?t.delete(a):(s.icon=s.icon||t.get(a)?.icon,t.set(a,s))}async function n(r,t,a,s,l,o,y,C,T,W){if(a.length===0)return Promise.resolve(void 0);const O=a.shift();if(O==="")return n(r,t,a,s,l,o,y,C,T);const j={profileName:r,path:O,args:o,env:y,overrideName:C,isAutoDetected:T,isDefault:r===t};if((0,D.basename)(O)===O){const A=l.PATH?l.PATH.split(D.delimiter):void 0,M=await(0,I.findExecutable)(O,void 0,A,void 0,s.existsFile);return M?(j.path=M,j.isFromPath=!0,j):n(r,t,a,s,l,o)}return await s.existsFile((0,D.normalize)(O))?j:n(r,t,a,s,l,o,y,C,T)}}),define(re[248],ae([0,1,3,2,23,5,39,68,16,13,94,233,7,102,241,113,246,247]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let c=0,h=class extends i.Disposable{constructor(n,r,t,a){super(),this.D=n,this.F=r,this.G=t,this.H=a,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new R.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new R.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new R.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new R.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new R.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new R.Emitter),this.onProcessData=this.s.event,this.t=this.B(new R.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new R.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new R.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new R.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new R.Emitter),this.onDidChangeProperty=this.y.event,this.C=this.B(new R.Emitter),this.onProcessExit=this.C.event,(0,w.registerTerminalPlatformConfiguration)(),this.c=this.L(),this.B((0,i.toDisposable)(()=>this.N())),this.f=this.B(new d.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.M(),this.B(this.F.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.J()}))}initialize(){this.J()}get I(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async J(){return this.b.refreshIgnoreProcessNames?.(this.I)}async L(){if(k.isWindows)return process.env;try{return await(0,b.getResolvedShellEnv)(this.H,{_:[]},process.env)}catch(n){return this.H.error("ptyHost was unable to resolve shell environment",n),{}}}M(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsPath],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.D.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.D.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.D.scrollback}},r=(0,E.parsePtyHostPort)(this.G.args,this.G.isBuilt);r&&(r.break&&r.port?n.debugBrk=r.port:!r.break&&r.port&&(n.debug=r.port));const t=new P.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,n);this.m.fire(),L.ProxyChannel.toService(t.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.O()),this.O(),this.B(t.onDidProcessExit(o=>{this.l.fire(o.code),this.i||(this.g<=m.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const s=t.getChannel(g.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(s,this.H.getLevel()),this.B(this.H.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(s,this.H.getLevel())}));const l=L.ProxyChannel.toService(t.getChannel(g.TerminalIpcChannels.PtyHost));return this.B(l.onProcessData(o=>this.s.fire(o))),this.B(l.onProcessReady(o=>this.t.fire(o))),this.B(l.onProcessExit(o=>this.C.fire(o))),this.B(l.onDidChangeProperty(o=>this.y.fire(o))),this.B(l.onProcessReplay(o=>this.u.fire(o))),this.B(l.onProcessOrphanQuestion(o=>this.v.fire(o))),this.B(l.onDidRequestDetach(o=>this.w.fire(o))),[t,l]}dispose(){this.i=!0,super.dispose()}async createProcess(n,r,t,a,s,l,o,y,C,T,W){const O=setTimeout(()=>this.R(),g.HeartbeatConstants.CreateProcessTimeout),j=await this.b.createProcess(n,r,t,a,s,l,o,y,C,T,W);return clearTimeout(O),c=Math.max(c,j),j}updateTitle(n,r,t){return this.b.updateTitle(n,r,t)}updateIcon(n,r,t,a){return this.b.updateIcon(n,r,t,a)}attachToProcess(n){return this.b.attachToProcess(n)}detachFromProcess(n,r){return this.b.detachFromProcess(n,r)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(n){return this.b.start(n)}shutdown(n,r){return this.b.shutdown(n,r)}input(n,r){return this.b.input(n,r)}processBinary(n,r){return this.b.processBinary(n,r)}resize(n,r,t){return this.b.resize(n,r,t)}acknowledgeDataEvent(n,r){return this.b.acknowledgeDataEvent(n,r)}setUnicodeVersion(n,r){return this.b.setUnicodeVersion(n,r)}getInitialCwd(n){return this.b.getInitialCwd(n)}getCwd(n){return this.b.getCwd(n)}getLatency(n){return this.b.getLatency(n)}orphanQuestionReply(n){return this.b.orphanQuestionReply(n)}installAutoReply(n,r){return this.b.installAutoReply(n,r)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(n){return this.b.uninstallAutoReply(n)}getDefaultSystemShell(n){return this.b.getDefaultSystemShell(n)}async getProfiles(n,r,t,a=!1){const s=await this.c;return(0,u.detectAvailableProfiles)(r,t,a,this.F,s,void 0,this.H,this.U.bind(this,n))}getEnvironment(){return this.b.getEnvironment()}getWslPath(n){return this.b.getWslPath(n)}getRevivedPtyNewId(n){return this.b.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this.b.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this.b.getTerminalLayoutInfo(n)}async requestDetachInstance(n,r){return this.b.requestDetachInstance(n,r)}async acceptDetachInstanceReply(n,r){return this.b.acceptDetachInstanceReply(n,r)}async freePortKillProcess(n){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(n)}async serializeTerminalState(n){return this.b.serializeTerminalState(n)}async reviveTerminalProcesses(n,r){return this.b.reviveTerminalProcesses(n,r)}async refreshProperty(n,r){return this.b.refreshProperty(n,r)}async updateProperty(n,r,t){return this.b.updateProperty(n,r,t)}async restartPtyHost(){this.h=!0,this.N(),[this.a,this.b]=this.M()}N(){this.b.shutdownAll?.(),this.a.dispose()}O(){this.S(),this.j=setTimeout(()=>this.P(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}P(){this.H.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.Q(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}Q(){this.H.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}R(){this.S(),this.H.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}S(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}U(n,r){return this.f.createRequest({workspaceId:n,originalText:r})}async acceptPtyHostResolvedVariables(n,r){this.f.acceptReply(n,r)}};h=pe([K(1,I.IConfigurationService),K(2,S.IEnvironmentService),K(3,v.ILogService)],h),e.PtyHostService=h}),define(re[76],ae([0,1,3,16,4,7]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var L;(function(g){g.Http="http",g.Https="https"})(L=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=E,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=b;function v(g,w,u,m){if(u===1)return!1;if(u===2&&b(w)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(c?.length===4&&parseInt(c[1])>=18)return!1}return g<1024}e.isPortPrivileged=v;class p{constructor(w,u,m){this.remoteAddress=w,this.localAddress=u,this.b=m,this.a=new R.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=p;let d=class{constructor(w,u){this.i=w,this.j=u,this.a=new R.Emitter,this.onTunnelOpened=this.a.event,this.b=new R.Emitter,this.onTunnelClosed=this.b.event,this.c=new R.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const w=this.j.getValue("remote.localPortHost");return!w||w==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(w){return this.e=w,w?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(w){this.f=w.elevation,this.g=w.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const w=[],u=Array.from(this.d.values());for(const m of u){const c=Array.from(m.values());for(const h of c){const f=await h.value;f&&w.push(f)}}return w}async dispose(){for(const w of this.d.values()){for(const{value:u}of w.values())await u.then(m=>m?.dispose());w.clear()}this.d.clear()}setEnvironmentTunnel(w,u,m,c,h){this.o(w,u,Promise.resolve({tunnelRemoteHost:w,tunnelRemotePort:u,localAddress:m,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(w,u){(b(w)||E(w))&&(w=e.LOCALHOST_ADDRESSES[0]);const m=this.q(w,u);if(m)return++m.refcount,m.value}openTunnel(w,u,m,c,h=!1,f,n){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${m} on local port ${c}.`),!w)return;if(u||(u="localhost"),this.e&&this.h.has(m)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(w,u,m,c,h,f,n);return r?r.then(t=>{if(!t){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,m);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.m(t);return(t.tunnelRemoteHost!==u||t.tunnelRemotePort!==m)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(a),a}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const u=this.d.get(w.tunnelRemoteHost);if(u){const m=u.get(w.tunnelRemotePort);m&&(m.refcount--,await this.n(w.tunnelRemoteHost,w.tunnelRemotePort,m))}}}}async n(w,u,m){if(m.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${u}.`);const c=m.value.then(async h=>{h&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.d.has(w)&&this.d.get(w).delete(u),c}}async closeTunnel(w,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${u} `);const m=this.d.get(w);if(m&&m.has(u)){const c=m.get(u);c.refcount=0,await this.n(w,u,c)}}o(w,u,m){this.d.has(w)||this.d.set(w,new Map),this.d.get(w).set(u,{refcount:1,value:m})}async p(w,u){const m=this.d.get(w);m&&(await m.get(u)||m.delete(u),m.size===0&&this.d.delete(w))}q(w,u){const m=[w];E(w)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):b(w)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const c=m.map(h=>this.d.get(h));for(const h of c){const f=h?.get(u);if(f)return f}}canTunnel(w){return!!S(w)}s(w,u,m,c,h,f,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${m} on local port ${c}.`);const r=m;this.h.add(r);const t=c===void 0?m:c,a={elevationRequired:h?this.isPortPrivileged(t):!1},s={remoteAddress:{host:u,port:m},localAddressPort:c,privacy:f,public:f?f!==P.Private:void 0,protocol:n},l=w.forwardPort(s,a);return l?(this.o(u,m,l),l.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),l}};d=pe([K(0,k.ILogService),K(1,i.IConfigurationService)],d),e.AbstractTunnelService=d}),define(re[249],ae([0,1,7,76,2,9,6]),function(_,e,R,i,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends D.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new L.DeferredPromise),this.b.p)}setAddress(E){this.a=E,this.b&&(this.b.complete(E),this.b=null)}setTunnel(E){this.B(E)}}let I=class kt extends D.Disposable{constructor(E,b){super(),this.f=E,this.g=b,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++kt.a)}}async startTunnel(E,b,v,p,d,g){const w=new P,u=await Promise.resolve(this.f.openTunnel(E,w,v,p,d,g));if(!u)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${v}:${p} (remote).`),w.dispose(),new Error("Could not create tunnel");if(this.c.has(b))throw this.c.delete(b),w.dispose(),await u.dispose(),(0,k.canceled)();return w.setTunnel(u),this.b.set(b,w),this.g.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${u.localAddress} (local) to ${v}:${p} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(E,b){const v=this.b.get(E);!v||v.setAddress(b)}async destroyTunnel(E){const b=this.b.get(E);if(b){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this.b.delete(E),await b.dispose();return}this.c.add(E)}};I.a=0,I=pe([K(0,i.ISharedTunnelsService),K(1,R.ILogService)],I),e.SharedProcessTunnelService=I}),define(re[250],ae([0,1,85,34,131,224,6,2,16,7,25,222,76,108,5]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function g(h,f,n,r,t){let a;for(let s=3;s&&(a?.dispose(),a=await new w(h,f,n,r,t).waitForReady(),!(t&&D.BROWSER_RESTRICTED_PORTS[t]||!D.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));s--);return a}class w extends P.Disposable{constructor(f,n,r,t,a){super(),this.j=n,this.k=a,this.privacy=v.TunnelPrivacyId.Private,this.i=new Map,this.a=f,this.b=R.createServer(),this.c=new L.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(n=>{n()})}async waitForReady(){const f=this.k??this.tunnelRemotePort,n=(0,v.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,D.findFreePortFaster)(f,2,1e3,n),t=null;return this.b.listen(r,this.j),await this.c.wait(),t=this.b.address(),t||(r=0,this.b.listen(r,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(f){f.pause();const n=(0,v.isLocalhost)(this.tunnelRemoteHost)||(0,v.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,b.connectRemoteAgentTunnel)(this.a,n,this.tunnelRemotePort),t=r.getSocket().socket,a=r.readEntireBuffer();r.dispose(),a.byteLength>0&&f.write(a.buffer),f.on("end",()=>{f.localAddress&&this.i.delete(f.localAddress),t.end()}),f.on("close",()=>t.end()),f.on("error",()=>{f.localAddress&&this.i.delete(f.localAddress),t.destroy()}),t.on("end",()=>f.end()),t.on("close",()=>f.end()),t.on("error",()=>{f.destroy()}),f.pipe(t),t.pipe(f),f.localAddress&&this.i.set(f.localAddress,()=>{f.end(),t.end()})}}let u=class extends v.AbstractTunnelService{constructor(f,n,r,t,a){super(n,a),this.t=f,this.u=r,this.v=t}isPortPrivileged(f){return(0,v.isPortPrivileged)(f,this.k,d.OS,i.release())}r(f,n,r,t,a,s,l){const o=this.q(n,r);if(o)return++o.refcount,o.value;if(this.e)return this.s(this.e,n,r,t,a,s,l);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${r} on local port ${t}.`);const y={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:f,signService:this.u,logService:this.i,ipcLogger:null},C=g(y,this.k,n,r,t);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(n,r,C),C}}};u=pe([K(1,S.ILogService),K(2,p.ISignService),K(3,E.IProductService),K(4,I.IConfigurationService)],u),e.BaseTunnelService=u;let m=class extends u{constructor(f,n,r,t){super(k.nodeSocketFactory,f,n,r,t)}};m=pe([K(0,S.ILogService),K(1,p.ISignService),K(2,E.IProductService),K(3,I.IConfigurationService)],m),e.TunnelService=m;let c=class extends P.Disposable{constructor(f,n,r,t){super(),this.b=f,this.c=n,this.f=r,this.g=t,this.a=new Map}async openTunnel(f,n,r,t,a,s,l,o){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${t} on local port ${a}.`),!this.a.has(f)){const y=new m(this.b,this.f,this.c,this.g);this.B(y),this.a.set(f,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(f))})}return this.a.get(f).openTunnel(n,r,t,a,s,l,o)}};c=pe([K(0,S.ILogService),K(1,E.IProductService),K(2,p.ISignService),K(3,I.IConfigurationService)],c),e.SharedTunnelsService=c}),define(re[31],ae([0,1,4]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,R.createDecorator)("IUriIdentityService")}),define(re[251],ae([0,1,31,71,14,20,129,3,2]),function(_,e,R,i,D,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(v){this.uri=v,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let E=class{constructor(v){this.g=v,this.c=new I.DisposableStore,this.f=2**16;const p=new Map,d=g=>{let w=p.get(g.scheme);return w===void 0&&(w=v.hasProvider(g)&&!this.g.hasCapability(g,1024),p.set(g.scheme,w)),w};this.c.add(P.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(g=>{p.delete(g.scheme)})),this.extUri=new k.ExtUri(d),this.d=new L.SkipList((g,w)=>this.extUri.compare(g,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,k.normalizePath)(v));const p=this.d.get(v);return p?p.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new S(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((d,g)=>d[1].touch<g[1].touch?1:d[1].touch>g[1].touch?-1:0);S._clock=0,this.d.clear();const p=this.f*.5;for(let d=0;d<p;d++)this.d.set(v[d][0],v[d][1].touch())}};E=pe([K(0,D.IFileService)],E),e.UriIdentityService=E,(0,i.registerSingleton)(R.IUriIdentityService,E,1)}),define(re[252],ae([0,1,3,2,14,43,49,17]),function(_,e,R,i,D,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends i.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(E,b,v,p){super(),this.c=E,this.f=b,this.g=v,this.h=p,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new R.Emitter),this.onDidChangeFile=this.a.event,this.b=L.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(d=>this.i(d)))}watch(E,b){this.b.set(E,E);const v=this.f.watch(this.j(E),b);return(0,i.toDisposable)(()=>{this.b.delete(E),v.dispose()})}stat(E){return this.f.stat(this.j(E))}mkdir(E){return this.f.mkdir(this.j(E))}rename(E,b,v){return this.f.rename(this.j(E),this.j(b),v)}readFile(E){return this.f.readFile(this.j(E),{atomic:!0})}readFileStream(E,b,v){const p=(0,k.newWriteableStream)(d=>P.VSBuffer.concat(d.map(g=>P.VSBuffer.wrap(g))).buffer);return(async()=>{try{const d=await this.readFile(E);p.end(d)}catch(d){p.error(d),p.end()}})(),p}readdir(E){return this.f.readdir(this.j(E))}writeFile(E,b,v){return this.f.writeFile(this.j(E),b,v)}delete(E,b){return this.f.delete(this.j(E),b)}copy(E,b,v){if((0,D.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(E),this.j(b),v);throw new Error("copy not supported")}i(E){const b=[];for(const v of E){if(v.resource.scheme!==this.c)continue;const p=this.k(v.resource);this.b.findSubstr(p)&&b.push({resource:p,type:v.type})}b.length&&(this.h.debug("User data changed"),this.a.fire(b))}j(E){return E.with({scheme:this.c})}k(E){return E.with({scheme:this.g})}}e.FileUserDataProvider=I}),define(re[61],ae([0,1,82]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function i(L,P,I,S){const E=(0,R.setProperty)(L,P,I,S)[0];return E&&(L=L.substring(0,E.offset)+E.content+L.substring(E.offset+E.length)),L}e.edit=i;function D(L,P,I){let S=I;for(;S>=0;){if(L.charAt(S)===P.charAt(P.length-1)&&P.length===1)return S+1;if(S--,P.length===2&&S>=0&&L.charAt(S)===P.charAt(0))return S+2}return 0}e.getLineStartOffset=D;function k(L,P,I){let S=I;for(;S>=0;)if(L.charAt(S)===P.charAt(P.length-1)&&P.length===1||(S++,P.length===2&&S>=0&&L.charAt(S)===P.charAt(1)))return S;return L.length-1}e.getLineEndOffset=k}),define(re[253],ae([0,1,32,54,15]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(p,d,g,w,u,m){const c=[],h=[],f=[];if(!d){const M=p.filter(({identifier:B})=>u.every(G=>G.toLowerCase()!==B.id.toLowerCase()));return{local:{added:c,removed:h,updated:f},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}p=p.map(b),d=d.map(b),g=g?g.map(b):null;const n=new Map,r=M=>{M.uuid&&n.set(M.id.toLowerCase(),M.uuid)};p.forEach(({identifier:M})=>r(M)),d.forEach(({identifier:M})=>r(M)),g?.forEach(({identifier:M})=>r(M));const t=M=>{const B=M.identifier.uuid||n.get(M.identifier.id.toLowerCase());return B?`uuid:${B}`:`id:${M.identifier.id.toLowerCase()}`},a=(M,B)=>(M.set(t(B),B),M),s=p.reduce(a,new Map),l=d.reduce(a,new Map),o=d.reduce((M,B)=>a(M,(0,R.deepClone)(B)),new Map),y=g?g.reduce(a,new Map):null,C=w.reduce(a,new Map),T=u.reduce((M,B)=>{const G=n.get(B.toLowerCase());return M.add(G?`uuid:${G}`:`id:${B.toLowerCase()}`)},new Set),W=m.reduce((M,{id:B,uuid:G})=>(G=G??n.get(B.toLowerCase()),M.add(G?`uuid:${G}`:`id:${B.toLowerCase()}`)),new Set),O=L(s,l,T,!1);if(O.added.size>0||O.removed.size>0||O.updated.size>0){const M=L(y,s,T,!1),B=L(y,l,T,!0),G=(V,Q,$,z)=>({...z,installed:Q.installed||$.installed,version:$.version&&(!Q.installed||i.gt($.version,Q.version))?$.version:Q.version,state:I(Q,$,y?.get(V)),preRelease:(Q.installed?z.preRelease:$.preRelease)??Q.preRelease});for(const V of B.removed.values()){const Q=s.get(V);if(!Q)continue;const $=(0,D.assertIsDefined)(y?.get(V)),z=!W.has(V)&&$.installed;Q.installed&&z?h.push(Q.identifier):o.set(V,Q)}for(const V of B.added.values()){const Q=(0,D.assertIsDefined)(l.get(V)),$=s.get(V);if($){if(O.updated.has(V)){const z=G(V,$,Q,Q);P($,Q,!1,!1)||f.push(v(z,V)),o.set(V,z)}}else Q.installed&&c.push(v(Q,V))}for(const V of B.updated.values()){const Q=(0,D.assertIsDefined)(l.get(V)),$=(0,D.assertIsDefined)(y?.get(V)),z=s.get(V);if(z)if(!W.has(V)&&$.installed&&z.installed&&!Q.installed)h.push(z.identifier);else{const ee=G(V,z,Q,Q);f.push(v(ee,V)),o.set(V,ee)}else Q.installed&&c.push(v(Q,V))}for(const V of M.added.values())B.added.has(V)||o.set(V,(0,D.assertIsDefined)(s.get(V)));for(const V of M.updated.values()){if(B.removed.has(V)||B.updated.has(V))continue;const Q=(0,D.assertIsDefined)(s.get(V)),$=(0,D.assertIsDefined)(l.get(V));o.set(V,G(V,Q,$,Q))}for(const V of M.removed.values())B.updated.has(V)||B.removed.has(V)||C.has(V)||!(0,D.assertIsDefined)(l.get(V)).installed||W.has(V)||!(0,D.assertIsDefined)(y?.get(V)).installed||o.delete(V)}const j=[],F=L(l,o,new Set,!0),A=F.added.size>0||F.updated.size>0||F.removed.size>0;return A&&o.forEach((M,B)=>j.push(v(M,B))),{local:{added:c,removed:h,updated:f},remote:A?{added:[...F.added].map(M=>o.get(M)),updated:[...F.updated].map(M=>o.get(M)),removed:[...F.removed].map(M=>l.get(M)),all:j}:null}}e.merge=k;function L(p,d,g,w){const u=p?[...p.keys()].filter(n=>!g.has(n)):[],m=[...d.keys()].filter(n=>!g.has(n)),c=m.filter(n=>u.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),h=u.filter(n=>m.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),f=new Set;for(const n of u){if(h.has(n))continue;const r=p.get(n),t=d.get(n);(!t||!P(r,t,w,!0))&&f.add(n)}return{added:c,removed:h,updated:f}}function P(p,d,g,w){return!(p.disabled!==d.disabled||w&&p.installed!==d.installed||p.installed&&d.installed&&p.preRelease!==d.preRelease||!E(p.state,d.state)||g&&p.version!==d.version)}function I(p,d,g){const w=p.state,u=d.state,m=g?.state;if(!d.version||w&&i.gt(p.version,d.version))return w;if(u&&i.gt(d.version,p.version)||!w)return u;if(!u)return w;const c=(0,R.deepClone)(w),h=m?S(m,u):{added:Object.keys(u).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set},f=m?S(m,w):{added:Object.keys(w).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set};for(const n of[...h.added.values(),...h.updated.values()])c[n]=u[n];for(const n of h.removed.values())f.updated.has(n)||delete c[n];return c}function S(p,d){const g=Object.keys(p),w=Object.keys(d),u=w.filter(h=>g.indexOf(h)===-1).reduce((h,f)=>(h.add(f),h),new Set),m=g.filter(h=>w.indexOf(h)===-1).reduce((h,f)=>(h.add(f),h),new Set),c=new Set;for(const h of g){if(m.has(h))continue;const f=p[h],n=d[h];(0,R.equals)(f,n)||c.add(h)}return{added:u,removed:m,updated:c}}function E(p={},d={}){const{added:g,removed:w,updated:u}=S(p,d);return g.size===0&&w.size===0&&u.size===0}function b(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function v(p,d){const g={identifier:{id:p.identifier.id,uuid:d.startsWith("uuid:")?d.substring(5):void 0},preRelease:!!p.preRelease};return p.version&&(g.version=p.version),p.disabled&&(g.disabled=!0),p.installed&&(g.installed=!0),p.state&&(g.state=p.state),g}}),define(re[115],ae([0,1,19,16,4]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(P){this.a=P}hasToNeverSyncExtension(P){return this.b().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.b().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,I){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return S=S.filter(E=>E!==P&&E!==`-${P}`),I&&S.push(P.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}updateSynchronizedExtensions(P,I){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return S=S.filter(E=>E!==P&&E!==`-${P}`),I&&S.push(`-${P.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}getIgnoredExtensions(P){const I=P.filter(v=>v.isMachineScoped).map(v=>v.identifier.id.toLowerCase()),S=this.b().map(v=>v.toLowerCase()),E=[],b=[];if(Array.isArray(S))for(const v of S)v.startsWith("-")?b.push(v.substring(1)):E.push(v);return(0,R.distinct)([...I,...E].filter(v=>b.indexOf(v)===-1))}b(){let P=this.a.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.a.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};k=pe([K(0,i.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(re[254],ae([0,1,19,35,32,193,61]),function(_,e,R,i,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(h){return(0,i.parse)(h)||[]}e.parseKeybindings=P;async function I(h,f,n,r,t){const a=P(h),s=P(f),l=n?P(n):null,o=[...a,...s,...l||[]].map(G=>G.key),y=await t.resolveUserBindings(o),C=E(a,s,l,y);if(!C.hasLocalForwarded&&!C.hasRemoteForwarded)return{mergeContent:h,hasChanges:!1,hasConflicts:!1};if(!C.hasLocalForwarded&&C.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};if(C.hasLocalForwarded&&!C.hasRemoteForwarded)return{mergeContent:h,hasChanges:!0,hasConflicts:!1};const T=v(a),W=v(s),O=l?v(l):null,j=d(T,W,y),F=O?d(O,T,y):{added:[...T.keys()].reduce((G,V)=>(G.add(V),G),new Set),removed:new Set,updated:new Set},A=O?d(O,W,y):{added:[...W.keys()].reduce((G,V)=>(G.add(V),G),new Set),removed:new Set,updated:new Set},M=S(j,F,A);let B=h;for(const G of M.removed.values())M.conflicts.has(G)||(B=m(B,G,r));for(const G of M.added.values()){if(M.conflicts.has(G))continue;const V=W.get(G);if(V.some(Q=>Q.command!==`-${G}`&&C.conflicts.has(y[Q.key]))){M.conflicts.add(G);continue}B=u(B,V,r)}for(const G of M.updated.values()){if(M.conflicts.has(G))continue;const V=W.get(G);if(V.some(Q=>Q.command!==`-${G}`&&C.conflicts.has(y[Q.key]))){M.conflicts.add(G);continue}B=c(B,G,V,r)}return{mergeContent:B,hasChanges:!0,hasConflicts:M.conflicts.size>0}}e.merge=I;function S(h,f,n){const r=new Set,t=new Set,a=new Set,s=new Set;for(const l of f.removed.values())n.updated.has(l)&&s.add(l);for(const l of n.removed.values())s.has(l)||(f.updated.has(l)?s.add(l):t.add(l));for(const l of f.added.values())s.has(l)||n.added.has(l)&&h.updated.has(l)&&s.add(l);for(const l of n.added.values())s.has(l)||(f.added.has(l)?h.updated.has(l)&&s.add(l):r.add(l));for(const l of f.updated.values())s.has(l)||n.updated.has(l)&&h.updated.has(l)&&s.add(l);for(const l of n.updated.values())s.has(l)||(f.updated.has(l)?h.updated.has(l)&&s.add(l):a.add(l));return{added:r,removed:t,updated:a,conflicts:s}}function E(h,f,n,r){const t=new Set,a=b(h,r),s=b(f,r),l=n?b(n,r):null,o=p(a,s);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const y=l?p(l,a):{added:[...a.keys()].reduce((F,A)=>(F.add(A),F),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const C=l?p(l,s):{added:[...s.keys()].reduce((F,A)=>(F.add(A),F),new Set),removed:new Set,updated:new Set};if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:T,removed:W,updated:O,conflicts:j}=S(o,y,C);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:T,removed:W,updated:O,conflicts:j}}function b(h,f){const n=new Map;for(const r of h){const t=f[r.key];let a=n.get(t);a||(a=[],n.set(t,a)),a.push(r)}return n}function v(h){const f=new Map;for(const n of h){const r=n.command[0]==="-"?n.command.substring(1):n.command;let t=f.get(r);t||(t=[],f.set(r,t)),t.push(n)}return f}function p(h,f){const n=[...h.keys()],r=[...f.keys()],t=r.filter(l=>n.indexOf(l)===-1).reduce((l,o)=>(l.add(o),l),new Set),a=n.filter(l=>r.indexOf(l)===-1).reduce((l,o)=>(l.add(o),l),new Set),s=new Set;for(const l of n){if(a.has(l))continue;const o=h.get(l).map(C=>({...C,key:l})),y=f.get(l).map(C=>({...C,key:l}));(0,R.equals)(o,y,(C,T)=>w(C,T))||s.add(l)}return{added:t,removed:a,updated:s}}function d(h,f,n){const r=[...h.keys()],t=[...f.keys()],a=t.filter(o=>r.indexOf(o)===-1).reduce((o,y)=>(o.add(y),o),new Set),s=r.filter(o=>t.indexOf(o)===-1).reduce((o,y)=>(o.add(y),o),new Set),l=new Set;for(const o of r){if(s.has(o))continue;const y=h.get(o).map(T=>({...T,key:n[T.key]})),C=f.get(o).map(T=>({...T,key:n[T.key]}));g(y,C)||l.add(o)}return{added:a,removed:s,updated:l}}function g(h,f){return!(!(0,R.equals)(h.filter(({command:n})=>n[0]!=="-"),f.filter(({command:n})=>n[0]!=="-"),(n,r)=>w(n,r))||!(0,R.equals)(h.filter(({command:n})=>n[0]==="-"),f.filter(({command:n})=>n[0]==="-"),(n,r)=>w(n,r)))}function w(h,f){if(h.command!==f.command||h.key!==f.key)return!1;const n=k.ContextKeyExpr.deserialize(h.when),r=k.ContextKeyExpr.deserialize(f.when);return!(n&&!r||!n&&r||n&&r&&!n.equals(r)||!D.equals(h.args,f.args))}function u(h,f,n){for(const r of f)h=L.edit(h,[-1],r,n);return h}function m(h,f,n){const r=P(h);for(let t=r.length-1;t>=0;t--)(r[t].command===f||r[t].command===`-${f}`)&&(h=L.edit(h,[t],void 0,n));return h}function c(h,f,n,r){const t=P(h),a=t.findIndex(s=>s.command===f||s.command===`-${f}`);for(let s=t.length-1;s>=0;s--)(t[s].command===f||t[s].command===`-${f}`)&&(h=L.edit(h,[s],void 0,r));for(let s=n.length-1;s>=0;s--)h=L.edit(h,[a],n[s],r);return h}}),define(re[255],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(k,L,P){const I={},S={},E=new Set;if(!L)return{local:{added:I,updated:S,removed:[...E.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const b=i(k,L);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:I,updated:S,removed:[...E.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const v=i(P,k),p=i(P,L),d={},g={},w=new Set,u=new Set;for(const m of v.removed.values())p.updated.has(m)?I[m]=L[m]:w.add(m);for(const m of p.removed.values())u.has(m)||(v.updated.has(m)?u.add(m):E.add(m));for(const m of v.updated.values())u.has(m)||(p.updated.has(m)?b.updated.has(m)&&u.add(m):g[m]=k[m]);for(const m of p.updated.values())u.has(m)||(v.updated.has(m)?b.updated.has(m)&&u.add(m):k[m]!==void 0&&(S[m]=L[m]));for(const m of v.added.values())u.has(m)||(p.added.has(m)?b.updated.has(m)&&u.add(m):d[m]=k[m]);for(const m of p.added.values())u.has(m)||(v.added.has(m)?b.updated.has(m)&&u.add(m):I[m]=L[m]);return{local:{added:I,removed:[...E.values()],updated:S},remote:{added:d,removed:[...w.values()],updated:g},conflicts:[...u.values()]}}e.merge=R;function i(k,L){const P=k?Object.keys(k):[],I=L?Object.keys(L):[],S=I.filter(v=>P.indexOf(v)===-1).reduce((v,p)=>(v.add(p),v),new Set),E=P.filter(v=>I.indexOf(v)===-1).reduce((v,p)=>(v.add(p),v),new Set),b=new Set;for(const v of P){if(E.has(v))continue;const p=k[v],d=L[v];p!==d&&b.add(v)}return{added:S,removed:E,updated:b}}function D(k,L){const{added:P,removed:I,updated:S}=i(k,L);return P.size===0&&I.size===0&&S.size===0}e.areSame=D}),define(re[256],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(D,k,L,P){const I={local:{added:[],removed:[],updated:[]},remote:{added:[],removed:[],updated:[]}};if(!k){const E=D.filter(({id:b})=>!P.includes(b));return E.length?I.remote.added=E:I.remote=null,I}const S=i(D,k,P);if(S.added.length>0||S.removed.length>0||S.updated.length>0){const E=i(L,D,P),b=i(L,k,P);for(const v of b.removed){const p=D.find(d=>d.id===v);p&&I.local.removed.push(p)}for(const v of b.added){const p=k.find(d=>d.id===v);E.added.includes(v)?S.updated.includes(v)&&I.local.updated.push(p):I.local.added.push(p)}for(const v of b.updated)I.local.updated.push(k.find(p=>p.id===v));for(const v of E.added)b.added.includes(v)||I.remote.added.push(D.find(p=>p.id===v));for(const v of E.updated)b.removed.includes(v)||b.updated.includes(v)||I.remote.updated.push(D.find(p=>p.id===v));for(const v of E.removed)I.remote.removed.push(k.find(p=>p.id===v))}return I.remote.added.length===0&&I.remote.removed.length===0&&I.remote.updated.length===0&&(I.remote=null),I}e.merge=R;function i(D,k,L){D=D?D.filter(({id:v})=>!L.includes(v)):[],k=k.filter(({id:v})=>!L.includes(v));const P=D.map(({id:v})=>v),I=k.map(({id:v})=>v),S=I.filter(v=>P.indexOf(v)===-1),E=P.filter(v=>I.indexOf(v)===-1),b=[];for(const{id:v,name:p,shortName:d}of D){if(E.includes(v))continue;const g=k.find(w=>w.id===v);(!g||g.name!==p||g.shortName!==d)&&b.push(v)}return{added:S,removed:E,updated:b}}}),define(re[26],ae([0,1,19,15,179,45,29,4,104,40]),function(_,e,R,i,D,k,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const s=S.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(l=>!!s[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function b(){const s=S.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(s).filter(C=>!!s[C].ignoreSync),o=Object.keys(s).filter(C=>s[C].scope===2||s[C].scope===6),y=E();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...o,...y])}e.getDefaultIgnoredSettings=b,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function v(){const s="vscode://schemas/ignoredSettings",l=S.Registry.as(k.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,D.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,D.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,D.localize)(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,D.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,D.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=S.Registry.as(I.Extensions.JSONContribution),y=()=>{const C=E(),T=b().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),W=Object.keys(k.allSettings.properties).filter(F=>T.indexOf(F)===-1),O=T.filter(F=>C.indexOf(F)===-1),j={items:{type:"string",enum:[...W,...O.map(F=>`-${F}`)]}};o.registerSchema(s,j)};return l.onDidUpdateConfiguration(()=>y())}e.registerConfiguration=v;function p(s){return s&&(0,i.isObject)(s)&&(0,i.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=p;var d;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(d=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function g(s,...l){return s?[s,...l]:l}e.getPathSegments=g;function w(s,l,o,y){return y.joinPath(o.userDataSyncHome,...g(s,l,`lastSync${l}.json`))}e.getLastSyncResourceUri=w,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(s){const l={};return l[e.HEADER_EXECUTION_ID]=s,l}e.createSyncHeaders=u;var m;(function(s){s.Unauthorized="Unauthorized",s.NotFound="NotFound",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.Unknown="Unknown"})(m=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class c extends Error{constructor(l,o,y,C){super(l),this.code=o,this.resource=y,this.operationId=C,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=c;class h extends c{constructor(l,o,y,C,T){super(l,y,void 0,T),this.url=o,this.serverCode=C}}e.UserDataSyncStoreError=h;class f extends c{constructor(l,o){super(l,o)}}e.UserDataAutoSyncError=f,function(s){function l(o){if(o instanceof s)return o;const y=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(y&&y[1]){const C=y[2]==="unknown"?void 0:y[2],T=y[3]==="unknown"?void 0:y[3];return new s(o.message,y[1],C,T)}return new s(o.message,"Unknown")}s.toUserDataSyncError=l}(c=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var r;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function a(s){return`sync.enable.${s}`}e.getEnablementKey=a,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,P.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(re[257],ae([0,1,32,26]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(L,P,I,S,E){if(!P)return{remote:{added:Object.keys(L),removed:[],updated:[],all:Object.keys(L).length>0?L:null},local:{added:{},removed:[],updated:{}}};const b=k(L,P);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const v=I?k(I,P):{added:Object.keys(P).reduce((m,c)=>(m.add(c),m),new Set),removed:new Set,updated:new Set},p=I?k(I,L):{added:Object.keys(L).reduce((m,c)=>(m.add(c),m),new Set),removed:new Set,updated:new Set},d={added:{},removed:[],updated:{}},g=R.deepClone(P),w=!I;for(const m of p.added.values())m!==i.SYNC_SERVICE_URL_TYPE&&w&&v.added.has(m)||(g[m]=L[m]);for(const m of p.updated.values())g[m]=L[m];for(const m of p.removed.values())S.unregistered.includes(m)||delete g[m];for(const m of v.added.values()){const c=P[m];if(S.machine.includes(m)){E.info(`GlobalState: Skipped adding ${m} in local storage because it is declared as machine scoped.`);continue}if(I&&p.added.has(m))continue;const h=L[m];h&&h.value===c.value||m===i.SYNC_SERVICE_URL_TYPE&&w&&p.added.has(m)||(h?d.updated[m]=c:d.added[m]=c)}for(const m of v.updated.values()){const c=P[m];if(S.machine.includes(m)){E.info(`GlobalState: Skipped updating ${m} in local storage because it is declared as machine scoped.`);continue}if(p.updated.has(m)||p.removed.has(m))continue;const h=L[m];h&&h.value===c.value||(d.updated[m]=c)}for(const m of v.removed.values()){if(S.machine.includes(m)){E.trace(`GlobalState: Skipped removing ${m} in local storage because it is declared as machine scoped.`);continue}p.updated.has(m)||p.removed.has(m)||d.removed.push(m)}const u=k(P,g);return{local:d,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:g}}}e.merge=D;function k(L,P){const I=Object.keys(L),S=Object.keys(P),E=S.filter(p=>I.indexOf(p)===-1).reduce((p,d)=>(p.add(d),p),new Set),b=I.filter(p=>S.indexOf(p)===-1).reduce((p,d)=>(p.add(d),p),new Set),v=new Set;for(const p of I){if(b.has(p))continue;const d=L[p],g=P[p];R.equals(d,g)||v.add(p)}return{added:E,removed:b,updated:v}}}),define(re[258],ae([0,1,19,35,82,42,32,61,26]),function(_,e,R,i,D,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function S(o,y,C){let T=[];C?T=b(C):T=E(y);const W=[],O=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(T))for(const j of T)j.startsWith("-")?O.push(j.substring(1)):W.push(j);return(0,R.distinct)([...o,...W].filter(j=>O.indexOf(j)===-1))}e.getIgnoredSettings=S;function E(o){let y=o.inspect("settingsSync.ignoredSettings").userValue;return y!==void 0||(y=o.inspect("sync.ignoredSettings").userValue,y!==void 0)?y:o.getValue("settingsSync.ignoredSettings")||[]}function b(o){const y=(0,i.parse)(o);return y?y["settingsSync.ignoredSettings"]||y["sync.ignoredSettings"]||[]:[]}function v(o,y){const C=(0,i.parse)(o)||{};let T="{}";for(const W of Object.keys(C)){const O=(0,D.setProperty)(T,[W],C[W],y);T=(0,D.applyEdits)(T,O)}return T}e.removeComments=v;function p(o,y,C,T){if(C.length){const W=l(y),O=(0,i.parse)(y)||{},j=(0,i.parse)(o);if(!j)return o;const F=[];for(const A of C){const M=O[A],B=j[A];M===void 0?o=P.edit(o,[A],void 0,T):B!==void 0?o=P.edit(o,[A],M,T):F.push(n(A,W))}F.sort((A,M)=>A.startOffset-M.startOffset),F.forEach(A=>o=m(A.setting.key,y,o,T))}return o}e.updateIgnoredSettings=p;function d(o,y,C,T,W,O){const j=p(o,y,T,O),F=C!==j,A=C!==y;if(!F&&!A)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!A)return{conflictsSettings:[],localContent:null,remoteContent:j,hasConflicts:!1};if(A&&!F)return{conflictsSettings:[],localContent:p(y,o,T,O),remoteContent:null,hasConflicts:!1};if(C===null&&w(o)){const q=g(o,y,T)?null:p(y,o,T,O);return{conflictsSettings:[],localContent:q,remoteContent:null,hasConflicts:!1}}let M=o,B=y;const G=(0,i.parse)(o),V=(0,i.parse)(y),Q=C?(0,i.parse)(C):null,$=T.reduce((q,J)=>(q.add(J),q),new Set),z=u(G,V,$),Y=u(Q,G,$),ee=u(Q,V,$),oe=new Map,X=new Set,Z=q=>{X.add(q);const J=W.filter(({key:ne})=>ne===q)[0];J?(M=P.edit(M,[q],J.value,O),B=P.edit(B,[q],J.value,O)):oe.set(q,{key:q,localValue:G[q],remoteValue:V[q]})};for(const q of Y.removed.values())ee.updated.has(q)?Z(q):B=P.edit(B,[q],void 0,O);for(const q of ee.removed.values())X.has(q)||(Y.updated.has(q)?Z(q):M=P.edit(M,[q],void 0,O));for(const q of Y.updated.values())X.has(q)||(ee.updated.has(q)?z.updated.has(q)&&Z(q):B=P.edit(B,[q],G[q],O));for(const q of ee.updated.values())X.has(q)||(Y.updated.has(q)?z.updated.has(q)&&Z(q):M=P.edit(M,[q],V[q],O));for(const q of Y.added.values())X.has(q)||(ee.added.has(q)?z.updated.has(q)&&Z(q):B=m(q,M,B,O));for(const q of ee.added.values())X.has(q)||(Y.added.has(q)?z.updated.has(q)&&Z(q):M=m(q,B,M,O));const U=oe.size>0||!g(M,B,T),N=U||!g(M,o,[]),H=U||!g(B,y,[]);return{localContent:N?M:null,remoteContent:H?B:null,conflictsSettings:[...oe.values()],hasConflicts:U}}e.merge=d;function g(o,y,C){if(o===y)return!0;const T=(0,i.parse)(o),W=(0,i.parse)(y),O=C.reduce((A,M)=>(A.add(M),A),new Set),j=l(o).filter(A=>!(A.setting&&O.has(A.setting.key))),F=l(y).filter(A=>!(A.setting&&O.has(A.setting.key)));if(j.length!==F.length)return!1;for(let A=0;A<j.length;A++){const M=j[A],B=F[A];if(M.setting&&B.setting){if(M.setting.key!==B.setting.key||!L.equals(T[M.setting.key],W[M.setting.key]))return!1}else if(!M.setting&&!B.setting){if(M.value!==B.value)return!1}else return!1}return!0}e.areSame=g;function w(o){return o?l(o).length===0:!0}e.isEmpty=w;function u(o,y,C){const T=o?Object.keys(o).filter(A=>!C.has(A)):[],W=Object.keys(y).filter(A=>!C.has(A)),O=W.filter(A=>T.indexOf(A)===-1).reduce((A,M)=>(A.add(M),A),new Set),j=T.filter(A=>W.indexOf(A)===-1).reduce((A,M)=>(A.add(M),A),new Set),F=new Set;if(o)for(const A of T){if(j.has(A))continue;const M=o[A],B=y[A];L.equals(M,B)||F.add(A)}return{added:O,removed:j,updated:F}}function m(o,y,C,T){const W=(0,i.parse)(y),O=l(y),j=l(C),F=c(o,O,j);return h(C,o,W[o],F,j,T)}e.addSetting=m;function c(o,y,C){const T=y.findIndex(O=>O.setting?.key===o),W=y[T-1];if(W){if(W.setting){const j=n(W.setting.key,C);if(j)return{index:C.indexOf(j),insertAfter:!0}}else{const j=r(T,y);if(j){const F=n(j.setting.key,C);if(F){const A=t(C.indexOf(F),C),M=a(y,j,y[T]);if(A){const B=a(C,F,A),G=s(M,B);return G?{index:C.indexOf(G),insertAfter:!0}:{index:C.indexOf(A),insertAfter:!1}}else{const B=a(C,F,C[C.length-1]),G=s(M,B);return G?{index:C.indexOf(G),insertAfter:!0}:{index:C.length-1,insertAfter:!0}}}}}const O=y[T+1];if(O)if(O.setting){const j=n(O.setting.key,C);if(j)return{index:C.indexOf(j),insertAfter:!1}}else{const j=t(T,y);if(j){const F=n(j.setting.key,C);if(F){const A=r(C.indexOf(F),C),M=a(y,y[T],j);if(A){const B=a(C,A,F),G=s(M.reverse(),B.reverse());return G?{index:C.indexOf(G),insertAfter:!1}:{index:C.indexOf(A),insertAfter:!0}}else{const B=a(C,C[0],F),G=s(M.reverse(),B.reverse());return G?{index:C.indexOf(G),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:C.length-1,insertAfter:!0}}function h(o,y,C,T,W,O){let j;return T.index===-1?j=(0,D.setProperty)(o,[y],C,O):j=f(o,y,C,T,W,O).map(F=>(0,D.withFormatting)(o,F,O)[0]),(0,D.applyEdits)(o,j)}function f(o,y,C,T,W,O){const j=`${JSON.stringify(y)}: ${JSON.stringify(C)}`,F=(0,k.getEOL)(O,o),A=W[T.index];if(T.insertAfter){const M=[];if(A.setting)M.push({offset:A.endOffset,length:0,content:","+j});else{const B=t(T.index,W),G=r(T.index,W),V=G?.setting?.commaOffset;G&&V===void 0&&M.push({offset:G.endOffset,length:0,content:","});const Q=V!==void 0&&V>A.endOffset;M.push({offset:Q?V+1:A.endOffset,length:0,content:B?F+j+",":F+j})}return M}else{if(A.setting)return[{offset:A.startOffset,length:0,content:j+","}];const M=(W[T.index-1]&&!W[T.index-1].setting?F:"")+j+(t(T.index,W)?",":"")+F;return[{offset:A.startOffset,length:0,content:M}]}}function n(o,y){return y.filter(C=>C.setting?.key===o)[0]}function r(o,y){for(let C=o-1;C>=0;C--)if(y[C].setting)return y[C]}function t(o,y){for(let C=o+1;C<y.length;C++)if(y[C].setting)return y[C]}function a(o,y,C){const T=o.indexOf(y),W=o.indexOf(C);return o.filter((O,j)=>T<j&&j<W)}function s(o,y){if(o.length&&y.length){let C=0;for(;C<y.length&&C<o.length;C++)if(o[C].value!==y[C].value)return y[C-1];return y[C-1]}}function l(o){const y=[];let C=-1,T,W;const O={onObjectBegin:j=>{C++},onObjectProperty:(j,F,A)=>{C===0&&(T=F,W=j)},onObjectEnd:(j,F)=>{C--,C===0&&y.push({startOffset:T,endOffset:j+F,value:o.substring(T,j+F),setting:{key:W,commaOffset:void 0}})},onArrayBegin:(j,F)=>{C++},onArrayEnd:(j,F)=>{C--,C===0&&y.push({startOffset:T,endOffset:j+F,value:o.substring(T,j+F),setting:{key:W,commaOffset:void 0}})},onLiteralValue:(j,F,A)=>{C===0&&y.push({startOffset:T,endOffset:F+A,value:o.substring(T,F+A),setting:{key:W,commaOffset:void 0}})},onSeparator:(j,F,A)=>{if(C===0&&j===","){let M=y.length-1;for(;M>=0&&!y[M].setting;M--);const B=y[M];B&&y.splice(M,1,{startOffset:B.startOffset,endOffset:B.endOffset,value:B.value,setting:{key:B.setting.key,commaOffset:F}})}},onComment:(j,F)=>{C===0&&y.push({startOffset:j,endOffset:j+F,value:o.substring(j,j+F)})}};return(0,i.visit)(o,O),y}}),define(re[77],ae([0,1,3,2,4,26]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let L=class extends i.Disposable{get account(){return this.a}constructor(I,S){super(),this.g=I,this.h=S,this.b=this.B(new R.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new R.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(I.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(I.onTokenSucceed(()=>this.f=!1))}async updateAccount(I){(I&&this.a?I.token!==this.a.token||I.authenticationProviderId!==this.a.authenticationProviderId:I!==this.a)&&(this.a=I,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(I))}};L=pe([K(0,k.IUserDataSyncStoreService),K(1,k.IUserDataSyncLogService)],L),e.UserDataSyncAccountService=L}),define(re[259],ae([0,1,2,8]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(v){this.a=v}listen(v,p){switch(p){case"onError":return this.a.onError}throw new Error(`Event not found: ${p}`)}call(v,p,d){switch(p){case"triggerSync":return this.a.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class k{constructor(v){this.a=v}listen(v,p){throw new Error(`Event not found: ${p}`)}call(v,p,d){switch(p){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(i.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class L{constructor(v){this.a=v}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(v){return this.a.call("resolveUserKeybindings",[v])}async resolveFormattingOptions(v){return this.a.call("resolveFormattingOptions",[v])}}e.UserDataSyncUtilServiceClient=L;class P{constructor(v){this.a=v}listen(v,p){switch(p){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${p}`)}async call(v,p,d){switch(p){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(d[0],d[1]);case"setEnablements":return this.a.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class I{constructor(v){this.a=v}listen(v,p){switch(p){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(v,p,d){switch(p){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class S{constructor(v){this.a=v}listen(v,p){switch(p){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(v,p,d){switch(p){case"switch":return this.a.switch(d[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class E extends R.Disposable{constructor(v){super(),this.a=v,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(v){return this.a.call("switch",[v])}async getPreviousUserDataSyncStore(){const v=await this.a.call("getPreviousUserDataSyncStore");return this.b(v)}b(v){return{url:i.URI.revive(v.url),type:v.type,defaultUrl:i.URI.revive(v.defaultUrl),insidersUrl:i.URI.revive(v.insidersUrl),stableUrl:i.URI.revive(v.stableUrl),canSwitch:v.canSwitch,authenticationProviders:v.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=E}),define(re[260],ae([0,1,13,7]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends i.AbstractLogger{constructor(L,P){super(),this.f=this.B(L.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(L,...P){this.f.trace(L,...P)}debug(L,...P){this.f.debug(L,...P)}info(L,...P){this.f.info(L,...P)}warn(L,...P){this.f.warn(L,...P)}error(L,...P){this.f.error(L,...P)}flush(){this.f.flush()}};D=pe([K(0,i.ILoggerService),K(1,R.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(re[261],ae([0,1,6,3,2]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends D.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:I,getActiveWindowId:S}){super(),this.a=this.B(new D.DisposableStore),i.Event.latch(i.Event.any(P,I))(this.f,this,this.a),this.b=(0,R.createCancelablePromise)(()=>S()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=k}),define(re[116],ae([0,1,182,12,49,20,8,4,23]),function(_,e,R,i,D,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function S(r){const t=r;return typeof t?.id=="string"&&L.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=S,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function E(r,t){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,i.basename)(r)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const a=r;if(a.configuration)return{id:a.id,configPath:a.configuration};if(a.folders.length===1)return{id:a.id,uri:a.folders[0].uri}}e.toWorkspaceIdentifier=E;function b(r){const t=r;return typeof t?.id=="string"&&L.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=b;function v(r){const t=r;if(t?.uri)return{id:t.id,uri:L.URI.revive(t.uri)};const a=r;if(a?.configPath)return{id:a.id,configPath:L.URI.revive(a.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=v;var p;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function d(r){const t=r;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=d;function g(r){const t=r;return!!(t&&typeof t=="object"&&L.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=g;class w{constructor(t,a,s,l,o){this.h=t,this.j=s,this.k=l,this.l=o,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class u{constructor(t,a){this.raw=a,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,k.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function m(r){return new u({uri:r,index:0,name:(0,k.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=m,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(r,t){return k.extUriBiasedIgnorePathCase.isEqualOrParent(r,t.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function h(r){let t;return L.URI.isUri(r)?t=r:t=r.configuration,t?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=h;function f(r,t){return!c(r,t)&&!h(r)}e.isSavedWorkspace=f;function n(r){return(typeof r=="string"?(0,i.extname)(r):(0,k.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(re[21],ae([0,1,66,3,2,20,8,174,13,14,4,7,116,37,31,6,30,27]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function m(r){const t=r;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&L.URI.isUri(t.location)&&L.URI.isUri(t.globalStorageHome)&&L.URI.isUri(t.settingsResource)&&L.URI.isUri(t.keybindingsResource)&&L.URI.isUri(t.tasksResource)&&L.URI.isUri(t.snippetsHome)&&L.URI.isUri(t.extensionsResource))}e.isUserDataProfile=m,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,E.createDecorator)("IUserDataProfilesService");function c(r,t){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:L.URI.revive(r.location).with({scheme:t}),globalStorageHome:L.URI.revive(r.globalStorageHome).with({scheme:t}),settingsResource:L.URI.revive(r.settingsResource).with({scheme:t}),keybindingsResource:L.URI.revive(r.keybindingsResource).with({scheme:t}),tasksResource:L.URI.revive(r.tasksResource).with({scheme:t}),snippetsHome:L.URI.revive(r.snippetsHome).with({scheme:t}),extensionsResource:L.URI.revive(r.extensionsResource)?.with({scheme:t}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=c;function h(r,t,a,s){return{id:r,name:t,location:a,isDefault:!1,shortName:s?.shortName,globalStorageHome:(0,k.joinPath)(a,"globalStorage"),settingsResource:(0,k.joinPath)(a,"settings.json"),keybindingsResource:(0,k.joinPath)(a,"keybindings.json"),tasksResource:(0,k.joinPath)(a,"tasks.json"),snippetsHome:(0,k.joinPath)(a,"snippets"),extensionsResource:(0,k.joinPath)(a,"extensions.json"),useDefaultFlags:s?.useDefaultFlags,isTransient:s?.transient}}e.toUserDataProfile=h;let f=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(t,a,s,l){super(),this.m=t,this.n=a,this.r=s,this.s=l,this.f=!1,this.g=this.B(new i.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new i.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new i.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new i.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new p.ResourceMap},this.profilesHome=(0,k.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(t){this.f!==t&&(this.t=void 0,this.f=t)}isEnabled(){return this.f}get u(){if(!this.t){const t=this.f?this.I().map(o=>h((0,k.basename)(o.location),o.name,o.location,{shortName:o.shortName,useDefaultFlags:o.useDefaultFlags})):[];let a;const s=new p.ResourceMap,l=h((0,R.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(t.unshift({...l,isDefault:!0}),t.length){const o=this.L();if(o.workspaces)for(const[y,C]of Object.entries(o.workspaces)){const T=L.URI.parse(y),W=L.URI.parse(C),O=t.find(j=>this.r.extUri.isEqual(j.location,W));O&&s.set(T,O)}if(o.emptyWindow){const y=L.URI.parse(o.emptyWindow);a=t.find(C=>this.r.extUri.isEqual(C.location,y))}}this.t={profiles:t,workspaces:s,emptyWindow:a}}return this.t}async createTransientProfile(t){const a="Temp",s=new RegExp(`${(0,u.escapeRegExpCharacters)(a)}\\s(\\d+)`);let l=0;for(const y of this.profiles){const C=s.exec(y.name),T=C?parseInt(C[1]):0;l=T>l?T:l}const o=`${a} ${l+1}`;return this.createProfile((0,R.hash)((0,w.generateUuid)()).toString(16),o,{transient:!0},t)}async createNamedProfile(t,a,s){return this.createProfile((0,R.hash)((0,w.generateUuid)()).toString(16),t,a,s)}async createProfile(t,a,s,l){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=await this.v(t,a,s);return l&&await this.setProfileForWorkspace(l,o),o}async v(t,a,s){let l=this.k.get(a);return l||(l=(async()=>{try{const o=this.profiles.find(T=>T.name===a||T.id===t);if(o)return o;const y=h(t,a,(0,k.joinPath)(this.profilesHome,t),s);await this.n.createFolder(y.location);const C=[];return this.h.fire({profile:y,join(T){C.push(T)}}),await g.Promises.settled(C),this.D([y],[],[]),y}finally{this.k.delete(a)}})(),this.k.set(a,l)),l}async updateProfile(t,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let s=this.profiles.find(l=>l.id===t.id);if(!s)throw new Error(`Profile '${t.name}' does not exist`);return s=h(s.id,a.name??s.name,s.location,{shortName:a.shortName??s.shortName,transient:a.transient??s.isTransient,useDefaultFlags:a.useDefaultFlags??s.useDefaultFlags}),this.D([],[],[s]),s}async removeProfile(t){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(l=>l.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);const s=[];this.i.fire({profile:a,join(l){s.push(l)}});try{await Promise.allSettled(s)}catch(l){this.s.error(l)}a.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const l of[...this.u.workspaces.keys()])a.id===this.u.workspaces.get(l)?.id&&this.u.workspaces.delete(l);this.H(),this.D([],[a],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(a.location,{recursive:!0})}catch(l){this.s.error(l)}}getOrSetProfileForWorkspace(t,a=this.defaultProfile){if(!this.f)return this.defaultProfile;let s=this.w(t);return s||(s=a,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,s)),s}async setProfileForWorkspace(t,a){this.setProfileForWorkspaceSync(t,a)}setProfileForWorkspaceSync(t,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(l=>l.id===a.id);if(!s)throw new Error(`Profile '${a.name}' does not exist`);this.G(t,s)}unsetWorkspace(t,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.G(t,void 0,a)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.H(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const t=await this.n.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(a=>a.isDirectory&&this.profiles.every(s=>!this.r.extUri.isEqual(s.location,a.resource))).map(a=>this.n.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.l.profiles.filter(a=>!this.C(a));await Promise.allSettled(t.map(a=>this.removeProfile(a)))}w(t){const a=this.y(t);return L.URI.isUri(a)?this.l.workspaces.get(a)??this.u.workspaces.get(a):this.l.emptyWindow??this.u.emptyWindow}y(t){return(0,v.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,v.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}C(t){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,t.location)||[...this.l.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,t.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,t.location)||[...this.u.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,t.location)))}D(t,a,s){const l=[...this.profiles,...t],o=[];this.l.profiles=[];for(let y of l)y.isDefault||a.some(C=>y.id===C.id)||(y=s.find(C=>y.id===C.id)??y,y.isTransient?this.l.profiles.push(y):o.push({location:y.location,name:y.name,shortName:y.shortName,useDefaultFlags:y.useDefaultFlags}));this.J(o),this.t=void 0,this.F(t,a,s)}F(t,a,s){this.g.fire({added:t,removed:a,updated:s,all:this.profiles})}G(t,a,s){s=a?.isTransient?!0:s,s||this.G(t,void 0,!0);const l=this.y(t),o=s?this.l:this.u;L.URI.isUri(l)?(o.workspaces.delete(l),a&&o.workspaces.set(l,a)):o.emptyWindow=a,s||this.H()}H(){const t={};for(const[s,l]of this.u.workspaces.entries())t[s.toString()]=l.location.toString();const a=this.u.emptyWindow?.location.toString();this.M({workspaces:t,emptyWindow:a}),this.t=void 0}I(){return[]}J(t){throw new Error("not implemented")}L(){return{}}M(t){throw new Error("not implemented")}};f.b="userDataProfiles",f.c="profileAssociations",f=pe([K(0,I.IEnvironmentService),K(1,S.IFileService),K(2,d.IUriIdentityService),K(3,b.ILogService)],f),e.UserDataProfilesService=f;class n extends f{constructor(){super(...arguments),this.a=[],this.P={}}I(){return this.a}J(t){this.a=t}L(){return this.P}M(t){this.P=t}}e.InMemoryUserDataProfilesService=n}),define(re[262],ae([0,1,6,2,21]),function(_,e,R,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let k=class extends i.Disposable{constructor(P){super(),this.B(new R.RunOnceScheduler(()=>{P.cleanUp()},10*1e3)).schedule()}};k=pe([K(0,D.IUserDataProfilesService)],k),e.UserDataProfilesCleaner=k}),define(re[263],ae([0,1,19,6,22,9,3,2,5,8,155,29,33,46,7,25,24,21]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends P.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(t,a,s,l,o){super(),this.t=t,this.u=a,this.v=s,this.w=l,this.y=o,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new L.Emitter),this.m=this.B(new L.Emitter),this.n=this.B(new L.Emitter),this.p=this.B(new L.Emitter),this.s=[],this.B((0,P.toDisposable)(()=>{this.j.forEach(({task:y})=>y.cancel()),this.k.forEach(y=>y.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(t){const a=await this.getTargetPlatform();return t.allTargetPlatforms.some(s=>(0,b.isTargetPlatformCompatible)(s,t.allTargetPlatforms,a))}async installFromGallery(t,a={}){try{if(!this.t.isEnabled())throw new b.ExtensionManagementError(E.localize(0,null),b.ExtensionManagementErrorCode.Internal);const s=await this.H(t,!!a.installGivenVersion,!!a.installPreReleaseVersion);return await this.C(s.manifest,s.extension,a)}catch(s){throw f(this.u,"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(t),error:s}),this.v.error("Failed to install extension.",t.identifier.id),this.v.error(s),h(s)}}async uninstall(t,a={}){return this.v.trace("ExtensionManagementService#uninstall",t.identifier.id),this.J(t,a)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.P(),this.h=t),this.g}registerParticipant(t){this.s.push(t)}async C(t,a,s){const l={...s,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(a)?s.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,p.isApplicationScopedExtension)(t)?this.y.defaultProfile.extensionsResource:s.profileLocation??this.Q()},o=j=>`${v.ExtensionKey.create(j).toString()}${l.profileLocation?`-${l.profileLocation.toString()}`:""}`;if(!S.URI.isUri(a)){const j=this.j.get(o(a));if(j){this.v.info("Extensions is already requested to install",a.identifier.id);const{local:F}=await j.task.waitUntilTaskIsFinished();return F}}const y=[],C=[],T=[],W=this.R(t,a,l);S.URI.isUri(a)||this.j.set(o(a),{task:W,waitingTasks:[]}),this.l.fire({identifier:W.identifier,source:a,profileLocation:l.profileLocation}),this.v.info("Installing extension:",W.identifier.id),y.push({task:W,manifest:t});let O=!1;try{if(l.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",W.identifier.id);else try{const F=await this.G(W.identifier,t,!!l.installOnlyNewlyAddedFromExtensionPack,!!l.installPreReleaseVersion,l.profileLocation),A=await this.getInstalled(void 0,l.profileLocation);for(const{gallery:M,manifest:B}of F){O=O||!!B.extensionDependencies?.some(Q=>(0,v.areSameExtensions)({id:Q},W.identifier));const G=o(M),V=this.j.get(G);if(V){if(this.D(W,V.task)){this.v.info("Waiting for already requested installing extension",M.identifier.id,W.identifier.id),V.waitingTasks.push(W);const Q=V.task.identifier;C.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,$=>$.some(z=>(0,v.areSameExtensions)(z.identifier,Q)))).then($=>{if(!$.find(Y=>(0,v.areSameExtensions)(Y.identifier,Q))?.local)throw new Error(`Extension ${Q.id} is not installed`)}))}}else if(!A.some(({identifier:Q})=>(0,v.areSameExtensions)(Q,M.identifier))){const Q=this.R(B,M,{...l,donotIncludePackAndDependencies:!0});this.j.set(G,{task:Q,waitingTasks:[W]}),this.l.fire({identifier:Q.identifier,source:M,profileLocation:l.profileLocation}),this.v.info("Installing extension:",Q.identifier.id,W.identifier.id),y.push({task:Q,manifest:B})}}}catch(F){if(S.URI.isUri(W.source))(0,R.isNonEmptyArray)(t.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",W.identifier.id,F.message),(0,R.isNonEmptyArray)(t.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",W.identifier.id,F.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",W.identifier.id),F}const j=y.reduce((F,{task:A,manifest:M})=>(F.set(A.identifier.id.toLowerCase(),{task:A,manifest:M}),F),new Map);for(;j.size;){let F;const A=[...j.values()].filter(({manifest:M})=>!M.extensionDependencies?.some(B=>j.has(B.toLowerCase())));A.length?F=j.size===1?A:A.filter(({task:M})=>!(M===W&&!O)):(this.v.info("Found extensions with circular dependencies",A.map(({task:M})=>M.identifier.id)),F=[...j.values()]),await this.F(F.map(async({task:M})=>{const B=new Date().getTime();try{const{local:G}=await M.run();if(await this.F(this.s.map(V=>V.postInstall(G,M.source,l,D.CancellationToken.None))),!S.URI.isUri(M.source)){const V=M.operation===3,Q=V?void 0:(new Date().getTime()-M.source.lastUpdated)/1e3;if(f(this.u,V?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(M.source),wasVerified:M.wasVerified,duration:new Date().getTime()-B,durationSinceUpdate:Q}),I.isWeb&&M.operation!==3)try{await this.t.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}T.push({local:G,identifier:M.identifier,operation:M.operation,source:M.source,context:l.context,profileLocation:l.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw S.URI.isUri(M.source)||f(this.u,M.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(M.source),wasVerified:M.wasVerified,duration:new Date().getTime()-B,error:G}),this.v.error("Error while installing the extension:",M.identifier.id),G}finally{j.delete(M.identifier.id.toLowerCase())}}))}return C.length&&await this.F(C),T.forEach(({identifier:F})=>this.v.info("Extension installed successfully:",F.id)),this.m.fire(T),T.filter(({identifier:F})=>(0,v.areSameExtensions)(F,W.identifier))[0].local}catch(j){if(y.forEach(({task:F})=>F.cancel()),T.length)try{const F=await Promise.allSettled(T.map(({local:A})=>this.S(A,{versionOnly:!0,profileLocation:l.profileLocation}).run()));for(let A=0;A<F.length;A++){const M=F[A],{identifier:B}=T[A];M.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",B.id):this.v.warn("Rollback: Error while uninstalling extension",B.id,(0,k.getErrorMessage)(M.reason))}}catch(F){this.v.warn("Error while rolling back extensions",(0,k.getErrorMessage)(F),T.map(({identifier:A})=>A.id))}throw this.m.fire(y.map(({task:F})=>({identifier:F.identifier,operation:2,source:F.source,context:l.context,profileLocation:l.profileLocation}))),j}finally{for(const[j,{task:F,waitingTasks:A}]of this.j.entries()){const M=A.indexOf(W);M!==-1&&A.splice(M,1),A.length===0&&(F===W||M!==-1)&&this.j.delete(j)}}}D(t,a){for(const[,{task:s,waitingTasks:l}]of this.j.entries())if(s===t&&(l.includes(a)||l.some(o=>this.D(o,a)))||s===a&&l[0]&&!this.D(t,l[0]))return!1;return!0}async F(t){const a=[],s=[],l=await Promise.allSettled(t);for(const o of l)o.status==="fulfilled"?a.push(o.value):s.push(o.reason);if(s.length)throw c(s);return a}async G(t,a,s,l,o){if(!this.t.isEnabled())return[];const y=await this.getInstalled(void 0,o),C=[t],T=[],W=async(O,j)=>{const F=j.extensionDependencies||[],A=[...F];if(j.extensionPack){const M=s?y.find(B=>(0,v.areSameExtensions)(B.identifier,O)):void 0;for(const B of j.extensionPack)M&&M.manifest.extensionPack&&M.manifest.extensionPack.some(G=>(0,v.areSameExtensions)({id:G},{id:B}))||A.every(G=>!(0,v.areSameExtensions)({id:G},{id:B}))&&A.push(B)}if(A.length){const M=[...C,...T.map(G=>G.gallery.identifier)],B=A.filter(G=>M.every(V=>!(0,v.areSameExtensions)(V,{id:G})));if(B.length){const G=await this.t.getExtensions(B.map(V=>({id:V,preRelease:l})),D.CancellationToken.None);for(const V of G){if(M.find(z=>(0,v.areSameExtensions)(z,V.identifier)))continue;const Q=F.some(z=>(0,v.areSameExtensions)({id:z},V.identifier));let $;try{$=await this.H(V,!1,l)}catch(z){if(z instanceof b.ExtensionManagementError&&z.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!Q){this.v.info("Skipping the packed extension as it cannot be installed",V.identifier.id);continue}else throw z}T.push({gallery:$.extension,manifest:$.manifest}),await W($.extension.identifier,$.manifest)}}}};return await W(t,a),T}async H(t,a,s){if((await this.getExtensionsControlManifest()).malicious.some(C=>(0,v.areSameExtensions)(t.identifier,C)))throw new b.ExtensionManagementError(E.localize(1,null,t.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const C=await this.getTargetPlatform();throw new b.ExtensionManagementError(E.localize(2,null,t.identifier.id,this.w.nameLong,(0,b.TargetPlatformToString)(C)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.I(t,a,s);if(o){if(s&&!a&&t.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new b.ExtensionManagementError(E.localize(3,null,t.identifier.id,this.w.nameLong,this.w.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&t.properties.isPreReleaseVersion&&(await this.t.getExtensions([t.identifier],D.CancellationToken.None))[0]?new b.ExtensionManagementError(E.localize(4,null,t.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.ExtensionManagementError(E.localize(5,null,t.identifier.id,this.w.nameLong,this.w.version),b.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",o.identifier.id);const y=await this.t.getManifest(o,D.CancellationToken.None);if(y===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(y.version!==o.version)throw new b.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:y}}async I(t,a,s){const l=await this.getTargetPlatform();let o=null;return!a&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==s&&(o=(await this.t.getExtensions([{...t.identifier,preRelease:s}],{targetPlatform:l,compatible:!0},D.CancellationToken.None))[0]||null),!o&&await this.t.isExtensionCompatible(t,s,l)&&(o=t),o||(a?o=(await this.t.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:l,compatible:!0},D.CancellationToken.None))[0]||null:o=await this.t.getCompatibleExtension(t,s,l)),o}async J(t,a){const s={...a,profileLocation:t.isApplicationScoped?this.y.defaultProfile.extensionsResource:a.profileLocation??this.Q()},l=O=>`${O.id.toLowerCase()}${s.versionOnly?`-${t.manifest.version}`:""}${s.profileLocation?`@${s.profileLocation.toString()}`:""}`,o=this.k.get(l(t.identifier));if(o)return this.v.info("Extensions is already requested to uninstall",t.identifier.id),o.waitUntilTaskIsFinished();const y=O=>{const j=this.S(O,s);return this.k.set(l(j.extension.identifier),j),s.profileLocation?this.v.info("Uninstalling extension from the profile:",`${O.identifier.id}@${O.manifest.version}`,s.profileLocation.toString()):this.v.info("Uninstalling extension:",`${O.identifier.id}@${O.manifest.version}`),this.n.fire({identifier:O.identifier,profileLocation:s.profileLocation,applicationScoped:O.isApplicationScoped}),j},C=(O,j)=>{j?s.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${O.identifier.id}@${O.manifest.version}`,s.profileLocation.toString(),j.message):this.v.error("Failed to uninstall extension:",`${O.identifier.id}@${O.manifest.version}`,j.message):s.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${O.identifier.id}@${O.manifest.version}`,s.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${O.identifier.id}@${O.manifest.version}`),f(this.u,"extensionGallery:uninstall",{extensionData:(0,v.getLocalExtensionTelemetryData)(O),error:j}),this.p.fire({identifier:O.identifier,error:j?.code,profileLocation:s.profileLocation,applicationScoped:O.isApplicationScoped})},T=[],W=[];try{T.push(y(t));const O=await this.getInstalled(1,s.profileLocation);if(s.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const j=this.N(t,O);for(const F of j)this.k.has(l(F.identifier))?this.v.info("Extensions is already requested to uninstall",F.identifier.id):T.push(y(F))}s.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.L(T.map(j=>j.extension),O,t),await this.F(T.map(async j=>{try{if(await j.run(),await this.F(this.s.map(F=>F.postUninstall(j.extension,s,D.CancellationToken.None))),j.extension.identifier.uuid)try{await this.t.reportStatistic(j.extension.manifest.publisher,j.extension.manifest.name,j.extension.manifest.version,"uninstall")}catch{}C(j.extension)}catch(F){const A=F instanceof b.ExtensionManagementError?F:new b.ExtensionManagementError((0,k.getErrorMessage)(F),b.ExtensionManagementErrorCode.Internal);throw C(j.extension,A),A}finally{W.push(j)}}))}catch(O){const j=O instanceof b.ExtensionManagementError?O:new b.ExtensionManagementError((0,k.getErrorMessage)(O),b.ExtensionManagementErrorCode.Internal);for(const F of T){try{F.cancel()}catch{}W.includes(F)||C(F.extension,j)}throw j}finally{for(const O of T)this.k.delete(l(O.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",O.extension.identifier.id)}}L(t,a,s){for(const l of t){const o=this.O(l,a);if(o.length){const y=o.filter(C=>!t.some(T=>(0,v.areSameExtensions)(T.identifier,C.identifier)));if(y.length)throw new Error(this.M(l,y,s))}}}M(t,a,s){return s===t?a.length===1?E.localize(6,null,s.manifest.displayName||s.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(7,null,s.manifest.displayName||s.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(8,null,s.manifest.displayName||s.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?E.localize(9,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(10,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(11,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}N(t,a,s=[]){if(s.indexOf(t)!==-1)return[];s.push(t);const l=t.manifest.extensionPack?t.manifest.extensionPack:[];if(l.length){const o=a.filter(C=>!C.isBuiltin&&l.some(T=>(0,v.areSameExtensions)({id:T},C.identifier))),y=[];for(const C of o)y.push(...this.N(C,a,s));return[...o,...y]}return[]}O(t,a){return a.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(l=>(0,v.areSameExtensions)({id:l},t.identifier)))}async P(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const t=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};m=pe([K(0,b.IExtensionGalleryService),K(1,w.ITelemetryService),K(2,d.ILogService),K(3,g.IProductService),K(4,u.IUserDataProfilesService)],m),e.AbstractExtensionManagementService=m;function c(r){const t=Array.isArray(r)?r:[r];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((a,s)=>new Error(`${a.message}${a.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=c;function h(r){if(r instanceof b.ExtensionManagementError)return r;const t=new b.ExtensionManagementError(r.message,b.ExtensionManagementErrorCode.Internal);return t.stack=r.stack,t}function f(r,t,{extensionData:a,wasVerified:s,duration:l,error:o,durationSinceUpdate:y}){let C,T;o&&(o instanceof b.ExtensionManagementError?(C=o.code,o.code===b.ExtensionManagementErrorCode.Signature&&(T=o.message)):C=b.ExtensionManagementErrorCode.Internal),r.publicLog(t,{...a,wasVerified:s,success:!o,duration:l,errorcode:C,errorcodeDetail:T,durationSinceUpdate:y})}e.reportTelemetry=f;class n{constructor(){this.d=new i.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,i.createCancelablePromise)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,i.createCancelablePromise)(t=>new Promise((a,s)=>{const l=t.onCancellationRequested(()=>{l.dispose(),s(new k.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=n}),define(re[78],ae([0,1,19,6,32,17,9,35,137,2,23,12,5,20,54,88,15,8,158,13,33,46,70,14,4,7,25,3,67,60,21,31,188,189]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u,m,c,h,f,n,r,t,a,s,l,o,y,C,T,W,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var j;(function(Q){function $(z,Y){if(z===Y)return!0;const ee=Object.keys(z),oe=new Set;for(const X of Object.keys(Y))oe.add(X);if(ee.length!==oe.size)return!1;for(const X of ee){if(z[X]!==Y[X])return!1;oe.delete(X)}return oe.size===0}Q.equals=$})(j=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let F=class extends S.Disposable{constructor($,z,Y,ee,oe,X,Z,U,N,H,q,J){super(),this.systemExtensionsLocation=$,this.userExtensionsLocation=z,this.l=Y,this.m=ee,this.n=oe,this.p=X,this.r=Z,this.s=U,this.t=N,this.u=H,this.v=q,this.w=J,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,p.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(B,(0,p.joinPath)(this.m,f.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(B,(0,p.joinPath)(this.m,f.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(M,this.h)),this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,h.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions($,z,Y){const[ee,oe]=await Promise.all([this.scanSystemExtensions($),this.scanUserExtensions(z)]),X=Y?await this.scanExtensionsUnderDevelopment($,[...ee,...oe]):[];return this.D(ee,oe,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions($){const z=[];z.push(this.F(!!$.useCache,$.language)),z.push(this.G($.language,!!$.checkControlFile));const[Y,ee]=await Promise.all(z);return this.C([...Y,...ee],0,$,!1)}async scanUserExtensions($){const z=$.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",z);const Y=await this.I(z,!!$.profileLocation,1,!$.includeUninstalled,$.language);let oe=await($.useCache&&!Y.devMode&&Y.excludeObsolete?this.j:this.k).scanExtensions(Y);return oe=await this.C(oe,1,$,!0),this.s.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment($,z){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const Y=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(ee=>ee.scheme===E.Schemas.file).map(async ee=>{const oe=await this.I(ee,!1,1,!0,$.language,!1);return(await this.k.scanOneOrMultipleExtensions(oe)).map(Z=>(Z.type=z.find(U=>(0,h.areSameExtensions)(U.identifier,Z.identifier))?.type??Z.type,this.k.validate(Z,oe)))}))).flat();return this.C(Y,"development",$,!0)}return[]}async scanExistingExtension($,z,Y){const ee=await this.I($,!1,z,!0,Y.language),oe=await this.k.scanExtension(ee);return!oe||!Y.includeInvalid&&!oe.isValid?null:oe}async scanOneOrMultipleExtensions($,z,Y){const ee=await this.I($,!1,z,!0,Y.language),oe=await this.k.scanOneOrMultipleExtensions(ee);return this.C(oe,z,Y,!0)}async scanMetadata($){const z=(0,p.joinPath)($,"package.json"),Y=(await this.r.readFile(z)).value.toString();return JSON.parse(Y).__metadata}async updateMetadata($,z){const Y=(0,p.joinPath)($,"package.json"),ee=(await this.r.readFile(Y)).value.toString(),oe=JSON.parse(ee);z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.installedTimestamp=z.installedTimestamp||void 0,oe.__metadata={...oe.__metadata,...z},await this.r.writeFile((0,p.joinPath)($,"package.json"),k.VSBuffer.fromString(JSON.stringify(oe,null,"	")))}async C($,z,Y,ee){return Y.includeAllVersions||($=this.D(z===0?$:void 0,z===1?$:void 0,z==="development"?$:void 0,await this.getTargetPlatform(),ee)),Y.includeInvalid||($=$.filter(oe=>oe.isValid)),$.sort((oe,X)=>{const Z=b.basename(oe.location.fsPath),U=b.basename(X.location.fsPath);return Z<U?-1:Z>U?1:0})}D($,z,Y,ee,oe){const X=(U,N,H)=>{if(U.isValid&&!N.isValid)return!1;if(U.isValid===N.isValid){if(oe&&d.gt(U.manifest.version,N.manifest.version))return this.s.debug(`Skipping extension ${N.location.path} with lower version ${N.manifest.version} in favour of ${U.location.path} with version ${U.manifest.version}`),!1;if(d.eq(U.manifest.version,N.manifest.version)){if(U.type===0)return this.s.debug(`Skipping extension ${N.location.path} in favour of system extension ${U.location.path} with same version`),!1;if(U.targetPlatform===ee)return this.s.debug(`Skipping extension ${N.location.path} from different target platform ${N.targetPlatform}`),!1}}return H?this.s.warn(`Overwriting user extension ${U.location.path} with ${N.location.path}.`):this.s.debug(`Overwriting user extension ${U.location.path} with ${N.location.path}.`),!0},Z=new Map;return $?.forEach(U=>{const N=f.ExtensionIdentifier.toKey(U.identifier.id),H=Z.get(N);(!H||X(H,U,!1))&&Z.set(N,U)}),z?.forEach(U=>{const N=f.ExtensionIdentifier.toKey(U.identifier.id),H=Z.get(N);if(!H&&$&&U.type===0){this.s.debug(`Skipping obsolete system extension ${U.location.path}.`);return}(!H||X(H,U,!1))&&Z.set(N,U)}),Y?.forEach(U=>{const N=f.ExtensionIdentifier.toKey(U.identifier.id),H=Z.get(N);(!H||X(H,U,!0))&&Z.set(N,U),Z.set(N,U)}),[...Z.values()]}async F($,z){this.s.trace("Started scanning system extensions");const Y=await this.I(this.systemExtensionsLocation,!1,0,!0,z),oe=await($&&!Y.devMode?this.i:this.k).scanExtensions(Y);return this.s.trace("Scanned system extensions:",oe.length),oe}async G($,z){const Y=this.t.isBuilt?[]:this.u.builtInExtensions;if(!Y?.length)return[];this.s.trace("Started scanning dev system extensions");const ee=z?await this.H():{},oe=[],X=u.URI.file(b.normalize(b.join(E.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const U of Y){const N=ee[U.name]||"marketplace";switch(N){case"disabled":break;case"marketplace":oe.push((0,p.joinPath)(X,U.name));break;default:oe.push(u.URI.file(N));break}}const Z=await Promise.all(oe.map(async U=>this.k.scanExtension(await this.I(U,!1,0,!0,$))));return this.s.trace("Scanned dev system extensions:",Z.length),(0,R.coalesce)(Z)}async H(){try{const $=await this.r.readFile(this.l);return JSON.parse($.value.toString())}catch{return{}}}async I($,z,Y,ee,oe,X=!0){const Z=await this.f(oe??v.language),U=await this.J($),N=z&&!this.v.extUri.isEqual($,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,H=N?await this.J(N):void 0;return new A($,U,N,H,z,Y,ee,X,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,oe,Z)}async J($){try{const z=await this.r.stat($);if(typeof z.mtime=="number")return z.mtime}catch{}}};F=pe([K(4,C.IUserDataProfilesService),K(5,y.IExtensionsProfileScannerService),K(6,r.IFileService),K(7,a.ILogService),K(8,c.IEnvironmentService),K(9,s.IProductService),K(10,T.IUriIdentityService),K(11,t.IInstantiationService)],F),e.AbstractExtensionsScannerService=F;class A{constructor($,z,Y,ee,oe,X,Z,U,N,H,q,J,ne,x){this.location=$,this.mtime=z,this.applicationExtensionslocation=Y,this.applicationExtensionslocationMtime=ee,this.profile=oe,this.type=X,this.excludeObsolete=Z,this.validate=U,this.productVersion=N,this.productDate=H,this.productCommit=q,this.devMode=J,this.language=ne,this.translations=x}static createNlsConfiguration($){return{language:$.language,pseudo:$.language==="pseudo",devMode:$.devMode,translations:$.translations}}static equals($,z){return(0,p.isEqual)($.location,z.location)&&$.mtime===z.mtime&&(0,p.isEqual)($.applicationExtensionslocation,z.applicationExtensionslocation)&&$.applicationExtensionslocationMtime===z.applicationExtensionslocationMtime&&$.profile===z.profile&&$.type===z.type&&$.excludeObsolete===z.excludeObsolete&&$.validate===z.validate&&$.productVersion===z.productVersion&&$.productDate===z.productDate&&$.productCommit===z.productCommit&&$.devMode===z.devMode&&$.language===z.language&&j.equals($.translations,z.translations)}}let M=class extends S.Disposable{constructor($,z,Y,ee,oe){super(),this.f=$,this.g=z,this.h=Y,this.i=ee,this.j=oe}async scanExtensions($){const z=$.profile?await this.l($):await this.k($);let Y={};if($.excludeObsolete&&$.type===1)try{const ee=(await this.i.readFile(this.f)).value.toString();Y=JSON.parse(ee)}catch{}return(0,w.isEmptyObject)(Y)?z:z.filter(ee=>!Y[h.ExtensionKey.create(ee).toString()])}async k($){const z=await this.i.resolve($.location);if(!z.children?.length)return[];const Y=await Promise.all(z.children.map(async ee=>{if(!ee.isDirectory||$.type===1&&(0,p.basename)(ee.resource).indexOf(".")===0)return null;const oe=new A(ee.resource,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(oe)}));return(0,R.coalesce)(Y).sort((ee,oe)=>ee.location.path<oe.location.path?-1:1)}async l($){let z=await this.m($.location,()=>!0,$);if($.applicationExtensionslocation&&!this.h.extUri.isEqual($.location,$.applicationExtensionslocation)){z=z.filter(ee=>!ee.metadata?.isApplicationScoped);const Y=await this.m($.applicationExtensionslocation,ee=>!!ee.metadata?.isApplicationScoped,$);z.push(...Y)}return z}async m($,z,Y){const ee=await this.g.scanProfileExtensions($);if(!ee.length)return[];const oe=await Promise.all(ee.map(async X=>{if(z(X)){const Z=new A(X.location,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(Z,X.metadata)}return null}));return(0,R.coalesce)(oe)}async scanOneOrMultipleExtensions($){try{if(await this.i.exists((0,p.joinPath)($.location,"package.json"))){const z=await this.scanExtension($);return z?[z]:[]}else return await this.scanExtensions($)}catch(z){return this.j.error(`Error scanning extensions at ${$.location.path}:`,(0,L.getErrorMessage)(z)),[]}}async scanExtension($,z){try{let Y=await this.scanExtensionManifest($.location);if(Y){Y.publisher||(Y.publisher=f.UNDEFINED_PUBLISHER),z=z??Y.__metadata,delete Y.__metadata;const ee=(0,h.getGalleryExtensionId)(Y.publisher,Y.name),oe=z?.id?{id:ee,uuid:z.id}:{id:ee},X=z?.isSystem?0:$.type,Z=X===0||!!z?.isBuiltin;O.ImplicitActivationEvents.updateManifest(Y),Y=await this.n($.location,Y,A.createNlsConfiguration($));const U={type:X,identifier:oe,manifest:Y,location:$.location,isBuiltin:Z,targetPlatform:z?.targetPlatform??"undefined",metadata:z,isValid:!0,validations:[]};return $.validate?this.validate(U,$):U}}catch(Y){$.type!==0&&this.j.error(Y)}return null}validate($,z){let Y=!0;const ee=(0,n.validateExtensionManifest)(z.productVersion,z.productDate,z.location,$.manifest,$.isBuiltin);for(const[oe,X]of ee)oe===g.default.Error&&(Y=!1,this.j.error(this.t(z.location,X)));return $.isValid=Y,$.validations=ee,$}async scanExtensionManifest($){const z=(0,p.joinPath)($,"package.json");let Y;try{Y=(await this.i.readFile(z)).value.toString()}catch(oe){return(0,r.toFileOperationResult)(oe)!==1&&this.j.error(this.t($,(0,m.localize)(0,null,z.path,oe.message))),null}let ee;try{ee=JSON.parse(Y)}catch{const X=[];(0,P.parse)(Y,X);for(const Z of X)this.j.error(this.t($,(0,m.localize)(1,null,z.path,Z.offset,Z.length,(0,I.getParseErrorMessage)(Z.error))));return null}return(0,P.getNodeType)(ee)!=="object"?(this.j.error(this.t($,(0,m.localize)(2,null,z.path))),null):ee}async n($,z,Y){const ee=await this.p($,z,Y);if(ee)try{const oe=[],X=await this.r(ee.default,oe);if(oe.length>0)return oe.forEach(U=>{this.j.error(this.t($,(0,m.localize)(3,null,ee.default?.path,(0,I.getParseErrorMessage)(U.error))))}),z;if((0,P.getNodeType)(ee)!=="object")return this.j.error(this.t($,(0,m.localize)(4,null,ee.default?.path))),z;const Z=ee.values||Object.create(null);return(0,W.localizeManifest)(z,Z,X)}catch{}return z}async p($,z,Y){const ee=(0,p.joinPath)($,"package.nls.json"),oe=(N,H)=>{H.forEach(q=>{this.j.error(this.t($,(0,m.localize)(5,null,N?.path,(0,I.getParseErrorMessage)(q.error))))})},X=N=>{this.j.error(this.t($,(0,m.localize)(6,null,N?.path)))},Z=`${z.publisher}.${z.name}`,U=Y.translations[Z];if(U)try{const N=u.URI.file(U),H=(await this.i.readFile(N)).value.toString(),q=[],J=(0,P.parse)(H,q);return q.length>0?(oe(N,q),{values:void 0,default:ee}):(0,P.getNodeType)(J)!=="object"?(X(N),{values:void 0,default:ee}):{values:J.contents?J.contents.package:void 0,default:ee}}catch{return{values:void 0,default:ee}}else{if(!await this.i.exists(ee))return;let H;try{H=await this.s($,Y)}catch{return}if(!H.localized)return{values:void 0,default:H.original};try{const q=(await this.i.readFile(H.localized)).value.toString(),J=[],ne=(0,P.parse)(q,J);return J.length>0?(oe(H.localized,J),{values:void 0,default:H.original}):(0,P.getNodeType)(ne)!=="object"?(X(H.localized),{values:void 0,default:H.original}):{values:ne,default:H.original}}catch{return{values:void 0,default:H.original}}}}async r($,z){if($)try{const Y=(await this.i.readFile($)).value.toString();return(0,P.parse)(Y,z)}catch{}}s($,z){return new Promise((Y,ee)=>{const oe=X=>{const Z=(0,p.joinPath)($,`package.nls.${X}.json`);this.i.exists(Z).then(U=>{U&&Y({localized:Z,original:(0,p.joinPath)($,"package.nls.json")});const N=X.lastIndexOf("-");N===-1?Y({localized:(0,p.joinPath)($,"package.nls.json"),original:null}):(X=X.substring(0,N),oe(X))})};if(z.devMode||z.pseudo||!z.language)return Y({localized:(0,p.joinPath)($,"package.nls.json"),original:null});oe(z.language)})}t($,z){return`[${$.path}]: ${z}`}};M=pe([K(1,y.IExtensionsProfileScannerService),K(2,T.IUriIdentityService),K(3,r.IFileService),K(4,a.ILogService)],M);let B=class extends M{constructor($,z,Y,ee,oe,X){super(z,Y,ee,oe,X),this.y=$,this.v=this.B(new i.ThrottledDelayer(3e3)),this.w=this.B(new l.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions($){const z=await this.C();if(this.u=$,z&&z.input&&A.equals(z.input,this.u))return this.v.trigger(()=>this.F()),z.result.map(ee=>(ee.location=u.URI.revive(ee.location),ee));const Y=await super.scanExtensions($);return await this.D({input:$,result:Y}),Y}async C(){try{const $=await this.i.readFile(this.y),z=JSON.parse($.value.toString());return{result:z.result,input:(0,o.revive)(z.input)}}catch($){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,L.getErrorMessage)($))}return null}async D($){try{await this.i.writeFile(this.y,k.VSBuffer.fromString(JSON.stringify($)))}catch(z){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,L.getErrorMessage)(z))}}async F(){if(!this.u)return;const $=await this.C();if(!$)return;const z=$.result,Y=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!D.equals(Y,z))try{await this.i.del(this.y),this.w.fire()}catch(ee){this.j.error(ee)}}};B=pe([K(2,y.IExtensionsProfileScannerService),K(3,T.IUriIdentityService),K(4,r.IFileService),K(5,a.ILogService)],B);function G(Q,$){const z=(0,h.getExtensionId)(Q.manifest.publisher,Q.manifest.name);return{id:z,identifier:new f.ExtensionIdentifier(z),isBuiltin:Q.type===0,isUserBuiltin:Q.type===1&&Q.isBuiltin,isUnderDevelopment:$,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,...Q.manifest}}e.toExtensionDescription=G;class V extends F{constructor($,z,Y,ee,oe,X,Z,U,N,H,q,J){super($,z,(0,p.joinPath)(Y,".vscode-oss-dev","extensions","control.json"),(0,p.joinPath)(ee,f.MANIFEST_CACHE_FOLDER),oe,X,Z,U,N,H,q,J),this.L=(async()=>{if(v.translationsConfigFile)try{const ne=await this.r.readFile(u.URI.file(v.translationsConfigFile));return JSON.parse(ne.value.toString())}catch{}return Object.create(null)})()}f($){return this.L}}e.NativeExtensionsScannerService=V}),define(re[264],ae([0,1,50,6,38,3,2,23,12,28,7,21]),function(_,e,R,i,D,k,L,P,I,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends L.Disposable{constructor(d,g){super(),this.b=d,this.f=g,this.a=new i.Limiter(5)}async postUninstall(d){const g=this.g(d,"uninstall");return g&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(g.script,"uninstall",g.args,!0,d).then(()=>this.f.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),w=>this.f.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${w}`)))),S.Promises.rm(this.j(d)).then(void 0,w=>this.f.error("Error while removing extension storage path",w))}g(d,g){const w=`vscode:${g}`;if(d.location.scheme===P.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[w]=="string"){const u=d.manifest.scripts[w].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${w} should be a node script`),null):{script:(0,I.join)(d.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(d,g,w,u,m){return new Promise((c,h)=>{const f=this.i(d,g,w,m);let n;const r=t=>{n&&(clearTimeout(n),n=null),t?h(t):c(void 0)};f.on("error",t=>{r((0,D.toErrorMessage)(t)||"Unknown")}),f.on("exit",(t,a)=>{r(t?`post-${g} process exited with code ${t}`:void 0)}),u&&(n=setTimeout(()=>{n=null,f.kill(),h("timed out")},5e3))})}i(d,g,w,u){const m={silent:!0,execArgv:void 0},c=(0,R.fork)(d,[`--type=extension-post-${g}`,...w],m);c.stdout.setEncoding("utf8"),c.stderr.setEncoding("utf8");const h=k.Event.fromNodeEventEmitter(c.stdout,"data"),f=k.Event.fromNodeEventEmitter(c.stderr,"data");h(t=>this.f.info(u.identifier.id,u.manifest.version,`post-${g}`,t)),f(t=>this.f.error(u.identifier.id,u.manifest.version,`post-${g}`,t));const n=k.Event.any(k.Event.map(h,t=>({data:`%c${t}`,format:[""]})),k.Event.map(f,t=>({data:`%c${t}`,format:["color: red"]})));return k.Event.debounce(n,(t,a)=>t?{data:t.data+a.data,format:[...t.format,...a.format]}:{data:a.data,format:a.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),c}j(d){return(0,I.join)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};v=pe([K(0,b.IUserDataProfilesService),K(1,E.ILogService)],v),e.ExtensionsLifecycle=v}),define(re[265],ae([0,1,8,13,60,78,14,4,7,25,31,21]),function(_,e,R,i,D,k,L,P,I,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let v=class extends k.NativeExtensionsScannerService{constructor(d,g,w,u,m,c,h,f){super(R.URI.file(m.builtinExtensionsPath),R.URI.file(m.extensionsPath),m.userHome,R.URI.file(m.userDataPath),d,g,w,u,m,c,h,f)}};v=pe([K(0,b.IUserDataProfilesService),K(1,D.IExtensionsProfileScannerService),K(2,L.IFileService),K(3,I.ILogService),K(4,i.INativeEnvironmentService),K(5,S.IProductService),K(6,E.IUriIdentityService),K(7,P.IInstantiationService)],v),e.ExtensionsScannerService=v}),define(re[18],ae([0,1,6,3,2,207,15,69,4,21]),function(_,e,R,i,D,k,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var E;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var v;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(v=e.StorageTarget||(e.StorageTarget={}));function p(m){const c=m.get(e.TARGET_KEY);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.loadKeyTargets=p;class d extends D.Disposable{constructor(c={flushInterval:d.a}){super(),this.j=c,this.b=this.B(new i.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new i.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new i.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new R.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new D.MutableDisposable),this.u=void 0,this.w=void 0,this.C=void 0}k(){this.i.value=(0,R.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,D.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.J()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(c,h){if(h===e.TARGET_KEY){switch(c){case-1:this.C=void 0;break;case 0:this.w=void 0;break;case 1:this.u=void 0;break}this.c.fire({scope:c})}else this.b.fire({scope:c,key:h,target:this.F(c)[h]})}emitWillSaveState(c){this.f.fire({reason:c})}get(c,h,f){return this.L(h)?.get(c,f)}getBoolean(c,h,f){return this.L(h)?.getBoolean(c,f)}getNumber(c,h,f){return this.L(h)?.getNumber(c,f)}store(c,h,f,n){if((0,L.isUndefinedOrNull)(h)){this.remove(c,f);return}this.r(()=>{this.t(c,f,n),this.L(f)?.set(c,h)})}remove(c,h){this.r(()=>{this.t(c,h,void 0),this.L(h)?.delete(c)})}r(c){this.b.pause(),this.c.pause();try{c()}finally{this.b.resume(),this.c.resume()}}keys(c,h){const f=[],n=this.F(c);for(const r of Object.keys(n))n[r]===h&&f.push(r);return f}t(c,h,f){const n=this.F(h);typeof f=="number"?n[c]!==f&&(n[c]=f,this.L(h)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[c]=="number"&&(delete n[c],this.L(h)?.set(e.TARGET_KEY,JSON.stringify(n)))}get v(){return this.u||(this.u=this.G(1)),this.u}get y(){return this.w||(this.w=this.G(0)),this.w}get D(){return this.C||(this.C=this.G(-1)),this.C}F(c){switch(c){case-1:return this.D;case 0:return this.y;default:return this.v}}G(c){const h=this.L(c);return h?p(h):Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=E.NONE){this.f.fire({reason:c});const h=this.L(-1),f=this.L(0),n=this.L(1);switch(c){case E.NONE:await R.Promises.settled([h?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await R.Promises.settled([h?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.L(-1)?.items??new Map,h=this.L(0)?.items??new Map,f=this.L(1)?.items??new Map;return u(c,h,f,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(c,h){return this.emitWillSaveState(E.NONE),(0,S.isUserDataProfile)(c)?this.N(c,h):this.O(c,h)}H(c,h){return!(c.id===h.id||g(h)&&g(c))}I(c,h,f,n){this.r(()=>{if(n)for(const[r,t]of c)h.set(r,t);else{const r=new Set;for(const[t,a]of c)r.add(t),h.get(t)!==a&&this.n(f,t);for(const[t]of h.items)r.has(t)||this.n(f,t)}})}}e.AbstractStorageService=d,d.a=60*1e3;function g(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=g;class w extends d{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase)),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase)),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase)),this.B(this.Q.onDidChangeStorage(c=>this.n(1,c))),this.B(this.P.onDidChangeStorage(c=>this.n(0,c))),this.B(this.p.onDidChangeStorage(c=>this.n(-1,c)))}L(c){switch(c){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(c){return!1}}e.InMemoryStorageService=w;async function u(m,c,h,f,n,r){const t=O=>{try{return JSON.parse(O)}catch{return O}},a=new Map,s=new Map;m.forEach((O,j)=>{a.set(j,O),s.set(j,t(O))});const l=new Map,o=new Map;c.forEach((O,j)=>{l.set(j,O),o.set(j,t(O))});const y=new Map,C=new Map;h.forEach((O,j)=>{y.set(j,O),C.set(j,t(O))}),console.group(f!==n?`Storage: Application (path: ${f})`:`Storage: Application & Profile (path: ${f}, default profile)`);const T=[];if(a.forEach((O,j)=>{T.push({key:j,value:O})}),console.table(T),console.groupEnd(),console.log(s),f!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const O=[];l.forEach((j,F)=>{O.push({key:F,value:j})}),console.table(O),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${r})`);const W=[];y.forEach((O,j)=>{W.push({key:j,value:O})}),console.table(W),console.groupEnd(),console.log(C)}e.logStorage=u}),define(re[117],ae([0,1,3,2,15,29,33,18]),function(_,e,R,i,D,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends i.Disposable{constructor(b,v){super(),this.a=new R.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new S(b)),this.B(this.b.onDidChange(p=>this.a.fire({extensions:p,source:"storage"}))),this.B(v.onDidInstallExtensions(p=>p.forEach(({local:d,operation:g})=>{d&&g===4&&this.f(d.identifier)})))}async enableExtension(b,v){return this.f(b)?(this.a.fire({extensions:[b],source:v}),!0):!1}async disableExtension(b,v){return this.c(b)?(this.a.fire({extensions:[b],source:v}),!0):!1}getDisabledExtensions(){return this.h(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(b){const v=this.getDisabledExtensions();return v.every(p=>!(0,L.areSameExtensions)(p,b))?(v.push(b),this.g(v),!0):!1}f(b){const v=this.getDisabledExtensions();for(let p=0;p<v.length;p++){const d=v[p];if((0,L.areSameExtensions)(d,b))return v.splice(p,1),this.g(v),!0}return!1}g(b){this.i(k.DISABLED_EXTENSIONS_STORAGE_PATH,b)}h(b){return this.b.get(b,0)}i(b,v){this.b.set(b,v,0)}};I=pe([K(0,P.IStorageService),K(1,k.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class S extends i.Disposable{constructor(b){super(),this.c=b,this.a=Object.create(null),this.b=this.B(new R.Emitter),this.onDidChange=this.b.event,this.B(b.onDidChangeValue(v=>this.f(v)))}get(b,v){let p;return v===0?((0,D.isUndefinedOrNull)(this.a[b])&&(this.a[b]=this.g(b,v)),p=this.a[b]):p=this.g(b,v),JSON.parse(p)}set(b,v,p){const d=JSON.stringify(v.map(({id:w,uuid:u})=>({id:w,uuid:u})));this.g(b,p)!==d&&(p===0&&(v.length?this.a[b]=d:delete this.a[b]),this.h(b,v.length?d:void 0,p))}f(b){if(b.scope===0&&!(0,D.isUndefinedOrNull)(this.a[b.key])&&this.g(b.key,b.scope)!==this.a[b.key]){const p=this.get(b.key,b.scope);delete this.a[b.key];const d=this.get(b.key,b.scope),g=p.filter(u=>!d.some(m=>(0,L.areSameExtensions)(u,m))),w=d.filter(u=>!p.some(m=>(0,L.areSameExtensions)(m,u)));(g.length||w.length)&&this.b.fire([...g,...w])}}g(b,v){return this.c.get(b,v,"[]")}h(b,v,p){v?this.c.store(b,v,p,1):this.c.remove(b,p)}}e.StorageManager=S}),define(re[266],ae([0,1,19,22,9,5,36,15,8,16,13,29,33,70,14,7,25,47,237,18,24]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u,m,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const f=k.isWeb?"web":(0,b.getTargetPlatform)(k.platform,L.arch);var n;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function r(...U){return String(U.reduce((N,H)=>N|H,0))}var t;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class y{constructor(N=o){this.d=N}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(N,H=this.d.pageSize){return new y({...this.d,pageNumber:N,pageSize:H})}withFilter(N,...H){const q=[...this.d.criteria,...H.length?H.map(J=>({filterType:N,value:J})):[{filterType:N}]];return new y({...this.d,criteria:q})}withSortBy(N){return new y({...this.d,sortBy:N})}withSortOrder(N){return new y({...this.d,sortOrder:N})}withFlags(...N){return new y({...this.d,flags:N.reduce((H,q)=>H|q,0)})}withAssetTypes(...N){return new y({...this.d,assetTypes:N})}withSource(N){return new y({...this.d,source:N})}get raw(){const{criteria:N,pageNumber:H,pageSize:q,sortBy:J,sortOrder:ne,flags:x,assetTypes:te}=this.d;return{filters:[{criteria:N,pageNumber:H,pageSize:q,sortBy:J,sortOrder:ne}],assetTypes:te,flags:x}}get searchText(){const N=this.d.criteria.filter(H=>H.filterType===t.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(N=>String(N.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function C(U,N){const H=(U||[]).filter(q=>q.statisticName===N)[0];return H?H.value:0}function T(U){const N="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(q=>q.assetType.indexOf(N)===0).reduce((q,J)=>{const ne=j(U,J.assetType);return ne&&q.push([J.assetType.substring(N.length),ne]),q},[])}function W(U){if(U.properties){const N=U.properties.filter(J=>J.key===a.Repository),H=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),q=N.filter(J=>H.test(J.value))[0];return q?{uri:q.value,fallbackUri:q.value}:null}return j(U,a.Repository)}function O(U){return{uri:`${U.fallbackAssetUri}/${a.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${a.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function j(U,N){return U.files.filter(q=>q.assetType===N)[0]?{uri:`${U.assetUri}/${N}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${N}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function F(U,N){const H=U.properties?U.properties.filter(J=>J.key===N):[],q=H.length>0&&H[0].value;return q?q.split(",").map(J=>(0,v.adoptToGalleryExtensionId)(J)):[]}function A(U){const N=U.properties?U.properties.filter(H=>H.key===s.Engine):[];return N.length>0&&N[0].value||""}function M(U){const N=U.properties?U.properties.filter(H=>H.key===s.PreRelease):[];return N.length>0&&N[0].value==="true"}function B(U){const N=U.properties?U.properties.filter(q=>q.key===s.LocalizedLanguages):[],H=N.length>0&&N[0].value||"";return H?H.split(","):[]}function G(U){return U.properties?.find(N=>N.key===s.SponsorLink)?.value}function V(U){return U.indexOf("preview")!==-1}function Q(U){return U.targetPlatform?(0,b.toTargetPlatform)(U.targetPlatform):"undefined"}function $(U){const N=(0,R.distinct)(U.versions.map(Q)),H=!!U.tags?.includes(b.WEB_EXTENSION_TAG),q=N.indexOf("web");return H?q===-1&&N.push("web"):q!==-1&&N.splice(q,1),N}function z(U,N){const H=(0,b.getFallbackTargetPlarforms)(N);for(let q=0;q<U.length;q++){const J=U[q];if(J.version===U[q-1]?.version){let ne=q;const x=Q(J);if(x===N)for(;ne>0&&U[ne-1].version===J.version;)ne--;else if(H.includes(x))for(;ne>0&&U[ne-1].version===J.version&&Q(U[ne-1])!==N;)ne--;ne!==q&&(U.splice(q,1),U.splice(ne,0,J))}}return U}e.sortExtensionVersions=z;function Y(U,N,H){U.telemetryData={index:N,querySource:H}}function ee(U,N,H){const q=U.versions[0],J={manifest:j(N,a.Manifest),readme:j(N,a.Details),changelog:j(N,a.Changelog),license:j(N,a.License),repository:W(N),download:O(N),icon:j(N,a.Icon),signature:j(N,a.Signature),coreTranslations:T(N)};return{identifier:{id:(0,v.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:N.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:G(q),description:U.shortDescription||"",installCount:C(U.statistics,"install"),rating:C(U.statistics,"averagerating"),ratingCount:C(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:H,assets:J,properties:{dependencies:F(N,s.Dependency),extensionPack:F(N,s.ExtensionPack),engine:A(N),localizedLanguages:B(N),targetPlatform:Q(N),isPreReleaseVersion:M(N)},hasPreReleaseVersion:M(q),hasReleaseVersion:!0,preview:V(U.flags),isSigned:!!J.signature}}let oe=class{constructor(N,H,q,J,ne,x,te,se){this.k=H,this.l=q,this.n=J,this.o=ne,this.q=x,this.u=te,this.w=se;const le=te.extensionsGallery,ue=le?.servicePPEUrl&&se.getValue("_extensionsGallery.enablePPE");this.d=ue?le.servicePPEUrl:le?.serviceUrl,this.g=ue?void 0:le?.searchUrl,this.h=le?.controlUrl,this.j=(0,m.resolveMarketplaceHeaders)(te.version,te,this.n,this.w,this.q,N,this.o)}x(N=""){return`${this.d}${N}`}isEnabled(){return!!this.d}async getExtensions(N,H,q){const J=i.CancellationToken.isCancellationToken(H)?{}:H,ne=i.CancellationToken.isCancellationToken(H)?H:q,x=[],te=[],se=[],le=[];let ue=!0;for(const be of N){be.uuid?te.push(be.uuid):x.push(be.id);const Ce=!!(be.version||be.preRelease);se.push({id:be.id,uuid:be.uuid,includePreRelease:Ce}),be.version&&le.push({id:be.id,uuid:be.uuid,version:be.version}),ue=ue&&!!be.hasPreRelease&&!Ce}if(!te.length&&!x.length)return[];let ye=new y().withPage(1,N.length);te.length&&(ye=ye.withFilter(t.ExtensionId,...te)),x.length&&(ye=ye.withFilter(t.ExtensionName,...x)),(J.queryAllVersions||ue)&&(ye=ye.withFlags(ye.flags,n.IncludeVersions)),J.source&&(ye=ye.withSource(J.source));const{extensions:Se}=await this.A(ye,{targetPlatform:J.targetPlatform??f,includePreRelease:se,versions:le,compatible:!!J.compatible},ne);return J.source&&Se.forEach((be,Ce)=>Y(be,Ce,J.source)),Se}async getCompatibleExtension(N,H,q){if((0,b.isNotWebExtensionInWebTargetPlatform)(N.allTargetPlatforms,q))return null;if(await this.isExtensionCompatible(N,H,q))return N;const J=new y().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,N.identifier.uuid),{extensions:ne}=await this.A(J,{targetPlatform:q,compatible:!0,includePreRelease:H},i.CancellationToken.None);return ne[0]||null}async isExtensionCompatible(N,H,q){if(!(0,b.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,q)||!H&&N.properties.isPreReleaseVersion)return!1;let J=N.properties.engine;if(!J){const ne=await this.getManifest(N,i.CancellationToken.None);if(!ne)throw new Error("Manifest was not found");J=ne.engines.vscode}return(0,p.isEngineValid)(J,this.u.version,this.u.date)}async y(N,H,q,J,ne){if(!(0,b.isTargetPlatformCompatible)(Q(N),J,ne)||H!=="any"&&M(N)!==(H==="prerelease"))return!1;if(q)try{const x=await this.F(N);if(!(0,p.isEngineValid)(x,this.u.version,this.u.date))return!1}catch(x){return this.l.error(`Error while getting the engine for the version ${N.version}.`,(0,D.getErrorMessage)(x)),!1}return!0}async query(N,H){let q=N.text||"";const J=N.pageSize??50;let ne=new y().withPage(1,J);q?(q=q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ye,Se)=>(ne=ne.withFilter(t.Category,Se||ye),"")),q=q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ye,Se)=>(ne=ne.withFilter(t.Tag,Se||ye),"")),q=q.replace(/\bfeatured(\s+|\b|$)/g,()=>(ne=ne.withFilter(t.Featured),"")),q=q.trim(),q&&(q=q.length<200?q:q.substring(0,200),ne=ne.withFilter(t.SearchText,q)),ne=ne.withSortBy(0)):N.ids?ne=ne.withFilter(t.ExtensionId,...N.ids):N.names?ne=ne.withFilter(t.ExtensionName,...N.names):ne=ne.withSortBy(4),typeof N.sortBy=="number"&&(ne=ne.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(ne=ne.withSortOrder(N.sortOrder)),N.source&&(ne=ne.withSource(N.source));const x=async(ue,ye)=>{const{extensions:Se,total:be}=await this.A(ue,{targetPlatform:f,compatible:!1,includePreRelease:!!N.includePreRelease},ye);return Se.forEach((Ce,Te)=>Y(Ce,(ue.pageNumber-1)*ue.pageSize+Te,N.source)),{extensions:Se,total:be}},{extensions:te,total:se}=await x(ne,H),le=async(ue,ye)=>{if(ye.isCancellationRequested)throw new D.CancellationError;const{extensions:Se}=await x(ne.withPage(ue+1),ye);return Se};return{firstPage:te,total:se,pageSize:ne.pageSize,getPage:le}}async A(N,H,q){const J=N.flags;!!(N.flags&n.IncludeLatestVersionOnly)&&!!(N.flags&n.IncludeVersions)&&(N=N.withFlags(N.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(N.flags&n.IncludeLatestVersionOnly)&&!(N.flags&n.IncludeVersions)&&(N=N.withFlags(N.flags,n.IncludeLatestVersionOnly)),H.versions?.length&&(N=N.withFlags(N.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),N=N.withFlags(N.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:ne,total:x}=await this.C(N,q);if(!(N.flags&n.IncludeLatestVersionOnly)){const ue=[];for(const ye of ne){const Se=await this.B(ye,H);Se&&ue.push(Se)}return{extensions:ue,total:x}}const se=[],le=new Map;for(let ue=0;ue<ne.length;ue++){const ye=ne[ue],Se={id:(0,v.getGalleryExtensionId)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},be=(0,P.isBoolean)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(Te=>(0,v.areSameExtensions)(Te,Se))?.includePreRelease;if(H.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)($(ye),H.targetPlatform))continue;const Ce=await this.B(ye,H);!Ce||Ce.properties.isPreReleaseVersion&&(!be||!Ce.hasReleaseVersion)||!Ce.properties.isPreReleaseVersion&&Ce.properties.targetPlatform!==H.targetPlatform&&Ce.hasPreReleaseVersion?le.set(ye.extensionId,ue):se.push([ue,Ce])}if(le.size){const ue=new Date().getTime(),ye=new y().withFlags(J&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,le.size).withFilter(t.ExtensionId,...le.keys()),{extensions:Se}=await this.A(ye,H,q);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:le.size});for(const be of Se){const Ce=le.get(be.identifier.uuid);se.push([Ce,be])}}return{extensions:se.sort((ue,ye)=>ue[0]-ye[0]).map(([,ue])=>ue),total:x}}async B(N,H){const q={id:(0,v.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},J=H.versions?.find(se=>(0,v.areSameExtensions)(se,q))?.version,ne=(0,P.isBoolean)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(se=>(0,v.areSameExtensions)(se,q))?.includePreRelease,x=$(N),te=z(N.versions,H.targetPlatform);if(H.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(x,H.targetPlatform))return null;for(let se=0;se<te.length;se++){const le=te[se];if(!(J&&le.version!==J)){if(await this.y(le,ne?"any":"release",H.compatible,x,H.targetPlatform))return ee(N,le,x);if(J&&le.version===J)return null}}return J||H.compatible?null:ee(N,N.versions[0],x)}async C(N,H){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,r(n.Unpublished));const q=await this.j,J=JSON.stringify(N.raw),ne={...q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},x=new Date().getTime();let te,se,le=0;try{if(te=await this.k.request({type:"POST",url:this.g&&N.criteria.some(ye=>ye.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:J,headers:ne},H),te.res.statusCode&&te.res.statusCode>=400&&te.res.statusCode<500)return{galleryExtensions:[],total:le};const ue=await(0,u.asJson)(te);if(ue){const ye=ue.results[0],Se=ye.extensions,be=ye.resultMetadata&&ye.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return le=be&&be.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:le}}return{galleryExtensions:[],total:le}}catch(ue){throw se=ue,ue}finally{this.o.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(J.length),duration:new Date().getTime()-x,success:!!te&&(0,u.isSuccess)(te),responseBodySize:te?.res.headers["Content-Length"],statusCode:te?String(te.res.statusCode):void 0,errorCode:se?(0,D.isCancellationError)(se)?"canceled":(0,D.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(N,H,q,J){if(!this.isEnabled())return;const ne=k.isWeb?this.x(`/itemName/${N}.${H}/version/${q}/statType/${J==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${N}/extensions/${H}/${q}/stats?statType=${J}`),x=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.j,Accept:x};try{await this.k.request({type:"POST",url:ne,headers:se},i.CancellationToken.None)}catch{}}async download(N,H,q){this.l.trace("ExtensionGalleryService#download",N.identifier.id);const J=(0,v.getGalleryExtensionTelemetryData)(N),ne=new Date().getTime(),x=ue=>this.o.publicLog("galleryService:downloadVSIX",{...J,duration:ue}),te=q===2?"install":q===3?"update":"",se=te?{uri:`${N.assets.download.uri}${I.URI.parse(N.assets.download.uri).query?"&":"?"}${te}=true`,fallbackUri:`${N.assets.download.fallbackUri}${I.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${te}=true`}:N.assets.download,le=await this.E(se);await this.q.writeFile(H,le.stream),x(new Date().getTime()-ne)}async downloadSignatureArchive(N,H){if(!N.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",N.identifier.id);const q=await this.E(N.assets.signature);await this.q.writeFile(H,q.stream)}async getReadme(N,H){if(N.assets.readme){const q=await this.E(N.assets.readme,{},H);return await(0,u.asTextOrError)(q)||""}return""}async getManifest(N,H){if(N.assets.manifest){const q=await this.E(N.assets.manifest,{},H),J=await(0,u.asTextOrError)(q);return J?JSON.parse(J):null}return null}async D(N,H){const q=j(N,a.Manifest);if(!q)throw new Error("Manifest was not found");const J={"Accept-Encoding":"gzip"},ne=await this.E(q,{headers:J});return await(0,u.asJson)(ne)}async getCoreTranslation(N,H){const q=N.assets.coreTranslations.filter(J=>J[0]===H.toUpperCase())[0];if(q){const J=await this.E(q[1]),ne=await(0,u.asTextOrError)(J);return ne?JSON.parse(ne):null}return null}async getChangelog(N,H){if(N.assets.changelog){const q=await this.E(N.assets.changelog,{},H);return await(0,u.asTextOrError)(q)||""}return""}async getAllCompatibleVersions(N,H,q){let J=new y().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?J=J.withFilter(t.ExtensionId,N.identifier.uuid):J=J.withFilter(t.ExtensionName,N.identifier.id);const{galleryExtensions:ne}=await this.C(J,i.CancellationToken.None);if(!ne.length)return[];const x=$(ne[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(x,q))return[];const te=[];await Promise.all(ne[0].versions.map(async ue=>{try{await this.y(ue,H?"any":"release",!0,x,q)&&te.push(ue)}catch{}}));const se=[],le=new Set;for(const ue of z(te,q))le.has(ue.version)||(le.add(ue.version),se.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:M(ue)}));return se}async E(N,H={},q=i.CancellationToken.None){const J=await this.j,ne={type:"GET"},x={...J,...H.headers||{}};H={...H,...ne,headers:x};const te=N.uri,se=N.fallbackUri,le={...H,url:te};try{const ue=await this.k.request(le,q);if(ue.res.statusCode===200)return ue;const ye=await(0,u.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${ye}`)}catch(ue){if((0,D.isCancellationError)(ue))throw ue;const ye=(0,D.getErrorMessage)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:te,message:ye});const Se={...H,url:se};return this.k.request(Se,q)}}async F(N){let H=A(N);if(!H){const q=await this.D(N,i.CancellationToken.None);if(!q)throw new Error("Manifest was not found");H=q.engines.vscode}return H}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const N=await this.k.request({type:"GET",url:this.h},i.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const H=await(0,u.asJson)(N),q=[],J={};if(H){for(const ne of H.malicious)q.push({id:ne});if(H.migrateToPreRelease)for(const[ne,x]of Object.entries(H.migrateToPreRelease))(!x.engine||(0,p.isEngineValid)(x.engine,this.u.version,this.u.date))&&(J[ne.toLowerCase()]={disallowInstall:!0,extension:{id:x.id,displayName:x.displayName,autoMigrate:{storage:!!x.migrateStorage},preRelease:!0}});if(H.deprecated)for(const[ne,x]of Object.entries(H.deprecated))x&&(J[ne.toLowerCase()]=(0,P.isBoolean)(x)?{}:x)}return{malicious:q,deprecated:J}}};oe=pe([K(1,u.IRequestService),K(2,g.ILogService),K(3,E.IEnvironmentService),K(4,h.ITelemetryService),K(5,d.IFileService),K(6,w.IProductService),K(7,S.IConfigurationService)],oe);let X=class extends oe{constructor(N,H,q,J,ne,x,te,se){super(N,H,q,J,ne,x,te,se)}};X=pe([K(0,c.IStorageService),K(1,u.IRequestService),K(2,g.ILogService),K(3,E.IEnvironmentService),K(4,h.ITelemetryService),K(5,d.IFileService),K(6,w.IProductService),K(7,S.IConfigurationService)],X),e.ExtensionGalleryService=X;let Z=class extends oe{constructor(N,H,q,J,ne,x,te){super(void 0,N,H,q,J,ne,x,te)}};Z=pe([K(0,u.IRequestService),K(1,g.ILogService),K(2,E.IEnvironmentService),K(3,h.ITelemetryService),K(4,d.IFileService),K(5,w.IProductService),K(6,S.IConfigurationService)],Z),e.ExtensionGalleryServiceWithNoStorageService=Z}),define(re[79],ae([0,1,4,3,2,18,33,25,19,7,15]),function(_,e,R,i,D,k,L,P,I,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,R.createDecorator)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let v=class Ze extends D.Disposable{static b(d){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static c(d){const g=b.exec(d);if(g&&g[1])return{id:g[1],version:g[2]}}static async removeOutdatedExtensionVersions(d,g){const w=await d.getInstalled(),u=[];for(const[m,c]of Ze.f(g)){const h=w.find(f=>(0,L.areSameExtensions)(f.identifier,{id:m}))?.manifest.version;for(const f of c)h!==f&&u.push(Ze.b({id:m,version:f}))}for(const m of u)g.remove(m,0)}static f(d){const g=new Map,w=d.keys(0,1);for(const u of w){const m=Ze.c(u);if(m){let c=g.get(m.id.toLowerCase());c||g.set(m.id.toLowerCase(),c=[]),c.push(m.version)}}return g}constructor(d,g,w){super(),this.i=d,this.j=g,this.k=w,this.g=this.B(new i.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Ze.f(d),this.B(this.i.onDidChangeValue(u=>this.l(u)))}l(d){if(d.scope!==0)return;if(this.h.has(d.key.toLowerCase())){this.g.fire();return}const g=Ze.c(d.key);if(g){if(this.i.get(d.key,0)===void 0)this.h.delete(g.id.toLowerCase());else{let w=this.h.get(g.id.toLowerCase());w||this.h.set(g.id.toLowerCase(),w=[]),w.push(g.version),this.g.fire()}return}}m(d){if((0,E.isString)(d))return d;const g=d.manifest?d.manifest.publisher:d.publisher,w=d.manifest?d.manifest.name:d.name;return(0,L.getExtensionId)(g,w)}getExtensionState(d,g){const w=this.m(d),u=this.getExtensionStateRaw(d,g);if(u)try{return JSON.parse(u)}catch(m){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${g}): ${m}`)}}getExtensionStateRaw(d,g){const w=this.m(d),u=this.i.get(w,g?0:1);return u&&u?.length>Ze.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${w}, global: ${g}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(d,g,w){const u=this.m(d);g===void 0?this.i.remove(u,w?0:1):this.i.store(u,JSON.stringify(g),w?0:1,1)}setKeysForSync(d,g){this.i.store(Ze.b(d),JSON.stringify(g),0,1)}getKeysForSync(d){const g=this.j.extensionSyncedKeys?.[d.id.toLowerCase()],w=this.i.get(Ze.b(d),0),u=w?JSON.parse(w):void 0;return u&&g?(0,I.distinct)([...u,...g]):u||g}addToMigrationList(d,g){if(d!==g){const w=this.n.filter(u=>!u.includes(d)&&!u.includes(g));w.push([d,g]),this.n=w}}getSourceExtensionToMigrate(d){const g=this.n.find(([,w])=>d===w);return g?g[0]:void 0}get n(){const d=this.i.get("extensionStorage.migrationList",-1,"[]");try{const g=JSON.parse(d);if(Array.isArray(g))return g}catch{}return[]}set n(d){d.length?this.i.store("extensionStorage.migrationList",JSON.stringify(d),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};v.a=512*1024,v=pe([K(0,k.IStorageService),K(1,P.IProductService),K(2,S.ILogService)],v),e.ExtensionStorageService=v}),define(re[267],ae([0,1,19,6,3,12,5,36,8,159,13,29,33,227,98,14,7,58,25,47,18,24]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u,m,c,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const n="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let t=class extends p.ExtensionTipsService{constructor(s,l,o,y,C,T,W,O,j,F){super(W,O,j,F),this.r=s,this.s=l,this.t=o,this.u=y,this.v=C,this.w=T,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Map,this.p=new Map,O.exeBasedExtensionTips&&Object.entries(O.exeBasedExtensionTips).forEach(([A,M])=>{const B=[],G=[],V=[];Object.entries(M.recommendations).forEach(([Q,$])=>{$.important?M.important?B.push({extensionId:Q,extensionName:$.name,isExtensionPack:!!$.isExtensionPack}):G.push({extensionId:Q,extensionName:$.name,isExtensionPack:!!$.isExtensionPack}):V.push({extensionId:Q,extensionName:$.name,isExtensionPack:!!$.isExtensionPack})}),B.length&&this.k.set(A,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:B}),G.length&&this.l.set(A,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:G}),V.length&&this.m.set(A,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:V})}),(0,i.timeout)(3e3).then(async()=>{await this.y(),this.D(),this.F()})}async getImportantExecutableBasedTips(){const s=await this.N(this.k),l=await this.N(this.l);return[...s,...l]}getOtherExecutableBasedTips(){return this.N(this.m)}async y(){const s=await this.N(this.k),l=await this.N(this.l),o=await this.t.getInstalled();this.n=this.C(s,o),this.p=this.C(l,o)}C(s,l){const o=new Map;s.forEach(O=>o.set(O.extensionId.toLowerCase(),O));const{installed:y,uninstalled:C}=this.M([...o.keys()],l);for(const O of y){const j=o.get(O);j&&this.s.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:j.exeName})}for(const O of C){const j=o.get(O);j&&this.s.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:j.exeName})}const T=this.J(),W=new Map;for(const O of C){const j=o.get(O);if(j&&(!T[j.exeName]||!T[j.exeName].includes(j.extensionId))){let F=W.get(j.exeName);F||(F=[],W.set(j.exeName,F)),F.push(j)}}return W}D(){if(this.n.size===0)return;const[s,l]=[...this.n.entries()][0];this.G(l).then(o=>{switch(o){case"reacted":this.L(l[0].exeName,l);break;case"ignored":this.n.delete(s);break;case"incompatibleWindow":{const y=D.Event.once(D.Event.latch(D.Event.any(this.v.onDidOpenWindow,this.v.onDidFocusWindow)));this.B(y(()=>this.D()));break}case"toomany":{const y=this.B((0,i.disposableTimeout)(()=>{y.dispose(),this.D()},36e5));break}}})}F(){if(this.p.size===0)return;const s=this.H(),l=Date.now()-s,o=7*24*60*60*1e3;if(l<o){const T=this.B((0,i.disposableTimeout)(()=>{T.dispose(),this.F()},o-l));return}const[y,C]=[...this.p.entries()][0];this.G(C).then(T=>{switch(T){case"reacted":{this.I(Date.now()),this.p.delete(y),this.L(C[0].exeName,C);const W=this.B((0,i.disposableTimeout)(()=>{W.dispose(),this.F()},o));break}case"ignored":this.p.delete(y),this.F();break;case"incompatibleWindow":{const W=D.Event.once(D.Event.latch(D.Event.any(this.v.onDidOpenWindow,this.v.onDidFocusWindow)));this.B(W(()=>this.F()));break}case"toomany":{const W=this.B((0,i.disposableTimeout)(()=>{W.dispose(),this.F()},36e5));break}}})}async G(s){const l=await this.t.getInstalled(1),o=s.filter(C=>!C.whenNotInstalled||C.whenNotInstalled.every(T=>l.every(W=>!(0,v.areSameExtensions)(W.identifier,{id:T})))).map(({extensionId:C})=>C.toLowerCase()),y=(0,S.localize)(0,null,s[0].exeFriendlyName);return this.w.promptImportantExtensionsInstallNotification(o,y,`@exe:"${s[0].exeName}"`,3)}H(){let s=this.u.getNumber(r,-1);return s||(s=Date.now(),this.I(s)),s}I(s){this.u.store(r,s,-1,1)}J(){return JSON.parse(this.u.get(n,-1,"{}"))}L(s,l){const o=this.J();o[s]=l.map(({extensionId:y})=>y.toLowerCase()),this.u.store(n,JSON.stringify(o),-1,0)}M(s,l){const o=[],y=[],C=l.reduce((T,W)=>(T.add(W.identifier.id.toLowerCase()),T),new Set);return s.forEach(T=>{C.has(T.toLowerCase())?o.push(T):y.push(T)}),{installed:o,uninstalled:y}}async N(s){const l=[],o=new Map;for(const y of s.keys()){const C=s.get(y);if(!C||!(0,R.isNonEmptyArray)(C.recommendations))continue;const T=[];L.isWindows?C.windowsPath&&T.push(C.windowsPath.replace("%USERPROFILE%",P.env.USERPROFILE).replace("%ProgramFiles(x86)%",P.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",P.env.ProgramFiles).replace("%APPDATA%",P.env.APPDATA).replace("%WINDIR%",P.env.WINDIR)):(T.push((0,k.join)("/usr/local/bin",y)),T.push((0,k.join)("/usr/bin",y)),T.push((0,k.join)(this.r.userHome.fsPath,y)));for(const W of T){let O=o.get(W);if(O===void 0&&(O=await this.b.exists(I.URI.file(W)),o.set(W,O)),O)for(const{extensionId:j,extensionName:F,isExtensionPack:A,whenNotInstalled:M}of C.recommendations)l.push({extensionId:j,extensionName:F,isExtensionPack:A,exeName:y,exeFriendlyName:C.exeFriendlyName,windowsPath:C.windowsPath,whenNotInstalled:M})}}return l}};t=pe([K(0,E.INativeEnvironmentService),K(1,f.ITelemetryService),K(2,b.IExtensionManagementService),K(3,h.IStorageService),K(4,u.INativeHostService),K(5,d.IExtensionRecommendationNotificationService),K(6,g.IFileService),K(7,m.IProductService),K(8,c.IRequestService),K(9,w.ILogService)],t),e.ExtensionTipsService=t}),define(re[268],ae([0,1,6,2,20,69,18,75,21]),function(_,e,R,i,D,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends L.AbstractStorageService{constructor(b,v,p,d){super(),this.X=b,this.Y=v,this.ab=p,this.bb=d,this.p=this.Y.defaultProfile,this.s=this.cb(),this.P=this.Y.currentProfile,this.Q=this.B(new i.DisposableStore),this.R=this.db(this.P),this.S=this.X?.id,this.U=this.B(new i.DisposableStore),this.W=this.eb(this.X)}cb(){const b=this.B(new P.ApplicationStorageDatabaseClient(this.ab.getChannel("storage"))),v=this.B(new k.Storage(b));return this.B(v.onDidChangeStorage(p=>this.n(-1,p))),v}db(b){this.Q.clear(),this.P=b;let v;if((0,L.isProfileUsingDefaultStorage)(b))v=this.s;else{const p=this.Q.add(new P.ProfileStorageDatabaseClient(this.ab.getChannel("storage"),b));v=this.Q.add(new k.Storage(p))}return this.Q.add(v.onDidChangeStorage(p=>this.n(0,p))),v}eb(b){this.U.clear(),this.S=b?.id;let v;if(b){const p=this.U.add(new P.WorkspaceStorageDatabaseClient(this.ab.getChannel("storage"),b));v=this.U.add(new k.Storage(p)),this.U.add(v.onDidChangeStorage(d=>this.n(1,d)))}return v}async J(){await R.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(b){switch(b){case-1:return this.s;case 0:return this.R;default:return this.W}}M(b){switch(b){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,D.joinPath)(this.bb.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.emitWillSaveState(L.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(b,v){if(!this.H(this.P,b))return;const p=this.R,d=p.items;p!==this.s&&await p.close(),this.R=this.db(b),await this.R.init(),this.I(d,this.R,0,v)}async O(b,v){const p=this.W,d=p?.items??new Map;await p?.close(),this.W=this.eb(b),await this.W.init(),this.I(d,this.W,1,v)}hasScope(b){return(0,I.isUserDataProfile)(b)?this.P.id===b.id:this.S===b.id}}e.NativeStorageService=S}),define(re[62],ae([0,1,2,69,4,18]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,D.createDecorator)("IUserDataProfileStorageService");let L=class extends R.Disposable{constructor(S){super(),this.a=S}async readStorageData(S){return this.withProfileScopedStorageService(S,async E=>this.b(E))}async updateStorageData(S,E,b){return this.withProfileScopedStorageService(S,async v=>this.c(v,E,b))}async withProfileScopedStorageService(S,E){if(this.a.hasScope(S))return E(this.a);const b=await this.createStorageDatabase(S),v=new P(b);try{await v.initialize();const p=await E(v);return await v.flush(),p}finally{v.dispose(),await this.f(b)}}b(S){const E=new Map,b=v=>{for(const p of S.keys(0,v))E.set(p,{value:S.get(p,0),target:v})};return b(0),b(1),E}c(S,E,b){for(const[v,p]of E)S.store(v,p,0,b)}async f(S){try{await S.close()}finally{(0,R.isDisposable)(S)&&S.dispose()}}};L=pe([K(0,k.IStorageService)],L),e.AbstractUserDataProfileStorageService=L;class P extends k.AbstractStorageService{constructor(S){super({flushInterval:100}),this.p=this.B(new i.Storage(S))}J(){return this.p.init()}L(S){return S===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(re[269],ae([0,1,3,2,20,13,57,21]),function(_,e,R,i,D,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let I=class extends i.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.b}constructor(E,b,v){super(),this.b=[],this.c=this.B(new R.Emitter),this.onDidChangeProfiles=this.c.event,this.f=!0,this.a=b.getChannel("userDataProfiles"),this.profilesHome=(0,D.joinPath)(v.userRoamingDataHome,"profiles"),this.b=E.map(p=>(0,P.reviveProfile)(p,this.profilesHome.scheme)),this.B(this.a.listen("onDidChangeProfiles")(p=>{const d=p.added.map(u=>(0,P.reviveProfile)(u,this.profilesHome.scheme)),g=p.removed.map(u=>(0,P.reviveProfile)(u,this.profilesHome.scheme)),w=p.updated.map(u=>(0,P.reviveProfile)(u,this.profilesHome.scheme));this.b=p.all.map(u=>(0,P.reviveProfile)(u,this.profilesHome.scheme)),this.c.fire({added:d,removed:g,updated:w,all:this.profiles})})),this.onDidResetWorkspaces=this.a.listen("onDidResetWorkspaces")}setEnablement(E){this.f=E}isEnabled(){return this.f}async createNamedProfile(E,b,v){const p=await this.a.call("createNamedProfile",[E,b,v]);return(0,P.reviveProfile)(p,this.profilesHome.scheme)}async createProfile(E,b,v,p){const d=await this.a.call("createProfile",[E,b,v,p]);return(0,P.reviveProfile)(d,this.profilesHome.scheme)}async createTransientProfile(E){const b=await this.a.call("createTransientProfile",[E]);return(0,P.reviveProfile)(b,this.profilesHome.scheme)}async setProfileForWorkspace(E,b){await this.a.call("setProfileForWorkspace",[E,b])}removeProfile(E){return this.a.call("removeProfile",[E])}async updateProfile(E,b){const v=await this.a.call("updateProfile",[E,b]);return(0,P.reviveProfile)(v,this.profilesHome.scheme)}resetWorkspaces(){return this.a.call("resetWorkspaces")}cleanUp(){return this.a.call("cleanUp")}cleanUpTransientProfiles(){return this.a.call("cleanUpTransientProfiles")}};I=pe([K(1,L.IMainProcessService),K(2,k.IEnvironmentService)],I),e.UserDataProfilesNativeService=I}),define(re[270],ae([0,1,3,2,57,7,62,18,75,21,71]),function(_,e,R,i,D,k,L,P,I,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let b=class extends L.AbstractUserDataProfileStorageService{constructor(p,d,g,w){super(g),this.h=p;const u=p.getChannel("profileStorageListener"),m=this.B(new i.MutableDisposable);this.g=this.B(new R.Emitter({onWillAddFirstListener:()=>{m.value=u.listen("onDidChange")(c=>{w.trace("profile storage changes",c),this.g.fire({targetChanges:c.targetChanges.map(h=>(0,S.reviveProfile)(h,d.profilesHome.scheme)),valueChanges:c.valueChanges.map(h=>({...h,profile:(0,S.reviveProfile)(h.profile,d.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>m.value=void 0})),this.onDidChange=this.g.event}async createStorageDatabase(p){const d=this.h.getChannel("storage");return(0,P.isProfileUsingDefaultStorage)(p)?new I.ApplicationStorageDatabaseClient(d):new I.ProfileStorageDatabaseClient(d,p)}};b=pe([K(0,D.IMainProcessService),K(1,S.IUserDataProfilesService),K(2,P.IStorageService),K(3,k.ILogService)],b),e.UserDataProfileStorageService=b,(0,E.registerSingleton)(L.IUserDataProfileStorageService,b,1)}),define(re[41],ae([0,1,19,6,17,22,3,35,2,27,15,175,16,13,14,7,44,18,24,31,26,21]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u,m,c,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function n(y){return!!(y&&y.ref!==void 0&&typeof y.ref=="string"&&y.ref!==""&&y.syncData!==void 0&&(y.syncData===null||r(y.syncData)))}e.isRemoteUserData=n;function r(y){return!!(y&&y.version!==void 0&&typeof y.version=="number"&&y.content!==void 0&&typeof y.content=="string"&&(Object.keys(y).length===2||Object.keys(y).length===3&&y.machineId!==void 0&&typeof y.machineId=="string"))}e.isSyncData=r;function t(y,C){return`${(0,S.uppercaseFirstLetter)(y)}${C.isDefault?"":` (${C.name})`}`}e.getSyncResourceLogLabel=t;let a=class extends I.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(C,T,W,O,j,F,A,M,B,G,V,Q){super(),this.syncResource=C,this.collection=T,this.D=W,this.F=O,this.G=j,this.H=F,this.I=A,this.J=M,this.L=B,this.M=G,this.N=V,this.c=null,this.k="idle",this.l=this.B(new L.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new L.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new i.ThrottledDelayer(50),this.t=this.B(new L.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.C={},this.resource=this.syncResource.syncResource,this.y=t(C.syncResource,C.profile),this.h=Q.extUri,this.f=this.h.joinPath(O.userDataSyncHome,...(0,h.getPathSegments)(C.profile.isDefault?void 0:C.profile.id,C.syncResource)),this.g=this.h.joinPath(this.f,h.PREVIEW_DIR_NAME),this.u=(0,h.getLastSyncResourceUri)(C.profile.isDefault?void 0:C.profile.id,C.syncResource,O,this.h),this.j=(0,w.getServiceMachineId)(O,W,j)}triggerLocalChange(){this.s.trigger(()=>this.O())}async O(){if(this.status==="hasConflicts"){this.M.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const C=await this.c;this.c=null;const T=await this.U(C.remoteUserData,C.lastSyncUserData,!0,this.mb());this.P(T)}else{this.M.trace(`${this.y}: Checking for local changes...`);const C=await this.getLastSyncUserData();(C?await this.sb(C):!0)&&this.t.fire()}}P(C){this.k!==C&&(this.k=C,this.l.fire(C))}async sync(C,T={}){await this.Q(C,!0,this.mb(),T)}async preview(C,T,W={}){return this.Q(C,!1,T,W)}async apply(C,T={}){try{this.C={...T};const W=await this.Y(C);return this.P(W),this.c}finally{this.C={}}}async Q(C,T,W,O){try{if(this.C={...O},this.status==="hasConflicts")return this.M.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.M.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.M.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.P("syncing");let j="idle";try{const F=await this.getLastSyncUserData(),A=await this.S(C,F);return j=await this.U(A,F,T,W),j==="hasConflicts"?this.M.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):j==="idle"&&this.M.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.P(j)}}finally{this.C={}}}async replace(C){const T=this.ib(C);if(!T)return!1;await this.stop();try{this.M.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.P("syncing");const W=await this.getLastSyncUserData(),O=await this.S(null,W),j=await this.R(O),F=await this.ob({ref:O.ref,syncData:T},W,j,this.mb(),k.CancellationToken.None),A=[];for(const M of F){const B=await this.qb(M,M.remoteResource,void 0,k.CancellationToken.None),{remoteChange:G}=await this.qb(M,M.previewResource,M.remoteContent,k.CancellationToken.None);A.push([M,{...B,remoteChange:G!==0?G:2}])}await this.rb(O,W,A,!1),this.M.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.P("idle")}return!0}async R(C){const T=await this.j;return!!C.syncData?.machineId&&C.syncData.machineId===T}async S(C,T){if(T){const W=C?C[this.resource]:void 0;if(T.ref===W||W===void 0&&T.syncData===null)return T}return this.getRemoteUserData(T)}async U(C,T,W,O){if(C.syncData&&C.syncData.version>this.nb)throw this.L.publicLog2("sync/incompatible",{source:this.resource}),new h.UserDataSyncError((0,b.localize)(0,null,this.resource,this.nb,C.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.W(C,T,W,O)}catch(j){if(j instanceof h.UserDataSyncError)switch(j.code){case"LocalPreconditionFailed":return this.M.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.U(C,T,W,O);case"Conflict":case"PreconditionFailed":return this.M.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),C=await this.getRemoteUserData(null),T=await this.getLastSyncUserData(),this.U(C,T,W,O)}throw j}}async W(C,T,W,O){try{this.c||(this.c=(0,i.createCancelablePromise)(F=>this.db(C,T,W,O,F)));const j=await this.c;return this.bb(j.resourcePreviews),j.resourcePreviews.some(({mergeState:F})=>F==="conflict")?"hasConflicts":W?await this.Y(!1):"syncing"}catch(j){throw this.c=null,j}}async merge(C){return await this.X(C,async T=>{const W=await this.pb(T,k.CancellationToken.None);await this.D.writeFile(T.previewResource,D.VSBuffer.fromString(W?.content||""));const O=W&&!W.hasConflicts?await this.qb(T,T.previewResource,void 0,k.CancellationToken.None):void 0;return T.acceptResult=O,T.mergeState=W.hasConflicts?"conflict":O?"accepted":"preview",T.localChange=O?O.localChange:W.localChange,T.remoteChange=O?O.remoteChange:W.remoteChange,T}),this.c}async accept(C,T){return await this.X(C,async W=>{const O=await this.qb(W,C,T,k.CancellationToken.None);return W.acceptResult=O,W.mergeState="accepted",W.localChange=O.localChange,W.remoteChange=O.remoteChange,W}),this.c}async discard(C){return await this.X(C,async T=>{const W=await this.pb(T,k.CancellationToken.None);return await this.D.writeFile(T.previewResource,D.VSBuffer.fromString(W.content||"")),T.acceptResult=void 0,T.mergeState="preview",T.localChange=W.localChange,T.remoteChange=W.remoteChange,T}),this.c}async X(C,T){if(!this.c)return;let W=await this.c;const O=W.resourcePreviews.findIndex(({localResource:j,remoteResource:F,previewResource:A})=>this.h.isEqual(j,C)||this.h.isEqual(F,C)||this.h.isEqual(A,C));O!==-1&&(this.c=(0,i.createCancelablePromise)(async j=>{const F=[...W.resourcePreviews];return F[O]=await T(F[O]),{...W,resourcePreviews:F}}),W=await this.c,this.bb(W.resourcePreviews),W.resourcePreviews.some(({mergeState:j})=>j==="conflict")?this.P("hasConflicts"):this.P("syncing"))}async Y(C){if(!this.c)return"idle";const T=await this.c;return T.resourcePreviews.some(({mergeState:W})=>W==="conflict")?"hasConflicts":T.resourcePreviews.some(({mergeState:W})=>W!=="accepted")?"syncing":(await this.rb(T.remoteUserData,T.lastSyncUserData,T.resourcePreviews.map(W=>[W,W.acceptResult]),C),this.c=null,await this.ab(),"idle")}async ab(){try{await this.D.del(this.g,{recursive:!0})}catch{}}bb(C){const T=C.filter(({mergeState:W})=>W==="conflict");(0,R.equals)(this.m,T,(W,O)=>this.h.isEqual(W.previewResource,O.previewResource))||(this.m=T,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const C=await this.getLastSyncUserData();return!!C&&C.syncData!==null}async cb(C){const T=this.c?await this.c:null;if(T)for(const W of T.resourcePreviews){if(this.h.isEqual(W.acceptedResource,C))return W.acceptResult?W.acceptResult.content:null;if(this.h.isEqual(W.remoteResource,C))return W.remoteContent;if(this.h.isEqual(W.localResource,C))return W.localContent;if(this.h.isEqual(W.baseResource,C))return W.baseContent}return null}async resetLocal(){this.G.remove(this.v,-1);try{await this.D.del(this.u)}catch(C){this.M.error(C)}}async db(C,T,W,O,j){const F=await this.R(C),A=await this.ob(C,T,F,O,j),M=[];for(const B of A){const G=B.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(B.localChange===0&&B.remoteChange===0)M.push({...B,acceptedResource:G,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const V=W?await this.pb(B,j):void 0;if(j.isCancellationRequested)break;await this.D.writeFile(B.previewResource,D.VSBuffer.fromString(V?.content||""));const Q=V&&!V.hasConflicts?await this.qb(B,B.previewResource,void 0,j):void 0;M.push({...B,acceptResult:Q,mergeState:V?.hasConflicts?"conflict":Q?"accepted":"preview",localChange:Q?Q.localChange:V?V.localChange:B.localChange,remoteChange:Q?Q.remoteChange:V?V.remoteChange:B.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:C,lastSyncUserData:T,resourcePreviews:M,isLastSyncFromCurrentMachine:F}}async getLastSyncUserData(){let C=this.G.get(this.v,-1);if(C||(C=await this.hb()),!C)return this.M.info(`${this.y}: Last sync data state does not exist.`),null;const T=JSON.parse(C),W=this.J.getResourceSyncStateVersion(this.resource);if(this.w=!!T.version&&!!W&&T.version!==W,this.w)return this.M.info(`${this.y}: Reset last sync state because last sync state version ${T.version} is not compatible with current sync state version ${W}.`),await this.resetLocal(),null;let O,j=1;for(;O===void 0&&j++<6;)try{const F=await this.fb();F&&(F.ref===T.ref?O=F.syncData:this.M.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof d.FileOperationError&&F.fileOperationResult===1){this.M.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(F instanceof h.UserDataSyncError)throw F;this.M.error(F,j)}}if(O===void 0)try{const F=await this.H.resolveResourceContent(this.resource,T.ref,this.collection,this.C);O=F===null?null:this.ib(F),await this.gb({ref:T.ref,syncData:O})}catch(F){if(F instanceof h.UserDataSyncError&&F.code==="NotFound")this.M.info(`${this.y}: 	.`);else throw F}return O===void 0?null:{...T,syncData:O}}async eb(C,T={}){if(T.ref||T.version)throw new Error("Cannot have core properties as additional");const W=this.J.getResourceSyncStateVersion(this.resource),O={ref:C.ref,version:W,...T};this.G.store(this.v,JSON.stringify(O),-1,1),await this.gb(C)}async fb(){const C=(await this.D.readFile(this.u)).value.toString();try{const T=C?JSON.parse(C):void 0;if(n(T))return T}catch(T){this.M.error(T)}}async gb(C){await this.D.writeFile(this.u,D.VSBuffer.fromString(JSON.stringify(C)))}async hb(){try{const C=await this.D.readFile(this.u),T=JSON.parse(C.value.toString());await this.D.del(this.u),T.ref&&T.content!==void 0&&(this.G.store(this.v,JSON.stringify({...T,content:void 0}),-1,1),await this.gb({ref:T.ref,syncData:T.content===null?null:JSON.parse(T.content)}))}catch(C){C instanceof d.FileOperationError&&C.fileOperationResult===1?this.M.debug(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.M.error(C)}return this.G.get(this.v,-1)}async getRemoteUserData(C){const{ref:T,content:W}=await this.jb(C);let O=null;return W!==null&&(O=this.ib(W)),{ref:T,syncData:O}}ib(C){try{const T=JSON.parse(C);if(r(T))return T}catch(T){this.M.error(T)}throw new h.UserDataSyncError((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async jb(C){const T=C?{ref:C.ref,content:C.syncData?JSON.stringify(C.syncData):null}:null;return this.H.readResource(this.resource,T,this.collection,this.C)}async kb(C,T){const W=await this.j,O={version:this.nb,machineId:W,content:C};try{return T=await this.H.writeResource(this.resource,JSON.stringify(O),T,this.collection,this.C),{ref:T,syncData:O}}catch(j){throw j instanceof h.UserDataSyncError&&j.code==="TooLarge"&&(j=new h.UserDataSyncError(j.message,j.code,this.resource)),j}}async lb(C){const T={version:this.nb,content:C};return this.I.backup(this.syncResource.profile,this.resource,JSON.stringify(T))}async stop(){this.status!=="idle"&&(this.M.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.bb([]),await this.ab(),this.P("idle"),this.M.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}mb(){return this.N.getValue(h.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=pe([K(2,d.IFileService),K(3,p.IEnvironmentService),K(4,u.IStorageService),K(5,h.IUserDataSyncStoreService),K(6,h.IUserDataSyncBackupStoreService),K(7,h.IUserDataSyncEnablementService),K(8,m.ITelemetryService),K(9,h.IUserDataSyncLogService),K(10,v.IConfigurationService),K(11,c.IUriIdentityService)],a),e.AbstractSynchroniser=a;let s=class extends a{constructor(C,T,W,O,j,F,A,M,B,G,V,Q,$){super(T,W,O,j,F,A,M,B,G,V,Q,$),this.i=C,this.B(this.D.watch(this.h.dirname(C))),this.B(this.D.onDidFilesChange(z=>this.ub(z)))}async p(){try{return await this.D.readFile(this.i)}catch{return null}}async r(C,T,W){try{T?await this.D.writeFile(this.i,D.VSBuffer.fromString(C),W?void 0:T):await this.D.createFile(this.i,D.VSBuffer.fromString(C),{overwrite:W})}catch(O){throw O instanceof d.FileOperationError&&O.fileOperationResult===1||O instanceof d.FileOperationError&&O.fileOperationResult===3?new h.UserDataSyncError(O.message,"LocalPreconditionFailed"):O}}async tb(){try{await this.D.del(this.i)}catch(C){if(!(C instanceof d.FileOperationError&&C.fileOperationResult===1))throw C}}ub(C){!C.contains(this.i)||this.triggerLocalChange()}};s=pe([K(3,d.IFileService),K(4,p.IEnvironmentService),K(5,u.IStorageService),K(6,h.IUserDataSyncStoreService),K(7,h.IUserDataSyncBackupStoreService),K(8,h.IUserDataSyncEnablementService),K(9,m.ITelemetryService),K(10,h.IUserDataSyncLogService),K(11,v.IConfigurationService),K(12,c.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let l=class extends s{constructor(C,T,W,O,j,F,A,M,B,G,V,Q,$,z){super(C,T,W,O,j,F,A,M,B,G,V,$,z),this.vb=Q,this.xb=void 0}wb(C,T){const W=[],O=(0,P.parse)(C,W,{allowEmptyContent:!0,allowTrailingComma:!0});return W.length>0||!(0,E.isUndefined)(O)&&T!==Array.isArray(O)}yb(){return this.xb||(this.xb=this.vb.resolveFormattingOptions(this.i)),this.xb}};l=pe([K(3,d.IFileService),K(4,p.IEnvironmentService),K(5,u.IStorageService),K(6,h.IUserDataSyncStoreService),K(7,h.IUserDataSyncBackupStoreService),K(8,h.IUserDataSyncEnablementService),K(9,m.ITelemetryService),K(10,h.IUserDataSyncLogService),K(11,h.IUserDataSyncUtilService),K(12,v.IConfigurationService),K(13,c.IUriIdentityService)],l),e.AbstractJsonFileSynchroniser=l;let o=class{constructor(C,T,W,O,j,F,A){this.resource=C,this.g=T,this.h=W,this.j=O,this.k=j,this.l=F,this.d=A.extUri,this.f=(0,h.getLastSyncResourceUri)(void 0,this.resource,W,this.d)}async initialize({ref:C,content:T}){if(!T){this.j.info("Remote content does not exist.",this.resource);return}const W=this.m(T);if(!!W)try{await this.doInitialize({ref:C,syncData:W})}catch(O){this.j.error(O)}}m(C){try{const T=JSON.parse(C);if(r(T))return T}catch(T){this.j.error(T)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(C,T={}){if(T.ref||T.version)throw new Error("Cannot have core properties as additional");const W={ref:C.ref,version:void 0,...T};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(W),-1,1),await this.k.writeFile(this.f,D.VSBuffer.fromString(JSON.stringify(C)))}};o=pe([K(1,f.IUserDataProfilesService),K(2,p.IEnvironmentService),K(3,g.ILogService),K(4,d.IFileService),K(5,u.IStorageService),K(6,c.IUriIdentityService)],o),e.AbstractInitializer=o}),define(re[118],ae([0,1,6,22,9,3,42,2,27,16,13,117,29,33,79,14,4,72,7,18,24,31,21,41,253,115,26,62]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u,m,c,h,f,n,r,t,a,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function o(j,F){const A=JSON.parse(j.content);if(j.version===1||j.version===2){const M=(await F.getInstalled(0)).filter(B=>B.isBuiltin);for(const B of A)j.version===1&&(B.enabled===!1&&(B.disabled=!0),delete B.enabled),j.version===2&&M.every(G=>!(0,p.areSameExtensions)(G.identifier,B.identifier))&&(B.installed=!0)}return A}function y(j){return JSON.parse(j.content)}e.parseExtensions=y;function C(j,F){return j.sort((A,M)=>!A.identifier.uuid&&M.identifier.uuid?-1:A.identifier.uuid&&!M.identifier.uuid?1:(0,I.compare)(A.identifier.id,M.identifier.id)),F?(0,L.toFormattedString)(j,{}):JSON.stringify(j)}e.stringify=C;let T=class extends r.AbstractSynchroniser{constructor(F,A,M,B,G,V,Q,$,z,Y,ee,oe,X,Z,U,N,H){super({syncResource:"extensions",profile:F},A,B,M,G,V,Q,oe,X,Y,ee,U),this.Ab=$,this.Bb=z,this.Cb=H,this.nb=5,this.tb=this.h.joinPath(this.g,"extensions.json"),this.ub=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.vb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.wb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.xb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.yb=this.Cb.createInstance(W),this.B(k.Event.any(k.Event.filter(this.Ab.onDidInstallExtensions,q=>q.some(({local:J})=>!!J)),k.Event.filter(this.Ab.onDidUninstallExtension,q=>!q.error),k.Event.filter(N.onDidChange,q=>q.valueChanges.some(({profile:J,changes:ne})=>this.syncResource.profile.id===J.id&&ne.some(x=>x.key===v.DISABLED_EXTENSIONS_STORAGE_PATH))),Z.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async ob(F,A){const M=F.syncData?await o(F.syncData,this.Ab):null,B=A?.skippedExtensions||[],G=A?.builtinExtensions||[],V=A?.syncData?await o(A.syncData,this.Ab):null,{localExtensions:Q,ignoredExtensions:$}=await this.yb.getLocalExtensions(this.syncResource.profile);M?this.M.trace(`${this.y}: Merging remote extensions with local extensions...`):this.M.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:Y}=(0,t.merge)(Q,M,V,B,$,G),ee={local:z,remote:Y,content:this.Fb(Q,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:Y!==null?2:0},oe=this.Lb(Q,!1);return[{skippedExtensions:B,builtinExtensions:G,baseResource:this.ub,baseContent:V?this.Lb(V,!1):oe,localResource:this.vb,localContent:oe,localExtensions:Q,remoteResource:this.wb,remoteExtensions:M,remoteContent:M?this.Lb(M,!1):null,previewResource:this.tb,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.xb}]}async sb(F){const A=F.syncData?await o(F.syncData,this.Ab):null,{localExtensions:M,ignoredExtensions:B}=await this.yb.getLocalExtensions(this.syncResource.profile),{remote:G}=(0,t.merge)(M,A,A,F.skippedExtensions||[],B,F.builtinExtensions||[]);return G!==null}Fb(F,A,M,B){const G=[...A,...M],V=new Set,Q=$=>{V.add($.id.toLowerCase()),$.uuid&&V.add($.uuid)};G.forEach(({identifier:$})=>Q($)),B.forEach(Q);for(const $ of F)V.has($.identifier.id.toLowerCase())||$.identifier.uuid&&V.has($.identifier.uuid)||G.push($);return this.Lb(G,!1)}async pb(F,A){return{...F.previewResult,hasConflicts:!1}}async qb(F,A,M,B){if(this.h.isEqual(A,this.vb))return this.Ib(F);if(this.h.isEqual(A,this.wb))return this.Jb(F);if(this.h.isEqual(A,this.tb))return F.previewResult;throw new Error(`Invalid Resource: ${A.toString()}`)}async Ib(F){const A=await this.Ab.getInstalled(void 0,this.syncResource.profile.extensionsResource),M=this.Bb.getIgnoredExtensions(A),B=(0,t.merge)(F.localExtensions,null,null,F.skippedExtensions,M,F.builtinExtensions),{local:G,remote:V}=B;return{content:F.localContent,local:G,remote:V,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:V!==null?2:0}}async Jb(F){const A=await this.Ab.getInstalled(void 0,this.syncResource.profile.extensionsResource),M=this.Bb.getIgnoredExtensions(A),B=F.remoteContent?JSON.parse(F.remoteContent):null;if(B!==null){const G=(0,t.merge)(F.localExtensions,B,F.localExtensions,[],M,F.builtinExtensions),{local:V,remote:Q}=G;return{content:F.remoteContent,local:V,remote:Q,localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:Q!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(F,A,M,B){let{skippedExtensions:G,localExtensions:V}=M[0][0];const{local:Q,remote:$,localChange:z,remoteChange:Y}=M[0][1];if(z===0&&Y===0&&this.M.info(`${this.y}: No changes found during synchronizing extensions.`),z!==0&&(await this.lb(JSON.stringify(V)),G=await this.yb.updateLocalExtensions(Q.added,Q.removed,Q.updated,G,this.syncResource.profile)),$){this.M.trace(`${this.y}: Updating remote extensions...`);const ee=JSON.stringify($.all);F=await this.kb(ee,B?null:F.ref),this.M.info(`${this.y}: Updated remote extensions.${$.added.length?` Added: ${JSON.stringify($.added.map(oe=>oe.identifier.id))}.`:""}${$.updated.length?` Updated: ${JSON.stringify($.updated.map(oe=>oe.identifier.id))}.`:""}${$.removed.length?` Removed: ${JSON.stringify($.removed.map(oe=>oe.identifier.id))}.`:""}`)}if(A?.ref!==F.ref){this.M.trace(`${this.y}: Updating last synchronized extensions...`);const ee=V.filter(oe=>!oe.installed).map(oe=>oe.identifier);await this.eb(F,{skippedExtensions:G,builtinExtensions:ee}),this.M.info(`${this.y}: Updated last synchronized extensions.${G.length?` Skipped: ${JSON.stringify(G.map(oe=>oe.identifier.id))}.`:""}`)}}async resolveContent(F){if(this.h.isEqual(this.wb,F)||this.h.isEqual(this.ub,F)||this.h.isEqual(this.vb,F)||this.h.isEqual(this.xb,F)){const A=await this.cb(F);return A&&this.Lb(JSON.parse(A),!0)}return null}Lb(F,A){return C(F,A)}async hasLocalData(){try{const{localExtensions:F}=await this.yb.getLocalExtensions(this.syncResource.profile);if(F.some(A=>A.installed||A.disabled))return!0}catch{}return!1}};T=pe([K(2,E.IEnvironmentService),K(3,g.IFileService),K(4,c.IStorageService),K(5,s.IUserDataSyncStoreService),K(6,s.IUserDataSyncBackupStoreService),K(7,v.IExtensionManagementService),K(8,a.IIgnoredExtensionsManagementService),K(9,s.IUserDataSyncLogService),K(10,S.IConfigurationService),K(11,s.IUserDataSyncEnablementService),K(12,h.ITelemetryService),K(13,d.IExtensionStorageService),K(14,f.IUriIdentityService),K(15,l.IUserDataProfileStorageService),K(16,w.IInstantiationService)],T),e.ExtensionsSynchroniser=T;let W=class{constructor(F,A,M,B,G,V){this.a=F,this.b=A,this.c=M,this.d=B,this.f=G,this.g=V}async getLocalExtensions(F){const A=await this.a.getInstalled(void 0,F.extensionsResource),M=this.d.getIgnoredExtensions(A);return{localExtensions:await this.j(F,async(G,V)=>{const Q=G.getDisabledExtensions();return A.map($=>{const{identifier:z,isBuiltin:Y,manifest:ee,preRelease:oe}=$,X={identifier:z,preRelease:oe,version:ee.version};Q.some(Z=>(0,p.areSameExtensions)(Z,z))&&(X.disabled=!0),Y||(X.installed=!0);try{const Z=V.getKeysForSync({id:z.id,version:ee.version});if(Z){const U=V.getExtensionState($,!0)||{};X.state=Object.keys(U).reduce((N,H)=>(Z.includes(H)&&(N[H]=U[H]),N),{})}}catch(Z){this.g.info(`${(0,r.getSyncResourceLogLabel)("extensions",F)}: Error while parsing extension state`,(0,D.getErrorMessage)(Z))}return X})}),ignoredExtensions:M}}async updateLocalExtensions(F,A,M,B,G){const V=(0,r.getSyncResourceLogLabel)("extensions",G);return this.j(G,async(Q,$)=>{const z=[],Y=[],ee=await this.a.getInstalled(void 0,G.extensionsResource);if(A.length){const X=ee.filter(({identifier:Z,isBuiltin:U})=>!U&&A.some(N=>(0,p.areSameExtensions)(Z,N)));await R.Promises.settled(X.map(async Z=>{this.g.trace(`${V}: Uninstalling local extension...`,Z.identifier.id),await this.a.uninstall(Z,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:G.extensionsResource}),this.g.info(`${V}: Uninstalled local extension.`,Z.identifier.id),z.push(Z.identifier)}))}(F.length||M.length)&&await R.Promises.settled([...F,...M].map(async X=>{const Z=ee.find(N=>(0,p.areSameExtensions)(N.identifier,X.identifier));if(Z&&Z.isBuiltin){X.state&&Z.manifest.version===X.version&&this.h(X.state,Z,Z.manifest.version,$),Q.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,X.identifier))!==!!X.disabled&&(X.disabled?(this.g.trace(`${V}: Disabling extension...`,X.identifier.id),await Q.disableExtension(X.identifier),this.g.info(`${V}: Disabled extension`,X.identifier.id)):(this.g.trace(`${V}: Enabling extension...`,X.identifier.id),await Q.enableExtension(X.identifier),this.g.info(`${V}: Enabled extension`,X.identifier.id))),z.push(X.identifier);return}const U=(await this.c.getExtensions([{...X.identifier,preRelease:X.preRelease}],i.CancellationToken.None))[0];if(X.state&&(Z?Z.manifest.version===X.version:!!U)&&this.h(X.state,Z||U,Z?.manifest.version,$),U)try{Q.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,X.identifier))!==!!X.disabled&&(X.disabled?(this.g.trace(`${V}: Disabling extension...`,X.identifier.id,U.version),await Q.disableExtension(U.identifier),this.g.info(`${V}: Disabled extension`,X.identifier.id,U.version)):(this.g.trace(`${V}: Enabling extension...`,X.identifier.id,U.version),await Q.enableExtension(U.identifier),this.g.info(`${V}: Enabled extension`,X.identifier.id,U.version))),(!Z||Z.preRelease!==X.preRelease)&&(await this.a.canInstall(U)?(this.g.trace(`${V}: Installing extension...`,X.identifier.id,U.version),await this.a.installFromGallery(U,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:X.preRelease,profileLocation:G.extensionsResource}),this.g.info(`${V}: Installed extension.`,X.identifier.id,U.version),z.push(U.identifier)):(this.g.info(`${V}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),Y.push(X)))}catch(N){Y.push(X),N instanceof v.ExtensionManagementError&&[v.ExtensionManagementErrorCode.Incompatible,v.ExtensionManagementErrorCode.IncompatiblePreRelease,v.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(N.code)?this.g.info(`${V}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):(this.g.error(N),this.g.info(`${V}: Skipped synchronizing extension`,U.displayName||U.identifier.id))}else Y.push(X),this.g.info(`${V}: Skipped synchronizing extension because the extension is not found.`,X.identifier.id)}));const oe=[];for(const X of B)z.some(Z=>(0,p.areSameExtensions)(Z,X.identifier))||oe.push(X);for(const X of Y)oe.some(Z=>(0,p.areSameExtensions)(Z.identifier,X.identifier))||oe.push(X);return oe})}h(F,A,M,B){const G=B.getExtensionState(A,!0)||{},V=M?B.getKeysForSync({id:A.identifier.id,version:M}):void 0;V?V.forEach(Q=>{G[Q]=F[Q]}):Object.keys(F).forEach(Q=>G[Q]=F[Q]),B.setExtensionState(A,G,!0)}async j(F,A){return this.b.withProfileScopedStorageService(F,async M=>{const B=new P.DisposableStore,G=this.f.createChild(new u.ServiceCollection([c.IStorageService,M])),V=B.add(G.createInstance(b.GlobalExtensionEnablementService)),Q=B.add(G.createInstance(d.ExtensionStorageService));try{return await A(V,Q)}finally{B.dispose()}})}};W=pe([K(0,v.IExtensionManagementService),K(1,l.IUserDataProfileStorageService),K(2,v.IExtensionGalleryService),K(3,a.IIgnoredExtensionsManagementService),K(4,w.IInstantiationService),K(5,s.IUserDataSyncLogService)],W),e.LocalExtensionsProvider=W;let O=class extends r.AbstractInitializer{constructor(F,A,M,B,G,V,Q,$){super("extensions",B,G,V,M,Q,$),this.o=F,this.p=A}async q(F){return F.syncData?await o(F.syncData,this.o):null}t(F,A){const M=[],B=[],G=[];for(const V of F){if(this.p.hasToNeverSyncExtension(V.identifier.id))continue;const Q=A.find($=>(0,p.areSameExtensions)($.identifier,V.identifier));Q?(M.push(Q),V.disabled&&G.push(V.identifier)):V.installed&&(B.push({...V.identifier,preRelease:!!V.preRelease}),V.disabled&&G.push(V.identifier))}return{installedExtensions:M,newExtensions:B,disabledExtensions:G,remoteExtensions:F}}};O=pe([K(0,v.IExtensionManagementService),K(1,a.IIgnoredExtensionsManagementService),K(2,g.IFileService),K(3,n.IUserDataProfilesService),K(4,E.IEnvironmentService),K(5,m.ILogService),K(6,c.IStorageService),K(7,f.IUriIdentityService)],O),e.AbstractExtensionsInitializer=O}),define(re[119],ae([0,1,17,9,3,35,42,5,30,16,13,14,7,44,18,24,31,41,61,257,26,21,62,4]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u,m,c,h,f,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",a=["locale"];function s(W,O){const j=W.storage?Object.keys(W.storage).sort():[],F={};return j.forEach(A=>F[A]=W.storage[A]),W.storage=F,O?(0,L.toFormattedString)(W,{}):JSON.stringify(W)}e.stringify=s;const l=1;let o=class extends u.AbstractSynchroniser{constructor(O,j,F,A,M,B,G,V,Q,$,z,Y,ee,oe){super({syncResource:"globalState",profile:O},j,A,V,Y,M,B,Q,$,G,z,ee),this.xb=F,this.nb=l,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.tb=this.p.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.ub=this.p.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.vb=this.p.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.wb=oe.createInstance(y),this.B(A.watch(this.h.dirname(this.F.argvResource))),this.B(D.Event.any(D.Event.filter(A.onDidFilesChange,X=>X.contains(this.F.argvResource)),D.Event.filter(F.onDidChange,X=>!!(X.targetChanges.some(Z=>this.syncResource.profile.id===Z.id)||X.valueChanges.some(({profile:Z,changes:U})=>this.syncResource.profile.id===Z.id&&U.some(N=>N.target===0)))))(()=>this.triggerLocalChange()))}async ob(O,j,F){const A=O.syncData?JSON.parse(O.syncData.content):null;j=j===null&&F?O:j;const M=j&&j.syncData?JSON.parse(j.syncData.content):null,B=await this.wb.getLocalGlobalState(this.syncResource.profile);A?this.M.trace(`${this.y}: Merging remote ui state with local ui state...`):this.M.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const G=await this.Gb(M),{local:V,remote:Q}=(0,c.merge)(B.storage,A?A.storage:null,M?M.storage:null,G,this.M),$={content:null,local:V,remote:Q,localChange:Object.keys(V.added).length>0||Object.keys(V.updated).length>0||V.removed.length>0?2:0,remoteChange:Q.all!==null?2:0},z=s(B,!1);return[{baseResource:this.r,baseContent:M?s(M,!1):z,localResource:this.tb,localContent:z,localUserData:B,remoteResource:this.ub,remoteContent:A?s(A,!1):null,previewResource:this.p,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.vb,storageKeys:G}]}async sb(O){const j=O.syncData?JSON.parse(O.syncData.content):null;if(j===null)return!0;const F=await this.wb.getLocalGlobalState(this.syncResource.profile),A=await this.Gb(j),{remote:M}=(0,c.merge)(F.storage,j.storage,j.storage,A,this.M);return M.all!==null}async pb(O,j){return{...O.previewResult,hasConflicts:!1}}async qb(O,j,F,A){if(this.h.isEqual(j,this.tb))return this.Db(O);if(this.h.isEqual(j,this.ub))return this.Eb(O);if(this.h.isEqual(j,this.p))return O.previewResult;throw new Error(`Invalid Resource: ${j.toString()}`)}async Db(O){return{content:O.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(O.localUserData.storage),removed:[],updated:[],all:O.localUserData.storage},localChange:0,remoteChange:2}}async Eb(O){if(O.remoteContent!==null){const j=JSON.parse(O.remoteContent),{local:F,remote:A}=(0,c.merge)(O.localUserData.storage,j.storage,null,O.storageKeys,this.M);return{content:O.remoteContent,local:F,remote:A,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:A!==null?2:0}}else return{content:O.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async rb(O,j,F,A){const{localUserData:M}=F[0][0],{local:B,remote:G,localChange:V,remoteChange:Q}=F[0][1];if(V===0&&Q===0&&this.M.info(`${this.y}: No changes found during synchronizing ui state.`),V!==0&&(this.M.trace(`${this.y}: Updating local ui state...`),await this.lb(JSON.stringify(M)),await this.wb.writeLocalGlobalState(B,this.syncResource.profile),this.M.info(`${this.y}: Updated local ui state`)),Q!==0){this.M.trace(`${this.y}: Updating remote ui state...`);const $=JSON.stringify({storage:G.all});O=await this.kb($,A?null:O.ref),this.M.info(`${this.y}: Updated remote ui state.${G.added.length?` Added: ${G.added}.`:""}${G.updated.length?` Updated: ${G.updated}.`:""}${G.removed.length?` Removed: ${G.removed}.`:""}`)}j?.ref!==O.ref&&(this.M.trace(`${this.y}: Updating last synchronized ui state...`),await this.eb(O),this.M.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(O){if(this.h.isEqual(this.ub,O)||this.h.isEqual(this.r,O)||this.h.isEqual(this.tb,O)||this.h.isEqual(this.vb,O)){const j=await this.cb(O);return j&&s(JSON.parse(j),!0)}return null}async hasLocalData(){try{const{storage:O}=await this.wb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(O).length>1||O[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Gb(O){const j=await this.xb.readStorageData(this.syncResource.profile),F=[],A=[];for(const[G,V]of j)V.target===0?F.push(G):V.target===1&&A.push(G);const M=[...F,...A],B=O?.storage?Object.keys(O.storage).filter(G=>!G.startsWith(t)&&!M.includes(G)&&j.get(G)!==void 0):[];if(!P.isWeb){const G=[...h.ALL_SYNC_RESOURCES.map(V=>(0,h.getEnablementKey)(V)),h.SYNC_SERVICE_URL_TYPE];B.push(...G),A.push(...G)}return{user:F,machine:A,unregistered:B}}};o=pe([K(2,n.IUserDataProfileStorageService),K(3,b.IFileService),K(4,h.IUserDataSyncStoreService),K(5,h.IUserDataSyncBackupStoreService),K(6,h.IUserDataSyncLogService),K(7,E.IEnvironmentService),K(8,h.IUserDataSyncEnablementService),K(9,g.ITelemetryService),K(10,S.IConfigurationService),K(11,d.IStorageService),K(12,w.IUriIdentityService),K(13,r.IInstantiationService)],o),e.GlobalStateSynchroniser=o;let y=class{constructor(O,j,F,A){this.a=O,this.b=j,this.c=F,this.d=A}async getLocalGlobalState(O){const j={};if(O.isDefault){const A=await this.f(),M=(0,k.parse)(A);for(const B of a)M[B]!==void 0&&(j[`${t}${B}`]={version:1,value:M[B]})}const F=await this.c.readStorageData(O);for(const[A,M]of F)M.value&&M.target===0&&(j[A]={version:1,value:M.value});return{storage:j}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const O=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),O.value.toString()}catch(O){this.d.debug((0,i.getErrorMessage)(O))}return"{}"}async writeLocalGlobalState({added:O,removed:j,updated:F},A){const M=(0,u.getSyncResourceLogLabel)("globalState",A),B={},G=new Map,V=await this.c.readStorageData(A),Q=($,z)=>{for(const Y of $){if(Y.startsWith(t)){B[Y.substring(t.length)]=z?z[Y].value:void 0;continue}if(z){const ee=z[Y];ee.value!==V.get(Y)?.value&&G.set(Y,ee.value)}else V.get(Y)!==void 0&&G.set(Y,void 0)}};if(Q(Object.keys(O),O),Q(Object.keys(F),F),Q(j),Object.keys(B).length){this.d.trace(`${M}: Updating locale...`);const $=await this.f();let z=$;for(const Y of Object.keys(B))z=(0,m.edit)(z,[Y],B[Y],{});$!==z&&(this.d.trace(`${M}: Updating locale...`),await this.a.writeFile(this.b.argvResource,R.VSBuffer.fromString(z)),this.d.info(`${M}: Updated locale.`)),this.d.info(`${M}: Updated locale`)}G.size&&(this.d.trace(`${M}: Updating global state...`),await this.c.updateStorageData(A,G,0),this.d.info(`${M}: Updated global state`,[...G.keys()]))}};y=pe([K(0,b.IFileService),K(1,E.IEnvironmentService),K(2,n.IUserDataProfileStorageService),K(3,h.IUserDataSyncLogService)],y),e.LocalGlobalStateProvider=y;let C=class extends u.AbstractInitializer{constructor(O,j,F,A,M,B){super("globalState",F,A,M,j,O,B)}async doInitialize(O){const j=O.syncData?JSON.parse(O.syncData.content):null;if(!j){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},A={};for(const M of Object.keys(j.storage))M.startsWith(t)?F[M.substring(t.length)]=j.storage[M].value:this.l.get(M,0)===void 0&&(A[M]=j.storage[M].value);if(Object.keys(F).length){let M="{}";try{M=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const B of Object.keys(F))M=(0,m.edit)(M,[B],F[B],{});await this.k.writeFile(this.h.argvResource,R.VSBuffer.fromString(M))}if(Object.keys(A).length)for(const M of Object.keys(A))this.l.store(M,A[M],0,0)}};C=pe([K(0,d.IStorageService),K(1,b.IFileService),K(2,f.IUserDataProfilesService),K(3,E.IEnvironmentService),K(4,h.IUserDataSyncLogService),K(5,w.IUriIdentityService)],C),e.GlobalStateInitializer=C;let T=class{constructor(O,j,F,A,M){this.a=O,this.b=j,this.c=F,this.d=A,this.f=M}getSyncStoreType(O){return this.h(O)?.storage[h.SYNC_SERVICE_URL_TYPE]?.value}async sync(O){const j=(0,h.createSyncHeaders)((0,I.generateUuid)());try{return await this.g(O,j)}catch(F){if(F instanceof h.UserDataSyncError)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(O,j)}throw F}}async g(O,j){const F=await this.a.readResource("globalState",null,void 0,j),A=this.h(F)||{storage:{}};A.storage[h.SYNC_SERVICE_URL_TYPE]={value:O,version:l};const M=await(0,p.getServiceMachineId)(this.c,this.d,this.b),B={version:l,machineId:M,content:s(A,!1)};await this.a.writeResource("globalState",JSON.stringify(B),F.ref,void 0,j)}h({content:O}){if(!O)return null;const j=JSON.parse(O);if((0,u.isSyncData)(j))return j?JSON.parse(j.content):null;throw new Error("Invalid remote data")}};T=pe([K(1,d.IStorageService),K(2,E.IEnvironmentService),K(3,b.IFileService),K(4,v.ILogService)],T),e.UserDataSyncStoreTypeSynchronizer=T}),define(re[120],ae([0,1,19,17,3,35,5,15,176,16,13,14,18,24,31,21,41,254,26]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function c(n,r,t){try{const a=JSON.parse(n);if(!r)return(0,P.isUndefined)(a.all)?null:a.all;switch(L.OS){case 2:return(0,P.isUndefined)(a.mac)?null:a.mac;case 3:return(0,P.isUndefined)(a.linux)?null:a.linux;case 1:return(0,P.isUndefined)(a.windows)?null:a.windows}}catch(a){return t.error(a),null}}e.getKeybindingsContentFromSyncContent=c;let h=class extends w.AbstractJsonFileSynchroniser{constructor(r,t,a,s,l,o,y,C,T,W,O,j,F){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},t,C,T,W,a,s,y,j,l,O,o,F),this.nb=2,this.Bb=this.h.joinPath(this.g,"keybindings.json"),this.Cb=this.Bb.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Db=this.Bb.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Eb=this.Bb.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Fb=this.Bb.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(D.Event.filter(o.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async ob(r,t,a,s){const l=r.syncData?c(r.syncData.content,s.keybindingsPerPlatform??this.Nb(),this.M):null;t=t===null&&a?r:t;const o=t?this.Lb(t):null,y=await this.p(),C=await this.yb();let T=null,W=!1,O=!1,j=!1;if(l){let M=y?y.value.toString():"[]";if(M=M||"[]",this.wb(M,!0))throw new m.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==M||o!==l){this.M.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const B=await(0,u.merge)(M,l,o,C,this.vb);B.hasChanges&&(T=B.mergeContent,j=B.hasConflicts,W=j||B.mergeContent!==M,O=j||B.mergeContent!==l)}}else y&&(this.M.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),T=y.value.toString(),O=!0);const F={content:j?o:T,localChange:W?y?2:1:0,remoteChange:O?2:0,hasConflicts:j},A=y?y.value.toString():null;return[{fileContent:y,baseResource:this.Cb,baseContent:o,localResource:this.Db,localContent:A,localChange:F.localChange,remoteResource:this.Eb,remoteContent:l,remoteChange:F.remoteChange,previewResource:this.Bb,previewResult:F,acceptedResource:this.Fb}]}async sb(r){const t=this.Lb(r);if(t===null)return!0;const a=await this.p(),s=a?a.value.toString():"",l=await this.yb(),o=await(0,u.merge)(s||"[]",t,t,l,this.vb);return o.hasConflicts||o.mergeContent!==t}async pb(r,t){return r.previewResult}async qb(r,t,a,s){if(this.h.isEqual(t,this.Db))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Eb))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.Bb))return a===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:a,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async rb(r,t,a,s){const{fileContent:l}=a[0][0];let{content:o,localChange:y,remoteChange:C}=a[0][1];if(y===0&&C===0&&this.M.info(`${this.y}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.wb(o,!0)))throw new m.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(y!==0&&(this.M.trace(`${this.y}: Updating local keybindings...`),l&&await this.lb(this.Mb(l.value.toString())),await this.r(o||"[]",l,s),this.M.info(`${this.y}: Updated local keybindings`)),C!==0){this.M.trace(`${this.y}: Updating remote keybindings...`);const T=this.Mb(o||"[]",r.syncData?.content);r=await this.kb(T,s?null:r.ref),this.M.info(`${this.y}: Updated remote keybindings`)}try{await this.D.del(this.Bb)}catch{}t?.ref!==r.ref&&(this.M.trace(`${this.y}: Updating last synchronized keybindings...`),await this.eb(r,{platformSpecific:this.Nb()}),this.M.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=(0,k.parse)(r.value.toString());if((0,R.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Eb,r)||this.h.isEqual(this.Cb,r)||this.h.isEqual(this.Db,r)||this.h.isEqual(this.Fb,r)?this.cb(r):null}Lb(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Nb()?null:c(r.syncData.content,this.Nb(),this.M)}Mb(r,t){let a={};try{a=JSON.parse(t||"{}")}catch(s){this.M.error(s)}switch(this.Nb()?delete a.all:a.all=r,L.OS){case 2:a.mac=r;break;case 3:a.linux=r;break;case 1:a.windows=r;break}return JSON.stringify(a)}Nb(){return!!this.N.getValue(m.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};h=pe([K(2,m.IUserDataSyncStoreService),K(3,m.IUserDataSyncBackupStoreService),K(4,m.IUserDataSyncLogService),K(5,S.IConfigurationService),K(6,m.IUserDataSyncEnablementService),K(7,b.IFileService),K(8,E.IEnvironmentService),K(9,v.IStorageService),K(10,m.IUserDataSyncUtilService),K(11,p.ITelemetryService),K(12,d.IUriIdentityService)],h),e.KeybindingsSynchroniser=h;let f=class extends w.AbstractInitializer{constructor(r,t,a,s,l,o){super("keybindings",t,a,s,r,l,o)}async doInitialize(r){const t=r.syncData?this.i(r.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,i.VSBuffer.fromString(t)),await this.n(r)}async c(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,k.parse)(r.value.toString());return!(0,R.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}i(r){try{return c(r,!0,this.j)}catch(t){return this.j.error(t),null}}};f=pe([K(0,b.IFileService),K(1,g.IUserDataProfilesService),K(2,E.IEnvironmentService),K(3,m.IUserDataSyncLogService),K(4,v.IStorageService),K(5,d.IUriIdentityService)],f),e.KeybindingsInitializer=f}),define(re[121],ae([0,1,17,3,177,16,74,13,29,14,18,24,31,21,41,61,258,26]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function m(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function c(n){const r=JSON.parse(n);return m(r)?r:{settings:n}}e.parseSettingsSyncContent=c;let h=class extends d.AbstractJsonFileSynchroniser{constructor(r,t,a,s,l,o,y,C,T,W,O,j,F,A){super(r.settingsResource,{syncResource:"settings",profile:r},t,a,s,l,o,y,O,j,C,T,W,A),this.Bb=F,this.nb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Lb=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),a=await this.S(r,t),s=this.Ib(a),l=new L.ConfigurationModelParser(u.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&l.parse(s.settings),l.configurationModel.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async ob(r,t,a){const s=await this.p(),l=await this.yb(),o=this.Ib(r);t=t===null&&a?r:t;const y=t?this.Ib(t):null,C=await this.Mb();let T=null,W=!1,O=!1,j=!1;if(o){let B=s?s.value.toString().trim():"{}";B=B||"{}",this.Nb(B),this.M.trace(`${this.y}: Merging remote settings with local settings...`);const G=(0,w.merge)(B,o.settings,y?y.settings:null,C,[],l);T=G.localContent||G.remoteContent,W=G.localContent!==null,O=G.remoteContent!==null,j=G.hasConflicts}else s&&(this.M.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),T=s.value.toString().trim()||"{}",this.Nb(T),O=!0);const F=s?s.value.toString():null,A=y?.settings??null,M={content:j?A:T,localChange:W?2:0,remoteChange:O?2:0,hasConflicts:j};return[{fileContent:s,baseResource:this.baseResource,baseContent:A,localResource:this.localResource,localContent:F,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async sb(r){const t=this.Ib(r);if(t===null)return!0;const a=await this.p(),s=a?a.value.toString().trim():"",l=await this.Mb(),o=await this.yb();return(0,w.merge)(s||"{}",t.settings,t.settings,l,[],o).remoteContent!==null}async pb(r,t){const a=await this.yb(),s=await this.Mb();return{...r.previewResult,content:r.previewResult.content?(0,w.updateIgnoredSettings)(r.previewResult.content,"{}",s,a):null}}async qb(r,t,a,s){const l=await this.yb(),o=await this.Mb();if(this.h.isEqual(t,this.localResource))return{content:r.fileContent?(0,w.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",o,l):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,w.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,l):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return a===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:a!==null?(0,w.updateIgnoredSettings)(a,r.fileContent?r.fileContent.value.toString():"{}",o,l):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async rb(r,t,a,s){const{fileContent:l}=a[0][0];let{content:o,localChange:y,remoteChange:C}=a[0][1];if(y===0&&C===0&&this.M.info(`${this.y}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Nb(o),y!==0&&(this.M.trace(`${this.y}: Updating local settings...`),l&&await this.lb(JSON.stringify(this.Kb(l.value.toString()))),await this.r(o,l,s),await this.N.reloadConfiguration(3),this.M.info(`${this.y}: Updated local settings`)),C!==0){const T=await this.yb(),W=this.Ib(r),O=await this.Mb(o);o=(0,w.updateIgnoredSettings)(o,W?W.settings:"{}",O,T),this.M.trace(`${this.y}: Updating remote settings...`),r=await this.kb(JSON.stringify(this.Kb(o)),s?null:r.ref),this.M.info(`${this.y}: Updated remote settings`)}try{await this.D.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.M.trace(`${this.y}: Updating last synchronized settings...`),await this.eb(r),this.M.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=await this.yb(),a=(0,g.edit)(r.value.toString(),[u.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,w.isEmpty)(a)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.remoteResource,r)||this.h.isEqual(this.localResource,r)||this.h.isEqual(this.acceptedResource,r)||this.h.isEqual(this.baseResource,r)?this.cb(r):null}async cb(r){let t=await super.cb(r);if(t){const a=await this.yb(),s=await this.Mb();t=(0,w.updateIgnoredSettings)(t,"{}",s,a)}return t}Ib(r){return r.syncData?this.Jb(r.syncData.content):null}Jb(r){try{return c(r)}catch(t){this.M.error(t)}return null}Kb(r){return{settings:r}}async Mb(r){if(!this.Lb){this.Lb=this.vb.resolveDefaultIgnoredSettings();const a=i.Event.any(i.Event.filter(this.Bb.onDidInstallExtensions,s=>s.some(({local:l})=>!!l)),i.Event.filter(this.Bb.onDidUninstallExtension,s=>!s.error))(()=>{a.dispose(),this.Lb=void 0})}const t=await this.Lb;return(0,w.getIgnoredSettings)(t,this.N,r)}Nb(r){if(this.wb(r,!1))throw new u.UserDataSyncError((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};h=pe([K(2,S.IFileService),K(3,P.IEnvironmentService),K(4,E.IStorageService),K(5,u.IUserDataSyncStoreService),K(6,u.IUserDataSyncBackupStoreService),K(7,u.IUserDataSyncLogService),K(8,u.IUserDataSyncUtilService),K(9,k.IConfigurationService),K(10,u.IUserDataSyncEnablementService),K(11,b.ITelemetryService),K(12,I.IExtensionManagementService),K(13,v.IUriIdentityService)],h),e.SettingsSynchroniser=h;let f=class extends d.AbstractInitializer{constructor(r,t,a,s,l,o){super("settings",t,a,s,r,l,o)}async doInitialize(r){const t=r.syncData?this.i(r.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,R.VSBuffer.fromString(t.settings)),await this.n(r)}async c(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,w.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}i(r){try{return c(r)}catch(t){this.j.error(t)}return null}};f=pe([K(0,S.IFileService),K(1,p.IUserDataProfilesService),K(2,P.IEnvironmentService),K(3,u.IUserDataSyncLogService),K(4,E.IStorageService),K(5,v.IUriIdentityService)],f),e.SettingsInitializer=f}),define(re[122],ae([0,1,17,3,32,16,13,14,18,24,31,21,41,255,26]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function g(m){return JSON.parse(m.content)}e.parseSnippets=g;let w=class extends v.AbstractSynchroniser{constructor(c,h,f,n,r,t,a,s,l,o,y,C){super({syncResource:"snippets",profile:c},h,n,f,r,t,a,o,y,s,l,C),this.nb=1,this.p=c.snippetsHome,this.B(this.D.watch(f.userRoamingDataHome)),this.B(this.D.watch(this.p)),this.B(i.Event.filter(this.D.onDidFilesChange,T=>T.affects(this.p))(()=>this.triggerLocalChange()))}async ob(c,h,f){const n=await this.Eb(),r=this.Db(n),t=c.syncData?this.Cb(c.syncData):null;h=h===null&&f?c:h;const a=h&&h.syncData?this.Cb(h.syncData):null;t?this.M.trace(`${this.y}: Merging remote snippets with local snippets...`):this.M.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,p.merge)(r,t,a);return this.xb(s,n,t||{},a||{})}async sb(c){const h=c.syncData?this.Cb(c.syncData):null;if(h===null)return!0;const f=await this.Eb(),n=this.Db(f),r=(0,p.merge)(n,h,h);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async pb(c,h){return c.previewResult}async qb(c,h,f,n){if(this.h.isEqualOrParent(h,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:c.fileContent?c.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(h,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:c.remoteContent,localChange:c.remoteContent!==null?c.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(h,this.g))return f===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:f,localChange:f===null?c.fileContent!==null?3:0:2,remoteChange:f===null?c.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${h.toString()}`)}async rb(c,h,f,n){const r=f.map(([t,a])=>({...t,acceptResult:a}));r.every(({localChange:t,remoteChange:a})=>t===0&&a===0)&&this.M.info(`${this.y}: No changes found during synchronizing snippets.`),r.some(({localChange:t})=>t!==0)&&(await this.yb(r),await this.Ab(r,n)),r.some(({remoteChange:t})=>t!==0)&&(c=await this.Bb(r,c,n)),h?.ref!==c.ref&&(this.M.trace(`${this.y}: Updating last synchronized snippets...`),await this.eb(c),this.M.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:t}of r)try{await this.D.del(t)}catch{}}xb(c,h,f,n){const r=new Map;for(const t of Object.keys(c.local.added)){const a={content:c.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(c.local.updated)){const a={content:c.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},s=h[t]?h[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of c.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=h[t]?h[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(c.remote.added)){const a={content:c.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},s=h[t]?h[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(c.remote.updated)){const a={content:c.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},s=h[t]?h[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of c.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of c.conflicts){const a={content:n[t]??null,hasConflicts:!0,localChange:h[t]?2:1,remoteChange:f[t]?2:1},s=h[t]?h[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(h))if(!r.has(t)){const a={content:h[t]?h[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=h[t]?h[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async resolveContent(c){return this.h.isEqualOrParent(c,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(c,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(c,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(c,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.cb(c):null}async hasLocalData(){try{const c=await this.Eb();if(Object.keys(c).length)return!0}catch{}return!1}async yb(c){const h={};for(const f of c)f.fileContent&&(h[this.h.basename(f.localResource)]=f.fileContent);await this.lb(JSON.stringify(this.Db(h)))}async Ab(c,h){for(const{fileContent:f,acceptResult:n,localResource:r,remoteResource:t,localChange:a}of c)if(a!==0){const s=t?this.h.basename(t):this.h.basename(r),l=this.h.joinPath(this.p,s);a===3?(this.M.trace(`${this.y}: Deleting snippet...`,this.h.basename(l)),await this.D.del(l),this.M.info(`${this.y}: Deleted snippet`,this.h.basename(l))):a===1?(this.M.trace(`${this.y}: Creating snippet...`,this.h.basename(l)),await this.D.createFile(l,R.VSBuffer.fromString(n.content),{overwrite:h}),this.M.info(`${this.y}: Created snippet`,this.h.basename(l))):(this.M.trace(`${this.y}: Updating snippet...`,this.h.basename(l)),await this.D.writeFile(l,R.VSBuffer.fromString(n.content),h?void 0:f),this.M.info(`${this.y}: Updated snippet`,this.h.basename(l)))}}async Bb(c,h,f){const n=h.syncData?this.Cb(h.syncData):{},r=(0,D.deepClone)(n);for(const{acceptResult:t,localResource:a,remoteResource:s,remoteChange:l}of c)if(l!==0){const o=a?this.h.basename(a):this.h.basename(s);l===3?delete r[o]:r[o]=t.content}return(0,p.areSame)(n,r)||(this.M.trace(`${this.y}: Updating remote snippets...`),h=await this.kb(JSON.stringify(r),f?null:h.ref),this.M.info(`${this.y}: Updated remote snippets`)),h}Cb(c){return g(c)}Db(c){const h={};for(const f of Object.keys(c))h[f]=c[f].value.toString();return h}async Eb(){const c={};let h;try{h=await this.D.resolve(this.p)}catch(f){if(f instanceof P.FileOperationError&&f.fileOperationResult===1)return c;throw f}for(const f of h.children||[]){const n=f.resource,r=this.h.extname(n);if(r===".json"||r===".code-snippets"){const t=this.h.relativePath(this.p,n),a=await this.D.readFile(n);c[t]=a}}return c}};w=pe([K(2,L.IEnvironmentService),K(3,P.IFileService),K(4,I.IStorageService),K(5,d.IUserDataSyncStoreService),K(6,d.IUserDataSyncBackupStoreService),K(7,d.IUserDataSyncLogService),K(8,k.IConfigurationService),K(9,d.IUserDataSyncEnablementService),K(10,S.ITelemetryService),K(11,E.IUriIdentityService)],w),e.SnippetsSynchroniser=w;let u=class extends v.AbstractInitializer{constructor(c,h,f,n,r,t){super("snippets",h,f,n,c,r,t)}async doInitialize(c){const h=c.syncData?JSON.parse(c.syncData.content):null;if(!h){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(h)){const r=h[n];if(r){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,n);await this.k.createFile(t,R.VSBuffer.fromString(r)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(c)}async c(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(c){return c.fileOperationResult===1}}};u=pe([K(0,P.IFileService),K(1,b.IUserDataProfilesService),K(2,L.IEnvironmentService),K(3,d.IUserDataSyncLogService),K(4,I.IStorageService),K(5,E.IUriIdentityService)],u),e.SnippetsInitializer=u}),define(re[123],ae([0,1,17,16,13,14,18,24,31,21,41,26]),function(_,e,R,i,D,k,L,P,I,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function v(w,u){try{return JSON.parse(w).tasks??null}catch(m){return u.error(m),null}}e.getTasksContentFromSyncContent=v;let p=class extends E.AbstractFileSynchroniser{constructor(u,m,c,h,f,n,r,t,a,s,l,o){super(u.tasksResource,{syncResource:"tasks",profile:u},m,t,a,s,c,h,r,l,f,n,o),this.nb=1,this.wb=this.h.joinPath(this.g,"tasks.json"),this.xb=this.wb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.yb=this.wb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Ab=this.wb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Bb=this.wb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async ob(u,m,c,h){const f=u.syncData?v(u.syncData.content,this.M):null;m=m===null&&c?u:m;const n=m?.syncData?v(m.syncData.content,this.M):null,r=await this.p();let t=null,a=!1,s=!1,l=!1;if(u.syncData){const C=r?r.value.toString():null;if(!n||n!==C||n!==f){this.M.trace(`${this.y}: Merging remote tasks with local tasks...`);const T=g(C,f,n);t=T.content,l=T.hasConflicts,a=T.hasLocalChanged,s=T.hasRemoteChanged}}else r&&(this.M.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=r.value.toString(),s=!0);const o={content:l?n:t,localChange:a?r?2:1:0,remoteChange:s?2:0,hasConflicts:l},y=r?r.value.toString():null;return[{fileContent:r,baseResource:this.xb,baseContent:n,localResource:this.yb,localContent:y,localChange:o.localChange,remoteResource:this.Ab,remoteContent:f,remoteChange:o.remoteChange,previewResource:this.wb,previewResult:o,acceptedResource:this.Bb}]}async sb(u){const m=u?.syncData?v(u.syncData.content,this.M):null;if(m===null)return!0;const c=await this.p(),h=c?c.value.toString():null,f=g(h,m,m);return f.hasLocalChanged||f.hasRemoteChanged}async pb(u,m){return u.previewResult}async qb(u,m,c,h){if(this.h.isEqual(m,this.yb))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(m,this.Ab))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(m,this.wb))return c===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:c,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async rb(u,m,c,h){const{fileContent:f}=c[0][0],{content:n,localChange:r,remoteChange:t}=c[0][1];if(r===0&&t===0&&this.M.info(`${this.y}: No changes found during synchronizing tasks.`),r!==0&&(this.M.trace(`${this.y}: Updating local tasks...`),f&&await this.lb(JSON.stringify(this.Hb(f.value.toString()))),n?await this.r(n,f,h):await this.tb(),this.M.info(`${this.y}: Updated local tasks`)),t!==0){this.M.trace(`${this.y}: Updating remote tasks...`);const a=JSON.stringify(this.Hb(n));u=await this.kb(a,h?null:u.ref),this.M.info(`${this.y}: Updated remote tasks`)}try{await this.D.del(this.wb)}catch{}m?.ref!==u.ref&&(this.M.trace(`${this.y}: Updating last synchronized tasks...`),await this.eb(u),this.M.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.D.exists(this.i)}async resolveContent(u){return this.h.isEqual(this.Ab,u)||this.h.isEqual(this.xb,u)||this.h.isEqual(this.yb,u)||this.h.isEqual(this.Bb,u)?this.cb(u):null}Hb(u){return u?{tasks:u}:{}}};p=pe([K(2,b.IUserDataSyncStoreService),K(3,b.IUserDataSyncBackupStoreService),K(4,b.IUserDataSyncLogService),K(5,i.IConfigurationService),K(6,b.IUserDataSyncEnablementService),K(7,k.IFileService),K(8,D.IEnvironmentService),K(9,L.IStorageService),K(10,P.ITelemetryService),K(11,I.IUriIdentityService)],p),e.TasksSynchroniser=p;let d=class extends E.AbstractInitializer{constructor(u,m,c,h,f,n){super("tasks",m,c,h,u,f,n),this.c=this.g.defaultProfile.tasksResource}async doInitialize(u){const m=u.syncData?v(u.syncData.content,this.j):null;if(!m){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,R.VSBuffer.fromString(m)),await this.n(u)}async i(){return this.k.exists(this.c)}};d=pe([K(0,k.IFileService),K(1,S.IUserDataProfilesService),K(2,D.IEnvironmentService),K(3,b.IUserDataSyncLogService),K(4,L.IStorageService),K(5,I.IUriIdentityService)],d),e.TasksInitializer=d;function g(w,u,m){if(w===null&&u===null&&m===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const c=m!==w,h=m!==u;return!c&&!h?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:c&&!h?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:h&&!c?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[124],ae([0,1,42,16,13,14,18,24,31,21,41,256,26]),function(_,e,R,i,D,k,L,P,I,S,E,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let p=class extends E.AbstractSynchroniser{constructor(u,m,c,h,f,n,r,t,a,s,l,o,y){super({syncResource:"profiles",profile:u},m,h,f,n,r,t,l,o,a,s,y),this.r=c,this.nb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?g(u.syncData):null}async getRemoteSyncedProfiles(u){const m=await this.getLastSyncUserData(),c=await this.S(u,m);return c?.syncData?g(c.syncData):null}async ob(u,m,c){if(!this.r.isEnabled())throw new v.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const h=u.syncData?g(u.syncData):null,f=m?.syncData?g(m.syncData):null,n=this.Bb(),{local:r,remote:t}=(0,b.merge)(n,h,f,[]),a={local:r,remote:t,content:f?this.Cb(f):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:t!==null?2:0},s=d(n,!1);return[{baseResource:this.baseResource,baseContent:f?this.Cb(f):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:h?this.Cb(h):null,remoteProfiles:h,previewResource:this.previewResource,previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.acceptedResource}]}async sb(u){const m=u?.syncData?g(u.syncData):null,c=this.Bb(),{remote:h}=(0,b.merge)(c,m,m,[]);return!!h?.added.length||!!h?.removed.length||!!h?.updated.length}async pb(u,m){return{...u.previewResult,hasConflicts:!1}}async qb(u,m,c,h){if(this.h.isEqual(m,this.localResource))return this.xb(u);if(this.h.isEqual(m,this.remoteResource))return this.yb(u);if(this.h.isEqual(m,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${m.toString()}`)}async xb(u){const m=this.Bb(),c=(0,b.merge)(m,null,null,[]),{local:h,remote:f}=c;return{content:u.localContent,local:h,remote:f,localChange:h.added.length>0||h.removed.length>0||h.updated.length>0?2:0,remoteChange:f!==null?2:0}}async yb(u){const m=u.remoteContent?JSON.parse(u.remoteContent):null,c=[],h=[];for(const f of this.Bb()){const n=m?.find(r=>r.id===f.id);n&&(c.push({id:f.id,name:f.name,collection:n.collection}),h.push(f))}if(m!==null){const f=(0,b.merge)(h,m,c,[]),{local:n,remote:r}=f;return{content:u.remoteContent,local:n,remote:r,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(u,m,c,h){const{local:f,remote:n,localChange:r,remoteChange:t}=c[0][1];if(r===0&&t===0&&this.M.info(`${this.y}: No changes found during synchronizing profiles.`),r!==0){await this.lb(d(this.Bb(),!1));const a=[];for(const s of f.added)a.push((async()=>{this.M.trace(`${this.y}: Creating '${s.name}' profile...`),await this.r.createProfile(s.id,s.name,{shortName:s.shortName}),this.M.info(`${this.y}: Created profile '${s.name}'.`)})());for(const s of f.removed)a.push((async()=>{this.M.trace(`${this.y}: Removing '${s.name}' profile...`),await this.r.removeProfile(s),this.M.info(`${this.y}: Removed profile '${s.name}'.`)})());for(const s of f.updated){const l=this.r.profiles.find(o=>o.id===s.id);l?a.push((async()=>{this.M.trace(`${this.y}: Updating '${s.name}' profile...`),await this.r.updateProfile(l,{name:s.name,shortName:s.shortName}),this.M.info(`${this.y}: Updated profile '${s.name}'.`)})()):this.M.info(`${this.y}: Could not find profile with id '${s.id}' to update.`)}await Promise.all(a)}if(t!==0){const a=c[0][0].remoteProfiles||[];this.M.trace(`${this.y}: Updating remote profiles...`);for(const s of n?.added||[]){const l=await this.H.createCollection(this.C);a.push({id:s.id,name:s.name,collection:l,shortName:s.shortName})}for(const s of n?.removed||[])a.splice(a.findIndex(({id:l})=>s.id===l),1);for(const s of n?.updated||[]){const l=a.find(({id:o})=>s.id===o);l&&a.splice(a.indexOf(l),1,{id:s.id,name:s.name,collection:l.collection,shortName:s.shortName})}u=await this.kb(this.Cb(a),h?null:u.ref),this.M.info(`${this.y}: Updated remote profiles.${n?.added.length?` Added: ${JSON.stringify(n.added.map(s=>s.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(s=>s.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(s=>s.name))}.`:""}`);for(const s of n?.removed||[])await this.H.deleteCollection(s.collection,this.C)}m?.ref!==u.ref&&(this.M.trace(`${this.y}: Updating last synchronized profiles...`),await this.eb(u),this.M.info(`${this.y}: Updated last synchronized profiles.`))}async hasLocalData(){return this.Bb().length>0}async resolveContent(u){if(this.h.isEqual(this.remoteResource,u)||this.h.isEqual(this.baseResource,u)||this.h.isEqual(this.localResource,u)||this.h.isEqual(this.acceptedResource,u)){const m=await this.cb(u);return m&&(0,R.toFormattedString)(JSON.parse(m),{})}return null}Bb(){return this.r.profiles.filter(u=>!u.isDefault&&!u.isTransient)}Cb(u){return JSON.stringify([...u].sort((m,c)=>m.name.localeCompare(c.name)))}};p=pe([K(2,S.IUserDataProfilesService),K(3,k.IFileService),K(4,D.IEnvironmentService),K(5,L.IStorageService),K(6,v.IUserDataSyncStoreService),K(7,v.IUserDataSyncBackupStoreService),K(8,v.IUserDataSyncLogService),K(9,i.IConfigurationService),K(10,v.IUserDataSyncEnablementService),K(11,P.ITelemetryService),K(12,I.IUriIdentityService)],p),e.UserDataProfilesManifestSynchroniser=p;function d(w,u){const m=[...w].sort((c,h)=>c.name.localeCompare(h.name)).map(c=>({id:c.id,name:c.name}));return u?(0,R.toFormattedString)(m,{}):JSON.stringify(m)}e.stringifyLocalProfiles=d;function g(w){return JSON.parse(w.content)}e.parseUserDataProfilesManifest=g}),define(re[271],ae([0,1,6,17,65,2,20,16,13,14,21,26]),function(_,e,R,i,D,k,L,P,I,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let v=class extends k.Disposable{constructor(d,g,w,u,m){super(),this.a=d,this.b=g,this.c=w,this.f=u,this.g=m;for(const c of this.g.profiles)for(const h of b.ALL_SYNC_RESOURCES)this.i(this.h(c,h))}async getAllRefs(d,g){const w=this.h(d,g),u=await this.b.resolve(w);return u.children?u.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort().reverse().map(c=>({ref:c.name,created:this.j(c)})):[]}async resolveContent(d,g,w){const u=this.h(d,g),m=(0,L.joinPath)(u,w);try{return(await this.b.readFile(m)).value.toString()}catch(c){return this.f.error(c),null}}async backup(d,g,w){const u=this.h(d,g),m=(0,L.joinPath)(u,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(m,i.VSBuffer.fromString(w))}catch(c){this.f.error(c)}try{this.i(u)}catch{}}h(d,g){return(0,L.joinPath)(this.a.userDataSyncHome,...d.isDefault?[g]:[d.id,g])}async i(d){try{try{if(!await this.b.exists(d))return}catch{return}const g=await this.b.resolve(d);if(g.children){const w=g.children.filter(h=>h.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(h.name)).sort(),u=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let m=w.filter(h=>Date.now()-this.j(h)>u);const c=w.length-m.length;c<10&&(m=m.slice(10-c)),await R.Promises.settled(m.map(async h=>{this.f.info("Deleting from backup",h.resource.path),await this.b.del(h.resource)}))}}catch(g){this.f.error(g)}}j(d){return d.ctime||new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};v=pe([K(0,I.IEnvironmentService),K(1,S.IFileService),K(2,P.IConfigurationService),K(3,b.IUserDataSyncLogService),K(4,E.IUserDataProfilesService)],v),e.UserDataSyncBackupStoreService=v}),define(re[272],ae([0,1,3,2,5,13,18,24,26]),function(_,e,R,i,D,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const S="sync.enable";let E=class extends i.Disposable{constructor(v,p,d,g){super(),this.c=v,this.f=p,this.g=d,this.h=g,this.a=new R.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new R.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(v.onDidChangeValue(w=>this.j(w)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(S,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(v){v&&!this.canToggleEnablement()||(this.f.publicLog2(S,{enabled:v}),this.c.store(S,v,-1,1))}isResourceEnabled(v){return this.c.getBoolean((0,I.getEnablementKey)(v),-1,!0)}setResourceEnablement(v,p){if(this.isResourceEnabled(v)!==p){const d=(0,I.getEnablementKey)(v);this.i(d,p)}}getResourceSyncStateVersion(v){}i(v,p){this.c.store(v,p,-1,D.isWeb?0:1)}j(v){if(v.scope!==-1)return;if(S===v.key){this.a.fire(this.isEnabled());return}const p=I.ALL_SYNC_RESOURCES.filter(d=>(0,I.getEnablementKey)(d)===v.key)[0];if(p){this.b.fire([p,this.isResourceEnabled(p)]);return}}};E=pe([K(0,L.IStorageService),K(1,P.ITelemetryService),K(2,k.IEnvironmentService),K(3,I.IUserDataSyncStoreManagementService)],E),e.UserDataSyncEnablementService=E}),define(re[80],ae([0,1,3,2,5,27,180,13,14,4,25,44,18,26]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",g="Safari",w="Chrome",u="Edge",m="Firefox",c="Android";function h(r){switch(r){case g:case w:case u:case m:case c:case(0,D.PlatformToString)(0):return!0}return!1}e.isWebPlatform=h;function f(){return D.isSafari?g:D.isChrome?w:D.isEdge?u:D.isFirefox?m:D.isAndroid?c:(0,D.PlatformToString)(D.isWeb?0:D.platform)}let n=class rt extends i.Disposable{constructor(t,a,s,l,o,y){super(),this.h=s,this.i=l,this.j=o,this.k=y,this.c=this.B(new R.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,b.getServiceMachineId)(t,a,s)}async getMachines(t){const a=await this.f;return(await this.m(t)).machines.map(l=>({...l,isCurrent:l.id===a}))}async addCurrentMachine(t){const a=await this.f,s=await this.m(t);s.machines.some(({id:l})=>l===a)||(s.machines.push({id:a,name:this.l(s.machines),platform:f()}),await this.n(s))}async removeCurrentMachine(t){const a=await this.f,s=await this.m(t),l=s.machines.filter(({id:o})=>o!==a);l.length!==s.machines.length&&(s.machines=l,await this.n(s))}async renameMachine(t,a,s){const l=await this.m(s),o=l.machines.find(({id:y})=>y===t);if(o){o.name=a,await this.n(l);const y=await this.f;t===y&&this.h.store(d,a,-1,1)}}async setEnablements(t){const a=await this.m();for(const[s,l]of t){const o=a.machines.find(y=>y.id===s);o&&(o.disabled=l?void 0:!0)}await this.n(a)}l(t){const a=this.h.get(d,-1);if(a)return a;const s=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${f()} (${this.k.nameShort})`,l=new RegExp(`${(0,k.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let o=0;for(const y of t){const C=l.exec(y.name),T=C?parseInt(C[1]):0;o=T>o?T:o}return`${s} #${o+1}`}async m(t){this.g=await this.p(t);const a=this.r(this.g);if(a.version!==rt.a)throw new Error((0,L.localize)(0,null,this.k.nameLong));return a}async n(t){const a=JSON.stringify(t),s=await this.i.writeResource(rt.b,a,this.g?.ref||null);this.g={ref:s,content:a},this.c.fire()}async p(t){if(this.g){const a=t&&t.latest?t.latest[rt.b]:void 0;if(this.g.ref===a)return this.g;if(a===void 0&&this.g.content===null)return this.g}return this.i.readResource(rt.b,this.g)}r(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(a){this.j.error(a)}return{version:rt.a,machines:[]}}};n.a=1,n.b="machines",n=pe([K(0,P.IEnvironmentService),K(1,I.IFileService),K(2,v.IStorageService),K(3,p.IUserDataSyncStoreService),K(4,p.IUserDataSyncLogService),K(5,E.IProductService)],n),e.UserDataSyncMachinesService=n}),define(re[273],ae([0,1,6,65,38,9,3,2,5,20,8,178,25,18,24,26,77,80]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const m="sync.disableMachineEventually",c="sync.sessionId",h="sync.storeUrl",f="sync.productQuality";let n=class extends P.Disposable{get j(){const a=this.C.get(h,-1);return a?E.URI.parse(a):void 0}set j(a){a?this.C.store(h,a.toString(),-1,1):this.C.remove(h,-1)}get l(){return this.C.get(f,-1)}set l(a){a?this.C.store(f,a,-1,1):this.C.remove(f,-1)}constructor(a,s,l,o,y,C,T,W,O,j){super(),this.n=s,this.p=l,this.r=o,this.s=y,this.u=C,this.v=T,this.w=W,this.y=O,this.C=j,this.a=this.B(new P.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new L.Emitter),this.onError=this.h.event,this.O=[],this.f=this.B(new R.ThrottledDelayer(this.P())),this.i=this.j,this.j=s.userDataSyncStore?.url,this.k=this.l,this.l=a.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,S.isEqual)(this.j,s.userDataSyncStore?.url)||(this.i=this.j,this.j=s.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.D(),this.M()&&this.L(),this.B(T.onDidChangeAccount(()=>this.D())),this.B(l.onDidChangeDonotMakeRequestsUntil(()=>this.D())),this.B(y.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(L.Event.filter(this.r.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}D(){const{enabled:a,message:s}=this.G();a?this.a.value===void 0&&(this.a.value=new r(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.C),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(l=>this.J(l))),this.F()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.u.info(s),this.a.clear()):s&&this.r.isEnabled()&&this.u.info(s))}F(){return!0}G(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,i.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.N(),this.i=this.j,this.H(!0)}async turnOff(a,s,l){try{this.v.account&&!l&&await this.y.removeCurrentMachine(),this.H(!1),this.C.remove(c,-1),a?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(o){if(this.u.error(o),s)this.H(!1);else throw o}}H(a){this.r.isEnabled()!==a&&(this.r.setEnablement(a),this.D())}I(){return!!this.k&&!!this.l&&this.k!==this.l}async J(a){if(!a){this.b=0;return}const s=g.UserDataSyncError.toUserDataSyncError(a);s instanceof g.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:s.code,service:this.n.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.D()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.L(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.L(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?I.isWeb&&s.code==="DefaultServiceChanged"&&!this.I()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(s),this.b++),this.h.fire(s)}async L(){this.C.store(m,!0,-1,1),await(0,R.timeout)(1e3*60*10),this.M()&&(this.N(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}M(){return this.C.getBoolean(m,-1,!1)}N(){this.C.remove(m,-1)}async triggerSync(a,s,l){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.O.push(...a),this.f.trigger(async()=>{this.u.trace("activity sources",...this.O),this.w.publicLog2("sync/triggered",{sources:this.O}),this.O=[],this.a.value&&await this.a.value.sync("Activity",l)},this.b?this.P()*1*Math.min(Math.pow(2,this.b),60):this.P())}P(){return 2e3}};n=pe([K(0,v.IProductService),K(1,g.IUserDataSyncStoreManagementService),K(2,g.IUserDataSyncStoreService),K(3,g.IUserDataSyncEnablementService),K(4,g.IUserDataSyncService),K(5,g.IUserDataSyncLogService),K(6,w.IUserDataSyncAccountService),K(7,d.ITelemetryService),K(8,u.IUserDataSyncMachinesService),K(9,p.IStorageService)],n),e.UserDataAutoSyncService=n;class r extends P.Disposable{constructor(a,s,l,o,y,C,T,W){super(),this.j=a,this.k=s,this.l=l,this.m=o,this.n=y,this.p=C,this.r=T,this.s=W,this.b=this.B(new P.MutableDisposable),this.c=this.B(new L.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new L.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,P.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}u(){this.b.value=(0,R.disposableTimeout)(()=>this.sync(r.a,!1),this.k)}sync(a,s){const l=(0,R.createCancelablePromise)(async o=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(y){if((0,k.isCancellationError)(y))return}return this.y(a,s,o)});return this.i=l,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,S.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const a=await this.l.getPreviousUserDataSyncStore(),s=this.l.userDataSyncStore;return!!s&&!!a&&(!(0,S.isEqual)(s.defaultUrl,a.defaultUrl)||!(0,S.isEqual)(s.insidersUrl,a.insidersUrl)||!(0,S.isEqual)(s.stableUrl,a.stableUrl))}async y(a,s,l){this.r.info(`Auto Sync: Triggered by ${a}`),this.c.fire();let o;try{if(this.h=await this.n.createSyncTask(this.g,s),l.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new g.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new g.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new g.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const y=this.s.get(c,-1);if(y&&this.g&&y!==this.g.session)throw this.v()?await this.w()?new g.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new g.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new g.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const C=await this.p.getMachines(this.g||void 0);if(l.isCancellationRequested)return;const T=C.find(W=>W.isCurrent);if(T?.disabled)throw new g.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(W){throw new g.UserDataAutoSyncError((0,D.toErrorMessage)(W),W instanceof g.UserDataSyncError?W.code:"Unknown")}if(this.g&&this.g.session!==y&&this.s.store(c,this.g.session,-1,1),l.isCancellationRequested)return;T||await this.p.addCurrentMachine(this.g||void 0)}catch(y){this.r.error(y),o=y}this.f.fire(o)}register(a){return super.B(a)}}r.a="Interval"}),define(re[274],ae([0,1,8,181,13,14,44,18,31,26,21,41,122,121,120,16,123,118,119,4,124,42]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u,m,c,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class Ve{constructor(t,a,s,l,o,y,C,T,W,O){this.e=t,this.f=a,this.g=s,this.h=o,this.i=y,this.j=C,this.k=T,this.l=W,this.m=O,this.d=l.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const a=this.L(t.content,"profiles");return(0,h.parseUserDataProfilesManifest)(a)}return[]}async getRemoteSyncResourceHandles(t,a){return(await this.e.getAllResourceRefs(t,a?.collection)).map(({created:l,ref:o})=>({created:l,uri:this.J({remote:!0,syncResource:t,profile:a?.id??this.k.defaultProfile.id,collection:a?.collection,ref:o,node:void 0})}))}async getLocalSyncResourceHandles(t,a){return(await this.f.getAllRefs(a,t)).map(({created:l,ref:o})=>({created:l,uri:this.J({remote:!1,syncResource:t,profile:a.id,collection:void 0,ref:o,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const a=this.K(t),s=a?this.k.profiles.find(l=>l.id===a.profile):void 0;return a&&s?{profile:s,syncResource:a?.syncResource}:void 0}async getAssociatedResources({uri:t}){const a=this.K(t);if(!a)return[];const s=this.k.profiles.find(l=>l.id===a.profile);switch(a.syncResource){case"settings":return this.r(t,s);case"keybindings":return this.t(t,s);case"tasks":return this.v(t,s);case"snippets":return this.x(t,s);case"globalState":return this.D(t,s);case"extensions":return this.A(t,s);case"profiles":return this.G(t,s)}}async getMachineId({uri:t}){const a=this.K(t);if(!!a){if(a.remote){if(a.ref){const{content:s}=await this.M(a.syncResource,a.ref,a.collection);if(s)return this.L(s,a.syncResource)?.machineId}return}return(0,L.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const a=this.K(t);if(!a||a.node===Ve.a)return null;if(a.ref){const s=await this.n(a.remote,a.syncResource,a.profile,a.collection,a.ref);return a.node&&s?this.o(a.syncResource,s,a.node):s}return!a.remote&&!a.node?this.q(a.syncResource,a.profile):null}async n(t,a,s,l,o){if(t){const{content:C}=await this.M(a,o,l);return C}const y=this.k.profiles.find(C=>C.id===s);return y?this.f.resolveContent(y,a,o):null}o(t,a,s){const l=this.L(a,t);switch(t){case"settings":return this.s(l,s);case"keybindings":return this.u(l,s);case"tasks":return this.w(l,s);case"snippets":return this.y(l,s);case"globalState":return this.E(l,s);case"extensions":return this.B(l,s);case"profiles":return this.H(l,s)}}async q(t,a){const s=this.k.profiles.find(l=>l.id===a);if(!s)return null;switch(t){case"globalState":return this.F(s);case"extensions":return this.C(s);case"profiles":return this.I(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,a){const s=this.d.joinPath(t,"settings.json"),l=a?a.settingsResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:l}]}s(t,a){switch(a){case"settings.json":return(0,p.parseSettingsSyncContent)(t.content).settings}return null}t(t,a){const s=this.d.joinPath(t,"keybindings.json"),l=a?a.keybindingsResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:l}]}u(t,a){switch(a){case"keybindings.json":return(0,d.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,a){const s=this.d.joinPath(t,"tasks.json"),l=a?a.tasksResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:l}]}w(t,a){switch(a){case"tasks.json":return(0,w.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,a){const s=await this.resolveContent(t);if(s){const l=this.L(s,"snippets");if(l){const o=(0,v.parseSnippets)(l),y=[];for(const C of Object.keys(o)){const T=this.d.joinPath(t,C),W=a?this.d.joinPath(a.snippetsHome,C):this.d.joinPath(t,Ve.a);y.push({resource:T,comparableResource:W})}return y}}return[]}y(t,a){return(0,v.parseSnippets)(t)[a]||null}A(t,a){const s=this.d.joinPath(t,"extensions.json"),l=a?this.J({remote:!1,syncResource:"extensions",profile:a.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:l}]}B(t,a){switch(a){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(t),!0)}return null}async C(t){const{localExtensions:a}=await this.m.createInstance(u.LocalExtensionsProvider).getLocalExtensions(t);return(0,u.stringify)(a,!0)}D(t,a){const s=this.d.joinPath(t,"globalState.json"),l=a?this.J({remote:!1,syncResource:"globalState",profile:a.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:l}]}E(t,a){switch(a){case"globalState.json":return(0,m.stringify)(JSON.parse(t.content),!0)}return null}async F(t){const a=await this.m.createInstance(m.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,m.stringify)(a,!0)}G(t,a){const s=this.d.joinPath(t,"profiles.json"),l=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:l}]}H(t,a){switch(a){case"profiles.json":return(0,f.toFormattedString)(JSON.parse(t.content),{})}return null}async I(t){return(0,h.stringifyLocalProfiles)(this.k.profiles.filter(a=>!a.isDefault&&!a.isTransient),!0)}J(t){const a=t.remote?Ve.b:Ve.c,s=[t.syncResource,t.profile];return t.collection&&s.push(`collection:${t.collection}`),t.ref&&s.push(`ref:${t.ref}`),t.node&&s.push(t.node),this.d.joinPath(R.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:a,path:"/"}),...s)}K(t){if(t.scheme!==S.USER_DATA_SYNC_SCHEME||t.authority!==Ve.c&&t.authority!==Ve.b)return;const a=[];for(;t.path!=="/";)a.unshift(this.d.basename(t)),t=this.d.dirname(t);if(a.length<2)return;const s=t.authority===Ve.b,l=a.shift(),o=a.shift();let y,C,T;for(;a.length;){const W=a.shift();W.startsWith("collection:")?y=W.substring(11):W.startsWith("ref:")?C=W.substring(4):T=W}return{remote:s,syncResource:l,profile:o,collection:y,ref:C,node:T}}L(t,a){try{const s=JSON.parse(t);if((0,b.isSyncData)(s))return s}catch(s){this.g.error(s)}throw new S.UserDataSyncError((0,i.localize)(0,null),"IncompatibleRemoteContent",a)}async M(t,a,s){const l=await this.e.resolveResourceContent(t,a,s);return{ref:a,content:l}}};n.a="not-existing-resource",n.b="remote-backup",n.c="local-backup",n=pe([K(0,S.IUserDataSyncStoreService),K(1,S.IUserDataSyncBackupStoreService),K(2,S.IUserDataSyncLogService),K(3,I.IUriIdentityService),K(4,D.IEnvironmentService),K(5,P.IStorageService),K(6,k.IFileService),K(7,E.IUserDataProfilesService),K(8,g.IConfigurationService),K(9,c.IInstantiationService)],n),e.UserDataSyncResourceProviderService=n}),define(re[275],ae([0,1,19,6,22,38,3,2,20,15,30,16,13,29,4,25,18,24,21,118,119,120,121,122,123,124,26]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u,m,c,h,f,n,r,t,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let o=class extends P.Disposable{get status(){return this.c}get conflicts(){return this.h}get lastSyncTime(){return this.l}constructor(O,j,F,A,M,B,G,V,Q,$,z){super(),this.u=O,this.v=j,this.w=F,this.y=A,this.C=M,this.D=B,this.F=G,this.G=V,this.H=Q,this.I=$,this.J=z,this.c="uninitialized",this.f=this.B(new L.Emitter),this.onDidChangeStatus=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeLocal=this.g.event,this.h=[],this.i=this.B(new L.Emitter),this.onDidChangeConflicts=this.i.event,this.j=[],this.k=this.B(new L.Emitter),this.onSyncErrors=this.k.event,this.l=void 0,this.m=this.B(new L.Emitter),this.onDidChangeLastSyncTime=this.m.event,this.n=this.B(new L.Emitter),this.onDidResetLocal=this.n.event,this.r=this.B(new L.Emitter),this.onDidResetRemote=this.r.event,this.t=new Map,this.c=j.userDataSyncStore?"idle":"uninitialized",this.l=this.D.getNumber(l,-1,void 0),this.B((0,P.toDisposable)(()=>this.Y()))}async createSyncTask(O,j){this.ab(),this.y.info("Sync started.");const F=new Date().getTime(),A=(0,E.generateUuid)();try{const V=(0,s.createSyncHeaders)(A);j&&(V["Cache-Control"]="no-cache"),O=await this.u.manifest(O,V)}catch(V){const Q=s.UserDataSyncError.toUserDataSyncError(V);throw T(Q,A,this.v,this.C),Q}const M=!1,B=this;let G;return{manifest:O,async run(){if(M)throw new Error("Can run a task only once");G=(0,i.createCancelablePromise)(V=>B.L(O,!1,A,V)),await G.finally(()=>G=void 0),B.y.info(`Sync done. Took ${new Date().getTime()-F}ms`),B.W()},stop(){return G?.cancel(),B.P()}}}async createManualSyncTask(){if(this.ab(),this.F.isEnabled())throw new s.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.y.info("Sync started.");const O=new Date().getTime(),j=(0,E.generateUuid)(),F=(0,s.createSyncHeaders)(j);let A;try{A=await this.u.manifest(null,F)}catch(G){const V=s.UserDataSyncError.toUserDataSyncError(G);throw T(V,j,this.v,this.C),V}await this.resetLocal();const M=this,B=new D.CancellationTokenSource;return{id:j,async merge(){return M.L(A,!0,j,B.token)},async apply(){await M.N(A,j,B.token),M.y.info(`Sync done. Took ${new Date().getTime()-O}ms`),M.W()},async stop(){B.cancel(),await M.P(),await M.resetLocal()}}}async L(O,j,F,A){this.j=[];try{this.status!=="hasConflicts"&&this.S("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.j.push(...await this.O(M,O,j,F,A));const B=M.enabled.find(G=>G.resource==="profiles");if(B){const G=await B.getLastSyncedProfiles()||[];if(A.isCancellationRequested)return;await this.M(G,O,j,F,A)}}finally{this.k.fire(this.j)}}async M(O,j,F,A,M){for(const B of O){if(M.isCancellationRequested)return;const G=this.G.profiles.find(Q=>Q.id===B.id);if(!G){this.y.error(`Profile with id:${B.id} and name: ${B.name} does not exist locally to sync.`);continue}this.y.info("Syncing profile.",B.name);const V=this.getOrCreateActiveProfileSynchronizer(G,B);this.j.push(...await this.O(V,j,F,A,M))}for(const[B,G]of this.t.entries())this.G.profiles.some(V=>V.id===G[0].profile.id)||(G[1].dispose(),this.t.delete(B))}async N(O,j,F){const A=this.X();for(const Q of A){if(F.isCancellationRequested)return;await Q.apply(j,F)}const M=A.find(Q=>Q.profile.isDefault);if(!M)return;const B=M.enabled.find(Q=>Q.resource==="profiles");if(!B)return;const V=(await B.getRemoteSyncedProfiles(O?.latest??null)||[]).filter(Q=>A.every($=>$.profile.id!==Q.id));V.length&&await this.M(V,O,!1,j,F)}async O(O,j,F,A,M){return(await O.sync(j,F,A,M)).map(([G,V])=>({profile:O.profile,syncResource:G,error:V}))}async P(){this.status!=="idle"&&await Promise.allSettled(this.X().map(O=>O.stop()))}async resolveContent(O){const j=await this.J.resolveContent(O);if(j)return j;for(const F of this.X())for(const A of F.enabled){const M=await A.resolveContent(O);if(M)return M}return null}async replace(O){this.ab();const j=this.J.resolveUserDataSyncResource(O);if(!j)return;const F=await this.resolveContent(O.uri);!F||await this.Q(j.profile,async A=>{if(j.syncResource===A.resource)return await A.replace(F),!0})}async accept(O,j,F,A){this.ab(),await this.Q(O.profile,async M=>{if(O.syncResource===M.resource)return await M.accept(j,F),A&&await M.apply((0,S.isBoolean)(A)?!1:A.force,(0,s.createSyncHeaders)((0,E.generateUuid)())),!0})}getRemoteProfiles(){return this.J.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(O,j){return this.J.getRemoteSyncResourceHandles(O,j)}async getLocalSyncResourceHandles(O,j){return this.J.getLocalSyncResourceHandles(O,j??this.G.defaultProfile)}async getAssociatedResources(O){return this.J.getAssociatedResources(O)}async getMachineId(O){return this.J.getMachineId(O)}async hasLocalData(){return!!await this.Q(this.G.defaultProfile,async j=>{if(j.resource!=="globalState"&&await j.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.Q(this.G.defaultProfile,async j=>{if(await j.hasPreviouslySynced())return!0})}async reset(){this.ab(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.ab();try{await this.u.clear(),this.y.info("Cleared data on server")}catch(O){this.y.error(O)}this.r.fire()}async resetLocal(){this.ab(),this.l=void 0,this.D.remove(l,-1);for(const[O]of this.t.values())try{await O.resetLocal()}catch(j){this.y.error(j)}this.Y(),this.n.fire(),this.y.info("Did reset the local sync state.")}async Q(O,j){const F=new P.DisposableStore;try{const A=this.t.get(O.id);if(A){const Q=await this.R(A[0],j,F);return(0,S.isUndefined)(Q)?null:Q}if(O.isDefault){const Q=F.add(this.w.createInstance(y,O,void 0)),$=await this.R(Q,j,F);return(0,S.isUndefined)($)?null:$}if(this.G.isEnabled()||this.I.isBuilt&&(!this.H.enableSyncingProfiles||(0,I.isEqual)(this.v.userDataSyncStore?.url,this.v.userDataSyncStore?.stableUrl)))return null;const M=F.add(this.w.createInstance(a.UserDataProfilesManifestSynchroniser,O,void 0)),B=await this.u.manifest(null),V=(await M.getRemoteSyncedProfiles(B?.latest??null)||[]).find(Q=>Q.id===O.id);if(V){const Q=F.add(this.w.createInstance(y,O,V.collection)),$=await this.R(Q,j,F);return(0,S.isUndefined)($)?null:$}return null}finally{F.dispose()}}async R(O,j,F){const A=[...O.enabled,...O.disabled.map(M=>F.add(O.createSynchronizer(M)))];for(const M of A){const B=await j(M);if(!(0,S.isUndefined)(B))return B}}S(O){const j=this.c;this.c!==O&&(this.c=O,this.f.fire(O),j==="hasConflicts"&&this.W())}U(){const O=this.X().map(j=>j.conflicts).flat();(0,R.equals)(this.h,O,(j,F)=>j.profile.id===F.profile.id&&j.syncResource===F.syncResource&&(0,R.equals)(j.conflicts,F.conflicts,(A,M)=>(0,I.isEqual)(A.previewResource,M.previewResource)))||(this.h=O,this.i.fire(O))}W(){this.status==="idle"&&(this.l=new Date().getTime(),this.D.store(l,this.l,-1,1),this.m.fire(this.l))}getOrCreateActiveProfileSynchronizer(O,j){let F=this.t.get(O.id);if(F&&F[0].collection!==j?.collection&&(this.y.error("Profile synchronizer collection does not match with the remote sync profile collection"),F[1].dispose(),F=void 0,this.t.delete(O.id)),!F){const A=new P.DisposableStore,M=A.add(this.w.createInstance(y,O,j?.collection));A.add(M.onDidChangeStatus(B=>this.S(B))),A.add(M.onDidChangeConflicts(B=>this.U())),A.add(M.onDidChangeLocal(B=>this.g.fire(B))),this.t.set(O.id,F=[M,A])}return F[0]}X(){const O=[];for(const[j]of this.t.values())O.push(j);return O}Y(){this.t.forEach(([,O])=>O.dispose()),this.t.clear()}ab(){if(!this.v.userDataSyncStore)throw new Error("Not enabled")}};o=pe([K(0,s.IUserDataSyncStoreService),K(1,s.IUserDataSyncStoreManagementService),K(2,d.IInstantiationService),K(3,s.IUserDataSyncLogService),K(4,u.ITelemetryService),K(5,w.IStorageService),K(6,s.IUserDataSyncEnablementService),K(7,m.IUserDataProfilesService),K(8,g.IProductService),K(9,v.IEnvironmentService),K(10,s.IUserDataSyncResourceProviderService)],o),e.UserDataSyncService=o;let y=class extends P.Disposable{get enabled(){return this.c.sort((O,j)=>O[1]-j[1]).map(([O])=>O)}get disabled(){return s.ALL_SYNC_RESOURCES.filter(O=>!this.k.isResourceEnabled(O))}get status(){return this.f}get conflicts(){return this.i}constructor(O,j,F,A,M,B,G,V,Q,$,z,Y){super(),this.profile=O,this.collection=j,this.k=F,this.l=A,this.m=M,this.n=B,this.r=G,this.t=V,this.u=Q,this.v=$,this.w=z,this.y=Y,this.c=[],this.f="idle",this.g=this.B(new L.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new L.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new L.Emitter),this.onDidChangeConflicts=this.j.event,this.B(F.onDidChangeResourceEnablement(([ee,oe])=>this.C(ee,oe))),this.B((0,P.toDisposable)(()=>this.c.splice(0,this.c.length).forEach(([,,ee])=>ee.dispose())));for(const ee of s.ALL_SYNC_RESOURCES)F.isResourceEnabled(ee)&&this.D(ee)}C(O,j){j?this.D(O):this.F(O)}D(O){if(this.c.some(([M])=>M.resource===O))return;if(O==="extensions"&&!this.m.isEnabled()){this.t.info("Skipping extensions sync because gallery is not configured");return}if(O==="profiles"){if(!this.profile.isDefault||!this.v.isEnabled())return;if(this.y.isBuilt&&(!this.u.enableSyncingProfiles||(0,I.isEqual)(this.n.userDataSyncStore?.url,this.n.userDataSyncStore?.stableUrl))){this.t.debug("Skipping profiles sync");return}}const j=new P.DisposableStore,F=j.add(this.createSynchronizer(O));j.add(F.onDidChangeStatus(()=>this.I())),j.add(F.onDidChangeConflicts(()=>this.J())),j.add(F.onDidChangeLocal(()=>this.h.fire(O)));const A=this.L(O);this.c.push([F,A,j])}F(O){const j=this.c.findIndex(([F])=>F.resource===O);if(j!==-1){const[[F,,A]]=this.c.splice(j,1);A.dispose(),this.I(),Promise.allSettled([F.stop(),F.resetLocal()]).then(null,M=>this.t.error(M))}}createSynchronizer(O){switch(O){case"settings":return this.l.createInstance(n.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.l.createInstance(f.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.l.createInstance(r.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.l.createInstance(t.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.l.createInstance(h.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.l.createInstance(c.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.l.createInstance(a.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(O,j,F,A){if(A.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const B=[],G=(0,s.createSyncHeaders)(F),V=(this.collection?O?.collections?.[this.collection]?.latest:O?.latest)??null,Q=j?await this.G(V):{};for(const $ of M){if(A.isCancellationRequested)return[];if(!this.k.isResourceEnabled($.resource))return[];try{if(j){const z=await $.preview(V,Q,G);if(z)for(const Y of z.resourcePreviews)(Y.localChange!==0||Y.remoteChange!==0)&&Y.mergeState==="preview"&&await $.merge(Y.previewResource)}else await $.sync(V,G)}catch(z){const Y=s.UserDataSyncError.toUserDataSyncError(z);if(T(Y,F,this.n,this.r),C(z))throw Y;this.t.error(z),this.t.error(`${$.resource}: ${(0,k.toErrorMessage)(z)}`),B.push([$.resource,Y])}}return B}finally{this.I()}}async apply(O,j){const F=(0,s.createSyncHeaders)(O);for(const A of this.enabled){if(j.isCancellationRequested)return;try{await A.apply(!1,F)}catch(M){const B=s.UserDataSyncError.toUserDataSyncError(M);if(T(B,O,this.n,this.r),C(M))throw B;this.t.error(M),this.t.error(`${A.resource}: ${(0,k.toErrorMessage)(M)}`)}}}async stop(){for(const O of this.enabled)try{O.status!=="idle"&&await O.stop()}catch(j){this.t.error(j)}}async resetLocal(){for(const O of this.enabled)try{await O.resetLocal()}catch(j){this.t.error(`${O.resource}: ${(0,k.toErrorMessage)(j)}`),this.t.error(j)}}async G(O){if(!this.profile.isDefault)return{};const j=this.w.getValue(s.USER_DATA_SYNC_CONFIGURATION_SCOPE),F=this.enabled.find(A=>A instanceof n.SettingsSynchroniser);if(F){const A=await F.getRemoteUserDataSyncConfiguration(O);return{...j,...A}}return j}H(O){this.f!==O&&(this.f=O,this.g.fire(O))}I(){return this.J(),this.enabled.some(O=>O.status==="hasConflicts")?this.H("hasConflicts"):this.enabled.some(O=>O.status==="syncing")?this.H("syncing"):this.H("idle")}J(){const O=this.enabled.filter(j=>j.status==="hasConflicts").filter(j=>j.conflicts.conflicts.length>0).map(j=>j.conflicts);(0,R.equals)(this.i,O,(j,F)=>j.syncResource===F.syncResource&&(0,R.equals)(j.conflicts,F.conflicts,(A,M)=>(0,I.isEqual)(A.previewResource,M.previewResource)))||(this.i=O,this.j.fire(O))}L(O){switch(O){case"profiles":return 0;case"settings":return 1;case"keybindings":return 2;case"snippets":return 3;case"tasks":return 4;case"globalState":return 5;case"extensions":return 6}}};y=pe([K(2,s.IUserDataSyncEnablementService),K(3,d.IInstantiationService),K(4,p.IExtensionGalleryService),K(5,s.IUserDataSyncStoreManagementService),K(6,u.ITelemetryService),K(7,s.IUserDataSyncLogService),K(8,g.IProductService),K(9,m.IUserDataProfilesService),K(10,b.IConfigurationService),K(11,v.IEnvironmentService)],y);function C(W){if(W instanceof s.UserDataSyncError)switch(W.code){case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function T(W,O,j,F){F.publicLog2("sync/error",{code:W.code,serverCode:W instanceof s.UserDataSyncStoreError?String(W.serverCode):void 0,url:W instanceof s.UserDataSyncStoreError?W.url:void 0,resource:W.resource,executionId:O,service:j.userDataSyncStore.url.toString()})}}),define(re[276],ae([0,1,3,2,8,21,26]),function(_,e,R,i,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function P(v,p){return{...v,profile:(0,k.reviveProfile)(v.profile,p.profilesHome.scheme)}}function I(v){return{created:v.created,uri:D.URI.revive(v.uri)}}class S{constructor(p,d,g){this.c=p,this.d=d,this.f=g,this.a=new Map,this.b=new R.Emitter}listen(p,d){switch(d){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${d}`)}async call(p,d,g){try{return await this.g(p,d,g)}catch(w){throw this.f.error(w),w}}async g(p,d,g){switch(d){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(D.URI.revive(g[0]));case"accept":return this.c.accept(P(g[0],this.d),D.URI.revive(g[1]),g[2],g[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(g[0],(0,k.reviveProfile)(g[1],this.d.profilesHome.scheme));case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(g[0],g[1]);case"replace":return this.c.replace(I(g[0]));case"getAssociatedResources":return this.c.getAssociatedResources(I(g[0]));case"getMachineId":return this.c.getMachineId(I(g[0]));case"createManualSyncTask":return this.i()}if(d.startsWith("manualSync/")){const w=d.substring(11),u=g[0],m=this.h(u);switch(g=g.slice(1),w){case"merge":return m.merge();case"apply":return m.apply().finally(()=>this.a.delete(this.j(m.id)));case"stop":return m.stop().finally(()=>this.a.delete(this.j(m.id)))}}throw new Error("Invalid call")}h(p){const d=this.a.get(this.j(p));if(!d)throw new Error(`Manual sync taks not found: ${p}`);return d}async i(){const p=await this.c.createManualSyncTask();return this.a.set(this.j(p.id),p),p.id}j(p){return`manualSyncTask-${p}`}}e.UserDataSyncChannel=S;let E=class extends i.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(p,d){super(),this.k=d,this.b="uninitialized",this.c=this.B(new R.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new R.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new R.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new R.Emitter),this.onSyncErrors=this.j.event,this.a={call(g,w,u){return p.call(g,w,u).then(null,m=>{throw L.UserDataSyncError.toUserDataSyncError(m)})},listen(g,w){return p.listen(g,w)}},this.a.call("_getInitialData").then(([g,w,u])=>{this.l(g),this.m(w),u&&this.n(u),this.B(this.a.listen("onDidChangeStatus")(m=>this.l(m))),this.B(this.a.listen("onDidChangeLastSyncTime")(m=>this.n(m)))}),this.B(this.a.listen("onDidChangeConflicts")(g=>this.m(g))),this.B(this.a.listen("onSyncErrors")(g=>this.j.fire(g.map(w=>({...w,error:L.UserDataSyncError.toUserDataSyncError(w.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const p=await this.a.call("createManualSyncTask"),d=this;return new b(p,{async call(w,u,m){return d.a.call(`manualSync/${w}`,[p,...Array.isArray(u)?u:[u]],m)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(p,d,g,w){return this.a.call("accept",[p,d,g,w])}resolveContent(p){return this.a.call("resolveContent",[p])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(p,d){return(await this.a.call("getLocalSyncResourceHandles",[p,d])).map(({created:w,uri:u})=>({created:w,uri:D.URI.revive(u)}))}async getRemoteSyncResourceHandles(p,d){return(await this.a.call("getRemoteSyncResourceHandles",[p,d])).map(({created:w,uri:u})=>({created:w,uri:D.URI.revive(u)}))}async getAssociatedResources(p){return(await this.a.call("getAssociatedResources",[p])).map(({resource:g,comparableResource:w})=>({resource:D.URI.revive(g),comparableResource:D.URI.revive(w)}))}getMachineId(p){return this.a.call("getMachineId",[p])}replace(p){return this.a.call("replace",[p])}async l(p){this.b=p,this.c.fire(p)}async m(p){this.f=p.map(d=>({syncResource:d.syncResource,profile:(0,k.reviveProfile)(d.profile,this.k.profilesHome.scheme),conflicts:d.conflicts.map(g=>({...g,baseResource:D.URI.revive(g.baseResource),localResource:D.URI.revive(g.localResource),remoteResource:D.URI.revive(g.remoteResource),previewResource:D.URI.revive(g.previewResource)}))})),this.g.fire(this.f)}n(p){this.h!==p&&(this.h=p,this.i.fire(p))}};E=pe([K(1,k.IUserDataProfilesService)],E),e.UserDataSyncChannelClient=E;class b extends i.Disposable{constructor(p,d){super(),this.id=p,this.a=d}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(re[277],ae([0,1,6,22,9,3,2,139,5,20,15,8,30,16,13,14,25,47,44,18,26]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u,m,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const f="sync.previous.store",n="sync.donot-make-requests-until",r="sync.user-session-id",t="sync.machine-session-id",a=100,s=1e3*60*5;let l=class extends L.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(h.SYNC_SERVICE_URL_TYPE,-1)}set c(O){this.h.store(h.SYNC_SERVICE_URL_TYPE,O,-1,I.isWeb?0:1)}constructor(O,j,F){super(),this.f=O,this.g=j,this.h=F,this.a=this.B(new k.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(k.Event.filter(F.onDidChangeValue,A=>A.key===h.SYNC_SERVICE_URL_TYPE&&A.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[h.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(h.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(O,j){O=I.isWeb&&O?.web?{...O,...O.web}:O;const F={...O||{},...j||{}};if(F&&(0,E.isString)(F.url)&&(0,E.isObject)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(A=>Array.isArray(F.authenticationProviders[A].scopes))){const A=F,M=!!A.canSwitch&&!j?.url,B=A.url===A.insidersUrl?"insiders":"stable",G=(M?this.c:void 0)||B,V=j?.url||(G==="insiders"?A.insidersUrl:G==="stable"?A.stableUrl:A.url);return{url:b.URI.parse(V),type:G,defaultType:B,defaultUrl:b.URI.parse(A.url),stableUrl:b.URI.parse(A.stableUrl),insidersUrl:b.URI.parse(A.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(A.authenticationProviders).reduce((Q,$)=>(Q.push({id:$,scopes:A.authenticationProviders[$].scopes}),Q),[])}}}};l=pe([K(0,w.IProductService),K(1,p.IConfigurationService),K(2,c.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let o=class extends l{constructor(O,j,F){super(O,j,F);const A=this.h.get(f,-1);A&&(this.k=JSON.parse(A));const M=this.f[h.CONFIGURATION_SYNC_STORE_KEY];M?this.h.store(f,JSON.stringify(M),-1,1):this.h.remove(f,-1)}async switch(O){O!==this.c&&(this.c=O,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};o=pe([K(0,w.IProductService),K(1,p.IConfigurationService),K(2,c.IStorageService)],o),e.UserDataSyncStoreManagementService=o;let y=class extends L.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(O,j,F,A,M,B,G){super(),this.k=F,this.l=A,this.n=G,this.g=this.B(new k.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new k.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new k.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(O),this.c=(0,m.getServiceMachineId)(M,B,G).then(V=>{const Q={"X-Client-Name":`${j.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":j.version};return j.commit&&(Q["X-Client-Commit"]=j.commit),Q}),this.f=new T(a,s,this.k,this.l),this.r(),this.B((0,L.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(O,j){this.b={token:O,type:j}}p(O){this.a=O?(0,S.joinPath)(O,"v1"):void 0}r(){const O=this.n.getNumber(n,-1);O&&Date.now()<O&&this.t(new Date(O))}t(O){this.i?.getTime()!==O?.getTime()&&(this.i=O,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(n,this.i.getTime(),-1,1),this.s=(0,R.createCancelablePromise)(j=>(0,R.timeout)(this.i.getTime()-Date.now(),j).then(()=>this.t(void 0))),this.s.then(null,j=>null)):this.n.remove(n,-1),this.j.fire())}async getAllCollections(O={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,S.joinPath)(this.a,"collection").toString();O={...O},O["Content-Type"]="application/json";const F=await this.w(j,{type:"GET",headers:O},[],i.CancellationToken.None);return await(0,u.asJson)(F)||[]}async createCollection(O={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,S.joinPath)(this.a,"collection").toString();O={...O},O["Content-Type"]=P.Mimes.text;const F=await this.w(j,{type:"POST",headers:O},[],i.CancellationToken.None),A=await(0,u.asTextOrError)(F);if(!A)throw new h.UserDataSyncStoreError("Server did not return the collection id",j,"NoCollection",F.res.statusCode,F.res.headers[h.HEADER_OPERATION_ID]);return A}async deleteCollection(O,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=O?(0,S.joinPath)(this.a,"collection",O).toString():(0,S.joinPath)(this.a,"collection").toString();j={...j},await this.w(F,{type:"DELETE",headers:j},[],i.CancellationToken.None)}async getAllResourceRefs(O,j){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.u(this.a,j,O),A={},M=await this.w(F.toString(),{type:"GET",headers:A},[],i.CancellationToken.None);return(await(0,u.asJson)(M)||[]).map(({url:G,created:V})=>({ref:(0,S.relativePath)(F,F.with({path:G})),created:V*1e3}))}async resolveResourceContent(O,j,F,A={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,S.joinPath)(this.u(this.a,F,O),j).toString();A={...A},A["Cache-Control"]="no-cache";const B=await this.w(M,{type:"GET",headers:A},[],i.CancellationToken.None);return await(0,u.asTextOrError)(B)}async deleteResource(O,j,F){if(!this.a)throw new Error("No settings sync store url configured.");const A=j!==null?(0,S.joinPath)(this.u(this.a,F,O),j).toString():this.u(this.a,F,O).toString(),M={};await this.w(A,{type:"DELETE",headers:M},[],i.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const O=(0,S.joinPath)(this.a,"resource").toString(),j={"Content-Type":P.Mimes.text};await this.w(O,{type:"DELETE",headers:j},[],i.CancellationToken.None)}async readResource(O,j,F,A={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,S.joinPath)(this.u(this.a,F,O),"latest").toString();A={...A},A["Cache-Control"]="no-cache",j&&(A["If-None-Match"]=j.ref);const B=await this.w(M,{type:"GET",headers:A},[304],i.CancellationToken.None);let G=null;if(B.res.statusCode===304&&(G=j),G===null){const V=B.res.headers.etag;if(!V)throw new h.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",B.res.statusCode,B.res.headers[h.HEADER_OPERATION_ID]);const Q=await(0,u.asTextOrError)(B);if(!Q&&B.res.statusCode===304)throw new h.UserDataSyncStoreError("Empty response",M,"EmptyResponse",B.res.statusCode,B.res.headers[h.HEADER_OPERATION_ID]);G={ref:V,content:Q}}return G}async writeResource(O,j,F,A,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const B=this.u(this.a,A,O).toString();M={...M},M["Content-Type"]=P.Mimes.text,F&&(M["If-Match"]=F);const G=await this.w(B,{type:"POST",data:j,headers:M},[],i.CancellationToken.None),V=G.res.headers.etag;if(!V)throw new h.UserDataSyncStoreError("Server did not return the ref",B,"NoRef",G.res.statusCode,G.res.headers[h.HEADER_OPERATION_ID]);return V}async manifest(O,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,S.joinPath)(this.a,"manifest").toString();j={...j},j["Content-Type"]="application/json",O&&(j["If-None-Match"]=O.ref);const A=await this.w(F,{type:"GET",headers:j},[304],i.CancellationToken.None);let M=null;if(A.res.statusCode===304&&(M=O),!M){const G=A.res.headers.etag;if(!G)throw new h.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",A.res.statusCode,A.res.headers[h.HEADER_OPERATION_ID]);const V=await(0,u.asTextOrError)(A);if(!V&&A.res.statusCode===304)throw new h.UserDataSyncStoreError("Empty response",F,"EmptyResponse",A.res.statusCode,A.res.headers[h.HEADER_OPERATION_ID]);V&&(M={...JSON.parse(V),ref:G})}const B=this.n.get(r,-1);return B&&M&&B!==M.session&&this.v(),M===null&&B&&this.v(),M&&this.n.store(r,M.session,-1,1),M}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteResources(),await this.deleteCollection(),this.v()}u(O,j,F){return j?(0,S.joinPath)(O,"collection",j,"resource",F):(0,S.joinPath)(O,"resource",F)}v(){this.n.remove(r,-1),this.n.remove(t,-1)}async w(O,j,F,A){if(!this.b)throw new h.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new h.UserDataSyncStoreError(`${j.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const M=await this.c;j.headers={...j.headers||{},...M,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y(j.headers),this.l.trace("Sending request to server",{url:O,type:j.type,headers:{...j.headers,authorization:void 0}});let B;try{B=await this.f.request(O,j,A)}catch($){if(!($ instanceof h.UserDataSyncStoreError)){let z="RequestFailed";const Y=(0,D.getErrorMessage)($).toLowerCase();Y.includes("xhr timeout")?z="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?z="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?z="RequestPathNotEscaped":Y.includes("headers must be an object")?z="RequestHeadersNotObject":(0,D.isCancellationError)($)&&(z="RequestCanceled"),$=new h.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,z,void 0,void 0)}throw this.l.info("Request failed",O),$}const G=B.res.headers[h.HEADER_OPERATION_ID],V={url:O,status:B.res.statusCode,"execution-id":j.headers[h.HEADER_EXECUTION_ID],"operation-id":G},Q=(0,u.isSuccess)(B)||B.res.statusCode&&F.indexOf(B.res.statusCode)!==-1;if(Q?this.l.trace("Request succeeded",V):this.l.info("Request failed",V),B.res.statusCode===401)throw this.b=void 0,this.g.fire(),new h.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",B.res.statusCode,G);if(this.h.fire(),B.res.statusCode===404)throw new h.UserDataSyncStoreError(`${j.type} request '${O}' failed because the requested resource is not found (404).`,O,"NotFound",B.res.statusCode,G);if(B.res.statusCode===409)throw new h.UserDataSyncStoreError(`${j.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",B.res.statusCode,G);if(B.res.statusCode===410)throw new h.UserDataSyncStoreError(`${j.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",B.res.statusCode,G);if(B.res.statusCode===412)throw new h.UserDataSyncStoreError(`${j.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",B.res.statusCode,G);if(B.res.statusCode===413)throw new h.UserDataSyncStoreError(`${j.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",B.res.statusCode,G);if(B.res.statusCode===426)throw new h.UserDataSyncStoreError(`${j.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",B.res.statusCode,G);if(B.res.statusCode===429){const $=B.res.headers["retry-after"];throw $?(this.t(new Date(Date.now()+parseInt($)*1e3)),new h.UserDataSyncStoreError(`${j.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",B.res.statusCode,G)):new h.UserDataSyncStoreError(`${j.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",B.res.statusCode,G)}if(!Q)throw new h.UserDataSyncStoreError("Server returned "+B.res.statusCode,O,"Unknown",B.res.statusCode,G);return B}y(O){let j=this.n.get(t,-1);j===void 0&&(j=(0,v.generateUuid)(),this.n.store(t,j,-1,1)),O["X-Machine-Session-Id"]=j;const F=this.n.get(r,-1);F!==void 0&&(O["X-User-Session-Id"]=F)}};y=pe([K(1,w.IProductService),K(2,u.IRequestService),K(3,h.IUserDataSyncLogService),K(4,d.IEnvironmentService),K(5,g.IFileService),K(6,c.IStorageService)],y),e.UserDataSyncStoreClient=y;let C=class extends y{constructor(O,j,F,A,M,B,G){super(O.userDataSyncStore?.url,j,F,A,M,B,G),this.B(O.onDidChangeUserDataSyncStore(()=>this.p(O.userDataSyncStore?.url)))}};C=pe([K(0,h.IUserDataSyncStoreManagementService),K(1,w.IProductService),K(2,u.IRequestService),K(3,h.IUserDataSyncLogService),K(4,d.IEnvironmentService),K(5,g.IFileService),K(6,c.IStorageService)],C),e.UserDataSyncStoreService=C;class T{constructor(O,j,F,A){this.c=O,this.d=j,this.f=F,this.g=A,this.a=[],this.b=void 0}request(O,j,F){if(this.h()&&this.i(),j.url=O,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new h.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(O),this.f.request(j,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=T}),define(re[278],ae([0,1,3,58,25,18,24,273,26,77,80]),function(_,e,R,i,D,k,L,P,I,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends P.UserDataAutoSyncService{constructor(p,d,g,w,u,m,c,h,f,n,r){super(p,d,g,w,u,c,h,f,n,r),this.B(R.Event.debounce(R.Event.any(R.Event.map(m.onDidFocusWindow,()=>"windowFocus"),R.Event.map(m.onDidOpenWindow,()=>"windowOpen")),(t,a)=>t?[...t,a]:[a],1e3)(t=>this.triggerSync(t,!0,!1)))}};b=pe([K(0,D.IProductService),K(1,I.IUserDataSyncStoreManagementService),K(2,I.IUserDataSyncStoreService),K(3,I.IUserDataSyncEnablementService),K(4,I.IUserDataSyncService),K(5,i.INativeHostService),K(6,I.IUserDataSyncLogService),K(7,S.IUserDataSyncAccountService),K(8,L.ITelemetryService),K(9,E.IUserDataSyncMachinesService),K(10,k.IStorageService)],b),e.UserDataAutoSyncService=b}),define(re[279],ae([0,1,99,23,5,20]),function(_,e,R,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function L(S){function E(){let b=S.scheme===i.Schemas.file?(0,k.originalFSPath)(S):S.toString();return D.isLinux||(b=b.toLowerCase()),(0,R.createHash)("md5").update(b).digest("hex")}return{id:E(),configPath:S}}e.getWorkspaceIdentifier=L;function P(S,E){function b(){if(S.scheme!==i.Schemas.file)return(0,R.createHash)("md5").update(S.toString()).digest("hex");if(!E)return;let p;return D.isLinux?p=E.ino:D.isMacintosh?p=E.birthtime.getTime():D.isWindows&&(typeof E.birthtimeMs=="number"?p=Math.floor(E.birthtimeMs):p=E.birthtime.getTime()),(0,R.createHash)("md5").update(S.fsPath).update(p?String(p):"").digest("hex")}const v=b();if(typeof v=="string")return{id:v,uri:S}}e.getSingleFolderWorkspaceIdentifier=P;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(re[280],ae([0,1,6,9,2,12,28,13,57,7,58,75,116,279]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let d=class extends D.Disposable{constructor(w,u,m,c){super(),this.a=w,this.b=u,this.c=m,this.f=c,this.B(new R.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const w=await L.Promises.readdir(this.a.workspaceStorageHome.fsPath),u=new b.StorageClient(this.f.getChannel("storage"));await Promise.all(w.map(async m=>{const c=(0,k.join)(this.a.workspaceStorageHome.fsPath,m);m.length===p.NON_EMPTY_WORKSPACE_ID_LENGTH||m===v.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(n=>n.workspace?.id===m)||await u.isUsed(c)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await L.Promises.rm(c))}))}catch(w){(0,i.onUnexpectedError)(w)}}};d=pe([K(0,P.INativeEnvironmentService),K(1,S.ILogService),K(2,E.INativeHostService),K(3,I.IMainProcessService)],d),e.UnusedWorkspaceStorageDataCleaner=d}),define(re[125],ae([0,1,53,6,12,15,28,151,289,290]),function(_,e,R,i,D,k,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class E extends Error{constructor(n,r){let t=r.message;switch(n){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=n,this.cause=r}}e.ExtractError=E;function b(f){const n=f.externalFileAttributes>>16||33188;return[448,56,7].map(r=>n&r).reduce((r,t)=>r+t,n&61440)}function v(f){if(f instanceof E)return f;let n;return/end of central directory record signature not found/.test(f.message)&&(n="CorruptZip"),new E(n,f)}function p(f,n,r,t,a,s){const l=D.dirname(n),o=D.join(t,l);if(!o.startsWith(t))return Promise.reject(new Error(P.localize(0,null,n)));const y=D.join(t,n);let C;return s.onCancellationRequested(()=>{C?.destroy()}),Promise.resolve(L.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((T,W)=>{if(!s.isCancellationRequested)try{C=(0,R.createWriteStream)(y,{mode:r}),C.once("close",()=>T()),C.once("error",W),f.once("error",W),f.pipe(C)}catch(O){W(O)}}))}function d(f,n,r,t){let a=(0,i.createCancelablePromise)(()=>Promise.resolve()),s=0;return t.onCancellationRequested(()=>{a.cancel(),f.close()}),new Promise((l,o)=>{const y=new i.Sequencer,C=T=>{T.isCancellationRequested||(s++,f.readEntry())};f.once("error",o),f.once("close",()=>a.then(()=>{t.isCancellationRequested||f.entryCount===s?l():o(new E("Incomplete",new Error(P.localize(1,null,s,f.entryCount))))},o)),f.readEntry(),f.on("entry",T=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(T.fileName)){C(t);return}const W=T.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(W)){const F=D.join(n,W);a=(0,i.createCancelablePromise)(A=>L.Promises.mkdir(F,{recursive:!0}).then(()=>C(A)).then(void 0,o));return}const O=w(f,T),j=b(T);a=(0,i.createCancelablePromise)(F=>y.queue(()=>O.then(A=>p(A,W,j,n,r,F).then(()=>C(F)))).then(null,o))})})}function g(f,n=!1){return new Promise((r,t)=>{(0,I.open)(f,n?{lazyEntries:!0}:void 0,(a,s)=>{a?t(v(a)):r((0,k.assertIsDefined)(s))})})}function w(f,n){return new Promise((r,t)=>{f.openReadStream(n,(a,s)=>{a?t(v(a)):r((0,k.assertIsDefined)(s))})})}function u(f,n){return new Promise((r,t)=>{const a=new S.ZipFile;n.forEach(l=>{l.contents?a.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&a.addFile(l.localPath,l.path)}),a.end();const s=(0,R.createWriteStream)(f);a.outputStream.pipe(s),a.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(f))})}e.zip=u;function m(f,n,r={},t){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=g(f,!0);return r.overwrite&&(s=s.then(l=>L.Promises.rm(n).then(()=>l))),s.then(l=>d(l,n,{sourcePathRegex:a},t))}e.extract=m;function c(f,n){return g(f).then(r=>new Promise((t,a)=>{r.on("entry",s=>{s.fileName===n&&w(r,s).then(l=>t(l),l=>a(l))}),r.once("close",()=>a(new Error(P.localize(2,null,n))))}))}function h(f,n){return c(f,n).then(r=>new Promise((t,a)=>{const s=[];r.once("error",a),r.on("data",l=>s.push(l)),r.on("end",()=>t(Buffer.concat(s)))}))}e.buffer=h}),define(re[281],ae([0,1,125,161]),function(_,e,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(k){return(0,R.buffer)(k,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,i.localize)(0,null))}})}e.getManifest=D}),define(re[126],ae([0,1,6,17,22,38,9,3,2,37,23,12,5,20,54,15,8,30,28,125,160,96,13,263,29,33,60,78,218,264,281,219,220,46,70,14,4,7,25,24,31,21]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u,m,c,h,f,n,r,t,a,s,l,o,y,C,T,W,O,j,F,A,M,B,G,V,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,A.refineServiceDecorator)(t.IExtensionManagementService);let $=class extends r.AbstractExtensionManagementService{constructor(N,H,q,J,ne,x,te,se,le,ue,ye,Se){super(N,H,q,ue,Se),this.ab=ne,this.bb=x,this.cb=te,this.db=le,this.eb=ye,this.Y=new Map,this.mb=new S.ResourceSet;const be=this.B(se.createInstance(y.ExtensionsLifecycle));this.U=this.B(se.createInstance(z,Te=>be.postUninstall(Te))),this.W=this.B(new T.ExtensionsManifestCache(J,this)),this.X=this.B(se.createInstance(o.ExtensionsDownloader));const Ce=this.B(new W.ExtensionsWatcher(this,Se,x,ye,le,q));this.B(Ce.onDidChangeExtensionsByAnotherSource(Te=>this.lb(Te))),this.nb()}getTargetPlatform(){return this.fb||(this.fb=(0,a.computeTargetPlatform)(this.db,this.v)),this.fb}async zip(N){this.v.trace("ExtensionManagementService#zip",N.identifier.id);const H=await this.kb(N),q=await(0,c.zip)((0,p.joinPath)(this.X.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,H);return w.URI.file(q)}async unzip(N){return this.v.trace("ExtensionManagementService#unzip",N.toString()),(await this.install(N)).identifier}async getManifest(N){const{location:H,cleanup:q}=await this.gb(N),J=b.resolve(H.fsPath);try{return await(0,C.getManifest)(J)}finally{await q()}}getInstalled(N,H){return this.U.scanExtensions(N??null,H)}getAllUserInstalled(){return this.U.scanAllUserExtensions(!1)}async install(N,H={}){this.v.trace("ExtensionManagementService#install",N.toString());const{location:q,cleanup:J}=await this.gb(N);try{const ne=await(0,C.getManifest)(b.resolve(q.fsPath));if(ne.engines&&ne.engines.vscode&&!(0,j.isEngineValid)(ne.engines.vscode,this.w.version,this.w.date))throw new Error(h.localize(0,null,(0,a.getGalleryExtensionId)(ne.publisher,ne.name),this.w.version));return await this.C(ne,q,H)}finally{await J()}}getMetadata(N){return this.ab.scanMetadata(N.location)}async updateMetadata(N,H){this.v.trace("ExtensionManagementService#updateMetadata",N.identifier.id);const q={...H};return H.isPreReleaseVersion&&(q.preRelease=!0),N=await this.U.updateMetadata(N,q),this.W.invalidate(),N}async updateExtensionScope(N,H){return this.v.trace("ExtensionManagementService#updateExtensionScope",N.identifier.id),N=await this.U.updateMetadata(N,{isMachineScoped:H}),this.W.invalidate(),N}async reinstallFromGallery(N){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",N.identifier.id),!this.t.isEnabled())throw new Error(h.localize(1,null));const H=await this.getTargetPlatform(),[q]=await this.t.getExtensions([{...N.identifier,preRelease:N.preRelease}],{targetPlatform:H,compatible:!0},D.CancellationToken.None);if(!q)throw new Error(h.localize(2,null));await this.U.setUninstalled(N);try{await this.U.removeUninstalledExtension(N)}catch(J){throw new Error(h.localize(3,null,(0,k.toErrorMessage)(J)))}await this.installFromGallery(q)}markAsUninstalled(...N){return this.U.setUninstalled(...N)}removeUninstalledExtensions(){return this.U.cleanUp()}migrateDefaultProfileExtensions(){return this.U.migrateDefaultProfileExtensions()}async download(N,H){const{location:q}=await this.X.download(N,H);return q}async gb(N){if(N.scheme===E.Schemas.file)return{location:N,async cleanup(){}};this.v.trace("Downloading extension from",N.toString());const H=(0,p.joinPath)(this.X.extensionsDownloadDir,(0,u.generateUuid)());return await this.cb.download(N,H),this.v.info("Downloaded extension to",H.toString()),{location:H,cleanup:async()=>{try{await this.db.del(H)}catch(J){this.v.error(J)}}}}Q(){return this.y.defaultProfile.extensionsResource}R(N,H,q){let J;if(w.URI.isUri(H))J=new oe(N,H,q,this.t,this.U,this.v);else{const ne=a.ExtensionKey.create(H).toString();J=this.Y.get(ne),J||(this.Y.set(ne,J=new ee(N,H,q,this.X,this.U,this.v)),J.waitUntilTaskIsFinished().then(()=>this.Y.delete(ne)))}return new X(J,q.profileLocation,this.bb)}S(N,H){return new Z(N,H.profileLocation,this.bb)}async kb(N){const H=async J=>{let ne=await m.Promises.readdir(J);ne=ne.map(se=>b.join(J,se));const x=await Promise.all(ne.map(se=>m.Promises.stat(se)));let te=Promise.resolve([]);return x.forEach((se,le)=>{const ue=ne[le];se.isFile()&&(te=te.then(ye=>[...ye,ue])),se.isDirectory()&&(te=te.then(ye=>H(ue).then(Se=>[...ye,...Se])))}),te};return(await H(N.location.fsPath)).map(J=>({path:`extension/${b.relative(N.location.fsPath,J)}`,localPath:J}))}async lb({added:N,removed:H}){if(H)for(const q of H.extensions)this.v.info("Extensions removed from another source",q.id,H.profileLocation.toString()),this.p.fire({identifier:q,profileLocation:H.profileLocation});if(N){const J=(await this.U.scanExtensions(1,N.profileLocation)).filter(ne=>N.extensions.some(x=>(0,a.areSameExtensions)(x,ne.identifier)));this.m.fire(J.map(ne=>(this.v.info("Extensions added from another source",ne.identifier.id,N.profileLocation.toString()),{identifier:ne.identifier,local:ne,profileLocation:N.profileLocation,operation:1})))}}async nb(){this.B(this.U.onExtract(H=>this.mb.add(H)));const N=await this.db.resolve(this.ab.userExtensionsLocation);for(const H of N.children??[])H.isDirectory&&this.mb.add(H.resource);this.B(this.db.watch(this.ab.userExtensionsLocation)),this.B(this.db.onDidFilesChange(H=>this.ob(H)))}async ob(N){const H=[];for(const q of N.rawAdded){if(this.mb.has(q)||!this.eb.extUri.isEqual(this.eb.extUri.dirname(q),this.ab.userExtensionsLocation)||this.eb.extUri.isEqual(q,this.eb.extUri.joinPath(this.ab.userExtensionsLocation,".obsolete"))||this.eb.extUri.basename(q).startsWith(".")||!(await this.db.stat(q)).isDirectory)continue;const J=await this.U.scanUserExtensionAtLocation(q);J&&J.installedTimestamp===void 0&&(this.mb.add(q),H.push(J))}H.length&&(await this.bb.addExtensionsToProfile(H.map(q=>[q,void 0]),this.y.defaultProfile.extensionsResource),this.m.fire(H.map(q=>({local:q,version:q.manifest.version,identifier:q.identifier,operation:1,profileLocation:this.y.defaultProfile.extensionsResource}))))}};$=pe([K(0,t.IExtensionGalleryService),K(1,G.ITelemetryService),K(2,M.ILogService),K(3,n.INativeEnvironmentService),K(4,l.IExtensionsScannerService),K(5,s.IExtensionsProfileScannerService),K(6,f.IDownloadService),K(7,A.IInstantiationService),K(8,F.IFileService),K(9,B.IProductService),K(10,V.IUriIdentityService),K(11,Q.IUserDataProfilesService)],$),e.ExtensionManagementService=$;let z=class extends I.Disposable{constructor(N,H,q,J,ne,x){super(),this.j=N,this.k=H,this.l=q,this.m=J,this.n=ne,this.p=x,this.h=this.B(new P.Emitter),this.onExtract=this.h.event,this.C=void 0,this.c=(0,p.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new R.Queue}async cleanUp(){await this.y()}async scanExtensions(N,H){await this.migrateDefaultProfileExtensions();const q={includeInvalid:!0,profileLocation:H};let J=[];return N===null||N===0?J.push(...await this.l.scanAllExtensions({includeInvalid:!0},q,!1)):N===1&&J.push(...await this.l.scanUserExtensions(q)),J=N!==null?J.filter(ne=>ne.type===N):J,Promise.all(J.map(ne=>this.w(ne)))}async scanAllUserExtensions(N){const H=await this.l.scanUserExtensions({includeAllVersions:!N,includeInvalid:!0});return Promise.all(H.map(q=>this.w(q)))}async scanUserExtensionAtLocation(N){try{const H=await this.l.scanExistingExtension(N,1,{includeInvalid:!0});if(H)return await this.w(H)}catch(H){this.p.error(H)}return null}async extractUserExtension(N,H,q,J){await this.migrateDefaultProfileExtensions();const ne=N.toString(),x=b.join(this.l.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),te=b.join(this.l.userExtensionsLocation.fsPath,ne);try{await m.Promises.rm(te)}catch{throw new t.ExtensionManagementError(h.localize(4,null,te,N.id),t.ExtensionManagementErrorCode.Delete)}await this.t(N,H,x,J),await this.l.updateMetadata(w.URI.file(x),q);try{this.h.fire(w.URI.file(te)),await this.u(N,x,te,Date.now()+2*60*1e3),this.p.info("Renamed to",te)}catch(se){try{await m.Promises.rm(x)}catch{}if(se.code==="ENOTEMPTY")this.p.info("Rename failed because extension was installed by another source. So ignoring renaming.",N.id);else throw this.p.info(`Rename failed because of ${(0,L.getErrorMessage)(se)}. Deleted from extracted location`,x),se}return this.v(w.URI.file(te),1)}async updateMetadata(N,H){return await this.l.updateMetadata(N.location,H),this.v(N.location,N.type)}getUninstalledExtensions(){return this.s()}async setUninstalled(...N){const H=N.map(q=>a.ExtensionKey.create(q));await this.s(q=>H.forEach(J=>{q[J.toString()]=!0,this.p.info("Marked extension as uninstalled",J.toString())}))}async setInstalled(N){await this.s(J=>delete J[N.toString()]);const q=(await this.scanAllUserExtensions(!0)).find(J=>a.ExtensionKey.create(J).equals(N))||null;return q?this.updateMetadata(q,{installedTimestamp:Date.now()}):null}async removeExtension(N,H){this.p.trace(`Deleting ${H} extension from disk`,N.identifier.id,N.location.fsPath),await m.Promises.rm(N.location.fsPath),this.p.info("Deleted from disk",N.identifier.id,N.location.fsPath)}async removeUninstalledExtension(N){await this.removeExtension(N,"uninstalled"),await this.s(H=>delete H[a.ExtensionKey.create(N).toString()])}async s(N){return this.g.queue(async()=>{let H;try{H=await m.Promises.readFile(this.c,"utf8")}catch(J){if(J.code!=="ENOENT")throw J}let q={};if(H)try{q=JSON.parse(H)}catch{}return N&&(N(q),Object.keys(q).length?await m.Promises.writeFile(this.c,JSON.stringify(q)):await m.Promises.rm(this.c)),q})}async t(N,H,q,J){this.p.trace(`Started extracting the extension from ${H} to ${q}`);try{await m.Promises.rm(q)}catch(ne){throw new t.ExtensionManagementError(this.D(ne).message,t.ExtensionManagementErrorCode.Delete)}try{await(0,c.extract)(H,q,{sourcePath:"extension",overwrite:!0},J),this.p.info(`Extracted extension to ${q}:`,N.id)}catch(ne){try{await m.Promises.rm(q)}catch{}let x=t.ExtensionManagementErrorCode.Extract;throw ne instanceof c.ExtractError&&(ne.type==="CorruptZip"?x=t.ExtensionManagementErrorCode.CorruptZip:ne.type==="Incomplete"&&(x=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(ne.message,x)}}async u(N,H,q,J){try{await m.Promises.rename(H,q)}catch(ne){if(v.isWindows&&ne&&ne.code==="EPERM"&&Date.now()<J)return this.p.info(`Failed renaming ${H} to ${q} with 'EPERM' error. Trying again...`,N.id),this.u(N,H,q,J);throw new t.ExtensionManagementError(ne.message||h.localize(5,null,H,q),ne.code||t.ExtensionManagementErrorCode.Rename)}}async v(N,H){const q=await this.l.scanExistingExtension(N,H,{includeInvalid:!0});if(q)return this.w(q);throw new Error(h.localize(6,null,N.path))}async w(N){const H=await this.k.resolve(N.location);let q,J;return H.children&&(q=H.children.find(({name:ne})=>/^readme(\.txt|\.md|)$/i.test(ne))?.resource,J=H.children.find(({name:ne})=>/^changelog(\.txt|\.md|)$/i.test(ne))?.resource),{identifier:N.identifier,type:N.type,isBuiltin:N.isBuiltin||!!N.metadata?.isBuiltin,location:N.location,manifest:N.manifest,targetPlatform:N.targetPlatform,validations:N.validations,isValid:N.isValid,readmeUrl:q,changelogUrl:J,publisherDisplayName:N.metadata?.publisherDisplayName||null,publisherId:N.metadata?.publisherId||null,isApplicationScoped:!!N.metadata?.isApplicationScoped,isMachineScoped:!!N.metadata?.isMachineScoped,isPreReleaseVersion:!!N.metadata?.isPreReleaseVersion,preRelease:!!N.metadata?.preRelease,installedTimestamp:N.metadata?.installedTimestamp,updated:!!N.metadata?.updated}}async y(){const N=await this.getUninstalledExtensions(),H=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),q=new Set;for(const x of H)N[a.ExtensionKey.create(x).toString()]||q.add(x.identifier.id.toLowerCase());const J=(0,a.groupByExtension)(H,x=>x.identifier);await R.Promises.settled(J.map(async x=>{const te=x.sort((se,le)=>d.rcompare(se.manifest.version,le.manifest.version))[0];q.has(te.identifier.id.toLowerCase())||await this.j(await this.w(te))}));const ne=H.filter(x=>N[a.ExtensionKey.create(x).toString()]);await R.Promises.settled(ne.map(x=>this.removeUninstalledExtension(x)))}migrateDefaultProfileExtensions(){return this.C||(this.C=(async()=>{try{const N=(0,p.joinPath)(this.m.defaultProfile.location,".migrated-default-profile");if(await this.k.exists(N))return;if(!await this.k.exists(this.m.defaultProfile.extensionsResource)){this.p.info("Started migrating default profile extensions from extensions installation folder to extensions manifest.");const H=await this.l.scanUserExtensions({includeInvalid:!0});await this.n.addExtensionsToProfile(H.map(q=>[q,q.metadata]),this.m.defaultProfile.extensionsResource),this.p.info("Completed migrating default profile extensions from extensions installation folder to extensions manifest.")}try{await this.k.createFile(N,i.VSBuffer.fromString(""))}catch(H){this.p.warn("Failed to create migration marker file for default profile extensions migration.",(0,L.getErrorMessage)(H))}}catch(N){throw this.p.error(N),N}})()),this.C}D(N){const H=Array.isArray(N)?N:[N];return H.length===1?H[0]instanceof Error?H[0]:new Error(H[0]):H.reduce((q,J)=>new Error(`${q.message}${q.message?",":""}${J instanceof Error?J.message:J}`),new Error(""))}};z=pe([K(1,F.IFileService),K(2,l.IExtensionsScannerService),K(3,Q.IUserDataProfilesService),K(4,s.IExtensionsProfileScannerService),K(5,M.ILogService)],z),e.ExtensionsScanner=z;class Y extends r.AbstractExtensionTask{get operation(){return(0,g.isUndefined)(this.k.operation)?this.j:this.k.operation}constructor(N,H,q,J,ne){super(),this.identifier=N,this.source=H,this.k=q,this.l=J,this.m=ne,this.wasVerified=!1,this.j=2}async n(N,H){try{const q=await this.o(N.key);if(q)return this.l.updateMetadata(q,N.metadata)}catch{throw v.isMacintosh?new t.ExtensionManagementError(h.localize(7,null),t.ExtensionManagementErrorCode.Internal):new t.ExtensionManagementError(h.localize(8,null),t.ExtensionManagementErrorCode.Internal)}return this.q(N,H)}async o(N){if(!await this.p(N))return null;this.m.trace("Removing the extension from uninstalled list:",N.id);const q=await this.l.setInstalled(N);return this.m.info("Removed the extension from uninstalled list:",N.id),q}async p(N){return!!(await this.l.getUninstalledExtensions())[N.toString()]}async q({zipPath:N,key:H,metadata:q},J){const ne=await this.l.extractUserExtension(H,N,q,J);return this.m.info("Extracting completed.",H.id),ne}}class ee extends Y{constructor(N,H,q,J,ne,x){super(H.identifier,H,q,ne,x),this.s=N,this.t=H,this.u=J}async h(N){const q=(await this.l.scanExtensions(null,void 0)).find(te=>(0,a.areSameExtensions)(te.identifier,this.t.identifier));q&&(this.j=3);const J={id:this.t.identifier.uuid,publisherId:this.t.publisherId,publisherDisplayName:this.t.publisherDisplayName,targetPlatform:this.t.properties.targetPlatform,isApplicationScoped:(0,O.isApplicationScopedExtension)(this.s),isMachineScoped:this.k.isMachineScoped||q?.isMachineScoped,isBuiltin:this.k.isBuiltin||q?.isBuiltin,isSystem:q?.type===0?!0:void 0,updated:!!q,isPreReleaseVersion:this.t.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.t.properties.isPreReleaseVersion||((0,g.isBoolean)(this.k.installPreReleaseVersion)?this.k.installPreReleaseVersion:q?.preRelease)};if(q?.manifest.version===this.t.version)return{local:await this.l.updateMetadata(q,J),metadata:J};const{location:ne,verified:x}=await this.u.download(this.t,this.j);try{return this.wasVerified=!!x,this.w(ne.fsPath),{local:await this.n({zipPath:ne.fsPath,key:a.ExtensionKey.create(this.t),metadata:J},N),metadata:J}}catch(te){try{await this.u.delete(ne)}catch(se){this.m.warn("Error while deleting the downloaded file",ne.toString(),(0,L.getErrorMessage)(se))}throw te}}async w(N){try{await(0,C.getManifest)(N)}catch(H){throw new t.ExtensionManagementError((0,r.joinErrors)(H).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=ee;class oe extends Y{constructor(N,H,q,J,ne,x){super({id:(0,a.getGalleryExtensionId)(N.publisher,N.name)},H,q,ne,x),this.s=N,this.t=H,this.u=J}async h(N){const H=new a.ExtensionKey(this.identifier,this.s.version),J=(await this.l.scanExtensions(1,void 0)).find(te=>(0,a.areSameExtensions)(this.identifier,te.identifier)),ne=await this.w(this.identifier.id,this.s.version,N);if(ne.isApplicationScoped=(0,O.isApplicationScopedExtension)(this.s),ne.isMachineScoped=this.k.isMachineScoped||J?.isMachineScoped,ne.isBuiltin=this.k.isBuiltin||J?.isBuiltin,ne.installedTimestamp=Date.now(),J)if(this.j=3,H.equals(new a.ExtensionKey(J.identifier,J.manifest.version)))try{await this.l.removeExtension(J,"existing")}catch{throw new Error(h.localize(9,null,this.s.displayName||this.s.name))}else!this.k.profileLocation&&d.gt(J.manifest.version,this.s.version)&&await this.l.setUninstalled(J);else{const te=await this.o(H);if(te)try{await this.l.removeExtension(te,"existing")}catch{throw new Error(h.localize(10,null,this.s.displayName||this.s.name))}}return{local:await this.n({zipPath:b.resolve(this.t.fsPath),key:H,metadata:ne},N),metadata:ne}}async w(N,H,q){try{let[J]=await this.u.getExtensions([{id:N,version:H}],q);if(J||([J]=await this.u.getExtensions([{id:N}],q)),J)return{id:J.identifier.uuid,publisherDisplayName:J.publisherDisplayName,publisherId:J.publisherId,isPreReleaseVersion:J.properties.isPreReleaseVersion,preRelease:J.properties.isPreReleaseVersion||this.k.installPreReleaseVersion}}catch{}return{}}}class X{constructor(N,H,q){this.d=N,this.g=H,this.h=q,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.j()}async j(){const N=await this.d.waitUntilTaskIsFinished();return await this.h.addExtensionsToProfile([[N.local,N.metadata]],this.g),N}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class Z extends r.AbstractExtensionTask{constructor(N,H,q){super(),this.extension=N,this.j=H,this.k=q}async h(N){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(re[282],ae([0,1,2,29,79,217,126,7,18]),function(_,e,R,i,D,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let S=class extends R.Disposable{constructor(b,v,p,d,g,w){super(),b.migrateDefaultProfileExtensions().then(()=>g.store(i.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY,!0,-1,1),u=>null),b.removeUninstalledExtensions(),(0,k.migrateUnsupportedExtensions)(b,v,p,d,w),D.ExtensionStorageService.removeOutdatedExtensionVersions(b,g)}};S=pe([K(0,L.INativeServerExtensionManagementService),K(1,i.IExtensionGalleryService),K(2,D.IExtensionStorageService),K(3,i.IGlobalExtensionEnablementService),K(4,I.IStorageService),K(5,P.ILogService)],S),e.ExtensionsContributions=S}),define(re[291],ae([0,1,93,34,38,9,2,23,20,8,39,149,210,211,203,204,280,192,195,16,215,95,235,96,226,13,232,117,266,29,97,194,267,126,98,190,14,206,208,55,4,201,72,202,57,73,221,7,102,58,103,25,47,18,268,109,24,110,111,112,51,240,113,242,248,79,115,26,77,271,259,260,80,272,275,276,277,278,270,62,261,108,234,76,250,223,249,107,231,31,251,5,252,196,213,212,78,265,21,60,209,59,269,229,239,262,236,106,101,274,282]),function(_,e,R,i,D,k,L,P,I,S,E,b,v,p,d,g,w,u,m,c,h,f,n,r,t,a,s,l,o,y,C,T,W,O,j,F,A,M,B,G,V,Q,$,z,Y,ee,oe,X,Z,U,N,H,q,J,ne,x,te,se,le,ue,ye,Se,be,Ce,Te,Fe,Ye,Be,ce,de,ge,Ee,Pe,Ae,De,je,Oe,Ue,ze,ke,Ne,ie,he,fe,me,we,Ie,Re,He,$e,Le,qe,Ge,et,at,wt,At,Lt,vt,St,Tt,bt,Ot,Nt,Mt,Ut,Ft,Et,Ct,jt,$t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Bt extends L.Disposable{constructor(ve){super(),this.f=ve,this.a=this.B(new b.Server),this.b=void 0,this.c=void 0,this.g()}g(){const ve=async()=>{this.c&&(await this.c.fireOnWillShutdown(),this.c.dispose(),this.c=void 0),this.dispose()};process.once("exit",ve),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Me="vscode:electron-main->shared-process=disposeWorker",We=(Je,tt)=>{this.h(tt)};R.ipcRenderer.on(Me,We),this.B((0,L.toDisposable)(()=>R.ipcRenderer.removeListener(Me,We)))}h(ve){this.b?.disposeWorker(ve)}async open(){const ve=await this.i();(0,Be.registerConfiguration)(),ve.invokeFunction(Me=>{const We=Me.get(X.ILogService);We.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Me),this.k(We)}),this.B((0,L.combinedDisposable)(ve.createInstance(v.CodeCacheCleaner,this.f.codeCachePath),ve.createInstance(p.LanguagePackCachedDataCleaner),ve.createInstance(w.UnusedWorkspaceStorageDataCleaner),ve.createInstance(g.LogsDataCleaner),ve.createInstance(d.LocalizationsUpdater),ve.createInstance($t.ExtensionsContributions),ve.createInstance(Ut.UserDataProfilesCleaner)))}async i(){const ve=new $.ServiceCollection,Me={_serviceBrand:void 0,...N.default};ve.set(H.IProductService,Me);const We=new E.StaticRouter(Qe=>Qe==="main"),Je=new z.MessagePortMainProcessService(this.a,We);ve.set(Y.IMainProcessService,Je);const tt=this.f.policiesData?new Tt.PolicyChannelClient(this.f.policiesData,Je.getChannel("policy")):new bt.NullPolicyService;ve.set(bt.IPolicyService,tt);const Ke=new s.SharedProcessEnvironmentService(this.f.args,Me);ve.set(a.INativeEnvironmentService,Ke);const lt=new Z.LogLevelChannelClient(this.a.getChannel("logLevel",We)),it=new Z.LoggerChannelClient(this.f.logLevel,lt.onDidChangeLogLevel,Je.getChannel("logger"));ve.set(X.ILoggerService,it);const ht=this.B(new X.MultiplexLogService([this.B(new X.ConsoleLogger(this.f.logLevel)),this.B(it.createLogger((0,I.joinPath)(S.URI.file(Ke.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Xe=this.B(new Z.FollowerLogService(lt,ht));ve.set(X.ILogService,Xe),this.c=new Ct.SharedProcessLifecycleService(Xe),ve.set(Ct.ISharedProcessLifecycleService,this.c),this.b=new He.SharedProcessWorkerService(Xe),ve.set(Re.ISharedProcessWorkerService,this.b);const _e=this.B(new M.FileService(Xe));ve.set(A.IFileService,_e);const ft=this.B(new B.DiskFileSystemProvider(Xe));_e.registerProvider(P.Schemas.file,ft);const dt=this.B(new Ge.FileUserDataProvider(P.Schemas.file,this.B(new et.DiskFileSystemProviderClient(Je.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:qe.isLinux})),P.Schemas.vscodeUserData,Xe));_e.registerProvider(P.Schemas.vscodeUserData,dt);const nt=this.B(new Ot.UserDataProfilesNativeService(this.f.profiles,Je,Ke));ve.set(vt.IUserDataProfilesService,nt);const xe=this.B(new h.ConfigurationService(nt.defaultProfile.settingsResource,_e,tt,Xe));ve.set(c.IConfigurationService,xe);const ot=new ne.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},Je,Ke);ve.set(J.IStorageService,ot),this.B((0,L.toDisposable)(()=>ot.flush())),await Promise.all([xe.initialize(),ot.initialize()]),ve.set($e.IUriIdentityService,new Le.UriIdentityService(_e)),ve.set(q.IRequestService,new Nt.SharedProcessRequestService(Je,xe,Xe)),ve.set(u.IChecksumService,new G.SyncDescriptor(m.ChecksumService,void 0,!1)),ve.set(wt.IV8InspectProfilingService,new G.SyncDescriptor(at.InspectProfilingService,void 0,!1));const ut=E.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.f.windowId});ve.set(U.INativeHostService,ut),ve.set(r.IDownloadService,new G.SyncDescriptor(t.DownloadService,void 0,!0));const gt=this.B(new Ne.ActiveWindowManager(ut)),mt=new E.StaticRouter(Qe=>gt.getActiveClientId().then(pt=>Qe===pt));ve.set(j.IExtensionRecommendationNotificationService,new F.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",mt)));let st;const ct=[],Pt=(0,ye.isInternalTelemetry)(Me,xe);if((0,ye.supportsTelemetry)(Me,Ke)){const Qe=new le.TelemetryLogAppender(it,Ke);ct.push(Qe);const{installSourcePath:pt}=Ke;if(Me.aiConfig?.ariaKey){const Dt=new Mt.OneDataSystemAppender(Pt,"monacoworkbench",null,Me.aiConfig.ariaKey);this.B((0,L.toDisposable)(()=>Dt.flush())),ct.push(Dt)}st=new ue.TelemetryService({appenders:ct,commonProperties:(0,x.resolveCommonProperties)(_e,(0,i.release)(),(0,i.hostname)(),process.arch,Me.commit,Me.version,this.f.machineId,Pt,pt),sendErrorTelemetry:!0,piiPaths:(0,ye.getPiiPathsFromEnvironment)(Ke)},xe,Me)}else{st=ye.NullTelemetryService;const Qe=ye.NullAppender;ct.push(Qe)}this.a.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(ct)),ve.set(te.ITelemetryService,st);const qt=new Se.CustomEndpointTelemetryService(xe,st,it,Ke,Me);ve.set(te.ICustomEndpointTelemetryService,qt),ve.set(St.IExtensionsProfileScannerService,new G.SyncDescriptor(St.ExtensionsProfileScannerService,void 0,!0)),ve.set(At.IExtensionsScannerService,new G.SyncDescriptor(Lt.ExtensionsScannerService,void 0,!0)),ve.set(C.IExtensionSignatureVerificationService,new G.SyncDescriptor(C.ExtensionSignatureVerificationService,void 0,!0)),ve.set(O.INativeServerExtensionManagementService,new G.SyncDescriptor(O.ExtensionManagementService,void 0,!0)),ve.set(y.IExtensionGalleryService,new G.SyncDescriptor(o.ExtensionGalleryService,void 0,!0)),ve.set(y.IExtensionTipsService,new G.SyncDescriptor(W.ExtensionTipsService,void 0,!1)),ve.set(ee.ILanguagePackService,new G.SyncDescriptor(oe.NativeLanguagePackService,void 0,!1)),ve.set(f.IDiagnosticsService,new G.SyncDescriptor(n.DiagnosticsService,void 0,!1)),ve.set(ce.IUserDataSyncAccountService,new G.SyncDescriptor(ce.UserDataSyncAccountService,void 0,!0)),ve.set(Be.IUserDataSyncLogService,new G.SyncDescriptor(Ee.UserDataSyncLogService,void 0,!0)),ve.set(Be.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),ve.set(y.IGlobalExtensionEnablementService,new G.SyncDescriptor(l.GlobalExtensionEnablementService,void 0,!1)),ve.set(Ye.IIgnoredExtensionsManagementService,new G.SyncDescriptor(Ye.IgnoredExtensionsManagementService,void 0,!0)),ve.set(Fe.IExtensionStorageService,new G.SyncDescriptor(Fe.ExtensionStorageService)),ve.set(Be.IUserDataSyncStoreManagementService,new G.SyncDescriptor(Oe.UserDataSyncStoreManagementService,void 0,!0)),ve.set(Be.IUserDataSyncStoreService,new G.SyncDescriptor(Oe.UserDataSyncStoreService,void 0,!0)),ve.set(Pe.IUserDataSyncMachinesService,new G.SyncDescriptor(Pe.UserDataSyncMachinesService,void 0,!0)),ve.set(Be.IUserDataSyncBackupStoreService,new G.SyncDescriptor(de.UserDataSyncBackupStoreService,void 0,!1)),ve.set(Be.IUserDataSyncEnablementService,new G.SyncDescriptor(Ae.UserDataSyncEnablementService,void 0,!0)),ve.set(Be.IUserDataSyncService,new G.SyncDescriptor(De.UserDataSyncService,void 0,!1)),ve.set(ke.IUserDataProfileStorageService,new G.SyncDescriptor(ze.UserDataProfileStorageService,void 0,!0)),ve.set(Be.IUserDataSyncResourceProviderService,new G.SyncDescriptor(jt.UserDataSyncResourceProviderService,void 0,!0));const Rt=new Te.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:xe.getValue("terminal.integrated.persistentSessionScrollback")??100},xe,Ke,Xe);return Rt.initialize(),ve.set(Ce.ILocalPtyService,this.B(Rt)),ve.set(ie.ISignService,new G.SyncDescriptor(he.SignService,void 0,!1)),ve.set(fe.ISharedTunnelsService,new G.SyncDescriptor(me.SharedTunnelsService)),ve.set(we.ISharedProcessTunnelService,new G.SyncDescriptor(Ie.SharedProcessTunnelService)),ve.set(Et.IRemoteTunnelService,new G.SyncDescriptor(Ft.RemoteTunnelService)),new Q.InstantiationService(ve)}j(ve){const Me=new Z.LogLevelChannel(ve.get(X.ILogService),ve.get(X.ILoggerService));this.a.registerChannel("logLevel",Me);const We=new T.ExtensionManagementChannel(ve.get(y.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",We);const Je=E.ProxyChannel.fromService(ve.get(ee.ILanguagePackService));this.a.registerChannel("languagePacks",Je);const tt=E.ProxyChannel.fromService(ve.get(f.IDiagnosticsService));this.a.registerChannel("diagnostics",tt);const Ke=new T.ExtensionTipsChannel(ve.get(y.IExtensionTipsService));this.a.registerChannel("extensionTipsService",Ke);const lt=E.ProxyChannel.fromService(ve.get(u.IChecksumService));this.a.registerChannel("checksum",lt);const it=E.ProxyChannel.fromService(ve.get(wt.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",it);const ht=new ge.UserDataSyncMachinesServiceChannel(ve.get(Pe.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ht);const Xe=E.ProxyChannel.fromService(ve.get(te.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",Xe);const _e=new ge.UserDataSyncAccountServiceChannel(ve.get(ce.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",_e);const ft=new ge.UserDataSyncStoreManagementServiceChannel(ve.get(Be.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",ft);const dt=new je.UserDataSyncChannel(ve.get(Be.IUserDataSyncService),ve.get(vt.IUserDataProfilesService),ve.get(X.ILogService));this.a.registerChannel("userDataSync",dt);const nt=this.B(ve.get(V.IInstantiationService).createInstance(Ue.UserDataAutoSyncService)),xe=new ge.UserDataAutoSyncChannel(nt);this.a.registerChannel("userDataAutoSync",xe);const ot=ve.get(Ce.ILocalPtyService),ut=E.ProxyChannel.fromService(ot);this.a.registerChannel(be.TerminalIpcChannels.LocalPty,ut);const gt=E.ProxyChannel.fromService(ve.get(we.ISharedProcessTunnelService));this.a.registerChannel(we.ipcSharedProcessTunnelChannelName,gt);const mt=E.ProxyChannel.fromService(ve.get(Re.ISharedProcessWorkerService));this.a.registerChannel(Re.ipcSharedProcessWorkerChannelName,mt);const st=E.ProxyChannel.fromService(ve.get(Et.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",st)}k(ve){window.addEventListener("unhandledrejection",Me=>{(0,k.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,k.setUnexpectedErrorHandler)(Me=>{const We=(0,D.toErrorMessage)(Me,!0);!We||ve.error(`[uncaught exception in sharedProcess]: ${We}`)})}}async function zt(It){const ve=new Bt(It);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=zt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d9a70c4236a8bde4fe7435df3ecdd333c7bc939c/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
