/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/network","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","os","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","vs/platform/state/electron-main/state","vs/base/common/map","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/functional","vs/base/common/objects","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],te=function(q){for(var e=[],E=0,t=q.length;E<t;E++)e[E]=ee[q[E]];return e};define(ee[119],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function E(A){return A?A.replace(/\$\((.*?)\)/g,(M,k)=>` ${k} `).trim():""}e.getCodiconAriaLabel=E;class t{constructor(M,k,w){this.id=M,this.definition=k,this.description=w,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var C;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const M=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function k(S){if(S instanceof t)return["codicon","codicon-"+S.id];const P=M.exec(S.id);if(!P)return k(t.error);const[,I,h]=P,m=["codicon","codicon-"+I];return h&&m.push("codicon-modifier-"+h.substring(1)),m}A.asClassNameArray=k;function w(S){return k(S).join(" ")}A.asClassName=w;function v(S){return"."+k(S).join(".")}A.asCSSSelector=v})(C=e.CSSIcon||(e.CSSIcon={}))}),define(ee[120],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(k,w){const v=Math.pow(10,w);return Math.round(k*v)/v}class t{constructor(w,v,S,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,w))|0,this.g=Math.min(255,Math.max(0,v))|0,this.b=Math.min(255,Math.max(0,S))|0,this.a=E(Math.max(Math.min(1,P),0),3)}static equals(w,v){return w.r===v.r&&w.g===v.g&&w.b===v.b&&w.a===v.a}}e.RGBA=t;class C{constructor(w,v,S,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,w),0)|0,this.s=E(Math.max(Math.min(1,v),0),3),this.l=E(Math.max(Math.min(1,S),0),3),this.a=E(Math.max(Math.min(1,P),0),3)}static equals(w,v){return w.h===v.h&&w.s===v.s&&w.l===v.l&&w.a===v.a}static fromRGBA(w){const v=w.r/255,S=w.g/255,P=w.b/255,I=w.a,h=Math.max(v,S,P),m=Math.min(v,S,P);let f=0,p=0;const u=(m+h)/2,b=h-m;if(b>0){switch(p=Math.min(u<=.5?b/(2*u):b/(2-2*u),1),h){case v:f=(S-P)/b+(S<P?6:0);break;case S:f=(P-v)/b+2;break;case P:f=(v-S)/b+4;break}f*=60,f=Math.round(f)}return new C(f,p,u,I)}static i(w,v,S){return S<0&&(S+=1),S>1&&(S-=1),S<1/6?w+(v-w)*6*S:S<1/2?v:S<2/3?w+(v-w)*(2/3-S)*6:w}static toRGBA(w){const v=w.h/360,{s:S,l:P,a:I}=w;let h,m,f;if(S===0)h=m=f=P;else{const p=P<.5?P*(1+S):P+S-P*S,u=2*P-p;h=C.i(u,p,v+1/3),m=C.i(u,p,v),f=C.i(u,p,v-1/3)}return new t(Math.round(h*255),Math.round(m*255),Math.round(f*255),I)}}e.HSLA=C;class A{constructor(w,v,S,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,w),0)|0,this.s=E(Math.max(Math.min(1,v),0),3),this.v=E(Math.max(Math.min(1,S),0),3),this.a=E(Math.max(Math.min(1,P),0),3)}static equals(w,v){return w.h===v.h&&w.s===v.s&&w.v===v.v&&w.a===v.a}static fromRGBA(w){const v=w.r/255,S=w.g/255,P=w.b/255,I=Math.max(v,S,P),h=Math.min(v,S,P),m=I-h,f=I===0?0:m/I;let p;return m===0?p=0:I===v?p=((S-P)/m%6+6)%6:I===S?p=(P-v)/m+2:p=(v-S)/m+4,new A(Math.round(p*60),f,I,w.a)}static toRGBA(w){const{h:v,s:S,v:P,a:I}=w,h=P*S,m=h*(1-Math.abs(v/60%2-1)),f=P-h;let[p,u,b]=[0,0,0];return v<60?(p=h,u=m):v<120?(p=m,u=h):v<180?(u=h,b=m):v<240?(u=m,b=h):v<300?(p=m,b=h):v<=360&&(p=h,b=m),p=Math.round((p+f)*255),u=Math.round((u+f)*255),b=Math.round((b+f)*255),new t(p,u,b,I)}}e.HSVA=A;class M{static fromHex(w){return M.Format.CSS.parseHex(w)||M.red}static equals(w,v){return!w&&!v?!0:!w||!v?!1:w.equals(v)}get hsla(){return this.i?this.i:C.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:A.fromRGBA(this.rgba)}constructor(w){if(w)if(w instanceof t)this.rgba=w;else if(w instanceof C)this.i=w,this.rgba=C.toRGBA(w);else if(w instanceof A)this.j=w,this.rgba=A.toRGBA(w);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(w){return!!w&&t.equals(this.rgba,w.rgba)&&C.equals(this.hsla,w.hsla)&&A.equals(this.hsva,w.hsva)}getRelativeLuminance(){const w=M.k(this.rgba.r),v=M.k(this.rgba.g),S=M.k(this.rgba.b),P=.2126*w+.7152*v+.0722*S;return E(P,4)}static k(w){const v=w/255;return v<=.03928?v/12.92:Math.pow((v+.055)/1.055,2.4)}getContrastRatio(w){const v=this.getRelativeLuminance(),S=w.getRelativeLuminance();return v>S?(v+.05)/(S+.05):(S+.05)/(v+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(w){const v=this.getRelativeLuminance(),S=w.getRelativeLuminance();return v>S}isDarkerThan(w){const v=this.getRelativeLuminance(),S=w.getRelativeLuminance();return v<S}lighten(w){return new M(new C(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*w,this.hsla.a))}darken(w){return new M(new C(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*w,this.hsla.a))}transparent(w){const{r:v,g:S,b:P,a:I}=this.rgba;return new M(new t(v,S,P,I*w))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(w){const v=w.rgba,S=this.rgba.a,P=v.a,I=S+P*(1-S);if(I<1e-6)return M.transparent;const h=this.rgba.r*S/I+v.r*P*(1-S)/I,m=this.rgba.g*S/I+v.g*P*(1-S)/I,f=this.rgba.b*S/I+v.b*P*(1-S)/I;return new M(new t(h,m,f,I))}makeOpaque(w){if(this.isOpaque()||w.rgba.a!==1)return this;const{r:v,g:S,b:P,a:I}=this.rgba;return new M(new t(w.rgba.r-I*(w.rgba.r-v),w.rgba.g-I*(w.rgba.g-S),w.rgba.b-I*(w.rgba.b-P),1))}flatten(...w){const v=w.reduceRight((S,P)=>M.o(P,S));return M.o(this,v)}static o(w,v){const S=1-w.rgba.a;return new M(new t(S*v.rgba.r+w.rgba.a*w.rgba.r,S*v.rgba.g+w.rgba.a*w.rgba.g,S*v.rgba.b+w.rgba.a*w.rgba.b))}toString(){return this.u||(this.u=M.Format.CSS.format(this)),this.u}static getLighterColor(w,v,S){if(w.isLighterThan(v))return w;S=S||.5;const P=w.getRelativeLuminance(),I=v.getRelativeLuminance();return S=S*(I-P)/I,w.lighten(S)}static getDarkerColor(w,v,S){if(w.isDarkerThan(v))return w;S=S||.5;const P=w.getRelativeLuminance(),I=v.getRelativeLuminance();return S=S*(P-I)/P,w.darken(S)}}e.Color=M,M.white=new M(new t(255,255,255,1)),M.black=new M(new t(0,0,0,1)),M.red=new M(new t(255,0,0,1)),M.blue=new M(new t(0,0,255,1)),M.green=new M(new t(0,255,0,1)),M.cyan=new M(new t(0,255,255,1)),M.lightgrey=new M(new t(211,211,211,1)),M.transparent=new M(new t(0,0,0,0)),function(k){let w;(function(v){let S;(function(P){function I(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:k.Format.CSS.formatRGBA(n)}P.formatRGB=I;function h(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}P.formatRGBA=h;function m(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(n)}P.formatHSL=m;function f(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}P.formatHSLA=f;function p(n){const s=n.toString(16);return s.length!==2?"0"+s:s}function u(n){return`#${p(n.rgba.r)}${p(n.rgba.g)}${p(n.rgba.b)}`}P.formatHex=u;function b(n,s=!1){return s&&n.rgba.a===1?k.Format.CSS.formatHex(n):`#${p(n.rgba.r)}${p(n.rgba.g)}${p(n.rgba.b)}${p(Math.round(n.rgba.a*255))}`}P.formatHexA=b;function g(n){return n.isOpaque()?k.Format.CSS.formatHex(n):k.Format.CSS.formatRGBA(n)}P.format=g;function d(n){const s=n.length;if(s===0||n.charCodeAt(0)!==35)return null;if(s===7){const i=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),a=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),r=16*l(n.charCodeAt(5))+l(n.charCodeAt(6));return new k(new t(i,a,r,1))}if(s===9){const i=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),a=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),r=16*l(n.charCodeAt(5))+l(n.charCodeAt(6)),c=16*l(n.charCodeAt(7))+l(n.charCodeAt(8));return new k(new t(i,a,r,c/255))}if(s===4){const i=l(n.charCodeAt(1)),a=l(n.charCodeAt(2)),r=l(n.charCodeAt(3));return new k(new t(16*i+i,16*a+a,16*r+r))}if(s===5){const i=l(n.charCodeAt(1)),a=l(n.charCodeAt(2)),r=l(n.charCodeAt(3)),c=l(n.charCodeAt(4));return new k(new t(16*i+i,16*a+a,16*r+r,(16*c+c)/255))}return null}P.parseHex=d;function l(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(S=v.CSS||(v.CSS={}))})(w=k.Format||(k.Format={}))}(M=e.Color||(e.Color={}))}),define(ee[53],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(M){return(k,w,v)=>{let S=null,P=null;if(typeof v.value=="function"?(S="value",P=v.value):typeof v.get=="function"&&(S="get",P=v.get),!P)throw new Error("not supported");v[S]=M(P,w)}}function t(M,k,w){let v=null,S=null;if(typeof w.value=="function"?(v="value",S=w.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(v="get",S=w.get),!S)throw new Error("not supported");const P=`$memoize$${k}`;w[v]=function(...I){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,I)}),this[P]}}e.memoize=t;function C(M,k,w){return E((v,S)=>{const P=`$debounce$${S}`,I=`$debounce$result$${S}`;return function(...h){this[I]||(this[I]=w?w():void 0),clearTimeout(this[P]),k&&(this[I]=k(this[I],...h),h=[this[I]]),this[P]=setTimeout(()=>{v.apply(this,h),this[I]=w?w():void 0},M)}})}e.debounce=C;function A(M,k,w){return E((v,S)=>{const P=`$throttle$timer$${S}`,I=`$throttle$result$${S}`,h=`$throttle$lastRun$${S}`,m=`$throttle$pending$${S}`;return function(...f){if(this[I]||(this[I]=w?w():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),k&&(this[I]=k(this[I],...f)),this[m])return;const p=this[h]+M;p<=Date.now()?(this[h]=Date.now(),v.apply(this,[this[I]]),this[I]=w?w():void 0):(this[m]=!0,this[P]=setTimeout(()=>{this[m]=!1,this[h]=Date.now(),v.apply(this,[this[I]]),this[I]=w?w():void 0},p-Date.now()))}})}e.throttle=A}),define(ee[15],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?g.isErrorNoTelemetry(n)?new g(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.ErrorHandler=E,e.errorHandler=new E;function t(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=t;function C(l){w(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=C;function A(l){w(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=A;function M(l){if(l instanceof Error){const{name:n,message:s}=l,i=l.stacktrace||l.stack;return{$isError:!0,name:n,message:s,stack:i,noTelemetry:g.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=M;const k="Canceled";function w(l){return l instanceof v?!0:l instanceof Error&&l.name===k&&l.message===k}e.isCancellationError=w;class v extends Error{constructor(){super(k),this.name=this.message}}e.CancellationError=v;function S(){const l=new Error(k);return l.name=l.message,l}e.canceled=S;function P(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=P;function I(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=I;function h(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function m(l){const n=new Error(`${l} has been disposed`);return n.name="DISPOSED",n}e.disposed=m;function f(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=f;class p extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=p;class u extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=u;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class g extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof g)return n;const s=new g;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=g;class d extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype);debugger}}e.BugIndicatingError=d}),define(ee[24],te([0,1,15]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(j,x=0){return j[j.length-(1+x)]}e.tail=t;function C(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=C;function A(j,x,_=(ae,ge)=>ae===ge){if(j===x)return!0;if(!j||!x||j.length!==x.length)return!1;for(let ae=0,ge=j.length;ae<ge;ae++)if(!_(j[ae],x[ae]))return!1;return!0}e.equals=A;function M(j,x){const _=j.length-1;x<_&&(j[x]=j[_]),j.pop()}e.removeFastWithoutKeepingOrder=M;function k(j,x,_){return w(j.length,ae=>_(j[ae],x))}e.binarySearch=k;function w(j,x){let _=0,ae=j-1;for(;_<=ae;){const ge=(_+ae)/2|0,Me=x(ge);if(Me<0)_=ge+1;else if(Me>0)ae=ge-1;else return ge}return-(_+1)}e.binarySearch2=w;function v(j,x){let _=0,ae=j.length;if(ae===0)return 0;for(;_<ae;){const ge=Math.floor((_+ae)/2);x(j[ge])?ae=ge:_=ge+1}return _}e.findFirstInSorted=v;function S(j,x,_){if(j=j|0,j>=x.length)throw new TypeError("invalid index");const ae=x[Math.floor(x.length*Math.random())],ge=[],Me=[],Oe=[];for(const De of x){const Re=_(De,ae);Re<0?ge.push(De):Re>0?Me.push(De):Oe.push(De)}return j<ge.length?S(j,ge,_):j<ge.length+Oe.length?Oe[0]:S(j-(ge.length+Oe.length),Me,_)}e.quickSelect=S;function P(j,x){const _=[];let ae;for(const ge of j.slice(0).sort(x))!ae||x(ae[0],ge)!==0?(ae=[ge],_.push(ae)):ae.push(ge);return _}e.groupBy=P;function I(j,x,_){const ae=[];function ge(De,Re,ve){if(Re===0&&ve.length===0)return;const we=ae[ae.length-1];we&&we.start+we.deleteCount===De?(we.deleteCount+=Re,we.toInsert.push(...ve)):ae.push({start:De,deleteCount:Re,toInsert:ve})}let Me=0,Oe=0;for(;;){if(Me===j.length){ge(Me,0,x.slice(Oe));break}if(Oe===x.length){ge(Me,j.length-Me,[]);break}const De=j[Me],Re=x[Oe],ve=_(De,Re);ve===0?(Me+=1,Oe+=1):ve<0?(ge(Me,1,[]),Me+=1):ve>0&&(ge(Me,0,[Re]),Oe+=1)}return ae}e.sortedDiff=I;function h(j,x,_){const ae=I(j,x,_),ge=[],Me=[];for(const Oe of ae)ge.push(...j.slice(Oe.start,Oe.start+Oe.deleteCount)),Me.push(...Oe.toInsert);return{removed:ge,added:Me}}e.delta=h;function m(j,x,_){if(_===0)return[];const ae=j.slice(0,_).sort(x);return p(j,x,ae,_,j.length),ae}e.top=m;function f(j,x,_,ae,ge){return _===0?Promise.resolve([]):new Promise((Me,Oe)=>{(async()=>{const De=j.length,Re=j.slice(0,_).sort(x);for(let ve=_,we=Math.min(_+ae,De);ve<De;ve=we,we=Math.min(we+ae,De)){if(ve>_&&await new Promise(be=>setTimeout(be)),ge&&ge.isCancellationRequested)throw new E.CancellationError;p(j,x,Re,ve,we)}return Re})().then(Me,Oe)})}e.topAsync=f;function p(j,x,_,ae,ge){for(const Me=_.length;ae<ge;ae++){const Oe=j[ae];if(x(Oe,_[Me-1])<0){_.pop();const De=v(_,Re=>x(Oe,Re)<0);_.splice(De,0,Oe)}}}function u(j){return j.filter(x=>!!x)}e.coalesce=u;function b(j){let x=0;for(let _=0;_<j.length;_++)j[_]&&(j[x]=j[_],x+=1);j.length=x}e.coalesceInPlace=b;function g(j,x,_){j.splice(_,0,j.splice(x,1)[0])}e.move=g;function d(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=d;function l(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=l;function n(j,x=_=>_){const _=new Set;return j.filter(ae=>{const ge=x(ae);return _.has(ge)?!1:(_.add(ge),!0)})}e.distinct=n;function s(j){const x=new Set;return _=>{const ae=j(_);return x.has(ae)?!1:(x.add(ae),!0)}}e.uniqueFilter=s;function i(j,x){const _=a(j,x);if(_!==-1)return j[_]}e.findLast=i;function a(j,x){for(let _=j.length-1;_>=0;_--){const ae=j[_];if(x(ae))return _}return-1}e.lastIndex=a;function r(j,x){return j.length>0?j[0]:x}e.firstOrDefault=r;function c(j,x){return j.length>0?j[j.length-1]:x}e.lastOrDefault=c;function o(j,x,_=(ae,ge)=>ae===ge){let ae=0;for(let ge=0,Me=Math.min(j.length,x.length);ge<Me&&_(j[ge],x[ge]);ge++)ae++;return ae}e.commonPrefixLength=o;function y(j){return[].concat(...j)}e.flatten=y;function D(j,x){let _=typeof x=="number"?j:0;typeof x=="number"?_=j:(_=0,x=j);const ae=[];if(_<=x)for(let ge=_;ge<x;ge++)ae.push(ge);else for(let ge=_;ge>x;ge--)ae.push(ge);return ae}e.range=D;function O(j,x,_){return j.reduce((ae,ge)=>(ae[x(ge)]=_?_(ge):ge,ae),Object.create(null))}e.index=O;function N(j,x){return j.push(x),()=>Y(j,x)}e.insert=N;function Y(j,x){const _=j.indexOf(x);if(_>-1)return j.splice(_,1),x}e.remove=Y;function G(j,x,_){const ae=j.slice(0,x),ge=j.slice(x);return ae.concat(_,ge)}e.arrayInsert=G;function V(j,x){let _;if(typeof x=="number"){let ae=x;_=()=>{const ge=Math.sin(ae++)*179426549;return ge-Math.floor(ge)}}else _=Math.random;for(let ae=j.length-1;ae>0;ae-=1){const ge=Math.floor(_()*(ae+1)),Me=j[ae];j[ae]=j[ge],j[ge]=Me}}e.shuffle=V;function se(j,x){const _=j.indexOf(x);_>-1&&(j.splice(_,1),j.unshift(x))}e.pushToStart=se;function oe(j,x){const _=j.indexOf(x);_>-1&&(j.splice(_,1),j.push(x))}e.pushToEnd=oe;function re(j,x){for(const _ of x)j.push(_)}e.pushMany=re;function de(j,x){return Array.isArray(j)?j.map(x):x(j)}e.mapArrayOrNot=de;function X(j){return Array.isArray(j)?j:[j]}e.asArray=X;function le(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=le;function W(j,x){for(const _ of j){const ae=x(_);if(ae!==void 0)return ae}}e.mapFind=W;function L(j,x,_){const ae=U(j,x),ge=j.length,Me=_.length;j.length=ge+Me;for(let Oe=ge-1;Oe>=ae;Oe--)j[Oe+Me]=j[Oe];for(let Oe=0;Oe<Me;Oe++)j[Oe+ae]=_[Oe]}e.insertInto=L;function T(j,x,_,ae){const ge=U(j,x),Me=j.splice(ge,_);return L(j,ge,ae),Me}e.splice=T;function U(j,x){return x<0?Math.max(x+j.length,0):Math.min(x,j.length)}var Q;(function(j){function x(ge){return ge<0}j.isLessThan=x;function _(ge){return ge>0}j.isGreaterThan=_;function ae(ge){return ge===0}j.isNeitherLessOrGreaterThan=ae,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function B(j,x){return(_,ae)=>x(j(_),j(ae))}e.compareBy=B;function H(...j){return(x,_)=>{for(const ae of j){const ge=ae(x,_);if(!Q.isNeitherLessOrGreaterThan(ge))return ge}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=H;const R=(j,x)=>j-x;e.numberComparator=R;function F(j,x){if(j.length===0)return;let _=j[0];for(let ae=1;ae<j.length;ae++){const ge=j[ae];x(ge,_)>0&&(_=ge)}return _}e.findMaxBy=F;function $(j,x){if(j.length===0)return;let _=j[0];for(let ae=1;ae<j.length;ae++){const ge=j[ae];x(ge,_)>=0&&(_=ge)}return _}e.findLastMaxBy=$;function z(j,x){return F(j,(_,ae)=>-x(_,ae))}e.findMinBy=z;class J{constructor(x){this.f=x,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(x){let _=this.c;for(;_<this.f.length&&x(this.f[_]);)_++;const ae=_===this.c?null:this.f.slice(this.c,_);return this.c=_,ae}takeFromEndWhile(x){let _=this.d;for(;_>=0&&x(this.f[_]);)_--;const ae=_===this.d?null:this.f.slice(_+1,this.d+1);return this.d=_,ae}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const x=this.f[this.c];return this.c++,x}removeLast(){const x=this.f[this.d];return this.d--,x}takeCount(x){const _=this.f.slice(this.c,this.c+x);return this.c+=x,_}}e.ArrayQueue=J;class ne{constructor(x){this.iterate=x}forEach(x){this.iterate(_=>(x(_),!0))}toArray(){const x=[];return this.iterate(_=>(x.push(_),!0)),x}filter(x){return new ne(_=>this.iterate(ae=>x(ae)?_(ae):!0))}map(x){return new ne(_=>this.iterate(ae=>_(x(ae))))}some(x){let _=!1;return this.iterate(ae=>(_=x(ae),!_)),_}findFirst(x){let _;return this.iterate(ae=>x(ae)?(_=ae,!1):!0),_}findLast(x){let _;return this.iterate(ae=>(x(ae)&&(_=ae),!0)),_}findLastMaxBy(x){let _,ae=!0;return this.iterate(ge=>((ae||Q.isGreaterThan(x(ge,_)))&&(ae=!1,_=ge),!0)),_}}e.CallbackIterable=ne,ne.empty=new ne(j=>{})}),define(ee[121],te([0,1,15]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(w,v){if(!w)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=t;function C(w,v="Unreachable"){throw new Error(v)}e.assertNever=C;function A(w){if(!w)throw new E.BugIndicatingError("Assertion Failed")}e.assert=A;function M(w){if(!w()){debugger;w(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=M;function k(w,v){let S=0;for(;S<w.length-1;){const P=w[S],I=w[S+1];if(!v(P,I))return!1;S++}return!0}e.checkAdjacentItems=k}),define(ee[49],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(t){const C=this;let A=!1,M;return function(){return A||(A=!0,M=t.apply(C,arguments)),M}}e.once=E}),define(ee[66],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(t){function C(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}t.is=C;const A=Object.freeze([]);function M(){return A}t.empty=M;function*k(d){yield d}t.single=k;function w(d){return C(d)?d:k(d)}t.wrap=w;function v(d){return d||A}t.from=v;function S(d){return!d||d[Symbol.iterator]().next().done===!0}t.isEmpty=S;function P(d){return d[Symbol.iterator]().next().value}t.first=P;function I(d,l){for(const n of d)if(l(n))return!0;return!1}t.some=I;function h(d,l){for(const n of d)if(l(n))return n}t.find=h;function*m(d,l){for(const n of d)l(n)&&(yield n)}t.filter=m;function*f(d,l){let n=0;for(const s of d)yield l(s,n++)}t.map=f;function*p(...d){for(const l of d)for(const n of l)yield n}t.concat=p;function u(d,l,n){let s=n;for(const i of d)s=l(s,i);return s}t.reduce=u;function*b(d,l,n=d.length){for(l<0&&(l+=d.length),n<0?n+=d.length:n>d.length&&(n=d.length);l<n;l++)yield d[l]}t.slice=b;function g(d,l=Number.POSITIVE_INFINITY){const n=[];if(l===0)return[n,d];const s=d[Symbol.iterator]();for(let i=0;i<l;i++){const a=s.next();if(a.done)return[n,t.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return s}}]}t.consume=g})(E=e.Iterable||(e.Iterable={}))}),define(ee[42],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(n){n.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function M(n,s=!1){let i=0;const a=n.length;let r="",c=0,o=16,y=0;function D(oe){let re=0,de=0;for(;re<oe;){const X=n.charCodeAt(i);if(X>=48&&X<=57)de=de*16+X-48;else if(X>=65&&X<=70)de=de*16+X-65+10;else if(X>=97&&X<=102)de=de*16+X-97+10;else break;i++,re++}return re<oe&&(de=-1),de}function O(oe){i=oe,r="",c=0,o=16,y=0}function N(){const oe=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&v(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&v(n.charCodeAt(i)))for(i++;i<n.length&&v(n.charCodeAt(i));)i++;else return y=3,n.substring(oe,i);let re=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&v(n.charCodeAt(i))){for(i++;i<n.length&&v(n.charCodeAt(i));)i++;re=i}else y=3;return n.substring(oe,re)}function Y(){let oe="",re=i;for(;;){if(i>=a){oe+=n.substring(re,i),y=2;break}const de=n.charCodeAt(i);if(de===34){oe+=n.substring(re,i),i++;break}if(de===92){if(oe+=n.substring(re,i),i++,i>=a){y=2;break}switch(n.charCodeAt(i++)){case 34:oe+='"';break;case 92:oe+="\\";break;case 47:oe+="/";break;case 98:oe+="\b";break;case 102:oe+="\f";break;case 110:oe+=`
`;break;case 114:oe+="\r";break;case 116:oe+="	";break;case 117:{const le=D(4);le>=0?oe+=String.fromCharCode(le):y=4;break}default:y=5}re=i;continue}if(de>=0&&de<=31)if(w(de)){oe+=n.substring(re,i),y=2;break}else y=6;i++}return oe}function G(){if(r="",y=0,c=i,i>=a)return c=a,o=17;let oe=n.charCodeAt(i);if(k(oe)){do i++,r+=String.fromCharCode(oe),oe=n.charCodeAt(i);while(k(oe));return o=15}if(w(oe))return i++,r+=String.fromCharCode(oe),oe===13&&n.charCodeAt(i)===10&&(i++,r+=`
`),o=14;switch(oe){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,r=Y(),o=10;case 47:{const re=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<a&&!w(n.charCodeAt(i));)i++;return r=n.substring(re,i),o=12}if(n.charCodeAt(i+1)===42){i+=2;const de=a-1;let X=!1;for(;i<de;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,X=!0;break}i++}return X||(i++,y=1),r=n.substring(re,i),o=13}return r+=String.fromCharCode(oe),i++,o=16}case 45:if(r+=String.fromCharCode(oe),i++,i===a||!v(n.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=N(),o=11;default:for(;i<a&&V(oe);)i++,oe=n.charCodeAt(i);if(c!==i){switch(r=n.substring(c,i),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode(oe),i++,o=16}}function V(oe){if(k(oe)||w(oe))return!1;switch(oe){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let oe;do oe=G();while(oe>=12&&oe<=15);return oe}return{setPosition:O,getPosition:()=>i,scan:s?se:G,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>y}}e.createScanner=M;function k(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function w(n){return n===10||n===13||n===8232||n===8233}function v(n){return n>=48&&n<=57}var S;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(S||(S={}));function P(n,s){const i=[],a=new Object;let r;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function y(D,O,N,Y){c.value=D,c.offset=O,c.length=N,c.type=Y,c.colonOffset=void 0,r=c}try{g(n,{onObjectBegin:(D,O)=>{if(s<=D)throw a;r=void 0,o=s>D,i.push("")},onObjectProperty:(D,O,N)=>{if(s<O||(y(D,O,N,"property"),i[i.length-1]=D,s<=O+N))throw a},onObjectEnd:(D,O)=>{if(s<=D)throw a;r=void 0,i.pop()},onArrayBegin:(D,O)=>{if(s<=D)throw a;r=void 0,i.push(0)},onArrayEnd:(D,O)=>{if(s<=D)throw a;r=void 0,i.pop()},onLiteralValue:(D,O,N)=>{if(s<O||(y(D,O,N,l(D)),s<=O+N))throw a},onSeparator:(D,O,N)=>{if(s<=O)throw a;if(D===":"&&r&&r.type==="property")r.colonOffset=O,o=!1,r=void 0;else if(D===","){const Y=i[i.length-1];typeof Y=="number"?i[i.length-1]=Y+1:(o=!0,i[i.length-1]=""),r=void 0}}})}catch(D){if(D!==a)throw D}return{path:i,previousNode:r,isAtPropertyKey:o,matches:D=>{let O=0;for(let N=0;O<D.length&&N<i.length;N++)if(D[O]===i[N]||D[O]==="*")O++;else if(D[O]!=="**")return!1;return O===D.length}}}e.getLocation=P;function I(n,s=[],i=A.DEFAULT){let a=null,r=[];const c=[];function o(D){Array.isArray(r)?r.push(D):a!==null&&(r[a]=D)}return g(n,{onObjectBegin:()=>{const D={};o(D),c.push(r),r=D,a=null},onObjectProperty:D=>{a=D},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const D=[];o(D),c.push(r),r=D,a=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:o,onError:(D,O,N)=>{s.push({error:D,offset:O,length:N})}},i),r[0]}e.parse=I;function h(n,s=[],i=A.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(D){a.type==="property"&&(a.length=D-a.offset,a=a.parent)}function c(D){return a.children.push(D),D}g(n,{onObjectBegin:D=>{a=c({type:"object",offset:D,length:-1,parent:a,children:[]})},onObjectProperty:(D,O,N)=>{a=c({type:"property",offset:O,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:D,offset:O,length:N,parent:a})},onObjectEnd:(D,O)=>{a.length=D+O-a.offset,a=a.parent,r(D+O)},onArrayBegin:(D,O)=>{a=c({type:"array",offset:D,length:-1,parent:a,children:[]})},onArrayEnd:(D,O)=>{a.length=D+O-a.offset,a=a.parent,r(D+O)},onLiteralValue:(D,O,N)=>{c({type:l(D),offset:O,length:N,parent:a,value:D}),r(O+N)},onSeparator:(D,O,N)=>{a.type==="property"&&(D===":"?a.colonOffset=O:D===","&&r(O))},onError:(D,O,N)=>{s.push({error:D,offset:O,length:N})}},i);const y=a.children[0];return y&&delete y.parent,y}e.parseTree=h;function m(n,s){if(!n)return;let i=n;for(const a of s)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===a){i=c.children[1],r=!0;break}if(!r)return}else{const r=a;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=m;function f(n){if(!n.parent||!n.parent.children)return[];const s=f(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;s.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&s.push(i)}return s}e.getNodePath=f;function p(n){switch(n.type){case"array":return n.children.map(p);case"object":{const s=Object.create(null);for(const i of n.children){const a=i.children[1];a&&(s[i.children[0].value]=p(a))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=p;function u(n,s,i=!1){return s>=n.offset&&s<n.offset+n.length||i&&s===n.offset+n.length}e.contains=u;function b(n,s,i=!1){if(u(n,s,i)){const a=n.children;if(Array.isArray(a))for(let r=0;r<a.length&&a[r].offset<=s;r++){const c=b(a[r],s,i);if(c)return c}return n}}e.findNodeAtOffset=b;function g(n,s,i=A.DEFAULT){const a=M(n,!1);function r(B){return B?()=>B(a.getTokenOffset(),a.getTokenLength()):()=>!0}function c(B){return B?H=>B(H,a.getTokenOffset(),a.getTokenLength()):()=>!0}const o=r(s.onObjectBegin),y=c(s.onObjectProperty),D=r(s.onObjectEnd),O=r(s.onArrayBegin),N=r(s.onArrayEnd),Y=c(s.onLiteralValue),G=c(s.onSeparator),V=r(s.onComment),se=c(s.onError),oe=i&&i.disallowComments,re=i&&i.allowTrailingComma;function de(){for(;;){const B=a.scan();switch(a.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:oe||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(B){case 12:case 13:oe?X(10):V();break;case 16:X(1);break;case 15:case 14:break;default:return B}}}function X(B,H=[],R=[]){if(se(B),H.length+R.length>0){let F=a.getToken();for(;F!==17;){if(H.indexOf(F)!==-1){de();break}else if(R.indexOf(F)!==-1)break;F=de()}}}function le(B){const H=a.getTokenValue();return B?Y(H):y(H),de(),!0}function W(){switch(a.getToken()){case 11:{let B=0;try{B=JSON.parse(a.getTokenValue()),typeof B!="number"&&(X(2),B=0)}catch{X(2)}Y(B);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return de(),!0}function L(){return a.getToken()!==10?(X(3,[],[2,5]),!1):(le(!1),a.getToken()===6?(G(":"),de(),Q()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function T(){o(),de();let B=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(B||X(4,[],[]),G(","),de(),a.getToken()===2&&re)break}else B&&X(6,[],[]);L()||X(4,[],[2,5]),B=!0}return D(),a.getToken()!==2?X(7,[2],[]):de(),!0}function U(){O(),de();let B=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(B||X(4,[],[]),G(","),de(),a.getToken()===4&&re)break}else B&&X(6,[],[]);Q()||X(4,[],[4,5]),B=!0}return N(),a.getToken()!==4?X(8,[4],[]):de(),!0}function Q(){switch(a.getToken()){case 3:return U();case 1:return T();case 10:return le(!0);default:return W()}}return de(),a.getToken()===17?i.allowEmptyContent?!0:(X(4,[],[]),!1):Q()?(a.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=g;function d(n,s){const i=M(n),a=[];let r,c=0,o;do switch(o=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:c!==o&&a.push(n.substring(c,o)),s!==void 0&&a.push(i.getTokenValue().replace(/[^\r\n]/g,s)),c=i.getPosition();break}while(r!==17);return a.join("")}e.stripComments=d;function l(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ee[122],te([0,1,42]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(v,S,P){let I,h,m,f,p;if(S){for(f=S.offset,p=f+S.length,m=f;m>0&&!w(v,m-1);)m--;let o=p;for(;o<v.length&&!w(v,o);)o++;h=v.substring(m,o),I=M(h,P)}else h=v,I=0,m=0,f=0,p=v.length;const u=k(P,v);let b=!1,g=0,d;P.insertSpaces?d=A(" ",P.tabSize||4):d="	";const l=(0,E.createScanner)(h,!1);let n=!1;function s(){return u+A(d,I+g)}function i(){let o=l.scan();for(b=!1;o===15||o===14;)b=b||o===14,o=l.scan();return n=o===16||l.getTokenError()!==0,o}const a=[];function r(o,y,D){!n&&y<p&&D>f&&v.substring(y,D)!==o&&a.push({offset:y,length:D-y,content:o})}let c=i();if(c!==17){const o=l.getTokenOffset()+m,y=A(d,I);r(y,m,o)}for(;c!==17;){let o=l.getTokenOffset()+l.getTokenLength()+m,y=i(),D="";for(;!b&&(y===12||y===13);){const N=l.getTokenOffset()+m;r(" ",o,N),o=l.getTokenOffset()+l.getTokenLength()+m,D=y===12?s():"",y=i()}if(y===2)c!==1&&(g--,D=s());else if(y===4)c!==3&&(g--,D=s());else{switch(c){case 3:case 1:g++,D=s();break;case 5:case 12:D=s();break;case 13:b?D=s():D=" ";break;case 6:D=" ";break;case 10:if(y===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?D=" ":y!==5&&y!==17&&(n=!0);break;case 16:n=!0;break}b&&(y===12||y===13)&&(D=s())}const O=l.getTokenOffset()+m;r(D,o,O),c=y}return a}e.format=t;function C(v,S){const P=JSON.stringify(v,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?P.replace(/\r\n|\r|\n/g,S.eol):P}e.toFormattedString=C;function A(v,S){let P="";for(let I=0;I<S;I++)P+=v;return P}function M(v,S){let P=0,I=0;const h=S.tabSize||4;for(;P<v.length;){const m=v.charAt(P);if(m===" ")I++;else if(m==="	")I+=h;else break;P++}return Math.floor(I/h)}function k(v,S){for(let P=0;P<S.length;P++){const I=S.charAt(P);if(I==="\r")return P+1<S.length&&S.charAt(P+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return v&&v.eol||`
`}e.getEOL=k;function w(v,S){return`\r
`.indexOf(v.charAt(S))!==-1}e.isEOL=w}),define(ee[123],te([0,1,42,122]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(v,S,P){return A(v,S,void 0,P)}e.removeProperty=C;function A(v,S,P,I,h){const m=S.slice(),f=[],p=(0,E.parseTree)(v,f);let u,b;for(;m.length>0&&(b=m.pop(),u=(0,E.findNodeAtLocation)(p,m),u===void 0&&P!==void 0);)typeof b=="string"?P={[b]:P}:P=[P];if(u)if(u.type==="object"&&typeof b=="string"&&Array.isArray(u.children)){const g=(0,E.findNodeAtLocation)(u,[b]);if(g!==void 0)if(P===void 0){if(!g.parent)throw new Error("Malformed AST");const d=u.children.indexOf(g.parent);let l,n=g.parent.offset+g.parent.length;if(d>0){const s=u.children[d-1];l=s.offset+s.length}else l=u.offset+1,u.children.length>1&&(n=u.children[1].offset);return M(v,{offset:l,length:n-l,content:""},I)}else return M(v,{offset:g.offset,length:g.length,content:JSON.stringify(P)},I);else{if(P===void 0)return[];const d=`${JSON.stringify(b)}: ${JSON.stringify(P)}`,l=h?h(u.children.map(s=>s.children[0].value)):u.children.length;let n;if(l>0){const s=u.children[l-1];n={offset:s.offset+s.length,length:0,content:","+d}}else u.children.length===0?n={offset:u.offset+1,length:0,content:d}:n={offset:u.offset+1,length:0,content:d+","};return M(v,n,I)}}else if(u.type==="array"&&typeof b=="number"&&Array.isArray(u.children))if(P!==void 0){const g=`${JSON.stringify(P)}`;let d;if(u.children.length===0||b===0)d={offset:u.offset+1,length:0,content:u.children.length===0?g:g+","};else{const l=b===-1||b>u.children.length?u.children.length:b,n=u.children[l-1];d={offset:n.offset+n.length,length:0,content:","+g}}return M(v,d,I)}else{const g=b,d=u.children[g];let l;if(u.children.length===1)l={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===g){const n=u.children[g-1],s=n.offset+n.length,i=u.offset+u.length;l={offset:s,length:i-2-s,content:""}}else l={offset:d.offset,length:u.children[g+1].offset-d.offset,content:""};return M(v,l,I)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${u.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return M(v,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(P)},I)}}e.setProperty=A;function M(v,S,P){let I=k(v,S),h=S.offset,m=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;h>0&&!(0,t.isEOL)(I,h-1);)h--;for(;m<I.length&&!(0,t.isEOL)(I,m);)m++}const f=(0,t.format)(I,{offset:h,length:m-h},P);for(let u=f.length-1;u>=0;u--){const b=f[u];I=k(I,b),h=Math.min(h,b.offset),m=Math.max(m,b.offset+b.length),m+=b.content.length-b.length}const p=v.length-(I.length-m)-h;return[{offset:h,length:p,content:I.substring(h,m)}]}e.withFormatting=M;function k(v,S){return v.substring(0,S.offset)+S.content+v.substring(S.offset+S.length)}e.applyEdit=k;function w(v,S){const P=S.slice(0).sort((h,m)=>{const f=h.offset-m.offset;return f===0?h.length-m.length:f});let I=v.length;for(let h=P.length-1;h>=0;h--){const m=P[h];if(m.offset+m.length<=I)v=k(v,m);else throw new Error("Overlapping edit");I=m.offset}return v}e.applyEdits=w}),define(ee[124],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(C){this.d=C,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(C){return new E(()=>C(this.getValue()))}}e.Lazy=E}),define(ee[2],te([0,1,49,66]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let A=null;function M(c){A=c}if(e.setDisposableTracker=M,C){const c="__is_disposable_tracked__";M(new class{trackDisposable(o){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[c]||console.log(y)},3e3)}setParent(o,y){if(o&&o!==b.None)try{o[c]=!0}catch{}}markAsDisposed(o){if(o&&o!==b.None)try{o[c]=!0}catch{}}markAsSingleton(o){}})}function k(c){return A?.trackDisposable(c),c}function w(c){A?.markAsDisposed(c)}function v(c,o){A?.setParent(c,o)}function S(c,o){if(!!A)for(const y of c)A.setParent(y,o)}function P(c){return A?.markAsSingleton(c),c}e.markAsSingleton=P;function I(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=I;function h(c){if(t.Iterable.is(c)){const o=[];for(const y of c)if(y)try{y.dispose()}catch(D){o.push(D)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=h;function m(c){for(const o of c)I(o)&&o.dispose();return[]}e.disposeIfDisposable=m;function f(...c){const o=p(()=>h(c));return S(c,o),o}e.combinedDisposable=f;function p(c){const o=k({dispose:(0,E.once)(()=>{w(o),c()})});return o}e.toDisposable=p;class u{constructor(){this.c=new Set,this.f=!1,k(this)}dispose(){this.f||(w(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{h(this.c)}finally{this.c.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return v(o,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(o),o}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this.q=new u,k(this),v(this.q,this)}dispose(){w(this),this.q.dispose()}B(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(o)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class g{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&v(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&v(o,null),o}}e.MutableDisposable=g;class d{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=d;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(o){let y=o;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,w(this))},this}}e.SafeDisposable=l;class n{constructor(){this.a=new Map}acquire(o,...y){let D=this.a.get(o);D||(D={counter:0,object:this.b(o,...y)},this.a.set(o,D));const{object:O}=D,N=(0,E.once)(()=>{--D.counter===0&&(this.c(o,D.object),this.a.delete(o))});return D.counter++,{object:O,dispose:N}}}e.ReferenceCollection=n;class s{constructor(o){this.a=o}async acquire(o,...y){const D=this.a.acquire(o,...y);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(O){throw D.dispose(),O}}}e.AsyncReferenceCollection=s;class i{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=i;function a(c){const o=new u;try{c(o)}finally{o.dispose()}}e.disposeOnReturn=a;class r{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,y,D=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),D||this.a.get(o)?.dispose(),this.a.set(o,y)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=r}),define(ee[94],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(A){this.element=A,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class t{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let A=this.a;for(;A!==E.Undefined;){const M=A.next;A.prev=E.Undefined,A.next=E.Undefined,A=M}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,M){const k=new E(A);if(this.a===E.Undefined)this.a=k,this.b=k;else if(M){const v=this.b;this.b=k,k.prev=v,v.next=k}else{const v=this.a;this.a=k,k.next=v,v.prev=k}this.c+=1;let w=!1;return()=>{w||(w=!0,this.e(k))}}shift(){if(this.a!==E.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==E.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==E.Undefined&&A.next!==E.Undefined){const M=A.prev;M.next=A.next,A.next.prev=M}else A.prev===E.Undefined&&A.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):A.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):A.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==E.Undefined;)yield A.element,A=A.next}}e.LinkedList=t}),define(ee[38],te([0,1]),function(q,e){"use strict";var E,t,C;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(m,f,p){let u=m.get(f);return u===void 0&&(u=p,m.set(f,u)),u}e.getOrSet=A;function M(m){const f=[];return m.forEach((p,u)=>{f.push(`${u} => ${p}`)}),`Map(${m.size}) {${f.join(", ")}}`}e.mapToString=M;function k(m){const f=[];return m.forEach(p=>{f.push(p)}),`Set(${m.size}) {${f.join(", ")}}`}e.setToString=k;class w{constructor(f,p){this.uri=f,this.value=p}}class v{constructor(f,p){this[E]="ResourceMap",f instanceof v?(this.b=new Map(f.b),this.c=p??v.a):(this.b=new Map,this.c=f??v.a)}set(f,p){return this.b.set(this.c(f),new w(f,p)),this}get(f){return this.b.get(this.c(f))?.value}has(f){return this.b.has(this.c(f))}get size(){return this.b.size}clear(){this.b.clear()}delete(f){return this.b.delete(this.c(f))}forEach(f,p){typeof p<"u"&&(f=f.bind(p));for(const[u,b]of this.b)f(b.value,b.uri,this)}*values(){for(const f of this.b.values())yield f.value}*keys(){for(const f of this.b.values())yield f.uri}*entries(){for(const f of this.b.values())yield[f.uri,f.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.b)yield[f.uri,f.value]}}e.ResourceMap=v,v.a=m=>m.toString();class S{constructor(f,p){this[t]="ResourceSet",!f||typeof f=="function"?this.a=new v(f):(this.a=new v(p),f.forEach(this.add,this))}get size(){return this.a.size}add(f){return this.a.set(f,f),this}clear(){this.a.clear()}delete(f){return this.a.delete(f)}forEach(f,p){this.a.forEach((u,b)=>f.call(p,b,b,this))}has(f){return this.a.has(f)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=S;var P;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class I{constructor(){this[C]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(f){return this.a.has(f)}get(f,p=0){const u=this.a.get(f);if(!!u)return p!==0&&this.j(u,p),u.value}set(f,p,u=0){let b=this.a.get(f);if(b)b.value=p,u!==0&&this.j(b,u);else{switch(b={key:f,value:p,next:void 0,previous:void 0},u){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(f,b),this.d++}return this}delete(f){return!!this.remove(f)}remove(f){const p=this.a.get(f);if(!!p)return this.a.delete(f),this.i(p),this.d--,p.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const f=this.b;return this.a.delete(f.key),this.i(f),this.d--,f.value}forEach(f,p){const u=this.e;let b=this.b;for(;b;){if(p?f.bind(p)(b.value,b.key,this):f(b.value,b.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const f=this,p=this.e;let u=this.b;const b={[Symbol.iterator](){return b},next(){if(f.e!==p)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:u.key,done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return b}values(){const f=this,p=this.e;let u=this.b;const b={[Symbol.iterator](){return b},next(){if(f.e!==p)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:u.value,done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return b}entries(){const f=this,p=this.e;let u=this.b;const b={[Symbol.iterator](){return b},next(){if(f.e!==p)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:[u.key,u.value],done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return b}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(f){if(f>=this.size)return;if(f===0){this.clear();return}let p=this.b,u=this.size;for(;p&&u>f;)this.a.delete(p.key),p=p.next,u--;this.b=p,this.d=u,p&&(p.previous=void 0),this.e++}g(f){if(!this.b&&!this.c)this.c=f;else if(this.b)f.next=this.b,this.b.previous=f;else throw new Error("Invalid list");this.b=f,this.e++}h(f){if(!this.b&&!this.c)this.b=f;else if(this.c)f.previous=this.c,this.c.next=f;else throw new Error("Invalid list");this.c=f,this.e++}i(f){if(f===this.b&&f===this.c)this.b=void 0,this.c=void 0;else if(f===this.b){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this.b=f.next}else if(f===this.c){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this.c=f.previous}else{const p=f.next,u=f.previous;if(!p||!u)throw new Error("Invalid list");p.previous=u,u.next=p}f.next=void 0,f.previous=void 0,this.e++}j(f,p){if(!this.b||!this.c)throw new Error("Invalid list");if(!(p!==1&&p!==2)){if(p===1){if(f===this.b)return;const u=f.next,b=f.previous;f===this.c?(b.next=void 0,this.c=b):(u.previous=b,b.next=u),f.previous=void 0,f.next=this.b,this.b.previous=f,this.b=f,this.e++}else if(p===2){if(f===this.c)return;const u=f.next,b=f.previous;f===this.b?(u.previous=void 0,this.b=u):(u.previous=b,b.next=u),f.next=void 0,f.previous=this.c,this.c.next=f,this.c=f,this.e++}}}toJSON(){const f=[];return this.forEach((p,u)=>{f.push([u,p])}),f}fromJSON(f){this.clear();for(const[p,u]of f)this.set(p,u)}}e.LinkedMap=I;class h extends I{constructor(f,p=1){super(),this.k=f,this.l=Math.min(Math.max(0,p),1)}get limit(){return this.k}set limit(f){this.k=f,this.m()}get ratio(){return this.l}set ratio(f){this.l=Math.min(Math.max(0,f),1),this.m()}get(f,p=2){return super.get(f,p)}peek(f){return super.get(f,0)}set(f,p){return super.set(f,p,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=h}),define(ee[76],te([0,1,38]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new E.LRUCache(1e4);function C(v){return w(v,"NFC",t)}e.normalizeNFC=C;const A=new E.LRUCache(1e4);function M(v){return w(v,"NFD",A)}e.normalizeNFD=M;const k=/[^\u0000-\u0080]/;function w(v,S,P){if(!v)return v;const I=P.get(v);if(I)return I;let h;return k.test(v)?h=v.normalize(S):h=v,P.set(v,h),h}e.removeAccents=function(){const v=/[\u0300-\u036f]/g;return function(S){return M(S).replace(v,"")}}()}),function(){function q(C){const A=[];typeof C=="number"&&A.push("code/timeOrigin",C);function M(w){A.push(w,Date.now())}function k(){const w=[];for(let v=0;v<A.length;v+=2)w.push({name:A[v],startTime:A[v+1]});return w}return{mark:M,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const M of performance.getEntriesByType("mark"))A.push({name:M.name,startTime:Math.round(C+M.startTime)});return A}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function E(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=E(t))}(),function(q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var t in E)(typeof exports=="object"?exports:q)[t]=E[t]}}(typeof self<"u"?self:this,function(){return function(q){var e={};function E(t){if(e[t])return e[t].exports;var C=e[t]={i:t,l:!1,exports:{}};return q[t].call(C.exports,C,C.exports,E),C.l=!0,C.exports}return E.m=q,E.c=e,E.d=function(t,C,A){E.o(t,C)||Object.defineProperty(t,C,{enumerable:!0,get:A})},E.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},E.t=function(t,C){if(1&C&&(t=E(t)),8&C||4&C&&typeof t=="object"&&t&&t.__esModule)return t;var A=Object.create(null);if(E.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:t}),2&C&&typeof t!="string")for(var M in t)E.d(A,M,function(k){return t[k]}.bind(null,M));return A},E.n=function(t){var C=t&&t.__esModule?function(){return t.default}:function(){return t};return E.d(C,"a",C),C},E.o=function(t,C){return Object.prototype.hasOwnProperty.call(t,C)},E.p="",E(E.s=0)}([function(q,e,E){(function(t){var C;e=q.exports=R,C=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],w=e.src=[],v=0,S=v++;w[S]="0|[1-9]\\d*";var P=v++;w[P]="[0-9]+";var I=v++;w[I]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=v++;w[h]="("+w[S]+")\\.("+w[S]+")\\.("+w[S]+")";var m=v++;w[m]="("+w[P]+")\\.("+w[P]+")\\.("+w[P]+")";var f=v++;w[f]="(?:"+w[S]+"|"+w[I]+")";var p=v++;w[p]="(?:"+w[P]+"|"+w[I]+")";var u=v++;w[u]="(?:-("+w[f]+"(?:\\."+w[f]+")*))";var b=v++;w[b]="(?:-?("+w[p]+"(?:\\."+w[p]+")*))";var g=v++;w[g]="[0-9A-Za-z-]+";var d=v++;w[d]="(?:\\+("+w[g]+"(?:\\."+w[g]+")*))";var l=v++,n="v?"+w[h]+w[u]+"?"+w[d]+"?";w[l]="^"+n+"$";var s="[v=\\s]*"+w[m]+w[b]+"?"+w[d]+"?",i=v++;w[i]="^"+s+"$";var a=v++;w[a]="((?:<|>)?=?)";var r=v++;w[r]=w[P]+"|x|X|\\*";var c=v++;w[c]=w[S]+"|x|X|\\*";var o=v++;w[o]="[v=\\s]*("+w[c]+")(?:\\.("+w[c]+")(?:\\.("+w[c]+")(?:"+w[u]+")?"+w[d]+"?)?)?";var y=v++;w[y]="[v=\\s]*("+w[r]+")(?:\\.("+w[r]+")(?:\\.("+w[r]+")(?:"+w[b]+")?"+w[d]+"?)?)?";var D=v++;w[D]="^"+w[a]+"\\s*"+w[o]+"$";var O=v++;w[O]="^"+w[a]+"\\s*"+w[y]+"$";var N=v++;w[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=v++;w[Y]="(?:~>?)";var G=v++;w[G]="(\\s*)"+w[Y]+"\\s+",k[G]=new RegExp(w[G],"g");var V=v++;w[V]="^"+w[Y]+w[o]+"$";var se=v++;w[se]="^"+w[Y]+w[y]+"$";var oe=v++;w[oe]="(?:\\^)";var re=v++;w[re]="(\\s*)"+w[oe]+"\\s+",k[re]=new RegExp(w[re],"g");var de=v++;w[de]="^"+w[oe]+w[o]+"$";var X=v++;w[X]="^"+w[oe]+w[y]+"$";var le=v++;w[le]="^"+w[a]+"\\s*("+s+")$|^$";var W=v++;w[W]="^"+w[a]+"\\s*("+n+")$|^$";var L=v++;w[L]="(\\s*)"+w[a]+"\\s*("+s+"|"+w[o]+")",k[L]=new RegExp(w[L],"g");var T=v++;w[T]="^\\s*("+w[o]+")\\s+-\\s+("+w[o]+")\\s*$";var U=v++;w[U]="^\\s*("+w[y]+")\\s+-\\s+("+w[y]+")\\s*$";var Q=v++;w[Q]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)C(B,w[B]),k[B]||(k[B]=new RegExp(w[B]));function H(Z,ue){if(Z instanceof R)return Z;if(typeof Z!="string"||Z.length>A||!(ue?k[i]:k[l]).test(Z))return null;try{return new R(Z,ue)}catch{return null}}function R(Z,ue){if(Z instanceof R){if(Z.loose===ue)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof R))return new R(Z,ue);C("SemVer",Z,ue),this.loose=ue;var he=Z.trim().match(ue?k[i]:k[l]);if(!he)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Ie=+ye;if(Ie>=0&&Ie<M)return Ie}return ye}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=H,e.valid=function(Z,ue){var he=H(Z,ue);return he?he.version:null},e.clean=function(Z,ue){var he=H(Z.trim().replace(/^[=v]+/,""),ue);return he?he.version:null},e.SemVer=R,R.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},R.prototype.toString=function(){return this.version},R.prototype.compare=function(Z){return C("SemVer.compare",this.version,this.loose,Z),Z instanceof R||(Z=new R(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},R.prototype.compareMain=function(Z){return Z instanceof R||(Z=new R(Z,this.loose)),$(this.major,Z.major)||$(this.minor,Z.minor)||$(this.patch,Z.patch)},R.prototype.comparePre=function(Z){if(Z instanceof R||(Z=new R(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var ue=0;do{var he=this.prerelease[ue],ye=Z.prerelease[ue];if(C("prerelease compare",ue,he,ye),he===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(he===void 0)return-1;if(he!==ye)return $(he,ye)}while(++ue)},R.prototype.inc=function(Z,ue){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,ue,he,ye){typeof he=="string"&&(ye=he,he=void 0);try{return new R(Z,he).inc(ue,ye).version}catch{return null}},e.diff=function(Z,ue){if(j(Z,ue))return null;var he=H(Z),ye=H(ue);if(he.prerelease.length||ye.prerelease.length){for(var Ie in he)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&he[Ie]!==ye[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in he)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&he[Ie]!==ye[Ie])return Ie},e.compareIdentifiers=$;var F=/^[0-9]+$/;function $(Z,ue){var he=F.test(Z),ye=F.test(ue);return he&&ye&&(Z=+Z,ue=+ue),he&&!ye?-1:ye&&!he?1:Z<ue?-1:Z>ue?1:0}function z(Z,ue,he){return new R(Z,he).compare(new R(ue,he))}function J(Z,ue,he){return z(Z,ue,he)>0}function ne(Z,ue,he){return z(Z,ue,he)<0}function j(Z,ue,he){return z(Z,ue,he)===0}function x(Z,ue,he){return z(Z,ue,he)!==0}function _(Z,ue,he){return z(Z,ue,he)>=0}function ae(Z,ue,he){return z(Z,ue,he)<=0}function ge(Z,ue,he,ye){var Ie;switch(ue){case"===":typeof Z=="object"&&(Z=Z.version),typeof he=="object"&&(he=he.version),Ie=Z===he;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof he=="object"&&(he=he.version),Ie=Z!==he;break;case"":case"=":case"==":Ie=j(Z,he,ye);break;case"!=":Ie=x(Z,he,ye);break;case">":Ie=J(Z,he,ye);break;case">=":Ie=_(Z,he,ye);break;case"<":Ie=ne(Z,he,ye);break;case"<=":Ie=ae(Z,he,ye);break;default:throw new TypeError("Invalid operator: "+ue)}return Ie}function Me(Z,ue){if(Z instanceof Me){if(Z.loose===ue)return Z;Z=Z.value}if(!(this instanceof Me))return new Me(Z,ue);C("comparator",Z,ue),this.loose=ue,this.parse(Z),this.semver===Oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(Z,ue){return $(ue,Z)},e.major=function(Z,ue){return new R(Z,ue).major},e.minor=function(Z,ue){return new R(Z,ue).minor},e.patch=function(Z,ue){return new R(Z,ue).patch},e.compare=z,e.compareLoose=function(Z,ue){return z(Z,ue,!0)},e.rcompare=function(Z,ue,he){return z(ue,Z,he)},e.sort=function(Z,ue){return Z.sort(function(he,ye){return e.compare(he,ye,ue)})},e.rsort=function(Z,ue){return Z.sort(function(he,ye){return e.rcompare(he,ye,ue)})},e.gt=J,e.lt=ne,e.eq=j,e.neq=x,e.gte=_,e.lte=ae,e.cmp=ge,e.Comparator=Me;var Oe={};function De(Z,ue){if(Z instanceof De)return Z.loose===ue?Z:new De(Z.raw,ue);if(Z instanceof Me)return new De(Z.value,ue);if(!(this instanceof De))return new De(Z,ue);if(this.loose=ue,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Re(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function ve(Z,ue,he,ye,Ie,We,Te,ze,Be,qe,Ye,je,Xe){return((ue=Re(he)?"":Re(ye)?">="+he+".0.0":Re(Ie)?">="+he+"."+ye+".0":">="+ue)+" "+(ze=Re(Be)?"":Re(qe)?"<"+(+Be+1)+".0.0":Re(Ye)?"<"+Be+"."+(+qe+1)+".0":je?"<="+Be+"."+qe+"."+Ye+"-"+je:"<="+ze)).trim()}function we(Z,ue){for(var he=0;he<Z.length;he++)if(!Z[he].test(ue))return!1;if(ue.prerelease.length){for(he=0;he<Z.length;he++)if(C(Z[he].semver),Z[he].semver!==Oe&&Z[he].semver.prerelease.length>0){var ye=Z[he].semver;if(ye.major===ue.major&&ye.minor===ue.minor&&ye.patch===ue.patch)return!0}return!1}return!0}function be(Z,ue,he){try{ue=new De(ue,he)}catch{return!1}return ue.test(Z)}function Ce(Z,ue,he,ye){var Ie,We,Te,ze,Be;switch(Z=new R(Z,ye),ue=new De(ue,ye),he){case">":Ie=J,We=ae,Te=ne,ze=">",Be=">=";break;case"<":Ie=ne,We=_,Te=J,ze="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(Z,ue,ye))return!1;for(var qe=0;qe<ue.set.length;++qe){var Ye=ue.set[qe],je=null,Xe=null;if(Ye.forEach(function(K){K.semver===Oe&&(K=new Me(">=0.0.0")),je=je||K,Xe=Xe||K,Ie(K.semver,je.semver,ye)?je=K:Te(K.semver,Xe.semver,ye)&&(Xe=K)}),je.operator===ze||je.operator===Be||(!Xe.operator||Xe.operator===ze)&&We(Z,Xe.semver)||Xe.operator===Be&&Te(Z,Xe.semver))return!1}return!0}Me.prototype.parse=function(Z){var ue=this.loose?k[le]:k[W],he=Z.match(ue);if(!he)throw new TypeError("Invalid comparator: "+Z);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new R(he[2],this.loose):this.semver=Oe},Me.prototype.toString=function(){return this.value},Me.prototype.test=function(Z){return C("Comparator.test",Z,this.loose),this.semver===Oe||(typeof Z=="string"&&(Z=new R(Z,this.loose)),ge(Z,this.operator,this.semver,this.loose))},Me.prototype.intersects=function(Z,ue){if(!(Z instanceof Me))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new De(Z.value,ue),be(this.value,he,ue);if(Z.operator==="")return he=new De(this.value,ue),be(Z.semver,he,ue);var ye=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),We=this.semver.version===Z.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),ze=ge(this.semver,"<",Z.semver,ue)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),Be=ge(this.semver,">",Z.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return ye||Ie||We&&Te||ze||Be},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(Z){var ue=this.loose;Z=Z.trim(),C("range",Z,ue);var he=ue?k[U]:k[T];Z=Z.replace(he,ve),C("hyphen replace",Z),Z=Z.replace(k[L],"$1$2$3"),C("comparator trim",Z,k[L]),Z=(Z=(Z=Z.replace(k[G],"$1~")).replace(k[re],"$1^")).split(/\s+/).join(" ");var ye=ue?k[le]:k[W],Ie=Z.split(" ").map(function(We){return function(Te,ze){return C("comp",Te),Te=function(Be,qe){return Be.trim().split(/\s+/).map(function(Ye){return function(je,Xe){C("caret",je,Xe);var K=Xe?k[X]:k[de];return je.replace(K,function(ce,fe,me,Se,Le){var Ne;return C("caret",je,ce,fe,me,Se,Le),Re(fe)?Ne="":Re(me)?Ne=">="+fe+".0.0 <"+(+fe+1)+".0.0":Re(Se)?Ne=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":Le?(C("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Ne=fe==="0"?me==="0"?">="+fe+"."+me+"."+Se+Le+" <"+fe+"."+me+"."+(+Se+1):">="+fe+"."+me+"."+Se+Le+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+Se+Le+" <"+(+fe+1)+".0.0"):(C("no pr"),Ne=fe==="0"?me==="0"?">="+fe+"."+me+"."+Se+" <"+fe+"."+me+"."+(+Se+1):">="+fe+"."+me+"."+Se+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+Se+" <"+(+fe+1)+".0.0"),C("caret return",Ne),Ne})}(Ye,qe)}).join(" ")}(Te,ze),C("caret",Te),Te=function(Be,qe){return Be.trim().split(/\s+/).map(function(Ye){return function(je,Xe){var K=Xe?k[se]:k[V];return je.replace(K,function(ce,fe,me,Se,Le){var Ne;return C("tilde",je,ce,fe,me,Se,Le),Re(fe)?Ne="":Re(me)?Ne=">="+fe+".0.0 <"+(+fe+1)+".0.0":Re(Se)?Ne=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":Le?(C("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Ne=">="+fe+"."+me+"."+Se+Le+" <"+fe+"."+(+me+1)+".0"):Ne=">="+fe+"."+me+"."+Se+" <"+fe+"."+(+me+1)+".0",C("tilde return",Ne),Ne})}(Ye,qe)}).join(" ")}(Te,ze),C("tildes",Te),Te=function(Be,qe){return C("replaceXRanges",Be,qe),Be.split(/\s+/).map(function(Ye){return function(je,Xe){je=je.trim();var K=Xe?k[O]:k[D];return je.replace(K,function(ce,fe,me,Se,Le,Ne){C("xRange",je,ce,fe,me,Se,Le,Ne);var it=Re(me),Ze=it||Re(Se),Ve=Ze||Re(Le);return fe==="="&&Ve&&(fe=""),it?ce=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Ve?(Ze&&(Se=0),Ve&&(Le=0),fe===">"?(fe=">=",Ze?(me=+me+1,Se=0,Le=0):Ve&&(Se=+Se+1,Le=0)):fe==="<="&&(fe="<",Ze?me=+me+1:Se=+Se+1),ce=fe+me+"."+Se+"."+Le):Ze?ce=">="+me+".0.0 <"+(+me+1)+".0.0":Ve&&(ce=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),C("xRange return",ce),ce})}(Ye,qe)}).join(" ")}(Te,ze),C("xrange",Te),Te=function(Be,qe){return C("replaceStars",Be,qe),Be.trim().replace(k[Q],"")}(Te,ze),C("stars",Te),Te}(We,ue)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(We){return!!We.match(ye)})),Ie=Ie.map(function(We){return new Me(We,ue)})},De.prototype.intersects=function(Z,ue){if(!(Z instanceof De))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(ye){return Z.set.some(function(Ie){return Ie.every(function(We){return ye.intersects(We,ue)})})})})},e.toComparators=function(Z,ue){return new De(Z,ue).set.map(function(he){return he.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},De.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new R(Z,this.loose));for(var ue=0;ue<this.set.length;ue++)if(we(this.set[ue],Z))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(Z,ue,he){var ye=null,Ie=null;try{var We=new De(ue,he)}catch{return null}return Z.forEach(function(Te){We.test(Te)&&(ye&&Ie.compare(Te)!==-1||(Ie=new R(ye=Te,he)))}),ye},e.minSatisfying=function(Z,ue,he){var ye=null,Ie=null;try{var We=new De(ue,he)}catch{return null}return Z.forEach(function(Te){We.test(Te)&&(ye&&Ie.compare(Te)!==1||(Ie=new R(ye=Te,he)))}),ye},e.validRange=function(Z,ue){try{return new De(Z,ue).range||"*"}catch{return null}},e.ltr=function(Z,ue,he){return Ce(Z,ue,"<",he)},e.gtr=function(Z,ue,he){return Ce(Z,ue,">",he)},e.outside=Ce,e.prerelease=function(Z,ue){var he=H(Z,ue);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(Z,ue,he){return Z=new De(Z,he),ue=new De(ue,he),Z.intersects(ue)},e.coerce=function(Z){if(Z instanceof R)return Z;if(typeof Z!="string")return null;var ue=Z.match(k[N]);return ue==null?null:H((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,E(1))},function(q,e){var E,t,C=q.exports={};function A(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function k(p){if(E===setTimeout)return setTimeout(p,0);if((E===A||!E)&&setTimeout)return E=setTimeout,setTimeout(p,0);try{return E(p,0)}catch{try{return E.call(null,p,0)}catch{return E.call(this,p,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:A}catch{E=A}try{t=typeof clearTimeout=="function"?clearTimeout:M}catch{t=M}})();var w,v=[],S=!1,P=-1;function I(){S&&w&&(S=!1,w.length?v=w.concat(v):P=-1,v.length&&h())}function h(){if(!S){var p=k(I);S=!0;for(var u=v.length;u;){for(w=v,v=[];++P<u;)w&&w[P].run();P=-1,u=v.length}w=null,S=!1,function(b){if(t===clearTimeout)return clearTimeout(b);if((t===M||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(b);try{t(b)}catch{try{return t.call(null,b)}catch{return t.call(this,b)}}}(p)}}function m(p,u){this.fun=p,this.array=u}function f(){}C.nextTick=function(p){var u=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)u[b-1]=arguments[b];v.push(new m(p,u)),v.length!==1||S||k(h)},m.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=f,C.addListener=f,C.once=f,C.off=f,C.removeListener=f,C.removeAllListeners=f,C.emit=f,C.prependListener=f,C.prependOnceListener=f,C.listeners=function(p){return[]},C.binding=function(p){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(p){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(ee[125],te([0,1]),function(q,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(k,w,v){this.level=k,this.key=w,this.value=v,this.forward=[]}}const C=void 0;class A{constructor(k,w=2**16){this.comparator=k,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new t(this.c,C,C)}get size(){return this.f}clear(){this.e=new t(this.c,C,C)}has(k){return Boolean(A.g(this,k,this.comparator))}get(k){return A.g(this,k,this.comparator)?.value}set(k,w){return A.h(this,k,w,this.comparator)&&(this.f+=1),this}delete(k){const w=A.k(this,k,this.comparator);return w&&(this.f-=1),w}forEach(k,w){let v=this.e.forward[0];for(;v;)k.call(w,v.value,v.key,this),v=v.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",w=this.e.forward[0];for(;w;)k+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return k}static g(k,w,v){let S=k.e;for(let P=k.d-1;P>=0;P--)for(;S.forward[P]&&v(S.forward[P].key,w)<0;)S=S.forward[P];if(S=S.forward[0],S&&v(S.key,w)===0)return S}static h(k,w,v,S){const P=[];let I=k.e;for(let h=k.d-1;h>=0;h--){for(;I.forward[h]&&S(I.forward[h].key,w)<0;)I=I.forward[h];P[h]=I}if(I=I.forward[0],I&&S(I.key,w)===0)return I.value=v,!1;{const h=A.j(k);if(h>k.d){for(let m=k.d;m<h;m++)P[m]=k.e;k.d=h}I=new t(h,w,v);for(let m=0;m<h;m++)I.forward[m]=P[m].forward[m],P[m].forward[m]=I;return!0}}static j(k,w=.5){let v=1;for(;Math.random()<w&&v<k.c;)v+=1;return v}static k(k,w,v){const S=[];let P=k.e;for(let I=k.d-1;I>=0;I--){for(;P.forward[I]&&v(P.forward[I].key,w)<0;)P=P.forward[I];S[I]=P}if(P=P.forward[0],!P||v(P.key,w)!==0)return!1;for(let I=0;I<k.d&&S[I].forward[I]===P;I++)S[I].forward[I]=P.forward[I];for(;k.d>0&&k.e.forward[k.d-1]===C;)k.d-=1;return!0}}e.SkipList=A}),define(ee[57],te([0,1,15,2]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function C(d){const l=d;return l?typeof l.read=="function":!1}e.isReadable=C;function A(d){const l=d;return l?[l.on,l.pause,l.resume,l.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=A;function M(d){const l=d;return l?A(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=M;function k(d,l){return new w(d,l)}e.newWriteableStream=k;class w{constructor(l,n){this.e=l,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(n=>n(l))}h(l){this.c.error.length===0?(0,E.onUnexpectedError)(l):this.c.error.slice(0).forEach(n=>n(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,n){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(l,n){if(this.a.destroyed)return;let s;switch(l){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const i=s.indexOf(n);i>=0&&s.splice(i,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function v(d,l){const n=[];let s;for(;(s=d.read())!==null;)n.push(s);return l(n)}e.consumeReadable=v;function S(d,l,n){const s=[];let i;for(;(i=d.read())!==null&&s.length<n;)s.push(i);return i===null&&s.length>0?l(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i<"u"){const a=i;return i=void 0,a}return d.read()}}}e.peekReadable=S;function P(d,l){return new Promise((n,s)=>{const i=[];I(d,{onData:a=>{l&&i.push(a)},onError:a=>{l?s(a):n(void 0)},onEnd:()=>{n(l?l(i):void 0)}})})}e.consumeStream=P;function I(d,l){let n=!1;return d.on("error",s=>{n||l.onError(s)}),d.on("end",()=>{n||l.onEnd()}),d.on("data",s=>{n||l.onData(s)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=I;function h(d,l){return new Promise((n,s)=>{const i=new t.DisposableStore,a=[],r=y=>{if(a.push(y),a.length>l)return i.dispose(),d.pause(),n({stream:d,buffer:a,ended:!1})},c=y=>s(y),o=()=>n({stream:d,buffer:a,ended:!0});i.add((0,t.toDisposable)(()=>d.removeListener("error",c))),d.on("error",c),i.add((0,t.toDisposable)(()=>d.removeListener("end",o))),d.on("end",o),i.add((0,t.toDisposable)(()=>d.removeListener("data",r))),d.on("data",r)})}e.peekStream=h;function m(d,l){const n=k(l);return n.end(d),n}e.toStream=m;function f(){const d=k(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=f;function p(d){let l=!1;return{read:()=>l?null:(l=!0,d)}}e.toReadable=p;function u(d,l,n){const s=k(n);return I(d,{onData:i=>s.write(l.data(i)),onError:i=>s.error(l.error?l.error(i):i),onEnd:()=>s.end()}),s}e.transform=u;function b(d,l,n){let s=!1;return{read:()=>{const i=l.read();return s?i:(s=!0,i!==null?n([d,i]):d)}}}e.prefixedReadable=b;function g(d,l,n){let s=!1;const i=k(n);return I(l,{onData:a=>s?i.write(a):(s=!0,i.write(n([d,a]))),onError:a=>i.error(a),onEnd:()=>{s||(s=!0,i.write(d)),i.end()}}),i}e.prefixedStream=g}),define(ee[17],te([0,1,57]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let C,A;class M{static alloc(y){return t?new M(Buffer.allocUnsafe(y)):new M(new Uint8Array(y))}static wrap(y){return t&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new M(y)}static fromString(y,D){return!(D?.dontUseNodeBuffer||!1)&&t?new M(Buffer.from(y)):(C||(C=new TextEncoder),new M(C.encode(y)))}static fromByteArray(y){const D=M.alloc(y.length);for(let O=0,N=y.length;O<N;O++)D.buffer[O]=y[O];return D}static concat(y,D){if(typeof D>"u"){D=0;for(let Y=0,G=y.length;Y<G;Y++)D+=y[Y].byteLength}const O=M.alloc(D);let N=0;for(let Y=0,G=y.length;Y<G;Y++){const V=y[Y];O.set(V,N),N+=V.byteLength}return O}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=M.alloc(this.byteLength);return y.set(this),y}toString(){return t?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(y,D){return new M(this.buffer.subarray(y,D))}set(y,D){if(y instanceof M)this.buffer.set(y.buffer,D);else if(y instanceof Uint8Array)this.buffer.set(y,D);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),D);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return v(this.buffer,y)}writeUInt32BE(y,D){S(this.buffer,y,D)}readUInt32LE(y){return P(this.buffer,y)}writeUInt32LE(y,D){I(this.buffer,y,D)}readUInt8(y){return h(this.buffer,y)}writeUInt8(y,D){m(this.buffer,y,D)}}e.VSBuffer=M;function k(o,y){return o[y+0]<<0>>>0|o[y+1]<<8>>>0}e.readUInt16LE=k;function w(o,y,D){o[D+0]=y&255,y=y>>>8,o[D+1]=y&255}e.writeUInt16LE=w;function v(o,y){return o[y]*2**24+o[y+1]*2**16+o[y+2]*2**8+o[y+3]}e.readUInt32BE=v;function S(o,y,D){o[D+3]=y,y=y>>>8,o[D+2]=y,y=y>>>8,o[D+1]=y,y=y>>>8,o[D]=y}e.writeUInt32BE=S;function P(o,y){return o[y+0]<<0>>>0|o[y+1]<<8>>>0|o[y+2]<<16>>>0|o[y+3]<<24>>>0}e.readUInt32LE=P;function I(o,y,D){o[D+0]=y&255,y=y>>>8,o[D+1]=y&255,y=y>>>8,o[D+2]=y&255,y=y>>>8,o[D+3]=y&255}e.writeUInt32LE=I;function h(o,y){return o[y]}e.readUInt8=h;function m(o,y,D){o[D]=y}e.writeUInt8=m;function f(o){return E.consumeReadable(o,y=>M.concat(y))}e.readableToBuffer=f;function p(o){return E.toReadable(o)}e.bufferToReadable=p;function u(o){return E.consumeStream(o,y=>M.concat(y))}e.streamToBuffer=u;async function b(o){return o.ended?M.concat(o.buffer):M.concat([...o.buffer,await u(o.stream)])}e.bufferedStreamToBuffer=b;function g(o){return E.toStream(o,y=>M.concat(y))}e.bufferToStream=g;function d(o){return E.transform(o,{data:y=>typeof y=="string"?M.fromString(y):M.wrap(y)},y=>M.concat(y))}e.streamToBufferReadableStream=d;function l(o){return E.newWriteableStream(y=>M.concat(y),o)}e.newWriteableBufferStream=l;function n(o,y){return E.prefixedReadable(o,y,D=>M.concat(D))}e.prefixedBufferReadable=n;function s(o,y){return E.prefixedStream(o,y,D=>M.concat(D))}e.prefixedBufferStream=s;function i(o){let y=0,D=0,O=0;const N=new Uint8Array(Math.floor(o.length/4*3)),Y=V=>{switch(D){case 3:N[O++]=y|V,D=0;break;case 2:N[O++]=y|V>>>2,y=V<<6,D=3;break;case 1:N[O++]=y|V>>>4,y=V<<4,D=2;break;default:y=V<<2,D=1}};for(let V=0;V<o.length;V++){const se=o.charCodeAt(V);if(se>=65&&se<=90)Y(se-65);else if(se>=97&&se<=122)Y(se-97+26);else if(se>=48&&se<=57)Y(se-48+52);else if(se===43||se===45)Y(62);else if(se===47||se===95)Y(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${o[V]}`)}}const G=O;for(;D>0;)Y(0);return M.wrap(N).slice(0,G)}e.decodeBase64=i;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:o},y=!0,D=!1){const O=D?r:a;let N="";const Y=o.byteLength%3;let G=0;for(;G<o.byteLength-Y;G+=3){const V=o[G+0],se=o[G+1],oe=o[G+2];N+=O[V>>>2],N+=O[(V<<4|se>>>4)&63],N+=O[(se<<2|oe>>>6)&63],N+=O[oe&63]}if(Y===1){const V=o[G+0];N+=O[V>>>2],N+=O[V<<4&63],y&&(N+="==")}else if(Y===2){const V=o[G+0],se=o[G+1];N+=O[V>>>2],N+=O[(V<<4|se>>>4)&63],N+=O[se<<2&63],y&&(N+="=")}return N}e.encodeBase64=c}),define(ee[12],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(s){return typeof s=="string"}e.isString=E;function t(s){return Array.isArray(s)&&s.every(i=>E(i))}e.isStringArray=t;function C(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=C;function A(s){const i=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof i}e.isTypedArray=A;function M(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=M;function k(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=k;function w(s){return s===!0||s===!1}e.isBoolean=w;function v(s){return typeof s>"u"}e.isUndefined=v;function S(s){return!P(s)}e.isDefined=S;function P(s){return v(s)||s===null}e.isUndefinedOrNull=P;function I(s,i){if(!s)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=I;function h(s){if(P(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=h;function m(...s){const i=[];for(let a=0;a<s.length;a++){const r=s[a];if(P(r))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);i.push(r)}return i}e.assertAllDefined=m;const f=Object.prototype.hasOwnProperty;function p(s){if(!C(s))return!1;for(const i in s)if(f.call(s,i))return!1;return!0}e.isEmptyObject=p;function u(s){return typeof s=="function"}e.isFunction=u;function b(...s){return s.length>0&&s.every(u)}e.areFunctions=b;function g(s,i){const a=Math.min(s.length,i.length);for(let r=0;r<a;r++)d(s[r],i[r])}e.validateConstraints=g;function d(s,i){if(E(i)){if(typeof s!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(s instanceof i)return}catch{}if(!P(s)&&s.constructor===i||i.length===1&&i.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function l(s){return s===null?void 0:s}e.withNullAsUndefined=l;function n(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=n}),define(ee[50],te([0,1,12]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const b=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([g,d])=>{b[g]=d&&typeof d=="object"?t(d):d}),b}e.deepClone=t;function C(u){if(!u||typeof u!="object")return u;const b=[u];for(;b.length>0;){const g=b.shift();Object.freeze(g);for(const d in g)if(A.call(g,d)){const l=g[d];typeof l=="object"&&!Object.isFrozen(l)&&!(0,E.isTypedArray)(l)&&b.push(l)}}return u}e.deepFreeze=C;const A=Object.prototype.hasOwnProperty;function M(u,b){return k(u,b,new Set)}e.cloneAndChange=M;function k(u,b,g){if((0,E.isUndefinedOrNull)(u))return u;const d=b(u);if(typeof d<"u")return d;if(Array.isArray(u)){const l=[];for(const n of u)l.push(k(n,b,g));return l}if((0,E.isObject)(u)){if(g.has(u))throw new Error("Cannot clone recursive data-structure");g.add(u);const l={};for(const n in u)A.call(u,n)&&(l[n]=k(u[n],b,g));return g.delete(u),l}return u}function w(u,b,g=!0){return(0,E.isObject)(u)?((0,E.isObject)(b)&&Object.keys(b).forEach(d=>{d in u?g&&((0,E.isObject)(u[d])&&(0,E.isObject)(b[d])?w(u[d],b[d],g):u[d]=b[d]):u[d]=b[d]}),u):b}e.mixin=w;function v(u,b){if(u===b)return!0;if(u==null||b===null||b===void 0||typeof u!=typeof b||typeof u!="object"||Array.isArray(u)!==Array.isArray(b))return!1;let g,d;if(Array.isArray(u)){if(u.length!==b.length)return!1;for(g=0;g<u.length;g++)if(!v(u[g],b[g]))return!1}else{const l=[];for(d in u)l.push(d);l.sort();const n=[];for(d in b)n.push(d);if(n.sort(),!v(l,n))return!1;for(g=0;g<l.length;g++)if(!v(u[l[g]],b[l[g]]))return!1}return!0}e.equals=v;function S(u){const b=new Set;return JSON.stringify(u,(g,d)=>{if((0,E.isObject)(d)||Array.isArray(d)){if(b.has(d))return"[Circular]";b.add(d)}return d})}e.safeStringify=S;function P(u,b){const g=Object.create(null);return!u||!b||Object.keys(b).forEach(l=>{const n=u[l],s=b[l];v(n,s)||(g[l]=s)}),g}e.distinct=P;function I(u,b){const g=b.toLowerCase(),d=Object.keys(u).find(l=>l.toLowerCase()===g);return d?u[d]:u[b]}e.getCaseInsensitive=I;function h(u,b){const g=Object.create(null);for(const[d,l]of Object.entries(u))b(d,l)&&(g[d]=l);return g}e.filter=h;function m(u){let b=[],g=Object.getPrototypeOf(u);for(;Object.prototype!==g;)b=b.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return b}e.getAllPropertyNames=m;function f(u){const b=[];for(const g of m(u))typeof u[g]=="function"&&b.push(g);return b}e.getAllMethodNames=f;function p(u,b){const g=l=>function(){const n=Array.prototype.slice.call(arguments,0);return b(l,n)},d={};for(const l of u)d[l]=g(l);return d}e.createProxyObject=p}),define(ee[29],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return E.test(C)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(k){for(let w=0;w<k.length;w++)k[w]=Math.floor(Math.random()*256);return k};const A=new Uint8Array(16),M=[];for(let k=0;k<256;k++)M.push(k.toString(16).padStart(2,"0"));return function(){C(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let w=0,v="";return v+=M[A[w++]],v+=M[A[w++]],v+=M[A[w++]],v+=M[A[w++]],v+="-",v+=M[A[w++]],v+=M[A[w++]],v+="-",v+=M[A[w++]],v+=M[A[w++]],v+="-",v+=M[A[w++]],v+=M[A[w++]],v+="-",v+=M[A[w++]],v+=M[A[w++]],v+=M[A[w++]],v+=M[A[w++]],v+=M[A[w++]],v+=M[A[w++]],v}}()}),define(ee[126],te([0,1,77,39,49]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function A(M,k){if(await new Promise((S,P)=>{const I=t.createReadStream(M),h=E.createHash("sha1");I.pipe(h);const m=(0,C.once)((f,p)=>{I.removeAllListeners(),h.removeAllListeners(),f?P(f):S(p)});I.once("error",m),I.once("end",m),h.once("error",m),h.once("data",f=>m(void 0,f.toString("hex")))})!==k)throw new Error("Hash mismatch")}e.checksum=A}),define(ee[127],te([0,1,27]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function C(M){const k=M.replace(/\-/g,":").toLowerCase();return!t.has(k)}function A(){const M=(0,E.networkInterfaces)();for(const k in M){const w=M[k];if(w){for(const{mac:v}of w)if(C(v))return v}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ee[95],te([0,1,78]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(k,w,v,S=1){let P=!1;return new Promise(I=>{const h=setTimeout(()=>{if(!P)return P=!0,I(0)},v);C(k,w,S,m=>{if(!P)return P=!0,clearTimeout(h),I(m)})})}e.findFreePort=t;function C(k,w,v,S){if(w===0)return S(0);const P=new E.Socket;P.once("connect",()=>(M(P),C(k+v,w-1,v,S))),P.once("data",()=>{}),P.once("error",I=>(M(P),I.code!=="ECONNREFUSED"?C(k+v,w-1,v,S):S(k))),P.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(k,w,v,S="127.0.0.1"){let P=!1,I,h=1;const m=E.createServer({pauseOnConnect:!0});function f(p,u){P||(P=!0,m.removeAllListeners(),m.close(),I&&clearTimeout(I),u(p))}return new Promise(p=>{I=setTimeout(()=>{f(0,p)},v),m.on("listening",()=>{f(k,p)}),m.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&h<w?(k++,h++,m.listen(k,S)):f(0,p)}),m.on("close",()=>{f(0,p)}),m.listen(k,S)})}e.findFreePortFaster=A;function M(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(w){console.error(w)}}}),define(ee[128],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[129],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(C,A){this.a=C,this.onMessage=A}send(C){try{this.a.send("vscode:message",C.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=E}),define(ee[40],te([0,1,13,15]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class C{constructor(){this.a=new WeakMap}on(M,k){const w=(v,...S)=>{this.b(M,v)&&k(v,...S)};return this.a.set(k,w),E.ipcMain.on(M,w),this}once(M,k){return E.ipcMain.once(M,(w,...v)=>{this.b(M,w)&&k(w,...v)}),this}handle(M,k){return E.ipcMain.handle(M,(w,...v)=>this.b(M,w)?k(w,...v):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return E.ipcMain.removeHandler(M),this}removeListener(M,k){const w=this.a.get(k);return w&&(E.ipcMain.removeListener(M,w),this.a.delete(k)),this}b(M,k){if(!M||!M.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const w=k.senderFrame,v=w.url;if(!v)return!0;let S="unknown";try{S=new URL(v).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${v}'.`),!1}return S!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${S}'.`),!1):w.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${S}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new C}),define(ee[130],te([0,1,13,40,12,128]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){t.validatedIpcMain.on(A.CONTEXT_MENU_CHANNEL,(w,v,S,P,I)=>{const h=k(w,P,S);h.popup({window:(0,C.withNullAsUndefined)(E.BrowserWindow.fromWebContents(w.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{h&&w.sender.send(A.CONTEXT_MENU_CLOSE_CHANNEL,v)}})})}e.registerContextMenuListener=M;function k(w,v,S){const P=new E.Menu;return S.forEach(I=>{let h;I.type==="separator"?h=new E.MenuItem({type:I.type}):Array.isArray(I.submenu)?h=new E.MenuItem({submenu:k(w,v,I.submenu),label:I.label}):h=new E.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(m,f,p)=>w.sender.send(v,I.id,p)}),P.append(h)}),P}}),define(ee[131],te([11,10]),function(q,e){return q.create("vs/base/common/date",e)}),define(ee[132],te([0,1,131]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,C=t*60,A=C*24,M=A*7,k=A*30,w=A*365;function v(P,I,h){typeof P!="number"&&(P=P.getTime());const m=Math.round((new Date().getTime()-P)/1e3);if(m<-30)return(0,E.localize)(0,null,v(new Date().getTime()+m*1e3,!1));if(m<30)return(0,E.localize)(1,null);let f;return m<t?(f=m,I?f===1?h?(0,E.localize)(2,null,f):(0,E.localize)(3,null,f):h?(0,E.localize)(4,null,f):(0,E.localize)(5,null,f):f===1?h?(0,E.localize)(6,null,f):(0,E.localize)(7,null,f):h?(0,E.localize)(8,null,f):(0,E.localize)(9,null,f)):m<C?(f=Math.floor(m/t),I?f===1?h?(0,E.localize)(10,null,f):(0,E.localize)(11,null,f):h?(0,E.localize)(12,null,f):(0,E.localize)(13,null,f):f===1?h?(0,E.localize)(14,null,f):(0,E.localize)(15,null,f):h?(0,E.localize)(16,null,f):(0,E.localize)(17,null,f)):m<A?(f=Math.floor(m/C),I?f===1?h?(0,E.localize)(18,null,f):(0,E.localize)(19,null,f):h?(0,E.localize)(20,null,f):(0,E.localize)(21,null,f):f===1?h?(0,E.localize)(22,null,f):(0,E.localize)(23,null,f):h?(0,E.localize)(24,null,f):(0,E.localize)(25,null,f)):m<M?(f=Math.floor(m/A),I?f===1?(0,E.localize)(26,null,f):(0,E.localize)(27,null,f):f===1?(0,E.localize)(28,null,f):(0,E.localize)(29,null,f)):m<k?(f=Math.floor(m/M),I?f===1?h?(0,E.localize)(30,null,f):(0,E.localize)(31,null,f):h?(0,E.localize)(32,null,f):(0,E.localize)(33,null,f):f===1?h?(0,E.localize)(34,null,f):(0,E.localize)(35,null,f):h?(0,E.localize)(36,null,f):(0,E.localize)(37,null,f)):m<w?(f=Math.floor(m/k),I?f===1?h?(0,E.localize)(38,null,f):(0,E.localize)(39,null,f):h?(0,E.localize)(40,null,f):(0,E.localize)(41,null,f):f===1?h?(0,E.localize)(42,null,f):(0,E.localize)(43,null,f):h?(0,E.localize)(44,null,f):(0,E.localize)(45,null,f)):(f=Math.floor(m/w),I?f===1?h?(0,E.localize)(46,null,f):(0,E.localize)(47,null,f):h?(0,E.localize)(48,null,f):(0,E.localize)(49,null,f):f===1?h?(0,E.localize)(50,null,f):(0,E.localize)(51,null,f):h?(0,E.localize)(52,null,f):(0,E.localize)(53,null,f))}e.fromNow=v;function S(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=S}),define(ee[133],te([11,10]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(ee[43],te([0,1,24,12,133]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(P,I){return I&&(P.stack||P.stacktrace)?C.localize(0,null,k(P),M(P.stack)||M(P.stacktrace)):k(P)}function M(P){return Array.isArray(P)?P.join(`
`):P}function k(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?C.localize(1,null,P.message):P.message||C.localize(2,null)}function w(P=null,I=!1){if(!P)return C.localize(3,null);if(Array.isArray(P)){const h=E.coalesce(P),m=w(h[0],I);return h.length>1?C.localize(4,null,m,h.length):m}if(t.isString(P))return P;if(P.detail){const h=P.detail;if(h.error)return A(h.error,I);if(h.exception)return A(h.exception,I)}return P.stack?A(P,I):P.message?P.message:C.localize(5,null)}e.toErrorMessage=w;function v(P){const I=P;return I instanceof Error&&Array.isArray(I.actions)}e.isErrorWithActions=v;function S(P,I){let h;return typeof P=="string"?h=new Error(P):h=P,h.actions=I,h}e.createErrorWithActions=S}),define(ee[134],te([11,10]),function(q,e){return q.create("vs/base/common/jsonErrorMessages",e)}),define(ee[135],te([0,1,134]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(C){switch(C){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ee[136],te([11,10]),function(q,e){return q.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,136]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,C=!1,A=!1,M=!1,k=!1,w=!1,v=!1,S=!1,P=!1,I=!1,h,m=e.LANGUAGE_DEFAULT,f,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const b=typeof u?.versions?.electron=="string",g=b&&u?.type==="renderer";if(typeof navigator=="object"&&!g)p=navigator.userAgent,t=p.indexOf("Windows")>=0,C=p.indexOf("Macintosh")>=0,S=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=p.indexOf("Linux")>=0,I=p?.indexOf("Mobi")>=0,w=!0,h=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,m=h;else if(typeof u=="object"){t=u.platform==="win32",C=u.platform==="darwin",A=u.platform==="linux",M=A&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,v=b,P=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.LANGUAGE_DEFAULT,m=e.LANGUAGE_DEFAULT;const o=u.env.VSCODE_NLS_CONFIG;if(o)try{const y=JSON.parse(o),D=y.availableLanguages["*"];h=y.locale,m=D||e.LANGUAGE_DEFAULT,f=y._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var d;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function l(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let n=0;C?n=1:t?n=3:A&&(n=2),e.isWindows=t,e.isMacintosh=C,e.isLinux=A,e.isLinuxSnap=M,e.isNative=k,e.isElectron=v,e.isWeb=w,e.isWebWorker=w&&typeof e.globals.importScripts=="function",e.isIOS=S,e.isMobile=I,e.isCI=P,e.platform=n,e.userAgent=p,e.language=m;var s;(function(o){function y(){return e.language}o.value=y;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=D;function O(){return e.language==="en"}o.isDefault=O})(s=e.Language||(e.Language={})),e.locale=h,e.translationsConfigFile=f,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let O=0,N=o.length;O<N;O++){const Y=o[O];if(Y.id===D.data.vscodeScheduleAsyncWork){o.splice(O,1),Y.callback();return}}});let y=0;return D=>{const O=++y;o.push({id:O,callback:D}),e.globals.postMessage({vscodeScheduleAsyncWork:O},"*")}}return o=>setTimeout(o)})();var i;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||S?2:t?1:3;let a=!0,r=!1;function c(){if(!r){r=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,a=new Uint16Array(o.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[32],te([0,1,4]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const C=E.globals.vscode.process;t={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ee[9],te([0,1,32]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,C=97,A=90,M=122,k=46,w=47,v=92,S=58,P=63;class I extends Error{constructor(d,l,n){let s;typeof l=="string"&&l.indexOf("not ")===0?(s="must not be",l=l.replace(/^not /,"")):s="must be";const i=d.indexOf(".")!==-1?"property":"argument";let a=`The "${d}" ${i} ${s} of type ${l}`;a+=`. Received type ${typeof n}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(g,d){if(typeof g!="string")throw new I(d,"string",g)}function m(g){return g===w||g===v}function f(g){return g===w}function p(g){return g>=t&&g<=A||g>=C&&g<=M}function u(g,d,l,n){let s="",i=0,a=-1,r=0,c=0;for(let o=0;o<=g.length;++o){if(o<g.length)c=g.charCodeAt(o);else{if(n(c))break;c=w}if(n(c)){if(!(a===o-1||r===1))if(r===2){if(s.length<2||i!==2||s.charCodeAt(s.length-1)!==k||s.charCodeAt(s.length-2)!==k){if(s.length>2){const y=s.lastIndexOf(l);y===-1?(s="",i=0):(s=s.slice(0,y),i=s.length-1-s.lastIndexOf(l)),a=o,r=0;continue}else if(s.length!==0){s="",i=0,a=o,r=0;continue}}d&&(s+=s.length>0?`${l}..`:"..",i=2)}else s.length>0?s+=`${l}${g.slice(a+1,o)}`:s=g.slice(a+1,o),i=o-a-1;a=o,r=0}else c===k&&r!==-1?++r:r=-1}return s}function b(g,d){if(d===null||typeof d!="object")throw new I("pathObject","Object",d);const l=d.dir||d.root,n=d.base||`${d.name||""}${d.ext||""}`;return l?l===d.root?`${l}${n}`:`${l}${g}${n}`:n}e.win32={resolve(...g){let d="",l="",n=!1;for(let s=g.length-1;s>=-1;s--){let i;if(s>=0){if(i=g[s],h(i,"path"),i.length===0)continue}else d.length===0?i=E.cwd():(i=E.env[`=${d}`]||E.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==d.toLowerCase()&&i.charCodeAt(2)===v)&&(i=`${d}\\`));const a=i.length;let r=0,c="",o=!1;const y=i.charCodeAt(0);if(a===1)m(y)&&(r=1,o=!0);else if(m(y))if(o=!0,m(i.charCodeAt(1))){let D=2,O=D;for(;D<a&&!m(i.charCodeAt(D));)D++;if(D<a&&D!==O){const N=i.slice(O,D);for(O=D;D<a&&m(i.charCodeAt(D));)D++;if(D<a&&D!==O){for(O=D;D<a&&!m(i.charCodeAt(D));)D++;(D===a||D!==O)&&(c=`\\\\${N}\\${i.slice(O,D)}`,r=D)}}}else r=1;else p(y)&&i.charCodeAt(1)===S&&(c=i.slice(0,2),r=2,a>2&&m(i.charCodeAt(2))&&(o=!0,r=3));if(c.length>0)if(d.length>0){if(c.toLowerCase()!==d.toLowerCase())continue}else d=c;if(n){if(d.length>0)break}else if(l=`${i.slice(r)}\\${l}`,n=o,o&&d.length>0)break}return l=u(l,!n,"\\",m),n?`${d}\\${l}`:`${d}${l}`||"."},normalize(g){h(g,"path");const d=g.length;if(d===0)return".";let l=0,n,s=!1;const i=g.charCodeAt(0);if(d===1)return f(i)?"\\":g;if(m(i))if(s=!0,m(g.charCodeAt(1))){let r=2,c=r;for(;r<d&&!m(g.charCodeAt(r));)r++;if(r<d&&r!==c){const o=g.slice(c,r);for(c=r;r<d&&m(g.charCodeAt(r));)r++;if(r<d&&r!==c){for(c=r;r<d&&!m(g.charCodeAt(r));)r++;if(r===d)return`\\\\${o}\\${g.slice(c)}\\`;r!==c&&(n=`\\\\${o}\\${g.slice(c,r)}`,l=r)}}}else l=1;else p(i)&&g.charCodeAt(1)===S&&(n=g.slice(0,2),l=2,d>2&&m(g.charCodeAt(2))&&(s=!0,l=3));let a=l<d?u(g.slice(l),!s,"\\",m):"";return a.length===0&&!s&&(a="."),a.length>0&&m(g.charCodeAt(d-1))&&(a+="\\"),n===void 0?s?`\\${a}`:a:s?`${n}\\${a}`:`${n}${a}`},isAbsolute(g){h(g,"path");const d=g.length;if(d===0)return!1;const l=g.charCodeAt(0);return m(l)||d>2&&p(l)&&g.charCodeAt(1)===S&&m(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let d,l;for(let i=0;i<g.length;++i){const a=g[i];h(a,"path"),a.length>0&&(d===void 0?d=l=a:d+=`\\${a}`)}if(d===void 0)return".";let n=!0,s=0;if(typeof l=="string"&&m(l.charCodeAt(0))){++s;const i=l.length;i>1&&m(l.charCodeAt(1))&&(++s,i>2&&(m(l.charCodeAt(2))?++s:n=!1))}if(n){for(;s<d.length&&m(d.charCodeAt(s));)s++;s>=2&&(d=`\\${d.slice(s)}`)}return e.win32.normalize(d)},relative(g,d){if(h(g,"from"),h(d,"to"),g===d)return"";const l=e.win32.resolve(g),n=e.win32.resolve(d);if(l===n||(g=l.toLowerCase(),d=n.toLowerCase(),g===d))return"";let s=0;for(;s<g.length&&g.charCodeAt(s)===v;)s++;let i=g.length;for(;i-1>s&&g.charCodeAt(i-1)===v;)i--;const a=i-s;let r=0;for(;r<d.length&&d.charCodeAt(r)===v;)r++;let c=d.length;for(;c-1>r&&d.charCodeAt(c-1)===v;)c--;const o=c-r,y=a<o?a:o;let D=-1,O=0;for(;O<y;O++){const Y=g.charCodeAt(s+O);if(Y!==d.charCodeAt(r+O))break;Y===v&&(D=O)}if(O!==y){if(D===-1)return n}else{if(o>y){if(d.charCodeAt(r+O)===v)return n.slice(r+O+1);if(O===2)return n.slice(r+O)}a>y&&(g.charCodeAt(s+O)===v?D=O:O===2&&(D=3)),D===-1&&(D=0)}let N="";for(O=s+D+1;O<=i;++O)(O===i||g.charCodeAt(O)===v)&&(N+=N.length===0?"..":"\\..");return r+=D,N.length>0?`${N}${n.slice(r,c)}`:(n.charCodeAt(r)===v&&++r,n.slice(r,c))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const d=e.win32.resolve(g);if(d.length<=2)return g;if(d.charCodeAt(0)===v){if(d.charCodeAt(1)===v){const l=d.charCodeAt(2);if(l!==P&&l!==k)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(p(d.charCodeAt(0))&&d.charCodeAt(1)===S&&d.charCodeAt(2)===v)return`\\\\?\\${d}`;return g},dirname(g){h(g,"path");const d=g.length;if(d===0)return".";let l=-1,n=0;const s=g.charCodeAt(0);if(d===1)return m(s)?g:".";if(m(s)){if(l=n=1,m(g.charCodeAt(1))){let r=2,c=r;for(;r<d&&!m(g.charCodeAt(r));)r++;if(r<d&&r!==c){for(c=r;r<d&&m(g.charCodeAt(r));)r++;if(r<d&&r!==c){for(c=r;r<d&&!m(g.charCodeAt(r));)r++;if(r===d)return g;r!==c&&(l=n=r+1)}}}}else p(s)&&g.charCodeAt(1)===S&&(l=d>2&&m(g.charCodeAt(2))?3:2,n=l);let i=-1,a=!0;for(let r=d-1;r>=n;--r)if(m(g.charCodeAt(r))){if(!a){i=r;break}}else a=!1;if(i===-1){if(l===-1)return".";i=l}return g.slice(0,i)},basename(g,d){d!==void 0&&h(d,"ext"),h(g,"path");let l=0,n=-1,s=!0,i;if(g.length>=2&&p(g.charCodeAt(0))&&g.charCodeAt(1)===S&&(l=2),d!==void 0&&d.length>0&&d.length<=g.length){if(d===g)return"";let a=d.length-1,r=-1;for(i=g.length-1;i>=l;--i){const c=g.charCodeAt(i);if(m(c)){if(!s){l=i+1;break}}else r===-1&&(s=!1,r=i+1),a>=0&&(c===d.charCodeAt(a)?--a===-1&&(n=i):(a=-1,n=r))}return l===n?n=r:n===-1&&(n=g.length),g.slice(l,n)}for(i=g.length-1;i>=l;--i)if(m(g.charCodeAt(i))){if(!s){l=i+1;break}}else n===-1&&(s=!1,n=i+1);return n===-1?"":g.slice(l,n)},extname(g){h(g,"path");let d=0,l=-1,n=0,s=-1,i=!0,a=0;g.length>=2&&g.charCodeAt(1)===S&&p(g.charCodeAt(0))&&(d=n=2);for(let r=g.length-1;r>=d;--r){const c=g.charCodeAt(r);if(m(c)){if(!i){n=r+1;break}continue}s===-1&&(i=!1,s=r+1),c===k?l===-1?l=r:a!==1&&(a=1):l!==-1&&(a=-1)}return l===-1||s===-1||a===0||a===1&&l===s-1&&l===n+1?"":g.slice(l,s)},format:b.bind(null,"\\"),parse(g){h(g,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return d;const l=g.length;let n=0,s=g.charCodeAt(0);if(l===1)return m(s)?(d.root=d.dir=g,d):(d.base=d.name=g,d);if(m(s)){if(n=1,m(g.charCodeAt(1))){let D=2,O=D;for(;D<l&&!m(g.charCodeAt(D));)D++;if(D<l&&D!==O){for(O=D;D<l&&m(g.charCodeAt(D));)D++;if(D<l&&D!==O){for(O=D;D<l&&!m(g.charCodeAt(D));)D++;D===l?n=D:D!==O&&(n=D+1)}}}}else if(p(s)&&g.charCodeAt(1)===S){if(l<=2)return d.root=d.dir=g,d;if(n=2,m(g.charCodeAt(2))){if(l===3)return d.root=d.dir=g,d;n=3}}n>0&&(d.root=g.slice(0,n));let i=-1,a=n,r=-1,c=!0,o=g.length-1,y=0;for(;o>=n;--o){if(s=g.charCodeAt(o),m(s)){if(!c){a=o+1;break}continue}r===-1&&(c=!1,r=o+1),s===k?i===-1?i=o:y!==1&&(y=1):i!==-1&&(y=-1)}return r!==-1&&(i===-1||y===0||y===1&&i===r-1&&i===a+1?d.base=d.name=g.slice(a,r):(d.name=g.slice(a,i),d.base=g.slice(a,r),d.ext=g.slice(i,r))),a>0&&a!==n?d.dir=g.slice(0,a-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let d="",l=!1;for(let n=g.length-1;n>=-1&&!l;n--){const s=n>=0?g[n]:E.cwd();h(s,"path"),s.length!==0&&(d=`${s}/${d}`,l=s.charCodeAt(0)===w)}return d=u(d,!l,"/",f),l?`/${d}`:d.length>0?d:"."},normalize(g){if(h(g,"path"),g.length===0)return".";const d=g.charCodeAt(0)===w,l=g.charCodeAt(g.length-1)===w;return g=u(g,!d,"/",f),g.length===0?d?"/":l?"./":".":(l&&(g+="/"),d?`/${g}`:g)},isAbsolute(g){return h(g,"path"),g.length>0&&g.charCodeAt(0)===w},join(...g){if(g.length===0)return".";let d;for(let l=0;l<g.length;++l){const n=g[l];h(n,"path"),n.length>0&&(d===void 0?d=n:d+=`/${n}`)}return d===void 0?".":e.posix.normalize(d)},relative(g,d){if(h(g,"from"),h(d,"to"),g===d||(g=e.posix.resolve(g),d=e.posix.resolve(d),g===d))return"";const l=1,n=g.length,s=n-l,i=1,a=d.length-i,r=s<a?s:a;let c=-1,o=0;for(;o<r;o++){const D=g.charCodeAt(l+o);if(D!==d.charCodeAt(i+o))break;D===w&&(c=o)}if(o===r)if(a>r){if(d.charCodeAt(i+o)===w)return d.slice(i+o+1);if(o===0)return d.slice(i+o)}else s>r&&(g.charCodeAt(l+o)===w?c=o:o===0&&(c=0));let y="";for(o=l+c+1;o<=n;++o)(o===n||g.charCodeAt(o)===w)&&(y+=y.length===0?"..":"/..");return`${y}${d.slice(i+c)}`},toNamespacedPath(g){return g},dirname(g){if(h(g,"path"),g.length===0)return".";const d=g.charCodeAt(0)===w;let l=-1,n=!0;for(let s=g.length-1;s>=1;--s)if(g.charCodeAt(s)===w){if(!n){l=s;break}}else n=!1;return l===-1?d?"/":".":d&&l===1?"//":g.slice(0,l)},basename(g,d){d!==void 0&&h(d,"ext"),h(g,"path");let l=0,n=-1,s=!0,i;if(d!==void 0&&d.length>0&&d.length<=g.length){if(d===g)return"";let a=d.length-1,r=-1;for(i=g.length-1;i>=0;--i){const c=g.charCodeAt(i);if(c===w){if(!s){l=i+1;break}}else r===-1&&(s=!1,r=i+1),a>=0&&(c===d.charCodeAt(a)?--a===-1&&(n=i):(a=-1,n=r))}return l===n?n=r:n===-1&&(n=g.length),g.slice(l,n)}for(i=g.length-1;i>=0;--i)if(g.charCodeAt(i)===w){if(!s){l=i+1;break}}else n===-1&&(s=!1,n=i+1);return n===-1?"":g.slice(l,n)},extname(g){h(g,"path");let d=-1,l=0,n=-1,s=!0,i=0;for(let a=g.length-1;a>=0;--a){const r=g.charCodeAt(a);if(r===w){if(!s){l=a+1;break}continue}n===-1&&(s=!1,n=a+1),r===k?d===-1?d=a:i!==1&&(i=1):d!==-1&&(i=-1)}return d===-1||n===-1||i===0||i===1&&d===n-1&&d===l+1?"":g.slice(d,n)},format:b.bind(null,"/"),parse(g){h(g,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return d;const l=g.charCodeAt(0)===w;let n;l?(d.root="/",n=1):n=0;let s=-1,i=0,a=-1,r=!0,c=g.length-1,o=0;for(;c>=n;--c){const y=g.charCodeAt(c);if(y===w){if(!r){i=c+1;break}continue}a===-1&&(r=!1,a=c+1),y===k?s===-1?s=c:o!==1&&(o=1):s!==-1&&(o=-1)}if(a!==-1){const y=i===0&&l?1:i;s===-1||o===0||o===1&&s===a-1&&s===i+1?d.base=d.name=g.slice(y,a):(d.name=g.slice(y,s),d.base=g.slice(y,a),d.ext=g.slice(s,a))}return i>0?d.dir=g.slice(0,i-1):l&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ee[79],te([0,1,4]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var C;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(C=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(k,...w){const v=w.reduce((I,h)=>(I[h]=!0,I),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(I=>!v[I]).forEach(I=>{for(let h=0;h<S.length;h++)if(I.search(S[h])!==-1){delete k[I];break}})}e.sanitizeProcessEnvironment=A;function M(k){!k||(delete k.DEBUG,E.isMacintosh&&delete k.DYLD_LIBRARY_PATH,E.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(ee[80],te([0,1,4]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=E.globals.performance&&typeof E.globals.performance.now=="function";class C{static create(M=!0){return new C(M)}constructor(M){this.a=t&&M,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}e.StopWatch=C}),define(ee[3],te([0,1,15,49,2,94,80]),function(q,e,E,t,C,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,w=!1;var v;(function(c){c.None=()=>C.Disposable.None;function o(z){if(w){const{onDidAddListener:J}=z,ne=m.create();let j=0;z.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ne.print()),J?.()}}}function y(z,J){return re(z,()=>{},0,void 0,void 0,J)}c.defer=y;function D(z){return(J,ne=null,j)=>{let x=!1,_;return _=z(ae=>{if(!x)return _?_.dispose():x=!0,J.call(ne,ae)},null,j),x&&_.dispose(),_}}c.once=D;function O(z,J,ne){return oe((j,x=null,_)=>z(ae=>j.call(x,J(ae)),null,_),ne)}c.map=O;function N(z,J,ne){return oe((j,x=null,_)=>z(ae=>{J(ae),j.call(x,ae)},null,_),ne)}c.forEach=N;function Y(z,J,ne){return oe((j,x=null,_)=>z(ae=>J(ae)&&j.call(x,ae),null,_),ne)}c.filter=Y;function G(z){return z}c.signal=G;function V(...z){return(J,ne=null,j)=>(0,C.combinedDisposable)(...z.map(x=>x(_=>J.call(ne,_),null,j)))}c.any=V;function se(z,J,ne,j){let x=ne;return O(z,_=>(x=J(x,_),x),j)}c.reduce=se;function oe(z,J){let ne;const j={onWillAddFirstListener(){ne=z(x.fire,x)},onDidRemoveLastListener(){ne?.dispose()}};J||o(j);const x=new p(j);return J?.add(x),x.event}function re(z,J,ne=100,j=!1,x,_){let ae,ge,Me,Oe=0;const De={leakWarningThreshold:x,onWillAddFirstListener(){ae=z(ve=>{Oe++,ge=J(ge,ve),j&&!Me&&(Re.fire(ge),ge=void 0),clearTimeout(Me),Me=setTimeout(()=>{const we=ge;ge=void 0,Me=void 0,(!j||Oe>1)&&Re.fire(we),Oe=0},ne)})},onDidRemoveLastListener(){ae.dispose()}};_||o(De);const Re=new p(De);return _?.add(Re),Re.event}c.debounce=re;function de(z,J=0,ne){return c.debounce(z,(j,x)=>j?(j.push(x),j):[x],J,void 0,void 0,ne)}c.accumulate=de;function X(z,J=(j,x)=>j===x,ne){let j=!0,x;return Y(z,_=>{const ae=j||!J(_,x);return j=!1,x=_,ae},ne)}c.latch=X;function le(z,J,ne){return[c.filter(z,J,ne),c.filter(z,j=>!J(j),ne)]}c.split=le;function W(z,J=!1,ne=[]){let j=ne.slice(),x=z(ge=>{j?j.push(ge):ae.fire(ge)});const _=()=>{j?.forEach(ge=>ae.fire(ge)),j=null},ae=new p({onWillAddFirstListener(){x||(x=z(ge=>ae.fire(ge)))},onDidAddFirstListener(){j&&(J?setTimeout(_):_())},onDidRemoveLastListener(){x&&x.dispose(),x=null}});return ae.event}c.buffer=W;class L{constructor(J){this.event=J,this.c=new C.DisposableStore}map(J){return new L(O(this.event,J,this.c))}forEach(J){return new L(N(this.event,J,this.c))}filter(J){return new L(Y(this.event,J,this.c))}reduce(J,ne){return new L(se(this.event,J,ne,this.c))}latch(){return new L(X(this.event,void 0,this.c))}debounce(J,ne=100,j=!1,x){return new L(re(this.event,J,ne,j,x,this.c))}on(J,ne,j){return this.event(J,ne,j)}once(J,ne,j){return D(this.event)(J,ne,j)}dispose(){this.c.dispose()}}function T(z){return new L(z)}c.chain=T;function U(z,J,ne=j=>j){const j=(...ge)=>ae.fire(ne(...ge)),x=()=>z.on(J,j),_=()=>z.removeListener(J,j),ae=new p({onWillAddFirstListener:x,onDidRemoveLastListener:_});return ae.event}c.fromNodeEventEmitter=U;function Q(z,J,ne=j=>j){const j=(...ge)=>ae.fire(ne(...ge)),x=()=>z.addEventListener(J,j),_=()=>z.removeEventListener(J,j),ae=new p({onWillAddFirstListener:x,onDidRemoveLastListener:_});return ae.event}c.fromDOMEventEmitter=Q;function B(z){return new Promise(J=>D(z)(J))}c.toPromise=B;function H(z,J){return J(void 0),z(ne=>J(ne))}c.runAndSubscribe=H;function R(z,J){let ne=null;function j(_){ne?.dispose(),ne=new C.DisposableStore,J(_,ne)}j(void 0);const x=z(_=>j(_));return(0,C.toDisposable)(()=>{x.dispose(),ne?.dispose()})}c.runAndSubscribeWithStore=R;class F{constructor(J,ne){this.obs=J,this.c=0,this.d=!1;const j={onWillAddFirstListener:()=>{J.addObserver(this)},onDidRemoveLastListener:()=>{J.removeObserver(this)}};ne||o(j),this.emitter=new p(j),ne&&ne.add(this.emitter)}beginUpdate(J){this.c++}handleChange(J,ne){this.d=!0}endUpdate(J){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function $(z,J){return new F(z,J).emitter.event}c.fromObservable=$})(v=e.Event||(e.Event={}));class S{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${S.c++}`,S.all.add(this)}start(o){this.d=new M.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=S,S.all=new Set,S.c=0;let P=-1;function I(c){const o=P;return P=c,{dispose(){P=o}}}e.setGlobalLeakWarningThreshold=I;class h{constructor(o,y=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=y,this.d=0}dispose(){this.c?.clear()}check(o,y){const D=this.threshold;if(D<=0||y<D)return;this.c||(this.c=new Map);const O=this.c.get(o.value)||0;if(this.c.set(o.value,O+1),this.d-=1,this.d<=0){this.d=D*.5;let N,Y=0;for(const[G,V]of this.c)(!N||Y<V)&&(N=G,Y=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${Y}):`),console.warn(N)}return()=>{const N=this.c.get(o.value)||0;this.c.set(o.value,N-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f{constructor(o,y,D){this.callback=o,this.callbackThis=y,this.stack=D,this.subscription=new C.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class p{constructor(o){this.j=!1,this.d=o,this.f=P>0||this.d?.leakWarningThreshold?new h(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new S(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(k){const o=Array.from(this.q);queueMicrotask(()=>{for(const y of o)y.subscription.isset()&&(y.subscription.unset(),y.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,y,D)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),C.Disposable.None;const O=this.q.isEmpty();O&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let N,Y;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(Y=m.create(),N=this.f.check(Y,this.q.size+1)),k&&(Y=Y??m.create());const G=new f(o,y,Y),V=this.q.push(G);O&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,y);const se=G.subscription.set(()=>{N?.(),this.j||(V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return D instanceof C.DisposableStore?D.add(se):Array.isArray(D)&&D.push(se),se}),this.l}fire(o){if(this.q){this.m||(this.m=new b);for(const y of this.q)this.m.push(this,y,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=p;class u{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(o,y,D){this.c.push(new g(o,y,D))}clear(o){const y=new A.LinkedList;for(const D of this.c)D.emitter!==o&&y.push(D);this.c=y}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(y){(0,E.onUnexpectedError)(y)}}}}e.EventDeliveryQueue=u;class b extends u{clear(o){this.c.clear()}}class g{constructor(o,y,D){this.emitter=o,this.listener=y,this.event=D}}class d extends p{async fireAsync(o,y,D){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const O of this.q)this.c.push([O,o]);for(;this.c.size>0&&!y.isCancellationRequested;){const[O,N]=this.c.shift(),Y=[],G={...N,token:y,waitUntil:V=>{if(Object.isFrozen(Y))throw new Error("waitUntil can NOT be called asynchronous");D&&(V=D(V,O.callback)),Y.push(V)}};try{O.invoke(G)}catch(V){(0,E.onUnexpectedError)(V);continue}Object.freeze(Y),await Promise.allSettled(Y).then(V=>{for(const se of V)se.status==="rejected"&&(0,E.onUnexpectedError)(se.reason)})}}}}e.AsyncEmitter=d;class l extends p{constructor(o){super(o),this.h=0,this.s=new A.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}e.PauseableEmitter=l;class n extends l{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}e.DebounceEmitter=n;class s extends p{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){!this.hasListeners()||(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(y=>super.fire(y)),this.c=[]}))}}e.MicrotaskEmitter=s;class i{constructor(){this.d=!1,this.f=[],this.c=new p({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const y={event:o,listener:null};this.f.push(y),this.d&&this.j(y);const D=()=>{this.d&&this.k(y);const O=this.f.indexOf(y);this.f.splice(O,1)};return(0,C.toDisposable)((0,t.once)(D))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(y=>this.c.fire(y))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class a{constructor(){this.c=[]}wrapEvent(o){return(y,D,O)=>o(N=>{const Y=this.c[this.c.length-1];Y?Y.push(()=>y.call(D,N)):y.call(D,N)},void 0,O)}bufferEvents(o){const y=[];this.c.push(y);const D=o();return this.c.pop(),y.forEach(O=>O()),D}}e.EventBufferer=a;class r{constructor(){this.c=!1,this.d=v.None,this.f=C.Disposable.None,this.g=new p({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=r}),define(ee[22],te([0,1,3]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(k,w){const v=setTimeout(k.bind(w),0);return{dispose(){clearTimeout(v)}}});var C;(function(k){function w(v){return v===k.None||v===k.Cancelled||v instanceof A?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}k.isCancellationToken=w,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(C=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor(w){this.a=void 0,this.b=void 0,this.b=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=C.Cancelled}dispose(w=!1){w&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=C.None}}e.CancellationTokenSource=M}),define(ee[137],te([0,1,22]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new E.CancellationTokenSource,w=this.b(k.token);return this.a={promise:w,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.Cache=t;class C{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const w=JSON.stringify(k);return this.b!==w&&(this.b=w,this.a=this.c(k)),this.a}}e.LRUCachedFunction=C;class A{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const w=this.b(k);return this.a.set(k,w),w}}e.CachedFunction=A}),define(ee[96],te([0,1,3,2]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const C=M=>({onDidChange:E.Event.None,value:M});e.staticObservableValue=C;class A extends t.Disposable{get value(){return this.b}set value(k){k!==this.b&&(this.b=k,this.a.fire(k))}constructor(k){super(),this.b=k,this.a=this.B(new E.Emitter),this.onDidChange=this.a.event}}e.MutableObservableValue=A}),define(ee[25],te([0,1,137,124]),function(q,e,E,t){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=A;const M=/{(\d+)}/g;function k(K,...ce){return ce.length===0?K:K.replace(M,function(fe,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=ce.length?fe:ce[Se]})}e.format=k;const w=/{([^}]+)}/g;function v(K,ce){return K.replace(w,(fe,me)=>ce[me]??fe)}e.format2=v;function S(K){return K.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=S;function P(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function I(K,ce){let fe=0;const me=ce.charCodeAt(0);for(let Se=K.length-1;Se>=0;Se--)K.charCodeAt(Se)===me&&fe++;return fe}e.count=I;function h(K,ce,fe="\u2026"){return K.length<=ce?K:`${K.substr(0,ce)}${fe}`}e.truncate=h;function m(K,ce=" "){const fe=f(K,ce);return p(fe,ce)}e.trim=m;function f(K,ce){if(!K||!ce)return K;const fe=ce.length;if(fe===0||K.length===0)return K;let me=0;for(;K.indexOf(ce,me)===me;)me=me+fe;return K.substring(me)}e.ltrim=f;function p(K,ce){if(!K||!ce)return K;const fe=ce.length,me=K.length;if(fe===0||me===0)return K;let Se=me,Le=-1;for(;Le=K.lastIndexOf(ce,Se-1),!(Le===-1||Le+fe!==Se);){if(Le===0)return"";Se=Le}return K.substring(0,Se)}e.rtrim=p;function u(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function b(K){return K.replace(/\*/g,"")}e.stripWildcards=b;function g(K,ce,fe={}){if(!K)throw new Error("Cannot create regex from empty string");ce||(K=P(K)),fe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let me="";return fe.global&&(me+="g"),fe.matchCase||(me+="i"),fe.multiline&&(me+="m"),fe.unicode&&(me+="u"),new RegExp(K,me)}e.createRegExp=g;function d(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function l(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function n(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=n;function s(K){return K.split(/\r\n|\r|\n/)}e.splitLines=s;function i(K){for(let ce=0,fe=K.length;ce<fe;ce++){const me=K.charCodeAt(ce);if(me!==32&&me!==9)return ce}return-1}e.firstNonWhitespaceIndex=i;function a(K,ce=0,fe=K.length){for(let me=ce;me<fe;me++){const Se=K.charCodeAt(me);if(Se!==32&&Se!==9)return K.substring(ce,me)}return K.substring(ce,fe)}e.getLeadingWhitespace=a;function r(K,ce=K.length-1){for(let fe=ce;fe>=0;fe--){const me=K.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.lastNonWhitespaceIndex=r;function c(K,ce,fe){const me=[];let Se=0;for(const Le of K.matchAll(ce)){if(me.push(K.slice(Se,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");Se=Le.index+Le[0].length,me.push(fe(Le[0],...Le.slice(1),Le.index,K,Le.groups))}return me.push(K.slice(Se)),Promise.all(me).then(Le=>Le.join(""))}e.replaceAsync=c;function o(K,ce){return K<ce?-1:K>ce?1:0}e.compare=o;function y(K,ce,fe=0,me=K.length,Se=0,Le=ce.length){for(;fe<me&&Se<Le;fe++,Se++){const Ze=K.charCodeAt(fe),Ve=ce.charCodeAt(Se);if(Ze<Ve)return-1;if(Ze>Ve)return 1}const Ne=me-fe,it=Le-Se;return Ne<it?-1:Ne>it?1:0}e.compareSubstring=y;function D(K,ce){return O(K,ce,0,K.length,0,ce.length)}e.compareIgnoreCase=D;function O(K,ce,fe=0,me=K.length,Se=0,Le=ce.length){for(;fe<me&&Se<Le;fe++,Se++){let Ze=K.charCodeAt(fe),Ve=ce.charCodeAt(Se);if(Ze===Ve)continue;if(Ze>=128||Ve>=128)return y(K.toLowerCase(),ce.toLowerCase(),fe,me,Se,Le);Y(Ze)&&(Ze-=32),Y(Ve)&&(Ve-=32);const et=Ze-Ve;if(et!==0)return et}const Ne=me-fe,it=Le-Se;return Ne<it?-1:Ne>it?1:0}e.compareSubstringIgnoreCase=O;function N(K){return K>=48&&K<=57}e.isAsciiDigit=N;function Y(K){return K>=97&&K<=122}e.isLowerAsciiLetter=Y;function G(K){return K>=65&&K<=90}e.isUpperAsciiLetter=G;function V(K,ce){return K.length===ce.length&&O(K,ce)===0}e.equalsIgnoreCase=V;function se(K,ce){const fe=ce.length;return ce.length>K.length?!1:O(K,ce,0,fe)===0}e.startsWithIgnoreCase=se;function oe(K,ce){const fe=Math.min(K.length,ce.length);let me;for(me=0;me<fe;me++)if(K.charCodeAt(me)!==ce.charCodeAt(me))return me;return fe}e.commonPrefixLength=oe;function re(K,ce){const fe=Math.min(K.length,ce.length);let me;const Se=K.length-1,Le=ce.length-1;for(me=0;me<fe;me++)if(K.charCodeAt(Se-me)!==ce.charCodeAt(Le-me))return me;return fe}e.commonSuffixLength=re;function de(K){return 55296<=K&&K<=56319}e.isHighSurrogate=de;function X(K){return 56320<=K&&K<=57343}e.isLowSurrogate=X;function le(K,ce){return(K-55296<<10)+(ce-56320)+65536}e.computeCodePoint=le;function W(K,ce,fe){const me=K.charCodeAt(fe);if(de(me)&&fe+1<ce){const Se=K.charCodeAt(fe+1);if(X(Se))return le(me,Se)}return me}e.getNextCodePoint=W;function L(K,ce){const fe=K.charCodeAt(ce-1);if(X(fe)&&ce>1){const me=K.charCodeAt(ce-2);if(de(me))return le(me,fe)}return fe}class T{get offset(){return this.e}constructor(ce,fe=0){this.c=ce,this.d=ce.length,this.e=fe}setOffset(ce){this.e=ce}prevCodePoint(){const ce=L(this.c,this.e);return this.e-=ce>=65536?2:1,ce}nextCodePoint(){const ce=W(this.c,this.d,this.e);return this.e+=ce>=65536?2:1,ce}eol(){return this.e>=this.d}}e.CodePointIterator=T;class U{get offset(){return this.c.offset}constructor(ce,fe=0){this.c=new T(ce,fe)}nextGraphemeLength(){const ce=We.getInstance(),fe=this.c,me=fe.offset;let Se=ce.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Le=fe.offset,Ne=ce.getGraphemeBreakType(fe.nextCodePoint());if(ye(Se,Ne)){fe.setOffset(Le);break}Se=Ne}return fe.offset-me}prevGraphemeLength(){const ce=We.getInstance(),fe=this.c,me=fe.offset;let Se=ce.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Le=fe.offset,Ne=ce.getGraphemeBreakType(fe.prevCodePoint());if(ye(Ne,Se)){fe.setOffset(Le);break}Se=Ne}return me-fe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=U;function Q(K,ce){return new U(K,ce).nextGraphemeLength()}e.nextCharLength=Q;function B(K,ce){return new U(K,ce).prevGraphemeLength()}e.prevCharLength=B;function H(K,ce){ce>0&&X(K.charCodeAt(ce))&&ce--;const fe=ce+Q(K,ce);return[fe-B(K,fe),fe]}e.getCharContainingOffset=H;function R(K){const ce=new U(K);let fe=0;for(;!ce.eol();)fe++,ce.nextGraphemeLength();return fe}e.charCount=R;let F;function $(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function z(K){return F||(F=$()),F.test(K)}e.containsRTL=z;const J=/^[\t\n\r\x20-\x7E]*$/;function ne(K){return J.test(K)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=j;function x(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=x;function _(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=_;function ae(K,ce){if(K.length<ce)return K;const fe=/\b/g;let me=0;for(;fe.test(K)&&!(K.length-fe.lastIndex<ce);)me=fe.lastIndex,fe.lastIndex+=1;return K.substring(me).replace(/^\s/,"")}e.lcut=ae;const ge=/\x1B\x5B[12]?K/g,Me=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function De(K){return K&&(K=K.replace(ge,""),K=K.replace(Me,""),K=K.replace(Oe,"")),K}e.removeAnsiEscapeCodes=De,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function ve(K){return Re(K)?K.substr(1):K}e.stripUTF8BOM=ve;function we(K,ce){if(!K||!ce||K.length<ce.length)return!1;const fe=ce.length,me=K.toLowerCase();let Se=0,Le=-1;for(;Se<fe;){const Ne=me.indexOf(ce[Se],Le+1);if(Ne<0)return!1;Le=Ne,Se++}return!0}e.fuzzyContains=we;function be(K,ce=!1){return K?(ce&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=be;function Ce(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ce;function Z(K,ce=1){if(ce===0)return"";let fe=-1;do fe=K.indexOf(`
`,fe+1),ce--;while(ce>0&&fe>=0);return fe===-1?K:(K[fe-1]==="\r"&&fe--,K.substr(0,fe))}e.getNLines=Z;function ue(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}e.singleLetterHash=ue;function he(K){return We.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=he;function ye(K,ce){return K===0?ce!==5&&ce!==7:K===2&&ce===3?!1:K===4||K===2||K===3||ce===4||ce===2||ce===3?!0:!(K===8&&(ce===8||ce===9||ce===11||ce===12)||(K===11||K===9)&&(ce===9||ce===10)||(K===12||K===10)&&ce===10||ce===5||ce===13||ce===7||K===1||K===13&&ce===14||K===6&&ce===6)}var Ie;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{static getInstance(){return We.c||(We.c=new We),We.c}constructor(){this.d=Te()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const fe=this.d,me=fe.length/3;let Se=1;for(;Se<=me;)if(ce<fe[3*Se])Se=2*Se;else if(ce>fe[3*Se+1])Se=2*Se+1;else return fe[3*Se+2];return 0}}We.c=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(K,ce){if(K===0)return 0;const fe=Be(K,ce);if(fe!==void 0)return fe;const me=new T(ce,K);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=ze;function Be(K,ce){const fe=new T(ce,K);let me=fe.prevCodePoint();for(;qe(me)||me===65039||me===8419;){if(fe.offset===0)return;me=fe.prevCodePoint()}if(!_(me))return;let Se=fe.offset;return Se>0&&fe.prevCodePoint()===8205&&(Se=fe.offset),Se}function qe(K){return 127995<=K&&K<=127999}var Ye;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.noBreakWhitespace="\xA0";class je{static getInstance(ce){return je.d.get(Array.from(ce))}static getLocales(){return je.e.getValue()}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=je,C=je,je.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.d=new E.LRUCachedFunction(K=>{function ce(Ve){const et=new Map;for(let nt=0;nt<Ve.length;nt+=2)et.set(Ve[nt],Ve[nt+1]);return et}function fe(Ve,et){const nt=new Map(Ve);for(const[ct,gt]of et)nt.set(ct,gt);return nt}function me(Ve,et){if(!Ve)return et;const nt=new Map;for(const[ct,gt]of Ve)et.has(ct)&&nt.set(ct,gt);return nt}const Se=C.c.getValue();let Le=K.filter(Ve=>!Ve.startsWith("_")&&Ve in Se);Le.length===0&&(Le=["_default"]);let Ne;for(const Ve of Le){const et=ce(Se[Ve]);Ne=me(Ne,et)}const it=ce(Se._common),Ze=fe(it,Ne);return new je(Ze)}),je.e=new t.Lazy(()=>Object.keys(je.c.getValue()).filter(K=>!K.startsWith("_")));class Xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Xe.c())),this.d}static isInvisibleCharacter(ce){return Xe.e().has(ce)}static get codePoints(){return Xe.e()}}e.InvisibleCharacters=Xe,Xe.d=void 0}),define(ee[30],te([0,1,9,4,25,12]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(r){return r===47||r===92}e.isPathSeparator=M;function k(r){return r.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=k;function w(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=w;function v(r,c=E.posix.sep){if(!r)return"";const o=r.length,y=r.charCodeAt(0);if(M(y)){if(M(r.charCodeAt(1))&&!M(r.charCodeAt(2))){let O=3;const N=O;for(;O<o&&!M(r.charCodeAt(O));O++);if(N!==O&&!M(r.charCodeAt(O+1))){for(O+=1;O<o;O++)if(M(r.charCodeAt(O)))return r.slice(0,O+1).replace(/[\\/]/g,c)}}return c}else if(u(y)&&r.charCodeAt(1)===58)return M(r.charCodeAt(2))?r.slice(0,2)+c:r.slice(0,2);let D=r.indexOf("://");if(D!==-1){for(D+=3;D<o;D++)if(M(r.charCodeAt(D)))return r.slice(0,D+1)}return""}e.getRoot=v;function S(r){if(!t.isWindows||!r||r.length<5)return!1;let c=r.charCodeAt(0);if(c!==92||(c=r.charCodeAt(1),c!==92))return!1;let o=2;const y=o;for(;o<r.length&&(c=r.charCodeAt(o),c!==92);o++);return!(y===o||(c=r.charCodeAt(o+1),isNaN(c)||c===92))}e.isUNC=S;const P=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(r,c=t.isWindows){const o=c?P:I;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||c&&h.test(r)||r==="."||r===".."||c&&r[r.length-1]==="."||c&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=m;function f(r,c,o){const y=r===c;return!o||y?y:!r||!c?!1:(0,C.equalsIgnoreCase)(r,c)}e.isEqual=f;function p(r,c,o,y=E.sep){if(r===c)return!0;if(!r||!c||c.length>r.length)return!1;if(o){if(!(0,C.startsWithIgnoreCase)(r,c))return!1;if(c.length===r.length)return!0;let O=c.length;return c.charAt(c.length-1)===y&&O--,r.charAt(O)===y}return c.charAt(c.length-1)!==y&&(c+=y),r.indexOf(c)===0}e.isEqualOrParent=p;function u(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=u;function b(r,c){return t.isWindows&&r.endsWith(":")&&(r+=E.sep),(0,E.isAbsolute)(r)||(r=(0,E.join)(c,r)),r=(0,E.normalize)(r),t.isWindows?(r=(0,C.rtrim)(r,E.sep),r.endsWith(":")&&(r+=E.sep)):(r=(0,C.rtrim)(r,E.sep),r||(r=E.sep)),r}e.sanitizeFilePath=b;function g(r){const c=(0,E.normalize)(r);return t.isWindows?r.length>3?!1:d(c)&&(r.length===2||c.charCodeAt(2)===92):c===E.posix.sep}e.isRootOrDriveLetter=g;function d(r,c=t.isWindows){return c?u(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function l(r){return d(r)?r[0]:void 0}e.getDriveLetter=l;function n(r,c,o){return c.length>r.length?-1:r===c?0:(o&&(r=r.toLowerCase(),c=c.toLowerCase()),r.indexOf(c))}e.indexOfPath=n;function s(r){const c=r.split(":");let o,y,D;for(const O of c){const N=Number(O);(0,A.isNumber)(N)?y===void 0?y=N:D===void 0&&(D=N):o=o?[o,O].join(":"):O}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:y!==void 0?y:void 0,column:D!==void 0?D:y!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(r,c,o=8){let y="";for(let O=0;O<o;O++)y+=i.charAt(Math.floor(Math.random()*i.length));let D;return c?D=`${c}-${y}`:D=y,r?(0,E.join)(r,D):D}e.randomPath=a}),define(ee[67],te([0,1,25]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(u){return C(u,0)}e.hash=t;function C(u,b){switch(typeof u){case"object":return u===null?A(349,b):Array.isArray(u)?w(u,b):v(u,b);case"string":return k(u,b);case"boolean":return M(u,b);case"number":return A(u,b);case"undefined":return A(937,b);default:return A(617,b)}}e.doHash=C;function A(u,b){return(b<<5)-b+u|0}e.numberHash=A;function M(u,b){return A(u?433:863,b)}function k(u,b){b=A(149417,b);for(let g=0,d=u.length;g<d;g++)b=A(u.charCodeAt(g),b);return b}e.stringHash=k;function w(u,b){return b=A(104579,b),u.reduce((g,d)=>C(d,g),b)}function v(u,b){return b=A(181387,b),Object.keys(u).sort().reduce((g,d)=>(g=k(d,g),C(u[d],g)),b)}class S{constructor(){this.g=0}get value(){return this.g}hash(b){return this.g=C(b,this.g),this.g}}e.Hasher=S;var P;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function I(u,b,g=32){const d=g-b,l=~((1<<d)-1);return(u<<b|(l&u)>>>d)>>>0}function h(u,b=0,g=u.byteLength,d=0){for(let l=0;l<g;l++)u[b+l]=d}function m(u,b,g="0"){for(;u.length<b;)u=g+u;return u}function f(u,b=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(g=>g.toString(16).padStart(2,"0")).join(""):m((u>>>0).toString(16),b/4)}e.toHexString=f;class p{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(b){const g=b.length;if(g===0)return;const d=this.p;let l=this.r,n=this.u,s,i;for(n!==0?(s=n,i=-1,n=0):(s=b.charCodeAt(0),i=0);;){let a=s;if(E.isHighSurrogate(s))if(i+1<g){const r=b.charCodeAt(i+1);E.isLowSurrogate(r)?(i++,a=E.computeCodePoint(s,r)):a=65533}else{n=s;break}else E.isLowSurrogate(s)&&(a=65533);if(l=this.w(d,l,a),i++,i<g)s=b.charCodeAt(i);else break}this.r=l,this.u=n}w(b,g,d){return d<128?b[g++]=d:d<2048?(b[g++]=192|(d&1984)>>>6,b[g++]=128|(d&63)>>>0):d<65536?(b[g++]=224|(d&61440)>>>12,b[g++]=128|(d&4032)>>>6,b[g++]=128|(d&63)>>>0):(b[g++]=240|(d&1835008)>>>18,b[g++]=128|(d&258048)>>>12,b[g++]=128|(d&4032)>>>6,b[g++]=128|(d&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const b=8*this.t;this.q.setUint32(56,Math.floor(b/4294967296),!1),this.q.setUint32(60,b%4294967296,!1),this.y()}y(){const b=p.g,g=this.q;for(let o=0;o<64;o+=4)b.setUint32(o,g.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)b.setUint32(o,I(b.getUint32(o-12,!1)^b.getUint32(o-32,!1)^b.getUint32(o-56,!1)^b.getUint32(o-64,!1),1),!1);let d=this.h,l=this.l,n=this.m,s=this.n,i=this.o,a,r,c;for(let o=0;o<80;o++)o<20?(a=l&n|~l&s,r=1518500249):o<40?(a=l^n^s,r=1859775393):o<60?(a=l&n|l&s|n&s,r=2400959708):(a=l^n^s,r=3395469782),c=I(d,5)+a+i+r+b.getUint32(o*4,!1)&4294967295,i=s,s=n,n=I(l,30),l=d,d=c;this.h=this.h+d&4294967295,this.l=this.l+l&4294967295,this.m=this.m+n&4294967295,this.n=this.n+s&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=p,p.g=new DataView(new ArrayBuffer(320))}),define(ee[97],te([0,1,25]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(t||(t={})),function(C){const A="error",M="warning",k="warn",w="info",v="ignore";function S(I){return I?E.equalsIgnoreCase(A,I)?C.Error:E.equalsIgnoreCase(M,I)||E.equalsIgnoreCase(k,I)?C.Warning:E.equalsIgnoreCase(w,I)?C.Info:C.Ignore:C.Ignore}C.fromValue=S;function P(I){switch(I){case C.Error:return A;case C.Warning:return M;case C.Info:return w;default:return v}}C.toString=P}(t||(t={})),e.default=t}),define(ee[58],te([0,1,24,25]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class C{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const m=h.charCodeAt(0),f=this.b.charCodeAt(this.c);return m-f}value(){return this.b[this.c]}}e.StringIterator=C;class A{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,t.compareSubstring)(h,this.b,0,h.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class M{constructor(h=!0,m=!0){this.f=h,this.g=m}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let m=h.length-1;m>=0;m--,this.c--){const f=this.b.charCodeAt(m);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,t.compareSubstring)(h,this.b,0,h.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=M;var k;(function(I){I[I.Scheme=1]="Scheme",I[I.Authority=2]="Authority",I[I.Path=3]="Path",I[I.Query=4]="Query",I[I.Fragment=5]="Fragment"})(k||(k={}));class w{constructor(h,m){this.f=h,this.g=m,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(h,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,t.compare)(h,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=w;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(I){I[I.Left=-1]="Left",I[I.Mid=0]="Mid",I[I.Right=1]="Right"})(S||(S={}));class P{static forUris(h=()=>!1,m=()=>!1){return new P(new w(h,m))}static forPaths(h=!1){return new P(new M(void 0,!h))}static forStrings(){return new P(new C)}static forConfigKeys(){return new P(new A)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,m){if(m){const f=m.slice(0);(0,E.shuffle)(f);for(const p of f)this.set(p,h)}else{const f=h.slice(0);(0,E.shuffle)(f);for(const p of f)this.set(p[0],p[1])}}set(h,m){const f=this.b.reset(h);let p;this.c||(this.c=new v,this.c.segment=f.value());const u=[];for(p=this.c;;){const g=f.cmp(p.segment);if(g>0)p.left||(p.left=new v,p.left.segment=f.value()),u.push([-1,p]),p=p.left;else if(g<0)p.right||(p.right=new v,p.right.segment=f.value()),u.push([1,p]),p=p.right;else if(f.hasNext())f.next(),p.mid||(p.mid=new v,p.mid.segment=f.value()),u.push([0,p]),p=p.mid;else break}const b=p.value;p.value=m,p.key=h;for(let g=u.length-1;g>=0;g--){const d=u[g][1];d.updateHeight();const l=d.balanceFactor();if(l<-1||l>1){const n=u[g][0],s=u[g+1][0];if(n===1&&s===1)u[g][1]=d.rotateLeft();else if(n===-1&&s===-1)u[g][1]=d.rotateRight();else if(n===1&&s===-1)d.right=u[g+1][1]=u[g+1][1].rotateRight(),u[g][1]=d.rotateLeft();else if(n===-1&&s===1)d.left=u[g+1][1]=u[g+1][1].rotateLeft(),u[g][1]=d.rotateRight();else throw new Error;if(g>0)switch(u[g-1][0]){case-1:u[g-1][1].left=u[g][1];break;case 1:u[g-1][1].right=u[g][1];break;case 0:u[g-1][1].mid=u[g][1];break}else this.c=u[0][1]}}return b}get(h){return this.d(h)?.value}d(h){const m=this.b.reset(h);let f=this.c;for(;f;){const p=m.cmp(f.segment);if(p>0)f=f.left;else if(p<0)f=f.right;else if(m.hasNext())m.next(),f=f.mid;else break}return f}has(h){const m=this.d(h);return!(m?.value===void 0&&m?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,m){const f=this.b.reset(h),p=[];let u=this.c;for(;u;){const b=f.cmp(u.segment);if(b>0)p.push([-1,u]),u=u.left;else if(b<0)p.push([1,u]),u=u.right;else if(f.hasNext())f.next(),p.push([0,u]),u=u.mid;else break}if(!!u){if(m?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const b=this.f(u.right);if(b.key){const{key:g,value:d,segment:l}=b;this.e(b.key,!1),u.key=g,u.value=d,u.segment=l}}else{const b=u.left??u.right;if(p.length>0){const[g,d]=p[p.length-1];switch(g){case-1:d.left=b;break;case 0:d.mid=b;break;case 1:d.right=b;break}}else this.c=b}for(let b=p.length-1;b>=0;b--){const g=p[b][1];g.updateHeight();const d=g.balanceFactor();if(d>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),p[b][1]=g.rotateLeft()):d<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),p[b][1]=g.rotateRight()),b>0)switch(p[b-1][0]){case-1:p[b-1][1].left=p[b][1];break;case 1:p[b-1][1].right=p[b][1];break;case 0:p[b-1][1].mid=p[b][1];break}else this.c=p[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const m=this.b.reset(h);let f=this.c,p;for(;f;){const u=m.cmp(f.segment);if(u>0)f=f.left;else if(u<0)f=f.right;else if(m.hasNext())m.next(),p=f.value||p,f=f.mid;else break}return f&&f.value||p}findSuperstr(h){const m=this.b.reset(h);let f=this.c;for(;f;){const p=m.cmp(f.segment);if(p>0)f=f.left;else if(p<0)f=f.right;else if(m.hasNext())m.next(),f=f.mid;else return f.mid?this.g(f.mid):void 0}}forEach(h){for(const[m,f]of this)h(f,m)}*[Symbol.iterator](){yield*this.g(this.c)}g(h){const m=[];return this.h(h,m),m[Symbol.iterator]()}h(h,m){!h||(h.left&&this.h(h.left,m),h.value&&m.push([h.key,h.value]),h.mid&&this.h(h.mid,m),h.right&&this.h(h.right,m))}_isBalanced(){const h=m=>{if(!m)return!0;const f=m.balanceFactor();return f<-1||f>1?!1:h(m.left)&&h(m.right)};return h(this.c)}}e.TernarySearchTree=P}),define(ee[7],te([0,1,9,4]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,A=/^\//,M=/^\/\//;function k(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!C.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(i,a){return!i&&!a?"file":i}function v(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==P&&(a=P+a):a=P;break}return a}const S="",P="/",I=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(a){return a instanceof h?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,r,c,o,y,D=!1){typeof a=="object"?(this.scheme=a.scheme||S,this.authority=a.authority||S,this.path=a.path||S,this.query=a.query||S,this.fragment=a.fragment||S):(this.scheme=w(a,D),this.authority=r||S,this.path=v(this.scheme,c||S),this.query=o||S,this.fragment=y||S,k(this,D))}get fsPath(){return g(this,!1)}with(a){if(!a)return this;let{scheme:r,authority:c,path:o,query:y,fragment:D}=a;return r===void 0?r=this.scheme:r===null&&(r=S),c===void 0?c=this.authority:c===null&&(c=S),o===void 0?o=this.path:o===null&&(o=S),y===void 0?y=this.query:y===null&&(y=S),D===void 0?D=this.fragment:D===null&&(D=S),r===this.scheme&&c===this.authority&&o===this.path&&y===this.query&&D===this.fragment?this:new f(r,c,o,y,D)}static parse(a,r=!1){const c=I.exec(a);return c?new f(c[2]||S,s(c[4]||S),s(c[5]||S),s(c[7]||S),s(c[9]||S),r):new f(S,S,S,S,S)}static file(a){let r=S;if(t.isWindows&&(a=a.replace(/\\/g,P)),a[0]===P&&a[1]===P){const c=a.indexOf(P,2);c===-1?(r=a.substring(2),a=P):(r=a.substring(2,c),a=a.substring(c)||P)}return new f("file",r,a,S,S)}static from(a){const r=new f(a.scheme,a.authority,a.path,a.query,a.fragment);return k(r,!0),r}static joinPath(a,...r){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&a.scheme==="file"?c=h.file(E.win32.join(g(a,!0),...r)).path:c=E.posix.join(a.path,...r),a.with({path:c})}toString(a=!1){return d(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof h)return a;{const r=new f(a);return r._formatted=a.external,r._fsPath=a._sep===m?a.fsPath:null,r}}else return a}}e.URI=h;const m=t.isWindows?1:void 0;class f extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(a=!1){return a?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=m),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,a){let r,c=-1;for(let o=0;o<i.length;o++){const y=i.charCodeAt(o);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||a&&y===47)c!==-1&&(r+=encodeURIComponent(i.substring(c,o)),c=-1),r!==void 0&&(r+=i.charAt(o));else{r===void 0&&(r=i.substr(0,o));const D=p[y];D!==void 0?(c!==-1&&(r+=encodeURIComponent(i.substring(c,o)),c=-1),r+=D):c===-1&&(c=o)}}return c!==-1&&(r+=encodeURIComponent(i.substring(c))),r!==void 0?r:i}function b(i){let a;for(let r=0;r<i.length;r++){const c=i.charCodeAt(r);c===35||c===63?(a===void 0&&(a=i.substr(0,r)),a+=p[c]):a!==void 0&&(a+=i[r])}return a!==void 0?a:i}function g(i,a){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=g;function d(i,a){const r=a?b:u;let c="",{scheme:o,authority:y,path:D,query:O,fragment:N}=i;if(o&&(c+=o,c+=":"),(y||o==="file")&&(c+=P,c+=P),y){let Y=y.indexOf("@");if(Y!==-1){const G=y.substr(0,Y);y=y.substr(Y+1),Y=G.indexOf(":"),Y===-1?c+=r(G,!1):(c+=r(G.substr(0,Y),!1),c+=":",c+=r(G.substr(Y+1),!1)),c+="@"}y=y.toLowerCase(),Y=y.indexOf(":"),Y===-1?c+=r(y,!1):(c+=r(y.substr(0,Y),!1),c+=y.substr(Y))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const Y=D.charCodeAt(1);Y>=65&&Y<=90&&(D=`/${String.fromCharCode(Y+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const Y=D.charCodeAt(0);Y>=65&&Y<=90&&(D=`${String.fromCharCode(Y+32)}:${D.substr(2)}`)}c+=r(D,!0)}return O&&(c+="?",c+=r(O,!1)),N&&(c+="#",c+=a?N:u(N,!1)),c}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(n)?i.replace(n,a=>l(a)):i}}),define(ee[138],te([0,1,7]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(v){const S=v;return S&&typeof S.type=="string"&&typeof S.severity=="string"}e.isRemoteConsoleLog=t;function C(v){const S=[];let P;try{const I=JSON.parse(v.arguments),h=I[I.length-1];h&&h.__$stack&&(I.pop(),P=h.__$stack),S.push(...I)}catch{S.push("Unable to log remote console arguments",v.arguments)}return{args:S,stack:P}}e.parse=C;function A(v){if(typeof v!="string")return A(C(v).stack);const S=v;if(S){const P=M(S),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(I&&I.length===4)return{uri:E.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}e.getFirstFrame=A;function M(v){if(!v)return v;const S=v.indexOf(`
`);return S===-1?v:v.substring(0,S)}function k(v,S){const{args:P,stack:I}=C(v),h=typeof P[0]=="string"&&P.length===1;let m=M(I);m&&(m=`(${m.trim()})`);let f=[];if(typeof P[0]=="string"?m&&h?f=[`%c[${S}] %c${P[0]} %c${m}`,w("blue"),w(""),w("grey")]:f=[`%c[${S}] %c${P[0]}`,w("blue"),w(""),...P.slice(1)]:f=[`%c[${S}]%`,w("blue"),...P],m&&!h&&f.push(m),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,f)}e.log=k;function w(v){return`color: ${v}`}}),define(ee[68],te([0,1,17,25,7]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(v){return JSON.stringify(v,k)}e.stringify=A;function M(v){let S=JSON.parse(v);return S=w(S),S}e.parse=M;function k(v,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:(0,t.regExpFlags)(S)}:S}function w(v,S=0){if(!v||S>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return C.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 15:return new Date(v.source)}if(v instanceof E.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let P=0;P<v.length;++P)v[P]=w(v[P],S+1);else for(const P in v)Object.hasOwnProperty.call(v,P)&&(v[P]=w(v[P],S+1))}return v}e.revive=w}),define(ee[14],te([0,1,4,7]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var C;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(C=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v){this.f=`${v}/${C.vscodeRemoteResource}`}set(v,S,P){this.a[v]=S,this.b[v]=P}setConnectionToken(v,S){this.c[v]=S}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)return this.e(v);const S=v.authority;let P=this.a[S];P&&P.indexOf(":")!==-1&&P.indexOf("[")===-1&&(P=`[${P}]`);const I=this.b[S],h=this.c[S];let m=`path=${encodeURIComponent(v.path)}`;return typeof h=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(h)}`),t.URI.from({scheme:E.isWeb?this.d:C.vscodeRemoteResource,authority:`${P}:${I}`,path:this.f,query:m})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class M{asBrowserUri(v){const S=this.b(v,q);return this.uriToBrowserUri(S)}uriToBrowserUri(v){return v.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(v):v.scheme===C.file&&(E.isNative||E.isWebWorker&&E.globals.origin===`${C.vscodeFileResource}://${M.a}`)?v.with({scheme:C.vscodeFileResource,authority:v.authority||M.a,query:null,fragment:null}):v}asFileUri(v){const S=this.b(v,q);return this.uriToFileUri(S)}uriToFileUri(v){return v.scheme===C.vscodeFileResource?v.with({scheme:C.file,authority:v.authority!==M.a?v.authority:null,query:null,fragment:null}):v}b(v,S){return t.URI.isUri(v)?v:t.URI.parse(S.toUrl(v))}}M.a="vscode-app",e.FileAccess=new M;var k;(function(w){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(v.get("3"));const S="vscode-coi";function P(h){let m;typeof h=="string"?m=new URL(h).searchParams:h instanceof URL?m=h.searchParams:t.URI.isUri(h)&&(m=new URL(h.toString(!0)).searchParams);const f=m?.get(S);if(!!f)return v.get(f)}w.getHeadersFromQuery=P;function I(h,m,f){if(!globalThis.crossOriginIsolated)return;const p=m&&f?"3":f?"2":"1";h instanceof URLSearchParams?h.set(S,p):h[S]=p}w.addSearchParam=I})(k=e.COI||(e.COI={}))}),define(ee[19],te([0,1,30,14,9,4,25,7]),function(q,e,E,t,C,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(h){return(0,k.uriToFsPath)(h,!0)}e.originalFSPath=w;class v{constructor(m){this.a=m}compare(m,f,p=!1){return m===f?0:(0,M.compare)(this.getComparisonKey(m,p),this.getComparisonKey(f,p))}isEqual(m,f,p=!1){return m===f?!0:!m||!f?!1:this.getComparisonKey(m,p)===this.getComparisonKey(f,p)}getComparisonKey(m,f=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,f,p=!1){if(m.scheme===f.scheme){if(m.scheme===t.Schemas.file)return E.isEqualOrParent(w(m),w(f),this.a(m))&&m.query===f.query&&(p||m.fragment===f.fragment);if((0,e.isEqualAuthority)(m.authority,f.authority))return E.isEqualOrParent(m.path,f.path,this.a(m),"/")&&m.query===f.query&&(p||m.fragment===f.fragment)}return!1}joinPath(m,...f){return k.URI.joinPath(m,...f)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return C.posix.basename(m.path)}extname(m){return C.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let f;return m.scheme===t.Schemas.file?f=k.URI.file(C.dirname(w(m))).path:(f=C.posix.dirname(m.path),m.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),f="/")),m.with({path:f})}normalizePath(m){if(!m.path.length)return m;let f;return m.scheme===t.Schemas.file?f=k.URI.file(C.normalize(w(m))).path:f=C.posix.normalize(m.path),m.with({path:f})}relativePath(m,f){if(m.scheme!==f.scheme||!(0,e.isEqualAuthority)(m.authority,f.authority))return;if(m.scheme===t.Schemas.file){const b=C.relative(w(m),w(f));return A.isWindows?E.toSlashes(b):b}let p=m.path||"/";const u=f.path||"/";if(this.a(m)){let b=0;for(const g=Math.min(p.length,u.length);b<g&&!(p.charCodeAt(b)!==u.charCodeAt(b)&&p.charAt(b).toLowerCase()!==u.charAt(b).toLowerCase());b++);p=u.substr(0,b)+p.substr(b)}return C.posix.relative(p,u)}resolvePath(m,f){if(m.scheme===t.Schemas.file){const p=k.URI.file(C.resolve(w(m),f));return m.with({authority:p.authority,path:p.path})}return f=E.toPosixPath(f),m.with({path:C.posix.resolve(m.path,f)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,f){return m===f||m!==void 0&&f!==void 0&&(0,M.equalsIgnoreCase)(m,f)}hasTrailingPathSeparator(m,f=C.sep){if(m.scheme===t.Schemas.file){const p=w(m);return p.length>E.getRoot(p).length&&p[p.length-1]===f}else{const p=m.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,f=C.sep){return(0,e.hasTrailingPathSeparator)(m,f)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,f=C.sep){let p=!1;if(m.scheme===t.Schemas.file){const u=w(m);p=u!==void 0&&u.length===E.getRoot(u).length&&u[u.length-1]===f}else{f="/";const u=m.path;p=u.length===1&&u.charCodeAt(u.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(m,f)?m.with({path:m.path+"/"}):m}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(h=>h.scheme===t.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new v(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function S(h,m){const f=[];for(let p=0;p<h.length;p++){const u=m(h[p]);h.some((b,g)=>g===p?!1:(0,e.isEqualOrParent)(u,m(b)))||f.push(h[p])}return f}e.distinctParents=S;var P;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function m(f){const p=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(g=>{const[d,l]=g.split(":");d&&l&&p.set(d,l)});const b=f.path.substring(0,f.path.indexOf(";"));return b&&p.set(h.META_DATA_MIME,b),p}h.parseMetaData=m})(P=e.DataUri||(e.DataUri={}));function I(h,m,f){if(m){let p=h.path;return p&&p[0]!==C.posix.sep&&(p=C.posix.sep+p),h.with({scheme:f,authority:m,path:p})}return h.with({scheme:f})}e.toLocalResource=I}),define(ee[8],te([0,1,22,15,3,2,19,4]),function(q,e,E,t,C,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(H){return!!H&&typeof H.then=="function"}e.isThenable=w;function v(H){const R=new E.CancellationTokenSource,F=H(R.token),$=new Promise((z,J)=>{const ne=R.token.onCancellationRequested(()=>{ne.dispose(),R.dispose(),J(new t.CancellationError)});Promise.resolve(F).then(j=>{ne.dispose(),R.dispose(),z(j)},j=>{ne.dispose(),R.dispose(),J(j)})});return new class{cancel(){R.cancel()}then(z,J){return $.then(z,J)}catch(z){return this.then(void 0,z)}finally(z){return $.finally(z)}}}e.createCancelablePromise=v;function S(H,R,F){return new Promise(($,z)=>{const J=R.onCancellationRequested(()=>{J.dispose(),$(F)});H.then($,z).finally(()=>J.dispose())})}e.raceCancellation=S;function P(H,R){return new Promise((F,$)=>{const z=R.onCancellationRequested(()=>{z.dispose(),$(new t.CancellationError)});H.then(F,$).finally(()=>z.dispose())})}e.raceCancellationError=P;async function I(H){let R=-1;const F=H.map((z,J)=>z.then(ne=>(R=J,ne))),$=await Promise.race(F);return H.forEach((z,J)=>{J!==R&&z.cancel()}),$}e.raceCancellablePromises=I;function h(H,R,F){let $;const z=setTimeout(()=>{$?.(void 0),F?.()},R);return Promise.race([H.finally(()=>clearTimeout(z)),new Promise(J=>$=J)])}e.raceTimeout=h;function m(H){return new Promise((R,F)=>{const $=H();w($)?$.then(R,F):R($)})}e.asPromise=m;class f{constructor(){this.a=null,this.b=null,this.d=null}queue(R){if(this.a){if(this.d=R,!this.b){const F=()=>{this.b=null;const $=this.queue(this.d);return this.d=null,$};this.b=new Promise($=>{this.a.then(F,F).then($)})}return new Promise((F,$)=>{this.b.then(F,$)})}return this.a=R(),new Promise((F,$)=>{this.a.then(z=>{this.a=null,F(z)},z=>{this.a=null,$(z)})})}}e.Throttler=f;class p{constructor(){this.a=Promise.resolve(null)}queue(R){return this.a=this.a.then(()=>R(),()=>R())}}e.Sequencer=p;class u{constructor(){this.a=new Map}queue(R,F){const z=(this.a.get(R)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(R)===z&&this.a.delete(R)});return this.a.set(R,z),z}}e.SequencerByKey=u;const b=(H,R)=>{let F=!0;const $=setTimeout(()=>{F=!1,R()},H);return{isTriggered:()=>F,dispose:()=>{clearTimeout($),F=!1}}},g=H=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,H())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class d{constructor(R){this.defaultDelay=R,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(R,F=this.defaultDelay){this.g=R,this.h(),this.b||(this.b=new Promise((z,J)=>{this.d=z,this.f=J}).then(()=>{if(this.b=null,this.d=null,this.g){const z=this.g;return this.g=null,z()}}));const $=()=>{this.a=null,this.d?.(null)};return this.a=F===e.MicrotaskDelay?g($):b(F,$),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=d;class l{constructor(R){this.a=new d(R),this.b=new f}trigger(R,F){return this.a.trigger(()=>this.b.queue(R),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=l;class n{constructor(){this.a=!1,this.b=new Promise((R,F)=>{this.d=R})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class s extends n{constructor(R){super(),this.f=setTimeout(()=>this.open(),R)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function i(H,R){return R?new Promise((F,$)=>{const z=setTimeout(()=>{J.dispose(),F()},H),J=R.onCancellationRequested(()=>{clearTimeout(z),J.dispose(),$(new t.CancellationError)})}):v(F=>i(H,F))}e.timeout=i;function a(H,R=0){const F=setTimeout(H,R);return(0,A.toDisposable)(()=>clearTimeout(F))}e.disposableTimeout=a;function r(H){const R=[];let F=0;const $=H.length;function z(){return F<$?H[F++]():null}function J(ne){ne!=null&&R.push(ne);const j=z();return j?j.then(J):Promise.resolve(R)}return Promise.resolve(null).then(J)}e.sequence=r;function c(H,R=$=>!!$,F=null){let $=0;const z=H.length,J=()=>{if($>=z)return Promise.resolve(F);const ne=H[$++];return Promise.resolve(ne()).then(x=>R(x)?Promise.resolve(x):J())};return J()}e.first=c;function o(H,R=$=>!!$,F=null){if(H.length===0)return Promise.resolve(F);let $=H.length;const z=()=>{$=-1;for(const J of H)J.cancel?.()};return new Promise((J,ne)=>{for(const j of H)j.then(x=>{--$>=0&&R(x)?(z(),J(x)):$===0&&J(F)}).catch(x=>{--$>=0&&(z(),ne(x))})})}e.firstParallel=o;class y{constructor(R){this.a=0,this.d=R,this.f=[],this.b=0,this.g=new C.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(R){return this.a++,new Promise((F,$)=>{this.f.push({factory:R,c:F,e:$}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const R=this.f.shift();this.b++;const F=R.factory();F.then(R.c,R.e),F.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=y;class D extends y{constructor(){super(1)}}e.Queue=D;class O{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const R=new W;return this.b.add(R),R.p}d(){for(const[,R]of this.a)if(R.size>0)return!1;return!0}queueFor(R,F=M.extUri){const $=F.getComparisonKey(R);let z=this.a.get($);return z||(z=new D,C.Event.once(z.onDrained)(()=>{z?.dispose(),this.a.delete($),this.f()}),this.a.set($,z)),z}f(){!this.d()||this.g()}g(){for(const R of this.b)R.complete();this.b.clear()}dispose(){for(const[,R]of this.a)R.dispose();this.a.clear(),this.g()}}e.ResourceQueue=O;class N{constructor(R,F){this.a=-1,typeof R=="function"&&typeof F=="number"&&this.setIfNotSet(R,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(R,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,R()},F)}setIfNotSet(R,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,R()},F))}}e.TimeoutTimer=N;class Y{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(R,F){this.cancel(),this.a=setInterval(()=>{R()},F)}}e.IntervalTimer=Y;class G{constructor(R,F){this.b=-1,this.a=R,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(R=this.d){this.cancel(),this.b=setTimeout(this.f,R)}get delay(){return this.d}set delay(R){this.d=R}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=G;class V{constructor(R,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=R,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(R=this.b){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(R/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=V;class se extends G{constructor(R,F){super(R,F),this.j=[]}work(R){this.j.push(R),this.isScheduled()||this.schedule()}h(){const R=this.j;this.j=[],this.a?.(R)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=se;class oe extends A.Disposable{constructor(R,F){super(),this.g=R,this.h=F,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(R){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+R.length>this.g.maxBufferedWork)return!1}else if(this.pending+R.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...R),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=oe,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{(0,k.setTimeout0)(()=>{if(R)return;const F=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:e.runWhenIdle=(H,R)=>{const F=requestIdleCallback(H,typeof R=="number"?{timeout:R}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(F))}}}}();class re{constructor(R){this.d=!1,this.a=()=>{try{this.f=R()}catch(F){this.g=F}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=re;async function de(H,R,F){let $;for(let z=0;z<F;z++)try{return await H()}catch(J){$=J,await i(R)}throw $}e.retry=de;class X{hasPending(R){return this.a?typeof R=="number"?this.a.taskId===R:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(R,F,$){return this.a={taskId:R,cancel:()=>$?.(),promise:F},F.then(()=>this.d(R),()=>this.d(R)),F}d(R){this.a&&R===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const R=this.b;this.b=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}setNext(R){if(this.b)this.b.run=R;else{let F,$;const z=new Promise((J,ne)=>{F=J,$=ne});this.b={run:R,promise:z,promiseResolve:F,promiseReject:$}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=X;class le{constructor(R,F=()=>Date.now()){this.d=R,this.f=F,this.a=0,this.b=0}increment(){const R=this.f();return R-this.a>this.d&&(this.a=R,this.b=0),this.b++,this.b}}e.IntervalCounter=le;class W{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((R,F)=>{this.a=R,this.b=F})}complete(R){return new Promise(F=>{this.a(R),this.f=!0,F()})}error(R){return new Promise(F=>{this.b(R),this.d=!0,F()})}cancel(){new Promise(R=>{this.b(new t.CancellationError),this.d=!0,R()})}}e.DeferredPromise=W;var L;(function(H){async function R($){let z;const J=await Promise.all($.map(ne=>ne.then(j=>j,j=>{z||(z=j)})));if(typeof z<"u")throw z;return J}H.settled=R;function F($){return new Promise(async(z,J)=>{try{await $(z,J)}catch(ne){J(ne)}})}H.withAsyncBody=F})(L=e.Promises||(e.Promises={}));var T;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(T||(T={}));class U{static fromArray(R){return new U(F=>{F.emitMany(R)})}static fromPromise(R){return new U(async F=>{F.emitMany(await R)})}static fromPromises(R){return new U(async F=>{await Promise.all(R.map(async $=>F.emitOne(await $)))})}static merge(R){return new U(async F=>{await Promise.all(R.map(async $=>{for await(const z of $)F.emitOne(z)}))})}constructor(R){this.a=0,this.b=[],this.d=null,this.f=new C.Emitter,queueMicrotask(async()=>{const F={emitOne:$=>this.g($),emitMany:$=>this.h($),reject:$=>this.k($)};try{await Promise.resolve(R(F)),this.j()}catch($){this.k($)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(R<this.b.length)return{done:!1,value:this.b[R++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(R,F){return new U(async $=>{for await(const z of R)$.emitOne(F(z))})}map(R){return U.map(this,R)}static filter(R,F){return new U(async $=>{for await(const z of R)F(z)&&$.emitOne(z)})}filter(R){return U.filter(this,R)}static coalesce(R){return U.filter(R,F=>!!F)}coalesce(){return U.coalesce(this)}static async toPromise(R){const F=[];for await(const $ of R)F.push($);return F}toPromise(){return U.toPromise(this)}g(R){this.a===0&&(this.b.push(R),this.f.fire())}h(R){this.a===0&&(this.b=this.b.concat(R),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(R){this.a===0&&(this.a=2,this.d=R,this.f.fire())}}e.AsyncIterableObject=U,U.EMPTY=U.fromArray([]);class Q extends U{constructor(R,F){super(F),this.l=R}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Q;function B(H){const R=new E.CancellationTokenSource,F=H(R.token);return new Q(R,async $=>{const z=R.token.onCancellationRequested(()=>{z.dispose(),R.dispose(),$.reject(new t.CancellationError)});try{for await(const J of F){if(R.token.isCancellationRequested)return;$.emitOne(J)}z.dispose(),R.dispose()}catch(J){z.dispose(),R.dispose(),$.reject(J)}})}e.createCancelableAsyncIterable=B}),define(ee[98],te([0,1,24,8,30,38,9,4,25]),function(q,e,E,t,C,A,M,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function v(){return Object.create(null)}e.getEmptyExpression=v,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const S="[/\\\\]",P="[^/\\\\]",I=/\//g;function h(W,L){switch(W){case 0:return"";case 1:return`${P}*?`;default:return`(?:${S}|${P}+${S}${L?`|${S}${P}+`:""})*?`}}function m(W,L){if(!W)return[];const T=[];let U=!1,Q=!1,B="";for(const H of W){switch(H){case L:if(!U&&!Q){T.push(B),B="";continue}break;case"{":U=!0;break;case"}":U=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}B+=H}return B&&T.push(B),T}e.splitGlobAware=m;function f(W){if(!W)return"";let L="";const T=m(W,e.GLOB_SPLIT);if(T.every(U=>U===e.GLOBSTAR))L=".*";else{let U=!1;T.forEach((Q,B)=>{if(Q===e.GLOBSTAR){if(U)return;L+=h(2,B===T.length-1)}else{let H=!1,R="",F=!1,$="";for(const z of Q){if(z!=="}"&&H){R+=z;continue}if(F&&(z!=="]"||!$)){let J;z==="-"?J=z:(z==="^"||z==="!")&&!$?J="^":z===e.GLOB_SPLIT?J="":J=(0,w.escapeRegExpCharacters)(z),$+=J;continue}switch(z){case"{":H=!0;continue;case"[":F=!0;continue;case"}":{L+=`(?:${m(R,",").map(j=>f(j)).join("|")})`,H=!1,R="";break}case"]":{L+="["+$+"]",F=!1,$="";break}case"?":L+=P;continue;case"*":L+=h(1);continue;default:L+=(0,w.escapeRegExpCharacters)(z)}}B<T.length-1&&(T[B+1]!==e.GLOBSTAR||B+2<T.length)&&(L+=S)}U=Q===e.GLOBSTAR})}return L}const p=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new A.LRUCache(1e4),s=function(){return!1},i=function(){return null};function a(W,L){if(!W)return i;let T;typeof W!="string"?T=W.pattern:T=W,T=T.trim();const U=`${T}_${!!L.trimForExclusions}`;let Q=n.get(U);if(Q)return r(Q,W);let B;return p.test(T)?Q=o(T.substr(4),T):(B=u.exec(c(T,L)))?Q=y(B[1],T):(L.trimForExclusions?g:b).test(T)?Q=D(T,L):(B=d.exec(c(T,L)))?Q=O(B[1].substr(1),T,!0):(B=l.exec(c(T,L)))?Q=O(B[1],T,!1):Q=N(T),n.set(U,Q),r(Q,W)}function r(W,L){if(typeof L=="string")return W;const T=function(U,Q){return(0,C.isEqualOrParent)(U,L.base,!k.isLinux)?W((0,w.ltrim)(U.substr(L.base.length),M.sep),Q):null};return T.allBasenames=W.allBasenames,T.allPaths=W.allPaths,T.basenames=W.basenames,T.patterns=W.patterns,T}function c(W,L){return L.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function o(W,L){return function(T,U){return typeof T=="string"&&T.endsWith(W)?L:null}}function y(W,L){const T=`/${W}`,U=`\\${W}`,Q=function(H,R){return typeof H!="string"?null:R?R===W?L:null:H===W||H.endsWith(T)||H.endsWith(U)?L:null},B=[W];return Q.basenames=B,Q.patterns=[L],Q.allBasenames=B,Q}function D(W,L){const T=X(W.slice(1,-1).split(",").map(R=>a(R,L)).filter(R=>R!==i),W),U=T.length;if(!U)return i;if(U===1)return T[0];const Q=function(R,F){for(let $=0,z=T.length;$<z;$++)if(T[$](R,F))return W;return null},B=T.find(R=>!!R.allBasenames);B&&(Q.allBasenames=B.allBasenames);const H=T.reduce((R,F)=>F.allPaths?R.concat(F.allPaths):R,[]);return H.length&&(Q.allPaths=H),Q}function O(W,L,T){const U=M.sep===M.posix.sep,Q=U?W:W.replace(I,M.sep),B=M.sep+Q,H=M.posix.sep+W;let R;return T?R=function(F,$){return typeof F=="string"&&(F===Q||F.endsWith(B)||!U&&(F===W||F.endsWith(H)))?L:null}:R=function(F,$){return typeof F=="string"&&(F===Q||!U&&F===W)?L:null},R.allPaths=[(T?"*/":"./")+W],R}function N(W){try{const L=new RegExp(`^${f(W)}$`);return function(T){return L.lastIndex=0,typeof T=="string"&&L.test(T)?W:null}}catch{return i}}function Y(W,L,T){return!W||typeof L!="string"?!1:G(W)(L,void 0,T)}e.match=Y;function G(W,L={}){if(!W)return s;if(typeof W=="string"||V(W)){const T=a(W,L);if(T===i)return s;const U=function(Q,B){return!!T(Q,B)};return T.allBasenames&&(U.allBasenames=T.allBasenames),T.allPaths&&(U.allPaths=T.allPaths),U}return re(W,L)}e.parse=G;function V(W){const L=W;return L?typeof L.base=="string"&&typeof L.pattern=="string":!1}e.isRelativePattern=V;function se(W){return W.allBasenames||[]}e.getBasenameTerms=se;function oe(W){return W.allPaths||[]}e.getPathTerms=oe;function re(W,L){const T=X(Object.getOwnPropertyNames(W).map(R=>de(R,W[R],L)).filter(R=>R!==i)),U=T.length;if(!U)return i;if(!T.some(R=>!!R.requiresSiblings)){if(U===1)return T[0];const R=function(z,J){let ne;for(let j=0,x=T.length;j<x;j++){const _=T[j](z,J);if(typeof _=="string")return _;(0,t.isThenable)(_)&&(ne||(ne=[]),ne.push(_))}return ne?(async()=>{for(const j of ne){const x=await j;if(typeof x=="string")return x}return null})():null},F=T.find(z=>!!z.allBasenames);F&&(R.allBasenames=F.allBasenames);const $=T.reduce((z,J)=>J.allPaths?z.concat(J.allPaths):z,[]);return $.length&&(R.allPaths=$),R}const Q=function(R,F,$){let z,J;for(let ne=0,j=T.length;ne<j;ne++){const x=T[ne];x.requiresSiblings&&$&&(F||(F=(0,M.basename)(R)),z||(z=F.substr(0,F.length-(0,M.extname)(R).length)));const _=x(R,F,z,$);if(typeof _=="string")return _;(0,t.isThenable)(_)&&(J||(J=[]),J.push(_))}return J?(async()=>{for(const ne of J){const j=await ne;if(typeof j=="string")return j}return null})():null},B=T.find(R=>!!R.allBasenames);B&&(Q.allBasenames=B.allBasenames);const H=T.reduce((R,F)=>F.allPaths?R.concat(F.allPaths):R,[]);return H.length&&(Q.allPaths=H),Q}function de(W,L,T){if(L===!1)return i;const U=a(W,T);if(U===i)return i;if(typeof L=="boolean")return U;if(L){const Q=L.when;if(typeof Q=="string"){const B=(H,R,F,$)=>{if(!$||!U(H,R))return null;const z=Q.replace("$(basename)",F),J=$(z);return(0,t.isThenable)(J)?J.then(ne=>ne?W:null):J?W:null};return B.requiresSiblings=!0,B}}return U}function X(W,L){const T=W.filter(R=>!!R.basenames);if(T.length<2)return W;const U=T.reduce((R,F)=>{const $=F.basenames;return $?R.concat($):R},[]);let Q;if(L){Q=[];for(let R=0,F=U.length;R<F;R++)Q.push(L)}else Q=T.reduce((R,F)=>{const $=F.patterns;return $?R.concat($):R},[]);const B=function(R,F){if(typeof R!="string")return null;if(!F){let z;for(z=R.length;z>0;z--){const J=R.charCodeAt(z-1);if(J===47||J===92)break}F=R.substr(z)}const $=U.indexOf(F);return $!==-1?Q[$]:null};B.basenames=U,B.patterns=Q,B.allBasenames=U;const H=W.filter(R=>!R.basenames);return H.push(B),H}function le(W,L){return(0,E.equals)(W,L,(T,U)=>typeof T=="string"&&typeof U=="string"?T===U:typeof T!="string"&&typeof U!="string"?T.base===U.base&&T.pattern===U.pattern:!1)}e.patternsEquals=le}),define(ee[33],te([0,1,24,30,9,4,19,25]),function(q,e,E,t,C,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(i,a){const{os:r,tildify:c,relative:o}=a;if(o){const O=v(i,o,r);if(typeof O=="string")return O}let y=i.fsPath;if(r===1&&!A.isWindows?y=y.replace(/\//g,"\\"):r!==1&&A.isWindows&&(y=y.replace(/\\/g,"/")),r!==1&&c?.userHome){const O=c.userHome.fsPath;let N;i.scheme!==c.userHome.scheme&&i.path.startsWith(C.posix.sep)?N=c.userHome.with({path:i.path}).fsPath:N=i.fsPath,y=I(N,O,r)}return(r===1?C.win32:C.posix).normalize(S(y,r===1))}e.getPathLabel=w;function v(i,a,r){const c=r===1?C.win32:C.posix,o=r===3?M.extUri:M.extUriIgnorePathCase,y=a.getWorkspace(),D=(0,E.firstOrDefault)(y.folders);if(!D)return;i.scheme!==D.uri.scheme&&i.path.startsWith(C.posix.sep)&&(i=D.uri.with({path:i.path}));const O=a.getWorkspaceFolder(i);if(!O)return;let N;if(o.isEqual(O.uri,i)?N="":N=o.relativePath(O.uri,i)??"",N&&(N=c.normalize(N)),y.folders.length>1&&!a.noPrefix){const Y=O.name?O.name:o.basenameOrAuthority(O.uri);N=N?`${Y} \u2022 ${N}`:Y}return N}function S(i,a=A.isWindows){return(0,t.hasDriveLetter)(i,a)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=S;let P=Object.create(null);function I(i,a,r=A.OS){if(r===1||!i||!a)return i;let c=P.original===a?P.normalized:void 0;c||(c=a,A.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,k.rtrim)(c,C.posix.sep)}${C.posix.sep}`,P={original:a,normalized:c});let o=i;return A.isWindows&&(o=(0,t.toSlashes)(o)),(r===3?o.startsWith(c):(0,k.startsWithIgnoreCase)(o,c))?`~/${o.substr(c.length)}`:i}e.tildify=I;function h(i,a){return i.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=h;const m="\u2026",f="\\\\",p="~";function u(i,a=C.sep){const r=new Array(i.length);let c=!1;for(let o=0;o<i.length;o++){const y=i[o];if(y===""){r[o]=`.${a}`;continue}if(!y){r[o]=y;continue}c=!0;let D="",O=y;O.indexOf(f)===0?(D=O.substr(0,O.indexOf(f)+f.length),O=O.substr(O.indexOf(f)+f.length)):O.indexOf(a)===0?(D=O.substr(0,O.indexOf(a)+a.length),O=O.substr(O.indexOf(a)+a.length)):O.indexOf(p)===0&&(D=O.substr(0,O.indexOf(p)+p.length),O=O.substr(O.indexOf(p)+p.length));const N=O.split(a);for(let Y=1;c&&Y<=N.length;Y++)for(let G=N.length-Y;c&&G>=0;G--){c=!1;let V=N.slice(G,G+Y).join(a);for(let se=0;!c&&se<i.length;se++)if(se!==o&&i[se]&&i[se].indexOf(V)>-1){const oe=G+Y===N.length,re=G>0&&i[se].indexOf(a)>-1?a+V:V,de=i[se].endsWith(re);c=!oe||de}if(!c){let se="";(N[0].endsWith(":")||D!=="")&&(G===1&&(G=0,Y++,V=N[0]+a+V),G>0&&(se=N[0]+a),se=D+se),G>0&&(se=se+m+a),se=se+V,G+Y<N.length&&(se=se+a+m),r[o]=se}}c&&(r[o]=y)}return r}e.shorten=u;var b;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(b||(b={}));function g(i,a=Object.create(null)){const r=[];let c=!1,o="";for(const y of i)if(y==="$"||c&&y==="{")o&&r.push({value:o,type:b.TEXT}),o="",c=!0;else if(y==="}"&&c){const D=a[o];if(typeof D=="string")D.length&&r.push({value:D,type:b.VARIABLE});else if(D){const O=r[r.length-1];(!O||O.type!==b.SEPARATOR)&&r.push({value:D.label,type:b.SEPARATOR})}o="",c=!1}else o+=y;return o&&!c&&r.push({value:o,type:b.TEXT}),r.filter((y,D)=>{if(y.type===b.SEPARATOR){const O=r[D-1],N=r[D+1];return[O,N].every(Y=>Y&&(Y.type===b.VARIABLE||Y.type===b.TEXT)&&Y.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=g;function d(i,a){return A.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=d;function l(i,a){return A.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,r=>r==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(i){const a=i.indexOf("/")!==-1?C.posix:C.win32,r=a.basename(i),c=a.dirname(i);return r.length?{name:r,parentPath:c}:{name:c,parentPath:""}}e.splitName=s}),define(ee[139],te([0,1,7]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(S){return S.toJSON()}class C{constructor(P){this.a=P}transformIncoming(P){const I=this.a.transformIncoming(P);return I===P?P:t(E.URI.from(I))}transformOutgoing(P){const I=this.a.transformOutgoing(P);return I===P?P:t(E.URI.from(I))}transformOutgoingURI(P){const I=this.a.transformOutgoing(P);return I===P?P:E.URI.from(I)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function A(S,P,I){if(!S||I>200)return null;if(typeof S=="object"){if(S instanceof E.URI)return P.transformOutgoing(S);for(const h in S)if(Object.hasOwnProperty.call(S,h)){const m=A(S[h],P,I+1);m!==null&&(S[h]=m)}}return null}function M(S,P){const I=A(S,P,0);return I===null?S:I}e.transformOutgoingURIs=M;function k(S,P,I,h){if(!S||h>200)return null;if(typeof S=="object"){if(S.$mid===1)return I?E.URI.revive(P.transformIncoming(S)):P.transformIncoming(S);for(const m in S)if(Object.hasOwnProperty.call(S,m)){const f=k(S[m],P,I,h+1);f!==null&&(S[m]=f)}}return null}function w(S,P){const I=k(S,P,!1,0);return I===null?S:I}e.transformIncomingURIs=w;function v(S,P){const I=k(S,P,!0,0);return I===null?S:I}e.transformAndReviveIncomingURIs=v}),define(ee[81],te([0,1,27,15,58,29,127]),function(q,e,E,t,C,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(S){return this.a||(this.a=C.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(S)}value(){if(this.b===void 0){let S=0,P=0;const I=(0,E.networkInterfaces)();for(const h in I){const m=I[h];if(m)for(const{mac:f,internal:p}of m)p||(P+=1,this.c(f.toUpperCase())&&(S+=1))}this.b=P>0?S/P:0}return this.b}};let k;async function w(){return k||(k=(async()=>await v()||A.generateUuid())()),k}e.getMachineId=w;async function v(){try{const S=await new Promise((I,h)=>{q(["crypto"],I,h)}),P=(0,M.getMac)();return S.createHash("sha256").update(P,"utf8").digest("hex")}catch(S){t.onUnexpectedError(S);return}}}),define(ee[23],te([0,1,39,27,140,8,30,76,9,4,19,7]),function(q,e,E,t,C,A,M,k,w,v,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var I;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(I=e.RimRafMode||(e.RimRafMode={}));async function h(re,de=I.UNLINK){if((0,M.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");return de===I.UNLINK?f(re):m(re)}async function m(re){try{const de=(0,M.randomPath)((0,t.tmpdir)());try{await E.promises.rename(re,de)}catch(X){return X.code==="ENOENT"?void 0:f(re)}f(de).catch(X=>{})}catch(de){if(de.code!=="ENOENT")throw de}}async function f(re){return(0,C.promisify)(E.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function p(re){if((0,M.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function u(re,de){return d(await(de?b(re):(0,C.promisify)(E.readdir)(re)))}async function b(re){try{return await(0,C.promisify)(E.readdir)(re,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const de=[],X=await u(re);for(const le of X){let W=!1,L=!1,T=!1;try{const U=await e.Promises.lstat((0,w.join)(re,le));W=U.isFile(),L=U.isDirectory(),T=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}de.push({name:le,isFile:()=>W,isDirectory:()=>L,isSymbolicLink:()=>T})}return de}function g(re){return d(E.readdirSync(re))}e.readdirSync=g;function d(re){return re.map(de=>typeof de=="string"?v.isMacintosh?(0,k.normalizeNFC)(de):de:(de.name=v.isMacintosh?(0,k.normalizeNFC)(de.name):de.name,de))}async function l(re){const de=await u(re),X=[];for(const le of de)await s.existsDirectory((0,w.join)(re,le))&&X.push(le);return X}function n(re,de=1e3){return new Promise(X=>{let le=!1;const W=setInterval(()=>{le||(le=!0,E.access(re,L=>{le=!1,L&&(clearInterval(W),X(void 0))}))},de)})}e.whenDeleted=n;var s;(function(re){async function de(W){let L;try{if(L=await e.Promises.lstat(W),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(v.isWindows&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw U}throw T}}re.stat=de;async function X(W){try{const{stat:L,symbolicLink:T}=await re.stat(W);return L.isFile()&&T?.dangling!==!0}catch{}return!1}re.existsFile=X;async function le(W){try{const{stat:L,symbolicLink:T}=await re.stat(W);return L.isDirectory()&&T?.dangling!==!0}catch{}return!1}re.existsDirectory=le})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new A.ResourceQueue;function a(re,de,X){return i.queueFor(P.URI.file(re),S.extUriBiasedIgnorePathCase).queue(()=>{const le=D(X);return new Promise((W,L)=>o(re,de,le,T=>T?L(T):W()))})}let r=!0;function c(re){r=re}e.configureFlushOnWrite=c;function o(re,de,X,le){if(!r)return E.writeFile(re,de,{mode:X.mode,flag:X.flag},le);E.open(re,X.flag,X.mode,(W,L)=>{if(W)return le(W);E.writeFile(L,de,T=>{if(T)return E.close(L,()=>le(T));E.fdatasync(L,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),c(!1)),E.close(L,Q=>le(Q))))})})}function y(re,de,X){const le=D(X);if(!r)return E.writeFileSync(re,de,{mode:le.mode,flag:le.flag});const W=E.openSync(re,le.flag,le.mode);try{E.writeFileSync(W,de);try{E.fdatasyncSync(W)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),c(!1)}}finally{E.closeSync(W)}}e.writeFileSync=y;function D(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function O(re,de){if(re!==de)try{await e.Promises.rename(re,de)}catch(X){if(re.toLowerCase()!==de.toLowerCase()&&X.code==="EXDEV"||re.endsWith("."))await N(re,de,{preserveSymlinks:!1}),await h(re,I.MOVE);else throw X}}async function N(re,de,X){return G(re,de,{root:{source:re,target:de},options:X,handledSourcePaths:new Set})}const Y=511;async function G(re,de,X){if(X.handledSourcePaths.has(re))return;X.handledSourcePaths.add(re);const{stat:le,symbolicLink:W}=await s.stat(re);if(W){if(X.options.preserveSymlinks)try{return await oe(re,de,X)}catch(L){console.warn("[node.js fs] copy of symlink failed: ",L)}if(W.dangling)return}return le.isDirectory()?V(re,de,le.mode&Y,X):se(re,de,le.mode&Y)}async function V(re,de,X,le){await e.Promises.mkdir(de,{recursive:!0,mode:X});const W=await u(re);for(const L of W)await G((0,w.join)(re,L),(0,w.join)(de,L),le)}async function se(re,de,X){await e.Promises.copyFile(re,de),await e.Promises.chmod(de,X)}async function oe(re,de,X){let le=await e.Promises.readlink(re);(0,M.isEqualOrParent)(le,X.root.source,!v.isLinux)&&(le=(0,w.join)(X.root.target,le.substr(X.root.source.length+1))),await e.Promises.symlink(le,de)}e.Promises=new class{get access(){return(0,C.promisify)(E.access)}get stat(){return(0,C.promisify)(E.stat)}get lstat(){return(0,C.promisify)(E.lstat)}get utimes(){return(0,C.promisify)(E.utimes)}get read(){return(re,de,X,le,W)=>new Promise((L,T)=>{E.read(re,de,X,le,W,(U,Q,B)=>U?T(U):L({bytesRead:Q,buffer:B}))})}get readFile(){return(0,C.promisify)(E.readFile)}get write(){return(re,de,X,le,W)=>new Promise((L,T)=>{E.write(re,de,X,le,W,(U,Q,B)=>U?T(U):L({bytesWritten:Q,buffer:B}))})}get appendFile(){return(0,C.promisify)(E.appendFile)}get fdatasync(){return(0,C.promisify)(E.fdatasync)}get truncate(){return(0,C.promisify)(E.truncate)}get rename(){return(0,C.promisify)(E.rename)}get copyFile(){return(0,C.promisify)(E.copyFile)}get open(){return(0,C.promisify)(E.open)}get close(){return(0,C.promisify)(E.close)}get symlink(){return(0,C.promisify)(E.symlink)}get readlink(){return(0,C.promisify)(E.readlink)}get chmod(){return(0,C.promisify)(E.chmod)}get mkdir(){return(0,C.promisify)(E.mkdir)}get unlink(){return(0,C.promisify)(E.unlink)}get rmdir(){return(0,C.promisify)(E.rmdir)}get realpath(){return(0,C.promisify)(E.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return l}get writeFile(){return a}get rm(){return h}get move(){return O}get copy(){return N}}}),define(ee[99],te([0,1,39,9,4,25,23]),function(q,e,E,t,C,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(I){if(C.isLinux)return I;const h=(0,t.dirname)(I);if(I===h)return I;const m=((0,t.basename)(I)||I).toLowerCase();try{const p=(0,M.readdirSync)(h).filter(u=>u.toLowerCase()===m);if(p.length===1){const u=k(h);if(u)return(0,t.join)(u,p[0])}else if(p.length>1){const u=p.indexOf(m);if(u>=0){const b=k(h);if(b)return(0,t.join)(b,p[u])}}}catch{}return null}e.realcaseSync=k;async function w(I){if(C.isLinux)return I;const h=(0,t.dirname)(I);if(I===h)return I;const m=((0,t.basename)(I)||I).toLowerCase();try{const p=(await M.Promises.readdir(h)).filter(u=>u.toLowerCase()===m);if(p.length===1){const u=await w(h);if(u)return(0,t.join)(u,p[0])}else if(p.length>1){const u=p.indexOf(m);if(u>=0){const b=await w(h);if(b)return(0,t.join)(b,p[u])}}}catch{}return null}e.realcase=w;async function v(I){try{return await M.Promises.realpath(I)}catch{const m=P(I);return await M.Promises.access(m,E.constants.R_OK),m}}e.realpath=v;function S(I){try{return E.realpathSync(I)}catch{const m=P(I);return E.accessSync(m,E.constants.R_OK),m}}e.realpathSync=S;function P(I){return(0,A.rtrim)((0,t.normalize)(I),t.sep)}}),define(ee[141],te([0,1,27,9,23]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,M=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var w;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(w||(w={}));let v;switch(process.arch){case"ia32":case"x32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class P{constructor(l,n,s){this.exePath=l,this.displayName=n,this.a=s}async exists(){return this.a===void 0&&(this.a=await C.SymlinkSupport.existsFile(this.exePath)),this.a}}function I({useAlternateBitness:d=!1}={}){return d?v===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:d=!1,findPreview:l=!1}={}){const n=I({useAlternateBitness:d});if(!n)return null;const s=t.join(n,"PowerShell");if(!await C.SymlinkSupport.existsDirectory(s))return null;let i=-1,a=null;for(const o of await C.Promises.readdir(s)){let y=-1;if(l){const O=o.indexOf("-");if(O<0)continue;const N=o.substring(0,O);if(!A.test(N)||o.substring(O+1)!=="preview")continue;y=parseInt(N,10)}else{if(!A.test(o))continue;y=parseInt(o,10)}if(y<=i)continue;const D=t.join(s,o,"pwsh.exe");!await C.SymlinkSupport.existsFile(D)||(a=D,i=y)}if(!a)return null;const r=n.includes("x86")?" (x86)":"",c=l?" Preview":"";return new P(a,`PowerShell${c}${r}`,!0)}async function m({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const l=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await C.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:n,pwshMsixName:s}=d?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const i of await C.Promises.readdir(l))if(n.test(i)){const a=t.join(l,i,"pwsh.exe");return new P(a,s)}return null}function f(){const d=t.join(E.homedir(),".dotnet","tools","pwsh.exe");return new P(d,".NET Core PowerShell Global Tool")}function p(){const d=t.join(process.env.windir,v===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(d,"Windows PowerShell",!0)}async function*u(){let d=await h();d&&(yield d),d=await h({useAlternateBitness:!0}),d&&(yield d),d=await m(),d&&(yield d),d=f(),d&&(yield d),d=await h({findPreview:!0}),d&&(yield d),d=await m({findPreview:!0}),d&&(yield d),d=await h({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=p(),d&&(yield d)}async function*b(){for await(const d of u())await d.exists()&&(yield d)}e.enumeratePowerShellInstallations=b;async function g(){for await(const d of b())return d;return null}e.getFirstAvailablePowerShellInstallation=g}),define(ee[82],te([0,1,9,4,32,79,12,23]),function(q,e,E,t,C,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function w(P=C.env){return P.comspec||"cmd.exe"}e.getWindowsShell=w;function v(P){let I=[],h=!1;const m=function(f){if(h){I.push(f);return}(!P.send(f,u=>{if(u&&console.error(u),h=!1,I.length>0){const b=I.slice(0);I=[],b.forEach(g=>m(g))}})||t.isWindows)&&(h=!0)};return{send:m}}e.createQueuedSender=v;var S;(function(P){async function I(h,m,f){if(E.isAbsolute(h))return h;if(m===void 0&&(m=C.cwd()),E.dirname(h)!=="."||(f===void 0&&M.isString(C.env.PATH)&&(f=C.env.PATH.split(E.delimiter)),f===void 0||f.length===0))return E.join(m,h);async function u(b){if(await k.Promises.exists(b)){let g;try{g=await k.Promises.stat(b)}catch(d){d.message.startsWith("EACCES")&&(g=await k.Promises.lstat(b))}return g?!g.isDirectory():!1}return!1}for(const b of f){let g;if(E.isAbsolute(b)?g=E.join(b,h):g=E.join(m,b,h),await u(g))return g;let d=g+".com";if(await u(d)||(d=g+".exe",await u(d)))return d}return E.join(m,h)}P.findExecutable=I})(S=e.win32||(e.win32={}))}),define(ee[100],te([0,1,44,14]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function C(M){return new Promise((k,w)=>{let v;const S=new Map;function P(h,m,f,p,u){const b=S.get(m);if(h===M||b){const g={name:I(f),cmd:f,pid:h,ppid:m,load:p,mem:u};S.set(h,g),h===M&&(v=g),b&&(b.children||(b.children=[]),b.children.push(g),b.children.length>1&&(b.children=b.children.sort((d,l)=>d.pid-l.pid)))}}function I(h){const m=/--vscode-window-kind=shared-process/,f=/--vscode-window-kind=issue-reporter/,p=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,b=/--utility-sub-type=node.mojom.NodeService/,g=/--crashes-directory/,d=/\\pipe\\winpty-control/,l=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(g.exec(h))return"electron-crash-reporter";if(d.exec(h))return"winpty-process";if(l.exec(h))return"console-window-host (Windows internal process)";let s=n.exec(h);if(s&&s.length===2){if(s[1]==="renderer")return m.exec(h)?"shared-process":f.exec(h)?"issue-reporter":p.exec(h)?"process-explorer":"window";if(s[1]==="utility"){if(u.exec(h))return"utility-network-service";if(b.exec(h))return"extension-host"}return s[1]}const i=/[a-zA-Z-]+\.js/g;let a="";do s=i.exec(h),s&&(a+=s+" ");while(s);return a&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron_node ${a}`:h}if(process.platform==="win32"){const h=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,f)=>{q(["windows-process-tree"],m,f)}).then(m=>{m.getProcessList(M,f=>{if(!f){w(new Error(`Root process ${M} not found`));return}m.getProcessCpuUsage(f,p=>{const u=new Map;p.forEach(b=>{const g=h(b.commandLine||"");u.set(b.pid,{name:I(g),cmd:g,pid:b.pid,ppid:b.ppid,load:b.cpu||0,mem:b.memory||0})}),v=u.get(M),v?(u.forEach(b=>{const g=u.get(b.ppid);g&&(g.children||(g.children=[]),g.children.push(b))}),u.forEach(b=>{b.children&&(b.children=b.children.sort((g,d)=>g.pid-d.pid))}),k(v)):w(new Error(`Root process ${M} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let h=function(){let m=[v];const f=[];for(;m.length;){const u=m.shift();u&&(f.push(u.pid),u.children&&(m=m.concat(u.children)))}let p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+f.join(" "),(0,E.exec)(p,{},(u,b,g)=>{if(u||g)w(u||new Error(g.toString()));else{const d=b.toString().split(`
`);for(let l=0;l<f.length;l++){const n=S.get(f[l]);n.load=parseFloat(d[l])}if(!v){w(new Error(`Root process ${M} not found`));return}k(v)}})};(0,E.exec)("which ps",{},(m,f,p)=>{if(m||p)if(process.platform!=="linux")w(m||new Error(p.toString()));else{const u=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(u,{},(b,g,d)=>{b||d?w(b||new Error(d.toString())):(A(g,P),h())})}else{const u=f.toString().trim(),b="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${u} ${b}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,d,l)=>{g||l&&!l.includes("screen size is bogus")?w(g||new Error(l.toString())):(A(d,P),process.platform==="linux"?h():v?k(v):w(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=C;function A(M,k){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=M.toString().split(`
`);for(const S of v){const P=w.exec(S.trim());P&&P.length===6&&k(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}}),define(ee[142],te([0,1,27,4,141,82]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(h,m){return h===1?t.isWindows?P():A.getWindowsShell(m):v(h,m)}e.getSystemShell=M;function k(h,m){return h===1?t.isWindows?I(m):A.getWindowsShell(m):v(h,m)}e.getSystemShellSync=k;let w=null;function v(h,m){if(t.isLinux&&h===2||t.isMacintosh&&h===3)return"/bin/bash";if(!w){let f;if(t.isWindows)f="/bin/bash";else{if(f=m.SHELL,!f)try{f=(0,E.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}w=f}return w}let S=null;async function P(){return S||(S=(await(0,C.getFirstAvailablePowerShellInstallation)()).exePath),S}function I(h){if(S)return S;const m=t.isWindows&&parseFloat((0,E.release)())>=10,f=h.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${h.windir}\\${f?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return m?p:A.getWindowsShell(h)}});var pe=this&&this.__decorate||function(q,e,E,t){var C=arguments.length,A=C<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,E):t,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(q,e,E,t);else for(var k=q.length-1;k>=0;k--)(M=q[k])&&(A=(C<3?M(A):C>3?M(e,E,A):M(e,E))||A);return C>3&&A&&Object.defineProperty(e,E,A),A};define(ee[45],te([0,1,24,8,17,22,53,15,3,2,68,25,12]),function(q,e,E,t,C,A,M,k,w,v,S,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var h;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(h||(h={}));function m(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(f||(f={}));function p(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(u||(u={}));class b{constructor(L){this.b=L,this.a=0}read(L){const T=this.b.slice(this.a,this.a+L);return this.a+=T.byteLength,T}}class g{constructor(){this.a=[]}get buffer(){return C.VSBuffer.concat(this.a)}write(L){this.a.push(L)}}var d;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(d||(d={}));function l(W){const L=C.VSBuffer.alloc(4);return L.writeUInt32BE(W,0),L}function n(W){return W.read(4).readUInt32BE(0)}function s(W){const L=C.VSBuffer.alloc(1);return L.writeUInt8(W,0),L}const i={Undefined:s(d.Undefined),String:s(d.String),Buffer:s(d.Buffer),VSBuffer:s(d.VSBuffer),Array:s(d.Array),Object:s(d.Object)},a=typeof Buffer<"u";function r(W,L){if(typeof L>"u")W.write(i.Undefined);else if(typeof L=="string"){const T=C.VSBuffer.fromString(L);W.write(i.String),W.write(l(T.byteLength)),W.write(T)}else if(a&&Buffer.isBuffer(L)){const T=C.VSBuffer.wrap(L);W.write(i.Buffer),W.write(l(T.byteLength)),W.write(T)}else if(L instanceof C.VSBuffer)W.write(i.VSBuffer),W.write(l(L.byteLength)),W.write(L);else if(Array.isArray(L)){W.write(i.Array),W.write(l(L.length));for(const T of L)r(W,T)}else{const T=C.VSBuffer.fromString(JSON.stringify(L));W.write(i.Object),W.write(l(T.byteLength)),W.write(T)}}function c(W){switch(W.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return W.read(n(W)).toString();case d.Buffer:return W.read(n(W)).buffer;case d.VSBuffer:return W.read(n(W));case d.Array:{const T=n(W),U=[];for(let Q=0;Q<T;Q++)U.push(c(W));return U}case d.Object:return JSON.parse(W.read(n(W)).toString())}}class o{constructor(L,T,U=null,Q=1e3){this.h=L,this.j=T,this.k=U,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(B=>this.p(B)),this.m({type:200})}registerChannel(L,T){this.b.set(L,T),setTimeout(()=>this.v(L),0)}m(L){switch(L.type){case 200:{const T=this.n([L.type]);this.k?.logOutgoing(T,0,1,p(L.type));return}case 201:case 202:case 204:case 203:{const T=this.n([L.type,L.id],L.data);this.k?.logOutgoing(T,L.id,1,p(L.type),L.data);return}}}n(L,T=void 0){const U=new g;return r(U,L),r(U,T),this.o(U.buffer)}o(L){try{return this.h.send(L),L.byteLength}catch{return 0}}p(L){const T=new b(L),U=c(T),Q=c(T),B=U[0];switch(B){case 100:return this.k?.logIncoming(L.byteLength,U[1],1,`${m(B)}: ${U[2]}.${U[3]}`,Q),this.q({type:B,id:U[1],channelName:U[2],name:U[3],arg:Q});case 102:return this.k?.logIncoming(L.byteLength,U[1],1,`${m(B)}: ${U[2]}.${U[3]}`,Q),this.s({type:B,id:U[1],channelName:U[2],name:U[3],arg:Q});case 101:return this.k?.logIncoming(L.byteLength,U[1],1,`${m(B)}`),this.t({type:B,id:U[1]});case 103:return this.k?.logIncoming(L.byteLength,U[1],1,`${m(B)}`),this.t({type:B,id:U[1]})}}q(L){const T=this.b.get(L.channelName);if(!T){this.u(L);return}const U=new A.CancellationTokenSource;let Q;try{Q=T.call(this.j,L.name,L.arg,U.token)}catch(R){Q=Promise.reject(R)}const B=L.id;Q.then(R=>{this.m({id:B,data:R,type:201}),this.d.delete(L.id)},R=>{R instanceof Error?this.m({id:B,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.m({id:B,data:R,type:203}),this.d.delete(L.id)});const H=(0,v.toDisposable)(()=>U.cancel());this.d.set(L.id,H)}s(L){const T=this.b.get(L.channelName);if(!T){this.u(L);return}const U=L.id,B=T.listen(this.j,L.name,L.arg)(H=>this.m({id:U,data:H,type:204}));this.d.set(L.id,B)}t(L){const T=this.d.get(L.id);T&&(T.dispose(),this.d.delete(L.id))}u(L){let T=this.g.get(L.channelName);T||(T=[],this.g.set(L.channelName,T));const U=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);T.push({request:L,timeoutTimer:U})}v(L){const T=this.g.get(L);if(T){for(const U of T)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.q(U.request);break;case 102:this.s(U.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,v.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=o;var y;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(L,T=null){this.l=L,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(U=>this.r(U)),this.j=T}getChannel(L){const T=this;return{call(U,Q,B){return T.a?Promise.reject(new k.CancellationError):T.m(L,U,Q,B)},listen(U,Q){return T.a?w.Event.None:T.n(L,U,Q)}}}m(L,T,U,Q=A.CancellationToken.None){const B=this.g++,R={id:B,type:100,channelName:L,name:T,arg:U};if(Q.isCancellationRequested)return Promise.reject(new k.CancellationError);let F;return new Promise((z,J)=>{if(Q.isCancellationRequested)return J(new k.CancellationError);const ne=()=>{const ae=ge=>{switch(ge.type){case 201:this.f.delete(B),z(ge.data);break;case 202:{this.f.delete(B);const Me=new Error(ge.data.message);Me.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,Me.name=ge.data.name,J(Me);break}case 203:this.f.delete(B),J(ge.data);break}};this.f.set(B,ae),this.o(R)};let j=null;this.b===u.Idle?ne():(j=(0,t.createCancelablePromise)(ae=>this.t()),j.then(()=>{j=null,ne()}));const x=()=>{j?(j.cancel(),j=null):this.o({id:B,type:101}),J(new k.CancellationError)},_=Q.onCancellationRequested(x);F=(0,v.combinedDisposable)((0,v.toDisposable)(x),_),this.d.add(F)}).finally(()=>{this.d.delete(F)})}n(L,T,U){const Q=this.g++,H={id:Q,type:102,channelName:L,name:T,arg:U};let R=null;const F=new w.Emitter({onWillAddFirstListener:()=>{R=(0,t.createCancelablePromise)(z=>this.t()),R.then(()=>{R=null,this.d.add(F),this.o(H)})},onDidRemoveLastListener:()=>{R?(R.cancel(),R=null):(this.d.delete(F),this.o({id:Q,type:103}))}}),$=z=>F.fire(z.data);return this.f.set(Q,$),F.event}o(L){switch(L.type){case 100:case 102:{const T=this.p([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(T,L.id,0,`${m(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const T=this.p([L.type,L.id]);this.j?.logOutgoing(T,L.id,0,m(L.type));return}}}p(L,T=void 0){const U=new g;return r(U,L),r(U,T),this.q(U.buffer)}q(L){try{return this.l.send(L),L.byteLength}catch{return 0}}r(L){const T=new b(L),U=c(T),Q=c(T),B=U[0];switch(B){case 200:return this.j?.logIncoming(L.byteLength,0,0,p(B)),this.s({type:U[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,U[1],0,p(B),Q),this.s({type:U[0],id:U[1],data:Q})}}s(L){if(L.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}t(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,v.dispose)(this.d.values()),this.d.clear()}}pe([M.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class O{get connections(){const L=[];return this.f.forEach(T=>L.push(T)),L}constructor(L){this.a=new Map,this.f=new Set,this.g=new w.Emitter,this.onDidAddConnection=this.g.event,this.h=new w.Emitter,this.onDidRemoveConnection=this.h.event,L(({protocol:T,onDidClientDisconnect:U})=>{w.Event.once(T.onMessage)(B=>{const H=new b(B),R=c(H),F=new o(T,R),$=new D(T);this.a.forEach((J,ne)=>F.registerChannel(ne,J));const z={channelServer:F,channelClient:$,ctx:R};this.f.add(z),this.g.fire(z),U(()=>{F.dispose(),$.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel(L,T){const U=this;return{call(Q,B,H){let R;if((0,I.isFunction)(T)){const $=(0,E.getRandomElement)(U.connections.filter(T));R=$?Promise.resolve($):w.Event.toPromise(w.Event.filter(U.onDidAddConnection,T))}else R=T.routeCall(U,Q,B);const F=R.then($=>$.channelClient.getChannel(L));return Y(F).call(Q,B,H)},listen(Q,B){if((0,I.isFunction)(T))return U.j(L,T,Q,B);const H=T.routeEvent(U,Q,B).then(R=>R.channelClient.getChannel(L));return Y(H).listen(Q,B)}}}j(L,T,U,Q){const B=this;let H=new v.DisposableStore;const R=new w.Emitter({onWillAddFirstListener:()=>{H=new v.DisposableStore;const F=new w.EventMultiplexer,$=new Map,z=ne=>{const x=ne.channelClient.getChannel(L).listen(U,Q),_=F.add(x);$.set(ne,_)},J=ne=>{const j=$.get(ne);!j||(j.dispose(),$.delete(ne))};B.connections.filter(T).forEach(z),w.Event.filter(B.onDidAddConnection,T)(z,void 0,H),B.onDidRemoveConnection(J,void 0,H),F.event(R.fire,R,H),H.add(F)},onDidRemoveLastListener:()=>{H.dispose()}});return R.event}registerChannel(L,T){this.a.set(L,T),this.f.forEach(U=>{U.channelServer.registerChannel(L,T)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=O;class N{constructor(L,T,U=null){const Q=new g;r(Q,T),L.send(Q.buffer),this.a=new D(L,U),this.d=new o(L,T,U)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,T){this.d.registerChannel(L,T)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function Y(W){return{call(L,T,U){return W.then(Q=>Q.call(L,T,U))},listen(L,T){const U=new w.Relay;return W.then(Q=>U.input=Q.listen(L,T)),U.event}}}e.getDelayedChannel=Y;function G(W){let L=!1;return{call(T,U,Q){return L?W.call(T,U,Q):(0,t.timeout)(0).then(()=>L=!0).then(()=>W.call(T,U,Q))},listen(T,U){if(L)return W.listen(T,U);const Q=new w.Relay;return(0,t.timeout)(0).then(()=>L=!0).then(()=>Q.input=W.listen(T,U)),Q.event}}}e.getNextTickChannel=G;class V{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const T of L.connections)if(await Promise.resolve(this.a(T.ctx)))return Promise.resolve(T);return await w.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.StaticRouter=V;var se;(function(W){function L(B,H){const R=B,F=H&&H.disableMarshalling,$=new Map;for(const z in R)U(z)&&$.set(z,w.Event.buffer(R[z],!0));return new class{listen(z,J,ne){const j=$.get(J);if(j)return j;if(Q(J)){const x=R[J];if(typeof x=="function")return x.call(R,ne)}throw new Error(`Event not found: ${J}`)}call(z,J,ne){const j=R[J];if(typeof j=="function"){if(!F&&Array.isArray(ne))for(let x=0;x<ne.length;x++)ne[x]=(0,S.revive)(ne[x]);return j.apply(R,ne)}throw new Error(`Method not found: ${J}`)}}}W.fromService=L;function T(B,H){const R=H&&H.disableMarshalling;return new Proxy({},{get(F,$){if(typeof $=="string")return H?.properties?.has($)?H.properties.get($):Q($)?function(z){return B.listen($,z)}:U($)?B.listen($):async function(...z){let J;H&&!(0,I.isUndefinedOrNull)(H.context)?J=[H.context,...z]:J=z;const ne=await B.call($,J);return R?ne:(0,S.revive)(ne)};throw new Error(`Property not found: ${String($)}`)}})}W.toService=T;function U(B){return B[0]==="o"&&B[1]==="n"&&P.isUpperAsciiLetter(B.charCodeAt(2))}function Q(B){return/^onDynamic/.test(B)&&P.isUpperAsciiLetter(B.charCodeAt(9))}})(se=e.ProxyChannel||(e.ProxyChannel={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const L=W.toString();if(L!=="[object Object]")return L}return W}function de(W){return Array.isArray(W)?W.map(re):re(W)}function X(W,L,T,U,Q,B,H){H=de(H);const R=oe[Q],F=R[U%R.length];let $=[`%c[${W}]%c[${String(L).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${F}`];/\($/.test(B)?($=$.concat(H),$.push(")")):$.push(H),console.log.apply(console,$)}class le{constructor(L,T){this.d=L,this.f=T,this.a=0,this.b=0}logOutgoing(L,T,U,Q,B){this.b+=L,X(this.d,this.b,L,T,U,Q,B)}logIncoming(L,T,U,Q,B){this.a+=L,X(this.f,this.a,L,T,U,Q,B)}}e.IPCLogger=le}),define(ee[143],te([0,1,17,3,45]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(w){this.a=w,this.onMessage=t.Event.fromDOMEventEmitter(this.a,"message",v=>E.VSBuffer.wrap(v.data)),w.start()}send(w){this.a.postMessage(w.buffer)}disconnect(){this.a.close()}}e.Protocol=A;class M extends C.IPCClient{constructor(w,v){const S=new A(w);super(S,v),this.b=S}dispose(){this.b.disconnect()}}e.Client=M}),define(ee[101],te([0,1,17,3,2,45]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(M=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(a){a.enableDiagnostics=!1,a.records=[];const r=new WeakMap;let c=0;function o(D,O){if(!r.has(D)){const N=String(++c);r.set(D,N)}return r.get(D)}function y(D,O,N,Y){if(!a.enableDiagnostics)return;const G=o(D,O);if(Y instanceof E.VSBuffer||Y instanceof Uint8Array||Y instanceof ArrayBuffer||ArrayBuffer.isView(Y)){const V=E.VSBuffer.alloc(Y.byteLength);V.set(Y),a.records.push({timestamp:Date.now(),id:G,label:O,type:N,buff:V})}else a.records.push({timestamp:Date.now(),id:G,label:O,type:N,data:Y})}a.traceSocketEvent=y})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let v=null;function S(){return v||(v=E.VSBuffer.alloc(0)),v}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(r){this.a.push(r),this.b+=r.byteLength}read(r){return this.c(r,!0)}peek(r){return this.c(r,!1)}c(r,c){if(r===0)return S();if(r>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===r){const O=this.a[0];return c&&(this.a.shift(),this.b-=r),O}if(this.a[0].byteLength>r){const O=this.a[0].slice(0,r);return c&&(this.a[0]=this.a[0].slice(r),this.b-=r),O}const o=E.VSBuffer.alloc(r);let y=0,D=0;for(;r>0;){const O=this.a[D];if(O.byteLength>r){const N=O.slice(0,r);o.set(N,y),y+=r,c&&(this.a[D]=O.slice(r),this.b-=r),r-=r}else o.set(O,y),y+=O.byteLength,c?(this.a.shift(),this.b-=O.byteLength):D++,r-=O.byteLength}return o}}e.ChunkStream=P;var I;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume",a[a.KeepAlive=9]="KeepAlive"})(I||(I={}));function h(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(r,c,o,y){this.type=r,this.id=c,this.ack=o,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends C.Disposable{constructor(r){super(),this.f=this.B(new t.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=r,this.b=!1,this.c=new P,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(r);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,y=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new f(o,y,D,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(r){this.k=null,this.a=!1,this.b=!1,this.c=r,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(r){if(this.a)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=E.VSBuffer.alloc(13);c.writeUInt8(r.type,0),c.writeUInt32BE(r.id,1),c.writeUInt32BE(r.ack,5),c.writeUInt32BE(r.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",r.data),this.j(c,r.data)}g(r,c){const o=this.f===0;return this.d.push(r,c),this.f+=r.byteLength+c.byteLength,o}h(){const r=E.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,r}j(r,c){this.g(r,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const r=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this.c.write(r)}}class b extends C.Disposable{constructor(r){super(),this.f=new t.Emitter,this.onMessage=this.f.event,this.g=new t.Emitter,this.onDidDispose=this.g.event,this.a=r,this.b=this.B(new u(this.a)),this.c=this.B(new p(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(r){this.b.write(new f(1,0,0,r))}}e.Protocol=b;class g extends A.IPCClient{static fromSocket(r,c){return new g(new b(r),c)}get onDidDispose(){return this.b.onDidDispose}constructor(r,c,o=null){super(r,c,o),this.b=r}dispose(){super.dispose();const r=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),r.end()}}e.Client=g;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new t.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(r){this.b?this.d.length>0?this.d.push(r):this.a.fire(r):this.d.push(r)}flushBuffer(){this.d=[]}}e.BufferedEmitter=d;class l{constructor(r){this.data=r,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let r=0,c=this.a;for(;c;)c=c.next,r++;return r}peek(){return this.a?this.a.data:null}toArray(){const r=[];let c=0,o=this.a;for(;o;)r[c++]=o.data,o=o.next;return r}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(r){const c=new l(r);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class s{static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const r=Date.now();for(let c=0;c<s.a;c++)this.c[c]=r-1e3*c;setInterval(()=>{for(let c=s.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const r=Date.now(),c=(1+s.a)*1e3;let o=0;for(let y=0;y<s.a;y++)r-this.c[y]<=c&&o++;return 1-o/s.a}hasHighLoad(){return this.d()>=.5}}s.a=10,s.b=null;class i{get unacknowledgedCount(){return this.c-this.d}constructor(r,c=null,o=s.getInstance()){this.t=new d,this.onControlMessage=this.t.event,this.u=new d,this.onMessage=this.u.event,this.v=new d,this.onDidDispose=this.v.event,this.w=new d,this.onSocketClose=this.w.event,this.x=new d,this.onSocketTimeout=this.x.event,this.s=o,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=r,this.p=new u(this.o),this.r.push(this.p),this.q=new p(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(y=>this.y(y))),this.r.push(this.o.onClose(y=>this.w.fire(y))),c&&this.q.acceptChunk(c),this.l=setInterval(()=>{this.D()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,C.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const r=new f(5,0,0,S());this.p.write(r),this.p.flush()}sendPause(){const r=new f(7,0,0,S());this.p.write(r)}sendResume(){const r=new f(8,0,0,S());this.p.write(r)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(r,c){this.a=!0,this.r=(0,C.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=r,this.p=new u(this.o),this.r.push(this.p),this.q=new p(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(o=>this.y(o))),this.r.push(this.o.onClose(o=>this.w.fire(o))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const r=new f(3,0,this.h,S());this.p.write(r);const c=this.b.toArray();for(let o=0,y=c.length;o<y;o++)this.p.write(c[o]);this.B()}acceptDisconnect(){this.v.fire()}y(r){if(r.ack>this.d){this.d=r.ack;do{const c=this.b.peek();if(c&&c.id<=r.ack)this.b.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this.g)if(r.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new f(6,0,0,S())))}else this.g=r.id,this.j=Date.now(),this.A(),this.u.fire(r.data);break}case 2:{this.t.fire(r.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const c=this.b.toArray();for(let o=0,y=c.length;o<y;o++)this.p.write(c[o]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(r){const c=++this.c;this.h=this.g;const o=new f(1,c,this.h,r);this.b.push(o),this.a||(this.p.write(o),this.B())}sendControl(r){const c=new f(2,0,0,r);this.p.write(c)}A(){if(this.g<=this.h||this.k)return;const r=Date.now()-this.j;if(r>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-r+5)}B(){if(this.c<=this.d||this.f||this.a)return;const r=this.b.peek(),c=Date.now()-r.writtenTime,o=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(c>=2e4&&o>=2e4&&y>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:o});return}const D=Math.max(2e4-c,2e4-o,2e4-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const r=new f(3,0,this.h,S());this.p.write(r)}D(){const r=new f(9,0,0,S());this.p.write(r)}}e.PersistentProtocol=i}),define(ee[144],te([0,1,40,17,3,2,45,129]),function(q,e,E,t,C,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(S,P){const I=C.Event.fromNodeEventEmitter(E.validatedIpcMain,P,(m,f)=>({event:m,message:f})),h=C.Event.filter(I,({event:m})=>m.sender.id===S);return C.Event.map(h,({message:m})=>m&&t.VSBuffer.wrap(m))}class v extends M.IPCServer{static d(){const P=C.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:I})=>I);return C.Event.map(P,I=>{const h=I.id;v.b.get(h)?.dispose();const f=new C.Emitter;v.b.set(h,(0,A.toDisposable)(()=>f.fire()));const p=w(h,"vscode:message"),u=C.Event.any(C.Event.signal(w(h,"vscode:disconnect")),f.event);return{protocol:new k.Protocol(I,p),onDidClientDisconnect:u}})}constructor(){super(v.d())}}e.Server=v,v.b=new Map}),define(ee[102],te([0,1,40,3,29,143]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends A.Client{constructor(v,S){super({addEventListener:(P,I)=>v.addListener(P,I),removeEventListener:(P,I)=>v.removeListener(P,I),postMessage:P=>v.postMessage(P),start:()=>v.start(),close:()=>v.close()},S)}}e.Client=M;async function k(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const v=(0,C.generateUuid)();w.webContents.send("vscode:createMessageChannel",v);const S=t.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(I,h)=>({nonce:h,port:I.ports[0]})),{port:P}=await t.Event.toPromise(t.Event.once(t.Event.filter(S,I=>I.nonce===v)));return P}e.connect=k}),define(ee[145],te([0,1,44,8,17,22,138,15,3,2,50,82,79,45]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends h.ChannelServer{constructor(u){super({send:b=>{try{process.send?.(b.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",b=>C.VSBuffer.wrap(Buffer.from(b,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=m;class f{constructor(u,b){this.i=u,this.j=b,this.c=new Set,this.g=new Map,this.h=new w.Emitter,this.onDidProcessExit=this.h.event;const g=b&&b.timeout?b.timeout:6e4;this.b=new t.Delayer(g),this.d=null,this.f=null}getChannel(u){const b=this;return{call(g,d,l){return b.k(u,g,d,l)},listen(g,d){return b.l(u,g,d)}}}k(u,b,g,d=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(k.canceled());this.b.cancel();const l=this.n(u),n=(0,t.createCancelablePromise)(a=>l.call(b,g,a)),s=d.onCancellationRequested(()=>n.cancel()),i=(0,v.toDisposable)(()=>n.cancel());return this.c.add(i),n.finally(()=>{s.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(u,b,g){if(!this.b)return w.Event.None;this.b.cancel();let d;const l=new w.Emitter({onWillAddFirstListener:()=>{d=this.n(u).listen(b,g)(l.fire,l),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return l.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],b=Object.create(null);b.env={...(0,S.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(b.env={...b.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(b.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(b.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(b.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),b.execArgv===void 0&&(b.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,I.removeDangerousEnvVariables)(b.env),this.d=(0,E.fork)(this.i,u,b);const g=new w.Emitter;w.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,M.isRemoteConsoleLog)(r)){(0,M.log)(r,`IPC Library: ${this.j.serverName}`);return}g.fire(C.VSBuffer.wrap(Buffer.from(r,"base64")))});const l=this.j.useQueue?(0,P.createQueuedSender)(this.d):this.d,n=r=>this.d&&this.d.connected&&l.send(r.buffer.toString("base64")),s=g.event,i={send:n,onMessage:s};this.f=new h.ChannelClient(i);const a=()=>this.o();process.once("exit",a),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,c)=>{process.removeListener("exit",a),this.c.forEach(o=>(0,v.dispose)(o)),this.c.clear(),r!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:c})})}return this.f}n(u){let b=this.g.get(u);return b||(b=this.m.getChannel(u),this.g.set(u,b)),b}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=f}),define(ee[83],te([0,1,17,15,3,2,9,4,29,45,101]),function(q,e,E,t,C,A,M,k,w,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:q.__$__nodeRequire("crypto"),zlib:q.__$__nodeRequire("zlib"),net:q.__$__nodeRequire("net"),os:q.__$__nodeRequire("os")}}class I{traceSocketEvent(o,y){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,y)}constructor(o,y=""){this.f=!0,this.debugLabel=y,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,t.onUnexpectedError)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(o){const y=D=>{this.traceSocketEvent("read",D),o(E.VSBuffer.wrap(D))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(o){const y=D=>{o({type:0,hadError:D,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(o){const y=()=>{o()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(o){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,t.onUnexpectedError)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,t.onUnexpectedError)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=I;var h;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(h||(h={}));var m;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(m||(m={}));class f extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(o,y){this.socket.traceSocketEvent(o,y)}constructor(o,y,D,O){super(),this.f=this.B(new C.Emitter),this.g=this.B(new C.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:D?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new p(this,y,D,O,this.f,(N,Y)=>this.k(N,Y))),this.B(this.a.onError(N=>{console.error(N),(0,t.onUnexpectedError)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new S.ChunkStream,this.B(this.socket.onData(N=>this.l(N))),this.B(this.socket.onClose(N=>this.g.fire(N)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this.f.event(o)}onClose(o){return this.g.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this.a.writeMessage(o)}k(o,y){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let D=2;o.byteLength<126?D+=0:o.byteLength<2**16?D+=2:D+=8;const O=E.VSBuffer.alloc(D);if(y?O.writeUInt8(194,0):O.writeUInt8(130,0),o.byteLength<126)O.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){O.writeUInt8(126,1);let N=1;O.writeUInt8(o.byteLength>>>8&255,++N),O.writeUInt8(o.byteLength>>>0&255,++N)}else{O.writeUInt8(127,1);let N=1;O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(o.byteLength>>>24&255,++N),O.writeUInt8(o.byteLength>>>16&255,++N),O.writeUInt8(o.byteLength>>>8&255,++N),O.writeUInt8(o.byteLength>>>0&255,++N)}this.socket.write(E.VSBuffer.concat([O,o]))}end(){this.h=!0,this.socket.end()}l(o){if(o.byteLength!==0){for(this.b.acceptChunk(o);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),D=y.readUInt8(0),O=(D&128)>>>7,N=(D&64)>>>6,Y=y.readUInt8(1),G=(Y&128)>>>7,V=Y&127;this.j.state=2,this.j.readLen=2+(G?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(N)),this.j.firstFrameOfMessage=Boolean(O),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),D=y.readUInt8(1),O=(D&128)>>>7;let N=D&127,Y=1;N===126?N=y.readUInt8(++Y)*2**8+y.readUInt8(++Y):N===127&&(N=y.readUInt8(++Y)*0+y.readUInt8(++Y)*0+y.readUInt8(++Y)*0+y.readUInt8(++Y)*0+y.readUInt8(++Y)*2**24+y.readUInt8(++Y)*2**16+y.readUInt8(++Y)*2**8+y.readUInt8(++Y));let G=0;O&&(G=y.readUInt8(++Y)*2**24+y.readUInt8(++Y)*2**16+y.readUInt8(++Y)*2**8+y.readUInt8(++Y)),this.j.state=3,this.j.readLen=N,this.j.mask=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),g(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(y,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=f;class p extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:E.VSBuffer.alloc(0)}constructor(o,y,D,O,N,Y){super(),this.k=o,this.l=N,this.m=Y,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new C.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,y?(this.b=this.B(new u(this.k,O,D,{windowBits:15})),this.f=this.B(new b(this.k,{windowBits:15})),this.B(this.b.onError(G=>this.a.fire(G))),this.B(this.f.onError(G=>this.a.fire(G)))):(this.b=null,this.f=null)}writeMessage(o){this.g.push(o),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const o=this.g.shift();if(this.f){const y=await this.r(this.f,o);this.m(y,!0)}else this.m(o,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(o,y){return new Promise((D,O)=>{o.write(y),o.flush(N=>D(N))})}acceptFrame(o,y,D){this.h.push({data:o,isCompressed:y,isLastFrameOfMessage:D}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const o=this.h.shift();if(this.b&&o.isCompressed){const y=await this.u(this.b,o.data,o.isLastFrameOfMessage);this.l.fire(y)}else this.l.fire(o.data)}this.s=!1}}u(o,y,D){return new Promise((O,N)=>{o.write(y),D&&o.write(E.VSBuffer.fromByteArray([0,0,255,255])),o.flush(Y=>O(Y))})}}class u extends A.Disposable{get recordedInflateBytes(){return this.j?E.VSBuffer.concat(this.f):E.VSBuffer.alloc(0)}constructor(o,y,D,O){super(),this.h=o,this.j=y,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(O),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(E.VSBuffer.wrap(N))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(o){this.j&&this.f.push(o.clone()),this.h.traceSocketEvent("zlibInflateWrite",o),this.b.write(o.buffer)}flush(o){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=E.VSBuffer.concat(this.g);this.g.length=0,o(y)})}}class b extends A.Disposable{constructor(o,y){super(),this.g=o,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(E.VSBuffer.wrap(D))})}write(o){this.g.traceSocketEvent("zlibDeflateWrite",o.buffer),this.b.write(o.buffer)}flush(o){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=E.VSBuffer.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),o(y)})}}function g(c,o){if(o===0)return;const y=c.byteLength>>>2;for(let V=0;V<y;V++){const se=c.readUInt32BE(V*4);c.writeUInt32BE(se^o,V*4)}const D=y*4,O=c.byteLength-D,N=o>>>24&255,Y=o>>>16&255,G=o>>>8&255;O>=1&&c.writeUInt8(c.readUInt8(D)^N,D),O>=2&&c.writeUInt8(c.readUInt8(D+1)^Y,D+1),O>=3&&c.writeUInt8(c.readUInt8(D+2)^G,D+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const d={[2]:107,[1]:103};function l(){const c=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):o=(0,M.join)(P().os.tmpdir(),`vscode-ipc-${c}.sock`),s(o),o}e.createRandomIPCHandle=l;function n(c,o,y){const D=P().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${y}-${o}-sock`;let O;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?O=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${y}-${o}.sock`):O=(0,M.join)(c,`${y}-${o}.sock`),s(O),O}e.createStaticIPCHandle=n;function s(c){const o=d[k.platform];typeof o=="number"&&c.length>=o&&console.warn(`WARNING: IPC handle "${c}" is longer than ${o} chars, try a shorter --user-data-dir`)}class i extends v.IPCServer{static b(o){const y=C.Event.fromNodeEventEmitter(o,"connection");return C.Event.map(y,D=>({protocol:new S.Protocol(new I(D,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(D,"close"))}))}constructor(o){super(i.b(o)),this.d=o}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function a(c){return new Promise((o,y)=>{const D=P().net.createServer();D.on("error",y),D.listen(c,()=>{D.removeListener("error",y),o(new i(D))})})}e.serve=a;function r(c,o){return new Promise((y,D)=>{const O=P().net.createConnection(c,()=>{O.removeListener("error",D),y(S.Client.fromSocket(new I(O,`ipc-client${o}`),o))});O.once("error",D)})}e.connect=r}),define(ee[103],te([0,1,8,3,2,12]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));function k(P){const I=P;return I?.changed instanceof Map||I?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var w;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(w=e.StorageState||(e.StorageState={}));class v extends C.Disposable{constructor(I,h=Object.create(null)){super(),this.m=I,this.n=h,this.b=this.B(new t.Emitter),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=new E.ThrottledDelayer(v.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(I=>this.r(I)))}r(I){I.changed?.forEach((h,m)=>this.s(m,h)),I.deleted?.forEach(h=>this.s(h,void 0))}s(I,h){if(this.c===w.Closed)return;let m=!1;(0,A.isUndefinedOrNull)(h)?m=this.f.delete(I):this.f.get(I)!==h&&(this.f.set(I,h),m=!0),m&&this.b.fire(I)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.n.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(I,h){const m=this.f.get(I);return(0,A.isUndefinedOrNull)(m)?h:m}getBoolean(I,h){const m=this.get(I);return(0,A.isUndefinedOrNull)(m)?h:m==="true"}getNumber(I,h){const m=this.get(I);return(0,A.isUndefinedOrNull)(m)?h:parseInt(m,10)}async set(I,h){if(this.c===w.Closed)return;if((0,A.isUndefinedOrNull)(h))return this.delete(I);const m=String(h);if(this.f.get(I)!==m)return this.f.set(I,m),this.j.set(I,m),this.h.delete(I),this.b.fire(I),this.w()}async delete(I){if(!(this.c===w.Closed||!this.f.delete(I)))return this.h.has(I)||this.h.add(I),this.j.delete(I),this.b.fire(I),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=w.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const I={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(I).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(I){if(!!this.u)return this.w(I)}async w(I){return this.g.trigger(()=>this.v(),I)}async whenFlushed(){if(!!this.u)return new Promise(I=>this.l.push(I))}dispose(){this.g.dispose(),super.dispose()}}e.Storage=v,v.a=100;class S{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(I){I.insert?.forEach((h,m)=>this.a.set(m,h)),I.delete?.forEach(h=>this.a.delete(h))}async close(){}}e.InMemoryStorageDatabase=S}),define(ee[146],te([0,1,8,3,38,9,23]),function(q,e,E,t,C,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class k{get onDidChangeItemsExternal(){return t.Event.None}constructor(S,P=Object.create(null)){this.g=S,this.h=P,this.c=(0,A.basename)(this.g),this.d=new w(this.h.logging),this.f=this.n(this.g)}async getItems(){const S=await this.f,P=new Map;return(await this.s(S,"SELECT * FROM ItemTable")).forEach(h=>P.set(h.key,h.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${P.size} rows`),P}async updateItems(S){const P=await this.f;return this.j(P,S)}j(S,P){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${P.insert?(0,C.mapToString)(P.insert):"0"}), delete(${P.delete?(0,C.setToString)(P.delete):"0"})`),this.t(S,()=>{const I=P.insert,h=P.delete;if(I&&I.size>0){const m=[];m.push([]);let f=0;I.forEach((p,u)=>{let b=m[f];b.length>k.b&&(f++,b=[],m.push(b)),b.push(u,p)}),m.forEach(p=>{this.u(S,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,u=>u.run(p),()=>{const u=[];let b=0;return I.forEach((g,d)=>{u.push(d),b+=g.length}),`Keys: ${u.join(", ")} Length: ${b}`})})}if(h&&h.size){const m=[];m.push([]);let f=0;h.forEach(p=>{let u=m[f];u.length>k.b&&(f++,u=[],m.push(u)),u.push(p)}),m.forEach(p=>{this.u(S,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,u=>u.run(p),()=>{const u=[];return h.forEach(b=>{u.push(b)}),`Keys: ${u.join(", ")}`})})}})}async close(S){this.d.trace(`[storage ${this.c}] close()`);const P=await this.f;return this.k(P,S)}k(S,P){return new Promise((I,h)=>{S.db.close(m=>(m&&this.o(S,`[storage ${this.c}] close(): ${m}`),this.g===k.IN_MEMORY_PATH?I():!S.isErroneous&&!S.isInMemory?this.l().then(I,f=>(this.d.error(`[storage ${this.c}] backup(): ${f}`),I())):typeof P=="function"?M.Promises.unlink(this.g).then(()=>this.p(this.g).then(f=>{const p=()=>this.k(f,void 0);return this.j(f,{insert:P()}).then(()=>p(),u=>(p(),Promise.reject(u)))})).then(I,h):h(m||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const S=this.m(this.g);return M.Promises.copy(this.g,S,{preserveSymlinks:!1})}m(S){return`${S}.backup`}async checkIntegrity(S){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${S})`);const P=await this.f,I=await this.r(P,S?"PRAGMA integrity_check":"PRAGMA quick_check"),h=S?I.integrity_check:I.quick_check;return P.isErroneous?`${h} (last error: ${P.lastError})`:P.isInMemory?`${h} (in-memory!)`:h}async n(S,P=!0){this.d.trace(`[storage ${this.c}] open(${S}, retryOnBusy: ${P})`);try{return await this.p(S)}catch(I){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${I}`),I.code==="SQLITE_BUSY"&&P)return await(0,E.timeout)(k.a),this.n(S,!1);try{await M.Promises.unlink(S);try{await M.Promises.rename(this.m(S),S)}catch{}return await this.p(S)}catch(h){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${h}`),this.p(k.IN_MEMORY_PATH)}}}o(S,P){S.isErroneous=!0,S.lastError=P,this.d.error(P)}p(S){return new Promise((P,I)=>{new Promise((h,m)=>{q(["@vscode/sqlite3"],h,m)}).then(h=>{const m={db:new(this.d.isTracing?h.verbose().Database:h.Database)(S,f=>f?m.db&&f.code!=="SQLITE_CANTOPEN"?m.db.close(()=>I(f)):I(f):this.q(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(m),p=>m.db.close(()=>I(p)))),isInMemory:S===k.IN_MEMORY_PATH};m.db.on("error",f=>this.o(m,`[storage ${this.c}] Error (event): ${f}`)),this.d.isTracing&&m.db.on("trace",f=>this.d.trace(`[storage ${this.c}] Trace (event): ${f}`))},I)})}q(S,P){return new Promise((I,h)=>{S.db.exec(P,m=>m?(this.o(S,`[storage ${this.c}] exec(): ${m}`),h(m)):I())})}r(S,P){return new Promise((I,h)=>{S.db.get(P,(m,f)=>m?(this.o(S,`[storage ${this.c}] get(): ${m}`),h(m)):I(f))})}s(S,P){return new Promise((I,h)=>{S.db.all(P,(m,f)=>m?(this.o(S,`[storage ${this.c}] all(): ${m}`),h(m)):I(f))})}t(S,P){return new Promise((I,h)=>{S.db.serialize(()=>{S.db.run("BEGIN TRANSACTION"),P(),S.db.run("END TRANSACTION",m=>m?(this.o(S,`[storage ${this.c}] transaction(): ${m}`),h(m)):I())})})}u(S,P,I,h){const m=S.db.prepare(P),f=p=>{this.o(S,`[storage ${this.c}] prepare(): ${p} (${P}). Details: ${h()}`)};m.on("error",f),I(m),m.finalize(p=>{p&&f(p),m.removeListener("error",f)})}}e.SQLiteStorageDatabase=k,k.IN_MEMORY_PATH=":memory:",k.a=2e3,k.b=256;class w{constructor(S){S&&typeof S.logTrace=="function"&&process.env[w.VSCODE_TRACE_STORAGE]&&(this.a=S.logTrace),S&&typeof S.logError=="function"&&(this.b=S.logError)}get isTracing(){return!!this.a}trace(S){this.a?.(S)}error(S){this.b?.(S)}}w.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[147],te([11,10]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(ee[148],te([11,10]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[149],te([11,10]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[150],te([11,10]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(ee[151],te([11,10]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(ee[152],te([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[153],te([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[154],te([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[155],te([11,10]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[156],te([11,10]),function(q,e){return q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[157],te([11,10]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(ee[158],te([11,10]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(ee[159],te([11,10]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(ee[160],te([11,10]),function(q,e){return q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[161],te([11,10]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[162],te([11,10]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[163],te([11,10]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[164],te([11,10]),function(q,e){return q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[165],te([11,10]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(ee[166],te([11,10]),function(q,e){return q.create("vs/platform/shell/node/shellEnv",e)}),define(ee[167],te([11,10]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[168],te([11,10]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[169],te([11,10]),function(q,e){return q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[170],te([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[171],te([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[172],te([11,10]),function(q,e){return q.create("vs/platform/workspace/common/workspace",e)}),define(ee[173],te([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[174],te([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[175],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(C){return C&&C.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function t(C){return C&&C.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(ee[176],te([0,1,7]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(M){return typeof M?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function C(M){let k=[];try{Array.isArray(M.workspaces)&&(k=M.workspaces.map(w=>({workspace:{id:w.id,configPath:E.URI.parse(w.configURIPath)},remoteAuthority:w.remoteAuthority})))}catch{}return k}e.deserializeWorkspaceInfos=C;function A(M){let k=[];try{Array.isArray(M.folders)&&(k=M.folders.map(w=>({folderUri:E.URI.parse(w.folderUri),remoteAuthority:w.remoteAuthority})))}catch{}return k}e.deserializeFolderInfos=A}),define(ee[177],te([0,1,3,2]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class C{constructor(){this.a=new E.Emitter,this.b=new E.Emitter,this.c=new E.Emitter,this.d=new E.Emitter}call(k,w,v){switch(w){case"close":return Promise.resolve(this.a.fire({sessionId:v[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:v[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:v[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:v[0],port:v[1],subId:v[2]}))}throw new Error("Method not implemented.")}listen(k,w,v){switch(w){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=C,C.ChannelName="extensionhostdebugservice";class A extends t.Disposable{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,w,v){this.b.call("attach",[k,w,v])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,w){this.b.call("terminate",[k,w])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,w){return this.b.call("openExtensionDevelopmentHostWindow",[k,w])}}e.ExtensionHostDebugChannelClient=A}),define(ee[178],te([0,1,132,53,14,9,32,19,7]),function(q,e,E,t,C,A,M,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class v{get appRoot(){return(0,A.dirname)(C.FileAccess.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,k.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,A.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return w.URI.file((0,A.join)(this.logsPath,"editSessions.log"))}get remoteTunnelLogResource(){return w.URI.file((0,A.join)(this.logsPath,"remoteTunnel.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(w.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=M.env.VSCODE_PORTABLE;return f?w.URI.file((0,A.join)(f,"argv.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,A.resolve)(f):(0,A.normalize)((0,A.join)(C.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?w.URI.file((0,A.resolve)(f)):w.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,A.resolve)(f);const p=M.env.VSCODE_EXTENSIONS;if(p)return p;const u=M.env.VSCODE_PORTABLE;return u?(0,A.join)(u,"extensions"):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(p=>/^[^:/?#]+?:\/\//.test(p)?w.URI.parse(p):w.URI.file((0,A.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?w.URI.parse(f):w.URI.file((0,A.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const p of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);u&&u[1]&&u[2]&&f.push([u[1],u[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,k.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return w.URI.file((0,A.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=M.env.VSCODE_PORTABLE;return f?w.URI.file((0,A.join)(f,"policy.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,p,u){this.a=f,this.b=p,this.c=u,this.editSessionId=this.args.editSessionId}}pe([t.memoize],v.prototype,"appRoot",null),pe([t.memoize],v.prototype,"userHome",null),pe([t.memoize],v.prototype,"userDataPath",null),pe([t.memoize],v.prototype,"appSettingsHome",null),pe([t.memoize],v.prototype,"tmpDir",null),pe([t.memoize],v.prototype,"cacheHome",null),pe([t.memoize],v.prototype,"stateResource",null),pe([t.memoize],v.prototype,"userRoamingDataHome",null),pe([t.memoize],v.prototype,"userDataSyncHome",null),pe([t.memoize],v.prototype,"userDataSyncLogResource",null),pe([t.memoize],v.prototype,"editSessionsLogResource",null),pe([t.memoize],v.prototype,"remoteTunnelLogResource",null),pe([t.memoize],v.prototype,"sync",null),pe([t.memoize],v.prototype,"machineSettingsResource",null),pe([t.memoize],v.prototype,"workspaceStorageHome",null),pe([t.memoize],v.prototype,"localHistoryHome",null),pe([t.memoize],v.prototype,"keyboardLayoutResource",null),pe([t.memoize],v.prototype,"argvResource",null),pe([t.memoize],v.prototype,"isExtensionDevelopment",null),pe([t.memoize],v.prototype,"untitledWorkspacesHome",null),pe([t.memoize],v.prototype,"installSourcePath",null),pe([t.memoize],v.prototype,"builtinExtensionsPath",null),pe([t.memoize],v.prototype,"extensionsPath",null),pe([t.memoize],v.prototype,"extensionDevelopmentLocationURI",null),pe([t.memoize],v.prototype,"extensionDevelopmentKind",null),pe([t.memoize],v.prototype,"extensionTestsLocationURI",null),pe([t.memoize],v.prototype,"debugExtensionHost",null),pe([t.memoize],v.prototype,"logLevel",null),pe([t.memoize],v.prototype,"extensionLogLevel",null),pe([t.memoize],v.prototype,"serviceMachineIdResource",null),pe([t.memoize],v.prototype,"telemetryLogResource",null),pe([t.memoize],v.prototype,"disableWorkspaceTrust",null),pe([t.memoize],v.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=v;function S(m,f){return h(m["inspect-extensions"],m["inspect-brk-extensions"],5870,f,m.debugId,m.extensionEnvironment)}e.parseExtensionHostPort=S;function P(m,f){return h(m["inspect-search"],m["inspect-brk-search"],5876,f,m.extensionEnvironment)}e.parseSearchPort=P;function I(m,f){return h(m["inspect-ptyhost"],m["inspect-brk-ptyhost"],5877,f,m.extensionEnvironment)}e.parsePtyHostPort=I;function h(m,f,p,u,b,g){const l=Number(f||m)||(u?null:p),n=l?Boolean(!!f):!1;let s;if(g)try{s=JSON.parse(g)}catch{}return{port:l,break:n,debugId:b,env:s}}}),define(ee[104],te([0,1,276,4,150]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,C.localize)(0,null),e:(0,C.localize)(1,null),t:(0,C.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,C.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,C.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,C.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,C.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,C.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,C.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,C.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,C.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,C.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,C.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,C.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,C.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,C.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,C.localize)(17,null)},category:{type:"string",cat:"e",description:(0,C.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,C.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,C.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,C.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,C.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,C.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,C.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,C.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,C.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,C.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,C.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,C.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,C.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,C.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,C.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,C.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,C.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,C.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(f,p,u=M){const b=f.find(c=>c.length>0&&c[0]!=="-"),g={},d=["_"],l=[],n={};let s;for(const c in p){const o=p[c];o.type==="subcommand"?c===b&&(s=o):(o.alias&&(g[c]=o.alias),o.type==="string"||o.type==="string[]"?(d.push(c),o.deprecates&&d.push(...o.deprecates)):o.type==="boolean"&&(l.push(c),o.deprecates&&l.push(...o.deprecates)),o.global&&(n[c]=o))}if(s&&b){const c=n;for(const O in s.options)c[O]=s.options[O];const o=f.filter(O=>O!==b),y=u.getSubcommandReporter?u.getSubcommandReporter(b):void 0,D=k(o,c,y);return{[b]:D,_:[]}}const i=E(f,{string:d,boolean:l,alias:g}),a={},r=i;a._=i._.map(c=>String(c)).filter(c=>c.length>0),delete r._;for(const c in p){const o=p[c];if(o.type==="subcommand")continue;o.alias&&delete r[o.alias];let y=r[c];if(o.deprecates)for(const D of o.deprecates)r.hasOwnProperty(D)&&(y||(y=r[D],y&&u.onDeprecatedOption(D,o.deprecationMessage||(0,C.localize)(36,null,c))),delete r[D]);if(typeof y<"u"){if(o.type==="string[]"){if(Array.isArray(y)||(y=[y]),!o.allowEmptyValue){const D=y.filter(O=>O.length>0);D.length!==y.length&&(u.onEmptyValue(c),y=D.length>0?D:void 0)}}else o.type==="string"&&(Array.isArray(y)?(y=y.pop(),u.onMultipleValues(c,y)):!y&&!o.allowEmptyValue&&(u.onEmptyValue(c),y=void 0));a[c]=y,o.deprecationMessage&&u.onDeprecatedOption(c,o.deprecationMessage)}delete r[c]}for(const c in r)u.onUnknownOption(c);return a}e.parseArgs=k;function w(f,p){let u="";return p.args&&(Array.isArray(p.args)?u=` <${p.args.join("> <")}>`:u=` <${p.args}>`),p.alias?`-${p.alias} --${f}${u}`:`--${f}${u}`}function v(f,p){const u=[];for(const b in f){const g=f[b],d=w(b,g);u.push([d,g.description])}return S(u,p)}e.formatOptions=v;function S(f,p){const b=f.reduce((l,n)=>Math.max(l,n[0].length),12)+2+1;if(p-b<25)return f.reduce((l,n)=>l.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const g=p-b-1,d=[];for(const l of f){const n=l[0],s=I(l[1],g),i=P(b-n.length-2);d.push("  "+n+i+s[0]);for(let a=1;a<s.length;a++)d.push(P(b)+s[a])}return d}function P(f){return" ".repeat(f)}function I(f,p){const u=[];for(;f.length;){const b=f.length<p?f.length:f.lastIndexOf(" ",p),g=f.slice(0,b).trim();f=f.slice(b),u.push(g)}return u}function h(f,p,u,b,g){const d=process.stdout.isTTY&&process.stdout.columns||80,l=g?.noInputFiles!==!0?`[${(0,C.localize)(37,null)}...]`:"",n=[`${f} ${u}`];n.push(""),n.push(`${(0,C.localize)(38,null)}: ${p} [${(0,C.localize)(39,null)}]${l}`),n.push(""),g?.noPipe!==!0&&(t.isWindows?n.push((0,C.localize)(40,null,p)):n.push((0,C.localize)(41,null,p)),n.push(""));const s={},i=[];for(const a in b){const r=b[a];if(r.type==="subcommand")r.description&&i.push({command:a,description:r.description});else if(r.description&&r.cat){let c=s[r.cat];c||(s[r.cat]=c={}),c[a]=r}}for(const a in s){const r=a,c=s[r];c&&(n.push(A[r]),n.push(...v(c,d)),n.push(""))}return i.length&&(n.push((0,C.localize)(42,null)),n.push(...S(i.map(a=>[a.command,a.description]),d)),n.push("")),n.join(`
`)}e.buildHelpMessage=h;function m(f,p){return`${f||(0,C.localize)(43,null)}
${p||(0,C.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=m}),define(ee[179],te([0,1,78,177,104]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class A extends t.ExtensionHostDebugBroadcastChannel{constructor(k){super(),this.f=k}call(k,w,v){return w==="openExtensionDevelopmentHostWindow"?this.g(v[0],v[1]):super.call(k,w,v)}async g(k,w){const v=(0,C.parseArgs)(k,C.OPTIONS);v.debugRenderer=w;const S=v.extensionDevelopmentPath;if(!S)return{success:!1};const[P]=await this.f.openExtensionDevelopmentHostWindow(S,{context:5,cli:v,forceProfile:v.profile,forceTempProfile:v["profile-temp"]});if(!w)return{success:!0};const I=P.win;if(!I)return{success:!0};const h=I.webContents.debugger;let m=h.isAttached()?1/0:0;const f=(0,E.createServer)(p=>{m++===0&&h.attach();let u=!1;const b=l=>{u||p.write(JSON.stringify(l)+"\0")},g=(l,n,s,i)=>b({method:n,params:s,sessionId:i});I.on("close",()=>{h.removeListener("message",g),p.end(),u=!0}),h.addListener("message",g);let d=Buffer.alloc(0);p.on("data",l=>{d=Buffer.concat([d,l]);for(let n=d.indexOf(0);n!==-1;n=d.indexOf(0)){let s;try{const i=d.slice(0,n).toString("utf8");d=d.slice(n+1),s=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}h.sendCommand(s.method,s.params,s.sessionId).then(i=>b({id:s.id,sessionId:s.sessionId,result:i})).catch(i=>b({id:s.id,sessionId:s.sessionId,error:{code:0,message:i.message}}))}}),p.on("error",l=>{console.error("error on cdp pipe:",l)}),p.on("close",()=>{u=!0,--m===0&&h.detach()})});return await new Promise(p=>f.listen(0,p)),I.on("close",()=>f.close()),{rendererDebugPort:f.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=A}),define(ee[59],te([0,1,277,151,104]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const A=2048;function M(I,h){const m=(d,l)=>{console.warn((0,t.localize)(0,null,d,l))},f=d=>{console.warn((0,t.localize)(1,null,d))},p=(d,l)=>{console.warn((0,t.localize)(2,null,d,l))},u=d=>({onUnknownOption:l=>{d!=="tunnel"&&console.warn((0,t.localize)(3,null,l,d))},onMultipleValues:m,onEmptyValue:f,onDeprecatedOption:p,getSubcommandReporter:d!=="tunnel"?u:void 0}),b={onUnknownOption:d=>{console.warn((0,t.localize)(4,null,d))},onMultipleValues:m,onEmptyValue:f,onDeprecatedOption:p,getSubcommandReporter:u},g=(0,C.parseArgs)(I,C.OPTIONS,h?b:void 0);return g.goto&&g._.forEach(d=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(d),(0,t.localize)(5,null))),g["max-memory"]&&E(parseInt(g["max-memory"])>=A,`The max-memory argument cannot be specified lower than ${A} MB.`),g}function k(I){const h=I.findIndex(m=>!/^-/.test(m));if(h>-1)return[...I.slice(0,h),...I.slice(h+1)]}function w(I){let[,...h]=I;process.env.VSCODE_DEV&&(h=k(h)||[]);const m=!P(process.env);return M(h,m)}e.parseMainProcessArgv=w;function v(I){let[,,...h]=I;return process.env.VSCODE_DEV&&(h=k(h)||[]),M(h,!0)}e.parseCLIProcessArgv=v;function S(I,...h){const m=I.indexOf("--");return m===-1?I.push(...h):I.splice(m,0,...h),I}e.addArg=S;function P(I){return I.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),function(){"use strict";function q(e,E,t){function C(M,k){const w=A(M,k),v=[w];return e.isAbsolute(w)||v.unshift(t),e.resolve(...v)}function A(M,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return e.join(v,k);const S=M["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=e.join(P,"AppData","Roaming")}break;case"darwin":v=e.join(E.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(v,k)}return{getUserDataPath:C}}if(typeof define=="function")define(ee[180],te([181,27,32]),function(e,E,t){return q(e,E,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=q(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[182],te([0,1,27,178,180]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends t.AbstractNativeEnvironmentService{constructor(k,w){super(k,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,C.getUserDataPath)(k,w.nameShort)},w)}}e.NativeEnvironmentService=A}),define(ee[183],te([0,1,39,27,30]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function A(M){const k=(0,C.randomPath)((0,t.tmpdir)());try{return(0,E.writeFileSync)(k,""),M&&console.log(`Marker file for --wait created: ${k}`),k}catch(w){M&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFileSync=A}),define(ee[184],te([0,1,12,153]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function C(M,k,w){try{A(M,k,w)}catch(v){console.error(v?.message??v)}return M}e.localizeManifest=C;function A(M,k,w){const v=(S,P,I)=>{const h=S[P];if((0,E.isString)(h)){const m=h,f=m.length;if(f>1&&m[0]==="%"&&m[f-1]==="%"){const p=m.substr(1,f-2);let u=k[p];u===void 0&&w&&(u=w[p]);const b=typeof u=="string"?u:u?.message,g=w?.[p],d=typeof g=="string"?g:g?.message;if(!b){d||console.warn(`[${M.name}]: ${(0,t.localize)(0,null,p)}`);return}if(I&&(P==="title"||P==="category")&&d&&d!==b){const l={value:b,original:d};S[P]=l}else S[P]=b}}else if((0,E.isObject)(h))for(const m in h)h.hasOwnProperty(m)&&(m==="commands"?v(h,m,!0):v(h,m,I));else if(Array.isArray(h))for(let m=0;m<h.length;m++)v(h,m,I)};for(const S in M)M.hasOwnProperty(S)&&v(M,S)}}),define(ee[185],te([0,1,15]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(A,M){this.a.set(A,M)}updateManifest(A){if(!(!Array.isArray(A.activationEvents)||!A.contributes)&&!(typeof A.main>"u"&&typeof A.browser>"u"))for(const M in A.contributes){const k=this.a.get(M);if(!k)continue;const w=A.contributes[M],v=Array.isArray(w)?w:[w];try{k(v,A.activationEvents)}catch(S){(0,E.onUnexpectedError)(S)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ee[186],te([0,1,19,97,155,187]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function w(u){return u=u.trim(),u==="*"||M.test(u)}e.isValidVersionStr=w;function v(u){if(!w(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const b=u.match(M);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=v;function S(u){if(!u)return null;const b=u.majorBase,g=u.majorMustEqual,d=u.minorBase;let l=u.minorMustEqual;const n=u.patchBase;let s=u.patchMustEqual;u.hasCaret&&(b===0||(l=!1),s=!1);let i=0;if(u.preRelease){const a=k.exec(u.preRelease);if(a){const[,r,c,o]=a;i=Date.UTC(Number(r),Number(c)-1,Number(o))}}return{majorBase:b,majorMustEqual:g,minorBase:d,minorMustEqual:l,patchBase:n,patchMustEqual:s,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=S;function P(u,b,g){let d;typeof u=="string"?d=S(v(u)):d=u;let l;b instanceof Date?l=b.getTime():typeof b=="string"&&(l=new Date(b).getTime());let n;if(typeof g=="string"?n=S(v(g)):n=g,!d||!n)return!1;const s=d.majorBase,i=d.minorBase,a=d.patchBase;let r=n.majorBase,c=n.minorBase,o=n.patchBase;const y=n.notBefore;let D=n.majorMustEqual,O=n.minorMustEqual,N=n.patchMustEqual;return n.isMinimum?s>r?!0:s<r?!1:i>c?!0:i<c||l&&l<y?!1:a>=o:(s===1&&r===0&&(!D||!O||!N)&&(r=1,c=0,o=0,D=!0,O=!1,N=!1),s<r?!1:s>r?!D:i<c?!1:i>c?!O:a<o?!1:a>o?!N:!(l&&l<y))}e.isValidVersion=P;function I(u,b,g,d,l){const n=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return n.push([t.default.Error,C.localize(0,null)]),n;if(typeof d.name!="string")return n.push([t.default.Error,C.localize(1,null,"name")]),n;if(typeof d.version!="string")return n.push([t.default.Error,C.localize(2,null,"version")]),n;if(!d.engines)return n.push([t.default.Error,C.localize(3,null,"engines")]),n;if(typeof d.engines.vscode!="string")return n.push([t.default.Error,C.localize(4,null,"engines.vscode")]),n;if(typeof d.extensionDependencies<"u"&&!p(d.extensionDependencies))return n.push([t.default.Error,C.localize(5,null,"extensionDependencies")]),n;if(typeof d.activationEvents<"u"){if(!p(d.activationEvents))return n.push([t.default.Error,C.localize(6,null,"activationEvents")]),n;if(typeof d.main>"u"&&typeof d.browser>"u")return n.push([t.default.Error,C.localize(7,null,"activationEvents","main")]),n}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&n.push([t.default.Warning,C.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return n.push([t.default.Error,C.localize(9,null,"main")]),n;{const a=(0,E.joinPath)(g,d.main);(0,E.isEqualOrParent)(a,g)||n.push([t.default.Warning,C.localize(10,null,a.path,g.path)])}if(typeof d.activationEvents>"u")return n.push([t.default.Error,C.localize(11,null,"activationEvents","main")]),n}if(typeof d.browser<"u"){if(typeof d.browser!="string")return n.push([t.default.Error,C.localize(12,null,"browser")]),n;{const a=(0,E.joinPath)(g,d.browser);(0,E.isEqualOrParent)(a,g)||n.push([t.default.Warning,C.localize(13,null,a.path,g.path)])}if(typeof d.activationEvents>"u")return n.push([t.default.Error,C.localize(14,null,"activationEvents","browser")]),n}if(!A.valid(d.version))return n.push([t.default.Error,C.localize(15,null)]),n;const s=[];if(!h(u,b,d,l,s))for(const a of s)n.push([t.default.Error,a]);return n}e.validateExtensionManifest=I;function h(u,b,g,d,l){return d||typeof g.main>"u"&&typeof g.browser>"u"?!0:f(u,b,g.engines.vscode,l)}e.isValidExtensionVersion=h;function m(u,b,g){return u==="*"||f(b,g,u)}e.isEngineValid=m;function f(u,b,g,d=[]){const l=S(v(g));if(!l)return d.push(C.localize(16,null,g)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return d.push(C.localize(17,null,g)),!1}else if(!l.majorMustEqual)return d.push(C.localize(18,null,g)),!1;return P(u,b,l)?!0:(d.push(C.localize(19,null,u,g)),!1)}function p(u){if(!Array.isArray(u))return!1;for(let b=0,g=u.length;b<g;b++)if(typeof u[b]!="string")return!1;return!0}}),define(ee[188],te([0,1,17,29]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function C(A,M,k){let w=k&&k.get("storage.serviceMachineId",-1)||null;if(w)return w;try{const S=(await M.readFile(A.serviceMachineIdResource)).value.toString();w=(0,t.isUUID)(S)?S:null}catch{w=null}if(!w){w=(0,t.generateUuid)();try{await M.writeFile(A.serviceMachineIdResource,E.VSBuffer.fromString(w))}catch{}}return k?.store("storage.serviceMachineId",w,-1,1),w}e.getServiceMachineId=C}),define(ee[69],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(C,A=[],M=!1){this.ctor=C,this.staticArguments=A,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=E}),define(ee[189],te([0,1,69]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var C;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(C=e.InstantiationType||(e.InstantiationType={}));function A(k,w,v){w instanceof E.SyncDescriptor||(w=new E.SyncDescriptor(w,[],Boolean(v))),t.push([k,w])}e.registerSingleton=A;function M(){return t}e.getSingletonServiceDescriptors=M}),define(ee[190],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(A,M){this.key=A,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class t{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const M of this.a.values())M.outgoing.size===0&&A.push(M);return A}insertEdge(A,M){const k=this.lookupOrInsertNode(A),w=this.lookupOrInsertNode(M);k.outgoing.set(w.key,w),w.incoming.set(k.key,k)}removeNode(A){const M=this.b(A);this.a.delete(M);for(const k of this.a.values())k.outgoing.delete(M),k.incoming.delete(M)}lookupOrInsertNode(A){const M=this.b(A);let k=this.a.get(M);return k||(k=new E(M,A),this.a.set(M,k)),k}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[M,k]of this.a)A.push(`${M}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,M]of this.a){const k=new Set([A]),w=this.c(M,k);if(w)return w}}c(A,M){for(const[k,w]of A.outgoing){if(M.has(k))return[...M,k].join(" -> ");M.add(k);const v=this.c(w,M);if(v)return v;M.delete(k)}}}e.Graph=t}),define(ee[5],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function k(w){return w[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=k})(E=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function t(M,k,w){k[E.DI_TARGET]===k?k[E.DI_DEPENDENCIES].push({id:M,index:w}):(k[E.DI_DEPENDENCIES]=[{id:M,index:w}],k[E.DI_TARGET]=k)}function C(M){if(E.serviceIds.has(M))return E.serviceIds.get(M);const k=function(w,v,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,w,S)};return k.toString=()=>M,E.serviceIds.set(M,k),k}e.createDecorator=C;function A(M){return M}e.refineServiceDecorator=A}),define(ee[60],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(ee[18],te([0,1,12,7,5]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationOverrides=A;function M(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=M;var k;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function v(u,b){const g=Object.create(null);for(const d in u)S(g,d,u[d],b);return g}e.toValuesTree=v;function S(u,b,g,d){const l=b.split("."),n=l.pop();let s=u;for(let i=0;i<l.length;i++){const a=l[i];let r=s[a];switch(typeof r){case"undefined":r=s[a]=Object.create(null);break;case"object":break;default:d(`Ignoring ${b} as ${l.slice(0,i+1).join(".")} is ${JSON.stringify(r)}`);return}s=r}if(typeof s=="object"&&s!==null)try{s[n]=g}catch{d(`Ignoring ${b} as ${l.join(".")} is ${JSON.stringify(s)}`)}else d(`Ignoring ${b} as ${l.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=S;function P(u,b){const g=b.split(".");I(u,g)}e.removeFromValueTree=P;function I(u,b){const g=b.shift();if(b.length===0){delete u[g];return}if(Object.keys(u).indexOf(g)!==-1){const d=u[g];typeof d=="object"&&!Array.isArray(d)&&(I(d,b),Object.keys(d).length===0&&delete u[g])}}function h(u,b,g){function d(s,i){let a=s;for(const r of i){if(typeof a!="object"||a===null)return;a=a[r]}return a}const l=b.split("."),n=d(u,l);return typeof n>"u"?g:n}e.getConfigurationValue=h;function m(u,b,g){Object.keys(b).forEach(d=>{d!=="__proto__"&&(d in u?E.isObject(u[d])&&E.isObject(b[d])?m(u[d],b[d],g):g&&(u[d]=b[d]):u[d]=b[d])})}e.merge=m;function f(u,b,g){const d=u.inspect(b),l=u.inspect(g);return typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:d.defaultValue}e.getMigratedSettingValue=f;function p(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(ee[70],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class t{constructor(){this.a={}}async getPassword(A,M){return this.a[A]?.[M]??null}async setPassword(A,M,k){this.a[A]=this.a[A]??{},this.a[A][M]=k}async deletePassword(A,M){return this.a[A]?.[M]?(delete this.a[A][M],Object.keys(this.a[A]).length===0&&delete this.a[A],!0):!1}async findPassword(A){return JSON.stringify(this.a[A])??null}async findCredentials(A){const M=[];for(const k of Object.keys(this.a[A]||{}))M.push({account:k,password:this.a[A][k]});return M}async clear(){this.a={}}}e.InMemoryCredentialsProvider=t}),define(ee[84],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function t(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=t;class C{async getPerformanceInfo(M,k){return{}}async getSystemInfo(M,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,k){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=C}),define(ee[105],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(ee[34],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[26],te([0,1,53,9,83,34,182,5]),function(q,e,E,t,C,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,k.refineServiceDecorator)(A.IEnvironmentService);class w extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,C.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}pe([E.memoize],w.prototype,"cachedLanguagesPath",null),pe([E.memoize],w.prototype,"backupHome",null),pe([E.memoize],w.prototype,"mainIPCHandle",null),pe([E.memoize],w.prototype,"mainLockfile",null),pe([E.memoize],w.prototype,"disableUpdates",null),pe([E.memoize],w.prototype,"disableKeytar",null),pe([E.memoize],w.prototype,"crossOriginIsolated",null),pe([E.memoize],w.prototype,"codeCachePath",null),pe([E.memoize],w.prototype,"useCodeCache",null),e.EnvironmentMainService=w}),define(ee[191],te([0,1,152,5]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY="DEFAULT_PROFILE_EXTENSIONS_MIGRATION";function C(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function A(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function M(u,b){switch(u){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function k(u,b){return b==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function w(u,b,g){return k(b,g)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===g?!0:v(g).includes(u)}e.isTargetPlatformCompatible=w;function v(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=v;function S(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=S;var P;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var I;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(I=e.SortOrder||(e.SortOrder={}));var h;(function(u){u.Install="install",u.Uninstall="uninstall"})(h=e.StatisticType||(e.StatisticType={}));var m;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var f;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(f=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class p extends Error{constructor(b,g){super(b),this.code=g,this.name=g}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ee[192],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(ee[193],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[106],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(ee[194],te([0,1,44,14,9,4,79,23,82,156,106]),function(q,e,E,t,C,A,M,k,w,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=v.localize(0,null);class I{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends I{openTerminal(d,l){return this.spawnTerminal(E,d,w.getWindowsShell(),l)}spawnTerminal(d,l,n,s){const i=l.windowsExec||h.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const a=C.basename(i).toLowerCase();if(a==="cmder"||a==="cmder.exe")return d.spawn(i,s?[s]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return i.indexOf(" ")>=0&&r.push('""'),r.push(i),(a==="wt"||a==="wt.exe")&&r.push("-d ."),new Promise((c,o)=>{const y=p(process),D=d.spawn(n,r,{cwd:s,env:y});D.on("error",o),D.on("exit",()=>c())})}runInTerminal(d,l,n,s,i){const a="windowsExec"in i&&i.windowsExec?i.windowsExec:h.getDefaultTerminalWindows();return new Promise((r,c)=>{const o=`"${l} - ${P}"`,y=`""${n.join('" "')}" & pause"`,D=["/c","start",o,"/wait",a,"/c",y],O=Object.assign({},p(process),s);Object.keys(O).filter(G=>O[G]===null).forEach(G=>delete O[G]);const N={cwd:l,env:O,windowsVerbatimArguments:!0};E.spawn(h.b,D,N).on("error",G=>{c(u(G))}),r(void 0)})}static getDefaultTerminalWindows(){if(!h.d){const d=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${d?"Sysnative":"System32"}\\cmd.exe`}return h.d}}e.WindowsExternalTerminalService=h,h.b="cmd.exe";class m extends I{openTerminal(d,l){return this.spawnTerminal(E,d,l)}runInTerminal(d,l,n,s,i){const a=i.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((r,c)=>{if(a===S.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const o=a===S.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`).fsPath,"-t",d||P,"-w",l];for(const Y of n)D.push("-a"),D.push(Y);if(s){const Y=Object.assign({},p(process),s);for(const G in Y){const V=Y[G];V===null?(D.push("-u"),D.push(G)):(D.push("-e"),D.push(`${G}=${V}`))}}let O="";const N=E.spawn(m.b,D);N.on("error",Y=>{c(u(Y))}),N.stderr.on("data",Y=>{O+=Y.toString()}),N.on("exit",Y=>{if(Y===0)r(void 0);else if(O){const G=O.split(`
`,1);c(new Error(G[0]))}else c(new Error(v.localize(1,null,o,Y)))})}else c(new Error(v.localize(2,null,a)))})}spawnTerminal(d,l,n){const s=l.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((i,a)=>{const r=["-a",s];n&&r.push(n);const c=p(process),o=d.spawn("/usr/bin/open",r,{cwd:n,env:c});o.on("error",a),o.on("exit",()=>i())})}}e.MacExternalTerminalService=m,m.b="/usr/bin/osascript";class f extends I{openTerminal(d,l){return this.spawnTerminal(E,d,l)}runInTerminal(d,l,n,s,i){const a=i.linuxExec?Promise.resolve(i.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((r,c)=>{const o=[];a.then(y=>{y.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const D=`${b(n)}; echo; read -p "${f.b}" -n1;`;o.push(`''${D}''`);const O=Object.assign({},p(process),s);Object.keys(O).filter(V=>O[V]===null).forEach(V=>delete O[V]);const N={cwd:l,env:O};let Y="";const G=E.spawn(y,o,N);G.on("error",V=>{c(u(V))}),G.stderr.on("data",V=>{Y+=V.toString()}),G.on("exit",V=>{if(V===0)r(void 0);else if(Y){const se=Y.split(`
`,1);c(new Error(se[0]))}else c(new Error(v.localize(4,null,y,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!A.isLinux)f.d=Promise.resolve("xterm");else{const d=await k.Promises.exists("/etc/debian_version");f.d=new Promise(l=>{d?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return f.d}spawnTerminal(d,l,n){const s=l.linuxExec?Promise.resolve(l.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((i,a)=>{s.then(r=>{const c=p(process),o=d.spawn(r,[],{cwd:n,env:c});o.on("error",a),o.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=f,f.b=v.localize(3,null);function p(g){const d={...g.env};return(0,M.sanitizeProcessEnvironment)(d),d}function u(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(v.localize(5,null,g.path)):g}function b(g){let d="";for(const l of g)l.indexOf(" ")>=0?d+='"'+l+'"':d+=l,d+=" ";return d}}),define(ee[16],te([0,1,58,9,25,12,7,158,5]),function(q,e,E,t,C,A,M,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function v(X){return X.create===!0}e.isFileOpenForWriteOptions=v;var S;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(S=e.FileType||(e.FileType={}));var P;(function(X){X[X.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var I;(function(X){X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileClone=32768]="FileClone"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(X){return!!(X.capabilities&2)}e.hasReadWriteCapability=h;function m(X){return!!(X.capabilities&8)}e.hasFileFolderCopyCapability=m;function f(X){return!!(X.capabilities&32768)}e.hasFileCloneCapability=f;function p(X){return!!(X.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function u(X){return!!(X.capabilities&16)}e.hasFileReadStreamCapability=u;function b(X){return h(X)?!!(X.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var g;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(le,W){super(le),this.code=W}}e.FileSystemProviderError=d;function l(X,le){const W=new d(X.toString(),le);return s(W,le),W}e.createFileSystemProviderError=l;function n(X){return X||l((0,k.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=n;function s(X,le){return X.name=le?`${le} (FileSystemError)`:"FileSystemError",X}e.markAsFileSystemProviderError=s;function i(X){if(!X)return g.Unknown;if(X instanceof d)return X.code;const le=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!le)return g.Unknown;switch(le[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=i;function a(X){if(X instanceof O)return X.fileOperationResult;switch(i(X)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var r;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class c{constructor(le,W,L){this.resource=le,this.operation=W,this.target=L}isOperation(le){return this.operation===le}}e.FileOperationEvent=c;var o;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class y{constructor(le,W){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=le;const L=new Map;for(const T of le){const U=L.get(T.type);switch(U?U.push([T.resource,T]):L.set(T.type,[[T.resource,T]]),T.type){case 1:this.rawAdded.push(T.resource);break;case 0:this.rawUpdated.push(T.resource);break;case 2:this.rawDeleted.push(T.resource);break}}for(const[T,U]of L)switch(T){case 1:this.a=E.TernarySearchTree.forUris(()=>W),this.a.fill(U);break;case 0:this.b=E.TernarySearchTree.forUris(()=>W),this.b.fill(U);break;case 2:this.c=E.TernarySearchTree.forUris(()=>W),this.c.fill(U);break}}contains(le,...W){return this.d(le,{includeChildren:!1},...W)}affects(le,...W){return this.d(le,{includeChildren:!0},...W)}d(le,W,...L){if(!le)return!1;const T=L.length>0;return!!((!T||L.includes(1))&&(this.a?.get(le)||W.includeChildren&&this.a?.findSuperstr(le))||(!T||L.includes(0))&&(this.b?.get(le)||W.includeChildren&&this.b?.findSuperstr(le))||(!T||L.includes(2))&&(this.c?.findSubstr(le)||W.includeChildren&&this.c?.findSuperstr(le)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=y;function D(X,le,W){return!X||!le||X===le||le.length>X.length?!1:(le.charAt(le.length-1)!==t.sep&&(le+=t.sep),W?(0,C.startsWithIgnoreCase)(X,le):X.indexOf(le)===0)}e.isParent=D;class O extends Error{constructor(le,W,L){super(le),this.fileOperationResult=W,this.options=L}}e.FileOperationError=O;class N extends O{constructor(le,W,L){super(le,2,L),this.stat=W}}e.NotModifiedSinceFileOperationError=N;var Y;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",X[X.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var G;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(G=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}e.etag=V;async function se(X,le){if(!le.hasProvider(M.URI.from({scheme:X.scheme})))return new Promise(W=>{const L=le.onDidChangeFileSystemProviderRegistrations(T=>{T.scheme===X.scheme&&T.added&&(L.dispose(),W())})})}e.whenProviderRegistered=se,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class oe{static formatSize(le){return(0,A.isNumber)(le)||(le=0),le<oe.KB?(0,k.localize)(1,null,le.toFixed(0)):le<oe.MB?(0,k.localize)(2,null,(le/oe.KB).toFixed(2)):le<oe.GB?(0,k.localize)(3,null,(le/oe.MB).toFixed(2)):le<oe.TB?(0,k.localize)(4,null,(le/oe.GB).toFixed(2)):(0,k.localize)(5,null,(le/oe.TB).toFixed(2))}}e.ByteSize=oe,oe.KB=1024,oe.MB=oe.KB*oe.KB,oe.GB=oe.MB*oe.KB,oe.TB=oe.GB*oe.KB;var re;(function(X){X[X.IA32=0]="IA32",X[X.OTHER=1]="OTHER"})(re=e.Arch||(e.Arch={}));function de(X){return{maxFileSize:X===0?300*oe.MB:16*oe.GB,maxHeapSize:X===0?700*oe.MB:2*700*oe.MB}}e.getPlatformLimits=de}),define(ee[195],te([0,1,17,43,15,3,2,57,7,29,16]),function(q,e,E,t,C,A,M,k,w,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class P extends M.Disposable{constructor(h,m){super(),this.a=h,this.b=m,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.h=(0,v.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,m){const{buffer:f}=await this.a.call("readFile",[h,m]);return f}readFileStream(h,m,f){const p=(0,k.newWriteableStream)(b=>E.VSBuffer.concat(b.map(g=>E.VSBuffer.wrap(g))).buffer),u=this.a.listen("readFileStream",[h,m])(b=>{if(b instanceof E.VSBuffer)p.write(b.buffer);else{if(b==="end")p.end();else{let g=b;g instanceof Error||(g=(0,S.createFileSystemProviderError)((0,t.toErrorMessage)(g),S.FileSystemProviderErrorCode.Unknown)),p.error(g),p.end()}u.dispose()}});return f.onCancellationRequested(()=>{p.error((0,C.canceled)()),p.end(),u.dispose()}),p}writeFile(h,m,f){return this.a.call("writeFile",[h,E.VSBuffer.wrap(m),f])}open(h,m){return this.a.call("open",[h,m])}close(h){return this.a.call("close",[h])}async read(h,m,f,p,u){const[b,g]=await this.a.call("read",[h,m,u]);return f.set(b.buffer.slice(0,g),p),g}write(h,m,f,p,u){return this.a.call("write",[h,m,E.VSBuffer.wrap(f),p,u])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,m){return this.a.call("delete",[h,m])}rename(h,m,f){return this.a.call("rename",[h,m,f])}copy(h,m,f){return this.a.call("copy",[h,m,f])}cloneFile(h,m){return this.a.call("cloneFile",[h,m])}i(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const m=h;this.f.fire(m.map(f=>({resource:w.URI.revive(f.resource),type:f.type})))}else{const m=h;this.g.fire(m)}}))}watch(h,m){const f=(0,v.generateUuid)();return this.a.call("watch",[this.h,f,h,m]),(0,M.toDisposable)(()=>this.a.call("unwatch",[this.h,f]))}}e.DiskFileSystemProviderClient=P}),define(ee[107],te([0,1,17,15,159,16]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(S,P,I,h,m,f){let p;try{await k(S,P,I,h,m,f)}catch(u){p=u}finally{p&&m.errorTransformer&&(p=m.errorTransformer(p)),typeof p<"u"&&I.error(p),I.end()}}e.readFileIntoStream=M;async function k(S,P,I,h,m,f){w(f);const p=await S.open(P,{create:!1});try{w(f);let u=0,b=0,g=m&&typeof m.length=="number"?m.length:void 0,d=E.VSBuffer.alloc(Math.min(m.bufferSize,typeof g=="number"?g:m.bufferSize)),l=m&&typeof m.position=="number"?m.position:0,n=0;do b=await S.read(p,l,d.buffer,n,d.byteLength-n),l+=b,n+=b,u+=b,typeof g=="number"&&(g-=b),n===d.byteLength&&(await I.write(h(d)),d=E.VSBuffer.alloc(Math.min(m.bufferSize,typeof g=="number"?g:m.bufferSize)),n=0);while(b>0&&(typeof g!="number"||g>0)&&w(f)&&v(u,m));if(n>0){let s=n;typeof g=="number"&&(s=Math.min(n,g)),I.write(h(d.slice(0,s)))}}catch(u){throw(0,A.ensureFileSystemProviderError)(u)}finally{await S.close(p)}}function w(S){if(S.isCancellationRequested)throw(0,t.canceled)();return!0}function v(S,P){if(P?.limits){if(typeof P.limits.memory=="number"&&S>P.limits.memory)throw(0,A.createFileSystemProviderError)((0,C.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&S>P.limits.size)throw(0,A.createFileSystemProviderError)((0,C.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[71],te([0,1,98,2,9,4,7,16]),function(q,e,E,t,C,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function w(u){return u.recursive===!0}e.isRecursiveWatchRequest=w;class v extends t.Disposable{constructor(b,g,d,l){super(),this.h=b,this.i=g,this.j=d,this.k=l,this.c=this.B(new t.MutableDisposable),this.f=void 0,this.g=0}m(){const b=new t.DisposableStore;this.c.value=b,this.b=this.l(b),this.b.setVerboseLogging(this.j),b.add(this.b.onDidChangeFile(g=>this.h(g))),b.add(this.b.onDidLogMessage(g=>this.i(g))),b.add(this.b.onDidError(g=>this.n(g)))}n(b){this.k.restartOnError?this.g<v.a&&this.f?(this.r(`restarting watcher after error: ${b}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${b}`):this.r(b)}p(b){this.g++,this.m(),this.watch(b)}async watch(b){this.f=b,await this.b?.watch(b)}async setVerboseLogging(b){this.j=b,await this.b?.setVerboseLogging(b)}r(b){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${b}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=v,v.a=5;class S extends v{constructor(b,g,d){super(b,g,d,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=S;class P extends v{constructor(b,g,d){super(b,g,d,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=P;function I(u){return u.map(b=>({type:b.type,resource:M.URI.file(b.path)}))}e.toFileChanges=I;function h(u){const b=new p;for(const g of u)b.processEvent(g);return b.coalesce()}e.coalesceEvents=h;function m(u,b){return typeof b=="string"&&!b.startsWith(E.GLOBSTAR)&&!(0,C.isAbsolute)(b)?{base:u,pattern:b}:b}e.normalizeWatcherPattern=m;function f(u,b){const g=[];for(const d of b)g.push((0,E.parse)(m(u,d)));return g}e.parseWatcherPatterns=f;class p{constructor(){this.a=new Set,this.b=new Map}c(b){return A.isLinux?b.path:b.path.toLowerCase()}processEvent(b){const g=this.b.get(this.c(b));let d=!1;if(g){const l=g.type,n=b.type;g.path!==b.path&&(b.type===2||b.type===1)?d=!0:l===1&&n===2?(this.b.delete(this.c(b)),this.a.delete(g)):l===2&&n===1?g.type=0:l===1&&n===0||(g.type=n)}else d=!0;d&&(this.a.add(b),this.b.set(this.c(b),b))}coalesce(){const b=[],g=[];return Array.from(this.a).filter(d=>d.type!==2?(b.push(d),!1):!0).sort((d,l)=>d.path.length-l.path.length).filter(d=>g.some(l=>(0,k.isParent)(d.path,l,!A.isLinux))?!1:(g.push(d.path),!0)).concat(b)}}}),define(ee[196],te([0,1,39,8,22,30,2,76,9,4,99,23,71]),function(q,e,E,t,C,A,M,k,w,v,S,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends M.Disposable{constructor(p,u,b,g){super(),this.k=p,this.l=u,this.m=b,this.n=g,this.c=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},d=>this.l(d)),this.f=this.B(new t.ThrottledDelayer(h.b)),this.g=[],this.h=(0,I.parseWatcherPatterns)(this.k.path,this.k.excludes),this.i=this.k.includes?(0,I.parseWatcherPatterns)(this.k.path,this.k.includes):void 0,this.j=new C.CancellationTokenSource,this.ready=this.r()}async r(){try{const p=await this.s(this.k);if(this.j.token.isCancellationRequested)return;const u=await P.Promises.stat(p);this.B(await this.t(p,u.isDirectory()))}catch(p){p.code!=="ENOENT"?this.w(p):this.C(p)}}async s(p){let u=p.path;try{u=await P.Promises.realpath(p.path),p.path===u&&(u=await(0,S.realcase)(p.path)??p.path),p.path!==u&&this.C(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${p.path}, real: ${u})`)}catch{}return u}async t(p,u){if(v.isMacintosh&&(0,A.isEqualOrParent)(p,"/Volumes/",!0))return this.w(`Refusing to watch ${p} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const b=new C.CancellationTokenSource(this.j.token),g=new M.DisposableStore;try{const d=(0,w.basename)(p),l=(0,E.watch)(p);g.add((0,M.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.C(`Started watching: '${p}'`);const n=new Set;if(u)try{for(const i of await P.Promises.readdir(p))n.add(i)}catch(i){this.w(i)}const s=new Map;g.add((0,M.toDisposable)(()=>{for(const[,i]of s)i.dispose();s.clear()})),l.on("error",(i,a)=>{this.w(`Failed to watch ${p} for changes using fs.watch() (${i}, ${a})`),this.dispose()}),l.on("change",(i,a)=>{if(b.token.isCancellationRequested)return;this.C(`[raw] ["${i}"] ${a}`);let r="";if(a&&(r=a.toString(),v.isMacintosh&&(r=(0,k.normalizeNFC)(r))),!(!r||i!=="change"&&i!=="rename"))if(u)if(i==="rename"){s.get(r)?.dispose();const c=setTimeout(async()=>{if(s.delete(r),r===d&&!await P.Promises.exists(p)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.v((0,w.join)(p,r));if(b.token.isCancellationRequested)return;let y;o?n.has(r)?y=0:(y=1,n.add(r)):(n.delete(r),y=2),this.u({path:(0,w.join)(this.k.path,r),type:y})},h.a);s.set(r,(0,M.toDisposable)(()=>clearTimeout(c)))}else{let c;n.has(r)?c=0:(c=1,n.add(r)),this.u({path:(0,w.join)(this.k.path,r),type:c})}else if(i==="rename"||r!==d){const c=setTimeout(async()=>{const o=await P.Promises.exists(p);b.token.isCancellationRequested||(o?(this.u({path:this.k.path,type:0},!0),g.add(await this.t(p,!1))):(await this.u({path:this.k.path,type:2},!0),this.dispose()))},h.a);g.clear(),g.add((0,M.toDisposable)(()=>clearTimeout(c)))}else this.u({path:this.k.path,type:0},!0)})}catch(d){await P.Promises.exists(p)&&!b.token.isCancellationRequested&&this.w(`Failed to watch ${p} for changes using fs.watch() (${d.toString()})`)}return(0,M.toDisposable)(()=>{b.dispose(!0),g.dispose()})}async u(p,u=!1){if(!this.j.token.isCancellationRequested){this.n&&this.C(`${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`),!u&&this.h.some(b=>b(p.path))?this.n&&this.C(` >> ignored (excluded) ${p.path}`):!u&&this.i&&this.i.length>0&&!this.i.some(b=>b(p.path))?this.n&&this.C(` >> ignored (not included) ${p.path}`):this.g.push(p);try{await this.f.trigger(async()=>{const b=this.g;this.g=[];const g=(0,I.coalesceEvents)(b);if(g.length>0){if(this.n)for(const l of g)this.C(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.c.work(g)?this.c.pending>0&&this.C(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async v(p){if(v.isLinux)return P.Promises.exists(p);try{const u=(0,w.basename)(p);return(await P.Promises.readdir((0,w.dirname)(p))).some(g=>g===u)}catch(u){return this.C(u),!1}}setVerboseLogging(p){this.n=p}w(p){this.j.token.isCancellationRequested||this.m?.({type:"error",message:`[File Watcher (node.js)] ${p}`})}y(p){this.j.token.isCancellationRequested||this.m?.({type:"warn",message:`[File Watcher (node.js)] ${p}`})}C(p){!this.j.token.isCancellationRequested&&this.n&&this.m?.({type:"trace",message:`[File Watcher (node.js)] ${p}`})}dispose(){this.C(`stopping file watcher on ${this.k.path}`),this.j.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=h,h.a=100,h.b=50;async function m(f,p,u,b,g=512){const d=await P.Promises.open(f,"r"),l=Buffer.allocUnsafe(g),n=new C.CancellationTokenSource(b);let s,i=!1;const a={path:f,excludes:[],recursive:!1},r=new h(a,c=>{(async()=>{for(const{type:o}of c)if(o===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:y}=await P.Promises.read(d,l,0,g,null);if(!y||n.token.isCancellationRequested)break;p(l.slice(0,y))}}catch(y){s=new Error(y),n.dispose(!0)}finally{i=!1}}})()});return await r.ready,u(),new Promise((c,o)=>{n.token.onCancellationRequested(async()=>{r.dispose();try{await P.Promises.close(d)}catch(y){s=new Error(y)}s?o(s):c()})})}e.watchFileContents=m}),define(ee[197],te([0,1,3,98,2,4,196]),function(q,e,E,t,C,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends C.Disposable{constructor(){super(...arguments),this.a=this.B(new E.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new E.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(v){const S=this.i(v),P=S.filter(h=>{const m=this.c.get(h.path);return m?!(0,t.patternsEquals)(m.request.excludes,h.excludes)||!(0,t.patternsEquals)(m.request.includes,h.includes):!0}),I=Array.from(this.c.values()).filter(({request:h})=>!S.find(m=>m.path===h.path&&(0,t.patternsEquals)(m.excludes,h.excludes)&&(0,t.patternsEquals)(m.includes,h.includes))).map(({request:h})=>h.path);P.length&&this.j(`Request to start watching: ${P.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),I.length&&this.j(`Request to stop watching: ${I.join(",")}`);for(const h of I)this.h(h);for(const h of P)this.g(h)}g(v){const S=new M.NodeJSFileWatcherLibrary(v,I=>this.a.fire(I),I=>this.b.fire(I),this.f),P={request:v,instance:S};this.c.set(v.path,P)}async stop(){for(const[v]of this.c)this.h(v);this.c.clear()}h(v){const S=this.c.get(v);S&&(this.c.delete(v),S.instance.dispose())}i(v){const S=new Map;for(const P of v){const I=A.isLinux?P.path:P.path.toLowerCase();S.set(I,P)}return Array.from(S.values())}async setVerboseLogging(v){this.f=v;for(const[,S]of this.c)S.instance.setVerboseLogging(v)}j(v){this.f&&this.b.fire({type:"trace",message:this.k(v)})}k(v,S){return S?`[File Watcher (node.js)] ${v} (path: ${S.request.path})`:`[File Watcher (node.js)] ${v}`}}e.NodeJSWatcher=k}),define(ee[198],te([0,1,71,197]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class C extends E.AbstractNonRecursiveWatcherClient{constructor(M,k,w){super(M,k,w),this.m()}l(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=C}),define(ee[199],te([0,1,14,45,145,71]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends A.AbstractUniversalWatcherClient{constructor(w,v,S){super(w,v,S),this.m()}l(w){const v=w.add(new C.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(v.onDidProcessExit(({code:S,signal:P})=>this.n(`terminated by itself with code ${S}, signal: ${P}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(v.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(ee[85],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...C){this.a=new Map;for(const[A,M]of C)this.set(A,M)}set(C,A){const M=this.a.get(C);return this.a.set(C,A),M}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.ServiceCollection=E}),define(ee[200],te([0,1,8,15,2,69,190,5,85,94]),function(q,e,E,t,C,A,M,k,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const S=!1;class P extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class I{constructor(p=new w.ServiceCollection,u=!1,b,g=S){this.f=p,this.g=u,this.h=b,this.i=g,this.o=new Set,this.f.set(k.IInstantiationService,this),this._globalGraph=g?b?._globalGraph??new M.Graph(d=>d):void 0}createChild(p){return new I(p,this.g,this,this.i)}invokeFunction(p,...u){const b=m.traceInvocation(this.i,p);let g=!1;try{return p({get:l=>{if(g)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(l,b);if(!n)throw new Error(`[invokeFunction] unknown service '${l}'`);return n}},...u)}finally{g=!0,b.stop()}}createInstance(p,...u){let b,g;return p instanceof A.SyncDescriptor?(b=m.traceCreation(this.i,p.ctor),g=this.j(p.ctor,p.staticArguments.concat(u),b)):(b=m.traceCreation(this.i,p),g=this.j(p,u,b)),b.stop(),g}j(p,u=[],b){const g=k._util.getServiceDependencies(p).sort((n,s)=>n.index-s.index),d=[];for(const n of g){const s=this.m(n.id,b);s||this.u(`[createInstance] ${p.name} depends on UNKNOWN service ${n.id}.`,!1),d.push(s)}const l=g.length>0?g[0].index:u.length;if(u.length!==l){console.trace(`[createInstance] First service dependency of ${p.name} at position ${l+1} conflicts with ${u.length} static arguments`);const n=l-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,l)}return Reflect.construct(p,u.concat(d))}k(p,u){if(this.f.get(p)instanceof A.SyncDescriptor)this.f.set(p,u);else if(this.h)this.h.k(p,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(p){const u=this.f.get(p);return!u&&this.h?this.h.l(p):u}m(p,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const b=this.l(p);return b instanceof A.SyncDescriptor?this.q(p,b,u.branch(p,!0)):(u.branch(p,!1),b)}q(p,u,b){if(this.o.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.o.add(p);try{return this.r(p,u,b)}finally{this.o.delete(p)}}r(p,u,b){const g=new M.Graph(n=>n.id.toString());let d=0;const l=[{id:p,desc:u,_trace:b}];for(;l.length;){const n=l.pop();if(g.lookupOrInsertNode(n),d++>1e3)throw new P(g);for(const s of k._util.getServiceDependencies(n.desc.ctor)){const i=this.l(s.id);if(i||this.u(`[createInstance] ${p} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),i instanceof A.SyncDescriptor){const a={id:s.id,desc:i,_trace:n._trace.branch(s.id,!0)};g.insertEdge(n,a),l.push(a)}}}for(;;){const n=g.roots();if(n.length===0){if(!g.isEmpty())throw new P(g);break}for(const{data:s}of n){if(this.l(s.id)instanceof A.SyncDescriptor){const a=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,a)}g.removeNode(s)}}return this.l(p)}s(p,u,b=[],g,d){if(this.f.get(p)instanceof A.SyncDescriptor)return this.t(p,u,b,g,d);if(this.h)return this.h.s(p,u,b,g,d);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(p,u,b=[],g,d){if(g){const l=new I(void 0,this.g,this,this.i);l.c=String(p);const n=new Map,s=new E.IdleValue(()=>{const i=l.j(u,b,d);for(const[a,r]of n){const c=i[a];if(typeof c=="function")for(const o of r)c.apply(i,o)}return n.clear(),i});return new Proxy(Object.create(null),{get(i,a){if(!s.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let o=n.get(a);return o||(o=new v.LinkedList,n.set(a,o)),(D,O,N)=>{const Y=o.push([D,O,N]);return(0,C.toDisposable)(Y)}}if(a in i)return i[a];const r=s.value;let c=r[a];return typeof c!="function"||(c=c.bind(r),i[a]=c),c},set(i,a,r){return s.value[a]=r,!0}})}else return this.j(u,b,d)}u(p,u){if(u&&console.warn(p),this.g)throw new Error(p)}}e.InstantiationService=I;var h;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(h||(h={}));class m{static traceInvocation(p,u){return p?new m(1,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(p,u){return p?new m(0,u.name):m.c}constructor(p,u){this.type=p,this.name=u,this.g=Date.now(),this.h=[]}branch(p,u){const b=new m(2,p.toString());return this.h.push([p,u,b]),b}stop(){const p=Date.now()-this.g;m.f+=p;let u=!1;function b(d,l){const n=[],s=new Array(d+1).join("	");for(const[i,a,r]of l.h)if(a&&r){u=!0,n.push(`${s}CREATES -> ${i}`);const c=b(d+1,r);c&&n.push(c)}else n.push(`${s}uses -> ${i}`);return n.join(`
`)}const g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(p>2||u)&&m.all.add(g.join(`
`))}}e.Trace=m,m.all=new Set,m.c=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m.f=0}),define(ee[6],te([0,1,43,3,2,38,4,7,5]),function(q,e,E,t,C,A,M,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function v(){return new Date().toISOString()}var S;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function P(c,o,y){switch(o){case S.Trace:c.trace(y);break;case S.Debug:c.debug(y);break;case S.Info:c.info(y);break;case S.Warning:c.warn(y);break;case S.Error:c.error(y);break;default:throw new Error("Invalid log level")}}e.log=P;function I(c){let o="";for(let y=0;y<c.length;y++){let D=c[y];if(typeof D=="object")try{D=JSON.stringify(D)}catch{}o+=(y>0?" ":"")+D}return o}e.format=I;class h extends C.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(o){this.b!==o&&(this.b=o,this.c.fire(this.b))}getLevel(){return this.b}}e.AbstractLogger=h;class m extends h{constructor(o){super(),this.g=o}h(o){return this.g||this.getLevel()<=o}trace(o,...y){this.h(S.Trace)&&this.f(S.Trace,I([o,...y]))}debug(o,...y){this.h(S.Debug)&&this.f(S.Debug,I([o,...y]))}info(o,...y){this.h(S.Info)&&this.f(S.Info,I([o,...y]))}warn(o,...y){this.h(S.Warning)&&this.f(S.Warning,I([o,...y]))}error(o,...y){if(this.h(S.Error))if(o instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=o.stack,this.f(S.Error,I(D))}else this.f(S.Error,I([o,...y]))}flush(){}}e.AbstractMessageLogger=m;class f extends h{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.f=!M.isWindows}trace(o,...y){this.getLevel()<=S.Trace&&(this.f?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,o,...y):console.log(`[main ${v()}]`,o,...y))}debug(o,...y){this.getLevel()<=S.Debug&&(this.f?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,o,...y):console.log(`[main ${v()}]`,o,...y))}info(o,...y){this.getLevel()<=S.Info&&(this.f?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,o,...y):console.log(`[main ${v()}]`,o,...y))}warn(o,...y){this.getLevel()<=S.Warning&&(this.f?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,o,...y):console.warn(`[main ${v()}]`,o,...y))}error(o,...y){this.getLevel()<=S.Error&&(this.f?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,o,...y):console.error(`[main ${v()}]`,o,...y))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class p extends h{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...y){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",o,...y)}debug(o,...y){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...y)}info(o,...y){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",o,...y)}warn(o,...y){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",o,...y)}error(o,...y){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",o,...y)}dispose(){}flush(){}}e.ConsoleLogger=p;class u extends h{constructor(o,y=e.DEFAULT_LOG_LEVEL){super(),this.f=o,this.setLevel(y)}trace(o,...y){this.getLevel()<=S.Trace&&this.f.log(S.Trace,[this.g(o),...y])}debug(o,...y){this.getLevel()<=S.Debug&&this.f.log(S.Debug,[this.g(o),...y])}info(o,...y){this.getLevel()<=S.Info&&this.f.log(S.Info,[this.g(o),...y])}warn(o,...y){this.getLevel()<=S.Warning&&this.f.log(S.Warning,[this.g(o),...y])}error(o,...y){this.getLevel()<=S.Error&&this.f.log(S.Error,[this.g(o),...y])}g(o){return typeof o=="string"?o:(0,E.toErrorMessage)(o,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class b extends h{constructor(o){super(),this.f=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const y of this.f)y.setLevel(o);super.setLevel(o)}trace(o,...y){for(const D of this.f)D.trace(o,...y)}debug(o,...y){for(const D of this.f)D.debug(o,...y)}info(o,...y){for(const D of this.f)D.info(o,...y)}warn(o,...y){for(const D of this.f)D.warn(o,...y)}error(o,...y){for(const D of this.f)D.error(o,...y)}flush(){for(const o of this.f)o.flush()}dispose(){for(const o of this.f)o.dispose()}}e.MultiplexLogService=b;class g extends C.Disposable{constructor(o){super(),this.b=o,this.B(o)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(o){this.b.setLevel(o)}getLevel(){return this.b.getLevel()}trace(o,...y){this.b.trace(o,...y)}debug(o,...y){this.b.debug(o,...y)}info(o,...y){this.b.info(o,...y)}warn(o,...y){this.b.warn(o,...y)}error(o,...y){this.b.error(o,...y)}flush(){this.b.flush()}}e.LogService=g;class d extends C.Disposable{constructor(o,y){super(),this.c=o,this.b=new A.ResourceMap,this.B(y(D=>this.setLevel(D)))}getLoggers(){return[...this.b.values()].map(({logger:o})=>o)}getLogger(o){return this.b.get(o)?.logger}createLogger(o,y,D){let O=this.b.get(o)?.logger;return O||(D=y?.always?S.Trace:D,O=this.f(o,D??this.c,y),this.b.set(o,{logger:O,logLevel:D})),O}setLevel(o,y){const D=k.URI.isUri(o)?o:void 0,O=D?y:o;if(D){const N=this.b.get(D);N&&N.logLevel!==O&&(N.logLevel=O,N.logger.setLevel(O))}else this.c=O,this.b.forEach(({logLevel:N,logger:Y})=>{N===void 0&&Y.setLevel(this.c)})}getLogLevel(o){return this.b.get(o)?.logLevel}dispose(){this.b.forEach(({logger:o})=>o.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=d;class l{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return S.Info}trace(o,...y){}debug(o,...y){}info(o,...y){}warn(o,...y){}error(o,...y){}critical(o,...y){}dispose(){}flush(){}}e.NullLogger=l;class n extends l{}e.NullLogService=n;class s extends d{constructor(){super(S.Info,t.Event.None)}f(o,y,D){return new l}}e.NullLoggerService=s;function i(c){if(c.verbose)return S.Trace;if(typeof c.logLevel=="string"){const o=r(c.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function a(c){switch(c){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Off:return"off"}}e.LogLevelToString=a;function r(c){switch(c){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Error;case"off":return S.Off}}e.parseLogLevel=r});var ie=this&&this.__param||function(q,e){return function(E,t){e(E,t,q)}};define(ee[201],te([0,1,70,3,2,6,4,8]),function(q,e,E,t,C,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let w=class St extends C.Disposable{constructor(S){super(),this.g=S,this.c=this.B(new t.Emitter),this.onDidChangePassword=this.c.event}async getPassword(S,P){this.g.trace("Getting password from keytar:",S,P);let I;try{I=await this.h()}catch{return null}const h=await(0,k.retry)(()=>I.getPassword(S,P),50,3);if(!h)return this.g.trace("Did not get a password from keytar for account:",P),h;let m,f;try{const p=JSON.parse(h);m=p.content,f=p.hasNextChunk}catch{}if(!m||!f)return this.g.trace("Got password from keytar for account:",P),h;try{let p=1;for(;f;){const u=await(0,k.retry)(()=>I.getPassword(S,`${P}-${p}`),50,3),b=JSON.parse(u);m+=b.content,f=b.hasNextChunk,p++}return this.g.trace(`Got ${p}-chunked password from keytar for account:`,P),m}catch(p){return this.g.error(p),h}}async setPassword(S,P,I){this.g.trace("Setting password using keytar:",S,P);let h;try{h=await this.h()}catch(m){throw this.i?.(m),m}if(M.isWindows&&I.length>St.a){let m=0,f=0,p=!0;for(;p;){const u=I.substring(m,m+St.b);m+=St.b,p=I.length-m>0;const b={content:u,hasNextChunk:p};await(0,k.retry)(()=>h.setPassword(S,f?`${P}-${f}`:P,JSON.stringify(b)),50,3),f++}this.g.trace(`Got${f?` ${f}-chunked`:""} password from keytar for account:`,P)}else await(0,k.retry)(()=>h.setPassword(S,P,I),50,3),this.g.trace("Got password from keytar for account:",P);this.c.fire({service:S,account:P})}async deletePassword(S,P){this.g.trace("Deleting password using keytar:",S,P);let I;try{I=await this.h()}catch(u){throw this.i?.(u),u}const h=await I.getPassword(S,P);if(!h)return this.g.trace("Did not get a password to delete from keytar for account:",P),!1;let m,f;try{const u=JSON.parse(h);m=u.content,f=u.hasNextChunk}catch{}let p=0;if(m&&f)try{for(p++;f;){const u=`${P}-${p}`,b=await I.getPassword(S,u);await I.deletePassword(S,u),f=JSON.parse(b).hasNextChunk,p++}}catch(u){this.g.error(u)}return await I.deletePassword(S,P)?(this.c.fire({service:S,account:P}),this.g.trace(`Deleted${p?` ${p}-chunked`:""} password from keytar for account:`,P),!0):(this.g.trace(`Keytar failed to delete${p?` ${p}-chunked`:""} password for account:`,P),!1)}async findPassword(S){let P;try{P=await this.h()}catch{return null}return await P.findPassword(S)}async findCredentials(S){let P;try{P=await this.h()}catch{return[]}return await P.findCredentials(S)}clear(){return this.f instanceof E.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};w.a=2500,w.b=w.a-100,w=pe([ie(0,A.ILogService)],w),e.BaseCredentialsMainService=w}),define(ee[202],te([0,1,6]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let t=class{constructor(A,M){this.a=A,this.b=M}c(){return new Promise((A,M)=>q(["vscode-encrypt"],A,M))}async encrypt(A){let M;try{M=await this.c()}catch{return A}try{return M.encrypt(this.a,A)}catch(k){return this.b.error(k),A}}async decrypt(A){let M;try{M=await this.c()}catch{return A}try{return M.decrypt(this.a,A)}catch(k){return this.b.error(k),A}}};t=pe([ie(1,E.ILogService)],t),e.EncryptionMainService=t}),define(ee[203],te([0,1,24,8,15,3,2,9,71,6]),function(q,e,E,t,C,A,M,k,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class S extends M.Disposable{constructor(I,h){super(),this.a=I,this.b=h,this.c=this.B(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new t.ThrottledDelayer(0)),this.s=[],this.t=this.B(new t.ThrottledDelayer(0))}watch(I,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(I,h):this.u(I,h)}l(I,h){const m={path:this.D(I),excludes:h.excludes,includes:h.includes,recursive:h.recursive},f=(0,E.insert)(this.j,m);return this.m(),(0,M.toDisposable)(()=>{f(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(I=>(0,C.onUnexpectedError)(I))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,w.toFileChanges)(h)),h=>this.C(h),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)})));const I=this.b?.watcher?.recursive?.usePolling;if(I===!0)for(const h of this.j)(0,w.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(I))for(const h of this.j)(0,w.isRecursiveWatchRequest)(h)&&I.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(I,h){const m={path:this.D(I),excludes:h.excludes,includes:h.includes,recursive:!1},f=(0,E.insert)(this.s,m);return this.v(),(0,M.toDisposable)(()=>{f(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(I=>(0,C.onUnexpectedError)(I))}w(){return this.r||(this.r=this.B(this.y(I=>this.c.fire((0,w.toFileChanges)(I)),I=>this.C(I),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)}))),this.r.watch(this.s)}C(I){I.type==="error"&&this.g.fire(I.message),this.a[I.type](I.message)}D(I){return(0,k.normalize)(I.fsPath)}}e.AbstractDiskFileSystemProvider=S}),define(ee[204],te([0,1,24,8,17,22,3,67,66,2,58,14,72,19,57,157,16,107,6]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends v.Disposable{constructor(l){super(),this.b=l,this.a=256*1024,this.c=this.B(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new M.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new M.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new M.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new M.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new t.ResourceQueue)}registerProvider(l,n){if(this.h.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${l}`);const s=new v.DisposableStore;return this.h.set(l,n),this.c.fire({added:!0,scheme:l,provider:n}),s.add(n.onDidChangeFile(i=>this.R.fire(new p.FileChangesEvent(i,!this.O(n))))),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(i=>this.S.fire(new Error(i)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:l}))),(0,v.toDisposable)(()=>{this.c.fire({added:!1,scheme:l,provider:n}),this.h.delete(l),(0,v.dispose)(s)})}getProvider(l){return this.h.get(l)}async activateProvider(l){const n=[];this.f.fire({scheme:l,join(s){n.push(s)}}),!this.h.has(l)&&await t.Promises.settled(n)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.h.has(l.scheme)}hasCapability(l,n){const s=this.h.get(l.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return w.Iterable.map(this.h,([l,n])=>({scheme:l,capabilities:n.capabilities}))}async j(l){if(!(0,h.isAbsolutePath)(l))throw new p.FileOperationError((0,f.localize)(0,null,this.ob(l)),8);await this.activateProvider(l.scheme);const n=this.h.get(l.scheme);if(!n){const s=new Error;throw s.name="ENOPRO",s.message=(0,f.localize)(1,null,l.toString()),s}return n}async k(l){const n=await this.j(l);if((0,p.hasOpenReadWriteCloseCapability)(n)||(0,p.hasReadWriteCapability)(n)||(0,p.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(l){const n=await this.j(l);if((0,p.hasOpenReadWriteCloseCapability)(n)||(0,p.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,n){try{return await this.n(l,n)}catch(s){throw(0,p.toFileSystemProviderErrorCode)(s)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,f.localize)(2,null,this.ob(l)),1):(0,p.ensureFileSystemProviderError)(s)}}async n(l,n){const s=await this.j(l),i=this.O(s),a=n?.resolveTo,r=n?.resolveSingleChildDescendants,c=n?.resolveMetadata,o=await s.stat(l);let y;return this.p(s,l,o,void 0,!!c,(D,O)=>(y||(y=S.TernarySearchTree.forUris(()=>!i),y.set(l,!0),a&&y.fill(!0,a)),y.get(D.resource)||y.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&r?O===1:!1))}async p(l,n,s,i,a,r){const{providerExtUri:c}=this.N(l),o={resource:n,name:c.basename(n),isFile:(s.type&p.FileType.File)!==0,isDirectory:(s.type&p.FileType.Directory)!==0,isSymbolicLink:(s.type&p.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&p.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,p.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(o.isDirectory&&r(o,i)){try{const y=await l.readdir(n),D=await t.Promises.settled(y.map(async([O,N])=>{try{const Y=c.joinPath(n,O),G=a?await l.stat(Y):{type:N};return await this.p(l,Y,G,y.length,a,r)}catch(Y){return this.b.trace(Y),null}}));o.children=(0,E.coalesce)(D)}catch(y){this.b.trace(y),o.children=[]}return o}return o}async resolveAll(l){return t.Promises.settled(l.map(async n=>{try{return{stat:await this.n(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(l){const n=await this.j(l),s=await n.stat(l);return this.p(n,l,s,void 0,!0,()=>!1)}async exists(l){const n=await this.j(l);try{return!!await n.stat(l)}catch{return!1}}async canCreateFile(l,n){try{await this.r(l,n)}catch(s){return s}return!0}async r(l,n){if(!n?.overwrite&&await this.exists(l))throw new p.FileOperationError((0,f.localize)(3,null,this.ob(l)),3,n)}async createFile(l,n=C.VSBuffer.fromString(""),s){await this.r(l,s);const i=await this.writeFile(l,n);return this.m.fire(new p.FileOperationEvent(l,0,i)),i}async writeFile(l,n,s){const i=this.mb(await this.l(l),l),{providerExtUri:a}=this.N(i);try{await this.s(i,l,s)||await this.P(i,a.dirname(l));let c;if((0,p.hasReadWriteCapability)(i)&&!(n instanceof C.VSBuffer))if((0,m.isReadableStream)(n)){const o=await(0,m.peekStream)(n,3);o.ended?c=C.VSBuffer.concat(o.buffer):c=o}else c=(0,m.peekReadable)(n,o=>C.VSBuffer.concat(o),3);else c=n;!(0,p.hasOpenReadWriteCloseCapability)(i)||(0,p.hasReadWriteCapability)(i)&&c instanceof C.VSBuffer?await this.db(i,l,s,c):await this.Y(i,l,s,c instanceof C.VSBuffer?(0,C.bufferToReadable)(c):c),this.m.fire(new p.FileOperationEvent(l,4))}catch(r){throw new p.FileOperationError((0,f.localize)(4,null,this.ob(l),(0,p.ensureFileSystemProviderError)(r).toString()),(0,p.toFileOperationResult)(r),s)}return this.resolve(l,{resolveMetadata:!0})}async s(l,n,s){if(!!s?.unlock&&!(l.capabilities&8192))throw new Error((0,f.localize)(5,null,this.ob(n)));let a;try{a=await l.stat(n)}catch{return}if((a.type&p.FileType.Directory)!==0)throw new p.FileOperationError((0,f.localize)(6,null,this.ob(n)),0,s);if(this.nb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==p.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,p.etag)({mtime:s.mtime,size:a.size}))throw new p.FileOperationError((0,f.localize)(7,null),3,s);return a}async readFile(l,n,s){const i=await this.k(l);return n?.atomic?this.t(i,l,n,s):this.u(i,l,n,s)}async t(l,n,s,i){return new Promise((a,r)=>{this.X.queueFor(n,this.N(l).providerExtUri).queue(async()=>{try{const c=await this.u(l,n,s,i);a(c)}catch(c){r(c)}})})}async u(l,n,s,i){const a=await this.v(l,n,{...s,preferUnbuffered:!0},i);return{...a,value:await(0,C.streamToBuffer)(a.value)}}async readFileStream(l,n,s){const i=await this.k(l);return this.v(i,l,n,s)}async v(l,n,s,i){const a=new A.CancellationTokenSource(i),r=this.F(n,s).then(o=>o,o=>{throw a.cancel(),o});let c;try{return typeof s?.etag=="string"&&s.etag!==p.ETAG_DISABLED&&await r,s?.atomic&&(0,p.hasFileAtomicReadCapability)(l)||!((0,p.hasOpenReadWriteCloseCapability)(l)||(0,p.hasFileReadStreamCapability)(l))||(0,p.hasReadWriteCapability)(l)&&s?.preferUnbuffered?c=this.D(l,n,s):(0,p.hasFileReadStreamCapability)(l)?c=this.w(l,n,a.token,s):c=this.C(l,n,a.token,s),{...await r,value:c}}catch(o){c&&await(0,m.consumeStream)(c);const y=(0,f.localize)(8,null,this.ob(n),(0,p.ensureFileSystemProviderError)(o).toString());throw o instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(y,o.stat,s):new p.FileOperationError(y,(0,p.toFileOperationResult)(o),s)}}w(l,n,s,i=Object.create(null)){const a=l.readFileStream(n,i,s);return(0,m.transform)(a,{data:r=>r instanceof C.VSBuffer?r:C.VSBuffer.wrap(r),error:r=>new p.FileOperationError((0,f.localize)(9,null,this.ob(n),(0,p.ensureFileSystemProviderError)(r).toString()),(0,p.toFileOperationResult)(r),i)},r=>C.VSBuffer.concat(r))}C(l,n,s,i=Object.create(null)){const a=(0,C.newWriteableBufferStream)();return(0,u.readFileIntoStream)(l,n,a,r=>r,{...i,bufferSize:this.a,errorTransformer:r=>new p.FileOperationError((0,f.localize)(10,null,this.ob(n),(0,p.ensureFileSystemProviderError)(r).toString()),(0,p.toFileOperationResult)(r),i)},s),a}D(l,n,s){const i=(0,m.newWriteableStream)(a=>C.VSBuffer.concat(a));return(async()=>{try{let a;s?.atomic&&(0,p.hasFileAtomicReadCapability)(l)?a=await l.readFile(n,{atomic:!0}):a=await l.readFile(n),typeof s?.position=="number"&&(a=a.slice(s.position)),typeof s?.length=="number"&&(a=a.slice(0,s.length)),this.G(n,a.byteLength,s),i.end(C.VSBuffer.wrap(a))}catch(a){i.error(a),i.end()}})(),i}async F(l,n){const s=await this.resolve(l,{resolveMetadata:!0});if(s.isDirectory)throw new p.FileOperationError((0,f.localize)(11,null,this.ob(l)),0,n);if(typeof n?.etag=="string"&&n.etag!==p.ETAG_DISABLED&&n.etag===s.etag)throw new p.NotModifiedSinceFileOperationError((0,f.localize)(12,null),s,n);return this.G(l,s.size,n),s}G(l,n,s){if(s?.limits){let i;if(typeof s.limits.memory=="number"&&n>s.limits.memory&&(i=9),typeof s.limits.size=="number"&&n>s.limits.size&&(i=7),typeof i=="number")throw new p.FileOperationError((0,f.localize)(13,null,this.ob(l)),i)}}async canMove(l,n,s){return this.H(l,n,"move",s)}async canCopy(l,n,s){return this.H(l,n,"copy",s)}async H(l,n,s,i){if(l.toString()!==n.toString())try{const a=s==="move"?this.mb(await this.l(l),l):await this.k(l),r=this.mb(await this.l(n),n);await this.M(a,l,r,n,s,i)}catch(a){return a}return!0}async move(l,n,s){const i=this.mb(await this.l(l),l),a=this.mb(await this.l(n),n),r=await this.I(i,l,a,n,"move",!!s),c=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new p.FileOperationEvent(l,r==="move"?2:3,c)),c}async copy(l,n,s){const i=await this.k(l),a=this.mb(await this.l(n),n),r=await this.I(i,l,a,n,"copy",!!s),c=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new p.FileOperationEvent(l,r==="copy"?3:2,c)),c}async I(l,n,s,i,a,r){if(n.toString()===i.toString())return a;const{exists:c,isSameResourceWithDifferentPathCase:o}=await this.M(l,n,s,i,a,r);if(c&&!o&&r&&await this.del(i,{recursive:!0}),await this.P(s,this.N(s).providerExtUri.dirname(i)),a==="copy"){if(l===s&&(0,p.hasFileFolderCopyCapability)(l))await l.copy(n,i,{overwrite:r});else{const y=await this.resolve(n);y.isDirectory?await this.L(l,y,s,i):await this.J(l,n,s,i)}return a}else return l===s?(await l.rename(n,i,{overwrite:r}),a):(await this.I(l,n,s,i,"copy",r),await this.del(n,{recursive:!0}),"copy")}async J(l,n,s,i){if((0,p.hasOpenReadWriteCloseCapability)(l)&&(0,p.hasOpenReadWriteCloseCapability)(s))return this.fb(l,n,s,i);if((0,p.hasOpenReadWriteCloseCapability)(l)&&(0,p.hasReadWriteCapability)(s))return this.lb(l,n,s,i);if((0,p.hasReadWriteCapability)(l)&&(0,p.hasOpenReadWriteCloseCapability)(s))return this.jb(l,n,s,i);if((0,p.hasReadWriteCapability)(l)&&(0,p.hasReadWriteCapability)(s))return this.hb(l,n,s,i)}async L(l,n,s,i){await s.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async a=>{const r=this.N(s).providerExtUri.joinPath(i,a.name);return a.isDirectory?this.L(l,await this.resolve(a.resource),s,r):this.J(l,a.resource,s,r)}))}async M(l,n,s,i,a,r){let c=!1;if(l===s){const{providerExtUri:y,isPathCaseSensitive:D}=this.N(l);if(D||(c=y.isEqual(n,i)),c&&a==="copy")throw new Error((0,f.localize)(14,null,this.ob(n),this.ob(i)));if(!c&&y.isEqualOrParent(i,n))throw new Error((0,f.localize)(15,null,this.ob(n),this.ob(i)))}const o=await this.exists(i);if(o&&!c){if(!r)throw new p.FileOperationError((0,f.localize)(16,null,this.ob(n),this.ob(i)),4);if(l===s){const{providerExtUri:y}=this.N(l);if(y.isEqualOrParent(n,i))throw new Error((0,f.localize)(17,null,this.ob(n),this.ob(i)))}}return{exists:o,isSameResourceWithDifferentPathCase:c}}N(l){const n=this.O(l);return{providerExtUri:n?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:n}}O(l){return!!(l.capabilities&1024)}async createFolder(l){const n=this.mb(await this.j(l),l);await this.P(n,l);const s=await this.resolve(l,{resolveMetadata:!0});return this.m.fire(new p.FileOperationEvent(l,0,s)),s}async P(l,n){const s=[],{providerExtUri:i}=this.N(l);for(;!i.isEqual(n,i.dirname(n));)try{if(((await l.stat(n)).type&p.FileType.Directory)===0)throw new Error((0,f.localize)(18,null,this.ob(n)));break}catch(a){if((0,p.toFileSystemProviderErrorCode)(a)!==p.FileSystemProviderErrorCode.FileNotFound)throw a;s.push(i.basename(n)),n=i.dirname(n)}for(let a=s.length-1;a>=0;a--){n=i.joinPath(n,s[a]);try{await l.mkdir(n)}catch(r){if((0,p.toFileSystemProviderErrorCode)(r)!==p.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(l,n){try{await this.Q(l,n)}catch(s){return s}return!0}async Q(l,n){const s=this.mb(await this.j(l),l);if(!!n?.useTrash&&!(s.capabilities&4096))throw new Error((0,f.localize)(19,null,this.ob(l)));let a;try{a=await s.stat(l)}catch{}if(a)this.nb(l,a);else throw new p.FileOperationError((0,f.localize)(20,null,this.ob(l)),1);if(!!!n?.recursive){const c=await this.resolve(l);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,f.localize)(21,null,this.ob(l)))}return s}async del(l,n){const s=await this.Q(l,n),i=!!n?.useTrash,a=!!n?.recursive;await s.delete(l,{recursive:a,useTrash:i}),this.m.fire(new p.FileOperationEvent(l,1))}async cloneFile(l,n){const s=await this.j(l),i=this.mb(await this.l(n),n);if(s===i&&this.N(s).providerExtUri.isEqual(l,n))return;if(s===i&&(0,p.hasFileCloneCapability)(s))return s.cloneFile(l,n);await this.P(i,this.N(i).providerExtUri.dirname(n));const a=this.X.queueFor(l,this.N(s).providerExtUri);return s===i&&(0,p.hasFileFolderCopyCapability)(s)?a.queue(()=>s.copy(l,n,{overwrite:!0})):a.queue(()=>this.J(s,l,i,n))}watch(l,n={recursive:!1,excludes:[]}){const s=new v.DisposableStore;let i=!1,a=()=>{i=!0};return s.add((0,v.toDisposable)(()=>a())),(async()=>{try{const r=await this.W(l,n);i?(0,v.dispose)(r):a=()=>(0,v.dispose)(r)}catch(r){this.b.error(r)}})(),s}async W(l,n){const s=await this.j(l),i=(0,k.hash)([this.N(s).providerExtUri.getComparisonKey(l),n]);let a=this.U.get(i);return a||(a={count:0,disposable:s.watch(l,n)},this.U.set(i,a)),a.count+=1,(0,v.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,v.dispose)(a.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,l]of this.U)(0,v.dispose)(l.disposable);this.U.clear()}async Y(l,n,s,i){return this.X.queueFor(n,this.N(l).providerExtUri).queue(async()=>{const a=await l.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,m.isReadableStream)(i)||(0,m.isReadableBufferedStream)(i)?await this.ab(l,a,i):await this.bb(l,a,i)}catch(r){throw(0,p.ensureFileSystemProviderError)(r)}finally{await l.close(a)}})}async ab(l,n,s){let i=0,a;if((0,m.isReadableBufferedStream)(s)){if(s.buffer.length>0){const r=C.VSBuffer.concat(s.buffer);await this.cb(l,n,r,r.byteLength,i,0),i+=r.byteLength}if(s.ended)return;a=s.stream}else a=s;return new Promise((r,c)=>{(0,m.listenStream)(a,{onData:async o=>{a.pause();try{await this.cb(l,n,o,o.byteLength,i,0)}catch(y){return c(y)}i+=o.byteLength,setTimeout(()=>a.resume())},onError:o=>c(o),onEnd:()=>r()})})}async bb(l,n,s){let i=0,a;for(;(a=s.read())!==null;)await this.cb(l,n,a,a.byteLength,i,0),i+=a.byteLength}async cb(l,n,s,i,a,r){let c=0;for(;c<i;)c+=await l.write(n,a+c,s.buffer,r+c,i-c)}async db(l,n,s,i){return this.X.queueFor(n,this.N(l).providerExtUri).queue(()=>this.eb(l,n,s,i))}async eb(l,n,s,i){let a;i instanceof C.VSBuffer?a=i:(0,m.isReadableStream)(i)?a=await(0,C.streamToBuffer)(i):(0,m.isReadableBufferedStream)(i)?a=await(0,C.bufferedStreamToBuffer)(i):a=(0,C.readableToBuffer)(i),await l.writeFile(n,a.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async fb(l,n,s,i){return this.X.queueFor(i,this.N(s).providerExtUri).queue(()=>this.gb(l,n,s,i))}async gb(l,n,s,i){let a,r;try{a=await l.open(n,{create:!1}),r=await s.open(i,{create:!0,unlock:!1});const c=C.VSBuffer.alloc(this.a);let o=0,y=0,D=0;do D=await l.read(a,o,c.buffer,y,c.byteLength-y),await this.cb(s,r,c,D,o,y),o+=D,y+=D,y===c.byteLength&&(y=0);while(D>0)}catch(c){throw(0,p.ensureFileSystemProviderError)(c)}finally{await t.Promises.settled([typeof a=="number"?l.close(a):Promise.resolve(),typeof r=="number"?s.close(r):Promise.resolve()])}}async hb(l,n,s,i){return this.X.queueFor(i,this.N(s).providerExtUri).queue(()=>this.ib(l,n,s,i))}async ib(l,n,s,i){return s.writeFile(i,await l.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async jb(l,n,s,i){return this.X.queueFor(i,this.N(s).providerExtUri).queue(()=>this.kb(l,n,s,i))}async kb(l,n,s,i){const a=await s.open(i,{create:!0,unlock:!1});try{const r=await l.readFile(n);await this.cb(s,a,C.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,p.ensureFileSystemProviderError)(r)}finally{await s.close(a)}}async lb(l,n,s,i){const a=await(0,C.streamToBuffer)(this.C(l,n,A.CancellationToken.None));await this.db(s,i,void 0,a)}mb(l,n){if(l.capabilities&2048)throw new p.FileOperationError((0,f.localize)(22,null,this.ob(n)),6);return l}nb(l,n){if((n.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,f.localize)(23,null,this.ob(l)),6)}ob(l){return l.scheme===P.Schemas.file?l.fsPath:l.toString(!0)}};g=pe([ie(0,b.ILogService)],g),e.FileService=g}),define(ee[86],te([0,1,39,278,8,38,17,3,30,2,9,4,19,57,23,161,16,107,203,43,199,198]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p,u,b,g,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(E)}catch(s){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(s)}`)}})();class n extends b.AbstractDiskFileSystemProvider{constructor(i,a){super(i,a),this.onDidChangeCapabilities=k.Event.None,this.I=new A.ResourceMap(r=>I.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.M=new Map,this.N=new Map,this.O=new Map}get capabilities(){return this.G||(this.G=57374,P.isLinux&&(this.G|=1024)),this.G}async stat(i){try{const{stat:a,symbolicLink:r}=await m.SymlinkSupport.stat(this.D(i));return{type:this.H(a,r),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.ab(a)}}async readdir(i){try{const a=await m.Promises.readdir(this.D(i),{withFileTypes:!0}),r=[];return await Promise.all(a.map(async c=>{try{let o;c.isSymbolicLink()?o=(await this.stat((0,I.joinPath)(i,c.name))).type:o=this.H(c),r.push([c.name,o])}catch(o){this.a.trace(o)}})),r}catch(a){throw this.ab(a)}}H(i,a){let r;return a?.dangling?r=p.FileType.Unknown:i.isFile()?r=p.FileType.File:i.isDirectory()?r=p.FileType.Directory:r=p.FileType.Unknown,a&&(r|=p.FileType.SymbolicLink),r}async J(i){const a=this.D(i);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let r;for(;r=this.I.get(i);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await r.wait();const c=new C.Barrier;return this.I.set(i,c),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,v.toDisposable)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.I.get(i)===c&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.I.delete(i)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),c.open()})}async readFile(i,a){let r;try{a?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.D(i)})`),r=await this.J(i));const c=this.D(i);return await m.Promises.readFile(c)}catch(c){throw this.ab(c)}finally{r?.dispose()}}L(i){n.F&&this.a.trace(i)}readFileStream(i,a,r){const c=(0,h.newWriteableStream)(o=>M.VSBuffer.concat(o.map(y=>M.VSBuffer.wrap(y))).buffer);return(0,u.readFileIntoStream)(this,i,c,o=>o.buffer,{...a,bufferSize:256*1024},r),c}async writeFile(i,a,r){let c;try{const o=this.D(i);if(!r.create||!r.overwrite){if(await m.Promises.exists(o)){if(!r.overwrite)throw(0,p.createFileSystemProviderError)((0,f.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,p.createFileSystemProviderError)((0,f.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(c,0,a,0,a.byteLength)}catch(o){throw await this.bb(i,o)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(i){n.P=i}async open(i,a){const r=this.D(i);let c;(0,p.isFileOpenForWriteOptions)(a)&&(c=await this.J(i));let o;try{if((0,p.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:D}=await m.SymlinkSupport.stat(r);D.mode&128||await m.Promises.chmod(r,D.mode|128)}catch(D){this.a.trace(D)}let y;if((0,p.isFileOpenForWriteOptions)(a)){if(P.isWindows)try{await m.Promises.truncate(r,0),y="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}y||(y="w")}else y="r";o=await m.Promises.open(r,y)}catch(y){throw c?.dispose(),(0,p.isFileOpenForWriteOptions)(a)?await this.bb(i,y):this.ab(y)}if(this.M.set(o,0),(0,p.isFileOpenForWriteOptions)(a)&&this.O.set(o,i),c){const y=this.N.get(o);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${r})`),this.N.set(o,c),y&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${r})`),y.dispose())}return o}async close(i){const a=this.N.get(i);try{if(this.M.delete(i),this.O.delete(i)&&n.P)try{await m.Promises.fdatasync(i)}catch(r){n.configureFlushOnWrite(!1),this.a.error(r)}return await m.Promises.close(i)}catch(r){throw this.ab(r)}finally{a&&(this.N.get(i)===a&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.N.delete(i)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),a.dispose())}}async read(i,a,r,c,o){const y=this.Q(i,a);let D=null;try{D=(await m.Promises.read(i,r,c,o,y)).bytesRead}catch(O){throw this.ab(O)}finally{this.R(i,y,D)}return D}Q(i,a){return a===this.M.get(i)?null:a}R(i,a,r){const c=this.M.get(i);typeof c=="number"&&(typeof a=="number"||(typeof r=="number"?this.M.set(i,c+r):this.M.delete(i)))}async write(i,a,r,c,o){return(0,C.retry)(()=>this.S(i,a,r,c,o),100,3)}async S(i,a,r,c,o){const y=this.Q(i,a);let D=null;try{D=(await m.Promises.write(i,r,c,o,y)).bytesWritten}catch(O){throw await this.bb(this.O.get(i),O)}finally{this.R(i,y,D)}return D}async mkdir(i){try{await m.Promises.mkdir(this.D(i))}catch(a){throw this.ab(a)}}async delete(i,a){try{const r=this.D(i);a.recursive?await m.Promises.rm(r,m.RimRafMode.MOVE):await m.Promises.unlink(r)}catch(r){throw this.ab(r)}}async rename(i,a,r){const c=this.D(i),o=this.D(a);if(c!==o)try{await this.U(i,a,"move",r.overwrite),await m.Promises.move(c,o)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,f.localize)(2,null,(0,S.basename)(c),(0,S.basename)((0,S.dirname)(o)),y.toString()))),this.ab(y)}}async copy(i,a,r){const c=this.D(i),o=this.D(a);if(c!==o)try{await this.U(i,a,"copy",r.overwrite),await m.Promises.copy(c,o,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,f.localize)(3,null,(0,S.basename)(c),(0,S.basename)((0,S.dirname)(o)),y.toString()))),this.ab(y)}}async U(i,a,r,c){const o=this.D(i),y=this.D(a);let D=!1;if(!!(this.capabilities&1024)||(D=(0,w.isEqual)(o,y,!0)),D&&r==="copy")throw(0,p.createFileSystemProviderError)((0,f.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(!D&&await m.Promises.exists(y)){if(!c)throw(0,p.createFileSystemProviderError)((0,f.localize)(5,null),p.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}async cloneFile(i,a){return this.W(i,a,!1)}async W(i,a,r){const c=this.D(i),o=this.D(a),y=!!(this.capabilities&1024);if((0,w.isEqual)(c,o,!y))return;const D=new v.DisposableStore;try{const[O,N]=await Promise.all([this.J(i),this.J(a)]);D.add(O),D.add(N),r&&await m.Promises.mkdir((0,S.dirname)(o),{recursive:!0}),await m.Promises.copyFile(c,o)}catch(O){if(O.code==="ENOENT"&&!r)return this.W(i,a,!0);throw this.ab(O)}finally{D.dispose()}}p(i,a,r){return new d.UniversalWatcherClient(c=>i(c),c=>a(c),r)}y(i,a,r){return new l.NodeJSWatcherClient(c=>i(c),c=>a(c),r)}ab(i){if(i instanceof p.FileSystemProviderError)return i;let a;switch(i.code){case"ENOENT":a=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=p.FileSystemProviderErrorCode.NoPermissions;break;default:a=p.FileSystemProviderErrorCode.Unknown}return(0,p.createFileSystemProviderError)(i,a)}async bb(i,a){let r=this.ab(a);if(i&&r.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await m.SymlinkSupport.stat(this.D(i));c.mode&128||(r=(0,p.createFileSystemProviderError)(a,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return r}}e.DiskFileSystemProvider=n,n.F=!1,n.P=!0}),define(ee[205],te([0,1,3,86,2,17,57,22]),function(q,e,E,t,C,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class w extends C.Disposable{constructor(P,I){super(),this.a=P,this.b=I,this.w=new Map,this.y=new Map}call(P,I,h){const m=this.c(P);switch(I){case"stat":return this.g(m,h[0]);case"readdir":return this.h(m,h[0]);case"open":return this.l(m,h[0],h[1]);case"close":return this.m(h[0]);case"read":return this.n(h[0],h[1],h[2]);case"readFile":return this.i(m,h[0],h[1]);case"write":return this.p(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.k(m,h[0],h[1],h[2]);case"rename":return this.t(m,h[0],h[1],h[2]);case"copy":return this.u(m,h[0],h[1],h[2]);case"cloneFile":return this.v(m,h[0],h[1]);case"mkdir":return this.r(m,h[0]);case"delete":return this.s(m,h[0],h[1]);case"watch":return this.D(m,h[0],h[1],h[2],h[3]);case"unwatch":return this.F(h[0],h[1])}throw new Error(`IPC Command ${I} not found`)}listen(P,I,h){const m=this.c(P);switch(I){case"fileChange":return this.C(m,h[0]);case"readFileStream":return this.j(m,h[0],h[1])}throw new Error(`Unknown event ${I}`)}g(P,I){const h=this.f(P,I,!0);return this.a.stat(h)}h(P,I){const h=this.f(P,I);return this.a.readdir(h)}async i(P,I,h){const m=this.f(P,I,!0),f=await this.a.readFile(m,h);return A.VSBuffer.wrap(f)}j(P,I,h){const m=this.f(P,I,!0),f=new k.CancellationTokenSource,p=new E.Emitter({onDidRemoveLastListener:()=>{f.cancel()}}),u=this.a.readFileStream(m,h,f.token);return(0,M.listenStream)(u,{onData:b=>p.fire(A.VSBuffer.wrap(b)),onError:b=>p.fire(b),onEnd:()=>{p.fire("end"),p.dispose(),f.dispose()}}),p.event}k(P,I,h,m){const f=this.f(P,I);return this.a.writeFile(f,h.buffer,m)}l(P,I,h){const m=this.f(P,I,!0);return this.a.open(m,h)}m(P){return this.a.close(P)}async n(P,I,h){const m=A.VSBuffer.alloc(h),f=0,p=await this.a.read(P,I,m.buffer,f,h);return[m,p]}p(P,I,h,m,f){return this.a.write(P,I,h.buffer,m,f)}r(P,I){const h=this.f(P,I);return this.a.mkdir(h)}s(P,I,h){const m=this.f(P,I);return this.a.delete(m,h)}t(P,I,h,m){const f=this.f(P,I),p=this.f(P,h);return this.a.rename(f,p,m)}u(P,I,h,m){const f=this.f(P,I),p=this.f(P,h);return this.a.copy(f,p,m)}v(P,I,h){const m=this.f(P,I),f=this.f(P,h);return this.a.cloneFile(m,f)}C(P,I){const h=new E.Emitter({onWillAddFirstListener:()=>{this.w.set(I,this.G(P,h))},onDidRemoveLastListener:()=>{(0,C.dispose)(this.w.get(I)),this.w.delete(I)}});return h.event}async D(P,I,h,m,f){const p=this.w.get(I);if(p){const u=this.f(P,m),b=p.watch(h,u,f);this.y.set(I+h,b)}}async F(P,I){const h=P+I,m=this.y.get(h);m&&((0,C.dispose)(m),this.y.delete(h))}dispose(){super.dispose();for(const[,P]of this.y)P.dispose();this.y.clear();for(const[,P]of this.w)P.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=w;class v extends C.Disposable{constructor(P,I,h,m){super(),this.c=P,this.f=h,this.g=m,this.a=new Map,this.b=this.B(new t.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(I)}h(P){const I=this.B(new E.Emitter);this.B(I.event(h=>{P.fire(h.map(m=>({resource:this.c.transformOutgoingURI(m.resource),type:m.type})))})),this.B(this.b.onDidChangeFile(h=>I.fire(h))),this.B(this.b.onDidWatchError(h=>P.fire(h)))}i(P){}j(P){}watch(P,I,h){const m=this.j(this.g);return Array.isArray(m)&&(h.excludes=[...h.excludes,...m]),this.a.set(P,this.b.watch(I,h)),(0,C.toDisposable)(()=>{(0,C.dispose)(this.a.get(P)),this.a.delete(P)})}dispose(){super.dispose();for(const[,P]of this.a)P.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=v}),define(ee[206],te([0,1,13,160,4,7,16,9,205,139]),function(q,e,E,t,C,A,M,k,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class S extends w.AbstractDiskFileSystemProviderChannel{constructor(h,m,f){super(h,m),this.H=f}c(h){return v.DefaultURITransformer}f(h,m){return A.URI.revive(m)}async s(h,m,f){if(!f.useTrash)return super.s(h,m,f);const p=this.f(h,m),u=(0,k.normalize)(p.fsPath);try{await E.shell.trashItem(u)}catch{throw(0,M.createFileSystemProviderError)(C.isWindows?(0,t.localize)(0,null,(0,k.basename)(u)):(0,t.localize)(1,null,(0,k.basename)(u)),M.FileSystemProviderErrorCode.Unknown)}}G(h,m){return new P(h,m,this.b,this.H)}}e.DiskFileSystemProviderChannel=S;class P extends w.AbstractSessionFileWatcher{watch(h,m,f){if(f.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(h,m,f)}}}),define(ee[207],te([0,1,6]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(A,M){switch(M){case E.LogLevel.Trace:return A.trace;case E.LogLevel.Debug:return A.debug;case E.LogLevel.Info:return A.info;case E.LogLevel.Warning:return A.warn;case E.LogLevel.Error:return A.error;default:throw new Error("Invalid log level")}}class C extends E.AbstractLogger{constructor(M=E.DEFAULT_LOG_LEVEL){super(),this.f=[],this.g=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(k=>{this.g?.setLevel(k)}))}set logger(M){this.g=M;for(const{level:k,args:w}of this.f)t(M,k).apply(M,w);this.f=[]}h(M,...k){this.g?t(this.g,M).apply(this.g,k):this.getLevel()<=M&&this.f.push({level:M,args:k})}trace(M,...k){this.h(E.LogLevel.Trace,M,...k)}debug(M,...k){this.h(E.LogLevel.Debug,M,...k)}info(M,...k){this.h(E.LogLevel.Info,M,...k)}warn(M,...k){this.h(E.LogLevel.Warning,M,...k)}error(M,...k){this.h(E.LogLevel.Error,M,...k)}dispose(){this.g?.dispose()}flush(){this.g?.flush()}}e.BufferLogService=C}),define(ee[208],te([0,1,3,7,6]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class A{constructor(I,h){this.a=I,this.b=h,this.onDidChangeLogLevel=E.Event.buffer(I.onDidChangeLogLevel,!0)}listen(I,h){switch(h){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${h}`)}async call(I,h,m){switch(h){case"setLevel":return m[1]?this.b.setLevel(t.URI.revive(m[1]),m[0]):this.a.setLevel(m[0])}throw new Error(`Call not found: ${h}`)}}e.LogLevelChannel=A;class M{constructor(I){this.a=I}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(I,h){M.setLevel(this.a,I,h)}static setLevel(I,h,m){return I.call("setLevel",[h,m])}}e.LogLevelChannelClient=M;class k{constructor(I){this.b=I,this.a=new Map}listen(I,h){throw new Error(`Event not found: ${h}`)}async call(I,h,m){switch(h){case"createLogger":this.c(t.URI.revive(m[0]),m[1]);return;case"log":return this.e(t.URI.revive(m[0]),m[1]);case"consoleLog":return this.d(m[0],m[1])}throw new Error(`Call not found: ${h}`)}c(I,h){this.a.set(I.toString(),this.b.createLogger(I,h))}d(I,h){let m=console.log;switch(I){case C.LogLevel.Error:m=console.error;break;case C.LogLevel.Warning:m=console.warn;break;case C.LogLevel.Info:m=console.info;break}m.call(console,...h)}e(I,h){const m=this.a.get(I.toString());if(!m)throw new Error("Create the logger before logging");for(const[f,p]of h)(0,C.log)(m,f,p)}}e.LoggerChannel=k;class w extends C.AbstractLoggerService{constructor(I,h,m){super(I,h),this.g=m}createConsoleMainLogger(){return new C.AdapterLogger({log:(I,h)=>{this.g.call("consoleLog",[I,h])}})}f(I,h,m){return new v(this.g,I,h,m)}}e.LoggerChannelClient=w;class v extends C.AbstractMessageLogger{constructor(I,h,m,f){super(f?.always),this.l=I,this.m=h,this.j=!1,this.k=[],this.setLevel(m),this.l.call("createLogger",[h,f]).then(()=>{this.p(this.k),this.j=!0})}f(I,h){const m=[[I,h]];this.j?this.p(m):this.k.push(...m)}p(I){this.l.call("log",[this.m,I])}}class S extends C.LogService{constructor(I,h){super(h),this.c=I,this.B(I.onDidChangeLogLevel(m=>h.setLevel(m)))}setLevel(I){super.setLevel(I),this.c.setLevel(I)}}e.FollowerLogService=S}),define(ee[209],te([0,1,16,6]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var C;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(C||(C={}));async function A(v,S,P,I,h){try{const m=await new Promise((p,u)=>{q(["spdlog"],p,u)});m.setFlushOn(t.LogLevel.Trace);const f=await m.createAsyncRotatingLogger(v,S,P,I);return h?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(m){console.error(m)}return null}function M(v,S,P){switch(S){case t.LogLevel.Trace:v.trace(P);break;case t.LogLevel.Debug:v.debug(P);break;case t.LogLevel.Info:v.info(P);break;case t.LogLevel.Warning:v.warn(P);break;case t.LogLevel.Error:v.error(P);break;default:throw new Error("Invalid log level")}}function k(v,S){switch(S){case t.LogLevel.Trace:v.setLevel(C.Trace);break;case t.LogLevel.Debug:v.setLevel(C.Debug);break;case t.LogLevel.Info:v.setLevel(C.Info);break;case t.LogLevel.Warning:v.setLevel(C.Warning);break;case t.LogLevel.Error:v.setLevel(C.Error);break;case t.LogLevel.Off:v.setLevel(C.Off);break;default:throw new Error("Invalid log level")}}class w extends t.AbstractMessageLogger{constructor(S,P,I,h,m){super(),this.j=[],this.setLevel(m),this.k=this.m(S,P,I,h),this.B(this.onDidChangeLogLevel(f=>{this.l&&k(this.l,f)}))}async m(S,P,I,h){const m=I?6:1,f=30/m*E.ByteSize.MB,p=await A(S,P,f,m,h);if(p){this.l=p,k(this.l,this.getLevel());for(const{level:u,message:b}of this.j)M(this.l,u,b);this.j=[]}}f(S,P){this.l?M(this.l,S,P):this.getLevel()<=S&&this.j.push({level:S,message:P})}flush(){this.l?this.l.flush():this.k.then(()=>this.flush())}dispose(){this.l?this.p():this.k.then(()=>this.p())}p(){this.l&&(this.l.drop(),this.l=void 0)}}e.SpdLogLogger=w}),define(ee[210],te([0,1,29,6,209]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let A=class extends t.AbstractLoggerService{constructor(k){super(k.getLevel(),k.onDidChangeLogLevel)}f(k,w,v){return new C.SpdLogLogger(v?.name||(0,E.generateUuid)(),k.fsPath,!v?.donotRotate,!!v?.donotUseFormatters,w)}};A=pe([ie(0,t.ILogService)],A),e.LoggerService=A}),define(ee[211],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function t(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function C(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=C;function A(M){return!E(M)&&!t(M)&&!C(M)}e.isMenubarMenuItemAction=A}),define(ee[36],te([0,1,3,66,2,5]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class M extends C.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(v){const S=Object.keys(this.f).length;return this.f={...v,...this.f},S!==Object.keys(this.f).length&&await this.i(v),t.Iterable.reduce(this.g.entries(),(P,[I,h])=>({...P,[I]:h}),{})}getPolicyValue(v){return this.g.get(v)}serialize(){return t.Iterable.reduce(Object.entries(this.f),(v,[S,P])=>({...v,[S]:{definition:P,value:this.g.get(S)}}),{})}}e.AbstractPolicyService=M;class k{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=k}),define(ee[212],te([0,1,8,3,66,12,16,6,36]),function(q,e,E,t,C,A,M,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function v(P,I){const h=[];for(const m of C.Iterable.concat(P.keys(),I.keys()))P.get(m)!==I.get(m)&&h.push(m);return h}let S=class extends w.AbstractPolicyService{constructor(I,h,m){super(),this.j=I,this.k=h,this.l=m,this.c=this.B(new E.ThrottledDelayer(500));const f=t.Event.filter(h.onDidFilesChange,p=>p.affects(I));this.B(h.watch(I)),this.B(f(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const I=new Map;try{const h=await this.k.readFile(this.j),m=JSON.parse(h.value.toString());if(!(0,A.isObject)(m))throw new Error("Policy file isn't a JSON object");for(const f of Object.keys(m))this.f[f]&&I.set(f,m[f])}catch(h){h.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",h)}return I}async p(){const I=await this.n(),h=v(this.g,I);this.g=I,h.length>0&&this.h.fire(h)}};S=pe([ie(1,M.IFileService),ie(2,k.ILogService)],S),e.FilePolicyService=S}),define(ee[213],te([0,1,3,2,36]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(w){this.b=w,this.a=new t.DisposableStore}listen(w,v){switch(v){case"onDidChange":return E.Event.map(this.b.onDidChange,S=>S.reduce((P,I)=>({...P,[I]:this.b.getPolicyValue(I)??null}),{}),this.a)}throw new Error(`Event not found: ${v}`)}call(w,v,S){switch(v){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(S)}throw new Error(`Call not found: ${v}`)}dispose(){this.a.dispose()}}e.PolicyChannel=A;class M extends C.AbstractPolicyService{constructor(w,v){super(),this.a=v;for(const S in w){const{definition:P,value:I}=w[S];this.f[S]=P,I!==void 0&&this.g.set(S,I)}this.a.listen("onDidChange")(S=>{for(const P in S){const I=S[P];I===null?this.g.delete(P):this.g.set(P,I)}this.h.fire(Object.keys(S))})}async i(w){const v=await this.a.call("updatePolicyDefinitions",w);for(const S in v)this.g.set(S,v[S])}}e.PolicyChannelClient=M}),define(ee[54],te([0,1,14,4,32,19]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const k=t.globals.vscode.context.configuration();if(k)M=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof q?.__$__nodeRequire=="function"){const k=(0,A.dirname)(E.FileAccess.asFileUri(""));if(M=q.__$__nodeRequire((0,A.joinPath)(k,"product.json").fsPath),C.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),!M.version){const w=q.__$__nodeRequire((0,A.joinPath)(k,"package.json").fsPath);Object.assign(M,{version:w.version})}}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=M}),define(ee[20],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[214],te([0,1,77,6,20]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let A=class{constructor(k,w){this.b=k,this.c=w,this.a=new Map}async isExtensionUrlTrusted(k,w){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const v=/^(.*)#([^#]+)$/.exec(w);if(!v)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,S,P]=v;let I=this.a.get(k);if(!I){if(I=this.b.trustedExtensionUrlPublicKeys[k],!I||I.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",k),!1;this.a.set(k,[...I])}const h=Buffer.from(decodeURIComponent(P),"base64");if(h.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const m=h.slice(0,6),f=h.readUIntBE(0,6),p=Date.now()-f;if(p<0||p>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const u=h.slice(6),b=E.createVerify("SHA256");b.write(m),b.write(Buffer.from(S)),b.end();for(let g=0;g<I.length;g++){let d=I[g];if(d!==null){if(typeof d=="string")try{d=E.createPublicKey({key:Buffer.from(d,"base64"),format:"der",type:"spki"}),I[g]=d}catch(l){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${g+1} for ${k}:`,l),I[g]=null;continue}if(b.verify(d,u))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};A=pe([ie(0,C.IProductService),ie(1,t.ILogService)],A),e.ExtensionUrlTrustService=A}),define(ee[215],te([0,1,8,6]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let C=class{constructor(M,k,w){this.a=M,this.b=k,this.c=w}async inspect(M){await this.d();const k=this.a.webContents.debugger;await k.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,E.timeout)(M);const w=await k.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),w.profile}async d(){const M=this.a.webContents.debugger;M.attach(),await M.sendCommand("Profiler.enable")}async e(){const M=this.a.webContents.debugger;await M.sendCommand("Profiler.disable"),M.detach()}};C=pe([ie(2,t.ILogService)],C),e.WindowProfiler=C}),define(ee[61],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(ee[46],te([0,1,121,12]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.a=new Map}add(M,k){E.ok(t.isString(M)),E.ok(t.isObject(k)),E.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,k)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.Registry=new C}),define(ee[216],te([0,1,3,46]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,v){this.a[C(w)]=v,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const M=new A;t.Registry.add(e.Extensions.JSONContribution,M)}),define(ee[62],te([0,1,24,3,12,148,18,216,46]),function(q,e,E,t,C,A,M,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var v;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(v=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=w.Registry.as(k.Extensions.JSONContribution);class I{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const i=this.k(n,s);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(n){const s=this.l(n);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:n,remove:s}){const i=[];i.push(...this.l(s)),i.push(...this.k(n,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,E.distinct)(i)})}registerDefaultConfigurations(n){const s=[],i=[];for(const{overrides:a,source:r}of n)for(const c in a)if(s.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const o=this.a.get(c),y=o?.valuesSources??new Map;if(r)for(const Y of Object.keys(a[c]))y.set(Y,r);const D={...o?.value||{},...a[c]};this.a.set(c,{source:r,value:D,valuesSources:y});const O=(0,M.getLanguageTagSettingPlainKey)(c),N={type:"object",default:D,description:A.localize(1,null,O),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:C.isString(r)?void 0:r,defaultValueSource:r};i.push(...f(c)),this.d[c]=N,this.b.properties[c]=N}else{this.a.set(c,{value:a[c],source:r});const o=this.d[c];o&&(this.s(c,o),this.o(c,o))}this.registerOverrideIdentifiers(i),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const s=[];for(const{overrides:i,source:a}of n)for(const r in i){const c=this.a.get(r),o=C.isString(a)?a:a?.id,y=C.isString(c?.source)?c?.source:c?.source?.id;if(o===y)if(s.push(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const D=this.d[r];D&&(this.s(r,D),this.o(r,D))}}this.q(),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){for(const s of n)this.h.add(s);this.q()}k(n,s){const i=[];return n.forEach(a=>{i.push(...this.m(a,s,a.extensionInfo,a.restrictedProperties)),this.c.push(a),this.n(a)}),i}l(n){const s=[],i=a=>{if(a.properties)for(const r in a.properties){s.push(r);const c=this.d[r];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[r],this.p(r,a.properties[r])}a.allOf?.forEach(r=>i(r))};for(const a of n){i(a);const r=this.c.indexOf(a);r!==-1&&this.c.splice(r,1)}return s}m(n,s=!0,i,a,r=3){r=C.isUndefinedOrNull(n.scope)?r:n.scope;const c=[],o=n.properties;if(o)for(const D in o){const O=o[D];if(s&&g(D,O)){delete o[D];continue}if(O.source=i,O.defaultDefaultValue=o[D].default,this.s(D,O),e.OVERRIDE_PROPERTY_REGEX.test(D)?O.scope=void 0:(O.scope=C.isUndefinedOrNull(O.scope)?r:O.scope,O.restricted=C.isUndefinedOrNull(O.restricted)?!!a?.includes(D):O.restricted),o[D].hasOwnProperty("included")&&!o[D].included){this.f[D]=o[D],delete o[D];continue}else this.d[D]=o[D],o[D].policy?.name&&this.e.set(o[D].policy.name,D);!o[D].deprecationMessage&&o[D].markdownDeprecationMessage&&(o[D].deprecationMessage=o[D].markdownDeprecationMessage),c.push(D)}const y=n.allOf;if(y)for(const D of y)c.push(...this.m(D,s,i,a,r));return c}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(n){const s=i=>{const a=i.properties;if(a)for(const c in a)this.o(c,a[c]);i.allOf?.forEach(s)};s(n)}o(n,s){switch(e.allSettings.properties[n]=s,s.scope){case 1:e.applicationSettings.properties[n]=s;break;case 2:e.machineSettings.properties[n]=s;break;case 6:e.machineOverridableSettings.properties[n]=s;break;case 3:e.windowSettings.properties[n]=s;break;case 4:e.resourceSettings.properties[n]=s;break;case 5:e.resourceSettings.properties[n]=s,this.g.properties[n]=s;break}}p(n,s){switch(delete e.allSettings.properties[n],s.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}q(){for(const n of this.h.values()){const s=`[${n}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(s,i),e.allSettings.properties[s]=i,e.applicationSettings.properties[s]=i,e.machineSettings.properties[s]=i,e.machineOverridableSettings.properties[s]=i,e.windowSettings.properties[s]=i,e.resourceSettings.properties[s]=i}this.i.fire()}r(){const n={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}s(n,s){const i=this.a.get(n);let a=i?.value,r=i?.source;C.isUndefined(a)&&(a=s.defaultDefaultValue,r=void 0),C.isUndefined(a)&&(a=u(s.type)),s.default=a,s.defaultValueSource=r}}const h="\\[([^\\]]+)\\]",m=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(l){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let s=m.exec(l);for(;s?.length;){const i=s[1].trim();i&&n.push(i),s=m.exec(l)}}return(0,E.distinct)(n)}e.overrideIdentifiersFromKey=f;function p(l){return l.reduce((n,s)=>`${n}[${s}]`,"")}e.keyFromOverrideIdentifiers=p;function u(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const b=new I;w.Registry.add(e.Extensions.Configuration,b);function g(l,n){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?A.localize(7,null,l):b.getConfigurationProperties()[l]!==void 0?A.localize(8,null,l):n.policy?.name&&b.getPolicyConfigurations().get(n.policy?.name)!==void 0?A.localize(9,null,l,n.policy?.name,b.getPolicyConfigurations().get(n.policy?.name)):null:A.localize(6,null)}e.validateProperty=g;function d(){const l=[],n=b.getConfigurationProperties();for(const s of Object.keys(n))l.push([s,n[s].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=d}),define(ee[108],te([0,1,24,3,42,2,38,50,12,7,18,62,46]),function(q,e,E,t,C,A,M,k,w,v,S,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class h{constructor(s={},i=[],a=[],r){this.c=s,this.d=i,this.f=a,this.raw=r,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof h)return i;const a=new m("");return a.parseRaw(i),a.configurationModel});this.g=s.reduce((i,a)=>a===i?a:i.merge(a),s[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(s){return s?(0,S.getConfigurationValue)(this.contents,s):this.contents}inspect(s,i){const a=this.rawConfiguration.getValue(s),r=i?this.rawConfiguration.getOverrideValue(s,i):void 0,c=i?this.rawConfiguration.override(i).getValue(s):a;return{value:a,override:r,merged:c}}getOverrideValue(s,i){const a=this.l(i);return a?s?(0,S.getConfigurationValue)(a,s):a:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const a of this.overrides)a.identifiers.includes(s)&&i.push(...a.keys);return E.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return E.distinct(s)}override(s){let i=this.b.get(s);return i||(i=this.h(s),this.b.set(s,i)),i}merge(...s){const i=k.deepClone(this.contents),a=k.deepClone(this.overrides),r=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const o of s)if(c.push(...o.raw?.length?o.raw:[o]),!o.isEmpty()){this.j(i,o.contents);for(const y of o.overrides){const[D]=a.filter(O=>E.equals(O.identifiers,y.identifiers));D?(this.j(D.contents,y.contents),D.keys.push(...y.keys),D.keys=E.distinct(D.keys)):a.push(k.deepClone(y))}for(const y of o.keys)r.indexOf(y)===-1&&r.push(y)}return new h(i,r,a,c.every(o=>o instanceof h)?void 0:c)}freeze(){return this.a=!0,this}clone(){return new h(k.deepClone(this.contents),[...this.keys],k.deepClone(this.overrides))}h(s){const i=this.l(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const a={};for(const r of E.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[r];const o=i[r];o&&(typeof c=="object"&&typeof o=="object"?(c=k.deepClone(c),this.j(c,o)):c=o),a[r]=c}return new h(a,this.keys,this.overrides)}j(s,i){for(const a of Object.keys(i)){if(a in s&&w.isObject(s[a])&&w.isObject(i[a])){this.j(s[a],i[a]);continue}s[a]=k.deepClone(i[a])}}k(s){return this.a&&!Object.isFrozen(s)?k.deepFreeze(s):s}l(s){let i=null,a=null;const r=c=>{c&&(a?this.j(a,c):a=k.deepClone(c))};for(const c of this.overrides)E.equals(c.identifiers,[s])?i=c.contents:c.identifiers.includes(s)&&r(c.contents);return r(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,i){this.m(s),(0,S.addToValueTree)(this.contents,s,i,a=>{throw new Error(a)})}removeValue(s){this.n(s)&&(0,S.removeFromValueTree)(this.contents,s)}m(s){let i=this.keys.length;for(let a=0;a<i;a++)s.indexOf(this.keys[a])===0&&(i=a);this.keys.splice(i,1,s)}n(s){const i=this.keys.indexOf(s);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=h;class m{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new h}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,i){if(!w.isUndefinedOrNull(s)){const a=this.g(s);this.parseRaw(a,i)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,i){this.a=s;const{contents:a,keys:r,overrides:c,restricted:o,hasExcludedProperties:y}=this.h(s,i);this.b=new h(a,r,c,y?[s]:void 0),this.c=o||[]}g(s){let i={},a=null,r=[];const c=[],o=[];function y(O){Array.isArray(r)?r.push(O):a!==null&&(r[a]=O)}const D={onObjectBegin:()=>{const O={};y(O),c.push(r),r=O,a=null},onObjectProperty:O=>{a=O},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const O=[];y(O),c.push(r),r=O,a=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:y,onError:(O,N,Y)=>{o.push({error:O,offset:N,length:Y})}};if(s)try{C.visit(s,D),i=r[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return i}h(s,i){const a=I.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),r=this.j(s,a,!0,i);s=r.raw;const c=(0,S.toValuesTree)(s,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),o=Object.keys(s),y=this.l(s,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:c,keys:o,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}j(s,i,a,r){let c=!1;if(!r?.scopes&&!r?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:c};const o={},y=[];for(const D in s)if(P.OVERRIDE_PROPERTY_REGEX.test(D)&&a){const O=this.j(s[D],i,!1,r);o[D]=O.raw,c=c||O.hasExcludedProperties,y.push(...O.restricted)}else{const O=i[D],N=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&y.push(D),(N===void 0||r.scopes===void 0||r.scopes.includes(N))&&!(r.skipRestricted&&O?.restricted)?o[D]=s[D]:c=!0}return{raw:o,restricted:y,hasExcludedProperties:c}}l(s,i){const a=[];for(const r of Object.keys(s))if(P.OVERRIDE_PROPERTY_REGEX.test(r)){const c={};for(const o in s[r])c[o]=s[r][o];a.push({identifiers:(0,P.overrideIdentifiersFromKey)(r),keys:Object.keys(c),contents:(0,S.toValuesTree)(c,i)})}return a}}e.ConfigurationModelParser=m;class f extends A.Disposable{constructor(s,i,a,r){super(),this.f=s,this.g=i,this.h=r,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new m(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(a.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&a.isEqual(c.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new h}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=f;class p{constructor(s,i,a,r,c,o,y,D,O,N,Y,G,V){this.a=s,this.b=i,this.value=a,this.overrideIdentifiers=r,this.c=c,this.d=o,this.f=y,this.g=D,this.h=O,this.j=N,this.k=Y,this.l=G,this.m=V}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get A(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class u{constructor(s,i,a,r,c=new h,o=new h,y=new M.ResourceMap,D=new h,O=new M.ResourceMap,N=!0){this.c=s,this.d=i,this.f=a,this.g=r,this.h=c,this.j=o,this.l=y,this.m=D,this.n=O,this.p=N,this.a=null,this.b=new M.ResourceMap,this.q=null}getValue(s,i,a){return this.s(s,i,a).getValue(s)}updateValue(s,i,a={}){let r;a.resource?(r=this.n.get(a.resource),r||(r=new h,this.n.set(a.resource,r))):r=this.m,i===void 0?r.removeValue(s):r.setValue(s,i),a.resource||(this.a=null)}inspect(s,i,a){const r=this.s(s,i,a),c=E.distinct(r.overrides.map(D=>D.identifiers).flat()).filter(D=>r.getOverrideValue(s,D)!==void 0),o=this.w(i.resource,a),y=i.resource?this.n.get(i.resource)||this.m:this.m;return new p(s,i,r.getValue(s),c.length?c:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),a?this.j.freeze():void 0,o?o.freeze():void 0,y.inspect(s,i.overrideIdentifier))}keys(s){const i=this.w(void 0,s);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.j=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,i){this.l.set(s,i),this.b.delete(s)}deleteFolderConfiguration(s){this.r.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const a=[];if(!i){const{added:r,updated:c,removed:o}=d(this.c,s);i=[...r,...c,...o]}for(const r of i)for(const c of(0,P.overrideIdentifiersFromKey)(r)){const o=this.c.getKeysForOverrideIdentifier(c),y=s.getKeysForOverrideIdentifier(c),D=[...y.filter(O=>o.indexOf(O)===-1),...o.filter(O=>y.indexOf(O)===-1),...o.filter(O=>!k.equals(this.c.override(c).getValue(O),s.override(c).getValue(O)))];a.push([c,D])}return this.updateDefaultConfiguration(s),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:a,removed:r}=d(this.d,s),c=[...i,...a,...r];return c.length&&this.updatePolicyConfiguration(s),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:a,removed:r,overrides:c}=d(this.applicationConfiguration,s),o=[...i,...a,...r];return o.length&&this.updateApplicationConfiguration(s),{keys:o,overrides:c}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:a,removed:r,overrides:c}=d(this.localUserConfiguration,s),o=[...i,...a,...r];return o.length&&this.updateLocalUserConfiguration(s),{keys:o,overrides:c}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:a,removed:r,overrides:c}=d(this.remoteUserConfiguration,s),o=[...i,...a,...r];return o.length&&this.updateRemoteUserConfiguration(s),{keys:o,overrides:c}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:a,removed:r,overrides:c}=d(this.workspaceConfiguration,s),o=[...i,...a,...r];return o.length&&this.updateWorkspaceConfiguration(s),{keys:o,overrides:c}}compareAndUpdateFolderConfiguration(s,i){const a=this.r.get(s),{added:r,updated:c,removed:o,overrides:y}=d(a,i),D=[...r,...c,...o];return(D.length||!a)&&this.updateFolderConfiguration(s,i),{keys:D,overrides:y}}compareAndDeleteFolderConfiguration(s){const i=this.r.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:a,updated:r,removed:c,overrides:o}=d(i,void 0);return{keys:[...a,...r,...c],overrides:o}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(s,i,a){let r=this.t(i,a);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(r=r.merge(this.d)),r}t({resource:s},i){let a=this.u();if(i&&s){const r=i.getFolder(s);r&&(a=this.v(r.uri)||a);const c=this.n.get(s);c&&(a=a.merge(c))}return a}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(s){let i=this.b.get(s);if(!i){const a=this.u(),r=this.l.get(s);r?(i=a.merge(r),this.p&&(i=i.freeze()),this.b.set(s,i)):i=a}return i}w(s,i){if(i&&s){const a=i.getFolder(s);if(a)return this.l.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((s,i)=>{const{contents:a,overrides:r,keys:c}=this.l.get(i);return s.push([i,{contents:a,overrides:r,keys:c}]),s},[])}}allKeys(){const s=new Set;return this.c.freeze().keys.forEach(i=>s.add(i)),this.userConfiguration.freeze().keys.forEach(i=>s.add(i)),this.j.freeze().keys.forEach(i=>s.add(i)),this.l.forEach(i=>i.freeze().keys.forEach(a=>s.add(a))),[...s.values()]}x(){const s=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.j.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.l.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a))),[...s.values()]}y(s){const i=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a)),this.j.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a)),this.l.forEach(a=>a.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r))),[...i.values()]}static parse(s){const i=this.A(s.defaults),a=this.A(s.policy),r=this.A(s.application),c=this.A(s.user),o=this.A(s.workspace),y=s.folders.reduce((D,O)=>(D.set(v.URI.revive(O[0]),this.A(O[1])),D),new M.ResourceMap);return new u(i,a,r,c,new h,o,y,new h,new M.ResourceMap,!1)}static A(s){return new h(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=u;function b(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const s=new Set,i=new Map;for(const r of n)r.keys.forEach(c=>s.add(c)),r.overrides.forEach(([c,o])=>{const y=(0,M.getOrSet)(i,c,new Set);o.forEach(D=>y.add(D))});const a=[];return i.forEach((r,c)=>a.push([c,[...r.values()]])),{keys:[...s.values()],overrides:a}}e.mergeChanges=b;class g{constructor(s,i,a,r){this.change=s,this.b=i,this.c=a,this.d=r,this.f=void 0;const c=new Set;s.keys.forEach(y=>c.add(y)),s.overrides.forEach(([,y])=>y.forEach(D=>c.add(D))),this.affectedKeys=[...c.values()];const o=new h;this.affectedKeys.forEach(y=>o.setValue(y,{})),this.a=o.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=u.parse(this.b.data)),this.f}affectsConfiguration(s,i){if(this.g(this.a,s)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.b?.workspace):void 0,r=this.c.getValue(s,i,this.d);return!k.equals(a,r)}return!0}return!1}g(s,i){let a=(0,S.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof a=="object"&&(r=Object.keys(a)[0]);){if(s=s[r],!s)return!1;a=a[r]}return!0}}e.ConfigurationChangeEvent=g;function d(n,s){const{added:i,removed:a,updated:r}=l(s?.rawConfiguration,n?.rawConfiguration),c=[],o=n?.getAllOverrideIdentifiers()||[],y=s?.getAllOverrideIdentifiers()||[];if(s){const D=y.filter(O=>!o.includes(O));for(const O of D)c.push([O,s.getKeysForOverrideIdentifier(O)])}if(n){const D=o.filter(O=>!y.includes(O));for(const O of D)c.push([O,n.getKeysForOverrideIdentifier(O)])}if(s&&n){for(const D of o)if(y.includes(D)){const O=l({contents:n.getOverrideValue(void 0,D)||{},keys:n.getKeysForOverrideIdentifier(D)},{contents:s.getOverrideValue(void 0,D)||{},keys:s.getKeysForOverrideIdentifier(D)});c.push([D,[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:a,updated:r,overrides:c}}function l(n,s){const i=n?s?n.keys.filter(c=>s.keys.indexOf(c)===-1):[...n.keys]:[],a=s?n?s.keys.filter(c=>n.keys.indexOf(c)===-1):[...s.keys]:[],r=[];if(n&&s){for(const c of s.keys)if(n.keys.indexOf(c)!==-1){const o=(0,S.getConfigurationValue)(s.contents,c),y=(0,S.getConfigurationValue)(n.contents,c);k.equals(o,y)||r.push(c)}}return{added:i,removed:a,updated:r}}}),define(ee[217],te([0,1,24,3,2,50,12,18,108,62,6,36,46]),function(q,e,E,t,C,A,M,k,w,v,S,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class h extends C.Disposable{constructor(){super(...arguments),this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new m(this.f())),this.b}async initialize(){return this.b=void 0,this.B(I.Registry.as(v.Extensions.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:g})=>this.c(b,g))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(b,g){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:b})}f(){return{}}}e.DefaultConfiguration=h;class m extends w.ConfigurationModel{constructor(b={}){const g=I.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),d=Object.keys(g),l=Object.create(null),n=[];for(const s in g){const i=b[s],a=i!==void 0?i:g[s].default;(0,k.addToValueTree)(l,s,a,r=>console.error(`Conflict in default settings: ${r}`))}for(const s of Object.keys(l))v.OVERRIDE_PROPERTY_REGEX.test(s)&&n.push({identifiers:(0,v.overrideIdentifiersFromKey)(s),keys:Object.keys(l[s]),contents:(0,k.toValuesTree)(l[s],i=>console.error(`Conflict in default settings file: ${i}`))});super(l,d,n)}}e.DefaultConfigurationModel=m;class f{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new w.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let p=class extends C.Disposable{get configurationModel(){return this.b}constructor(b,g,d){super(),this.c=b,this.f=g,this.g=d,this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new w.ConfigurationModel}async initialize(){return this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.i(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.j(await this.h(b),!0))),this.b}async h(b){const g={},d=[],l=I.Registry.as(v.Extensions.Configuration).getConfigurationProperties();for(const n of b){const s=l[n];if(!s){d.push(n);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.g.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}d.push(n),g[s.policy.name]={type:s.type}}}return(0,M.isEmptyObject)(g)||await this.f.updatePolicyDefinitions(g),d}i(b){const g=I.Registry.as(v.Extensions.Configuration).getPolicyConfigurations(),d=(0,E.coalesce)(b.map(l=>g.get(l)));this.j(d,!0)}j(b,g){const d=I.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),l=[],n=this.b.isEmpty();for(const s of b){const i=d[s]?.policy?.name;if(i){const a=this.f.getPolicyValue(i);(n?a!==void 0:!(0,A.equals)(this.b.getValue(s),a))&&l.push([s,a])}else this.b.getValue(s)!==void 0&&l.push([s,void 0])}if(l.length){const s=this.b;this.b=new w.ConfigurationModel;for(const i of s.keys)this.b.setValue(i,s.getValue(i));for(const[i,a]of l)a===void 0?this.b.removeValue(i):this.b.setValue(i,a);g&&this.a.fire(this.b)}}};p=pe([ie(1,P.IPolicyService),ie(2,S.ILogService)],p),e.PolicyConfiguration=p}),define(ee[218],te([0,1,8,3,2,19,18,108,217,36]),function(q,e,E,t,C,A,M,k,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class S extends C.Disposable{constructor(I,h,m,f){super(),this.i=I,this.h=this.B(new t.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.DefaultConfiguration),this.c=m instanceof v.NullPolicyService?new w.NullPolicyConfiguration:this.B(new w.PolicyConfiguration(this.b,m,f)),this.f=this.B(new k.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,h)),this.a=new k.Configuration(this.b.configurationModel,this.c.configurationModel,new k.ConfigurationModel,new k.ConfigurationModel),this.g=this.B(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:p,properties:u})=>this.k(p,u))),this.B(this.c.onDidChangeConfiguration(p=>this.l(p))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[I,h,m]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new k.Configuration(I,h,new k.ConfigurationModel,m)}getConfigurationData(){return this.a.toData()}getValue(I,h){const m=typeof I=="string"?I:void 0,f=(0,M.isConfigurationOverrides)(I)?I:(0,M.isConfigurationOverrides)(h)?h:{};return this.a.getValue(m,f,void 0)}updateValue(I,h,m,f){return Promise.reject(new Error("not supported"))}inspect(I){return this.a.inspect(I,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const I=await this.f.loadConfiguration();this.j(I)}j(I){const h=this.a.toData(),m=this.a.compareAndUpdateLocalUserConfiguration(I);this.m(m,h,2)}k(I,h){const m=this.a.toData(),f=this.a.compareAndUpdateDefaultConfiguration(I,h);this.m(f,m,7)}l(I){const h=this.a.toData(),m=this.a.compareAndUpdatePolicyConfiguration(I);this.m(m,h,7)}m(I,h,m){const f=new k.ConfigurationChangeEvent(I,{data:h},this.a);f.source=m,f.sourceConfig=this.n(m),this.h.fire(f)}n(I){switch(I){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=S}),define(ee[219],te([0,1,15,5]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var C;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends E.ErrorNoTelemetry{static isNotAvailable(k){return k instanceof A&&k._code===C.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof A&&k._code===C.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof A&&k._code===C.NoResolverFound}static isHandled(k){return k instanceof A&&k.isHandled}constructor(k,w=C.Unknown,v){super(k),this._message=k,this._code=w,this._detail=v,this.isHandled=w===C.NotAvailable&&v===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A}),define(ee[63],te([0,1,14]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(v){return v.scheme===E.Schemas.vscodeRemote?v.authority:void 0}e.getRemoteAuthority=t;function C(v){if(!v)return;const S=v.indexOf("+");return S<0?v:v.substr(0,S)}e.getRemoteName=C;function A(v){return`/${v.quality??"oss"}-${v.commit??"dev"}`}e.getRemoteServerRootPath=A;function M(v){const{host:S,port:P}=w(v);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:S,port:P}}e.parseAuthorityWithPort=M;function k(v,S){let{host:P,port:I}=w(v);return typeof I>"u"&&(I=S),{host:P,port:I}}e.parseAuthorityWithOptionalPort=k;function w(v){const S=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const P=v.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const I=v.match(/(.*):(\d+)$/);return I?{host:I[1],port:parseInt(I[2],10)}:{host:v,port:void 0}}}),define(ee[109],te([0,1,25,5,63]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=A;function M(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));var w;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class v{constructor(f){this.value=f,this.c=f.toLowerCase()}static equals(f,p){if(typeof f>"u"||f===null)return typeof p>"u"||p===null;if(typeof p>"u"||p===null)return!1;if(typeof f=="string"||typeof p=="string"){const u=typeof f=="string"?f:f.value,b=typeof p=="string"?p:p.value;return E.equalsIgnoreCase(u,b)}return f.c===p.c}static toKey(f){return typeof f=="string"?f.toLowerCase():f.c}}e.ExtensionIdentifier=v;function S(m){return P(m)}e.isApplicationScopedExtension=S;function P(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function I(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function h(m,f){if(f){const p=`onResolveRemoteAuthority:${(0,C.getRemoteName)(f)}`;return m.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=h,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[110],te([0,1,25,191,109,4,7,15,32]),function(q,e,E,t,C,A,M,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function v(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,E.compareIgnoreCase)(s.id,i.id)===0}e.areSameExtensions=v;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class P{static create(i){const a=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new P(i.identifier,a,r)}static parse(i){const a=S.exec(i);return a&&a[1]&&a[2]?new P({id:a[1]},a[2],a[4]||void 0):null}constructor(i,a,r="undefined"){this.version=a,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof P?v(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=P;const I=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(s){const i=I.exec(s);return i&&i[1]?[f(i[1]),i[2]]:[f(s),void 0]}e.getIdAndVersion=h;function m(s,i){return`${s}.${i}`}e.getExtensionId=m;function f(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=f;function p(s,i){return f(m(s,i))}e.getGalleryExtensionId=p;function u(s,i){const a=[],r=c=>{for(const o of a)if(o.some(y=>v(i(y),i(c))))return o;return null};for(const c of s){const o=r(c);o?o.push(c):a.push([c])}return a}e.groupByExtension=u;function b(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function g(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function d(s,i){const a=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const c=r.shift();if(c&&a.every(o=>!v(o.identifier,{id:c}))){const o=s.filter(y=>v(y.identifier,{id:c}));o.length===1&&(a.push(o[0]),r.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=d;async function l(s,i){if(!A.isLinux)return!1;let a;try{a=(await s.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await s.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(c))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=l;async function n(s,i){const a=await l(s,i),r=(0,t.getTargetPlatform)(a?"alpine":A.platform,w.arch);return i.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=n}),define(ee[87],te([0,1,8,17,2,3,38,7,110,16,5,6]),function(q,e,E,t,C,A,M,k,w,v,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,S.createDecorator)("IExtensionsProfileScannerService");let I=class extends C.Disposable{constructor(m,f){super(),this.h=m,this.i=f,this.a=this.B(new A.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new A.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new A.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new A.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new M.ResourceMap}scanProfileExtensions(m){return this.j(m)}async addExtensionsToProfile(m,f){const p=[],u=[];try{return await this.j(f,b=>{const g=[];for(const d of b)m.some(([l])=>(0,w.areSameExtensions)(l.identifier,d.identifier)&&l.manifest.version!==d.version)?p.push(d):g.push(d);for(const[d,l]of m)if(!g.some(n=>(0,w.areSameExtensions)(n.identifier,d.identifier)&&n.version===d.manifest.version)){const n={identifier:d.identifier,version:d.manifest.version,location:d.location,metadata:l};u.push(n),g.push(n)}return u.length&&this.a.fire({extensions:u,profileLocation:f}),p.length&&this.c.fire({extensions:p,profileLocation:f}),g}),u.length&&this.b.fire({extensions:u,profileLocation:f}),p.length&&this.f.fire({extensions:p,profileLocation:f}),u}catch(b){throw u.length&&this.b.fire({extensions:u,error:b,profileLocation:f}),p.length&&this.f.fire({extensions:p,error:b,profileLocation:f}),b}}async removeExtensionFromProfile(m,f){const p=[];this.c.fire({extensions:p,profileLocation:f});try{await this.j(f,u=>{const b=[];for(const g of u)(0,w.areSameExtensions)(g.identifier,m.identifier)?p.push(g):b.push(g);return p.length&&this.c.fire({extensions:p,profileLocation:f}),b}),p.length&&this.f.fire({extensions:p,profileLocation:f})}catch(u){throw p.length&&this.f.fire({extensions:p,error:u,profileLocation:f}),u}}async j(m,f){return this.k(m).queue(async()=>{let p=[];try{const u=await this.h.readFile(m),b=JSON.parse(u.value.toString());for(const g of b){if(!g.identifier){this.i.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.i.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.i.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}p.push({identifier:g.identifier,location:k.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(u){u.fileOperationResult!==1&&this.i.error(u)}if(f){p=f(p);const u=p.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),metadata:b.metadata}));await this.h.writeFile(m,t.VSBuffer.fromString(JSON.stringify(u)))}return p})}k(m){let f=this.g.get(m);return f||(f=new E.Queue,this.g.set(m,f)),f}};I=pe([ie(0,v.IFileService),ie(1,P.ILogService)],I),e.ExtensionsProfileScannerService=I}),define(ee[220],te([0,1,8,17,22,15,3,2,29,101,219,63]),function(q,e,E,t,C,A,M,k,w,v,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var h;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(h=e.ConnectionType||(e.ConnectionType={}));function m(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function f(B){const H=new C.CancellationTokenSource;return setTimeout(()=>H.cancel(),B),H.token}function p(B,H){if(B.isCancellationRequested||H.isCancellationRequested)return C.CancellationToken.Cancelled;const R=new C.CancellationTokenSource;return B.onCancellationRequested(()=>R.cancel()),H.onCancellationRequested(()=>R.cancel()),R.token}class u{get didTimeout(){return this.c==="timedout"}constructor(H){this.c="pending",this.d=new k.DisposableStore,this.promise=new Promise((R,F)=>{this.f=R,this.g=F}),H.isCancellationRequested?this.h():this.d.add(H.onCancellationRequested(()=>this.h()))}registerDisposable(H){this.c==="pending"?this.d.add(H):H.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const H=new Error("Time limit reached");return H.code="ETIMEDOUT",H.syscall="connect",H}resolve(H){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(H))}reject(H){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(H))}}function b(B,H){const R=new u(H);return R.registerDisposable(B.onControlMessage(F=>{const $=JSON.parse(F.toString()),z=W($);z?R.reject(z):R.resolve($)})),R.promise}function g(B,H,R,F,$,z,J,ne){const j=new u(ne);return H.connect(R,F,$,z,J,(x,_)=>{j.didTimeout?(x&&B.error(x),_?.dispose()):x||!_?j.reject(x):j.resolve(_)}),j.promise}function d(B,H){const R=new u(H);return B.then(F=>{R.didTimeout||R.resolve(F)},F=>{R.didTimeout||R.reject(F)}),R.promise}async function l(B,H,R,F){const $=U(B,H);B.logService.trace(`${$} 1/6. invoking socketFactory.connect().`);let z;try{z=await g(B.logService,B.socketFactory,B.host,B.port,(0,P.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${m(H)}-${B.reconnectionToken}`,F)}catch(_){throw B.logService.error(`${$} socketFactory.connect() failed or timed out. Error:`),B.logService.error(_),_}B.logService.trace(`${$} 2/6. socketFactory.connect() was successful.`);let J,ne;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(z,null),J=B.reconnectionProtocol,ne=!1):(J=new v.PersistentProtocol(z,null),ne=!0),B.logService.trace(`${$} 3/6. sending AuthRequest control message.`);const j=await d(B.signService.createNewMessage((0,w.generateUuid)()),F),x={type:"auth",auth:B.connectionToken||"00000000000000000000",data:j.data};J.sendControl(t.VSBuffer.fromString(JSON.stringify(x)));try{const _=await b(J,p(F,f(1e4)));if(_.type!=="sign"||typeof _.data!="string"){const Oe=new Error("Unexpected handshake message");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}if(B.logService.trace(`${$} 4/6. received SignRequest control message.`),!await d(B.signService.validate(j,_.signedData),F)){const Oe=new Error("Refused to connect to unsupported server");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}const ge=await d(B.signService.sign(_.data),F),Me={type:"connectionType",commit:B.commit,signedData:ge,desiredConnectionType:H};return R&&(Me.args=R),B.logService.trace(`${$} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(t.VSBuffer.fromString(JSON.stringify(Me))),{protocol:J,ownsProtocol:ne}}catch(_){throw _&&_.code==="ETIMEDOUT"&&(B.logService.error(`${$} the handshake timed out. Error:`),B.logService.error(_)),_&&_.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${$} received error control message when negotiating connection. Error:`),B.logService.error(_)),ne&&le(J),_}}async function n(B,H,R,F){const $=Date.now(),z=U(B,H),{protocol:J,ownsProtocol:ne}=await l(B,H,R,F),j=new u(F);return j.registerDisposable(J.onControlMessage(x=>{const _=JSON.parse(x.toString()),ae=W(_);ae?(B.logService.error(`${z} received error control message when negotiating connection. Error:`),B.logService.error(ae),ne&&le(J),j.reject(ae)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${Q($)}!`),j.resolve({protocol:J,firstMessage:_}))})),j.promise}async function s(B,H){const{protocol:R}=await n(B,1,void 0,H);return{protocol:R}}async function i(B,H,R){const{protocol:F,firstMessage:$}=await n(B,2,H,R),z=$&&$.debugPort;return{protocol:F,debugPort:z}}async function a(B,H,R){const F=Date.now(),$=U(B,3),{protocol:z}=await l(B,3,H,R);return B.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${Q(F)}!`),z}async function r(B,H,R){const{host:F,port:$,connectionToken:z}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:F,port:$,connectionToken:z,reconnectionToken:H,reconnectionProtocol:R,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function c(B,H,R){return y(B,async F=>{const{protocol:$}=await s(F,C.CancellationToken.None);return new de(B,H,R,F.reconnectionToken,$)})}e.connectRemoteAgentManagement=c;async function o(B,H){return y(B,async R=>{const{protocol:F,debugPort:$}=await i(R,H,C.CancellationToken.None);return new X(B,H,R.reconnectionToken,F,$)})}e.connectRemoteAgentExtensionHost=o;async function y(B,H){for(let F=1;;F++)try{const $=(0,w.generateUuid)(),z=await r(B,$,null);return await H(z)}catch($){if(F<5)B.logService.error(`[remote-connection][attempt ${F}] An error occurred in initial connection! Will retry... Error:`),B.logService.error($);else throw B.logService.error(`[remote-connection][attempt ${F}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error($),re.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled($)),$}}async function D(B,H,R){const F=await r(B,(0,w.generateUuid)(),null);return await a(F,{host:H,port:R},C.CancellationToken.None)}e.connectRemoteAgentTunnel=D;function O(B){return(0,E.createCancelablePromise)(H=>new Promise((R,F)=>{const $=setTimeout(R,B*1e3);H.onCancellationRequested(()=>{clearTimeout($),R()})}))}var N;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(N=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class Y{constructor(H,R){this.reconnectionToken=H,this.millisSinceLastIncomingData=R,this.type=0}}e.ConnectionLostEvent=Y;class G{constructor(H,R,F,$){this.reconnectionToken=H,this.millisSinceLastIncomingData=R,this.durationSeconds=F,this.c=$,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=G;class V{constructor(H,R,F){this.reconnectionToken=H,this.millisSinceLastIncomingData=R,this.attempt=F,this.type=2}}e.ReconnectionRunningEvent=V;class se{constructor(H,R,F){this.reconnectionToken=H,this.millisSinceLastIncomingData=R,this.attempt=F,this.type=4}}e.ConnectionGainEvent=se;class oe{constructor(H,R,F,$){this.reconnectionToken=H,this.millisSinceLastIncomingData=R,this.attempt=F,this.handled=$,this.type=3}}e.ReconnectionPermanentFailureEvent=oe;class re extends k.Disposable{static triggerPermanentFailure(H,R,F){this._permanentFailure=!0,this.f=H,this.g=R,this.h=F,this.i.forEach($=>$.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(H=>H.r())}static debugPauseSocketWriting(){this.i.forEach(H=>H.v())}get k(){return this.c||re._permanentFailure}constructor(H,R,F,$,z){super(),this.m=H,this.n=R,this.reconnectionToken=F,this.protocol=$,this.p=z,this.j=this.B(new M.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new se(this.reconnectionToken,0,0)),this.B($.onSocketClose(J=>{const ne=T(this.m,this.reconnectionToken,!0);J?J.type===0?(this.n.logService.info(`${ne} received socket close event (hadError: ${J.hadError}).`),J.error&&this.n.logService.error(J.error)):(this.n.logService.info(`${ne} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.n.logService.error(J.event)):this.n.logService.info(`${ne} received socket close event.`),this.r()})),this.B($.onSocketTimeout(J=>{const ne=T(this.m,this.reconnectionToken,!0);this.n.logService.info(`${ne} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.r()})),re.i.push(this),this.B((0,k.toDisposable)(()=>{const J=re.i.indexOf(this);J>=0&&re.i.splice(J,1)})),this.k&&this.u(re.f,re.g,re.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const H=T(this.m,this.reconnectionToken,!0);this.n.logService.info(`${H} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const R=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const $=F<R.length?R[F]:R[R.length-1];try{if($>0){const J=O($);this.j.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$,J)),this.n.logService.info(`${H} waiting for ${$} seconds before reconnecting...`);try{await J}catch{}}if(this.k){this.n.logService.error(`${H} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this.n.logService.info(`${H} resolving connection...`);const z=await r(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${H} connecting to ${z.host}:${z.port}...`),await this.w(z,f(I)),this.n.logService.info(`${H} reconnected!`),this.j.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${H} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(z),this.t(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this.n.logService.error(`${H} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(z),this.t(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable(z)){this.n.logService.info(`${H} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.n.logService.info(`${H} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(z);continue}if((0,A.isCancellationError)(z)){this.n.logService.info(`${H} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(z);continue}if(z instanceof S.RemoteAuthorityResolverError){this.n.logService.error(`${H} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(z),this.t(this.protocol.getMillisSinceLastIncomingData(),F+1,S.RemoteAuthorityResolverError.isHandled(z));break}this.n.logService.error(`${H} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(z),this.t(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!this.k)}t(H,R,F){this.p?re.triggerPermanentFailure(H,R,F):this.u(H,R,F)}u(H,R,F){this.j.fire(new oe(this.reconnectionToken,H,R,F)),le(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=re,re._permanentFailure=!1,re.f=0,re.g=0,re.h=!1,re.i=[];class de extends re{constructor(H,R,F,$,z){super(1,H,$,z,!0),this.client=this.B(new v.Client(z,{remoteAuthority:R,clientId:F},H.ipcLogger))}async w(H,R){await s(H,R)}}e.ManagementPersistentConnection=de;class X extends re{constructor(H,R,F,$,z){super(2,H,F,$,!1),this.y=R,this.debugPort=z}async w(H,R){await i(H,this.y,R)}}e.ExtensionHostPersistentConnection=X;function le(B){try{B.acceptDisconnect();const H=B.getSocket();B.dispose(),H.dispose()}catch(H){(0,A.onUnexpectedError)(H)}}function W(B){if(B&&B.type==="error"){const H=new Error(`Connection error: ${B.reason}`);return H.code="VSCODE_CONNECTION_ERROR",H}return null}function L(B,H){for(;B.length<H;)B+=" ";return B}function T(B,H,R){return`[remote-connection][${L(m(B),13)}][${H.substr(0,5)}\u2026][${R?"reconnect":"initial"}]`}function U(B,H){return`${T(H,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function Q(B){return`${Date.now()-B} ms`}}),define(ee[221],te([0,1,78,83]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(C,A,M,k,w,v){const S=I=>v(I,void 0),P=E.createConnection({host:C,port:A},()=>{P.removeListener("error",S);const I=Buffer.alloc(16);for(let p=0;p<16;p++)I[p]=Math.round(Math.random()*256);const h=I.toString("base64"),m=[`GET ws://${/:/.test(C)?`[${C}]`:C}:${A}${M}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`];P.write(m.join(`\r
`)+`\r
\r
`);const f=p=>{p.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",f),v(void 0,new t.NodeSocket(P,w)))};P.on("data",f)});P.setNoDelay(!0),P.once("error",S)}}}),define(ee[222],te([0,1,27,44,39,181]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let M;async function k(h=!1){return(M===void 0||h)&&(M=w()),M}e.hasWSLFeatureInstalled=k;async function w(){const h=v();if(h===void 0)return!1;if(h>=22e3){const m=P();if(m)return new Promise(f=>{t.execFile(m,["--status"],p=>f(!p))})}else{const m=I();if(m)try{if((await C.promises.stat(m)).isFile())return!0}catch{}}return!1}function v(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(h)return parseInt(h[3])}function S(h){const m=process.env.SystemRoot;if(m){const f=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return A.join(m,f?"Sysnative":"System32",h)}}function P(){return S("wsl.exe")}function I(){return S("lxss\\LxssManager.dll")}}),define(ee[55],te([0,1,17,165,62,5,46]),function(q,e,E,t,C,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function k(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}e.isSuccess=k;function w(f){return f.res.statusCode===204}async function v(f){return w(f)?null:(await(0,E.streamToBuffer)(f.stream)).toString()}e.asText=v;async function S(f){if(!k(f))throw new Error("Server returned "+f.res.statusCode);return v(f)}e.asTextOrError=S;async function P(f){if(!k(f))throw new Error("Server returned "+f.res.statusCode);if(w(f))return null;const u=(await(0,E.streamToBuffer)(f.stream)).toString();try{return JSON.parse(u)}catch(b){throw b.message+=`:
`+u,b}}e.asJson=P;function I(f){m(f)}e.updateProxyConfigurationsScope=I;let h;function m(f){const p=M.Registry.as(C.Extensions.Configuration),u=h;h={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},p.updateConfigurations({add:[h],remove:u?[u]:[]})}m(2)}),define(ee[223],te([0,1,17,22]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class C{constructor(k){this.a=k}listen(k,w){throw new Error("Invalid listen")}call(k,w,v,S=t.CancellationToken.None){switch(w){case"request":return this.a.request(v[0],S).then(async({res:P,stream:I})=>{const h=await(0,E.streamToBuffer)(I);return[{statusCode:P.statusCode,headers:P.headers},h]});case"resolveProxy":return this.a.resolveProxy(v[0])}throw new Error("Invalid call")}}e.RequestChannel=C;class A{constructor(k){this.a=k}async request(k,w){const[v,S]=await this.a.call("request",[k],w);return{res:v,stream:(0,E.bufferToStream)(S)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}}e.RequestChannelClient=A}),define(ee[224],te([0,1,225,12]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function C(M,k){return M.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:M.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function A(M,k,w={}){const v=(0,E.parse)(M),S=w.proxyUrl||C(v,k);if(!S)return null;const P=(0,E.parse)(S);if(!/^https?:$/.test(P.protocol||""))return null;const I={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,t.isBoolean)(w.strictSSL)?w.strictSSL:!0};return v.protocol==="http:"?new(await new Promise((h,m)=>{q(["http-proxy-agent"],h,m)}))(I):new(await new Promise((h,m)=>{q(["https-proxy-agent"],h,m)}))(I)}e.getProxyAgent=A}),define(ee[111],te([0,1,44,9,166,22,43,15,4,29,142,59,8]),function(q,e,E,t,C,A,M,k,w,v,S,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const h=1e4;let m;async function f(u,b,g){return b["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(g)&&!b["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(g)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=I.Promises.withAsyncBody(async(d,l)=>{const n=new A.CancellationTokenSource,s=setTimeout(()=>{n.dispose(!0),l(new Error((0,C.localize)(0,null)))},h);try{d(await p(u,n.token))}catch(i){!(0,k.isCancellationError)(i)&&!n.token.isCancellationRequested?l(new Error((0,C.localize)(1,null,(0,M.toErrorMessage)(i)))):d({})}finally{clearTimeout(s),n.dispose()}})),m)}e.getResolvedShellEnv=f;async function p(u,b){const g=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",g);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",d);const l=(0,v.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(l+"(.*)"+l),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",s);const i=await(0,S.getSystemShell)(w.OS,s);return u.trace("getUnixShellEnvironment#shell",i),new Promise((a,r)=>{if(b.isCancellationRequested)return r((0,k.canceled)());const c=(0,t.basename)(i);let o,y;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(o=`& '${process.execPath}' ${D} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,y=["-Login","-Command"]):(o=`'${process.execPath}' ${D} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,c==="tcsh"?y=["-ic"]:y=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),o);const O=(0,E.spawn)(i,[...y,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});b.onCancellationRequested(()=>(O.kill(),r((0,k.canceled)()))),O.on("error",G=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(G)),r(G)});const N=[];O.stdout.on("data",G=>N.push(G));const Y=[];O.stderr.on("data",G=>Y.push(G)),O.on("close",(G,V)=>{const se=Buffer.concat(N).toString("utf8");u.trace("getUnixShellEnvironment#raw",se);const oe=Buffer.concat(Y).toString("utf8");if(oe.trim()&&u.trace("getUnixShellEnvironment#stderr",oe),G||V)return r(new Error((0,C.localize)(2,null,G,V)));const re=n.exec(se),de=re?re[1]:"{}";try{const X=JSON.parse(de);g?X.ELECTRON_RUN_AS_NODE=g:delete X.ELECTRON_RUN_AS_NODE,d?X.ELECTRON_NO_ATTACH_CONSOLE=d:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",X),a(X)}catch(X){u.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(X)),r(X)}})})}}),define(ee[88],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[226],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{constructor(){this.b=new Map}c(){return new Promise((C,A)=>q(["vsda"],C,A))}async createNewMessage(C){try{const A=await this.c(),M=new A.validator;if(M){const k=String(E.a++);return this.b.set(k,M),{id:k,data:M.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,A){if(!C.id)return!0;const M=this.b.get(C.id);if(!M)return!1;this.b.delete(C.id);try{return M.validate(A)==="ok"}catch{return!1}}async sign(C){try{const A=await this.c(),M=new A.signer;if(M)return M.sign(C)}catch{}return C}}e.SignService=E,E.a=1}),define(ee[37],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,E.createDecorator)("stateMainService")}),define(ee[21],te([0,1,13,40,8,3,2,4,32,12,5,6,37,26]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,S.createDecorator)("lifecycleMainService");var m;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(m=e.ShutdownReason||(e.ShutdownReason={}));var f;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})(f=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let p=class Et extends M.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(b,g,d){super(),this.v=b,this.w=g,this.y=d,this.c=this.B(new A.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new A.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new A.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new A.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.C(),this.when(2).then(()=>this.D())}C(){this.j=!!this.w.getItem(Et.b),this.j&&this.w.removeItem(Et.b)}D(){const b=()=>{this.i||(this.M("Lifecycle#app.on(before-quit)"),this.i=!0,this.M("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),k.isMacintosh&&this.n===0&&this.F(1))};E.app.addListener("before-quit",b);const g=()=>{this.M("Lifecycle#app.on(window-all-closed)"),(this.i||!k.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",g),E.app.once("will-quit",d=>{this.M("Lifecycle#app.on(will-quit)"),d.preventDefault(),this.F(1).finally(()=>{this.I(!1),E.app.removeListener("before-quit",b),E.app.removeListener("window-all-closed",g),E.app.quit()})})}F(b){if(this.s)return this.s;this.M("Lifecycle#onWillShutdown.fire()");const g=[];return this.f.fire({reason:b,join(d){g.push(d)}}),this.s=(async()=>{try{await C.Promises.settled(g)}catch(d){this.v.error(d)}try{await this.w.close()}catch(d){this.v.error(d)}})(),this.s}set phase(b){if(b<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===b)return;this.M(`lifecycle (main): phase changed (value: ${b})`),this.k=b;const g=this.u.get(this.k);g&&(g.open(),this.u.delete(this.k))}async when(b){if(b<=this.k)return;let g=this.u.get(b);g||(g=new C.Barrier,this.u.set(b,g)),await g.wait()}registerWindow(b){const g=new M.DisposableStore;this.n++,g.add(b.onWillLoad(l=>this.g.fire({window:b,workspace:l.workspace,reason:l.reason})));const d=(0,v.assertIsDefined)(b.win);d.on("close",l=>{const n=b.id;if(this.l.has(n)){this.l.delete(n);return}this.M(`Lifecycle#window.on('close') - window ID ${b.id}`),l.preventDefault(),this.unload(b,1).then(s=>{if(s){this.l.delete(n);return}this.l.add(n),this.M(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${n}`),this.h.fire(b),b.close()})}),d.on("closed",()=>{this.M(`Lifecycle#window.on('closed') - window ID ${b.id}`),this.n--,g.dispose(),this.n===0&&(!k.isMacintosh||this.i)&&this.F(1)})}async reload(b,g){await this.unload(b,3)||b.reload(g)}unload(b,g){const d=this.t.get(b.id);if(d)return d;const l=this.G(b,g).finally(()=>{this.t.delete(b.id)});return this.t.set(b.id,l),l}async G(b,g){if(!b.isReady)return!1;this.M(`Lifecycle#unload() - window ID ${b.id}`);const d=this.i?2:g,l=await this.J(b,d);return l?(this.M(`Lifecycle#unload() - veto in renderer (window ID ${b.id})`),this.H(l)):(await this.L(b,d),!1)}H(b){return b?(this.I(!0),this.i=!1,!0):!1}I(b){this.r&&(this.r(b),this.r=void 0,this.p=void 0)}J(b,g){return new Promise(d=>{const l=this.m++,n=`vscode:ok${l}`,s=`vscode:cancel${l}`;t.validatedIpcMain.once(n,()=>{d(!1)}),t.validatedIpcMain.once(s,()=>{d(!0)}),b.send("vscode:onBeforeUnload",{okChannel:n,cancelChannel:s,reason:g})})}L(b,g){return new Promise(d=>{const n=`vscode:reply${this.m++}`;t.validatedIpcMain.once(n,()=>d()),b.send("vscode:onWillUnload",{replyChannel:n,reason:g})})}quit(b){return this.M(`Lifecycle#quit() - begin (willRestart: ${b})`),this.p?(this.M("Lifecycle#quit() - returning pending quit promise"),this.p):(b&&this.w.setItem(Et.b,!0),this.p=new Promise(g=>{this.r=g,this.M("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.p)}M(b){this.y.args["enable-smoke-test-driver"]?this.v.info(b):this.v.trace(b)}async relaunch(b){this.M("Lifecycle#relaunch()");const g=process.argv.slice(1);if(b?.addArgs&&g.push(...b.addArgs),b?.removeArgs)for(const n of b.removeArgs){const s=g.indexOf(n);s>=0&&g.splice(s,1)}const d=()=>{try{if(k.isWindows){const n=(0,w.cwd)();n!==process.cwd()&&process.chdir(n)}}catch(n){this.v.error(n)}this.M("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:g})};E.app.once("quit",d),await this.quit(!0)&&E.app.removeListener("quit",d)}async kill(b){this.M("Lifecycle#kill()"),await this.F(2),await Promise.race([(0,C.timeout)(1e3),(async()=>{for(const g of E.BrowserWindow.getAllWindows())if(g&&!g.isDestroyed()){let d;g.webContents&&!g.webContents.isDestroyed()?d=new Promise(l=>g.once("closed",l)):d=Promise.resolve(),g.destroy(),await d}})()]),E.app.exit(b)}};p.b="lifecycle.quitAndRestart",p=pe([ie(0,P.ILogService),ie(1,I.IStateMainService),ie(2,h.IEnvironmentMainService)],p),e.LifecycleMainService=p}),define(ee[227],te([0,1,4,3,2,5,21]),function(q,e,E,t,C,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,A.createDecorator)("keyboardLayoutMainService");let k=class extends C.Disposable{constructor(S){super(),this.a=this.B(new t.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,S.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const S=await new Promise((P,I)=>{q(["native-keymap"],P,I)});this.c=w(S),E.isCI||S.onDidChangeKeyboardLayout(()=>{this.c=w(S),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};k=pe([ie(0,M.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function w(v){const S=v.getKeyMap(),P=v.getCurrentKeyboardLayout();return{keyboardMapping:S,keyboardLayoutInfo:P}}}),define(ee[228],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,E.createDecorator)("stateService")}),define(ee[229],te([0,1,8,17,12,34,16,6]),function(q,e,E,t,C,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class w{constructor(P,I,h){this.f=P,this.g=I,this.h=h,this.a=Object.create(null),this.b="",this.c=new E.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(P){P.fileOperationResult!==1&&this.g.error(P)}}getItem(P,I){const h=this.a[P];return(0,C.isUndefinedOrNull)(h)?I:h}setItem(P,I){this.setItems([{key:P,data:I}])}setItems(P){let I=!1;for(const{key:h,data:m}of P)this.a[h]!==m&&((0,C.isUndefinedOrNull)(m)?(0,C.isUndefined)(this.a[h])||(this.a[h]=void 0,I=!0):(this.a[h]=m,I=!0));I&&this.j()}removeItem(P){(0,C.isUndefined)(this.a[P])||(this.a[P]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const P=JSON.stringify(this.a,null,4);if(P!==this.b)try{await this.h.writeFile(this.f,t.VSBuffer.fromString(P)),this.b=P}catch(I){this.g.error(I)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=w;let v=class{constructor(P,I,h){this.a=new w(P.stateResource,I,h)}async init(){await this.a.init()}getItem(P,I){return this.a.getItem(P,I)}};v=pe([ie(0,A.IEnvironmentService),ie(1,k.ILogService),ie(2,M.IFileService)],v),e.StateService=v}),define(ee[230],te([0,1,229]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends E.StateService{setItem(A,M){this.a.setItem(A,M)}setItems(A){this.a.setItems(A)}removeItem(A){this.a.removeItem(A)}close(){return this.a.close()}}e.StateMainService=t}),define(ee[112],te([0,1,4,32,7,29]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(v){if(E.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function k(v,S,P,I,h,m,f,p,u,b){const g=Object.create(null);g["common.machineId"]=f,g.sessionID=(0,A.generateUuid)()+Date.now(),g.commitHash=h,g.version=m,g["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,E.PlatformToString)(E.platform),g["common.nodePlatform"]=t.platform,g["common.nodeArch"]=I,g["common.product"]=b||"desktop",p&&(g["common.msftInternal"]=p);let d=0;const l=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),E.isLinuxSnap&&(g["common.snap"]="true");const n=M(P);n&&(g["common.platformDetail"]=n);try{const s=await v.readFile(C.URI.file(u));g["common.source"]=s.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=k;function w(v){const S=t.env.USERDNSDOMAIN;if(!S)return!1;const P=S.toLowerCase();return v.some(I=>P===I)}e.verifyMicrosoftInternalDomain=w}),define(ee[35],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var C;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(C=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[231],te([0,1,27,8,42,14,9,4,7,81,23,100,84,16,20,35]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function u(n,s){const i=`${n}::${s.join(":")}`,a=p.get(i);if(a)return a;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,o=new Map,y=2e4;function D(N,Y,G,V){const se=Y.substring(N.length+1);return t.Promises.withAsyncBody(async oe=>{let re;try{re=await S.Promises.readdir(Y,{withFileTypes:!0})}catch{oe();return}if(V.count>=y){V.count+=re.length,V.maxReached=!0,oe();return}let de=re.length;if(de===0){oe();return}let X=re;V.count+re.length>y&&(V.maxReached=!0,de=y-V.count,X=re.slice(0,de)),V.count+=re.length;for(const le of X)if(le.isDirectory()){if(G.includes(le.name)||await D(N,(0,M.join)(Y,le.name),G,V),--de===0){oe();return}}else{const W=le.name.lastIndexOf(".");if(W>=0){const L=le.name.substring(W+1);L&&c.set(L,(c.get(L)??0)+1)}for(const L of r)L.relativePathPattern?.test(se)!==!1&&L.filePattern.test(le.name)&&o.set(L.tag,(o.get(L.tag)??0)+1);if(--de===0){oe();return}}})}const O=t.Promises.withAsyncBody(async N=>{const Y={count:0,maxReached:!1};await D(n,n,s,Y);const G=await d(n);N({configFiles:b(o),fileTypes:b(c),fileCount:Y.count,maxFilesReached:Y.maxReached,launchConfigFiles:G})});return p.set(i,O),O}e.collectWorkspaceStats=u;function b(n){return Array.from(n.entries(),([s,i])=>({name:s,count:i})).sort((s,i)=>i.count-s.count)}function g(){const n={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(v.virtualMachineHint.value()*100)}%`},s=E.cpus();return s&&s.length>0&&(n.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),n}e.getMachineInfo=g;async function d(n){try{const s=new Map,i=(0,M.join)(n,".vscode","launch.json"),a=await S.Promises.readFile(i),r=[],c=(0,C.parse)(a.toString(),r);if(r.length)return console.log(`Unable to parse ${i}`),[];if((0,C.getNodeType)(c)==="object"&&c.configurations)for(const o of c.configurations){const y=o.type;y&&(s.has(y)?s.set(y,s.get(y)+1):s.set(y,1))}return b(s)}catch{return[]}}e.collectLaunchConfigs=d;let l=class{constructor(s,i){this.c=s,this.d=i}f(s){const i=[];return i.push(`OS Version:       ${s.os}`),i.push(`CPUs:             ${s.cpus}`),i.push(`Memory (System):  ${s.memory}`),i.push(`VM:               ${s.vmHint}`),i.join(`
`)}g(s){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const a=E.cpus();return a&&a.length>0&&i.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),i.push(`Memory (System):  ${(E.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),k.isWindows||i.push(`Load (avg):       ${E.loadavg().map(r=>Math.round(r)).join(", ")}`),i.push(`VM:               ${Math.round(v.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${s.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(s,i){return Promise.all([(0,P.listProcesses)(s.mainPID),this.k(s)]).then(async a=>{let[r,c]=a,o=this.m(s,r);return i.forEach(y=>{if((0,I.isRemoteDiagnosticError)(y))o+=`
${y.errorMessage}`,c+=`
${y.errorMessage}`;else if(o+=`

Remote: ${y.hostName}`,y.processes&&(o+=`
${this.m(s,y.processes)}`),y.workspaceMetadata){c+=`
|  Remote: ${y.hostName}`;for(const D of Object.keys(y.workspaceMetadata)){const O=y.workspaceMetadata[D];let N=`${O.fileCount} files`;O.maxFilesReached&&(N=`more than ${N}`),c+=`|    Folder (${D}): ${N}`,c+=this.h(O)}}}),{processInfo:o,workspaceInfo:c}})}async getSystemInfo(s,i){const{memory:a,vmHint:r,os:c,cpus:o}=g(),y={os:c,memory:a,cpus:o,vmHint:r,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:i};return k.isWindows||(y.load=`${E.loadavg().map(D=>Math.round(D)).join(", ")}`),k.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(s,i){const a=[];return(0,P.listProcesses)(s.mainPID).then(async r=>(a.push(""),a.push(this.g(s)),a.push(""),a.push(this.m(s,r)),s.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.k(s))),i.forEach(c=>{if((0,I.isRemoteDiagnosticError)(c))a.push(`
${c.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${c.hostName}`),a.push(this.f(c.machineInfo)),c.processes&&a.push(this.m(s,c.processes)),c.workspaceMetadata)for(const o of Object.keys(c.workspaceMetadata)){const y=c.workspaceMetadata[o];let D=`${y.fileCount} files`;y.maxFilesReached&&(D=`more than ${D}`),a.push(`Folder (${o}): ${D}`),a.push(this.h(y))}}),a.push(""),a.push(""),a.join(`
`)))}h(s){const i=[];let r=0;const c=(O,N)=>{const Y=` ${O}(${N})`;r+Y.length>60?(i.push(o),o="|                 ",r=o.length):r+=Y.length,o+=Y};let o="|      File types:";const y=10,D=s.fileTypes.length>y?y:s.fileTypes.length;for(let O=0;O<D;O++){const N=s.fileTypes[O];c(N.name,N.count)}if(i.push(o),s.configFiles.length>=0&&(o="|      Conf files:",r=0,s.configFiles.forEach(O=>{c(O.name,O.count)}),i.push(o)),s.launchConfigFiles.length>0){let O="|      Launch Configs:";s.launchConfigFiles.forEach(N=>{O+=N.count>1?` ${N.name}(${N.count})`:` ${N.name}`}),i.push(O)}return i.join(`
`)}j(s){const i=Math.max(...Object.keys(s).map(a=>a.length));return Object.keys(s).map(a=>`${a}:  ${" ".repeat(i-a.length)}  ${s[a]}`).join(`
                  `)}k(s){const i=[],a=[];return s.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(i.push(`|  Window (${r.title})`),r.folderURIs.forEach(c=>{const o=w.URI.revive(c);if(o.scheme===A.Schemas.file){const y=o.fsPath;a.push(u(y,["node_modules",".git"]).then(D=>{let O=`${D.fileCount} files`;D.maxFilesReached&&(O=`more than ${O}`),i.push(`|    Folder (${(0,M.basename)(y)}): ${O}`),i.push(this.h(D))}).catch(D=>{i.push(`|      Error: Unable to collect workspace stats for folder ${y} (${D.toString()})`)}))}else i.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(r=>i.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}m(s,i){const a=new Map;s.windows.forEach(c=>a.set(c.pid,c.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),i&&this.n(s.mainPID,a,r,i,0),r.join(`
`)}n(s,i,a,r,c){const o=c===0;let y;o?y=r.pid===s?`${this.d.applicationName} main`:"remote agent":(y=`${"  ".repeat(c)} ${r.name}`,r.name==="window"&&(y=`${y} (${i.get(r.pid)})`));const D=process.platform==="win32"?r.mem:E.totalmem()*(r.mem/100);a.push(`${r.load.toFixed(0).padStart(5," ")}	${(D/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(r.children)&&r.children.forEach(O=>this.n(s,i,a,O,c+1))}async getWorkspaceFileExtensions(s){const i=new Set;for(const{uri:a}of s.folders){const r=w.URI.revive(a);if(r.scheme!==A.Schemas.file)continue;const c=r.fsPath;try{(await u(c,["node_modules",".git"])).fileTypes.forEach(y=>i.add(y.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(s){for(const{uri:i}of s.folders){const a=w.URI.revive(i);if(a.scheme!==A.Schemas.file)continue;const r=a.fsPath;try{const c=await u(r,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),c.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:o.name,count:o.count})}),c.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:o.name,count:o.count})}),c.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};l=pe([ie(0,f.ITelemetryService),ie(1,m.IProductService)],l),e.DiagnosticsService=l}),define(ee[232],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(A){this.b=A}listen(A,M){throw new Error(`Event not found: ${M}`)}call(A,M,{eventName:k,data:w}){return this.b.forEach(v=>v.log(k,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class t{constructor(A){this.b=A}log(A,M){return this.b.call("log",{eventName:A,data:M}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ee[73],te([0,1,50,96,12,18,112,35]),function(q,e,E,t,C,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class w{constructor(c){this.value=c}}e.TrustedTelemetryValue=w;class v{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(c,o){return Promise.resolve(void 0)}publicLog2(c,o){return this.publicLog(c,o)}publicLogError(c,o){return Promise.resolve(void 0)}publicLogError2(c,o){return this.publicLogError(c,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=v,e.NullTelemetryService=new v;class S{async publicLog(c,o,y){}async publicLogError(c,o,y){}}e.NullEndpointTelemetryService=S,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(r,c){return c.onDidChangeConfiguration(o=>{o.source!==7&&r.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(o.source),configurationKeys:g(o.sourceConfig)})})}e.configurationTelemetry=P;function I(r,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!r.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=I;function h(r,c){return!(c.isBuilt||c.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}e.isLoggingOnly=h;function m(r){const c=r.getValue(k.TELEMETRY_SETTING_ID),o=r.getValue("telemetry.enableCrashReporter");if(r.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function f(r){const c={},o={},y={};b(r,y);for(let D in y){D=D.length>150?D.substr(D.length-149):D;const O=y[D];typeof O=="number"?o[D]=O:typeof O=="boolean"?o[D]=O?1:0:typeof O=="string"?(O.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${O.length}`),c[D]=O.substring(0,8191)):typeof O<"u"&&O!==null&&(c[D]=O)}return{properties:c,measurements:o}}e.validateTelemetryData=f;const p=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function u(r){if(!r)return"none";for(const c of p)if(r.startsWith(`${c}+`))return c;return"other"}e.cleanRemoteAuthority=u;function b(r,c,o=0,y){if(!!r)for(const D of Object.getOwnPropertyNames(r)){const O=r[D],N=y?y+D:D;Array.isArray(O)?c[N]=(0,E.safeStringify)(O):O instanceof Date?c[N]=O.toISOString():(0,C.isObject)(O)?o<2?b(O,c,o+1,N+"."):c[N]=(0,E.safeStringify)(O):c[N]=O}}function g(r){if(!r)return[];const c=[];return d(c,"",r),c}function d(r,c,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(y=>d(r,c?`${c}.${y}`:y,o[y])):r.push(c)}function l(r,c){const o=r.msftInternalDomains||[],y=c.getValue("telemetry.internalTesting");return(0,M.verifyMicrosoftInternalDomain)(o)||y}e.isInternalTelemetry=l;function n(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}e.getPiiPathsFromEnvironment=n;function s(r,c){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let o=r;const y=[];for(const Y of c)for(;;){const G=Y.exec(r);if(!G)break;y.push([G.index,Y.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,O=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(o="";;){const Y=O.exec(r);if(!Y)break;const G=y.some(([V,se])=>Y.index<se&&V<O.lastIndex);!D.test(Y[0])&&!G&&(o+=r.substring(N,Y.index)+"<REDACTED: user-file-path>",N=O.lastIndex)}return N<r.length&&(o+=r.substr(N)),o}function i(r){if(!r)return r;const c=r.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const y of o)if(y.regex.test(c))return`<REDACTED: ${y.label}>`;return r}function a(r,c){return(0,E.cloneAndChange)(r,o=>{if(o instanceof w)return o.value;if(typeof o=="string"){let y=o;y=s(y,c);for(const D of c)y=y.replace(D,"");return y=i(y),y}})}e.cleanData=a}),define(ee[233],te([0,1,188,73]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function C(A,M,k,w,v,S,P){const I={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${M.nameShort})`};if((0,t.supportsTelemetry)(M,k)&&(0,t.getTelemetryLevel)(w)===3){const h=await(0,E.getServiceMachineId)(k,v,S),{machineId:m}=await P.getTelemetryInfo();I["X-Market-User-Id"]=h,I["VSCode-SessionId"]=m}return I}e.resolveMarketplaceHeaders=C}),define(ee[234],te([0,1,2,50,96,4,25,167,18,62,54,20,46,35,73]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(b,g,d){this.j=g,this.k=d,this.d={},this.telemetryLevel=new C.MutableObservableValue(3),this.h=new E.DisposableStore,this.i=[],this.b=b.appenders,this.c=b.commonProperties||Promise.resolve({}),this.f=b.piiPaths||[],this.g=!!b.sendErrorTelemetry,this.i=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const l of this.f)this.i.push(new RegExp((0,M.escapeRegExpCharacters)(l),"gi")),l.indexOf("\\")>=0&&this.i.push(new RegExp((0,M.escapeRegExpCharacters)(l.replace(/\\/g,"/")),"gi"));this.l(),this.j.onDidChangeConfiguration(this.l,this,this.h)}setExperimentProperty(b,g){this.d[b]=g}l(){let b=(0,m.getTelemetryLevel)(this.j);const g=this.k.enabledTelemetryLevels;if(g){this.g=this.sendErrorTelemetry?g.error:!1;const d=g.usage?3:g.error?2:0;b=Math.min(b,d)}this.telemetryLevel.value=b}get sendErrorTelemetry(){return this.g}async getTelemetryInfo(){const b=await this.c,g=b.sessionID,d=b["common.machineId"],l=b["common.firstSessionDate"],n=b["common.msftInternal"];return{sessionId:g,machineId:d,firstSessionDate:l,msftInternal:n}}dispose(){this.h.dispose()}m(b,g,d){return this.telemetryLevel.value<g?Promise.resolve(void 0):this.c.then(l=>{d=(0,t.mixin)(d,this.d),d=(0,m.cleanData)(d,this.i),d=(0,t.mixin)(d,l),this.b.forEach(n=>n.log(b,d))},l=>{console.error(l)})}publicLog(b,g){return this.m(b,3,g)}publicLog2(b,g){return this.publicLog(b,g)}publicLogError(b,g){return this.g?this.m(b,2,g):Promise.resolve(void 0)}publicLogError2(b,g){return this.publicLogError(b,g)}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=pe([ie(1,w.IConfigurationService),ie(2,P.IProductService)],f),e.TelemetryService=f;function p(){const u=(0,k.localize)(0,null,S.default.nameLong),b=S.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=A.isWeb?"":(0,k.localize)(3,null),d=(0,k.localize)(4,null),l=(0,k.localize)(5,null),n=(0,k.localize)(6,null),s=(0,k.localize)(7,null),i=`
|       | ${d} | ${l} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,k.localize)(8,null);return`
${u} ${b} ${g}

&nbsp;

${s}
${i}

&nbsp;

${a}
`}I.Registry.as(v.Extensions.Configuration).registerConfiguration({id:h.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[h.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(v.Extensions.Configuration).registerConfiguration({id:h.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[h.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,k.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,k.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${h.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[235],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var E;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(E=e.ColorScheme||(e.ColorScheme={}));function t(A){return A===E.HIGH_CONTRAST_DARK||A===E.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function C(A){return A===E.DARK||A===E.HIGH_CONTRAST_DARK}e.isDark=C}),define(ee[236],te([0,1,119,3,2,5,46,235]),function(q,e,E,t,C,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var w;(function(p){function u(b){return b&&typeof b=="object"&&typeof b.id=="string"}p.isThemeColor=u})(w=e.ThemeColor||(e.ThemeColor={}));function v(p){return{id:p}}e.themeColorFromId=v;var S;(function(p){function u(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||w.isThemeColor(a.color))}p.isThemeIcon=u;const b=new RegExp(`^\\$\\((${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?)\\)$`);function g(a){const r=b.exec(a);if(!r)return;const[,c]=r;return{id:c}}p.fromString=g;function d(a){return{id:a}}p.fromId=d;function l(a,r){let c=a.id;const o=c.lastIndexOf("~");return o!==-1&&(c=c.substring(0,o)),r&&(c=`${c}~${r}`),{id:c}}p.modify=l;function n(a){const r=a.id.lastIndexOf("~");if(r!==-1)return a.id.substring(r+1)}p.getModifier=n;function s(a,r){return a.id===r.id&&a.color?.id===r.color?.id}p.isEqual=s;function i(a,r){return{id:a.id,color:r?v(r):void 0}}p.asThemeIcon=i,p.asClassNameArray=E.CSSIcon.asClassNameArray,p.asClassName=E.CSSIcon.asClassName,p.asCSSSelector=E.CSSIcon.asCSSSelector})(S=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=E.Codicon.file,e.FolderThemeIcon=E.Codicon.folder;function P(p){switch(p){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case k.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class I{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(u){return this.a.push(u),this.b.fire(u),(0,C.toDisposable)(()=>{const b=this.a.indexOf(u);this.a.splice(b,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const h=new I;M.Registry.add(e.Extensions.ThemingContribution,h);function m(p){return h.onColorThemeChange(p)}e.registerThemingParticipant=m;class f extends C.Disposable{constructor(u){super(),this.k=u,this.h=u.getColorTheme(),this.B(this.k.onDidColorThemeChange(b=>this.n(b)))}n(u){this.h=u,this.updateStyles()}updateStyles(){}w(u,b){let g=this.h.getColor(u);return g&&b&&(g=b(g,this.h)),g?g.toString():null}}e.Themable=f}),define(ee[64],te([0,1,13,3,2,4,18,5,37]),function(q,e,E,t,C,A,M,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const v="#FFFFFF",S="#1E1E1E",P="#000000",I="#FFFFFF",h="theme",m="themeBackground",f="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let p=class extends C.Disposable{constructor(b,g){super(),this.b=b,this.c=g,this.a=this.B(new t.Emitter),this.onDidChangeColorScheme=this.a.event,E.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(A.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(A.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(A.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const b=this.getColorScheme();if(b.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return b.dark?P:I;let g=this.b.getItem(m,null);if(!g)switch(this.b.getItem(h,"vs-dark").split(" ")[0]){case"vs":g=v;break;case"hc-black":g=P;break;case"hc-light":g=I;break;default:g=S}return A.isMacintosh&&g.toUpperCase()===S&&(g="#171717"),g}saveWindowSplash(b,g){this.b.setItems([{key:h,data:g.baseTheme},{key:m,data:g.colorInfo.background},{key:f,data:g}]),typeof b=="number"&&this.f(b,g)}f(b,g){for(const d of E.BrowserWindow.getAllWindows())if(d.id===b){d.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(f)}};p=pe([ie(0,w.IStateMainService),ie(1,M.IConfigurationService)],p),e.ThemeMainService=p}),define(ee[113],te([0,1,3,18,5,6]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var M;(function(f){f.Http="http",f.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function v(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=v,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=S,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=P;function I(f,p,u,b){if(u===1)return!1;if(u===2&&P(p)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(g?.length===4&&parseInt(g[1])>=18)return!1}return f<1024}e.isPortPrivileged=I;class h{constructor(p,u,b){this.remoteAddress=p,this.localAddress=u,this.b=b,this.a=new E.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=h;let m=class{constructor(p,u){this.i=p,this.j=u,this.a=new E.Emitter,this.onTunnelOpened=this.a.event,this.b=new E.Emitter,this.onTunnelClosed=this.b.event,this.c=new E.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const p=this.j.getValue("remote.localPortHost");return!p||p==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(p){return this.e=p,p?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(p){this.f=p.elevation,this.g=p.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const p=[],u=Array.from(this.d.values());for(const b of u){const g=Array.from(b.values());for(const d of g){const l=await d.value;l&&p.push(l)}}return p}async dispose(){for(const p of this.d.values()){for(const{value:u}of p.values())await u.then(b=>b?.dispose());p.clear()}this.d.clear()}setEnvironmentTunnel(p,u,b,g,d){this.o(p,u,Promise.resolve({tunnelRemoteHost:p,tunnelRemotePort:u,localAddress:b,privacy:g,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(p,u){(P(p)||S(p))&&(p=e.LOCALHOST_ADDRESSES[0]);const b=this.q(p,u);if(b)return++b.refcount,b.value}openTunnel(p,u,b,g,d=!1,l,n){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${b} on local port ${g}.`),!p)return;if(u||(u="localhost"),this.e&&this.h.has(b)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(p,u,b,g,d,l,n);return s?s.then(i=>{if(!i){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,b);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.m(i);return(i.tunnelRemoteHost!==u||i.tunnelRemotePort!==b)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(a),a}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const u=this.d.get(p.tunnelRemoteHost);if(u){const b=u.get(p.tunnelRemotePort);b&&(b.refcount--,await this.n(p.tunnelRemoteHost,p.tunnelRemotePort,b))}}}}async n(p,u,b){if(b.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${u}.`);const g=b.value.then(async d=>{d&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.d.has(p)&&this.d.get(p).delete(u),g}}async closeTunnel(p,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${u} `);const b=this.d.get(p);if(b&&b.has(u)){const g=b.get(u);g.refcount=0,await this.n(p,u,g)}}o(p,u,b){this.d.has(p)||this.d.set(p,new Map),this.d.get(p).set(u,{refcount:1,value:b})}async p(p,u){const b=this.d.get(p);b&&(await b.get(u)||b.delete(u),b.size===0&&this.d.delete(p))}q(p,u){const b=[p];S(p)?(b.push(...e.LOCALHOST_ADDRESSES),b.push(...e.ALL_INTERFACES_ADDRESSES)):P(p)&&b.push(...e.ALL_INTERFACES_ADDRESSES);const g=b.map(d=>this.d.get(d));for(const d of g){const l=d?.get(u);if(l)return l}}canTunnel(p){return!!v(p)}s(p,u,b,g,d,l,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${b} on local port ${g}.`);const s=b;this.h.add(s);const i=g===void 0?b:g,a={elevationRequired:d?this.isPortPrivileged(i):!1},r={remoteAddress:{host:u,port:b},localAddressPort:g,privacy:l,public:l?l!==k.Private:void 0,protocol:n},c=p.forwardPort(r,a);return c?(this.o(u,b,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),c}};m=pe([ie(0,A.ILogService),ie(1,t.IConfigurationService)],m),e.AbstractTunnelService=m}),define(ee[237],te([0,1,78,27,95,221,8,2,18,6,20,220,113,88,4]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function f(d,l,n,s,i){let a;for(let r=3;r&&(a?.dispose(),a=await new p(d,l,n,s,i).waitForReady(),!(i&&C.BROWSER_RESTRICTED_PORTS[i]||!C.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));r--);return a}class p extends k.Disposable{constructor(l,n,s,i,a){super(),this.j=n,this.k=a,this.privacy=I.TunnelPrivacyId.Private,this.i=new Map,this.a=l,this.b=E.createServer(),this.c=new M.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=r=>this.l(r),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(n=>{n()})}async waitForReady(){const l=this.k??this.tunnelRemotePort,n=(0,I.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let s=await(0,C.findFreePortFaster)(l,2,1e3,n),i=null;return this.b.listen(s,this.j),await this.c.wait(),i=this.b.address(),i||(s=0,this.b.listen(s,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(l){l.pause();const n=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,P.connectRemoteAgentTunnel)(this.a,n,this.tunnelRemotePort),i=s.getSocket().socket,a=s.readEntireBuffer();s.dispose(),a.byteLength>0&&l.write(a.buffer),l.on("end",()=>{l.localAddress&&this.i.delete(l.localAddress),i.end()}),l.on("close",()=>i.end()),l.on("error",()=>{l.localAddress&&this.i.delete(l.localAddress),i.destroy()}),i.on("end",()=>l.end()),i.on("close",()=>l.end()),i.on("error",()=>{l.destroy()}),l.pipe(i),i.pipe(l),l.localAddress&&this.i.set(l.localAddress,()=>{l.end(),i.end()})}}let u=class extends I.AbstractTunnelService{constructor(l,n,s,i,a){super(n,a),this.t=l,this.u=s,this.v=i}isPortPrivileged(l){return(0,I.isPortPrivileged)(l,this.k,m.OS,t.release())}r(l,n,s,i,a,r,c){const o=this.q(n,s);if(o)return++o.refcount,o.value;if(this.e)return this.s(this.e,n,s,i,a,r,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${i}.`);const y={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:l,signService:this.u,logService:this.i,ipcLogger:null},D=f(y,this.k,n,s,i);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(n,s,D),D}}};u=pe([ie(1,v.ILogService),ie(2,h.ISignService),ie(3,S.IProductService),ie(4,w.IConfigurationService)],u),e.BaseTunnelService=u;let b=class extends u{constructor(l,n,s,i){super(A.nodeSocketFactory,l,n,s,i)}};b=pe([ie(0,v.ILogService),ie(1,h.ISignService),ie(2,S.IProductService),ie(3,w.IConfigurationService)],b),e.TunnelService=b;let g=class extends k.Disposable{constructor(l,n,s,i){super(),this.b=l,this.c=n,this.f=s,this.g=i,this.a=new Map}async openTunnel(l,n,s,i,a,r,c,o){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${i} on local port ${a}.`),!this.a.has(l)){const y=new b(this.b,this.f,this.c,this.g);this.B(y),this.a.set(l,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(l))})}return this.a.get(l).openTunnel(n,s,i,a,r,c,o)}};g=pe([ie(0,v.ILogService),ie(1,S.IProductService),ie(2,h.ISignService),ie(3,w.IConfigurationService)],g),e.SharedTunnelsService=g}),define(ee[47],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(A){A.Uninitialized="uninitialized",A.Idle="idle",A.CheckingForUpdates="checking for updates",A.AvailableForDownload="available for download",A.Downloading="downloading",A.Downloaded="downloaded",A.Updating="updating",A.Ready="ready"})(t=e.StateType||(e.StateType={}));var C;(function(A){A[A.Setup=0]="Setup",A[A.Archive=1]="Archive",A[A.Snap=2]="Snap"})(C=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(A,M)=>({type:"idle",updateType:A,error:M}),CheckingForUpdates:A=>({type:"checking for updates",explicit:A}),AvailableForDownload:A=>({type:"available for download",update:A}),Downloading:A=>({type:"downloading",update:A}),Downloaded:A=>({type:"downloaded",update:A}),Updating:A=>({type:"updating",update:A}),Ready:A=>({type:"ready",update:A})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(ee[238],te([0,1,4,168,62,46]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),A.Registry.as(C.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[239],te([0,1,3,47]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class C{constructor(k){this.a=k}listen(k,w){switch(w){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${w}`)}call(k,w,v){switch(w){case"checkForUpdates":return this.a.checkForUpdates(v);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(v)}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=C;class A{get state(){return this.b}set state(k){this.b=k,this.a.fire(k)}constructor(k){this.c=k,this.a=new E.Emitter,this.onStateChange=this.a.event,this.b=t.State.Uninitialized,this.c.listen("onStateChange")(w=>this.state=w),this.c.call("_getInitialState").then(w=>this.state=w)}checkForUpdates(k){return this.c.call("checkForUpdates",k)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(k){return this.c.call("_applySpecificUpdate",k)}}e.UpdateChannelClient=A}),define(ee[89],te([0,1,8,22,3,18,26,21,6,20,55,47]),function(q,e,E,t,C,A,M,k,w,v,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function I(m,f,p){return`${p.updateUrl}/api/update/${m}/${f}/${p.commit}`}e.createUpdateURL=I;let h=class{get state(){return this.b}d(f){this.j.info("update#setState",f.type),this.b=f,this.c.fire(f)}constructor(f,p,u,b,g,d){this.f=f,this.g=p,this.h=u,this.i=b,this.j=g,this.k=d,this.b=P.State.Uninitialized,this.c=new C.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const f=this.l(),p=this.m(f);if(!p){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(p),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(P.State.Idle(this.q())),f==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}f==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,u=>this.j.error(u))}l(){return(0,A.getMigratedSettingValue)(this.g,"update.mode","update.channel")}m(f){return f==="none"?void 0:this.k.quality}n(f=60*60*1e3){return(0,E.timeout)(f).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(f){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(f)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(f){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(f=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${f}`),!f&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){return this.a?await this.l()==="none"?!1:(await this.i.request({url:this.a},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(f){}q(){return 1}r(){}};h=pe([ie(0,k.ILifecycleMainService),ie(1,A.IConfigurationService),ie(2,M.IEnvironmentMainService),ie(3,S.IRequestService),ie(4,w.ILogService),ie(5,v.IProductService)],h),e.AbstractUpdateService=h}),define(ee[240],te([0,1,13,53,3,2,18,26,21,6,20,55,35,47,89]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let f=class extends m.AbstractUpdateService{get v(){return C.Event.fromNodeEventEmitter(E.autoUpdater,"error",(u,b)=>b)}get w(){return C.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get x(){return C.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(u,b,g)=>({url:b,version:g,productVersion:g}))}get y(){return C.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(u,b,g,d)=>({releaseNotes:b,version:g,productVersion:g,date:d}))}constructor(u,b,g,d,l,n,s){super(u,b,d,l,n,s),this.A=g,this.u=new A.DisposableStore}async initialize(){await super.initialize(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(u){this.j.error("UpdateService error:",u);const g=(this.state.type==="checking for updates"?this.state.explicit:!0)?u:void 0;this.d(h.State.Idle(1,g))}s(u){let b;this.k.darwinUniversalAssetId?b=this.k.darwinUniversalAssetId:b=process.arch==="x64"?"darwin":"darwin-arm64";const g=(0,m.createUpdateURL)(b,u,this.k);try{E.autoUpdater.setFeedURL({url:g})}catch(d){this.j.error("Failed to set update feed URL",d);return}return g}t(u){this.d(h.State.CheckingForUpdates(u)),E.autoUpdater.checkForUpdates()}E(u){this.state.type==="checking for updates"&&this.d(h.State.Downloading(u))}F(u){this.state.type==="downloading"&&(this.A.publicLog2("update:downloaded",{version:u.version}),this.d(h.State.Ready(u)))}G(){this.state.type==="checking for updates"&&(this.A.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(h.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};pe([t.memoize],f.prototype,"v",null),pe([t.memoize],f.prototype,"w",null),pe([t.memoize],f.prototype,"x",null),pe([t.memoize],f.prototype,"y",null),f=pe([ie(0,w.ILifecycleMainService),ie(1,M.IConfigurationService),ie(2,I.ITelemetryService),ie(3,k.IEnvironmentMainService),ie(4,P.IRequestService),ie(5,v.ILogService),ie(6,S.IProductService)],f),e.DarwinUpdateService=f}),define(ee[241],te([0,1,44,39,8,3,9,26,21,6,35,47]),function(q,e,E,t,C,A,M,k,w,v,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let I=class{get state(){return this.a}d(f){this.g.info("update#setState",f.type),this.a=f,this.b.fire(f)}constructor(f,p,u){if(this.f=f,this.g=u,this.a=P.State.Uninitialized,this.b=new A.Emitter,this.onStateChange=this.b.event,p.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(P.State.Idle(this.k())),this.h(30*1e3).then(void 0,b=>this.g.error(b))}h(f=60*60*1e3){return(0,C.timeout)(f).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(f){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(f)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(f){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(f=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${f}`),!f&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(f){}};I=pe([ie(0,w.ILifecycleMainService),ie(1,k.IEnvironmentMainService),ie(2,v.ILogService)],I);let h=class extends I{constructor(f,p,u,b,g,d){super(u,b,g),this.o=f,this.p=p,this.q=d;const l=(0,t.watch)(M.dirname(this.o)),n=A.Event.fromNodeEventEmitter(l,"change",(r,c)=>c),s=A.Event.filter(n,r=>r==="current"),a=A.Event.debounce(s,(r,c)=>c,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{a.dispose(),l.close()})}m(){this.d(P.State.CheckingForUpdates(!1)),this.u().then(f=>{f?this.d(P.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(P.State.Idle(2)))},f=>{this.g.error(f),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(P.State.Idle(2,f.message||f))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const f=await new Promise((u,b)=>(0,t.realpath)(`${M.dirname(this.o)}/current`,(g,d)=>g?b(g):u(d))),p=M.basename(f);return this.p!==p}isLatestVersion(){return this.u().then(void 0,f=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};h=pe([ie(2,w.ILifecycleMainService),ie(3,k.IEnvironmentMainService),ie(4,v.ILogService),ie(5,S.ITelemetryService)],h),e.SnapUpdateService=h}),define(ee[48],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(ee[242],te([0,1,48,189,16,19,125,3,2]),function(q,e,E,t,C,A,M,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class v{constructor(I){this.uri=I,this.time=v._clock++}touch(){return this.time=v._clock++,this}}v._clock=0;let S=class{constructor(I){this.g=I,this.c=new w.DisposableStore,this.f=2**16;const h=new Map,m=f=>{let p=h.get(f.scheme);return p===void 0&&(p=I.hasProvider(f)&&!this.g.hasCapability(f,1024),h.set(f.scheme,p)),p};this.c.add(k.Event.any(I.onDidChangeFileSystemProviderRegistrations,I.onDidChangeFileSystemProviderCapabilities)(f=>{h.delete(f.scheme)})),this.extUri=new A.ExtUri(m),this.d=new M.SkipList((f,p)=>this.extUri.compare(f,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(I){this.g.hasProvider(I)&&(I=(0,A.normalizePath)(I));const h=this.d.get(I);return h?h.touch().uri.with({fragment:I.fragment}):(this.d.set(I,new v(I)),this.h(),I)}h(){if(this.d.size<this.f)return;const I=[...this.d.entries()].sort((m,f)=>m[1].touch<f[1].touch?1:m[1].touch>f[1].touch?-1:0);v._clock=0,this.d.clear();const h=this.f*.5;for(let m=0;m<h;m++)this.d.set(I[m][0],I[m][1].touch())}};S=pe([ie(0,C.IFileService)],S),e.UriIdentityService=S,(0,t.registerSingleton)(E.IUriIdentityService,S,1)}),define(ee[114],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(ee[243],te([0,1,7]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(k){this.a=k}listen(k,w){throw new Error(`Event not found: ${w}`)}call(k,w,v){switch(w){case"handleURL":return this.a.handleURL(E.URI.revive(v[0]),v[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=t;class C{constructor(k){this.a=k}handleURL(k,w){return this.a.call("handleURL",[k.toJSON(),w])}}e.URLHandlerChannelClient=C;class A{constructor(k){this.a=k}async routeCall(k,w,v,S){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(v){const P=E.URI.revive(v);if(P&&P.query){const I=/\bwindowId=(\d+)/.exec(P.query);if(I){const h=I[1],m=new RegExp(`window:${h}`),f=k.connections.find(p=>m.test(p.ctx));if(f)return f}}}return this.a.routeCall(k,w,v,S)}routeEvent(k,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=A}),define(ee[244],te([0,1,8,2,7,20]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends t.Disposable{constructor(){super(...arguments),this.a=new Set}open(v,S){const P=[...this.a.values()];return(0,E.first)(P.map(I=>()=>I.handleURL(v,S)),void 0,!1).then(I=>I||!1)}registerHandler(v){return this.a.add(v),(0,t.toDisposable)(()=>this.a.delete(v))}}e.AbstractURLService=M;let k=class extends M{constructor(v){super(),this.b=v}create(v){let{authority:S,path:P,query:I,fragment:h}=v||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return S&&P&&P.indexOf("/")!==0&&(P=`/${P}`),C.URI.from({scheme:this.b.urlProtocol,authority:S,path:P,query:I,fragment:h})}};k=pe([ie(0,A.IProductService)],k),e.NativeURLService=k}),define(ee[245],te([0,1,13,8,3,2,4,7]),function(q,e,E,t,C,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(S){try{return k.URI.parse(S)}catch{return null}}class v{constructor(P,I,h,m,f){if(this.f=I,this.a=[],this.b=0,this.c=A.Disposable.None,this.d=new A.DisposableStore,this.a=P,M.isWindows){const b=m.isBuilt?[]:[`"${m.appRoot}"`];b.push("--open-url","--"),E.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,b)}const p=C.Event.map(C.Event.fromNodeEventEmitter(E.app,"open-url",(b,g)=>({event:b,url:g})),({event:b,url:g})=>(b.preventDefault(),g));this.d.add(p(b=>{const g=w(b);!g||this.f.open(g,{originalUrl:b})})),h.getWindows().filter(b=>b.isReady).length>0?this.g():C.Event.once(h.onDidSignalReadyWindow)(this.g,this,this.d)}async g(){if(this.b++>10)return;const P=[];for(const I of this.a)await this.f.open(I.uri,{originalUrl:I.url})||P.push(I);P.length!==0&&(this.a=P,this.c=(0,t.disposableTimeout)(()=>this.g(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=v}),define(ee[246],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(ee[247],te([0,1,13,2,14,7]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends t.Disposable{constructor(){super();const w=this.b.bind(this);E.protocol.registerFileProtocol(C.Schemas.vscodeWebview,w)}b(w,v){try{const S=A.URI.parse(w.url),P=M.a.get(S.path);if(typeof P=="string"){const I=`vs/workbench/contrib/webview/browser/pre/${P}`,h=C.FileAccess.asFileUri(I);return v({path:decodeURIComponent(h.fsPath),headers:{...C.COI.getHeadersFromQuery(w.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return v({error:-10})}catch{}return v({error:-2})}}e.WebviewProtocolProvider=M,M.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ee[74],te([0,1,4]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(S){return!!S.workspaceUri}e.isWorkspaceToOpen=t;function C(S){return!!S.folderUri}e.isFolderToOpen=C;function A(S){return!!S.fileUri}e.isFileToOpen=A;function M(S){const P=k(S),I=S.getValue("window.menuBarVisibility");return I==="default"||P==="native"&&I==="compact"||E.isMacintosh&&E.isNative?"classic":I}e.getMenuBarVisibility=M;function k(S){if(E.isWeb)return"custom";const P=S.getValue("window");if(P){if(E.isMacintosh&&P.nativeTabs===!0||E.isMacintosh&&P.nativeFullScreen===!1)return"native";const m=P.titleBarStyle;if(m==="native"||m==="custom")return m}return E.isLinux?"native":"custom"}e.getTitleBarStyle=k;function w(S){if(!E.isWindows||E.isWeb||k(S)==="native")return!1;const P=S.getValue("window.experimental.windowControlsOverlay.enabled");return typeof P=="boolean"?P:!1}e.useWindowControlsOverlay=w;function v(S=0){return Math.pow(1.2,S)}e.zoomLevelToZoomFactor=v}),define(ee[115],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(k){k[k.INITIAL=1]="INITIAL",k[k.LOAD=2]="LOAD",k[k.RELOAD=3]="RELOAD"})(E=e.LoadReason||(e.LoadReason={}));var t;(function(k){k[k.CLOSE=1]="CLOSE",k[k.QUIT=2]="QUIT",k[k.RELOAD=3]="RELOAD",k[k.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const C=function(k=1){return{width:1024,height:768,mode:k}};e.defaultWindowState=C;var A;(function(k){k[k.Maximized=0]="Maximized",k[k.Normal=1]="Normal",k[k.Minimized=2]="Minimized",k[k.Fullscreen=3]="Fullscreen"})(A=e.WindowMode||(e.WindowMode={}));var M;(function(k){k[k.UNRESPONSIVE=1]="UNRESPONSIVE",k[k.PROCESS_GONE=2]="PROCESS_GONE",k[k.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={}))}),define(ee[31],te([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var t;(function(C){C[C.CLI=0]="CLI",C[C.DOCK=1]="DOCK",C[C.MENU=2]="MENU",C[C.DIALOG=3]="DIALOG",C[C.DESKTOP=4]="DESKTOP",C[C.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(ee[248],te([0,1,13,22,3,67,2,29,70,105,6,20,31]),function(q,e,E,t,C,A,M,k,w,v,S,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var h;(function(f){f[f.Initial=1]="Initial",f[f.StoredCredentialsUsed=2]="StoredCredentialsUsed",f[f.LoginDialogShown=3]="LoginDialogShown"})(h||(h={}));let m=class extends M.Disposable{constructor(p,u,b,g,d){super(),this.g=p,this.h=u,this.i=b,this.j=g,this.k=d,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=h.Initial,this.f=void 0,this.l()}l(){const p=C.Event.fromNodeEventEmitter(E.app,"login",(u,b,g,d,l)=>({event:u,webContents:b,req:g,authInfo:d,callback:l}));this.B(p(this.m,this))}async m({event:p,authInfo:u,req:b,callback:g}){if(!u.isProxy)return;if(!this.b&&this.c===h.LoginDialogShown&&b.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}p.preventDefault();let d;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),d=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(u);try{d=await this.b}finally{this.b=void 0}}g(d?.username,d?.password)}async n(p){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const u=await this.p(p);if(u)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),u;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(p){this.g.trace("auth#doResolveProxyCredentials - enter",p);const u=String((0,A.hash)({scheme:p.scheme,host:p.host,port:p.port}));let b,g;try{const s=await this.i.getPassword(this.a,u);if(s){const i=JSON.parse(await this.j.decrypt(s));b=i.username,g=i.password}}catch(s){this.g.error(s)}if(this.c!==h.StoredCredentialsUsed&&typeof b=="string"&&typeof g=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=h.StoredCredentialsUsed,{username:b,password:g};const d=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!d){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${d.id} to handle proxy login`);const l={authInfo:p,username:this.f?.username??b,password:this.f?.password??g,replyChannel:`vscode:proxyAuthResponse:${(0,k.generateUuid)()}`};d.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,l),this.c=h.LoginDialogShown;const n=await new Promise(s=>{const i=async(a,r,c)=>{if(r===l.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${d.id}`),d.win?.webContents.off("ipc-message",i),c){const o={username:c.username,password:c.password};try{if(c.remember){const y=await this.j.encrypt(JSON.stringify(o));await this.i.setPassword(this.a,u,y)}else await this.i.deletePassword(this.a,u)}catch(y){this.g.error(y)}s({username:o.username,password:o.password})}else s(void 0)};d.win?.webContents.on("ipc-message",i)});return this.f=n,n}};m=pe([ie(0,S.ILogService),ie(1,I.IWindowsMainService),ie(2,w.ICredentialsMainService),ie(3,v.IEncryptionMainService),ie(4,P.IProductService)],m),e.ProxyAuthHandler=m}),define(ee[249],te([0,1,70,6,34,20,31,201]),function(q,e,E,t,C,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let w=class extends k.BaseCredentialsMainService{constructor(S,P,I,h){super(S),this.j=P,this.k=I,this.l=h,this.i=m=>{this.l.sendToFocused("vscode:showCredentialsError",m.message??m)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.InMemoryCredentialsProvider,this.f;const S=await new Promise((P,I)=>{q(["keytar"],P,I)});return await S.findCredentials("test-keytar-loads"),this.f=S,this.f}};w=pe([ie(0,t.ILogService),ie(1,C.INativeEnvironmentService),ie(2,A.IProductService),ie(3,M.IWindowsMainService)],w),e.CredentialsNativeMainService=w}),define(ee[250],te([0,1,15,2,3,6,21,80,44,279,8,14,50,4,32,13,31]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const u=f.utilityProcess,b=typeof u<"u";let g=class Bt{constructor(s,i,a){this.d=s,this.f=a,this.c=!1,this.b=new Map,i.onWillShutdown(r=>{this.c=!0,r.join(this._waitForAllExit(6e3))})}dispose(){}g(s){const i=this.b.get(s);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(s){return this.g(s).onStdout}onDynamicStderr(s){return this.g(s).onStderr}onDynamicMessage(s){return this.g(s).onMessage}onDynamicError(s){return this.g(s).onError}onDynamicExit(s){return this.g(s).onExit}async canUseUtilityProcess(){return b}async createExtensionHost(s){if(this.c)throw(0,E.canceled)();const i=String(++Bt.a);let a;if(s){if(!b)throw new Error("Cannot use UtilityProcess!");a=new l(i,this.d,this.f)}else a=new d(i,this.d);return this.b.set(i,a),a.onExit(({pid:r,code:c,signal:o})=>{this.d.info(`Extension host with pid ${r} exited with code: ${c}, signal: ${o}.`),setTimeout(()=>{a.dispose(),this.b.delete(i)})}),{id:i}}async start(s,i){if(this.c)throw(0,E.canceled)();return this.g(s).start(i)}async enableInspectPort(s){if(this.c)throw(0,E.canceled)();const i=this.b.get(s);return i?i.enableInspectPort():!1}async kill(s){if(this.c)throw(0,E.canceled)();const i=this.b.get(s);!i||i.kill()}async _killAllNow(){for(const[,s]of this.b)s.kill()}async _waitForAllExit(s){const i=[];for(const[,a]of this.b)i.push(a.waitForExit(s));return S.Promises.settled(i).then(()=>{})}};g.a=0,g=pe([ie(0,A.ILogService),ie(1,M.ILifecycleMainService),ie(2,p.IWindowsMainService)],g),e.ExtensionHostStarter=g;let d=class extends t.Disposable{constructor(s,i){super(),this.id=s,this.c=i,this._onStdout=this.B(new C.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new C.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new C.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new C.Emitter),this.onError=this._onError.event,this._onExit=this.B(new C.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(s){h.isCI&&this.c.info("Calling fork to start extension host...");const i=k.StopWatch.create(!1);this.a=(0,w.fork)(P.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,I.mixin)({cwd:(0,m.cwd)()},s));const a=i.elapsed(),r=this.a.pid;this.c.info(`Starting extension host with pid ${r} (fork() took ${a} ms).`);const c=new v.StringDecoder("utf-8");this.a.stdout?.on("data",y=>{const D=typeof y=="string"?y:c.write(y);this._onStdout.fire(D)});const o=new v.StringDecoder("utf-8");this.a.stderr?.on("data",y=>{const D=typeof y=="string"?y:o.write(y);this._onStderr.fire(D)}),this.a.on("message",y=>{this._onMessage.fire(y)}),this.a.on("error",y=>{this._onError.fire({error:(0,E.transformErrorForSerialization)(y)})}),this.a.on("exit",(y,D)=>{this.b=!0,this._onExit.fire({pid:r,code:y,signal:D})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):h.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(s){if(!this.a)return;const i=this.a.pid;this.c.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([C.Event.toPromise(this.onExit),(0,S.timeout)(s)]),this.b||(this.c.info(`Extension host with pid ${i} did not exit within ${s}ms.`),this.a.kill())}};d=pe([ie(1,A.ILogService)],d);let l=class extends t.Disposable{constructor(s,i,a){super(),this.id=s,this.c=i,this.f=a,this.onError=C.Event.None,this._onStdout=this.B(new C.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new C.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new C.Emitter),this.onMessage=this._onMessage.event,this._onExit=this.B(new C.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(s){const i=this.f.getWindowById(s.responseWindowId);if(!i){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const a=i.win;if(!a||a.isDestroyed()||a.webContents.isDestroyed()){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const r=`extensionHost${this.id}`,c=P.FileAccess.asFileUri("bootstrap-fork.js").fsPath,o=["--type=extensionHost","--skipWorkspaceStorageLock"],y=s.execArgv||[],D={...s.env},O=!0,N="pipe";for(const re of Object.keys(D))D[re]=String(D[re]);this.c.info(`UtilityProcess<${this.id}>: Creating new...`),this.a=u.fork(c,o,{serviceName:r,env:D,execArgv:y,allowLoadingUnsignedLibraries:O,stdio:N});const Y=new v.StringDecoder("utf-8");this.a.stdout?.on("data",re=>{const de=typeof re=="string"?re:Y.write(re);this._onStdout.fire(de)});const G=new v.StringDecoder("utf-8");this.a.stderr?.on("data",re=>{const de=typeof re=="string"?re:G.write(re);this._onStderr.fire(de)}),this.a.on("message",re=>{this._onMessage.fire(re)}),this.B(C.Event.fromNodeEventEmitter(this.a,"spawn")(()=>{this.c.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const V=C.Event.fromNodeEventEmitter(this.a,"exit",re=>re);this.B(V(re=>{this.c.info(`UtilityProcess<${this.id}>: received exit event with code ${re}.`),this.b=!0,this._onExit.fire({pid:this.a.pid,code:re,signal:""})}));const{port1:se,port2:oe}=new f.MessageChannelMain;this.a.postMessage("null",[oe]),a.webContents.postMessage(s.responseChannel,s.responseNonce,[se])}enableInspectPort(){return this.a?(this.c.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):!1):!1}kill(){!this.a||(this.c.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(s){if(!this.a)return;const i=this.a.pid;this.c.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([C.Event.toPromise(this.onExit),(0,S.timeout)(s)]),this.b||(this.c.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${s}ms, will kill it now.`),this.a.kill())}};l=pe([ie(1,A.ILogService),ie(2,p.IWindowsMainService)],l)}),define(ee[251],te([0,1,13,24,4,7,23,18,59,5,6,114,31]),function(q,e,E,t,C,A,M,k,w,v,S,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,v.createDecorator)(e.ID);let h=class{constructor(f,p,u,b){this.a=f,this.b=p,this.c=u,this.d=b}async start(f,p){this.a.trace("Received data from other instance: ",f,p),C.isMacintosh&&E.app.focus({steal:!0});const u=this.e(f);if(u.length){let b=Promise.resolve();if(this.b.getWindowCount()===0){const g=(0,t.firstOrDefault)(await this.b.openEmptyWindow({context:4}));g&&(b=g.ready())}b.then(()=>{for(const{uri:g,url:d}of u)this.c.open(g,{originalUrl:d})})}else return this.f(f,p)}e(f){return f["open-url"]&&f._urls&&f._urls.length>0?(0,t.coalesce)(f._urls.map(p=>{try{return{uri:A.URI.parse(p),url:p}}catch{return null}})):[]}async f(f,p){const u=(0,w.isLaunchedFromCli)(p)?0:4;let b=[];const g=f.wait&&f.waitMarkerFilePath?A.URI.file(f.waitMarkerFilePath):void 0,d=f.remote||void 0,l={context:u,cli:f,userEnv:p,waitMarkerFileURI:g,remoteAuthority:d,forceProfile:f.profile,forceTempProfile:f["profile-temp"]};if(f.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(f.extensionDevelopmentPath,l);else if(!f._.length&&!f["folder-uri"]&&!f["file-uri"]){let n=!1;if(f["new-window"]||f["unity-launch"]||l.forceProfile||l.forceTempProfile)n=!0;else if(f["reuse-window"])n=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":n=!0;break;case"off":n=!1;break;default:n=!C.isMacintosh}if(n)b=await this.b.open({...l,forceNewWindow:!0,forceEmpty:!0});else{const s=this.b.getLastActiveWindow();s?(this.b.openExistingWindow(s,l),b=[s]):b=await this.b.open({...l,forceEmpty:!0})}}else b=await this.b.open({...l,forceNewWindow:f["new-window"],preferNewWindow:!f["reuse-window"]&&!f.wait,forceReuseWindow:f["reuse-window"],diffMode:f.diff,mergeMode:f.merge,addMode:f.add,noRecentEntry:!!f["skip-add-to-recently-opened"],gotoLineMode:f.goto});if(g&&b.length===1&&b[0])return Promise.race([b[0].whenClosedOrLoaded,(0,M.whenDeleted)(g.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};h=pe([ie(0,S.ILogService),ie(1,I.IWindowsMainService),ie(2,P.IURLService),ie(3,k.IConfigurationService)],h),e.LaunchMainService=h}),define(ee[252],te([0,1,13,3,2,247,31]),function(q,e,E,t,C,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let k=class extends C.Disposable{constructor(v){super(),this.b=v,this.a=this.B(new t.Emitter),this.onFoundInFrame=this.a.event,this.B(new A.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(v,S){let P;if(typeof v.windowId=="number"){const{windowId:I}=v,h=this.b.getWindowById(I);if(!h?.win)throw new Error(`Invalid windowId: ${I}`);P=h.win.webContents}else{const{webContentsId:I}=v;if(P=E.webContents.fromId(I),!P)throw new Error(`Invalid webContentsId: ${I}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(S)}async findInFrame(v,S,P,I){const m=this.c(v,S);if(typeof m.findInFrame=="function"){m.findInFrame(P,{findNext:I.findNext,forward:I.forward});const f=(p,u)=>{u.finalUpdate&&(this.a.fire(u),m.removeListener("found-in-frame",f))};m.on("found-in-frame",f)}}async stopFindInFrame(v,S,P){const h=this.c(v,S);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(P.keepSelection?"keepSelection":"clearSelection")}c(v,S){const P=this.b.getWindowById(v.windowId);if(!P?.win)throw new Error(`Invalid windowId: ${v}`);const I=P.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===S);if(!I)throw new Error(`Unknown frame: ${S}`);return I}};k=pe([ie(0,M.IWindowsMainService)],k),e.WebviewMainService=k}),define(ee[253],te([0,1,8,3,2]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends C.Disposable{constructor({onDidOpenWindow:k,onDidFocusWindow:w,getActiveWindowId:v}){super(),this.a=this.B(new C.DisposableStore),t.Event.latch(t.Event.any(k,w))(this.f,this,this.a),this.b=(0,E.createCancelablePromise)(()=>v()),(async()=>{try{const P=await this.b;this.c=typeof this.c=="number"?this.c:P}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=A}),define(ee[28],te([0,1,172,9,58,19,7,5,14]),function(q,e,E,t,C,A,M,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function v(s){const i=s;return typeof i?.id=="string"&&M.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=v,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function S(s,i){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,t.basename)(s)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const a=s;if(a.configuration)return{id:a.id,configPath:a.configuration};if(a.folders.length===1)return{id:a.id,uri:a.folders[0].uri}}e.toWorkspaceIdentifier=S;function P(s){const i=s;return typeof i?.id=="string"&&M.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=P;function I(s){const i=s;if(i?.uri)return{id:i.id,uri:M.URI.revive(i.uri)};const a=s;if(a?.configPath)return{id:a.id,configPath:M.URI.revive(a.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=I;var h;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(h=e.WorkbenchState||(e.WorkbenchState={}));function m(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=m;function f(s){const i=s;return!!(i&&typeof i=="object"&&M.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=f;class p{constructor(i,a,r,c,o){this.h=i,this.j=r,this.k=c,this.l=o,this.c=C.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=C.TernarySearchTree.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class u{constructor(i,a){this.raw=a,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,A.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function b(s){return new u({uri:s,index:0,name:(0,A.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(s,i){return A.extUriBiasedIgnorePathCase.isEqualOrParent(s,i.untitledWorkspacesHome)}e.isUntitledWorkspace=g;function d(s){let i;return M.URI.isUri(s)?i=s:i=s.configuration,i?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=d;function l(s,i){return!g(s,i)&&!d(s)}e.isSavedWorkspace=l;function n(s){return(typeof s=="string"?(0,t.extname)(s):(0,A.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(ee[56],te([0,1,13,8,67,33,2,76,4,12,23,149,5,6,28]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,I.createDecorator)("dialogMainService");let f=class{constructor(u){this.d=u,this.a=new Map,this.b=new Map,this.c=new t.Queue}pickFileFolder(u,b){return this.e({...u,pickFolders:!0,pickFiles:!0,title:(0,P.localize)(0,null)},b)}pickFolder(u,b){return this.e({...u,pickFolders:!0,title:(0,P.localize)(1,null)},b)}pickFile(u,b){return this.e({...u,pickFiles:!0,title:(0,P.localize)(2,null)},b)}pickWorkspace(u,b){const g=(0,P.localize)(3,null),d=(0,A.mnemonicButtonLabel)((0,P.localize)(4,null)),l=m.WORKSPACE_FILTER;return this.e({...u,pickFiles:!0,title:g,filters:l,buttonLabel:d},b)}async e(u,b){const g={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(g.properties=void 0,u.pickFiles&&u.pickFolders&&(g.properties=["multiSelections","openDirectory","openFile","createDirectory"])),g.properties||(g.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&g.properties.push("treatPackageAsDirectory");const d=await this.showOpenDialog(g,(0,v.withNullAsUndefined)(b||E.BrowserWindow.getFocusedWindow()));if(d&&d.filePaths&&d.filePaths.length>0)return d.filePaths}f(u){if(u){let b=this.b.get(u.id);return b||(b=new t.Queue,this.b.set(u.id,b)),b}else return this.c}showMessageBox(u,b){return this.f(b).queue(async()=>b?E.dialog.showMessageBox(b,u):E.dialog.showMessageBox(u))}async showSaveDialog(u,b){const g=this.i(u,b);if(!g)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.f(b).queue(async()=>{let d;return b?d=await E.dialog.showSaveDialog(b,u):d=await E.dialog.showSaveDialog(u),d.filePath=this.g(d.filePath),d})}finally{(0,M.dispose)(g)}}g(u){return u&&w.isMacintosh&&(u=(0,k.normalizeNFC)(u)),u}h(u){return u.map(b=>this.g(b))}async showOpenDialog(u,b){u.defaultPath&&(await S.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const g=this.i(u,b);if(!g)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.f(b).queue(async()=>{let d;return b?d=await E.dialog.showOpenDialog(b,u):d=await E.dialog.showOpenDialog(u),d.filePaths=this.h(d.filePaths),d})}finally{(0,M.dispose)(g)}}i(u,b){if(!b)return M.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",u);let g=this.a.get(b.id);g||(g=new Set,this.a.set(b.id,g));const d=(0,C.hash)(u);if(!g.has(d))return this.d.trace("[DialogMainService]: new file dialog lock created",u),g.add(d),(0,M.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",u),g?.delete(d),g?.size===0&&this.a.delete(b.id)})}};f=pe([ie(0,h.ILogService)],f),e.DialogMainService=f}),define(ee[254],te([0,1,3,2,68,28]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends t.Disposable{constructor(w,v){super(),this.f=w,this.g=v,this.b=this.B(new E.Emitter),this.c=new Map,this.h(v.applicationStorage,this.b)}h(w,v){this.B(E.Event.debounce(w.onDidChangeStorage,(S,P)=>(S?S.push(P):S=[P],S),M.a)(S=>{S.length&&v.fire(this.i(S,w))}))}i(w,v){const S=new Map,P=new Set;return w.forEach(I=>{const h=v.get(I.key);typeof h=="string"?S.set(I.key,h):P.add(I.key)}),{changed:Array.from(S.entries()),deleted:Array.from(P.values())}}listen(w,v,S){switch(v){case"onDidChangeStorage":{const P=S.profile?(0,C.revive)(S.profile):void 0;if(!P)return this.b.event;let I=this.c.get(P.id);return I||(I=this.B(new E.Emitter),this.h(this.g.profileStorage(P),I),this.c.set(P.id,I)),I.event}}throw new Error(`Event not found: ${v}`)}async call(w,v,S){const P=S.profile?(0,C.revive)(S.profile):void 0,I=(0,A.reviveIdentifier)(S.workspace),h=await this.j(P,I);switch(v){case"getItems":return Array.from(h.items.entries());case"updateItems":{const m=S;if(m.insert)for(const[f,p]of m.insert)h.set(f,p);m.delete?.forEach(f=>h.delete(f));break}case"isUsed":{const m=S.payload;if(typeof m=="string")return this.g.isUsed(m)}default:throw new Error(`Call not found: ${v}`)}}async j(w,v){let S;v?S=this.g.workspaceStorage(v):w?S=this.g.profileStorage(w):S=this.g.applicationStorage;try{await S.init()}catch(P){this.f.error(`StorageIPC#init: Unable to init ${v?"workspace":w?"profile":"application"} storage due to ${P}`)}return S}}e.StorageDatabaseChannel=M,M.a=100}),define(ee[41],te([0,1,67,3,2,19,7,169,34,16,5,6,28,38,48,8,29,25]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function b(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&M.URI.isUri(i.location)&&M.URI.isUri(i.globalStorageHome)&&M.URI.isUri(i.settingsResource)&&M.URI.isUri(i.keybindingsResource)&&M.URI.isUri(i.tasksResource)&&M.URI.isUri(i.snippetsHome)&&M.URI.isUri(i.extensionsResource))}e.isUserDataProfile=b,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,S.createDecorator)("IUserDataProfilesService");function g(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,location:M.URI.revive(s.location).with({scheme:i}),globalStorageHome:M.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:M.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:M.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:M.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:M.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:M.URI.revive(s.extensionsResource)?.with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.reviveProfile=g;function d(s,i,a,r){return{id:s,name:i,location:a,isDefault:!1,shortName:r?.shortName,globalStorageHome:(0,A.joinPath)(a,"globalStorage"),settingsResource:(0,A.joinPath)(a,"settings.json"),keybindingsResource:(0,A.joinPath)(a,"keybindings.json"),tasksResource:(0,A.joinPath)(a,"tasks.json"),snippetsHome:(0,A.joinPath)(a,"snippets"),extensionsResource:(0,A.joinPath)(a,"extensions.json"),useDefaultFlags:r?.useDefaultFlags,isTransient:r?.transient}}e.toUserDataProfile=d;let l=class extends C.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(i,a,r,c){super(),this.m=i,this.n=a,this.r=r,this.s=c,this.f=!1,this.g=this.B(new t.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new t.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new t.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new t.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,A.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(i){this.f!==i&&(this.t=void 0,this.f=i)}isEnabled(){return this.f}get u(){if(!this.t){const i=this.f?this.I().map(o=>d((0,A.basename)(o.location),o.name,o.location,{shortName:o.shortName,useDefaultFlags:o.useDefaultFlags})):[];let a;const r=new h.ResourceMap,c=d((0,E.hash)(this.m.userRoamingDataHome.path).toString(16),(0,k.localize)(0,null),this.m.userRoamingDataHome);if(i.unshift({...c,isDefault:!0}),i.length){const o=this.L();if(o.workspaces)for(const[y,D]of Object.entries(o.workspaces)){const O=M.URI.parse(y),N=M.URI.parse(D),Y=i.find(G=>this.r.extUri.isEqual(G.location,N));Y&&r.set(O,Y)}if(o.emptyWindow){const y=M.URI.parse(o.emptyWindow);a=i.find(D=>this.r.extUri.isEqual(D.location,y))}}this.t={profiles:i,workspaces:r,emptyWindow:a}}return this.t}async createTransientProfile(i){const a="Temp",r=new RegExp(`${(0,u.escapeRegExpCharacters)(a)}\\s(\\d+)`);let c=0;for(const y of this.profiles){const D=r.exec(y.name),O=D?parseInt(D[1]):0;c=O>c?O:c}const o=`${a} ${c+1}`;return this.createProfile((0,E.hash)((0,p.generateUuid)()).toString(16),o,{transient:!0},i)}async createNamedProfile(i,a,r){return this.createProfile((0,E.hash)((0,p.generateUuid)()).toString(16),i,a,r)}async createProfile(i,a,r,c){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=await this.v(i,a,r);return c&&await this.setProfileForWorkspace(c,o),o}async v(i,a,r){let c=this.k.get(a);return c||(c=(async()=>{try{const o=this.profiles.find(O=>O.name===a||O.id===i);if(o)return o;const y=d(i,a,(0,A.joinPath)(this.profilesHome,i),r);await this.n.createFolder(y.location);const D=[];return this.h.fire({profile:y,join(O){D.push(O)}}),await f.Promises.settled(D),this.D([y],[],[]),y}finally{this.k.delete(a)}})(),this.k.set(a,c)),c}async updateProfile(i,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let r=this.profiles.find(c=>c.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);return r=d(r.id,a.name??r.name,r.location,{shortName:a.shortName??r.shortName,transient:a.transient??r.isTransient,useDefaultFlags:a.useDefaultFlags??r.useDefaultFlags}),this.D([],[],[r]),r}async removeProfile(i){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(i.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(c=>c.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);const r=[];this.i.fire({profile:a,join(c){r.push(c)}});try{await Promise.allSettled(r)}catch(c){this.s.error(c)}a.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const c of[...this.u.workspaces.keys()])a.id===this.u.workspaces.get(c)?.id&&this.u.workspaces.delete(c);this.H(),this.D([],[a],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(a.location,{recursive:!0})}catch(c){this.s.error(c)}}getOrSetProfileForWorkspace(i,a=this.defaultProfile){if(!this.f)return this.defaultProfile;let r=this.w(i);return r||(r=a,this.profiles.length>1&&this.setProfileForWorkspaceSync(i,r)),r}async setProfileForWorkspace(i,a){this.setProfileForWorkspaceSync(i,a)}setProfileForWorkspaceSync(i,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const r=this.profiles.find(c=>c.id===a.id);if(!r)throw new Error(`Profile '${a.name}' does not exist`);this.G(i,r)}unsetWorkspace(i,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.G(i,void 0,a)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.H(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const i=await this.n.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(a=>a.isDirectory&&this.profiles.every(r=>!this.r.extUri.isEqual(r.location,a.resource))).map(a=>this.n.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.l.profiles.filter(a=>!this.C(a));await Promise.allSettled(i.map(a=>this.removeProfile(a)))}w(i){const a=this.y(i);return M.URI.isUri(a)?this.l.workspaces.get(a)??this.u.workspaces.get(a):this.l.emptyWindow??this.u.emptyWindow}y(i){return(0,I.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,I.isWorkspaceIdentifier)(i)?i.configPath:"empty-window"}C(i){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,i.location)||[...this.l.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,i.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,i.location)||[...this.u.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,i.location)))}D(i,a,r){const c=[...this.profiles,...i],o=[];this.l.profiles=[];for(let y of c)y.isDefault||a.some(D=>y.id===D.id)||(y=r.find(D=>y.id===D.id)??y,y.isTransient?this.l.profiles.push(y):o.push({location:y.location,name:y.name,shortName:y.shortName,useDefaultFlags:y.useDefaultFlags}));this.J(o),this.t=void 0,this.F(i,a,r)}F(i,a,r){this.g.fire({added:i,removed:a,updated:r,all:this.profiles})}G(i,a,r){r=a?.isTransient?!0:r,r||this.G(i,void 0,!0);const c=this.y(i),o=r?this.l:this.u;M.URI.isUri(c)?(o.workspaces.delete(c),a&&o.workspaces.set(c,a)):o.emptyWindow=a,r||this.H()}H(){const i={};for(const[r,c]of this.u.workspaces.entries())i[r.toString()]=c.location.toString();const a=this.u.emptyWindow?.location.toString();this.M({workspaces:i,emptyWindow:a}),this.t=void 0}I(){return[]}J(i){throw new Error("not implemented")}L(){return{}}M(i){throw new Error("not implemented")}};l.b="userDataProfiles",l.c="profileAssociations",l=pe([ie(0,w.IEnvironmentService),ie(1,v.IFileService),ie(2,m.IUriIdentityService),ie(3,P.ILogService)],l),e.UserDataProfilesService=l;class n extends l{constructor(){super(...arguments),this.a=[],this.P={}}I(){return this.a}J(i){this.a=i}L(){return this.P}M(i){this.P=i}}e.InMemoryUserDataProfilesService=n}),define(ee[116],te([0,1,24,8,50,17,15,42,135,2,14,9,4,19,187,97,12,7,154,34,110,109,186,16,5,6,20,3,68,87,41,48,184,185]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p,u,b,g,d,l,n,s,i,a,r,c,o,y,D,O,N,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var G;(function(le){function W(L,T){if(L===T)return!0;const U=Object.keys(L),Q=new Set;for(const B of Object.keys(T))Q.add(B);if(U.length!==Q.size)return!1;for(const B of U){if(L[B]!==T[B])return!1;Q.delete(B)}return Q.size===0}le.equals=W})(G=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let V=class extends v.Disposable{constructor(W,L,T,U,Q,B,H,R,F,$,z,J){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=L,this.l=T,this.m=U,this.n=Q,this.p=B,this.r=H,this.s=R,this.t=F,this.u=$,this.v=z,this.w=J,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(re,(0,h.joinPath)(this.m,l.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(re,(0,h.joinPath)(this.m,l.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(oe,this.h)),this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,d.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(W,L,T){const[U,Q]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(L)]),B=T?await this.scanExtensionsUnderDevelopment(W,[...U,...Q]):[];return this.D(U,Q,B,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const L=[];L.push(this.F(!!W.useCache,W.language)),L.push(this.G(W.language,!!W.checkControlFile));const[T,U]=await Promise.all(L);return this.C([...T,...U],0,W,!1)}async scanUserExtensions(W){const L=W.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",L);const T=await this.I(L,!!W.profileLocation,1,!W.includeUninstalled,W.language);let Q=await(W.useCache&&!T.devMode&&T.excludeObsolete?this.j:this.k).scanExtensions(T);return Q=await this.C(Q,1,W,!0),this.s.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment(W,L){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const T=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(U=>U.scheme===S.Schemas.file).map(async U=>{const Q=await this.I(U,!1,1,!0,W.language,!1);return(await this.k.scanOneOrMultipleExtensions(Q)).map(H=>(H.type=L.find(R=>(0,d.areSameExtensions)(R.identifier,H.identifier))?.type??H.type,this.k.validate(H,Q)))}))).flat();return this.C(T,"development",W,!0)}return[]}async scanExistingExtension(W,L,T){const U=await this.I(W,!1,L,!0,T.language),Q=await this.k.scanExtension(U);return!Q||!T.includeInvalid&&!Q.isValid?null:Q}async scanOneOrMultipleExtensions(W,L,T){const U=await this.I(W,!1,L,!0,T.language),Q=await this.k.scanOneOrMultipleExtensions(U);return this.C(Q,L,T,!0)}async scanMetadata(W){const L=(0,h.joinPath)(W,"package.json"),T=(await this.r.readFile(L)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(W,L){const T=(0,h.joinPath)(W,"package.json"),U=(await this.r.readFile(T)).value.toString(),Q=JSON.parse(U);L.isMachineScoped=L.isMachineScoped||void 0,L.isBuiltin=L.isBuiltin||void 0,L.installedTimestamp=L.installedTimestamp||void 0,Q.__metadata={...Q.__metadata,...L},await this.r.writeFile((0,h.joinPath)(W,"package.json"),A.VSBuffer.fromString(JSON.stringify(Q,null,"	")))}async C(W,L,T,U){return T.includeAllVersions||(W=this.D(L===0?W:void 0,L===1?W:void 0,L==="development"?W:void 0,await this.getTargetPlatform(),U)),T.includeInvalid||(W=W.filter(Q=>Q.isValid)),W.sort((Q,B)=>{const H=P.basename(Q.location.fsPath),R=P.basename(B.location.fsPath);return H<R?-1:H>R?1:0})}D(W,L,T,U,Q){const B=(R,F,$)=>{if(R.isValid&&!F.isValid)return!1;if(R.isValid===F.isValid){if(Q&&m.gt(R.manifest.version,F.manifest.version))return this.s.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${R.location.path} with version ${R.manifest.version}`),!1;if(m.eq(R.manifest.version,F.manifest.version)){if(R.type===0)return this.s.debug(`Skipping extension ${F.location.path} in favour of system extension ${R.location.path} with same version`),!1;if(R.targetPlatform===U)return this.s.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return $?this.s.warn(`Overwriting user extension ${R.location.path} with ${F.location.path}.`):this.s.debug(`Overwriting user extension ${R.location.path} with ${F.location.path}.`),!0},H=new Map;return W?.forEach(R=>{const F=l.ExtensionIdentifier.toKey(R.identifier.id),$=H.get(F);(!$||B($,R,!1))&&H.set(F,R)}),L?.forEach(R=>{const F=l.ExtensionIdentifier.toKey(R.identifier.id),$=H.get(F);if(!$&&W&&R.type===0){this.s.debug(`Skipping obsolete system extension ${R.location.path}.`);return}(!$||B($,R,!1))&&H.set(F,R)}),T?.forEach(R=>{const F=l.ExtensionIdentifier.toKey(R.identifier.id),$=H.get(F);(!$||B($,R,!0))&&H.set(F,R),H.set(F,R)}),[...H.values()]}async F(W,L){this.s.trace("Started scanning system extensions");const T=await this.I(this.systemExtensionsLocation,!1,0,!0,L),Q=await(W&&!T.devMode?this.i:this.k).scanExtensions(T);return this.s.trace("Scanned system extensions:",Q.length),Q}async G(W,L){const T=this.t.isBuilt?[]:this.u.builtInExtensions;if(!T?.length)return[];this.s.trace("Started scanning dev system extensions");const U=L?await this.H():{},Q=[],B=u.URI.file(P.normalize(P.join(S.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const R of T){const F=U[R.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":Q.push((0,h.joinPath)(B,R.name));break;default:Q.push(u.URI.file(F));break}}const H=await Promise.all(Q.map(async R=>this.k.scanExtension(await this.I(R,!1,0,!0,W))));return this.s.trace("Scanned dev system extensions:",H.length),(0,E.coalesce)(H)}async H(){try{const W=await this.r.readFile(this.l);return JSON.parse(W.value.toString())}catch{return{}}}async I(W,L,T,U,Q,B=!0){const H=await this.f(Q??I.language),R=await this.J(W),F=L&&!this.v.extUri.isEqual(W,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,$=F?await this.J(F):void 0;return new se(W,R,F,$,L,T,U,B,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,Q,H)}async J(W){try{const L=await this.r.stat(W);if(typeof L.mtime=="number")return L.mtime}catch{}}};V=pe([ie(4,D.IUserDataProfilesService),ie(5,y.IExtensionsProfileScannerService),ie(6,s.IFileService),ie(7,a.ILogService),ie(8,g.IEnvironmentService),ie(9,r.IProductService),ie(10,O.IUriIdentityService),ie(11,i.IInstantiationService)],V),e.AbstractExtensionsScannerService=V;class se{constructor(W,L,T,U,Q,B,H,R,F,$,z,J,ne,j){this.location=W,this.mtime=L,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=U,this.profile=Q,this.type=B,this.excludeObsolete=H,this.validate=R,this.productVersion=F,this.productDate=$,this.productCommit=z,this.devMode=J,this.language=ne,this.translations=j}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,L){return(0,h.isEqual)(W.location,L.location)&&W.mtime===L.mtime&&(0,h.isEqual)(W.applicationExtensionslocation,L.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===L.applicationExtensionslocationMtime&&W.profile===L.profile&&W.type===L.type&&W.excludeObsolete===L.excludeObsolete&&W.validate===L.validate&&W.productVersion===L.productVersion&&W.productDate===L.productDate&&W.productCommit===L.productCommit&&W.devMode===L.devMode&&W.language===L.language&&G.equals(W.translations,L.translations)}}let oe=class extends v.Disposable{constructor(W,L,T,U,Q){super(),this.f=W,this.g=L,this.h=T,this.i=U,this.j=Q}async scanExtensions(W){const L=W.profile?await this.l(W):await this.k(W);let T={};if(W.excludeObsolete&&W.type===1)try{const U=(await this.i.readFile(this.f)).value.toString();T=JSON.parse(U)}catch{}return(0,p.isEmptyObject)(T)?L:L.filter(U=>!T[d.ExtensionKey.create(U).toString()])}async k(W){const L=await this.i.resolve(W.location);if(!L.children?.length)return[];const T=await Promise.all(L.children.map(async U=>{if(!U.isDirectory||W.type===1&&(0,h.basename)(U.resource).indexOf(".")===0)return null;const Q=new se(U.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(Q)}));return(0,E.coalesce)(T).sort((U,Q)=>U.location.path<Q.location.path?-1:1)}async l(W){let L=await this.m(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.h.extUri.isEqual(W.location,W.applicationExtensionslocation)){L=L.filter(U=>!U.metadata?.isApplicationScoped);const T=await this.m(W.applicationExtensionslocation,U=>!!U.metadata?.isApplicationScoped,W);L.push(...T)}return L}async m(W,L,T){const U=await this.g.scanProfileExtensions(W);if(!U.length)return[];const Q=await Promise.all(U.map(async B=>{if(L(B)){const H=new se(B.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(H,B.metadata)}return null}));return(0,E.coalesce)(Q)}async scanOneOrMultipleExtensions(W){try{if(await this.i.exists((0,h.joinPath)(W.location,"package.json"))){const L=await this.scanExtension(W);return L?[L]:[]}else return await this.scanExtensions(W)}catch(L){return this.j.error(`Error scanning extensions at ${W.location.path}:`,(0,M.getErrorMessage)(L)),[]}}async scanExtension(W,L){try{let T=await this.scanExtensionManifest(W.location);if(T){T.publisher||(T.publisher=l.UNDEFINED_PUBLISHER),L=L??T.__metadata,delete T.__metadata;const U=(0,d.getGalleryExtensionId)(T.publisher,T.name),Q=L?.id?{id:U,uuid:L.id}:{id:U},B=L?.isSystem?0:W.type,H=B===0||!!L?.isBuiltin;Y.ImplicitActivationEvents.updateManifest(T),T=await this.n(W.location,T,se.createNlsConfiguration(W));const R={type:B,identifier:Q,manifest:T,location:W.location,isBuiltin:H,targetPlatform:L?.targetPlatform??"undefined",metadata:L,isValid:!0,validations:[]};return W.validate?this.validate(R,W):R}}catch(T){W.type!==0&&this.j.error(T)}return null}validate(W,L){let T=!0;const U=(0,n.validateExtensionManifest)(L.productVersion,L.productDate,L.location,W.manifest,W.isBuiltin);for(const[Q,B]of U)Q===f.default.Error&&(T=!1,this.j.error(this.t(L.location,B)));return W.isValid=T,W.validations=U,W}async scanExtensionManifest(W){const L=(0,h.joinPath)(W,"package.json");let T;try{T=(await this.i.readFile(L)).value.toString()}catch(Q){return(0,s.toFileOperationResult)(Q)!==1&&this.j.error(this.t(W,(0,b.localize)(0,null,L.path,Q.message))),null}let U;try{U=JSON.parse(T)}catch{const B=[];(0,k.parse)(T,B);for(const H of B)this.j.error(this.t(W,(0,b.localize)(1,null,L.path,H.offset,H.length,(0,w.getParseErrorMessage)(H.error))));return null}return(0,k.getNodeType)(U)!=="object"?(this.j.error(this.t(W,(0,b.localize)(2,null,L.path))),null):U}async n(W,L,T){const U=await this.p(W,L,T);if(U)try{const Q=[],B=await this.r(U.default,Q);if(Q.length>0)return Q.forEach(R=>{this.j.error(this.t(W,(0,b.localize)(3,null,U.default?.path,(0,w.getParseErrorMessage)(R.error))))}),L;if((0,k.getNodeType)(U)!=="object")return this.j.error(this.t(W,(0,b.localize)(4,null,U.default?.path))),L;const H=U.values||Object.create(null);return(0,N.localizeManifest)(L,H,B)}catch{}return L}async p(W,L,T){const U=(0,h.joinPath)(W,"package.nls.json"),Q=(F,$)=>{$.forEach(z=>{this.j.error(this.t(W,(0,b.localize)(5,null,F?.path,(0,w.getParseErrorMessage)(z.error))))})},B=F=>{this.j.error(this.t(W,(0,b.localize)(6,null,F?.path)))},H=`${L.publisher}.${L.name}`,R=T.translations[H];if(R)try{const F=u.URI.file(R),$=(await this.i.readFile(F)).value.toString(),z=[],J=(0,k.parse)($,z);return z.length>0?(Q(F,z),{values:void 0,default:U}):(0,k.getNodeType)(J)!=="object"?(B(F),{values:void 0,default:U}):{values:J.contents?J.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.i.exists(U))return;let $;try{$=await this.s(W,T)}catch{return}if(!$.localized)return{values:void 0,default:$.original};try{const z=(await this.i.readFile($.localized)).value.toString(),J=[],ne=(0,k.parse)(z,J);return J.length>0?(Q($.localized,J),{values:void 0,default:$.original}):(0,k.getNodeType)(ne)!=="object"?(B($.localized),{values:void 0,default:$.original}):{values:ne,default:$.original}}catch{return{values:void 0,default:$.original}}}}async r(W,L){if(W)try{const T=(await this.i.readFile(W)).value.toString();return(0,k.parse)(T,L)}catch{}}s(W,L){return new Promise((T,U)=>{const Q=B=>{const H=(0,h.joinPath)(W,`package.nls.${B}.json`);this.i.exists(H).then(R=>{R&&T({localized:H,original:(0,h.joinPath)(W,"package.nls.json")});const F=B.lastIndexOf("-");F===-1?T({localized:(0,h.joinPath)(W,"package.nls.json"),original:null}):(B=B.substring(0,F),Q(B))})};if(L.devMode||L.pseudo||!L.language)return T({localized:(0,h.joinPath)(W,"package.nls.json"),original:null});Q(L.language)})}t(W,L){return`[${W.path}]: ${L}`}};oe=pe([ie(1,y.IExtensionsProfileScannerService),ie(2,O.IUriIdentityService),ie(3,s.IFileService),ie(4,a.ILogService)],oe);let re=class extends oe{constructor(W,L,T,U,Q,B){super(L,T,U,Q,B),this.y=W,this.v=this.B(new t.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(W){const L=await this.C();if(this.u=W,L&&L.input&&se.equals(L.input,this.u))return this.v.trigger(()=>this.F()),L.result.map(U=>(U.location=u.URI.revive(U.location),U));const T=await super.scanExtensions(W);return await this.D({input:W,result:T}),T}async C(){try{const W=await this.i.readFile(this.y),L=JSON.parse(W.value.toString());return{result:L.result,input:(0,o.revive)(L.input)}}catch(W){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,M.getErrorMessage)(W))}return null}async D(W){try{await this.i.writeFile(this.y,A.VSBuffer.fromString(JSON.stringify(W)))}catch(L){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,M.getErrorMessage)(L))}}async F(){if(!this.u)return;const W=await this.C();if(!W)return;const L=W.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!C.equals(T,L))try{await this.i.del(this.y),this.w.fire()}catch(U){this.j.error(U)}}};re=pe([ie(2,y.IExtensionsProfileScannerService),ie(3,O.IUriIdentityService),ie(4,s.IFileService),ie(5,a.ILogService)],re);function de(le,W){const L=(0,d.getExtensionId)(le.manifest.publisher,le.manifest.name);return{id:L,identifier:new l.ExtensionIdentifier(L),isBuiltin:le.type===0,isUserBuiltin:le.type===1&&le.isBuiltin,isUnderDevelopment:W,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,...le.manifest}}e.toExtensionDescription=de;class X extends V{constructor(W,L,T,U,Q,B,H,R,F,$,z,J){super(W,L,(0,h.joinPath)(T,".vscode-oss-dev","extensions","control.json"),(0,h.joinPath)(U,l.MANIFEST_CACHE_FOLDER),Q,B,H,R,F,$,z,J),this.L=(async()=>{if(I.translationsConfigFile)try{const ne=await this.r.readFile(u.URI.file(I.translationsConfigFile));return JSON.parse(ne.value.toString())}catch{}return Object.create(null)})()}f(W){return this.L}}e.NativeExtensionsScannerService=X}),define(ee[255],te([0,1,7,34,87,116,16,5,6,20,48,41]),function(q,e,E,t,C,A,M,k,w,v,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let I=class extends A.NativeExtensionsScannerService{constructor(m,f,p,u,b,g,d,l){super(E.URI.file(b.builtinExtensionsPath),E.URI.file(b.extensionsPath),b.userHome,E.URI.file(b.userDataPath),m,f,p,u,b,g,d,l)}};I=pe([ie(0,P.IUserDataProfilesService),ie(1,C.IExtensionsProfileScannerService),ie(2,M.IFileService),ie(3,w.ILogService),ie(4,t.INativeEnvironmentService),ie(5,v.IProductService),ie(6,S.IUriIdentityService),ie(7,k.IInstantiationService)],I),e.ExtensionsScannerService=I}),define(ee[256],te([0,1,13,2,14,9,4,58,7,29,40,34,6,41]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let m=class extends t.Disposable{constructor(p,u,b){super(),this.c=p,this.f=b,this.a=k.TernarySearchTree.forPaths(!M.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(p.appRoot),this.addValidFileRoot(p.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(p.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:p}=E.session;p.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(u,b)=>this.i(u,b)),p.protocol.interceptFileProtocol(C.Schemas.file,(u,b)=>this.h(u,b)),this.B((0,t.toDisposable)(()=>{p.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),p.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(p){const u=(0,A.normalize)(p);return this.a.get(u)?t.Disposable.None:(this.a.set(u,!0),(0,t.toDisposable)(()=>this.a.delete(u)))}h(p,u){const b=w.URI.parse(p.url);return this.f.error(`Refused to load resource ${b.fsPath} from ${C.Schemas.file}: protocol (original URL: ${p.url})`),u({error:-3})}i(p,u){const b=this.j(p);let g;return this.c.crossOriginIsolated&&((0,A.basename)(b)==="workbench.html"||(0,A.basename)(b)==="workbench-dev.html"?g=C.COI.CoopAndCoep:g=C.COI.getHeadersFromQuery(p.url)),this.a.findSubstr(b)?u({path:b,headers:g}):this.b.has((0,A.extname)(b).toLowerCase())?u({path:b}):(this.f.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${b} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${p.url})`),u({error:-3}))}j(p){const u=w.URI.parse(p.url),b=C.FileAccess.uriToFileUri(u);return(0,A.normalize)(b.fsPath)}createIPCObjectUrl(){let p;const u=w.URI.from({scheme:"vscode",path:(0,v.generateUuid)()}),b=u.toString(),g=async()=>p;return S.validatedIpcMain.handle(b,g),this.f.trace(`IPC Object URL: Registered new channel ${b}.`),{resource:u,update:d=>p=d,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${b}.`),S.validatedIpcMain.removeHandler(b)}}}};m=pe([ie(0,P.INativeEnvironmentService),ie(1,h.IUserDataProfilesService),ie(2,I.ILogService)],m),e.ProtocolMainService=m}),define(ee[257],te([0,1,13,40,8,3,2,14,12,102,26,21,6,54,61,64,43,41,36]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends M.Disposable{constructor(l,n,s,i,a,r,c,o,y){super(),this.g=l,this.h=n,this.i=s,this.j=i,this.k=a,this.l=r,this.m=c,this.n=o,this.p=y,this.a=new C.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new A.Emitter),this.onDidError=A.Event.buffer(this.f.event),this.w=void 0,this.y=void 0,this.r()}r(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(l,n)=>this.s(l,n)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(l,n)=>this.t(l,n)),this.B(this.k.onWillShutdown(()=>this.u()))}async s(l,n){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const s=await this.connect();if(l.sender.isDestroyed())return s.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",n,[s])}t(l,n){this.l.trace("SharedProcess: onWorkerConnection",n);const s=new M.DisposableStore,i=r=>{!this.G()||(this.l.trace(`SharedProcess: disposing worker (reason: '${r}')`,n),s.dispose(),this.v("vscode:electron-main->shared-process=disposeWorker",n))},a=E.BrowserWindow.fromId(n.reply.windowId);if(!a||a.isDestroyed()||a.webContents.isDestroyed()||!n.reply.channel){i("unavailable");return}s.add(A.Event.filter(this.k.onWillLoadWindow,r=>r.window.win===a)(()=>i("load"))),s.add(A.Event.fromNodeEventEmitter(a,"closed")(()=>i("closed"))),a.webContents.postMessage(n.reply.channel,n.reply.nonce,l.ports)}u(){const l=this.b;!l||(this.v("vscode:electron-main->shared-process=exit"),this.c&&(l.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{l.close()}catch{}this.b=void 0},0))}v(l,...n){if(!this.G()){this.l.warn(`Sending IPC message to channel '${l}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(l,...n)}catch(s){this.l.warn(`Error sending IPC message to channel '${l}' of shared process: ${(0,p.toErrorMessage)(s)}`)}}whenReady(){return this.w||(this.w=new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),l()}))),this.w}get C(){return this.y||(this.y=(async()=>{await this.a.wait(),this.D(),this.F(),await new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),l()}))})()),this.y}D(){const l=this.B(this.p.createIPCObjectUrl());this.b=new E.BrowserWindow({show:!1,backgroundColor:this.n.getBackgroundColor(),webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),l.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.l.getLevel(),product:h.default,policiesData:this.m.serialize()}),this.b.loadURL(k.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}F(){!this.b||(this.c=l=>{this.l.trace("SharedProcess#close prevented"),l.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(l,n)=>this.f.fire({type:2,details:n})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(l,n,s)=>this.f.fire({type:3,details:{reason:s,exitCode:n}})))}async connect(){await this.C;const l=(0,w.assertIsDefined)(this.b);return(0,v.connect)(l)}async toggle(){await this.C,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}G(){const l=this.b;return l?!l.isDestroyed()&&!l.webContents.isDestroyed():!1}};g=pe([ie(2,S.IEnvironmentMainService),ie(3,u.IUserDataProfilesService),ie(4,P.ILifecycleMainService),ie(5,I.ILogService),ie(6,b.IPolicyService),ie(7,f.IThemeMainService),ie(8,m.IProtocolMainService)],g),e.SharedProcess=g}),define(ee[90],te([0,1,8,3,2,72,12,103,5,41]),function(q,e,E,t,C,A,M,k,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,w.createDecorator)("storageService");var S;(function(b){b[b.NONE=0]="NONE",b[b.SHUTDOWN=1]="SHUTDOWN"})(S=e.WillSaveStateReason||(e.WillSaveStateReason={}));var P;(function(b){b[b.APPLICATION=-1]="APPLICATION",b[b.PROFILE=0]="PROFILE",b[b.WORKSPACE=1]="WORKSPACE"})(P=e.StorageScope||(e.StorageScope={}));var I;(function(b){b[b.USER=0]="USER",b[b.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));function h(b){const g=b.get(e.TARGET_KEY);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.loadKeyTargets=h;class m extends C.Disposable{constructor(g={flushInterval:m.a}){super(),this.j=g,this.b=this.B(new t.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new t.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new t.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new E.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new C.MutableDisposable),this.u=void 0,this.w=void 0,this.C=void 0}k(){this.i.value=(0,E.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,C.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(g,d){if(d===e.TARGET_KEY){switch(g){case-1:this.C=void 0;break;case 0:this.w=void 0;break;case 1:this.u=void 0;break}this.c.fire({scope:g})}else this.b.fire({scope:g,key:d,target:this.F(g)[d]})}emitWillSaveState(g){this.f.fire({reason:g})}get(g,d,l){return this.L(d)?.get(g,l)}getBoolean(g,d,l){return this.L(d)?.getBoolean(g,l)}getNumber(g,d,l){return this.L(d)?.getNumber(g,l)}store(g,d,l,n){if((0,M.isUndefinedOrNull)(d)){this.remove(g,l);return}this.r(()=>{this.t(g,l,n),this.L(l)?.set(g,d)})}remove(g,d){this.r(()=>{this.t(g,d,void 0),this.L(d)?.delete(g)})}r(g){this.b.pause(),this.c.pause();try{g()}finally{this.b.resume(),this.c.resume()}}keys(g,d){const l=[],n=this.F(g);for(const s of Object.keys(n))n[s]===d&&l.push(s);return l}t(g,d,l){const n=this.F(d);typeof l=="number"?n[g]!==l&&(n[g]=l,this.L(d)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[g]=="number"&&(delete n[g],this.L(d)?.set(e.TARGET_KEY,JSON.stringify(n)))}get v(){return this.u||(this.u=this.G(1)),this.u}get y(){return this.w||(this.w=this.G(0)),this.w}get D(){return this.C||(this.C=this.G(-1)),this.C}F(g){switch(g){case-1:return this.D;case 0:return this.y;default:return this.v}}G(g){const d=this.L(g);return d?h(d):Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=S.NONE){this.f.fire({reason:g});const d=this.L(-1),l=this.L(0),n=this.L(1);switch(g){case S.NONE:await E.Promises.settled([d?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await E.Promises.settled([d?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.L(-1)?.items??new Map,d=this.L(0)?.items??new Map,l=this.L(1)?.items??new Map;return u(g,d,l,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(g,d){return this.emitWillSaveState(S.NONE),(0,v.isUserDataProfile)(g)?this.N(g,d):this.O(g,d)}H(g,d){return!(g.id===d.id||f(d)&&f(g))}I(g,d,l,n){this.r(()=>{if(n)for(const[s,i]of g)d.set(s,i);else{const s=new Set;for(const[i,a]of g)s.add(i),d.get(i)!==a&&this.n(l,i);for(const[i]of d.items)s.has(i)||this.n(l,i)}})}}e.AbstractStorageService=m,m.a=60*1e3;function f(b){return b.isDefault||!!b.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=f;class p extends m{constructor(){super(),this.p=this.B(new k.Storage(new k.InMemoryStorageDatabase)),this.P=this.B(new k.Storage(new k.InMemoryStorageDatabase)),this.Q=this.B(new k.Storage(new k.InMemoryStorageDatabase)),this.B(this.Q.onDidChangeStorage(g=>this.n(1,g))),this.B(this.P.onDidChangeStorage(g=>this.n(0,g))),this.B(this.p.onDidChangeStorage(g=>this.n(-1,g)))}L(g){switch(g){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(g){return!1}}e.InMemoryStorageService=p;async function u(b,g,d,l,n,s){const i=Y=>{try{return JSON.parse(Y)}catch{return Y}},a=new Map,r=new Map;b.forEach((Y,G)=>{a.set(G,Y),r.set(G,i(Y))});const c=new Map,o=new Map;g.forEach((Y,G)=>{c.set(G,Y),o.set(G,i(Y))});const y=new Map,D=new Map;d.forEach((Y,G)=>{y.set(G,Y),D.set(G,i(Y))}),console.group(l!==n?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const O=[];if(a.forEach((Y,G)=>{O.push({key:G,value:Y})}),console.table(O),console.groupEnd(),console.log(r),l!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const Y=[];c.forEach((G,V)=>{Y.push({key:V,value:G})}),console.table(Y),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${s})`);const N=[];y.forEach((Y,G)=>{N.push({key:G,value:Y})}),console.table(N),console.groupEnd(),console.log(D)}e.logStorage=u}),define(ee[258],te([0,1,24,8,3,2,9,80,7,23,103,146,6,90,35,28]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class p extends A.Disposable{get storage(){return this.f}constructor(s,i){super(),this.j=s,this.k=i,this.b=this.B(new C.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new C.Emitter),this.onDidCloseStorage=this.c.event,this.f=new S.Storage(new S.InMemoryStorageDatabase),this.g=void 0,this.h=new t.DeferredPromise,this.whenInit=this.h.p,this.i=S.StorageState.None}init(){return this.g||(this.g=(async()=>{if(this.i===S.StorageState.None)try{const s=await this.n();this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(a=>this.b.fire({key:a}))),await this.m(s);const i=s.getBoolean(h.IS_NEW_KEY);i===void 0?s.set(h.IS_NEW_KEY,!0):i&&s.set(h.IS_NEW_KEY,!1)}catch(s){this.j.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.i=S.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===I.LogLevel.Trace?s=>this.j.trace(s):void 0,logError:s=>this.j.error(s)}}m(s){return s.init()}get items(){return this.f.items}get(s,i){return this.f.get(s,i)}set(s,i){return this.f.set(s,i)}delete(s){return this.f.delete(s)}async close(){const s=new k.StopWatch(!1);await this.s(),s.stop(),s.elapsed()>p.a&&await this.r(s),this.c.fire()}async r(s){if(!!this.path)try{const i=(0,E.top)(Array.from(this.f.items.entries()).map(([r,c])=>({key:r,length:c.length})),(r,c)=>c.length-r.length,5).map(r=>`${r.key}:${r.length}`).join(", "),a=(await this.k.stat(w.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${a}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async s(){this.g&&await this.g,this.i=S.StorageState.Closed,await this.f.close()}}p.a=2e3;class u extends p{get path(){if(!this.v.useInMemoryStorage)return(0,M.join)(this.u.globalStorageHome.fsPath,u.t)}constructor(s,i,a,r){super(a,r),this.u=s,this.v=i}async n(){return new S.Storage(new P.SQLiteStorageDatabase(this.path??P.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}))}}u.t="state.vscdb";class b extends u{constructor(s,i,a,r){super(s,i,a,r)}}e.ProfileStorageMain=b;class g extends u{constructor(s,i,a,r){super(i.defaultProfile,s,a,r)}async m(s){await super.m(s),this.C(s)}C(s){s.get(m.firstSessionDateStorageKey,void 0)===void 0&&s.set(m.firstSessionDateStorageKey,new Date().toUTCString());const a=s.get(m.currentSessionDateStorageKey,void 0),r=new Date().toUTCString();s.set(m.lastSessionDateStorageKey,typeof a>"u"?null:a),s.set(m.currentSessionDateStorageKey,r)}}e.ApplicationStorageMain=g;class d extends p{get path(){if(!this.w.useInMemoryStorage)return(0,M.join)(this.y.workspaceStorageHome.fsPath,this.v.id,d.t)}constructor(s,i,a,r,c){super(a,c),this.v=s,this.w=i,this.y=r}async n(){const{storageFilePath:s,wasCreated:i}=await this.D();return new S.Storage(new P.SQLiteStorageDatabase(s,{logging:this.l()}),{hint:i?S.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async D(){if(this.w.useInMemoryStorage)return{storageFilePath:P.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const s=(0,M.join)(this.y.workspaceStorageHome.fsPath,this.v.id),i=(0,M.join)(s,d.t);return await v.Promises.exists(s)?{storageFilePath:i,wasCreated:!1}:(await v.Promises.mkdir(s,{recursive:!0}),this.F(s),{storageFilePath:i,wasCreated:!0})}async F(s){let i;if((0,f.isSingleFolderWorkspaceIdentifier)(this.v)?i={folder:this.v.uri.toString()}:(0,f.isWorkspaceIdentifier)(this.v)&&(i={workspace:this.v.configPath.toString()}),i)try{const a=(0,M.join)(s,d.u);await v.Promises.exists(a)||await v.Promises.writeFile(a,JSON.stringify(i,void 0,2))}catch(a){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${a}`)}}}e.WorkspaceStorageMain=d,d.t="state.vscdb",d.u="workspace.json";class l extends p{get path(){}async n(){return new S.Storage(new S.InMemoryStorageDatabase)}}e.InMemoryStorageMain=l}),define(ee[259],te([0,1,3,2,90]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class A extends t.Disposable{constructor(k,w,v){super(),this.b=k,this.c=w,this.f=v;const S=this.B(new t.MutableDisposable);this.a=this.B(new E.Emitter({onWillAddFirstListener:()=>S.value=this.g(),onDidRemoveLastListener:()=>S.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const k=new t.DisposableStore;return k.add(E.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(w,v)=>(w?w.push(v.key):w=[v.key],w),100)(w=>this.h(w))),k.add(E.Event.debounce(this.b.onDidChangeProfileStorage,(w,v)=>{w||(w=new Map);let S=w.get(v.profile.id);return S||w.set(v.profile.id,S={profile:v.profile,keys:[],storage:v.storage}),S.keys.push(v.key),w},100)(w=>this.i(w))),k}h(k){const w=k.includes(C.TARGET_KEY)?[this.c.defaultProfile]:[],v=[];if(k=k.filter(S=>S!==C.TARGET_KEY),k.length){const S=(0,C.loadKeyTargets)(this.b.applicationStorage.storage);v.push({profile:this.c.defaultProfile,changes:k.map(P=>({key:P,scope:0,target:S[P]}))})}this.j(w,v)}i(k){const w=[],v=new Map;for(const[S,P]of k.entries()){P.keys.includes(C.TARGET_KEY)&&w.push(P.profile);const I=P.keys.filter(h=>h!==C.TARGET_KEY);if(I.length){const h=(0,C.loadKeyTargets)(P.storage.storage);v.set(S,{profile:P.profile,changes:I.map(m=>({key:m,scope:0,target:h[m]}))})}}this.j(w,[...v.values()])}j(k,w){(k.length||w.length)&&this.a.fire({valueChanges:w,targetChanges:k})}listen(k,w,v){switch(w){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${w}`)}async call(k,w){throw new Error(`Call not found: ${w}`)}}e.ProfileStorageChangesListenerChannel=A}),define(ee[260],te([0,1,68,34,16,6,228,48,41]),function(q,e,E,t,C,A,M,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let v=class Lt extends w.UserDataProfilesService{constructor(P,I,h,m,f){super(h,m,I,f),this.a=P}I(){return(0,E.revive)(this.a.getItem(Lt.b,[]))}L(){return(0,E.revive)(this.a.getItem(Lt.c,{}))}};v=pe([ie(0,M.IStateService),ie(1,k.IUriIdentityService),ie(2,t.IEnvironmentService),ie(3,C.IFileService),ie(4,A.ILogService)],v),e.UserDataProfilesService=v}),define(ee[51],te([0,1,7,34,16,5,6,37,48,41,260]),function(q,e,E,t,C,A,M,k,w,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,A.refineServiceDecorator)(v.IUserDataProfilesService);let P=class ft extends S.UserDataProfilesService{constructor(h,m,f,p,u){super(h,m,f,p,u),this.P=h}setEnablement(h){super.setEnablement(h),this.f||(this.J([]),this.M({}))}J(h){h.length?this.P.setItem(ft.b,h):this.P.removeItem(ft.b)}M(h){h.emptyWindow||h.workspaces?this.P.setItem(ft.c,h):this.P.removeItem(ft.c)}L(){const h="workspaceAndProfileInfo",m=this.P.getItem(h,void 0);if(m){this.P.removeItem(h);const f=m.reduce((p,{workspace:u,profile:b})=>(p[E.URI.revive(u).toString()]=E.URI.revive(b).toString(),p),{});this.P.setItem(ft.c,{workspaces:f})}return super.L()}};P=pe([ie(0,k.IStateMainService),ie(1,w.IUriIdentityService),ie(2,t.IEnvironmentService),ie(3,C.IFileService),ie(4,M.ILogService)],P),e.UserDataProfilesMainService=P}),define(ee[91],te([0,1,7,49,3,2,34,16,5,21,6,90,258,41,51,48]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,w.createDecorator)("storageMainService");let p=class extends A.Disposable{constructor(g,d,l,n,s,i){super(),this.c=g,this.f=d,this.g=l,this.h=n,this.i=s,this.j=i,this.a=void 0,this.b=this.B(new C.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(g=>{g.window.profile&&this.profileStorage(g.window.profile).init(),g.workspace&&this.workspaceStorage(g.workspace).init()})),this.B(this.h.onWillShutdown(g=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=g.reason,g.join(this.applicationStorage.close());for(const[,d]of this.n)g.join(d.close());for(const[,d]of this.r)g.join(d.close())})),this.B(this.g.onWillCreateProfile(g=>{g.join((async()=>{await this.i.exists(g.profile.globalStorageHome)||await this.i.createFolder(g.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(g=>{const d=this.n.get(g.profile.id);d&&g.join(d.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const g=new I.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,t.once)(g.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),g}profileStorage(g){if((0,P.isProfileUsingDefaultStorage)(g))return this.applicationStorage;let d=this.n.get(g.id);if(!d){this.c.trace(`StorageMainService: creating profile storage (${g.name})`),d=this.p(g),this.n.set(g.id,d);const l=this.B(d.onDidChangeStorage(n=>this.b.fire({...n,storage:d,profile:g})));(0,t.once)(d.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${g.name})`),this.n.delete(g.id),l.dispose()})}return d}p(g){return this.a===2?new I.InMemoryStorageMain(this.c,this.i):new I.ProfileStorageMain(g,this.k(),this.c,this.i)}workspaceStorage(g){let d=this.r.get(g.id);return d||(this.c.trace(`StorageMainService: creating workspace storage (${g.id})`),d=this.s(g),this.r.set(g.id,d),(0,t.once)(d.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${g.id})`),this.r.delete(g.id)})),d}s(g){return this.a===2?new I.InMemoryStorageMain(this.c,this.i):new I.WorkspaceStorageMain(g,this.k(),this.c,this.f,this.i)}isUsed(g){const d=E.URI.file(g);for(const l of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!l.path&&this.j.extUri.isEqualOrParent(E.URI.file(l.path),d))return!0;return!1}};p=pe([ie(0,S.ILogService),ie(1,M.IEnvironmentService),ie(2,m.IUserDataProfilesMainService),ie(3,v.ILifecycleMainService),ie(4,k.IFileService),ie(5,f.IUriIdentityService)],p),e.StorageMainService=p,e.IApplicationStorageMainService=(0,w.createDecorator)("applicationStorageMainService");let u=class extends P.AbstractStorageService{constructor(g,d){super(),this.p=g,this.s=d,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(g){if(g===-1)return this.s.applicationStorage.storage}M(g){if(g===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};u=pe([ie(0,h.IUserDataProfilesService),ie(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(ee[261],te([0,1,2,21,51]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let A=class extends E.Disposable{constructor(k,w){super(),this.a=w,this.B(k.onWillLoadWindow(v=>{v.reason===2&&this.b(v.window.openedWorkspace??"empty-window")})),this.B(k.onBeforeCloseWindow(v=>this.b(v.openedWorkspace??"empty-window")))}async b(k){this.a.getOrSetProfileForWorkspace(k).isTransient&&(this.a.unsetWorkspace(k,!0),await this.a.cleanUpTransientProfiles())}};A=pe([ie(0,t.ILifecycleMainService),ie(1,C.IUserDataProfilesMainService)],A),e.UserDataTransientProfilesHandler=A}),define(ee[117],te([0,1,19,7,28]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function A(w,v,S){for(const I of w){const h=I.openedWorkspace;if((0,C.isWorkspaceIdentifier)(h)){const m=await S(h);if(m){if(m.folders.some(f=>E.extUriBiasedIgnorePathCase.isEqualOrParent(v,f.uri)))return I}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(v,h.configPath))return I}}const P=w.filter(I=>(0,C.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(v,I.openedWorkspace.uri));if(P.length)return P.sort((I,h)=>-(I.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=A;function M(w,v){for(const S of w)if((0,C.isWorkspaceIdentifier)(S.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(S.openedWorkspace.configPath,v)||(0,C.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(S.openedWorkspace.uri,v))return S}e.findWindowOnWorkspaceOrFolder=M;function k(w,v){const S=P=>v.some(I=>E.extUriBiasedIgnorePathCase.isEqual(t.URI.file(I),t.URI.file(P)));for(const P of w)if(P.config?.extensionDevelopmentPath?.some(I=>S(I)))return P}e.findWindowOnExtensionDevelopmentPath=k}),define(ee[262],te([0,1,13,2,4,19,7,18,21,6,37,31,115,28]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let m=class Ot extends t.Disposable{get state(){return this.b}constructor(d,l,n,s,i){super(),this.g=d,this.h=l,this.i=n,this.j=s,this.k=i,this.b=f(this.h.getItem(Ot.a)),this.c=void 0,this.f=!1,this.l()}l(){E.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(d=>this.p(d)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(d=>{d.newCount-d.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(d=>this.p(d))}m(){this.f=!0,this.n()}n(){const d=new Set,l={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!l.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(a=>!a.isExtensionDevelopmentHost)),i&&(l.lastActiveWindow=this.r(i),l.lastActiveWindow.uiState.mode===3&&d.add(l.lastActiveWindow.uiState.display))}const n=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);n&&(l.lastPluginDevelopmentHostWindow=this.r(n),l.lastPluginDevelopmentHostWindow.uiState.mode===3&&(d.has(l.lastPluginDevelopmentHostWindow.uiState.display)?C.isMacintosh&&!n.win?.isSimpleFullScreen()&&(l.lastPluginDevelopmentHostWindow.uiState.mode=1):d.add(l.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(l.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const a=this.r(i);return a.uiState.mode===3&&(d.has(a.uiState.display)?C.isMacintosh&&a.windowId!==l.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(a.uiState.mode=1):d.add(a.uiState.display)),a}));const s=u(l);this.h.setItem(Ot.a,s),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",s)}p(d){if(this.i.quitRequested)return;const l=this.r(d);d.isExtensionDevelopmentHost&&!d.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=l:!d.isExtensionDevelopmentHost&&d.openedWorkspace&&this.b.openedWindows.forEach(n=>{const s=(0,h.isWorkspaceIdentifier)(d.openedWorkspace)&&n.workspace?.id===d.openedWorkspace.id,i=(0,h.isSingleFolderWorkspaceIdentifier)(d.openedWorkspace)&&n.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(n.folderUri,d.openedWorkspace.uri);(s||i)&&(n.uiState=l.uiState)}),this.g.getWindowCount()===1&&(this.c=l)}r(d){return{windowId:d.id,workspace:(0,h.isWorkspaceIdentifier)(d.openedWorkspace)?d.openedWorkspace:void 0,folderUri:(0,h.isSingleFolderWorkspaceIdentifier)(d.openedWorkspace)?d.openedWorkspace.uri:void 0,backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.serializeWindowState()}}getNewWindowState(d){const l=this.s(d),n=this.k.getValue("window");if(l.mode===3){let s;l.hasDefaultState?s=!!(n?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(n.newWindowDimensions)>=0):s=!!(this.i.wasRestarted||n?.restoreFullscreen),s||(l.mode=1)}return l}s(d){const l=this.g.getLastActiveWindow();if(!d.extensionTestsPath){if(!!d.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=d.workspace;if((0,h.isWorkspaceIdentifier)(c)){const y=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===c.id).map(D=>D.uiState);if(y.length)return y[0]}if((0,h.isSingleFolderWorkspaceIdentifier)(c)){const y=this.state.openedWindows.filter(D=>D.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(D.folderUri,c.uri)).map(D=>D.uiState);if(y.length)return y[0]}else if(d.backupPath){const y=this.state.openedWindows.filter(D=>D.backupPath===d.backupPath).map(D=>D.uiState);if(y.length)return y[0]}const o=this.c||this.state.lastActiveWindow;if(!l&&o)return o.uiState}let n;const s=E.screen.getAllDisplays();if(s.length===1)n=s[0];else{if(C.isMacintosh){const c=E.screen.getCursorScreenPoint();n=E.screen.getDisplayNearestPoint(c)}!n&&l&&(n=E.screen.getDisplayMatching(l.getBounds())),n||(n=E.screen.getPrimaryDisplay()||s[0])}let i=(0,I.defaultWindowState)();i.x=Math.round(n.bounds.x+n.bounds.width/2-i.width/2),i.y=Math.round(n.bounds.y+n.bounds.height/2-i.height/2);const a=this.k.getValue("window");let r=!0;if(a?.newWindowDimensions){if(a.newWindowDimensions==="maximized")i.mode=0,r=!1;else if(a.newWindowDimensions==="fullscreen")i.mode=3,r=!1;else if((a.newWindowDimensions==="inherit"||a.newWindowDimensions==="offset")&&l){const c=l.serializeWindowState();c.mode===3?i.mode=3:i=c,r=i.mode!==3&&a.newWindowDimensions==="offset"}}return r&&(i=this.t(i)),i.hasDefaultState=!0,i}t(d){if(this.g.getWindows().length===0)return d;d.x=typeof d.x=="number"?d.x:0,d.y=typeof d.y=="number"?d.y:0;const l=this.g.getWindows().map(n=>n.getBounds());for(;l.some(n=>n.x===d.x||n.y===d.y);)d.x+=30,d.y+=30;return d}};m.a="windowsState",m=pe([ie(0,P.IWindowsMainService),ie(1,S.IStateMainService),ie(2,w.ILifecycleMainService),ie(3,v.ILogService),ie(4,k.IConfigurationService)],m),e.WindowsStateHandler=m;function f(g){const d={openedWindows:[]},l=g||{openedWindows:[]};return l.lastActiveWindow&&(d.lastActiveWindow=p(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(d.lastPluginDevelopmentHostWindow=p(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(d.openedWindows=l.openedWindows.map(n=>p(n))),d}e.restoreWindowsState=f;function p(g){const d={uiState:g.uiState};return g.backupPath&&(d.backupPath=g.backupPath),g.remoteAuthority&&(d.remoteAuthority=g.remoteAuthority),g.folder&&(d.folderUri=M.URI.parse(g.folder)),g.workspaceIdentifier&&(d.workspace={id:g.workspaceIdentifier.id,configPath:M.URI.parse(g.workspaceIdentifier.configURIPath)}),d}function u(g){return{lastActiveWindow:g.lastActiveWindow&&b(g.lastActiveWindow),lastPluginDevelopmentHostWindow:g.lastPluginDevelopmentHostWindow&&b(g.lastPluginDevelopmentHostWindow),openedWindows:g.openedWindows.map(d=>b(d))}}e.getWindowsStateStoreData=u;function b(g){return{workspaceIdentifier:g.workspace&&{id:g.workspace.id,configURIPath:g.workspace.configPath.toString()},folder:g.folderUri&&g.folderUri.toString(),backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.uiState}}}),define(ee[92],te([0,1,30,42,123,33,14,9,4,19,7,5,63,28]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,P.createDecorator)("workspacesService");function m(D){return D.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function f(D){return D.hasOwnProperty("folderUri")}e.isRecentFolder=f;function p(D){return D.hasOwnProperty("fileUri")}e.isRecentFile=p;function u(D){return b(D)||g(D)}e.isStoredWorkspaceFolder=u;function b(D){const O=D;return typeof O?.path=="string"&&(!O.name||typeof O.name=="string")}function g(D){const O=D;return typeof O?.uri=="string"&&(!O.name||typeof O.name=="string")}function d(D,O,N,Y,G){if(D.scheme!==Y.scheme)return{name:N,uri:D.toString(!0)};let V=O?void 0:G.relativePath(Y,D);if(V!==void 0)V.length===0?V=".":w.isWindows&&(V=l(V));else if(D.scheme===M.Schemas.file)V=D.fsPath,w.isWindows&&(V=l(V));else if(G.isEqualAuthority(D.authority,Y.authority))V=D.path;else return{name:N,uri:D.toString(!0)};return{name:N,path:V}}e.getStoredWorkspaceFolder=d;function l(D){return D=(0,A.normalizeDriveLetter)(D),(0,E.isUNC)(D)||(D=(0,E.toSlashes)(D)),D}function n(D,O,N){const Y=[],G=new Set,V=N.dirname(O);for(const se of D){let oe;if(b(se))se.path&&(oe=N.resolvePath(V,se.path));else if(g(se))try{oe=S.URI.parse(se.uri),oe.path[0]!==k.posix.sep&&(oe=oe.with({path:k.posix.sep+oe.path}))}catch(re){console.warn(re)}if(oe){const re=N.getComparisonKey(oe);if(!G.has(re)){G.add(re);const de=se.name||N.basenameOrAuthority(oe);Y.push(new h.WorkspaceFolder({uri:oe,name:de,index:Y.length},se))}}}return Y}e.toWorkspaceFolders=n;function s(D,O,N,Y,G){const V=i(O,D),se=G.dirname(O),oe=G.dirname(Y),re=[];for(const W of V.folders){const L=b(W)?G.resolvePath(se,W.path):S.URI.parse(W.uri);let T;N?T=!1:T=!b(W)||(0,k.isAbsolute)(W.path),re.push(d(L,T,W.name,oe,G))}const de={insertSpaces:!1,tabSize:4,eol:w.isLinux||w.isMacintosh?`
`:`\r
`},X=C.setProperty(D,["folders"],re,de);let le=C.applyEdits(D,X);return(0,v.isEqualAuthority)(V.remoteAuthority,(0,I.getRemoteAuthority)(Y))&&(le=C.applyEdits(le,C.removeProperty(le,["remoteAuthority"],de))),le}e.rewriteWorkspaceFileForNewLocation=s;function i(D,O){const N=t.parse(O);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(Y=>u(Y));else throw new Error(`${D} looks like an invalid workspace file.`);return N}function a(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function r(D){return typeof D.folderUri=="string"}function c(D){return typeof D.fileUri=="string"}function o(D,O){const N={workspaces:[],files:[]};if(D){const Y=function(V,se){for(let oe=0;oe<V.length;oe++)try{se(V[oe],oe)}catch(re){O.warn(`Error restoring recent entry ${JSON.stringify(V[oe])}: ${re.toString()}. Skip entry.`)}},G=D;Array.isArray(G.entries)&&Y(G.entries,V=>{const se=V.label,oe=V.remoteAuthority;a(V)?N.workspaces.push({label:se,remoteAuthority:oe,workspace:{id:V.workspace.id,configPath:S.URI.parse(V.workspace.configPath)}}):r(V)?N.workspaces.push({label:se,remoteAuthority:oe,folderUri:S.URI.parse(V.folderUri)}):c(V)&&N.files.push({label:se,remoteAuthority:oe,fileUri:S.URI.parse(V.fileUri)})})}return N}e.restoreRecentlyOpened=o;function y(D){const O={entries:[]};for(const N of D.workspaces)f(N)?O.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):O.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of D.files)O.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return O}e.toStoreData=y}),define(ee[93],te([0,1,77,14,4,19]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function M(v){function S(){let P=v.scheme===t.Schemas.file?(0,A.originalFSPath)(v):v.toString();return C.isLinux||(P=P.toLowerCase()),(0,E.createHash)("md5").update(P).digest("hex")}return{id:S(),configPath:v}}e.getWorkspaceIdentifier=M;function k(v,S){function P(){if(v.scheme!==t.Schemas.file)return(0,E.createHash)("md5").update(v.toString()).digest("hex");if(!S)return;let h;return C.isLinux?h=S.ino:C.isMacintosh?h=S.birthtime.getTime():C.isWindows&&(typeof S.birthtimeMs=="number"?h=Math.floor(S.birthtimeMs):h=S.birthtime.getTime()),(0,E.createHash)("md5").update(v.fsPath).update(h?String(h):"").digest("hex")}const I=P();if(typeof I=="string")return{id:I,uri:v}}e.getSingleFolderWorkspaceIdentifier=k;function w(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=w}),define(ee[263],te([0,1,77,30,14,9,4,19,23,176,18,26,37,16,6,175,28,93]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let b=class Tt{constructor(d,l,n,s){this.j=d,this.k=l,this.l=n,this.m=s,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=k.extUriBiasedIgnorePathCase,this.i={isEqual:(i,a)=>(0,t.isEqual)(i,a,!M.isLinux)}}async initialize(){const d=await this.n();this.g=await this.v(d.emptyWindows),this.d=await this.t((0,v.deserializeWorkspaceInfos)(d)),this.e=await this.u((0,v.deserializeFolderInfos)(d)),this.C()}async n(){let d=this.m.getItem(Tt.a);if(!d)try{const l=(0,A.join)(this.c,"workspaces.json"),n=await w.Promises.readFile(l,"utf8");try{await w.Promises.unlink(l)}catch{}const s=JSON.parse(n);d={workspaces:Array.isArray(s.rootURIWorkspaces)?s.rootURIWorkspaces:[],folders:Array.isArray(s.folderWorkspaceInfos)?s.folderWorkspaceInfos:[],emptyWindows:Array.isArray(s.emptyWorkspaceInfos)?s.emptyWorkspaceInfos:[]}}catch(l){l.code!=="ENOENT"&&this.l.error(`Backup: Could not migrate legacy backup workspaces metadata: ${l.toString()}`)}return d??{workspaces:[],folders:[],emptyWindows:[]}}getWorkspaceBackups(){return this.o()?[]:this.d.slice(0)}getFolderBackups(){return this.o()?[]:this.e.slice(0)}isHotExitEnabled(){return this.q()!==h.HotExitConfiguration.OFF}o(){return this.q()===h.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}q(){return this.k.getValue()?.files?.hotExit||h.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(d,l){this.d.some(s=>d.workspace.id===s.workspace.id)||(this.d.push(d),this.C());const n=(0,A.join)(this.c,d.workspace.id);return l?this.s(n,l).then(()=>n):n}async s(d,l){if(await w.Promises.exists(d)&&await this.y(d),await w.Promises.exists(l))try{await w.Promises.rename(l,d)}catch(n){this.l.error(`Backup: Could not move backup folder to new location: ${n.toString()}`)}}registerFolderBackup(d){return this.e.some(l=>this.h.isEqual(d.folderUri,l.folderUri))||(this.e.push(d),this.C()),(0,A.join)(this.c,this.getFolderHash(d))}registerEmptyWindowBackup(d){return this.g.some(l=>!!l.backupFolder&&this.i.isEqual(l.backupFolder,d.backupFolder))||(this.g.push(d),this.C()),(0,A.join)(this.c,d.backupFolder)}async t(d){if(!Array.isArray(d))return[];const l=new Set,n=[];for(const s of d){const i=s.workspace;if(!(0,p.isWorkspaceIdentifier)(i))return[];if(!l.has(i.id)){l.add(i.id);const a=(0,A.join)(this.c,i.id);await this.B(a)?i.configPath.scheme!==C.Schemas.file||await w.Promises.exists(i.configPath.fsPath)?n.push(s):await this.y(a):await this.w(a)}}return n}async u(d){if(!Array.isArray(d))return[];const l=[],n=new Set;for(const s of d){const i=s.folderUri,a=this.h.getComparisonKey(i);if(!n.has(a)){n.add(a);const r=(0,A.join)(this.c,this.getFolderHash(s));await this.B(r)?i.scheme!==C.Schemas.file||await w.Promises.exists(i.fsPath)?l.push(s):await this.y(r):await this.w(r)}}return l}async v(d){if(!Array.isArray(d))return[];const l=[],n=new Set;for(const s of d){const i=s.backupFolder;if(typeof i!="string")return[];if(!n.has(i)){n.add(i);const a=(0,A.join)(this.c,i);await this.B(a)?l.push(s):await this.w(a)}}return l}async w(d){try{await w.Promises.rm(d,w.RimRafMode.MOVE)}catch(l){this.l.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}x(){let d=(0,u.createEmptyWorkspaceIdentifier)();for(;this.g.some(l=>!!l.backupFolder&&this.i.isEqual(l.backupFolder,d.id));)d=(0,u.createEmptyWorkspaceIdentifier)();return{backupFolder:d.id}}async y(d){const l=this.x(),n=(0,A.join)(this.c,l.backupFolder);try{await w.Promises.rename(d,n)}catch(s){return this.l.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.g.push(l),!0}async getDirtyWorkspaces(){const d=[];for(const l of this.d)await this.A(l)&&d.push(l);for(const l of this.e)await this.A(l)&&d.push(l);return d}A(d){let l;return(0,v.isEmptyWindowBackupInfo)(d)?l=(0,A.join)(this.c,d.backupFolder):(0,f.isFolderBackupInfo)(d)?l=(0,A.join)(this.c,this.getFolderHash(d)):l=(0,A.join)(this.c,d.workspace.id),this.B(l)}async B(d){try{const l=await w.Promises.readdir(d);for(const n of l)try{if((await w.Promises.readdir((0,A.join)(d,n))).length>0)return!0}catch{}}catch{}return!1}C(){const d={workspaces:this.d.map(({workspace:l,remoteAuthority:n})=>{const s={id:l.id,configURIPath:l.configPath.toString()};return n&&(s.remoteAuthority=n),s}),folders:this.e.map(({folderUri:l,remoteAuthority:n})=>{const s={folderUri:l.toString()};return n&&(s.remoteAuthority=n),s}),emptyWindows:this.g.map(({backupFolder:l,remoteAuthority:n})=>{const s={backupFolder:l};return n&&(s.remoteAuthority=n),s})};this.m.setItem(Tt.a,d)}getFolderHash(d){const l=d.folderUri;let n;return l.scheme===C.Schemas.file?n=M.isLinux?l.fsPath:l.fsPath.toLowerCase():n=l.toString().toLowerCase(),(0,E.createHash)("md5").update(n).digest("hex")}};b.a="backupWorkspaces",b=pe([ie(0,P.IEnvironmentMainService),ie(1,S.IConfigurationService),ie(2,m.ILogService),ie(3,I.IStateMainService)],b),e.BackupMainService=b}),define(ee[52],te([0,1,13,3,42,33,2,14,9,19,12,23,174,60,56,26,5,6,20,51,117,28,92,93]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p,u,b,g,d,l,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,p.createDecorator)("workspacesManagementMainService");let i=class extends M.Disposable{constructor(r,c,o,y,D,O){super(),this.g=r,this.h=c,this.i=o,this.j=y,this.k=D,this.l=O,this.a=this.B(new t.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new t.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const r=(await P.Promises.readdir(this.c.fsPath)).map(c=>(0,v.joinPath)(this.c,c,l.UNTITLED_WORKSPACE_NAME));for(const c of r){const o=(0,s.getWorkspaceIdentifier)(c),y=await this.resolveLocalWorkspace(c);y?this.f.push({workspace:o,remoteAuthority:y.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(r){r.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${r}).`)}}resolveLocalWorkspace(r){return this.m(r,c=>P.Promises.readFile(c,"utf8"))}m(r,c){if(!!this.n(r)&&r.scheme===k.Schemas.file)try{const o=c(r.fsPath);return o instanceof Promise?o.then(y=>this.p(r,y),y=>{}):this.p(r,o)}catch{return}}n(r){return(0,l.isUntitledWorkspace)(r,this.g)||(0,l.hasWorkspaceFileExtension)(r)}p(r,c){try{const o=this.r(r,c),y=(0,s.getWorkspaceIdentifier)(r);return{id:y.id,configPath:y.configPath,folders:(0,n.toWorkspaceFolders)(o.folders,y.configPath,v.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.h.warn(o.toString())}}r(r,c){const o=(0,C.parse)(c);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(y=>(0,n.isStoredWorkspaceFolder)(y));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(r,c){const{workspace:o,storedWorkspace:y}=this.s(r,c),D=o.configPath.fsPath;return await P.Promises.mkdir((0,w.dirname)(D),{recursive:!0}),await P.Promises.writeFile(D,JSON.stringify(y,null,"	")),this.f.push({workspace:o,remoteAuthority:c}),o}s(r=[],c){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),y=(0,v.joinPath)(this.c,o),D=(0,v.joinPath)(y,l.UNTITLED_WORKSPACE_NAME),O=[];for(const N of r)O.push((0,n.getStoredWorkspaceFolder)(N.uri,!0,N.name,y,v.extUriBiasedIgnorePathCase));return{workspace:(0,s.getWorkspaceIdentifier)(D),storedWorkspace:{folders:O,remoteAuthority:c}}}async getWorkspaceIdentifier(r){return(0,s.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,l.isUntitledWorkspace)(r.configPath,this.g)}async deleteUntitledWorkspace(r){!this.isUntitledWorkspace(r)||(await this.t(r),this.i.isEnabled()&&this.i.unsetWorkspace(r),this.a.fire(r))}async t(r){const c=(0,v.originalFSPath)(r.configPath);try{await P.Promises.rm((0,w.dirname)(c));const o=(0,w.join)(this.g.workspaceStorageHome.fsPath,r.id);await P.Promises.exists(o)&&await P.Promises.writeFile((0,w.join)(o,"obsolete"),""),this.f=this.f.filter(y=>y.workspace.id!==r.id)}catch(o){this.h.warn(`Unable to delete untitled workspace ${c} (${o}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(r,c,o){if(!r||!r.win||!r.isReady||!await this.u(r,c,o))return;const D=await this.v(r,(0,s.getWorkspaceIdentifier)(o));if(!!D)return this.b.fire({window:r,workspace:D.workspace}),D}async u(r,c,o){if(!o)return!0;if((0,l.isWorkspaceIdentifier)(r.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,o))return!1;if((0,d.findWindowOnWorkspaceOrFolder)(c,o)){const y={title:this.l.nameLong,type:"info",buttons:[(0,A.mnemonicButtonLabel)((0,I.localize)(0,null))],message:(0,I.localize)(1,null,(0,v.basename)(o)),detail:(0,I.localize)(2,null),noLink:!0,defaultId:0};return await this.k.showMessageBox(y,(0,S.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1}return!0}async v(r,c){if(!r.config)return;r.focus();let o;return r.config.extensionDevelopmentPath||(r.config.backupPath?o=await this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:r.remoteAuthority},r.config.backupPath):o=this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:r.remoteAuthority})),(0,l.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&await this.deleteUntitledWorkspace(r.openedWorkspace),r.config.workspace=c,r.config.backupPath=o,{workspace:c,backupPath:o}}};i=pe([ie(0,f.IEnvironmentMainService),ie(1,u.ILogService),ie(2,g.IUserDataProfilesMainService),ie(3,h.IBackupMainService),ie(4,m.IDialogMainService),ie(5,b.IProductService)],i),e.WorkspacesManagementMainService=i}),define(ee[118],te([0,1,13,40,22,5,31,28,52,12,6]),function(q,e,E,t,C,A,M,k,w,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,A.createDecorator)(e.ID);let P=class{constructor(h,m,f){this.a=h,this.b=m,this.c=f}async getRemoteDiagnostics(h){const m=this.a.getWindows();return(await Promise.all(m.map(async p=>{const u=p.remoteAuthority;if(!u)return;const b=`vscode:getDiagnosticInfoResponse${p.id}`,g={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?await this.f(p):void 0};return new Promise(d=>{p.sendWhenReady("vscode:getDiagnosticInfo",C.CancellationToken.None,{replyChannel:b,args:g}),t.validatedIpcMain.once(b,(l,n)=>{n||d({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),d(n)}),setTimeout(()=>{d({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter(p=>!!p)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const h=[];for(const m of E.BrowserWindow.getAllWindows()){const f=this.a.getWindowById(m.id);f?h.push(await this.d(f)):h.push(this.e(m))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async d(h){const m=await this.f(h),f=(0,v.assertIsDefined)(h.win);return this.e(f,m,h.remoteAuthority)}e(h,m=[],f){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:m,remoteAuthority:f}}async f(h){const m=[],f=h.openedWorkspace;if((0,k.isSingleFolderWorkspaceIdentifier)(f))m.push(f.uri);else if((0,k.isWorkspaceIdentifier)(f)){const p=await this.b.resolveLocalWorkspace(f.configPath);p&&p.folders.forEach(b=>{m.push(b.uri)})}return m}};P=pe([ie(0,M.IWindowsMainService),ie(1,w.IWorkspacesManagementMainService),ie(2,S.ILogService)],P),e.DiagnosticsMainService=P}),define(ee[65],te([0,1,44,13,27,140,53,3,33,2,14,9,4,7,99,81,23,95,164,56,26,5,21,6,20,64,31,28,52,17,222,215]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p,u,b,g,d,l,n,s,i,a,r,c,o,y,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,l.createDecorator)("nativeHostMainService");let N=class extends v.Disposable{constructor(G,V,se,oe,re,de,X,le,W){super(),this.a=G,this.b=V,this.c=se,this.f=oe,this.g=re,this.h=de,this.i=X,this.j=le,this.k=W,this.onDidOpenWindow=k.Event.map(this.b.onDidOpenWindow,L=>L.id),this.onDidTriggerSystemContextMenu=k.Event.filter(k.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:T,y:U})=>({windowId:L.id,x:T,y:U})),({windowId:L})=>!!this.b.getWindowById(L)),this.onDidMaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(L,T)=>T.id),L=>!!this.b.getWindowById(L)),this.onDidUnmaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(L,T)=>T.id),L=>!!this.b.getWindowById(L)),this.onDidBlurWindow=k.Event.filter(k.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(L,T)=>T.id),L=>!!this.b.getWindowById(L)),this.onDidFocusWindow=k.Event.any(k.Event.map(k.Event.filter(k.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),L=>!!L),L=>L.id),k.Event.filter(k.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(L,T)=>T.id),L=>!!this.b.getWindowById(L))),this.onDidResumeOS=k.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.l=this.B(new k.Emitter),this.onDidChangePassword=this.l.event,this.onDidChangeDisplay=k.Event.debounce(k.Event.any(k.Event.filter(k.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(L,T,U)=>U),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),k.Event.fromNodeEventEmitter(t.screen,"display-added"),k.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(V=>({id:V.id,workspace:V.openedWorkspace??(0,c.toWorkspaceIdentifier)(V.backupPath,V.isExtensionDevelopmentHost),title:V.win?.getTitle()??"",filename:V.getRepresentedFilename(),dirty:V.isDocumentEdited()}))}async getWindowCount(G){return this.b.getWindowCount()}async getActiveWindowId(G){const V=t.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(V)return V.id}openWindow(G,V,se){return Array.isArray(V)?this.m(G,V,se):this.n(G,V)}async m(G,V,se=Object.create(null)){V.length>0&&await this.b.open({context:5,contextWindowId:G,urisToOpen:V,cli:this.g.args,forceNewWindow:se.forceNewWindow,forceReuseWindow:se.forceReuseWindow,preferNewWindow:se.preferNewWindow,diffMode:se.diffMode,mergeMode:se.mergeMode,addMode:se.addMode,gotoLineMode:se.gotoLineMode,noRecentEntry:se.noRecentEntry,waitMarkerFileURI:se.waitMarkerFileURI,remoteAuthority:se.remoteAuthority||void 0})}async n(G,V){await this.b.openEmptyWindow({context:5,contextWindowId:G},V)}async toggleFullScreen(G){this.v(G)?.toggleFullScreen()}async handleTitleDoubleClick(G){this.v(G)?.handleTitleDoubleClick()}async isMaximized(G){const V=this.v(G);return V?.win?V.win.isMaximized():!1}async maximizeWindow(G){const V=this.v(G);V?.win&&V.win.maximize()}async unmaximizeWindow(G){const V=this.v(G);V?.win&&V.win.unmaximize()}async minimizeWindow(G){const V=this.v(G);V?.win&&V.win.minimize()}async updateWindowControls(G,V){const se=this.v(G);se&&se.updateWindowControls(V)}async focusWindow(G,V){V&&typeof V.windowId=="number"&&(G=V.windowId),this.v(G)?.focus({force:V?.force??!1})}async setMinimumSize(G,V,se){const oe=this.v(G);if(oe?.win){const[re,de]=oe.win.getSize(),[X,le]=oe.win.getMinimumSize(),[W,L]=[V??X,se??le],[T,U]=[Math.max(re,W),Math.max(de,L)];(X!==W||le!==L)&&oe.win.setMinimumSize(W,L),(re!==T||de!==U)&&oe.win.setSize(T,U)}}async saveWindowSplash(G,V){this.j.saveWindowSplash(G,V)}async installShellCommand(G){const{source:V,target:se}=await this.p();try{const{symbolicLink:oe}=await p.SymlinkSupport.stat(V);if(oe&&!oe.dangling){const re=await(0,m.realpath)(V);if(se===re)return}await p.Promises.unlink(V)}catch(oe){if(oe.code!=="ENOENT")throw oe}try{await p.Promises.symlink(se,V)}catch(oe){if(oe.code!=="EACCES"&&oe.code!=="ENOENT")throw oe;const{response:re}=await this.showMessageBox(G,{title:this.i.nameLong,type:"info",message:(0,b.localize)(0,null,this.i.nameShort),buttons:[(0,w.mnemonicButtonLabel)((0,b.localize)(1,null)),(0,w.mnemonicButtonLabel)((0,b.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const de=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${se}' '${V}'\\" with administrator privileges"`;await(0,A.promisify)(E.exec)(de)}catch{throw new Error((0,b.localize)(3,null,V))}}}async uninstallShellCommand(G){const{source:V}=await this.p();try{await p.Promises.unlink(V)}catch(se){switch(se.code){case"EACCES":{const{response:oe}=await this.showMessageBox(G,{title:this.i.nameLong,type:"info",message:(0,b.localize)(4,null,this.i.nameShort),buttons:[(0,w.mnemonicButtonLabel)((0,b.localize)(5,null)),(0,w.mnemonicButtonLabel)((0,b.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(oe===0)try{const re=`osascript -e "do shell script \\"rm '${V}'\\" with administrator privileges"`;await(0,A.promisify)(E.exec)(re)}catch{throw new Error((0,b.localize)(7,null,V))}break}case"ENOENT":break;default:throw se}}}async p(){const G=(0,P.resolve)(this.g.appRoot,"bin","code"),V=`/usr/local/bin/${this.i.applicationName}`;if(!await p.Promises.exists(G))throw new Error((0,b.localize)(8,null,G));return{source:V,target:G}}async showMessageBox(G,V){return this.c.showMessageBox(V,this.r(G))}async showSaveDialog(G,V){return this.c.showSaveDialog(V,this.r(G))}async showOpenDialog(G,V){return this.c.showOpenDialog(V,this.r(G))}r(G){const V=this.v(G);if(V?.win)return V.win}async pickFileFolderAndOpen(G,V){const se=await this.c.pickFileFolder(V);se&&await this.s(await Promise.all(se.map(async oe=>await p.SymlinkSupport.existsDirectory(oe)?{folderUri:h.URI.file(oe)}:{fileUri:h.URI.file(oe)})),V,G)}async pickFolderAndOpen(G,V){const se=await this.c.pickFolder(V);se&&await this.s(se.map(oe=>({folderUri:h.URI.file(oe)})),V,G)}async pickFileAndOpen(G,V){const se=await this.c.pickFile(V);se&&await this.s(se.map(oe=>({fileUri:h.URI.file(oe)})),V,G)}async pickWorkspaceAndOpen(G,V){const se=await this.c.pickWorkspace(V);se&&await this.s(se.map(oe=>({workspaceUri:h.URI.file(oe)})),V,G)}async s(G,V,se){await this.b.open({context:3,contextWindowId:se,cli:this.g.args,urisToOpen:G,forceNewWindow:V.forceNewWindow})}async showItemInFolder(G,V){t.shell.showItemInFolder(V)}async setRepresentedFilename(G,V){this.v(G)?.setRepresentedFilename(V)}async setDocumentEdited(G,V){this.v(G)?.setDocumentEdited(V)}async openExternal(G,V){return I.isLinuxSnap?this.t(V):t.shell.openExternal(V),!0}t(G){const V=process.env.GDK_PIXBUF_MODULE_FILE,se=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(G),process.env.GDK_PIXBUF_MODULE_FILE=V,process.env.GDK_PIXBUF_MODULEDIR=se}moveItemToTrash(G,V){return t.shell.trashItem(V)}async isAdmin(){let G;return I.isWindows?G=(await new Promise((V,se)=>{q(["native-is-elevated"],V,se)}))():G=process.getuid()===0,G}async writeElevated(G,V,se,oe){const re=await new Promise((de,X)=>{q(["@vscode/sudo-prompt"],de,X)});return new Promise((de,X)=>{const le=[`"${this.u}"`];oe?.unlock&&le.push("--file-chmod"),le.push("--file-write",`"${V.fsPath}"`,`"${se.fsPath}"`);const W={name:this.i.nameLong.replace("-",""),icns:I.isMacintosh&&this.g.isBuilt?(0,P.join)((0,P.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};re.exec(le.join(" "),W,(L,T,U)=>{T&&this.h.trace(`[sudo-prompt] received stdout: ${T}`),U&&this.h.trace(`[sudo-prompt] received stderr: ${U}`),L?X(L):de(void 0)})})}get u(){return I.isWindows?this.g.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,P.join)(this.g.appRoot,"scripts","code-cli.bat"):I.isLinux?this.g.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,P.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,P.join)(this.g.appRoot,"bin","code"):(0,P.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,C.totalmem)(),freemem:(0,C.freemem)(),loadavg:(0,C.loadavg)()}}async getOSProperties(){return{arch:(0,C.arch)(),platform:(0,C.platform)(),release:(0,C.release)(),type:(0,C.type)(),cpus:(0,C.cpus)()}}async getOSVirtualMachineHint(){return f.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return I.isWindows&&(0,D.hasWSLFeatureInstalled)()}async killProcess(G,V,se){process.kill(V,se)}async readClipboardText(G,V){return t.clipboard.readText(V)}async writeClipboardText(G,V,se){return t.clipboard.writeText(V,se)}async readClipboardFindText(G){return t.clipboard.readFindText()}async writeClipboardFindText(G,V){return t.clipboard.writeFindText(V)}async writeClipboardBuffer(G,V,se,oe){return t.clipboard.writeBuffer(V,Buffer.from(se.buffer),oe)}async readClipboardBuffer(G,V){return y.VSBuffer.wrap(t.clipboard.readBuffer(V))}async hasClipboard(G,V,se){return t.clipboard.has(V,se)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(G,V){this.v(G)?.updateTouchBar(V)}async notifyReady(G){this.v(G)?.setReady()}async relaunch(G,V){return this.f.relaunch(V)}async reload(G,V){const se=this.v(G);if(se){if((0,c.isWorkspaceIdentifier)(se.openedWorkspace)){const oe=se.openedWorkspace.configPath;if(oe.scheme===S.Schemas.file&&(await this.k.resolveLocalWorkspace(oe))?.transient)return this.openWindow(se.id,{forceReuseWindow:!0})}return this.f.reload(se,V?.disableExtensions!==void 0?{_:[],"disable-extensions":V.disableExtensions}:void 0)}}async closeWindow(G){this.closeWindowById(G,G)}async closeWindowById(G,V){const se=this.v(V);if(se?.win)return se.win.close()}async quit(G){const V=this.b.getLastActiveWindow();V?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&V.win?V.win.close():this.f.quit()}async exit(G,V){await this.f.kill(V)}async resolveProxy(G,V){const oe=this.v(G)?.win?.webContents?.session;if(oe)return oe.resolveProxy(V)}findFreePort(G,V,se,oe,re=1){return(0,u.findFreePort)(V,se,oe,re)}async openDevTools(G,V){const se=this.v(G);se?.win&&se.win.webContents.openDevTools(V)}async toggleDevTools(G){const V=this.v(G);V?.win&&V.win.webContents.toggleDevTools()}async sendInputEvent(G,V){const se=this.v(G);se?.win&&(V.type==="mouseDown"||V.type==="mouseUp")&&se.win.webContents.sendInputEvent(V)}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(G,V,se){const oe=this.v(G);if(!oe||!oe.win)throw new Error;return await new O.WindowProfiler(oe.win,V,this.h).inspect(se)}async windowsGetStringRegKey(G,V,se,oe){if(!I.isWindows)return;const re=await new Promise((de,X)=>{q(["@vscode/windows-registry"],de,X)});try{return re.GetStringRegKey(V,se,oe)}catch{return}}v(G){if(typeof G=="number")return this.b.getWindowById(G)}};pe([M.memoize],N.prototype,"u",null),N=pe([ie(1,r.IWindowsMainService),ie(2,g.IDialogMainService),ie(3,n.ILifecycleMainService),ie(4,d.IEnvironmentMainService),ie(5,s.ILogService),ie(6,i.IProductService),ie(7,a.IThemeMainService),ie(8,o.IWorkspacesManagementMainService)],N),e.NativeHostMainService=N}),define(ee[264],te([0,1,13,40,27,33,2,14,4,100,162,84,118,56,26,5,6,65,54,20,61,74,30,12]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p,u,b,g,d,l,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,f.createDecorator)("issueMainService");let i=class jt{constructor(r,c,o,y,D,O,N,Y,G){this.g=r,this.h=c,this.i=o,this.j=y,this.k=D,this.l=O,this.m=N,this.n=Y,this.o=G,this.b=null,this.c=null,this.d=null,this.f=null,this.p()}p(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async r=>{const[c,o]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),y=await this.j.getSystemInfo(c,o);this.q(r,"vscode:issueSystemInfoResponse",y)}),t.validatedIpcMain.on("vscode:listProcesses",async r=>{const c=[];try{c.push({name:(0,S.localize)(0,null),rootProcess:await(0,v.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(y=>{(0,P.isRemoteDiagnosticError)(y)?c.push({name:y.hostName,rootProcess:y}):y.processes&&c.push({name:y.hostName,rootProcess:y.processes})})}catch(o){this.i.error(`Listing processes failed: ${o}`)}this.q(r,"vscode:listProcessesResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async r=>{const c={title:this.o.nameLong,message:(0,S.localize)(1,null),type:"warning",buttons:[(0,A.mnemonicButtonLabel)((0,S.localize)(2,null)),(0,A.mnemonicButtonLabel)((0,S.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.b){const o=await this.l.showMessageBox(c,this.b);this.q(r,"vscode:issueReporterClipboardResponse",o.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async r=>{const c=await this.u();this.q(r,"vscode:issuePerformanceInfoResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const r={title:this.o.nameLong,message:(0,S.localize)(4,null),type:"warning",buttons:[(0,A.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,A.mnemonicButtonLabel)((0,S.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.b&&(await this.l.showMessageBox(r,this.b)).response===0&&this.b&&(this.b.destroy(),this.b=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(r,c)=>{const{id:o,from:y,args:D}=c;let O;switch(y){case"issueReporter":O=this.c;break;case"processExplorer":O=this.f;break;default:throw new Error(`Unexpected command source: ${y}`)}O?.webContents.send("vscode:runAction",{id:o,from:y,args:D})}),t.validatedIpcMain.on("vscode:openExternal",(r,c)=>{this.m.openExternal(void 0,c)}),t.validatedIpcMain.on("vscode:closeIssueReporter",r=>{this.b?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",r=>{this.d?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async r=>{const c=await this.k.getMainDiagnostics();this.q(r,"vscode:windowsInfoResponse",c.windows)})}q(r,c,...o){r.sender.isDestroyed()||r.sender.send(c,...o)}async openReporter(r){if(!this.b&&(this.c=E.BrowserWindow.getFocusedWindow(),this.c)){const c=new M.DisposableStore,o=c.add(this.n.createIPCObjectUrl()),y=this.t(this.c,700,800);this.b=this.s(y,o,{backgroundColor:r.styles.backgroundColor,title:(0,S.localize)(7,null),zoomLevel:r.zoomLevel,alwaysOnTop:!1},"issue-reporter"),o.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:r,disableExtensions:!!this.h.disableExtensions,os:{type:(0,C.type)(),arch:(0,C.arch)(),release:(0,C.release)()},product:b.default}),this.b.loadURL(k.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,c.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,c.dispose())})}this.b&&this.r(this.b)}async openProcessExplorer(r){if(!this.d&&(this.f=E.BrowserWindow.getFocusedWindow(),this.f)){const c=new M.DisposableStore,o=c.add(this.n.createIPCObjectUrl()),y=this.t(this.f,800,500);this.d=this.s(y,o,{backgroundColor:r.styles.backgroundColor,title:(0,S.localize)(8,null),zoomLevel:r.zoomLevel,alwaysOnTop:!0},"process-explorer"),o.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:r,product:b.default}),this.d.loadURL(k.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,c.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,c.dispose())})}this.d&&this.r(this.d)}r(r){r.isMinimized()&&r.restore(),r.focus()}s(r,c,o,y){const D=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:o.title,backgroundColor:o.backgroundColor||jt.a,webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,`--vscode-window-kind=${y}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,l.zoomLevelToZoomFactor)(o.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:o.alwaysOnTop,experimentalDarkMode:!0});return D.setMenuBarVisibility(!1),D}async getSystemStatus(){const[r,c]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(r,c)}t(r,c,o){let y;const D=E.screen.getAllDisplays();if(D.length===1)y=D[0];else{if(w.isMacintosh){const Y=E.screen.getCursorScreenPoint();y=E.screen.getDisplayNearestPoint(Y)}!y&&r&&(y=E.screen.getDisplayMatching(r.getBounds())),y||(y=E.screen.getPrimaryDisplay()||D[0])}const O={width:c,height:o},N=y.bounds;return O.x=N.x+N.width/2-O.width/2,O.y=N.y+N.height/2-O.height/2,N.width>0&&N.height>0&&(O.x<N.x&&(O.x=N.x),O.y<N.y&&(O.y=N.y),O.x>N.x+N.width&&(O.x=N.x),O.y>N.y+N.height&&(O.y=N.y),O.width>N.width&&(O.width=N.width),O.height>N.height&&(O.height=N.height)),O}async u(){try{const[r,c]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(r,c)}catch(r){throw this.i.warn("issueService#getPerformanceInfo ",r.message),r}}async stopTracing(){if(!this.h.args.trace)return;const r=await E.contentTracing.stopRecording(`${(0,n.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({title:this.o.nameLong,type:"info",message:(0,S.localize)(9,null),detail:(0,S.localize)(10,null,r),buttons:[(0,A.mnemonicButtonLabel)((0,S.localize)(11,null))],defaultId:0,noLink:!0},(0,s.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,r)}};i.a="#1E1E1E",i=pe([ie(1,m.IEnvironmentMainService),ie(2,p.ILogService),ie(3,P.IDiagnosticsService),ie(4,I.IDiagnosticsMainService),ie(5,h.IDialogMainService),ie(6,u.INativeHostMainService),ie(7,d.IProtocolMainService),ie(8,g.IProductService)],i),e.IssueMainService=i}),define(ee[265],te([0,1,22,18,26,21,6,65,20,55,35,47,89]),function(q,e,E,t,C,A,M,k,w,v,S,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let h=class extends I.AbstractUpdateService{constructor(f,p,u,b,g,d,l,n){super(f,p,b,g,d,n),this.e=u,this.u=l}s(f){return(0,I.createUpdateURL)(`linux-${process.arch}`,f,this.k)}t(f){!this.a||(this.d(P.State.CheckingForUpdates(f)),this.i.request({url:this.a},E.CancellationToken.None).then(v.asJson).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!f}),this.d(P.State.Idle(1))):this.d(P.State.AvailableForDownload(p))}).then(void 0,p=>{this.j.error(p),this.e.publicLog2("update:notAvailable",{explicit:!!f});const u=f?p.message||p:void 0;this.d(P.State.Idle(1,u))}))}async o(f){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):f.update.url&&this.u.openExternal(void 0,f.update.url),this.d(P.State.Idle(1))}};h=pe([ie(0,A.ILifecycleMainService),ie(1,t.IConfigurationService),ie(2,S.ITelemetryService),ie(3,C.IEnvironmentMainService),ie(4,v.IRequestService),ie(5,M.ILogService),ie(6,k.INativeHostMainService),ie(7,w.IProductService)],h),e.LinuxUpdateService=h}),define(ee[266],te([0,1,44,39,27,8,22,53,9,7,126,23,18,26,16,21,6,65,20,55,35,47,89]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p,u,b,g,d,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function s(c,o=1e3){for(;!c();)await(0,A.timeout)(o)}let i;function a(){return typeof i>"u"&&(i=t.existsSync(w.join(w.dirname(process.execPath),"unins000.exe"))?0:1),i}let r=class extends n.AbstractUpdateService{get cachePath(){const o=w.join((0,C.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return P.Promises.mkdir(o,{recursive:!0}).then(()=>o)}constructor(o,y,D,O,N,Y,G,V,se){super(o,y,O,N,Y,se),this.u=D,this.v=G,this.w=V}async initialize(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}s(o){let y="win32";return process.arch!=="ia32"&&(y+=`-${process.arch}`),a()===1?y+="-archive":this.k.target==="user"&&(y+="-user"),(0,n.createUpdateURL)(y,o,this.k)}t(o){!this.a||(this.d(l.State.CheckingForUpdates(o)),this.i.request({url:this.a},M.CancellationToken.None).then(g.asJson).then(y=>{const D=a();return!y||!y.url||!y.version||!y.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!o}),this.d(l.State.Idle(D)),Promise.resolve(null)):D===1?(this.d(l.State.AvailableForDownload(y)),Promise.resolve(null)):(this.d(l.State.Downloading(y)),this.C(y.version).then(()=>this.B(y.version).then(O=>P.Promises.exists(O).then(N=>{if(N)return Promise.resolve(O);const Y=y.url,G=y.hash,V=`${O}.tmp`;return this.i.request({url:Y},M.CancellationToken.None).then(se=>this.v.writeFile(v.URI.file(V),se.stream)).then(G?()=>(0,S.checksum)(V,y.hash):()=>{}).then(()=>P.Promises.rename(V,O)).then(()=>O)})).then(O=>{const N=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:O},N&&y.supportsFastUpdate?this.k.target==="user"?this.p():this.d(l.State.Downloaded(y)):this.d(l.State.Ready(y))})))}).then(void 0,y=>{this.j.error(y),this.u.publicLog2("update:notAvailable",{explicit:!!o});const D=o?y.message||y:void 0;this.d(l.State.Idle(a(),D))}))}async o(o){o.update.url&&this.w.openExternal(void 0,o.update.url),this.d(l.State.Idle(a()))}async B(o){const y=await this.cachePath;return w.join(y,`CodeSetup-${this.k.quality}-${o}.exe`)}async C(o=null){const y=o?Y=>!new RegExp(`${this.k.quality}-${o}\\.exe$`).test(Y):()=>!0,D=await this.cachePath,N=(await P.Promises.readdir(D)).filter(y).map(async Y=>{try{await P.Promises.unlink(w.join(D,Y))}catch{}});await Promise.all(N)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const o=this.state.update;this.d(l.State.Updating(o));const y=await this.cachePath;this.e.updateFilePath=w.join(y,`CodeSetup-${this.k.quality}-${o.version}.flag`),await P.Promises.writeFile(this.e.updateFilePath,"flag"),(0,E.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(l.State.Idle(a()))});const O=`${this.k.win32MutexName}-ready`,N=await new Promise((Y,G)=>{q(["windows-mutex"],Y,G)});s(()=>N.isActive(O)).then(()=>this.d(l.State.Ready(o)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?t.unlinkSync(this.e.updateFilePath):(0,E.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return a()}async _applySpecificUpdate(o){if(this.state.type!=="idle")return;const y=this.g.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!y};this.d(l.State.Downloading(D)),this.e={packagePath:o},y?this.k.target==="user"?this.p():this.d(l.State.Downloaded(D)):this.d(l.State.Ready(D))}};pe([k.memoize],r.prototype,"cachePath",null),r=pe([ie(0,f.ILifecycleMainService),ie(1,I.IConfigurationService),ie(2,d.ITelemetryService),ie(3,h.IEnvironmentMainService),ie(4,g.IRequestService),ie(5,p.ILogService),ie(6,m.IFileService),ie(7,u.INativeHostMainService),ie(8,b.IProductService)],r),e.Win32UpdateService=r}),define(ee[267],te([0,1,13,8,22,43,3,33,2,14,9,72,4,7,170,60,18,56,26,59,16,21,6,20,61,233,91,35,236,64,74,31,28,52,115,120,36,37,54,51]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p,u,b,g,d,l,n,s,i,a,r,c,o,y,D,O,N,Y,G,V,se,oe,re,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var X;(function(W){W[W.NONE=0]="NONE",W[W.NAVIGATING=1]="NAVIGATING",W[W.READY=2]="READY"})(X||(X={}));let le=class Ft extends w.Disposable{get id(){return this.j}get win(){return this.k}get lastFocusTime(){return this.l}get backupPath(){return this.m?.backupPath}get openedWorkspace(){return this.m?.workspace}get profile(){return this.config?this.O.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.O.profiles.find(L=>L.id===this.config?.profiles.profile.id)??this.O.defaultProfile):void 0}get remoteAuthority(){return this.m?.remoteAuthority}get config(){return this.m}get isExtensionDevelopmentHost(){return!!this.m?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.m?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.m?.debugId}constructor(L,T,U,Q,B,H,R,F,$,z,J,ne,j,x,_,ae,ge,Me,Oe){super(),this.L=T,this.M=U,this.N=Q,this.O=B,this.P=H,this.Q=R,this.R=F,this.S=$,this.U=z,this.W=J,this.X=ne,this.Y=j,this.ab=x,this.bb=_,this.db=ae,this.eb=ge,this.fb=Me,this.gb=Oe,this.b=this.B(new M.Emitter),this.onWillLoad=this.b.event,this.c=this.B(new M.Emitter),this.onDidSignalReady=this.c.event,this.f=this.B(new M.Emitter),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new M.Emitter),this.onDidClose=this.g.event,this.h=this.B(new M.Emitter),this.onDidDestroy=this.h.event,this.l=-1,this.s=void 0,this.t=void 0,this.w=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.eb.createIPCObjectUrl()),this.J=!1,this.hb=0;{const[De,Re]=this.rb(L.state);this.n=De,this.L.trace("window#ctor: using window state",De);const ve=this.n.mode===0||this.n.mode===3,we=this.S.getValue("window");let be=!1;typeof we?.experimental?.useSandbox=="boolean"?be=we.experimental.useSandbox:be=typeof re.default.quality=="string"&&re.default.quality!=="stable";const Ce={width:this.n.width,height:this.n.height,x:this.n.x,y:this.n.y,backgroundColor:this.U.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!ve,title:this.db.nameLong,webPreferences:{preload:v.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.zoomLevelToZoomFactor)(we?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...be?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};I.isLinux?Ce.icon=(0,S.join)(this.M.appRoot,"resources/linux/code.png"):I.isWindows&&!this.M.isBuilt&&(Ce.icon=(0,S.join)(this.M.appRoot,"resources/win32/code_150x150.png")),I.isMacintosh&&!this.yb()&&(Ce.fullscreenable=!1),I.isMacintosh&&(Ce.acceptFirstMouse=!0,we?.clickThroughInactive===!1&&(Ce.acceptFirstMouse=!1));const Z=I.isMacintosh&&we?.nativeTabs===!0;Z&&(Ce.tabbingIdentifier=this.db.nameShort);const ue=(0,D.getTitleBarStyle)(this.S)==="custom";if(ue&&(Ce.titleBarStyle="hidden",I.isMacintosh||(Ce.frame=!1),(0,D.useWindowControlsOverlay)(this.S))){const he=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),ye=V.Color.fromHex(he).isDarker()?"#FFFFFF":"#000000";Ce.titleBarOverlay={height:29,color:he,symbolColor:ye},this.w=!0}if((0,P.mark)("code/willCreateCodeBrowserWindow"),this.k=new E.BrowserWindow(Ce),(0,P.mark)("code/didCreateCodeBrowserWindow"),this.j=this.k.id,I.isMacintosh&&ue&&this.k.setSheetOffset(22),ue&&(I.isWindows&&(0,D.useWindowControlsOverlay)(this.S)||I.isMacintosh)){const he=this.gb.getItem(Ft.a);he&&this.updateWindowControls({height:he})}I.isWindows&&ue&&this.k.hookWindowMessage(278,()=>{const[ye,Ie]=this.k.getPosition(),We=E.screen.getCursorScreenPoint(),Te=We.x-ye,ze=We.y-Ie;return(()=>!(Te>30&&ze>=0&&ze<=Math.max(this.k.getBounds().height*.15,35)))()||(this.k.setEnabled(!1),this.k.setEnabled(!0),this.f.fire({x:Te,y:ze})),0}),(I.isMacintosh||I.isWindows)&&Re&&(!Z||E.BrowserWindow.getAllWindows().length===1)&&[this.n.width,this.n.height,this.n.x,this.n.y].every(he=>typeof he=="number")&&this.k.setBounds({width:this.n.width,height:this.n.height,x:this.n.x,y:this.n.y}),ve&&((0,P.mark)("code/willMaximizeCodeWindow"),this.k.maximize(),this.n.mode===3&&this.ub(!0),this.k.show(),(0,P.mark)("code/didMaximizeCodeWindow")),this.l=Date.now()}this.M.args["open-devtools"]===!0&&this.k.webContents.openDevTools(),this.ob(),this.Db(),this.ib()}setRepresentedFilename(L){I.isMacintosh?this.k.setRepresentedFilename(L):this.u=L}getRepresentedFilename(){return I.isMacintosh?this.k.getRepresentedFilename():this.u}setDocumentEdited(L){I.isMacintosh&&this.k.setDocumentEdited(L),this.v=L}isDocumentEdited(){return I.isMacintosh?this.k.isDocumentEdited():!!this.v}focus(L){I.isMacintosh&&L?.force&&E.app.focus({steal:!0}),this.k&&(this.k.isMinimized()&&this.k.restore(),this.k.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.j})`),this.hb=2;this.C.length;)this.C.pop()(this);this.c.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.C.push(L)})}get isReady(){return this.hb===2}get whenClosedOrLoaded(){return new Promise(L=>{function T(){U.dispose(),Q.dispose(),L()}const U=this.onDidClose(()=>T()),Q=this.onWillLoad(()=>T())})}ib(){this.k.on("unresponsive",()=>this.lb(1)),this.k.webContents.on("render-process-gone",(T,U)=>this.lb(2,U)),this.k.webContents.on("did-fail-load",(T,U,Q)=>this.lb(3,{reason:Q,exitCode:U})),this.k.webContents.on("will-prevent-unload",T=>{T.preventDefault()}),this.k.on("closed",()=>{this.g.fire(),this.dispose()}),this.k.webContents.on("did-finish-load",()=>{this.I&&(this.m=this.I,this.I=void 0)}),this.k.on("focus",()=>{this.l=Date.now()}),this.k.on("maximize",T=>{this.m&&(this.m.maximized=!0),E.app.emit("browser-window-maximize",T,this.k)}),this.k.on("unmaximize",T=>{this.m&&(this.m.maximized=!1),E.app.emit("browser-window-unmaximize",T,this.k)}),this.k.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",C.CancellationToken.None),this.t?.complete(),this.t=void 0}),this.k.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",C.CancellationToken.None),this.t?.complete(),this.t=void 0}),this.B(this.S.onDidChangeConfiguration(T=>this.ob(T))),this.B(this.W.onDidDeleteUntitledWorkspace(T=>this.nb(T)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.k.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(T,U)=>{const Q=await this.kb();U({cancel:!1,requestHeaders:Object.assign(T.requestHeaders,Q)})})}kb(){return this.jb||(this.jb=(0,a.resolveMarketplaceHeaders)(this.db.version,this.db,this.M,this.S,this.P,this.Q,this.Y)),this.jb}async lb(L,T){switch(L){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:L,reason:T?.reason,code:T?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.bb.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.mb(!1,!1),this.bb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.k&&this.k.webContents&&this.k.webContents.isDevToolsOpened())return;const U=await this.ab.showMessageBox({title:this.db.nameLong,type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,m.localize)(0,null)),(0,k.mnemonicButtonLabel)((0,m.localize)(1,null)),(0,k.mnemonicButtonLabel)((0,m.localize)(2,null))],message:(0,m.localize)(3,null),detail:(0,m.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this.m?.workspace?(0,m.localize)(5,null):void 0},this.k);if(U.response!==1){const Q=U.response===0;await this.mb(Q,U.checkboxChecked)}}else if(L===2){let U;T?U=(0,m.localize)(7,null,T.reason,T.exitCode??"<unknown>"):U=(0,m.localize)(6,null);const Q=await this.ab.showMessageBox({title:this.db.nameLong,type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,m.localize)(8,null)),(0,k.mnemonicButtonLabel)((0,m.localize)(9,null))],message:U,detail:(0,m.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this.m?.workspace?(0,m.localize)(11,null):void 0},this.k),B=Q.response===0;await this.mb(B,Q.checkboxChecked)}break}}async mb(L,T){const U=this.m?.workspace;if(T&&U)try{const Q=this.R.workspaceStorage(U);await Q.init(),Q.delete("memento/workbench.parts.editor"),await Q.close()}catch(Q){this.L.error(Q)}if(this.h.fire(),this.k?.destroy(),L&&this.m){let Q,B;(0,N.isSingleFolderWorkspaceIdentifier)(U)?Q={folderUri:U.uri}:(0,N.isWorkspaceIdentifier)(U)?Q={workspaceUri:U.configPath}:B=!0;const[H]=await this.fb.open({context:5,userEnv:this.m.userEnv,cli:{...this.M.args,_:[]},urisToOpen:Q?[Q]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});H.focus()}}nb(L){this.m?.workspace?.id===L.id&&(this.m.workspace=void 0)}ob(L){const T=this.Ab();T!==this.r&&(this.r=T,this.Bb(T));let U=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const Q=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.F||Q!==this.G)){this.F=U,this.G=Q;const B=U||"",H=Q?`${Q},<local>`:"<local>";this.L.trace(`Setting proxy to '${B}', bypassing '${H}'`),this.k.webContents.session.setProxy({proxyRules:B,proxyBypassRules:H,pacScript:""})}}addTabbedWindow(L){I.isMacintosh&&L.win&&this.k.addTabbedWindow(L.win)}load(L,T=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!T.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.k.setTitle(this.db.nameLong)),this.pb(L,T),this.hb===0?this.m=L:this.I=L,this.hb=1,this.k.loadURL(v.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const U=this.J;this.J=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new t.RunOnceScheduler(()=>{this.k&&!this.k.isVisible()&&!this.k.isMinimized()&&(this.k.show(),this.focus({force:!0}),this.k.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:L.workspace,reason:T.isReload?3:U?2:1})}pb(L,T){const U=(this.m??this.I)?.userEnv;if(U){const Q=(0,g.isLaunchedFromCli)(U)&&!(0,g.isLaunchedFromCli)(L.userEnv),B=this.isExtensionDevelopmentHost;(Q||B)&&(L.userEnv={...U,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(L["disable-extensions"]=T.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.k.isMaximized(),L.partsSplash=this.U.getWindowSplash(),(0,P.mark)("code/willOpenNewWindow"),L.perfMarks=(0,P.getMarks)(),this.H.update(L)}async reload(L){const T=Object.assign({},this.m);T.workspace=await this.qb(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToMerge,delete T.filesToWait,this.isExtensionDevelopmentHost&&L&&(T.verbose=L.verbose,T.debugId=L.debugId,T.extensionEnvironment=L.extensionEnvironment,T["inspect-extensions"]=L["inspect-extensions"],T["inspect-brk-extensions"]=L["inspect-brk-extensions"],T["extensions-dir"]=L["extensions-dir"]),T.isInitialStartup=!1,T.policiesData=this.N.serialize(),T.continueOn=this.M.continueOn,T.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile},this.load(T,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async qb(L){if((0,N.isWorkspaceIdentifier)(L.workspace)){const T=L.workspace.configPath;if(T.scheme===v.Schemas.file&&!await this.P.exists(T))return}else if((0,N.isSingleFolderWorkspaceIdentifier)(L.workspace)){const T=L.workspace.uri;if(T.scheme===v.Schemas.file&&!await this.P.exists(T))return}return L.workspace}serializeWindowState(){if(!this.k)return(0,G.defaultWindowState)();if(this.isFullScreen){let U;try{U=E.screen.getDisplayMatching(this.getBounds())}catch{}const Q=(0,G.defaultWindowState)();return{mode:3,display:U?U.id:void 0,width:this.n.width||Q.width,height:this.n.height||Q.height,x:this.n.x||0,y:this.n.y||0}}const L=Object.create(null);let T;if(!I.isMacintosh&&this.k.isMaximized()?T=0:T=1,T===0?L.mode=0:L.mode=1,T===1||T===0){let U;T===1?U=this.getBounds():U=this.k.getNormalBounds(),L.x=U.x,L.y=U.y,L.width=U.width,L.height=U.height}return L}updateWindowControls(L){if(L.height&&this.gb.setItem(Ft.a,L.height),I.isWindows&&this.w)this.k.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(I.isMacintosh&&L.height!==void 0){const T=(L.height-15)/2;this.k.setTrafficLightPosition({x:T,y:T})}}rb(L){(0,P.mark)("code/willRestoreCodeWindowState");let T=!1;if(L)try{const U=E.screen.getAllDisplays();T=U.length>1,L=this.sb(L,U)}catch(U){this.L.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}return(0,P.mark)("code/didRestoreCodeWindowState"),[L||(0,G.defaultWindowState)(),T]}sb(L,T){if(this.L.trace(`window#validateWindowState: validating window state on ${T.length} display(s)`,L),typeof L.x!="number"||typeof L.y!="number"||typeof L.width!="number"||typeof L.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(L.width<=0||L.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(T.length===1){const B=this.tb(T[0]);if(B){let H=function(){!L||typeof L.x!="number"||typeof L.y!="number"||!B||(L.x<B.x&&(L.x=B.x),L.y<B.y&&(L.y=B.y))};this.L.trace("window#validateWindowState: 1 monitor working area",B),H(),L.width>B.width&&(L.width=B.width),L.height>B.height&&(L.height=B.height),L.x>B.x+B.width-128&&(L.x=B.x+B.width-L.width),L.y>B.y+B.height-128&&(L.y=B.y+B.height-L.height),H()}return L}if(L.display&&L.mode===3){const B=T.find(H=>H.id===L.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const H=(0,G.defaultWindowState)(3);return H.x=B.bounds.x,H.y=B.bounds.y,H}}let U,Q;try{U=E.screen.getDisplayMatching({x:L.x,y:L.y,width:L.width,height:L.height}),Q=this.tb(U)}catch{}if(U&&Q&&L.x+L.width>Q.x&&L.y+L.height>Q.y&&L.x<Q.x+Q.width&&L.y<Q.y+Q.height)return this.L.trace("window#validateWindowState: multi-monitor working area",Q),L}tb(L){if(L.workArea.width>0&&L.workArea.height>0)return L.workArea;if(L.bounds.width>0&&L.bounds.height>0)return L.bounds}getBounds(){const[L,T]=this.k.getPosition(),[U,Q]=this.k.getSize();return{x:L,y:T,width:U,height:Q}}toggleFullScreen(){this.ub(!this.isFullScreen)}ub(L){this.yb()?this.vb(L):this.xb(L),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",C.CancellationToken.None),this.r&&this.Bb(this.r,!1)}get isFullScreen(){return I.isMacintosh&&typeof this.s=="boolean"?this.s:this.k.isFullScreen()||this.k.isSimpleFullScreen()}vb(L){this.k.isSimpleFullScreen()&&this.k.setSimpleFullScreen(!1),this.wb(L)}wb(L){I.isMacintosh&&(this.s=L,this.t=new t.DeferredPromise,Promise.race([this.t.p,(0,t.timeout)(1e3)]).finally(()=>this.s=void 0)),this.k.setFullScreen(L)}xb(L){this.k.isFullScreen()&&this.wb(!1),this.k.setSimpleFullScreen(L),this.k.webContents.focus()}yb(){const L=this.S.getValue("window");return!L||typeof L.nativeFullScreen!="boolean"||L.nativeTabs?!0:L.nativeFullScreen!==!1}isMinimized(){return this.k.isMinimized()}Ab(){let L=(0,D.getMenuBarVisibility)(this.S);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Bb(L,T=!0){I.isMacintosh||(L==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,m.localize)(12,null)),L==="hidden"?setTimeout(()=>{this.Cb(L)}):this.Cb(L))}Cb(L){const T=this.isFullScreen;switch(L){case"classic":this.k.setMenuBarVisibility(!T),this.k.autoHideMenuBar=T;break;case"visible":this.k.setMenuBarVisibility(!0),this.k.autoHideMenuBar=!1;break;case"toggle":this.k.setMenuBarVisibility(!1),this.k.autoHideMenuBar=!0;break;case"hidden":this.k.setMenuBarVisibility(!1),this.k.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(I.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.k.minimize();break;case"None":break;case"Maximize":default:this.k.isMaximized()?this.k.unmaximize():this.k.maximize()}else this.k.isMaximized()?this.k.unmaximize():this.k.maximize()}close(){this.k?.close()}sendWhenReady(L,T,...U){this.isReady?this.send(L,...U):this.ready().then(()=>{T.isCancellationRequested||this.send(L,...U)})}send(L,...T){if(this.k){if(this.k.isDestroyed()||this.k.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.k.webContents.send(L,...T)}catch(U){this.L.warn(`Error sending IPC message to channel '${L}' of window ${this.j}: ${(0,A.toErrorMessage)(U)}`)}}}updateTouchBar(L){!I.isMacintosh||this.D.forEach((T,U)=>{const Q=L[U];T.segments=this.Fb(Q)})}Db(){if(!!I.isMacintosh){for(let L=0;L<10;L++){const T=this.Eb();this.D.push(T)}this.k.setTouchBar(new E.TouchBar({items:this.D}))}}Eb(L=[]){const T=this.Fb(L),U=new E.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:Q=>{this.sendWhenReady("vscode:runAction",C.CancellationToken.None,{id:U.segments[Q].id,from:"touchbar"})}});return U}Fb(L=[]){return L.map(U=>{let Q;U.icon&&!o.ThemeIcon.isThemeIcon(U.icon)&&U.icon?.dark?.scheme===v.Schemas.file&&(Q=E.nativeImage.createFromPath(h.URI.revive(U.icon.dark).fsPath),Q.isEmpty()&&(Q=void 0));let B;return typeof U.title=="string"?B=U.title:B=U.title.value,{id:U.id,label:Q?void 0:B,icon:Q}})}dispose(){super.dispose(),this.k=null}};le.a="windowControlHeight",le=pe([ie(1,n.ILogService),ie(2,b.IEnvironmentMainService),ie(3,se.IPolicyService),ie(4,de.IUserDataProfilesMainService),ie(5,d.IFileService),ie(6,r.IApplicationStorageMainService),ie(7,r.IStorageMainService),ie(8,p.IConfigurationService),ie(9,y.IThemeMainService),ie(10,Y.IWorkspacesManagementMainService),ie(11,f.IBackupMainService),ie(12,c.ITelemetryService),ie(13,u.IDialogMainService),ie(14,l.ILifecycleMainService),ie(15,s.IProductService),ie(16,i.IProtocolMainService),ie(17,O.IWindowsMainService),ie(18,oe.IStateMainService)],le),e.CodeWindow=le}),define(ee[75],te([0,1,13,24,8,3,33,2,14,4,19,7,23,173,5,21,6,91,92,28,52,38]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p,u,b,g,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,m.createDecorator)("workspacesHistoryMainService");let n=class rt extends k.Disposable{constructor(i,a,r,c){super(),this.f=i,this.g=a,this.h=r,this.j=c,this.c=this.B(new A.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.C=this.B(new C.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.D()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let a=[],r=[];for(const o of i)if((0,b.isRecentWorkspace)(o))!this.g.isUntitledWorkspace(o.workspace)&&!this.r(a,o.workspace)&&a.push(o);else if((0,b.isRecentFolder)(o))this.s(a,o.folderUri)||a.push(o);else{const y=this.t(r,o.fileUri),D=o.fileUri.scheme===w.Schemas.file&&rt.y.indexOf((0,S.basename)(o.fileUri))>=0;!y&&!D&&(r.push(o),v.isWindows&&o.fileUri.scheme===w.Schemas.file&&E.app.addRecentDocument(o.fileUri.fsPath))}const c=await this.l({workspaces:a,files:r});a=c.workspaces,r=c.files,a.length>rt.a&&(a.length=rt.a),r.length>rt.a&&(r.length=rt.a),await this.n({workspaces:a,files:r}),this.c.fire(),v.isMacintosh&&this.C.trigger(()=>this.I())}async removeRecentlyOpened(i){const a=y=>{const D=this.p(y);for(const O of i)if(S.extUriBiasedIgnorePathCase.isEqual(O,D))return!1;return!0},r=await this.getRecentlyOpened(),c=r.workspaces.filter(a),o=r.files.filter(a);(c.length!==r.workspaces.length||o.length!==r.files.length)&&(await this.n({files:o,workspaces:c}),this.c.fire(),v.isMacintosh&&this.C.trigger(()=>this.I()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const a=new l.ResourceMap(o=>S.extUriBiasedIgnorePathCase.getComparisonKey(o));if(i?.workspaces)for(const o of i.workspaces)a.set(this.p(o),o);const r=new l.ResourceMap(o=>S.extUriBiasedIgnorePathCase.getComparisonKey(o));if(i?.files)for(const o of i.files)r.set(this.p(o),o);const c=await this.m();for(const o of c.workspaces){const y=a.get(this.p(o));y?y.label=y.label??o.label:a.set(this.p(o),o)}for(const o of c.files){const y=r.get(this.p(o));y?y.label=y.label??o.label:r.set(this.p(o),o)}return{workspaces:[...a.values()],files:[...r.values()]}}async m(){await this.j.whenReady;let i;const a=this.j.get(rt.b,-1);if(typeof a=="string")try{i=JSON.parse(a)}catch(r){this.f.error("Unexpected error parsing opened paths list",r)}return(0,b.restoreRecentlyOpened)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(rt.b,JSON.stringify((0,b.toStoreData)(i)),-1,1)}p(i){return(0,b.isRecentFolder)(i)?i.folderUri:(0,b.isRecentFile)(i)?i.fileUri:i.workspace.configPath}r(i,a){return!!i.find(r=>(0,b.isRecentWorkspace)(r)&&r.workspace.id===a.id)}s(i,a){return!!i.find(r=>(0,b.isRecentFolder)(r)&&S.extUriBiasedIgnorePathCase.isEqual(r.folderUri,a))}t(i,a){return!!i.find(r=>S.extUriBiasedIgnorePathCase.isEqual(r.fileUri,a))}async D(){!v.isWindows||(await this.F(),this.B(this.onDidChangeRecentlyOpened(()=>this.F())))}async F(){if(!v.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(0,null),description:(0,h.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const a=[];for(const o of E.app.getJumpListSettings().removedItems){const y=o.args;if(y){const D=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(y);D&&a.push(P.URI.parse(D[2]))}}await this.removeRecentlyOpened(a);let r=!1;const c=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.w).map(o=>{const y=(0,b.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:D,description:O}=this.G(y,o.label);let N;return P.URI.isUri(y)?N=`--folder-uri "${y.toString()}"`:(r=!0,N=`--file-uri "${y.configPath.toString()}"`),{type:"task",title:D.substr(0,255),description:O.substr(0,255),program:process.execPath,args:N,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&i.push({type:"custom",name:r?(0,h.localize)(2,null):(0,h.localize)(3,null),items:c})}i.push({type:"recent"});try{const a=E.app.setJumpList(i);a&&a!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${a}`)}catch(a){this.f.warn("updateWindowsJumpList#setJumpList",a)}}G(i,a){if(a)return{title:(0,M.splitName)(a).name,description:a};if(P.URI.isUri(i))return{title:(0,S.basename)(i),description:this.H(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,h.localize)(4,null),description:""};let r=(0,S.basename)(i.configPath);return r.endsWith(g.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-g.WORKSPACE_EXTENSION.length-1)),{title:(0,h.localize)(5,null,r),description:this.H(i.configPath)}}H(i){return i.scheme==="file"?(0,M.normalizeDriveLetter)(i.fsPath):i.toString()}async I(){if(!v.isMacintosh)return;E.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),a=[];let r=0;for(let o=0;o<i.workspaces.length&&r<rt.u;o++){const y=this.p(i.workspaces[o]);if(y.scheme===w.Schemas.file){const D=(0,S.originalFSPath)(y);await I.Promises.exists(D)&&(a.push(D),r++)}}const c=[];for(let o=0;o<i.files.length&&r<rt.v;o++){const y=this.p(i.files[o]);if(y.scheme===w.Schemas.file){const D=(0,S.originalFSPath)(y);if(rt.y.includes((0,S.basename)(y))||a.includes(D))continue;await I.Promises.exists(D)&&(c.push(D),r++)}}c.reverse().forEach(o=>E.app.addRecentDocument(o)),a.reverse().forEach(o=>E.app.addRecentDocument(o))}};n.a=500,n.b="history.recentlyOpenedPathsList",n.u=7,n.v=10,n.w=7,n.y=["COMMIT_EDITMSG","MERGE_MSG"],n=pe([ie(0,p.ILogService),ie(1,d.IWorkspacesManagementMainService),ie(2,f.ILifecycleMainService),ie(3,u.IApplicationStorageMainService)],n),e.WorkspacesHistoryMainService=n}),define(ee[268],te([0,1,13,8,22,33,4,7,163,18,26,21,6,211,65,20,37,35,47,74,31,75]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p,u,b,g,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let s=class Wt{constructor(r,c,o,y,D,O,N,Y,G,V,se){this.n=r,this.o=c,this.p=o,this.q=y,this.r=D,this.s=O,this.t=N,this.u=Y,this.v=G,this.w=V,this.x=se,this.m=Object.create(null),this.g=new t.RunOnceScheduler(()=>this.F(),0),this.h=new t.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(M.isMacintosh||(0,g.getTitleBarStyle)(this.o)==="native")&&this.y(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}y(){const r=this.t.getItem(Wt.a);r&&(r.menus&&(this.k=r.menus),r.keybindings&&(this.l=r.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(O,N,Y)=>this.p.openEmptyWindow({context:2,contextWindowId:N?.id}),this.m["workbench.action.newWindow"]=(O,N,Y)=>this.p.openEmptyWindow({context:2,contextWindowId:N?.id}),this.m["workbench.action.files.openFileFolder"]=(O,N,Y)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.Q(Y),telemetryExtraData:{from:n}}),this.m["workbench.action.files.openFolder"]=(O,N,Y)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.Q(Y),telemetryExtraData:{from:n}}),this.m["workbench.action.openWorkspace"]=(O,N,Y)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.Q(Y),telemetryExtraData:{from:n}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const r=this.x.twitterUrl;r&&(this.m["workbench.action.openTwitterUrl"]=()=>this.bb(r,"openTwitterUrl"));const c=this.x.requestFeatureUrl;c&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.bb(c,"openUserVoiceUrl"));const o=this.x.reportIssueUrl;o&&(this.m["workbench.action.openIssueReporter"]=()=>this.bb(o,"openReportIssues"));const y=this.x.licenseUrl;y&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(M.language){const O=y.indexOf("?")>0?"&":"?";this.bb(`${y}${O}lang=${M.language}`,"openLicenseUrl")}else this.bb(y,"openLicenseUrl")});const D=this.x.privacyStatementUrl;D&&y&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.bb(D,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(r=>this.G(r)),this.w.onDidBlurWindow(()=>this.H()),this.w.onDidFocusWindow(()=>this.H())}get C(){const r=this.o.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get D(){if(!M.isMacintosh)return!1;const r=this.o.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,c){this.k=r.menus,this.l=r.keybindings,this.t.setItem(Wt.a,r),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(r){!M.isMacintosh||(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.d=r.newCount===0,this.E())}H(){!M.isMacintosh||(this.f=!E.BrowserWindow.getFocusedWindow(),this.E())}I(){const r=E.Menu.getApplicationMenu();if(r&&this.j.push(r),Object.keys(this.k).length===0){E.Menu.setApplicationMenu(M.isMacintosh?new E.Menu:null);return}const c=new E.Menu;let o;if(M.isMacintosh){const D=new E.Menu;o=new E.MenuItem({label:this.x.nameShort,submenu:D}),this.J(D),c.append(o)}if(M.isMacintosh&&!this.c){this.c=!0;const D=new E.Menu;D.append(new E.MenuItem({label:this.db(w.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),E.app.dock.setMenu(D)}if(this.L("File")){const D=new E.Menu,O=new E.MenuItem({label:this.db(w.localize(1,null)),submenu:D});this.N(D,"File"),c.append(O)}if(this.L("Edit")){const D=new E.Menu,O=new E.MenuItem({label:this.db(w.localize(2,null)),submenu:D});this.N(D,"Edit"),c.append(O)}if(this.L("Selection")){const D=new E.Menu,O=new E.MenuItem({label:this.db(w.localize(3,null)),submenu:D});this.N(D,"Selection"),c.append(O)}if(this.L("View")){const D=new E.Menu,O=new E.MenuItem({label:this.db(w.localize(4,null)),submenu:D});this.N(D,"View"),c.append(O)}if(this.L("Go")){const D=new E.Menu,O=new E.MenuItem({label:this.db(w.localize(5,null)),submenu:D});this.N(D,"Go"),c.append(O)}if(this.L("Run")){const D=new E.Menu,O=new E.MenuItem({label:this.db(w.localize(6,null)),submenu:D});this.N(D,"Run"),c.append(O)}if(this.L("Terminal")){const D=new E.Menu,O=new E.MenuItem({label:this.db(w.localize(7,null)),submenu:D});this.N(D,"Terminal"),c.append(O)}let y;if(this.L("Window")){const D=new E.Menu;y=new E.MenuItem({label:this.db(w.localize(8,null)),submenu:D,role:"window"}),this.T(D)}if(y&&c.append(y),this.L("Help")){const D=new E.Menu,O=new E.MenuItem({label:this.db(w.localize(9,null)),submenu:D,role:"help"});this.N(D,"Help"),c.append(O)}c.items&&c.items.length>0?E.Menu.setApplicationMenu(c):E.Menu.setApplicationMenu(null),this.h.schedule()}J(r){const c=this.V(w.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),o=this.U();let y;if(this.L("Preferences")){const oe=new E.Menu;this.N(oe,"Preferences"),y=new E.MenuItem({label:this.db(w.localize(11,null)),submenu:oe})}const D=new E.Menu,O=new E.MenuItem({label:w.localize(12,null),role:"services",submenu:D}),N=new E.MenuItem({label:w.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),Y=new E.MenuItem({label:w.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),G=new E.MenuItem({label:w.localize(15,null),role:"unhide"}),V=new E.MenuItem(this.ab("workbench.action.quit",{label:w.localize(16,null,this.x.nameLong),click:async(oe,re,de)=>{const X=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!E.BrowserWindow.getFocusedWindow()||X?.isMinimized())&&await this.K(de)&&this.w.quit(void 0)}})),se=[c];se.push(...o),y&&se.push(i(),y),se.push(i(),O,i(),N,Y,G,i(),V),se.forEach(oe=>r.append(oe))}async K(r){if(this.p.getWindowCount()===0)return!0;const c=this.o.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.R(r)){const o={title:this.x.nameLong,type:"question",buttons:[(0,A.mnemonicButtonLabel)(w.localize(17,null)),(0,A.mnemonicButtonLabel)(w.localize(18,null))],message:w.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:y}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,o);return y===0}return!0}L(r){if(!M.isMacintosh&&(0,g.getTitleBarStyle)(this.o)==="custom")return!1;switch(r){case"File":case"Help":if(M.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[r];case"Window":if(M.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[r]}}M(r,c){c.forEach(o=>{if((0,h.isMenubarMenuItemSeparator)(o))r.append(i());else if((0,h.isMenubarMenuItemSubmenu)(o)){const y=new E.Menu,D=new E.MenuItem({label:this.db(o.label),submenu:y});this.M(y,o.submenu.items),r.append(D)}else(0,h.isMenubarMenuItemRecentAction)(o)?r.append(this.P(o)):(0,h.isMenubarMenuItemAction)(o)&&(o.id==="workbench.action.showAboutDialog"&&this.O(r),M.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[o.id]?r.append(new E.MenuItem(this.ab(o.id,{label:this.db(o.label),click:this.m[o.id]}))):r.append(this.V(o.label,o.id,!1,o.checked)):r.append(this.V(o.label,o.id,o.enabled!==!1,!!o.checked)):r.append(this.V(o.label,o.id,o.enabled!==!1,!!o.checked)))})}N(r,c){this.k&&this.k[c]&&this.M(r,this.k[c].items)}O(r){const c=this.U();c.length&&(c.forEach(o=>r.append(o)),r.append(i()))}P(r){const c=k.URI.revive(r.uri),o=r.id,y=o==="openRecentFile"?{fileUri:c}:o==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new E.MenuItem(this.ab(o,{label:r.label,click:async(D,O,N)=>{const Y=this.Q(N);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[y],forceNewWindow:Y,gotoLineMode:!1,remoteAuthority:r.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([c])}},!1))}Q(r){return!!(r&&(!M.isMacintosh&&(r.ctrlKey||r.shiftKey)||M.isMacintosh&&(r.metaKey||r.altKey)))}R(r){return!!(r.triggeredByAccelerator||r.altKey||r.ctrlKey||r.metaKey||r.shiftKey)}S(r,c,o){const y={label:this.db(r),role:o,enabled:!0};return new E.MenuItem(this.Y(c,y))}T(r){const c=new E.MenuItem({label:w.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),o=new E.MenuItem({label:w.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),y=new E.MenuItem({label:w.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),D=this.V(w.localize(23,null),"workbench.action.switchWindow"),O=[];this.D&&(O.push(i()),O.push(this.V(w.localize(24,null),"workbench.action.newWindowTab")),O.push(this.S(w.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),O.push(this.S(w.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),O.push(this.S(w.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),O.push(this.S(w.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,o,i(),D,...O,i(),y].forEach(N=>r.append(N))}U(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.db(w.localize(29,null)),click:()=>setTimeout(()=>{this.cb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:w.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.db(w.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:w.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.db(w.localize(33,null)),click:()=>{this.cb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new E.MenuItem({label:w.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.db(w.localize(35,null)),click:()=>{this.cb("RestartToUpdate"),this.n.quitAndInstall()}})]}}V(r,c,o,y){const D=this.db(r),O=typeof c=="function"?c:(se,oe,re)=>{const de=se?se.userSettingsLabel:null;let X=c;Array.isArray(c)&&(X=this.Q(re)?c[1]:c[0]),de&&re.triggeredByAccelerator?this.X({type:"keybinding",userSettingsLabel:de}):this.X({type:"commandId",commandId:X})},N=typeof o=="boolean"?o:this.p.getWindowCount()>0,Y=typeof y=="boolean"?y:!1,G={label:D,click:O,enabled:N};Y&&(G.type="checkbox",G.checked=Y);let V;return typeof c=="string"?V=c:Array.isArray(c)&&(V=c[0]),M.isMacintosh&&(V==="editor.action.clipboardCutAction"?G.role="cut":V==="editor.action.clipboardCopyAction"?G.role="copy":V==="editor.action.clipboardPasteAction"&&(G.role="paste"),V==="undo"?G.click=this.W(O,{inDevTools:se=>se.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):V==="redo"?G.click=this.W(O,{inDevTools:se=>se.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):V==="editor.action.selectAll"&&(G.click=this.W(O,{inDevTools:se=>se.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.Y(V,G))}W(r,c){return(o,y,D)=>{const O=E.BrowserWindow.getFocusedWindow();if(!O)return c.inNoWindow();if(O.webContents.isDevToolsFocused()&&O.webContents.devToolsWebContents)return c.inDevTools(O.webContents.devToolsWebContents);r(o,y||O,D)}}X(r){let c=E.BrowserWindow.getFocusedWindow();if(!c){const y=this.p.getLastActiveWindow();y?.isMinimized()&&(c=y.win)}const o=c?this.p.getWindowById(c.id):void 0;if(o){if(this.v.trace("menubar#runActionInRenderer",r),M.isMacintosh&&!this.q.isBuilt&&!o.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const y={id:r.commandId,from:"menu"};o.sendWhenReady("vscode:runAction",C.CancellationToken.None,y)}else{const y={userSettingsLabel:r.userSettingsLabel};o.sendWhenReady("vscode:runKeybinding",C.CancellationToken.None,y)}}else this.v.trace("menubar#runActionInRenderer: no active window found",r)}Y(r,c){const o=typeof r=="string"?this.l[r]:void 0;if(o?.label){if(o.isNative!==!1)c.accelerator=o.label,c.userSettingsLabel=o.userSettingsLabel;else if(typeof c.label=="string"){const y=c.label.indexOf("[");y>=0?c.label=`${c.label.substr(0,y)} [${o.label}]`:c.label=`${c.label} [${o.label}]`}}else c.accelerator=void 0;return c}ab(r,c,o=!c.accelerator){o&&(c=this.Y(r,c));const y=c.click;return c.click=(D,O,N)=>{this.cb(r),y?.(D,O,N)},c}bb(r,c){this.w.openExternal(void 0,r),this.cb(c)}cb(r){this.r.publicLog2("workbenchActionExecuted",{id:r,from:n})}db(r){return(0,A.mnemonicMenuLabel)(r,!this.C)}};s.a="lastKnownMenubarData",s=pe([ie(0,b.IUpdateService),ie(1,v.IConfigurationService),ie(2,d.IWindowsMainService),ie(3,S.IEnvironmentMainService),ie(4,u.ITelemetryService),ie(5,l.IWorkspacesHistoryMainService),ie(6,p.IStateMainService),ie(7,P.ILifecycleMainService),ie(8,I.ILogService),ie(9,m.INativeHostMainService),ie(10,f.IProductService)],s),e.Menubar=s;function i(){return new E.MenuItem({type:"separator"})}}),define(ee[269],te([0,1,5,21,6,268]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let M=class{constructor(w,v,S){this.b=w,this.c=v,this.d=S,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(A.Menubar)}async updateMenubar(w,v){this.d.trace("menubarService#updateMenubar",w),(await this.a).updateMenu(v,w)}};M=pe([ie(0,E.IInstantiationService),ie(1,t.ILifecycleMainService),ie(2,C.ILogService)],M),e.MenubarMainService=M}),define(ee[270],te([0,1,13,23,27,24,22,3,30,49,33,2,14,9,72,4,32,19,12,7,171,60,18,56,26,16,5,21,6,54,20,61,63,37,74,267,117,262,28,93,75,52,64,36,51]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p,u,b,g,d,l,n,s,i,a,r,c,o,y,D,O,N,Y,G,V,se,oe,re,de,X,le,W,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function U(H){return(0,re.isWorkspaceIdentifier)(H?.workspace)}function Q(H){return(0,re.isSingleFolderWorkspaceIdentifier)(H?.workspace)}let B=class dt extends P.Disposable{constructor(R,F,$,z,J,ne,j,x,_,ae,ge,Me,Oe,De,Re,ve,we,be){super(),this.k=R,this.l=F,this.m=$,this.n=z,this.r=J,this.s=ne,this.t=j,this.u=x,this.v=_,this.w=ae,this.C=ge,this.D=Me,this.F=Oe,this.G=De,this.H=Re,this.I=ve,this.J=we,this.L=be,this.b=this.B(new k.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new k.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new k.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new k.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new oe.WindowsStateHandler(this,this.n,this.u,this.m,this.w)),this.M()}M(){this.B(this.D.onDidEnterWorkspace(R=>this.c.fire(R.window))),this.B(this.onDidSignalReadyWindow(R=>{if(R.config?.extensionDevelopmentPath||R.config?.extensionTestsPath){const F=new P.DisposableStore;if(F.add(k.Event.any(R.onDidClose,R.onDidDestroy)(()=>F.dispose())),R.config.extensionDevelopmentPath)for(const $ of R.config.extensionDevelopmentPath)F.add(this.J.addValidFileRoot($));R.config.extensionTestsPath&&F.add(this.J.addValidFileRoot(R.config.extensionTestsPath))}}))}openEmptyWindow(R,F){const $=this.s.args,z=F?.remoteAuthority||void 0,J=!0,ne=F?.forceReuseWindow,j=!ne;return this.open({...R,cli:$,forceEmpty:J,forceNewWindow:j,forceReuseWindow:ne,remoteAuthority:z})}openExistingWindow(R,F){R.focus(),this.N(F,[R])}async open(R){this.m.trace("windowsManager#open"),R.addMode&&(R.initialStartup||!this.getLastActiveWindow())&&(R.addMode=!1);const F=[],$=[],z=[],J=[],ne=[];let j,x=0;const _=await this.U(R);this.m.trace("windowsManager#open pathsToOpen",_);for(const De of _)Q(De)?R.addMode?F.push(De):$.push(De):U(De)?z.push(De):De.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),j.filesToOpenOrCreate.push(De)):De.backupPath?ne.push({backupFolder:(0,h.basename)(De.backupPath),remoteAuthority:De.remoteAuthority}):x++;R.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),R.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&R.waitMarkerFileURI&&(j.filesToWait={paths:(0,A.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:R.waitMarkerFileURI}),R.initialStartup?(J.push(...this.D.getUntitledWorkspaces()),z.push(...J),ne.push(...this.v.getEmptyWindowBackups())):ne.length=0;const{windows:ae,filesOpenedInWindow:ge}=await this.O(R,z,$,ne,x,j,F);if(this.m.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${$.length}, emptyToRestore: ${ne.length}, emptyToOpen: ${x})`),ae.length>1)if(ge)ge.focus();else{const De=this.j.state.lastActiveWindow&&!R.forceEmpty&&!R.cli._.length&&!R.cli["file-uri"]&&!R.cli["folder-uri"]&&!(R.urisToOpen&&R.urisToOpen.length);let Re=!0,ve=!0;if(De){const we=ae.filter(be=>this.j.state.lastActiveWindow&&be.backupPath===this.j.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Re=!1,ve=!1)}if(Re)for(let we=ae.length-1;we>=0;we--){const be=ae[we];if(!(be.openedWorkspace&&J.some(Ce=>be.openedWorkspace&&Ce.workspace.id===be.openedWorkspace.id)||be.backupPath&&ne.some(Ce=>be.backupPath&&Ce.backupFolder===(0,h.basename)(be.backupPath)))){be.focus(),ve=!1;break}}ve&&ae[ae.length-1].focus()}const Me=j&&j.filesToDiff.length>0,Oe=j&&j.filesToMerge.length>0;if(!ae.some(De=>De.isExtensionDevelopmentHost)&&!Me&&!Oe&&!R.noRecentEntry){const De=[];for(const Re of _)U(Re)&&!Re.transient?De.push({label:Re.label,workspace:Re.workspace,remoteAuthority:Re.remoteAuthority}):Q(Re)?De.push({label:Re.label,folderUri:Re.workspace.uri,remoteAuthority:Re.remoteAuthority}):Re.fileUri&&De.push({label:Re.label,fileUri:Re.fileUri,remoteAuthority:Re.remoteAuthority});this.C.addRecentlyOpened(De)}return this.N(R,ae),ae}N(R,F){const $=R.waitMarkerFileURI;R.context===0&&$&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.H.del($)}catch{}})()}async O(R,F,$,z,J,ne,j){const x=[];let _;function ae(we,be){x.push(we),be&&(_=we,ne=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:Me}=this.hb(R);if(!R.initialStartup&&j.length>0){const we=j[0].remoteAuthority,be=this.mb(we);be&&ae(this.Q(be,j.map(Ce=>Ce.workspace.uri)))}const Oe=$.length+F.length+z.length;if(ne&&Oe===0){const we=ne.filesToOpenOrCreate[0]||ne.filesToDiff[0]||ne.filesToMerge[3],be=this.getWindows().filter(Z=>ne&&(0,u.isEqualAuthority)(Z.remoteAuthority,ne.remoteAuthority));let Ce;we?.fileUri&&!Me&&((R.context===4||R.context===0||R.context===1)&&(Ce=await(0,se.findWindowOnFile)(be,we.fileUri,async Z=>Z.configPath.scheme===I.Schemas.file?this.D.resolveLocalWorkspace(Z.configPath):void 0)),Ce||(Ce=this.nb(be))),Ce?(0,re.isWorkspaceIdentifier)(Ce.openedWorkspace)?F.push({workspace:Ce.openedWorkspace,remoteAuthority:Ce.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(Ce.openedWorkspace)?$.push({workspace:Ce.openedWorkspace,remoteAuthority:Ce.remoteAuthority}):ae(this.P(R,Ce,ne),!0):ae(await this.ib({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:ne,forceNewWindow:!0,remoteAuthority:ne.remoteAuthority,forceNewTabbedWindow:R.forceNewTabbedWindow,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile}),!0)}const De=(0,A.distinct)(F,we=>we.workspace.id);if(De.length>0){const we=(0,A.coalesce)(De.map(be=>(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),be.workspace.configPath)));if(we.length>0){const be=we[0],Ce=(0,u.isEqualAuthority)(ne?.remoteAuthority,be.remoteAuthority)?ne:void 0;ae(this.P(R,be,Ce),!!Ce),ge=!0}for(const be of De){if(we.some(ue=>ue.openedWorkspace&&ue.openedWorkspace.id===be.workspace.id))continue;const Ce=be.remoteAuthority,Z=(0,u.isEqualAuthority)(ne?.remoteAuthority,Ce)?ne:void 0;ae(await this.S(R,be,ge,Z),!!Z),ge=!0}}const Re=(0,A.distinct)($,we=>u.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(Re.length>0){const we=(0,A.coalesce)(Re.map(be=>(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),be.workspace.uri)));if(we.length>0){const be=we[0],Ce=(0,u.isEqualAuthority)(ne?.remoteAuthority,be.remoteAuthority)?ne:void 0;ae(this.P(R,be,Ce),!!Ce),ge=!0}for(const be of Re){if(we.some(ue=>(0,re.isSingleFolderWorkspaceIdentifier)(ue.openedWorkspace)&&u.extUriBiasedIgnorePathCase.isEqual(ue.openedWorkspace.uri,be.workspace.uri)))continue;const Ce=be.remoteAuthority,Z=(0,u.isEqualAuthority)(ne?.remoteAuthority,Ce)?ne:void 0;ae(await this.S(R,be,ge,Z),!!Z),ge=!0}}const ve=(0,A.distinct)(z,we=>we.backupFolder);if(ve.length>0)for(const we of ve){const be=we.remoteAuthority,Ce=(0,u.isEqualAuthority)(ne?.remoteAuthority,be)?ne:void 0;ae(await this.R(R,!0,be,Ce,we),!!Ce),ge=!0}if(x.length===0||ne){ne&&!J&&J++;const we=ne?ne.remoteAuthority:R.remoteAuthority;for(let be=0;be<J;be++)ae(await this.R(R,ge,we,ne),!!ne),ge=!0}return{windows:(0,A.distinct)(x),filesOpenedInWindow:_}}P(R,F,$){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:$}),F.focus();const z={filesToOpenOrCreate:$?.filesToOpenOrCreate,filesToDiff:$?.filesToDiff,filesToMerge:$?.filesToMerge,filesToWait:$?.filesToWait,termProgram:R?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",M.CancellationToken.None,z),F}Q(R,F){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),R.focus();const $={foldersToAdd:F};return R.sendWhenReady("vscode:addFolders",M.CancellationToken.None,$),R}R(R,F,$,z,J){this.m.trace("windowsManager#doOpenEmpty",{restore:!!J,remoteAuthority:$,filesToOpen:z,forceNewWindow:F});let ne;return!F&&typeof R.contextWindowId=="number"&&(ne=this.getWindowById(R.contextWindowId)),this.ib({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:$,forceNewWindow:F,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:z,windowToUse:ne,emptyWindowBackupInfo:J,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}S(R,F,$,z,J){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:z}),!$&&!J&&typeof R.contextWindowId=="number"&&(J=this.getWindowById(R.contextWindowId)),this.ib({workspace:F.workspace,userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:$,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:z,windowToUse:J,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}async U(R){let F,$=!1,z=!1;if(R.urisToOpen&&R.urisToOpen.length>0?(F=await this.W(R),$=!0):R.forceEmpty?F=[Object.create(null)]:R.cli._.length||R.cli["folder-uri"]||R.cli["file-uri"]?(F=await this.X(R.cli),F.length===0&&F.push(Object.create(null)),$=!0):(F=await this.ab(),F.length===0&&F.push(Object.create(null)),z=!0),!R.addMode&&$){const J=F.filter(ne=>Q(ne));if(J.length>1){const ne=J[0].remoteAuthority;if(J.every(j=>(0,u.isEqualAuthority)(j.remoteAuthority,ne))){const j=await this.D.createUntitledWorkspace(J.map(x=>({uri:x.workspace.uri})));F.push({workspace:j,remoteAuthority:ne}),F=F.filter(x=>!Q(x))}}}if(R.initialStartup&&!z&&this.w.getValue("window")?.restoreWindows==="preserve"){const J=await this.ab();F.unshift(...J.filter(ne=>U(ne)||Q(ne)||ne.backupPath))}return F}async W(R){const F={gotoLineMode:R.gotoLineMode,remoteAuthority:R.remoteAuthority},$=await Promise.all((0,A.coalesce)(R.urisToOpen||[]).map(async z=>{const J=await this.cb(z,F);if(J)return J.label=z.label,J;const ne=this.eb(z),j={title:this.I.nameLong,type:"info",buttons:[(0,S.mnemonicButtonLabel)((0,d.localize)(0,null))],defaultId:0,message:ne.scheme===I.Schemas.file?(0,d.localize)(1,null):(0,d.localize)(2,null),detail:ne.scheme===I.Schemas.file?(0,d.localize)(3,null,(0,S.getPathLabel)(ne,{os:f.OS,tildify:this.s})):(0,d.localize)(4,null,ne.toString(!0)),noLink:!0};this.G.showMessageBox(j,(0,b.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,A.coalesce)($)}async X(R){const F=[],$={ignoreFileNotFound:!0,gotoLineMode:R.goto,remoteAuthority:R.remote||void 0,forceOpenWorkspaceAsFile:R.diff&&R._.length===2||R.merge&&R._.length===4},z=R["folder-uri"];if(z){const j=await Promise.all(z.map(x=>{const _=this.Y(x);if(!!_)return this.cb({folderUri:_},$)}));F.push(...(0,A.coalesce)(j))}const J=R["file-uri"];if(J){const j=await Promise.all(J.map(x=>{const _=this.Y(x);if(!!_)return this.cb((0,re.hasWorkspaceFileExtension)(x)?{workspaceUri:_}:{fileUri:_},$)}));F.push(...(0,A.coalesce)(j))}const ne=await Promise.all(R._.map(j=>$.remoteAuthority?this.gb(j,$):this.fb(j,$)));return F.push(...(0,A.coalesce)(ne)),F}Y(R){try{const F=g.URI.parse(R);if(!F.scheme){this.m.error(`Invalid URI input string, scheme missing: ${R}`);return}return F}catch(F){this.m.error(`Invalid URI input string: ${R}, ${F.message}`)}}async ab(){const R=this.bb();switch(R){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];R!=="one"&&F.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&F.push(this.j.state.lastActiveWindow);const $=await Promise.all(F.map(async z=>{if(z.workspace){const J=await this.cb({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(U(J))return J}else if(z.folderUri){const J=await this.cb({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(Q(J))return J}else if(R!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,A.coalesce)($)}}}bb(){let R;return this.u.wasRestarted?R="all":(R=this.w.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(R)||(R="all")),R}async cb(R,F=Object.create(null)){const $=this.eb(R);return $.scheme===I.Schemas.file?((0,G.isFileToOpen)(R)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.fb($.fsPath,F)):this.db(R,F)}db(R,F){let $=this.eb(R);const z=(0,N.getRemoteAuthority)($)||F.remoteAuthority;if($=(0,u.removeTrailingPathSeparator)((0,u.normalizePath)($)),(0,G.isFileToOpen)(R)){if(F.gotoLineMode){const{path:J,line:ne,column:j}=(0,w.parseLineAndColumnAware)($.path);return{fileUri:$.with({path:J}),options:{selection:ne?{startLineNumber:ne,startColumn:j||1}:void 0},remoteAuthority:z}}return{fileUri:$,remoteAuthority:z}}else if((0,G.isWorkspaceToOpen)(R))return{workspace:(0,de.getWorkspaceIdentifier)($),remoteAuthority:z};return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)($),remoteAuthority:z}}eb(R){return(0,G.isWorkspaceToOpen)(R)?R.workspaceUri:(0,G.isFolderToOpen)(R)?R.folderUri:R.fileUri}async fb(R,F){let $,z;F.gotoLineMode&&({path:R,line:$,column:z}=(0,w.parseLineAndColumnAware)(R)),R=(0,w.sanitizeFilePath)((0,h.normalize)(R),(0,p.cwd)());try{const J=await t.Promises.stat(R);if(J.isFile()){if(!F.forceOpenWorkspaceAsFile){const ne=await this.D.resolveLocalWorkspace(g.URI.file(R));if(ne)return ne.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:ne.id,configPath:ne.configPath},type:a.FileType.File,exists:!0,remoteAuthority:ne.remoteAuthority,transient:ne.transient}}return{fileUri:g.URI.file(R),type:a.FileType.File,exists:!0,options:{selection:$?{startLineNumber:$,startColumn:z||1}:void 0}}}else{if(J.isDirectory())return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(g.URI.file(R),J),type:a.FileType.Directory,exists:!0};if(!f.isWindows&&R==="/dev/null")return{fileUri:g.URI.file(R),type:a.FileType.File,exists:!0}}}catch{const ne=g.URI.file(R);if(this.C.removeRecentlyOpened([ne]),F.ignoreFileNotFound)return{fileUri:ne,type:a.FileType.File,exists:!1}}}gb(R,F){const $=R.charCodeAt(0),z=F.remoteAuthority;let J,ne;F.gotoLineMode&&({path:R,line:J,column:ne}=(0,w.parseLineAndColumnAware)(R)),$!==47&&((0,w.isWindowsDriveLetter)($)&&R.charCodeAt(R.charCodeAt(1))===58&&(R=(0,w.toSlashes)(R)),R=`/${R}`);const j=g.URI.from({scheme:I.Schemas.vscodeRemote,authority:z,path:R});if(R.charCodeAt(R.length-1)!==47){if((0,re.hasWorkspaceFileExtension)(R))return F.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:J?{startLineNumber:J,startColumn:ne||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,de.getWorkspaceIdentifier)(j),remoteAuthority:z};if(F.gotoLineMode||h.posix.basename(R).indexOf(".")!==-1)return{fileUri:j,options:{selection:J?{startLineNumber:J,startColumn:ne||1}:void 0},remoteAuthority:z}}return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:z}}hb(R){const F=this.w.getValue("window"),$=F?.openFoldersInNewWindow||"default",z=F?.openFilesInNewWindow||"off";let J=(R.preferNewWindow||R.forceNewWindow)&&!R.forceReuseWindow;!R.forceNewWindow&&!R.forceReuseWindow&&($==="on"||$==="off")&&(J=$==="on");let ne=!1;return R.forceNewWindow||R.forceReuseWindow?ne=!!R.forceNewWindow&&!R.forceReuseWindow:(f.isMacintosh?R.context===1&&(ne=!0):R.context!==3&&R.context!==2&&!(R.userEnv&&R.userEnv.TERM_PROGRAM==="vscode")&&(ne=!0),!R.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(ne=z==="on")),{openFolderInNewWindow:!!J,openFilesInNewWindow:ne}}async openExtensionDevelopmentHostWindow(R,F){const $=(0,se.findWindowOnExtensionDevelopmentPath)(this.getWindows(),R);if($)return this.u.reload($,F.cli),$.focus(),[$];let z=F.cli["folder-uri"]||[],J=F.cli["file-uri"]||[],ne=F.cli._;if(!ne.length&&!z.length&&!J.length&&!F.cli.extensionTestsPath){const _=this.j.state.lastPluginDevelopmentHostWindow,ae=_?.workspace??_?.folderUri;ae&&(g.URI.isUri(ae)?ae.scheme===I.Schemas.file?ne=[ae.fsPath]:z=[ae.toString()]:ae.configPath.scheme===I.Schemas.file?ne=[(0,u.originalFSPath)(ae.configPath)]:J=[ae.configPath.toString()])}let j=F.remoteAuthority;for(const _ of R)if(_.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ae=g.URI.parse(_),ge=(0,N.getRemoteAuthority)(ae);ge&&(j?(0,u.isEqualAuthority)(ge,j)||this.m.error("more than one extension development path authority"):j=ge)}ne=ne.filter(_=>{const ae=g.URI.file(_);return(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:(0,u.isEqualAuthority)((0,N.getRemoteAuthority)(ae),j)}),z=z.filter(_=>{const ae=this.Y(_);return ae&&!!(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,u.isEqualAuthority)((0,N.getRemoteAuthority)(ae),j):!1}),J=J.filter(_=>{const ae=this.Y(_);return ae&&!!(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,u.isEqualAuthority)((0,N.getRemoteAuthority)(ae),j):!1}),F.cli._=ne,F.cli["folder-uri"]=z,F.cli["file-uri"]=J;const x={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:!ne.length&&!z.length&&!J.length,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:j,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile};return this.open(x)}async ib(R){const F=this.w.getValue("window"),$={...this.s.args,...R.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.s.appRoot,execPath:process.execPath,codeCachePath:this.s.codeCachePath,backupPath:R.emptyWindowBackupInfo?(0,h.join)(this.s.backupHome,R.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.t.profiles,profile:await this.kb(R)},homeDir:this.s.userHome.fsPath,tmpDir:this.s.tmpDir.fsPath,userDataDir:this.s.userDataPath,remoteAuthority:R.remoteAuthority,workspace:R.workspace,userEnv:{...this.l,...R.userEnv},filesToOpenOrCreate:R.filesToOpen?.filesToOpenOrCreate,filesToDiff:R.filesToOpen?.filesToDiff,filesToMerge:R.filesToOpen?.filesToMerge,filesToWait:R.filesToOpen?.filesToWait,logLevel:this.m.getLevel(),logsPath:this.s.logsPath,product:y.default,isInitialStartup:R.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,C.release)(),hostname:(0,C.hostname)()},zoomLevel:typeof F?.zoomLevel=="number"?F.zoomLevel:void 0,autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.L.getColorScheme(),policiesData:this.r.serialize(),continueOn:this.s.continueOn};let z;if(!R.forceNewWindow&&!R.forceNewTabbedWindow&&(z=R.windowToUse||this.getLastActiveWindow(),z&&z.focus()),z){const J=z.config;!$.extensionDevelopmentPath&&J?.extensionDevelopmentPath&&($.extensionDevelopmentPath=J.extensionDevelopmentPath,$.extensionDevelopmentKind=J.extensionDevelopmentKind,$["enable-proposed-api"]=J["enable-proposed-api"],$.verbose=J.verbose,$["inspect-extensions"]=J["inspect-extensions"],$["inspect-brk-extensions"]=J["inspect-brk-extensions"],$.debugId=J.debugId,$.extensionEnvironment=J.extensionEnvironment,$["extensions-dir"]=J["extensions-dir"],$["disable-extensions"]=J["disable-extensions"])}else{const J=this.j.getNewWindowState($);(0,m.mark)("code/willCreateCodeWindow");const ne=z=this.F.createInstance(V.CodeWindow,{state:J,extensionDevelopmentPath:$.extensionDevelopmentPath,isExtensionTestHost:!!$.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),R.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ne),dt.a.push(ne),this.b.fire(ne),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,v.once)(ne.onDidSignalReady)(()=>this.c.fire(ne)),(0,v.once)(ne.onDidClose)(()=>this.lb(ne)),(0,v.once)(ne.onDidDestroy)(()=>this.f.fire(ne)),ne.onDidTriggerSystemContextMenu(({x,y:_})=>this.h.fire({window:ne,x,y:_}));const j=(0,b.assertIsDefined)(ne.win?.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.u.reload(ne)),this.u.registerWindow(ne)}return $.windowId=z.id,z.isReady?this.u.unload(z,4).then(J=>{J||this.jb(z,$,R)}):this.jb(z,$,R),z}jb(R,F,$){F.extensionDevelopmentPath||((0,re.isWorkspaceIdentifier)(F.workspace)?F.backupPath=this.v.registerWorkspaceBackup({workspace:F.workspace,remoteAuthority:F.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(F.workspace)?F.backupPath=this.v.registerFolderBackup({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority}):F.backupPath=this.v.registerEmptyWindowBackup({backupFolder:$.emptyWindowBackupInfo?.backupFolder??(0,de.createEmptyWorkspaceIdentifier)().id,remoteAuthority:F.remoteAuthority})),R.load(F)}async kb(R){let F;return this.t.isEnabled()&&(R.forceProfile?F=this.t.profiles.find($=>$.name===R.forceProfile)??await this.t.createNamedProfile(R.forceProfile):R.forceTempProfile&&(F=await this.t.createTransientProfile())),F?this.t.setProfileForWorkspaceSync(R.workspace??"empty-window",F):F=this.t.getOrSetProfileForWorkspace(R.workspace??"empty-window",(R.windowToUse??this.getLastActiveWindow())?.profile??this.t.defaultProfile),F}lb(R){const F=dt.a.indexOf(R);dt.a.splice(F,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const R=E.BrowserWindow.getFocusedWindow();if(R)return this.getWindowById(R.id)}getLastActiveWindow(){return this.nb(this.getWindows())}mb(R){return this.nb(this.getWindows().filter(F=>(0,u.isEqualAuthority)(F.remoteAuthority,R)))}nb(R){const F=Math.max.apply(Math,R.map($=>$.lastFocusTime));return R.find($=>$.lastFocusTime===F)}sendToFocused(R,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(R,M.CancellationToken.None,...F)}sendToAll(R,F,$){for(const z of this.getWindows())$&&$.indexOf(z.id)>=0||z.sendWhenReady(R,M.CancellationToken.None,F)}getWindows(){return dt.a}getWindowCount(){return dt.a.length}getWindowById(R){const F=this.getWindows().filter($=>$.id===R);return(0,A.firstOrDefault)(F)}getWindowByWebContents(R){const F=E.BrowserWindow.fromWebContents(R);if(!!F)return this.getWindowById(F.id)}};B.a=[],B=pe([ie(2,o.ILogService),ie(3,Y.IStateMainService),ie(4,L.IPolicyService),ie(5,i.IEnvironmentMainService),ie(6,T.IUserDataProfilesMainService),ie(7,c.ILifecycleMainService),ie(8,l.IBackupMainService),ie(9,n.IConfigurationService),ie(10,X.IWorkspacesHistoryMainService),ie(11,le.IWorkspacesManagementMainService),ie(12,r.IInstantiationService),ie(13,s.IDialogMainService),ie(14,a.IFileService),ie(15,D.IProductService),ie(16,O.IProtocolMainService),ie(17,W.IThemeMainService)],B),e.WindowsMainService=B}),define(ee[271],te([0,1,60,31,75,52]),function(q,e,E,t,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(w,v,S,P){this.a=w,this.b=v,this.c=S,this.d=P,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(w,v){const S=this.b.getWindowById(w);if(S)return this.a.enterWorkspace(S,this.b.getWindows(),v)}createUntitledWorkspace(w,v,S){return this.a.createUntitledWorkspace(v,S)}deleteUntitledWorkspace(w,v){return this.a.deleteUntitledWorkspace(v)}getWorkspaceIdentifier(w,v){return this.a.getWorkspaceIdentifier(v)}getRecentlyOpened(w){return this.c.getRecentlyOpened()}addRecentlyOpened(w,v){return this.c.addRecentlyOpened(v)}removeRecentlyOpened(w,v){return this.c.removeRecentlyOpened(v)}clearRecentlyOpened(w){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};M=pe([ie(0,A.IWorkspacesManagementMainService),ie(1,t.IWindowsMainService),ie(2,C.IWorkspacesHistoryMainService),ie(3,E.IBackupMainService)],M),e.WorkspacesMainService=M}),define(ee[272],te([0,1,13,40,27,17,43,15,30,49,42,33,2,14,9,4,12,7,29,81,130,45,144,102,248,147,60,263,18,70,179,84,118,56,105,202,26,59,111,192,214,193,250,106,194,195,16,206,86,69,5,85,264,227,251,21,6,208,269,65,20,63,257,88,37,254,91,112,35,232,234,73,47,239,240,265,241,266,114,243,244,245,246,252,31,270,253,28,92,75,271,52,249,36,213,51,223,55,87,116,255,261,259,8]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p,u,b,g,d,l,n,s,i,a,r,c,o,y,D,O,N,Y,G,V,se,oe,re,de,X,le,W,L,T,U,Q,B,H,R,F,$,z,J,ne,j,x,_,ae,ge,Me,Oe,De,Re,ve,we,be,Ce,Z,ue,he,ye,Ie,We,Te,ze,Be,qe,Ye,je,Xe,K,ce,fe,me,Se,Le,Ne,it,Ze,Ve,et,nt,ct,gt,It,$t,zt,Ut,qt,Ht,Vt,Gt,kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Pt=class extends I.Disposable{constructor(Ee,Pe,Ae,ke,Fe,$e,_e,tt,Ue,Ge,Ke){super(),this.c=Ee,this.f=Pe,this.g=Ae,this.h=ke,this.i=Fe,this.j=$e,this.k=_e,this.l=tt,this.m=Ue,this.n=Ge,this.p=Ke,this.r(),this.s()}r(){const Ee=Ue=>Ue?.startsWith(`${h.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((Ue,Ge,Ke,xe)=>Ee(xe.requestingUrl)?Ke(Pe.has(Ge)):Ke(!1)),E.session.defaultSession.setPermissionCheckHandler((Ue,Ge,Ke,xe)=>Ee(xe.requestingUrl)?Pe.has(Ge):!1);const Ae=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,"devtools"]),ke=Ue=>{for(let Ge=Ue;Ge;Ge=Ge.parent)if(Ge.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},Fe=Ue=>Ue.resourceType==="xhr"||ke(Ue.frame),$e=Ue=>{const Ge=Ue.frame;if(!Ge||!this.a)return!1;const Ke=E.BrowserWindow.getAllWindows();for(const xe of Ke)if(Ge.processId===xe.webContents.mainFrame.processId)return!0;return!1},_e=(Ue,Ge)=>{if(Ue.path!=="/index.html")return!0;const Ke=Ge.frame;if(!Ke||!this.a)return!1;for(const xe of this.a.getWindows())if(xe.win&&Ke.processId===xe.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((Ue,Ge)=>{const Ke=u.URI.parse(Ue.url);return Ke.scheme===h.Schemas.vscodeWebview&&!_e(Ke,Ue)?(this.h.error("Blocked vscode-webview request",Ue.url),Ge({cancel:!0})):Ke.scheme===h.Schemas.vscodeFileResource&&!$e(Ue)?(this.h.error("Blocked vscode-file request",Ue.url),Ge({cancel:!0})):Ke.path.endsWith(".svg")&&!Ae.has(Ke.scheme)?Ge({cancel:!Fe(Ue)}):Ge({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((Ue,Ge)=>{const Ke=Ue.responseHeaders,xe=Ke["content-type"]||Ke["Content-Type"];if(xe&&Array.isArray(xe)){const st=u.URI.parse(Ue.url);if(st.path.endsWith(".svg")&&Ae.has(st.scheme))return Ke["Content-Type"]=["image/svg+xml"],Ge({cancel:!1,responseHeaders:Ke});if(!st.path.endsWith(h.Schemas.vscodeRemoteResource)&&xe.some(at=>at.toLowerCase().includes("image/svg")))return Ge({cancel:!Fe(Ue)})}return Ge({cancel:!1})});const tt=E.session.defaultSession;typeof tt.setCodeCachePath=="function"&&this.i.codeCachePath&&tt.setCodeCachePath((0,m.join)(this.i.codeCachePath,"chrome"))}s(){(0,k.setUnexpectedErrorHandler)(Ae=>this.u(Ae)),process.on("uncaughtException",Ae=>(0,k.onUnexpectedError)(Ae)),process.on("unhandledRejection",Ae=>(0,k.onUnexpectedError)(Ae)),this.j.onWillShutdown(()=>this.dispose()),(0,d.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(Ae,ke)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",ke)}),E.app.on("activate",async(Ae,ke)=>{this.h.trace("app#activate"),ke||await this.a?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(Ae,ke)=>{ke.on("will-navigate",Fe=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),ke.setWindowOpenHandler(({url:Fe})=>(this.b?.openExternal(void 0,Fe),{action:"deny"}))});let Ee=[],Pe;E.app.on("open-file",(Ae,ke)=>{this.h.trace("app#open-file: ",ke),Ae.preventDefault(),Ee.push((0,Ne.hasWorkspaceFileExtension)(ke)?{workspaceUri:u.URI.file(ke)}:{fileUri:u.URI.file(ke)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],Pe=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Ae=>{const ke=this.a?.getWindowByWebContents(Ae.sender);let Fe,$e;return ke?.config?(Fe=ke.config,$e={...process.env,...ke.config.userEnv}):(Fe=this.i.args,$e=process.env),this.M(Fe,$e,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Ae,ke,Fe)=>{const $e=this.t([ke]);if(!$e||typeof Fe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile($e,A.VSBuffer.fromString(Fe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Ae,...ke)=>{const Fe=this.t(ke);if(!Fe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(Fe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Ae=>Ae.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Ae=>Ae.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Ae=>Ae.sender.reload())}t(Ee){let Pe;for(const Ae of Ee)typeof Ae=="string"&&(typeof Pe!="string"?Pe=Ae:Pe=(0,m.join)(Pe,Ae));if(!(typeof Pe!="string"||!(0,m.isAbsolute)(Pe)||!(0,w.isEqualOrParent)(Pe,this.i.cachedLanguagesPath,!f.isLinux)))return u.URI.file(Pe)}u(Ee){if(Ee){const Pe={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.h.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.h.error(Ee.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Ee=this.n.win32AppUserModelId;f.isWindows&&Ee&&E.app.setAppUserModelId(Ee);try{f.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ue){this.h.error(Ue)}const Pe=new n.Server;this.j.onWillShutdown(Ue=>{Ue.reason===2&&Pe.dispose()}),this.h.trace("Resolving machine identifier...");const Ae=await this.w();this.h.trace(`Resolved machine identifier: ${Ae}`);const{sharedProcess:ke,sharedProcessReady:Fe,sharedProcessClient:$e}=this.y(Ae),_e=await this.C(Ae,ke,Fe);this.v(_e),_e.invokeFunction(Ue=>this.D(Ue,Pe,$e)),await _e.invokeFunction(Ue=>this.F(Ue,Pe)),_e.invokeFunction(Ue=>this.I(Ue,ke)),this.B(new kt.RunOnceScheduler(()=>{this.B((0,kt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Ee){this.B(Ee.createInstance(i.ProxyAuthHandler)),this.B(Ee.createInstance(Vt.UserDataTransientProfilesHandler))}async w(){let Ee=this.l.getItem(Z.machineIdKey);return(!Ee||f.isMacintosh&&Ee==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(Ee=await(0,g.getMachineId)(),this.l.setItem(Z.machineIdKey,Ee)),Ee}y(Ee){const Pe=this.B(this.g.createInstance(De.SharedProcess,Ee,this.f)),Ae=(async()=>{this.h.trace("Main->SharedProcess#connect");const Fe=await Pe.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new s.Client(Fe,"main")})(),ke=(async()=>(await Pe.whenReady(),Ae))();return{sharedProcess:Pe,sharedProcessReady:ke,sharedProcessClient:Ae}}async C(Ee,Pe,Ae){const ke=new $.ServiceCollection;switch(process.platform){case"win32":ke.set(Ie.IUpdateService,new R.SyncDescriptor(qe.Win32UpdateService));break;case"linux":f.isLinuxSnap?ke.set(Ie.IUpdateService,new R.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ke.set(Ie.IUpdateService,new R.SyncDescriptor(ze.LinuxUpdateService));break;case"darwin":ke.set(Ie.IUpdateService,new R.SyncDescriptor(Te.DarwinUpdateService));break}ke.set(me.IWindowsMainService,new R.SyncDescriptor(Se.WindowsMainService,[Ee,this.f],!1));const Fe=new Y.DialogMainService(this.h);ke.set(Y.IDialogMainService,Fe),ke.set(ne.ILaunchMainService,new R.SyncDescriptor(ne.LaunchMainService,void 0,!1)),ke.set(N.IDiagnosticsMainService,new R.SyncDescriptor(N.DiagnosticsMainService,void 0,!1)),ke.set(O.IDiagnosticsService,l.ProxyChannel.toService((0,l.getDelayedChannel)(Ae.then(tt=>tt.getChannel("diagnostics"))))),ke.set(z.IIssueMainService,new R.SyncDescriptor(z.IssueMainService,[this.f])),ke.set(G.IEncryptionMainService,new R.SyncDescriptor(V.EncryptionMainService,[Ee])),ke.set(J.IKeyboardLayoutMainService,new R.SyncDescriptor(J.KeyboardLayoutMainService)),ke.set(ge.INativeHostMainService,new R.SyncDescriptor(ge.NativeHostMainService,[Pe],!1)),ke.set(y.ICredentialsMainService,new R.SyncDescriptor(nt.CredentialsNativeMainService)),ke.set(ce.IWebviewManagerService,new R.SyncDescriptor(fe.WebviewMainService)),ke.set(ae.IMenubarMainService,new R.SyncDescriptor(ae.MenubarMainService)),ke.set(de.IExtensionUrlTrustService,new R.SyncDescriptor(X.ExtensionUrlTrustService)),ke.set(le.IExtensionHostStarter,new R.SyncDescriptor(W.ExtensionHostStarter)),ke.set(be.IStorageMainService,new R.SyncDescriptor(be.StorageMainService)),ke.set(be.IApplicationStorageMainService,new R.SyncDescriptor(be.ApplicationStorageMainService)),f.isWindows?ke.set(L.IExternalTerminalMainService,new R.SyncDescriptor(T.WindowsExternalTerminalService)):f.isMacintosh?ke.set(L.IExternalTerminalMainService,new R.SyncDescriptor(T.MacExternalTerminalService)):f.isLinux&&ke.set(L.IExternalTerminalMainService,new R.SyncDescriptor(T.LinuxExternalTerminalService));const $e=new c.BackupMainService(this.i,this.k,this.h,this.l);ke.set(r.IBackupMainService,$e);const _e=new et.WorkspacesManagementMainService(this.i,this.h,this.p,$e,Fe,this.n);if(ke.set(et.IWorkspacesManagementMainService,_e),ke.set(it.IWorkspacesService,new R.SyncDescriptor(Ve.WorkspacesMainService,void 0,!1)),ke.set(Ze.IWorkspacesHistoryMainService,new R.SyncDescriptor(Ze.WorkspacesHistoryMainService,void 0,!1)),ke.set(Ye.IURLService,new R.SyncDescriptor(Xe.NativeURLService,void 0,!1)),(0,ye.supportsTelemetry)(this.n,this.i)){const tt=(0,ye.isInternalTelemetry)(this.n,this.k),Ue=(0,l.getDelayedChannel)(Ae.then(at=>at.getChannel("telemetryAppender"))),Ge=new ue.TelemetryAppenderClient(Ue),Ke=(0,Ce.resolveCommonProperties)(this.m,(0,C.release)(),(0,C.hostname)(),process.arch,this.n.commit,this.n.version,Ee,tt,this.i.installSourcePath),xe=(0,ye.getPiiPathsFromEnvironment)(this.i),st={appenders:[Ge],commonProperties:Ke,piiPaths:xe,sendErrorTelemetry:!0};ke.set(Z.ITelemetryService,new R.SyncDescriptor(he.TelemetryService,[st],!1))}else ke.set(Z.ITelemetryService,ye.NullTelemetryService);return ke.set(Ut.IExtensionsProfileScannerService,new R.SyncDescriptor(Ut.ExtensionsProfileScannerService,void 0,!0)),ke.set(qt.IExtensionsScannerService,new R.SyncDescriptor(Ht.ExtensionsScannerService,void 0,!0)),await kt.Promises.settled([$e.initialize(),_e.initialize()]),this.g.createChild(ke)}D(Ee,Pe,Ae){const ke=l.ProxyChannel.fromService(Ee.get(ne.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",ke);const Fe=l.ProxyChannel.fromService(Ee.get(N.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Fe);const $e=new gt.PolicyChannel(Ee.get(ct.IPolicyService));Pe.registerChannel("policy",$e),Ae.then(Je=>Je.registerChannel("policy",$e));const _e=this.m.getProvider(h.Schemas.file);(0,p.assertType)(_e instanceof H.DiskFileSystemProvider);const tt=new B.DiskFileSystemProviderChannel(_e,this.h,this.i);Pe.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt),Ae.then(Je=>Je.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt));const Ue=l.ProxyChannel.fromService(Ee.get(It.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",Ue),Ae.then(Je=>Je.registerChannel("userDataProfiles",Ue));const Ge=new $t.RequestChannel(Ee.get(zt.IRequestService));Ae.then(Je=>Je.registerChannel("request",Ge));const Ke=new We.UpdateChannel(Ee.get(Ie.IUpdateService));Pe.registerChannel("update",Ke);const xe=l.ProxyChannel.fromService(Ee.get(z.IIssueMainService));Pe.registerChannel("issue",xe);const st=l.ProxyChannel.fromService(Ee.get(G.IEncryptionMainService));Pe.registerChannel("encryption",st);const at=l.ProxyChannel.fromService(Ee.get(y.ICredentialsMainService));Pe.registerChannel("credentials",at);const Ct=l.ProxyChannel.fromService(Ee.get(Re.ISignService));Pe.registerChannel("sign",Ct);const Qe=l.ProxyChannel.fromService(Ee.get(J.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",Qe),this.b=Ee.get(ge.INativeHostMainService);const mt=l.ProxyChannel.fromService(this.b);Pe.registerChannel("nativeHost",mt),Ae.then(Je=>Je.registerChannel("nativeHost",mt));const wt=l.ProxyChannel.fromService(Ee.get(it.IWorkspacesService));Pe.registerChannel("workspaces",wt);const bt=l.ProxyChannel.fromService(Ee.get(ae.IMenubarMainService));Pe.registerChannel("menubar",bt);const Dt=l.ProxyChannel.fromService(Ee.get(Ye.IURLService));Pe.registerChannel("url",Dt);const Mt=l.ProxyChannel.fromService(Ee.get(de.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",Mt);const pt=l.ProxyChannel.fromService(Ee.get(ce.IWebviewManagerService));Pe.registerChannel("webview",pt);const lt=this.B(new we.StorageDatabaseChannel(this.h,Ee.get(be.IStorageMainService)));Pe.registerChannel("storage",lt),Ae.then(Je=>Je.registerChannel("storage",lt));const yt=this.B(new Gt.ProfileStorageChangesListenerChannel(Ee.get(be.IStorageMainService),Ee.get(It.IUserDataProfilesMainService),this.h));Ae.then(Je=>Je.registerChannel("profileStorageListener",yt));const vt=l.ProxyChannel.fromService(Ee.get(L.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",vt);const ut=new _.LogLevelChannel(Ee.get(x.ILogService),Ee.get(x.ILoggerService));Pe.registerChannel("logLevel",ut),Ae.then(Je=>Je.registerChannel("logLevel",ut));const He=new _.LoggerChannel(Ee.get(x.ILoggerService));Pe.registerChannel("logger",He),Ae.then(Je=>Je.registerChannel("logger",He));const ot=new D.ElectronExtensionHostDebugBroadcastChannel(Ee.get(me.IWindowsMainService));Pe.registerChannel("extensionhostdebugservice",ot);const ht=l.ProxyChannel.fromService(Ee.get(le.IExtensionHostStarter));Pe.registerChannel(le.ipcExtensionHostStarterChannelName,ht)}async F(Ee,Pe){const Ae=this.a=Ee.get(me.IWindowsMainService),ke=Ee.get(Ye.IURLService),Fe=Ee.get(ge.INativeHostMainService);this.j.phase=2;const $e=[],_e=[...this.i.args["open-url"]?this.i.args._urls||[]:[],...global.getOpenUrls()||[]].map(He=>{try{return{uri:u.URI.parse(He),url:He}}catch{return}}).filter(He=>{if(!He||this.G(He.uri))return!1;const ot=this.H(He.uri);return ot?($e.push(ot),!1):!0}),tt=this,Ue=this.i,Ge=this.n,Ke=this.h;ke.registerHandler({async handleURL(He,ot){if(Ke.trace("app#handleURL: ",He.toString(!0),ot),He.scheme===Ge.urlProtocol&&He.path==="workspace"&&(He=He.with({authority:"file",path:u.URI.parse(He.query).path,query:""})),tt.G(He))return!0;let ht=!1;const Je=new URLSearchParams(He.query);Je.get("windowId")==="_blank"&&(Je.delete("windowId"),He=He.with({query:Je.toString()}),ht=!0),ht||=f.isMacintosh&&Ae.getWindowCount()===0;const Nt=Je.get("continueOn");Nt!==null&&(Ue.continueOn=Nt??void 0,Je.delete("continueOn"),He=He.with({query:Je.toString()}));const At=tt.H(He);if(Ke.trace("app#handleURL: windowOpenableFromProtocolLink = ",At),At){const[Rt]=await Ae.open({context:5,cli:{...Ue.args},urisToOpen:[At],forceNewWindow:ht,gotoLineMode:!0});return Rt.focus(),!0}if(ht){const[Rt]=await Ae.open({context:5,cli:{...Ue.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Oe.getRemoteAuthority)(He)});return await Rt.ready(),ke.open(He,ot)}return!1}});const xe=this.B(new Le.ActiveWindowManager({onDidOpenWindow:Fe.onDidOpenWindow,onDidFocusWindow:Fe.onDidFocusWindow,getActiveWindowId:()=>Fe.getActiveWindowId(-1)})),st=new l.StaticRouter(He=>xe.getActiveClientId().then(ot=>He===ot)),at=new je.URLHandlerRouter(st),Ct=Pe.getChannel("urlHandler",at);ke.registerHandler(new je.URLHandlerChannelClient(Ct)),this.B(new K.ElectronURLListener(_e,ke,Ae,this.i,this.n));const Qe=this.i.args,mt=global.macOpenFiles,wt=(0,oe.isLaunchedFromCli)(process.env)?0:4,bt=Qe._.length,Dt=!!Qe["folder-uri"],Mt=!!Qe["file-uri"],pt=Qe["skip-add-to-recently-opened"]===!0,lt=Qe.wait&&Qe.waitMarkerFilePath?u.URI.file(Qe.waitMarkerFilePath):void 0,yt=Qe.remote||void 0,vt=Qe.profile,ut=Qe["profile-temp"];if($e.length>0)return Ae.open({context:wt,cli:Qe,urisToOpen:$e,gotoLineMode:!0,initialStartup:!0});if(!bt&&!Dt&&!Mt){if(Qe["new-window"]||vt||ut)return Ae.open({context:wt,cli:Qe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:pt,waitMarkerFileURI:lt,initialStartup:!0,remoteAuthority:yt,forceProfile:vt,forceTempProfile:ut});if(mt.length)return Ae.open({context:1,cli:Qe,urisToOpen:mt.map(He=>(0,Ne.hasWorkspaceFileExtension)(He)?{workspaceUri:u.URI.file(He)}:{fileUri:u.URI.file(He)}),noRecentEntry:pt,waitMarkerFileURI:lt,initialStartup:!0})}return Ae.open({context:wt,cli:Qe,forceNewWindow:Qe["new-window"]||!bt&&Qe["unity-launch"],diffMode:Qe.diff,mergeMode:Qe.merge,noRecentEntry:pt,waitMarkerFileURI:lt,gotoLineMode:Qe.goto,initialStartup:!0,remoteAuthority:yt,forceProfile:vt,forceTempProfile:ut})}G(Ee){return!!(Ee.authority===h.Schemas.file&&f.isWindows&&E.dialog.showMessageBoxSync({title:this.n.nameLong,type:"question",buttons:[(0,P.mnemonicButtonLabel)((0,a.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,a.localize)(1,null))],defaultId:0,cancelId:1,message:(0,a.localize)(2,null,(0,P.getPathLabel)(Ee,{os:f.OS,tildify:this.i}),this.n.nameShort),detail:(0,a.localize)(3,null),noLink:!0})===1)}H(Ee){if(!!Ee.path){if(Ee.authority===h.Schemas.file){const Pe=u.URI.file(Ee.fsPath);return(0,Ne.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(Ee.authority===h.Schemas.vscodeRemote){const Pe=Ee.path.indexOf(m.posix.sep,1);if(Pe!==-1){const Ae=Ee.path.substring(1,Pe),ke=Ee.path.substring(Pe),Fe=u.URI.from({scheme:h.Schemas.vscodeRemote,authority:Ae,path:ke,query:Ee.query,fragment:Ee.fragment});return(0,Ne.hasWorkspaceFileExtension)(ke)?{workspaceUri:Fe}:/:[\d]+$/.test(ke)?{fileUri:Fe}:{folderUri:Fe}}}}}I(Ee,Pe){const Ae=Ee.get(Z.ITelemetryService),ke=Ee.get(Ie.IUpdateService);this.j.phase=3,this.L(Ae,Pe),this.J(),E.protocol.registerHttpProtocol(h.Schemas.vscodeRemoteResource,(Fe,$e)=>{$e({url:Fe.url.replace(/^vscode-remote-resource:/,"http:"),method:Fe.method})}),(ke instanceof qe.Win32UpdateService||ke instanceof ze.LinuxUpdateService||ke instanceof Te.DarwinUpdateService)&&ke.initialize(),this.M(this.i.args,process.env,!0),this.N()}async J(){const Ee=this.n.win32MutexName;if(f.isWindows&&Ee)try{const Pe=await new Promise((ke,Fe)=>{q(["windows-mutex"],ke,Fe)}),Ae=new Pe.Mutex(Ee);(0,v.once)(this.j.onWillShutdown)(()=>Ae.release())}catch(Pe){this.h.error(Pe)}}L(Ee,Pe){let Ae=!1;(0,v.once)(this.j.onWillShutdown)(()=>Ae=!0),this.B(Pe.onDidError(({type:ke,details:Fe})=>{let $e;switch(ke){case 1:$e="SharedProcess: detected unresponsive window";break;case 2:$e=`SharedProcess: renderer process gone (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break;case 3:$e=`SharedProcess: failed to load (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break}(0,k.onUnexpectedError)(new Error($e)),Ee.publicLog2("sharedprocesserror",{type:ke,reason:Fe?.reason,code:Fe?.exitCode,visible:Pe.isVisible(),shuttingdown:Ae})}))}async M(Ee,Pe,Ae){try{return await(0,re.getResolvedShellEnv)(this.h,Ee,Pe)}catch(ke){const Fe=(0,M.toErrorMessage)(ke);Ae?this.a?.sendToFocused("vscode:showResolveShellEnvError",Fe):this.h.error(Fe)}return{}}async N(){try{const Pe=(await this.m.readFile(this.i.argvResource)).value.toString(),Ae=JSON.parse((0,S.stripComments)(Pe)),Fe=(0,ye.getTelemetryLevel)(this.k)>=1;if(Ae["enable-crash-reporter"]===void 0){const $e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Fe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,b.generateUuid)()}"`,"}"],_e=Pe.substring(0,Pe.length-2).concat(`,
`,$e.join(`
`));await this.m.writeFile(this.i.argvResource,A.VSBuffer.fromString(_e))}else{const $e=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Fe},`);$e!==Pe&&await this.m.writeFile(this.i.argvResource,A.VSBuffer.fromString($e))}}catch(Ee){this.h.error(Ee)}}};Pt=pe([ie(2,F.IInstantiationService),ie(3,x.ILogService),ie(4,se.IEnvironmentMainService),ie(5,j.ILifecycleMainService),ie(6,o.IConfigurationService),ie(7,ve.IStateMainService),ie(8,Q.IFileService),ie(9,Me.IProductService),ie(10,It.IUserDataProfilesMainService)],Pt),e.CodeApplication=Pt}),define(ee[273],te([0,1,36,8,280,2,6]),function(q,e,E,t,C,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let k=class extends E.AbstractPolicyService{constructor(v,S){super(),this.j=v,this.k=S,this.a=new t.Throttler,this.b=this.B(new A.MutableDisposable)}async i(v){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${v.length} policy definitions`),await this.a.queue(()=>new Promise((S,P)=>{try{this.b.value=(0,C.createWatcher)(this.k,v,I=>{this.m(I),S()})}catch(I){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",I),P(I)}}))}m(v){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${Object.keys(v).join(", ")}`);for(const S in v){const P=v[S];P===void 0?this.g.delete(S):this.g.set(S,P)}this.h.fire(Object.keys(v))}};k=pe([ie(0,M.ILogService)],k),e.NativePolicyService=k}),define(ee[274],te([0,1,225,8,17,15,2,12,18,34,111,6,224,281]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let m=class extends M.Disposable{constructor(p,u,b){super(),this.h=u,this.i=b,this.j(p.getValue()),this.B(p.onDidChangeConfiguration(()=>this.j(p.getValue()),this))}j(p){this.a=p.http&&p.http.proxy,this.b=!!(p.http&&p.http.proxyStrictSSL),this.f=p.http&&p.http.proxyAuthorization}async request(p,u){this.i.trace("RequestService#request (node) - begin",p.url);const{a:b,b:g}=this;let d;try{d=await(0,S.getResolvedShellEnv)(this.i,this.h.args,process.env)}catch(s){this.g||(this.g=!0,this.i.error("RequestService#request (node) resolving shell environment failed",s))}const l={...process.env,...d},n=p.agent?p.agent:await(0,I.getProxyAgent)(p.url||"",l,{proxyUrl:b,strictSSL:g});p.agent=n,p.strictSSL=g,this.f&&(p.headers={...p.headers||{},"Proxy-Authorization":this.f});try{const s=await this.l(p,u);return this.i.trace("RequestService#request (node) - success",p.url),s}catch(s){throw this.i.trace("RequestService#request (node) - error",p.url,s),s}}async k(p){return((0,E.parse)(p.url).protocol==="https:"?await new Promise((g,d)=>{q(["https"],g,d)}):await new Promise((g,d)=>{q(["http"],g,d)})).request}l(p,u){return t.Promises.withAsyncBody(async(b,g)=>{const d=(0,E.parse)(p.url),l=p.getRawRequest?p.getRawRequest(p):await this.k(p),n={hostname:d.hostname,port:d.port?parseInt(d.port):d.protocol==="https:"?443:80,protocol:d.protocol,path:d.path,method:p.type||"GET",headers:p.headers,agent:p.agent,rejectUnauthorized:(0,k.isBoolean)(p.strictSSL)?p.strictSSL:!0};p.user&&p.password&&(n.auth=p.user+":"+p.password);const s=l(n,i=>{const a=(0,k.isNumber)(p.followRedirects)?p.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&a>0&&i.headers.location)this.l({...p,url:i.headers.location,followRedirects:a-1},u).then(b,g);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,h.createGunzip)())),b({res:i,stream:(0,C.streamToBufferReadableStream)(r)})}});s.on("error",g),p.timeout&&s.setTimeout(p.timeout),p.data&&typeof p.data=="string"&&s.write(p.data),s.end(),u.onCancellationRequested(()=>{s.abort(),g(new A.CancellationError)})})}async resolveProxy(p){}};m=pe([ie(0,w.IConfigurationService),ie(1,v.INativeEnvironmentService),ie(2,P.ILogService)],m),e.RequestService=m}),define(ee[275],te([0,1,13,274]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function C(M){return E.net.request}class A extends t.RequestService{request(k,w){return super.request({...k||{},getRawRequest:C},w)}}e.RequestMainService=A}),define(ee[282],te([0,1,13,39,7,24,8,43,15,30,49,33,14,9,72,4,32,25,23,45,83,272,10,18,218,231,26,59,183,16,204,86,69,200,85,21,207,6,210,54,20,61,256,113,237,55,275,88,226,37,230,73,64,51,36,273,212,2,48,242,41,238]),function(q,e,E,t,C,A,M,k,w,v,S,P,I,h,m,f,p,u,b,g,d,l,n,s,i,a,r,c,o,y,D,O,N,Y,G,V,se,oe,re,de,X,le,W,L,T,U,Q,B,H,R,F,$,z,J,ne,j,x,_,ae,ge,Me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Oe{main(){try{this.a()}catch(ve){console.error(ve.message),E.app.exit(1)}}async a(){(0,w.setUnexpectedErrorHandler)(Ie=>console.error(Ie));const[ve,we,be,Ce,Z,ue,he,ye]=this.b();try{try{await this.d(be,ye,Ce,Z,he)}catch(Ie){throw this.f(be,he.nameLong,Ie),Ie}await ve.invokeFunction(async Ie=>{const We=Ie.get(oe.ILogService),Te=Ie.get(V.ILifecycleMainService),ze=Ie.get(y.IFileService),Be=Ie.get(oe.ILoggerService),qe=await this.e(We,be,Te,ve,he,!0);return b.Promises.writeFile(be.mainLockfile,String(process.pid)).catch(Ye=>{We.warn(`Error writing main lockfile: ${Ye.stack}`)}),ue.logger=Be.createLogger(C.URI.file((0,h.join)(be.logsPath,"main.log")),{name:"main"}),(0,S.once)(Te.onWillShutdown)(Ye=>{ze.dispose(),Ce.dispose(),Ye.join(b.Promises.unlink(be.mainLockfile).catch(()=>{}))}),ve.createInstance(l.CodeApplication,qe,we).startup()})}catch(Ie){ve.invokeFunction(this.i,Ie)}}b(){const ve=new G.ServiceCollection,we=new _.DisposableStore;process.once("exit",()=>we.dispose());const be={_serviceBrand:void 0,...de.default};ve.set(X.IProductService,be);const Ce=new r.EnvironmentMainService(this.j(),be),Z=this.c(Ce);ve.set(r.IEnvironmentMainService,Ce);const ue=new se.BufferLogService,he=we.add(new oe.MultiplexLogService([new oe.ConsoleMainLogger((0,oe.getLogLevel)(Ce)),ue]));ve.set(oe.ILogService,he);const ye=new D.FileService(he);ve.set(y.IFileService,ye);const Ie=new O.DiskFileSystemProvider(he);ye.registerProvider(I.Schemas.file,Ie);const We=new ge.UriIdentityService(ye);ve.set(ae.IUriIdentityService,We),ve.set(oe.ILoggerService,new re.LoggerService(he));const Te=new F.StateMainService(Ce,he,ye);ve.set(R.IStateMainService,Te);const ze=new J.UserDataProfilesMainService(Te,We,Ce,ye,he);ve.set(J.IUserDataProfilesMainService,ze);const Be=f.isWindows&&be.win32RegValueName?we.add(new j.NativePolicyService(he,be.win32RegValueName)):Ce.policyFile?we.add(new x.FilePolicyService(Ce.policyFile,ye,he)):new ne.NullPolicyService;ve.set(ne.IPolicyService,Be);const qe=new i.ConfigurationService(ze.defaultProfile.settingsResource,ye,Be,he);return ve.set(s.IConfigurationService,qe),ve.set(V.ILifecycleMainService,new N.SyncDescriptor(V.LifecycleMainService,void 0,!1)),ve.set(U.IRequestService,new N.SyncDescriptor(Q.RequestMainService,void 0,!0)),ve.set(z.IThemeMainService,new N.SyncDescriptor(z.ThemeMainService)),ve.set(B.ISignService,new N.SyncDescriptor(H.SignService,void 0,!1)),ve.set(L.ITunnelService,new N.SyncDescriptor(T.TunnelService)),ve.set(le.IProtocolMainService,new W.ProtocolMainService(Ce,ze,he)),[new Y.InstantiationService(ve,!0),Z,Ce,qe,Te,ue,be,ze]}c(ve){const we={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(be=>{const Ce=process.env[be];typeof Ce=="string"&&(we[be]=Ce)}),Object.assign(process.env,we),we}async d(ve,we,be,Ce,Z){await M.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsPath,we.defaultProfile.globalStorageHome.fsPath,ve.workspaceStorageHome.fsPath,ve.localHistoryHome.fsPath,ve.backupHome].map(ue=>ue?b.Promises.mkdir(ue,{recursive:!0}):void 0)),Ce.init(),be.initialize()]),we.setEnablement(Z.quality!=="stable"||be.getValue(Me.PROFILES_ENABLEMENT_CONFIG))}async e(ve,we,be,Ce,Z,ue){let he;try{(0,m.mark)("code/willStartMainServer"),he=await(0,d.serve)(we.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),(0,S.once)(be.onWillShutdown)(()=>he.dispose())}catch(ye){if(ye.code!=="EADDRINUSE")throw this.f(we,Z.nameLong,ye),ye;let Ie;try{Ie=await(0,d.connect)(we.mainIPCHandle,"main")}catch(Be){if(!ue||f.isWindows||Be.code!=="ECONNREFUSED")throw Be.code==="EPERM"&&this.g((0,n.localize)(0,null,Z.nameShort),(0,n.localize)(1,null),Z.nameLong),Be;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch(qe){throw ve.warn("Could not delete obsolete instance handle",qe),qe}return this.e(ve,we,be,Ce,Z,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const Be=`Running extension tests from the command line is currently only supported if no other instance of ${Z.nameShort} is running.`;throw ve.error(Be),Ie.dispose(),new Error(Be)}let We;!we.args.wait&&!we.args.status&&(We=setTimeout(()=>{this.g((0,n.localize)(2,null,Z.nameShort),(0,n.localize)(3,null),Z.nameLong)},1e4));const Te=g.ProxyChannel.toService(Ie.getChannel("launch"),{disableMarshalling:!0}),ze=g.ProxyChannel.toService(Ie.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return Ce.invokeFunction(async()=>{const Be=new a.DiagnosticsService($.NullTelemetryService,Z),qe=await ze.getMainDiagnostics(),Ye=await ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),je=await Be.getDiagnostics(qe,Ye);throw console.log(je),new w.ExpectedError});throw f.isWindows&&await this.h(Te,ve),ve.trace("Sending env to running instance..."),await Te.start(we.args,process.env),Ie.dispose(),We&&clearTimeout(We),new w.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw ve.warn(`Warning: The --status argument can only be used if ${Z.nameShort} is already running. Please run it again after {0} has started.`),new w.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),he}f(ve,we,be){if(be.code==="EACCES"||be.code==="EPERM"){const Ce=(0,A.coalesce)([ve.userDataPath,ve.extensionsPath,d.XDG_RUNTIME_DIR]).map(Z=>(0,P.getPathLabel)(C.URI.file(Z),{os:f.OS,tildify:ve}));this.g((0,n.localize)(4,null),(0,n.localize)(5,null,(0,k.toErrorMessage)(be),Ce.join(`
`)),we)}}g(ve,we,be){E.dialog.showMessageBoxSync({title:be,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,n.localize)(6,null))],message:ve,detail:we,defaultId:0,noLink:!0})}async h(ve,we){if(f.isWindows){const be=await ve.getMainProcessId();we.trace("Sending some foreground love to the running instance:",be);try{(await new Promise((Ce,Z)=>{q(["windows-foreground-love"],Ce,Z)})).allowSetForegroundWindow(be)}catch(Ce){we.error(Ce)}}}i(ve,we){const be=ve.get(oe.ILogService),Ce=ve.get(V.ILifecycleMainService);let Z=0;we&&(we.isExpected?we.message&&be.trace(we.message):(Z=1,we.stack?be.error(we.stack):be.error(`Startup error: ${we.toString()}`))),Ce.kill(Z)}j(){const ve=this.k((0,c.parseMainProcessArgv)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const we=(0,o.createWaitMarkerFileSync)(ve.verbose);we&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",we),ve.waitMarkerFilePath=we)}return ve}k(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const we=this.l(ve._,ve.goto);ve._=we}return ve}l(ve,we){const be=(0,p.cwd)(),Ce=ve.map(he=>{let ye=String(he),Ie;we&&(Ie=(0,v.parseLineAndColumnAware)(ye),ye=Ie.path),ye&&(ye=this.m(be,ye));const We=(0,v.sanitizeFilePath)(ye,be),Te=(0,h.basename)(We);return Te&&!(0,v.isValidBasename)(Te)?null:we&&Ie?(Ie.path=We,this.n(Ie)):We}),Z=f.isWindows||f.isMacintosh,ue=(0,A.distinct)(Ce,he=>he&&Z?he.toLowerCase():he||"");return(0,A.coalesce)(ue)}m(ve,we){return f.isWindows&&(we=(0,u.rtrim)(we,'"')),we=(0,u.trim)((0,u.trim)(we," "),"	"),f.isWindows&&(we=(0,h.resolve)(ve,we),we=(0,u.rtrim)(we,".")),we}n(ve){const we=[ve.path];return typeof ve.line=="number"&&we.push(String(ve.line)),typeof ve.column=="number"&&we.push(String(ve.column)),we.join(":")}}new Oe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d9a70c4236a8bde4fe7435df3ecdd333c7bc939c/core/vs/code/electron-main/main.js.map
