/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/errors","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/base/common/codicons","vs/nls","vs/base/common/arrays","vs/base/common/uri","vs/base/browser/browser","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/keyboardEvent","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/color","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/objects","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/platform/instantiation/common/instantiation","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/network","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/list/listWidget","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/toggle/toggle","vs/platform/instantiation/common/descriptors","vs/platform/theme/common/themeService","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(Q){for(var t=[],v=0,i=Q.length;v<i;v++)t[v]=be[Q[v]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function $t(Q){if(Array.isArray(Q)){for(var t=0,v=Array(Q.length);t<Q.length;t++)v[t]=Q[t];return v}else return Array.from(Q)}var _t=Object.hasOwnProperty,Nt=Object.setPrototypeOf,Vt=Object.isFrozen,jt=Object.getPrototypeOf,Kt=Object.getOwnPropertyDescriptor,et=Object.freeze,ot=Object.seal,qt=Object.create,It=typeof Reflect<"u"&&Reflect,vt=It.apply,Et=It.construct;vt||(vt=function(t,v,i){return t.apply(v,i)}),et||(et=function(t){return t}),ot||(ot=function(t){return t}),Et||(Et=function(t,v){return new(Function.prototype.bind.apply(t,[null].concat($t(v))))});var Gt=nt(Array.prototype.forEach),Mt=nt(Array.prototype.pop),bt=nt(Array.prototype.push),ht=nt(String.prototype.toLowerCase),Pt=nt(String.prototype.match),lt=nt(String.prototype.replace),Yt=nt(String.prototype.indexOf),Xt=nt(String.prototype.trim),at=nt(RegExp.prototype.test),Rt=Zt(TypeError);function nt(Q){return function(t){for(var v=arguments.length,i=Array(v>1?v-1:0),U=1;U<v;U++)i[U-1]=arguments[U];return vt(Q,t,i)}}function Zt(Q){return function(){for(var t=arguments.length,v=Array(t),i=0;i<t;i++)v[i]=arguments[i];return Et(Q,v)}}function He(Q,t){Nt&&Nt(Q,null);for(var v=t.length;v--;){var i=t[v];if(typeof i=="string"){var U=ht(i);U!==i&&(Vt(t)||(t[v]=U),i=U)}Q[i]=!0}return Q}function ut(Q){var t=qt(null),v=void 0;for(v in Q)vt(_t,Q,[v])&&(t[v]=Q[v]);return t}function Dt(Q,t){for(;Q!==null;){var v=Kt(Q,t);if(v){if(v.get)return nt(v.get);if(typeof v.value=="function")return nt(v.value)}Q=jt(Q)}function i(U){return console.warn("fallback value for",U),null}return i}var Ot=et(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Ct=et(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),At=et(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Qt=et(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),St=et(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),Jt=et(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Bt=et(["#text"]),Ht=et(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),kt=et(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Ut=et(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=et(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),xt=ot(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ei=ot(/<%[\s\S]*|[\s\S]*%>/gm),ti=ot(/^data-[\-\w.\u00B7-\uFFFF]/),ii=ot(/^aria-[\-\w]+$/),ni=ot(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),si=ot(/^(?:\w+script|data):/i),ri=ot(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),pt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(Q){return typeof Q}:function(Q){return Q&&typeof Symbol=="function"&&Q.constructor===Symbol&&Q!==Symbol.prototype?"symbol":typeof Q};function rt(Q){if(Array.isArray(Q)){for(var t=0,v=Array(Q.length);t<Q.length;t++)v[t]=Q[t];return v}else return Array.from(Q)}var oi=function(){return typeof window>"u"?null:window},ai=function(t,v){if((typeof t>"u"?"undefined":pt(t))!=="object"||typeof t.createPolicy!="function")return null;var i=null,U="data-tt-policy-suffix";v.currentScript&&v.currentScript.hasAttribute(U)&&(i=v.currentScript.getAttribute(U));var R="dompurify"+(i?"#"+i:"");try{return t.createPolicy(R,{createHTML:function(w){return w}})}catch{return console.warn("TrustedTypes policy "+R+" could not be created."),null}};function Wt(){var Q=arguments.length>0&&arguments[0]!==void 0?arguments[0]:oi(),t=function(re){return Wt(re)};if(t.version="2.3.1",t.removed=[],!Q||!Q.document||Q.document.nodeType!==9)return t.isSupported=!1,t;var v=Q.document,i=Q.document,U=Q.DocumentFragment,R=Q.HTMLTemplateElement,y=Q.Node,w=Q.Element,c=Q.NodeFilter,d=Q.NamedNodeMap,f=d===void 0?Q.NamedNodeMap||Q.MozNamedAttrMap:d,I=Q.Text,r=Q.Comment,n=Q.DOMParser,e=Q.trustedTypes,s=w.prototype,l=Dt(s,"cloneNode"),u=Dt(s,"nextSibling"),m=Dt(s,"childNodes"),o=Dt(s,"parentNode");if(typeof R=="function"){var a=i.createElement("template");a.content&&a.content.ownerDocument&&(i=a.content.ownerDocument)}var g=ai(e,v),C=g&&Z?g.createHTML(""):"",L=i,k=L.implementation,S=L.createNodeIterator,h=L.createDocumentFragment,E=L.getElementsByTagName,p=v.importNode,D={};try{D=ut(i).documentMode?i.documentMode:{}}catch{}var z={};t.isSupported=typeof o=="function"&&k&&typeof k.createHTMLDocument<"u"&&D!==9;var q=xt,ie=ei,J=ti,me=ii,he=si,fe=ri,oe=ni,de=null,Se=He({},[].concat(rt(Ot),rt(Ct),rt(At),rt(St),rt(Bt))),te=null,Ce=He({},[].concat(rt(Ht),rt(kt),rt(Ut),rt(yt))),se=null,x=null,ue=!0,ne=!0,F=!1,_=!1,G=!1,P=!1,b=!1,B=!1,$=!1,V=!0,Z=!1,T=!0,M=!0,H=!1,A={},N=null,O=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),W=null,j=He({},["audio","video","img","source","image","track"]),ee=null,le=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),ce="http://www.w3.org/1998/Math/MathML",De="http://www.w3.org/2000/svg",ye="http://www.w3.org/1999/xhtml",Ie=ye,ke=!1,ve=null,Re=i.createElement("form"),Pe=function(re){ve&&ve===re||((!re||(typeof re>"u"?"undefined":pt(re))!=="object")&&(re={}),re=ut(re),de="ALLOWED_TAGS"in re?He({},re.ALLOWED_TAGS):Se,te="ALLOWED_ATTR"in re?He({},re.ALLOWED_ATTR):Ce,ee="ADD_URI_SAFE_ATTR"in re?He(ut(le),re.ADD_URI_SAFE_ATTR):le,W="ADD_DATA_URI_TAGS"in re?He(ut(j),re.ADD_DATA_URI_TAGS):j,N="FORBID_CONTENTS"in re?He({},re.FORBID_CONTENTS):O,se="FORBID_TAGS"in re?He({},re.FORBID_TAGS):{},x="FORBID_ATTR"in re?He({},re.FORBID_ATTR):{},A="USE_PROFILES"in re?re.USE_PROFILES:!1,ue=re.ALLOW_ARIA_ATTR!==!1,ne=re.ALLOW_DATA_ATTR!==!1,F=re.ALLOW_UNKNOWN_PROTOCOLS||!1,_=re.SAFE_FOR_TEMPLATES||!1,G=re.WHOLE_DOCUMENT||!1,B=re.RETURN_DOM||!1,$=re.RETURN_DOM_FRAGMENT||!1,V=re.RETURN_DOM_IMPORT!==!1,Z=re.RETURN_TRUSTED_TYPE||!1,b=re.FORCE_BODY||!1,T=re.SANITIZE_DOM!==!1,M=re.KEEP_CONTENT!==!1,H=re.IN_PLACE||!1,oe=re.ALLOWED_URI_REGEXP||oe,Ie=re.NAMESPACE||ye,_&&(ne=!1),$&&(B=!0),A&&(de=He({},[].concat(rt(Bt))),te=[],A.html===!0&&(He(de,Ot),He(te,Ht)),A.svg===!0&&(He(de,Ct),He(te,kt),He(te,yt)),A.svgFilters===!0&&(He(de,At),He(te,kt),He(te,yt)),A.mathMl===!0&&(He(de,St),He(te,Ut),He(te,yt))),re.ADD_TAGS&&(de===Se&&(de=ut(de)),He(de,re.ADD_TAGS)),re.ADD_ATTR&&(te===Ce&&(te=ut(te)),He(te,re.ADD_ATTR)),re.ADD_URI_SAFE_ATTR&&He(ee,re.ADD_URI_SAFE_ATTR),re.FORBID_CONTENTS&&(N===O&&(N=ut(N)),He(N,re.FORBID_CONTENTS)),M&&(de["#text"]=!0),G&&He(de,["html","head","body"]),de.table&&(He(de,["tbody"]),delete se.tbody),et&&et(re),ve=re)},Ve=He({},["mi","mo","mn","ms","mtext"]),Ue=He({},["foreignobject","desc","title","annotation-xml"]),ze=He({},Ct);He(ze,At),He(ze,Qt);var xe=He({},St);He(xe,Jt);var it=function(re){var Ae=o(re);(!Ae||!Ae.tagName)&&(Ae={namespaceURI:ye,tagName:"template"});var Ne=ht(re.tagName),We=ht(Ae.tagName);if(re.namespaceURI===De)return Ae.namespaceURI===ye?Ne==="svg":Ae.namespaceURI===ce?Ne==="svg"&&(We==="annotation-xml"||Ve[We]):Boolean(ze[Ne]);if(re.namespaceURI===ce)return Ae.namespaceURI===ye?Ne==="math":Ae.namespaceURI===De?Ne==="math"&&Ue[We]:Boolean(xe[Ne]);if(re.namespaceURI===ye){if(Ae.namespaceURI===De&&!Ue[We]||Ae.namespaceURI===ce&&!Ve[We])return!1;var Ge=He({},["title","style","font","a","script"]);return!xe[Ne]&&(Ge[Ne]||!ze[Ne])}return!1},Be=function(re){bt(t.removed,{element:re});try{re.parentNode.removeChild(re)}catch{try{re.outerHTML=C}catch{re.remove()}}},Ke=function(re,Ae){try{bt(t.removed,{attribute:Ae.getAttributeNode(re),from:Ae})}catch{bt(t.removed,{attribute:null,from:Ae})}if(Ae.removeAttribute(re),re==="is"&&!te[re])if(B||$)try{Be(Ae)}catch{}else try{Ae.setAttribute(re,"")}catch{}},Ye=function(re){var Ae=void 0,Ne=void 0;if(b)re="<remove></remove>"+re;else{var We=Pt(re,/^[\r\n\t ]+/);Ne=We&&We[0]}var Ge=g?g.createHTML(re):re;if(Ie===ye)try{Ae=new n().parseFromString(Ge,"text/html")}catch{}if(!Ae||!Ae.documentElement){Ae=k.createDocument(Ie,"template",null);try{Ae.documentElement.innerHTML=ke?"":Ge}catch{}}var Ze=Ae.body||Ae.documentElement;return re&&Ne&&Ze.insertBefore(i.createTextNode(Ne),Ze.childNodes[0]||null),Ie===ye?E.call(Ae,G?"html":"body")[0]:G?Ae.documentElement:Ze},K=function(re){return S.call(re.ownerDocument||re,re,c.SHOW_ELEMENT|c.SHOW_COMMENT|c.SHOW_TEXT,null,!1)},ae=function(re){return re instanceof I||re instanceof r?!1:typeof re.nodeName!="string"||typeof re.textContent!="string"||typeof re.removeChild!="function"||!(re.attributes instanceof f)||typeof re.removeAttribute!="function"||typeof re.setAttribute!="function"||typeof re.namespaceURI!="string"||typeof re.insertBefore!="function"},we=function(re){return(typeof y>"u"?"undefined":pt(y))==="object"?re instanceof y:re&&(typeof re>"u"?"undefined":pt(re))==="object"&&typeof re.nodeType=="number"&&typeof re.nodeName=="string"},Ee=function(re,Ae,Ne){!z[re]||Gt(z[re],function(We){We.call(t,Ae,Ne,ve)})},Fe=function(re){var Ae=void 0;if(Ee("beforeSanitizeElements",re,null),ae(re)||Pt(re.nodeName,/[\u0080-\uFFFF]/))return Be(re),!0;var Ne=ht(re.nodeName);if(Ee("uponSanitizeElement",re,{tagName:Ne,allowedTags:de}),!we(re.firstElementChild)&&(!we(re.content)||!we(re.content.firstElementChild))&&at(/<[/\w]/g,re.innerHTML)&&at(/<[/\w]/g,re.textContent)||Ne==="select"&&at(/<template/i,re.innerHTML))return Be(re),!0;if(!de[Ne]||se[Ne]){if(M&&!N[Ne]){var We=o(re)||re.parentNode,Ge=m(re)||re.childNodes;if(Ge&&We)for(var Ze=Ge.length,Qe=Ze-1;Qe>=0;--Qe)We.insertBefore(l(Ge[Qe],!0),u(re))}return Be(re),!0}return re instanceof w&&!it(re)||(Ne==="noscript"||Ne==="noembed")&&at(/<\/no(script|embed)/i,re.innerHTML)?(Be(re),!0):(_&&re.nodeType===3&&(Ae=re.textContent,Ae=lt(Ae,q," "),Ae=lt(Ae,ie," "),re.textContent!==Ae&&(bt(t.removed,{element:re.cloneNode()}),re.textContent=Ae)),Ee("afterSanitizeElements",re,null),!1)},Oe=function(re,Ae,Ne){if(T&&(Ae==="id"||Ae==="name")&&(Ne in i||Ne in Re))return!1;if(!(ne&&!x[Ae]&&at(J,Ae))){if(!(ue&&at(me,Ae))){if(!te[Ae]||x[Ae])return!1;if(!ee[Ae]){if(!at(oe,lt(Ne,fe,""))){if(!((Ae==="src"||Ae==="xlink:href"||Ae==="href")&&re!=="script"&&Yt(Ne,"data:")===0&&W[re])){if(!(F&&!at(he,lt(Ne,fe,"")))){if(Ne)return!1}}}}}}return!0},_e=function(re){var Ae=void 0,Ne=void 0,We=void 0,Ge=void 0;Ee("beforeSanitizeAttributes",re,null);var Ze=re.attributes;if(!!Ze){var Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:te};for(Ge=Ze.length;Ge--;){Ae=Ze[Ge];var st=Ae,ct=st.name,dt=st.namespaceURI;if(Ne=Xt(Ae.value),We=ht(ct),Qe.attrName=We,Qe.attrValue=Ne,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,Ee("uponSanitizeAttribute",re,Qe),Ne=Qe.attrValue,!Qe.forceKeepAttr&&(Ke(ct,re),!!Qe.keepAttr)){if(at(/\/>/i,Ne)){Ke(ct,re);continue}_&&(Ne=lt(Ne,q," "),Ne=lt(Ne,ie," "));var Ft=re.nodeName.toLowerCase();if(!!Oe(Ft,We,Ne))try{dt?re.setAttributeNS(dt,ct,Ne):re.setAttribute(ct,Ne),Mt(t.removed)}catch{}}}Ee("afterSanitizeAttributes",re,null)}},tt=function Me(re){var Ae=void 0,Ne=K(re);for(Ee("beforeSanitizeShadowDOM",re,null);Ae=Ne.nextNode();)Ee("uponSanitizeShadowNode",Ae,null),!Fe(Ae)&&(Ae.content instanceof U&&Me(Ae.content),_e(Ae));Ee("afterSanitizeShadowDOM",re,null)};return t.sanitize=function(Me,re){var Ae=void 0,Ne=void 0,We=void 0,Ge=void 0,Ze=void 0;if(ke=!Me,ke&&(Me="<!-->"),typeof Me!="string"&&!we(Me)){if(typeof Me.toString!="function")throw Rt("toString is not a function");if(Me=Me.toString(),typeof Me!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(pt(Q.toStaticHTML)==="object"||typeof Q.toStaticHTML=="function"){if(typeof Me=="string")return Q.toStaticHTML(Me);if(we(Me))return Q.toStaticHTML(Me.outerHTML)}return Me}if(P||Pe(re),t.removed=[],typeof Me=="string"&&(H=!1),!H)if(Me instanceof y)Ae=Ye("<!---->"),Ne=Ae.ownerDocument.importNode(Me,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?Ae=Ne:Ae.appendChild(Ne);else{if(!B&&!_&&!G&&Me.indexOf("<")===-1)return g&&Z?g.createHTML(Me):Me;if(Ae=Ye(Me),!Ae)return B?null:C}Ae&&b&&Be(Ae.firstChild);for(var Qe=K(H?Me:Ae);We=Qe.nextNode();)We.nodeType===3&&We===Ge||Fe(We)||(We.content instanceof U&&tt(We.content),_e(We),Ge=We);if(Ge=null,H)return Me;if(B){if($)for(Ze=h.call(Ae.ownerDocument);Ae.firstChild;)Ze.appendChild(Ae.firstChild);else Ze=Ae;return V&&(Ze=p.call(v,Ze,!0)),Ze}var st=G?Ae.outerHTML:Ae.innerHTML;return _&&(st=lt(st,q," "),st=lt(st,ie," ")),g&&Z?g.createHTML(st):st},t.setConfig=function(Me){Pe(Me),P=!0},t.clearConfig=function(){ve=null,P=!1},t.isValidAttribute=function(Me,re,Ae){ve||Pe({});var Ne=ht(Me),We=ht(re);return Oe(Ne,We,Ae)},t.addHook=function(Me,re){typeof re=="function"&&(z[Me]=z[Me]||[],bt(z[Me],re))},t.removeHook=function(Me){z[Me]&&Mt(z[Me])},t.removeHooks=function(Me){z[Me]&&(z[Me]=[])},t.removeAllHooks=function(){z={}},t}var li=Wt();define("vs/base/browser/dompurify/dompurify",function(){return li}),define(be[40],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class v{constructor(y){this.domNode=y,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.A=!1,this.B="none",this.C=""}setMaxWidth(y){const w=i(y);this.a!==w&&(this.a=w,this.domNode.style.maxWidth=this.a)}setWidth(y){const w=i(y);this.b!==w&&(this.b=w,this.domNode.style.width=this.b)}setHeight(y){const w=i(y);this.c!==w&&(this.c=w,this.domNode.style.height=this.c)}setTop(y){const w=i(y);this.d!==w&&(this.d=w,this.domNode.style.top=this.d)}setLeft(y){const w=i(y);this.e!==w&&(this.e=w,this.domNode.style.left=this.e)}setBottom(y){const w=i(y);this.f!==w&&(this.f=w,this.domNode.style.bottom=this.f)}setRight(y){const w=i(y);this.g!==w&&(this.g=w,this.domNode.style.right=this.g)}setPaddingTop(y){const w=i(y);this.h!==w&&(this.h=w,this.domNode.style.paddingTop=this.h)}setPaddingLeft(y){const w=i(y);this.i!==w&&(this.i=w,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(y){const w=i(y);this.j!==w&&(this.j=w,this.domNode.style.paddingBottom=this.j)}setPaddingRight(y){const w=i(y);this.k!==w&&(this.k=w,this.domNode.style.paddingRight=this.k)}setFontFamily(y){this.l!==y&&(this.l=y,this.domNode.style.fontFamily=this.l)}setFontWeight(y){this.m!==y&&(this.m=y,this.domNode.style.fontWeight=this.m)}setFontSize(y){const w=i(y);this.n!==w&&(this.n=w,this.domNode.style.fontSize=this.n)}setFontStyle(y){this.o!==y&&(this.o=y,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(y){this.p!==y&&(this.p=y,this.domNode.style.fontFeatureSettings=this.p)}setTextDecoration(y){this.q!==y&&(this.q=y,this.domNode.style.textDecoration=this.q)}setLineHeight(y){const w=i(y);this.r!==w&&(this.r=w,this.domNode.style.lineHeight=this.r)}setLetterSpacing(y){const w=i(y);this.s!==w&&(this.s=w,this.domNode.style.letterSpacing=this.s)}setClassName(y){this.t!==y&&(this.t=y,this.domNode.className=this.t)}toggleClassName(y,w){this.domNode.classList.toggle(y,w),this.t=this.domNode.className}setDisplay(y){this.u!==y&&(this.u=y,this.domNode.style.display=this.u)}setPosition(y){this.v!==y&&(this.v=y,this.domNode.style.position=this.v)}setVisibility(y){this.w!==y&&(this.w=y,this.domNode.style.visibility=this.w)}setColor(y){this.x!==y&&(this.x=y,this.domNode.style.color=this.x)}setBackgroundColor(y){this.y!==y&&(this.y=y,this.domNode.style.backgroundColor=this.y)}setLayerHinting(y){this.A!==y&&(this.A=y,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(y){this.C!==y&&(this.C=y,this.domNode.style.boxShadow=y)}setContain(y){this.B!==y&&(this.B=y,this.domNode.style.contain=this.B)}setAttribute(y,w){this.domNode.setAttribute(y,w)}removeAttribute(y){this.domNode.removeAttribute(y)}appendChild(y){this.domNode.appendChild(y.domNode)}removeChild(y){this.domNode.removeChild(y.domNode)}}t.FastDomNode=v;function i(R){return typeof R=="number"?`${R}px`:R}function U(R){return new v(R)}t.createFastDomNode=U}),define(be[66],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let v=!1,i=null;function U(y){if(!y.parent||y.parent===y)return null;try{const w=y.location,c=y.parent.location;if(w.origin!=="null"&&c.origin!=="null"&&w.origin!==c.origin)return v=!0,null}catch{return v=!0,null}return y.parent}class R{static getSameOriginWindowChain(){if(!i){i=[];let w=window,c;do c=U(w),c?i.push({window:w,iframeElement:w.frameElement||null}):i.push({window:w,iframeElement:null}),w=c;while(w)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),v}static getPositionOfChildWindowRelativeToAncestorWindow(w,c){if(!c||w===c)return{top:0,left:0};let d=0,f=0;const I=this.getSameOriginWindowChain();for(const r of I){if(d+=r.window.scrollY,f+=r.window.scrollX,r.window===c||!r.iframeElement)break;const n=r.iframeElement.getBoundingClientRect();d+=n.top,f+=n.left}return{top:d,left:f}}}t.IframeUtils=R}),define(be[67],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var v;(function(R){R[R.Copy=0]="Copy",R[R.Move=1]="Move"})(v=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class i extends Error{constructor(y,w){super(`ListError [${y}] ${w}`)}}t.ListError=i;class U{constructor(){this.c=new WeakMap}getHeight(y){return this.c.get(y)??this.d(y)}setDynamicHeight(y,w){w>0&&this.c.set(y,w)}}t.CachedListVirtualDelegate=U}),define(be[68],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class v{constructor(U){this.a=U}splice(U,R,y){this.a.forEach(w=>w.splice(U,R,y))}}t.CombinedSpliceable=v}),define(be[41],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const v=20;class i{constructor(R,y,w,c,d,f){this.a=Math.round(y),this.b=Math.round(w),this.c=Math.round(R),this.d=c,this.e=d,this.f=f,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new i(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(R){const y=Math.round(R);return this.d!==y?(this.d=y,this.m(),!0):!1}setScrollSize(R){const y=Math.round(R);return this.e!==y?(this.e=y,this.m(),!0):!1}setScrollPosition(R){const y=Math.round(R);return this.f!==y?(this.f=y,this.m(),!0):!1}setScrollbarSize(R){this.a=Math.round(R)}setOppositeScrollbarSize(R){this.b=Math.round(R)}static l(R,y,w,c,d){const f=Math.max(0,w-R),I=Math.max(0,f-2*y),r=c>0&&c>w;if(!r)return{computedAvailableSize:Math.round(f),computedIsNeeded:r,computedSliderSize:Math.round(I),computedSliderRatio:0,computedSliderPosition:0};const n=Math.round(Math.max(v,Math.floor(w*I/c))),e=(I-n)/(c-w),s=d*e;return{computedAvailableSize:Math.round(f),computedIsNeeded:r,computedSliderSize:Math.round(n),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const R=i.l(this.b,this.c,this.d,this.e,this.f);this.g=R.computedAvailableSize,this.h=R.computedIsNeeded,this.i=R.computedSliderSize,this.j=R.computedSliderRatio,this.k=R.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(R){if(!this.h)return 0;const y=R-this.c-this.i/2;return Math.round(y/this.j)}getDesiredScrollPositionFromOffsetPaged(R){if(!this.h)return 0;const y=R-this.c;let w=this.f;return y<this.k?w-=this.d:w+=this.d,w}getDesiredScrollPositionFromDelta(R){if(!this.h)return 0;const y=this.k+R;return Math.round(y/this.j)}}t.ScrollbarState=i}),define(be[23],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var v;(function(w){w[w.Hidden=0]="Hidden",w[w.Visible=1]="Visible",w[w.Recurse=2]="Recurse"})(v=t.TreeVisibility||(t.TreeVisibility={}));var i;(function(w){w[w.Unknown=0]="Unknown",w[w.Twistie=1]="Twistie",w[w.Element=2]="Element",w[w.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var U;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(U=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(w=!1){return{accept:!0,bubble:0,autoExpand:w}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(w=!1){return{accept:!0,bubble:0,effect:0,autoExpand:w}}};class R extends Error{constructor(c,d){super(`TreeError [${c}] ${d}`)}}t.TreeError=R;class y{constructor(c){this.a=c,this.b=new WeakMap}map(c){let d=this.b.get(c);return d||(d=this.a(c),this.b.set(c,d)),d}}t.WeakMapper=y}),define(be[12],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.Codicon=t.getCodiconAriaLabel=void 0;function v(R){return R?R.replace(/\$\((.*?)\)/g,(y,w)=>` ${w} `).trim():""}t.getCodiconAriaLabel=v;class i{constructor(y,w,c){this.id=y,this.definition=w,this.description=c,i.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i.a}}t.Codicon=i,i.a=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);var U;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function w(f){if(f instanceof i)return["codicon","codicon-"+f.id];const I=y.exec(f.id);if(!I)return w(i.error);const[,r,n]=I,e=["codicon","codicon-"+r];return n&&e.push("codicon-modifier-"+n.substring(1)),e}R.asClassNameArray=w;function c(f){return w(f).join(" ")}R.asClassName=c;function d(f){return"."+w(f).join(".")}R.asCSSSelector=d})(U=t.CSSIcon||(t.CSSIcon={}))}),define(be[69],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function v(y,w){const c=Object.create(null);for(const d of y){const f=w(d);let I=c[f];I||(I=c[f]=[]),I.push(d)}return c}t.groupBy=v;function i(y,w){const c=[],d=[];for(const f of y)w.has(f)||c.push(f);for(const f of w)y.has(f)||d.push(f);return{removed:c,added:d}}t.diffSets=i;function U(y,w){const c=[],d=[];for(const[f,I]of y)w.has(f)||c.push(I);for(const[f,I]of w)y.has(f)||d.push(I);return{removed:c,added:d}}t.diffMaps=U;class R{constructor(){this.a=new Map}add(w,c){let d=this.a.get(w);d||(d=new Set,this.a.set(w,d)),d.add(c)}delete(w,c){const d=this.a.get(w);!d||(d.delete(c),d.size===0&&this.a.delete(w))}forEach(w,c){const d=this.a.get(w);!d||d.forEach(c)}}t.SetMap=R}),define(be[24],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function v(w,c){const d=Math.pow(10,c);return Math.round(w*d)/d}class i{constructor(c,d,f,I=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,d))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=v(Math.max(Math.min(1,I),0),3)}static equals(c,d){return c.r===d.r&&c.g===d.g&&c.b===d.b&&c.a===d.a}}t.RGBA=i;class U{constructor(c,d,f,I){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=v(Math.max(Math.min(1,d),0),3),this.l=v(Math.max(Math.min(1,f),0),3),this.a=v(Math.max(Math.min(1,I),0),3)}static equals(c,d){return c.h===d.h&&c.s===d.s&&c.l===d.l&&c.a===d.a}static fromRGBA(c){const d=c.r/255,f=c.g/255,I=c.b/255,r=c.a,n=Math.max(d,f,I),e=Math.min(d,f,I);let s=0,l=0;const u=(e+n)/2,m=n-e;if(m>0){switch(l=Math.min(u<=.5?m/(2*u):m/(2-2*u),1),n){case d:s=(f-I)/m+(f<I?6:0);break;case f:s=(I-d)/m+2;break;case I:s=(d-f)/m+4;break}s*=60,s=Math.round(s)}return new U(s,l,u,r)}static i(c,d,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?c+(d-c)*6*f:f<1/2?d:f<2/3?c+(d-c)*(2/3-f)*6:c}static toRGBA(c){const d=c.h/360,{s:f,l:I,a:r}=c;let n,e,s;if(f===0)n=e=s=I;else{const l=I<.5?I*(1+f):I+f-I*f,u=2*I-l;n=U.i(u,l,d+1/3),e=U.i(u,l,d),s=U.i(u,l,d-1/3)}return new i(Math.round(n*255),Math.round(e*255),Math.round(s*255),r)}}t.HSLA=U;class R{constructor(c,d,f,I){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=v(Math.max(Math.min(1,d),0),3),this.v=v(Math.max(Math.min(1,f),0),3),this.a=v(Math.max(Math.min(1,I),0),3)}static equals(c,d){return c.h===d.h&&c.s===d.s&&c.v===d.v&&c.a===d.a}static fromRGBA(c){const d=c.r/255,f=c.g/255,I=c.b/255,r=Math.max(d,f,I),n=Math.min(d,f,I),e=r-n,s=r===0?0:e/r;let l;return e===0?l=0:r===d?l=((f-I)/e%6+6)%6:r===f?l=(I-d)/e+2:l=(d-f)/e+4,new R(Math.round(l*60),s,r,c.a)}static toRGBA(c){const{h:d,s:f,v:I,a:r}=c,n=I*f,e=n*(1-Math.abs(d/60%2-1)),s=I-n;let[l,u,m]=[0,0,0];return d<60?(l=n,u=e):d<120?(l=e,u=n):d<180?(u=n,m=e):d<240?(u=e,m=n):d<300?(l=e,m=n):d<=360&&(l=n,m=e),l=Math.round((l+s)*255),u=Math.round((u+s)*255),m=Math.round((m+s)*255),new i(l,u,m,r)}}t.HSVA=R;class y{static fromHex(c){return y.Format.CSS.parseHex(c)||y.red}static equals(c,d){return!c&&!d?!0:!c||!d?!1:c.equals(d)}get hsla(){return this.i?this.i:U.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof i)this.rgba=c;else if(c instanceof U)this.i=c,this.rgba=U.toRGBA(c);else if(c instanceof R)this.j=c,this.rgba=R.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&i.equals(this.rgba,c.rgba)&&U.equals(this.hsla,c.hsla)&&R.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=y.k(this.rgba.r),d=y.k(this.rgba.g),f=y.k(this.rgba.b),I=.2126*c+.7152*d+.0722*f;return v(I,4)}static k(c){const d=c/255;return d<=.03928?d/12.92:Math.pow((d+.055)/1.055,2.4)}getContrastRatio(c){const d=this.getRelativeLuminance(),f=c.getRelativeLuminance();return d>f?(d+.05)/(f+.05):(f+.05)/(d+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const d=this.getRelativeLuminance(),f=c.getRelativeLuminance();return d>f}isDarkerThan(c){const d=this.getRelativeLuminance(),f=c.getRelativeLuminance();return d<f}lighten(c){return new y(new U(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new y(new U(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:d,g:f,b:I,a:r}=this.rgba;return new y(new i(d,f,I,r*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new y(new i(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const d=c.rgba,f=this.rgba.a,I=d.a,r=f+I*(1-f);if(r<1e-6)return y.transparent;const n=this.rgba.r*f/r+d.r*I*(1-f)/r,e=this.rgba.g*f/r+d.g*I*(1-f)/r,s=this.rgba.b*f/r+d.b*I*(1-f)/r;return new y(new i(n,e,s,r))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:d,g:f,b:I,a:r}=this.rgba;return new y(new i(c.rgba.r-r*(c.rgba.r-d),c.rgba.g-r*(c.rgba.g-f),c.rgba.b-r*(c.rgba.b-I),1))}flatten(...c){const d=c.reduceRight((f,I)=>y.o(I,f));return y.o(this,d)}static o(c,d){const f=1-c.rgba.a;return new y(new i(f*d.rgba.r+c.rgba.a*c.rgba.r,f*d.rgba.g+c.rgba.a*c.rgba.g,f*d.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=y.Format.CSS.format(this)),this.u}static getLighterColor(c,d,f){if(c.isLighterThan(d))return c;f=f||.5;const I=c.getRelativeLuminance(),r=d.getRelativeLuminance();return f=f*(r-I)/r,c.lighten(f)}static getDarkerColor(c,d,f){if(c.isDarkerThan(d))return c;f=f||.5;const I=c.getRelativeLuminance(),r=d.getRelativeLuminance();return f=f*(I-r)/I,c.darken(f)}}t.Color=y,y.white=new y(new i(255,255,255,1)),y.black=new y(new i(0,0,0,1)),y.red=new y(new i(255,0,0,1)),y.blue=new y(new i(0,0,255,1)),y.green=new y(new i(0,255,0,1)),y.cyan=new y(new i(0,255,255,1)),y.lightgrey=new y(new i(211,211,211,1)),y.transparent=new y(new i(0,0,0,0)),function(w){let c;(function(d){let f;(function(I){function r(C){return C.rgba.a===1?`rgb(${C.rgba.r}, ${C.rgba.g}, ${C.rgba.b})`:w.Format.CSS.formatRGBA(C)}I.formatRGB=r;function n(C){return`rgba(${C.rgba.r}, ${C.rgba.g}, ${C.rgba.b}, ${+C.rgba.a.toFixed(2)})`}I.formatRGBA=n;function e(C){return C.hsla.a===1?`hsl(${C.hsla.h}, ${(C.hsla.s*100).toFixed(2)}%, ${(C.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(C)}I.formatHSL=e;function s(C){return`hsla(${C.hsla.h}, ${(C.hsla.s*100).toFixed(2)}%, ${(C.hsla.l*100).toFixed(2)}%, ${C.hsla.a.toFixed(2)})`}I.formatHSLA=s;function l(C){const L=C.toString(16);return L.length!==2?"0"+L:L}function u(C){return`#${l(C.rgba.r)}${l(C.rgba.g)}${l(C.rgba.b)}`}I.formatHex=u;function m(C,L=!1){return L&&C.rgba.a===1?w.Format.CSS.formatHex(C):`#${l(C.rgba.r)}${l(C.rgba.g)}${l(C.rgba.b)}${l(Math.round(C.rgba.a*255))}`}I.formatHexA=m;function o(C){return C.isOpaque()?w.Format.CSS.formatHex(C):w.Format.CSS.formatRGBA(C)}I.format=o;function a(C){const L=C.length;if(L===0||C.charCodeAt(0)!==35)return null;if(L===7){const k=16*g(C.charCodeAt(1))+g(C.charCodeAt(2)),S=16*g(C.charCodeAt(3))+g(C.charCodeAt(4)),h=16*g(C.charCodeAt(5))+g(C.charCodeAt(6));return new w(new i(k,S,h,1))}if(L===9){const k=16*g(C.charCodeAt(1))+g(C.charCodeAt(2)),S=16*g(C.charCodeAt(3))+g(C.charCodeAt(4)),h=16*g(C.charCodeAt(5))+g(C.charCodeAt(6)),E=16*g(C.charCodeAt(7))+g(C.charCodeAt(8));return new w(new i(k,S,h,E/255))}if(L===4){const k=g(C.charCodeAt(1)),S=g(C.charCodeAt(2)),h=g(C.charCodeAt(3));return new w(new i(16*k+k,16*S+S,16*h+h))}if(L===5){const k=g(C.charCodeAt(1)),S=g(C.charCodeAt(2)),h=g(C.charCodeAt(3)),E=g(C.charCodeAt(4));return new w(new i(16*k+k,16*S+S,16*h+h,(16*E+E)/255))}return null}I.parseHex=a;function g(C){switch(C){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(f=d.CSS||(d.CSS={}))})(c=w.Format||(w.Format={}))}(y=t.Color||(t.Color={}))}),define(be[25],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=void 0;function v(y){return(w,c,d)=>{let f=null,I=null;if(typeof d.value=="function"?(f="value",I=d.value):typeof d.get=="function"&&(f="get",I=d.get),!I)throw new Error("not supported");d[f]=y(I,c)}}function i(y,w,c){let d=null,f=null;if(typeof c.value=="function"?(d="value",f=c.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(d="get",f=c.get),!f)throw new Error("not supported");const I=`$memoize$${w}`;c[d]=function(...r){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,r)}),this[I]}}t.memoize=i;function U(y,w,c){return v((d,f)=>{const I=`$debounce$${f}`,r=`$debounce$result$${f}`;return function(...n){this[r]||(this[r]=c?c():void 0),clearTimeout(this[I]),w&&(this[r]=w(this[r],...n),n=[this[r]]),this[I]=setTimeout(()=>{d.apply(this,n),this[r]=c?c():void 0},y)}})}t.debounce=U;function R(y,w,c){return v((d,f)=>{const I=`$throttle$timer$${f}`,r=`$throttle$result$${f}`,n=`$throttle$lastRun$${f}`,e=`$throttle$pending$${f}`;return function(...s){if(this[r]||(this[r]=c?c():void 0),(this[n]===null||this[n]===void 0)&&(this[n]=-Number.MAX_VALUE),w&&(this[r]=w(this[r],...s)),this[e])return;const l=this[n]+y;l<=Date.now()?(this[n]=Date.now(),d.apply(this,[this[r]]),this[r]=c?c():void 0):(this[e]=!0,this[I]=setTimeout(()=>{this[e]=!1,this[n]=Date.now(),d.apply(this,[this[r]]),this[r]=c?c():void 0},l-Date.now()))}})}t.throttle=R}),define(be[70],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class v{constructor(U,R,y,w){this.originalStart=U,this.originalLength=R,this.modifiedStart=y,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=v}),define(be[9],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class v{constructor(){this.b=[],this.a=function(C){setTimeout(()=>{throw C.stack?o.isErrorNoTelemetry(C)?new o(C.message+`

`+C.stack):new Error(C.message+`

`+C.stack):C},0)}}addListener(C){return this.b.push(C),()=>{this.d(C)}}c(C){this.b.forEach(L=>{L(C)})}d(C){this.b.splice(this.b.indexOf(C),1)}setUnexpectedErrorHandler(C){this.a=C}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(C){this.a(C),this.c(C)}onUnexpectedExternalError(C){this.a(C)}}t.ErrorHandler=v,t.errorHandler=new v;function i(g){t.errorHandler.setUnexpectedErrorHandler(g)}t.setUnexpectedErrorHandler=i;function U(g){c(g)||t.errorHandler.onUnexpectedError(g)}t.onUnexpectedError=U;function R(g){c(g)||t.errorHandler.onUnexpectedExternalError(g)}t.onUnexpectedExternalError=R;function y(g){if(g instanceof Error){const{name:C,message:L}=g,k=g.stacktrace||g.stack;return{$isError:!0,name:C,message:L,stack:k,noTelemetry:o.isErrorNoTelemetry(g)}}return g}t.transformErrorForSerialization=y;const w="Canceled";function c(g){return g instanceof d?!0:g instanceof Error&&g.name===w&&g.message===w}t.isCancellationError=c;class d extends Error{constructor(){super(w),this.name=this.message}}t.CancellationError=d;function f(){const g=new Error(w);return g.name=g.message,g}t.canceled=f;function I(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}t.illegalArgument=I;function r(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}t.illegalState=r;function n(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=n;function e(g){const C=new Error(`${g} has been disposed`);return C.name="DISPOSED",C}t.disposed=e;function s(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}t.getErrorMessage=s;class l extends Error{constructor(C){super("NotImplemented"),C&&(this.message=C)}}t.NotImplementedError=l;class u extends Error{constructor(C){super("NotSupported"),C&&(this.message=C)}}t.NotSupportedError=u;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=m;class o extends Error{constructor(C){super(C),this.name="CodeExpectedError"}static fromError(C){if(C instanceof o)return C;const L=new o;return L.message=C.message,L.stack=C.stack,L}static isErrorNoTelemetry(C){return C.name==="CodeExpectedError"}}t.ErrorNoTelemetry=o;class a extends Error{constructor(C){super(C||"An unexpected bug occurred."),Object.setPrototypeOf(this,a.prototype);debugger}}t.BugIndicatingError=a}),define(be[14],pe([1,0,9]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function i(T,M=0){return T[T.length-(1+M)]}t.tail=i;function U(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}t.tail2=U;function R(T,M,H=(A,N)=>A===N){if(T===M)return!0;if(!T||!M||T.length!==M.length)return!1;for(let A=0,N=T.length;A<N;A++)if(!H(T[A],M[A]))return!1;return!0}t.equals=R;function y(T,M){const H=T.length-1;M<H&&(T[M]=T[H]),T.pop()}t.removeFastWithoutKeepingOrder=y;function w(T,M,H){return c(T.length,A=>H(T[A],M))}t.binarySearch=w;function c(T,M){let H=0,A=T-1;for(;H<=A;){const N=(H+A)/2|0,O=M(N);if(O<0)H=N+1;else if(O>0)A=N-1;else return N}return-(H+1)}t.binarySearch2=c;function d(T,M){let H=0,A=T.length;if(A===0)return 0;for(;H<A;){const N=Math.floor((H+A)/2);M(T[N])?A=N:H=N+1}return H}t.findFirstInSorted=d;function f(T,M,H){if(T=T|0,T>=M.length)throw new TypeError("invalid index");const A=M[Math.floor(M.length*Math.random())],N=[],O=[],W=[];for(const j of M){const ee=H(j,A);ee<0?N.push(j):ee>0?O.push(j):W.push(j)}return T<N.length?f(T,N,H):T<N.length+W.length?W[0]:f(T-(N.length+W.length),O,H)}t.quickSelect=f;function I(T,M){const H=[];let A;for(const N of T.slice(0).sort(M))!A||M(A[0],N)!==0?(A=[N],H.push(A)):A.push(N);return H}t.groupBy=I;function r(T,M,H){const A=[];function N(j,ee,le){if(ee===0&&le.length===0)return;const ce=A[A.length-1];ce&&ce.start+ce.deleteCount===j?(ce.deleteCount+=ee,ce.toInsert.push(...le)):A.push({start:j,deleteCount:ee,toInsert:le})}let O=0,W=0;for(;;){if(O===T.length){N(O,0,M.slice(W));break}if(W===M.length){N(O,T.length-O,[]);break}const j=T[O],ee=M[W],le=H(j,ee);le===0?(O+=1,W+=1):le<0?(N(O,1,[]),O+=1):le>0&&(N(O,0,[ee]),W+=1)}return A}t.sortedDiff=r;function n(T,M,H){const A=r(T,M,H),N=[],O=[];for(const W of A)N.push(...T.slice(W.start,W.start+W.deleteCount)),O.push(...W.toInsert);return{removed:N,added:O}}t.delta=n;function e(T,M,H){if(H===0)return[];const A=T.slice(0,H).sort(M);return l(T,M,A,H,T.length),A}t.top=e;function s(T,M,H,A,N){return H===0?Promise.resolve([]):new Promise((O,W)=>{(async()=>{const j=T.length,ee=T.slice(0,H).sort(M);for(let le=H,ce=Math.min(H+A,j);le<j;le=ce,ce=Math.min(ce+A,j)){if(le>H&&await new Promise(De=>setTimeout(De)),N&&N.isCancellationRequested)throw new v.CancellationError;l(T,M,ee,le,ce)}return ee})().then(O,W)})}t.topAsync=s;function l(T,M,H,A,N){for(const O=H.length;A<N;A++){const W=T[A];if(M(W,H[O-1])<0){H.pop();const j=d(H,ee=>M(W,ee)<0);H.splice(j,0,W)}}}function u(T){return T.filter(M=>!!M)}t.coalesce=u;function m(T){let M=0;for(let H=0;H<T.length;H++)T[H]&&(T[M]=T[H],M+=1);T.length=M}t.coalesceInPlace=m;function o(T,M,H){T.splice(H,0,T.splice(M,1)[0])}t.move=o;function a(T){return!Array.isArray(T)||T.length===0}t.isFalsyOrEmpty=a;function g(T){return Array.isArray(T)&&T.length>0}t.isNonEmptyArray=g;function C(T,M=H=>H){const H=new Set;return T.filter(A=>{const N=M(A);return H.has(N)?!1:(H.add(N),!0)})}t.distinct=C;function L(T){const M=new Set;return H=>{const A=T(H);return M.has(A)?!1:(M.add(A),!0)}}t.uniqueFilter=L;function k(T,M){const H=S(T,M);if(H!==-1)return T[H]}t.findLast=k;function S(T,M){for(let H=T.length-1;H>=0;H--){const A=T[H];if(M(A))return H}return-1}t.lastIndex=S;function h(T,M){return T.length>0?T[0]:M}t.firstOrDefault=h;function E(T,M){return T.length>0?T[T.length-1]:M}t.lastOrDefault=E;function p(T,M,H=(A,N)=>A===N){let A=0;for(let N=0,O=Math.min(T.length,M.length);N<O&&H(T[N],M[N]);N++)A++;return A}t.commonPrefixLength=p;function D(T){return[].concat(...T)}t.flatten=D;function z(T,M){let H=typeof M=="number"?T:0;typeof M=="number"?H=T:(H=0,M=T);const A=[];if(H<=M)for(let N=H;N<M;N++)A.push(N);else for(let N=H;N>M;N--)A.push(N);return A}t.range=z;function q(T,M,H){return T.reduce((A,N)=>(A[M(N)]=H?H(N):N,A),Object.create(null))}t.index=q;function ie(T,M){return T.push(M),()=>J(T,M)}t.insert=ie;function J(T,M){const H=T.indexOf(M);if(H>-1)return T.splice(H,1),M}t.remove=J;function me(T,M,H){const A=T.slice(0,M),N=T.slice(M);return A.concat(H,N)}t.arrayInsert=me;function he(T,M){let H;if(typeof M=="number"){let A=M;H=()=>{const N=Math.sin(A++)*179426549;return N-Math.floor(N)}}else H=Math.random;for(let A=T.length-1;A>0;A-=1){const N=Math.floor(H()*(A+1)),O=T[A];T[A]=T[N],T[N]=O}}t.shuffle=he;function fe(T,M){const H=T.indexOf(M);H>-1&&(T.splice(H,1),T.unshift(M))}t.pushToStart=fe;function oe(T,M){const H=T.indexOf(M);H>-1&&(T.splice(H,1),T.push(M))}t.pushToEnd=oe;function de(T,M){for(const H of M)T.push(H)}t.pushMany=de;function Se(T,M){return Array.isArray(T)?T.map(M):M(T)}t.mapArrayOrNot=Se;function te(T){return Array.isArray(T)?T:[T]}t.asArray=te;function Ce(T){return T[Math.floor(Math.random()*T.length)]}t.getRandomElement=Ce;function se(T,M){for(const H of T){const A=M(H);if(A!==void 0)return A}}t.mapFind=se;function x(T,M,H){const A=ne(T,M),N=T.length,O=H.length;T.length=N+O;for(let W=N-1;W>=A;W--)T[W+O]=T[W];for(let W=0;W<O;W++)T[W+A]=H[W]}t.insertInto=x;function ue(T,M,H,A){const N=ne(T,M),O=T.splice(N,H);return x(T,N,A),O}t.splice=ue;function ne(T,M){return M<0?Math.max(M+T.length,0):Math.min(M,T.length)}var F;(function(T){function M(N){return N<0}T.isLessThan=M;function H(N){return N>0}T.isGreaterThan=H;function A(N){return N===0}T.isNeitherLessOrGreaterThan=A,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(F=t.CompareResult||(t.CompareResult={}));function _(T,M){return(H,A)=>M(T(H),T(A))}t.compareBy=_;function G(...T){return(M,H)=>{for(const A of T){const N=A(M,H);if(!F.isNeitherLessOrGreaterThan(N))return N}return F.neitherLessOrGreaterThan}}t.tieBreakComparators=G;const P=(T,M)=>T-M;t.numberComparator=P;function b(T,M){if(T.length===0)return;let H=T[0];for(let A=1;A<T.length;A++){const N=T[A];M(N,H)>0&&(H=N)}return H}t.findMaxBy=b;function B(T,M){if(T.length===0)return;let H=T[0];for(let A=1;A<T.length;A++){const N=T[A];M(N,H)>=0&&(H=N)}return H}t.findLastMaxBy=B;function $(T,M){return b(T,(H,A)=>-M(H,A))}t.findMinBy=$;class V{constructor(M){this.f=M,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(M){let H=this.c;for(;H<this.f.length&&M(this.f[H]);)H++;const A=H===this.c?null:this.f.slice(this.c,H);return this.c=H,A}takeFromEndWhile(M){let H=this.d;for(;H>=0&&M(this.f[H]);)H--;const A=H===this.d?null:this.f.slice(H+1,this.d+1);return this.d=H,A}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const M=this.f[this.c];return this.c++,M}removeLast(){const M=this.f[this.d];return this.d--,M}takeCount(M){const H=this.f.slice(this.c,this.c+M);return this.c+=M,H}}t.ArrayQueue=V;class Z{constructor(M){this.iterate=M}forEach(M){this.iterate(H=>(M(H),!0))}toArray(){const M=[];return this.iterate(H=>(M.push(H),!0)),M}filter(M){return new Z(H=>this.iterate(A=>M(A)?H(A):!0))}map(M){return new Z(H=>this.iterate(A=>H(M(A))))}some(M){let H=!1;return this.iterate(A=>(H=M(A),!H)),H}findFirst(M){let H;return this.iterate(A=>M(A)?(H=A,!1):!0),H}findLast(M){let H;return this.iterate(A=>(M(A)&&(H=A),!0)),H}findLastMaxBy(M){let H,A=!0;return this.iterate(N=>((A||F.isGreaterThan(M(N,H)))&&(A=!1,H=N),!0)),H}}t.CallbackIterable=Z,Z.empty=new Z(T=>{})}),define(be[71],pe([1,0,9]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function i(c,d){if(!c)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}t.ok=i;function U(c,d="Unreachable"){throw new Error(d)}t.assertNever=U;function R(c){if(!c)throw new v.BugIndicatingError("Assertion Failed")}t.assert=R;function y(c){if(!c()){debugger;c(),(0,v.onUnexpectedError)(new v.BugIndicatingError("Assertion Failed"))}}t.assertFn=y;function w(c,d){let f=0;for(;f<c.length-1;){const I=c[f],r=c[f+1];if(!d(I,r))return!1;f++}return!0}t.checkAdjacentItems=w}),define(be[42],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function v(i){const U=this;let R=!1,y;return function(){return R||(R=!0,y=i.apply(U,arguments)),y}}t.once=v}),define(be[72],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class v{constructor(U){this.a=U,this.b=0}nextId(){return this.a+ ++this.b}}t.IdGenerator=v,t.defaultGenerator=new v("id#")}),define(be[26],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var v;(function(i){function U(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}i.is=U;const R=Object.freeze([]);function y(){return R}i.empty=y;function*w(a){yield a}i.single=w;function c(a){return U(a)?a:w(a)}i.wrap=c;function d(a){return a||R}i.from=d;function f(a){return!a||a[Symbol.iterator]().next().done===!0}i.isEmpty=f;function I(a){return a[Symbol.iterator]().next().value}i.first=I;function r(a,g){for(const C of a)if(g(C))return!0;return!1}i.some=r;function n(a,g){for(const C of a)if(g(C))return C}i.find=n;function*e(a,g){for(const C of a)g(C)&&(yield C)}i.filter=e;function*s(a,g){let C=0;for(const L of a)yield g(L,C++)}i.map=s;function*l(...a){for(const g of a)for(const C of g)yield C}i.concat=l;function u(a,g,C){let L=C;for(const k of a)L=g(L,k);return L}i.reduce=u;function*m(a,g,C=a.length){for(g<0&&(g+=a.length),C<0?C+=a.length:C>a.length&&(C=a.length);g<C;g++)yield a[g]}i.slice=m;function o(a,g=Number.POSITIVE_INFINITY){const C=[];if(g===0)return[C,a];const L=a[Symbol.iterator]();for(let k=0;k<g;k++){const S=L.next();if(S.done)return[C,i.empty()];C.push(S.value)}return[C,{[Symbol.iterator](){return L}}]}i.consume=o})(v=t.Iterable||(t.Iterable={}))}),define(be[43],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var v;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(v=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i=t.ScanCode||(t.ScanCode={}));class U{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,l){this._keyCodeToStr[s]=l,this._strToKeyCode[l.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const R=new U,y=new U,w=new U;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const c=[],d=Object.create(null),f=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>f[e]||0,toEnum:e=>d[e]||0,toString:e=>c[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",s=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],l=[],u=[];for(const m of s){const[o,a,g,C,L,k,S,h,E,p]=m;if(u[g]||(u[g]=!0,c[g]=C,d[C]=g,f[C.toLowerCase()]=g,a&&(t.IMMUTABLE_CODE_TO_KEY_CODE[g]=L,L!==0&&L!==3&&L!==5&&L!==4&&L!==6&&L!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[L]=g))),!l[L]){if(l[L]=!0,!k)throw new Error(`String representation missing for key code ${L} around scan code ${C}`);R.define(L,k),y.define(L,E||k),w.define(L,p||E||k)}S&&(t.EVENT_KEY_CODE_MAP[S]=L),h&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[h]=L)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var I;(function(e){function s(g){return R.keyCodeToStr(g)}e.toString=s;function l(g){return R.strToKeyCode(g)}e.fromString=l;function u(g){return y.keyCodeToStr(g)}e.toUserSettingsUS=u;function m(g){return w.keyCodeToStr(g)}e.toUserSettingsGeneral=m;function o(g){return y.strToKeyCode(g)||w.strToKeyCode(g)}e.fromUserSettings=o;function a(g){if(g>=93&&g<=108)return null;switch(g){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return R.keyCodeToStr(g)}e.toElectronAccelerator=a})(I=t.KeyCodeUtils||(t.KeyCodeUtils={}));var r;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(r=t.KeyMod||(t.KeyMod={}));function n(e,s){const l=(s&65535)<<16>>>0;return(e|l)>>>0}t.KeyChord=n}),define(be[73],pe([1,0,9]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ScanCodeBinding=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=void 0;var i;(function(I){I[I.CtrlCmd=2048]="CtrlCmd",I[I.Shift=1024]="Shift",I[I.Alt=512]="Alt",I[I.WinCtrl=256]="WinCtrl",I[I.KeyCode=255]="KeyCode"})(i||(i={}));function U(I,r){if(I===0)return null;const n=(I&65535)>>>0,e=(I&4294901760)>>>16;return e!==0?new w([R(n,r),R(e,r)]):new w([R(n,r)])}t.createKeybinding=U;function R(I,r){const n=!!(I&2048),e=!!(I&256),s=r===2?e:n,l=!!(I&1024),u=!!(I&512),m=r===2?n:e,o=I&255;return new y(s,l,u,m,o)}t.createSimpleKeybinding=R;class y{constructor(r,n,e,s,l){this.ctrlKey=r,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.keyCode=l}equals(r){return this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.keyCode===r.keyCode}getHashCode(){const r=this.ctrlKey?"1":"0",n=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`${r}${n}${e}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=y;class w{constructor(r){if(r.length===0)throw(0,v.illegalArgument)("parts");this.parts=r}getHashCode(){let r="";for(let n=0,e=this.parts.length;n<e;n++)n!==0&&(r+=";"),r+=this.parts[n].getHashCode();return r}equals(r){if(r===null||this.parts.length!==r.parts.length)return!1;for(let n=0;n<this.parts.length;n++)if(!this.parts[n].equals(r.parts[n]))return!1;return!0}}t.ChordKeybinding=w;class c{constructor(r,n,e,s,l){this.ctrlKey=r,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.scanCode=l}equals(r){return this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.scanCode===r.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeBinding=c;class d{constructor(r,n,e,s,l,u){this.ctrlKey=r,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.keyLabel=l,this.keyAriaLabel=u}}t.ResolvedKeybindingPart=d;class f{}t.ResolvedKeybinding=f}),define(be[44],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class v{constructor(U){this.d=U,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(U){this.c=U}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(U){return new v(()=>U(this.getValue()))}}t.Lazy=v}),define(be[2],pe([1,0,42,26]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const U=!1;let R=null;function y(E){R=E}if(t.setDisposableTracker=y,U){const E="__is_disposable_tracked__";y(new class{trackDisposable(p){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[E]||console.log(D)},3e3)}setParent(p,D){if(p&&p!==m.None)try{p[E]=!0}catch{}}markAsDisposed(p){if(p&&p!==m.None)try{p[E]=!0}catch{}}markAsSingleton(p){}})}function w(E){return R?.trackDisposable(E),E}function c(E){R?.markAsDisposed(E)}function d(E,p){R?.setParent(E,p)}function f(E,p){if(!!R)for(const D of E)R.setParent(D,p)}function I(E){return R?.markAsSingleton(E),E}t.markAsSingleton=I;function r(E){return typeof E.dispose=="function"&&E.dispose.length===0}t.isDisposable=r;function n(E){if(i.Iterable.is(E)){const p=[];for(const D of E)if(D)try{D.dispose()}catch(z){p.push(z)}if(p.length===1)throw p[0];if(p.length>1)throw new AggregateError(p,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}t.dispose=n;function e(E){for(const p of E)r(p)&&p.dispose();return[]}t.disposeIfDisposable=e;function s(...E){const p=l(()=>n(E));return f(E,p),p}t.combinedDisposable=s;function l(E){const p=w({dispose:(0,v.once)(()=>{c(p),E()})});return p}t.toDisposable=l;class u{constructor(){this.c=new Set,this.f=!1,w(this)}dispose(){this.f||(c(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{n(this.c)}finally{this.c.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return d(p,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(p),p}}t.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this.q=new u,w(this),d(this.q,this)}dispose(){c(this),this.q.dispose()}B(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(p)}}t.Disposable=m,m.None=Object.freeze({dispose(){}});class o{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(p){this.b||p===this.a||(this.a?.dispose(),p&&d(p,this),this.a=p)}clear(){this.value=void 0}dispose(){this.b=!0,c(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const p=this.a;return this.a=void 0,p&&d(p,null),p}}t.MutableDisposable=o;class a{constructor(p){this.b=p,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=a;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(p){let D=p;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,c(this))},this}}t.SafeDisposable=g;class C{constructor(){this.a=new Map}acquire(p,...D){let z=this.a.get(p);z||(z={counter:0,object:this.b(p,...D)},this.a.set(p,z));const{object:q}=z,ie=(0,v.once)(()=>{--z.counter===0&&(this.c(p,z.object),this.a.delete(p))});return z.counter++,{object:q,dispose:ie}}}t.ReferenceCollection=C;class L{constructor(p){this.a=p}async acquire(p,...D){const z=this.a.acquire(p,...D);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(q){throw z.dispose(),q}}}t.AsyncReferenceCollection=L;class k{constructor(p){this.object=p}dispose(){}}t.ImmortalReference=k;function S(E){const p=new u;try{E(p)}finally{p.dispose()}}t.disposeOnReturn=S;class h{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){c(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{n(this.a.values())}finally{this.a.clear()}}has(p){return this.a.has(p)}get(p){return this.a.get(p)}set(p,D,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(p)?.dispose(),this.a.set(p,D)}deleteAndDispose(p){this.a.get(p)?.dispose(),this.a.delete(p)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=h}),define(be[45],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class v{constructor(R){this.element=R,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class i{constructor(){this.a=v.Undefined,this.b=v.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===v.Undefined}clear(){let R=this.a;for(;R!==v.Undefined;){const y=R.next;R.prev=v.Undefined,R.next=v.Undefined,R=y}this.a=v.Undefined,this.b=v.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,y){const w=new v(R);if(this.a===v.Undefined)this.a=w,this.b=w;else if(y){const d=this.b;this.b=w,w.prev=d,d.next=w}else{const d=this.a;this.a=w,w.next=d,d.prev=w}this.c+=1;let c=!1;return()=>{c||(c=!0,this.e(w))}}shift(){if(this.a!==v.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==v.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==v.Undefined&&R.next!==v.Undefined){const y=R.prev;y.next=R.next,R.next.prev=y}else R.prev===v.Undefined&&R.next===v.Undefined?(this.a=v.Undefined,this.b=v.Undefined):R.next===v.Undefined?(this.b=this.b.prev,this.b.next=v.Undefined):R.prev===v.Undefined&&(this.a=this.a.next,this.a.prev=v.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==v.Undefined;)yield R.element,R=R.next}}t.LinkedList=i}),define(be[74],pe([1,0]),function(Q,t){"use strict";var v,i,U;Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function R(e,s,l){let u=e.get(s);return u===void 0&&(u=l,e.set(s,u)),u}t.getOrSet=R;function y(e){const s=[];return e.forEach((l,u)=>{s.push(`${u} => ${l}`)}),`Map(${e.size}) {${s.join(", ")}}`}t.mapToString=y;function w(e){const s=[];return e.forEach(l=>{s.push(l)}),`Set(${e.size}) {${s.join(", ")}}`}t.setToString=w;class c{constructor(s,l){this.uri=s,this.value=l}}class d{constructor(s,l){this[v]="ResourceMap",s instanceof d?(this.b=new Map(s.b),this.c=l??d.a):(this.b=new Map,this.c=s??d.a)}set(s,l){return this.b.set(this.c(s),new c(s,l)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,l){typeof l<"u"&&(s=s.bind(l));for(const[u,m]of this.b)s(m.value,m.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}t.ResourceMap=d,d.a=e=>e.toString();class f{constructor(s,l){this[i]="ResourceSet",!s||typeof s=="function"?this.a=new d(s):(this.a=new d(l),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,l){this.a.forEach((u,m)=>s.call(l,m,m,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=f;var I;(function(e){e[e.None=0]="None",e[e.AsOld=1]="AsOld",e[e.AsNew=2]="AsNew"})(I=t.Touch||(t.Touch={}));class r{constructor(){this[U]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,l=0){const u=this.a.get(s);if(!!u)return l!==0&&this.j(u,l),u.value}set(s,l,u=0){let m=this.a.get(s);if(m)m.value=l,u!==0&&this.j(m,u);else{switch(m={key:s,value:l,next:void 0,previous:void 0},u){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(s,m),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const l=this.a.get(s);if(!!l)return this.a.delete(s),this.i(l),this.d--,l.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,l){const u=this.e;let m=this.b;for(;m;){if(l?s.bind(l)(m.value,m.key,this):s(m.value,m.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const s=this,l=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(s.e!==l)throw new Error("LinkedMap got modified during iteration.");if(u){const o={value:u.key,done:!1};return u=u.next,o}else return{value:void 0,done:!0}}};return m}values(){const s=this,l=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(s.e!==l)throw new Error("LinkedMap got modified during iteration.");if(u){const o={value:u.value,done:!1};return u=u.next,o}else return{value:void 0,done:!0}}};return m}entries(){const s=this,l=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(s.e!==l)throw new Error("LinkedMap got modified during iteration.");if(u){const o={value:[u.key,u.value],done:!1};return u=u.next,o}else return{value:void 0,done:!0}}};return m}[(U=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let l=this.b,u=this.size;for(;l&&u>s;)this.a.delete(l.key),l=l.next,u--;this.b=l,this.d=u,l&&(l.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const l=s.next,u=s.previous;if(!l||!u)throw new Error("Invalid list");l.previous=u,u.next=l}s.next=void 0,s.previous=void 0,this.e++}j(s,l){if(!this.b||!this.c)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(s===this.b)return;const u=s.next,m=s.previous;s===this.c?(m.next=void 0,this.c=m):(u.previous=m,m.next=u),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(l===2){if(s===this.c)return;const u=s.next,m=s.previous;s===this.b?(u.previous=void 0,this.b=u):(u.previous=m,m.next=u),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((l,u)=>{s.push([u,l])}),s}fromJSON(s){this.clear();for(const[l,u]of s)this.set(l,u)}}t.LinkedMap=r;class n extends r{constructor(s,l=1){super(),this.k=s,this.l=Math.min(Math.max(0,l),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,l=2){return super.get(s,l)}peek(s){return super.get(s,0)}set(s,l){return super.set(s,l,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.LRUCache=n}),function(Q,t){typeof exports=="object"&&typeof module<"u"?t(exports):typeof define=="function"&&define.amd?define(be[75],pe([0]),t):(Q=typeof globalThis<"u"?globalThis:Q||self,t(Q.marked={}))}(this,function(Q){"use strict";function t(T,M){for(var H=0;H<M.length;H++){var A=M[H];A.enumerable=A.enumerable||!1,A.configurable=!0,"value"in A&&(A.writable=!0),Object.defineProperty(T,A.key,A)}}function v(T,M,H){return M&&t(T.prototype,M),H&&t(T,H),Object.defineProperty(T,"prototype",{writable:!1}),T}function i(T,M){if(!!T){if(typeof T=="string")return U(T,M);var H=Object.prototype.toString.call(T).slice(8,-1);if(H==="Object"&&T.constructor&&(H=T.constructor.name),H==="Map"||H==="Set")return Array.from(T);if(H==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(H))return U(T,M)}}function U(T,M){(M==null||M>T.length)&&(M=T.length);for(var H=0,A=new Array(M);H<M;H++)A[H]=T[H];return A}function R(T,M){var H=typeof Symbol<"u"&&T[Symbol.iterator]||T["@@iterator"];if(H)return(H=H.call(T)).next.bind(H);if(Array.isArray(T)||(H=i(T))||M&&T&&typeof T.length=="number"){H&&(T=H);var A=0;return function(){return A>=T.length?{done:!0}:{done:!1,value:T[A++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Q.defaults=y();function w(T){Q.defaults=T}var c=/[&<>"']/,d=/[&<>"']/g,f=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},n=function(M){return r[M]};function e(T,M){if(M){if(c.test(T))return T.replace(d,n)}else if(f.test(T))return T.replace(I,n);return T}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(T){return T.replace(s,function(M,H){return H=H.toLowerCase(),H==="colon"?":":H.charAt(0)==="#"?H.charAt(1)==="x"?String.fromCharCode(parseInt(H.substring(2),16)):String.fromCharCode(+H.substring(1)):""})}var u=/(^|[^\[])\^/g;function m(T,M){T=typeof T=="string"?T:T.source,M=M||"";var H={replace:function(N,O){return O=O.source||O,O=O.replace(u,"$1"),T=T.replace(N,O),H},getRegex:function(){return new RegExp(T,M)}};return H}var o=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(T,M,H){if(T){var A;try{A=decodeURIComponent(l(H)).replace(o,"").toLowerCase()}catch{return null}if(A.indexOf("javascript:")===0||A.indexOf("vbscript:")===0||A.indexOf("data:")===0)return null}M&&!a.test(H)&&(H=h(M,H));try{H=encodeURI(H).replace(/%25/g,"%")}catch{return null}return H}var C={},L=/^[^:]+:\/*[^/]*$/,k=/^([^:]+:)[\s\S]*$/,S=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(T,M){C[" "+T]||(L.test(T)?C[" "+T]=T+"/":C[" "+T]=z(T,"/",!0)),T=C[" "+T];var H=T.indexOf(":")===-1;return M.substring(0,2)==="//"?H?M:T.replace(k,"$1")+M:M.charAt(0)==="/"?H?M:T.replace(S,"$1")+M:T+M}var E={exec:function(){}};function p(T){for(var M=1,H,A;M<arguments.length;M++){H=arguments[M];for(A in H)Object.prototype.hasOwnProperty.call(H,A)&&(T[A]=H[A])}return T}function D(T,M){var H=T.replace(/\|/g,function(O,W,j){for(var ee=!1,le=W;--le>=0&&j[le]==="\\";)ee=!ee;return ee?"|":" |"}),A=H.split(/ \|/),N=0;if(A[0].trim()||A.shift(),A.length>0&&!A[A.length-1].trim()&&A.pop(),A.length>M)A.splice(M);else for(;A.length<M;)A.push("");for(;N<A.length;N++)A[N]=A[N].trim().replace(/\\\|/g,"|");return A}function z(T,M,H){var A=T.length;if(A===0)return"";for(var N=0;N<A;){var O=T.charAt(A-N-1);if(O===M&&!H)N++;else if(O!==M&&H)N++;else break}return T.slice(0,A-N)}function q(T,M){if(T.indexOf(M[1])===-1)return-1;for(var H=T.length,A=0,N=0;N<H;N++)if(T[N]==="\\")N++;else if(T[N]===M[0])A++;else if(T[N]===M[1]&&(A--,A<0))return N;return-1}function ie(T){T&&T.sanitize&&!T.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function J(T,M){if(M<1)return"";for(var H="";M>1;)M&1&&(H+=T),M>>=1,T+=T;return H+T}function me(T,M,H,A){var N=M.href,O=M.title?e(M.title):null,W=T[1].replace(/\\([\[\]])/g,"$1");if(T[0].charAt(0)!=="!"){A.state.inLink=!0;var j={type:"link",raw:H,href:N,title:O,text:W,tokens:A.inlineTokens(W)};return A.state.inLink=!1,j}return{type:"image",raw:H,href:N,title:O,text:e(W)}}function he(T,M){var H=T.match(/^(\s+)(?:```)/);if(H===null)return M;var A=H[1];return M.split(`
`).map(function(N){var O=N.match(/^\s+/);if(O===null)return N;var W=O[0];return W.length>=A.length?N.slice(A.length):N}).join(`
`)}var fe=function(){function T(H){this.options=H||Q.defaults}var M=T.prototype;return M.space=function(A){var N=this.rules.block.newline.exec(A);if(N&&N[0].length>0)return{type:"space",raw:N[0]}},M.code=function(A){var N=this.rules.block.code.exec(A);if(N){var O=N[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:N[0],codeBlockStyle:"indented",text:this.options.pedantic?O:z(O,`
`)}}},M.fences=function(A){var N=this.rules.block.fences.exec(A);if(N){var O=N[0],W=he(O,N[3]||"");return{type:"code",raw:O,lang:N[2]?N[2].trim():N[2],text:W}}},M.heading=function(A){var N=this.rules.block.heading.exec(A);if(N){var O=N[2].trim();if(/#$/.test(O)){var W=z(O,"#");(this.options.pedantic||!W||/ $/.test(W))&&(O=W.trim())}return{type:"heading",raw:N[0],depth:N[1].length,text:O,tokens:this.lexer.inline(O)}}},M.hr=function(A){var N=this.rules.block.hr.exec(A);if(N)return{type:"hr",raw:N[0]}},M.blockquote=function(A){var N=this.rules.block.blockquote.exec(A);if(N){var O=N[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:N[0],tokens:this.lexer.blockTokens(O,[]),text:O}}},M.list=function(A){var N=this.rules.block.list.exec(A);if(N){var O,W,j,ee,le,ce,De,ye,Ie,ke,ve,Re,Pe=N[1].trim(),Ve=Pe.length>1,Ue={type:"list",raw:"",ordered:Ve,start:Ve?+Pe.slice(0,-1):"",loose:!1,items:[]};Pe=Ve?"\\d{1,9}\\"+Pe.slice(-1):"\\"+Pe,this.options.pedantic&&(Pe=Ve?Pe:"[*+-]");for(var ze=new RegExp("^( {0,3}"+Pe+")((?:[	 ][^\\n]*)?(?:\\n|$))");A&&(Re=!1,!(!(N=ze.exec(A))||this.rules.block.hr.test(A)));){if(O=N[0],A=A.substring(O.length),ye=N[2].split(`
`,1)[0],Ie=A.split(`
`,1)[0],this.options.pedantic?(ee=2,ve=ye.trimLeft()):(ee=N[2].search(/[^ ]/),ee=ee>4?1:ee,ve=ye.slice(ee),ee+=N[1].length),ce=!1,!ye&&/^ *$/.test(Ie)&&(O+=Ie+`
`,A=A.substring(Ie.length+1),Re=!0),!Re)for(var xe=new RegExp("^ {0,"+Math.min(3,ee-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,ee-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Be=new RegExp("^ {0,"+Math.min(3,ee-1)+"}(?:```|~~~)"),Ke=new RegExp("^ {0,"+Math.min(3,ee-1)+"}#");A&&(ke=A.split(`
`,1)[0],ye=ke,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Be.test(ye)||Ke.test(ye)||xe.test(ye)||it.test(A)));){if(ye.search(/[^ ]/)>=ee||!ye.trim())ve+=`
`+ye.slice(ee);else if(!ce)ve+=`
`+ye;else break;!ce&&!ye.trim()&&(ce=!0),O+=ke+`
`,A=A.substring(ke.length+1)}Ue.loose||(De?Ue.loose=!0:/\n *\n *$/.test(O)&&(De=!0)),this.options.gfm&&(W=/^\[[ xX]\] /.exec(ve),W&&(j=W[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Ue.items.push({type:"list_item",raw:O,task:!!W,checked:j,loose:!1,text:ve}),Ue.raw+=O}Ue.items[Ue.items.length-1].raw=O.trimRight(),Ue.items[Ue.items.length-1].text=ve.trimRight(),Ue.raw=Ue.raw.trimRight();var Ye=Ue.items.length;for(le=0;le<Ye;le++){this.lexer.state.top=!1,Ue.items[le].tokens=this.lexer.blockTokens(Ue.items[le].text,[]);var K=Ue.items[le].tokens.filter(function(we){return we.type==="space"}),ae=K.every(function(we){for(var Ee=we.raw.split(""),Fe=0,Oe=R(Ee),_e;!(_e=Oe()).done;){var tt=_e.value;if(tt===`
`&&(Fe+=1),Fe>1)return!0}return!1});!Ue.loose&&K.length&&ae&&(Ue.loose=!0,Ue.items[le].loose=!0)}return Ue}},M.html=function(A){var N=this.rules.block.html.exec(A);if(N){var O={type:"html",raw:N[0],pre:!this.options.sanitizer&&(N[1]==="pre"||N[1]==="script"||N[1]==="style"),text:N[0]};if(this.options.sanitize){var W=this.options.sanitizer?this.options.sanitizer(N[0]):e(N[0]);O.type="paragraph",O.text=W,O.tokens=this.lexer.inline(W)}return O}},M.def=function(A){var N=this.rules.block.def.exec(A);if(N){N[3]&&(N[3]=N[3].substring(1,N[3].length-1));var O=N[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:O,raw:N[0],href:N[2],title:N[3]}}},M.table=function(A){var N=this.rules.block.table.exec(A);if(N){var O={type:"table",header:D(N[1]).map(function(De){return{text:De}}),align:N[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:N[3]&&N[3].trim()?N[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(O.header.length===O.align.length){O.raw=N[0];var W=O.align.length,j,ee,le,ce;for(j=0;j<W;j++)/^ *-+: *$/.test(O.align[j])?O.align[j]="right":/^ *:-+: *$/.test(O.align[j])?O.align[j]="center":/^ *:-+ *$/.test(O.align[j])?O.align[j]="left":O.align[j]=null;for(W=O.rows.length,j=0;j<W;j++)O.rows[j]=D(O.rows[j],O.header.length).map(function(De){return{text:De}});for(W=O.header.length,ee=0;ee<W;ee++)O.header[ee].tokens=this.lexer.inline(O.header[ee].text);for(W=O.rows.length,ee=0;ee<W;ee++)for(ce=O.rows[ee],le=0;le<ce.length;le++)ce[le].tokens=this.lexer.inline(ce[le].text);return O}}},M.lheading=function(A){var N=this.rules.block.lheading.exec(A);if(N)return{type:"heading",raw:N[0],depth:N[2].charAt(0)==="="?1:2,text:N[1],tokens:this.lexer.inline(N[1])}},M.paragraph=function(A){var N=this.rules.block.paragraph.exec(A);if(N){var O=N[1].charAt(N[1].length-1)===`
`?N[1].slice(0,-1):N[1];return{type:"paragraph",raw:N[0],text:O,tokens:this.lexer.inline(O)}}},M.text=function(A){var N=this.rules.block.text.exec(A);if(N)return{type:"text",raw:N[0],text:N[0],tokens:this.lexer.inline(N[0])}},M.escape=function(A){var N=this.rules.inline.escape.exec(A);if(N)return{type:"escape",raw:N[0],text:e(N[1])}},M.tag=function(A){var N=this.rules.inline.tag.exec(A);if(N)return!this.lexer.state.inLink&&/^<a /i.test(N[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(N[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(N[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(N[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:N[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(N[0]):e(N[0]):N[0]}},M.link=function(A){var N=this.rules.inline.link.exec(A);if(N){var O=N[2].trim();if(!this.options.pedantic&&/^</.test(O)){if(!/>$/.test(O))return;var W=z(O.slice(0,-1),"\\");if((O.length-W.length)%2===0)return}else{var j=q(N[2],"()");if(j>-1){var ee=N[0].indexOf("!")===0?5:4,le=ee+N[1].length+j;N[2]=N[2].substring(0,j),N[0]=N[0].substring(0,le).trim(),N[3]=""}}var ce=N[2],De="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ce);ye&&(ce=ye[1],De=ye[3])}else De=N[3]?N[3].slice(1,-1):"";return ce=ce.trim(),/^</.test(ce)&&(this.options.pedantic&&!/>$/.test(O)?ce=ce.slice(1):ce=ce.slice(1,-1)),me(N,{href:ce&&ce.replace(this.rules.inline._escapes,"$1"),title:De&&De.replace(this.rules.inline._escapes,"$1")},N[0],this.lexer)}},M.reflink=function(A,N){var O;if((O=this.rules.inline.reflink.exec(A))||(O=this.rules.inline.nolink.exec(A))){var W=(O[2]||O[1]).replace(/\s+/g," ");if(W=N[W.toLowerCase()],!W||!W.href){var j=O[0].charAt(0);return{type:"text",raw:j,text:j}}return me(O,W,O[0],this.lexer)}},M.emStrong=function(A,N,O){O===void 0&&(O="");var W=this.rules.inline.emStrong.lDelim.exec(A);if(!!W&&!(W[3]&&O.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var j=W[1]||W[2]||"";if(!j||j&&(O===""||this.rules.inline.punctuation.exec(O))){var ee=W[0].length-1,le,ce,De=ee,ye=0,Ie=W[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ie.lastIndex=0,N=N.slice(-1*A.length+ee);(W=Ie.exec(N))!=null;)if(le=W[1]||W[2]||W[3]||W[4]||W[5]||W[6],!!le){if(ce=le.length,W[3]||W[4]){De+=ce;continue}else if((W[5]||W[6])&&ee%3&&!((ee+ce)%3)){ye+=ce;continue}if(De-=ce,!(De>0)){if(ce=Math.min(ce,ce+De+ye),Math.min(ee,ce)%2){var ke=A.slice(1,ee+W.index+ce);return{type:"em",raw:A.slice(0,ee+W.index+ce+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}var ve=A.slice(2,ee+W.index+ce-1);return{type:"strong",raw:A.slice(0,ee+W.index+ce+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},M.codespan=function(A){var N=this.rules.inline.code.exec(A);if(N){var O=N[2].replace(/\n/g," "),W=/[^ ]/.test(O),j=/^ /.test(O)&&/ $/.test(O);return W&&j&&(O=O.substring(1,O.length-1)),O=e(O,!0),{type:"codespan",raw:N[0],text:O}}},M.br=function(A){var N=this.rules.inline.br.exec(A);if(N)return{type:"br",raw:N[0]}},M.del=function(A){var N=this.rules.inline.del.exec(A);if(N)return{type:"del",raw:N[0],text:N[2],tokens:this.lexer.inlineTokens(N[2])}},M.autolink=function(A,N){var O=this.rules.inline.autolink.exec(A);if(O){var W,j;return O[2]==="@"?(W=e(this.options.mangle?N(O[1]):O[1]),j="mailto:"+W):(W=e(O[1]),j=W),{type:"link",raw:O[0],text:W,href:j,tokens:[{type:"text",raw:W,text:W}]}}},M.url=function(A,N){var O;if(O=this.rules.inline.url.exec(A)){var W,j;if(O[2]==="@")W=e(this.options.mangle?N(O[0]):O[0]),j="mailto:"+W;else{var ee;do ee=O[0],O[0]=this.rules.inline._backpedal.exec(O[0])[0];while(ee!==O[0]);W=e(O[0]),O[1]==="www."?j="http://"+W:j=W}return{type:"link",raw:O[0],text:W,href:j,tokens:[{type:"text",raw:W,text:W}]}}},M.inlineText=function(A,N){var O=this.rules.inline.text.exec(A);if(O){var W;return this.lexer.state.inRawBlock?W=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(O[0]):e(O[0]):O[0]:W=e(this.options.smartypants?N(O[0]):O[0]),{type:"text",raw:O[0],text:W}}},T}(),oe={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};oe._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,oe._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,oe.def=m(oe.def).replace("label",oe._label).replace("title",oe._title).getRegex(),oe.bullet=/(?:[*+-]|\d{1,9}[.)])/,oe.listItemStart=m(/^( *)(bull) */).replace("bull",oe.bullet).getRegex(),oe.list=m(oe.list).replace(/bull/g,oe.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+oe.def.source+")").getRegex(),oe._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",oe._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,oe.html=m(oe.html,"i").replace("comment",oe._comment).replace("tag",oe._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),oe.paragraph=m(oe._paragraph).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.blockquote=m(oe.blockquote).replace("paragraph",oe.paragraph).getRegex(),oe.normal=p({},oe),oe.gfm=p({},oe.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),oe.gfm.table=m(oe.gfm.table).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.gfm.paragraph=m(oe._paragraph).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",oe.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.pedantic=p({},oe.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",oe._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:m(oe.normal._paragraph).replace("hr",oe.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",oe.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var de={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};de._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",de.punctuation=m(de.punctuation).replace(/punctuation/g,de._punctuation).getRegex(),de.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,de.escapedEmSt=/\\\*|\\_/g,de._comment=m(oe._comment).replace("(?:-->|$)","-->").getRegex(),de.emStrong.lDelim=m(de.emStrong.lDelim).replace(/punct/g,de._punctuation).getRegex(),de.emStrong.rDelimAst=m(de.emStrong.rDelimAst,"g").replace(/punct/g,de._punctuation).getRegex(),de.emStrong.rDelimUnd=m(de.emStrong.rDelimUnd,"g").replace(/punct/g,de._punctuation).getRegex(),de._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,de._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,de._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,de.autolink=m(de.autolink).replace("scheme",de._scheme).replace("email",de._email).getRegex(),de._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,de.tag=m(de.tag).replace("comment",de._comment).replace("attribute",de._attribute).getRegex(),de._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,de._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,de._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,de.link=m(de.link).replace("label",de._label).replace("href",de._href).replace("title",de._title).getRegex(),de.reflink=m(de.reflink).replace("label",de._label).replace("ref",oe._label).getRegex(),de.nolink=m(de.nolink).replace("ref",oe._label).getRegex(),de.reflinkSearch=m(de.reflinkSearch,"g").replace("reflink",de.reflink).replace("nolink",de.nolink).getRegex(),de.normal=p({},de),de.pedantic=p({},de.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",de._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",de._label).getRegex()}),de.gfm=p({},de.normal,{escape:m(de.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),de.gfm.url=m(de.gfm.url,"i").replace("email",de.gfm._extended_email).getRegex(),de.breaks=p({},de.gfm,{br:m(de.br).replace("{2,}","*").getRegex(),text:m(de.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Se(T){return T.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function te(T){var M="",H,A,N=T.length;for(H=0;H<N;H++)A=T.charCodeAt(H),Math.random()>.5&&(A="x"+A.toString(16)),M+="&#"+A+";";return M}var Ce=function(){function T(H){this.tokens=[],this.tokens.links=Object.create(null),this.options=H||Q.defaults,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var A={block:oe.normal,inline:de.normal};this.options.pedantic?(A.block=oe.pedantic,A.inline=de.pedantic):this.options.gfm&&(A.block=oe.gfm,this.options.breaks?A.inline=de.breaks:A.inline=de.gfm),this.tokenizer.rules=A}T.lex=function(A,N){var O=new T(N);return O.lex(A)},T.lexInline=function(A,N){var O=new T(N);return O.inlineTokens(A)};var M=T.prototype;return M.lex=function(A){A=A.replace(/\r\n|\r/g,`
`),this.blockTokens(A,this.tokens);for(var N;N=this.inlineQueue.shift();)this.inlineTokens(N.src,N.tokens);return this.tokens},M.blockTokens=function(A,N){var O=this;N===void 0&&(N=[]),this.options.pedantic?A=A.replace(/\t/g,"    ").replace(/^ +$/gm,""):A=A.replace(/^( *)(\t+)/gm,function(De,ye,Ie){return ye+"    ".repeat(Ie.length)});for(var W,j,ee,le;A;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(De){return(W=De.call({lexer:O},A,N))?(A=A.substring(W.raw.length),N.push(W),!0):!1}))){if(W=this.tokenizer.space(A)){A=A.substring(W.raw.length),W.raw.length===1&&N.length>0?N[N.length-1].raw+=`
`:N.push(W);continue}if(W=this.tokenizer.code(A)){A=A.substring(W.raw.length),j=N[N.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+W.raw,j.text+=`
`+W.text,this.inlineQueue[this.inlineQueue.length-1].src=j.text):N.push(W);continue}if(W=this.tokenizer.fences(A)){A=A.substring(W.raw.length),N.push(W);continue}if(W=this.tokenizer.heading(A)){A=A.substring(W.raw.length),N.push(W);continue}if(W=this.tokenizer.hr(A)){A=A.substring(W.raw.length),N.push(W);continue}if(W=this.tokenizer.blockquote(A)){A=A.substring(W.raw.length),N.push(W);continue}if(W=this.tokenizer.list(A)){A=A.substring(W.raw.length),N.push(W);continue}if(W=this.tokenizer.html(A)){A=A.substring(W.raw.length),N.push(W);continue}if(W=this.tokenizer.def(A)){A=A.substring(W.raw.length),j=N[N.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+W.raw,j.text+=`
`+W.raw,this.inlineQueue[this.inlineQueue.length-1].src=j.text):this.tokens.links[W.tag]||(this.tokens.links[W.tag]={href:W.href,title:W.title});continue}if(W=this.tokenizer.table(A)){A=A.substring(W.raw.length),N.push(W);continue}if(W=this.tokenizer.lheading(A)){A=A.substring(W.raw.length),N.push(W);continue}if(ee=A,this.options.extensions&&this.options.extensions.startBlock&&function(){var De=1/0,ye=A.slice(1),Ie=void 0;O.options.extensions.startBlock.forEach(function(ke){Ie=ke.call({lexer:this},ye),typeof Ie=="number"&&Ie>=0&&(De=Math.min(De,Ie))}),De<1/0&&De>=0&&(ee=A.substring(0,De+1))}(),this.state.top&&(W=this.tokenizer.paragraph(ee))){j=N[N.length-1],le&&j.type==="paragraph"?(j.raw+=`
`+W.raw,j.text+=`
`+W.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):N.push(W),le=ee.length!==A.length,A=A.substring(W.raw.length);continue}if(W=this.tokenizer.text(A)){A=A.substring(W.raw.length),j=N[N.length-1],j&&j.type==="text"?(j.raw+=`
`+W.raw,j.text+=`
`+W.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):N.push(W);continue}if(A){var ce="Infinite loop on byte: "+A.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return this.state.top=!0,N},M.inline=function(A,N){return N===void 0&&(N=[]),this.inlineQueue.push({src:A,tokens:N}),N},M.inlineTokens=function(A,N){var O=this;N===void 0&&(N=[]);var W,j,ee,le=A,ce,De,ye;if(this.tokens.links){var Ie=Object.keys(this.tokens.links);if(Ie.length>0)for(;(ce=this.tokenizer.rules.inline.reflinkSearch.exec(le))!=null;)Ie.includes(ce[0].slice(ce[0].lastIndexOf("[")+1,-1))&&(le=le.slice(0,ce.index)+"["+J("a",ce[0].length-2)+"]"+le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ce=this.tokenizer.rules.inline.blockSkip.exec(le))!=null;)le=le.slice(0,ce.index)+"["+J("a",ce[0].length-2)+"]"+le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ce=this.tokenizer.rules.inline.escapedEmSt.exec(le))!=null;)le=le.slice(0,ce.index)+"++"+le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;A;)if(De||(ye=""),De=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(W=ve.call({lexer:O},A,N))?(A=A.substring(W.raw.length),N.push(W),!0):!1}))){if(W=this.tokenizer.escape(A)){A=A.substring(W.raw.length),N.push(W);continue}if(W=this.tokenizer.tag(A)){A=A.substring(W.raw.length),j=N[N.length-1],j&&W.type==="text"&&j.type==="text"?(j.raw+=W.raw,j.text+=W.text):N.push(W);continue}if(W=this.tokenizer.link(A)){A=A.substring(W.raw.length),N.push(W);continue}if(W=this.tokenizer.reflink(A,this.tokens.links)){A=A.substring(W.raw.length),j=N[N.length-1],j&&W.type==="text"&&j.type==="text"?(j.raw+=W.raw,j.text+=W.text):N.push(W);continue}if(W=this.tokenizer.emStrong(A,le,ye)){A=A.substring(W.raw.length),N.push(W);continue}if(W=this.tokenizer.codespan(A)){A=A.substring(W.raw.length),N.push(W);continue}if(W=this.tokenizer.br(A)){A=A.substring(W.raw.length),N.push(W);continue}if(W=this.tokenizer.del(A)){A=A.substring(W.raw.length),N.push(W);continue}if(W=this.tokenizer.autolink(A,te)){A=A.substring(W.raw.length),N.push(W);continue}if(!this.state.inLink&&(W=this.tokenizer.url(A,te))){A=A.substring(W.raw.length),N.push(W);continue}if(ee=A,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Re=A.slice(1),Pe=void 0;O.options.extensions.startInline.forEach(function(Ve){Pe=Ve.call({lexer:this},Re),typeof Pe=="number"&&Pe>=0&&(ve=Math.min(ve,Pe))}),ve<1/0&&ve>=0&&(ee=A.substring(0,ve+1))}(),W=this.tokenizer.inlineText(ee,Se)){A=A.substring(W.raw.length),W.raw.slice(-1)!=="_"&&(ye=W.raw.slice(-1)),De=!0,j=N[N.length-1],j&&j.type==="text"?(j.raw+=W.raw,j.text+=W.text):N.push(W);continue}if(A){var ke="Infinite loop on byte: "+A.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return N},v(T,null,[{key:"rules",get:function(){return{block:oe,inline:de}}}]),T}(),se=function(){function T(H){this.options=H||Q.defaults}var M=T.prototype;return M.code=function(A,N,O){var W=(N||"").match(/\S*/)[0];if(this.options.highlight){var j=this.options.highlight(A,W);j!=null&&j!==A&&(O=!0,A=j)}return A=A.replace(/\n$/,"")+`
`,W?'<pre><code class="'+this.options.langPrefix+e(W,!0)+'">'+(O?A:e(A,!0))+`</code></pre>
`:"<pre><code>"+(O?A:e(A,!0))+`</code></pre>
`},M.blockquote=function(A){return`<blockquote>
`+A+`</blockquote>
`},M.html=function(A){return A},M.heading=function(A,N,O,W){if(this.options.headerIds){var j=this.options.headerPrefix+W.slug(O);return"<h"+N+' id="'+j+'">'+A+"</h"+N+`>
`}return"<h"+N+">"+A+"</h"+N+`>
`},M.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},M.list=function(A,N,O){var W=N?"ol":"ul",j=N&&O!==1?' start="'+O+'"':"";return"<"+W+j+`>
`+A+"</"+W+`>
`},M.listitem=function(A){return"<li>"+A+`</li>
`},M.checkbox=function(A){return"<input "+(A?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},M.paragraph=function(A){return"<p>"+A+`</p>
`},M.table=function(A,N){return N&&(N="<tbody>"+N+"</tbody>"),`<table>
<thead>
`+A+`</thead>
`+N+`</table>
`},M.tablerow=function(A){return`<tr>
`+A+`</tr>
`},M.tablecell=function(A,N){var O=N.header?"th":"td",W=N.align?"<"+O+' align="'+N.align+'">':"<"+O+">";return W+A+("</"+O+`>
`)},M.strong=function(A){return"<strong>"+A+"</strong>"},M.em=function(A){return"<em>"+A+"</em>"},M.codespan=function(A){return"<code>"+A+"</code>"},M.br=function(){return this.options.xhtml?"<br/>":"<br>"},M.del=function(A){return"<del>"+A+"</del>"},M.link=function(A,N,O){if(A=g(this.options.sanitize,this.options.baseUrl,A),A===null)return O;var W='<a href="'+e(A)+'"';return N&&(W+=' title="'+N+'"'),W+=">"+O+"</a>",W},M.image=function(A,N,O){if(A=g(this.options.sanitize,this.options.baseUrl,A),A===null)return O;var W='<img src="'+A+'" alt="'+O+'"';return N&&(W+=' title="'+N+'"'),W+=this.options.xhtml?"/>":">",W},M.text=function(A){return A},T}(),x=function(){function T(){}var M=T.prototype;return M.strong=function(A){return A},M.em=function(A){return A},M.codespan=function(A){return A},M.del=function(A){return A},M.html=function(A){return A},M.text=function(A){return A},M.link=function(A,N,O){return""+O},M.image=function(A,N,O){return""+O},M.br=function(){return""},T}(),ue=function(){function T(){this.seen={}}var M=T.prototype;return M.serialize=function(A){return A.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},M.getNextSafeSlug=function(A,N){var O=A,W=0;if(this.seen.hasOwnProperty(O)){W=this.seen[A];do W++,O=A+"-"+W;while(this.seen.hasOwnProperty(O))}return N||(this.seen[A]=W,this.seen[O]=0),O},M.slug=function(A,N){N===void 0&&(N={});var O=this.serialize(A);return this.getNextSafeSlug(O,N.dryrun)},T}(),ne=function(){function T(H){this.options=H||Q.defaults,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new ue}T.parse=function(A,N){var O=new T(N);return O.parse(A)},T.parseInline=function(A,N){var O=new T(N);return O.parseInline(A)};var M=T.prototype;return M.parse=function(A,N){N===void 0&&(N=!0);var O="",W,j,ee,le,ce,De,ye,Ie,ke,ve,Re,Pe,Ve,Ue,ze,xe,it,Be,Ke,Ye=A.length;for(W=0;W<Ye;W++){if(ve=A[W],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(Ke=this.options.extensions.renderers[ve.type].call({parser:this},ve),Ke!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){O+=Ke||"";continue}switch(ve.type){case"space":continue;case"hr":{O+=this.renderer.hr();continue}case"heading":{O+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,l(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{O+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Ie="",ye="",le=ve.header.length,j=0;j<le;j++)ye+=this.renderer.tablecell(this.parseInline(ve.header[j].tokens),{header:!0,align:ve.align[j]});for(Ie+=this.renderer.tablerow(ye),ke="",le=ve.rows.length,j=0;j<le;j++){for(De=ve.rows[j],ye="",ce=De.length,ee=0;ee<ce;ee++)ye+=this.renderer.tablecell(this.parseInline(De[ee].tokens),{header:!1,align:ve.align[ee]});ke+=this.renderer.tablerow(ye)}O+=this.renderer.table(Ie,ke);continue}case"blockquote":{ke=this.parse(ve.tokens),O+=this.renderer.blockquote(ke);continue}case"list":{for(Re=ve.ordered,Pe=ve.start,Ve=ve.loose,le=ve.items.length,ke="",j=0;j<le;j++)ze=ve.items[j],xe=ze.checked,it=ze.task,Ue="",ze.task&&(Be=this.renderer.checkbox(xe),Ve?ze.tokens.length>0&&ze.tokens[0].type==="paragraph"?(ze.tokens[0].text=Be+" "+ze.tokens[0].text,ze.tokens[0].tokens&&ze.tokens[0].tokens.length>0&&ze.tokens[0].tokens[0].type==="text"&&(ze.tokens[0].tokens[0].text=Be+" "+ze.tokens[0].tokens[0].text)):ze.tokens.unshift({type:"text",text:Be}):Ue+=Be),Ue+=this.parse(ze.tokens,Ve),ke+=this.renderer.listitem(Ue,it,xe);O+=this.renderer.list(ke,Re,Pe);continue}case"html":{O+=this.renderer.html(ve.text);continue}case"paragraph":{O+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(ke=ve.tokens?this.parseInline(ve.tokens):ve.text;W+1<Ye&&A[W+1].type==="text";)ve=A[++W],ke+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);O+=N?this.renderer.paragraph(ke):ke;continue}default:{var K='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return O},M.parseInline=function(A,N){N=N||this.renderer;var O="",W,j,ee,le=A.length;for(W=0;W<le;W++){if(j=A[W],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[j.type]&&(ee=this.options.extensions.renderers[j.type].call({parser:this},j),ee!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(j.type))){O+=ee||"";continue}switch(j.type){case"escape":{O+=N.text(j.text);break}case"html":{O+=N.html(j.text);break}case"link":{O+=N.link(j.href,j.title,this.parseInline(j.tokens,N));break}case"image":{O+=N.image(j.href,j.title,j.text);break}case"strong":{O+=N.strong(this.parseInline(j.tokens,N));break}case"em":{O+=N.em(this.parseInline(j.tokens,N));break}case"codespan":{O+=N.codespan(j.text);break}case"br":{O+=N.br();break}case"del":{O+=N.del(this.parseInline(j.tokens,N));break}case"text":{O+=N.text(j.text);break}default:{var ce='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(ce);return}else throw new Error(ce)}}}return O},T}();function F(T,M,H){if(typeof T>"u"||T===null)throw new Error("marked(): input parameter is undefined or null");if(typeof T!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(T)+", string expected");if(typeof M=="function"&&(H=M,M=null),M=p({},F.defaults,M||{}),ie(M),H){var A=M.highlight,N;try{N=Ce.lex(T,M)}catch(le){return H(le)}var O=function(ce){var De;if(!ce)try{M.walkTokens&&F.walkTokens(N,M.walkTokens),De=ne.parse(N,M)}catch(ye){ce=ye}return M.highlight=A,ce?H(ce):H(null,De)};if(!A||A.length<3||(delete M.highlight,!N.length))return O();var W=0;F.walkTokens(N,function(le){le.type==="code"&&(W++,setTimeout(function(){A(le.text,le.lang,function(ce,De){if(ce)return O(ce);De!=null&&De!==le.text&&(le.text=De,le.escaped=!0),W--,W===0&&O()})},0))}),W===0&&O();return}function j(le){if(le.message+=`
Please report this to https://github.com/markedjs/marked.`,M.silent)return"<p>An error occurred:</p><pre>"+e(le.message+"",!0)+"</pre>";throw le}try{var ee=Ce.lex(T,M);if(M.walkTokens){if(M.async)return Promise.all(F.walkTokens(ee,M.walkTokens)).then(function(){return ne.parse(ee,M)}).catch(j);F.walkTokens(ee,M.walkTokens)}return ne.parse(ee,M)}catch(le){j(le)}}F.options=F.setOptions=function(T){return p(F.defaults,T),w(F.defaults),F},F.getDefaults=y,F.defaults=Q.defaults,F.use=function(){for(var T=arguments.length,M=new Array(T),H=0;H<T;H++)M[H]=arguments[H];var A=p.apply(void 0,[{}].concat(M)),N=F.defaults.extensions||{renderers:{},childTokens:{}},O;M.forEach(function(W){if(W.extensions&&(O=!0,W.extensions.forEach(function(ee){if(!ee.name)throw new Error("extension name required");if(ee.renderer){var le=N.renderers?N.renderers[ee.name]:null;le?N.renderers[ee.name]=function(){for(var ce=arguments.length,De=new Array(ce),ye=0;ye<ce;ye++)De[ye]=arguments[ye];var Ie=ee.renderer.apply(this,De);return Ie===!1&&(Ie=le.apply(this,De)),Ie}:N.renderers[ee.name]=ee.renderer}if(ee.tokenizer){if(!ee.level||ee.level!=="block"&&ee.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");N[ee.level]?N[ee.level].unshift(ee.tokenizer):N[ee.level]=[ee.tokenizer],ee.start&&(ee.level==="block"?N.startBlock?N.startBlock.push(ee.start):N.startBlock=[ee.start]:ee.level==="inline"&&(N.startInline?N.startInline.push(ee.start):N.startInline=[ee.start]))}ee.childTokens&&(N.childTokens[ee.name]=ee.childTokens)})),W.renderer&&function(){var ee=F.defaults.renderer||new se,le=function(ye){var Ie=ee[ye];ee[ye]=function(){for(var ke=arguments.length,ve=new Array(ke),Re=0;Re<ke;Re++)ve[Re]=arguments[Re];var Pe=W.renderer[ye].apply(ee,ve);return Pe===!1&&(Pe=Ie.apply(ee,ve)),Pe}};for(var ce in W.renderer)le(ce);A.renderer=ee}(),W.tokenizer&&function(){var ee=F.defaults.tokenizer||new fe,le=function(ye){var Ie=ee[ye];ee[ye]=function(){for(var ke=arguments.length,ve=new Array(ke),Re=0;Re<ke;Re++)ve[Re]=arguments[Re];var Pe=W.tokenizer[ye].apply(ee,ve);return Pe===!1&&(Pe=Ie.apply(ee,ve)),Pe}};for(var ce in W.tokenizer)le(ce);A.tokenizer=ee}(),W.walkTokens){var j=F.defaults.walkTokens;A.walkTokens=function(ee){var le=[];return le.push(W.walkTokens.call(this,ee)),j&&(le=le.concat(j.call(this,ee))),le}}O&&(A.extensions=N),F.setOptions(A)})},F.walkTokens=function(T,M){for(var H=[],A=function(){var j=O.value;switch(H=H.concat(M.call(F,j)),j.type){case"table":{for(var ee=R(j.header),le;!(le=ee()).done;){var ce=le.value;H=H.concat(F.walkTokens(ce.tokens,M))}for(var De=R(j.rows),ye;!(ye=De()).done;)for(var Ie=ye.value,ke=R(Ie),ve;!(ve=ke()).done;){var Re=ve.value;H=H.concat(F.walkTokens(Re.tokens,M))}break}case"list":{H=H.concat(F.walkTokens(j.items,M));break}default:F.defaults.extensions&&F.defaults.extensions.childTokens&&F.defaults.extensions.childTokens[j.type]?F.defaults.extensions.childTokens[j.type].forEach(function(Pe){H=H.concat(F.walkTokens(j[Pe],M))}):j.tokens&&(H=H.concat(F.walkTokens(j.tokens,M)))}},N=R(T),O;!(O=N()).done;)A();return H},F.parseInline=function(T,M){if(typeof T>"u"||T===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof T!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(T)+", string expected");M=p({},F.defaults,M||{}),ie(M);try{var H=Ce.lexInline(T,M);return M.walkTokens&&F.walkTokens(H,M.walkTokens),ne.parseInline(H,M)}catch(A){if(A.message+=`
Please report this to https://github.com/markedjs/marked.`,M.silent)return"<p>An error occurred:</p><pre>"+e(A.message+"",!0)+"</pre>";throw A}},F.Parser=ne,F.parser=ne.parse,F.Renderer=se,F.TextRenderer=x,F.Lexer=Ce,F.lexer=Ce.lex,F.Tokenizer=fe,F.Slugger=ue,F.parse=F;var _=F.options,G=F.setOptions,P=F.use,b=F.walkTokens,B=F.parseInline,$=F,V=ne.parse,Z=Ce.lex;Q.Lexer=Ce,Q.Parser=ne,Q.Renderer=se,Q.Slugger=ue,Q.TextRenderer=x,Q.Tokenizer=fe,Q.getDefaults=y,Q.lexer=Z,Q.marked=F,Q.options=_,Q.parse=$,Q.parseInline=B,Q.parser=V,Q.setOptions=G,Q.use=P,Q.walkTokens=b,Object.defineProperty(Q,"__esModule",{value:!0})}),define(be[76],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class v{constructor(U,R=0,y=U.length,w=R-1){this.a=U,this.b=R,this.c=y,this.d=w}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.ArrayNavigator=v}),define(be[77],pe([1,0,76]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class i{constructor(y=[],w=10){this.h(y),this.b=w,this.d()}getHistory(){return this.j}add(y){this.a.delete(y),this.a.add(y),this.d()}next(){return this.g()!==this.j.length-1?this.c.next():null}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}has(y){return this.a.has(y)}clear(){this.h([]),this.d()}d(){this.f();const y=this.j;this.c=new v.ArrayNavigator(y,0,y.length,y.length)}f(){const y=this.j;y.length>this.b&&this.h(y.slice(y.length-this.b))}g(){const y=this.c.current();return y?this.j.indexOf(y):-1}h(y){this.a=new Set;for(const w of y)this.a.add(w)}get j(){const y=[];return this.a.forEach(w=>y.push(w)),y}}t.HistoryNavigator=i;class U{constructor(y,w=10){if(this.f=w,y.length<1)throw new Error("not supported");this.d=1,this.a=this.b=this.c={value:y[0],previous:void 0,next:void 0};for(let c=1;c<y.length;c++)this.add(y[c])}add(y){const w={value:y,previous:this.b,next:void 0};for(this.b.next=w,this.b=w,this.c=this.b,this.d++;this.d>this.f;)this.a=this.a.next,this.a.previous=void 0,this.d--}replaceLast(y){const w=this.b.value;return this.b.value=y,w}isAtEnd(){return this.c===this.b}current(){return this.c.value}previous(){return this.c.previous&&(this.c=this.c.previous),this.c.value}next(){return this.c.next&&(this.c=this.c.next),this.c.value}has(y){let w=this.a;for(;w;){if(w.value===y)return!0;w=w.next}return!1}resetCursor(){return this.c=this.b,this.c.value}*[Symbol.iterator](){let y=this.a;for(;y;)yield y.value,y=y.next}}t.HistoryNavigator2=U}),define(be[46],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function v(w,c,d){return Math.min(Math.max(w,c),d)}t.clamp=v;function i(w,c){return(c+w%c)%c}t.rot=i;class U{constructor(){this.a=0}getNext(){return this.a++}}t.Counter=U;class R{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.MovingAverage=R;class y{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const d=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.SlidingWindowAverage=y}),define(be[47],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var v;(function(i){function U(c,d){if(c.start>=d.end||d.start>=c.end)return{start:0,end:0};const f=Math.max(c.start,d.start),I=Math.min(c.end,d.end);return I-f<=0?{start:0,end:0}:{start:f,end:I}}i.intersect=U;function R(c){return c.end-c.start<=0}i.isEmpty=R;function y(c,d){return!R(U(c,d))}i.intersects=y;function w(c,d){const f=[],I={start:c.start,end:Math.min(d.start,c.end)},r={start:Math.max(d.end,c.start),end:c.end};return R(I)||f.push(I),R(r)||f.push(r),f}i.relativeComplement=w})(v=t.Range||(t.Range={}))}),define(be[78],pe([1,0,47]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function i(c,d){const f=[];for(const I of d){if(c.start>=I.range.end)continue;if(c.end<I.range.start)break;const r=v.Range.intersect(c,I.range);v.Range.isEmpty(r)||f.push({range:r,size:I.size})}return f}t.groupIntersect=i;function U({start:c,end:d},f){return{start:c+f,end:d+f}}t.shift=U;function R(c){const d=[];let f=null;for(const I of c){const r=I.range.start,n=I.range.end,e=I.size;if(f&&e===f.size){f.range.end=n;continue}f={range:{start:r,end:n},size:e},d.push(f)}return d}t.consolidate=R;function y(...c){return R(c.reduce((d,f)=>d.concat(f),[]))}class w{constructor(){this.a=[],this.b=0}splice(d,f,I=[]){const r=I.length-f,n=i({start:0,end:d},this.a),e=i({start:d+f,end:Number.POSITIVE_INFINITY},this.a).map(l=>({range:U(l.range,r),size:l.size})),s=I.map((l,u)=>({range:{start:d+u,end:d+u+1},size:l.size}));this.a=y(n,s,e),this.b=this.a.reduce((l,u)=>l+u.size*(u.range.end-u.range.start),0)}get count(){const d=this.a.length;return d?this.a[d-1].range.end:0}get size(){return this.b}indexAt(d){if(d<0)return-1;let f=0,I=0;for(const r of this.a){const n=r.range.end-r.range.start,e=I+n*r.size;if(d<e)return f+Math.floor((d-I)/r.size);f+=n,I=e}return f}indexAfter(d){return Math.min(this.indexAt(d)+1,this.count)}positionAt(d){if(d<0)return-1;let f=0,I=0;for(const r of this.a){const n=r.range.end-r.range.start,e=I+n;if(d<e)return f+(d-I)*r.size;f+=n*r.size,I=e}return-1}}t.RangeMap=w}),define(be[79],pe([1,0,9,2]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function U(a){const g=a;return g?typeof g.read=="function":!1}t.isReadable=U;function R(a){const g=a;return g?[g.on,g.pause,g.resume,g.destroy].every(C=>typeof C=="function"):!1}t.isReadableStream=R;function y(a){const g=a;return g?R(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}t.isReadableBufferedStream=y;function w(a,g){return new c(a,g)}t.newWriteableStream=w;class c{constructor(g,C){this.e=g,this.f=C,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(C=>this.d.push(C))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(C=>C(g))}h(g){this.c.error.length===0?(0,v.onUnexpectedError)(g):this.c.error.slice(0).forEach(C=>C(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,C){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(C),this.resume();break;case"end":this.c.end.push(C),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(C),this.a.flowing&&this.k();break}}removeListener(g,C){if(this.a.destroyed)return;let L;switch(g){case"data":L=this.c.data;break;case"end":L=this.c.end;break;case"error":L=this.c.error;break}if(L){const k=L.indexOf(C);k>=0&&L.splice(k,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const C=[...this.d];this.d.length=0,C.forEach(L=>L())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(a,g){const C=[];let L;for(;(L=a.read())!==null;)C.push(L);return g(C)}t.consumeReadable=d;function f(a,g,C){const L=[];let k;for(;(k=a.read())!==null&&L.length<C;)L.push(k);return k===null&&L.length>0?g(L):{read:()=>{if(L.length>0)return L.shift();if(typeof k<"u"){const S=k;return k=void 0,S}return a.read()}}}t.peekReadable=f;function I(a,g){return new Promise((C,L)=>{const k=[];r(a,{onData:S=>{g&&k.push(S)},onError:S=>{g?L(S):C(void 0)},onEnd:()=>{C(g?g(k):void 0)}})})}t.consumeStream=I;function r(a,g){let C=!1;return a.on("error",L=>{C||g.onError(L)}),a.on("end",()=>{C||g.onEnd()}),a.on("data",L=>{C||g.onData(L)}),(0,i.toDisposable)(()=>C=!0)}t.listenStream=r;function n(a,g){return new Promise((C,L)=>{const k=new i.DisposableStore,S=[],h=D=>{if(S.push(D),S.length>g)return k.dispose(),a.pause(),C({stream:a,buffer:S,ended:!1})},E=D=>L(D),p=()=>C({stream:a,buffer:S,ended:!0});k.add((0,i.toDisposable)(()=>a.removeListener("error",E))),a.on("error",E),k.add((0,i.toDisposable)(()=>a.removeListener("end",p))),a.on("end",p),k.add((0,i.toDisposable)(()=>a.removeListener("data",h))),a.on("data",h)})}t.peekStream=n;function e(a,g){const C=w(g);return C.end(a),C}t.toStream=e;function s(){const a=w(()=>{throw new Error("not supported")});return a.end(),a}t.emptyStream=s;function l(a){let g=!1;return{read:()=>g?null:(g=!0,a)}}t.toReadable=l;function u(a,g,C){const L=w(C);return r(a,{onData:k=>L.write(g.data(k)),onError:k=>L.error(g.error?g.error(k):k),onEnd:()=>L.end()}),L}t.transform=u;function m(a,g,C){let L=!1;return{read:()=>{const k=g.read();return L?k:(L=!0,k!==null?C([a,k]):a)}}}t.prefixedReadable=m;function o(a,g,C){let L=!1;const k=w(C);return r(g,{onData:S=>L?k.write(S):(L=!0,k.write(C([a,S]))),onError:S=>k.error(S),onEnd:()=>{L||(L=!0,k.write(a)),k.end()}}),k}t.prefixedStream=o}),define(be[31],pe([1,0,79]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer<"u";let U,R;class y{static alloc(D){return i?new y(Buffer.allocUnsafe(D)):new y(new Uint8Array(D))}static wrap(D){return i&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new y(D)}static fromString(D,z){return!(z?.dontUseNodeBuffer||!1)&&i?new y(Buffer.from(D)):(U||(U=new TextEncoder),new y(U.encode(D)))}static fromByteArray(D){const z=y.alloc(D.length);for(let q=0,ie=D.length;q<ie;q++)z.buffer[q]=D[q];return z}static concat(D,z){if(typeof z>"u"){z=0;for(let J=0,me=D.length;J<me;J++)z+=D[J].byteLength}const q=y.alloc(z);let ie=0;for(let J=0,me=D.length;J<me;J++){const he=D[J];q.set(he,ie),ie+=he.byteLength}return q}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=y.alloc(this.byteLength);return D.set(this),D}toString(){return i?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(D,z){return new y(this.buffer.subarray(D,z))}set(D,z){if(D instanceof y)this.buffer.set(D.buffer,z);else if(D instanceof Uint8Array)this.buffer.set(D,z);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),z);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),z);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return d(this.buffer,D)}writeUInt32BE(D,z){f(this.buffer,D,z)}readUInt32LE(D){return I(this.buffer,D)}writeUInt32LE(D,z){r(this.buffer,D,z)}readUInt8(D){return n(this.buffer,D)}writeUInt8(D,z){e(this.buffer,D,z)}}t.VSBuffer=y;function w(p,D){return p[D+0]<<0>>>0|p[D+1]<<8>>>0}t.readUInt16LE=w;function c(p,D,z){p[z+0]=D&255,D=D>>>8,p[z+1]=D&255}t.writeUInt16LE=c;function d(p,D){return p[D]*2**24+p[D+1]*2**16+p[D+2]*2**8+p[D+3]}t.readUInt32BE=d;function f(p,D,z){p[z+3]=D,D=D>>>8,p[z+2]=D,D=D>>>8,p[z+1]=D,D=D>>>8,p[z]=D}t.writeUInt32BE=f;function I(p,D){return p[D+0]<<0>>>0|p[D+1]<<8>>>0|p[D+2]<<16>>>0|p[D+3]<<24>>>0}t.readUInt32LE=I;function r(p,D,z){p[z+0]=D&255,D=D>>>8,p[z+1]=D&255,D=D>>>8,p[z+2]=D&255,D=D>>>8,p[z+3]=D&255}t.writeUInt32LE=r;function n(p,D){return p[D]}t.readUInt8=n;function e(p,D,z){p[z]=D}t.writeUInt8=e;function s(p){return v.consumeReadable(p,D=>y.concat(D))}t.readableToBuffer=s;function l(p){return v.toReadable(p)}t.bufferToReadable=l;function u(p){return v.consumeStream(p,D=>y.concat(D))}t.streamToBuffer=u;async function m(p){return p.ended?y.concat(p.buffer):y.concat([...p.buffer,await u(p.stream)])}t.bufferedStreamToBuffer=m;function o(p){return v.toStream(p,D=>y.concat(D))}t.bufferToStream=o;function a(p){return v.transform(p,{data:D=>typeof D=="string"?y.fromString(D):y.wrap(D)},D=>y.concat(D))}t.streamToBufferReadableStream=a;function g(p){return v.newWriteableStream(D=>y.concat(D),p)}t.newWriteableBufferStream=g;function C(p,D){return v.prefixedReadable(p,D,z=>y.concat(z))}t.prefixedBufferReadable=C;function L(p,D){return v.prefixedStream(p,D,z=>y.concat(z))}t.prefixedBufferStream=L;function k(p){let D=0,z=0,q=0;const ie=new Uint8Array(Math.floor(p.length/4*3)),J=he=>{switch(z){case 3:ie[q++]=D|he,z=0;break;case 2:ie[q++]=D|he>>>2,D=he<<6,z=3;break;case 1:ie[q++]=D|he>>>4,D=he<<4,z=2;break;default:D=he<<2,z=1}};for(let he=0;he<p.length;he++){const fe=p.charCodeAt(he);if(fe>=65&&fe<=90)J(fe-65);else if(fe>=97&&fe<=122)J(fe-97+26);else if(fe>=48&&fe<=57)J(fe-48+52);else if(fe===43||fe===45)J(62);else if(fe===47||fe===95)J(63);else{if(fe===61)break;throw new SyntaxError(`Unexpected base64 character ${p[he]}`)}}const me=q;for(;z>0;)J(0);return y.wrap(ie).slice(0,me)}t.decodeBase64=k;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:p},D=!0,z=!1){const q=z?h:S;let ie="";const J=p.byteLength%3;let me=0;for(;me<p.byteLength-J;me+=3){const he=p[me+0],fe=p[me+1],oe=p[me+2];ie+=q[he>>>2],ie+=q[(he<<4|fe>>>4)&63],ie+=q[(fe<<2|oe>>>6)&63],ie+=q[oe&63]}if(J===1){const he=p[me+0];ie+=q[he>>>2],ie+=q[he<<4&63],D&&(ie+="==")}else if(J===2){const he=p[me+0],fe=p[me+1];ie+=q[he>>>2],ie+=q[(he<<4|fe>>>4)&63],ie+=q[fe<<2&63],D&&(ie+="=")}return ie}t.encodeBase64=E}),define(be[6],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function v(L){return typeof L=="string"}t.isString=v;function i(L){return Array.isArray(L)&&L.every(k=>v(k))}t.isStringArray=i;function U(L){return typeof L=="object"&&L!==null&&!Array.isArray(L)&&!(L instanceof RegExp)&&!(L instanceof Date)}t.isObject=U;function R(L){const k=Object.getPrototypeOf(Uint8Array);return typeof L=="object"&&L instanceof k}t.isTypedArray=R;function y(L){return typeof L=="number"&&!isNaN(L)}t.isNumber=y;function w(L){return!!L&&typeof L[Symbol.iterator]=="function"}t.isIterable=w;function c(L){return L===!0||L===!1}t.isBoolean=c;function d(L){return typeof L>"u"}t.isUndefined=d;function f(L){return!I(L)}t.isDefined=f;function I(L){return d(L)||L===null}t.isUndefinedOrNull=I;function r(L,k){if(!L)throw new Error(k?`Unexpected type, expected '${k}'`:"Unexpected type")}t.assertType=r;function n(L){if(I(L))throw new Error("Assertion Failed: argument is undefined or null");return L}t.assertIsDefined=n;function e(...L){const k=[];for(let S=0;S<L.length;S++){const h=L[S];if(I(h))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);k.push(h)}return k}t.assertAllDefined=e;const s=Object.prototype.hasOwnProperty;function l(L){if(!U(L))return!1;for(const k in L)if(s.call(L,k))return!1;return!0}t.isEmptyObject=l;function u(L){return typeof L=="function"}t.isFunction=u;function m(...L){return L.length>0&&L.every(u)}t.areFunctions=m;function o(L,k){const S=Math.min(L.length,k.length);for(let h=0;h<S;h++)a(L[h],k[h])}t.validateConstraints=o;function a(L,k){if(v(k)){if(typeof L!==k)throw new Error(`argument does not match constraint: typeof ${k}`)}else if(u(k)){try{if(L instanceof k)return}catch{}if(!I(L)&&L.constructor===k||k.length===1&&k.call(void 0,L)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=a;function g(L){return L===null?void 0:L}t.withNullAsUndefined=g;function C(L){return typeof L>"u"?null:L}t.withUndefinedAsNull=C}),define(be[27],pe([1,0,6]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function i(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const m=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([o,a])=>{m[o]=a&&typeof a=="object"?i(a):a}),m}t.deepClone=i;function U(u){if(!u||typeof u!="object")return u;const m=[u];for(;m.length>0;){const o=m.shift();Object.freeze(o);for(const a in o)if(R.call(o,a)){const g=o[a];typeof g=="object"&&!Object.isFrozen(g)&&!(0,v.isTypedArray)(g)&&m.push(g)}}return u}t.deepFreeze=U;const R=Object.prototype.hasOwnProperty;function y(u,m){return w(u,m,new Set)}t.cloneAndChange=y;function w(u,m,o){if((0,v.isUndefinedOrNull)(u))return u;const a=m(u);if(typeof a<"u")return a;if(Array.isArray(u)){const g=[];for(const C of u)g.push(w(C,m,o));return g}if((0,v.isObject)(u)){if(o.has(u))throw new Error("Cannot clone recursive data-structure");o.add(u);const g={};for(const C in u)R.call(u,C)&&(g[C]=w(u[C],m,o));return o.delete(u),g}return u}function c(u,m,o=!0){return(0,v.isObject)(u)?((0,v.isObject)(m)&&Object.keys(m).forEach(a=>{a in u?o&&((0,v.isObject)(u[a])&&(0,v.isObject)(m[a])?c(u[a],m[a],o):u[a]=m[a]):u[a]=m[a]}),u):m}t.mixin=c;function d(u,m){if(u===m)return!0;if(u==null||m===null||m===void 0||typeof u!=typeof m||typeof u!="object"||Array.isArray(u)!==Array.isArray(m))return!1;let o,a;if(Array.isArray(u)){if(u.length!==m.length)return!1;for(o=0;o<u.length;o++)if(!d(u[o],m[o]))return!1}else{const g=[];for(a in u)g.push(a);g.sort();const C=[];for(a in m)C.push(a);if(C.sort(),!d(g,C))return!1;for(o=0;o<g.length;o++)if(!d(u[g[o]],m[g[o]]))return!1}return!0}t.equals=d;function f(u){const m=new Set;return JSON.stringify(u,(o,a)=>{if((0,v.isObject)(a)||Array.isArray(a)){if(m.has(a))return"[Circular]";m.add(a)}return a})}t.safeStringify=f;function I(u,m){const o=Object.create(null);return!u||!m||Object.keys(m).forEach(g=>{const C=u[g],L=m[g];d(C,L)||(o[g]=L)}),o}t.distinct=I;function r(u,m){const o=m.toLowerCase(),a=Object.keys(u).find(g=>g.toLowerCase()===o);return a?u[a]:u[m]}t.getCaseInsensitive=r;function n(u,m){const o=Object.create(null);for(const[a,g]of Object.entries(u))m(a,g)&&(o[a]=g);return o}t.filter=n;function e(u){let m=[],o=Object.getPrototypeOf(u);for(;Object.prototype!==o;)m=m.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return m}t.getAllPropertyNames=e;function s(u){const m=[];for(const o of e(u))typeof u[o]=="function"&&m.push(o);return m}t.getAllMethodNames=s;function l(u,m){const o=g=>function(){const C=Array.prototype.slice.call(arguments,0);return m(g,C)},a={};for(const g of u)a[g]=o(g);return a}t.createProxyObject=l}),define(be[80],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(be[81],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class v{constructor(U,R){this.a=U,this.onMessage=R}send(U){try{this.a.send("vscode:message",U.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.Protocol=v}),define(be[48],pe([7]),{}),define(be[82],pe([7]),{}),define(be[83],pe([7]),{}),define(be[84],pe([7]),{}),define(be[85],pe([1,0,12,83,84]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.formatRule=void 0;function i(U){let R=U.definition;for(;R instanceof v.Codicon;)R=R.definition;return`.codicon-${U.id}:before { content: '${R.fontCharacter}'; }`}t.formatRule=i}),define(be[86],pe([7]),{}),define(be[87],pe([7]),{}),define(be[88],pe([7]),{}),define(be[89],pe([7]),{}),define(be[90],pe([7]),{}),define(be[91],pe([7]),{}),define(be[92],pe([7]),{}),define(be[93],pe([7]),{}),define(be[94],pe([7]),{}),define(be[95],pe([13,10]),function(Q,t){return Q.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[96],pe([13,10]),function(Q,t){return Q.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[97],pe([13,10]),function(Q,t){return Q.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[98],pe([13,10]),function(Q,t){return Q.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[99],pe([13,10]),function(Q,t){return Q.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[100],pe([13,10]),function(Q,t){return Q.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[101],pe([13,10]),function(Q,t){return Q.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[102],pe([13,10]),function(Q,t){return Q.create("vs/base/common/actions",t)}),define(be[103],pe([13,10]),function(Q,t){return Q.create("vs/base/common/platform",t)}),define(be[5],pe([1,0,103]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let i=!1,U=!1,R=!1,y=!1,w=!1,c=!1,d=!1,f=!1,I=!1,r=!1,n,e=t.LANGUAGE_DEFAULT,s,l;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?u=t.globals.vscode.process:typeof process<"u"&&(u=process);const m=typeof u?.versions?.electron=="string",o=m&&u?.type==="renderer";if(typeof navigator=="object"&&!o)l=navigator.userAgent,i=l.indexOf("Windows")>=0,U=l.indexOf("Macintosh")>=0,f=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=l.indexOf("Linux")>=0,r=l?.indexOf("Mobi")>=0,c=!0,n=v.getConfiguredDefaultLocale(v.localize(0,null))||t.LANGUAGE_DEFAULT,e=n;else if(typeof u=="object"){i=u.platform==="win32",U=u.platform==="darwin",R=u.platform==="linux",y=R&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,d=m,I=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,n=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const p=u.env.VSCODE_NLS_CONFIG;if(p)try{const D=JSON.parse(p),z=D.availableLanguages["*"];n=D.locale,e=z||t.LANGUAGE_DEFAULT,s=D._translationsConfigFile}catch{}w=!0}else console.error("Unable to resolve platform.");var a;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(a=t.Platform||(t.Platform={}));function g(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=g;let C=0;U?C=1:i?C=3:R&&(C=2),t.isWindows=i,t.isMacintosh=U,t.isLinux=R,t.isLinuxSnap=y,t.isNative=w,t.isElectron=d,t.isWeb=c,t.isWebWorker=c&&typeof t.globals.importScripts=="function",t.isIOS=f,t.isMobile=r,t.isCI=I,t.platform=C,t.userAgent=l,t.language=e;var L;(function(p){function D(){return t.language}p.value=D;function z(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}p.isDefaultVariant=z;function q(){return t.language==="en"}p.isDefault=q})(L=t.Language||(t.Language={})),t.locale=n,t.translationsConfigFile=s,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const p=[];t.globals.addEventListener("message",z=>{if(z.data&&z.data.vscodeScheduleAsyncWork)for(let q=0,ie=p.length;q<ie;q++){const J=p[q];if(J.id===z.data.vscodeScheduleAsyncWork){p.splice(q,1),J.callback();return}}});let D=0;return z=>{const q=++D;p.push({id:q,callback:z}),t.globals.postMessage({vscodeScheduleAsyncWork:q},"*")}}return p=>setTimeout(p)})();var k;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(k=t.OperatingSystem||(t.OperatingSystem={})),t.OS=U||f?2:i?1:3;let S=!0,h=!1;function E(){if(!h){h=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,S=new Uint16Array(p.buffer)[0]===(2<<8)+1}return S}t.isLittleEndian=E,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(be[104],pe([1,0,5]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let i;if(typeof v.globals.vscode<"u"&&typeof v.globals.vscode.process<"u"){const U=v.globals.vscode.process;i={get platform(){return U.platform},get arch(){return U.arch},get env(){return U.env},cwd(){return U.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.arch=i.arch}),define(be[21],pe([1,0,104]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const i=65,U=97,R=90,y=122,w=46,c=47,d=92,f=58,I=63;class r extends Error{constructor(a,g,C){let L;typeof g=="string"&&g.indexOf("not ")===0?(L="must not be",g=g.replace(/^not /,"")):L="must be";const k=a.indexOf(".")!==-1?"property":"argument";let S=`The "${a}" ${k} ${L} of type ${g}`;S+=`. Received type ${typeof C}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function n(o,a){if(typeof o!="string")throw new r(a,"string",o)}function e(o){return o===c||o===d}function s(o){return o===c}function l(o){return o>=i&&o<=R||o>=U&&o<=y}function u(o,a,g,C){let L="",k=0,S=-1,h=0,E=0;for(let p=0;p<=o.length;++p){if(p<o.length)E=o.charCodeAt(p);else{if(C(E))break;E=c}if(C(E)){if(!(S===p-1||h===1))if(h===2){if(L.length<2||k!==2||L.charCodeAt(L.length-1)!==w||L.charCodeAt(L.length-2)!==w){if(L.length>2){const D=L.lastIndexOf(g);D===-1?(L="",k=0):(L=L.slice(0,D),k=L.length-1-L.lastIndexOf(g)),S=p,h=0;continue}else if(L.length!==0){L="",k=0,S=p,h=0;continue}}a&&(L+=L.length>0?`${g}..`:"..",k=2)}else L.length>0?L+=`${g}${o.slice(S+1,p)}`:L=o.slice(S+1,p),k=p-S-1;S=p,h=0}else E===w&&h!==-1?++h:h=-1}return L}function m(o,a){if(a===null||typeof a!="object")throw new r("pathObject","Object",a);const g=a.dir||a.root,C=a.base||`${a.name||""}${a.ext||""}`;return g?g===a.root?`${g}${C}`:`${g}${o}${C}`:C}t.win32={resolve(...o){let a="",g="",C=!1;for(let L=o.length-1;L>=-1;L--){let k;if(L>=0){if(k=o[L],n(k,"path"),k.length===0)continue}else a.length===0?k=v.cwd():(k=v.env[`=${a}`]||v.cwd(),(k===void 0||k.slice(0,2).toLowerCase()!==a.toLowerCase()&&k.charCodeAt(2)===d)&&(k=`${a}\\`));const S=k.length;let h=0,E="",p=!1;const D=k.charCodeAt(0);if(S===1)e(D)&&(h=1,p=!0);else if(e(D))if(p=!0,e(k.charCodeAt(1))){let z=2,q=z;for(;z<S&&!e(k.charCodeAt(z));)z++;if(z<S&&z!==q){const ie=k.slice(q,z);for(q=z;z<S&&e(k.charCodeAt(z));)z++;if(z<S&&z!==q){for(q=z;z<S&&!e(k.charCodeAt(z));)z++;(z===S||z!==q)&&(E=`\\\\${ie}\\${k.slice(q,z)}`,h=z)}}}else h=1;else l(D)&&k.charCodeAt(1)===f&&(E=k.slice(0,2),h=2,S>2&&e(k.charCodeAt(2))&&(p=!0,h=3));if(E.length>0)if(a.length>0){if(E.toLowerCase()!==a.toLowerCase())continue}else a=E;if(C){if(a.length>0)break}else if(g=`${k.slice(h)}\\${g}`,C=p,p&&a.length>0)break}return g=u(g,!C,"\\",e),C?`${a}\\${g}`:`${a}${g}`||"."},normalize(o){n(o,"path");const a=o.length;if(a===0)return".";let g=0,C,L=!1;const k=o.charCodeAt(0);if(a===1)return s(k)?"\\":o;if(e(k))if(L=!0,e(o.charCodeAt(1))){let h=2,E=h;for(;h<a&&!e(o.charCodeAt(h));)h++;if(h<a&&h!==E){const p=o.slice(E,h);for(E=h;h<a&&e(o.charCodeAt(h));)h++;if(h<a&&h!==E){for(E=h;h<a&&!e(o.charCodeAt(h));)h++;if(h===a)return`\\\\${p}\\${o.slice(E)}\\`;h!==E&&(C=`\\\\${p}\\${o.slice(E,h)}`,g=h)}}}else g=1;else l(k)&&o.charCodeAt(1)===f&&(C=o.slice(0,2),g=2,a>2&&e(o.charCodeAt(2))&&(L=!0,g=3));let S=g<a?u(o.slice(g),!L,"\\",e):"";return S.length===0&&!L&&(S="."),S.length>0&&e(o.charCodeAt(a-1))&&(S+="\\"),C===void 0?L?`\\${S}`:S:L?`${C}\\${S}`:`${C}${S}`},isAbsolute(o){n(o,"path");const a=o.length;if(a===0)return!1;const g=o.charCodeAt(0);return e(g)||a>2&&l(g)&&o.charCodeAt(1)===f&&e(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let a,g;for(let k=0;k<o.length;++k){const S=o[k];n(S,"path"),S.length>0&&(a===void 0?a=g=S:a+=`\\${S}`)}if(a===void 0)return".";let C=!0,L=0;if(typeof g=="string"&&e(g.charCodeAt(0))){++L;const k=g.length;k>1&&e(g.charCodeAt(1))&&(++L,k>2&&(e(g.charCodeAt(2))?++L:C=!1))}if(C){for(;L<a.length&&e(a.charCodeAt(L));)L++;L>=2&&(a=`\\${a.slice(L)}`)}return t.win32.normalize(a)},relative(o,a){if(n(o,"from"),n(a,"to"),o===a)return"";const g=t.win32.resolve(o),C=t.win32.resolve(a);if(g===C||(o=g.toLowerCase(),a=C.toLowerCase(),o===a))return"";let L=0;for(;L<o.length&&o.charCodeAt(L)===d;)L++;let k=o.length;for(;k-1>L&&o.charCodeAt(k-1)===d;)k--;const S=k-L;let h=0;for(;h<a.length&&a.charCodeAt(h)===d;)h++;let E=a.length;for(;E-1>h&&a.charCodeAt(E-1)===d;)E--;const p=E-h,D=S<p?S:p;let z=-1,q=0;for(;q<D;q++){const J=o.charCodeAt(L+q);if(J!==a.charCodeAt(h+q))break;J===d&&(z=q)}if(q!==D){if(z===-1)return C}else{if(p>D){if(a.charCodeAt(h+q)===d)return C.slice(h+q+1);if(q===2)return C.slice(h+q)}S>D&&(o.charCodeAt(L+q)===d?z=q:q===2&&(z=3)),z===-1&&(z=0)}let ie="";for(q=L+z+1;q<=k;++q)(q===k||o.charCodeAt(q)===d)&&(ie+=ie.length===0?"..":"\\..");return h+=z,ie.length>0?`${ie}${C.slice(h,E)}`:(C.charCodeAt(h)===d&&++h,C.slice(h,E))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const a=t.win32.resolve(o);if(a.length<=2)return o;if(a.charCodeAt(0)===d){if(a.charCodeAt(1)===d){const g=a.charCodeAt(2);if(g!==I&&g!==w)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(l(a.charCodeAt(0))&&a.charCodeAt(1)===f&&a.charCodeAt(2)===d)return`\\\\?\\${a}`;return o},dirname(o){n(o,"path");const a=o.length;if(a===0)return".";let g=-1,C=0;const L=o.charCodeAt(0);if(a===1)return e(L)?o:".";if(e(L)){if(g=C=1,e(o.charCodeAt(1))){let h=2,E=h;for(;h<a&&!e(o.charCodeAt(h));)h++;if(h<a&&h!==E){for(E=h;h<a&&e(o.charCodeAt(h));)h++;if(h<a&&h!==E){for(E=h;h<a&&!e(o.charCodeAt(h));)h++;if(h===a)return o;h!==E&&(g=C=h+1)}}}}else l(L)&&o.charCodeAt(1)===f&&(g=a>2&&e(o.charCodeAt(2))?3:2,C=g);let k=-1,S=!0;for(let h=a-1;h>=C;--h)if(e(o.charCodeAt(h))){if(!S){k=h;break}}else S=!1;if(k===-1){if(g===-1)return".";k=g}return o.slice(0,k)},basename(o,a){a!==void 0&&n(a,"ext"),n(o,"path");let g=0,C=-1,L=!0,k;if(o.length>=2&&l(o.charCodeAt(0))&&o.charCodeAt(1)===f&&(g=2),a!==void 0&&a.length>0&&a.length<=o.length){if(a===o)return"";let S=a.length-1,h=-1;for(k=o.length-1;k>=g;--k){const E=o.charCodeAt(k);if(e(E)){if(!L){g=k+1;break}}else h===-1&&(L=!1,h=k+1),S>=0&&(E===a.charCodeAt(S)?--S===-1&&(C=k):(S=-1,C=h))}return g===C?C=h:C===-1&&(C=o.length),o.slice(g,C)}for(k=o.length-1;k>=g;--k)if(e(o.charCodeAt(k))){if(!L){g=k+1;break}}else C===-1&&(L=!1,C=k+1);return C===-1?"":o.slice(g,C)},extname(o){n(o,"path");let a=0,g=-1,C=0,L=-1,k=!0,S=0;o.length>=2&&o.charCodeAt(1)===f&&l(o.charCodeAt(0))&&(a=C=2);for(let h=o.length-1;h>=a;--h){const E=o.charCodeAt(h);if(e(E)){if(!k){C=h+1;break}continue}L===-1&&(k=!1,L=h+1),E===w?g===-1?g=h:S!==1&&(S=1):g!==-1&&(S=-1)}return g===-1||L===-1||S===0||S===1&&g===L-1&&g===C+1?"":o.slice(g,L)},format:m.bind(null,"\\"),parse(o){n(o,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return a;const g=o.length;let C=0,L=o.charCodeAt(0);if(g===1)return e(L)?(a.root=a.dir=o,a):(a.base=a.name=o,a);if(e(L)){if(C=1,e(o.charCodeAt(1))){let z=2,q=z;for(;z<g&&!e(o.charCodeAt(z));)z++;if(z<g&&z!==q){for(q=z;z<g&&e(o.charCodeAt(z));)z++;if(z<g&&z!==q){for(q=z;z<g&&!e(o.charCodeAt(z));)z++;z===g?C=z:z!==q&&(C=z+1)}}}}else if(l(L)&&o.charCodeAt(1)===f){if(g<=2)return a.root=a.dir=o,a;if(C=2,e(o.charCodeAt(2))){if(g===3)return a.root=a.dir=o,a;C=3}}C>0&&(a.root=o.slice(0,C));let k=-1,S=C,h=-1,E=!0,p=o.length-1,D=0;for(;p>=C;--p){if(L=o.charCodeAt(p),e(L)){if(!E){S=p+1;break}continue}h===-1&&(E=!1,h=p+1),L===w?k===-1?k=p:D!==1&&(D=1):k!==-1&&(D=-1)}return h!==-1&&(k===-1||D===0||D===1&&k===h-1&&k===S+1?a.base=a.name=o.slice(S,h):(a.name=o.slice(S,k),a.base=o.slice(S,h),a.ext=o.slice(k,h))),S>0&&S!==C?a.dir=o.slice(0,S-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...o){let a="",g=!1;for(let C=o.length-1;C>=-1&&!g;C--){const L=C>=0?o[C]:v.cwd();n(L,"path"),L.length!==0&&(a=`${L}/${a}`,g=L.charCodeAt(0)===c)}return a=u(a,!g,"/",s),g?`/${a}`:a.length>0?a:"."},normalize(o){if(n(o,"path"),o.length===0)return".";const a=o.charCodeAt(0)===c,g=o.charCodeAt(o.length-1)===c;return o=u(o,!a,"/",s),o.length===0?a?"/":g?"./":".":(g&&(o+="/"),a?`/${o}`:o)},isAbsolute(o){return n(o,"path"),o.length>0&&o.charCodeAt(0)===c},join(...o){if(o.length===0)return".";let a;for(let g=0;g<o.length;++g){const C=o[g];n(C,"path"),C.length>0&&(a===void 0?a=C:a+=`/${C}`)}return a===void 0?".":t.posix.normalize(a)},relative(o,a){if(n(o,"from"),n(a,"to"),o===a||(o=t.posix.resolve(o),a=t.posix.resolve(a),o===a))return"";const g=1,C=o.length,L=C-g,k=1,S=a.length-k,h=L<S?L:S;let E=-1,p=0;for(;p<h;p++){const z=o.charCodeAt(g+p);if(z!==a.charCodeAt(k+p))break;z===c&&(E=p)}if(p===h)if(S>h){if(a.charCodeAt(k+p)===c)return a.slice(k+p+1);if(p===0)return a.slice(k+p)}else L>h&&(o.charCodeAt(g+p)===c?E=p:p===0&&(E=0));let D="";for(p=g+E+1;p<=C;++p)(p===C||o.charCodeAt(p)===c)&&(D+=D.length===0?"..":"/..");return`${D}${a.slice(k+E)}`},toNamespacedPath(o){return o},dirname(o){if(n(o,"path"),o.length===0)return".";const a=o.charCodeAt(0)===c;let g=-1,C=!0;for(let L=o.length-1;L>=1;--L)if(o.charCodeAt(L)===c){if(!C){g=L;break}}else C=!1;return g===-1?a?"/":".":a&&g===1?"//":o.slice(0,g)},basename(o,a){a!==void 0&&n(a,"ext"),n(o,"path");let g=0,C=-1,L=!0,k;if(a!==void 0&&a.length>0&&a.length<=o.length){if(a===o)return"";let S=a.length-1,h=-1;for(k=o.length-1;k>=0;--k){const E=o.charCodeAt(k);if(E===c){if(!L){g=k+1;break}}else h===-1&&(L=!1,h=k+1),S>=0&&(E===a.charCodeAt(S)?--S===-1&&(C=k):(S=-1,C=h))}return g===C?C=h:C===-1&&(C=o.length),o.slice(g,C)}for(k=o.length-1;k>=0;--k)if(o.charCodeAt(k)===c){if(!L){g=k+1;break}}else C===-1&&(L=!1,C=k+1);return C===-1?"":o.slice(g,C)},extname(o){n(o,"path");let a=-1,g=0,C=-1,L=!0,k=0;for(let S=o.length-1;S>=0;--S){const h=o.charCodeAt(S);if(h===c){if(!L){g=S+1;break}continue}C===-1&&(L=!1,C=S+1),h===w?a===-1?a=S:k!==1&&(k=1):a!==-1&&(k=-1)}return a===-1||C===-1||k===0||k===1&&a===C-1&&a===g+1?"":o.slice(a,C)},format:m.bind(null,"/"),parse(o){n(o,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return a;const g=o.charCodeAt(0)===c;let C;g?(a.root="/",C=1):C=0;let L=-1,k=0,S=-1,h=!0,E=o.length-1,p=0;for(;E>=C;--E){const D=o.charCodeAt(E);if(D===c){if(!h){k=E+1;break}continue}S===-1&&(h=!1,S=E+1),D===w?L===-1?L=E:p!==1&&(p=1):L!==-1&&(p=-1)}if(S!==-1){const D=k===0&&g?1:k;L===-1||p===0||p===1&&L===S-1&&L===k+1?a.base=a.name=o.slice(D,S):(a.name=o.slice(D,L),a.base=o.slice(D,S),a.ext=o.slice(L,S))}return k>0?a.dir=o.slice(0,k-1):g&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=v.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=v.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=v.platform==="win32"?t.win32.join:t.posix.join,t.resolve=v.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=v.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=v.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=v.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=v.platform==="win32"?t.win32.extname:t.posix.extname,t.format=v.platform==="win32"?t.win32.format:t.posix.format,t.parse=v.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=v.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=v.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=v.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),define(be[105],pe([1,0,21]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},U={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(f){const I=(0,v.extname)(f),r=i[I.toLowerCase()];return r!==void 0?r:y(f)}t.getMediaOrTextMime=R;function y(f){const I=(0,v.extname)(f);return U[I.toLowerCase()]}t.getMediaMime=y;function w(f){for(const I in U)if(U[I]===f)return I}t.getExtensionForMimeType=w;const c=/^(.+)\/(.+?)(;.+)?$/;function d(f,I){const r=c.exec(f);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:I?void 0:f}t.normalizeMimeType=d}),define(be[106],pe([1,0,5]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=v.globals.performance&&typeof v.globals.performance.now=="function";class U{static create(y=!0){return new U(y)}constructor(y){this.a=i&&y,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?v.globals.performance.now():Date.now()}}t.StopWatch=U}),define(be[3],pe([1,0,9,42,2,45,106]),function(Q,t,v,i,U,R,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const w=!1,c=!1;var d;(function(E){E.None=()=>U.Disposable.None;function p($){if(c){const{onDidAddListener:V}=$,Z=e.create();let T=0;$.onDidAddListener=()=>{++T===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Z.print()),V?.()}}}function D($,V){return de($,()=>{},0,void 0,void 0,V)}E.defer=D;function z($){return(V,Z=null,T)=>{let M=!1,H;return H=$(A=>{if(!M)return H?H.dispose():M=!0,V.call(Z,A)},null,T),M&&H.dispose(),H}}E.once=z;function q($,V,Z){return oe((T,M=null,H)=>$(A=>T.call(M,V(A)),null,H),Z)}E.map=q;function ie($,V,Z){return oe((T,M=null,H)=>$(A=>{V(A),T.call(M,A)},null,H),Z)}E.forEach=ie;function J($,V,Z){return oe((T,M=null,H)=>$(A=>V(A)&&T.call(M,A),null,H),Z)}E.filter=J;function me($){return $}E.signal=me;function he(...$){return(V,Z=null,T)=>(0,U.combinedDisposable)(...$.map(M=>M(H=>V.call(Z,H),null,T)))}E.any=he;function fe($,V,Z,T){let M=Z;return q($,H=>(M=V(M,H),M),T)}E.reduce=fe;function oe($,V){let Z;const T={onWillAddFirstListener(){Z=$(M.fire,M)},onDidRemoveLastListener(){Z?.dispose()}};V||p(T);const M=new l(T);return V?.add(M),M.event}function de($,V,Z=100,T=!1,M,H){let A,N,O,W=0;const j={leakWarningThreshold:M,onWillAddFirstListener(){A=$(le=>{W++,N=V(N,le),T&&!O&&(ee.fire(N),N=void 0),clearTimeout(O),O=setTimeout(()=>{const ce=N;N=void 0,O=void 0,(!T||W>1)&&ee.fire(ce),W=0},Z)})},onDidRemoveLastListener(){A.dispose()}};H||p(j);const ee=new l(j);return H?.add(ee),ee.event}E.debounce=de;function Se($,V=0,Z){return E.debounce($,(T,M)=>T?(T.push(M),T):[M],V,void 0,void 0,Z)}E.accumulate=Se;function te($,V=(T,M)=>T===M,Z){let T=!0,M;return J($,H=>{const A=T||!V(H,M);return T=!1,M=H,A},Z)}E.latch=te;function Ce($,V,Z){return[E.filter($,V,Z),E.filter($,T=>!V(T),Z)]}E.split=Ce;function se($,V=!1,Z=[]){let T=Z.slice(),M=$(N=>{T?T.push(N):A.fire(N)});const H=()=>{T?.forEach(N=>A.fire(N)),T=null},A=new l({onWillAddFirstListener(){M||(M=$(N=>A.fire(N)))},onDidAddFirstListener(){T&&(V?setTimeout(H):H())},onDidRemoveLastListener(){M&&M.dispose(),M=null}});return A.event}E.buffer=se;class x{constructor(V){this.event=V,this.c=new U.DisposableStore}map(V){return new x(q(this.event,V,this.c))}forEach(V){return new x(ie(this.event,V,this.c))}filter(V){return new x(J(this.event,V,this.c))}reduce(V,Z){return new x(fe(this.event,V,Z,this.c))}latch(){return new x(te(this.event,void 0,this.c))}debounce(V,Z=100,T=!1,M){return new x(de(this.event,V,Z,T,M,this.c))}on(V,Z,T){return this.event(V,Z,T)}once(V,Z,T){return z(this.event)(V,Z,T)}dispose(){this.c.dispose()}}function ue($){return new x($)}E.chain=ue;function ne($,V,Z=T=>T){const T=(...N)=>A.fire(Z(...N)),M=()=>$.on(V,T),H=()=>$.removeListener(V,T),A=new l({onWillAddFirstListener:M,onDidRemoveLastListener:H});return A.event}E.fromNodeEventEmitter=ne;function F($,V,Z=T=>T){const T=(...N)=>A.fire(Z(...N)),M=()=>$.addEventListener(V,T),H=()=>$.removeEventListener(V,T),A=new l({onWillAddFirstListener:M,onDidRemoveLastListener:H});return A.event}E.fromDOMEventEmitter=F;function _($){return new Promise(V=>z($)(V))}E.toPromise=_;function G($,V){return V(void 0),$(Z=>V(Z))}E.runAndSubscribe=G;function P($,V){let Z=null;function T(H){Z?.dispose(),Z=new U.DisposableStore,V(H,Z)}T(void 0);const M=$(H=>T(H));return(0,U.toDisposable)(()=>{M.dispose(),Z?.dispose()})}E.runAndSubscribeWithStore=P;class b{constructor(V,Z){this.obs=V,this.c=0,this.d=!1;const T={onWillAddFirstListener:()=>{V.addObserver(this)},onDidRemoveLastListener:()=>{V.removeObserver(this)}};Z||p(T),this.emitter=new l(T),Z&&Z.add(this.emitter)}beginUpdate(V){this.c++}handleChange(V,Z){this.d=!0}endUpdate(V){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function B($,V){return new b($,V).emitter.event}E.fromObservable=B})(d=t.Event||(t.Event={}));class f{constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${f.c++}`,f.all.add(this)}start(p){this.d=new y.StopWatch(!0),this.listenerCount=p}stop(){if(this.d){const p=this.d.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.d=void 0}}}t.EventProfiling=f,f.all=new Set,f.c=0;let I=-1;function r(E){const p=I;return I=E,{dispose(){I=p}}}t.setGlobalLeakWarningThreshold=r;class n{constructor(p,D=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=D,this.d=0}dispose(){this.c?.clear()}check(p,D){const z=this.threshold;if(z<=0||D<z)return;this.c||(this.c=new Map);const q=this.c.get(p.value)||0;if(this.c.set(p.value,q+1),this.d-=1,this.d<=0){this.d=z*.5;let ie,J=0;for(const[me,he]of this.c)(!ie||J<he)&&(ie=me,J=he);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${J}):`),console.warn(ie)}return()=>{const ie=this.c.get(p.value)||0;this.c.set(p.value,ie-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class s{constructor(p,D,z){this.callback=p,this.callbackThis=D,this.stack=z,this.subscription=new U.SafeDisposable}invoke(p){this.callback.call(this.callbackThis,p)}}class l{constructor(p){this.j=!1,this.d=p,this.f=I>0||this.d?.leakWarningThreshold?new n(this.d?.leakWarningThreshold??I):void 0,this.g=this.d?._profName?new f(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(w){const p=Array.from(this.q);queueMicrotask(()=>{for(const D of p)D.subscription.isset()&&(D.subscription.unset(),D.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(p,D,z)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),U.Disposable.None;const q=this.q.isEmpty();q&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let ie,J;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(J=e.create(),ie=this.f.check(J,this.q.size+1)),w&&(J=J??e.create());const me=new s(p,D,J),he=this.q.push(me);q&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,p,D);const fe=me.subscription.set(()=>{ie?.(),this.j||(he(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return z instanceof U.DisposableStore?z.add(fe):Array.isArray(z)&&z.push(fe),fe}),this.l}fire(p){if(this.q){this.m||(this.m=new m);for(const D of this.q)this.m.push(this,D,p);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=l;class u{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(p,D,z){this.c.push(new o(p,D,z))}clear(p){const D=new R.LinkedList;for(const z of this.c)z.emitter!==p&&D.push(z);this.c=D}deliver(){for(;this.c.size>0;){const p=this.c.shift();try{p.listener.invoke(p.event)}catch(D){(0,v.onUnexpectedError)(D)}}}}t.EventDeliveryQueue=u;class m extends u{clear(p){this.c.clear()}}class o{constructor(p,D,z){this.emitter=p,this.listener=D,this.event=z}}class a extends l{async fireAsync(p,D,z){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const q of this.q)this.c.push([q,p]);for(;this.c.size>0&&!D.isCancellationRequested;){const[q,ie]=this.c.shift(),J=[],me={...ie,token:D,waitUntil:he=>{if(Object.isFrozen(J))throw new Error("waitUntil can NOT be called asynchronous");z&&(he=z(he,q.callback)),J.push(he)}};try{q.invoke(me)}catch(he){(0,v.onUnexpectedError)(he);continue}Object.freeze(J),await Promise.allSettled(J).then(he=>{for(const fe of he)fe.status==="rejected"&&(0,v.onUnexpectedError)(fe.reason)})}}}}t.AsyncEmitter=a;class g extends l{constructor(p){super(p),this.h=0,this.s=new R.LinkedList,this.t=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.t(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.q&&(this.h!==0?this.s.push(p):super.fire(p))}}t.PauseableEmitter=g;class C extends g{constructor(p){super(p),this.c=p.delay??100}fire(p){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(p)}}t.DebounceEmitter=C;class L extends l{constructor(p){super(p),this.c=[],this.h=p?.merge}fire(p){!this.hasListeners()||(this.c.push(p),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(D=>super.fire(D)),this.c=[]}))}}t.MicrotaskEmitter=L;class k{constructor(){this.d=!1,this.f=[],this.c=new l({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(p){const D={event:p,listener:null};this.f.push(D),this.d&&this.j(D);const z=()=>{this.d&&this.k(D);const q=this.f.indexOf(D);this.f.splice(q,1)};return(0,U.toDisposable)((0,i.once)(z))}g(){this.d=!0,this.f.forEach(p=>this.j(p))}h(){this.d=!1,this.f.forEach(p=>this.k(p))}j(p){p.listener=p.event(D=>this.c.fire(D))}k(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=k;class S{constructor(){this.c=[]}wrapEvent(p){return(D,z,q)=>p(ie=>{const J=this.c[this.c.length-1];J?J.push(()=>D.call(z,ie)):D.call(z,ie)},void 0,q)}bufferEvents(p){const D=[];this.c.push(D);const z=p();return this.c.pop(),D.forEach(q=>q()),z}}t.EventBufferer=S;class h{constructor(){this.c=!1,this.d=d.None,this.f=U.Disposable.None,this.g=new l({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(p){this.d=p,this.c&&(this.f.dispose(),this.f=p(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=h}),define(be[16],pe([1,0,3,2]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWCOVisible=t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class U{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new v.Emitter,this.onDidChangeFullscreen=this.d.event}getZoomLevel(){return this.a}setZoomLevel(a,g){this.a!==a&&(this.a=a)}getZoomFactor(){return this.b}setZoomFactor(a){this.b=a}setFullscreen(a){this.c!==a&&(this.c=a,this.d.fire())}isFullscreen(){return this.c}}U.INSTANCE=new U;class R extends i.Disposable{constructor(){super(),this.a=this.B(new v.Emitter),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(a){this.c?.removeEventListener("change",this.b),this.c=matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),a&&this.a.fire()}}class y extends i.Disposable{get value(){return this.b}constructor(){super(),this.a=this.B(new v.Emitter),this.onDidChange=this.a.event,this.b=this.c();const a=this.B(new R);this.B(a.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const a=document.createElement("canvas").getContext("2d"),g=window.devicePixelRatio||1,C=a.webkitBackingStorePixelRatio||a.mozBackingStorePixelRatio||a.msBackingStorePixelRatio||a.oBackingStorePixelRatio||a.backingStorePixelRatio||1;return g/C}}class w{constructor(){this.a=null}b(){return this.a||(this.a=(0,i.markAsSingleton)(new y)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function c(o,a){typeof o=="string"&&(o=window.matchMedia(o)),o.addEventListener("change",a)}t.addMatchMediaChangeListener=c,t.PixelRatio=new w;function d(o,a){U.INSTANCE.setZoomLevel(o,a)}t.setZoomLevel=d;function f(){return U.INSTANCE.getZoomLevel()}t.getZoomLevel=f;function I(){return U.INSTANCE.getZoomFactor()}t.getZoomFactor=I;function r(o){U.INSTANCE.setZoomFactor(o)}t.setZoomFactor=r;function n(o){U.INSTANCE.setFullscreen(o)}t.setFullscreen=n;function e(){return U.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=U.INSTANCE.onDidChangeFullscreen;const s=navigator.userAgent;t.isFirefox=s.indexOf("Firefox")>=0,t.isWebKit=s.indexOf("AppleWebKit")>=0,t.isChrome=s.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&s.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=s.indexOf("Electron/")>=0,t.isAndroid=s.indexOf("Android")>=0;let l=!1;if(window.matchMedia){const o=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),a=window.matchMedia("(display-mode: fullscreen)");l=o.matches,c(o,({matches:g})=>{l&&a.matches||(l=g)})}function u(){return l}t.isStandalone=u;function m(){return navigator?.windowControlsOverlay?.visible}t.isWCOVisible=m}),define(be[107],pe([1,0,16,5]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var U;(function(R){R[R.Always=0]="Always",R[R.FullScreen=1]="FullScreen",R[R.None=2]="None"})(U=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:i.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.isNative||v.isStandalone()?0:navigator.keyboard||v.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(be[18],pe([1,0,3]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class i{get event(){return this.a.event}constructor(R,y,w){const c=d=>this.a.fire(d);this.a=new v.Emitter({onWillAddFirstListener:()=>R.addEventListener(y,c,w),onDidRemoveLastListener:()=>R.removeEventListener(y,c,w)})}dispose(){this.a.dispose()}}t.DomEmitter=i}),define(be[19],pe([1,0,16,43,73,5]),function(Q,t,v,i,U,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function y(e){if(e.charCode){const l=String.fromCharCode(e.charCode).toUpperCase();return i.KeyCodeUtils.fromString(l)}const s=e.keyCode;if(s===3)return 7;if(v.isFirefox){if(s===59)return 80;if(s===107)return 81;if(s===109)return 83;if(R.isMacintosh&&s===224)return 57}else if(v.isWebKit){if(s===91)return 57;if(R.isMacintosh&&s===93)return 57;if(!R.isMacintosh&&s===92)return 57}return i.EVENT_KEY_CODE_MAP[s]||0}const w=R.isMacintosh?256:2048,c=512,d=1024,f=R.isMacintosh?2048:256;function I(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=I;function r(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${i.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=r;class n{constructor(s){this._standardKeyboardEventBrand=!0;const l=s;this.browserEvent=l,this.target=l.target,this.ctrlKey=l.ctrlKey,this.shiftKey=l.shiftKey,this.altKey=l.altKey,this.metaKey=l.metaKey,this.keyCode=y(l),this.code=l.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeybinding(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let l=0;return this.ctrlKey&&(l|=w),this.altKey&&(l|=c),this.shiftKey&&(l|=d),this.metaKey&&(l|=f),l|=s,l}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new U.SimpleKeybinding(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.StandardKeyboardEvent=n}),define(be[20],pe([1,0,16,66,5]),function(Q,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class R{constructor(d){this.timestamp=Date.now(),this.browserEvent=d,this.leftButton=d.button===0,this.middleButton=d.button===1,this.rightButton=d.button===2,this.buttons=d.buttons,this.target=d.target,this.detail=d.detail||1,d.type==="dblclick"&&(this.detail=2),this.ctrlKey=d.ctrlKey,this.shiftKey=d.shiftKey,this.altKey=d.altKey,this.metaKey=d.metaKey,typeof d.pageX=="number"?(this.posx=d.pageX,this.posy=d.pageY):(this.posx=d.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=d.clientY+document.body.scrollTop+document.documentElement.scrollTop);const f=i.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,d.view);this.posx-=f.left,this.posy-=f.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=R;class y extends R{constructor(d){super(d),this.dataTransfer=d.dataTransfer}}t.DragMouseEvent=y;class w{constructor(d,f=0,I=0){if(this.browserEvent=d||null,this.target=d?d.target||d.targetNode||d.srcElement:null,this.deltaY=I,this.deltaX=f,d){const r=d,n=d;if(typeof r.wheelDeltaY<"u")this.deltaY=r.wheelDeltaY/120;else if(typeof n.VERTICAL_AXIS<"u"&&n.axis===n.VERTICAL_AXIS)this.deltaY=-n.detail/3;else if(d.type==="wheel"){const e=d;e.deltaMode===e.DOM_DELTA_LINE?v.isFirefox&&!U.isMacintosh?this.deltaY=-d.deltaY/3:this.deltaY=-d.deltaY:this.deltaY=-d.deltaY/40}if(typeof r.wheelDeltaX<"u")v.isSafari&&U.isWindows?this.deltaX=-(r.wheelDeltaX/120):this.deltaX=r.wheelDeltaX/120;else if(typeof n.HORIZONTAL_AXIS<"u"&&n.axis===n.HORIZONTAL_AXIS)this.deltaX=-d.detail/3;else if(d.type==="wheel"){const e=d;e.deltaMode===e.DOM_DELTA_LINE?v.isFirefox&&!U.isMacintosh?this.deltaX=-d.deltaX/3:this.deltaX=-d.deltaX:this.deltaX=-d.deltaX/40}this.deltaY===0&&this.deltaX===0&&d.wheelDelta&&(this.deltaY=d.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=w}),define(be[32],pe([1,0,3,2,102]),function(Q,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class R extends i.Disposable{constructor(r,n="",e="",s=!0,l){super(),this.h=this.B(new v.Emitter),this.onDidChange=this.h.event,this.C=!0,this.j=r,this.n=n,this.w=e,this.C=s,this.F=l}get id(){return this.j}get label(){return this.n}set label(r){this.G(r)}G(r){this.n!==r&&(this.n=r,this.h.fire({label:r}))}get tooltip(){return this.u||""}set tooltip(r){this.H(r)}H(r){this.u!==r&&(this.u=r,this.h.fire({tooltip:r}))}get class(){return this.w}set class(r){this.I(r)}I(r){this.w!==r&&(this.w=r,this.h.fire({class:r}))}get enabled(){return this.C}set enabled(r){this.J(r)}J(r){this.C!==r&&(this.C=r,this.h.fire({enabled:r}))}get checked(){return this.D}set checked(r){this.L(r)}L(r){this.D!==r&&(this.D=r,this.h.fire({checked:r}))}async run(r,n){this.F&&await this.F(r)}}t.Action=R;class y extends i.Disposable{constructor(){super(...arguments),this.f=this.B(new v.Emitter),this.onWillRun=this.f.event,this.h=this.B(new v.Emitter),this.onDidRun=this.h.event}async run(r,n){if(!r.enabled)return;this.f.fire({action:r});let e;try{await this.runAction(r,n)}catch(s){e=s}this.h.fire({action:r,error:e})}async runAction(r,n){await r.run(n)}}t.ActionRunner=y;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...r){let n=[];for(const e of r)e.length&&(n.length?n=[...n,new w,...e]:n=e);return n}async run(){}}t.Separator=w,w.ID="vs.actions.separator";class c{get actions(){return this.a}constructor(r,n,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=r,this.label=n,this.class=s,this.a=e}async run(){}}t.SubmenuAction=c;class d extends R{constructor(){super(d.ID,U.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=d,d.ID="vs.actions.empty";function f(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}t.toAction=f}),define(be[28],pe([1,0,3]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const i=Object.freeze(function(w,c){const d=setTimeout(w.bind(c),0);return{dispose(){clearTimeout(d)}}});var U;(function(w){function c(d){return d===w.None||d===w.Cancelled||d instanceof R?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}w.isCancellationToken=c,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(U=t.CancellationToken||(t.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new v.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class y{constructor(c){this.a=void 0,this.b=void 0,this.b=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=U.Cancelled}dispose(c=!1){c&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=U.None}}t.CancellationTokenSource=y}),define(be[108],pe([1,0,28]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class i{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new v.CancellationTokenSource,c=this.b(w.token);return this.a={promise:c,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}t.Cache=i;class U{constructor(w){this.c=w,this.a=void 0,this.b=void 0}get(w){const c=JSON.stringify(w);return this.b!==c&&(this.b=c,this.a=this.c(w)),this.a}}t.LRUCachedFunction=U;class R{get cachedValues(){return this.a}constructor(w){this.b=w,this.a=new Map}get(w){if(this.a.has(w))return this.a.get(w);const c=this.b(w);return this.a.set(w,c),c}}t.CachedFunction=R}),define(be[49],pe([1,0,3,2]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var U;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(U=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class R{constructor(e,s,l,u,m,o,a){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,l=l|0,u=u|0,m=m|0,o=o|0,a=a|0),this.rawScrollLeft=u,this.rawScrollTop=a,s<0&&(s=0),u+s>l&&(u=l-s),u<0&&(u=0),m<0&&(m=0),a+m>o&&(a=o-m),a<0&&(a=0),this.width=s,this.scrollWidth=l,this.scrollLeft=u,this.height=m,this.scrollHeight=o,this.scrollTop=a}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new R(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new R(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const l=this.width!==e.width,u=this.scrollWidth!==e.scrollWidth,m=this.scrollLeft!==e.scrollLeft,o=this.height!==e.height,a=this.scrollHeight!==e.scrollHeight,g=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:l,scrollWidthChanged:u,scrollLeftChanged:m,heightChanged:o,scrollHeightChanged:a,scrollTopChanged:g}}}t.ScrollState=R;class y extends i.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this.i=this.B(new v.Emitter),this.onScroll=this.i.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new R(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const l=this.g.withScrollDimensions(e,s);this.k(l,Boolean(this.h)),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.k(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const l=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===l.scrollLeft&&this.h.to.scrollTop===l.scrollTop)return;let u;s?u=new f(this.h.from,l,this.h.startTime,this.h.duration):u=this.h.combine(this.g,l,this.c),this.h.dispose(),this.h=u}else{const l=this.g.withScrollPosition(e);this.h=f.start(this.g,l,this.c)}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}j(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.k(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}}k(e,s){const l=this.g;l.equals(e)||(this.g=e,this.i.fire(this.g.createScrollEvent(l,s)))}}t.Scrollable=y;class w{constructor(e,s,l){this.scrollLeft=e,this.scrollTop=s,this.isDone=l}}t.SmoothScrollingUpdate=w;function c(n,e){const s=e-n;return function(l){return n+s*r(l)}}function d(n,e,s){return function(l){return l<s?n(l/s):e((l-s)/(1-s))}}class f{constructor(e,s,l,u){this.from=e,this.to=s,this.duration=u,this.startTime=l,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,l){if(Math.abs(e-s)>2.5*l){let m,o;return e<s?(m=e+.75*l,o=s-.75*l):(m=e-.75*l,o=s+.75*l),d(c(e,m),c(o,s),.33)}return c(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const l=this.c(s),u=this.d(s);return new w(l,u,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,l){return f.start(e,s,l)}static start(e,s,l){l=l+10;const u=Date.now()-10;return new f(e,s,u,l)}}t.SmoothScrollingOperation=f;function I(n){return Math.pow(n,3)}function r(n){return 1-I(1-n)}}),define(be[11],pe([1,0,108,44]),function(Q,t,v,i){"use strict";var U;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function R(K){return!K||typeof K!="string"?!0:K.trim().length===0}t.isFalsyOrWhitespace=R;const y=/{(\d+)}/g;function w(K,...ae){return ae.length===0?K:K.replace(y,function(we,Ee){const Fe=parseInt(Ee,10);return isNaN(Fe)||Fe<0||Fe>=ae.length?we:ae[Fe]})}t.format=w;const c=/{([^}]+)}/g;function d(K,ae){return K.replace(c,(we,Ee)=>ae[Ee]??we)}t.format2=d;function f(K){return K.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}t.escape=f;function I(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=I;function r(K,ae){let we=0;const Ee=ae.charCodeAt(0);for(let Fe=K.length-1;Fe>=0;Fe--)K.charCodeAt(Fe)===Ee&&we++;return we}t.count=r;function n(K,ae,we="\u2026"){return K.length<=ae?K:`${K.substr(0,ae)}${we}`}t.truncate=n;function e(K,ae=" "){const we=s(K,ae);return l(we,ae)}t.trim=e;function s(K,ae){if(!K||!ae)return K;const we=ae.length;if(we===0||K.length===0)return K;let Ee=0;for(;K.indexOf(ae,Ee)===Ee;)Ee=Ee+we;return K.substring(Ee)}t.ltrim=s;function l(K,ae){if(!K||!ae)return K;const we=ae.length,Ee=K.length;if(we===0||Ee===0)return K;let Fe=Ee,Oe=-1;for(;Oe=K.lastIndexOf(ae,Fe-1),!(Oe===-1||Oe+we!==Fe);){if(Oe===0)return"";Fe=Oe}return K.substring(0,Fe)}t.rtrim=l;function u(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=u;function m(K){return K.replace(/\*/g,"")}t.stripWildcards=m;function o(K,ae,we={}){if(!K)throw new Error("Cannot create regex from empty string");ae||(K=I(K)),we.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Ee="";return we.global&&(Ee+="g"),we.matchCase||(Ee+="i"),we.multiline&&(Ee+="m"),we.unicode&&(Ee+="u"),new RegExp(K,Ee)}t.createRegExp=o;function a(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}t.regExpLeadsToEndlessLoop=a;function g(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=g;function C(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}t.regExpFlags=C;function L(K){return K.split(/\r\n|\r|\n/)}t.splitLines=L;function k(K){for(let ae=0,we=K.length;ae<we;ae++){const Ee=K.charCodeAt(ae);if(Ee!==32&&Ee!==9)return ae}return-1}t.firstNonWhitespaceIndex=k;function S(K,ae=0,we=K.length){for(let Ee=ae;Ee<we;Ee++){const Fe=K.charCodeAt(Ee);if(Fe!==32&&Fe!==9)return K.substring(ae,Ee)}return K.substring(ae,we)}t.getLeadingWhitespace=S;function h(K,ae=K.length-1){for(let we=ae;we>=0;we--){const Ee=K.charCodeAt(we);if(Ee!==32&&Ee!==9)return we}return-1}t.lastNonWhitespaceIndex=h;function E(K,ae,we){const Ee=[];let Fe=0;for(const Oe of K.matchAll(ae)){if(Ee.push(K.slice(Fe,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Fe=Oe.index+Oe[0].length,Ee.push(we(Oe[0],...Oe.slice(1),Oe.index,K,Oe.groups))}return Ee.push(K.slice(Fe)),Promise.all(Ee).then(Oe=>Oe.join(""))}t.replaceAsync=E;function p(K,ae){return K<ae?-1:K>ae?1:0}t.compare=p;function D(K,ae,we=0,Ee=K.length,Fe=0,Oe=ae.length){for(;we<Ee&&Fe<Oe;we++,Fe++){const Me=K.charCodeAt(we),re=ae.charCodeAt(Fe);if(Me<re)return-1;if(Me>re)return 1}const _e=Ee-we,tt=Oe-Fe;return _e<tt?-1:_e>tt?1:0}t.compareSubstring=D;function z(K,ae){return q(K,ae,0,K.length,0,ae.length)}t.compareIgnoreCase=z;function q(K,ae,we=0,Ee=K.length,Fe=0,Oe=ae.length){for(;we<Ee&&Fe<Oe;we++,Fe++){let Me=K.charCodeAt(we),re=ae.charCodeAt(Fe);if(Me===re)continue;if(Me>=128||re>=128)return D(K.toLowerCase(),ae.toLowerCase(),we,Ee,Fe,Oe);J(Me)&&(Me-=32),J(re)&&(re-=32);const Ae=Me-re;if(Ae!==0)return Ae}const _e=Ee-we,tt=Oe-Fe;return _e<tt?-1:_e>tt?1:0}t.compareSubstringIgnoreCase=q;function ie(K){return K>=48&&K<=57}t.isAsciiDigit=ie;function J(K){return K>=97&&K<=122}t.isLowerAsciiLetter=J;function me(K){return K>=65&&K<=90}t.isUpperAsciiLetter=me;function he(K,ae){return K.length===ae.length&&q(K,ae)===0}t.equalsIgnoreCase=he;function fe(K,ae){const we=ae.length;return ae.length>K.length?!1:q(K,ae,0,we)===0}t.startsWithIgnoreCase=fe;function oe(K,ae){const we=Math.min(K.length,ae.length);let Ee;for(Ee=0;Ee<we;Ee++)if(K.charCodeAt(Ee)!==ae.charCodeAt(Ee))return Ee;return we}t.commonPrefixLength=oe;function de(K,ae){const we=Math.min(K.length,ae.length);let Ee;const Fe=K.length-1,Oe=ae.length-1;for(Ee=0;Ee<we;Ee++)if(K.charCodeAt(Fe-Ee)!==ae.charCodeAt(Oe-Ee))return Ee;return we}t.commonSuffixLength=de;function Se(K){return 55296<=K&&K<=56319}t.isHighSurrogate=Se;function te(K){return 56320<=K&&K<=57343}t.isLowSurrogate=te;function Ce(K,ae){return(K-55296<<10)+(ae-56320)+65536}t.computeCodePoint=Ce;function se(K,ae,we){const Ee=K.charCodeAt(we);if(Se(Ee)&&we+1<ae){const Fe=K.charCodeAt(we+1);if(te(Fe))return Ce(Ee,Fe)}return Ee}t.getNextCodePoint=se;function x(K,ae){const we=K.charCodeAt(ae-1);if(te(we)&&ae>1){const Ee=K.charCodeAt(ae-2);if(Se(Ee))return Ce(Ee,we)}return we}class ue{get offset(){return this.e}constructor(ae,we=0){this.c=ae,this.d=ae.length,this.e=we}setOffset(ae){this.e=ae}prevCodePoint(){const ae=x(this.c,this.e);return this.e-=ae>=65536?2:1,ae}nextCodePoint(){const ae=se(this.c,this.d,this.e);return this.e+=ae>=65536?2:1,ae}eol(){return this.e>=this.d}}t.CodePointIterator=ue;class ne{get offset(){return this.c.offset}constructor(ae,we=0){this.c=new ue(ae,we)}nextGraphemeLength(){const ae=Ve.getInstance(),we=this.c,Ee=we.offset;let Fe=ae.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Oe=we.offset,_e=ae.getGraphemeBreakType(we.nextCodePoint());if(Re(Fe,_e)){we.setOffset(Oe);break}Fe=_e}return we.offset-Ee}prevGraphemeLength(){const ae=Ve.getInstance(),we=this.c,Ee=we.offset;let Fe=ae.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Oe=we.offset,_e=ae.getGraphemeBreakType(we.prevCodePoint());if(Re(_e,Fe)){we.setOffset(Oe);break}Fe=_e}return Ee-we.offset}eol(){return this.c.eol()}}t.GraphemeIterator=ne;function F(K,ae){return new ne(K,ae).nextGraphemeLength()}t.nextCharLength=F;function _(K,ae){return new ne(K,ae).prevGraphemeLength()}t.prevCharLength=_;function G(K,ae){ae>0&&te(K.charCodeAt(ae))&&ae--;const we=ae+F(K,ae);return[we-_(K,we),we]}t.getCharContainingOffset=G;function P(K){const ae=new ne(K);let we=0;for(;!ae.eol();)we++,ae.nextGraphemeLength();return we}t.charCount=P;let b;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function $(K){return b||(b=B()),b.test(K)}t.containsRTL=$;const V=/^[\t\n\r\x20-\x7E]*$/;function Z(K){return V.test(K)}t.isBasicASCII=Z,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function T(K){return t.UNUSUAL_LINE_TERMINATORS.test(K)}t.containsUnusualLineTerminators=T;function M(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}t.isFullWidthCharacter=M;function H(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}t.isEmojiImprecise=H;function A(K,ae){if(K.length<ae)return K;const we=/\b/g;let Ee=0;for(;we.test(K)&&!(K.length-we.lastIndex<ae);)Ee=we.lastIndex,we.lastIndex+=1;return K.substring(Ee).replace(/^\s/,"")}t.lcut=A;const N=/\x1B\x5B[12]?K/g,O=/\x1b\[\d+m/g,W=/\x1b\[0?m/g;function j(K){return K&&(K=K.replace(N,""),K=K.replace(O,""),K=K.replace(W,"")),K}t.removeAnsiEscapeCodes=j,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ee(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}t.startsWithUTF8BOM=ee;function le(K){return ee(K)?K.substr(1):K}t.stripUTF8BOM=le;function ce(K,ae){if(!K||!ae||K.length<ae.length)return!1;const we=ae.length,Ee=K.toLowerCase();let Fe=0,Oe=-1;for(;Fe<we;){const _e=Ee.indexOf(ae[Fe],Oe+1);if(_e<0)return!1;Oe=_e,Fe++}return!0}t.fuzzyContains=ce;function De(K,ae=!1){return K?(ae&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}t.containsUppercaseCharacter=De;function ye(K){return K.charAt(0).toUpperCase()+K.slice(1)}t.uppercaseFirstLetter=ye;function Ie(K,ae=1){if(ae===0)return"";let we=-1;do we=K.indexOf(`
`,we+1),ae--;while(ae>0&&we>=0);return we===-1?K:(K[we-1]==="\r"&&we--,K.substr(0,we))}t.getNLines=Ie;function ke(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}t.singleLetterHash=ke;function ve(K){return Ve.getInstance().getGraphemeBreakType(K)}t.getGraphemeBreakType=ve;function Re(K,ae){return K===0?ae!==5&&ae!==7:K===2&&ae===3?!1:K===4||K===2||K===3||ae===4||ae===2||ae===3?!0:!(K===8&&(ae===8||ae===9||ae===11||ae===12)||(K===11||K===9)&&(ae===9||ae===10)||(K===12||K===10)&&ae===10||ae===5||ae===13||ae===7||K===1||K===13&&ae===14||K===6&&ae===6)}var Pe;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=t.GraphemeBreakType||(t.GraphemeBreakType={}));class Ve{static getInstance(){return Ve.c||(Ve.c=new Ve),Ve.c}constructor(){this.d=Ue()}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const we=this.d,Ee=we.length/3;let Fe=1;for(;Fe<=Ee;)if(ae<we[3*Fe])Fe=2*Fe;else if(ae>we[3*Fe+1])Fe=2*Fe+1;else return we[3*Fe+2];return 0}}Ve.c=null;function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(K,ae){if(K===0)return 0;const we=xe(K,ae);if(we!==void 0)return we;const Ee=new ue(ae,K);return Ee.prevCodePoint(),Ee.offset}t.getLeftDeleteOffset=ze;function xe(K,ae){const we=new ue(ae,K);let Ee=we.prevCodePoint();for(;it(Ee)||Ee===65039||Ee===8419;){if(we.offset===0)return;Ee=we.prevCodePoint()}if(!H(Ee))return;let Fe=we.offset;return Fe>0&&we.prevCodePoint()===8205&&(Fe=we.offset),Fe}function it(K){return 127995<=K&&K<=127999}var Be;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),t.noBreakWhitespace="\xA0";class Ke{static getInstance(ae){return Ke.d.get(Array.from(ae))}static getLocales(){return Ke.e.getValue()}constructor(ae){this.f=ae}isAmbiguous(ae){return this.f.has(ae)}getPrimaryConfusable(ae){return this.f.get(ae)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.AmbiguousCharacters=Ke,U=Ke,Ke.c=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ke.d=new v.LRUCachedFunction(K=>{function ae(re){const Ae=new Map;for(let Ne=0;Ne<re.length;Ne+=2)Ae.set(re[Ne],re[Ne+1]);return Ae}function we(re,Ae){const Ne=new Map(re);for(const[We,Ge]of Ae)Ne.set(We,Ge);return Ne}function Ee(re,Ae){if(!re)return Ae;const Ne=new Map;for(const[We,Ge]of re)Ae.has(We)&&Ne.set(We,Ge);return Ne}const Fe=U.c.getValue();let Oe=K.filter(re=>!re.startsWith("_")&&re in Fe);Oe.length===0&&(Oe=["_default"]);let _e;for(const re of Oe){const Ae=ae(Fe[re]);_e=Ee(_e,Ae)}const tt=ae(Fe._common),Me=we(tt,_e);return new Ke(Me)}),Ke.e=new i.Lazy(()=>Object.keys(Ke.c.getValue()).filter(K=>!K.startsWith("_")));class Ye{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ye.c())),this.d}static isInvisibleCharacter(ae){return Ye.e().has(ae)}static get codePoints(){return Ye.e()}}t.InvisibleCharacters=Ye,Ye.d=void 0}),define(be[109],pe([1,0,21,5,11,6]),function(Q,t,v,i,U,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function y(h){return h===47||h===92}t.isPathSeparator=y;function w(h){return h.replace(/[\\/]/g,v.posix.sep)}t.toSlashes=w;function c(h){return h.indexOf("/")===-1&&(h=w(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}t.toPosixPath=c;function d(h,E=v.posix.sep){if(!h)return"";const p=h.length,D=h.charCodeAt(0);if(y(D)){if(y(h.charCodeAt(1))&&!y(h.charCodeAt(2))){let q=3;const ie=q;for(;q<p&&!y(h.charCodeAt(q));q++);if(ie!==q&&!y(h.charCodeAt(q+1))){for(q+=1;q<p;q++)if(y(h.charCodeAt(q)))return h.slice(0,q+1).replace(/[\\/]/g,E)}}return E}else if(u(D)&&h.charCodeAt(1)===58)return y(h.charCodeAt(2))?h.slice(0,2)+E:h.slice(0,2);let z=h.indexOf("://");if(z!==-1){for(z+=3;z<p;z++)if(y(h.charCodeAt(z)))return h.slice(0,z+1)}return""}t.getRoot=d;function f(h){if(!i.isWindows||!h||h.length<5)return!1;let E=h.charCodeAt(0);if(E!==92||(E=h.charCodeAt(1),E!==92))return!1;let p=2;const D=p;for(;p<h.length&&(E=h.charCodeAt(p),E!==92);p++);return!(D===p||(E=h.charCodeAt(p+1),isNaN(E)||E===92))}t.isUNC=f;const I=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,n=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(h,E=i.isWindows){const p=E?I:r;return!(!h||h.length===0||/^\s+$/.test(h)||(p.lastIndex=0,p.test(h))||E&&n.test(h)||h==="."||h===".."||E&&h[h.length-1]==="."||E&&h.length!==h.trim().length||h.length>255)}t.isValidBasename=e;function s(h,E,p){const D=h===E;return!p||D?D:!h||!E?!1:(0,U.equalsIgnoreCase)(h,E)}t.isEqual=s;function l(h,E,p,D=v.sep){if(h===E)return!0;if(!h||!E||E.length>h.length)return!1;if(p){if(!(0,U.startsWithIgnoreCase)(h,E))return!1;if(E.length===h.length)return!0;let q=E.length;return E.charAt(E.length-1)===D&&q--,h.charAt(q)===D}return E.charAt(E.length-1)!==D&&(E+=D),h.indexOf(E)===0}t.isEqualOrParent=l;function u(h){return h>=65&&h<=90||h>=97&&h<=122}t.isWindowsDriveLetter=u;function m(h,E){return i.isWindows&&h.endsWith(":")&&(h+=v.sep),(0,v.isAbsolute)(h)||(h=(0,v.join)(E,h)),h=(0,v.normalize)(h),i.isWindows?(h=(0,U.rtrim)(h,v.sep),h.endsWith(":")&&(h+=v.sep)):(h=(0,U.rtrim)(h,v.sep),h||(h=v.sep)),h}t.sanitizeFilePath=m;function o(h){const E=(0,v.normalize)(h);return i.isWindows?h.length>3?!1:a(E)&&(h.length===2||E.charCodeAt(2)===92):E===v.posix.sep}t.isRootOrDriveLetter=o;function a(h,E=i.isWindows){return E?u(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}t.hasDriveLetter=a;function g(h){return a(h)?h[0]:void 0}t.getDriveLetter=g;function C(h,E,p){return E.length>h.length?-1:h===E?0:(p&&(h=h.toLowerCase(),E=E.toLowerCase()),h.indexOf(E))}t.indexOfPath=C;function L(h){const E=h.split(":");let p,D,z;for(const q of E){const ie=Number(q);(0,R.isNumber)(ie)?D===void 0?D=ie:z===void 0&&(z=ie):p=p?[p,q].join(":"):q}if(!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:D!==void 0?D:void 0,column:z!==void 0?z:D!==void 0?1:void 0}}t.parseLineAndColumnAware=L;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function S(h,E,p=8){let D="";for(let q=0;q<p;q++)D+=k.charAt(Math.floor(Math.random()*k.length));let z;return E?z=`${E}-${D}`:z=D,h?(0,v.join)(h,z):z}t.randomPath=S}),define(be[33],pe([1,0,74,11]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function U(...O){return function(W,j){for(let ee=0,le=O.length;ee<le;ee++){const ce=O[ee](W,j);if(ce)return ce}return null}}t.or=U,t.matchesStrictPrefix=R.bind(void 0,!1),t.matchesPrefix=R.bind(void 0,!0);function R(O,W,j){if(!j||j.length<W.length)return null;let ee;return O?ee=i.startsWithIgnoreCase(j,W):ee=j.indexOf(W)===0,ee?W.length>0?[{start:0,end:W.length}]:[]:null}function y(O,W){const j=W.toLowerCase().indexOf(O.toLowerCase());return j===-1?null:[{start:j,end:j+O.length}]}t.matchesContiguousSubString=y;function w(O,W){return c(O.toLowerCase(),W.toLowerCase(),0,0)}t.matchesSubString=w;function c(O,W,j,ee){if(j===O.length)return[];if(ee===W.length)return null;if(O[j]===W[ee]){let le=null;return(le=c(O,W,j+1,ee+1))?u({start:ee,end:ee+1},le):null}return c(O,W,j,ee+1)}function d(O){return 97<=O&&O<=122}function f(O){return 65<=O&&O<=90}t.isUpper=f;function I(O){return 48<=O&&O<=57}function r(O){return O===32||O===9||O===10||O===13}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(O=>n.add(O.charCodeAt(0)));function e(O){return r(O)||n.has(O)}function s(O,W){return O===W||e(O)&&e(W)}function l(O){return d(O)||f(O)||I(O)}function u(O,W){return W.length===0?W=[O]:O.end===W[0].start?W[0].start=O.start:W.unshift(O),W}function m(O,W){for(let j=W;j<O.length;j++){const ee=O.charCodeAt(j);if(f(ee)||I(ee)||j>0&&!l(O.charCodeAt(j-1)))return j}return O.length}function o(O,W,j,ee){if(j===O.length)return[];if(ee===W.length)return null;if(O[j]!==W[ee].toLowerCase())return null;{let le=null,ce=ee+1;for(le=o(O,W,j+1,ee+1);!le&&(ce=m(W,ce))<W.length;)le=o(O,W,j+1,ce),ce++;return le===null?null:u({start:ee,end:ee+1},le)}}function a(O){let W=0,j=0,ee=0,le=0,ce=0;for(let ve=0;ve<O.length;ve++)ce=O.charCodeAt(ve),f(ce)&&W++,d(ce)&&j++,l(ce)&&ee++,I(ce)&&le++;const De=W/O.length,ye=j/O.length,Ie=ee/O.length,ke=le/O.length;return{upperPercent:De,lowerPercent:ye,alphaPercent:Ie,numericPercent:ke}}function g(O){const{upperPercent:W,lowerPercent:j}=O;return j===0&&W>.6}function C(O){const{upperPercent:W,lowerPercent:j,alphaPercent:ee,numericPercent:le}=O;return j>.2&&W<.8&&ee>.6&&le<.2}function L(O){let W=0,j=0,ee=0,le=0;for(let ce=0;ce<O.length;ce++)ee=O.charCodeAt(ce),f(ee)&&W++,d(ee)&&j++,r(ee)&&le++;return(W===0||j===0)&&le===0?O.length<=30:W<=5}function k(O,W){if(!W||(W=W.trim(),W.length===0)||!L(O)||W.length>60)return null;const j=a(W);if(!C(j)){if(!g(j))return null;W=W.toLowerCase()}let ee=null,le=0;for(O=O.toLowerCase();le<W.length&&(ee=o(O,W,0,le))===null;)le=m(W,le+1);return ee}t.matchesCamelCase=k;function S(O,W,j=!1){if(!W||W.length===0)return null;let ee=null,le=0;for(O=O.toLowerCase(),W=W.toLowerCase();le<W.length&&(ee=h(O,W,0,le,j))===null;)le=E(W,le+1);return ee}t.matchesWords=S;function h(O,W,j,ee,le){if(j===O.length)return[];if(ee===W.length)return null;if(s(O.charCodeAt(j),W.charCodeAt(ee))){let ce=null,De=ee+1;if(ce=h(O,W,j+1,ee+1,le),!le)for(;!ce&&(De=E(W,De))<W.length;)ce=h(O,W,j+1,De,le),De++;return ce?O.charCodeAt(j)!==W.charCodeAt(ee)?ce:u({start:ee,end:ee+1},ce):null}else return null}function E(O,W){for(let j=W;j<O.length;j++)if(e(O.charCodeAt(j))||j>0&&e(O.charCodeAt(j-1)))return j;return O.length}const p=U(t.matchesPrefix,k,y),D=U(t.matchesPrefix,k,w),z=new v.LRUCache(1e4);function q(O,W,j=!1){if(typeof O!="string"||typeof W!="string")return null;let ee=z.get(O);ee||(ee=new RegExp(i.convertSimple2RegExpPattern(O),"i"),z.set(O,ee));const le=ee.exec(W);return le?[{start:le.index,end:le.index+le[0].length}]:j?D(O,W):p(O,W)}t.matchesFuzzy=q;function ie(O,W){const j=V(O,O.toLowerCase(),0,W,W.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?me(j):null}t.matchesFuzzy2=ie;function J(O,W,j,ee,le,ce){const De=Math.min(13,O.length);for(;j<De;j++){const ye=V(O,W,j,ee,le,ce,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(ye)return ye}return[0,ce]}t.anyScore=J;function me(O){if(typeof O>"u")return[];const W=[],j=O[1];for(let ee=O.length-1;ee>1;ee--){const le=O[ee]+j,ce=W[W.length-1];ce&&ce.end===le?ce.end=le+1:W.push({start:le,end:le+1})}return W}t.createMatches=me;const he=128;function fe(){const O=[],W=[];for(let j=0;j<=he;j++)W[j]=0;for(let j=0;j<=he;j++)O.push(W.slice(0));return O}function oe(O){const W=[];for(let j=0;j<=O;j++)W[j]=0;return W}const de=oe(2*he),Se=oe(2*he),te=fe(),Ce=fe(),se=fe(),x=!1;function ue(O,W,j,ee,le){function ce(ye,Ie,ke=" "){for(;ye.length<Ie;)ye=ke+ye;return ye}let De=` |   |${ee.split("").map(ye=>ce(ye,3)).join("|")}
`;for(let ye=0;ye<=j;ye++)ye===0?De+=" |":De+=`${W[ye-1]}|`,De+=O[ye].slice(0,le+1).map(Ie=>ce(Ie.toString(),3)).join("|")+`
`;return De}function ne(O,W,j,ee){O=O.substr(W),j=j.substr(ee),console.log(ue(Ce,O,O.length,j,j.length)),console.log(ue(se,O,O.length,j,j.length)),console.log(ue(te,O,O.length,j,j.length))}function F(O,W){if(W<0||W>=O.length)return!1;const j=O.codePointAt(W);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(j)}}function _(O,W){if(W<0||W>=O.length)return!1;switch(O.charCodeAt(W)){case 32:case 9:return!0;default:return!1}}function G(O,W,j){return W[O]!==j[O]}function P(O,W,j,ee,le,ce,De=!1){for(;W<j&&le<ce;)O[W]===ee[le]&&(De&&(de[W]=le),W+=1),le+=1;return W===j}t.isPatternInWord=P;var b;(function(O){O[O.Diag=1]="Diag",O[O.Left=2]="Left",O[O.LeftLeft=3]="LeftLeft"})(b||(b={}));var B;(function(O){O.Default=[-100,0];function W(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}O.isDefault=W})(B=t.FuzzyScore||(t.FuzzyScore={}));class ${constructor(W,j){this.firstMatchCanBeWeak=W,this.boostFullMatch=j}}t.FuzzyScoreOptions=$,$.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function V(O,W,j,ee,le,ce,De=$.default){const ye=O.length>he?he:O.length,Ie=ee.length>he?he:ee.length;if(j>=ye||ce>=Ie||ye-j>Ie-ce||!P(W,j,ye,le,ce,Ie,!0))return;Z(ye,Ie,j,ce,W,le);let ke=1,ve=1,Re=j,Pe=ce;const Ve=[!1];for(ke=1,Re=j;Re<ye;ke++,Re++){const Be=de[Re],Ke=Se[Re],Ye=Re+1<ye?Se[Re+1]:Ie;for(ve=Be-ce+1,Pe=Be;Pe<Ye;ve++,Pe++){let K=Number.MIN_SAFE_INTEGER,ae=!1;Pe<=Ke&&(K=T(O,W,Re,j,ee,le,Pe,Ie,ce,te[ke-1][ve-1]===0,Ve));let we=0;K!==Number.MAX_SAFE_INTEGER&&(ae=!0,we=K+Ce[ke-1][ve-1]);const Ee=Pe>Be,Fe=Ee?Ce[ke][ve-1]+(te[ke][ve-1]>0?-5:0):0,Oe=Pe>Be+1&&te[ke][ve-1]>0,_e=Oe?Ce[ke][ve-2]+(te[ke][ve-2]>0?-5:0):0;if(Oe&&(!Ee||_e>=Fe)&&(!ae||_e>=we))Ce[ke][ve]=_e,se[ke][ve]=3,te[ke][ve]=0;else if(Ee&&(!ae||Fe>=we))Ce[ke][ve]=Fe,se[ke][ve]=2,te[ke][ve]=0;else if(ae)Ce[ke][ve]=we,se[ke][ve]=1,te[ke][ve]=te[ke-1][ve-1]+1;else throw new Error("not possible")}}if(x&&ne(O,j,ee,ce),!Ve[0]&&!De.firstMatchCanBeWeak)return;ke--,ve--;const Ue=[Ce[ke][ve],ce];let ze=0,xe=0;for(;ke>=1;){let Be=ve;do{const Ke=se[ke][Be];if(Ke===3)Be=Be-2;else if(Ke===2)Be=Be-1;else break}while(Be>=1);ze>1&&W[j+ke-1]===le[ce+ve-1]&&!G(Be+ce-1,ee,le)&&ze+1>te[ke][Be]&&(Be=ve),Be===ve?ze++:ze=1,xe||(xe=Be),ke--,ve=Be-1,Ue.push(ve)}Ie===ye&&De.boostFullMatch&&(Ue[0]+=2);const it=xe-ye;return Ue[0]-=it,Ue}t.fuzzyScore=V;function Z(O,W,j,ee,le,ce){let De=O-1,ye=W-1;for(;De>=j&&ye>=ee;)le[De]===ce[ye]&&(Se[De]=ye,De--),ye--}function T(O,W,j,ee,le,ce,De,ye,Ie,ke,ve){if(W[j]!==ce[De])return Number.MIN_SAFE_INTEGER;let Re=1,Pe=!1;return De===j-ee?Re=O[j]===le[De]?7:5:G(De,le,ce)&&(De===0||!G(De-1,le,ce))?(Re=O[j]===le[De]?7:5,Pe=!0):F(ce,De)&&(De===0||!F(ce,De-1))?Re=5:(F(ce,De-1)||_(ce,De-1))&&(Re=5,Pe=!0),Re>1&&j===ee&&(ve[0]=!0),Pe||(Pe=G(De,le,ce)||F(ce,De-1)||_(ce,De-1)),j===ee?De>Ie&&(Re-=Pe?3:5):ke?Re+=Pe?2:0:Re+=Pe?0:1,De+1===ye&&(Re-=Pe?3:5),Re}function M(O,W,j,ee,le,ce,De){return A(O,W,j,ee,le,ce,!0,De)}t.fuzzyScoreGracefulAggressive=M;function H(O,W,j,ee,le,ce,De){return A(O,W,j,ee,le,ce,!1,De)}t.fuzzyScoreGraceful=H;function A(O,W,j,ee,le,ce,De,ye){let Ie=V(O,W,j,ee,le,ce,ye);if(Ie&&!De)return Ie;if(O.length>=3){const ke=Math.min(7,O.length-1);for(let ve=j+1;ve<ke;ve++){const Re=N(O,ve);if(Re){const Pe=V(Re,Re.toLowerCase(),j,ee,le,ce,ye);Pe&&(Pe[0]-=3,(!Ie||Pe[0]>Ie[0])&&(Ie=Pe))}}}return Ie}function N(O,W){if(W+1>=O.length)return;const j=O[W],ee=O[W+1];if(j!==ee)return O.slice(0,W)+ee+j+O.slice(W+2)}}),define(be[110],pe([1,0,11]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function i(u){return U(u,0)}t.hash=i;function U(u,m){switch(typeof u){case"object":return u===null?R(349,m):Array.isArray(u)?c(u,m):d(u,m);case"string":return w(u,m);case"boolean":return y(u,m);case"number":return R(u,m);case"undefined":return R(937,m);default:return R(617,m)}}t.doHash=U;function R(u,m){return(m<<5)-m+u|0}t.numberHash=R;function y(u,m){return R(u?433:863,m)}function w(u,m){m=R(149417,m);for(let o=0,a=u.length;o<a;o++)m=R(u.charCodeAt(o),m);return m}t.stringHash=w;function c(u,m){return m=R(104579,m),u.reduce((o,a)=>U(a,o),m)}function d(u,m){return m=R(181387,m),Object.keys(u).sort().reduce((o,a)=>(o=w(a,o),U(u[a],o)),m)}class f{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=U(m,this.g),this.g}}t.Hasher=f;var I;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function r(u,m,o=32){const a=o-m,g=~((1<<a)-1);return(u<<m|(g&u)>>>a)>>>0}function n(u,m=0,o=u.byteLength,a=0){for(let g=0;g<o;g++)u[m+g]=a}function e(u,m,o="0"){for(;u.length<m;)u=o+u;return u}function s(u,m=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(o=>o.toString(16).padStart(2,"0")).join(""):e((u>>>0).toString(16),m/4)}t.toHexString=s;class l{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const o=m.length;if(o===0)return;const a=this.p;let g=this.r,C=this.u,L,k;for(C!==0?(L=C,k=-1,C=0):(L=m.charCodeAt(0),k=0);;){let S=L;if(v.isHighSurrogate(L))if(k+1<o){const h=m.charCodeAt(k+1);v.isLowSurrogate(h)?(k++,S=v.computeCodePoint(L,h)):S=65533}else{C=L;break}else v.isLowSurrogate(L)&&(S=65533);if(g=this.w(a,g,S),k++,k<o)L=m.charCodeAt(k);else break}this.r=g,this.u=C}w(m,o,a){return a<128?m[o++]=a:a<2048?(m[o++]=192|(a&1984)>>>6,m[o++]=128|(a&63)>>>0):a<65536?(m[o++]=224|(a&61440)>>>12,m[o++]=128|(a&4032)>>>6,m[o++]=128|(a&63)>>>0):(m[o++]=240|(a&1835008)>>>18,m[o++]=128|(a&258048)>>>12,m[o++]=128|(a&4032)>>>6,m[o++]=128|(a&63)>>>0),o>=64&&(this.y(),o-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),o}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,n(this.p,this.r),this.r>56&&(this.y(),n(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=l.g,o=this.q;for(let p=0;p<64;p+=4)m.setUint32(p,o.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)m.setUint32(p,r(m.getUint32(p-12,!1)^m.getUint32(p-32,!1)^m.getUint32(p-56,!1)^m.getUint32(p-64,!1),1),!1);let a=this.h,g=this.l,C=this.m,L=this.n,k=this.o,S,h,E;for(let p=0;p<80;p++)p<20?(S=g&C|~g&L,h=1518500249):p<40?(S=g^C^L,h=1859775393):p<60?(S=g&C|g&L|C&L,h=2400959708):(S=g^C^L,h=3395469782),E=r(a,5)+S+k+h+m.getUint32(p*4,!1)&4294967295,k=L,L=C,C=r(g,30),g=a,a=E;this.h=this.h+a&4294967295,this.l=this.l+g&4294967295,this.m=this.m+C&4294967295,this.n=this.n+L&4294967295,this.o=this.o+k&4294967295}}t.StringSHA1=l,l.g=new DataView(new ArrayBuffer(320))}),define(be[111],pe([1,0,70,110]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class U{constructor(r){this.a=r}getElements(){const r=this.a,n=new Int32Array(r.length);for(let e=0,s=r.length;e<s;e++)n[e]=r.charCodeAt(e);return n}}t.StringDiffSequence=U;function R(I,r,n){return new f(new U(I),new U(r)).ComputeDiff(n).changes}t.stringDiff=R;class y{static Assert(r,n){if(!r)throw new Error(n)}}class w{static Copy(r,n,e,s,l){for(let u=0;u<l;u++)e[s+u]=r[n+u]}static Copy2(r,n,e,s,l){for(let u=0;u<l;u++)e[s+u]=r[n+u]}}var c;(function(I){I[I.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(c||(c={}));class d{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new v.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(r,n){this.b=Math.min(this.b,r),this.c=Math.min(this.c,n),this.d++}AddModifiedElement(r,n){this.b=Math.min(this.b,r),this.c=Math.min(this.c,n),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class f{constructor(r,n,e=null){this.a=e,this.b=r,this.c=n;const[s,l,u]=f.o(r),[m,o,a]=f.o(n);this.d=u&&a,this.e=s,this.f=l,this.g=m,this.h=o,this.k=[],this.m=[]}static n(r){return r.length>0&&typeof r[0]=="string"}static o(r){const n=r.getElements();if(f.n(n)){const e=new Int32Array(n.length);for(let s=0,l=n.length;s<l;s++)e[s]=(0,i.stringHash)(n[s],0);return[n,e,!0]}return n instanceof Int32Array?[[],n,!1]:[[],new Int32Array(n),!1]}p(r,n){return this.f[r]!==this.h[n]?!1:this.d?this.e[r]===this.g[n]:!0}q(r,n){if(!this.p(r,n))return!1;const e=f.r(this.b,r),s=f.r(this.c,n);return e===s}static r(r,n){return typeof r.getStrictElement=="function"?r.getStrictElement(n):null}s(r,n){return this.f[r]!==this.f[n]?!1:this.d?this.e[r]===this.e[n]:!0}u(r,n){return this.h[r]!==this.h[n]?!1:this.d?this.g[r]===this.g[n]:!0}ComputeDiff(r){return this.v(0,this.f.length-1,0,this.h.length-1,r)}v(r,n,e,s,l){const u=[!1];let m=this.w(r,n,e,s,u);return l&&(m=this.A(m)),{quitEarly:u[0],changes:m}}w(r,n,e,s,l){for(l[0]=!1;r<=n&&e<=s&&this.p(r,e);)r++,e++;for(;n>=r&&s>=e&&this.p(n,s);)n--,s--;if(r>n||e>s){let C;return e<=s?(y.Assert(r===n+1,"originalStart should only be one more than originalEnd"),C=[new v.DiffChange(r,0,e,s-e+1)]):r<=n?(y.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),C=[new v.DiffChange(r,n-r+1,e,0)]):(y.Assert(r===n+1,"originalStart should only be one more than originalEnd"),y.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),C=[]),C}const u=[0],m=[0],o=this.y(r,n,e,s,u,m,l),a=u[0],g=m[0];if(o!==null)return o;if(!l[0]){const C=this.w(r,a,e,g,l);let L=[];return l[0]?L=[new v.DiffChange(a+1,n-(a+1)+1,g+1,s-(g+1)+1)]:L=this.w(a+1,n,g+1,s,l),this.I(C,L)}return[new v.DiffChange(r,n-r+1,e,s-e+1)]}x(r,n,e,s,l,u,m,o,a,g,C,L,k,S,h,E,p,D){let z=null,q=null,ie=new d,J=n,me=e,he=k[0]-E[0]-s,fe=-1073741824,oe=this.k.length-1;do{const de=he+r;de===J||de<me&&a[de-1]<a[de+1]?(C=a[de+1],S=C-he-s,C<fe&&ie.MarkNextChange(),fe=C,ie.AddModifiedElement(C+1,S),he=de+1-r):(C=a[de-1]+1,S=C-he-s,C<fe&&ie.MarkNextChange(),fe=C-1,ie.AddOriginalElement(C,S+1),he=de-1-r),oe>=0&&(a=this.k[oe],r=a[0],J=1,me=a.length-1)}while(--oe>=-1);if(z=ie.getReverseChanges(),D[0]){let de=k[0]+1,Se=E[0]+1;if(z!==null&&z.length>0){const te=z[z.length-1];de=Math.max(de,te.getOriginalEnd()),Se=Math.max(Se,te.getModifiedEnd())}q=[new v.DiffChange(de,L-de+1,Se,h-Se+1)]}else{ie=new d,J=u,me=m,he=k[0]-E[0]-o,fe=1073741824,oe=p?this.m.length-1:this.m.length-2;do{const de=he+l;de===J||de<me&&g[de-1]>=g[de+1]?(C=g[de+1]-1,S=C-he-o,C>fe&&ie.MarkNextChange(),fe=C+1,ie.AddOriginalElement(C+1,S+1),he=de+1-l):(C=g[de-1],S=C-he-o,C>fe&&ie.MarkNextChange(),fe=C,ie.AddModifiedElement(C+1,S+1),he=de-1-l),oe>=0&&(g=this.m[oe],l=g[0],J=1,me=g.length-1)}while(--oe>=-1);q=ie.getChanges()}return this.I(z,q)}y(r,n,e,s,l,u,m){let o=0,a=0,g=0,C=0,L=0,k=0;r--,e--,l[0]=0,u[0]=0,this.k=[],this.m=[];const S=n-r+(s-e),h=S+1,E=new Int32Array(h),p=new Int32Array(h),D=s-e,z=n-r,q=r-e,ie=n-s,me=(z-D)%2===0;E[D]=r,p[z]=n,m[0]=!1;for(let he=1;he<=S/2+1;he++){let fe=0,oe=0;g=this.K(D-he,he,D,h),C=this.K(D+he,he,D,h);for(let Se=g;Se<=C;Se+=2){Se===g||Se<C&&E[Se-1]<E[Se+1]?o=E[Se+1]:o=E[Se-1]+1,a=o-(Se-D)-q;const te=o;for(;o<n&&a<s&&this.p(o+1,a+1);)o++,a++;if(E[Se]=o,o+a>fe+oe&&(fe=o,oe=a),!me&&Math.abs(Se-z)<=he-1&&o>=p[Se])return l[0]=o,u[0]=a,te<=p[Se]&&1447>0&&he<=1447+1?this.x(D,g,C,q,z,L,k,ie,E,p,o,n,l,a,s,u,me,m):null}const de=(fe-r+(oe-e)-he)/2;if(this.a!==null&&!this.a(fe,de))return m[0]=!0,l[0]=fe,u[0]=oe,de>0&&1447>0&&he<=1447+1?this.x(D,g,C,q,z,L,k,ie,E,p,o,n,l,a,s,u,me,m):(r++,e++,[new v.DiffChange(r,n-r+1,e,s-e+1)]);L=this.K(z-he,he,z,h),k=this.K(z+he,he,z,h);for(let Se=L;Se<=k;Se+=2){Se===L||Se<k&&p[Se-1]>=p[Se+1]?o=p[Se+1]-1:o=p[Se-1],a=o-(Se-z)-ie;const te=o;for(;o>r&&a>e&&this.p(o,a);)o--,a--;if(p[Se]=o,me&&Math.abs(Se-D)<=he&&o<=E[Se])return l[0]=o,u[0]=a,te>=E[Se]&&1447>0&&he<=1447+1?this.x(D,g,C,q,z,L,k,ie,E,p,o,n,l,a,s,u,me,m):null}if(he<=1447){let Se=new Int32Array(C-g+2);Se[0]=D-g+1,w.Copy2(E,g,Se,1,C-g+1),this.k.push(Se),Se=new Int32Array(k-L+2),Se[0]=z-L+1,w.Copy2(p,L,Se,1,k-L+1),this.m.push(Se)}}return this.x(D,g,C,q,z,L,k,ie,E,p,o,n,l,a,s,u,me,m)}A(r){for(let n=0;n<r.length;n++){const e=r[n],s=n<r.length-1?r[n+1].originalStart:this.f.length,l=n<r.length-1?r[n+1].modifiedStart:this.h.length,u=e.originalLength>0,m=e.modifiedLength>0;for(;e.originalStart+e.originalLength<s&&e.modifiedStart+e.modifiedLength<l&&(!u||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!m||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const a=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!a)break;e.originalStart++,e.modifiedStart++}const o=[null];if(n<r.length-1&&this.J(r[n],r[n+1],o)){r[n]=o[0],r.splice(n+1,1),n--;continue}}for(let n=r.length-1;n>=0;n--){const e=r[n];let s=0,l=0;if(n>0){const C=r[n-1];s=C.originalStart+C.originalLength,l=C.modifiedStart+C.modifiedLength}const u=e.originalLength>0,m=e.modifiedLength>0;let o=0,a=this.H(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let C=1;;C++){const L=e.originalStart-C,k=e.modifiedStart-C;if(L<s||k<l||u&&!this.s(L,L+e.originalLength)||m&&!this.u(k,k+e.modifiedLength))break;const h=(L===s&&k===l?5:0)+this.H(L,e.originalLength,k,e.modifiedLength);h>a&&(a=h,o=C)}e.originalStart-=o,e.modifiedStart-=o;const g=[null];if(n>0&&this.J(r[n-1],r[n],g)){r[n-1]=g[0],r.splice(n,1),n++;continue}}if(this.d)for(let n=1,e=r.length;n<e;n++){const s=r[n-1],l=r[n],u=l.originalStart-s.originalStart-s.originalLength,m=s.originalStart,o=l.originalStart+l.originalLength,a=o-m,g=s.modifiedStart,C=l.modifiedStart+l.modifiedLength,L=C-g;if(u<5&&a<20&&L<20){const k=this.B(m,a,g,L,u);if(k){const[S,h]=k;(S!==s.originalStart+s.originalLength||h!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=S-s.originalStart,s.modifiedLength=h-s.modifiedStart,l.originalStart=S+u,l.modifiedStart=h+u,l.originalLength=o-l.originalStart,l.modifiedLength=C-l.modifiedStart)}}}return r}B(r,n,e,s,l){if(n<l||s<l)return null;const u=r+n-l+1,m=e+s-l+1;let o=0,a=0,g=0;for(let C=r;C<u;C++)for(let L=e;L<m;L++){const k=this.C(C,L,l);k>0&&k>o&&(o=k,a=C,g=L)}return o>0?[a,g]:null}C(r,n,e){let s=0;for(let l=0;l<e;l++){if(!this.p(r+l,n+l))return 0;s+=this.e[r+l].length}return s}D(r){return r<=0||r>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[r])}E(r,n){if(this.D(r)||this.D(r-1))return!0;if(n>0){const e=r+n;if(this.D(e-1)||this.D(e))return!0}return!1}F(r){return r<=0||r>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[r])}G(r,n){if(this.F(r)||this.F(r-1))return!0;if(n>0){const e=r+n;if(this.F(e-1)||this.F(e))return!0}return!1}H(r,n,e,s){const l=this.E(r,n)?1:0,u=this.G(e,s)?1:0;return l+u}I(r,n){const e=[];if(r.length===0||n.length===0)return n.length>0?n:r;if(this.J(r[r.length-1],n[0],e)){const s=new Array(r.length+n.length-1);return w.Copy(r,0,s,0,r.length-1),s[r.length-1]=e[0],w.Copy(n,1,s,r.length,n.length-1),s}else{const s=new Array(r.length+n.length);return w.Copy(r,0,s,0,r.length),w.Copy(n,0,s,r.length,n.length),s}}J(r,n,e){if(y.Assert(r.originalStart<=n.originalStart,"Left change is not less than or equal to right change"),y.Assert(r.modifiedStart<=n.modifiedStart,"Left change is not less than or equal to right change"),r.originalStart+r.originalLength>=n.originalStart||r.modifiedStart+r.modifiedLength>=n.modifiedStart){const s=r.originalStart;let l=r.originalLength;const u=r.modifiedStart;let m=r.modifiedLength;return r.originalStart+r.originalLength>=n.originalStart&&(l=n.originalStart+n.originalLength-r.originalStart),r.modifiedStart+r.modifiedLength>=n.modifiedStart&&(m=n.modifiedStart+n.modifiedLength-r.modifiedStart),e[0]=new v.DiffChange(s,l,u,m),!0}else return e[0]=null,!1}K(r,n,e,s){if(r>=0&&r<s)return r;const l=e,u=s-e-1,m=n%2===0;if(r<0){const o=l%2===0;return m===o?0:1}else{const o=u%2===0;return m===o?s-1:s-2}}}t.LcsDiff=f}),define(be[34],pe([1,0,12,33,11]),function(Q,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=void 0;const R="$(",y=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(v.CSSIcon.iconNameCharacter),c=new RegExp(`(\\\\)?${y.source}`,"g");function d(u){return u.replace(c,(m,o)=>o?m:`\\${m}`)}t.escapeIcons=d;const f=new RegExp(`\\\\${y.source}`,"g");function I(u){return u.replace(f,m=>`\\${m}`)}t.markdownEscapeEscapedIcons=I;const r=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function n(u){return u.indexOf(R)===-1?u:u.replace(r,(m,o,a,g)=>a?m:o||g||"")}t.stripIcons=n;function e(u){const m=u.indexOf(R);return m===-1?{text:u}:s(u,m)}t.parseLabelWithIcons=e;function s(u,m){const o=[];let a="";function g(D){if(D){a+=D;for(const z of D)o.push(k)}}let C=-1,L="",k=0,S,h,E=m;const p=u.length;for(g(u.substr(0,m));E<p;)S=u[E],h=u[E+1],S===R[0]&&h===R[1]?(C=E,g(L),L=R,E++):S===")"&&C!==-1?(k+=E-C+1,C=-1,L=""):C!==-1?w.test(S)?L+=S:(g(L),C=-1,L=""):g(S),E++;return g(L),{text:a,iconOffsets:o}}function l(u,m,o=!1){const{text:a,iconOffsets:g}=m;if(!g||g.length===0)return(0,i.matchesFuzzy)(u,a,o);const C=(0,U.ltrim)(a," "),L=a.length-C.length,k=(0,i.matchesFuzzy)(u,C,o);if(k)for(const S of k){const h=g[S.start+L]+L;S.start+=h,S.end+=h}return k}t.matchesFuzzyIconAware=l}),define(be[112],pe([1,0,14,11]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class U{constructor(){this.b="",this.c=0}reset(n){return this.b=n,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(n){const e=n.charCodeAt(0),s=this.b.charCodeAt(this.c);return e-s}value(){return this.b[this.c]}}t.StringIterator=U;class R{constructor(n=!0){this.e=n}reset(n){return this.b=n,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let n=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(n)this.c++;else break;else n=!1;return this}cmp(n){return this.e?(0,i.compareSubstring)(n,this.b,0,n.length,this.c,this.d):(0,i.compareSubstringIgnoreCase)(n,this.b,0,n.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.ConfigKeysIterator=R;class y{constructor(n=!0,e=!0){this.f=n,this.g=e}reset(n){this.d=0,this.e=0,this.b=n,this.c=n.length;for(let e=n.length-1;e>=0;e--,this.c--){const s=this.b.charCodeAt(e);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let n=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(n)this.d++;else break;else n=!1}return this}cmp(n){return this.g?(0,i.compareSubstring)(n,this.b,0,n.length,this.d,this.e):(0,i.compareSubstringIgnoreCase)(n,this.b,0,n.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.PathIterator=y;var w;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(w||(w={}));class c{constructor(n,e){this.f=n,this.g=e,this.d=[],this.e=0}reset(n){return this.c=n,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new y(!1,!this.f(n)),this.b.reset(n.path),this.b.value()&&this.d.push(3)),this.g(n)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(n){if(this.d[this.e]===1)return(0,i.compareIgnoreCase)(n,this.c.scheme);if(this.d[this.e]===2)return(0,i.compareIgnoreCase)(n,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(n);if(this.d[this.e]===4)return(0,i.compare)(n,this.c.query);if(this.d[this.e]===5)return(0,i.compare)(n,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.UriIterator=c;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(f||(f={}));class I{static forUris(n=()=>!1,e=()=>!1){return new I(new c(n,e))}static forPaths(n=!1){return new I(new y(void 0,!n))}static forStrings(){return new I(new U)}static forConfigKeys(){return new I(new R)}constructor(n){this.b=n}clear(){this.c=void 0}fill(n,e){if(e){const s=e.slice(0);(0,v.shuffle)(s);for(const l of s)this.set(l,n)}else{const s=n.slice(0);(0,v.shuffle)(s);for(const l of s)this.set(l[0],l[1])}}set(n,e){const s=this.b.reset(n);let l;this.c||(this.c=new d,this.c.segment=s.value());const u=[];for(l=this.c;;){const o=s.cmp(l.segment);if(o>0)l.left||(l.left=new d,l.left.segment=s.value()),u.push([-1,l]),l=l.left;else if(o<0)l.right||(l.right=new d,l.right.segment=s.value()),u.push([1,l]),l=l.right;else if(s.hasNext())s.next(),l.mid||(l.mid=new d,l.mid.segment=s.value()),u.push([0,l]),l=l.mid;else break}const m=l.value;l.value=e,l.key=n;for(let o=u.length-1;o>=0;o--){const a=u[o][1];a.updateHeight();const g=a.balanceFactor();if(g<-1||g>1){const C=u[o][0],L=u[o+1][0];if(C===1&&L===1)u[o][1]=a.rotateLeft();else if(C===-1&&L===-1)u[o][1]=a.rotateRight();else if(C===1&&L===-1)a.right=u[o+1][1]=u[o+1][1].rotateRight(),u[o][1]=a.rotateLeft();else if(C===-1&&L===1)a.left=u[o+1][1]=u[o+1][1].rotateLeft(),u[o][1]=a.rotateRight();else throw new Error;if(o>0)switch(u[o-1][0]){case-1:u[o-1][1].left=u[o][1];break;case 1:u[o-1][1].right=u[o][1];break;case 0:u[o-1][1].mid=u[o][1];break}else this.c=u[0][1]}}return m}get(n){return this.d(n)?.value}d(n){const e=this.b.reset(n);let s=this.c;for(;s;){const l=e.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else break}return s}has(n){const e=this.d(n);return!(e?.value===void 0&&e?.mid===void 0)}delete(n){return this.e(n,!1)}deleteSuperstr(n){return this.e(n,!0)}e(n,e){const s=this.b.reset(n),l=[];let u=this.c;for(;u;){const m=s.cmp(u.segment);if(m>0)l.push([-1,u]),u=u.left;else if(m<0)l.push([1,u]),u=u.right;else if(s.hasNext())s.next(),l.push([0,u]),u=u.mid;else break}if(!!u){if(e?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const m=this.f(u.right);if(m.key){const{key:o,value:a,segment:g}=m;this.e(m.key,!1),u.key=o,u.value=a,u.segment=g}}else{const m=u.left??u.right;if(l.length>0){const[o,a]=l[l.length-1];switch(o){case-1:a.left=m;break;case 0:a.mid=m;break;case 1:a.right=m;break}}else this.c=m}for(let m=l.length-1;m>=0;m--){const o=l[m][1];o.updateHeight();const a=o.balanceFactor();if(a>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),l[m][1]=o.rotateLeft()):a<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),l[m][1]=o.rotateRight()),m>0)switch(l[m-1][0]){case-1:l[m-1][1].left=l[m][1];break;case 1:l[m-1][1].right=l[m][1];break;case 0:l[m-1][1].mid=l[m][1];break}else this.c=l[0][1]}}}f(n){for(;n.left;)n=n.left;return n}findSubstr(n){const e=this.b.reset(n);let s=this.c,l;for(;s;){const u=e.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(e.hasNext())e.next(),l=s.value||l,s=s.mid;else break}return s&&s.value||l}findSuperstr(n){const e=this.b.reset(n);let s=this.c;for(;s;){const l=e.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else return s.mid?this.g(s.mid):void 0}}forEach(n){for(const[e,s]of this)n(s,e)}*[Symbol.iterator](){yield*this.g(this.c)}g(n){const e=[];return this.h(n,e),e[Symbol.iterator]()}h(n,e){!n||(n.left&&this.h(n.left,e),n.value&&e.push([n.key,n.value]),n.mid&&this.h(n.mid,e),n.right&&this.h(n.right,e))}_isBalanced(){const n=e=>{if(!e)return!0;const s=e.balanceFactor();return s<-1||s>1?!1:n(e.left)&&n(e.right)};return n(this.c)}}t.TernarySearchTree=I}),define(be[15],pe([1,0,21,5]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const U=/^\w[\w\d+.-]*$/,R=/^\//,y=/^\/\//;function w(k,S){if(!k.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${k.authority}", path: "${k.path}", query: "${k.query}", fragment: "${k.fragment}"}`);if(k.scheme&&!U.test(k.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(k.path){if(k.authority){if(!R.test(k.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(k.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(k,S){return!k&&!S?"file":k}function d(k,S){switch(k){case"https":case"http":case"file":S?S[0]!==I&&(S=I+S):S=I;break}return S}const f="",I="/",r=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class n{static isUri(S){return S instanceof n?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,h,E,p,D,z=!1){typeof S=="object"?(this.scheme=S.scheme||f,this.authority=S.authority||f,this.path=S.path||f,this.query=S.query||f,this.fragment=S.fragment||f):(this.scheme=c(S,z),this.authority=h||f,this.path=d(this.scheme,E||f),this.query=p||f,this.fragment=D||f,w(this,z))}get fsPath(){return o(this,!1)}with(S){if(!S)return this;let{scheme:h,authority:E,path:p,query:D,fragment:z}=S;return h===void 0?h=this.scheme:h===null&&(h=f),E===void 0?E=this.authority:E===null&&(E=f),p===void 0?p=this.path:p===null&&(p=f),D===void 0?D=this.query:D===null&&(D=f),z===void 0?z=this.fragment:z===null&&(z=f),h===this.scheme&&E===this.authority&&p===this.path&&D===this.query&&z===this.fragment?this:new s(h,E,p,D,z)}static parse(S,h=!1){const E=r.exec(S);return E?new s(E[2]||f,L(E[4]||f),L(E[5]||f),L(E[7]||f),L(E[9]||f),h):new s(f,f,f,f,f)}static file(S){let h=f;if(i.isWindows&&(S=S.replace(/\\/g,I)),S[0]===I&&S[1]===I){const E=S.indexOf(I,2);E===-1?(h=S.substring(2),S=I):(h=S.substring(2,E),S=S.substring(E)||I)}return new s("file",h,S,f,f)}static from(S){const h=new s(S.scheme,S.authority,S.path,S.query,S.fragment);return w(h,!0),h}static joinPath(S,...h){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return i.isWindows&&S.scheme==="file"?E=n.file(v.win32.join(o(S,!0),...h)).path:E=v.posix.join(S.path,...h),S.with({path:E})}toString(S=!1){return a(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof n)return S;{const h=new s(S);return h._formatted=S.external,h._fsPath=S._sep===e?S.fsPath:null,h}}else return S}}t.URI=n;const e=i.isWindows?1:void 0;class s extends n{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(S=!1){return S?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const S={$mid:1};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=e),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const l={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(k,S){let h,E=-1;for(let p=0;p<k.length;p++){const D=k.charCodeAt(p);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||S&&D===47)E!==-1&&(h+=encodeURIComponent(k.substring(E,p)),E=-1),h!==void 0&&(h+=k.charAt(p));else{h===void 0&&(h=k.substr(0,p));const z=l[D];z!==void 0?(E!==-1&&(h+=encodeURIComponent(k.substring(E,p)),E=-1),h+=z):E===-1&&(E=p)}}return E!==-1&&(h+=encodeURIComponent(k.substring(E))),h!==void 0?h:k}function m(k){let S;for(let h=0;h<k.length;h++){const E=k.charCodeAt(h);E===35||E===63?(S===void 0&&(S=k.substr(0,h)),S+=l[E]):S!==void 0&&(S+=k[h])}return S!==void 0?S:k}function o(k,S){let h;return k.authority&&k.path.length>1&&k.scheme==="file"?h=`//${k.authority}${k.path}`:k.path.charCodeAt(0)===47&&(k.path.charCodeAt(1)>=65&&k.path.charCodeAt(1)<=90||k.path.charCodeAt(1)>=97&&k.path.charCodeAt(1)<=122)&&k.path.charCodeAt(2)===58?S?h=k.path.substr(1):h=k.path[1].toLowerCase()+k.path.substr(2):h=k.path,i.isWindows&&(h=h.replace(/\//g,"\\")),h}t.uriToFsPath=o;function a(k,S){const h=S?m:u;let E="",{scheme:p,authority:D,path:z,query:q,fragment:ie}=k;if(p&&(E+=p,E+=":"),(D||p==="file")&&(E+=I,E+=I),D){let J=D.indexOf("@");if(J!==-1){const me=D.substr(0,J);D=D.substr(J+1),J=me.indexOf(":"),J===-1?E+=h(me,!1):(E+=h(me.substr(0,J),!1),E+=":",E+=h(me.substr(J+1),!1)),E+="@"}D=D.toLowerCase(),J=D.indexOf(":"),J===-1?E+=h(D,!1):(E+=h(D.substr(0,J),!1),E+=D.substr(J))}if(z){if(z.length>=3&&z.charCodeAt(0)===47&&z.charCodeAt(2)===58){const J=z.charCodeAt(1);J>=65&&J<=90&&(z=`/${String.fromCharCode(J+32)}:${z.substr(3)}`)}else if(z.length>=2&&z.charCodeAt(1)===58){const J=z.charCodeAt(0);J>=65&&J<=90&&(z=`${String.fromCharCode(J+32)}:${z.substr(2)}`)}E+=h(z,!0)}return q&&(E+="?",E+=h(q,!1)),ie&&(E+="#",E+=S?ie:u(ie,!1)),E}function g(k){try{return decodeURIComponent(k)}catch{return k.length>3?k.substr(0,3)+g(k.substr(3)):k}}const C=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(k){return k.match(C)?k.replace(C,S=>g(S)):k}}),define(be[50],pe([1,0,31,11,15]),function(Q,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function R(d){return JSON.stringify(d,w)}t.stringify=R;function y(d){let f=JSON.parse(d);return f=c(f),f}t.parse=y;function w(d,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:(0,i.regExpFlags)(f)}:f}function c(d,f=0){if(!d||f>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return U.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 15:return new Date(d.source)}if(d instanceof v.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let I=0;I<d.length;++I)d[I]=c(d[I],f+1);else for(const I in d)Object.hasOwnProperty.call(d,I)&&(d[I]=c(d[I],f+1))}return d}t.revive=c}),define(be[35],pe([1,0,5,15]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var U;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebook="vscode-notebook",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractive="vscode-interactive",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm"})(U=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${U.vscodeRemoteResource}`}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d){this.f=`${d}/${U.vscodeRemoteResource}`}set(d,f,I){this.a[d]=f,this.b[d]=I}setConnectionToken(d,f){this.c[d]=f}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)return this.e(d);const f=d.authority;let I=this.a[f];I&&I.indexOf(":")!==-1&&I.indexOf("[")===-1&&(I=`[${I}]`);const r=this.b[f],n=this.c[f];let e=`path=${encodeURIComponent(d.path)}`;return typeof n=="string"&&(e+=`&${t.connectionTokenQueryName}=${encodeURIComponent(n)}`),i.URI.from({scheme:v.isWeb?this.d:U.vscodeRemoteResource,authority:`${I}:${r}`,path:this.f,query:e})}}t.RemoteAuthorities=new R,t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class y{asBrowserUri(d){const f=this.b(d,Q);return this.uriToBrowserUri(f)}uriToBrowserUri(d){return d.scheme===U.vscodeRemote?t.RemoteAuthorities.rewrite(d):d.scheme===U.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${U.vscodeFileResource}://${y.a}`)?d.with({scheme:U.vscodeFileResource,authority:d.authority||y.a,query:null,fragment:null}):d}asFileUri(d){const f=this.b(d,Q);return this.uriToFileUri(f)}uriToFileUri(d){return d.scheme===U.vscodeFileResource?d.with({scheme:U.file,authority:d.authority!==y.a?d.authority:null,query:null,fragment:null}):d}b(d,f){return i.URI.isUri(d)?d:i.URI.parse(f.toUrl(d))}}y.a="vscode-app",t.FileAccess=new y;var w;(function(c){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(d.get("3"));const f="vscode-coi";function I(n){let e;typeof n=="string"?e=new URL(n).searchParams:n instanceof URL?e=n.searchParams:i.URI.isUri(n)&&(e=new URL(n.toString(!0)).searchParams);const s=e?.get(f);if(!!s)return d.get(s)}c.getHeadersFromQuery=I;function r(n,e,s){if(!globalThis.crossOriginIsolated)return;const l=e&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(f,l):n[f]=l}c.addSearchParam=r})(w=t.COI||(t.COI={}))}),define(be[36],pe([1,0,109,35,21,5,11,15]),function(Q,t,v,i,U,R,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function c(n){return(0,w.uriToFsPath)(n,!0)}t.originalFSPath=c;class d{constructor(e){this.a=e}compare(e,s,l=!1){return e===s?0:(0,y.compare)(this.getComparisonKey(e,l),this.getComparisonKey(s,l))}isEqual(e,s,l=!1){return e===s?!0:!e||!s?!1:this.getComparisonKey(e,l)===this.getComparisonKey(s,l)}getComparisonKey(e,s=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,s,l=!1){if(e.scheme===s.scheme){if(e.scheme===i.Schemas.file)return v.isEqualOrParent(c(e),c(s),this.a(e))&&e.query===s.query&&(l||e.fragment===s.fragment);if((0,t.isEqualAuthority)(e.authority,s.authority))return v.isEqualOrParent(e.path,s.path,this.a(e),"/")&&e.query===s.query&&(l||e.fragment===s.fragment)}return!1}joinPath(e,...s){return w.URI.joinPath(e,...s)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return U.posix.basename(e.path)}extname(e){return U.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let s;return e.scheme===i.Schemas.file?s=w.URI.file(U.dirname(c(e))).path:(s=U.posix.dirname(e.path),e.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),s="/")),e.with({path:s})}normalizePath(e){if(!e.path.length)return e;let s;return e.scheme===i.Schemas.file?s=w.URI.file(U.normalize(c(e))).path:s=U.posix.normalize(e.path),e.with({path:s})}relativePath(e,s){if(e.scheme!==s.scheme||!(0,t.isEqualAuthority)(e.authority,s.authority))return;if(e.scheme===i.Schemas.file){const m=U.relative(c(e),c(s));return R.isWindows?v.toSlashes(m):m}let l=e.path||"/";const u=s.path||"/";if(this.a(e)){let m=0;for(const o=Math.min(l.length,u.length);m<o&&!(l.charCodeAt(m)!==u.charCodeAt(m)&&l.charAt(m).toLowerCase()!==u.charAt(m).toLowerCase());m++);l=u.substr(0,m)+l.substr(m)}return U.posix.relative(l,u)}resolvePath(e,s){if(e.scheme===i.Schemas.file){const l=w.URI.file(U.resolve(c(e),s));return e.with({authority:l.authority,path:l.path})}return s=v.toPosixPath(s),e.with({path:U.posix.resolve(e.path,s)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,s){return e===s||e!==void 0&&s!==void 0&&(0,y.equalsIgnoreCase)(e,s)}hasTrailingPathSeparator(e,s=U.sep){if(e.scheme===i.Schemas.file){const l=c(e);return l.length>v.getRoot(l).length&&l[l.length-1]===s}else{const l=e.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,s=U.sep){return(0,t.hasTrailingPathSeparator)(e,s)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,s=U.sep){let l=!1;if(e.scheme===i.Schemas.file){const u=c(e);l=u!==void 0&&u.length===v.getRoot(u).length&&u[u.length-1]===s}else{s="/";const u=e.path;l=u.length===1&&u.charCodeAt(u.length-1)===47}return!l&&!(0,t.hasTrailingPathSeparator)(e,s)?e.with({path:e.path+"/"}):e}}t.ExtUri=d,t.extUri=new d(()=>!1),t.extUriBiasedIgnorePathCase=new d(n=>n.scheme===i.Schemas.file?!R.isLinux:!0),t.extUriIgnorePathCase=new d(n=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function f(n,e){const s=[];for(let l=0;l<n.length;l++){const u=e(n[l]);n.some((m,o)=>o===l?!1:(0,t.isEqualOrParent)(u,e(m)))||s.push(n[l])}return s}t.distinctParents=f;var I;(function(n){n.META_DATA_LABEL="label",n.META_DATA_DESCRIPTION="description",n.META_DATA_SIZE="size",n.META_DATA_MIME="mime";function e(s){const l=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(o=>{const[a,g]=o.split(":");a&&g&&l.set(a,g)});const m=s.path.substring(0,s.path.indexOf(";"));return m&&l.set(n.META_DATA_MIME,m),l}n.parseMetaData=e})(I=t.DataUri||(t.DataUri={}));function r(n,e,s){if(e){let l=n.path;return l&&l[0]!==U.posix.sep&&(l=U.posix.sep+l),n.with({scheme:s,authority:e,path:l})}return n.with({scheme:s})}t.toLocalResource=r}),define(be[8],pe([1,0,28,9,3,2,36,5]),function(Q,t,v,i,U,R,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function c(G){return!!G&&typeof G.then=="function"}t.isThenable=c;function d(G){const P=new v.CancellationTokenSource,b=G(P.token),B=new Promise(($,V)=>{const Z=P.token.onCancellationRequested(()=>{Z.dispose(),P.dispose(),V(new i.CancellationError)});Promise.resolve(b).then(T=>{Z.dispose(),P.dispose(),$(T)},T=>{Z.dispose(),P.dispose(),V(T)})});return new class{cancel(){P.cancel()}then($,V){return B.then($,V)}catch($){return this.then(void 0,$)}finally($){return B.finally($)}}}t.createCancelablePromise=d;function f(G,P,b){return new Promise((B,$)=>{const V=P.onCancellationRequested(()=>{V.dispose(),B(b)});G.then(B,$).finally(()=>V.dispose())})}t.raceCancellation=f;function I(G,P){return new Promise((b,B)=>{const $=P.onCancellationRequested(()=>{$.dispose(),B(new i.CancellationError)});G.then(b,B).finally(()=>$.dispose())})}t.raceCancellationError=I;async function r(G){let P=-1;const b=G.map(($,V)=>$.then(Z=>(P=V,Z))),B=await Promise.race(b);return G.forEach(($,V)=>{V!==P&&$.cancel()}),B}t.raceCancellablePromises=r;function n(G,P,b){let B;const $=setTimeout(()=>{B?.(void 0),b?.()},P);return Promise.race([G.finally(()=>clearTimeout($)),new Promise(V=>B=V)])}t.raceTimeout=n;function e(G){return new Promise((P,b)=>{const B=G();c(B)?B.then(P,b):P(B)})}t.asPromise=e;class s{constructor(){this.a=null,this.b=null,this.d=null}queue(P){if(this.a){if(this.d=P,!this.b){const b=()=>{this.b=null;const B=this.queue(this.d);return this.d=null,B};this.b=new Promise(B=>{this.a.then(b,b).then(B)})}return new Promise((b,B)=>{this.b.then(b,B)})}return this.a=P(),new Promise((b,B)=>{this.a.then($=>{this.a=null,b($)},$=>{this.a=null,B($)})})}}t.Throttler=s;class l{constructor(){this.a=Promise.resolve(null)}queue(P){return this.a=this.a.then(()=>P(),()=>P())}}t.Sequencer=l;class u{constructor(){this.a=new Map}queue(P,b){const $=(this.a.get(P)??Promise.resolve()).catch(()=>{}).then(b).finally(()=>{this.a.get(P)===$&&this.a.delete(P)});return this.a.set(P,$),$}}t.SequencerByKey=u;const m=(G,P)=>{let b=!0;const B=setTimeout(()=>{b=!1,P()},G);return{isTriggered:()=>b,dispose:()=>{clearTimeout(B),b=!1}}},o=G=>{let P=!0;return queueMicrotask(()=>{P&&(P=!1,G())}),{isTriggered:()=>P,dispose:()=>{P=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class a{constructor(P){this.defaultDelay=P,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(P,b=this.defaultDelay){this.g=P,this.h(),this.b||(this.b=new Promise(($,V)=>{this.d=$,this.f=V}).then(()=>{if(this.b=null,this.d=null,this.g){const $=this.g;return this.g=null,$()}}));const B=()=>{this.a=null,this.d?.(null)};return this.a=b===t.MicrotaskDelay?o(B):m(b,B),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.Delayer=a;class g{constructor(P){this.a=new a(P),this.b=new s}trigger(P,b){return this.a.trigger(()=>this.b.queue(P),b)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}t.ThrottledDelayer=g;class C{constructor(){this.a=!1,this.b=new Promise((P,b)=>{this.d=P})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.Barrier=C;class L extends C{constructor(P){super(),this.f=setTimeout(()=>this.open(),P)}open(){clearTimeout(this.f),super.open()}}t.AutoOpenBarrier=L;function k(G,P){return P?new Promise((b,B)=>{const $=setTimeout(()=>{V.dispose(),b()},G),V=P.onCancellationRequested(()=>{clearTimeout($),V.dispose(),B(new i.CancellationError)})}):d(b=>k(G,b))}t.timeout=k;function S(G,P=0){const b=setTimeout(G,P);return(0,R.toDisposable)(()=>clearTimeout(b))}t.disposableTimeout=S;function h(G){const P=[];let b=0;const B=G.length;function $(){return b<B?G[b++]():null}function V(Z){Z!=null&&P.push(Z);const T=$();return T?T.then(V):Promise.resolve(P)}return Promise.resolve(null).then(V)}t.sequence=h;function E(G,P=B=>!!B,b=null){let B=0;const $=G.length,V=()=>{if(B>=$)return Promise.resolve(b);const Z=G[B++];return Promise.resolve(Z()).then(M=>P(M)?Promise.resolve(M):V())};return V()}t.first=E;function p(G,P=B=>!!B,b=null){if(G.length===0)return Promise.resolve(b);let B=G.length;const $=()=>{B=-1;for(const V of G)V.cancel?.()};return new Promise((V,Z)=>{for(const T of G)T.then(M=>{--B>=0&&P(M)?($(),V(M)):B===0&&V(b)}).catch(M=>{--B>=0&&($(),Z(M))})})}t.firstParallel=p;class D{constructor(P){this.a=0,this.d=P,this.f=[],this.b=0,this.g=new U.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(P){return this.a++,new Promise((b,B)=>{this.f.push({factory:P,c:b,e:B}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const P=this.f.shift();this.b++;const b=P.factory();b.then(P.c,P.e),b.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.Limiter=D;class z extends D{constructor(){super(1)}}t.Queue=z;class q{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const P=new se;return this.b.add(P),P.p}d(){for(const[,P]of this.a)if(P.size>0)return!1;return!0}queueFor(P,b=y.extUri){const B=b.getComparisonKey(P);let $=this.a.get(B);return $||($=new z,U.Event.once($.onDrained)(()=>{$?.dispose(),this.a.delete(B),this.f()}),this.a.set(B,$)),$}f(){!this.d()||this.g()}g(){for(const P of this.b)P.complete();this.b.clear()}dispose(){for(const[,P]of this.a)P.dispose();this.a.clear(),this.g()}}t.ResourceQueue=q;class ie{constructor(P,b){this.a=-1,typeof P=="function"&&typeof b=="number"&&this.setIfNotSet(P,b)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(P,b){this.cancel(),this.a=setTimeout(()=>{this.a=-1,P()},b)}setIfNotSet(P,b){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,P()},b))}}t.TimeoutTimer=ie;class J{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(P,b){this.cancel(),this.a=setInterval(()=>{P()},b)}}t.IntervalTimer=J;class me{constructor(P,b){this.b=-1,this.a=P,this.d=b,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(P=this.d){this.cancel(),this.b=setTimeout(this.f,P)}get delay(){return this.d}set delay(P){this.d=P}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.RunOnceScheduler=me;class he{constructor(P,b){b%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${b}ms is not a multiple of 1000ms.`),this.a=P,this.b=b,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(P=this.b){P%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${P}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(P/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.ProcessTimeRunOnceScheduler=he;class fe extends me{constructor(P,b){super(P,b),this.j=[]}work(P){this.j.push(P),this.isScheduled()||this.schedule()}h(){const P=this.j;this.j=[],this.a?.(P)}dispose(){this.j=[],super.dispose()}}t.RunOnceWorker=fe;class oe extends R.Disposable{constructor(P,b){super(),this.g=P,this.h=b,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(P){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+P.length>this.g.maxBufferedWork)return!1}else if(this.pending+P.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...P),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new me(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.ThrottledWorker=oe,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=G=>{(0,w.setTimeout0)(()=>{if(P)return;const b=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,b-Date.now())}}))});let P=!1;return{dispose(){P||(P=!0)}}}:t.runWhenIdle=(G,P)=>{const b=requestIdleCallback(G,typeof P=="number"?{timeout:P}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(b))}}}}();class de{constructor(P){this.d=!1,this.a=()=>{try{this.f=P()}catch(b){this.g=b}finally{this.d=!0}},this.b=(0,t.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.IdleValue=de;async function Se(G,P,b){let B;for(let $=0;$<b;$++)try{return await G()}catch(V){B=V,await k(P)}throw B}t.retry=Se;class te{hasPending(P){return this.a?typeof P=="number"?this.a.taskId===P:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(P,b,B){return this.a={taskId:P,cancel:()=>B?.(),promise:b},b.then(()=>this.d(P),()=>this.d(P)),b}d(P){this.a&&P===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const P=this.b;this.b=void 0,P.run().then(P.promiseResolve,P.promiseReject)}}setNext(P){if(this.b)this.b.run=P;else{let b,B;const $=new Promise((V,Z)=>{b=V,B=Z});this.b={run:P,promise:$,promiseResolve:b,promiseReject:B}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.TaskSequentializer=te;class Ce{constructor(P,b=()=>Date.now()){this.d=P,this.f=b,this.a=0,this.b=0}increment(){const P=this.f();return P-this.a>this.d&&(this.a=P,this.b=0),this.b++,this.b}}t.IntervalCounter=Ce;class se{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((P,b)=>{this.a=P,this.b=b})}complete(P){return new Promise(b=>{this.a(P),this.f=!0,b()})}error(P){return new Promise(b=>{this.b(P),this.d=!0,b()})}cancel(){new Promise(P=>{this.b(new i.CancellationError),this.d=!0,P()})}}t.DeferredPromise=se;var x;(function(G){async function P(B){let $;const V=await Promise.all(B.map(Z=>Z.then(T=>T,T=>{$||($=T)})));if(typeof $<"u")throw $;return V}G.settled=P;function b(B){return new Promise(async($,V)=>{try{await B($,V)}catch(Z){V(Z)}})}G.withAsyncBody=b})(x=t.Promises||(t.Promises={}));var ue;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(ue||(ue={}));class ne{static fromArray(P){return new ne(b=>{b.emitMany(P)})}static fromPromise(P){return new ne(async b=>{b.emitMany(await P)})}static fromPromises(P){return new ne(async b=>{await Promise.all(P.map(async B=>b.emitOne(await B)))})}static merge(P){return new ne(async b=>{await Promise.all(P.map(async B=>{for await(const $ of B)b.emitOne($)}))})}constructor(P){this.a=0,this.b=[],this.d=null,this.f=new U.Emitter,queueMicrotask(async()=>{const b={emitOne:B=>this.g(B),emitMany:B=>this.h(B),reject:B=>this.k(B)};try{await Promise.resolve(P(b)),this.j()}catch(B){this.k(B)}finally{b.emitOne=void 0,b.emitMany=void 0,b.reject=void 0}})}[Symbol.asyncIterator](){let P=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(P<this.b.length)return{done:!1,value:this.b[P++]};if(this.a===1)return{done:!0,value:void 0};await U.Event.toPromise(this.f.event)}while(!0)}}}static map(P,b){return new ne(async B=>{for await(const $ of P)B.emitOne(b($))})}map(P){return ne.map(this,P)}static filter(P,b){return new ne(async B=>{for await(const $ of P)b($)&&B.emitOne($)})}filter(P){return ne.filter(this,P)}static coalesce(P){return ne.filter(P,b=>!!b)}coalesce(){return ne.coalesce(this)}static async toPromise(P){const b=[];for await(const B of P)b.push(B);return b}toPromise(){return ne.toPromise(this)}g(P){this.a===0&&(this.b.push(P),this.f.fire())}h(P){this.a===0&&(this.b=this.b.concat(P),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(P){this.a===0&&(this.a=2,this.d=P,this.f.fire())}}t.AsyncIterableObject=ne,ne.EMPTY=ne.fromArray([]);class F extends ne{constructor(P,b){super(b),this.l=P}cancel(){this.l.cancel()}}t.CancelableAsyncIterableObject=F;function _(G){const P=new v.CancellationTokenSource,b=G(P.token);return new F(P,async B=>{const $=P.token.onCancellationRequested(()=>{$.dispose(),P.dispose(),B.reject(new i.CancellationError)});try{for await(const V of b){if(P.token.isCancellationRequested)return;B.emitOne(V)}$.dispose(),P.dispose()}catch(V){$.dispose(),P.dispose(),B.reject(V)}})}t.createCancelableAsyncIterable=_}),define(be[4],pe([1,0,16,107,19,20,8,9,3,113,2,35,5,6,15]),function(Q,t,v,i,U,R,y,w,c,d,f,I,r,n,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function s(X){for(;X.firstChild;)X.firstChild.remove()}t.clearNode=s;function l(X){return X?.isConnected??!1}t.isInDOM=l;class u{constructor(Y,ge,Te,Le){this.f=Y,this.g=ge,this.d=Te,this.j=Le||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){!this.d||(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function m(X,Y,ge,Te){return new u(X,Y,ge,Te)}t.addDisposableListener=m;function o(X){return function(Y){return X(new R.StandardMouseEvent(Y))}}function a(X){return function(Y){return X(new U.StandardKeyboardEvent(Y))}}const g=function(Y,ge,Te,Le){let je=Te;return ge==="click"||ge==="mousedown"?je=o(Te):(ge==="keydown"||ge==="keypress"||ge==="keyup")&&(je=a(Te)),m(Y,ge,je,Le)};t.addStandardDisposableListener=g;const C=function(Y,ge,Te){const Le=o(ge);return k(Y,Le,Te)};t.addStandardDisposableGenericMouseDownListener=C;const L=function(Y,ge,Te){const Le=o(ge);return h(Y,Le,Te)};t.addStandardDisposableGenericMouseUpListener=L;function k(X,Y,ge){return m(X,r.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,Y,ge)}t.addDisposableGenericMouseDownListener=k;function S(X,Y,ge){return m(X,r.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,Y,ge)}t.addDisposableGenericMouseMoveListener=S;function h(X,Y,ge){return m(X,r.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,Y,ge)}t.addDisposableGenericMouseUpListener=h;class E{constructor(Y,ge=0){this.d=Y,this.priority=ge,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Y){(0,w.onUnexpectedError)(Y)}}static sort(Y,ge){return ge.priority-Y.priority}}(function(){let X=[],Y=null,ge=!1,Te=!1;const Le=()=>{for(ge=!1,Y=X,X=[],Te=!0;Y.length>0;)Y.sort(E.sort),Y.shift().execute();Te=!1};t.scheduleAtNextAnimationFrame=(je,$e=0)=>{const Xe=new E(je,$e);return X.push(Xe),ge||(ge=!0,requestAnimationFrame(Le)),Xe},t.runAtThisOrScheduleAtNextAnimationFrame=(je,$e)=>{if(Te){const Xe=new E(je,$e);return Y.push(Xe),Xe}else return(0,t.scheduleAtNextAnimationFrame)(je,$e)}})();function p(X){return(0,t.scheduleAtNextAnimationFrame)(X,1e4)}t.measure=p;function D(X){return(0,t.scheduleAtNextAnimationFrame)(X,-1e4)}t.modify=D;const z=8,q=function(X,Y){return Y};class ie extends f.Disposable{constructor(Y,ge,Te,Le=q,je=z){super();let $e=null,Xe=0;const Je=this.B(new y.TimeoutTimer),gt=()=>{Xe=new Date().getTime(),Te($e),$e=null};this.B(m(Y,ge,Lt=>{$e=Le($e,Lt);const mt=new Date().getTime()-Xe;mt>=je?(Je.cancel(),gt()):Je.setIfNotSet(gt,je-mt)}))}}function J(X,Y,ge,Te,Le){return new ie(X,Y,ge,Te,Le)}t.addDisposableThrottledListener=J;function me(X){return document.defaultView.getComputedStyle(X,null)}t.getComputedStyle=me;function he(X){if(X!==document.body)return new oe(X.clientWidth,X.clientHeight);if(r.isIOS&&window.visualViewport)return new oe(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new oe(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new oe(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new oe(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=he;class fe{static d(Y,ge){return parseFloat(ge)||0}static f(Y,ge,Te){const Le=me(Y),je=Le?Le.getPropertyValue(ge):"0";return fe.d(Y,je)}static getBorderLeftWidth(Y){return fe.f(Y,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Y){return fe.f(Y,"border-right-width","borderRightWidth")}static getBorderTopWidth(Y){return fe.f(Y,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Y){return fe.f(Y,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Y){return fe.f(Y,"padding-left","paddingLeft")}static getPaddingRight(Y){return fe.f(Y,"padding-right","paddingRight")}static getPaddingTop(Y){return fe.f(Y,"padding-top","paddingTop")}static getPaddingBottom(Y){return fe.f(Y,"padding-bottom","paddingBottom")}static getMarginLeft(Y){return fe.f(Y,"margin-left","marginLeft")}static getMarginTop(Y){return fe.f(Y,"margin-top","marginTop")}static getMarginRight(Y){return fe.f(Y,"margin-right","marginRight")}static getMarginBottom(Y){return fe.f(Y,"margin-bottom","marginBottom")}}class oe{constructor(Y,ge){this.width=Y,this.height=ge}with(Y=this.width,ge=this.height){return Y!==this.width||ge!==this.height?new oe(Y,ge):this}static is(Y){return typeof Y=="object"&&typeof Y.height=="number"&&typeof Y.width=="number"}static lift(Y){return Y instanceof oe?Y:new oe(Y.width,Y.height)}static equals(Y,ge){return Y===ge?!0:!Y||!ge?!1:Y.width===ge.width&&Y.height===ge.height}}t.Dimension=oe,oe.None=new oe(0,0);function de(X){let Y=X.offsetParent,ge=X.offsetTop,Te=X.offsetLeft;for(;(X=X.parentNode)!==null&&X!==document.body&&X!==document.documentElement;){ge-=X.scrollTop;const Le=H(X)?null:me(X);Le&&(Te-=Le.direction!=="rtl"?X.scrollLeft:-X.scrollLeft),X===Y&&(Te+=fe.getBorderLeftWidth(X),ge+=fe.getBorderTopWidth(X),ge+=X.offsetTop,Te+=X.offsetLeft,Y=X.offsetParent)}return{left:Te,top:ge}}t.getTopLeftOffset=de;function Se(X,Y,ge){typeof Y=="number"&&(X.style.width=`${Y}px`),typeof ge=="number"&&(X.style.height=`${ge}px`)}t.size=Se;function te(X,Y,ge,Te,Le,je="absolute"){typeof Y=="number"&&(X.style.top=`${Y}px`),typeof ge=="number"&&(X.style.right=`${ge}px`),typeof Te=="number"&&(X.style.bottom=`${Te}px`),typeof Le=="number"&&(X.style.left=`${Le}px`),X.style.position=je}t.position=te;function Ce(X){const Y=X.getBoundingClientRect();return{left:Y.left+window.scrollX,top:Y.top+window.scrollY,width:Y.width,height:Y.height}}t.getDomNodePagePosition=Ce;function se(X){let Y=X,ge=1;do{const Te=me(Y).zoom;Te!=null&&Te!=="1"&&(ge*=Te),Y=Y.parentElement}while(Y!==null&&Y!==document.documentElement);return ge}t.getDomNodeZoomLevel=se;function x(X){const Y=fe.getMarginLeft(X)+fe.getMarginRight(X);return X.offsetWidth+Y}t.getTotalWidth=x;function ue(X){const Y=fe.getBorderLeftWidth(X)+fe.getBorderRightWidth(X),ge=fe.getPaddingLeft(X)+fe.getPaddingRight(X);return X.offsetWidth-Y-ge}t.getContentWidth=ue;function ne(X){const Y=fe.getMarginLeft(X)+fe.getMarginRight(X);return X.scrollWidth+Y}t.getTotalScrollWidth=ne;function F(X){const Y=fe.getBorderTopWidth(X)+fe.getBorderBottomWidth(X),ge=fe.getPaddingTop(X)+fe.getPaddingBottom(X);return X.offsetHeight-Y-ge}t.getContentHeight=F;function _(X){const Y=fe.getMarginTop(X)+fe.getMarginBottom(X);return X.offsetHeight+Y}t.getTotalHeight=_;function G(X,Y){if(X===null)return 0;const ge=de(X),Te=de(Y);return ge.left-Te.left}function P(X,Y){const ge=Y.map(Le=>Math.max(ne(Le),x(Le))+G(Le,X)||0);return Math.max(...ge)}t.getLargestChildWidth=P;function b(X,Y){for(;X;){if(X===Y)return!0;X=X.parentNode}return!1}t.isAncestor=b;const B="parentFlowToElementId";function $(X,Y){X.dataset[B]=Y.id}t.setParentFlowTo=$;function V(X){const Y=X.dataset[B];return typeof Y=="string"?document.getElementById(Y):null}function Z(X,Y){let ge=X;for(;ge;){if(ge===Y)return!0;if(ge instanceof HTMLElement){const Te=V(ge);if(Te){ge=Te;continue}}ge=ge.parentNode}return!1}t.isAncestorUsingFlowTo=Z;function T(X,Y,ge){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X.classList.contains(Y))return X;if(ge){if(typeof ge=="string"){if(X.classList.contains(ge))return null}else if(X===ge)return null}X=X.parentNode}return null}t.findParentWithClass=T;function M(X,Y,ge){return!!T(X,Y,ge)}t.hasParentWithClass=M;function H(X){return X&&!!X.host&&!!X.mode}t.isShadowRoot=H;function A(X){return!!N(X)}t.isInShadowDOM=A;function N(X){for(;X.parentNode;){if(X===document.body)return null;X=X.parentNode}return H(X)?X:null}t.getShadowRoot=N;function O(){let X=document.activeElement;for(;X?.shadowRoot;)X=X.shadowRoot.activeElement;return X}t.getActiveElement=O;function W(X=document.getElementsByTagName("head")[0]){const Y=document.createElement("style");return Y.type="text/css",Y.media="screen",X.appendChild(Y),Y}t.createStyleSheet=W;function j(X=document.getElementsByTagName("head")[0]){const Y=document.createElement("meta");return X.appendChild(Y),Y}t.createMetaElement=j;let ee=null;function le(){return ee||(ee=W()),ee}function ce(X){return X?.sheet?.rules?X.sheet.rules:X?.sheet?.cssRules?X.sheet.cssRules:[]}function De(X,Y,ge=le()){!ge||!Y||ge.sheet.insertRule(X+"{"+Y+"}",0)}t.createCSSRule=De;function ye(X,Y=le()){if(!Y)return;const ge=ce(Y),Te=[];for(let Le=0;Le<ge.length;Le++)ge[Le].selectorText.indexOf(X)!==-1&&Te.push(Le);for(let Le=Te.length-1;Le>=0;Le--)Y.sheet.deleteRule(Te[Le])}t.removeCSSRulesContainingSelector=ye;function Ie(X){return typeof HTMLElement=="object"?X instanceof HTMLElement:X&&typeof X=="object"&&X.nodeType===1&&typeof X.nodeName=="string"}t.isHTMLElement=Ie,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:v.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:v.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:v.isWebKit?"webkitAnimationIteration":"animationiteration"},t.EventHelper={stop:(X,Y)=>(X.preventDefault(),Y&&X.stopPropagation(),X)};function ke(X){const Y=[];for(let ge=0;X&&X.nodeType===X.ELEMENT_NODE;ge++)Y[ge]=X.scrollTop,X=X.parentNode;return Y}t.saveParentsScrollTop=ke;function ve(X,Y){for(let ge=0;X&&X.nodeType===X.ELEMENT_NODE;ge++)X.scrollTop!==Y[ge]&&(X.scrollTop=Y[ge]),X=X.parentNode}t.restoreParentsScrollTop=ve;class Re extends f.Disposable{static l(Y){const ge=N(Y),Te=ge?ge.activeElement:document.activeElement;return b(Te,Y)}constructor(Y){super(),this.f=this.B(new c.Emitter),this.onDidFocus=this.f.event,this.g=this.B(new c.Emitter),this.onDidBlur=this.g.event;let ge=Re.l(Y),Te=!1;const Le=()=>{Te=!1,ge||(ge=!0,this.f.fire())},je=()=>{ge&&(Te=!0,window.setTimeout(()=>{Te&&(Te=!1,ge=!1,this.g.fire())},0))};this.j=()=>{Re.l(Y)!==ge&&(ge?je():Le())},this.B(m(Y,t.EventType.FOCUS,Le,!0)),this.B(m(Y,t.EventType.BLUR,je,!0)),this.B(m(Y,t.EventType.FOCUS_IN,()=>this.j())),this.B(m(Y,t.EventType.FOCUS_OUT,()=>this.j()))}refreshState(){this.j()}}function Pe(X){return new Re(X)}t.trackFocus=Pe;function Ve(X,Y){return X.after(Y),Y}t.after=Ve;function Ue(X,...Y){if(X.append(...Y),Y.length===1&&typeof Y[0]!="string")return Y[0]}t.append=Ue;function ze(X,Y){return X.insertBefore(Y,X.firstChild),Y}t.prepend=ze;function xe(X,...Y){X.innerText="",Ue(X,...Y)}t.reset=xe;const it=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Be;(function(X){X.HTML="http://www.w3.org/1999/xhtml",X.SVG="http://www.w3.org/2000/svg"})(Be=t.Namespace||(t.Namespace={}));function Ke(X,Y,ge,...Te){const Le=it.exec(Y);if(!Le)throw new Error("Bad use of emmet");const je=Le[1]||"div";let $e;return X!==Be.HTML?$e=document.createElementNS(X,je):$e=document.createElement(je),Le[3]&&($e.id=Le[3]),Le[4]&&($e.className=Le[4].replace(/\./g," ").trim()),ge&&Object.entries(ge).forEach(([Xe,Je])=>{typeof Je>"u"||(/^on\w+$/.test(Xe)?$e[Xe]=Je:Xe==="selected"?Je&&$e.setAttribute(Xe,"true"):$e.setAttribute(Xe,Je))}),$e.append(...Te),$e}function Ye(X,Y,...ge){return Ke(Be.HTML,X,Y,...ge)}t.$=Ye,Ye.SVG=function(X,Y,...ge){return Ke(Be.SVG,X,Y,...ge)};function K(X,Y){const ge=[];return X.forEach((Te,Le)=>{Le>0&&(Y instanceof Node?ge.push(Y.cloneNode()):ge.push(document.createTextNode(Y))),ge.push(Te)}),ge}t.join=K;function ae(...X){for(const Y of X)Y.style.display="",Y.removeAttribute("aria-hidden")}t.show=ae;function we(...X){for(const Y of X)Y.style.display="none",Y.setAttribute("aria-hidden","true")}t.hide=we;function Ee(X,Y){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X instanceof HTMLElement&&X.hasAttribute(Y))return X;X=X.parentNode}return null}function Fe(X){!X||!X.hasAttribute("tabIndex")||(document.activeElement===X&&Ee(X.parentElement,"tabIndex")?.focus(),X.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Fe;function Oe(X){return Y=>{Y.preventDefault(),Y.stopPropagation(),X(Y)}}t.finalHandler=Oe;function _e(){return new Promise(X=>{document.readyState==="complete"||document&&document.body!==null?X(void 0):window.addEventListener("DOMContentLoaded",X,!1)})}t.domContentLoaded=_e;function tt(X){const Y=window.devicePixelRatio*X;return Math.max(1,Math.floor(Y))/window.devicePixelRatio}t.computeScreenAwareSize=tt;function Me(X){window.open(X,"_blank","noopener")}t.windowOpenNoOpener=Me;const re=780,Ae=640;function Ne(X){const Y=Math.floor(window.screenLeft+window.innerWidth/2-re/2),ge=Math.floor(window.screenTop+window.innerHeight/2-Ae/2);window.open(X,"_blank",`width=${re},height=${Ae},top=${ge},left=${Y}`)}t.windowOpenPopup=Ne;function We(X,Y=!0){const ge=window.open();return ge?(Y&&(ge.opener=null),ge.location.href=X,!0):!1}t.windowOpenWithSuccess=We;function Ge(X){const Y=()=>{X(),ge=(0,t.scheduleAtNextAnimationFrame)(Y)};let ge=(0,t.scheduleAtNextAnimationFrame)(Y);return(0,f.toDisposable)(()=>ge.dispose())}t.animate=Ge,I.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Ze(X){return X?`url('${I.FileAccess.uriToBrowserUri(X).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=Ze;function Qe(X){return`'${X.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=Qe;function st(X,Y){let ge;if(e.URI.isUri(X))ge=X.toString(!0);else{const Le=new Blob([X]);ge=URL.createObjectURL(Le),setTimeout(()=>URL.revokeObjectURL(ge))}const Te=document.createElement("a");document.body.appendChild(Te),Te.download=Y,Te.href=ge,Te.click(),setTimeout(()=>document.body.removeChild(Te))}t.triggerDownload=st;function ct(){return new Promise(X=>{const Y=document.createElement("input");document.body.appendChild(Y),Y.type="file",Y.multiple=!0,c.Event.once(c.Event.fromDOMEventEmitter(Y,"input"))(()=>{X((0,n.withNullAsUndefined)(Y.files))}),Y.click(),setTimeout(()=>document.body.removeChild(Y))})}t.triggerUpload=ct;var dt;(function(X){X[X.DOCUMENT=1]="DOCUMENT",X[X.BROWSER=2]="BROWSER"})(dt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function Ft(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:dt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:dt.BROWSER,guess:!1}:(r.isMacintosh||r.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:dt.BROWSER,guess:!0}:null}t.detectFullscreen=Ft;function Tt(X,Y=!1){const ge=document.createElement("a");return d.addHook("afterSanitizeAttributes",Te=>{for(const Le of["href","src"])if(Te.hasAttribute(Le)){const je=Te.getAttribute(Le);if(Le==="href"&&je.startsWith("#"))continue;if(ge.href=je,!X.includes(ge.protocol.replace(/:$/,""))){if(Y&&Le==="src"&&ge.href.startsWith("data:"))continue;Te.removeAttribute(Le)}}}),(0,f.toDisposable)(()=>{d.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Tt;const hi=[I.Schemas.http,I.Schemas.https,I.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const ui=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function ci(X,Y){const ge=Tt(hi);try{const Te=d.sanitize(Y,ui);X.innerHTML=Te}finally{ge.dispose()}}t.safeInnerHtml=ci;function di(X){const Y=new Uint16Array(X.length);for(let Le=0;Le<Y.length;Le++)Y[Le]=X.charCodeAt(Le);let ge="";const Te=new Uint8Array(Y.buffer);for(let Le=0;Le<Te.length;Le++)ge+=String.fromCharCode(Te[Le]);return ge}function fi(X){return btoa(di(X))}t.multibyteAwareBtoa=fi;class ft extends c.Emitter{constructor(){super(),this.s=new f.DisposableStore,this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.s.add(m(window,"keydown",Y=>{if(Y.defaultPrevented)return;const ge=new U.StandardKeyboardEvent(Y);if(!(ge.keyCode===6&&Y.repeat)){if(Y.altKey&&!this.t.altKey)this.t.lastKeyPressed="alt";else if(Y.ctrlKey&&!this.t.ctrlKey)this.t.lastKeyPressed="ctrl";else if(Y.metaKey&&!this.t.metaKey)this.t.lastKeyPressed="meta";else if(Y.shiftKey&&!this.t.shiftKey)this.t.lastKeyPressed="shift";else if(ge.keyCode!==6)this.t.lastKeyPressed=void 0;else return;this.t.altKey=Y.altKey,this.t.ctrlKey=Y.ctrlKey,this.t.metaKey=Y.metaKey,this.t.shiftKey=Y.shiftKey,this.t.lastKeyPressed&&(this.t.event=Y,this.fire(this.t))}},!0)),this.s.add(m(window,"keyup",Y=>{Y.defaultPrevented||(!Y.altKey&&this.t.altKey?this.t.lastKeyReleased="alt":!Y.ctrlKey&&this.t.ctrlKey?this.t.lastKeyReleased="ctrl":!Y.metaKey&&this.t.metaKey?this.t.lastKeyReleased="meta":!Y.shiftKey&&this.t.shiftKey?this.t.lastKeyReleased="shift":this.t.lastKeyReleased=void 0,this.t.lastKeyPressed!==this.t.lastKeyReleased&&(this.t.lastKeyPressed=void 0),this.t.altKey=Y.altKey,this.t.ctrlKey=Y.ctrlKey,this.t.metaKey=Y.metaKey,this.t.shiftKey=Y.shiftKey,this.t.lastKeyReleased&&(this.t.event=Y,this.fire(this.t)))},!0)),this.s.add(m(document.body,"mousedown",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(m(document.body,"mouseup",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(m(document.body,"mousemove",Y=>{Y.buttons&&(this.t.lastKeyPressed=void 0)},!0)),this.s.add(m(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.t}get isModifierPressed(){return this.t.altKey||this.t.ctrlKey||this.t.metaKey||this.t.shiftKey}resetKeyStatus(){this.v(),this.fire(this.t)}v(){this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.u||(ft.u=new ft),ft.u}dispose(){super.dispose(),this.s.dispose()}}t.ModifierKeyEmitter=ft;function gi(X){const Y=document.cookie.match("(^|[^;]+)\\s*"+X+"\\s*=\\s*([^;]+)");return Y?Y.pop():void 0}t.getCookieValue=gi;class mi extends f.Disposable{constructor(Y,ge){super(),this.j=Y,this.l=ge,this.f=0,this.g=0,this.m()}m(){this.B(m(this.j,t.EventType.DRAG_ENTER,Y=>{this.f++,this.g=Y.timeStamp,this.l.onDragEnter(Y)})),this.B(m(this.j,t.EventType.DRAG_OVER,Y=>{Y.preventDefault(),this.l.onDragOver?.(Y,Y.timeStamp-this.g)})),this.B(m(this.j,t.EventType.DRAG_LEAVE,Y=>{this.f--,this.f===0&&(this.g=0,this.l.onDragLeave(Y))})),this.B(m(this.j,t.EventType.DRAG_END,Y=>{this.f=0,this.g=0,this.l.onDragEnd(Y)})),this.B(m(this.j,t.EventType.DROP,Y=>{this.f=0,this.g=0,this.l.onDrop(Y)}))}}t.DragAndDropObserver=mi;const bi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function pi(X,...Y){let ge,Te;Array.isArray(Y[0])?(ge={},Te=Y[0]):(ge=Y[0]||{},Te=Y[1]);const Le=bi.exec(X);if(!Le||!Le.groups)throw new Error("Bad use of h");const je=Le.groups.tag||"div",$e=document.createElement(je);Le.groups.id&&($e.id=Le.groups.id),Le.groups.class&&($e.className=Le.groups.class.replace(/\./g," ").trim());const Xe={};if(Le.groups.name&&(Xe[Le.groups.name]=$e),Te)for(const Je of Te)Je instanceof HTMLElement?$e.appendChild(Je):typeof Je=="string"?$e.append(Je):(Object.assign(Xe,Je),$e.appendChild(Je.root));for(const[Je,gt]of Object.entries(ge))if(Je==="style")for(const[Lt,mt]of Object.entries(gt))$e.style.setProperty(zt(Lt),typeof mt=="number"?mt+"px":""+mt);else Je==="tabIndex"?$e.tabIndex=gt:$e.setAttribute(zt(Je),gt.toString());return Xe.root=$e,Xe}t.h=pi;function zt(X){return X.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(be[51],pe([1,0,4,2,105]),function(Q,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class R extends i.Disposable{constructor(c,d){super(),this.B((0,v.addDisposableListener)(c,"dragover",f=>{f.preventDefault(),this.a||(this.a=setTimeout(()=>{d(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(f=>{this.B((0,v.addDisposableListener)(c,f,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.DelayedDragHandler=R,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:U.Mimes.text};function y(w,c,d){const f=document.createElement("div");f.className=d,f.textContent=c,w.dataTransfer&&(document.body.appendChild(f),w.dataTransfer.setDragImage(f,-10,-10),setTimeout(()=>document.body.removeChild(f),0))}t.applyDragImage=y}),define(be[52],pe([1,0,4]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function i(r,n={}){const e=R(n);return e.textContent=r,e}t.renderText=i;function U(r,n={}){const e=R(n);return c(e,d(r,!!n.renderCodeSegments),n.actionHandler,n.renderCodeSegments),e}t.renderFormattedText=U;function R(r){const n=r.inline?"span":"div",e=document.createElement(n);return r.className&&(e.className=r.className),e}t.createElement=R;class y{constructor(n){this.b=n,this.c=0}eos(){return this.c>=this.b.length}next(){const n=this.peek();return this.advance(),n}peek(){return this.b[this.c]}advance(){this.c++}}var w;(function(r){r[r.Invalid=0]="Invalid",r[r.Root=1]="Root",r[r.Text=2]="Text",r[r.Bold=3]="Bold",r[r.Italics=4]="Italics",r[r.Action=5]="Action",r[r.ActionClose=6]="ActionClose",r[r.Code=7]="Code",r[r.NewLine=8]="NewLine"})(w||(w={}));function c(r,n,e,s){let l;if(n.type===2)l=document.createTextNode(n.content||"");else if(n.type===3)l=document.createElement("b");else if(n.type===4)l=document.createElement("i");else if(n.type===7&&s)l=document.createElement("code");else if(n.type===5&&e){const u=document.createElement("a");e.disposables.add(v.addStandardDisposableListener(u,"click",m=>{e.callback(String(n.index),m)})),l=u}else n.type===8?l=document.createElement("br"):n.type===1&&(l=r);l&&r!==l&&r.appendChild(l),l&&Array.isArray(n.children)&&n.children.forEach(u=>{c(l,u,e,s)})}function d(r,n){const e={type:1,children:[]};let s=0,l=e;const u=[],m=new y(r);for(;!m.eos();){let o=m.next();const a=o==="\\"&&I(m.peek(),n)!==0;if(a&&(o=m.next()),!a&&f(o,n)&&o===m.peek()){m.advance(),l.type===2&&(l=u.pop());const g=I(o,n);if(l.type===g||l.type===5&&g===6)l=u.pop();else{const C={type:g,children:[]};g===5&&(C.index=s,s++),l.children.push(C),u.push(l),l=C}}else if(o===`
`)l.type===2&&(l=u.pop()),l.children.push({type:8});else if(l.type!==2){const g={type:2,content:o};l.children.push(g),u.push(l),l=g}else l.content+=o}return l.type===2&&(l=u.pop()),u.length,e}function f(r,n){return I(r,n)!==0}function I(r,n){switch(r){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return n?7:0;default:return 0}}}),define(be[53],pe([1,0,4,2]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class U{constructor(){this.a=new i.DisposableStore,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(y,w){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const c=this.c;this.c=null,y&&c&&c(w)}isMonitoring(){return!!this.b}startMonitoring(y,w,c,d,f){this.isMonitoring()&&this.stopMonitoring(!1),this.b=d,this.c=f;let I=y;try{y.setPointerCapture(w),this.a.add((0,i.toDisposable)(()=>{try{y.releasePointerCapture(w)}catch{}}))}catch{I=window}this.a.add(v.addDisposableListener(I,v.EventType.POINTER_MOVE,r=>{if(r.buttons!==c){this.stopMonitoring(!0);return}r.preventDefault(),this.b(r)})),this.a.add(v.addDisposableListener(I,v.EventType.POINTER_UP,r=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=U});var qe=this&&this.__decorate||function(Q,t,v,i){var U=arguments.length,R=U<3?t:i===null?i=Object.getOwnPropertyDescriptor(t,v):i,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(Q,t,v,i);else for(var w=Q.length-1;w>=0;w--)(y=Q[w])&&(R=(U<3?y(R):U>3?y(t,v,R):y(t,v))||R);return U>3&&R&&Object.defineProperty(t,v,R),R};define(be[22],pe([1,0,4,14,25,2,45]),function(Q,t,v,i,U,R,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var w;(function(d){d.Tap="-monaco-gesturetap",d.Change="-monaco-gesturechange",d.Start="-monaco-gesturestart",d.End="-monaco-gesturesend",d.Contextmenu="-monaco-gesturecontextmenu"})(w=t.EventType||(t.EventType={}));class c extends R.Disposable{constructor(){super(),this.f=!1,this.g=new y.LinkedList,this.h=new y.LinkedList,this.k={},this.j=null,this.l=0,this.B(v.addDisposableListener(document,"touchstart",f=>this.n(f),{passive:!1})),this.B(v.addDisposableListener(document,"touchend",f=>this.p(f))),this.B(v.addDisposableListener(document,"touchmove",f=>this.v(f),{passive:!1}))}static addTarget(f){if(!c.isTouchDevice())return R.Disposable.None;c.b||(c.b=new c);const I=c.b.g.push(f);return(0,R.toDisposable)(I)}static ignoreTarget(f){if(!c.isTouchDevice())return R.Disposable.None;c.b||(c.b=new c);const I=c.b.h.push(f);return(0,R.toDisposable)(I)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}n(f){const I=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let r=0,n=f.targetTouches.length;r<n;r++){const e=f.targetTouches.item(r);this.k[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:I,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[I],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const s=this.r(w.Start,e.target);s.pageX=e.pageX,s.pageY=e.pageY,this.s(s)}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}p(f){const I=Date.now(),r=Object.keys(this.k).length;for(let n=0,e=f.changedTouches.length;n<e;n++){const s=f.changedTouches.item(n);if(!this.k.hasOwnProperty(String(s.identifier))){console.warn("move of an UNKNOWN touch",s);continue}const l=this.k[s.identifier],u=Date.now()-l.initialTimeStamp;if(u<c.c&&Math.abs(l.initialPageX-i.tail(l.rollingPageX))<30&&Math.abs(l.initialPageY-i.tail(l.rollingPageY))<30){const m=this.r(w.Tap,l.initialTarget);m.pageX=i.tail(l.rollingPageX),m.pageY=i.tail(l.rollingPageY),this.s(m)}else if(u>=c.c&&Math.abs(l.initialPageX-i.tail(l.rollingPageX))<30&&Math.abs(l.initialPageY-i.tail(l.rollingPageY))<30){const m=this.r(w.Contextmenu,l.initialTarget);m.pageX=i.tail(l.rollingPageX),m.pageY=i.tail(l.rollingPageY),this.s(m)}else if(r===1){const m=i.tail(l.rollingPageX),o=i.tail(l.rollingPageY),a=i.tail(l.rollingTimestamps)-l.rollingTimestamps[0],g=m-l.rollingPageX[0],C=o-l.rollingPageY[0],L=[...this.g].filter(k=>l.initialTarget instanceof Node&&k.contains(l.initialTarget));this.u(L,I,Math.abs(g)/a,g>0?1:-1,m,Math.abs(C)/a,C>0?1:-1,o)}this.s(this.r(w.End,l.initialTarget)),delete this.k[s.identifier]}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}r(f,I){const r=document.createEvent("CustomEvent");return r.initEvent(f,!1,!0),r.initialTarget=I,r.tapCount=0,r}s(f){if(f.type===w.Tap){const I=new Date().getTime();let r=0;I-this.l>c.m?r=1:r=2,this.l=I,f.tapCount=r}else(f.type===w.Change||f.type===w.Contextmenu)&&(this.l=0);if(f.initialTarget instanceof Node){for(const I of this.h)if(I.contains(f.initialTarget))return;for(const I of this.g)I.contains(f.initialTarget)&&(I.dispatchEvent(f),this.f=!0)}}u(f,I,r,n,e,s,l,u){this.j=v.scheduleAtNextAnimationFrame(()=>{const m=Date.now(),o=m-I;let a=0,g=0,C=!0;r+=c.a*o,s+=c.a*o,r>0&&(C=!1,a=n*r*o),s>0&&(C=!1,g=l*s*o);const L=this.r(w.Change);L.translationX=a,L.translationY=g,f.forEach(k=>k.dispatchEvent(L)),C||this.u(f,m,r,n,e+a,s,l,u+g)})}v(f){const I=Date.now();for(let r=0,n=f.changedTouches.length;r<n;r++){const e=f.changedTouches.item(r);if(!this.k.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const s=this.k[e.identifier],l=this.r(w.Change,s.initialTarget);l.translationX=e.pageX-i.tail(s.rollingPageX),l.translationY=e.pageY-i.tail(s.rollingPageY),l.pageX=e.pageX,l.pageY=e.pageY,this.s(l),s.rollingPageX.length>3&&(s.rollingPageX.shift(),s.rollingPageY.shift(),s.rollingTimestamps.shift()),s.rollingPageX.push(e.pageX),s.rollingPageY.push(e.pageY),s.rollingTimestamps.push(I)}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}}c.a=-.005,c.c=700,c.m=400,qe([U.memoize],c,"isTouchDevice",null),t.Gesture=c}),define(be[54],pe([1,0,4,5,82]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const U=2e4;let R,y,w,c,d;function f(e){R=document.createElement("div"),R.className="monaco-aria-container";const s=()=>{const u=document.createElement("div");return u.className="monaco-alert",u.setAttribute("role","alert"),u.setAttribute("aria-atomic","true"),R.appendChild(u),u};y=s(),w=s();const l=()=>{const u=document.createElement("div");return u.className="monaco-status",u.setAttribute("role","complementary"),u.setAttribute("aria-live","polite"),u.setAttribute("aria-atomic","true"),R.appendChild(u),u};c=l(),d=l(),e.appendChild(R)}t.setARIAContainer=f;function I(e){!R||(y.textContent!==e?(v.clearNode(w),n(y,e)):(v.clearNode(y),n(w,e)))}t.alert=I;function r(e){!R||(i.isMacintosh?I(e):c.textContent!==e?(v.clearNode(d),n(c,e)):(v.clearNode(c),n(d,e)))}t.status=r;function n(e,s){v.clearNode(e),s.length>U&&(s=s.substr(0,U)),e.textContent=s,e.style.visibility="hidden",e.style.visibility="visible"}}),define(be[114],pe([1,0,4,12]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const U=new RegExp(`(\\\\)?\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)`,"g");function R(w){const c=new Array;let d,f=0,I=0;for(;(d=U.exec(w))!==null;){I=d.index||0,f<I&&c.push(w.substring(f,I)),f=(d.index||0)+d[0].length;const[,r,n]=d;c.push(r?`$(${n})`:y({id:n}))}return f<w.length&&c.push(w.substring(f)),c}t.renderLabelWithIcons=R;function y(w){const c=v.$("span");return c.classList.add(...i.CSSIcon.asClassNameArray(w)),c}t.renderIcon=y}),define(be[115],pe([1,0,4]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function i(R){try{R.parentElement?.removeChild(R)}catch{}}class U{constructor(y){this.b=y,this.a=new Map}alloc(y){let w=this.d(y).pop();if(!w){const c=(0,v.$)(".monaco-list-row"),f=this.f(y).renderTemplate(c);w={domNode:c,templateId:y,templateData:f}}return w}release(y){!y||this.c(y)}c(y){const{domNode:w,templateId:c}=y;w&&(w.classList.remove("scrolling"),i(w)),this.d(c).push(y)}d(y){let w=this.a.get(y);return w||(w=[],this.a.set(y,w)),w}dispose(){this.a.forEach((y,w)=>{for(const c of y)this.f(w).disposeTemplate(c.templateData),c.templateData=null}),this.a.clear()}f(y){const w=this.b.get(y);if(!w)throw new Error(`No renderer found for ${y}`);return w}}t.RowCache=U}),define(be[116],pe([1,0,8,2]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class U extends i.Disposable{constructor(y,w,c){super(),this.a=y,this.b=w,this.c=c,this.f=null,this.j=!1,this.i=!1,this.g=!1,this.h=!1,this.k=this.B(new v.TimeoutTimer)}setVisibility(y){this.a!==y&&(this.a=y,this.m())}setShouldBeVisible(y){this.g=y,this.m()}l(){return this.a===2?!1:this.a===3?!0:this.g}m(){const y=this.l();this.h!==y&&(this.h=y,this.ensureVisibility())}setIsNeeded(y){this.i!==y&&(this.i=y,this.ensureVisibility())}setDomNode(y){this.f=y,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.i){this.p(!1);return}this.h?this.n():this.p(!0)}n(){this.j||(this.j=!0,this.k.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}p(y){this.k.cancel(),this.j&&(this.j=!1,this.f?.setClassName(this.c+(y?" fade":"")))}}t.ScrollbarVisibilityController=U}),define(be[117],pe([1,0,4,22,14,3,2,5]),function(Q,t,v,i,U,R,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class c extends y.Disposable{constructor(f,I,r,n){super(),this.f=0,this.b=n||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new R.Emitter),this.h=r,this.i(),this.setOptions(f,I)}i(){this.B(i.Gesture.addTarget(this.a)),[i.EventType.Tap].forEach(f=>{this.B(v.addDisposableListener(this.a,f,I=>{this.a.focus()}))}),this.B(v.addStandardDisposableListener(this.a,"click",f=>{v.EventHelper.stop(f,!0)})),this.B(v.addStandardDisposableListener(this.a,"change",f=>{this.a.title=f.target.value,this.g.fire({index:f.target.selectedIndex,selected:f.target.value})})),this.B(v.addStandardDisposableListener(this.a,"keydown",f=>{let I=!1;w.isMacintosh?(f.keyCode===18||f.keyCode===16||f.keyCode===10)&&(I=!0):(f.keyCode===18&&f.altKey||f.keyCode===10||f.keyCode===3)&&(I=!0),I&&f.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(f,I){(!this.c||!U.equals(this.c,f))&&(this.c=f,this.a.options.length=0,this.c.forEach((r,n)=>{this.a.add(this.j(r.text,n,r.isDisabled))})),I!==void 0&&this.select(I)}select(f){this.c.length===0?this.f=0:f>=0&&f<this.c.length?this.f=f:f>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(f){this.b.ariaLabel=f,this.a.setAttribute("aria-label",f)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(f){this.a.tabIndex=f?0:-1}render(f){f.classList.add("select-container"),f.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(f){this.h=f,this.applyStyles()}applyStyles(){if(this.a){const f=this.h.selectBackground?this.h.selectBackground.toString():"",I=this.h.selectForeground?this.h.selectForeground.toString():"",r=this.h.selectBorder?this.h.selectBorder.toString():"";this.a.style.backgroundColor=f,this.a.style.color=I,this.a.style.borderColor=r}}j(f,I,r){const n=document.createElement("option");return n.value=f,n.text=f,n.disabled=!!r,n}}t.SelectBoxNative=c}),define(be[55],pe([1,0,23,14,8,111,3,26]),function(Q,t,v,i,U,R,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function c(r){return typeof r=="object"&&"visibility"in r&&"data"in r}t.isFilterResult=c;function d(r){switch(r){case!0:return 1;case!1:return 0;default:return r}}t.getVisibleState=d;function f(r){return typeof r.collapsible=="boolean"}class I{constructor(n,e,s,l={}){this.o=n,this.p=e,this.rootRef=[],this.d=new y.EventBufferer,this.f=new y.Emitter,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new y.Emitter,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new y.Emitter,this.onDidSplice=this.l.event,this.m=new U.Delayer(U.MicrotaskDelay),this.h=typeof l.collapseByDefault>"u"?!1:l.collapseByDefault,this.j=l.filter,this.k=typeof l.autoExpandSingleChildren>"u"?!1:l.autoExpandSingleChildren,this.c={parent:void 0,element:s,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(n,e,s=w.Iterable.empty(),l={}){if(n.length===0)throw new v.TreeError(this.o,"Invalid tree location");l.diffIdentityProvider?this.q(l.diffIdentityProvider,n,e,s,l):this.s(n,e,s,l)}q(n,e,s,l=w.Iterable.empty(),u,m=u.diffDepth??0){const{parentNode:o}=this.H(e);if(!o.lastDiffIds)return this.s(e,s,l,u);const a=[...l],g=e[e.length-1],C=new R.LcsDiff({getElements:()=>o.lastDiffIds},{getElements:()=>[...o.children.slice(0,g),...a,...o.children.slice(g+s)].map(E=>n.getId(E.element).toString())}).ComputeDiff(!1);if(C.quitEarly)return o.lastDiffIds=void 0,this.s(e,s,a,u);const L=e.slice(0,-1),k=(E,p,D)=>{if(m>0)for(let z=0;z<D;z++)E--,p--,this.q(n,[...L,E,0],Number.MAX_SAFE_INTEGER,a[p].children,u,m-1)};let S=Math.min(o.children.length,g+s),h=a.length;for(const E of C.changes.sort((p,D)=>D.originalStart-p.originalStart))k(S,h,S-(E.originalStart+E.originalLength)),S=E.originalStart,h=E.modifiedStart-g,this.s([...L,S],E.originalLength,w.Iterable.slice(a,h,h+E.modifiedLength),u);k(S,h,S)}s(n,e,s=w.Iterable.empty(),{onDidCreateNode:l,onDidDeleteNode:u,diffIdentityProvider:m}){const{parentNode:o,listIndex:a,revealed:g,visible:C}=this.H(n),L=[],k=w.Iterable.map(s,he=>this.w(he,o,o.visible?1:0,g,L,l)),S=n[n.length-1],h=o.children.length>0;let E=0;for(let he=S;he>=0&&he<o.children.length;he--){const fe=o.children[he];if(fe.visible){E=fe.visibleChildIndex;break}}const p=[];let D=0,z=0;for(const he of k)p.push(he),z+=he.renderNodeCount,he.visible&&(he.visibleChildIndex=E+D++);const q=(0,i.splice)(o.children,S,e,p);m?o.lastDiffIds?(0,i.splice)(o.lastDiffIds,S,e,p.map(he=>m.getId(he.element).toString())):o.lastDiffIds=o.children.map(he=>m.getId(he.element).toString()):o.lastDiffIds=void 0;let ie=0;for(const he of q)he.visible&&ie++;if(ie!==0)for(let he=S+p.length;he<o.children.length;he++){const fe=o.children[he];fe.visible&&(fe.visibleChildIndex-=ie)}if(o.visibleChildrenCount+=D-ie,g&&C){const he=q.reduce((fe,oe)=>fe+(oe.visible?oe.renderNodeCount:0),0);this.C(o,z-he),this.p.splice(a,he,L)}if(q.length>0&&u){const he=fe=>{u(fe),fe.children.forEach(he)};q.forEach(he)}this.l.fire({insertedNodes:p,deletedNodes:q});const J=o.children.length>0;h!==J&&this.setCollapsible(n.slice(0,-1),J);let me=o;for(;me;){if(me.visibility===2){this.m.trigger(()=>this.refilter());break}me=me.parent}}rerender(n){if(n.length===0)throw new v.TreeError(this.o,"Invalid tree location");const{node:e,listIndex:s,revealed:l}=this.G(n);e.visible&&l&&this.p.splice(s,1,[e])}updateElementHeight(n,e){if(n.length===0)throw new v.TreeError(this.o,"Invalid tree location");const{listIndex:s}=this.G(n);this.p.updateElementHeight(s,e)}has(n){return this.E(n)}getListIndex(n){const{listIndex:e,visible:s,revealed:l}=this.G(n);return s&&l?e:-1}getListRenderCount(n){return this.F(n).renderNodeCount}isCollapsible(n){return this.F(n).collapsible}setCollapsible(n,e){const s=this.F(n);typeof e>"u"&&(e=!s.collapsible);const l={collapsible:e};return this.d.bufferEvents(()=>this.t(n,l))}isCollapsed(n){return this.F(n).collapsed}setCollapsed(n,e,s){const l=this.F(n);typeof e>"u"&&(e=!l.collapsed);const u={collapsed:e,recursive:s||!1};return this.d.bufferEvents(()=>this.t(n,u))}t(n,e){const{node:s,listIndex:l,revealed:u}=this.G(n),m=this.u(s,l,u,e);if(s!==this.c&&this.k&&m&&!f(e)&&s.collapsible&&!s.collapsed&&!e.recursive){let o=-1;for(let a=0;a<s.children.length;a++)if(s.children[a].visible)if(o>-1){o=-1;break}else o=a;o>-1&&this.t([...n,o],e)}return m}u(n,e,s,l){const u=this.v(n,l,!1);if(!s||!n.visible||!u)return u;const m=n.renderNodeCount,o=this.x(n),a=m-(e===-1?0:1);return this.p.splice(e+1,a,o.slice(1)),u}v(n,e,s){let l;if(n===this.c?l=!1:(f(e)?(l=n.collapsible!==e.collapsible,n.collapsible=e.collapsible):n.collapsible?(l=n.collapsed!==e.collapsed,n.collapsed=e.collapsed):l=!1,l&&this.f.fire({node:n,deep:s})),!f(e)&&e.recursive)for(const u of n.children)l=this.v(u,e,!0)||l;return l}expandTo(n){this.d.bufferEvents(()=>{let e=this.F(n);for(;e.parent;)e=e.parent,n=n.slice(0,n.length-1),e.collapsed&&this.t(n,{collapsed:!1,recursive:!1})})}refilter(){const n=this.c.renderNodeCount,e=this.A(this.c);this.p.splice(0,n,e),this.m.cancel()}w(n,e,s,l,u,m){const o={parent:e,element:n.element,children:[],depth:e.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof n.collapsible=="boolean"?n.collapsible:typeof n.collapsed<"u",collapsed:typeof n.collapsed>"u"?this.h:n.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},a=this.D(o,s);o.visibility=a,l&&u.push(o);const g=n.children||w.Iterable.empty(),C=l&&a!==0&&!o.collapsed;let L=0,k=1;for(const S of g){const h=this.w(S,o,a,C,u,m);o.children.push(h),k+=h.renderNodeCount,h.visible&&(h.visibleChildIndex=L++)}return o.collapsible=o.collapsible||o.children.length>0,o.visibleChildrenCount=L,o.visible=a===2?L>0:a===1,o.visible?o.collapsed||(o.renderNodeCount=k):(o.renderNodeCount=0,l&&u.pop()),m?.(o),o}x(n){const e=n.renderNodeCount,s=[];return this.y(n,s),this.C(n.parent,s.length-e),s}y(n,e){if(n.visible===!1)return 0;if(e.push(n),n.renderNodeCount=1,!n.collapsed)for(const s of n.children)n.renderNodeCount+=this.y(s,e);return this.g.fire(n),n.renderNodeCount}A(n){const e=n.renderNodeCount,s=[];return this.B(n,n.visible?1:0,s),this.C(n.parent,s.length-e),s}B(n,e,s,l=!0){let u;if(n!==this.c){if(u=this.D(n,e),u===0)return n.visible=!1,n.renderNodeCount=0,!1;l&&s.push(n)}const m=s.length;n.renderNodeCount=n===this.c?0:1;let o=!1;if(!n.collapsed||u!==0){let a=0;for(const g of n.children)o=this.B(g,u,s,l&&!n.collapsed)||o,g.visible&&(g.visibleChildIndex=a++);n.visibleChildrenCount=a}else n.visibleChildrenCount=0;return n!==this.c&&(n.visible=u===2?o:u===1,n.visibility=u),n.visible?n.collapsed||(n.renderNodeCount+=s.length-m):(n.renderNodeCount=0,l&&s.pop()),this.g.fire(n),n.visible}C(n,e){if(e!==0)for(;n;)n.renderNodeCount+=e,this.g.fire(n),n=n.parent}D(n,e){const s=this.j?this.j.filter(n.element,e):1;return typeof s=="boolean"?(n.filterData=void 0,s?1:0):c(s)?(n.filterData=s.data,d(s.visibility)):(n.filterData=void 0,d(s))}E(n,e=this.c){if(!n||n.length===0)return!0;const[s,...l]=n;return s<0||s>e.children.length?!1:this.E(l,e.children[s])}F(n,e=this.c){if(!n||n.length===0)return e;const[s,...l]=n;if(s<0||s>e.children.length)throw new v.TreeError(this.o,"Invalid tree location");return this.F(l,e.children[s])}G(n){if(n.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:e,listIndex:s,revealed:l,visible:u}=this.H(n),m=n[n.length-1];if(m<0||m>e.children.length)throw new v.TreeError(this.o,"Invalid tree location");const o=e.children[m];return{node:o,listIndex:s,revealed:l,visible:u&&o.visible}}H(n,e=this.c,s=0,l=!0,u=!0){const[m,...o]=n;if(m<0||m>e.children.length)throw new v.TreeError(this.o,"Invalid tree location");for(let a=0;a<m;a++)s+=e.children[a].renderNodeCount;return l=l&&!e.collapsed,u=u&&e.visible,o.length===0?{parentNode:e,listIndex:s,revealed:l,visible:u}:this.H(o,e.children[m],s+1,l,u)}getNode(n=[]){return this.F(n)}getNodeLocation(n){const e=[];let s=n;for(;s.parent;)e.push(s.parent.children.indexOf(s)),s=s.parent;return e.reverse()}getParentNodeLocation(n){if(n.length!==0)return n.length===1?[]:(0,i.tail2)(n)[0]}getFirstElementChild(n){const e=this.F(n);if(e.children.length!==0)return e.children[0].element}getLastElementAncestor(n=[]){const e=this.F(n);if(e.children.length!==0)return this.I(e)}I(n){return n.children.length===0?n.element:this.I(n.children[n.children.length-1])}}t.IndexTreeModel=I}),define(be[118],pe([1,0,55,23,26]),function(Q,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class R{get size(){return this.d.size}constructor(w,c,d={}){this.k=w,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new v.IndexTreeModel(w,c,null,d),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,d.sorter&&(this.j={compare(f,I){return d.sorter.compare(f.element,I.element)}}),this.h=d.identityProvider}setChildren(w,c=U.Iterable.empty(),d={}){const f=this.o(w);this.l(f,this.m(c),d)}l(w,c=U.Iterable.empty(),d){const f=new Set,I=new Set,r=e=>{if(e.element===null)return;const s=e;if(f.add(s.element),this.d.set(s.element,s),this.h){const l=this.h.getId(s.element).toString();I.add(l),this.f.set(l,s)}d.onDidCreateNode?.(s)},n=e=>{if(e.element===null)return;const s=e;if(f.has(s.element)||this.d.delete(s.element),this.h){const l=this.h.getId(s.element).toString();I.has(l)||this.f.delete(l)}d.onDidDeleteNode?.(s)};this.c.splice([...w,0],Number.MAX_VALUE,c,{...d,onDidCreateNode:r,onDidDeleteNode:n})}m(w=U.Iterable.empty()){return this.j&&(w=[...w].sort(this.j.compare.bind(this.j))),U.Iterable.map(w,c=>{let d=this.d.get(c.element);if(!d&&this.h){const r=this.h.getId(c.element).toString();d=this.f.get(r)}if(!d)return{...c,children:this.m(c.children)};const f=typeof c.collapsible=="boolean"?c.collapsible:d.collapsible,I=typeof c.collapsed<"u"?c.collapsed:d.collapsed;return{...c,collapsible:f,collapsed:I,children:this.m(c.children)}})}rerender(w){const c=this.o(w);this.c.rerender(c)}updateElementHeight(w,c){const d=this.o(w);this.c.updateElementHeight(d,c)}resort(w=null,c=!0){if(!this.j)return;const d=this.o(w),f=this.c.getNode(d);this.l(d,this.n(f,c),{})}n(w,c,d=!0){let f=[...w.children];return(c||d)&&(f=f.sort(this.j.compare.bind(this.j))),U.Iterable.map(f,I=>({element:I.element,collapsible:I.collapsible,collapsed:I.collapsed,children:this.n(I,c,!1)}))}getFirstElementChild(w=null){const c=this.o(w);return this.c.getFirstElementChild(c)}getLastElementAncestor(w=null){const c=this.o(w);return this.c.getLastElementAncestor(c)}has(w){return this.d.has(w)}getListIndex(w){const c=this.o(w);return this.c.getListIndex(c)}getListRenderCount(w){const c=this.o(w);return this.c.getListRenderCount(c)}isCollapsible(w){const c=this.o(w);return this.c.isCollapsible(c)}setCollapsible(w,c){const d=this.o(w);return this.c.setCollapsible(d,c)}isCollapsed(w){const c=this.o(w);return this.c.isCollapsed(c)}setCollapsed(w,c,d){const f=this.o(w);return this.c.setCollapsed(f,c,d)}expandTo(w){const c=this.o(w);this.c.expandTo(c)}refilter(){this.c.refilter()}getNode(w=null){if(w===null)return this.c.getNode(this.c.rootRef);const c=this.d.get(w);if(!c)throw new i.TreeError(this.k,`Tree element not found: ${w}`);return c}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new i.TreeError(this.k,"Invalid getParentNodeLocation call");const c=this.d.get(w);if(!c)throw new i.TreeError(this.k,`Tree element not found: ${w}`);const d=this.c.getNodeLocation(c),f=this.c.getParentNodeLocation(d);return this.c.getNode(f).element}o(w){if(w===null)return[];const c=this.d.get(w);if(!c)throw new i.TreeError(this.k,`Tree element not found: ${w}`);return this.c.getNodeLocation(c)}}t.ObjectTreeModel=R}),define(be[17],pe([1,0,4,19,20,22,2]),function(Q,t,v,i,U,R,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class w extends y.Disposable{f(d,f){this.B(v.addDisposableListener(d,v.EventType.CLICK,I=>f(new U.StandardMouseEvent(I))))}j(d,f){this.B(v.addDisposableListener(d,v.EventType.MOUSE_DOWN,I=>f(new U.StandardMouseEvent(I))))}k(d,f){this.B(v.addDisposableListener(d,v.EventType.MOUSE_OVER,I=>f(new U.StandardMouseEvent(I))))}m(d,f){this.B(v.addDisposableListener(d,v.EventType.MOUSE_LEAVE,I=>f(new U.StandardMouseEvent(I))))}p(d,f){this.B(v.addDisposableListener(d,v.EventType.KEY_DOWN,I=>f(new i.StandardKeyboardEvent(I))))}u(d,f){this.B(v.addDisposableListener(d,v.EventType.KEY_UP,I=>f(new i.StandardKeyboardEvent(I))))}C(d,f){this.B(v.addDisposableListener(d,v.EventType.INPUT,f))}D(d,f){this.B(v.addDisposableListener(d,v.EventType.BLUR,f))}F(d,f){this.B(v.addDisposableListener(d,v.EventType.FOCUS,f))}G(d,f){this.B(v.addDisposableListener(d,v.EventType.CHANGE,f))}H(d){return R.Gesture.ignoreTarget(d)}}t.Widget=w}),define(be[37],pe([1,0,53,17,8,4]),function(Q,t,v,i,U,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class y extends i.Widget{constructor(c){super(),this.a=c.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=c.bgWidth+"px",this.bgDomNode.style.height=c.bgHeight+"px",typeof c.top<"u"&&(this.bgDomNode.style.top="0px"),typeof c.left<"u"&&(this.bgDomNode.style.left="0px"),typeof c.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof c.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=c.className,this.domNode.classList.add(...c.icon.classNamesArray),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof c.top<"u"&&(this.domNode.style.top=c.top+"px"),typeof c.left<"u"&&(this.domNode.style.left=c.left+"px"),typeof c.bottom<"u"&&(this.domNode.style.bottom=c.bottom+"px"),typeof c.right<"u"&&(this.domNode.style.right=c.right+"px"),this.g=this.B(new v.GlobalPointerMoveMonitor),this.B(R.addStandardDisposableListener(this.bgDomNode,R.EventType.POINTER_DOWN,d=>this.h(d))),this.B(R.addStandardDisposableListener(this.domNode,R.EventType.POINTER_DOWN,d=>this.h(d))),this.b=this.B(new U.IntervalTimer),this.c=this.B(new U.TimeoutTimer)}h(c){if(!c.target||!(c.target instanceof Element))return;const d=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(d,200),this.g.startMonitoring(c.target,c.pointerId,c.buttons,f=>{},()=>{this.b.cancel(),this.c.cancel()}),c.preventDefault()}}t.ScrollbarArrow=y}),define(be[56],pe([1,0,4,40,53,37,116,17,5]),function(Q,t,v,i,U,R,y,w,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const d=140;class f extends w.Widget{constructor(r){super(),this.g=r.lazyRender,this.a=r.host,this.b=r.scrollable,this.c=r.scrollByPage,this.h=r.scrollbarState,this.i=this.B(new y.ScrollbarVisibilityController(r.visibility,"visible scrollbar "+r.extraScrollbarClassName,"invisible scrollbar "+r.extraScrollbarClassName)),this.i.setIsNeeded(this.h.isNeeded()),this.l=this.B(new U.GlobalPointerMoveMonitor),this.n=!0,this.domNode=(0,i.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.i.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(v.addDisposableListener(this.domNode.domNode,v.EventType.POINTER_DOWN,n=>this.y(n)))}r(r){const n=this.B(new R.ScrollbarArrow(r));this.domNode.domNode.appendChild(n.bgDomNode),this.domNode.domNode.appendChild(n.domNode)}s(r,n,e,s){this.slider=(0,i.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(r),this.slider.setLeft(n),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(v.addDisposableListener(this.slider.domNode,v.EventType.POINTER_DOWN,l=>{l.button===0&&(l.preventDefault(),this.J(l))})),this.f(this.slider.domNode,l=>{l.leftButton&&l.stopPropagation()})}t(r){return this.h.setVisibleSize(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}v(r){return this.h.setScrollSize(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}w(r){return this.h.setScrollPosition(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}beginReveal(){this.i.setShouldBeVisible(!0)}beginHide(){this.i.setShouldBeVisible(!1)}render(){!this.n||(this.n=!1,this.M(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.N(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}y(r){r.target===this.domNode.domNode&&this.I(r)}delegatePointerDown(r){const n=this.domNode.domNode.getClientRects()[0].top,e=n+this.h.getSliderPosition(),s=n+this.h.getSliderPosition()+this.h.getSliderSize(),l=this.P(r);e<=l&&l<=s?r.button===0&&(r.preventDefault(),this.J(r)):this.I(r)}I(r){let n,e;if(r.target===this.domNode.domNode&&typeof r.offsetX=="number"&&typeof r.offsetY=="number")n=r.offsetX,e=r.offsetY;else{const l=v.getDomNodePagePosition(this.domNode.domNode);n=r.pageX-l.left,e=r.pageY-l.top}const s=this.O(n,e);this.L(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),r.button===0&&(r.preventDefault(),this.J(r))}J(r){if(!r.target||!(r.target instanceof Element))return;const n=this.P(r),e=this.Q(r),s=this.h.clone();this.slider.toggleClassName("active",!0),this.l.startMonitoring(r.target,r.pointerId,r.buttons,l=>{const u=this.Q(l),m=Math.abs(u-e);if(c.isWindows&&m>d){this.L(s.getScrollPosition());return}const a=this.P(l)-n;this.L(s.getDesiredScrollPositionFromDelta(a))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}L(r){const n={};this.writeScrollPosition(n,r),this.b.setScrollPositionNow(n)}updateScrollbarSize(r){this.R(r),this.h.setScrollbarSize(r),this.n=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.AbstractScrollbar=f}),define(be[119],pe([1,0,20,56,37,41,12]),function(Q,t,v,i,U,R,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(d,f,I){const r=d.getScrollDimensions(),n=d.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:I,scrollbarState:new R.ScrollbarState(f.horizontalHasArrows?f.arrowSize:0,f.horizontal===2?0:f.horizontalScrollbarSize,f.vertical===2?0:f.verticalScrollbarSize,r.width,r.scrollWidth,n.scrollLeft),visibility:f.horizontal,extraScrollbarClassName:"horizontal",scrollable:d,scrollByPage:f.scrollByPage}),f.horizontalHasArrows){const e=(f.arrowSize-U.ARROW_IMG_SIZE)/2,s=(f.horizontalScrollbarSize-U.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:y.Codicon.scrollbarButtonLeft,top:s,left:e,bottom:void 0,right:void 0,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,1,0))}),this.r({className:"scra",icon:y.Codicon.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:e,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,-1,0))})}this.s(Math.floor((f.horizontalScrollbarSize-f.horizontalSliderSize)/2),0,void 0,f.horizontalSliderSize)}N(d,f){this.slider.setWidth(d),this.slider.setLeft(f)}M(d,f){this.domNode.setWidth(d),this.domNode.setHeight(f),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(d){return this.n=this.v(d.scrollWidth)||this.n,this.n=this.w(d.scrollLeft)||this.n,this.n=this.t(d.width)||this.n,this.n}O(d,f){return d}P(d){return d.pageX}Q(d){return d.pageY}R(d){this.slider.setHeight(d)}writeScrollPosition(d,f){d.scrollLeft=f}updateOptions(d){this.updateScrollbarSize(d.horizontal===2?0:d.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(d.vertical===2?0:d.verticalScrollbarSize),this.i.setVisibility(d.horizontal),this.c=d.scrollByPage}}t.HorizontalScrollbar=w}),define(be[120],pe([1,0,20,56,37,41,12]),function(Q,t,v,i,U,R,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(d,f,I){const r=d.getScrollDimensions(),n=d.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:I,scrollbarState:new R.ScrollbarState(f.verticalHasArrows?f.arrowSize:0,f.vertical===2?0:f.verticalScrollbarSize,0,r.height,r.scrollHeight,n.scrollTop),visibility:f.vertical,extraScrollbarClassName:"vertical",scrollable:d,scrollByPage:f.scrollByPage}),f.verticalHasArrows){const e=(f.arrowSize-U.ARROW_IMG_SIZE)/2,s=(f.verticalScrollbarSize-U.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:y.Codicon.scrollbarButtonUp,top:e,left:s,bottom:void 0,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,0,1))}),this.r({className:"scra",icon:y.Codicon.scrollbarButtonDown,top:void 0,left:s,bottom:e,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,0,-1))})}this.s(0,Math.floor((f.verticalScrollbarSize-f.verticalSliderSize)/2),f.verticalSliderSize,void 0)}N(d,f){this.slider.setHeight(d),this.slider.setTop(f)}M(d,f){this.domNode.setWidth(f),this.domNode.setHeight(d),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(d){return this.n=this.v(d.scrollHeight)||this.n,this.n=this.w(d.scrollTop)||this.n,this.n=this.t(d.height)||this.n,this.n}O(d,f){return f}P(d){return d.pageY}Q(d){return d.pageX}R(d){this.slider.setWidth(d)}writeScrollPosition(d,f){d.scrollTop=f}updateOptions(d){this.updateScrollbarSize(d.vertical===2?0:d.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.i.setVisibility(d.vertical),this.c=d.scrollByPage}}t.VerticalScrollbar=w}),define(be[57],pe([1,0,16,4,40,20,119,120,17,8,3,2,5,49,89]),function(Q,t,v,i,U,R,y,w,c,d,f,I,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,s=50,l=!0;class u{constructor(S,h,E){this.timestamp=S,this.deltaX=h,this.deltaY=E,this.score=0}}class m{constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let S=1,h=0,E=1,p=this.d;do{const D=p===this.c?S:Math.pow(2,-E);if(S-=D,h+=this.b[p].score*D,p===this.c)break;p=(this.a+p-1)%this.a,E++}while(!0);return h<=.5}accept(S,h,E){const p=new u(S,h,E);p.score=this.f(p),this.c===-1&&this.d===-1?(this.b[0]=p,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=p)}f(S){if(Math.abs(S.deltaX)>0&&Math.abs(S.deltaY)>0)return 1;let h=.5;const E=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(S.deltaX)||!this.g(S.deltaY))&&(h+=.25),Math.min(Math.max(h,0),1)}g(S){return Math.abs(Math.round(S)-S)<.01}}t.MouseWheelClassifier=m,m.INSTANCE=new m;class o extends c.Widget{get options(){return this.a}constructor(S,h,E){super(),this.J=this.B(new f.Emitter),this.onScroll=this.J.event,this.L=this.B(new f.Emitter),this.onWillScroll=this.L.event,S.style.overflow="hidden",this.a=L(h),this.b=E,this.B(this.b.onScroll(D=>{this.L.fire(D),this.O(D),this.J.fire(D)}));const p={onMouseWheel:D=>this.N(D),onDragStart:()=>this.Q(),onDragEnd:()=>this.R()};this.c=this.B(new w.VerticalScrollbar(this.b,this.a,p)),this.g=this.B(new y.HorizontalScrollbar(this.b,this.a,p)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(S),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.i=(0,U.createFastDomNode)(document.createElement("div")),this.i.setClassName("shadow"),this.h.appendChild(this.i.domNode),this.l=(0,U.createFastDomNode)(document.createElement("div")),this.l.setClassName("shadow"),this.h.appendChild(this.l.domNode),this.n=(0,U.createFastDomNode)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode)):(this.i=null,this.l=null,this.n=null),this.r=this.a.listenOnDomNode||this.h,this.s=[],this.M(this.a.handleMouseWheel),this.k(this.r,D=>this.U(D)),this.m(this.r,D=>this.S(D)),this.w=this.B(new d.TimeoutTimer),this.t=!1,this.v=!1,this.y=!0,this.I=!0}dispose(){this.s=(0,I.dispose)(this.s),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(S){this.c.delegatePointerDown(S)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(S){this.b.setScrollDimensions(S,!1)}updateClassName(S){this.a.className=S,r.isMacintosh&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(S){typeof S.handleMouseWheel<"u"&&(this.a.handleMouseWheel=S.handleMouseWheel,this.M(this.a.handleMouseWheel)),typeof S.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=S.mouseWheelScrollSensitivity),typeof S.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=S.fastScrollSensitivity),typeof S.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=S.scrollPredominantAxis),typeof S.horizontal<"u"&&(this.a.horizontal=S.horizontal),typeof S.vertical<"u"&&(this.a.vertical=S.vertical),typeof S.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=S.horizontalScrollbarSize),typeof S.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=S.verticalScrollbarSize),typeof S.scrollByPage<"u"&&(this.a.scrollByPage=S.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.P()}setRevealOnScroll(S){this.I=S}delegateScrollFromMouseWheelEvent(S){this.N(new R.StandardWheelEvent(S))}M(S){if(this.s.length>0!==S&&(this.s=(0,I.dispose)(this.s),S)){const E=p=>{this.N(new R.StandardWheelEvent(p))};this.s.push(i.addDisposableListener(this.r,i.EventType.MOUSE_WHEEL,E,{passive:!1}))}}N(S){const h=m.INSTANCE;if(l){const D=window.devicePixelRatio/(0,v.getZoomFactor)();r.isWindows||r.isLinux?h.accept(Date.now(),S.deltaX/D,S.deltaY/D):h.accept(Date.now(),S.deltaX,S.deltaY)}let E=!1;if(S.deltaY||S.deltaX){let D=S.deltaY*this.a.mouseWheelScrollSensitivity,z=S.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(Math.abs(D)>=Math.abs(z)?z=0:D=0),this.a.flipAxes&&([D,z]=[z,D]);const q=!r.isMacintosh&&S.browserEvent&&S.browserEvent.shiftKey;(this.a.scrollYToX||q)&&!z&&(z=D,D=0),S.browserEvent&&S.browserEvent.altKey&&(z=z*this.a.fastScrollSensitivity,D=D*this.a.fastScrollSensitivity);const ie=this.b.getFutureScrollPosition();let J={};if(D){const me=s*D,he=ie.scrollTop-(me<0?Math.floor(me):Math.ceil(me));this.c.writeScrollPosition(J,he)}if(z){const me=s*z,he=ie.scrollLeft-(me<0?Math.floor(me):Math.ceil(me));this.g.writeScrollPosition(J,he)}J=this.b.validateScrollPosition(J),(ie.scrollLeft!==J.scrollLeft||ie.scrollTop!==J.scrollTop)&&(l&&this.a.mouseWheelSmoothScroll&&h.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(J):this.b.setScrollPositionNow(J),E=!0)}let p=E;!p&&this.a.alwaysConsumeMouseWheel&&(p=!0),!p&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(p=!0),p&&(S.preventDefault(),S.stopPropagation())}O(S){this.y=this.g.onDidScroll(S)||this.y,this.y=this.c.onDidScroll(S)||this.y,this.a.useShadows&&(this.y=!0),this.I&&this.W(),this.a.lazyRender||this.P()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.P()}P(){if(!!this.y&&(this.y=!1,this.g.render(),this.c.render(),this.a.useShadows)){const S=this.b.getCurrentScrollPosition(),h=S.scrollTop>0,E=S.scrollLeft>0,p=E?" left":"",D=h?" top":"",z=E||h?" top-left-corner":"";this.i.setClassName(`shadow${p}`),this.l.setClassName(`shadow${D}`),this.n.setClassName(`shadow${z}${D}${p}`)}}Q(){this.t=!0,this.W()}R(){this.t=!1,this.X()}S(S){this.v=!1,this.X()}U(S){this.v=!0,this.W()}W(){this.c.beginReveal(),this.g.beginReveal(),this.Y()}X(){!this.v&&!this.t&&(this.c.beginHide(),this.g.beginHide())}Y(){!this.v&&!this.t&&this.w.cancelAndSet(()=>this.X(),e)}}t.AbstractScrollableElement=o;class a extends o{constructor(S,h){h=h||{},h.mouseWheelSmoothScroll=!1;const E=new n.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:p=>i.scheduleAtNextAnimationFrame(p)});super(S,h,E),this.B(E)}setScrollPosition(S){this.b.setScrollPositionNow(S)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.ScrollableElement=a;class g extends o{constructor(S,h,E){super(S,h,E)}setScrollPosition(S){S.reuseAnimation?this.b.setScrollPositionSmooth(S,S.reuseAnimation):this.b.setScrollPositionNow(S)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.SmoothScrollableElement=g;class C extends o{constructor(S,h){h=h||{},h.mouseWheelSmoothScroll=!1;const E=new n.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:p=>i.scheduleAtNextAnimationFrame(p)});super(S,h,E),this.B(E),this.ab=S,this.onScroll(p=>{p.scrollTopChanged&&(this.ab.scrollTop=p.scrollTop),p.scrollLeftChanged&&(this.ab.scrollLeft=p.scrollLeft)}),this.scanDomNode()}setScrollPosition(S){this.b.setScrollPositionNow(S)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.ab.clientWidth,scrollWidth:this.ab.scrollWidth,height:this.ab.clientHeight,scrollHeight:this.ab.scrollHeight}),this.setScrollPosition({scrollLeft:this.ab.scrollLeft,scrollTop:this.ab.scrollTop})}}t.DomScrollableElement=C;function L(k){const S={lazyRender:typeof k.lazyRender<"u"?k.lazyRender:!1,className:typeof k.className<"u"?k.className:"",useShadows:typeof k.useShadows<"u"?k.useShadows:!0,handleMouseWheel:typeof k.handleMouseWheel<"u"?k.handleMouseWheel:!0,flipAxes:typeof k.flipAxes<"u"?k.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof k.consumeMouseWheelIfScrollbarIsNeeded<"u"?k.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof k.alwaysConsumeMouseWheel<"u"?k.alwaysConsumeMouseWheel:!1,scrollYToX:typeof k.scrollYToX<"u"?k.scrollYToX:!1,mouseWheelScrollSensitivity:typeof k.mouseWheelScrollSensitivity<"u"?k.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof k.fastScrollSensitivity<"u"?k.fastScrollSensitivity:5,scrollPredominantAxis:typeof k.scrollPredominantAxis<"u"?k.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof k.mouseWheelSmoothScroll<"u"?k.mouseWheelSmoothScroll:!0,arrowSize:typeof k.arrowSize<"u"?k.arrowSize:11,listenOnDomNode:typeof k.listenOnDomNode<"u"?k.listenOnDomNode:null,horizontal:typeof k.horizontal<"u"?k.horizontal:1,horizontalScrollbarSize:typeof k.horizontalScrollbarSize<"u"?k.horizontalScrollbarSize:10,horizontalSliderSize:typeof k.horizontalSliderSize<"u"?k.horizontalSliderSize:0,horizontalHasArrows:typeof k.horizontalHasArrows<"u"?k.horizontalHasArrows:!1,vertical:typeof k.vertical<"u"?k.vertical:1,verticalScrollbarSize:typeof k.verticalScrollbarSize<"u"?k.verticalScrollbarSize:10,verticalHasArrows:typeof k.verticalHasArrows<"u"?k.verticalHasArrows:!1,verticalSliderSize:typeof k.verticalSliderSize<"u"?k.verticalSliderSize:0,scrollByPage:typeof k.scrollByPage<"u"?k.scrollByPage:!1};return S.horizontalSliderSize=typeof k.horizontalSliderSize<"u"?k.horizontalSliderSize:S.horizontalScrollbarSize,S.verticalSliderSize=typeof k.verticalSliderSize<"u"?k.verticalSliderSize:S.verticalScrollbarSize,r.isMacintosh&&(S.className+=" mac"),S}}),define(be[58],pe([1,0,51,4,18,22,57,14,8,25,3,2,47,49,78,115,9]),function(Q,t,v,i,U,R,y,w,c,d,f,I,r,n,e,s,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const u={CurrentDragAndDropData:void 0},m={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(S){return[S]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class o{get context(){return this.d}set context(h){this.d=h}constructor(h){this.elements=h}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=o;class a{constructor(h){this.elements=h}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=a;class g{constructor(){this.types=[],this.files=[]}update(h){if(h.types&&this.types.splice(0,this.types.length,...h.types),h.files){this.files.splice(0,this.files.length);for(let E=0;E<h.files.length;E++){const p=h.files.item(E);p&&(p.size||p.type)&&this.files.push(p)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=g;function C(S,h){return Array.isArray(S)&&Array.isArray(h)?(0,w.equals)(S,h):S===h}class L{constructor(h){h?.getSetSize?this.getSetSize=h.getSetSize.bind(h):this.getSetSize=(E,p,D)=>D,h?.getPosInSet?this.getPosInSet=h.getPosInSet.bind(h):this.getPosInSet=(E,p)=>p+1,h?.getRole?this.getRole=h.getRole.bind(h):this.getRole=E=>"listitem",h?.isChecked?this.isChecked=h.isChecked.bind(h):this.isChecked=E=>{}}}class k{get contentHeight(){return this.g.size}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(h){if(h!==this.O){if(h&&this.C)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=h,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const E of this.d)this.Y(E);this.V(),this.q.setScrollDimensions({width:(0,i.getContentWidth)(this.domNode)}),this.o.style.width=`${Math.max(this.F||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(h,E,p,D=m){if(this.Q=E,this.domId=`list_id_${++k.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new c.Delayer(50),this.v=!1,this.x=I.Disposable.None,this.y=0,this.H=!1,this.K=I.Disposable.None,this.L=I.Disposable.None,this.M=new I.DisposableStore,this.N=new f.Emitter,this.onDidChangeContentHeight=f.Event.latch(this.N.event,void 0,this.M),this.O=!1,D.horizontalScrolling&&D.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.RangeMap;for(const q of p)this.j.set(q.templateId,q);this.h=this.M.add(new s.RowCache(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof D.mouseSupport=="boolean"?D.mouseSupport:!0),this.O=D.horizontalScrolling??m.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.D=typeof D.additionalScrollHeight>"u"?0:D.additionalScrollHeight,this.E=new L(D.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(D.transformOptimization??m.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(R.Gesture.addTarget(this.o)),this.p=new n.Scrollable({forceIntegerValues:!0,smoothScrollDuration:D.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:q=>(0,i.scheduleAtNextAnimationFrame)(q)}),this.q=this.M.add(new y.SmoothScrollableElement(this.o,{alwaysConsumeMouseWheel:D.alwaysConsumeMouseWheel??m.alwaysConsumeMouseWheel,horizontal:1,vertical:D.verticalScrollMode??m.verticalScrollMode,useShadows:D.useShadows??m.useShadows,mouseWheelScrollSensitivity:D.mouseWheelScrollSensitivity,fastScrollSensitivity:D.fastScrollSensitivity},this.p)),this.domNode.appendChild(this.q.getDomNode()),h.appendChild(this.domNode),this.q.onScroll(this.hb,this,this.M),this.M.add((0,i.addDisposableListener)(this.o,R.EventType.Change,q=>this.ib(q))),this.M.add((0,i.addDisposableListener)(this.q.getDomNode(),"scroll",q=>q.target.scrollTop=0)),this.M.add((0,i.addDisposableListener)(this.domNode,"dragover",q=>this.kb(this.gb(q)))),this.M.add((0,i.addDisposableListener)(this.domNode,"drop",q=>this.mb(this.gb(q)))),this.M.add((0,i.addDisposableListener)(this.domNode,"dragleave",q=>this.lb(this.gb(q)))),this.M.add((0,i.addDisposableListener)(this.domNode,"dragend",q=>this.nb(q))),this.A=D.setRowLineHeight??m.setRowLineHeight,this.B=D.setRowHeight??m.setRowHeight,this.C=D.supportDynamicHeights??m.supportDynamicHeights,this.G=D.dnd??m.dnd,this.layout(D.initialSize?.height,D.initialSize?.width)}updateOptions(h){h.additionalScrollHeight!==void 0&&(this.D=h.additionalScrollHeight,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),h.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(h.smoothScrolling?125:0),h.horizontalScrolling!==void 0&&(this.P=h.horizontalScrolling),h.mouseWheelScrollSensitivity!==void 0&&this.q.updateOptions({mouseWheelScrollSensitivity:h.mouseWheelScrollSensitivity}),h.fastScrollSensitivity!==void 0&&this.q.updateOptions({fastScrollSensitivity:h.fastScrollSensitivity})}delegateScrollFromMouseWheelEvent(h){this.q.delegateScrollFromMouseWheelEvent(h)}delegateVerticalScrollbarPointerDown(h){this.q.delegateVerticalScrollbarPointerDown(h)}updateElementHeight(h,E,p){if(h<0||h>=this.d.length)return;const D=this.d[h].size;if(typeof E>"u"){if(!this.C){console.warn("Dynamic heights not supported");return}this.d[h].lastDynamicHeightWidth=void 0,E=D+this.vb(h)}if(D===E)return;const z=this.tb(this.k,this.m);let q=0;h<z.start||p!==null&&p>h&&p<=z.end?q=E-D:q=0,this.g.splice(h,1,[{size:E}]),this.d[h].size=E,this.W(z,Math.max(0,this.k+q),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.C&&this.ub(this.k,this.m)}splice(h,E,p=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(h,E,p)}finally{this.v=!1,this.N.fire(this.contentHeight)}}R(h,E,p=[]){const D=this.tb(this.k,this.m),z={start:h,end:h+E},q=r.Range.intersect(D,z),ie=new Map;for(let _=q.end-1;_>=q.start;_--){const G=this.d[_];if(G.dragStartDisposable.dispose(),G.checkedDisposable.dispose(),G.row){let P=ie.get(G.templateId);P||(P=[],ie.set(G.templateId,P));const b=this.j.get(G.templateId);b&&b.disposeElement&&b.disposeElement(G.element,_,G.row.templateData,G.size),P.push(G.row)}G.row=null}const J={start:h+E,end:this.d.length},me=r.Range.intersect(J,D),he=r.Range.relativeComplement(J,D),fe=p.map(_=>({id:String(this.f++),element:_,templateId:this.Q.getTemplateId(_),size:this.Q.getHeight(_),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(_),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:I.Disposable.None,checkedDisposable:I.Disposable.None}));let oe;h===0&&E>=this.d.length?(this.g=new e.RangeMap,this.g.splice(0,0,fe),oe=this.d,this.d=fe):(this.g.splice(h,E,fe),oe=this.d.splice(h,E,...fe));const de=p.length-E,Se=this.tb(this.k,this.m),te=(0,e.shift)(me,de),Ce=r.Range.intersect(Se,te);for(let _=Ce.start;_<Ce.end;_++)this.ab(this.d[_],_);const se=r.Range.relativeComplement(te,Se);for(const _ of se)for(let G=_.start;G<_.end;G++)this.bb(G);const x=he.map(_=>(0,e.shift)(_,de)),ne=[{start:h,end:h+p.length},...x].map(_=>r.Range.intersect(Se,_)),F=this.wb(ne);for(const _ of ne)for(let G=_.start;G<_.end;G++){const P=this.d[G],B=ie.get(P.templateId)?.pop();this.X(G,F,B)}for(const _ of ie.values())for(const G of _)this.h.release(G);return this.S(),this.C&&this.ub(this.scrollTop,this.renderHeight),oe.map(_=>_.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,i.scheduleAtNextAnimationFrame)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let h=0;for(const E of this.d)typeof E.width<"u"&&(h=Math.max(h,E.width));this.F=h,this.q.setScrollDimensions({scrollWidth:h===0?0:h+10})}updateWidth(h){if(!this.P||typeof this.F>"u")return;const E=this.d[h];this.Y(E),typeof E.width<"u"&&E.width>this.F&&(this.F=E.width,this.q.setScrollDimensions({scrollWidth:this.F+10}))}rerender(){if(!!this.C){for(const h of this.d)h.lastDynamicHeightWidth=void 0;this.ub(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const h=this.tb(this.k,this.m),E=this.g.positionAt(h.start),p=this.g.positionAt(h.start+1);return p!==-1&&(p-E)/2+E<this.scrollTop?h.start+1:h.start}get lastVisibleIndex(){return this.tb(this.k,this.m).end-1}element(h){return this.d[h].element}indexOf(h){return this.d.findIndex(E=>E.element===h)}domElement(h){const E=this.d[h].row;return E&&E.domNode}elementHeight(h){return this.d[h].size}elementTop(h){return this.g.positionAt(h)}indexAt(h){return this.g.indexAt(h)}indexAfter(h){return this.g.indexAfter(h)}layout(h,E){const p={height:typeof h=="number"?h:(0,i.getContentHeight)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,p.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(p),typeof E<"u"&&(this.n=E,this.C&&this.ub(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof E=="number"?E:(0,i.getContentWidth)(this.domNode)})}W(h,E,p,D,z,q=!1){const ie=this.tb(E,p),J=r.Range.relativeComplement(ie,h),me=r.Range.relativeComplement(h,ie),he=this.wb(J);if(q){const fe=r.Range.intersect(h,ie);for(let oe=fe.start;oe<fe.end;oe++)this.ab(this.d[oe],oe)}for(const fe of J)for(let oe=fe.start;oe<fe.end;oe++)this.X(oe,he);for(const fe of me)for(let oe=fe.start;oe<fe.end;oe++)this.bb(oe);D!==void 0&&(this.o.style.left=`-${D}px`),this.o.style.top=`-${E}px`,this.P&&z!==void 0&&(this.o.style.width=`${Math.max(z,this.n)}px`),this.k=E,this.m=p}X(h,E,p){const D=this.d[h];D.row||(D.row=p??this.h.alloc(D.templateId));const z=this.E.getRole(D.element)||"listitem";D.row.domNode.setAttribute("role",z);const q=this.E.isChecked(D.element);if(typeof q=="boolean")D.row.domNode.setAttribute("aria-checked",String(!!q));else if(q){const me=he=>D.row.domNode.setAttribute("aria-checked",String(!!he));me(q.value),D.checkedDisposable=q.onDidChange(me)}D.row.domNode.parentElement||(E?this.o.insertBefore(D.row.domNode,E):this.o.appendChild(D.row.domNode)),this.ab(D,h);const ie=this.j.get(D.templateId);if(!ie)throw new Error(`No renderer found for template id ${D.templateId}`);ie?.renderElement(D.element,h,D.row.templateData,D.size);const J=this.G.getDragURI(D.element);D.dragStartDisposable.dispose(),D.row.domNode.draggable=!!J,J&&(D.dragStartDisposable=(0,i.addDisposableListener)(D.row.domNode,"dragstart",me=>this.jb(D.element,J,me))),this.P&&(this.Y(D),this.U())}Y(h){if(!h.row||!h.row.domNode)return;h.row.domNode.style.width="fit-content",h.width=(0,i.getContentWidth)(h.row.domNode);const E=window.getComputedStyle(h.row.domNode);E.paddingLeft&&(h.width+=parseFloat(E.paddingLeft)),E.paddingRight&&(h.width+=parseFloat(E.paddingRight)),h.row.domNode.style.width=""}ab(h,E){h.row.domNode.style.top=`${this.elementTop(E)}px`,this.B&&(h.row.domNode.style.height=`${h.size}px`),this.A&&(h.row.domNode.style.lineHeight=`${h.size}px`),h.row.domNode.setAttribute("data-index",`${E}`),h.row.domNode.setAttribute("data-last-element",E===this.length-1?"true":"false"),h.row.domNode.setAttribute("data-parity",E%2===0?"even":"odd"),h.row.domNode.setAttribute("aria-setsize",String(this.E.getSetSize(h.element,E,this.length))),h.row.domNode.setAttribute("aria-posinset",String(this.E.getPosInSet(h.element,E))),h.row.domNode.setAttribute("id",this.getElementDomId(E)),h.row.domNode.classList.toggle("drop-target",h.dropTarget)}bb(h){const E=this.d[h];if(E.dragStartDisposable.dispose(),E.checkedDisposable.dispose(),E.row){const p=this.j.get(E.templateId);p&&p.disposeElement&&p.disposeElement(E.element,h,E.row.templateData,E.size),this.h.release(E.row),E.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(h,E){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:h,reuseAnimation:E})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(h){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.F})),this.q.setScrollPosition({scrollLeft:h})}get scrollTop(){return this.getScrollTop()}set scrollTop(h){this.setScrollTop(h)}get scrollHeight(){return this.s+(this.P?10:0)+this.D}get onMouseClick(){return f.Event.map(this.M.add(new U.DomEmitter(this.domNode,"click")).event,h=>this.db(h),this.M)}get onMouseDblClick(){return f.Event.map(this.M.add(new U.DomEmitter(this.domNode,"dblclick")).event,h=>this.db(h),this.M)}get onMouseMiddleClick(){return f.Event.filter(f.Event.map(this.M.add(new U.DomEmitter(this.domNode,"auxclick")).event,h=>this.db(h),this.M),h=>h.browserEvent.button===1,this.M)}get onMouseUp(){return f.Event.map(this.M.add(new U.DomEmitter(this.domNode,"mouseup")).event,h=>this.db(h),this.M)}get onMouseDown(){return f.Event.map(this.M.add(new U.DomEmitter(this.domNode,"mousedown")).event,h=>this.db(h),this.M)}get onMouseOver(){return f.Event.map(this.M.add(new U.DomEmitter(this.domNode,"mouseover")).event,h=>this.db(h),this.M)}get onMouseMove(){return f.Event.map(this.M.add(new U.DomEmitter(this.domNode,"mousemove")).event,h=>this.db(h),this.M)}get onMouseOut(){return f.Event.map(this.M.add(new U.DomEmitter(this.domNode,"mouseout")).event,h=>this.db(h),this.M)}get onContextMenu(){return f.Event.any(f.Event.map(this.M.add(new U.DomEmitter(this.domNode,"contextmenu")).event,h=>this.db(h),this.M),f.Event.map(this.M.add(new U.DomEmitter(this.domNode,R.EventType.Contextmenu)).event,h=>this.fb(h),this.M))}get onTouchStart(){return f.Event.map(this.M.add(new U.DomEmitter(this.domNode,"touchstart")).event,h=>this.eb(h),this.M)}get onTap(){return f.Event.map(this.M.add(new U.DomEmitter(this.o,R.EventType.Tap)).event,h=>this.fb(h),this.M)}db(h){const E=this.sb(h.target||null),p=typeof E>"u"?void 0:this.d[E],D=p&&p.element;return{browserEvent:h,index:E,element:D}}eb(h){const E=this.sb(h.target||null),p=typeof E>"u"?void 0:this.d[E],D=p&&p.element;return{browserEvent:h,index:E,element:D}}fb(h){const E=this.sb(h.initialTarget||null),p=typeof E>"u"?void 0:this.d[E],D=p&&p.element;return{browserEvent:h,index:E,element:D}}gb(h){const E=this.sb(h.target||null),p=typeof E>"u"?void 0:this.d[E],D=p&&p.element;return{browserEvent:h,index:E,element:D}}hb(h){try{const E=this.tb(this.k,this.m);this.W(E,h.scrollTop,h.height,h.scrollLeft,h.scrollWidth),this.C&&this.ub(h.scrollTop,h.height,h.inSmoothScrolling)}catch(E){throw console.error("Got bad scroll event:",h),E}}ib(h){h.preventDefault(),h.stopPropagation(),this.scrollTop-=h.translationY}jb(h,E,p){if(!p.dataTransfer)return;const D=this.G.getDragElements(h);if(p.dataTransfer.effectAllowed="copyMove",p.dataTransfer.setData(v.DataTransfers.TEXT,E),p.dataTransfer.setDragImage){let z;this.G.getDragLabel&&(z=this.G.getDragLabel(D,p)),typeof z>"u"&&(z=String(D.length));const q=(0,i.$)(".monaco-drag-image");q.textContent=z,document.body.appendChild(q),p.dataTransfer.setDragImage(q,-10,-10),setTimeout(()=>document.body.removeChild(q),0)}this.domNode.classList.add("dragging"),this.I=new o(D),u.CurrentDragAndDropData=new a(D),this.G.onDragStart?.(this.I,p)}kb(h){if(h.browserEvent.preventDefault(),this.L.dispose(),u.CurrentDragAndDropData&&u.CurrentDragAndDropData.getData()==="vscode-ui"||(this.pb(h.browserEvent),!h.browserEvent.dataTransfer))return!1;if(!this.I)if(u.CurrentDragAndDropData)this.I=u.CurrentDragAndDropData;else{if(!h.browserEvent.dataTransfer.types)return!1;this.I=new g}const E=this.G.onDragOver(this.I,h.element,h.index,h.browserEvent);if(this.H=typeof E=="boolean"?E:E.accept,!this.H)return this.J=void 0,this.K.dispose(),!1;h.browserEvent.dataTransfer.dropEffect=typeof E!="boolean"&&E.effect===0?"copy":"move";let p;if(typeof E!="boolean"&&E.feedback?p=E.feedback:typeof h.index>"u"?p=[-1]:p=[h.index],p=(0,w.distinct)(p).filter(D=>D>=-1&&D<this.length).sort((D,z)=>D-z),p=p[0]===-1?[-1]:p,C(this.J,p))return!0;if(this.J=p,this.K.dispose(),p[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.K=(0,I.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const D of p){const z=this.d[D];z.dropTarget=!0,z.row?.domNode.classList.add("drop-target")}this.K=(0,I.toDisposable)(()=>{for(const D of p){const z=this.d[D];z.dropTarget=!1,z.row?.domNode.classList.remove("drop-target")}})}return!0}lb(h){this.L.dispose(),this.L=(0,c.disposableTimeout)(()=>this.ob(),100),this.I&&this.G.onDragLeave?.(this.I,h.element,h.index,h.browserEvent)}mb(h){if(!this.H)return;const E=this.I;this.rb(),this.ob(),this.domNode.classList.remove("dragging"),this.I=void 0,u.CurrentDragAndDropData=void 0,!(!E||!h.browserEvent.dataTransfer)&&(h.browserEvent.preventDefault(),E.update(h.browserEvent.dataTransfer),this.G.drop(E,h.element,h.index,h.browserEvent))}nb(h){this.H=!1,this.rb(),this.ob(),this.domNode.classList.remove("dragging"),this.I=void 0,u.CurrentDragAndDropData=void 0,this.G.onDragEnd?.(h)}ob(){this.J=void 0,this.K.dispose(),this.K=I.Disposable.None}pb(h){if(!this.w){const E=(0,i.getTopLeftOffset)(this.domNode).top;this.w=(0,i.animate)(this.qb.bind(this,E))}this.x.dispose(),this.x=(0,c.disposableTimeout)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3),this.y=h.pageY}qb(h){if(this.y===void 0)return;const E=this.y-h,p=this.renderHeight-35;E<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(E-35))):E>p&&(this.scrollTop+=Math.min(14,Math.floor(.3*(E-p))))}rb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}sb(h){const E=this.q.getDomNode();let p=h;for(;p instanceof HTMLElement&&p!==this.o&&E.contains(p);){const D=p.getAttribute("data-index");if(D){const z=Number(D);if(!isNaN(z))return z}p=p.parentElement}}tb(h,E){return{start:this.g.indexAt(h),end:this.g.indexAfter(h+E-1)}}ub(h,E,p){const D=this.tb(h,E);let z,q;h===this.elementTop(D.start)?(z=D.start,q=0):D.end-D.start>1&&(z=D.start+1,q=this.elementTop(z)-h);let ie=0;for(;;){const J=this.tb(h,E);let me=!1;for(let he=J.start;he<J.end;he++){const fe=this.vb(he);fe!==0&&this.g.splice(he,1,[this.d[he]]),ie+=fe,me=me||fe!==0}if(!me){ie!==0&&this.S();const he=r.Range.relativeComplement(D,J);for(const oe of he)for(let de=oe.start;de<oe.end;de++)this.d[de].row&&this.bb(de);const fe=r.Range.relativeComplement(J,D);for(const oe of fe)for(let de=oe.start;de<oe.end;de++){const Se=de+1,te=Se<this.d.length?this.d[Se].row:null,Ce=te?te.domNode:null;this.X(de,Ce)}for(let oe=J.start;oe<J.end;oe++)this.d[oe].row&&this.ab(this.d[oe],oe);if(typeof z=="number"){const oe=this.p.getFutureScrollPosition().scrollTop-h,de=this.elementTop(z)-q+oe;this.setScrollTop(de,p)}this.N.fire(this.contentHeight);return}}}vb(h){const E=this.d[h];if(this.Q.getDynamicHeight){const q=this.Q.getDynamicHeight(E.element);if(q!==null){const ie=E.size;return E.size=q,E.lastDynamicHeightWidth=this.n,q-ie}}if(!E.hasDynamicHeight||E.lastDynamicHeightWidth===this.n||!!this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(E.element))return 0;const p=E.size;if(E.row)return E.row.domNode.style.height="",E.size=E.row.domNode.offsetHeight,E.lastDynamicHeightWidth=this.n,E.size-p;const D=this.h.alloc(E.templateId);D.domNode.style.height="",this.o.appendChild(D.domNode);const z=this.j.get(E.templateId);if(!z)throw new l.BugIndicatingError("Missing renderer for templateId: "+E.templateId);return z.renderElement(E.element,h,D.templateData,void 0),E.size=D.domNode.offsetHeight,z.disposeElement?.(E.element,h,D.templateData,void 0),this.Q.setDynamicHeight?.(E.element,E.size),E.lastDynamicHeightWidth=this.n,this.o.removeChild(D.domNode),this.h.release(D),E.size-p}wb(h){const E=h[h.length-1];if(!E)return null;const p=this.d[E.end];return!p||!p.row?null:p.row.domNode}getElementDomId(h){return`${this.domId}_${h}`}dispose(){if(this.d){for(const h of this.d)if(h.row){const E=this.j.get(h.row.templateId);E&&(E.disposeElement?.(h.element,-1,h.row.templateData,void 0),E.disposeTemplate(h.row.templateData))}this.d=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,I.dispose)(this.M)}}k.c=0,qe([d.memoize],k.prototype,"onMouseClick",null),qe([d.memoize],k.prototype,"onMouseDblClick",null),qe([d.memoize],k.prototype,"onMouseMiddleClick",null),qe([d.memoize],k.prototype,"onMouseUp",null),qe([d.memoize],k.prototype,"onMouseDown",null),qe([d.memoize],k.prototype,"onMouseOver",null),qe([d.memoize],k.prototype,"onMouseMove",null),qe([d.memoize],k.prototype,"onMouseOut",null),qe([d.memoize],k.prototype,"onContextMenu",null),qe([d.memoize],k.prototype,"onTouchStart",null),qe([d.memoize],k.prototype,"onTap",null),t.ListView=k}),define(be[59],pe([1,0,4,18,19,22,54,68,14,8,24,25,3,33,2,46,27,5,6,67,58,88]),function(Q,t,v,i,U,R,y,w,c,d,f,I,r,n,e,s,l,u,m,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class g{constructor(b){this.d=b,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(b){return b}renderElement(b,B,$){const V=this.c.findIndex(Z=>Z.templateData===$);if(V>=0){const Z=this.c[V];this.d.unrender($),Z.index=B}else{const Z={index:B,templateData:$};this.c.push(Z)}this.d.renderIndex(B,$)}splice(b,B,$){const V=[];for(const Z of this.c)Z.index<b?V.push(Z):Z.index>=b+B&&V.push({index:Z.index+$-B,templateData:Z.templateData});this.c=V}renderIndexes(b){for(const{index:B,templateData:$}of this.c)b.indexOf(B)>-1&&this.d.renderIndex(B,$)}disposeTemplate(b){const B=this.c.findIndex($=>$.templateData===b);B<0||this.c.splice(B,1)}}class C{get name(){return this.h}get renderer(){return new g(this)}constructor(b){this.h=b,this.c=0,this.d=[],this.f=[],this.g=new r.Emitter,this.onChange=this.g.event}splice(b,B,$){B=Math.max(0,Math.min(B,this.c-b));const V=$.length-B,Z=b+B,T=[...this.f.filter(H=>H<b),...$.map((H,A)=>H?A+b:-1).filter(H=>H!==-1),...this.f.filter(H=>H>=Z).map(H=>H+V)],M=this.c+V;if(this.f.length>0&&T.length===0&&M>0){const H=this.f.find(A=>A>=b)??M-1;T.push(Math.min(H,M-1))}this.renderer.splice(b,B,$.length),this.k(T,T),this.c=M}renderIndex(b,B){B.classList.toggle(this.h,this.contains(b))}unrender(b){b.classList.remove(this.h)}set(b,B){return this.k(b,[...b].sort(ue),B)}k(b,B,$){const V=this.d,Z=this.f;this.d=b,this.f=B;const T=se(Z,b);return this.renderer.renderIndexes(T),this.g.fire({indexes:b,browserEvent:$}),V}get(){return this.d}contains(b){return(0,c.binarySearch)(this.f,b,ue)>=0}dispose(){(0,e.dispose)(this.g)}}qe([I.memoize],C.prototype,"renderer",null);class L extends C{constructor(b){super("selected"),this.l=b}renderIndex(b,B){super.renderIndex(b,B),this.l&&(this.contains(b)?B.setAttribute("aria-selected","true"):B.setAttribute("aria-selected","false"))}}class k{constructor(b,B,$){this.c=b,this.d=B,this.f=$}splice(b,B,$){if(!this.f)return this.c.splice(b,B,$.map(()=>!1));const V=this.c.get().map(T=>this.f.getId(this.d.element(T)).toString()),Z=$.map(T=>V.indexOf(this.f.getId(T).toString())>-1);this.c.splice(b,B,Z)}}function S(P){return P.tagName==="INPUT"||P.tagName==="TEXTAREA"}t.isInputElement=S;function h(P){return P.classList.contains("monaco-editor")?!0:P.classList.contains("monaco-list")||!P.parentElement?!1:h(P.parentElement)}t.isMonacoEditor=h;function E(P){return P.tagName==="A"&&P.classList.contains("monaco-button")||P.tagName==="DIV"&&P.classList.contains("monaco-button-dropdown")?!0:P.classList.contains("monaco-list")||!P.parentElement?!1:E(P.parentElement)}t.isButton=E;class p{get f(){return this.c.add(r.Event.chain(this.c.add(new i.DomEmitter(this.h.domNode,"keydown")).event).filter(b=>!S(b.target)).map(b=>new U.StandardKeyboardEvent(b)))}constructor(b,B,$){this.g=b,this.h=B,this.c=new e.DisposableStore,this.d=new e.DisposableStore,this.f.filter(V=>V.keyCode===3).on(this.k,this,this.c),this.f.filter(V=>V.keyCode===16).on(this.l,this,this.c),this.f.filter(V=>V.keyCode===18).on(this.o,this,this.c),this.f.filter(V=>V.keyCode===11).on(this.p,this,this.c),this.f.filter(V=>V.keyCode===12).on(this.q,this,this.c),this.f.filter(V=>V.keyCode===9).on(this.t,this,this.c),$.multipleSelectionSupport!==!1&&this.f.filter(V=>(u.isMacintosh?V.metaKey:V.ctrlKey)&&V.keyCode===31).on(this.s,this,this.d)}updateOptions(b){b.multipleSelectionSupport!==void 0&&(this.d.clear(),b.multipleSelectionSupport&&this.f.filter(B=>(u.isMacintosh?B.metaKey:B.ctrlKey)&&B.keyCode===31).on(this.s,this,this.d))}k(b){b.preventDefault(),b.stopPropagation(),this.g.setSelection(this.g.getFocus(),b.browserEvent)}l(b){b.preventDefault(),b.stopPropagation(),this.g.focusPrevious(1,!1,b.browserEvent);const B=this.g.getFocus()[0];this.g.setAnchor(B),this.g.reveal(B),this.h.domNode.focus()}o(b){b.preventDefault(),b.stopPropagation(),this.g.focusNext(1,!1,b.browserEvent);const B=this.g.getFocus()[0];this.g.setAnchor(B),this.g.reveal(B),this.h.domNode.focus()}p(b){b.preventDefault(),b.stopPropagation(),this.g.focusPreviousPage(b.browserEvent);const B=this.g.getFocus()[0];this.g.setAnchor(B),this.g.reveal(B),this.h.domNode.focus()}q(b){b.preventDefault(),b.stopPropagation(),this.g.focusNextPage(b.browserEvent);const B=this.g.getFocus()[0];this.g.setAnchor(B),this.g.reveal(B),this.h.domNode.focus()}s(b){b.preventDefault(),b.stopPropagation(),this.g.setSelection((0,c.range)(this.g.length),b.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus()}t(b){this.g.getSelection().length&&(b.preventDefault(),b.stopPropagation(),this.g.setSelection([],b.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}qe([I.memoize],p.prototype,"f",null);var D;(function(P){P[P.Automatic=0]="Automatic",P[P.Trigger=1]="Trigger"})(D=t.TypeNavigationMode||(t.TypeNavigationMode={}));var z;(function(P){P[P.Idle=0]="Idle",P[P.Typing=1]="Typing"})(z||(z={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(P){return P.ctrlKey||P.metaKey||P.altKey?!1:P.keyCode>=31&&P.keyCode<=56||P.keyCode>=21&&P.keyCode<=30||P.keyCode>=93&&P.keyCode<=102||P.keyCode>=80&&P.keyCode<=90}};class q{constructor(b,B,$,V,Z){this.o=b,this.p=B,this.q=$,this.s=V,this.t=Z,this.c=!1,this.d=z.Idle,this.f=D.Automatic,this.g=!1,this.h=-1,this.k=new e.DisposableStore,this.l=new e.DisposableStore,this.updateOptions(b.options)}updateOptions(b){b.typeNavigationEnabled??!0?this.u():this.v(),this.f=b.typeNavigationMode??D.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let b=!1;const B=this.k.add(r.Event.chain(this.k.add(new i.DomEmitter(this.p.domNode,"keydown")).event)).filter(Z=>!S(Z.target)).filter(()=>this.f===D.Automatic||this.g).map(Z=>new U.StandardKeyboardEvent(Z)).filter(Z=>b||this.s(Z)).filter(Z=>this.t.mightProducePrintableCharacter(Z)).forEach(Z=>v.EventHelper.stop(Z,!0)).map(Z=>Z.browserEvent.key).event,$=r.Event.debounce(B,()=>null,800,void 0,void 0,this.k);r.Event.reduce(r.Event.any(B,$),(Z,T)=>T===null?null:(Z||"")+T,void 0,this.k)(this.A,this,this.k),$(this.w,this,this.k),B(()=>b=!0,void 0,this.k),$(()=>b=!1,void 0,this.k),this.c=!0,this.g=!1}v(){!this.c||(this.k.clear(),this.c=!1,this.g=!1)}w(){const b=this.o.getFocus();if(b.length>0&&b[0]===this.h){const B=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(b[0]));B&&(0,y.alert)(B)}this.h=-1}A(b){if(!b){this.d=z.Idle,this.g=!1;return}const B=this.o.getFocus(),$=B.length>0?B[0]:0,V=this.d===z.Idle?1:0;this.d=z.Typing;for(let Z=0;Z<this.o.length;Z++){const T=($+Z+V)%this.o.length,M=this.q.getKeyboardNavigationLabel(this.p.element(T)),H=M&&M.toString();if(typeof H>"u"||(0,n.matchesPrefix)(b,H)){this.h=$,this.o.setFocus([T]),this.o.reveal(T);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ie{constructor(b,B){this.d=b,this.f=B,this.c=new e.DisposableStore,this.c.add(r.Event.chain(this.c.add(new i.DomEmitter(B.domNode,"keydown")).event)).filter(V=>!S(V.target)).map(V=>new U.StandardKeyboardEvent(V)).filter(V=>V.keyCode===2&&!V.ctrlKey&&!V.metaKey&&!V.shiftKey&&!V.altKey).on(this.g,this,this.c)}g(b){if(b.target!==this.f.domNode)return;const B=this.d.getFocus();if(B.length===0)return;const $=this.f.domElement(B[0]);if(!$)return;const V=$.querySelector("[tabIndex]");if(!V||!(V instanceof HTMLElement)||V.tabIndex===-1)return;const Z=window.getComputedStyle(V);Z.visibility==="hidden"||Z.display==="none"||(b.preventDefault(),b.stopPropagation(),V.focus())}dispose(){this.c.dispose()}}function J(P){return u.isMacintosh?P.browserEvent.metaKey:P.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=J;function me(P){return P.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=me;function he(P){return P instanceof MouseEvent&&P.button===2}const fe={isSelectionSingleChangeEvent:J,isSelectionRangeChangeEvent:me};class oe{constructor(b){this.k=b,this.f=new e.DisposableStore,this.g=new r.Emitter,this.onPointer=this.g.event,b.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||fe),this.d=typeof b.options.mouseSupport>"u"||!!b.options.mouseSupport,this.d&&(b.onMouseDown(this.s,this,this.f),b.onContextMenu(this.t,this,this.f),b.onMouseDblClick(this.v,this,this.f),b.onTouchStart(this.s,this,this.f),this.f.add(R.Gesture.addTarget(b.getHTMLElement()))),r.Event.any(b.onMouseClick,b.onMouseMiddleClick,b.onTap)(this.u,this,this.f)}updateOptions(b){b.multipleSelectionSupport!==void 0&&(this.c=void 0,b.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||fe))}o(b){return this.c?this.c.isSelectionSingleChangeEvent(b):!1}p(b){return this.c?this.c.isSelectionRangeChangeEvent(b):!1}q(b){return this.o(b)||this.p(b)}s(b){h(b.browserEvent.target)||document.activeElement!==b.browserEvent.target&&this.k.domFocus()}t(b){if(h(b.browserEvent.target))return;const B=typeof b.index>"u"?[]:[b.index];this.k.setFocus(B,b.browserEvent)}u(b){if(!this.d||S(b.browserEvent.target)||h(b.browserEvent.target))return;const B=b.index;if(typeof B>"u"){this.k.setFocus([],b.browserEvent),this.k.setSelection([],b.browserEvent),this.k.setAnchor(void 0);return}if(this.p(b))return this.w(b);if(this.q(b))return this.w(b);this.k.setFocus([B],b.browserEvent),this.k.setAnchor(B),he(b.browserEvent)||this.k.setSelection([B],b.browserEvent),this.g.fire(b)}v(b){if(S(b.browserEvent.target)||h(b.browserEvent.target)||this.q(b))return;const B=this.k.getFocus();this.k.setSelection(B,b.browserEvent)}w(b){const B=b.index;let $=this.k.getAnchor();if(this.p(b)){typeof $>"u"&&($=this.k.getFocus()[0]??B,this.k.setAnchor($));const V=Math.min($,B),Z=Math.max($,B),T=(0,c.range)(V,Z+1),M=this.k.getSelection(),H=Ce(se(M,[$]),$);if(H.length===0)return;const A=se(T,x(M,H));this.k.setSelection(A,b.browserEvent),this.k.setFocus([B],b.browserEvent)}else if(this.o(b)){const V=this.k.getSelection(),Z=V.filter(T=>T!==B);this.k.setFocus([B]),this.k.setAnchor(B),V.length===Z.length?this.k.setSelection([...Z,B],b.browserEvent):this.k.setSelection(Z,b.browserEvent)}}dispose(){this.f.dispose()}}t.MouseController=oe;class de{constructor(b,B){this.c=b,this.d=B}style(b){const B=this.d&&`.${this.d}`,$=[];b.listBackground&&(b.listBackground.isOpaque()?$.push(`.monaco-list${B} .monaco-list-rows { background: ${b.listBackground}; }`):u.isMacintosh||console.warn(`List with id '${this.d}' was styled with a non-opaque background color. This will break sub-pixel antialiasing.`)),b.listFocusBackground&&($.push(`.monaco-list${B}:focus .monaco-list-row.focused { background-color: ${b.listFocusBackground}; }`),$.push(`.monaco-list${B}:focus .monaco-list-row.focused:hover { background-color: ${b.listFocusBackground}; }`)),b.listFocusForeground&&$.push(`.monaco-list${B}:focus .monaco-list-row.focused { color: ${b.listFocusForeground}; }`),b.listActiveSelectionBackground&&($.push(`.monaco-list${B}:focus .monaco-list-row.selected { background-color: ${b.listActiveSelectionBackground}; }`),$.push(`.monaco-list${B}:focus .monaco-list-row.selected:hover { background-color: ${b.listActiveSelectionBackground}; }`)),b.listActiveSelectionForeground&&$.push(`.monaco-list${B}:focus .monaco-list-row.selected { color: ${b.listActiveSelectionForeground}; }`),b.listActiveSelectionIconForeground&&$.push(`.monaco-list${B}:focus .monaco-list-row.selected .codicon { color: ${b.listActiveSelectionIconForeground}; }`),b.listFocusAndSelectionOutline&&$.push(`.monaco-list${B}:focus .monaco-list-row.selected { outline-color: ${b.listFocusAndSelectionOutline} !important; }`),b.listFocusAndSelectionBackground&&$.push(`
				.monaco-drag-image,
				.monaco-list${B}:focus .monaco-list-row.selected.focused { background-color: ${b.listFocusAndSelectionBackground}; }
			`),b.listFocusAndSelectionForeground&&$.push(`
				.monaco-drag-image,
				.monaco-list${B}:focus .monaco-list-row.selected.focused { color: ${b.listFocusAndSelectionForeground}; }
			`),b.listInactiveFocusForeground&&($.push(`.monaco-list${B} .monaco-list-row.focused { color:  ${b.listInactiveFocusForeground}; }`),$.push(`.monaco-list${B} .monaco-list-row.focused:hover { color:  ${b.listInactiveFocusForeground}; }`)),b.listInactiveSelectionIconForeground&&$.push(`.monaco-list${B} .monaco-list-row.focused .codicon { color:  ${b.listInactiveSelectionIconForeground}; }`),b.listInactiveFocusBackground&&($.push(`.monaco-list${B} .monaco-list-row.focused { background-color:  ${b.listInactiveFocusBackground}; }`),$.push(`.monaco-list${B} .monaco-list-row.focused:hover { background-color:  ${b.listInactiveFocusBackground}; }`)),b.listInactiveSelectionBackground&&($.push(`.monaco-list${B} .monaco-list-row.selected { background-color:  ${b.listInactiveSelectionBackground}; }`),$.push(`.monaco-list${B} .monaco-list-row.selected:hover { background-color:  ${b.listInactiveSelectionBackground}; }`)),b.listInactiveSelectionForeground&&$.push(`.monaco-list${B} .monaco-list-row.selected { color: ${b.listInactiveSelectionForeground}; }`),b.listHoverBackground&&$.push(`.monaco-list${B}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${b.listHoverBackground}; }`),b.listHoverForeground&&$.push(`.monaco-list${B}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${b.listHoverForeground}; }`),b.listSelectionOutline&&$.push(`.monaco-list${B} .monaco-list-row.selected { outline: 1px dotted ${b.listSelectionOutline}; outline-offset: -1px; }`),b.listFocusOutline&&$.push(`
				.monaco-drag-image,
				.monaco-list${B}:focus .monaco-list-row.focused { outline: 1px solid ${b.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${B}.last-focused .monaco-list-row.focused { outline: 1px solid ${b.listFocusOutline}; outline-offset: -1px; }
			`),b.listInactiveFocusOutline&&$.push(`.monaco-list${B} .monaco-list-row.focused { outline: 1px dotted ${b.listInactiveFocusOutline}; outline-offset: -1px; }`),b.listHoverOutline&&$.push(`.monaco-list${B} .monaco-list-row:hover { outline: 1px dashed ${b.listHoverOutline}; outline-offset: -1px; }`),b.listDropBackground&&$.push(`
				.monaco-list${B}.drop-target,
				.monaco-list${B} .monaco-list-rows.drop-target,
				.monaco-list${B} .monaco-list-row.drop-target { background-color: ${b.listDropBackground} !important; color: inherit !important; }
			`),b.tableColumnsBorder&&$.push(`
				.monaco-table:hover > .monaco-split-view2,
				.monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${b.tableColumnsBorder};
			}`),b.tableOddRowsBackgroundColor&&$.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${b.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=$.join(`
`)}}t.DefaultStyleController=de;const Se={listFocusBackground:f.Color.fromHex("#7FB0D0"),listActiveSelectionBackground:f.Color.fromHex("#0E639C"),listActiveSelectionForeground:f.Color.fromHex("#FFFFFF"),listActiveSelectionIconForeground:f.Color.fromHex("#FFFFFF"),listFocusAndSelectionOutline:f.Color.fromHex("#90C2F9"),listFocusAndSelectionBackground:f.Color.fromHex("#094771"),listFocusAndSelectionForeground:f.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:f.Color.fromHex("#3F3F46"),listInactiveSelectionIconForeground:f.Color.fromHex("#FFFFFF"),listHoverBackground:f.Color.fromHex("#2A2D2E"),listDropBackground:f.Color.fromHex("#383B3D"),treeIndentGuidesStroke:f.Color.fromHex("#a9a9a9"),tableColumnsBorder:f.Color.fromHex("#cccccc").transparent(.2),tableOddRowsBackgroundColor:f.Color.fromHex("#cccccc").transparent(.04)},te={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function Ce(P,b){const B=P.indexOf(b);if(B===-1)return[];const $=[];let V=B-1;for(;V>=0&&P[V]===b-(B-V);)$.push(P[V--]);for($.reverse(),V=B;V<P.length&&P[V]===b+(V-B);)$.push(P[V++]);return $}function se(P,b){const B=[];let $=0,V=0;for(;$<P.length||V<b.length;)if($>=P.length)B.push(b[V++]);else if(V>=b.length)B.push(P[$++]);else if(P[$]===b[V]){B.push(P[$]),$++,V++;continue}else P[$]<b[V]?B.push(P[$++]):B.push(b[V++]);return B}function x(P,b){const B=[];let $=0,V=0;for(;$<P.length||V<b.length;)if($>=P.length)B.push(b[V++]);else if(V>=b.length)B.push(P[$++]);else if(P[$]===b[V]){$++,V++;continue}else P[$]<b[V]?B.push(P[$++]):V++;return B}const ue=(P,b)=>P-b;class ne{constructor(b,B){this.c=b,this.d=B}get templateId(){return this.c}renderTemplate(b){return this.d.map(B=>B.renderTemplate(b))}renderElement(b,B,$,V){let Z=0;for(const T of this.d)T.renderElement(b,B,$[Z++],V)}disposeElement(b,B,$,V){let Z=0;for(const T of this.d)T.disposeElement?.(b,B,$[Z],V),Z+=1}disposeTemplate(b){let B=0;for(const $ of this.d)$.disposeTemplate(b[B++])}}class F{constructor(b){this.c=b,this.templateId="a18n"}renderTemplate(b){return b}renderElement(b,B,$){const V=this.c.getAriaLabel(b);V?$.setAttribute("aria-label",V):$.removeAttribute("aria-label");const Z=this.c.getAriaLevel&&this.c.getAriaLevel(b);typeof Z=="number"?$.setAttribute("aria-level",`${Z}`):$.removeAttribute("aria-level")}disposeTemplate(b){}}class _{constructor(b,B){this.c=b,this.d=B}getDragElements(b){const B=this.c.getSelectedElements();return B.indexOf(b)>-1?B:[b]}getDragURI(b){return this.d.getDragURI(b)}getDragLabel(b,B){if(this.d.getDragLabel)return this.d.getDragLabel(b,B)}onDragStart(b,B){this.d.onDragStart?.(b,B)}onDragOver(b,B,$,V){return this.d.onDragOver(b,B,$,V)}onDragLeave(b,B,$,V){this.d.onDragLeave?.(b,B,$,V)}onDragEnd(b){this.d.onDragEnd?.(b)}drop(b,B,$,V){this.d.drop(b,B,$,V)}}class G{get onDidChangeFocus(){return r.Event.map(this.g.wrapEvent(this.c.onChange),b=>this.I(b),this.B)}get onDidChangeSelection(){return r.Event.map(this.g.wrapEvent(this.d.onChange),b=>this.I(b),this.B)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let b=!1;const B=this.B.add(r.Event.chain(this.B.add(new i.DomEmitter(this.k.domNode,"keydown")).event)).map(Z=>new U.StandardKeyboardEvent(Z)).filter(Z=>b=Z.keyCode===58||Z.shiftKey&&Z.keyCode===68).map(Z=>v.EventHelper.stop(Z,!0)).filter(()=>!1).event,$=this.B.add(r.Event.chain(this.B.add(new i.DomEmitter(this.k.domNode,"keyup")).event)).forEach(()=>b=!1).map(Z=>new U.StandardKeyboardEvent(Z)).filter(Z=>Z.keyCode===58||Z.shiftKey&&Z.keyCode===68).map(Z=>v.EventHelper.stop(Z,!0)).map(({browserEvent:Z})=>{const T=this.getFocus(),M=T.length?T[0]:void 0,H=typeof M<"u"?this.k.element(M):void 0,A=typeof M<"u"?this.k.domElement(M):this.k.domNode;return{index:M,element:H,anchor:A,browserEvent:Z}}).event,V=this.B.add(r.Event.chain(this.k.onContextMenu)).filter(Z=>!b).map(({element:Z,index:T,browserEvent:M})=>({element:Z,index:T,anchor:{x:M.pageX+1,y:M.pageY},browserEvent:M})).event;return r.Event.any(B,$,V)}get onKeyDown(){return this.B.add(new i.DomEmitter(this.k.domNode,"keydown")).event}get onKeyUp(){return this.B.add(new i.DomEmitter(this.k.domNode,"keyup")).event}get onKeyPress(){return this.B.add(new i.DomEmitter(this.k.domNode,"keypress")).event}get onDidFocus(){return r.Event.signal(this.B.add(new i.DomEmitter(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return r.Event.signal(this.B.add(new i.DomEmitter(this.k.domNode,"blur",!0)).event)}constructor(b,B,$,V,Z=te){this.D=b,this.E=Z,this.c=new C("focused"),this.f=new C("anchor"),this.g=new r.EventBufferer,this.A="",this.B=new e.DisposableStore,this.C=new r.Emitter,this.onDidDispose=this.C.event;const T=this.E.accessibilityProvider&&this.E.accessibilityProvider.getWidgetRole?this.E.accessibilityProvider?.getWidgetRole():"list";this.d=new L(T!=="listbox"),(0,l.mixin)(Z,Se,!1);const M=[this.c.renderer,this.d.renderer];this.u=Z.accessibilityProvider,this.u&&(M.push(new F(this.u)),this.u.onDidChangeActiveDescendant?.(this.K,this,this.B)),V=V.map(A=>new ne(A.templateId,[...M,A]));const H={...Z,dnd:Z.dnd&&new _(this,Z.dnd)};if(this.k=new a.ListView(B,$,V,H),this.k.domNode.setAttribute("role",T),Z.styleController)this.q=Z.styleController(this.k.domId);else{const A=(0,v.createStyleSheet)(this.k.domNode);this.q=new de(A,this.k.domId)}if(this.o=new w.CombinedSpliceable([new k(this.c,this.k,Z.identityProvider),new k(this.d,this.k,Z.identityProvider),new k(this.f,this.k,Z.identityProvider),this.k]),this.B.add(this.c),this.B.add(this.d),this.B.add(this.f),this.B.add(this.k),this.B.add(this.C),this.B.add(new ie(this,this.k)),(typeof Z.keyboardSupport!="boolean"||Z.keyboardSupport)&&(this.v=new p(this,this.k,Z),this.B.add(this.v)),Z.keyboardNavigationLabelProvider){const A=Z.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.t=new q(this,this.k,Z.keyboardNavigationLabelProvider,Z.keyboardNavigationEventFilter??(()=>!0),A),this.B.add(this.t)}this.w=this.F(Z),this.B.add(this.w),this.onDidChangeFocus(this.J,this,this.B),this.onDidChangeSelection(this.L,this,this.B),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.E.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}F(b){return new oe(this)}updateOptions(b={}){this.E={...this.E,...b},this.t?.updateOptions(this.E),this.E.multipleSelectionController!==void 0&&(this.E.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(b),this.v?.updateOptions(b),this.k.updateOptions(b)}get options(){return this.E}splice(b,B,$=[]){if(b<0||b>this.k.length)throw new o.ListError(this.D,`Invalid start index: ${b}`);if(B<0)throw new o.ListError(this.D,`Invalid delete count: ${B}`);B===0&&$.length===0||this.g.bufferEvents(()=>this.o.splice(b,B,$))}updateWidth(b){this.k.updateWidth(b)}updateElementHeight(b,B){this.k.updateElementHeight(b,B,null)}rerender(){this.k.rerender()}element(b){return this.k.element(b)}indexOf(b){return this.k.indexOf(b)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get scrollTop(){return this.k.getScrollTop()}set scrollTop(b){this.k.setScrollTop(b)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(b){this.k.setScrollLeft(b)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.A}set ariaLabel(b){this.A=b,this.k.domNode.setAttribute("aria-label",b)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(b,B){this.k.layout(b,B)}triggerTypeNavigation(){this.t?.trigger()}setSelection(b,B){for(const $ of b)if($<0||$>=this.length)throw new o.ListError(this.D,`Invalid index ${$}`);this.d.set(b,B)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(b=>this.k.element(b))}setAnchor(b){if(typeof b>"u"){this.f.set([]);return}if(b<0||b>=this.length)throw new o.ListError(this.D,`Invalid index ${b}`);this.f.set([b])}getAnchor(){return(0,c.firstOrDefault)(this.f.get(),void 0)}getAnchorElement(){const b=this.getAnchor();return typeof b>"u"?void 0:this.element(b)}setFocus(b,B){for(const $ of b)if($<0||$>=this.length)throw new o.ListError(this.D,`Invalid index ${$}`);this.c.set(b,B)}focusNext(b=1,B=!1,$,V){if(this.length===0)return;const Z=this.c.get(),T=this.G(Z.length>0?Z[0]+b:0,B,V);T>-1&&this.setFocus([T],$)}focusPrevious(b=1,B=!1,$,V){if(this.length===0)return;const Z=this.c.get(),T=this.H(Z.length>0?Z[0]-b:0,B,V);T>-1&&this.setFocus([T],$)}async focusNextPage(b,B){let $=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);$=$===0?0:$-1;const V=this.getFocus()[0];if(V!==$&&(V===void 0||$>V)){const Z=this.H($,!1,B);Z>-1&&V!==Z?this.setFocus([Z],b):this.setFocus([$],b)}else{const Z=this.k.getScrollTop();let T=Z+this.k.renderHeight;$>V&&(T-=this.k.elementHeight($)),this.k.setScrollTop(T),this.k.getScrollTop()!==Z&&(this.setFocus([]),await(0,d.timeout)(0),await this.focusNextPage(b,B))}}async focusPreviousPage(b,B){let $;const V=this.k.getScrollTop();V===0?$=this.k.indexAt(V):$=this.k.indexAfter(V-1);const Z=this.getFocus()[0];if(Z!==$&&(Z===void 0||Z>=$)){const T=this.G($,!1,B);T>-1&&Z!==T?this.setFocus([T],b):this.setFocus([$],b)}else{const T=V;this.k.setScrollTop(V-this.k.renderHeight),this.k.getScrollTop()!==T&&(this.setFocus([]),await(0,d.timeout)(0),await this.focusPreviousPage(b,B))}}focusLast(b,B){if(this.length===0)return;const $=this.H(this.length-1,!1,B);$>-1&&this.setFocus([$],b)}focusFirst(b,B){this.focusNth(0,b,B)}focusNth(b,B,$){if(this.length===0)return;const V=this.G(b,!1,$);V>-1&&this.setFocus([V],B)}G(b,B=!1,$){for(let V=0;V<this.length;V++){if(b>=this.length&&!B)return-1;if(b=b%this.length,!$||$(this.element(b)))return b;b++}return-1}H(b,B=!1,$){for(let V=0;V<this.length;V++){if(b<0&&!B)return-1;if(b=(this.length+b%this.length)%this.length,!$||$(this.element(b)))return b;b--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(b=>this.k.element(b))}reveal(b,B){if(b<0||b>=this.length)throw new o.ListError(this.D,`Invalid index ${b}`);const $=this.k.getScrollTop(),V=this.k.elementTop(b),Z=this.k.elementHeight(b);if((0,m.isNumber)(B)){const T=Z-this.k.renderHeight;this.k.setScrollTop(T*(0,s.clamp)(B,0,1)+V)}else{const T=V+Z,M=$+this.k.renderHeight;V<$&&T>=M||(V<$||T>=M&&Z>=this.k.renderHeight?this.k.setScrollTop(V):T>=M&&this.k.setScrollTop(T-this.k.renderHeight))}}getRelativeTop(b){if(b<0||b>=this.length)throw new o.ListError(this.D,`Invalid index ${b}`);const B=this.k.getScrollTop(),$=this.k.elementTop(b),V=this.k.elementHeight(b);if($<B||$+V>B+this.k.renderHeight)return null;const Z=V-this.k.renderHeight;return Math.abs((B-$)/Z)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(b){return this.k.getElementDomId(b)}style(b){this.q.style(b)}I({indexes:b,browserEvent:B}){return{indexes:b,elements:b.map($=>this.k.element($)),browserEvent:B}}J(){const b=this.c.get();this.k.domNode.classList.toggle("element-focused",b.length>0),this.K()}K(){const b=this.c.get();if(b.length>0){let B;this.u?.getActiveDescendantId&&(B=this.u.getActiveDescendantId(this.k.element(b[0]))),this.k.domNode.setAttribute("aria-activedescendant",B||this.k.getElementDomId(b[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}L(){const b=this.d.get();this.k.domNode.classList.toggle("selection-none",b.length===0),this.k.domNode.classList.toggle("selection-single",b.length===1),this.k.domNode.classList.toggle("selection-multiple",b.length>1)}dispose(){this.C.fire(),this.B.dispose(),this.C.dispose()}}qe([I.memoize],G.prototype,"onDidChangeFocus",null),qe([I.memoize],G.prototype,"onDidChangeSelection",null),qe([I.memoize],G.prototype,"onContextMenu",null),qe([I.memoize],G.prototype,"onKeyDown",null),qe([I.memoize],G.prototype,"onKeyUp",null),qe([I.memoize],G.prototype,"onKeyPress",null),qe([I.memoize],G.prototype,"onDidFocus",null),qe([I.memoize],G.prototype,"onDidBlur",null),t.List=G}),define(be[60],pe([1,0,9,34,36,11,15]),function(Q,t,v,i,U,R,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var w;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(w=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class c{constructor(u="",m=!1){if(this.value=u,typeof this.value!="string")throw(0,v.illegalArgument)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=m.isTrusted??void 0,this.supportThemeIcons=m.supportThemeIcons??!1,this.supportHtml=m.supportHtml??!1)}appendText(u,m=0){return this.value+=r(this.supportThemeIcons?(0,i.escapeIcons)(u):u).replace(/([ \t]+)/g,(o,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,m===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,m){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=m,this.value+="\n```\n",this}appendLink(u,m,o){return this.value+="[",this.value+=this.c(m,"]"),this.value+="](",this.value+=this.c(String(u),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(u,m){const o=new RegExp((0,R.escapeRegExpCharacters)(m),"g");return u.replace(o,(a,g)=>u.charAt(g-1)!=="\\"?`\\${a}`:a)}}t.MarkdownString=c;function d(l){return f(l)?!l.value:Array.isArray(l)?l.every(d):!0}t.isEmptyMarkdownString=d;function f(l){return l instanceof c?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}t.isMarkdownString=f;function I(l,u){return l===u?!0:!l||!u?!1:l.value===u.value&&l.isTrusted===u.isTrusted&&l.supportThemeIcons===u.supportThemeIcons&&l.supportHtml===u.supportHtml&&(l.baseUri===u.baseUri||!!l.baseUri&&!!u.baseUri&&(0,U.isEqual)(y.URI.from(l.baseUri),y.URI.from(u.baseUri)))}t.markdownStringEqual=I;function r(l){return l.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=r;function n(l){return l.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=n;function e(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}t.removeMarkdownEscapes=e;function s(l){const u=[],m=l.split("|").map(a=>a.trim());l=m[0];const o=m[1];if(o){const a=/height=(\d+)/.exec(o),g=/width=(\d+)/.exec(o),C=a?a[1]:"",L=g?g[1]:"",k=isFinite(parseInt(L)),S=isFinite(parseInt(C));k&&u.push(`width="${L}"`),S&&u.push(`height="${C}"`)}return{href:l,dimensions:u}}t.parseHrefAndDimensions=s}),define(be[121],pe([1,0,4,113,18,52,20,114,9,3,60,34,72,44,2,75,50,35,27,36,11,15]),function(Q,t,v,i,U,R,y,w,c,d,f,I,r,n,e,s,l,u,m,o,a,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const C=Object.freeze({image:(ie,J,me)=>{let he=[],fe=[];return ie&&({href:ie,dimensions:he}=(0,f.parseHrefAndDimensions)(ie),fe.push(`src="${(0,f.escapeDoubleQuotes)(ie)}"`)),me&&fe.push(`alt="${(0,f.escapeDoubleQuotes)(me)}"`),J&&fe.push(`title="${(0,f.escapeDoubleQuotes)(J)}"`),he.length&&(fe=fe.concat(he)),"<img "+fe.join(" ")+">"},paragraph:ie=>`<p>${ie}</p>`,link:(ie,J,me)=>typeof ie!="string"?"":(ie===me&&(me=(0,f.removeMarkdownEscapes)(me)),J=typeof J=="string"?(0,f.escapeDoubleQuotes)((0,f.removeMarkdownEscapes)(J)):"",ie=(0,f.removeMarkdownEscapes)(ie),ie=ie.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${ie}" title="${J||ie}">${me}</a>`)});function L(ie,J={},me={}){const he=new e.DisposableStore;let fe=!1;const oe=(0,R.createElement)(J),de=function(F){let _;try{_=(0,l.parse)(decodeURIComponent(F))}catch{}return _?(_=(0,m.cloneAndChange)(_,G=>{if(ie.uris&&ie.uris[G])return g.URI.revive(ie.uris[G])}),encodeURIComponent(JSON.stringify(_))):F},Se=function(F,_){const G=ie.uris&&ie.uris[F];let P=g.URI.revive(G);return _?F.startsWith(u.Schemas.data+":")?F:(P||(P=g.URI.parse(F)),u.FileAccess.uriToBrowserUri(P).toString(!0)):!P||g.URI.parse(F).toString()===P.toString()?F:(P.query&&(P=P.with({query:de(P.query)})),P.toString())},te=new s.marked.Renderer;te.image=C.image,te.link=C.link,te.paragraph=C.paragraph;const Ce=[];if(J.codeBlockRenderer&&(te.code=(F,_)=>{const G=r.defaultGenerator.nextId(),P=J.codeBlockRenderer(k(_),F);return Ce.push(P.then(b=>[G,b])),`<div class="code" data-code="${G}">${(0,a.escape)(F)}</div>`}),J.actionHandler){const F=J.actionHandler.disposables.add(new U.DomEmitter(oe,"click")),_=J.actionHandler.disposables.add(new U.DomEmitter(oe,"auxclick"));J.actionHandler.disposables.add(d.Event.any(F.event,_.event)(G=>{const P=new y.StandardMouseEvent(G);if(!P.leftButton&&!P.middleButton)return;let b=P.target;if(!(b.tagName!=="A"&&(b=b.parentElement,!b||b.tagName!=="A")))try{let B=b.dataset.href;B&&(ie.baseUri&&(B=S(g.URI.from(ie.baseUri),B)),J.actionHandler.callback(B,P))}catch(B){(0,c.onUnexpectedError)(B)}finally{P.preventDefault()}}))}ie.supportHtml||(me.sanitizer=F=>(ie.isTrusted?F.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?F:"",me.sanitize=!0,me.silent=!0),me.renderer=te;let se=ie.value??"";se.length>1e5&&(se=`${se.substr(0,1e5)}\u2026`),ie.supportThemeIcons&&(se=(0,I.markdownEscapeEscapedIcons)(se));let x=s.marked.parse(se,me);ie.supportThemeIcons&&(x=(0,w.renderLabelWithIcons)(x).map(_=>typeof _=="string"?_:_.outerHTML).join(""));const ne=new DOMParser().parseFromString(h(ie,x),"text/html");if(ne.body.querySelectorAll("img").forEach(F=>{const _=F.getAttribute("src");if(_){let G=_;try{ie.baseUri&&(G=S(g.URI.from(ie.baseUri),G))}catch{}F.src=Se(G,!0)}}),ne.body.querySelectorAll("a").forEach(F=>{const _=F.getAttribute("href");if(F.setAttribute("href",""),!_||/^data:|javascript:/i.test(_)||/^command:/i.test(_)&&!ie.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(_))F.replaceWith(...F.childNodes);else{let G=Se(_,!1);ie.baseUri&&(G=S(g.URI.from(ie.baseUri),_)),F.dataset.href=G}}),oe.innerHTML=h(ie,ne.body.innerHTML),Ce.length>0&&Promise.all(Ce).then(F=>{if(fe)return;const _=new Map(F),G=oe.querySelectorAll("div[data-code]");for(const P of G){const b=_.get(P.dataset.code??"");b&&v.reset(P,b)}J.asyncRenderCallback?.()}),J.asyncRenderCallback)for(const F of oe.getElementsByTagName("img")){const _=he.add(v.addDisposableListener(F,"load",()=>{_.dispose(),J.asyncRenderCallback()}))}return{element:oe,dispose:()=>{fe=!0,he.dispose()}}}t.renderMarkdown=L;function k(ie){if(!ie)return"";const J=ie.split(/[\s+|:|,|\{|\?]/,1);return J.length?J[0]:ie}function S(ie,J){return/^\w[\w\d+.-]*:/.test(J)?J:ie.path.endsWith("/")?(0,o.resolvePath)(ie,J).toString():(0,o.resolvePath)((0,o.dirname)(ie),J).toString()}function h(ie,J){const{config:me,allowedSchemes:he}=E(ie);i.addHook("uponSanitizeAttribute",(oe,de)=>{if(de.attrName==="style"||de.attrName==="class"){if(oe.tagName==="SPAN"){if(de.attrName==="style"){de.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(de.attrValue);return}else if(de.attrName==="class"){de.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(de.attrValue);return}}de.keepAttr=!1;return}});const fe=v.hookDomPurifyHrefAndSrcSanitizer(he);try{return i.sanitize(J,{...me,RETURN_TRUSTED_TYPE:!0})}finally{i.removeHook("uponSanitizeAttribute"),fe.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width"];function E(ie){const J=[u.Schemas.http,u.Schemas.https,u.Schemas.mailto,u.Schemas.data,u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemote,u.Schemas.vscodeRemoteResource];return ie.isTrusted&&J.push(u.Schemas.command),{config:{ALLOWED_TAGS:[...v.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:J}}function p(ie){return typeof ie=="string"?ie:D(ie)}t.renderStringAsPlaintext=p;function D(ie){let J=ie.value??"";J.length>1e5&&(J=`${J.substr(0,1e5)}\u2026`);const me=s.marked.parse(J,{renderer:q.getValue()}).replace(/&(#\d+|[a-zA-Z]+);/g,he=>z.get(he)??he);return h({isTrusted:!1},me).toString()}t.renderMarkdownAsPlaintext=D;const z=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),q=new n.Lazy(()=>{const ie=new s.marked.Renderer;return ie.code=J=>J,ie.blockquote=J=>J,ie.html=J=>"",ie.heading=(J,me,he)=>J+`
`,ie.hr=()=>"",ie.list=(J,me)=>J,ie.listitem=J=>J+`
`,ie.paragraph=J=>J+`
`,ie.table=(J,me)=>J+me+`
`,ie.tablerow=J=>J,ie.tablecell=(J,me)=>J+" ",ie.strong=J=>J,ie.em=J=>J,ie.codespan=J=>J,ie.br=()=>`
`,ie.del=J=>J,ie.image=(J,me,he)=>"",ie.text=J=>J,ie.link=(J,me,he)=>he,ie})}),define(be[122],pe([1,0,4,8,28,60,34,2,6,98]),function(Q,t,v,i,U,R,y,w,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function f(n,e){(0,c.isString)(e)?n.title=(0,y.stripIcons)(e):e?.markdownNotSupportedFallback?n.title=e.markdownNotSupportedFallback:n.removeAttribute("title")}t.setupNativeHover=f;class I{constructor(e,s,l){this.c=e,this.d=s,this.f=l}async update(e,s,l){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let u;if(e===void 0||(0,c.isString)(e)||e instanceof HTMLElement)u=e;else if(!(0,c.isFunction)(e.markdown))u=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,d.localize)(0,null),s),this.b=new U.CancellationTokenSource;const m=this.b.token;if(u=await e.markdown(m),u===void 0&&(u=e.markdownNotSupportedFallback),this.isDisposed||m.isCancellationRequested)return}this.g(u,s,l)}g(e,s,l){const u=this.a;if(this.h(e)){const m={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!u,...l};this.a=this.c.showHover(m,s)}u?.dispose()}h(e){return e?(0,R.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function r(n,e,s,l){let u,m;const o=(k,S)=>{k&&(m?.dispose(),m=void 0),S&&(u?.dispose(),u=void 0),n.onDidHideHover?.()},a=(k,S,h)=>new i.TimeoutTimer(async()=>{(!m||m.isDisposed)&&(m=new I(n,h||e,k>0),await m.update(s,S,l))},k),g=()=>{if(u)return;const k=new w.DisposableStore,S=p=>o(!1,p.fromElement===e);k.add(v.addDisposableListener(e,v.EventType.MOUSE_LEAVE,S,!0));const h=()=>o(!0,!0);k.add(v.addDisposableListener(e,v.EventType.MOUSE_DOWN,h,!0));const E={targetElements:[e],dispose:()=>{}};if(n.placement===void 0||n.placement==="mouse"){const p=D=>{E.x=D.x+10,D.target instanceof HTMLElement&&D.target.classList.contains("action-label")&&o(!0,!0)};k.add(v.addDisposableListener(e,v.EventType.MOUSE_MOVE,p,!0))}k.add(a(n.delay,!1,E)),u=k},C=v.addDisposableListener(e,v.EventType.MOUSE_OVER,g,!0);return{show:k=>{o(!1,!0),a(0,k)},hide:()=>{o(!0,!0)},update:async(k,S)=>{s=k,await m?.update(s,void 0,S)},dispose:()=>{C.dispose(),o(!0,!0)}}}t.setupCustomHover=r}),define(be[123],pe([1,0,4,18,19,121,59,14,3,43,2,5,100,91]),function(Q,t,v,i,U,R,y,w,c,d,f,I,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const n=v.$,e="selectOption.entry.template";class s{get templateId(){return e}renderTemplate(m){const o=Object.create(null);return o.root=m,o.text=v.append(m,n(".option-text")),o.detail=v.append(m,n(".option-detail")),o.decoratorRight=v.append(m,n(".option-decorator-right")),o}renderElement(m,o,a){const g=a,C=m.text,L=m.detail,k=m.decoratorRight,S=m.isDisabled;g.text.textContent=C,g.detail.textContent=L||"",g.decoratorRight.innerText=k||"",S?g.root.classList.add("option-disabled"):g.root.classList.remove("option-disabled")}disposeTemplate(m){}}class l extends f.Disposable{constructor(m,o,a,g,C){super(),this.k=[],this.y=0,this.D=!1,this.G=!1,this.H=!1,this.f=!1,this.g=C||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=l.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.m=new c.Emitter,this.B(this.m),this.n=g,this.J(),this.I(a),this.l=o||0,m&&this.setOptions(m,o)}getHeight(){return 18}getTemplateId(){return e}I(m){this.r=m,this.s=v.$(".monaco-select-box-dropdown-container"),this.s.classList.add("monaco-select-box-dropdown-padding"),this.F=v.append(this.s,n(".select-box-details-pane"));const o=v.append(this.s,n(".select-box-dropdown-container-width-control")),a=v.append(o,n(".width-control-div"));this.w=document.createElement("span"),this.w.className="option-text-width-control",v.append(a,this.w),this.C=0,this.t=v.createStyleSheet(this.s),this.s.setAttribute("draggable","true"),this.B(v.addDisposableListener(this.s,v.EventType.DRAG_START,g=>{v.EventHelper.stop(g,!0)}))}J(){this.B(v.addStandardDisposableListener(this.h,"change",o=>{this.l=o.target.selectedIndex,this.m.fire({index:o.target.selectedIndex,selected:o.target.value}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)})),this.B(v.addDisposableListener(this.h,v.EventType.CLICK,o=>{v.EventHelper.stop(o),this.f?this.P(!0):this.O()})),this.B(v.addDisposableListener(this.h,v.EventType.MOUSE_DOWN,o=>{v.EventHelper.stop(o)}));let m;this.B(v.addDisposableListener(this.h,"touchstart",o=>{m=this.f})),this.B(v.addDisposableListener(this.h,"touchend",o=>{v.EventHelper.stop(o),m?this.P(!0):this.O()})),this.B(v.addDisposableListener(this.h,v.EventType.KEY_DOWN,o=>{const a=new U.StandardKeyboardEvent(o);let g=!1;I.isMacintosh?(a.keyCode===18||a.keyCode===16||a.keyCode===10||a.keyCode===3)&&(g=!0):(a.keyCode===18&&a.altKey||a.keyCode===16&&a.altKey||a.keyCode===10||a.keyCode===3)&&(g=!0),g&&(this.O(),v.EventHelper.stop(o,!0))}))}get onDidSelect(){return this.m.event}setOptions(m,o){w.equals(this.k,m)||(this.k=m,this.h.options.length=0,this.D=!1,this.k.forEach((a,g)=>{this.h.add(this.N(a.text,g,a.isDisabled)),typeof a.description=="string"&&(this.D=!0)})),o!==void 0&&(this.select(o),this.y=this.l)}L(){this.u?.splice(0,this.u.length,this.k)}select(m){m>=0&&m<this.k.length?this.l=m:m>this.k.length-1?this.select(this.k.length-1):this.l<0&&(this.l=0),this.h.selectedIndex=this.l,!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)}setAriaLabel(m){this.g.ariaLabel=m,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(m){this.h.tabIndex=m?0:-1}render(m){this.j=m,m.classList.add("select-container"),m.appendChild(this.h),this.applyStyles()}style(m){const o=[];this.n=m,this.n.listFocusBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.n.listFocusBackground} !important; }`),this.n.listFocusForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.n.listFocusForeground} !important; }`),this.n.decoratorRightForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.n.decoratorRightForeground}; }`),this.n.selectBackground&&this.n.selectBorder&&!this.n.selectBorder.equals(this.n.selectBackground)?(o.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.n.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectBorder} } `)):this.n.selectListBorder&&(o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectListBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectListBorder} } `)),this.n.listHoverForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.n.listHoverForeground} !important; }`),this.n.listHoverBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.n.listHoverBackground} !important; }`),this.n.listFocusOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.n.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.n.listHoverOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.n.listHoverOutline} !important; outline-offset: -1.6px !important; }`),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.t.textContent=o.join(`
`),this.applyStyles()}applyStyles(){if(this.h){const m=this.n.selectBackground?this.n.selectBackground.toString():"",o=this.n.selectForeground?this.n.selectForeground.toString():"",a=this.n.selectBorder?this.n.selectBorder.toString():"";this.h.style.backgroundColor=m,this.h.style.color=o,this.h.style.borderColor=a}this.u&&this.M()}M(){if(this.u){const m=this.n.selectBackground?this.n.selectBackground.toString():"";this.u.style({});const o=this.n.selectListBackground?this.n.selectListBackground.toString():m;this.v.style.backgroundColor=o,this.F.style.backgroundColor=o;const a=this.n.focusBorder?this.n.focusBorder.toString():"";this.s.style.outlineColor=a,this.s.style.outlineOffset="-1px"}}N(m,o,a){const g=document.createElement("option");return g.value=m,g.text=m,g.disabled=!!a,g}O(){this.F.innerText="",!(!this.r||this.f)&&(this.W(this.s),this.L(),this.r.showContextView({getAnchor:()=>this.h,render:m=>this.Q(m,!0),layout:()=>{this.S()},onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.C},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.P(!1),this.r.showContextView({getAnchor:()=>this.h,render:m=>this.Q(m),layout:()=>this.S(),onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.C},this.g.optionsAsChildren?this.j:void 0),this.y=this.l,this.f=!0,this.h.setAttribute("aria-expanded","true"))}P(m){!this.r||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),m&&this.h.focus(),this.r.hideContextView())}Q(m,o){return m.appendChild(this.s),this.S(o),{dispose:()=>{try{m.removeChild(this.s)}catch{}}}}R(){let m=0;return this.k.forEach((o,a)=>{this.cb(a),this.F.offsetHeight>m&&(m=this.F.offsetHeight)}),m}S(m){if(this.G)return!1;if(this.u){this.s.classList.add("visible");const o=v.getDomNodePagePosition(this.h),a=getComputedStyle(this.h),g=parseFloat(a.getPropertyValue("--dropdown-padding-top"))+parseFloat(a.getPropertyValue("--dropdown-padding-bottom")),C=window.innerHeight-o.top-o.height-(this.g.minBottomMargin||0),L=o.top-l.b,k=this.h.offsetWidth,S=this.U(this.w),h=Math.max(S,Math.round(k)).toString()+"px";this.s.style.width=h,this.u.getHTMLElement().style.height="",this.u.layout();let E=this.u.contentHeight;const p=this.D?this.R():0,D=E+g+p,z=Math.floor((C-g-p)/this.getHeight()),q=Math.floor((L-g-p)/this.getHeight());if(m)return o.top+o.height>window.innerHeight-22||o.top<l.b||z<1&&q<1?!1:(z<l.c&&q>z&&this.k.length>z?(this.C=1,this.s.removeChild(this.v),this.s.removeChild(this.F),this.s.appendChild(this.F),this.s.appendChild(this.v),this.F.classList.remove("border-top"),this.F.classList.add("border-bottom")):(this.C=0,this.s.removeChild(this.v),this.s.removeChild(this.F),this.s.appendChild(this.v),this.s.appendChild(this.F),this.F.classList.remove("border-bottom"),this.F.classList.add("border-top")),!0);if(o.top+o.height>window.innerHeight-22||o.top<l.b||this.C===0&&z<1||this.C===1&&q<1)return this.P(!0),!1;if(this.C===0){if(this.f&&z+q<1)return this.P(!0),!1;D>C&&(E=z*this.getHeight())}else D>L&&(E=q*this.getHeight());return this.u.layout(E),this.u.domFocus(),this.u.length>0&&(this.u.setFocus([this.l||0]),this.u.reveal(this.u.getFocus()[0]||0)),this.D?(this.u.getHTMLElement().style.height=E+g+"px",this.s.style.height=""):this.s.style.height=E+g+"px",this.cb(this.l),this.s.style.width=h,this.v.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.s.classList.add("synthetic-focus"),!0}else return!1}U(m){let o=0;if(m){let a=0,g=0;this.k.forEach((C,L)=>{const k=C.detail?C.detail.length:0,S=C.decoratorRight?C.decoratorRight.length:0,h=C.text.length+k+S;h>g&&(a=L,g=h)}),m.textContent=this.k[a].text+(this.k[a].decoratorRight?this.k[a].decoratorRight+" ":""),o=v.getTotalWidth(m)}return o}W(m){if(this.u)return;this.v=v.append(m,n(".select-box-dropdown-list-container")),this.p=new s,this.u=new y.List("SelectBoxCustom",this.v,this,[this.p],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:g=>{let C=g.text;return g.detail&&(C+=`. ${g.detail}`),g.decoratorRight&&(C+=`. ${g.decoratorRight}`),g.description&&(C+=`. ${g.description}`),C},getWidgetAriaLabel:()=>(0,r.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.u.ariaLabel=this.g.ariaLabel);const o=this.B(new i.DomEmitter(this.v,"keydown")),a=c.Event.chain(o.event).filter(()=>this.u.length>0).map(g=>new U.StandardKeyboardEvent(g));this.B(a.filter(g=>g.keyCode===3).on(g=>this.eb(g),this)),this.B(a.filter(g=>g.keyCode===2).on(g=>this.eb(g),this)),this.B(a.filter(g=>g.keyCode===9).on(g=>this.db(g),this)),this.B(a.filter(g=>g.keyCode===16).on(g=>this.gb(g),this)),this.B(a.filter(g=>g.keyCode===18).on(g=>this.fb(g),this)),this.B(a.filter(g=>g.keyCode===12).on(this.ib,this)),this.B(a.filter(g=>g.keyCode===11).on(this.hb,this)),this.B(a.filter(g=>g.keyCode===14).on(this.jb,this)),this.B(a.filter(g=>g.keyCode===13).on(this.kb,this)),this.B(a.filter(g=>g.keyCode>=21&&g.keyCode<=56||g.keyCode>=80&&g.keyCode<=108).on(this.lb,this)),this.B(v.addDisposableListener(this.u.getHTMLElement(),v.EventType.POINTER_UP,g=>this.X(g))),this.B(this.u.onMouseOver(g=>typeof g.index<"u"&&this.u.setFocus([g.index]))),this.B(this.u.onDidChangeFocus(g=>this.bb(g))),this.B(v.addDisposableListener(this.s,v.EventType.FOCUS_OUT,g=>{!this.f||v.isAncestor(g.relatedTarget,this.s)||this.Y()})),this.u.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.u.getHTMLElement().setAttribute("aria-expanded","true"),this.M()}X(m){if(!this.u.length)return;v.EventHelper.stop(m);const o=m.target;if(!o||o.classList.contains("slider"))return;const a=o.closest(".monaco-list-row");if(!a)return;const g=Number(a.getAttribute("data-index")),C=a.classList.contains("option-disabled");g>=0&&g<this.k.length&&!C&&(this.l=g,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.P(!0))}Y(){this.H||(this.l!==this.y&&this.select(this.y),this.P(!1))}ab(m,o){const a=C=>{for(let L=0;L<C.childNodes.length;L++){const k=C.childNodes.item(L);(k.tagName&&k.tagName.toLowerCase())==="img"?C.removeChild(k):a(k)}},g=(0,R.renderMarkdown)({value:m,supportThemeIcons:!0},{actionHandler:o});return g.element.classList.add("select-box-description-markdown"),a(g.element),g.element}bb(m){!this.f||!this.D||this.cb(m.indexes[0])}cb(m){this.F.innerText="";const o=this.k[m],a=o?.description??"",g=o?.descriptionIsMarkdown??!1;if(a){if(g){const C=o.descriptionMarkdownActionHandler;this.F.appendChild(this.ab(a,C))}else this.F.innerText=a;this.F.style.display="block"}else this.F.style.display="none";this.G=!0,this.r.layout(),this.G=!1}db(m){v.EventHelper.stop(m),this.select(this.y),this.P(!0)}eb(m){v.EventHelper.stop(m),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.P(!0)}fb(m){if(this.l<this.k.length-1){v.EventHelper.stop(m,!0);const o=this.k[this.l+1].isDisabled;if(o&&this.k.length>this.l+2)this.l+=2;else{if(o)return;this.l++}this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0])}}gb(m){this.l>0&&(v.EventHelper.stop(m,!0),this.k[this.l-1].isDisabled&&this.l>1?this.l-=2:this.l--,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]))}hb(m){v.EventHelper.stop(m),this.u.focusPreviousPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l<this.k.length-1&&(this.l++,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}ib(m){v.EventHelper.stop(m),this.u.focusNextPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l>0&&(this.l--,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}jb(m){v.EventHelper.stop(m),!(this.k.length<2)&&(this.l=0,this.k[this.l].isDisabled&&this.l>1&&this.l++,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}kb(m){v.EventHelper.stop(m),!(this.k.length<2)&&(this.l=this.k.length-1,this.k[this.l].isDisabled&&this.l>1&&this.l--,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}lb(m){const o=d.KeyCodeUtils.toString(m.keyCode);let a=-1;for(let g=0;g<this.k.length-1;g++)if(a=(g+this.l+1)%this.k.length,this.k[a].text.charAt(0).toUpperCase()===o&&!this.k[a].isDisabled){this.select(a),this.u.setFocus([a]),this.u.reveal(this.u.getFocus()[0]),v.EventHelper.stop(m);break}}dispose(){this.P(!1),super.dispose()}}t.SelectBoxList=l,l.a=32,l.b=2,l.c=3}),define(be[124],pe([1,0,123,117,17,24,27,5,90]),function(Q,t,v,i,U,R,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.defaultStyles=void 0,t.defaultStyles={selectBackground:R.Color.fromHex("#3C3C3C"),selectForeground:R.Color.fromHex("#F0F0F0"),selectBorder:R.Color.fromHex("#3C3C3C")};class c extends U.Widget{constructor(f,I,r,n=(0,y.deepClone)(t.defaultStyles),e){super(),w.isMacintosh&&!e?.useCustomDrawn?this.a=new i.SelectBoxNative(f,I,n,e):this.a=new v.SelectBoxList(f,I,r,n,e),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(f,I){this.a.setOptions(f,I)}select(f){this.a.select(f)}setAriaLabel(f){this.a.setAriaLabel(f)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(f){this.a.setFocusable(f)}render(f){this.a.render(f)}style(f){this.a.style(f)}applyStyles(){this.a.applyStyles()}}t.SelectBox=c}),define(be[61],pe([1,0,16,51,4,22,122,124,32,2,5,6,95,48]),function(Q,t,v,i,U,R,y,w,c,d,f,I,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class n extends d.Disposable{get action(){return this._action}constructor(u,m,o={}){super(),this.k=o,this._context=u||this,this._action=m,m instanceof c.Action&&this.B(m.onDidChange(a=>{!this.element||this.m(a)}))}m(u){u.enabled!==void 0&&this.t(),u.checked!==void 0&&this.updateChecked(),u.class!==void 0&&this.updateClass(),u.label!==void 0&&(this.updateLabel(),this.w()),u.tooltip!==void 0&&this.w()}get actionRunner(){return this.j||(this.j=this.B(new c.ActionRunner)),this.j}set actionRunner(u){this.j=u}isEnabled(){return this._action.enabled}setActionContext(u){this._context=u}render(u){const m=this.element=u;this.B(R.Gesture.addTarget(u));const o=this.k&&this.k.draggable;o&&(u.draggable=!0,v.isFirefox&&this.B((0,U.addDisposableListener)(u,U.EventType.DRAG_START,a=>a.dataTransfer?.setData(i.DataTransfers.TEXT,this._action.label)))),this.B((0,U.addDisposableListener)(m,R.EventType.Tap,a=>this.onClick(a,!0))),this.B((0,U.addDisposableListener)(m,U.EventType.MOUSE_DOWN,a=>{o||U.EventHelper.stop(a,!0),this._action.enabled&&a.button===0&&m.classList.add("active")})),f.isMacintosh&&this.B((0,U.addDisposableListener)(m,U.EventType.CONTEXT_MENU,a=>{a.button===0&&a.ctrlKey===!0&&this.onClick(a)})),this.B((0,U.addDisposableListener)(m,U.EventType.CLICK,a=>{U.EventHelper.stop(a,!0),this.k&&this.k.isMenu||this.onClick(a)})),this.B((0,U.addDisposableListener)(m,U.EventType.DBLCLICK,a=>{U.EventHelper.stop(a,!0)})),[U.EventType.MOUSE_UP,U.EventType.MOUSE_OUT].forEach(a=>{this.B((0,U.addDisposableListener)(m,a,g=>{U.EventHelper.stop(g),m.classList.remove("active")}))})}onClick(u,m=!1){U.EventHelper.stop(u,!0);const o=I.isUndefinedOrNull(this._context)?this.k?.useEventAsContext?u:{preserveFocus:m}:this._context;this.actionRunner.run(this._action,o)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(u){this.element&&(this.element.tabIndex=u?0:-1)}get trapsArrowNavigation(){return!1}t(){}updateLabel(){}u(){return this.action.tooltip}w(){if(!this.element)return;const u=this.u()??"";this.C(),this.k.hoverDelegate?(this.element.title="",this.f?this.f.update(u):(this.f=(0,y.setupCustomHover)(this.k.hoverDelegate,this.element,u),this.q.add(this.f))):this.element.title=u}C(){if(this.element){const u=this.u()??"";this.element.setAttribute("aria-label",u)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),super.dispose()}}t.BaseActionViewItem=n;class e extends n{constructor(u,m,o={}){super(u,m,o),this.k=o,this.k.icon=o.icon!==void 0?o.icon:!1,this.k.label=o.label!==void 0?o.label:!0,this.D=""}render(u){super.render(u),this.element&&(this.g=(0,U.append)(this.element,(0,U.$)("a.action-label"))),this.g&&(this._action.id===c.Separator.ID?this.g.setAttribute("role","presentation"):this.k.isMenu?this.g.setAttribute("role","menuitem"):this.g.setAttribute("role","button")),this.k.label&&this.k.keybinding&&this.element&&((0,U.append)(this.element,(0,U.$)("span.keybinding")).textContent=this.k.keybinding),this.updateClass(),this.updateLabel(),this.w(),this.t(),this.updateChecked()}focus(){this.g&&(this.g.tabIndex=0,this.g.focus())}isFocused(){return!!this.g&&this.g?.tabIndex===0}blur(){this.g&&(this.g.tabIndex=-1)}setFocusable(u){this.g&&(this.g.tabIndex=u?0:-1)}updateLabel(){this.k.label&&this.g&&(this.g.textContent=this.action.label)}u(){let u=null;return this.action.tooltip?u=this.action.tooltip:!this.k.label&&this.action.label&&this.k.icon&&(u=this.action.label,this.k.keybinding&&(u=r.localize(0,null,u,this.k.keybinding))),u??void 0}updateClass(){this.D&&this.g&&this.g.classList.remove(...this.D.split(" ")),this.k.icon?(this.D=this.action.class,this.g&&(this.g.classList.add("codicon"),this.D&&this.g.classList.add(...this.D.split(" "))),this.t()):this.g?.classList.remove("codicon")}t(){this.action.enabled?(this.g&&(this.g.removeAttribute("aria-disabled"),this.g.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.g&&(this.g.setAttribute("aria-disabled","true"),this.g.classList.add("disabled")),this.element?.classList.add("disabled"))}C(){if(this.g){const u=this.u()??"";this.g.setAttribute("aria-label",u)}}updateChecked(){this.g&&(this.action.checked?this.g.classList.add("checked"):this.g.classList.remove("checked"))}}t.ActionViewItem=e;class s extends n{constructor(u,m,o,a,g,C){super(u,m),this.b=new w.SelectBox(o,a,g,void 0,C),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(u,m){this.b.setOptions(u,m)}select(u){this.b.select(u)}g(){this.B(this.b.onDidSelect(u=>this.n(u.selected,u.index)))}n(u,m){this.actionRunner.run(this._action,this.r(u,m))}r(u,m){return u}setFocusable(u){this.b.setFocusable(u)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(u){this.b.render(u)}}t.SelectActionViewItem=s}),define(be[62],pe([1,0,4,19,61,32,3,2,6,48]),function(Q,t,v,i,U,R,y,w,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var d;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(d=t.ActionsOrientation||(t.ActionsOrientation={}));class f extends w.Disposable{constructor(n,e={}){super(),this.f=this.B(new w.DisposableStore),this.m=this.B(new w.DisposableMap),this.s=!1,this.t=!0,this.v=this.B(new y.Emitter),this.onDidBlur=this.v.event,this.w=this.B(new y.Emitter({onWillAddFirstListener:()=>this.y=!0})),this.onDidCancel=this.w.event,this.y=!1,this.C=this.B(new y.Emitter),this.onDidRun=this.C.event,this.D=this.B(new y.Emitter),this.onWillRun=this.D.event,this.b=e,this.g=e.context??null,this.j=this.b.orientation??0,this.l={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.c=this.b.actionRunner:(this.c=new R.ActionRunner,this.f.add(this.c)),this.f.add(this.c.onDidRun(u=>this.C.fire(u))),this.f.add(this.c.onWillRun(u=>this.D.fire(u))),this.viewItems=[],this.p=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let s,l;switch(this.j){case 0:s=[15],l=[17];break;case 1:s=[16],l=[18],this.domNode.className+=" vertical";break}this.B(v.addDisposableListener(this.domNode,v.EventType.KEY_DOWN,u=>{const m=new i.StandardKeyboardEvent(u);let o=!0;const a=typeof this.p=="number"?this.viewItems[this.p]:void 0;s&&(m.equals(s[0])||m.equals(s[1]))?o=this.M():l&&(m.equals(l[0])||m.equals(l[1]))?o=this.L():m.equals(9)&&this.y?this.w.fire():m.equals(14)?o=this.I():m.equals(13)?o=this.J():m.equals(2)&&a instanceof U.BaseActionViewItem&&a.trapsArrowNavigation?o=this.L():this.G(m)?this.l.keyDown?this.O(m):this.s=!0:o=!1,o&&(m.preventDefault(),m.stopPropagation())})),this.B(v.addDisposableListener(this.domNode,v.EventType.KEY_UP,u=>{const m=new i.StandardKeyboardEvent(u);this.G(m)?(!this.l.keyDown&&this.s&&(this.s=!1,this.O(m)),m.preventDefault(),m.stopPropagation()):(m.equals(2)||m.equals(1026))&&this.H()})),this.r=this.B(v.trackFocus(this.domNode)),this.B(this.r.onDidBlur(()=>{(v.getActiveElement()===this.domNode||!v.isAncestor(v.getActiveElement(),this.domNode))&&(this.v.fire(),this.p=void 0,this.n=void 0,this.s=!1)})),this.B(this.r.onDidFocus(()=>this.H())),this.u=document.createElement("ul"),this.u.className="actions-container",this.u.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.u.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.u),n.appendChild(this.domNode)}F(){this.length()>=2?this.u.setAttribute("role",this.b.ariaRole||"toolbar"):this.u.setAttribute("role","presentation")}setAriaLabel(n){n?this.u.setAttribute("aria-label",n):this.u.removeAttribute("aria-label")}setFocusable(n){if(this.t=n,this.t){const e=this.viewItems.find(s=>s instanceof U.BaseActionViewItem&&s.isEnabled());e instanceof U.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof U.BaseActionViewItem&&e.setFocusable(!1)})}G(n){let e=!1;return this.l.keys.forEach(s=>{e=e||n.equals(s)}),e}H(){for(let n=0;n<this.u.children.length;n++){const e=this.u.children[n];if(v.isAncestor(v.getActiveElement(),e)){this.p=n;break}}}get context(){return this.g}set context(n){this.g=n,this.viewItems.forEach(e=>e.setActionContext(n))}get actionRunner(){return this.c}set actionRunner(n){this.c=n,this.f.clear(),this.f.add(this.c.onDidRun(e=>this.C.fire(e))),this.f.add(this.c.onWillRun(e=>this.D.fire(e))),this.viewItems.forEach(e=>e.actionRunner=n)}getContainer(){return this.domNode}hasAction(n){return this.viewItems.findIndex(e=>e.action.id===n.id)!==-1}getAction(n){if(typeof n=="number")return this.viewItems[n]?.action;if(n instanceof HTMLElement){for(;n.parentElement!==this.u;){if(!n.parentElement)return;n=n.parentElement}for(let e=0;e<this.u.childNodes.length;e++)if(this.u.childNodes[e]===n)return this.viewItems[e].action}}push(n,e={}){const s=Array.isArray(n)?n:[n];let l=c.isNumber(e.index)?e.index:null;s.forEach(u=>{const m=document.createElement("li");m.className="action-item",m.setAttribute("role","presentation");let o;this.b.actionViewItemProvider&&(o=this.b.actionViewItemProvider(u)),o||(o=new U.ActionViewItem(this.context,u,{hoverDelegate:this.b.hoverDelegate,...e})),this.b.allowContextMenu||this.m.set(o,v.addDisposableListener(m,v.EventType.CONTEXT_MENU,a=>{v.EventHelper.stop(a,!0)})),o.actionRunner=this.c,o.setActionContext(this.context),o.render(m),this.t&&o instanceof U.BaseActionViewItem&&this.viewItems.length===0&&o.setFocusable(!0),l===null||l<0||l>=this.u.children.length?(this.u.appendChild(m),this.viewItems.push(o)):(this.u.insertBefore(m,this.u.children[l]),this.viewItems.splice(l,0,o),l++)}),typeof this.p=="number"&&this.focus(this.p),this.F()}getWidth(n){if(n>=0&&n<this.u.children.length){const e=this.u.children.item(n);if(e)return e.clientWidth}return 0}getHeight(n){if(n>=0&&n<this.u.children.length){const e=this.u.children.item(n);if(e)return e.clientHeight}return 0}pull(n){n>=0&&n<this.viewItems.length&&(this.u.removeChild(this.u.childNodes[n]),this.m.deleteAndDispose(this.viewItems[n]),(0,w.dispose)(this.viewItems.splice(n,1)),this.F())}clear(){this.isEmpty()||(this.viewItems=(0,w.dispose)(this.viewItems),this.m.clearAndDisposeAll(),v.clearNode(this.u),this.F())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(n){let e=!1,s;if(n===void 0?e=!0:typeof n=="number"?s=n:typeof n=="boolean"&&(e=n),e&&typeof this.p>"u"){const l=this.viewItems.findIndex(u=>u.isEnabled());this.p=l===-1?void 0:l,this.N(void 0,void 0,!0)}else s!==void 0&&(this.p=s),this.N(void 0,void 0,!0)}I(){return this.p=this.length()-1,this.L(!0)}J(){return this.p=0,this.M(!0)}L(n){if(typeof this.p>"u")this.p=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.p;let s;do{if(!n&&this.b.preventLoopNavigation&&this.p+1>=this.viewItems.length)return this.p=e,!1;this.p=(this.p+1)%this.viewItems.length,s=this.viewItems[this.p]}while(this.p!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===R.Separator.ID));return this.N(),!0}M(n){if(typeof this.p>"u")this.p=0;else if(this.viewItems.length<=1)return!1;const e=this.p;let s;do{if(this.p=this.p-1,this.p<0){if(!n&&this.b.preventLoopNavigation)return this.p=e,!1;this.p=this.viewItems.length-1}s=this.viewItems[this.p]}while(this.p!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===R.Separator.ID));return this.N(!0),!0}N(n,e,s=!1){typeof this.p>"u"&&this.u.focus({preventScroll:e}),this.n!==void 0&&this.n!==this.p&&this.viewItems[this.n]?.blur();const l=this.p!==void 0&&this.viewItems[this.p];if(l){let u=!0;c.isFunction(l.focus)||(u=!1),this.b.focusOnlyEnabledItems&&c.isFunction(l.isEnabled)&&!l.isEnabled()&&(u=!1),l.action.id===R.Separator.ID&&(u=!1),u?(s||this.n!==this.p)&&(l.focus(n),this.n=this.p):(this.u.focus({preventScroll:e}),this.n=void 0)}}O(n){if(typeof this.p>"u")return;const e=this.viewItems[this.p];if(e instanceof U.BaseActionViewItem){const s=e._context===null||e._context===void 0?n:e._context;this.run(e._action,s)}}async run(n,e){await this.c.run(n,e)}dispose(){this.viewItems=(0,w.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=f;function I(r){if(!r.length)return r;let n=-1;for(let s=0;s<r.length;s++)if(r[s].id!==R.Separator.ID){n=s;break}if(n===-1)return[];r=r.slice(n);for(let s=r.length-1;s>=0&&r[s].id===R.Separator.ID;s--)r.splice(s,1);let e=!1;for(let s=r.length-1;s>=0;s--){const l=r[s].id===R.Separator.ID;l&&!e?r.splice(s,1):l?l&&(e=!1):e=!0}return r}t.prepareActions=I}),define(be[125],pe([1,0,4,18,52,62,54,57,17,24,3,77,27,99,87]),function(Q,t,v,i,U,R,y,w,c,d,f,I,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.MessageType=void 0;const e=v.$;var s;(function(o){o[o.INFO=1]="INFO",o[o.WARNING=2]="WARNING",o[o.ERROR=3]="ERROR"})(s=t.MessageType||(t.MessageType={}));const l={inputBackground:d.Color.fromHex("#3C3C3C"),inputForeground:d.Color.fromHex("#CCCCCC"),inputValidationInfoBorder:d.Color.fromHex("#55AAFF"),inputValidationInfoBackground:d.Color.fromHex("#063B49"),inputValidationWarningBorder:d.Color.fromHex("#B89500"),inputValidationWarningBackground:d.Color.fromHex("#352A05"),inputValidationErrorBorder:d.Color.fromHex("#BE1100"),inputValidationErrorBackground:d.Color.fromHex("#5A1D1D")};class u extends c.Widget{constructor(a,g,C){super(),this.s="idle",this.y=Number.POSITIVE_INFINITY,this.Y=this.B(new f.Emitter),this.onDidChange=this.Y.event,this.ab=this.B(new f.Emitter),this.onDidHeightChange=this.ab.event,this.a=g,this.g=C||Object.create(null),(0,r.mixin)(this.g,l,!1),this.h=null,this.i=this.g.placeholder||"",this.l=this.g.tooltip??(this.i||""),this.n=this.g.ariaLabel||"",this.J=this.g.inputBackground,this.L=this.g.inputForeground,this.M=this.g.inputBorder,this.N=this.g.inputValidationInfoBorder,this.O=this.g.inputValidationInfoBackground,this.P=this.g.inputValidationInfoForeground,this.Q=this.g.inputValidationWarningBorder,this.R=this.g.inputValidationWarningBackground,this.S=this.g.inputValidationWarningForeground,this.U=this.g.inputValidationErrorBorder,this.W=this.g.inputValidationErrorBackground,this.X=this.g.inputValidationErrorForeground,this.g.validationOptions&&(this.r=this.g.validationOptions.validation),this.element=v.append(a,e(".monaco-inputbox.idle"));const L=this.g.flexibleHeight?"textarea":"input",k=v.append(this.element,e(".ibwrapper"));if(this.b=v.append(k,e(L+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.F(this.b,()=>this.element.classList.add("synthetic-focus")),this.D(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.y=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.t=v.append(k,e("div.mirror")),this.t.innerText="\xA0",this.I=new w.ScrollableElement(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.t.style.whiteSpace="pre",this.t.style.wordWrap="initial"),v.append(a,this.I.getDomNode()),this.B(this.I),this.B(this.I.onScroll(E=>this.b.scrollTop=E.scrollTop));const S=this.B(new i.DomEmitter(document,"selectionchange")),h=f.Event.filter(S.event,()=>document.getSelection()?.anchorNode===k);this.B(h(this.db,this)),this.B(this.onDidHeightChange(this.db,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.n&&this.b.setAttribute("aria-label",this.n),this.i&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.i),this.l&&this.setTooltip(this.l),this.C(this.b,()=>this.hb()),this.D(this.b,()=>this.bb()),this.F(this.b,()=>this.cb()),this.B(this.H(this.b)),setTimeout(()=>this.ib(),0),this.g.actions&&(this.c=this.B(new R.ActionBar(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.jb()}bb(){this.gb(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}cb(){this.fb(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.i||"")}setPlaceHolder(a){this.i=a,this.b.setAttribute("placeholder",a)}setTooltip(a){this.l=a,this.b.title=a}setAriaLabel(a){this.n=a,a?this.b.setAttribute("aria-label",this.n):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.n}get mirrorElement(){return this.t}get inputElement(){return this.b}get value(){return this.b.value}set value(a){this.b.value!==a&&(this.b.value=a,this.hb())}get height(){return typeof this.v=="number"?this.v:v.getTotalHeight(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(a=null){this.b.select(),a&&(this.b.setSelectionRange(a.start,a.end),a.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.gb()}setEnabled(a){a?this.enable():this.disable()}get width(){return v.getTotalWidth(this.b)}set width(a){if(this.g.flexibleHeight&&this.g.flexibleWidth){let g=0;if(this.t){const C=parseFloat(this.t.style.paddingLeft||"")||0,L=parseFloat(this.t.style.paddingRight||"")||0;g=C+L}this.b.style.width=a-g+"px"}else this.b.style.width=a+"px";this.t&&(this.t.style.width=a+"px")}set paddingRight(a){this.b.style.width=`calc(100% - ${a}px)`,this.t&&(this.t.style.paddingRight=a+"px")}db(){if(typeof this.w!="number"||typeof this.v!="number"||!this.I)return;const a=this.w,g=this.v,C=this.b.scrollTop;this.I.setScrollDimensions({scrollHeight:a,height:g}),this.I.setScrollPosition({scrollTop:C})}showMessage(a,g){this.h=a,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.eb(a.type));const C=this.stylesForType(this.h.type);this.element.style.border=C.border?`1px solid ${C.border}`:"",this.h.content&&(this.hasFocus()||g)&&this.fb()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.gb(),this.jb()}isInputValid(){return!!this.r&&!this.r(this.value)}validate(){let a=null;return this.r&&(a=this.r(this.value),a?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(a)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),a?.type}stylesForType(a){switch(a){case 1:return{border:this.N,background:this.O,foreground:this.P};case 2:return{border:this.Q,background:this.R,foreground:this.S};default:return{border:this.U,background:this.W,foreground:this.X}}}eb(a){switch(a){case 1:return"info";case 2:return"warning";default:return"error"}}fb(){if(!this.a||!this.h)return;let a;const g=()=>a.style.width=v.getTotalWidth(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:L=>{if(!this.h)return null;a=v.append(L,e(".monaco-inputbox-container")),g();const k={inline:!0,className:"monaco-inputbox-message"},S=this.h.formatContent?(0,U.renderFormattedText)(this.h.content,k):(0,U.renderText)(this.h.content,k);S.classList.add(this.eb(this.h.type));const h=this.stylesForType(this.h.type);return S.style.backgroundColor=h.background?h.background.toString():"",S.style.color=h.foreground?h.foreground.toString():"",S.style.border=h.border?`1px solid ${h.border}`:"",v.append(a,S),null},onHide:()=>{this.s="closed"},layout:g});let C;this.h.type===3?C=n.localize(0,null,this.h.content):this.h.type===2?C=n.localize(1,null,this.h.content):C=n.localize(2,null,this.h.content),y.alert(C),this.s="open"}gb(){!this.a||(this.s==="open"&&this.a.hideContextView(),this.s="idle")}hb(){this.Y.fire(this.value),this.validate(),this.ib(),this.b.classList.toggle("empty",!this.value),this.s==="open"&&this.a&&this.a.layout()}ib(){if(!this.t)return;const a=this.value,C=a.charCodeAt(a.length-1)===10?" ":"";(a+C).replace(/\u000c/g,"")?this.t.textContent=a+C:this.t.innerText="\xA0",this.layout()}style(a){this.J=a.inputBackground,this.L=a.inputForeground,this.M=a.inputBorder,this.O=a.inputValidationInfoBackground,this.P=a.inputValidationInfoForeground,this.N=a.inputValidationInfoBorder,this.R=a.inputValidationWarningBackground,this.S=a.inputValidationWarningForeground,this.Q=a.inputValidationWarningBorder,this.W=a.inputValidationErrorBackground,this.X=a.inputValidationErrorForeground,this.U=a.inputValidationErrorBorder,this.jb()}jb(){const a=this.J?this.J.toString():"",g=this.L?this.L.toString():"",C=this.M?this.M.toString():"";this.element.style.backgroundColor=a,this.element.style.color=g,this.b.style.backgroundColor="inherit",this.b.style.color=g,this.element.style.borderWidth=C?"1px":"",this.element.style.borderStyle=C?"solid":"",this.element.style.borderColor=C}layout(){if(!this.t)return;const a=this.w;this.w=v.getTotalHeight(this.t),a!==this.w&&(this.v=Math.min(this.w,this.y),this.b.style.height=this.v+"px",this.ab.fire(this.w))}insertAtCursor(a){const g=this.inputElement,C=g.selectionStart,L=g.selectionEnd,k=g.value;C!==null&&L!==null&&(this.value=k.substr(0,C)+a+k.substr(L),g.setSelectionRange(C+1,C+1),this.layout())}dispose(){this.gb(),this.h=null,this.c?.dispose(),super.dispose()}}t.InputBox=u;class m extends u{constructor(a,g,C){const L=n.localize(3,null),k=` or \u21C5 ${L}`,S=` (\u21C5 ${L})`;super(a,g,C),this.mb=this.B(new f.Emitter),this.onDidFocus=this.mb.event,this.nb=this.B(new f.Emitter),this.onDidBlur=this.nb.event,this.kb=new I.HistoryNavigator(C.history,100);const h=()=>{if(C.showHistoryHint&&C.showHistoryHint()&&!this.i.endsWith(k)&&!this.i.endsWith(S)&&this.kb.getHistory().length){const E=this.i.endsWith(")")?k:S,p=this.i+E;C.showPlaceholderOnFocus&&document.activeElement!==this.b?this.i=p:this.setPlaceHolder(p)}};this.lb=new MutationObserver((E,p)=>{E.forEach(D=>{D.target.textContent||h()})}),this.lb.observe(this.b,{attributeFilter:["class"]}),this.F(this.b,()=>h()),this.D(this.b,()=>{const E=p=>{if(this.i.endsWith(p)){const D=this.i.slice(0,this.i.length-p.length);return C.showPlaceholderOnFocus?this.i=D:this.setPlaceHolder(D),!0}else return!1};E(S)||E(k)})}dispose(){super.dispose(),this.lb&&(this.lb.disconnect(),this.lb=void 0)}addToHistory(){this.value&&this.value!==this.qb()&&this.kb.add(this.value)}getHistory(){return this.kb.getHistory()}showNextValue(){this.kb.has(this.value)||this.addToHistory();let a=this.sb();a&&(a=a===this.value?this.sb():a),a&&(this.value=a,y.status(this.value))}showPreviousValue(){this.kb.has(this.value)||this.addToHistory();let a=this.rb();a&&(a=a===this.value?this.rb():a),a&&(this.value=a,y.status(this.value))}clearHistory(){this.kb.clear()}bb(){super.bb(),this.nb.fire()}cb(){super.cb(),this.mb.fire()}qb(){let a=this.kb.current();return a||(a=this.kb.last(),this.kb.next()),a}rb(){return this.kb.previous()||this.kb.first()}sb(){return this.kb.next()||this.kb.last()}}t.HistoryInputBox=m}),define(be[63],pe([1,0,61,17,12,24,3,92]),function(Q,t,v,i,U,R,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=void 0;const w={inputActiveOptionBorder:R.Color.fromHex("#007ACC00"),inputActiveOptionForeground:R.Color.fromHex("#FFFFFF"),inputActiveOptionBackground:R.Color.fromHex("#0E639C50")};class c extends v.BaseActionViewItem{constructor(r,n,e){super(r,n,e),this.a=this.B(new d({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.k.keybinding?`${this._action.label} (${this.k.keybinding})`:this._action.label,notFocusable:!0})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(r){this.element=r,this.element.appendChild(this.a.domNode)}t(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}updateChecked(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(r){this.a.domNode.tabIndex=r?0:-1}}t.ToggleActionViewItem=c;class d extends i.Widget{constructor(r){super(),this.a=this.B(new y.Emitter),this.onChange=this.a.event,this.b=this.B(new y.Emitter),this.onKeyDown=this.b.event,this.c={...w,...r},this.s=this.c.isChecked;const n=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,n.push(...U.CSSIcon.asClassNameArray(this.g))),this.c.actionClassName&&n.push(...this.c.actionClassName.split(" ")),this.s&&n.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...n),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,e=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),e.preventDefault())}),this.B(this.H(this.domNode)),this.p(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this.s,this.a.fire(!0),e.preventDefault(),e.stopPropagation();return}this.b.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(r){this.s=r,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(r){this.g&&this.domNode.classList.remove(...U.CSSIcon.asClassNameArray(this.g)),this.g=r,this.g&&this.domNode.classList.add(...U.CSSIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}style(r){r.inputActiveOptionBorder&&(this.c.inputActiveOptionBorder=r.inputActiveOptionBorder),r.inputActiveOptionForeground&&(this.c.inputActiveOptionForeground=r.inputActiveOptionForeground),r.inputActiveOptionBackground&&(this.c.inputActiveOptionBackground=r.inputActiveOptionBackground),this.t()}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder?this.c.inputActiveOptionBorder.toString():"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground?this.c.inputActiveOptionForeground.toString():"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground?this.c.inputActiveOptionBackground.toString():"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(r){this.domNode.title=r,this.domNode.setAttribute("aria-label",r)}}t.Toggle=d;class f extends i.Widget{constructor(r,n){super(),this.c=r,this.g=n,this.a=new d({title:this.c,isChecked:this.g,icon:U.Codicon.check,actionClassName:"monaco-checkbox"}),this.domNode=this.a.domNode,this.b={},this.a.onChange(()=>{this.h()})}get checked(){return this.a.checked}set checked(r){this.a.checked=r,this.h()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}style(r){this.b=r,this.h()}h(){this.domNode.style.color=this.b.checkboxForeground?this.b.checkboxForeground.toString():"",this.domNode.style.backgroundColor=this.b.checkboxBackground?this.b.checkboxBackground.toString():"",this.domNode.style.borderColor=this.b.checkboxBorder?this.b.checkboxBorder.toString():""}}t.Checkbox=f}),define(be[126],pe([1,0,63,12,97]),function(Q,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const R=U.localize(0,null),y=U.localize(1,null),w=U.localize(2,null);class c extends v.Toggle{constructor(r){super({icon:i.Codicon.caseSensitive,title:R+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.CaseSensitiveToggle=c;class d extends v.Toggle{constructor(r){super({icon:i.Codicon.wholeWord,title:y+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.WholeWordsToggle=d;class f extends v.Toggle{constructor(r){super({icon:i.Codicon.regex,title:w+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.RegexToggle=f}),define(be[127],pe([1,0,4,126,125,17,3,96,2,86]),function(Q,t,v,i,U,R,y,w,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const d=w.localize(0,null);class f extends R.Widget{constructor(r,n,e){super(),this.i=!0,this.l=!1,this.n=new c.DisposableStore,this.bb=[],this.cb=this.B(new y.Emitter),this.onDidOptionChange=this.cb.event,this.db=this.B(new y.Emitter),this.onKeyDown=this.db.event,this.eb=this.B(new y.Emitter),this.onMouseDown=this.eb.event,this.fb=this.B(new y.Emitter),this.onInput=this.fb.event,this.gb=this.B(new y.Emitter),this.onKeyUp=this.gb.event,this.hb=this.B(new y.Emitter),this.onCaseSensitiveKeyDown=this.hb.event,this.ib=this.B(new y.Emitter),this.onRegexKeyDown=this.ib.event,this.kb=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||d,this.h=!!e.showCommonFindToggles,this.s=e.inputActiveOptionBorder,this.v=e.inputActiveOptionForeground,this.w=e.inputActiveOptionBackground,this.y=e.inputBackground,this.I=e.inputForeground,this.J=e.inputBorder,this.L=e.inputValidationInfoBorder,this.M=e.inputValidationInfoBackground,this.N=e.inputValidationInfoForeground,this.O=e.inputValidationWarningBorder,this.P=e.inputValidationWarningBackground,this.Q=e.inputValidationWarningForeground,this.R=e.inputValidationErrorBorder,this.S=e.inputValidationErrorBackground,this.U=e.inputValidationErrorForeground;const s=e.appendCaseSensitiveLabel||"",l=e.appendWholeWordsLabel||"",u=e.appendRegexLabel||"",m=e.history||[],o=!!e.flexibleHeight,a=!!e.flexibleWidth,g=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new U.HistoryInputBox(this.domNode,n,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},inputBackground:this.y,inputForeground:this.I,inputBorder:this.J,inputValidationInfoBackground:this.M,inputValidationInfoForeground:this.N,inputValidationInfoBorder:this.L,inputValidationWarningBackground:this.P,inputValidationWarningForeground:this.Q,inputValidationWarningBorder:this.O,inputValidationErrorBackground:this.S,inputValidationErrorForeground:this.U,inputValidationErrorBorder:this.R,history:m,showHistoryHint:e.showHistoryHint,flexibleHeight:o,flexibleWidth:a,flexibleMaxHeight:g})),this.h){this.X=this.B(new i.RegexToggle({appendTitle:u,isChecked:!1,inputActiveOptionBorder:this.s,inputActiveOptionForeground:this.v,inputActiveOptionBackground:this.w})),this.B(this.X.onChange(L=>{this.cb.fire(L),!L&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.X.onKeyDown(L=>{this.ib.fire(L)})),this.Y=this.B(new i.WholeWordsToggle({appendTitle:l,isChecked:!1,inputActiveOptionBorder:this.s,inputActiveOptionForeground:this.v,inputActiveOptionBackground:this.w})),this.B(this.Y.onChange(L=>{this.cb.fire(L),!L&&this.i&&this.inputBox.focus(),this.validate()})),this.ab=this.B(new i.CaseSensitiveToggle({appendTitle:s,isChecked:!1,inputActiveOptionBorder:this.s,inputActiveOptionForeground:this.v,inputActiveOptionBackground:this.w})),this.B(this.ab.onChange(L=>{this.cb.fire(L),!L&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.ab.onKeyDown(L=>{this.hb.fire(L)}));const C=[this.ab.domNode,this.Y.domNode,this.X.domNode];this.p(this.domNode,L=>{if(L.equals(15)||L.equals(17)||L.equals(9)){const k=C.indexOf(document.activeElement);if(k>=0){let S=-1;L.equals(17)?S=(k+1)%C.length:L.equals(15)&&(k===0?S=C.length-1:S=k-1),L.equals(9)?(C[k].blur(),this.inputBox.focus()):S>=0&&C[S].focus(),v.EventHelper.stop(L,!0)}}})}this.W=document.createElement("div"),this.W.className="controls",this.W.style.display=this.h?"block":"none",this.ab&&this.W.append(this.ab.domNode),this.Y&&this.W.appendChild(this.Y.domNode),this.X&&this.W.appendChild(this.X.domNode),this.setAdditionalToggles(e?.additionalToggles),this.W&&this.domNode.appendChild(this.W),r?.appendChild(this.domNode),this.B(v.addDisposableListener(this.inputBox.inputElement,"compositionstart",C=>{this.l=!0})),this.B(v.addDisposableListener(this.inputBox.inputElement,"compositionend",C=>{this.l=!1,this.fb.fire()})),this.p(this.inputBox.inputElement,C=>this.db.fire(C)),this.u(this.inputBox.inputElement,C=>this.gb.fire(C)),this.C(this.inputBox.inputElement,C=>this.fb.fire()),this.j(this.inputBox.inputElement,C=>this.eb.fire(C))}get isImeSessionInProgress(){return this.l}get onDidChange(){return this.inputBox.onDidChange}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.X?.enable(),this.Y?.enable(),this.ab?.enable();for(const r of this.bb)r.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.X?.disable(),this.Y?.disable(),this.ab?.disable();for(const r of this.bb)r.disable()}setFocusInputOnOptionClick(r){this.i=r}setEnabled(r){r?this.enable():this.disable()}setAdditionalToggles(r){for(const n of this.bb)n.domNode.remove();this.bb=[],this.n.dispose(),this.n=new c.DisposableStore;for(const n of r??[])this.n.add(n),this.W.appendChild(n.domNode),this.n.add(n.onChange(e=>{this.cb.fire(e),!e&&this.i&&this.inputBox.focus()})),this.bb.push(n);this.bb.length>0&&(this.W.style.display="block"),this.inputBox.paddingRight=(this.ab?.width()??0)+(this.Y?.width()??0)+(this.X?.width()??0)+this.bb.reduce((n,e)=>n+e.width(),0)}clear(){this.lb(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(r){this.inputBox.value!==r&&(this.inputBox.value=r)}onSearchSubmit(){this.inputBox.addToHistory()}style(r){this.s=r.inputActiveOptionBorder,this.v=r.inputActiveOptionForeground,this.w=r.inputActiveOptionBackground,this.y=r.inputBackground,this.I=r.inputForeground,this.J=r.inputBorder,this.M=r.inputValidationInfoBackground,this.N=r.inputValidationInfoForeground,this.L=r.inputValidationInfoBorder,this.P=r.inputValidationWarningBackground,this.Q=r.inputValidationWarningForeground,this.O=r.inputValidationWarningBorder,this.S=r.inputValidationErrorBackground,this.U=r.inputValidationErrorForeground,this.R=r.inputValidationErrorBorder,this.jb()}jb(){if(this.domNode){const r={inputActiveOptionBorder:this.s,inputActiveOptionForeground:this.v,inputActiveOptionBackground:this.w};this.X?.style(r),this.Y?.style(r),this.ab?.style(r);for(const e of this.bb)e.style(r);const n={inputBackground:this.y,inputForeground:this.I,inputBorder:this.J,inputValidationInfoBackground:this.M,inputValidationInfoForeground:this.N,inputValidationInfoBorder:this.L,inputValidationWarningBackground:this.P,inputValidationWarningForeground:this.Q,inputValidationWarningBorder:this.O,inputValidationErrorBackground:this.S,inputValidationErrorForeground:this.U,inputValidationErrorBorder:this.R};this.inputBox.style(n)}}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.ab?.checked??!1}setCaseSensitive(r){this.ab&&(this.ab.checked=r)}getWholeWords(){return this.Y?.checked??!1}setWholeWords(r){this.Y&&(this.Y.checked=r)}getRegex(){return this.X?.checked??!1}setRegex(r){this.X&&(this.X.checked=r,this.validate())}focusOnCaseSensitive(){this.ab?.focus()}focusOnRegex(){this.X?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.kb),this.kb=1-this.kb,this.domNode.classList.add("highlight-"+this.kb)}validate(){this.inputBox.validate()}showMessage(r){this.inputBox.showMessage(r)}clearMessage(){this.inputBox.hideMessage()}lb(){this.inputBox.hideMessage()}}t.FindInput=f,f.OPTION_CHANGE="optionChange"}),define(be[128],pe([1,0,4,18,19,62,127,58,59,63,55,23,32,14,8,12,69,3,33,2,46,6,101,93]),function(Q,t,v,i,U,R,y,w,c,d,f,I,r,n,e,s,l,u,m,o,a,g,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMode=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class L extends w.ElementsDragAndDropData{set context(F){this.c.context=F}get context(){return this.c.context}constructor(F){super(F.elements.map(_=>_.element)),this.c=F}}function k(ne){return ne instanceof w.ElementsDragAndDropData?new L(ne):ne}class S{constructor(F,_){this.c=F,this.d=_,this.b=o.Disposable.None}getDragURI(F){return this.d.getDragURI(F.element)}getDragLabel(F,_){if(this.d.getDragLabel)return this.d.getDragLabel(F.map(G=>G.element),_)}onDragStart(F,_){this.d.onDragStart?.(k(F),_)}onDragOver(F,_,G,P,b=!0){const B=this.d.onDragOver(k(F),_&&_.element,G,P),$=this.a!==_;if($&&(this.b.dispose(),this.a=_),typeof _>"u")return B;if($&&typeof B!="boolean"&&B.autoExpand&&(this.b=(0,e.disposableTimeout)(()=>{const H=this.c(),A=H.getNodeLocation(_);H.isCollapsed(A)&&H.setCollapsed(A,!1),this.a=void 0},500)),typeof B=="boolean"||!B.accept||typeof B.bubble>"u"||B.feedback){if(!b){const H=typeof B=="boolean"?B:B.accept,A=typeof B=="boolean"?void 0:B.effect;return{accept:H,effect:A,feedback:[G]}}return B}if(B.bubble===1){const H=this.c(),A=H.getNodeLocation(_),N=H.getParentNodeLocation(A),O=H.getNode(N),W=N&&H.getListIndex(N);return this.onDragOver(F,O,W,P,!1)}const V=this.c(),Z=V.getNodeLocation(_),T=V.getListIndex(Z),M=V.getListRenderCount(Z);return{...B,feedback:(0,n.range)(T,T+M)}}drop(F,_,G,P){this.b.dispose(),this.a=void 0,this.d.drop(k(F),_&&_.element,G,P)}onDragEnd(F){this.d.onDragEnd?.(F)}}function h(ne,F){return F&&{...F,identityProvider:F.identityProvider&&{getId(_){return F.identityProvider.getId(_.element)}},dnd:F.dnd&&new S(ne,F.dnd),multipleSelectionController:F.multipleSelectionController&&{isSelectionSingleChangeEvent(_){return F.multipleSelectionController.isSelectionSingleChangeEvent({..._,element:_.element})},isSelectionRangeChangeEvent(_){return F.multipleSelectionController.isSelectionRangeChangeEvent({..._,element:_.element})}},accessibilityProvider:F.accessibilityProvider&&{...F.accessibilityProvider,getSetSize(_){const G=ne(),P=G.getNodeLocation(_),b=G.getParentNodeLocation(P);return G.getNode(b).visibleChildrenCount},getPosInSet(_){return _.visibleChildIndex+1},isChecked:F.accessibilityProvider&&F.accessibilityProvider.isChecked?_=>F.accessibilityProvider.isChecked(_.element):void 0,getRole:F.accessibilityProvider&&F.accessibilityProvider.getRole?_=>F.accessibilityProvider.getRole(_.element):()=>"treeitem",getAriaLabel(_){return F.accessibilityProvider.getAriaLabel(_.element)},getWidgetAriaLabel(){return F.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:F.accessibilityProvider&&F.accessibilityProvider.getWidgetRole?()=>F.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:F.accessibilityProvider&&F.accessibilityProvider.getAriaLevel?_=>F.accessibilityProvider.getAriaLevel(_.element):_=>_.depth,getActiveDescendantId:F.accessibilityProvider.getActiveDescendantId&&(_=>F.accessibilityProvider.getActiveDescendantId(_.element))},keyboardNavigationLabelProvider:F.keyboardNavigationLabelProvider&&{...F.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(_){return F.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(_.element)}}}}class E{constructor(F){this.a=F}getHeight(F){return this.a.getHeight(F.element)}getTemplateId(F){return this.a.getTemplateId(F.element)}hasDynamicHeight(F){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(F.element)}setDynamicHeight(F,_){this.a.setDynamicHeight?.(F.element,_)}}t.ComposedTreeDelegate=E;class p{static lift(F){return F instanceof p?F:new p(F)}static empty(F=0){return new p({focus:[],selection:[],expanded:Object.create(null),scrollTop:F})}constructor(F){if(this.focus=new Set(F.focus),this.selection=new Set(F.selection),F.expanded instanceof Array){this.expanded=Object.create(null);for(const _ of F.expanded)this.expanded[_]=1}else this.expanded=F.expanded;this.expanded=F.expanded,this.scrollTop=F.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=p;var D;(function(ne){ne.None="none",ne.OnHover="onHover",ne.Always="always"})(D=t.RenderIndentGuides||(t.RenderIndentGuides={}));class z{get elements(){return this.b}constructor(F,_=[]){this.b=_,this.a=new o.DisposableStore,this.onDidChange=u.Event.forEach(F,G=>this.b=G,this.a)}dispose(){this.a.dispose()}}class q{constructor(F,_,G,P,b,B={}){this.o=F,this.p=_,this.q=P,this.s=b,this.b=new Map,this.c=new Map,this.d=q.a,this.f=!1,this.g=!1,this.j=new Set,this.k=o.Disposable.None,this.m=new o.DisposableStore,this.templateId=F.templateId,this.updateOptions(B),u.Event.map(G,$=>$.node)(this.u,this,this.m),F.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(F={}){if(typeof F.indent<"u"){const _=(0,a.clamp)(F.indent,0,40);if(_!==this.d){this.d=_;for(const[G,P]of this.c)this.v(G,P)}}if(typeof F.renderIndentGuides<"u"){const _=F.renderIndentGuides!==D.None;if(_!==this.g&&(this.g=_,this.k.dispose(),_)){const G=new o.DisposableStore;this.q.onDidChange(this.w,this,G),this.k=G,this.w(this.q.elements)}}typeof F.hideTwistiesOfChildlessElements<"u"&&(this.f=F.hideTwistiesOfChildlessElements)}renderTemplate(F){const _=(0,v.append)(F,(0,v.$)(".monaco-tl-row")),G=(0,v.append)(_,(0,v.$)(".monaco-tl-indent")),P=(0,v.append)(_,(0,v.$)(".monaco-tl-twistie")),b=(0,v.append)(_,(0,v.$)(".monaco-tl-contents")),B=this.o.renderTemplate(b);return{container:F,indent:G,twistie:P,indentGuidesDisposable:o.Disposable.None,templateData:B}}renderElement(F,_,G,P){this.c.set(F,G),this.b.set(F.element,F),this.v(F,G),this.o.renderElement(F,_,G.templateData,P)}disposeElement(F,_,G,P){G.indentGuidesDisposable.dispose(),this.o.disposeElement?.(F,_,G.templateData,P),typeof P=="number"&&(this.c.delete(F),this.b.delete(F.element))}disposeTemplate(F){this.o.disposeTemplate(F.templateData)}t(F){const _=this.b.get(F);!_||this.u(_)}u(F){const _=this.c.get(F);!_||(this.w(this.q.elements),this.v(F,_))}v(F,_){const G=q.a+(F.depth-1)*this.d;_.twistie.style.paddingLeft=`${G}px`,_.indent.style.width=`${G+this.d-16}px`,F.collapsible?_.container.setAttribute("aria-expanded",String(!F.collapsed)):_.container.removeAttribute("aria-expanded"),_.twistie.classList.remove(...s.Codicon.treeItemExpanded.classNamesArray);let P=!1;if(this.o.renderTwistie&&(P=this.o.renderTwistie(F.element,_.twistie)),F.collapsible&&(!this.f||F.visibleChildrenCount>0)?(P||_.twistie.classList.add(...s.Codicon.treeItemExpanded.classNamesArray),_.twistie.classList.add("collapsible"),_.twistie.classList.toggle("collapsed",F.collapsed)):_.twistie.classList.remove("collapsible","collapsed"),(0,v.clearNode)(_.indent),_.indentGuidesDisposable.dispose(),!this.g)return;const b=new o.DisposableStore,B=this.p();for(;;){const $=B.getNodeLocation(F),V=B.getParentNodeLocation($);if(!V)break;const Z=B.getNode(V),T=(0,v.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(Z)&&T.classList.add("active"),_.indent.childElementCount===0?_.indent.appendChild(T):_.indent.insertBefore(T,_.indent.firstElementChild),this.s.add(Z,T),b.add((0,o.toDisposable)(()=>this.s.delete(Z,T))),F=Z}_.indentGuidesDisposable=b}w(F){if(!this.g)return;const _=new Set,G=this.p();F.forEach(P=>{const b=G.getNodeLocation(P);try{const B=G.getParentNodeLocation(b);P.collapsible&&P.children.length>0&&!P.collapsed?_.add(P):B&&_.add(G.getNode(B))}catch{}}),this.j.forEach(P=>{_.has(P)||this.s.forEach(P,b=>b.classList.remove("active"))}),_.forEach(P=>{this.j.has(P)||this.s.forEach(P,b=>b.classList.add("active"))}),this.j=_}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,o.dispose)(this.m)}}q.a=8;class ie{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(F){this.c=F,this.d=F.toLowerCase()}constructor(F,_,G){this.g=F,this.j=_,this.k=G,this.a=0,this.b=0,this.c="",this.d="",this.f=new o.DisposableStore,F.onWillRefilter(this.m,this,this.f)}filter(F,_){let G=1;if(this.k){const B=this.k.filter(F,_);if(typeof B=="boolean"?G=B?1:0:(0,f.isFilterResult)(B)?G=(0,f.getVisibleState)(B.visibility):G=B,G===0)return!1}if(this.a++,!this.c)return this.b++,{data:m.FuzzyScore.Default,visibility:G};const P=this.j.getKeyboardNavigationLabel(F),b=Array.isArray(P)?P:[P];for(const B of b){const $=B&&B.toString();if(typeof $>"u")return{data:m.FuzzyScore.Default,visibility:G};const V=(0,m.fuzzyScore)(this.c,this.d,0,$,$.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(V)return this.b++,b.length===1?{data:V,visibility:G}:{data:{label:$,score:V},visibility:G}}return this.g.findMode===me.Filter?2:{data:m.FuzzyScore.Default,visibility:G}}m(){this.a=0,this.b=0}dispose(){(0,o.dispose)(this.f)}}class J extends d.Toggle{constructor(F){super({icon:s.Codicon.listFilter,title:(0,C.localize)(0,null),isChecked:F?.isChecked??!1,inputActiveOptionBorder:F?.inputActiveOptionBorder,inputActiveOptionForeground:F?.inputActiveOptionForeground,inputActiveOptionBackground:F?.inputActiveOptionBackground})}}t.ModeToggle=J;var me;(function(ne){ne[ne.Highlight=0]="Highlight",ne[ne.Filter=1]="Filter"})(me=t.TreeFindMode||(t.TreeFindMode={}));class he extends o.Disposable{set mode(F){this.b.checked=F===me.Filter,this.c.inputBox.setPlaceHolder(F===me.Filter?(0,C.localize)(1,null):(0,C.localize)(2,null))}get value(){return this.c.inputBox.value}set value(F){this.c.inputBox.value=F}constructor(F,_,G,P,b){super(),this.m=_,this.a=(0,v.h)(".monaco-tree-type-filter",[(0,v.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,v.h)(".monaco-tree-type-filter-input@findInput"),(0,v.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.g=0,this.j=0,this.k=0,this._onDidDisable=new u.Emitter,this.onDidDisable=this._onDidDisable.event,F.appendChild(this.a.root),this.B((0,o.toDisposable)(()=>F.removeChild(this.a.root))),this.b=this.B(new J({...b,isChecked:P===me.Filter})),this.onDidChangeMode=u.Event.map(this.b.onChange,()=>this.b.checked?me.Filter:me.Highlight,this.q),this.c=this.B(new y.FindInput(this.a.findInput,G,{label:(0,C.localize)(3,null),additionalToggles:[this.b],showCommonFindToggles:!1})),this.f=this.B(new R.ActionBar(this.a.actionbar)),this.mode=P;const B=this.B(new i.DomEmitter(this.c.inputBox.inputElement,"keydown")),$=this.B(u.Event.chain(B.event)).map(M=>new U.StandardKeyboardEvent(M)).event;this.B($(M=>{switch(M.keyCode){case 18:M.preventDefault(),M.stopPropagation(),this.m.domFocus();return}}));const V=this.B(new r.Action("close",(0,C.localize)(4,null),"codicon codicon-close",!0,()=>this.dispose()));this.f.push(V,{icon:!0,label:!1});const Z=this.B(new i.DomEmitter(this.a.grab,"mousedown"));this.B(Z.event(M=>{const H=new o.DisposableStore,A=H.add(new i.DomEmitter(window,"mousemove")),N=H.add(new i.DomEmitter(window,"mouseup")),O=this.j,W=M.pageX,j=this.k,ee=M.pageY;this.a.grab.classList.add("grabbing");const le=this.a.root.style.transition;this.a.root.style.transition="unset";const ce=De=>{const ye=De.pageX-W;this.j=O-ye;const Ie=De.pageY-ee;this.k=j+Ie,this.layout()};H.add(A.event(ce)),H.add(N.event(De=>{ce(De),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=le,H.dispose()}))}));const T=this.B(u.Event.chain(this.B(new i.DomEmitter(this.a.grab,"keydown")).event)).map(M=>new U.StandardKeyboardEvent(M)).event;this.B(T(M=>{let H,A;if(M.keyCode===15?H=Number.POSITIVE_INFINITY:M.keyCode===17?H=0:M.keyCode===10&&(H=this.j===0?Number.POSITIVE_INFINITY:0),M.keyCode===16?A=0:M.keyCode===18&&(A=Number.POSITIVE_INFINITY),H!==void 0&&(M.preventDefault(),M.stopPropagation(),this.j=H,this.layout()),A!==void 0){M.preventDefault(),M.stopPropagation(),this.k=A;const N=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=N},0)}})),this.onDidChangeValue=this.c.onDidChange,this.style(b??{})}style(F){this.c.style(F),F.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=F.listFilterWidgetBackground.toString()),F.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${F.listFilterWidgetShadow}`)}focus(){this.c.focus()}select(){this.c.select()}layout(F=this.g){this.g=F,this.j=(0,a.clamp)(this.j,0,Math.max(0,F-212)),this.a.root.style.right=`${this.j}px`,this.k=(0,a.clamp)(this.k,0,24),this.a.root.style.top=`${this.k}px`}showMessage(F){this.c.showMessage(F)}clearMessage(){this.c.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,e.timeout)(300),super.dispose()}}class fe{get pattern(){return this.a}get mode(){return this.c}set mode(F){F!==this.c&&(this.c=F,this.d&&(this.d.mode=this.c),this.q.refilter(),this.x(),this.j.fire(F))}constructor(F,_,G,P,b){this.q=F,this.s=G,this.t=P,this.u=b,this.a="",this.b="",this.g=0,this.j=new u.Emitter,this.onDidChangeMode=this.j.event,this.k=new u.Emitter,this.onDidChangePattern=this.k.event,this.m=new u.Emitter,this.onDidChangeOpenState=this.m.event,this.o=new o.DisposableStore,this.p=new o.DisposableStore,this.c=F.options.defaultFindMode??me.Highlight,_.onDidSplice(this.w,this,this.p)}open(){if(this.d){this.d.focus(),this.d.select();return}this.mode=this.q.options.defaultFindMode??me.Highlight,this.d=new he(this.s.getHTMLElement(),this.q,this.u,this.mode,this.f),this.o.add(this.d),this.d.onDidChangeValue(this.v,this,this.o),this.d.onDidChangeMode(F=>this.mode=F,void 0,this.o),this.d.onDidDisable(this.close,this,this.o),this.d.layout(this.g),this.d.focus(),this.d.value=this.b,this.d.select(),this.m.fire(!0)}close(){!this.d||(this.d=void 0,this.o.dispose(),this.o=new o.DisposableStore,this.b=this.pattern,this.v(""),this.q.domFocus(),this.m.fire(!1))}v(F){this.a=F,this.k.fire(F),this.t.pattern=F,this.q.refilter(),F&&this.q.focusNext(0,!0,void 0,G=>!m.FuzzyScore.isDefault(G.filterData));const _=this.q.getFocus();if(_.length>0){const G=_[0];this.q.getRelativeTop(G)===null&&this.q.reveal(G,.5)}this.x()}w(){!this.d||this.pattern.length===0||(this.q.refilter(),this.x())}x(){const F=this.t.totalCount>0&&this.t.matchCount===0;this.pattern&&F?this.q.options.showNotFoundMessage??!0?this.d?.showMessage({type:2,content:(0,C.localize)(5,null)}):this.d?.showMessage({type:2}):this.d?.clearMessage()}shouldAllowFocus(F){return!this.d||!this.pattern||this.c===me.Filter||this.t.totalCount>0&&this.t.matchCount<=1?!0:!m.FuzzyScore.isDefault(F.filterData)}style(F){this.f=F,this.d?.style(F)}layout(F){this.g=F,this.d?.layout(F)}dispose(){this.k.dispose(),this.o.dispose(),this.p.dispose()}}function oe(ne){let F=I.TreeMouseEventTarget.Unknown;return(0,v.hasParentWithClass)(ne.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?F=I.TreeMouseEventTarget.Twistie:(0,v.hasParentWithClass)(ne.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?F=I.TreeMouseEventTarget.Element:(0,v.hasParentWithClass)(ne.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(F=I.TreeMouseEventTarget.Filter),{browserEvent:ne.browserEvent,element:ne.element?ne.element.element:null,target:F}}function de(ne){return{element:ne.element?ne.element.element:null,browserEvent:ne.browserEvent,anchor:ne.anchor}}function Se(ne,F){F(ne),ne.children.forEach(_=>Se(_,F))}class te{get f(){return this.d||(this.d=this.m()),this.d}constructor(F,_){this.g=F,this.j=_,this.a=[],this.c=new u.Emitter,this.onDidChange=this.c.event}set(F,_){!_?.__forceEvent&&(0,n.equals)(this.a,F)||this.k(F,!1,_)}k(F,_,G){if(this.a=[...F],this.b=void 0,this.d=void 0,!_){const P=this;this.c.fire({get elements(){return P.get()},browserEvent:G})}}get(){return this.b||(this.b=this.a.map(F=>F.element)),[...this.b]}getNodes(){return this.a}has(F){return this.f.has(F)}onDidModelSplice({insertedNodes:F,deletedNodes:_}){if(!this.j){const V=this.m(),Z=T=>V.delete(T);_.forEach(T=>Se(T,Z)),this.set([...V.values()]);return}const G=new Set,P=V=>G.add(this.j.getId(V.element).toString());_.forEach(V=>Se(V,P));const b=new Map,B=V=>b.set(this.j.getId(V.element).toString(),V);F.forEach(V=>Se(V,B));const $=[];for(const V of this.a){const Z=this.j.getId(V.element).toString();if(!G.has(Z))$.push(V);else{const M=b.get(Z);M&&$.push(M)}}if(this.a.length>0&&$.length===0){const V=this.g();V&&$.push(V)}this.k($,!0)}m(){const F=new Set;for(const _ of this.a)F.add(_);return F}}class Ce extends c.MouseController{constructor(F,_){super(F),this.A=_}u(F){if((0,c.isButton)(F.browserEvent.target)||(0,c.isInputElement)(F.browserEvent.target)||(0,c.isMonacoEditor)(F.browserEvent.target))return;const _=F.element;if(!_)return super.u(F);if(this.p(F)||this.o(F))return super.u(F);const G=F.browserEvent.target,P=G.classList.contains("monaco-tl-twistie")||G.classList.contains("monaco-icon-label")&&G.classList.contains("folder-icon")&&F.browserEvent.offsetX<16;let b=!1;if(typeof this.A.expandOnlyOnTwistieClick=="function"?b=this.A.expandOnlyOnTwistieClick(_.element):b=!!this.A.expandOnlyOnTwistieClick,b&&!P&&F.browserEvent.detail!==2)return super.u(F);if(!this.A.expandOnDoubleClick&&F.browserEvent.detail===2)return super.u(F);if(_.collapsible){const B=this.A.model,$=B.getNodeLocation(_),V=F.browserEvent.altKey;if(this.A.setFocus([$]),B.setCollapsed($,void 0,V),b&&P)return}super.u(F)}v(F){F.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.A.expandOnDoubleClick||super.v(F)}}class se extends c.List{constructor(F,_,G,P,b,B,$,V){super(F,_,G,P,V),this.p=b,this.s=B,this.M=$}F(F){return new Ce(this,F.tree)}splice(F,_,G=[]){if(super.splice(F,_,G),G.length===0)return;const P=[],b=[];let B;G.forEach(($,V)=>{this.p.has($)&&P.push(F+V),this.s.has($)&&b.push(F+V),this.M.has($)&&(B=F+V)}),P.length>0&&super.setFocus((0,n.distinct)([...super.getFocus(),...P])),b.length>0&&super.setSelection((0,n.distinct)([...super.getSelection(),...b])),typeof B=="number"&&super.setAnchor(B)}setFocus(F,_,G=!1){super.setFocus(F,_),G||this.p.set(F.map(P=>this.element(P)),_)}setSelection(F,_,G=!1){super.setSelection(F,_),G||this.s.set(F.map(P=>this.element(P)),_)}setAnchor(F,_=!1){super.setAnchor(F),_||(typeof F>"u"?this.M.set([]):this.M.set([this.element(F)]))}}class x{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.u.wrapEvent(this.o.onDidChange)}get onDidChangeSelection(){return this.u.wrapEvent(this.p.onDidChange)}get onMouseClick(){return u.Event.map(this.j.onMouseClick,oe)}get onMouseDblClick(){return u.Event.filter(u.Event.map(this.j.onMouseDblClick,oe),F=>F.target!==I.TreeMouseEventTarget.Filter)}get onContextMenu(){return u.Event.map(this.j.onContextMenu,de)}get onTap(){return u.Event.map(this.j.onTap,oe)}get onPointer(){return u.Event.map(this.j.onPointer,oe)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return u.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.w?.mode??me.Highlight}set findMode(F){this.w&&(this.w.mode=F)}get onDidChangeFindPattern(){return this.w?this.w.onDidChangePattern:u.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(F,_,G,P,b={}){this.D=F,this.E=b,this.u=new u.EventBufferer,this.onDidChangeFindOpenState=u.Event.None,this.A=new o.DisposableStore,this.B=new u.Emitter,this.onWillRefilter=this.B.event,this.C=new u.Emitter,this.onDidUpdateOptions=this.C.event;const B=new E(G),$=new u.Relay,V=new u.Relay,Z=this.A.add(new z(V.event)),T=new l.SetMap;this.k=P.map(A=>new q(A,()=>this.model,$.event,Z,T,b));for(const A of this.k)this.A.add(A);let M;b.keyboardNavigationLabelProvider&&(M=new ie(this,b.keyboardNavigationLabelProvider,b.filter),b={...b,filter:M},this.A.add(M)),this.o=new te(()=>this.j.getFocusedElements()[0],b.identityProvider),this.p=new te(()=>this.j.getSelectedElements()[0],b.identityProvider),this.q=new te(()=>this.j.getAnchorElement(),b.identityProvider),this.j=new se(F,_,B,this.k,this.o,this.p,this.q,{...h(()=>this.model,b),tree:this}),this.model=this.I(F,this.j,b),$.input=this.model.onDidChangeCollapseState;const H=u.Event.forEach(this.model.onDidSplice,A=>{this.u.bufferEvents(()=>{this.o.onDidModelSplice(A),this.p.onDidModelSplice(A)})},this.A);if(H(()=>null,null,this.A),V.input=u.Event.chain(u.Event.any(H,this.o.onDidChange,this.p.onDidChange)).debounce(()=>null,0).map(()=>{const A=new Set;for(const N of this.o.getNodes())A.add(N);for(const N of this.p.getNodes())A.add(N);return[...A.values()]}).event,b.keyboardSupport!==!1){const A=u.Event.chain(this.j.onKeyDown).filter(N=>!(0,c.isInputElement)(N.target)).map(N=>new U.StandardKeyboardEvent(N));A.filter(N=>N.keyCode===15).on(this.F,this,this.A),A.filter(N=>N.keyCode===17).on(this.G,this,this.A),A.filter(N=>N.keyCode===10).on(this.H,this,this.A)}(b.findWidgetEnabled??!0)&&b.keyboardNavigationLabelProvider&&b.contextViewProvider?(this.w=new fe(this,this.model,this.j,M,b.contextViewProvider),this.x=A=>this.w.shouldAllowFocus(A),this.onDidChangeFindOpenState=this.w.onDidChangeOpenState,this.A.add(this.w),this.onDidChangeFindMode=this.w.onDidChangeMode):this.onDidChangeFindMode=u.Event.None,this.y=(0,v.createStyleSheet)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===D.Always)}updateOptions(F={}){this.E={...this.E,...F};for(const _ of this.k)_.updateOptions(F);this.j.updateOptions(this.E),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===D.Always)}get options(){return this.E}updateWidth(F){const _=this.model.getListIndex(F);_!==-1&&this.j.updateWidth(_)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get scrollTop(){return this.j.scrollTop}set scrollTop(F){this.j.scrollTop=F}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(F){this.j.scrollLeft=F}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const F=this.j.firstVisibleIndex;return F<0||F>=this.j.length?void 0:this.j.element(F).element}get lastVisibleElement(){const F=this.j.lastVisibleIndex;return this.j.element(F).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(F){this.j.ariaLabel=F}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(F,_){this.j.layout(F,_),(0,g.isNumber)(_)&&this.w?.layout(_)}style(F){const _=`.${this.j.domId}`,G=[];F.treeIndentGuidesStroke&&(G.push(`.monaco-list${_}:hover .monaco-tl-indent > .indent-guide, .monaco-list${_}.always .monaco-tl-indent > .indent-guide  { border-color: ${F.treeIndentGuidesStroke.transparent(.4)}; }`),G.push(`.monaco-list${_} .monaco-tl-indent > .indent-guide.active { border-color: ${F.treeIndentGuidesStroke}; }`)),this.y.textContent=G.join(`
`),this.w?.style(F),this.j.style(F)}getParentElement(F){const _=this.model.getParentNodeLocation(F);return this.model.getNode(_).element}getFirstElementChild(F){return this.model.getFirstElementChild(F)}getNode(F){return this.model.getNode(F)}collapse(F,_=!1){return this.model.setCollapsed(F,!0,_)}expand(F,_=!1){return this.model.setCollapsed(F,!1,_)}toggleCollapsed(F,_=!1){return this.model.setCollapsed(F,void 0,_)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(F){return this.model.isCollapsible(F)}setCollapsible(F,_){return this.model.setCollapsible(F,_)}isCollapsed(F){return this.model.isCollapsed(F)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.w?.open()}closeFind(){this.w?.close()}refilter(){this.B.fire(void 0),this.model.refilter()}setAnchor(F){if(typeof F>"u")return this.j.setAnchor(void 0);const _=this.model.getNode(F);this.q.set([_]);const G=this.model.getListIndex(F);G>-1&&this.j.setAnchor(G,!0)}getAnchor(){return(0,n.firstOrDefault)(this.q.get(),void 0)}setSelection(F,_){const G=F.map(b=>this.model.getNode(b));this.p.set(G,_);const P=F.map(b=>this.model.getListIndex(b)).filter(b=>b>-1);this.j.setSelection(P,_,!0)}getSelection(){return this.p.get()}setFocus(F,_){const G=F.map(b=>this.model.getNode(b));this.o.set(G,_);const P=F.map(b=>this.model.getListIndex(b)).filter(b=>b>-1);this.j.setFocus(P,_,!0)}focusNext(F=1,_=!1,G,P=this.x){this.j.focusNext(F,_,G,P)}focusPrevious(F=1,_=!1,G,P=this.x){this.j.focusPrevious(F,_,G,P)}focusNextPage(F,_=this.x){return this.j.focusNextPage(F,_)}focusPreviousPage(F,_=this.x){return this.j.focusPreviousPage(F,_)}focusLast(F,_=this.x){this.j.focusLast(F,_)}focusFirst(F,_=this.x){this.j.focusFirst(F,_)}getFocus(){return this.o.get()}reveal(F,_){this.model.expandTo(F);const G=this.model.getListIndex(F);G!==-1&&this.j.reveal(G,_)}getRelativeTop(F){const _=this.model.getListIndex(F);return _===-1?null:this.j.getRelativeTop(_)}getViewState(F=this.options.identityProvider){if(!F)throw new I.TreeError(this.D,"Can't get tree view state without an identity provider");const _=B=>F.getId(B).toString(),G=p.empty(this.scrollTop);for(const B of this.getFocus())G.focus.add(_(B));for(const B of this.getSelection())G.selection.add(_(B));const P=this.model.getNode(),b=[P];for(;b.length>0;){const B=b.shift();B!==P&&B.collapsible&&(G.expanded[_(B.element)]=B.collapsed?0:1),b.push(...B.children)}return G}F(F){F.preventDefault(),F.stopPropagation();const _=this.j.getFocusedElements();if(_.length===0)return;const G=_[0],P=this.model.getNodeLocation(G);if(!this.model.setCollapsed(P,!0)){const B=this.model.getParentNodeLocation(P);if(!B)return;const $=this.model.getListIndex(B);this.j.reveal($),this.j.setFocus([$])}}G(F){F.preventDefault(),F.stopPropagation();const _=this.j.getFocusedElements();if(_.length===0)return;const G=_[0],P=this.model.getNodeLocation(G);if(!this.model.setCollapsed(P,!1)){if(!G.children.some(V=>V.visible))return;const[B]=this.j.getFocus(),$=B+1;this.j.reveal($),this.j.setFocus([$])}}H(F){F.preventDefault(),F.stopPropagation();const _=this.j.getFocusedElements();if(_.length===0)return;const G=_[0],P=this.model.getNodeLocation(G),b=F.browserEvent.altKey;this.model.setCollapsed(P,void 0,b)}navigate(F){return new ue(this.j,this.model,F)}dispose(){(0,o.dispose)(this.A),this.j.dispose()}}t.AbstractTree=x;class ue{constructor(F,_,G){this.b=F,this.c=_,G?this.a=this.c.getListIndex(G):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[129],pe([1,0,128,118,23,26]),function(Q,t,v,i,U,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class y extends v.AbstractTree{constructor(c,d,f,I,r,n={}){super(c,d,f,I,n),this.d=c,this.f=r,this.c=new Map,this.b=n.identityProvider}getInput(){return this.a}setInput(c,d){if(d&&!this.b)throw new U.TreeError(this.d,"Can't restore tree view state without an identity provider");if(this.a=c,!c){this.c.clear(),this.model.setChildren(null,R.Iterable.empty());return}if(!d){this.g(c);return}const f=[],I=[],r=e=>{const s=this.b.getId(e).toString();return!d.expanded[s]},n=e=>{const s=this.b.getId(e.element).toString();d.focus.has(s)&&f.push(e.element),d.selection.has(s)&&I.push(e.element)};this.g(c,r,n),this.setFocus(f),this.setSelection(I),d&&typeof d.scrollTop=="number"&&(this.scrollTop=d.scrollTop)}updateChildren(c=this.a){if(typeof this.a>"u")throw new U.TreeError(this.d,"Tree input not set");let d;this.b&&(d=f=>{const I=this.b.getId(f).toString(),r=this.c.get(I);if(!!r)return r.collapsed}),this.g(c,d)}resort(c=this.a,d=!0){this.model.resort(c===this.a?null:c,d)}refresh(c){if(c===void 0){this.j.rerender();return}this.model.rerender(c)}g(c,d,f){let I;if(this.b){const r=new Set,n=f;f=e=>{const s=this.b.getId(e.element).toString();r.add(s),this.c.set(s,e),n?.(e)},I=e=>{const s=this.b.getId(e.element).toString();r.has(s)||this.c.delete(s)}}this.model.setChildren(c===this.a?null:c,this.m(c,d).elements,{onDidCreateNode:f,onDidDeleteNode:I})}m(c,d){const f=[...this.f.getChildren(c)];return{elements:R.Iterable.map(f,r=>{const{elements:n,size:e}=this.m(r,d),s=this.f.hasChildren?this.f.hasChildren(r):void 0,l=e===0?void 0:d&&d(r);return{element:r,children:n,collapsible:s,collapsed:l}}),size:f.length}}I(c,d,f){return new i.ObjectTreeModel(c,d,f)}}t.DataTree=y}),define(be[38],pe([1,0,14,8,31,28,25,9,3,2,50,11,6]),function(Q,t,v,i,U,R,y,w,c,d,f,I,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=void 0;var n;(function(se){se[se.Promise=100]="Promise",se[se.PromiseCancel=101]="PromiseCancel",se[se.EventListen=102]="EventListen",se[se.EventDispose=103]="EventDispose"})(n||(n={}));function e(se){switch(se){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(se){se[se.Initialize=200]="Initialize",se[se.PromiseSuccess=201]="PromiseSuccess",se[se.PromiseError=202]="PromiseError",se[se.PromiseErrorObj=203]="PromiseErrorObj",se[se.EventFire=204]="EventFire"})(s||(s={}));function l(se){switch(se){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(se){se[se.Uninitialized=0]="Uninitialized",se[se.Idle=1]="Idle"})(u||(u={}));class m{constructor(x){this.b=x,this.a=0}read(x){const ue=this.b.slice(this.a,this.a+x);return this.a+=ue.byteLength,ue}}class o{constructor(){this.a=[]}get buffer(){return U.VSBuffer.concat(this.a)}write(x){this.a.push(x)}}var a;(function(se){se[se.Undefined=0]="Undefined",se[se.String=1]="String",se[se.Buffer=2]="Buffer",se[se.VSBuffer=3]="VSBuffer",se[se.Array=4]="Array",se[se.Object=5]="Object"})(a||(a={}));function g(se){const x=U.VSBuffer.alloc(4);return x.writeUInt32BE(se,0),x}function C(se){return se.read(4).readUInt32BE(0)}function L(se){const x=U.VSBuffer.alloc(1);return x.writeUInt8(se,0),x}const k={Undefined:L(a.Undefined),String:L(a.String),Buffer:L(a.Buffer),VSBuffer:L(a.VSBuffer),Array:L(a.Array),Object:L(a.Object)},S=typeof Buffer<"u";function h(se,x){if(typeof x>"u")se.write(k.Undefined);else if(typeof x=="string"){const ue=U.VSBuffer.fromString(x);se.write(k.String),se.write(g(ue.byteLength)),se.write(ue)}else if(S&&Buffer.isBuffer(x)){const ue=U.VSBuffer.wrap(x);se.write(k.Buffer),se.write(g(ue.byteLength)),se.write(ue)}else if(x instanceof U.VSBuffer)se.write(k.VSBuffer),se.write(g(x.byteLength)),se.write(x);else if(Array.isArray(x)){se.write(k.Array),se.write(g(x.length));for(const ue of x)h(se,ue)}else{const ue=U.VSBuffer.fromString(JSON.stringify(x));se.write(k.Object),se.write(g(ue.byteLength)),se.write(ue)}}function E(se){switch(se.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return se.read(C(se)).toString();case a.Buffer:return se.read(C(se)).buffer;case a.VSBuffer:return se.read(C(se));case a.Array:{const ue=C(se),ne=[];for(let F=0;F<ue;F++)ne.push(E(se));return ne}case a.Object:return JSON.parse(se.read(C(se)).toString())}}class p{constructor(x,ue,ne=null,F=1e3){this.h=x,this.j=ue,this.k=ne,this.l=F,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.p(_)),this.m({type:200})}registerChannel(x,ue){this.b.set(x,ue),setTimeout(()=>this.v(x),0)}m(x){switch(x.type){case 200:{const ue=this.n([x.type]);this.k?.logOutgoing(ue,0,1,l(x.type));return}case 201:case 202:case 204:case 203:{const ue=this.n([x.type,x.id],x.data);this.k?.logOutgoing(ue,x.id,1,l(x.type),x.data);return}}}n(x,ue=void 0){const ne=new o;return h(ne,x),h(ne,ue),this.o(ne.buffer)}o(x){try{return this.h.send(x),x.byteLength}catch{return 0}}p(x){const ue=new m(x),ne=E(ue),F=E(ue),_=ne[0];switch(_){case 100:return this.k?.logIncoming(x.byteLength,ne[1],1,`${e(_)}: ${ne[2]}.${ne[3]}`,F),this.q({type:_,id:ne[1],channelName:ne[2],name:ne[3],arg:F});case 102:return this.k?.logIncoming(x.byteLength,ne[1],1,`${e(_)}: ${ne[2]}.${ne[3]}`,F),this.s({type:_,id:ne[1],channelName:ne[2],name:ne[3],arg:F});case 101:return this.k?.logIncoming(x.byteLength,ne[1],1,`${e(_)}`),this.t({type:_,id:ne[1]});case 103:return this.k?.logIncoming(x.byteLength,ne[1],1,`${e(_)}`),this.t({type:_,id:ne[1]})}}q(x){const ue=this.b.get(x.channelName);if(!ue){this.u(x);return}const ne=new R.CancellationTokenSource;let F;try{F=ue.call(this.j,x.name,x.arg,ne.token)}catch(P){F=Promise.reject(P)}const _=x.id;F.then(P=>{this.m({id:_,data:P,type:201}),this.d.delete(x.id)},P=>{P instanceof Error?this.m({id:_,data:{message:P.message,name:P.name,stack:P.stack?P.stack.split?P.stack.split(`
`):P.stack:void 0},type:202}):this.m({id:_,data:P,type:203}),this.d.delete(x.id)});const G=(0,d.toDisposable)(()=>ne.cancel());this.d.set(x.id,G)}s(x){const ue=this.b.get(x.channelName);if(!ue){this.u(x);return}const ne=x.id,_=ue.listen(this.j,x.name,x.arg)(G=>this.m({id:ne,data:G,type:204}));this.d.set(x.id,_)}t(x){const ue=this.d.get(x.id);ue&&(ue.dispose(),this.d.delete(x.id))}u(x){let ue=this.g.get(x.channelName);ue||(ue=[],this.g.set(x.channelName,ue));const ne=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.m({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ue.push({request:x,timeoutTimer:ne})}v(x){const ue=this.g.get(x);if(ue){for(const ne of ue)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.q(ne.request);break;case 102:this.s(ne.request);break}this.g.delete(x)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.dispose)(this.d.values()),this.d.clear()}}t.ChannelServer=p;var D;(function(se){se[se.LocalSide=0]="LocalSide",se[se.OtherSide=1]="OtherSide"})(D=t.RequestInitiator||(t.RequestInitiator={}));class z{constructor(x,ue=null){this.l=x,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new c.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.r(ne)),this.j=ue}getChannel(x){const ue=this;return{call(ne,F,_){return ue.a?Promise.reject(new w.CancellationError):ue.m(x,ne,F,_)},listen(ne,F){return ue.a?c.Event.None:ue.n(x,ne,F)}}}m(x,ue,ne,F=R.CancellationToken.None){const _=this.g++,P={id:_,type:100,channelName:x,name:ue,arg:ne};if(F.isCancellationRequested)return Promise.reject(new w.CancellationError);let b;return new Promise(($,V)=>{if(F.isCancellationRequested)return V(new w.CancellationError);const Z=()=>{const A=N=>{switch(N.type){case 201:this.f.delete(_),$(N.data);break;case 202:{this.f.delete(_);const O=new Error(N.data.message);O.stack=Array.isArray(N.data.stack)?N.data.stack.join(`
`):N.data.stack,O.name=N.data.name,V(O);break}case 203:this.f.delete(_),V(N.data);break}};this.f.set(_,A),this.o(P)};let T=null;this.b===u.Idle?Z():(T=(0,i.createCancelablePromise)(A=>this.t()),T.then(()=>{T=null,Z()}));const M=()=>{T?(T.cancel(),T=null):this.o({id:_,type:101}),V(new w.CancellationError)},H=F.onCancellationRequested(M);b=(0,d.combinedDisposable)((0,d.toDisposable)(M),H),this.d.add(b)}).finally(()=>{this.d.delete(b)})}n(x,ue,ne){const F=this.g++,G={id:F,type:102,channelName:x,name:ue,arg:ne};let P=null;const b=new c.Emitter({onWillAddFirstListener:()=>{P=(0,i.createCancelablePromise)($=>this.t()),P.then(()=>{P=null,this.d.add(b),this.o(G)})},onDidRemoveLastListener:()=>{P?(P.cancel(),P=null):(this.d.delete(b),this.o({id:F,type:103}))}}),B=$=>b.fire($.data);return this.f.set(F,B),b.event}o(x){switch(x.type){case 100:case 102:{const ue=this.p([x.type,x.id,x.channelName,x.name],x.arg);this.j?.logOutgoing(ue,x.id,0,`${e(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const ue=this.p([x.type,x.id]);this.j?.logOutgoing(ue,x.id,0,e(x.type));return}}}p(x,ue=void 0){const ne=new o;return h(ne,x),h(ne,ue),this.q(ne.buffer)}q(x){try{return this.l.send(x),x.byteLength}catch{return 0}}r(x){const ue=new m(x),ne=E(ue),F=E(ue),_=ne[0];switch(_){case 200:return this.j?.logIncoming(x.byteLength,0,0,l(_)),this.s({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(x.byteLength,ne[1],0,l(_),F),this.s({type:ne[0],id:ne[1],data:F})}}s(x){if(x.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(x.id)?.(x)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}t(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.dispose)(this.d.values()),this.d.clear()}}qe([y.memoize],z.prototype,"onDidInitializePromise",null),t.ChannelClient=z;class q{get connections(){const x=[];return this.f.forEach(ue=>x.push(ue)),x}constructor(x){this.a=new Map,this.f=new Set,this.g=new c.Emitter,this.onDidAddConnection=this.g.event,this.h=new c.Emitter,this.onDidRemoveConnection=this.h.event,x(({protocol:ue,onDidClientDisconnect:ne})=>{c.Event.once(ue.onMessage)(_=>{const G=new m(_),P=E(G),b=new p(ue,P),B=new z(ue);this.a.forEach((V,Z)=>b.registerChannel(Z,V));const $={channelServer:b,channelClient:B,ctx:P};this.f.add($),this.g.fire($),ne(()=>{b.dispose(),B.dispose(),this.f.delete($),this.h.fire($)})})})}getChannel(x,ue){const ne=this;return{call(F,_,G){let P;if((0,r.isFunction)(ue)){const B=(0,v.getRandomElement)(ne.connections.filter(ue));P=B?Promise.resolve(B):c.Event.toPromise(c.Event.filter(ne.onDidAddConnection,ue))}else P=ue.routeCall(ne,F,_);const b=P.then(B=>B.channelClient.getChannel(x));return J(b).call(F,_,G)},listen(F,_){if((0,r.isFunction)(ue))return ne.j(x,ue,F,_);const G=ue.routeEvent(ne,F,_).then(P=>P.channelClient.getChannel(x));return J(G).listen(F,_)}}}j(x,ue,ne,F){const _=this;let G=new d.DisposableStore;const P=new c.Emitter({onWillAddFirstListener:()=>{G=new d.DisposableStore;const b=new c.EventMultiplexer,B=new Map,$=Z=>{const M=Z.channelClient.getChannel(x).listen(ne,F),H=b.add(M);B.set(Z,H)},V=Z=>{const T=B.get(Z);!T||(T.dispose(),B.delete(Z))};_.connections.filter(ue).forEach($),c.Event.filter(_.onDidAddConnection,ue)($,void 0,G),_.onDidRemoveConnection(V,void 0,G),b.event(P.fire,P,G),G.add(b)},onDidRemoveLastListener:()=>{G.dispose()}});return P.event}registerChannel(x,ue){this.a.set(x,ue),this.f.forEach(ne=>{ne.channelServer.registerChannel(x,ue)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}t.IPCServer=q;class ie{constructor(x,ue,ne=null){const F=new o;h(F,ue),x.send(F.buffer),this.a=new z(x,ne),this.d=new p(x,ue,ne)}getChannel(x){return this.a.getChannel(x)}registerChannel(x,ue){this.d.registerChannel(x,ue)}dispose(){this.a.dispose(),this.d.dispose()}}t.IPCClient=ie;function J(se){return{call(x,ue,ne){return se.then(F=>F.call(x,ue,ne))},listen(x,ue){const ne=new c.Relay;return se.then(F=>ne.input=F.listen(x,ue)),ne.event}}}t.getDelayedChannel=J;function me(se){let x=!1;return{call(ue,ne,F){return x?se.call(ue,ne,F):(0,i.timeout)(0).then(()=>x=!0).then(()=>se.call(ue,ne,F))},listen(ue,ne){if(x)return se.listen(ue,ne);const F=new c.Relay;return(0,i.timeout)(0).then(()=>x=!0).then(()=>F.input=se.listen(ue,ne)),F.event}}}t.getNextTickChannel=me;class he{constructor(x){this.a=x}routeCall(x){return this.b(x)}routeEvent(x){return this.b(x)}async b(x){for(const ue of x.connections)if(await Promise.resolve(this.a(ue.ctx)))return Promise.resolve(ue);return await c.Event.toPromise(x.onDidAddConnection),await this.b(x)}}t.StaticRouter=he;var fe;(function(se){function x(_,G){const P=_,b=G&&G.disableMarshalling,B=new Map;for(const $ in P)ne($)&&B.set($,c.Event.buffer(P[$],!0));return new class{listen($,V,Z){const T=B.get(V);if(T)return T;if(F(V)){const M=P[V];if(typeof M=="function")return M.call(P,Z)}throw new Error(`Event not found: ${V}`)}call($,V,Z){const T=P[V];if(typeof T=="function"){if(!b&&Array.isArray(Z))for(let M=0;M<Z.length;M++)Z[M]=(0,f.revive)(Z[M]);return T.apply(P,Z)}throw new Error(`Method not found: ${V}`)}}}se.fromService=x;function ue(_,G){const P=G&&G.disableMarshalling;return new Proxy({},{get(b,B){if(typeof B=="string")return G?.properties?.has(B)?G.properties.get(B):F(B)?function($){return _.listen(B,$)}:ne(B)?_.listen(B):async function(...$){let V;G&&!(0,r.isUndefinedOrNull)(G.context)?V=[G.context,...$]:V=$;const Z=await _.call(B,V);return P?Z:(0,f.revive)(Z)};throw new Error(`Property not found: ${String(B)}`)}})}se.toService=ue;function ne(_){return _[0]==="o"&&_[1]==="n"&&I.isUpperAsciiLetter(_.charCodeAt(2))}function F(_){return/^onDynamic/.test(_)&&I.isUpperAsciiLetter(_.charCodeAt(9))}})(fe=t.ProxyChannel||(t.ProxyChannel={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(se){if(Array.isArray(se))return se;if(se&&typeof se=="object"&&typeof se.toString=="function"){const x=se.toString();if(x!=="[object Object]")return x}return se}function Se(se){return Array.isArray(se)?se.map(de):de(se)}function te(se,x,ue,ne,F,_,G){G=Se(G);const P=oe[F],b=P[ne%P.length];let B=[`%c[${se}]%c[${String(x).padStart(7," ")}]%c[len: ${String(ue).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${b}`];/\($/.test(_)?(B=B.concat(G),B.push(")")):B.push(G),console.log.apply(console,B)}class Ce{constructor(x,ue){this.d=x,this.f=ue,this.a=0,this.b=0}logOutgoing(x,ue,ne,F,_){this.b+=x,te(this.d,this.b,x,ue,ne,F,_)}logIncoming(x,ue,ne,F,_){this.a+=x,te(this.f,this.a,x,ue,ne,F,_)}}t.IPCLogger=Ce}),define(be[29],pe([1,0,5]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=v.globals.vscode.ipcRenderer,t.ipcMessagePort=v.globals.vscode.ipcMessagePort,t.webFrame=v.globals.vscode.webFrame,t.process=v.globals.vscode.process,t.context=v.globals.vscode.context}),define(be[130],pe([1,0,80,29]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let U=0;function R(w,c,d){const f=[],I=U++,r=`vscode:onContextMenu${I}`,n=(e,s,l)=>{f[s].click?.(l)};i.ipcRenderer.once(r,n),i.ipcRenderer.once(v.CONTEXT_MENU_CLOSE_CHANNEL,(e,s)=>{s===I&&(i.ipcRenderer.removeListener(r,n),d?.())}),i.ipcRenderer.send(v.CONTEXT_MENU_CHANNEL,I,w.map(e=>y(e,f)),r,c)}t.popup=R;function y(w,c){const d={id:c.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return c.push(w),Array.isArray(w.submenu)&&(d.submenu=w.submenu.map(f=>y(f,c))),d}}),define(be[131],pe([1,0,31,3,38,81,29]),function(Q,t,v,i,U,R,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class w extends U.IPCClient{static f(){const d=i.Event.fromNodeEventEmitter(y.ipcRenderer,"vscode:message",(f,I)=>v.VSBuffer.wrap(I));return y.ipcRenderer.send("vscode:hello"),new R.Protocol(y.ipcRenderer,d)}constructor(d){const f=w.f();super(f,d),this.b=f}dispose(){this.b.disconnect()}}t.Client=w}),define(be[132],pe([13,10]),function(Q,t){return Q.create("vs/platform/files/common/files",t)}),define(be[133],pe([13,10]),function(Q,t){return Q.create("vs/platform/theme/common/iconRegistry",t)}),define(be[64],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class v{constructor(U,R=[],y=!1){this.ctor=U,this.staticArguments=R,this.supportsDelayedInstantiation=y}}t.SyncDescriptor=v}),define(be[134],pe([1,0,64]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=t.InstantiationType=void 0;const i=[];var U;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(U=t.InstantiationType||(t.InstantiationType={}));function R(w,c,d){c instanceof v.SyncDescriptor||(c=new v.SyncDescriptor(c,[],Boolean(d))),i.push([w,c])}t.registerSingleton=R;function y(){return i}t.getSingletonServiceDescriptors=y}),define(be[30],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var v;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function w(c){return c[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=w})(v=t._util||(t._util={})),t.IInstantiationService=U("instantiationService");function i(y,w,c){w[v.DI_TARGET]===w?w[v.DI_DEPENDENCIES].push({id:y,index:c}):(w[v.DI_DEPENDENCIES]=[{id:y,index:c}],w[v.DI_TARGET]=w)}function U(y){if(v.serviceIds.has(y))return v.serviceIds.get(y);const w=function(c,d,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(w,c,f)};return w.toString=()=>y,v.serviceIds.set(y,w),w}t.createDecorator=U;function R(y){return y}t.refineServiceDecorator=R}),define(be[135],pe([1,0,30]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,v.createDecorator)(t.ID);function i(R){return!!R.hostName&&!!R.errorMessage}t.isRemoteDiagnosticError=i;class U{async getPerformanceInfo(y,w){return{}}async getSystemInfo(y,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(y,w){return""}async getWorkspaceFileExtensions(y){return{extensions:[]}}async reportWorkspaceStats(y){}}t.NullDiagnosticsService=U}),define(be[136],pe([1,0,112,21,11,6,15,132,30]),function(Q,t,v,i,U,R,y,w,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPlatformLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,c.createDecorator)("fileService");function d(te){return te.create===!0}t.isFileOpenForWriteOptions=d;var f;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(f=t.FileType||(t.FileType={}));var I;(function(te){te[te.Readonly=1]="Readonly"})(I=t.FilePermission||(t.FilePermission={}));var r;(function(te){te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileClone=32768]="FileClone"})(r=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function n(te){return!!(te.capabilities&2)}t.hasReadWriteCapability=n;function e(te){return!!(te.capabilities&8)}t.hasFileFolderCopyCapability=e;function s(te){return!!(te.capabilities&32768)}t.hasFileCloneCapability=s;function l(te){return!!(te.capabilities&4)}t.hasOpenReadWriteCloseCapability=l;function u(te){return!!(te.capabilities&16)}t.hasFileReadStreamCapability=u;function m(te){return n(te)?!!(te.capabilities&16384):!1}t.hasFileAtomicReadCapability=m;var o;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(o=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class a extends Error{constructor(Ce,se){super(Ce),this.code=se}}t.FileSystemProviderError=a;function g(te,Ce){const se=new a(te.toString(),Ce);return L(se,Ce),se}t.createFileSystemProviderError=g;function C(te){return te||g((0,w.localize)(0,null),o.Unknown)}t.ensureFileSystemProviderError=C;function L(te,Ce){return te.name=Ce?`${Ce} (FileSystemError)`:"FileSystemError",te}t.markAsFileSystemProviderError=L;function k(te){if(!te)return o.Unknown;if(te instanceof a)return te.code;const Ce=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!Ce)return o.Unknown;switch(Ce[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileExceedsMemoryLimit:return o.FileExceedsMemoryLimit;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}t.toFileSystemProviderErrorCode=k;function S(te){if(te instanceof q)return te.fileOperationResult;switch(k(te)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 10;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileExceedsMemoryLimit:return 9;case o.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=S;var h;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(h=t.FileOperation||(t.FileOperation={}));class E{constructor(Ce,se,x){this.resource=Ce,this.operation=se,this.target=x}isOperation(Ce){return this.operation===Ce}}t.FileOperationEvent=E;var p;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(p=t.FileChangeType||(t.FileChangeType={}));class D{constructor(Ce,se){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=Ce;const x=new Map;for(const ue of Ce){const ne=x.get(ue.type);switch(ne?ne.push([ue.resource,ue]):x.set(ue.type,[[ue.resource,ue]]),ue.type){case 1:this.rawAdded.push(ue.resource);break;case 0:this.rawUpdated.push(ue.resource);break;case 2:this.rawDeleted.push(ue.resource);break}}for(const[ue,ne]of x)switch(ue){case 1:this.a=v.TernarySearchTree.forUris(()=>se),this.a.fill(ne);break;case 0:this.b=v.TernarySearchTree.forUris(()=>se),this.b.fill(ne);break;case 2:this.c=v.TernarySearchTree.forUris(()=>se),this.c.fill(ne);break}}contains(Ce,...se){return this.d(Ce,{includeChildren:!1},...se)}affects(Ce,...se){return this.d(Ce,{includeChildren:!0},...se)}d(Ce,se,...x){if(!Ce)return!1;const ue=x.length>0;return!!((!ue||x.includes(1))&&(this.a?.get(Ce)||se.includeChildren&&this.a?.findSuperstr(Ce))||(!ue||x.includes(0))&&(this.b?.get(Ce)||se.includeChildren&&this.b?.findSuperstr(Ce))||(!ue||x.includes(2))&&(this.c?.findSubstr(Ce)||se.includeChildren&&this.c?.findSuperstr(Ce)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}t.FileChangesEvent=D;function z(te,Ce,se){return!te||!Ce||te===Ce||Ce.length>te.length?!1:(Ce.charAt(Ce.length-1)!==i.sep&&(Ce+=i.sep),se?(0,U.startsWithIgnoreCase)(te,Ce):te.indexOf(Ce)===0)}t.isParent=z;class q extends Error{constructor(Ce,se,x){super(Ce),this.fileOperationResult=se,this.options=x}}t.FileOperationError=q;class ie extends q{constructor(Ce,se,x){super(Ce,2,x),this.stat=se}}t.NotModifiedSinceFileOperationError=ie;var J;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",te[te.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(J=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var me;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(me=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function he(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}t.etag=he;async function fe(te,Ce){if(!Ce.hasProvider(y.URI.from({scheme:te.scheme})))return new Promise(se=>{const x=Ce.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===te.scheme&&ue.added&&(x.dispose(),se())})})}t.whenProviderRegistered=fe,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class oe{static formatSize(Ce){return(0,R.isNumber)(Ce)||(Ce=0),Ce<oe.KB?(0,w.localize)(1,null,Ce.toFixed(0)):Ce<oe.MB?(0,w.localize)(2,null,(Ce/oe.KB).toFixed(2)):Ce<oe.GB?(0,w.localize)(3,null,(Ce/oe.MB).toFixed(2)):Ce<oe.TB?(0,w.localize)(4,null,(Ce/oe.GB).toFixed(2)):(0,w.localize)(5,null,(Ce/oe.TB).toFixed(2))}}t.ByteSize=oe,oe.KB=1024,oe.MB=oe.KB*oe.KB,oe.GB=oe.MB*oe.KB,oe.TB=oe.GB*oe.KB;var de;(function(te){te[te.IA32=0]="IA32",te[te.OTHER=1]="OTHER"})(de=t.Arch||(t.Arch={}));function Se(te){return{maxFileSize:te===0?300*oe.MB:16*oe.GB,maxHeapSize:te===0?700*oe.MB:2*700*oe.MB}}t.getPlatformLimits=Se}),define(be[137],pe([1,0,2,131]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class U extends v.Disposable{constructor(y){super(),this.a=this.B(new i.Client(`window:${y}`))}getChannel(y){return this.a.getChannel(y)}registerChannel(y,w){this.a.registerChannel(y,w)}}t.ElectronIPCMainProcessService=U});var wt=this&&this.__param||function(Q,t){return function(v,i){t(v,i,Q)}};define(be[138],pe([1,0,38,64,134,30]),function(Q,t,v,i,U,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerSharedProcessRemoteService=t.ISharedProcessService=t.registerMainProcessRemoteService=t.IMainProcessService=void 0;class y{constructor(n,e,s,l){const u=s.getChannel(n);return w(e)?l.createInstance(new i.SyncDescriptor(e.channelClientCtor,[u])):v.ProxyChannel.toService(u,e?.proxyOptions)}}function w(r){return!!r?.channelClientCtor}t.IMainProcessService=(0,R.createDecorator)("mainProcessService");let c=class extends y{constructor(n,e,s,l){super(n,e,s,l)}};c=qe([wt(2,t.IMainProcessService),wt(3,R.IInstantiationService)],c);function d(r,n,e){(0,U.registerSingleton)(r,new i.SyncDescriptor(c,[n,e],!0))}t.registerMainProcessRemoteService=d,t.ISharedProcessService=(0,R.createDecorator)("sharedProcessService");let f=class extends y{constructor(n,e,s,l){super(n,e,s,l)}};f=qe([wt(2,t.ISharedProcessService),wt(3,R.IInstantiationService)],f);function I(r,n,e){(0,U.registerSingleton)(r,new i.SyncDescriptor(f,[n,e],!0))}t.registerSharedProcessRemoteService=I}),define(be[139],pe([1,0,38,138]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let U=class{constructor(y,w){return this.windowId=y,v.ProxyChannel.toService(w.getChannel("nativeHost"),{context:y,properties:(()=>{const c=new Map;return c.set("windowId",y),c})()})}};U=qe([wt(1,i.IMainProcessService)],U),t.NativeHostService=U}),define(be[39],pe([1,0,71,6]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class U{constructor(){this.a=new Map}add(y,w){v.ok(i.isString(y)),v.ok(i.isObject(w)),v.ok(!this.a.has(y),"There is already an extension with this id"),this.a.set(y,w)}knows(y){return this.a.has(y)}as(y){return this.a.get(y)||null}}t.Registry=new U}),define(be[140],pe([1,0,3,39]),function(Q,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function U(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class R{constructor(){this.b=new v.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,d){this.a[U(c)]=d,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}}const y=new R;i.Registry.add(t.Extensions.JSONContribution,y)}),define(be[141],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isDark=t.isHighContrast=t.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(v=t.ColorScheme||(t.ColorScheme={}));function i(R){return R===v.HIGH_CONTRAST_DARK||R===v.HIGH_CONTRAST_LIGHT}t.isHighContrast=i;function U(R){return R===v.DARK||R===v.HIGH_CONTRAST_DARK}t.isDark=U}),define(be[65],pe([1,0,12,3,2,30,39,141]),function(Q,t,v,i,U,R,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Themable=t.registerThemingParticipant=t.Extensions=t.getThemeTypeSelector=t.FolderThemeIcon=t.FileThemeIcon=t.ThemeIcon=t.themeColorFromId=t.ThemeColor=t.IThemeService=void 0,t.IThemeService=(0,R.createDecorator)("themeService");var c;(function(l){function u(m){return m&&typeof m=="object"&&typeof m.id=="string"}l.isThemeColor=u})(c=t.ThemeColor||(t.ThemeColor={}));function d(l){return{id:l}}t.themeColorFromId=d;var f;(function(l){function u(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(typeof S.color>"u"||c.isThemeColor(S.color))}l.isThemeIcon=u;const m=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function o(S){const h=m.exec(S);if(!h)return;const[,E]=h;return{id:E}}l.fromString=o;function a(S){return{id:S}}l.fromId=a;function g(S,h){let E=S.id;const p=E.lastIndexOf("~");return p!==-1&&(E=E.substring(0,p)),h&&(E=`${E}~${h}`),{id:E}}l.modify=g;function C(S){const h=S.id.lastIndexOf("~");if(h!==-1)return S.id.substring(h+1)}l.getModifier=C;function L(S,h){return S.id===h.id&&S.color?.id===h.color?.id}l.isEqual=L;function k(S,h){return{id:S.id,color:h?d(h):void 0}}l.asThemeIcon=k,l.asClassNameArray=v.CSSIcon.asClassNameArray,l.asClassName=v.CSSIcon.asClassName,l.asCSSSelector=v.CSSIcon.asCSSSelector})(f=t.ThemeIcon||(t.ThemeIcon={})),t.FileThemeIcon=v.Codicon.file,t.FolderThemeIcon=v.Codicon.folder;function I(l){switch(l){case w.ColorScheme.DARK:return"vs-dark";case w.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case w.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}t.getThemeTypeSelector=I,t.Extensions={ThemingContribution:"base.contributions.theming"};class r{constructor(){this.a=[],this.a=[],this.b=new i.Emitter}onColorThemeChange(u){return this.a.push(u),this.b.fire(u),(0,U.toDisposable)(()=>{const m=this.a.indexOf(u);this.a.splice(m,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const n=new r;y.Registry.add(t.Extensions.ThemingContribution,n);function e(l){return n.onColorThemeChange(l)}t.registerThemingParticipant=e;class s extends U.Disposable{constructor(u){super(),this.k=u,this.h=u.getColorTheme(),this.B(this.k.onDidColorThemeChange(m=>this.n(m)))}n(u){this.h=u,this.updateStyles()}updateStyles(){}w(u,m){let o=this.h.getColor(u);return o&&m&&(o=m(o,this.h)),o?o.toString():null}}t.Themable=s}),define(be[142],pe([1,0,8,12,3,6,15,133,140,39,65]),function(Q,t,v,i,U,R,y,w,c,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var I;(function(a){function g(C,L){let k=C.defaults;for(;f.ThemeIcon.isThemeIcon(k);){const S=e.getIcon(k.id);if(!S)return;k=S.defaults}return k}a.getDefinition=g})(I=t.IconContribution||(t.IconContribution={}));var r;(function(a){function g(L){return{weight:L.weight,style:L.style,src:L.src.map(k=>({format:k.format,location:k.location.toString()}))}}a.toJSONObject=g;function C(L){const k=S=>(0,R.isString)(S)?S:void 0;if(L&&Array.isArray(L.src)&&L.src.every(S=>(0,R.isString)(S.format)&&(0,R.isString)(S.location)))return{weight:k(L.weight),style:k(L.style),src:L.src.map(S=>({format:S.format,location:y.URI.parse(S.location)}))}}a.fromJSONObject=C})(r=t.IconFontDefinition||(t.IconFontDefinition={}));class n{constructor(){this.a=new U.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,C,L,k){const S=this.b[g];if(S){if(L&&!S.description){S.description=L,this.d.properties[g].markdownDescription=`${L} $(${g})`;const p=this.e.enum.indexOf(g);p!==-1&&(this.e.enumDescriptions[p]=L),this.a.fire()}return S}const h={id:g,description:L,defaults:C,deprecationMessage:k};this.b[g]=h;const E={$ref:"#/definitions/icons"};return k&&(E.deprecationMessage=k),L&&(E.markdownDescription=`${L}: $(${g})`),this.d.properties[g]=E,this.e.enum.push(g),this.e.enumDescriptions.push(L||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const C=this.e.enum.indexOf(g);C!==-1&&(this.e.enum.splice(C,1),this.e.enumDescriptions.splice(C,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,C){const L=this.f[g];return L||(this.f[g]=C,this.a.fire(),C)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(S,h)=>S.id.localeCompare(h.id),C=S=>{for(;f.ThemeIcon.isThemeIcon(S.defaults);)S=this.b[S.defaults.id];return`codicon codicon-${S?S.id:""}`},L=[];L.push("| preview     | identifier                        | default codicon ID                | description"),L.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const k=Object.keys(this.b).map(S=>this.b[S]);for(const S of k.filter(h=>!!h.description).sort(g))L.push(`|<i class="${C(S)}"></i>|${S.id}|${f.ThemeIcon.isThemeIcon(S.defaults)?S.defaults.id:S.id}|${S.description||""}|`);L.push("| preview     | identifier                        "),L.push("| ----------- | --------------------------------- |");for(const S of k.filter(h=>!f.ThemeIcon.isThemeIcon(h.defaults)).sort(g))L.push(`|<i class="${C(S)}"></i>|${S.id}|`);return L.join(`
`)}}const e=new n;d.Registry.add(t.Extensions.IconContribution,e);function s(a,g,C,L){return e.registerIcon(a,g,C,L)}t.registerIcon=s;function l(){return e}t.getIconRegistry=l;function u(){for(const a of i.Codicon.getAll())e.registerIcon(a.id,a.definition,a.description)}u(),t.iconsSchemaId="vscode://schemas/icons";const m=d.Registry.as(c.Extensions.JSONContribution);m.registerSchema(t.iconsSchemaId,e.getIconSchema());const o=new v.RunOnceScheduler(()=>m.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{o.isScheduled()||o.schedule()}),t.widgetClose=s("widget-close",i.Codicon.close,(0,w.localize)(2,null)),t.gotoPreviousLocation=s("goto-previous-location",i.Codicon.arrowUp,(0,w.localize)(3,null)),t.gotoNextLocation=s("goto-next-location",i.Codicon.arrowDown,(0,w.localize)(4,null)),t.syncing=f.ThemeIcon.modify(i.Codicon.sync,"spin"),t.spinningLoading=f.ThemeIcon.modify(i.Codicon.loading,"spin")}),define(be[143],pe([1,0,4,3,142,65]),function(Q,t,v,i,U,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function y(c){const d=new i.Emitter,f=(0,U.getIconRegistry)();return f.onDidChange(()=>d.fire()),c?.onDidProductIconThemeChange(()=>d.fire()),{onDidChange:d.event,getCSS(){const I=c?c.getProductIconTheme():new w,r={},n=s=>{const l=I.getIcon(s);if(!l)return;const u=l.font;return u?(r[u.id]=u.definition,`.codicon-${s.id}:before { content: '${l.fontCharacter}'; font-family: ${(0,v.asCSSPropertyValue)(u.id)}; }`):`.codicon-${s.id}:before { content: '${l.fontCharacter}'; }`},e=[];for(const s of f.getIcons()){const l=n(s);l&&e.push(l)}for(const s in r){const l=r[s],u=l.weight?`font-weight: ${l.weight};`:"",m=l.style?`font-style: ${l.style};`:"",o=l.src.map(a=>`${(0,v.asCSSUrl)(a.location)} format('${a.format}')`).join(", ");e.push(`@font-face { src: ${o}; font-family: ${(0,v.asCSSPropertyValue)(s)};${u}${m} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=y;class w{getIcon(d){const f=(0,U.getIconRegistry)();let I=d.defaults;for(;R.ThemeIcon.isThemeIcon(I);){const r=f.getIcon(I.id);if(!r)return;I=r.defaults}return I}}t.UnthemedProductIconTheme=w}),define(be[144],pe([1,0,5]),function(Q,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function i(f){return!!f.workspaceUri}t.isWorkspaceToOpen=i;function U(f){return!!f.folderUri}t.isFolderToOpen=U;function R(f){return!!f.fileUri}t.isFileToOpen=R;function y(f){const I=w(f),r=f.getValue("window.menuBarVisibility");return r==="default"||I==="native"&&r==="compact"||v.isMacintosh&&v.isNative?"classic":r}t.getMenuBarVisibility=y;function w(f){if(v.isWeb)return"custom";const I=f.getValue("window");if(I){if(v.isMacintosh&&I.nativeTabs===!0||v.isMacintosh&&I.nativeFullScreen===!1)return"native";const e=I.titleBarStyle;if(e==="native"||e==="custom")return e}return v.isLinux?"native":"custom"}t.getTitleBarStyle=w;function c(f){if(!v.isWindows||v.isWeb||w(f)==="native")return!1;const I=f.getValue("window.experimental.windowControlsOverlay.enabled");return typeof I=="boolean"?I:!1}t.useWindowControlsOverlay=c;function d(f=0){return Math.pow(1.2,f)}t.zoomLevelToZoomFactor=d}),define(be[145],pe([1,0,16,29,144]),function(Q,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function R(c){i.webFrame.setZoomLevel(c),(0,v.setZoomFactor)((0,U.zoomLevelToZoomFactor)(c)),(0,v.setZoomLevel)(c,!1)}t.applyZoom=R;function y(){R((0,v.getZoomLevel)()+1)}t.zoomIn=y;function w(){R((0,v.getZoomLevel)()-1)}t.zoomOut=w}),define(be[146],pe([1,0,10,4,129,8,130,29,135,136,137,139,143,145,94,85]),function(Q,t,v,i,U,R,y,w,c,d,f,I,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const e=/\s--(inspect|debug)(-brk|port)?=(\d+)?/,s=/\s--(inspect|debug)-port=(\d+)/;class l{getHeight(D){return 22}getTemplateId(D){return k(D)?"process":C(D)?"machine":(0,c.isRemoteDiagnosticError)(D)?"error":L(D)?"header":""}}class u{hasChildren(D){return(0,c.isRemoteDiagnosticError)(D)?!1:k(D)?!!D.children?.length:!0}getChildren(D){return k(D)?D.children?D.children:[]:(0,c.isRemoteDiagnosticError)(D)?[]:L(D)?D.processRoots.length>1?D.processRoots:[D.processRoots[0].rootProcess]:C(D)?[D.rootProcess]:[D.processes]}}class m{constructor(){this.templateId="header"}renderTemplate(D){const z=Object.create(null),q=(0,i.append)(D,(0,i.$)(".row"));return z.name=(0,i.append)(q,(0,i.$)(".nameLabel")),z.CPU=(0,i.append)(q,(0,i.$)(".cpu")),z.memory=(0,i.append)(q,(0,i.$)(".memory")),z.PID=(0,i.append)(q,(0,i.$)(".pid")),z}renderElement(D,z,q,ie){q.name.textContent=(0,v.localize)(0,null),q.CPU.textContent=(0,v.localize)(1,null),q.PID.textContent=(0,v.localize)(2,null),q.memory.textContent=(0,v.localize)(3,null)}disposeTemplate(D){}}class o{constructor(){this.templateId="machine"}renderTemplate(D){const z=Object.create(null),q=(0,i.append)(D,(0,i.$)(".row"));return z.name=(0,i.append)(q,(0,i.$)(".nameLabel")),z}renderElement(D,z,q,ie){q.name.textContent=D.element.name}disposeTemplate(D){}}class a{constructor(){this.templateId="error"}renderTemplate(D){const z=Object.create(null),q=(0,i.append)(D,(0,i.$)(".row"));return z.name=(0,i.append)(q,(0,i.$)(".nameLabel")),z}renderElement(D,z,q,ie){q.name.textContent=D.element.errorMessage}disposeTemplate(D){}}class g{constructor(D,z,q){this.a=D,this.b=z,this.c=q,this.templateId="process"}renderTemplate(D){const z=Object.create(null),q=(0,i.append)(D,(0,i.$)(".row"));return z.name=(0,i.append)(q,(0,i.$)(".nameLabel")),z.CPU=(0,i.append)(q,(0,i.$)(".cpu")),z.memory=(0,i.append)(q,(0,i.$)(".memory")),z.PID=(0,i.append)(q,(0,i.$)(".pid")),z}renderElement(D,z,q,ie){const{element:J}=D;let me=J.name;me==="window"&&(me=this.c.get(J.pid)!==void 0?`${me} (${this.c.get(J.pid)})`:me);const he=J.pid.toFixed(0);q.name.textContent=me,q.name.title=J.cmd,q.CPU.textContent=J.load.toFixed(0),q.PID.textContent=he,q.PID.parentElement.id=`pid-${he}`;const fe=this.a==="win32"?J.mem:this.b*(J.mem/100);q.memory.textContent=(fe/d.ByteSize.MB).toFixed(0)}disposeTemplate(D){}}function C(p){return!!p.name&&!!p.rootProcess}function L(p){return!!p.processRoots}function k(p){return!!p.pid}class S{constructor(D,z){this.f=z,this.b=new Map;const q=new f.ElectronIPCMainProcessService(D);this.c=new I.NativeHostService(D,q),this.k(z.styles),this.g(z),w.ipcRenderer.on("vscode:windowsInfoResponse",(ie,J)=>{this.b=new Map,J.forEach(me=>this.b.set(me.pid,me.title))}),w.ipcRenderer.on("vscode:listProcessesResponse",async(ie,J)=>{J.forEach((me,he)=>{k(me.rootProcess)&&(me.rootProcess.name=he===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:J}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(J),this.m(0)}),this.a=Date.now(),w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")}g(D){document.onkeydown=z=>{const q=D.platform==="darwin"?z.metaKey:z.ctrlKey;q&&z.keyCode===87&&(z.stopPropagation(),z.preventDefault(),w.ipcRenderer.send("vscode:closeProcessExplorer")),q&&z.keyCode===187&&(0,n.zoomIn)(),q&&z.keyCode===189&&(0,n.zoomOut)()}}async h(D){const z=document.getElementById("process-list");if(!z)return;const{totalmem:q}=await this.c.getOSStatistics(),ie=[new g(this.f.platform,q,this.b),new m,new o,new a];this.d=new U.DataTree("processExplorer",z,new l,ie,new u,{identityProvider:{getId:J=>k(J)?J.pid.toString():(0,c.isRemoteDiagnosticError)(J)?J.hostName:L(J)?"processes":C(J)?J.name:"header"}}),this.d.setInput({processes:{processRoots:D}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onContextMenu(J=>{k(J.element)&&this.l(J.element,!0)}),z.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{z.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(D){const z=e.exec(D);return z&&z.length>=2||D.indexOf("node ")>=0||D.indexOf("node.exe")>=0}j(D){const z={type:"node",request:"attach",name:`process ${D.pid}`};let q=e.exec(D.cmd);q&&q.length>=2?(q.length===4&&q[3]&&(z.port=parseInt(q[3])),z.protocol=q[1]==="debug"?"legacy":"inspector"):z.processId=String(D.pid),q=s.exec(D.cmd),q&&q.length===3&&(z.port=parseInt(q[2])),w.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[z]})}k(D){const z=(0,i.createStyleSheet)(),q=[];D.listFocusBackground&&(q.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${D.listFocusBackground}; }`),q.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${D.listFocusBackground}; }`)),D.listFocusForeground&&q.push(`.monaco-list:focus .monaco-list-row.focused { color: ${D.listFocusForeground}; }`),D.listActiveSelectionBackground&&(q.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${D.listActiveSelectionBackground}; }`),q.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${D.listActiveSelectionBackground}; }`)),D.listActiveSelectionForeground&&q.push(`.monaco-list:focus .monaco-list-row.selected { color: ${D.listActiveSelectionForeground}; }`),D.listHoverBackground&&q.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${D.listHoverBackground}; }`),D.listHoverForeground&&q.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${D.listHoverForeground}; }`),D.listFocusOutline&&q.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${D.listFocusOutline}; outline-offset: -1px; }`),D.listHoverOutline&&q.push(`.monaco-list-row:hover { outline: 1px dashed ${D.listHoverOutline}; outline-offset: -1px; }`),D.scrollbarShadowColor&&q.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${D.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${D.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${D.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),D.scrollbarSliderBackgroundColor&&q.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${D.scrollbarSliderBackgroundColor};
				}
			`),D.scrollbarSliderHoverBackgroundColor&&q.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${D.scrollbarSliderHoverBackgroundColor};
				}
			`),D.scrollbarSliderActiveBackgroundColor&&q.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${D.scrollbarSliderActiveBackgroundColor};
				}
			`),z.textContent=q.join(`
`),D.color&&(document.body.style.color=D.color)}l(D,z){const q=[],ie=Number(D.pid);z&&(q.push({label:(0,v.localize)(4,null),click:()=>{this.c.killProcess(ie,"SIGTERM")}}),q.push({label:(0,v.localize)(5,null),click:()=>{this.c.killProcess(ie,"SIGKILL")}}),q.push({type:"separator"})),q.push({label:(0,v.localize)(6,null),click:()=>{const J=this.d?.getSelection()?.map(he=>{if(!(!he||!("pid"in he)))return he.pid}).filter(he=>!!he);J?.includes(ie)||(J.length=0,J.push(ie));const me=J?.map(he=>document.getElementById(`pid-${he}`)).filter(he=>!!he);if(me){const he=me.map(fe=>fe.innerText).filter(fe=>!!fe);this.c.writeClipboardText(he.join(`
`))}}}),q.push({label:(0,v.localize)(7,null),click:()=>{const J=document.getElementById("process-list");J&&this.c.writeClipboardText(J.innerText)}}),D&&z&&this.i(D.cmd)&&(q.push({type:"separator"}),q.push({label:(0,v.localize)(8,null),click:()=>{this.j(D)}})),(0,y.popup)(q)}m(D){setTimeout(()=>{const z=Date.now(),q=D+z-this.a;this.a=z,q>1e3?(w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")):this.m(q)},200)}}function h(){const p=(0,i.createStyleSheet)();p.id="codiconStyles";const D=(0,r.getIconsStyleSheet)(void 0);function z(){p.textContent=D.getCSS()}const q=new R.RunOnceScheduler(z,0);D.onDidChange(()=>q.schedule()),q.schedule()}function E(p){const D=p.data.platform==="win32"?"windows":p.data.platform==="linux"?"linux":"mac";document.body.classList.add(D),h(),(0,n.applyZoom)(p.data.zoomLevel),new S(p.windowId,p.data)}t.startup=E})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d9a70c4236a8bde4fe7435df3ecdd333c7bc939c/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
