/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/ternarySearchTree","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function(W){for(var e=[],O=0,D=W.length;O<D;O++)e[O]=Y[W[O]];return e};define(Y[49],Z([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function O(L){return(P,g,l)=>{let m=null,E=null;if(typeof l.value=="function"?(m="value",E=l.value):typeof l.get=="function"&&(m="get",E=l.get),!E)throw new Error("not supported");l[m]=L(E,g)}}function D(L,P,g){let l=null,m=null;if(typeof g.value=="function"?(l="value",m=g.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(l="get",m=g.get),!m)throw new Error("not supported");const E=`$memoize$${P}`;g[l]=function(...p){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,p)}),this[E]}}e.memoize=D;function k(L,P,g){return O((l,m)=>{const E=`$debounce$${m}`,p=`$debounce$result$${m}`;return function(...I){this[p]||(this[p]=g?g():void 0),clearTimeout(this[E]),P&&(this[p]=P(this[p],...I),I=[this[p]]),this[E]=setTimeout(()=>{l.apply(this,I),this[p]=g?g():void 0},L)}})}e.debounce=k;function T(L,P,g){return O((l,m)=>{const E=`$throttle$timer$${m}`,p=`$throttle$result$${m}`,I=`$throttle$lastRun$${m}`,v=`$throttle$pending$${m}`;return function(...S){if(this[p]||(this[p]=g?g():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...S)),this[v])return;const y=this[I]+L;y<=Date.now()?(this[I]=Date.now(),l.apply(this,[this[p]]),this[p]=g?g():void 0):(this[v]=!0,this[E]=setTimeout(()=>{this[v]=!1,this[I]=Date.now(),l.apply(this,[this[p]]),this[p]=g?g():void 0},y-Date.now()))}})}e.throttle=T}),define(Y[69],Z([0,1,10]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function D(g,l){if(!g)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=D;function k(g,l="Unreachable"){throw new Error(l)}e.assertNever=k;function T(g){if(!g)throw new O.BugIndicatingError("Assertion Failed")}e.assert=T;function L(g){if(!g()){debugger;g(),(0,O.onUnexpectedError)(new O.BugIndicatingError("Assertion Failed"))}}e.assertFn=L;function P(g,l){let m=0;for(;m<g.length-1;){const E=g[m],p=g[m+1];if(!l(E,p))return!1;m++}return!0}e.checkAdjacentItems=P}),define(Y[50],Z([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var O;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(O=e.ScanError||(e.ScanError={}));var D;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(i){i.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function L(i,n=!1){let t=0;const r=i.length;let o="",c=0,a=16,d=0;function R(Q){let ge=0,ce=0;for(;ge<Q;){const oe=i.charCodeAt(t);if(oe>=48&&oe<=57)ce=ce*16+oe-48;else if(oe>=65&&oe<=70)ce=ce*16+oe-65+10;else if(oe>=97&&oe<=102)ce=ce*16+oe-97+10;else break;t++,ge++}return ge<Q&&(ce=-1),ce}function j(Q){t=Q,o="",c=0,a=16,d=0}function x(){const Q=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&l(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&l(i.charCodeAt(t)))for(t++;t<i.length&&l(i.charCodeAt(t));)t++;else return d=3,i.substring(Q,t);let ge=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&l(i.charCodeAt(t))){for(t++;t<i.length&&l(i.charCodeAt(t));)t++;ge=t}else d=3;return i.substring(Q,ge)}function K(){let Q="",ge=t;for(;;){if(t>=r){Q+=i.substring(ge,t),d=2;break}const ce=i.charCodeAt(t);if(ce===34){Q+=i.substring(ge,t),t++;break}if(ce===92){if(Q+=i.substring(ge,t),t++,t>=r){d=2;break}switch(i.charCodeAt(t++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:{const me=R(4);me>=0?Q+=String.fromCharCode(me):d=4;break}default:d=5}ge=t;continue}if(ce>=0&&ce<=31)if(g(ce)){Q+=i.substring(ge,t),d=2;break}else d=6;t++}return Q}function J(){if(o="",d=0,c=t,t>=r)return c=r,a=17;let Q=i.charCodeAt(t);if(P(Q)){do t++,o+=String.fromCharCode(Q),Q=i.charCodeAt(t);while(P(Q));return a=15}if(g(Q))return t++,o+=String.fromCharCode(Q),Q===13&&i.charCodeAt(t)===10&&(t++,o+=`
`),a=14;switch(Q){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,o=K(),a=10;case 47:{const ge=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<r&&!g(i.charCodeAt(t));)t++;return o=i.substring(ge,t),a=12}if(i.charCodeAt(t+1)===42){t+=2;const ce=r-1;let oe=!1;for(;t<ce;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,oe=!0;break}t++}return oe||(t++,d=1),o=i.substring(ge,t),a=13}return o+=String.fromCharCode(Q),t++,a=16}case 45:if(o+=String.fromCharCode(Q),t++,t===r||!l(i.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=x(),a=11;default:for(;t<r&&ie(Q);)t++,Q=i.charCodeAt(t);if(c!==t){switch(o=i.substring(c,t),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(Q),t++,a=16}}function ie(Q){if(P(Q)||g(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let Q;do Q=J();while(Q>=12&&Q<=15);return Q}return{setPosition:j,getPosition:()=>t,scan:n?se:J,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>d}}e.createScanner=L;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function l(i){return i>=48&&i<=57}var m;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(m||(m={}));function E(i,n){const t=[],r=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function d(R,j,x,K){c.value=R,c.offset=j,c.length=x,c.type=K,c.colonOffset=void 0,o=c}try{w(i,{onObjectBegin:(R,j)=>{if(n<=R)throw r;o=void 0,a=n>R,t.push("")},onObjectProperty:(R,j,x)=>{if(n<j||(d(R,j,x,"property"),t[t.length-1]=R,n<=j+x))throw r},onObjectEnd:(R,j)=>{if(n<=R)throw r;o=void 0,t.pop()},onArrayBegin:(R,j)=>{if(n<=R)throw r;o=void 0,t.push(0)},onArrayEnd:(R,j)=>{if(n<=R)throw r;o=void 0,t.pop()},onLiteralValue:(R,j,x)=>{if(n<j||(d(R,j,x,s(R)),n<=j+x))throw r},onSeparator:(R,j,x)=>{if(n<=j)throw r;if(R===":"&&o&&o.type==="property")o.colonOffset=j,a=!1,o=void 0;else if(R===","){const K=t[t.length-1];typeof K=="number"?t[t.length-1]=K+1:(a=!0,t[t.length-1]=""),o=void 0}}})}catch(R){if(R!==r)throw R}return{path:t,previousNode:o,isAtPropertyKey:a,matches:R=>{let j=0;for(let x=0;j<R.length&&x<t.length;x++)if(R[j]===t[x]||R[j]==="*")j++;else if(R[j]!=="**")return!1;return j===R.length}}}e.getLocation=E;function p(i,n=[],t=T.DEFAULT){let r=null,o=[];const c=[];function a(R){Array.isArray(o)?o.push(R):r!==null&&(o[r]=R)}return w(i,{onObjectBegin:()=>{const R={};a(R),c.push(o),o=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const R=[];a(R),c.push(o),o=R,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:a,onError:(R,j,x)=>{n.push({error:R,offset:j,length:x})}},t),o[0]}e.parse=p;function I(i,n=[],t=T.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(R){r.type==="property"&&(r.length=R-r.offset,r=r.parent)}function c(R){return r.children.push(R),R}w(i,{onObjectBegin:R=>{r=c({type:"object",offset:R,length:-1,parent:r,children:[]})},onObjectProperty:(R,j,x)=>{r=c({type:"property",offset:j,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:R,offset:j,length:x,parent:r})},onObjectEnd:(R,j)=>{r.length=R+j-r.offset,r=r.parent,o(R+j)},onArrayBegin:(R,j)=>{r=c({type:"array",offset:R,length:-1,parent:r,children:[]})},onArrayEnd:(R,j)=>{r.length=R+j-r.offset,r=r.parent,o(R+j)},onLiteralValue:(R,j,x)=>{c({type:s(R),offset:j,length:x,parent:r,value:R}),o(j+x)},onSeparator:(R,j,x)=>{r.type==="property"&&(R===":"?r.colonOffset=j:R===","&&o(j))},onError:(R,j,x)=>{n.push({error:R,offset:j,length:x})}},t);const d=r.children[0];return d&&delete d.parent,d}e.parseTree=I;function v(i,n){if(!i)return;let t=i;for(const r of n)if(typeof r=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===r){t=c.children[1],o=!0;break}if(!o)return}else{const o=r;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=v;function S(i){if(!i.parent||!i.parent.children)return[];const n=S(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;n.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&n.push(t)}return n}e.getNodePath=S;function y(i){switch(i.type){case"array":return i.children.map(y);case"object":{const n=Object.create(null);for(const t of i.children){const r=t.children[1];r&&(n[t.children[0].value]=y(r))}return n}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=y;function u(i,n,t=!1){return n>=i.offset&&n<i.offset+i.length||t&&n===i.offset+i.length}e.contains=u;function h(i,n,t=!1){if(u(i,n,t)){const r=i.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const c=h(r[o],n,t);if(c)return c}return i}}e.findNodeAtOffset=h;function w(i,n,t=T.DEFAULT){const r=L(i,!1);function o(q){return q?()=>q(r.getTokenOffset(),r.getTokenLength()):()=>!0}function c(q){return q?ne=>q(ne,r.getTokenOffset(),r.getTokenLength()):()=>!0}const a=o(n.onObjectBegin),d=c(n.onObjectProperty),R=o(n.onObjectEnd),j=o(n.onArrayBegin),x=o(n.onArrayEnd),K=c(n.onLiteralValue),J=c(n.onSeparator),ie=o(n.onComment),se=c(n.onError),Q=t&&t.disallowComments,ge=t&&t.allowTrailingComma;function ce(){for(;;){const q=r.scan();switch(r.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:Q||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(q){case 12:case 13:Q?oe(10):ie();break;case 16:oe(1);break;case 15:case 14:break;default:return q}}}function oe(q,ne=[],F=[]){if(se(q),ne.length+F.length>0){let b=r.getToken();for(;b!==17;){if(ne.indexOf(b)!==-1){ce();break}else if(F.indexOf(b)!==-1)break;b=ce()}}}function me(q){const ne=r.getTokenValue();return q?K(ne):d(ne),ce(),!0}function M(){switch(r.getToken()){case 11:{let q=0;try{q=JSON.parse(r.getTokenValue()),typeof q!="number"&&(oe(2),q=0)}catch{oe(2)}K(q);break}case 7:K(null);break;case 8:K(!0);break;case 9:K(!1);break;default:return!1}return ce(),!0}function N(){return r.getToken()!==10?(oe(3,[],[2,5]),!1):(me(!1),r.getToken()===6?(J(":"),ce(),G()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function U(){a(),ce();let q=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(q||oe(4,[],[]),J(","),ce(),r.getToken()===2&&ge)break}else q&&oe(6,[],[]);N()||oe(4,[],[2,5]),q=!0}return R(),r.getToken()!==2?oe(7,[2],[]):ce(),!0}function V(){j(),ce();let q=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(q||oe(4,[],[]),J(","),ce(),r.getToken()===4&&ge)break}else q&&oe(6,[],[]);G()||oe(4,[],[4,5]),q=!0}return x(),r.getToken()!==4?oe(8,[4],[]):ce(),!0}function G(){switch(r.getToken()){case 3:return V();case 1:return U();case 10:return me(!0);default:return M()}}return ce(),r.getToken()===17?t.allowEmptyContent?!0:(oe(4,[],[]),!1):G()?(r.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.visit=w;function f(i,n){const t=L(i),r=[];let o,c=0,a;do switch(a=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:c!==a&&r.push(i.substring(c,a)),n!==void 0&&r.push(t.getTokenValue().replace(/[^\r\n]/g,n)),c=t.getPosition();break}while(o!==17);return r.join("")}e.stripComments=f;function s(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),function(){function W(k){const T=[];typeof k=="number"&&T.push("code/timeOrigin",k);function L(g){T.push(g,Date.now())}function P(){const g=[];for(let l=0;l<T.length;l+=2)g.push({name:T[l],startTime:T[l+1]});return g}return{mark:L,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?W():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const L of performance.getEntriesByType("mark"))T.push({name:L.name,startTime:Math.round(k+L.startTime)});return T}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return W(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),W()}function O(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=O(D))}(),function(W,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var D in O)(typeof exports=="object"?exports:W)[D]=O[D]}}(typeof self<"u"?self:this,function(){return function(W){var e={};function O(D){if(e[D])return e[D].exports;var k=e[D]={i:D,l:!1,exports:{}};return W[D].call(k.exports,k,k.exports,O),k.l=!0,k.exports}return O.m=W,O.c=e,O.d=function(D,k,T){O.o(D,k)||Object.defineProperty(D,k,{enumerable:!0,get:T})},O.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},O.t=function(D,k){if(1&k&&(D=O(D)),8&k||4&k&&typeof D=="object"&&D&&D.__esModule)return D;var T=Object.create(null);if(O.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:D}),2&k&&typeof D!="string")for(var L in D)O.d(T,L,function(P){return D[P]}.bind(null,L));return T},O.n=function(D){var k=D&&D.__esModule?function(){return D.default}:function(){return D};return O.d(k,"a",k),k},O.o=function(D,k){return Object.prototype.hasOwnProperty.call(D,k)},O.p="",O(O.s=0)}([function(W,e,O){(function(D){var k;e=W.exports=F,k=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],g=e.src=[],l=0,m=l++;g[m]="0|[1-9]\\d*";var E=l++;g[E]="[0-9]+";var p=l++;g[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=l++;g[I]="("+g[m]+")\\.("+g[m]+")\\.("+g[m]+")";var v=l++;g[v]="("+g[E]+")\\.("+g[E]+")\\.("+g[E]+")";var S=l++;g[S]="(?:"+g[m]+"|"+g[p]+")";var y=l++;g[y]="(?:"+g[E]+"|"+g[p]+")";var u=l++;g[u]="(?:-("+g[S]+"(?:\\."+g[S]+")*))";var h=l++;g[h]="(?:-?("+g[y]+"(?:\\."+g[y]+")*))";var w=l++;g[w]="[0-9A-Za-z-]+";var f=l++;g[f]="(?:\\+("+g[w]+"(?:\\."+g[w]+")*))";var s=l++,i="v?"+g[I]+g[u]+"?"+g[f]+"?";g[s]="^"+i+"$";var n="[v=\\s]*"+g[v]+g[h]+"?"+g[f]+"?",t=l++;g[t]="^"+n+"$";var r=l++;g[r]="((?:<|>)?=?)";var o=l++;g[o]=g[E]+"|x|X|\\*";var c=l++;g[c]=g[m]+"|x|X|\\*";var a=l++;g[a]="[v=\\s]*("+g[c]+")(?:\\.("+g[c]+")(?:\\.("+g[c]+")(?:"+g[u]+")?"+g[f]+"?)?)?";var d=l++;g[d]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[h]+")?"+g[f]+"?)?)?";var R=l++;g[R]="^"+g[r]+"\\s*"+g[a]+"$";var j=l++;g[j]="^"+g[r]+"\\s*"+g[d]+"$";var x=l++;g[x]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var K=l++;g[K]="(?:~>?)";var J=l++;g[J]="(\\s*)"+g[K]+"\\s+",P[J]=new RegExp(g[J],"g");var ie=l++;g[ie]="^"+g[K]+g[a]+"$";var se=l++;g[se]="^"+g[K]+g[d]+"$";var Q=l++;g[Q]="(?:\\^)";var ge=l++;g[ge]="(\\s*)"+g[Q]+"\\s+",P[ge]=new RegExp(g[ge],"g");var ce=l++;g[ce]="^"+g[Q]+g[a]+"$";var oe=l++;g[oe]="^"+g[Q]+g[d]+"$";var me=l++;g[me]="^"+g[r]+"\\s*("+n+")$|^$";var M=l++;g[M]="^"+g[r]+"\\s*("+i+")$|^$";var N=l++;g[N]="(\\s*)"+g[r]+"\\s*("+n+"|"+g[a]+")",P[N]=new RegExp(g[N],"g");var U=l++;g[U]="^\\s*("+g[a]+")\\s+-\\s+("+g[a]+")\\s*$";var V=l++;g[V]="^\\s*("+g[d]+")\\s+-\\s+("+g[d]+")\\s*$";var G=l++;g[G]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)k(q,g[q]),P[q]||(P[q]=new RegExp(g[q]));function ne(z,H){if(z instanceof F)return z;if(typeof z!="string"||z.length>T||!(H?P[t]:P[s]).test(z))return null;try{return new F(z,H)}catch{return null}}function F(z,H){if(z instanceof F){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof F))return new F(z,H);k("SemVer",z,H),this.loose=H;var X=z.trim().match(H?P[t]:P[s]);if(!X)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var pe=+he;if(pe>=0&&pe<L)return pe}return he}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}e.parse=ne,e.valid=function(z,H){var X=ne(z,H);return X?X.version:null},e.clean=function(z,H){var X=ne(z.trim().replace(/^[=v]+/,""),H);return X?X.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(z){return k("SemVer.compare",this.version,this.loose,z),z instanceof F||(z=new F(z,this.loose)),this.compareMain(z)||this.comparePre(z)},F.prototype.compareMain=function(z){return z instanceof F||(z=new F(z,this.loose)),A(this.major,z.major)||A(this.minor,z.minor)||A(this.patch,z.patch)},F.prototype.comparePre=function(z){if(z instanceof F||(z=new F(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var X=this.prerelease[H],he=z.prerelease[H];if(k("prerelease compare",H,X,he),X===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(X===void 0)return-1;if(X!==he)return A(X,he)}while(++H)},F.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,H,X,he){typeof X=="string"&&(he=X,X=void 0);try{return new F(z,X).inc(H,he).version}catch{return null}},e.diff=function(z,H){if(_(z,H))return null;var X=ne(z),he=ne(H);if(X.prerelease.length||he.prerelease.length){for(var pe in X)if((pe==="major"||pe==="minor"||pe==="patch")&&X[pe]!==he[pe])return"pre"+pe;return"prerelease"}for(var pe in X)if((pe==="major"||pe==="minor"||pe==="patch")&&X[pe]!==he[pe])return pe},e.compareIdentifiers=A;var b=/^[0-9]+$/;function A(z,H){var X=b.test(z),he=b.test(H);return X&&he&&(z=+z,H=+H),X&&!he?-1:he&&!X?1:z<H?-1:z>H?1:0}function C(z,H,X){return new F(z,X).compare(new F(H,X))}function B(z,H,X){return C(z,H,X)>0}function $(z,H,X){return C(z,H,X)<0}function _(z,H,X){return C(z,H,X)===0}function re(z,H,X){return C(z,H,X)!==0}function ue(z,H,X){return C(z,H,X)>=0}function ve(z,H,X){return C(z,H,X)<=0}function ae(z,H,X,he){var pe;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof X=="object"&&(X=X.version),pe=z===X;break;case"!==":typeof z=="object"&&(z=z.version),typeof X=="object"&&(X=X.version),pe=z!==X;break;case"":case"=":case"==":pe=_(z,X,he);break;case"!=":pe=re(z,X,he);break;case">":pe=B(z,X,he);break;case">=":pe=ue(z,X,he);break;case"<":pe=$(z,X,he);break;case"<=":pe=ve(z,X,he);break;default:throw new TypeError("Invalid operator: "+H)}return pe}function te(z,H){if(z instanceof te){if(z.loose===H)return z;z=z.value}if(!(this instanceof te))return new te(z,H);k("comparator",z,H),this.loose=H,this.parse(z),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(z,H){return A(H,z)},e.major=function(z,H){return new F(z,H).major},e.minor=function(z,H){return new F(z,H).minor},e.patch=function(z,H){return new F(z,H).patch},e.compare=C,e.compareLoose=function(z,H){return C(z,H,!0)},e.rcompare=function(z,H,X){return C(H,z,X)},e.sort=function(z,H){return z.sort(function(X,he){return e.compare(X,he,H)})},e.rsort=function(z,H){return z.sort(function(X,he){return e.rcompare(X,he,H)})},e.gt=B,e.lt=$,e.eq=_,e.neq=re,e.gte=ue,e.lte=ve,e.cmp=ae,e.Comparator=te;var fe={};function le(z,H){if(z instanceof le)return z.loose===H?z:new le(z.raw,H);if(z instanceof te)return new le(z.value,H);if(!(this instanceof le))return new le(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function ye(z){return!z||z.toLowerCase()==="x"||z==="*"}function Re(z,H,X,he,pe,ke,Se,Oe,Ie,Te,je,De,Ne){return((H=ye(X)?"":ye(he)?">="+X+".0.0":ye(pe)?">="+X+"."+he+".0":">="+H)+" "+(Oe=ye(Ie)?"":ye(Te)?"<"+(+Ie+1)+".0.0":ye(je)?"<"+Ie+"."+(+Te+1)+".0":De?"<="+Ie+"."+Te+"."+je+"-"+De:"<="+Oe)).trim()}function Le(z,H){for(var X=0;X<z.length;X++)if(!z[X].test(H))return!1;if(H.prerelease.length){for(X=0;X<z.length;X++)if(k(z[X].semver),z[X].semver!==fe&&z[X].semver.prerelease.length>0){var he=z[X].semver;if(he.major===H.major&&he.minor===H.minor&&he.patch===H.patch)return!0}return!1}return!0}function Me(z,H,X){try{H=new le(H,X)}catch{return!1}return H.test(z)}function Ue(z,H,X,he){var pe,ke,Se,Oe,Ie;switch(z=new F(z,he),H=new le(H,he),X){case">":pe=B,ke=ve,Se=$,Oe=">",Ie=">=";break;case"<":pe=$,ke=ue,Se=B,Oe="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(z,H,he))return!1;for(var Te=0;Te<H.set.length;++Te){var je=H.set[Te],De=null,Ne=null;if(je.forEach(function(Ce){Ce.semver===fe&&(Ce=new te(">=0.0.0")),De=De||Ce,Ne=Ne||Ce,pe(Ce.semver,De.semver,he)?De=Ce:Se(Ce.semver,Ne.semver,he)&&(Ne=Ce)}),De.operator===Oe||De.operator===Ie||(!Ne.operator||Ne.operator===Oe)&&ke(z,Ne.semver)||Ne.operator===Ie&&Se(z,Ne.semver))return!1}return!0}te.prototype.parse=function(z){var H=this.loose?P[me]:P[M],X=z.match(H);if(!X)throw new TypeError("Invalid comparator: "+z);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new F(X[2],this.loose):this.semver=fe},te.prototype.toString=function(){return this.value},te.prototype.test=function(z){return k("Comparator.test",z,this.loose),this.semver===fe||(typeof z=="string"&&(z=new F(z,this.loose)),ae(z,this.operator,this.semver,this.loose))},te.prototype.intersects=function(z,H){if(!(z instanceof te))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new le(z.value,H),Me(this.value,X,H);if(z.operator==="")return X=new le(this.value,H),Me(z.semver,X,H);var he=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),ke=this.semver.version===z.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Oe=ae(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ie=ae(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return he||pe||ke&&Se||Oe||Ie},e.Range=le,le.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},le.prototype.toString=function(){return this.range},le.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),k("range",z,H);var X=H?P[V]:P[U];z=z.replace(X,Re),k("hyphen replace",z),z=z.replace(P[N],"$1$2$3"),k("comparator trim",z,P[N]),z=(z=(z=z.replace(P[J],"$1~")).replace(P[ge],"$1^")).split(/\s+/).join(" ");var he=H?P[me]:P[M],pe=z.split(" ").map(function(ke){return function(Se,Oe){return k("comp",Se),Se=function(Ie,Te){return Ie.trim().split(/\s+/).map(function(je){return function(De,Ne){k("caret",De,Ne);var Ce=Ne?P[oe]:P[ce];return De.replace(Ce,function(Fe,we,Ee,be,Pe){var Ae;return k("caret",De,Fe,we,Ee,be,Pe),ye(we)?Ae="":ye(Ee)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":ye(be)?Ae=we==="0"?">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+".0 <"+(+we+1)+".0.0":Pe?(k("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ae=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+be+Pe+" <"+we+"."+Ee+"."+(+be+1):">="+we+"."+Ee+"."+be+Pe+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+be+Pe+" <"+(+we+1)+".0.0"):(k("no pr"),Ae=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+be+" <"+we+"."+Ee+"."+(+be+1):">="+we+"."+Ee+"."+be+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+be+" <"+(+we+1)+".0.0"),k("caret return",Ae),Ae})}(je,Te)}).join(" ")}(Se,Oe),k("caret",Se),Se=function(Ie,Te){return Ie.trim().split(/\s+/).map(function(je){return function(De,Ne){var Ce=Ne?P[se]:P[ie];return De.replace(Ce,function(Fe,we,Ee,be,Pe){var Ae;return k("tilde",De,Fe,we,Ee,be,Pe),ye(we)?Ae="":ye(Ee)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":ye(be)?Ae=">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":Pe?(k("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ae=">="+we+"."+Ee+"."+be+Pe+" <"+we+"."+(+Ee+1)+".0"):Ae=">="+we+"."+Ee+"."+be+" <"+we+"."+(+Ee+1)+".0",k("tilde return",Ae),Ae})}(je,Te)}).join(" ")}(Se,Oe),k("tildes",Se),Se=function(Ie,Te){return k("replaceXRanges",Ie,Te),Ie.split(/\s+/).map(function(je){return function(De,Ne){De=De.trim();var Ce=Ne?P[j]:P[R];return De.replace(Ce,function(Fe,we,Ee,be,Pe,Ae){k("xRange",De,Fe,we,Ee,be,Pe,Ae);var We=ye(Ee),ze=We||ye(be),Be=ze||ye(Pe);return we==="="&&Be&&(we=""),We?Fe=we===">"||we==="<"?"<0.0.0":"*":we&&Be?(ze&&(be=0),Be&&(Pe=0),we===">"?(we=">=",ze?(Ee=+Ee+1,be=0,Pe=0):Be&&(be=+be+1,Pe=0)):we==="<="&&(we="<",ze?Ee=+Ee+1:be=+be+1),Fe=we+Ee+"."+be+"."+Pe):ze?Fe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Be&&(Fe=">="+Ee+"."+be+".0 <"+Ee+"."+(+be+1)+".0"),k("xRange return",Fe),Fe})}(je,Te)}).join(" ")}(Se,Oe),k("xrange",Se),Se=function(Ie,Te){return k("replaceStars",Ie,Te),Ie.trim().replace(P[G],"")}(Se,Oe),k("stars",Se),Se}(ke,H)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(ke){return!!ke.match(he)})),pe=pe.map(function(ke){return new te(ke,H)})},le.prototype.intersects=function(z,H){if(!(z instanceof le))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(he){return z.set.some(function(pe){return pe.every(function(ke){return he.intersects(ke,H)})})})})},e.toComparators=function(z,H){return new le(z,H).set.map(function(X){return X.map(function(he){return he.value}).join(" ").trim().split(" ")})},le.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new F(z,this.loose));for(var H=0;H<this.set.length;H++)if(Le(this.set[H],z))return!0;return!1},e.satisfies=Me,e.maxSatisfying=function(z,H,X){var he=null,pe=null;try{var ke=new le(H,X)}catch{return null}return z.forEach(function(Se){ke.test(Se)&&(he&&pe.compare(Se)!==-1||(pe=new F(he=Se,X)))}),he},e.minSatisfying=function(z,H,X){var he=null,pe=null;try{var ke=new le(H,X)}catch{return null}return z.forEach(function(Se){ke.test(Se)&&(he&&pe.compare(Se)!==1||(pe=new F(he=Se,X)))}),he},e.validRange=function(z,H){try{return new le(z,H).range||"*"}catch{return null}},e.ltr=function(z,H,X){return Ue(z,H,"<",X)},e.gtr=function(z,H,X){return Ue(z,H,">",X)},e.outside=Ue,e.prerelease=function(z,H){var X=ne(z,H);return X&&X.prerelease.length?X.prerelease:null},e.intersects=function(z,H,X){return z=new le(z,X),H=new le(H,X),z.intersects(H)},e.coerce=function(z){if(z instanceof F)return z;if(typeof z!="string")return null;var H=z.match(P[x]);return H==null?null:ne((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,O(1))},function(W,e){var O,D,k=W.exports={};function T(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function P(y){if(O===setTimeout)return setTimeout(y,0);if((O===T||!O)&&setTimeout)return O=setTimeout,setTimeout(y,0);try{return O(y,0)}catch{try{return O.call(null,y,0)}catch{return O.call(this,y,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:T}catch{O=T}try{D=typeof clearTimeout=="function"?clearTimeout:L}catch{D=L}})();var g,l=[],m=!1,E=-1;function p(){m&&g&&(m=!1,g.length?l=g.concat(l):E=-1,l.length&&I())}function I(){if(!m){var y=P(p);m=!0;for(var u=l.length;u;){for(g=l,l=[];++E<u;)g&&g[E].run();E=-1,u=l.length}g=null,m=!1,function(h){if(D===clearTimeout)return clearTimeout(h);if((D===L||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(h);try{D(h)}catch{try{return D.call(null,h)}catch{return D.call(this,h)}}}(y)}}function v(y,u){this.fun=y,this.array=u}function S(){}k.nextTick=function(y){var u=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)u[h-1]=arguments[h];l.push(new v(y,u)),l.length!==1||m||P(I)},v.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=S,k.addListener=S,k.once=S,k.off=S,k.removeListener=S,k.removeAllListeners=S,k.emit=S,k.prependListener=S,k.prependOnceListener=S,k.listeners=function(y){return[]},k.binding=function(y){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(y){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Y[70],Z([0,1]),function(W,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class D{constructor(P,g,l){this.level=P,this.key=g,this.value=l,this.forward=[]}}const k=void 0;class T{constructor(P,g=2**16){this.comparator=P,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new D(this.c,k,k)}get size(){return this.f}clear(){this.e=new D(this.c,k,k)}has(P){return Boolean(T.g(this,P,this.comparator))}get(P){return T.g(this,P,this.comparator)?.value}set(P,g){return T.h(this,P,g,this.comparator)&&(this.f+=1),this}delete(P){const g=T.k(this,P,this.comparator);return g&&(this.f-=1),g}forEach(P,g){let l=this.e.forward[0];for(;l;)P.call(g,l.value,l.key,this),l=l.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",g=this.e.forward[0];for(;g;)P+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return P}static g(P,g,l){let m=P.e;for(let E=P.d-1;E>=0;E--)for(;m.forward[E]&&l(m.forward[E].key,g)<0;)m=m.forward[E];if(m=m.forward[0],m&&l(m.key,g)===0)return m}static h(P,g,l,m){const E=[];let p=P.e;for(let I=P.d-1;I>=0;I--){for(;p.forward[I]&&m(p.forward[I].key,g)<0;)p=p.forward[I];E[I]=p}if(p=p.forward[0],p&&m(p.key,g)===0)return p.value=l,!1;{const I=T.j(P);if(I>P.d){for(let v=P.d;v<I;v++)E[v]=P.e;P.d=I}p=new D(I,g,l);for(let v=0;v<I;v++)p.forward[v]=E[v].forward[v],E[v].forward[v]=p;return!0}}static j(P,g=.5){let l=1;for(;Math.random()<g&&l<P.c;)l+=1;return l}static k(P,g,l){const m=[];let E=P.e;for(let p=P.d-1;p>=0;p--){for(;E.forward[p]&&l(E.forward[p].key,g)<0;)E=E.forward[p];m[p]=E}if(E=E.forward[0],!E||l(E.key,g)!==0)return!1;for(let p=0;p<P.d&&m[p].forward[p]===E;p++)m[p].forward[p]=E.forward[p];for(;P.d>0&&P.e.forward[P.d-1]===k;)P.d-=1;return!0}}e.SkipList=T}),define(Y[43],Z([0,1,10,2]),function(W,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(f){const s=f;return s?typeof s.read=="function":!1}e.isReadable=k;function T(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=T;function L(f){const s=f;return s?T(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=L;function P(f,s){return new g(f,s)}e.newWriteableStream=P;class g{constructor(s,i){this.e=s,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(i=>i(s))}h(s){this.c.error.length===0?(0,O.onUnexpectedError)(s):this.c.error.slice(0).forEach(i=>i(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,i){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(s,i){if(this.a.destroyed)return;let n;switch(s){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const t=n.indexOf(i);t>=0&&n.splice(t,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(f,s){const i=[];let n;for(;(n=f.read())!==null;)i.push(n);return s(i)}e.consumeReadable=l;function m(f,s,i){const n=[];let t;for(;(t=f.read())!==null&&n.length<i;)n.push(t);return t===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof t<"u"){const r=t;return t=void 0,r}return f.read()}}}e.peekReadable=m;function E(f,s){return new Promise((i,n)=>{const t=[];p(f,{onData:r=>{s&&t.push(r)},onError:r=>{s?n(r):i(void 0)},onEnd:()=>{i(s?s(t):void 0)}})})}e.consumeStream=E;function p(f,s){let i=!1;return f.on("error",n=>{i||s.onError(n)}),f.on("end",()=>{i||s.onEnd()}),f.on("data",n=>{i||s.onData(n)}),(0,D.toDisposable)(()=>i=!0)}e.listenStream=p;function I(f,s){return new Promise((i,n)=>{const t=new D.DisposableStore,r=[],o=d=>{if(r.push(d),r.length>s)return t.dispose(),f.pause(),i({stream:f,buffer:r,ended:!1})},c=d=>n(d),a=()=>i({stream:f,buffer:r,ended:!0});t.add((0,D.toDisposable)(()=>f.removeListener("error",c))),f.on("error",c),t.add((0,D.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),t.add((0,D.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=I;function v(f,s){const i=P(s);return i.end(f),i}e.toStream=v;function S(){const f=P(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=S;function y(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}e.toReadable=y;function u(f,s,i){const n=P(i);return p(f,{onData:t=>n.write(s.data(t)),onError:t=>n.error(s.error?s.error(t):t),onEnd:()=>n.end()}),n}e.transform=u;function h(f,s,i){let n=!1;return{read:()=>{const t=s.read();return n?t:(n=!0,t!==null?i([f,t]):f)}}}e.prefixedReadable=h;function w(f,s,i){let n=!1;const t=P(i);return p(s,{onData:r=>n?t.write(r):(n=!0,t.write(i([f,r]))),onError:r=>t.error(r),onEnd:()=>{n||(n=!0,t.write(f)),t.end()}}),t}e.prefixedStream=w}),define(Y[14],Z([0,1,43]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer<"u";let k,T;class L{static alloc(d){return D?new L(Buffer.allocUnsafe(d)):new L(new Uint8Array(d))}static wrap(d){return D&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new L(d)}static fromString(d,R){return!(R?.dontUseNodeBuffer||!1)&&D?new L(Buffer.from(d)):(k||(k=new TextEncoder),new L(k.encode(d)))}static fromByteArray(d){const R=L.alloc(d.length);for(let j=0,x=d.length;j<x;j++)R.buffer[j]=d[j];return R}static concat(d,R){if(typeof R>"u"){R=0;for(let K=0,J=d.length;K<J;K++)R+=d[K].byteLength}const j=L.alloc(R);let x=0;for(let K=0,J=d.length;K<J;K++){const ie=d[K];j.set(ie,x),x+=ie.byteLength}return j}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=L.alloc(this.byteLength);return d.set(this),d}toString(){return D?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(d,R){return new L(this.buffer.subarray(d,R))}set(d,R){if(d instanceof L)this.buffer.set(d.buffer,R);else if(d instanceof Uint8Array)this.buffer.set(d,R);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),R);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return l(this.buffer,d)}writeUInt32BE(d,R){m(this.buffer,d,R)}readUInt32LE(d){return E(this.buffer,d)}writeUInt32LE(d,R){p(this.buffer,d,R)}readUInt8(d){return I(this.buffer,d)}writeUInt8(d,R){v(this.buffer,d,R)}}e.VSBuffer=L;function P(a,d){return a[d+0]<<0>>>0|a[d+1]<<8>>>0}e.readUInt16LE=P;function g(a,d,R){a[R+0]=d&255,d=d>>>8,a[R+1]=d&255}e.writeUInt16LE=g;function l(a,d){return a[d]*2**24+a[d+1]*2**16+a[d+2]*2**8+a[d+3]}e.readUInt32BE=l;function m(a,d,R){a[R+3]=d,d=d>>>8,a[R+2]=d,d=d>>>8,a[R+1]=d,d=d>>>8,a[R]=d}e.writeUInt32BE=m;function E(a,d){return a[d+0]<<0>>>0|a[d+1]<<8>>>0|a[d+2]<<16>>>0|a[d+3]<<24>>>0}e.readUInt32LE=E;function p(a,d,R){a[R+0]=d&255,d=d>>>8,a[R+1]=d&255,d=d>>>8,a[R+2]=d&255,d=d>>>8,a[R+3]=d&255}e.writeUInt32LE=p;function I(a,d){return a[d]}e.readUInt8=I;function v(a,d,R){a[R]=d}e.writeUInt8=v;function S(a){return O.consumeReadable(a,d=>L.concat(d))}e.readableToBuffer=S;function y(a){return O.toReadable(a)}e.bufferToReadable=y;function u(a){return O.consumeStream(a,d=>L.concat(d))}e.streamToBuffer=u;async function h(a){return a.ended?L.concat(a.buffer):L.concat([...a.buffer,await u(a.stream)])}e.bufferedStreamToBuffer=h;function w(a){return O.toStream(a,d=>L.concat(d))}e.bufferToStream=w;function f(a){return O.transform(a,{data:d=>typeof d=="string"?L.fromString(d):L.wrap(d)},d=>L.concat(d))}e.streamToBufferReadableStream=f;function s(a){return O.newWriteableStream(d=>L.concat(d),a)}e.newWriteableBufferStream=s;function i(a,d){return O.prefixedReadable(a,d,R=>L.concat(R))}e.prefixedBufferReadable=i;function n(a,d){return O.prefixedStream(a,d,R=>L.concat(R))}e.prefixedBufferStream=n;function t(a){let d=0,R=0,j=0;const x=new Uint8Array(Math.floor(a.length/4*3)),K=ie=>{switch(R){case 3:x[j++]=d|ie,R=0;break;case 2:x[j++]=d|ie>>>2,d=ie<<6,R=3;break;case 1:x[j++]=d|ie>>>4,d=ie<<4,R=2;break;default:d=ie<<2,R=1}};for(let ie=0;ie<a.length;ie++){const se=a.charCodeAt(ie);if(se>=65&&se<=90)K(se-65);else if(se>=97&&se<=122)K(se-97+26);else if(se>=48&&se<=57)K(se-48+52);else if(se===43||se===45)K(62);else if(se===47||se===95)K(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${a[ie]}`)}}const J=j;for(;R>0;)K(0);return L.wrap(x).slice(0,J)}e.decodeBase64=t;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},d=!0,R=!1){const j=R?o:r;let x="";const K=a.byteLength%3;let J=0;for(;J<a.byteLength-K;J+=3){const ie=a[J+0],se=a[J+1],Q=a[J+2];x+=j[ie>>>2],x+=j[(ie<<4|se>>>4)&63],x+=j[(se<<2|Q>>>6)&63],x+=j[Q&63]}if(K===1){const ie=a[J+0];x+=j[ie>>>2],x+=j[ie<<4&63],d&&(x+="==")}else if(K===2){const ie=a[J+0],se=a[J+1];x+=j[ie>>>2],x+=j[(ie<<4|se>>>4)&63],x+=j[se<<2&63],d&&(x+="=")}return x}e.encodeBase64=c}),define(Y[26],Z([0,1,8]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const h=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([w,f])=>{h[w]=f&&typeof f=="object"?D(f):f}),h}e.deepClone=D;function k(u){if(!u||typeof u!="object")return u;const h=[u];for(;h.length>0;){const w=h.shift();Object.freeze(w);for(const f in w)if(T.call(w,f)){const s=w[f];typeof s=="object"&&!Object.isFrozen(s)&&!(0,O.isTypedArray)(s)&&h.push(s)}}return u}e.deepFreeze=k;const T=Object.prototype.hasOwnProperty;function L(u,h){return P(u,h,new Set)}e.cloneAndChange=L;function P(u,h,w){if((0,O.isUndefinedOrNull)(u))return u;const f=h(u);if(typeof f<"u")return f;if(Array.isArray(u)){const s=[];for(const i of u)s.push(P(i,h,w));return s}if((0,O.isObject)(u)){if(w.has(u))throw new Error("Cannot clone recursive data-structure");w.add(u);const s={};for(const i in u)T.call(u,i)&&(s[i]=P(u[i],h,w));return w.delete(u),s}return u}function g(u,h,w=!0){return(0,O.isObject)(u)?((0,O.isObject)(h)&&Object.keys(h).forEach(f=>{f in u?w&&((0,O.isObject)(u[f])&&(0,O.isObject)(h[f])?g(u[f],h[f],w):u[f]=h[f]):u[f]=h[f]}),u):h}e.mixin=g;function l(u,h){if(u===h)return!0;if(u==null||h===null||h===void 0||typeof u!=typeof h||typeof u!="object"||Array.isArray(u)!==Array.isArray(h))return!1;let w,f;if(Array.isArray(u)){if(u.length!==h.length)return!1;for(w=0;w<u.length;w++)if(!l(u[w],h[w]))return!1}else{const s=[];for(f in u)s.push(f);s.sort();const i=[];for(f in h)i.push(f);if(i.sort(),!l(s,i))return!1;for(w=0;w<s.length;w++)if(!l(u[s[w]],h[s[w]]))return!1}return!0}e.equals=l;function m(u){const h=new Set;return JSON.stringify(u,(w,f)=>{if((0,O.isObject)(f)||Array.isArray(f)){if(h.has(f))return"[Circular]";h.add(f)}return f})}e.safeStringify=m;function E(u,h){const w=Object.create(null);return!u||!h||Object.keys(h).forEach(s=>{const i=u[s],n=h[s];l(i,n)||(w[s]=n)}),w}e.distinct=E;function p(u,h){const w=h.toLowerCase(),f=Object.keys(u).find(s=>s.toLowerCase()===w);return f?u[f]:u[h]}e.getCaseInsensitive=p;function I(u,h){const w=Object.create(null);for(const[f,s]of Object.entries(u))h(f,s)&&(w[f]=s);return w}e.filter=I;function v(u){let h=[],w=Object.getPrototypeOf(u);for(;Object.prototype!==w;)h=h.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return h}e.getAllPropertyNames=v;function S(u){const h=[];for(const w of v(u))typeof u[w]=="function"&&h.push(w);return h}e.getAllMethodNames=S;function y(u,h){const w=s=>function(){const i=Array.prototype.slice.call(arguments,0);return h(s,i)},f={};for(const s of u)f[s]=w(s);return f}e.createProxyObject=y}),define(Y[31],Z([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(k){return O.test(k)}e.isUUID=D,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(P){for(let g=0;g<P.length;g++)P[g]=Math.floor(Math.random()*256);return P};const T=new Uint8Array(16),L=[];for(let P=0;P<256;P++)L.push(P.toString(16).padStart(2,"0"));return function(){k(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let g=0,l="";return l+=L[T[g++]],l+=L[T[g++]],l+=L[T[g++]],l+=L[T[g++]],l+="-",l+=L[T[g++]],l+=L[T[g++]],l+="-",l+=L[T[g++]],l+=L[T[g++]],l+="-",l+=L[T[g++]],l+=L[T[g++]],l+="-",l+=L[T[g++]],l+=L[T[g++]],l+=L[T[g++]],l+=L[T[g++]],l+=L[T[g++]],l+=L[T[g++]],l}}()}),define(Y[71],Z([5,6]),function(W,e){return W.create("vs/base/common/date",e)}),define(Y[72],Z([0,1,71]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,k=D*60,T=k*24,L=T*7,P=T*30,g=T*365;function l(E,p,I){typeof E!="number"&&(E=E.getTime());const v=Math.round((new Date().getTime()-E)/1e3);if(v<-30)return(0,O.localize)(0,null,l(new Date().getTime()+v*1e3,!1));if(v<30)return(0,O.localize)(1,null);let S;return v<D?(S=v,p?S===1?I?(0,O.localize)(2,null,S):(0,O.localize)(3,null,S):I?(0,O.localize)(4,null,S):(0,O.localize)(5,null,S):S===1?I?(0,O.localize)(6,null,S):(0,O.localize)(7,null,S):I?(0,O.localize)(8,null,S):(0,O.localize)(9,null,S)):v<k?(S=Math.floor(v/D),p?S===1?I?(0,O.localize)(10,null,S):(0,O.localize)(11,null,S):I?(0,O.localize)(12,null,S):(0,O.localize)(13,null,S):S===1?I?(0,O.localize)(14,null,S):(0,O.localize)(15,null,S):I?(0,O.localize)(16,null,S):(0,O.localize)(17,null,S)):v<T?(S=Math.floor(v/k),p?S===1?I?(0,O.localize)(18,null,S):(0,O.localize)(19,null,S):I?(0,O.localize)(20,null,S):(0,O.localize)(21,null,S):S===1?I?(0,O.localize)(22,null,S):(0,O.localize)(23,null,S):I?(0,O.localize)(24,null,S):(0,O.localize)(25,null,S)):v<L?(S=Math.floor(v/T),p?S===1?(0,O.localize)(26,null,S):(0,O.localize)(27,null,S):S===1?(0,O.localize)(28,null,S):(0,O.localize)(29,null,S)):v<P?(S=Math.floor(v/L),p?S===1?I?(0,O.localize)(30,null,S):(0,O.localize)(31,null,S):I?(0,O.localize)(32,null,S):(0,O.localize)(33,null,S):S===1?I?(0,O.localize)(34,null,S):(0,O.localize)(35,null,S):I?(0,O.localize)(36,null,S):(0,O.localize)(37,null,S)):v<g?(S=Math.floor(v/P),p?S===1?I?(0,O.localize)(38,null,S):(0,O.localize)(39,null,S):I?(0,O.localize)(40,null,S):(0,O.localize)(41,null,S):S===1?I?(0,O.localize)(42,null,S):(0,O.localize)(43,null,S):I?(0,O.localize)(44,null,S):(0,O.localize)(45,null,S)):(S=Math.floor(v/g),p?S===1?I?(0,O.localize)(46,null,S):(0,O.localize)(47,null,S):I?(0,O.localize)(48,null,S):(0,O.localize)(49,null,S):S===1?I?(0,O.localize)(50,null,S):(0,O.localize)(51,null,S):I?(0,O.localize)(52,null,S):(0,O.localize)(53,null,S))}e.fromNow=l;function m(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=m}),define(Y[73],Z([5,6]),function(W,e){return W.create("vs/base/common/errorMessage",e)}),define(Y[32],Z([0,1,19,8,73]),function(W,e,O,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(E,p){return p&&(E.stack||E.stacktrace)?k.localize(0,null,P(E),L(E.stack)||L(E.stacktrace)):P(E)}function L(E){return Array.isArray(E)?E.join(`
`):E}function P(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?k.localize(1,null,E.message):E.message||k.localize(2,null)}function g(E=null,p=!1){if(!E)return k.localize(3,null);if(Array.isArray(E)){const I=O.coalesce(E),v=g(I[0],p);return I.length>1?k.localize(4,null,v,I.length):v}if(D.isString(E))return E;if(E.detail){const I=E.detail;if(I.error)return T(I.error,p);if(I.exception)return T(I.exception,p)}return E.stack?T(E,p):E.message?E.message:k.localize(5,null)}e.toErrorMessage=g;function l(E){const p=E;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=l;function m(E,p){let I;return typeof E=="string"?I=new Error(E):I=E,I.actions=p,I}e.createErrorWithActions=m}),define(Y[74],Z([5,6]),function(W,e){return W.create("vs/base/common/jsonErrorMessages",e)}),define(Y[75],Z([0,1,74]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function D(k){switch(k){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}e.getParseErrorMessage=D}),define(Y[51],Z([0,1,12]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var k;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(P,...g){const l=g.reduce((p,I)=>(p[I]=!0,p),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(p=>!l[p]).forEach(p=>{for(let I=0;I<m.length;I++)if(p.search(m[I])!==-1){delete P[p];break}})}e.sanitizeProcessEnvironment=T;function L(P){!P||(delete P.DEBUG,O.isMacintosh&&delete P.DYLD_LIBRARY_PATH,O.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=L}),define(Y[52],Z([0,1,3,2]),function(W,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=L=>({onDidChange:O.Event.None,value:L});e.staticObservableValue=k;class T extends D.Disposable{get value(){return this.b}set value(P){P!==this.b&&(this.b=P,this.a.fire(P))}constructor(P){super(),this.b=P,this.a=this.B(new O.Emitter),this.onDidChange=this.a.event}}e.MutableObservableValue=T}),define(Y[53],Z([0,1,27]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function D(u){return k(u,0)}e.hash=D;function k(u,h){switch(typeof u){case"object":return u===null?T(349,h):Array.isArray(u)?g(u,h):l(u,h);case"string":return P(u,h);case"boolean":return L(u,h);case"number":return T(u,h);case"undefined":return T(937,h);default:return T(617,h)}}e.doHash=k;function T(u,h){return(h<<5)-h+u|0}e.numberHash=T;function L(u,h){return T(u?433:863,h)}function P(u,h){h=T(149417,h);for(let w=0,f=u.length;w<f;w++)h=T(u.charCodeAt(w),h);return h}e.stringHash=P;function g(u,h){return h=T(104579,h),u.reduce((w,f)=>k(f,w),h)}function l(u,h){return h=T(181387,h),Object.keys(u).sort().reduce((w,f)=>(w=P(f,w),k(u[f],w)),h)}class m{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=k(h,this.g),this.g}}e.Hasher=m;var E;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function p(u,h,w=32){const f=w-h,s=~((1<<f)-1);return(u<<h|(s&u)>>>f)>>>0}function I(u,h=0,w=u.byteLength,f=0){for(let s=0;s<w;s++)u[h+s]=f}function v(u,h,w="0"){for(;u.length<h;)u=w+u;return u}function S(u,h=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(w=>w.toString(16).padStart(2,"0")).join(""):v((u>>>0).toString(16),h/4)}e.toHexString=S;class y{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const w=h.length;if(w===0)return;const f=this.p;let s=this.r,i=this.u,n,t;for(i!==0?(n=i,t=-1,i=0):(n=h.charCodeAt(0),t=0);;){let r=n;if(O.isHighSurrogate(n))if(t+1<w){const o=h.charCodeAt(t+1);O.isLowSurrogate(o)?(t++,r=O.computeCodePoint(n,o)):r=65533}else{i=n;break}else O.isLowSurrogate(n)&&(r=65533);if(s=this.w(f,s,r),t++,t<w)n=h.charCodeAt(t);else break}this.r=s,this.u=i}w(h,w,f){return f<128?h[w++]=f:f<2048?(h[w++]=192|(f&1984)>>>6,h[w++]=128|(f&63)>>>0):f<65536?(h[w++]=224|(f&61440)>>>12,h[w++]=128|(f&4032)>>>6,h[w++]=128|(f&63)>>>0):(h[w++]=240|(f&1835008)>>>18,h[w++]=128|(f&258048)>>>12,h[w++]=128|(f&4032)>>>6,h[w++]=128|(f&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),S(this.h)+S(this.l)+S(this.m)+S(this.n)+S(this.o)}x(){this.p[this.r++]=128,I(this.p,this.r),this.r>56&&(this.y(),I(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=y.g,w=this.q;for(let a=0;a<64;a+=4)h.setUint32(a,w.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)h.setUint32(a,p(h.getUint32(a-12,!1)^h.getUint32(a-32,!1)^h.getUint32(a-56,!1)^h.getUint32(a-64,!1),1),!1);let f=this.h,s=this.l,i=this.m,n=this.n,t=this.o,r,o,c;for(let a=0;a<80;a++)a<20?(r=s&i|~s&n,o=1518500249):a<40?(r=s^i^n,o=1859775393):a<60?(r=s&i|s&n|i&n,o=2400959708):(r=s^i^n,o=3395469782),c=p(f,5)+r+t+o+h.getUint32(a*4,!1)&4294967295,t=n,n=i,i=p(s,30),s=f,f=c;this.h=this.h+f&4294967295,this.l=this.l+s&4294967295,this.m=this.m+i&4294967295,this.n=this.n+n&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=y,y.g=new DataView(new ArrayBuffer(320))}),define(Y[54],Z([0,1,27]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(D||(D={})),function(k){const T="error",L="warning",P="warn",g="info",l="ignore";function m(p){return p?O.equalsIgnoreCase(T,p)?k.Error:O.equalsIgnoreCase(L,p)||O.equalsIgnoreCase(P,p)?k.Warning:O.equalsIgnoreCase(g,p)?k.Info:k.Ignore:k.Ignore}k.fromValue=m;function E(p){switch(p){case k.Error:return T;case k.Warning:return L;case k.Info:return g;default:return l}}k.toString=E}(D||(D={})),e.default=D}),define(Y[76],Z([0,1,11]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function D(l){const m=l;return m&&typeof m.type=="string"&&typeof m.severity=="string"}e.isRemoteConsoleLog=D;function k(l){const m=[];let E;try{const p=JSON.parse(l.arguments),I=p[p.length-1];I&&I.__$stack&&(p.pop(),E=I.__$stack),m.push(...p)}catch{m.push("Unable to log remote console arguments",l.arguments)}return{args:m,stack:E}}e.parse=k;function T(l){if(typeof l!="string")return T(k(l).stack);const m=l;if(m){const E=L(m),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(p&&p.length===4)return{uri:O.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=T;function L(l){if(!l)return l;const m=l.indexOf(`
`);return m===-1?l:l.substring(0,m)}function P(l,m){const{args:E,stack:p}=k(l),I=typeof E[0]=="string"&&E.length===1;let v=L(p);v&&(v=`(${v.trim()})`);let S=[];if(typeof E[0]=="string"?v&&I?S=[`%c[${m}] %c${E[0]} %c${v}`,g("blue"),g(""),g("grey")]:S=[`%c[${m}] %c${E[0]}`,g("blue"),g(""),...E.slice(1)]:S=[`%c[${m}]%`,g("blue"),...E],v&&!I&&S.push(v),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,S)}e.log=P;function g(l){return`color: ${l}`}}),define(Y[44],Z([0,1,14,27,11]),function(W,e,O,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(l){return JSON.stringify(l,P)}e.stringify=T;function L(l){let m=JSON.parse(l);return m=g(m),m}e.parse=L;function P(l,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:(0,D.regExpFlags)(m)}:m}function g(l,m=0){if(!l||m>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return k.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 15:return new Date(l.source)}if(l instanceof O.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let E=0;E<l.length;++E)l[E]=g(l[E],m+1);else for(const E in l)Object.hasOwnProperty.call(l,E)&&(l[E]=g(l[E],m+1))}return l}e.revive=g}),define(Y[77],Z([0,1,38,15,20]),function(W,e,O,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,L=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var g;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(g||(g={}));let l;switch(process.arch){case"ia32":case"x32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class E{constructor(s,i,n){this.exePath=s,this.displayName=i,this.a=n}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:f=!1}={}){return f?l===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function I({useAlternateBitness:f=!1,findPreview:s=!1}={}){const i=p({useAlternateBitness:f});if(!i)return null;const n=D.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(n))return null;let t=-1,r=null;for(const a of await k.Promises.readdir(n)){let d=-1;if(s){const j=a.indexOf("-");if(j<0)continue;const x=a.substring(0,j);if(!T.test(x)||a.substring(j+1)!=="preview")continue;d=parseInt(x,10)}else{if(!T.test(a))continue;d=parseInt(a,10)}if(d<=t)continue;const R=D.join(n,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(R)||(r=R,t=d)}if(!r)return null;const o=i.includes("x86")?" (x86)":"",c=s?" Preview":"";return new E(r,`PowerShell${c}${o}`,!0)}async function v({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const s=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:i,pwshMsixName:n}=f?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(s))if(i.test(t)){const r=D.join(s,t,"pwsh.exe");return new E(r,n)}return null}function S(){const f=D.join(O.homedir(),".dotnet","tools","pwsh.exe");return new E(f,".NET Core PowerShell Global Tool")}function y(){const f=D.join(process.env.windir,l===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(f,"Windows PowerShell",!0)}async function*u(){let f=await I();f&&(yield f),f=await I({useAlternateBitness:!0}),f&&(yield f),f=await v(),f&&(yield f),f=S(),f&&(yield f),f=await I({findPreview:!0}),f&&(yield f),f=await v({findPreview:!0}),f&&(yield f),f=await I({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=y(),f&&(yield f)}async function*h(){for await(const f of u())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=h;async function w(){for await(const f of h())return f;return null}e.getFirstAvailablePowerShellInstallation=w}),define(Y[55],Z([0,1,15,12,33,51,8,20]),function(W,e,O,D,k,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function g(E=k.env){return E.comspec||"cmd.exe"}e.getWindowsShell=g;function l(E){let p=[],I=!1;const v=function(S){if(I){p.push(S);return}(!E.send(S,u=>{if(u&&console.error(u),I=!1,p.length>0){const h=p.slice(0);p=[],h.forEach(w=>v(w))}})||D.isWindows)&&(I=!0)};return{send:v}}e.createQueuedSender=l;var m;(function(E){async function p(I,v,S){if(O.isAbsolute(I))return I;if(v===void 0&&(v=k.cwd()),O.dirname(I)!=="."||(S===void 0&&L.isString(k.env.PATH)&&(S=k.env.PATH.split(O.delimiter)),S===void 0||S.length===0))return O.join(v,I);async function u(h){if(await P.Promises.exists(h)){let w;try{w=await P.Promises.stat(h)}catch(f){f.message.startsWith("EACCES")&&(w=await P.Promises.lstat(h))}return w?!w.isDirectory():!1}return!1}for(const h of S){let w;if(O.isAbsolute(h)?w=O.join(h,I):w=O.join(v,h,I),await u(w))return w;let f=w+".com";if(await u(f)||(f=w+".exe",await u(f)))return f}return O.join(v,I)}E.findExecutable=p})(m=e.win32||(e.win32={}))}),define(Y[78],Z([0,1,38,12,77,55]),function(W,e,O,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function L(I,v){return I===1?D.isWindows?E():T.getWindowsShell(v):l(I,v)}e.getSystemShell=L;function P(I,v){return I===1?D.isWindows?p(v):T.getWindowsShell(v):l(I,v)}e.getSystemShellSync=P;let g=null;function l(I,v){if(D.isLinux&&I===2||D.isMacintosh&&I===3)return"/bin/bash";if(!g){let S;if(D.isWindows)S="/bin/bash";else{if(S=v.SHELL,!S)try{S=(0,O.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}g=S}return g}let m=null;async function E(){return m||(m=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),m}function p(I){if(m)return m;const v=D.isWindows&&parseFloat((0,O.release)())>=10,S=I.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${I.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return v?y:T.getWindowsShell(I)}});var de=this&&this.__decorate||function(W,e,O,D){var k=arguments.length,T=k<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,O):D,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(W,e,O,D);else for(var P=W.length-1;P>=0;P--)(L=W[P])&&(T=(k<3?L(T):k>3?L(e,O,T):L(e,O))||T);return k>3&&T&&Object.defineProperty(e,O,T),T};define(Y[56],Z([0,1,19,4,14,22,49,10,3,2,44,27,8]),function(W,e,O,D,k,T,L,P,g,l,m,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var I;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(I||(I={}));function v(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(S||(S={}));function y(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(u||(u={}));class h{constructor(N){this.b=N,this.a=0}read(N){const U=this.b.slice(this.a,this.a+N);return this.a+=U.byteLength,U}}class w{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(N){this.a.push(N)}}var f;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(f||(f={}));function s(M){const N=k.VSBuffer.alloc(4);return N.writeUInt32BE(M,0),N}function i(M){return M.read(4).readUInt32BE(0)}function n(M){const N=k.VSBuffer.alloc(1);return N.writeUInt8(M,0),N}const t={Undefined:n(f.Undefined),String:n(f.String),Buffer:n(f.Buffer),VSBuffer:n(f.VSBuffer),Array:n(f.Array),Object:n(f.Object)},r=typeof Buffer<"u";function o(M,N){if(typeof N>"u")M.write(t.Undefined);else if(typeof N=="string"){const U=k.VSBuffer.fromString(N);M.write(t.String),M.write(s(U.byteLength)),M.write(U)}else if(r&&Buffer.isBuffer(N)){const U=k.VSBuffer.wrap(N);M.write(t.Buffer),M.write(s(U.byteLength)),M.write(U)}else if(N instanceof k.VSBuffer)M.write(t.VSBuffer),M.write(s(N.byteLength)),M.write(N);else if(Array.isArray(N)){M.write(t.Array),M.write(s(N.length));for(const U of N)o(M,U)}else{const U=k.VSBuffer.fromString(JSON.stringify(N));M.write(t.Object),M.write(s(U.byteLength)),M.write(U)}}function c(M){switch(M.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return M.read(i(M)).toString();case f.Buffer:return M.read(i(M)).buffer;case f.VSBuffer:return M.read(i(M));case f.Array:{const U=i(M),V=[];for(let G=0;G<U;G++)V.push(c(M));return V}case f.Object:return JSON.parse(M.read(i(M)).toString())}}class a{constructor(N,U,V=null,G=1e3){this.h=N,this.j=U,this.k=V,this.l=G,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(q=>this.p(q)),this.m({type:200})}registerChannel(N,U){this.b.set(N,U),setTimeout(()=>this.v(N),0)}m(N){switch(N.type){case 200:{const U=this.n([N.type]);this.k?.logOutgoing(U,0,1,y(N.type));return}case 201:case 202:case 204:case 203:{const U=this.n([N.type,N.id],N.data);this.k?.logOutgoing(U,N.id,1,y(N.type),N.data);return}}}n(N,U=void 0){const V=new w;return o(V,N),o(V,U),this.o(V.buffer)}o(N){try{return this.h.send(N),N.byteLength}catch{return 0}}p(N){const U=new h(N),V=c(U),G=c(U),q=V[0];switch(q){case 100:return this.k?.logIncoming(N.byteLength,V[1],1,`${v(q)}: ${V[2]}.${V[3]}`,G),this.q({type:q,id:V[1],channelName:V[2],name:V[3],arg:G});case 102:return this.k?.logIncoming(N.byteLength,V[1],1,`${v(q)}: ${V[2]}.${V[3]}`,G),this.s({type:q,id:V[1],channelName:V[2],name:V[3],arg:G});case 101:return this.k?.logIncoming(N.byteLength,V[1],1,`${v(q)}`),this.t({type:q,id:V[1]});case 103:return this.k?.logIncoming(N.byteLength,V[1],1,`${v(q)}`),this.t({type:q,id:V[1]})}}q(N){const U=this.b.get(N.channelName);if(!U){this.u(N);return}const V=new T.CancellationTokenSource;let G;try{G=U.call(this.j,N.name,N.arg,V.token)}catch(F){G=Promise.reject(F)}const q=N.id;G.then(F=>{this.m({id:q,data:F,type:201}),this.d.delete(N.id)},F=>{F instanceof Error?this.m({id:q,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:q,data:F,type:203}),this.d.delete(N.id)});const ne=(0,l.toDisposable)(()=>V.cancel());this.d.set(N.id,ne)}s(N){const U=this.b.get(N.channelName);if(!U){this.u(N);return}const V=N.id,q=U.listen(this.j,N.name,N.arg)(ne=>this.m({id:V,data:ne,type:204}));this.d.set(N.id,q)}t(N){const U=this.d.get(N.id);U&&(U.dispose(),this.d.delete(N.id))}u(N){let U=this.g.get(N.channelName);U||(U=[],this.g.set(N.channelName,U));const V=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.m({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);U.push({request:N,timeoutTimer:V})}v(N){const U=this.g.get(N);if(U){for(const V of U)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.q(V.request);break;case 102:this.s(V.request);break}this.g.delete(N)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=a;var d;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(N,U=null){this.l=N,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.r(V)),this.j=U}getChannel(N){const U=this;return{call(V,G,q){return U.a?Promise.reject(new P.CancellationError):U.m(N,V,G,q)},listen(V,G){return U.a?g.Event.None:U.n(N,V,G)}}}m(N,U,V,G=T.CancellationToken.None){const q=this.g++,F={id:q,type:100,channelName:N,name:U,arg:V};if(G.isCancellationRequested)return Promise.reject(new P.CancellationError);let b;return new Promise((C,B)=>{if(G.isCancellationRequested)return B(new P.CancellationError);const $=()=>{const ve=ae=>{switch(ae.type){case 201:this.f.delete(q),C(ae.data);break;case 202:{this.f.delete(q);const te=new Error(ae.data.message);te.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,te.name=ae.data.name,B(te);break}case 203:this.f.delete(q),B(ae.data);break}};this.f.set(q,ve),this.o(F)};let _=null;this.b===u.Idle?$():(_=(0,D.createCancelablePromise)(ve=>this.t()),_.then(()=>{_=null,$()}));const re=()=>{_?(_.cancel(),_=null):this.o({id:q,type:101}),B(new P.CancellationError)},ue=G.onCancellationRequested(re);b=(0,l.combinedDisposable)((0,l.toDisposable)(re),ue),this.d.add(b)}).finally(()=>{this.d.delete(b)})}n(N,U,V){const G=this.g++,ne={id:G,type:102,channelName:N,name:U,arg:V};let F=null;const b=new g.Emitter({onWillAddFirstListener:()=>{F=(0,D.createCancelablePromise)(C=>this.t()),F.then(()=>{F=null,this.d.add(b),this.o(ne)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(b),this.o({id:G,type:103}))}}),A=C=>b.fire(C.data);return this.f.set(G,A),b.event}o(N){switch(N.type){case 100:case 102:{const U=this.p([N.type,N.id,N.channelName,N.name],N.arg);this.j?.logOutgoing(U,N.id,0,`${v(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const U=this.p([N.type,N.id]);this.j?.logOutgoing(U,N.id,0,v(N.type));return}}}p(N,U=void 0){const V=new w;return o(V,N),o(V,U),this.q(V.buffer)}q(N){try{return this.l.send(N),N.byteLength}catch{return 0}}r(N){const U=new h(N),V=c(U),G=c(U),q=V[0];switch(q){case 200:return this.j?.logIncoming(N.byteLength,0,0,y(q)),this.s({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(N.byteLength,V[1],0,y(q),G),this.s({type:V[0],id:V[1],data:G})}}s(N){if(N.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(N.id)?.(N)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}t(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.dispose)(this.d.values()),this.d.clear()}}de([L.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class j{get connections(){const N=[];return this.f.forEach(U=>N.push(U)),N}constructor(N){this.a=new Map,this.f=new Set,this.g=new g.Emitter,this.onDidAddConnection=this.g.event,this.h=new g.Emitter,this.onDidRemoveConnection=this.h.event,N(({protocol:U,onDidClientDisconnect:V})=>{g.Event.once(U.onMessage)(q=>{const ne=new h(q),F=c(ne),b=new a(U,F),A=new R(U);this.a.forEach((B,$)=>b.registerChannel($,B));const C={channelServer:b,channelClient:A,ctx:F};this.f.add(C),this.g.fire(C),V(()=>{b.dispose(),A.dispose(),this.f.delete(C),this.h.fire(C)})})})}getChannel(N,U){const V=this;return{call(G,q,ne){let F;if((0,p.isFunction)(U)){const A=(0,O.getRandomElement)(V.connections.filter(U));F=A?Promise.resolve(A):g.Event.toPromise(g.Event.filter(V.onDidAddConnection,U))}else F=U.routeCall(V,G,q);const b=F.then(A=>A.channelClient.getChannel(N));return K(b).call(G,q,ne)},listen(G,q){if((0,p.isFunction)(U))return V.j(N,U,G,q);const ne=U.routeEvent(V,G,q).then(F=>F.channelClient.getChannel(N));return K(ne).listen(G,q)}}}j(N,U,V,G){const q=this;let ne=new l.DisposableStore;const F=new g.Emitter({onWillAddFirstListener:()=>{ne=new l.DisposableStore;const b=new g.EventMultiplexer,A=new Map,C=$=>{const re=$.channelClient.getChannel(N).listen(V,G),ue=b.add(re);A.set($,ue)},B=$=>{const _=A.get($);!_||(_.dispose(),A.delete($))};q.connections.filter(U).forEach(C),g.Event.filter(q.onDidAddConnection,U)(C,void 0,ne),q.onDidRemoveConnection(B,void 0,ne),b.event(F.fire,F,ne),ne.add(b)},onDidRemoveLastListener:()=>{ne.dispose()}});return F.event}registerChannel(N,U){this.a.set(N,U),this.f.forEach(V=>{V.channelServer.registerChannel(N,U)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=j;class x{constructor(N,U,V=null){const G=new w;o(G,U),N.send(G.buffer),this.a=new R(N,V),this.d=new a(N,U,V)}getChannel(N){return this.a.getChannel(N)}registerChannel(N,U){this.d.registerChannel(N,U)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=x;function K(M){return{call(N,U,V){return M.then(G=>G.call(N,U,V))},listen(N,U){const V=new g.Relay;return M.then(G=>V.input=G.listen(N,U)),V.event}}}e.getDelayedChannel=K;function J(M){let N=!1;return{call(U,V,G){return N?M.call(U,V,G):(0,D.timeout)(0).then(()=>N=!0).then(()=>M.call(U,V,G))},listen(U,V){if(N)return M.listen(U,V);const G=new g.Relay;return(0,D.timeout)(0).then(()=>N=!0).then(()=>G.input=M.listen(U,V)),G.event}}}e.getNextTickChannel=J;class ie{constructor(N){this.a=N}routeCall(N){return this.b(N)}routeEvent(N){return this.b(N)}async b(N){for(const U of N.connections)if(await Promise.resolve(this.a(U.ctx)))return Promise.resolve(U);return await g.Event.toPromise(N.onDidAddConnection),await this.b(N)}}e.StaticRouter=ie;var se;(function(M){function N(q,ne){const F=q,b=ne&&ne.disableMarshalling,A=new Map;for(const C in F)V(C)&&A.set(C,g.Event.buffer(F[C],!0));return new class{listen(C,B,$){const _=A.get(B);if(_)return _;if(G(B)){const re=F[B];if(typeof re=="function")return re.call(F,$)}throw new Error(`Event not found: ${B}`)}call(C,B,$){const _=F[B];if(typeof _=="function"){if(!b&&Array.isArray($))for(let re=0;re<$.length;re++)$[re]=(0,m.revive)($[re]);return _.apply(F,$)}throw new Error(`Method not found: ${B}`)}}}M.fromService=N;function U(q,ne){const F=ne&&ne.disableMarshalling;return new Proxy({},{get(b,A){if(typeof A=="string")return ne?.properties?.has(A)?ne.properties.get(A):G(A)?function(C){return q.listen(A,C)}:V(A)?q.listen(A):async function(...C){let B;ne&&!(0,p.isUndefinedOrNull)(ne.context)?B=[ne.context,...C]:B=C;const $=await q.call(A,B);return F?$:(0,m.revive)($)};throw new Error(`Property not found: ${String(A)}`)}})}M.toService=U;function V(q){return q[0]==="o"&&q[1]==="n"&&E.isUpperAsciiLetter(q.charCodeAt(2))}function G(q){return/^onDynamic/.test(q)&&E.isUpperAsciiLetter(q.charCodeAt(9))}})(se=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const N=M.toString();if(N!=="[object Object]")return N}return M}function ce(M){return Array.isArray(M)?M.map(ge):ge(M)}function oe(M,N,U,V,G,q,ne){ne=ce(ne);const F=Q[G],b=F[V%F.length];let A=[`%c[${M}]%c[${String(N).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${b}`];/\($/.test(q)?(A=A.concat(ne),A.push(")")):A.push(ne),console.log.apply(console,A)}class me{constructor(N,U){this.d=N,this.f=U,this.a=0,this.b=0}logOutgoing(N,U,V,G,q){this.b+=N,oe(this.d,this.b,N,U,V,G,q)}logIncoming(N,U,V,G,q){this.a+=N,oe(this.f,this.a,N,U,V,G,q)}}e.IPCLogger=me}),define(Y[79],Z([0,1,57,4,14,22,76,10,3,2,26,55,51,56]),function(W,e,O,D,k,T,L,P,g,l,m,E,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class v extends I.ChannelServer{constructor(u){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",h=>k.VSBuffer.wrap(Buffer.from(h,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=v;class S{constructor(u,h){this.i=u,this.j=h,this.c=new Set,this.g=new Map,this.h=new g.Emitter,this.onDidProcessExit=this.h.event;const w=h&&h.timeout?h.timeout:6e4;this.b=new D.Delayer(w),this.d=null,this.f=null}getChannel(u){const h=this;return{call(w,f,s){return h.k(u,w,f,s)},listen(w,f){return h.l(u,w,f)}}}k(u,h,w,f=T.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const s=this.n(u),i=(0,D.createCancelablePromise)(r=>s.call(h,w,r)),n=f.onCancellationRequested(()=>i.cancel()),t=(0,l.toDisposable)(()=>i.cancel());return this.c.add(t),i.finally(()=>{n.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(u,h,w){if(!this.b)return g.Event.None;this.b.cancel();let f;const s=new g.Emitter({onWillAddFirstListener:()=>{f=this.n(u).listen(h,w)(s.fire,s),this.c.add(f)},onDidRemoveLastListener:()=>{this.c.delete(f),f.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,p.removeDangerousEnvVariables)(h.env),this.d=(0,O.fork)(this.i,u,h);const w=new g.Emitter;g.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,L.isRemoteConsoleLog)(o)){(0,L.log)(o,`IPC Library: ${this.j.serverName}`);return}w.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.j.useQueue?(0,E.createQueuedSender)(this.d):this.d,i=o=>this.d&&this.d.connected&&s.send(o.buffer.toString("base64")),n=w.event,t={send:i,onMessage:n};this.f=new I.ChannelClient(t);const r=()=>this.o();process.once("exit",r),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,c)=>{process.removeListener("exit",r),this.c.forEach(a=>(0,l.dispose)(a)),this.c.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:c})})}return this.f}n(u){let h=this.g.get(u);return h||(h=this.m.getChannel(u),this.g.set(u,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=S}),define(Y[80],Z([0,1,4,3,2,8]),function(W,e,O,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var L;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=e.StorageHint||(e.StorageHint={}));function P(E){const p=E;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var g;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class l extends k.Disposable{constructor(p,I=Object.create(null)){super(),this.m=p,this.n=I,this.b=this.B(new D.Emitter),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=new O.ThrottledDelayer(l.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(p=>this.r(p)))}r(p){p.changed?.forEach((I,v)=>this.s(v,I)),p.deleted?.forEach(I=>this.s(I,void 0))}s(p,I){if(this.c===g.Closed)return;let v=!1;(0,T.isUndefinedOrNull)(I)?v=this.f.delete(p):this.f.get(p)!==I&&(this.f.set(p,I),v=!0),v&&this.b.fire(p)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.n.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(p,I){const v=this.f.get(p);return(0,T.isUndefinedOrNull)(v)?I:v}getBoolean(p,I){const v=this.get(p);return(0,T.isUndefinedOrNull)(v)?I:v==="true"}getNumber(p,I){const v=this.get(p);return(0,T.isUndefinedOrNull)(v)?I:parseInt(v,10)}async set(p,I){if(this.c===g.Closed)return;if((0,T.isUndefinedOrNull)(I))return this.delete(p);const v=String(I);if(this.f.get(p)!==v)return this.f.set(p,v),this.j.set(p,v),this.h.delete(p),this.b.fire(p),this.w()}async delete(p){if(!(this.c===g.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire(p),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=g.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(p).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(p){if(!!this.u)return this.w(p)}async w(p){return this.g.trigger(()=>this.v(),p)}async whenFlushed(){if(!!this.u)return new Promise(p=>this.l.push(p))}dispose(){this.g.dispose(),super.dispose()}}e.Storage=l,l.a=100;class m{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((I,v)=>this.a.set(v,I)),p.delete?.forEach(I=>this.a.delete(I))}async close(){}}e.InMemoryStorageDatabase=m}),define(Y[81],Z([5,6]),function(W,e){return W.create("vs/base/node/zip",e)}),define(Y[82],Z([5,6]),function(W,e){return W.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Y[83],Z([5,6]),function(W,e){return W.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Y[84],Z([5,6]),function(W,e){return W.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Y[85],Z([5,6]),function(W,e){return W.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Y[86],Z([5,6]),function(W,e){return W.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Y[87],Z([5,6]),function(W,e){return W.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Y[88],Z([5,6]),function(W,e){return W.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Y[89],Z([5,6]),function(W,e){return W.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Y[90],Z([5,6]),function(W,e){return W.create("vs/platform/extensions/common/extensionValidator",e)}),define(Y[91],Z([5,6]),function(W,e){return W.create("vs/platform/files/common/fileService",e)}),define(Y[92],Z([5,6]),function(W,e){return W.create("vs/platform/files/common/io",e)}),define(Y[93],Z([5,6]),function(W,e){return W.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Y[94],Z([5,6]),function(W,e){return W.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Y[95],Z([5,6]),function(W,e){return W.create("vs/platform/request/common/request",e)}),define(Y[96],Z([5,6]),function(W,e){return W.create("vs/platform/shell/node/shellEnv",e)}),define(Y[97],Z([5,6]),function(W,e){return W.create("vs/platform/telemetry/common/telemetryService",e)}),define(Y[98],Z([5,6]),function(W,e){return W.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Y[99],Z([5,6]),function(W,e){return W.create("vs/platform/workspace/common/workspace",e)}),define(Y[100],Z([0,1,72,49,16,15,33,17,11]),function(W,e,O,D,k,T,L,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,T.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,T.join)(this.logsPath,"editSessions.log"))}get remoteTunnelLogResource(){return g.URI.file((0,T.join)(this.logsPath,"remoteTunnel.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(g.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=L.env.VSCODE_PORTABLE;return S?g.URI.file((0,T.join)(S,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,T.resolve)(S):(0,T.normalize)((0,T.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const S=this.args["extensions-download-dir"];return S?g.URI.file((0,T.resolve)(S)):g.URI.file((0,T.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,T.resolve)(S);const y=L.env.VSCODE_EXTENSIONS;if(y)return y;const u=L.env.VSCODE_PORTABLE;return u?(0,T.join)(u,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(y=>/^[^:/?#]+?:\/\//.test(y)?g.URI.parse(y):g.URI.file((0,T.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?g.URI.parse(S):g.URI.file((0,T.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(S=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(S))}get extensionLogLevel(){const S=[];for(const y of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);u&&u[1]&&u[2]&&S.push([u[1],u[2]])}return S.length?S:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=L.env.VSCODE_PORTABLE;return S?g.URI.file((0,T.join)(S,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(S){this.args.continueOn=S}get args(){return this.a}constructor(S,y,u){this.a=S,this.b=y,this.c=u,this.editSessionId=this.args.editSessionId}}de([D.memoize],l.prototype,"appRoot",null),de([D.memoize],l.prototype,"userHome",null),de([D.memoize],l.prototype,"userDataPath",null),de([D.memoize],l.prototype,"appSettingsHome",null),de([D.memoize],l.prototype,"tmpDir",null),de([D.memoize],l.prototype,"cacheHome",null),de([D.memoize],l.prototype,"stateResource",null),de([D.memoize],l.prototype,"userRoamingDataHome",null),de([D.memoize],l.prototype,"userDataSyncHome",null),de([D.memoize],l.prototype,"userDataSyncLogResource",null),de([D.memoize],l.prototype,"editSessionsLogResource",null),de([D.memoize],l.prototype,"remoteTunnelLogResource",null),de([D.memoize],l.prototype,"sync",null),de([D.memoize],l.prototype,"machineSettingsResource",null),de([D.memoize],l.prototype,"workspaceStorageHome",null),de([D.memoize],l.prototype,"localHistoryHome",null),de([D.memoize],l.prototype,"keyboardLayoutResource",null),de([D.memoize],l.prototype,"argvResource",null),de([D.memoize],l.prototype,"isExtensionDevelopment",null),de([D.memoize],l.prototype,"untitledWorkspacesHome",null),de([D.memoize],l.prototype,"installSourcePath",null),de([D.memoize],l.prototype,"builtinExtensionsPath",null),de([D.memoize],l.prototype,"extensionsPath",null),de([D.memoize],l.prototype,"extensionDevelopmentLocationURI",null),de([D.memoize],l.prototype,"extensionDevelopmentKind",null),de([D.memoize],l.prototype,"extensionTestsLocationURI",null),de([D.memoize],l.prototype,"debugExtensionHost",null),de([D.memoize],l.prototype,"logLevel",null),de([D.memoize],l.prototype,"extensionLogLevel",null),de([D.memoize],l.prototype,"serviceMachineIdResource",null),de([D.memoize],l.prototype,"telemetryLogResource",null),de([D.memoize],l.prototype,"disableWorkspaceTrust",null),de([D.memoize],l.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=l;function m(v,S){return I(v["inspect-extensions"],v["inspect-brk-extensions"],5870,S,v.debugId,v.extensionEnvironment)}e.parseExtensionHostPort=m;function E(v,S){return I(v["inspect-search"],v["inspect-brk-search"],5876,S,v.extensionEnvironment)}e.parseSearchPort=E;function p(v,S){return I(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,S,v.extensionEnvironment)}e.parsePtyHostPort=p;function I(v,S,y,u,h,w){const s=Number(S||v)||(u?null:y),i=s?Boolean(!!S):!1;let n;if(w)try{n=JSON.parse(w)}catch{}return{port:s,break:i,debugId:h,env:n}}}),function(){"use strict";function W(e,O,D){function k(L,P){const g=T(L,P),l=[g];return e.isAbsolute(g)||l.unshift(D),e.resolve(...l)}function T(L,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,P);const m=L["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(E,"AppData","Roaming")}break;case"darwin":l=e.join(O.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,P)}return{getUserDataPath:k}}if(typeof define=="function")define(Y[101],Z([152,38,33]),function(e,O,D){return W(e,O,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=W(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[102],Z([0,1,38,100,101]),function(W,e,O,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends D.AbstractNativeEnvironmentService{constructor(P,g){super(P,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,k.getUserDataPath)(P,g.nameShort)},g)}}e.NativeEnvironmentService=T}),define(Y[103],Z([0,1,8,86]),function(W,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(L,P,g){try{T(L,P,g)}catch(l){console.error(l?.message??l)}return L}e.localizeManifest=k;function T(L,P,g){const l=(m,E,p)=>{const I=m[E];if((0,O.isString)(I)){const v=I,S=v.length;if(S>1&&v[0]==="%"&&v[S-1]==="%"){const y=v.substr(1,S-2);let u=P[y];u===void 0&&g&&(u=g[y]);const h=typeof u=="string"?u:u?.message,w=g?.[y],f=typeof w=="string"?w:w?.message;if(!h){f||console.warn(`[${L.name}]: ${(0,D.localize)(0,null,y)}`);return}if(p&&(E==="title"||E==="category")&&f&&f!==h){const s={value:h,original:f};m[E]=s}else m[E]=h}}else if((0,O.isObject)(I))for(const v in I)I.hasOwnProperty(v)&&(v==="commands"?l(I,v,!0):l(I,v,p));else if(Array.isArray(I))for(let v=0;v<I.length;v++)l(I,v,p)};for(const m in L)L.hasOwnProperty(m)&&l(L,m)}}),define(Y[104],Z([0,1,10]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class D{constructor(){this.a=new Map}register(T,L){this.a.set(T,L)}updateManifest(T){if(!(!Array.isArray(T.activationEvents)||!T.contributes)&&!(typeof T.main>"u"&&typeof T.browser>"u"))for(const L in T.contributes){const P=this.a.get(L);if(!P)continue;const g=T.contributes[L],l=Array.isArray(g)?g:[g];try{P(l,T.activationEvents)}catch(m){(0,O.onUnexpectedError)(m)}}}}e.ImplicitActivationEventsImpl=D,e.ImplicitActivationEvents=new D}),define(Y[45],Z([0,1,17,54,90,39]),function(W,e,O,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function g(u){return u=u.trim(),u==="*"||L.test(u)}e.isValidVersionStr=g;function l(u){if(!g(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=u.match(L);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=l;function m(u){if(!u)return null;const h=u.majorBase,w=u.majorMustEqual,f=u.minorBase;let s=u.minorMustEqual;const i=u.patchBase;let n=u.patchMustEqual;u.hasCaret&&(h===0||(s=!1),n=!1);let t=0;if(u.preRelease){const r=P.exec(u.preRelease);if(r){const[,o,c,a]=r;t=Date.UTC(Number(o),Number(c)-1,Number(a))}}return{majorBase:h,majorMustEqual:w,minorBase:f,minorMustEqual:s,patchBase:i,patchMustEqual:n,isMinimum:u.hasGreaterEquals,notBefore:t}}e.normalizeVersion=m;function E(u,h,w){let f;typeof u=="string"?f=m(l(u)):f=u;let s;h instanceof Date?s=h.getTime():typeof h=="string"&&(s=new Date(h).getTime());let i;if(typeof w=="string"?i=m(l(w)):i=w,!f||!i)return!1;const n=f.majorBase,t=f.minorBase,r=f.patchBase;let o=i.majorBase,c=i.minorBase,a=i.patchBase;const d=i.notBefore;let R=i.majorMustEqual,j=i.minorMustEqual,x=i.patchMustEqual;return i.isMinimum?n>o?!0:n<o?!1:t>c?!0:t<c||s&&s<d?!1:r>=a:(n===1&&o===0&&(!R||!j||!x)&&(o=1,c=0,a=0,R=!0,j=!1,x=!1),n<o?!1:n>o?!R:t<c?!1:t>c?!j:r<a?!1:r>a?!x:!(s&&s<d))}e.isValidVersion=E;function p(u,h,w,f,s){const i=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return i.push([D.default.Error,k.localize(0,null)]),i;if(typeof f.name!="string")return i.push([D.default.Error,k.localize(1,null,"name")]),i;if(typeof f.version!="string")return i.push([D.default.Error,k.localize(2,null,"version")]),i;if(!f.engines)return i.push([D.default.Error,k.localize(3,null,"engines")]),i;if(typeof f.engines.vscode!="string")return i.push([D.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof f.extensionDependencies<"u"&&!y(f.extensionDependencies))return i.push([D.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof f.activationEvents<"u"){if(!y(f.activationEvents))return i.push([D.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof f.main>"u"&&typeof f.browser>"u")return i.push([D.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&i.push([D.default.Warning,k.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return i.push([D.default.Error,k.localize(9,null,"main")]),i;{const r=(0,O.joinPath)(w,f.main);(0,O.isEqualOrParent)(r,w)||i.push([D.default.Warning,k.localize(10,null,r.path,w.path)])}if(typeof f.activationEvents>"u")return i.push([D.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof f.browser<"u"){if(typeof f.browser!="string")return i.push([D.default.Error,k.localize(12,null,"browser")]),i;{const r=(0,O.joinPath)(w,f.browser);(0,O.isEqualOrParent)(r,w)||i.push([D.default.Warning,k.localize(13,null,r.path,w.path)])}if(typeof f.activationEvents>"u")return i.push([D.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!T.valid(f.version))return i.push([D.default.Error,k.localize(15,null)]),i;const n=[];if(!I(u,h,f,s,n))for(const r of n)i.push([D.default.Error,r]);return i}e.validateExtensionManifest=p;function I(u,h,w,f,s){return f||typeof w.main>"u"&&typeof w.browser>"u"?!0:S(u,h,w.engines.vscode,s)}e.isValidExtensionVersion=I;function v(u,h,w){return u==="*"||S(h,w,u)}e.isEngineValid=v;function S(u,h,w,f=[]){const s=m(l(w));if(!s)return f.push(k.localize(16,null,w)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return f.push(k.localize(17,null,w)),!1}else if(!s.majorMustEqual)return f.push(k.localize(18,null,w)),!1;return E(u,h,s)?!0:(f.push(k.localize(19,null,u,w)),!1)}function y(u){if(!Array.isArray(u))return!1;for(let h=0,w=u.length;h<w;h++)if(typeof u[h]!="string")return!1;return!0}}),define(Y[105],Z([0,1,14,31]),function(W,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(T,L,P){let g=P&&P.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const m=(await L.readFile(T.serviceMachineIdResource)).value.toString();g=(0,D.isUUID)(m)?m:null}catch{g=null}if(!g){g=(0,D.generateUuid)();try{await L.writeFile(T.serviceMachineIdResource,O.VSBuffer.fromString(g))}catch{}}return P?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=k}),define(Y[46],Z([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class O{constructor(k,T=[],L=!1){this.ctor=k,this.staticArguments=T,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=O}),define(Y[106],Z([0,1,46]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const D=[];var k;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function T(P,g,l){g instanceof O.SyncDescriptor||(g=new O.SyncDescriptor(g,[],Boolean(l))),D.push([P,g])}e.registerSingleton=T;function L(){return D}e.getSingletonServiceDescriptors=L}),define(Y[107],Z([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class O{constructor(T,L){this.key=T,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=O;class D{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const L of this.a.values())L.outgoing.size===0&&T.push(L);return T}insertEdge(T,L){const P=this.lookupOrInsertNode(T),g=this.lookupOrInsertNode(L);P.outgoing.set(g.key,g),g.incoming.set(P.key,P)}removeNode(T){const L=this.b(T);this.a.delete(L);for(const P of this.a.values())P.outgoing.delete(L),P.incoming.delete(L)}lookupOrInsertNode(T){const L=this.b(T);let P=this.a.get(L);return P||(P=new O(L,T),this.a.set(L,P)),P}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[L,P]of this.a)T.push(`${L}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,L]of this.a){const P=new Set([T]),g=this.c(L,P);if(g)return g}}c(T,L){for(const[P,g]of T.outgoing){if(L.has(P))return[...L,P].join(" -> ");L.add(P);const l=this.c(g,L);if(l)return l;L.delete(P)}}}e.Graph=D}),define(Y[21],Z([0,1,8,11,7]),function(W,e,O,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function T(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof D.URI)}e.isConfigurationOverrides=T;function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof D.URI)}e.isConfigurationUpdateOverrides=L;var P;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function l(u,h){const w=Object.create(null);for(const f in u)m(w,f,u[f],h);return w}e.toValuesTree=l;function m(u,h,w,f){const s=h.split("."),i=s.pop();let n=u;for(let t=0;t<s.length;t++){const r=s[t];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${h} as ${s.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[i]=w}catch{f(`Ignoring ${h} as ${s.join(".")} is ${JSON.stringify(n)}`)}else f(`Ignoring ${h} as ${s.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=m;function E(u,h){const w=h.split(".");p(u,w)}e.removeFromValueTree=E;function p(u,h){const w=h.shift();if(h.length===0){delete u[w];return}if(Object.keys(u).indexOf(w)!==-1){const f=u[w];typeof f=="object"&&!Array.isArray(f)&&(p(f,h),Object.keys(f).length===0&&delete u[w])}}function I(u,h,w){function f(n,t){let r=n;for(const o of t){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=h.split("."),i=f(u,s);return typeof i>"u"?w:i}e.getConfigurationValue=I;function v(u,h,w){Object.keys(h).forEach(f=>{f!=="__proto__"&&(f in u?O.isObject(u[f])&&O.isObject(h[f])?v(u[f],h[f],w):w&&(u[f]=h[f]):u[f]=h[f])})}e.merge=v;function S(u,h,w){const f=u.inspect(h),s=u.inspect(w);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:f.defaultValue}e.getMigratedSettingValue=S;function y(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(Y[58],Z([0,1,7]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,O.createDecorator)("downloadService")}),define(Y[18],Z([0,1,7]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,O.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,O.refineServiceDecorator)(e.IEnvironmentService)}),define(Y[23],Z([0,1,84,7]),function(W,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY="DEFAULT_PROFILE_EXTENSIONS_MIGRATION";function k(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function T(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function L(u,h){switch(u){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=L;function P(u,h){return h==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function g(u,h,w){return P(h,w)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===w?!0:l(w).includes(u)}e.isTargetPlatformCompatible=g;function l(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=l;function m(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=m;var E;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var p;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var I;(function(u){u.Install="install",u.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var v;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var S;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(h,w){super(h),this.code=w,this.name=w}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,O.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,O.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Y[59],Z([0,1,7]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,O.createDecorator)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((T,L)=>W(["node-vsce-sign"],async P=>T(P),L))),this.a}async verify(T,L){let P;try{P=await this.b()}catch{return!1}return P.verify(T,L)}}e.ExtensionSignatureVerificationService=D}),define(Y[60],Z([0,1,14,10,92,13]),function(W,e,O,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function L(m,E,p,I,v,S){let y;try{await P(m,E,p,I,v,S)}catch(u){y=u}finally{y&&v.errorTransformer&&(y=v.errorTransformer(y)),typeof y<"u"&&p.error(y),p.end()}}e.readFileIntoStream=L;async function P(m,E,p,I,v,S){g(S);const y=await m.open(E,{create:!1});try{g(S);let u=0,h=0,w=v&&typeof v.length=="number"?v.length:void 0,f=O.VSBuffer.alloc(Math.min(v.bufferSize,typeof w=="number"?w:v.bufferSize)),s=v&&typeof v.position=="number"?v.position:0,i=0;do h=await m.read(y,s,f.buffer,i,f.byteLength-i),s+=h,i+=h,u+=h,typeof w=="number"&&(w-=h),i===f.byteLength&&(await p.write(I(f)),f=O.VSBuffer.alloc(Math.min(v.bufferSize,typeof w=="number"?w:v.bufferSize)),i=0);while(h>0&&(typeof w!="number"||w>0)&&g(S)&&l(u,v));if(i>0){let n=i;typeof w=="number"&&(n=Math.min(i,w)),p.write(I(f.slice(0,n)))}}catch(u){throw(0,T.ensureFileSystemProviderError)(u)}finally{await m.close(y)}}function g(m){if(m.isCancellationRequested)throw(0,D.canceled)();return!0}function l(m,E){if(E?.limits){if(typeof E.limits.memory=="number"&&m>E.limits.memory)throw(0,T.createFileSystemProviderError)((0,k.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&m>E.limits.size)throw(0,T.createFileSystemProviderError)((0,k.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[108],Z([0,1,3,153,2,12,154]),function(W,e,O,D,k,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new O.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new O.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=O.Event.None,this.c=new Map,this.f=!1}async watch(l){const m=this.i(l),E=m.filter(I=>{const v=this.c.get(I.path);return v?!(0,D.patternsEquals)(v.request.excludes,I.excludes)||!(0,D.patternsEquals)(v.request.includes,I.includes):!0}),p=Array.from(this.c.values()).filter(({request:I})=>!m.find(v=>v.path===I.path&&(0,D.patternsEquals)(v.excludes,I.excludes)&&(0,D.patternsEquals)(v.includes,I.includes))).map(({request:I})=>I.path);E.length&&this.j(`Request to start watching: ${E.map(I=>`${I.path} (excludes: ${I.excludes.length>0?I.excludes:"<none>"}, includes: ${I.includes&&I.includes.length>0?JSON.stringify(I.includes):"<all>"})`).join(",")}`),p.length&&this.j(`Request to stop watching: ${p.join(",")}`);for(const I of p)this.h(I);for(const I of E)this.g(I)}g(l){const m=new L.NodeJSFileWatcherLibrary(l,p=>this.a.fire(p),p=>this.b.fire(p),this.f),E={request:l,instance:m};this.c.set(l.path,E)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const m=this.c.get(l);m&&(this.c.delete(l),m.instance.dispose())}i(l){const m=new Map;for(const E of l){const p=T.isLinux?E.path:E.path.toLowerCase();m.set(p,E)}return Array.from(m.values())}async setVerboseLogging(l){this.f=l;for(const[,m]of this.c)m.instance.setVerboseLogging(l)}j(l){this.f&&this.b.fire({type:"trace",message:this.k(l)})}k(l,m){return m?`[File Watcher (node.js)] ${l} (path: ${m.request.path})`:`[File Watcher (node.js)] ${l}`}}e.NodeJSWatcher=P}),define(Y[109],Z([0,1,61,108]),function(W,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends O.AbstractNonRecursiveWatcherClient{constructor(L,P,g){super(L,P,g),this.m()}l(){return new D.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(Y[110],Z([0,1,16,56,79,61]),function(W,e,O,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends T.AbstractUniversalWatcherClient{constructor(g,l,m){super(g,l,m),this.m()}l(g){const l=g.add(new k.Client(O.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(l.onDidProcessExit(({code:m,signal:E})=>this.n(`terminated by itself with code ${m}, signal: ${E}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(Y[62],Z([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class O{constructor(...k){this.a=new Map;for(const[T,L]of k)this.set(T,L)}set(k,T){const L=this.a.get(k);return this.a.set(k,T),L}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=O}),define(Y[111],Z([0,1,4,10,2,46,107,7,62,155]),function(W,e,O,D,k,T,L,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const m=!1;class E extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class p{constructor(y=new g.ServiceCollection,u=!1,h,w=m){this.f=y,this.g=u,this.h=h,this.i=w,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=w?h?._globalGraph??new L.Graph(f=>f):void 0}createChild(y){return new p(y,this.g,this,this.i)}invokeFunction(y,...u){const h=v.traceInvocation(this.i,y);let w=!1;try{return y({get:s=>{if(w)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(s,h);if(!i)throw new Error(`[invokeFunction] unknown service '${s}'`);return i}},...u)}finally{w=!0,h.stop()}}createInstance(y,...u){let h,w;return y instanceof T.SyncDescriptor?(h=v.traceCreation(this.i,y.ctor),w=this.j(y.ctor,y.staticArguments.concat(u),h)):(h=v.traceCreation(this.i,y),w=this.j(y,u,h)),h.stop(),w}j(y,u=[],h){const w=P._util.getServiceDependencies(y).sort((i,n)=>i.index-n.index),f=[];for(const i of w){const n=this.m(i.id,h);n||this.u(`[createInstance] ${y.name} depends on UNKNOWN service ${i.id}.`,!1),f.push(n)}const s=w.length>0?w[0].index:u.length;if(u.length!==s){console.trace(`[createInstance] First service dependency of ${y.name} at position ${s+1} conflicts with ${u.length} static arguments`);const i=s-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,s)}return Reflect.construct(y,u.concat(f))}k(y,u){if(this.f.get(y)instanceof T.SyncDescriptor)this.f.set(y,u);else if(this.h)this.h.k(y,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(y){const u=this.f.get(y);return!u&&this.h?this.h.l(y):u}m(y,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(y));const h=this.l(y);return h instanceof T.SyncDescriptor?this.q(y,h,u.branch(y,!0)):(u.branch(y,!1),h)}q(y,u,h){if(this.o.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this.o.add(y);try{return this.r(y,u,h)}finally{this.o.delete(y)}}r(y,u,h){const w=new L.Graph(i=>i.id.toString());let f=0;const s=[{id:y,desc:u,_trace:h}];for(;s.length;){const i=s.pop();if(w.lookupOrInsertNode(i),f++>1e3)throw new E(w);for(const n of P._util.getServiceDependencies(i.desc.ctor)){const t=this.l(n.id);if(t||this.u(`[createInstance] ${y} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),t instanceof T.SyncDescriptor){const r={id:n.id,desc:t,_trace:i._trace.branch(n.id,!0)};w.insertEdge(i,r),s.push(r)}}}for(;;){const i=w.roots();if(i.length===0){if(!w.isEmpty())throw new E(w);break}for(const{data:n}of i){if(this.l(n.id)instanceof T.SyncDescriptor){const r=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,r)}w.removeNode(n)}}return this.l(y)}s(y,u,h=[],w,f){if(this.f.get(y)instanceof T.SyncDescriptor)return this.t(y,u,h,w,f);if(this.h)return this.h.s(y,u,h,w,f);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(y,u,h=[],w,f){if(w){const s=new p(void 0,this.g,this,this.i);s.c=String(y);const i=new Map,n=new O.IdleValue(()=>{const t=s.j(u,h,f);for(const[r,o]of i){const c=t[r];if(typeof c=="function")for(const a of o)c.apply(t,a)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,r){if(!n.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let a=i.get(r);return a||(a=new l.LinkedList,i.set(r,a)),(R,j,x)=>{const K=a.push([R,j,x]);return(0,k.toDisposable)(K)}}if(r in t)return t[r];const o=n.value;let c=o[r];return typeof c!="function"||(c=c.bind(o),t[r]=c),c},set(t,r,o){return n.value[r]=o,!0}})}else return this.j(u,h,f)}u(y,u){if(u&&console.warn(y),this.g)throw new Error(y)}}e.InstantiationService=p;var I;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(I||(I={}));class v{static traceInvocation(y,u){return y?new v(1,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(y,u){return y?new v(0,u.name):v.c}constructor(y,u){this.type=y,this.name=u,this.g=Date.now(),this.h=[]}branch(y,u){const h=new v(2,y.toString());return this.h.push([y,u,h]),h}stop(){const y=Date.now()-this.g;v.f+=y;let u=!1;function h(f,s){const i=[],n=new Array(f+1).join("	");for(const[t,r,o]of s.h)if(r&&o){u=!0,i.push(`${n}CREATES -> ${t}`);const c=h(f+1,o);c&&i.push(c)}else i.push(`${n}uses -> ${t}`);return i.join(`
`)}const w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(y>2||u)&&v.all.add(w.join(`
`))}}e.Trace=v,v.all=new Set,v.c=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v.f=0});var ee=this&&this.__param||function(W,e){return function(O,D){e(O,D,W)}};define(Y[63],Z([0,1,22,2,12,94,23,7]),function(W,e,O,D,k,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let g=class extends D.Disposable{constructor(m){super(),this.c=m}async getAvailableLanguages(){const m=new O.CancellationTokenSource;setTimeout(()=>m.cancel(),1e3);let E;try{E=await this.c.query({text:'category:"language packs"',pageSize:20},m.token)}catch{return[]}const I=E.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some(S=>S.startsWith("lp-"))).map(v=>{const S=v.properties.localizedLanguages?.[0],y=this.getLocale(v);return{...this.f(y,S,v),extensionId:v.identifier.id,galleryExtension:v}});return I.push({...this.f("en","English"),extensionId:"default"}),I}getLocale(m){return m.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}f(m,E,p){const I=E??m;let v;if(I!==m&&(v=`(${m})`),m.toLowerCase()===k.language.toLowerCase()&&(v??="",v+=(0,T.localize)(0,null)),p?.installCount){v??="";const S=p.installCount;let y;S>1e6?y=`${Math.floor(S/1e5)/10}M`:S>1e3?y=`${Math.floor(S/1e3)}K`:y=String(S),v+=` $(cloud-download) ${y}`}return{id:m,label:I,description:v}}};g=de([ee(0,L.IExtensionGalleryService)],g),e.LanguagePackBaseService=g}),define(Y[9],Z([0,1,32,3,2,34,12,11,7]),function(W,e,O,D,k,T,L,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function l(){return new Date().toISOString()}var m;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;function E(c,a,d){switch(a){case m.Trace:c.trace(d);break;case m.Debug:c.debug(d);break;case m.Info:c.info(d);break;case m.Warning:c.warn(d);break;case m.Error:c.error(d);break;default:throw new Error("Invalid log level")}}e.log=E;function p(c){let a="";for(let d=0;d<c.length;d++){let R=c[d];if(typeof R=="object")try{R=JSON.stringify(R)}catch{}a+=(d>0?" ":"")+R}return a}e.format=p;class I extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new D.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}}e.AbstractLogger=I;class v extends I{constructor(a){super(),this.g=a}h(a){return this.g||this.getLevel()<=a}trace(a,...d){this.h(m.Trace)&&this.f(m.Trace,p([a,...d]))}debug(a,...d){this.h(m.Debug)&&this.f(m.Debug,p([a,...d]))}info(a,...d){this.h(m.Info)&&this.f(m.Info,p([a,...d]))}warn(a,...d){this.h(m.Warning)&&this.f(m.Warning,p([a,...d]))}error(a,...d){if(this.h(m.Error))if(a instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=a.stack,this.f(m.Error,p(R))}else this.f(m.Error,p([a,...d]))}flush(){}}e.AbstractMessageLogger=v;class S extends I{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.f=!L.isWindows}trace(a,...d){this.getLevel()<=m.Trace&&(this.f?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,a,...d):console.log(`[main ${l()}]`,a,...d))}debug(a,...d){this.getLevel()<=m.Debug&&(this.f?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,a,...d):console.log(`[main ${l()}]`,a,...d))}info(a,...d){this.getLevel()<=m.Info&&(this.f?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,a,...d):console.log(`[main ${l()}]`,a,...d))}warn(a,...d){this.getLevel()<=m.Warning&&(this.f?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,a,...d):console.warn(`[main ${l()}]`,a,...d))}error(a,...d){this.getLevel()<=m.Error&&(this.f?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,a,...d):console.error(`[main ${l()}]`,a,...d))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class y extends I{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...d){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",a,...d)}debug(a,...d){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...d)}info(a,...d){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",a,...d)}warn(a,...d){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",a,...d)}error(a,...d){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",a,...d)}dispose(){}flush(){}}e.ConsoleLogger=y;class u extends I{constructor(a,d=e.DEFAULT_LOG_LEVEL){super(),this.f=a,this.setLevel(d)}trace(a,...d){this.getLevel()<=m.Trace&&this.f.log(m.Trace,[this.g(a),...d])}debug(a,...d){this.getLevel()<=m.Debug&&this.f.log(m.Debug,[this.g(a),...d])}info(a,...d){this.getLevel()<=m.Info&&this.f.log(m.Info,[this.g(a),...d])}warn(a,...d){this.getLevel()<=m.Warning&&this.f.log(m.Warning,[this.g(a),...d])}error(a,...d){this.getLevel()<=m.Error&&this.f.log(m.Error,[this.g(a),...d])}g(a){return typeof a=="string"?a:(0,O.toErrorMessage)(a,this.getLevel()<=m.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class h extends I{constructor(a){super(),this.f=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const d of this.f)d.setLevel(a);super.setLevel(a)}trace(a,...d){for(const R of this.f)R.trace(a,...d)}debug(a,...d){for(const R of this.f)R.debug(a,...d)}info(a,...d){for(const R of this.f)R.info(a,...d)}warn(a,...d){for(const R of this.f)R.warn(a,...d)}error(a,...d){for(const R of this.f)R.error(a,...d)}flush(){for(const a of this.f)a.flush()}dispose(){for(const a of this.f)a.dispose()}}e.MultiplexLogService=h;class w extends k.Disposable{constructor(a){super(),this.b=a,this.B(a)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(a){this.b.setLevel(a)}getLevel(){return this.b.getLevel()}trace(a,...d){this.b.trace(a,...d)}debug(a,...d){this.b.debug(a,...d)}info(a,...d){this.b.info(a,...d)}warn(a,...d){this.b.warn(a,...d)}error(a,...d){this.b.error(a,...d)}flush(){this.b.flush()}}e.LogService=w;class f extends k.Disposable{constructor(a,d){super(),this.c=a,this.b=new T.ResourceMap,this.B(d(R=>this.setLevel(R)))}getLoggers(){return[...this.b.values()].map(({logger:a})=>a)}getLogger(a){return this.b.get(a)?.logger}createLogger(a,d,R){let j=this.b.get(a)?.logger;return j||(R=d?.always?m.Trace:R,j=this.f(a,R??this.c,d),this.b.set(a,{logger:j,logLevel:R})),j}setLevel(a,d){const R=P.URI.isUri(a)?a:void 0,j=R?d:a;if(R){const x=this.b.get(R);x&&x.logLevel!==j&&(x.logLevel=j,x.logger.setLevel(j))}else this.c=j,this.b.forEach(({logLevel:x,logger:K})=>{x===void 0&&K.setLevel(this.c)})}getLogLevel(a){return this.b.get(a)?.logLevel}dispose(){this.b.forEach(({logger:a})=>a.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=f;class s{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(a){}getLevel(){return m.Info}trace(a,...d){}debug(a,...d){}info(a,...d){}warn(a,...d){}error(a,...d){}critical(a,...d){}dispose(){}flush(){}}e.NullLogger=s;class i extends s{}e.NullLogService=i;class n extends f{constructor(){super(m.Info,D.Event.None)}f(a,d,R){return new s}}e.NullLoggerService=n;function t(c){if(c.verbose)return m.Trace;if(typeof c.logLevel=="string"){const a=o(c.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function r(c){switch(c){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.LogLevelToString=r;function o(c){switch(c){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.parseLogLevel=o}),define(Y[112],Z([0,1,19,4,10,3,2,15,61,9]),function(W,e,O,D,k,T,L,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class m extends L.Disposable{constructor(p,I){super(),this.a=p,this.b=I,this.c=this.B(new T.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new T.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new D.ThrottledDelayer(0)),this.s=[],this.t=this.B(new D.ThrottledDelayer(0))}watch(p,I){return I.recursive||this.b?.watcher?.forceUniversal?this.l(p,I):this.u(p,I)}l(p,I){const v={path:this.D(p),excludes:I.excludes,includes:I.includes,recursive:I.recursive},S=(0,O.insert)(this.j,v);return this.m(),(0,L.toDisposable)(()=>{S(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(p=>(0,k.onUnexpectedError)(p))}n(){this.h||(this.h=this.B(this.p(I=>this.c.fire((0,g.toFileChanges)(I)),I=>this.C(I),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const I of this.j)(0,g.isRecursiveWatchRequest)(I)&&(I.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const I of this.j)(0,g.isRecursiveWatchRequest)(I)&&p.includes(I.path)&&(I.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(p,I){const v={path:this.D(p),excludes:I.excludes,includes:I.includes,recursive:!1},S=(0,O.insert)(this.s,v);return this.v(),(0,L.toDisposable)(()=>{S(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(p=>(0,k.onUnexpectedError)(p))}w(){return this.r||(this.r=this.B(this.y(p=>this.c.fire((0,g.toFileChanges)(p)),p=>this.C(p),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.r.watch(this.s)}C(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}D(p){return(0,P.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=m}),define(Y[113],Z([0,1,19,4,14,22,3,53,64,2,114,16,115,17,43,91,13,60,9]),function(W,e,O,D,k,T,L,P,g,l,m,E,p,I,v,S,y,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends l.Disposable{constructor(s){super(),this.b=s,this.a=256*1024,this.c=this.B(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new L.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new L.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new L.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new D.ResourceQueue)}registerProvider(s,i){if(this.h.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${s}`);const n=new l.DisposableStore;return this.h.set(s,i),this.c.fire({added:!0,scheme:s,provider:i}),n.add(i.onDidChangeFile(t=>this.R.fire(new y.FileChangesEvent(t,!this.O(i))))),typeof i.onDidWatchError=="function"&&n.add(i.onDidWatchError(t=>this.S.fire(new Error(t)))),n.add(i.onDidChangeCapabilities(()=>this.g.fire({provider:i,scheme:s}))),(0,l.toDisposable)(()=>{this.c.fire({added:!1,scheme:s,provider:i}),this.h.delete(s),(0,l.dispose)(n)})}getProvider(s){return this.h.get(s)}async activateProvider(s){const i=[];this.f.fire({scheme:s,join(n){i.push(n)}}),!this.h.has(s)&&await D.Promises.settled(i)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.h.has(s.scheme)}hasCapability(s,i){const n=this.h.get(s.scheme);return!!(n&&n.capabilities&i)}listCapabilities(){return g.Iterable.map(this.h,([s,i])=>({scheme:s,capabilities:i.capabilities}))}async j(s){if(!(0,I.isAbsolutePath)(s))throw new y.FileOperationError((0,S.localize)(0,null,this.ob(s)),8);await this.activateProvider(s.scheme);const i=this.h.get(s.scheme);if(!i){const n=new Error;throw n.name="ENOPRO",n.message=(0,S.localize)(1,null,s.toString()),n}return i}async k(s){const i=await this.j(s);if((0,y.hasOpenReadWriteCloseCapability)(i)||(0,y.hasReadWriteCapability)(i)||(0,y.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(s){const i=await this.j(s);if((0,y.hasOpenReadWriteCloseCapability)(i)||(0,y.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,i){try{return await this.n(s,i)}catch(n){throw(0,y.toFileSystemProviderErrorCode)(n)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,S.localize)(2,null,this.ob(s)),1):(0,y.ensureFileSystemProviderError)(n)}}async n(s,i){const n=await this.j(s),t=this.O(n),r=i?.resolveTo,o=i?.resolveSingleChildDescendants,c=i?.resolveMetadata,a=await n.stat(s);let d;return this.p(n,s,a,void 0,!!c,(R,j)=>(d||(d=m.TernarySearchTree.forUris(()=>!t),d.set(s,!0),r&&d.fill(!0,r)),d.get(R.resource)||d.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&o?j===1:!1))}async p(s,i,n,t,r,o){const{providerExtUri:c}=this.N(s),a={resource:i,name:c.basename(i),isFile:(n.type&y.FileType.File)!==0,isDirectory:(n.type&y.FileType.Directory)!==0,isSymbolicLink:(n.type&y.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&y.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,y.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(a.isDirectory&&o(a,t)){try{const d=await s.readdir(i),R=await D.Promises.settled(d.map(async([j,x])=>{try{const K=c.joinPath(i,j),J=r?await s.stat(K):{type:x};return await this.p(s,K,J,d.length,r,o)}catch(K){return this.b.trace(K),null}}));a.children=(0,O.coalesce)(R)}catch(d){this.b.trace(d),a.children=[]}return a}return a}async resolveAll(s){return D.Promises.settled(s.map(async i=>{try{return{stat:await this.n(i.resource,i.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const i=await this.j(s),n=await i.stat(s);return this.p(i,s,n,void 0,!0,()=>!1)}async exists(s){const i=await this.j(s);try{return!!await i.stat(s)}catch{return!1}}async canCreateFile(s,i){try{await this.r(s,i)}catch(n){return n}return!0}async r(s,i){if(!i?.overwrite&&await this.exists(s))throw new y.FileOperationError((0,S.localize)(3,null,this.ob(s)),3,i)}async createFile(s,i=k.VSBuffer.fromString(""),n){await this.r(s,n);const t=await this.writeFile(s,i);return this.m.fire(new y.FileOperationEvent(s,0,t)),t}async writeFile(s,i,n){const t=this.mb(await this.l(s),s),{providerExtUri:r}=this.N(t);try{await this.s(t,s,n)||await this.P(t,r.dirname(s));let c;if((0,y.hasReadWriteCapability)(t)&&!(i instanceof k.VSBuffer))if((0,v.isReadableStream)(i)){const a=await(0,v.peekStream)(i,3);a.ended?c=k.VSBuffer.concat(a.buffer):c=a}else c=(0,v.peekReadable)(i,a=>k.VSBuffer.concat(a),3);else c=i;!(0,y.hasOpenReadWriteCloseCapability)(t)||(0,y.hasReadWriteCapability)(t)&&c instanceof k.VSBuffer?await this.db(t,s,n,c):await this.Y(t,s,n,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c),this.m.fire(new y.FileOperationEvent(s,4))}catch(o){throw new y.FileOperationError((0,S.localize)(4,null,this.ob(s),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async s(s,i,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,S.localize)(5,null,this.ob(i)));let r;try{r=await s.stat(i)}catch{return}if((r.type&y.FileType.Directory)!==0)throw new y.FileOperationError((0,S.localize)(6,null,this.ob(i)),0,n);if(this.nb(i,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==y.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,y.etag)({mtime:n.mtime,size:r.size}))throw new y.FileOperationError((0,S.localize)(7,null),3,n);return r}async readFile(s,i,n){const t=await this.k(s);return i?.atomic?this.t(t,s,i,n):this.u(t,s,i,n)}async t(s,i,n,t){return new Promise((r,o)=>{this.X.queueFor(i,this.N(s).providerExtUri).queue(async()=>{try{const c=await this.u(s,i,n,t);r(c)}catch(c){o(c)}})})}async u(s,i,n,t){const r=await this.v(s,i,{...n,preferUnbuffered:!0},t);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(s,i,n){const t=await this.k(s);return this.v(t,s,i,n)}async v(s,i,n,t){const r=new T.CancellationTokenSource(t),o=this.F(i,n).then(a=>a,a=>{throw r.cancel(),a});let c;try{return typeof n?.etag=="string"&&n.etag!==y.ETAG_DISABLED&&await o,n?.atomic&&(0,y.hasFileAtomicReadCapability)(s)||!((0,y.hasOpenReadWriteCloseCapability)(s)||(0,y.hasFileReadStreamCapability)(s))||(0,y.hasReadWriteCapability)(s)&&n?.preferUnbuffered?c=this.D(s,i,n):(0,y.hasFileReadStreamCapability)(s)?c=this.w(s,i,r.token,n):c=this.C(s,i,r.token,n),{...await o,value:c}}catch(a){c&&await(0,v.consumeStream)(c);const d=(0,S.localize)(8,null,this.ob(i),(0,y.ensureFileSystemProviderError)(a).toString());throw a instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(d,a.stat,n):new y.FileOperationError(d,(0,y.toFileOperationResult)(a),n)}}w(s,i,n,t=Object.create(null)){const r=s.readFileStream(i,t,n);return(0,v.transform)(r,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new y.FileOperationError((0,S.localize)(9,null,this.ob(i),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),t)},o=>k.VSBuffer.concat(o))}C(s,i,n,t=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,u.readFileIntoStream)(s,i,r,o=>o,{...t,bufferSize:this.a,errorTransformer:o=>new y.FileOperationError((0,S.localize)(10,null,this.ob(i),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),t)},n),r}D(s,i,n){const t=(0,v.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,y.hasFileAtomicReadCapability)(s)?r=await s.readFile(i,{atomic:!0}):r=await s.readFile(i),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.G(i,r.byteLength,n),t.end(k.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async F(s,i){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new y.FileOperationError((0,S.localize)(11,null,this.ob(s)),0,i);if(typeof i?.etag=="string"&&i.etag!==y.ETAG_DISABLED&&i.etag===n.etag)throw new y.NotModifiedSinceFileOperationError((0,S.localize)(12,null),n,i);return this.G(s,n.size,i),n}G(s,i,n){if(n?.limits){let t;if(typeof n.limits.memory=="number"&&i>n.limits.memory&&(t=9),typeof n.limits.size=="number"&&i>n.limits.size&&(t=7),typeof t=="number")throw new y.FileOperationError((0,S.localize)(13,null,this.ob(s)),t)}}async canMove(s,i,n){return this.H(s,i,"move",n)}async canCopy(s,i,n){return this.H(s,i,"copy",n)}async H(s,i,n,t){if(s.toString()!==i.toString())try{const r=n==="move"?this.mb(await this.l(s),s):await this.k(s),o=this.mb(await this.l(i),i);await this.M(r,s,o,i,n,t)}catch(r){return r}return!0}async move(s,i,n){const t=this.mb(await this.l(s),s),r=this.mb(await this.l(i),i),o=await this.I(t,s,r,i,"move",!!n),c=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new y.FileOperationEvent(s,o==="move"?2:3,c)),c}async copy(s,i,n){const t=await this.k(s),r=this.mb(await this.l(i),i),o=await this.I(t,s,r,i,"copy",!!n),c=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new y.FileOperationEvent(s,o==="copy"?3:2,c)),c}async I(s,i,n,t,r,o){if(i.toString()===t.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:a}=await this.M(s,i,n,t,r,o);if(c&&!a&&o&&await this.del(t,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(t)),r==="copy"){if(s===n&&(0,y.hasFileFolderCopyCapability)(s))await s.copy(i,t,{overwrite:o});else{const d=await this.resolve(i);d.isDirectory?await this.L(s,d,n,t):await this.J(s,i,n,t)}return r}else return s===n?(await s.rename(i,t,{overwrite:o}),r):(await this.I(s,i,n,t,"copy",o),await this.del(i,{recursive:!0}),"copy")}async J(s,i,n,t){if((0,y.hasOpenReadWriteCloseCapability)(s)&&(0,y.hasOpenReadWriteCloseCapability)(n))return this.fb(s,i,n,t);if((0,y.hasOpenReadWriteCloseCapability)(s)&&(0,y.hasReadWriteCapability)(n))return this.lb(s,i,n,t);if((0,y.hasReadWriteCapability)(s)&&(0,y.hasOpenReadWriteCloseCapability)(n))return this.jb(s,i,n,t);if((0,y.hasReadWriteCapability)(s)&&(0,y.hasReadWriteCapability)(n))return this.hb(s,i,n,t)}async L(s,i,n,t){await n.mkdir(t),Array.isArray(i.children)&&await D.Promises.settled(i.children.map(async r=>{const o=this.N(n).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.L(s,await this.resolve(r.resource),n,o):this.J(s,r.resource,n,o)}))}async M(s,i,n,t,r,o){let c=!1;if(s===n){const{providerExtUri:d,isPathCaseSensitive:R}=this.N(s);if(R||(c=d.isEqual(i,t)),c&&r==="copy")throw new Error((0,S.localize)(14,null,this.ob(i),this.ob(t)));if(!c&&d.isEqualOrParent(t,i))throw new Error((0,S.localize)(15,null,this.ob(i),this.ob(t)))}const a=await this.exists(t);if(a&&!c){if(!o)throw new y.FileOperationError((0,S.localize)(16,null,this.ob(i),this.ob(t)),4);if(s===n){const{providerExtUri:d}=this.N(s);if(d.isEqualOrParent(i,t))throw new Error((0,S.localize)(17,null,this.ob(i),this.ob(t)))}}return{exists:a,isSameResourceWithDifferentPathCase:c}}N(s){const i=this.O(s);return{providerExtUri:i?I.extUri:I.extUriIgnorePathCase,isPathCaseSensitive:i}}O(s){return!!(s.capabilities&1024)}async createFolder(s){const i=this.mb(await this.j(s),s);await this.P(i,s);const n=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new y.FileOperationEvent(s,0,n)),n}async P(s,i){const n=[],{providerExtUri:t}=this.N(s);for(;!t.isEqual(i,t.dirname(i));)try{if(((await s.stat(i)).type&y.FileType.Directory)===0)throw new Error((0,S.localize)(18,null,this.ob(i)));break}catch(r){if((0,y.toFileSystemProviderErrorCode)(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(t.basename(i)),i=t.dirname(i)}for(let r=n.length-1;r>=0;r--){i=t.joinPath(i,n[r]);try{await s.mkdir(i)}catch(o){if((0,y.toFileSystemProviderErrorCode)(o)!==y.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,i){try{await this.Q(s,i)}catch(n){return n}return!0}async Q(s,i){const n=this.mb(await this.j(s),s);if(!!i?.useTrash&&!(n.capabilities&4096))throw new Error((0,S.localize)(19,null,this.ob(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.nb(s,r);else throw new y.FileOperationError((0,S.localize)(20,null,this.ob(s)),1);if(!!!i?.recursive){const c=await this.resolve(s);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,S.localize)(21,null,this.ob(s)))}return n}async del(s,i){const n=await this.Q(s,i),t=!!i?.useTrash,r=!!i?.recursive;await n.delete(s,{recursive:r,useTrash:t}),this.m.fire(new y.FileOperationEvent(s,1))}async cloneFile(s,i){const n=await this.j(s),t=this.mb(await this.l(i),i);if(n===t&&this.N(n).providerExtUri.isEqual(s,i))return;if(n===t&&(0,y.hasFileCloneCapability)(n))return n.cloneFile(s,i);await this.P(t,this.N(t).providerExtUri.dirname(i));const r=this.X.queueFor(s,this.N(n).providerExtUri);return n===t&&(0,y.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,i,{overwrite:!0})):r.queue(()=>this.J(n,s,t,i))}watch(s,i={recursive:!1,excludes:[]}){const n=new l.DisposableStore;let t=!1,r=()=>{t=!0};return n.add((0,l.toDisposable)(()=>r())),(async()=>{try{const o=await this.W(s,i);t?(0,l.dispose)(o):r=()=>(0,l.dispose)(o)}catch(o){this.b.error(o)}})(),n}async W(s,i){const n=await this.j(s),t=(0,P.hash)([this.N(n).providerExtUri.getComparisonKey(s),i]);let r=this.U.get(t);return r||(r={count:0,disposable:n.watch(s,i)},this.U.set(t,r)),r.count+=1,(0,l.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,l.dispose)(r.disposable),this.U.delete(t)))})}dispose(){super.dispose();for(const[,s]of this.U)(0,l.dispose)(s.disposable);this.U.clear()}async Y(s,i,n,t){return this.X.queueFor(i,this.N(s).providerExtUri).queue(async()=>{const r=await s.open(i,{create:!0,unlock:n?.unlock??!1});try{(0,v.isReadableStream)(t)||(0,v.isReadableBufferedStream)(t)?await this.ab(s,r,t):await this.bb(s,r,t)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async ab(s,i,n){let t=0,r;if((0,v.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=k.VSBuffer.concat(n.buffer);await this.cb(s,i,o,o.byteLength,t,0),t+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,c)=>{(0,v.listenStream)(r,{onData:async a=>{r.pause();try{await this.cb(s,i,a,a.byteLength,t,0)}catch(d){return c(d)}t+=a.byteLength,setTimeout(()=>r.resume())},onError:a=>c(a),onEnd:()=>o()})})}async bb(s,i,n){let t=0,r;for(;(r=n.read())!==null;)await this.cb(s,i,r,r.byteLength,t,0),t+=r.byteLength}async cb(s,i,n,t,r,o){let c=0;for(;c<t;)c+=await s.write(i,r+c,n.buffer,o+c,t-c)}async db(s,i,n,t){return this.X.queueFor(i,this.N(s).providerExtUri).queue(()=>this.eb(s,i,n,t))}async eb(s,i,n,t){let r;t instanceof k.VSBuffer?r=t:(0,v.isReadableStream)(t)?r=await(0,k.streamToBuffer)(t):(0,v.isReadableBufferedStream)(t)?r=await(0,k.bufferedStreamToBuffer)(t):r=(0,k.readableToBuffer)(t),await s.writeFile(i,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async fb(s,i,n,t){return this.X.queueFor(t,this.N(n).providerExtUri).queue(()=>this.gb(s,i,n,t))}async gb(s,i,n,t){let r,o;try{r=await s.open(i,{create:!1}),o=await n.open(t,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.a);let a=0,d=0,R=0;do R=await s.read(r,a,c.buffer,d,c.byteLength-d),await this.cb(n,o,c,R,a,d),a+=R,d+=R,d===c.byteLength&&(d=0);while(R>0)}catch(c){throw(0,y.ensureFileSystemProviderError)(c)}finally{await D.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async hb(s,i,n,t){return this.X.queueFor(t,this.N(n).providerExtUri).queue(()=>this.ib(s,i,n,t))}async ib(s,i,n,t){return n.writeFile(t,await s.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async jb(s,i,n,t){return this.X.queueFor(t,this.N(n).providerExtUri).queue(()=>this.kb(s,i,n,t))}async kb(s,i,n,t){const r=await n.open(t,{create:!0,unlock:!1});try{const o=await s.readFile(i);await this.cb(n,r,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async lb(s,i,n,t){const r=await(0,k.streamToBuffer)(this.C(s,i,T.CancellationToken.None));await this.db(n,t,void 0,r)}mb(s,i){if(s.capabilities&2048)throw new y.FileOperationError((0,S.localize)(22,null,this.ob(i)),6);return s}nb(s,i){if((i.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,S.localize)(23,null,this.ob(s)),6)}ob(s){return s.scheme===E.Schemas.file?s.fsPath:s.toString(!0)}};w=de([ee(0,h.ILogService)],w),e.FileService=w}),define(Y[116],Z([0,1,117,156,4,34,14,3,157,2,15,12,17,43,20,93,13,60,112,32,110,109]),function(W,e,O,D,k,T,L,P,g,l,m,E,p,I,v,S,y,u,h,w,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(O)}catch(n){console.error(`Error enabling graceful-fs: ${(0,w.toErrorMessage)(n)}`)}})();class i extends h.AbstractDiskFileSystemProvider{constructor(t,r){super(t,r),this.onDidChangeCapabilities=P.Event.None,this.I=new T.ResourceMap(o=>p.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.M=new Map,this.N=new Map,this.O=new Map}get capabilities(){return this.G||(this.G=57374,E.isLinux&&(this.G|=1024)),this.G}async stat(t){try{const{stat:r,symbolicLink:o}=await v.SymlinkSupport.stat(this.D(t));return{type:this.H(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.ab(r)}}async readdir(t){try{const r=await v.Promises.readdir(this.D(t),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async c=>{try{let a;c.isSymbolicLink()?a=(await this.stat((0,p.joinPath)(t,c.name))).type:a=this.H(c),o.push([c.name,a])}catch(a){this.a.trace(a)}})),o}catch(r){throw this.ab(r)}}H(t,r){let o;return r?.dangling?o=y.FileType.Unknown:t.isFile()?o=y.FileType.File:t.isDirectory()?o=y.FileType.Directory:o=y.FileType.Unknown,r&&(o|=y.FileType.SymbolicLink),o}async J(t){const r=this.D(t);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.I.get(t);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const c=new k.Barrier;return this.I.set(t,c),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,l.toDisposable)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.I.get(t)===c&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.I.delete(t)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),c.open()})}async readFile(t,r){let o;try{r?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.D(t)})`),o=await this.J(t));const c=this.D(t);return await v.Promises.readFile(c)}catch(c){throw this.ab(c)}finally{o?.dispose()}}L(t){i.F&&this.a.trace(t)}readFileStream(t,r,o){const c=(0,I.newWriteableStream)(a=>L.VSBuffer.concat(a.map(d=>L.VSBuffer.wrap(d))).buffer);return(0,u.readFileIntoStream)(this,t,c,a=>a.buffer,{...r,bufferSize:256*1024},o),c}async writeFile(t,r,o){let c;try{const a=this.D(t);if(!o.create||!o.overwrite){if(await v.Promises.exists(a)){if(!o.overwrite)throw(0,y.createFileSystemProviderError)((0,S.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,y.createFileSystemProviderError)((0,S.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(c,0,r,0,r.byteLength)}catch(a){throw await this.bb(t,a)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(t){i.P=t}async open(t,r){const o=this.D(t);let c;(0,y.isFileOpenForWriteOptions)(r)&&(c=await this.J(t));let a;try{if((0,y.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:R}=await v.SymlinkSupport.stat(o);R.mode&128||await v.Promises.chmod(o,R.mode|128)}catch(R){this.a.trace(R)}let d;if((0,y.isFileOpenForWriteOptions)(r)){if(E.isWindows)try{await v.Promises.truncate(o,0),d="r+"}catch(R){R.code!=="ENOENT"&&this.a.trace(R)}d||(d="w")}else d="r";a=await v.Promises.open(o,d)}catch(d){throw c?.dispose(),(0,y.isFileOpenForWriteOptions)(r)?await this.bb(t,d):this.ab(d)}if(this.M.set(a,0),(0,y.isFileOpenForWriteOptions)(r)&&this.O.set(a,t),c){const d=this.N.get(a);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.N.set(a,c),d&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),d.dispose())}return a}async close(t){const r=this.N.get(t);try{if(this.M.delete(t),this.O.delete(t)&&i.P)try{await v.Promises.fdatasync(t)}catch(o){i.configureFlushOnWrite(!1),this.a.error(o)}return await v.Promises.close(t)}catch(o){throw this.ab(o)}finally{r&&(this.N.get(t)===r&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.N.delete(t)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,o,c,a){const d=this.Q(t,r);let R=null;try{R=(await v.Promises.read(t,o,c,a,d)).bytesRead}catch(j){throw this.ab(j)}finally{this.R(t,d,R)}return R}Q(t,r){return r===this.M.get(t)?null:r}R(t,r,o){const c=this.M.get(t);typeof c=="number"&&(typeof r=="number"||(typeof o=="number"?this.M.set(t,c+o):this.M.delete(t)))}async write(t,r,o,c,a){return(0,k.retry)(()=>this.S(t,r,o,c,a),100,3)}async S(t,r,o,c,a){const d=this.Q(t,r);let R=null;try{R=(await v.Promises.write(t,o,c,a,d)).bytesWritten}catch(j){throw await this.bb(this.O.get(t),j)}finally{this.R(t,d,R)}return R}async mkdir(t){try{await v.Promises.mkdir(this.D(t))}catch(r){throw this.ab(r)}}async delete(t,r){try{const o=this.D(t);r.recursive?await v.Promises.rm(o,v.RimRafMode.MOVE):await v.Promises.unlink(o)}catch(o){throw this.ab(o)}}async rename(t,r,o){const c=this.D(t),a=this.D(r);if(c!==a)try{await this.U(t,r,"move",o.overwrite),await v.Promises.move(c,a)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,S.localize)(2,null,(0,m.basename)(c),(0,m.basename)((0,m.dirname)(a)),d.toString()))),this.ab(d)}}async copy(t,r,o){const c=this.D(t),a=this.D(r);if(c!==a)try{await this.U(t,r,"copy",o.overwrite),await v.Promises.copy(c,a,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,S.localize)(3,null,(0,m.basename)(c),(0,m.basename)((0,m.dirname)(a)),d.toString()))),this.ab(d)}}async U(t,r,o,c){const a=this.D(t),d=this.D(r);let R=!1;if(!!(this.capabilities&1024)||(R=(0,g.isEqual)(a,d,!0)),R&&o==="copy")throw(0,y.createFileSystemProviderError)((0,S.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!R&&await v.Promises.exists(d)){if(!c)throw(0,y.createFileSystemProviderError)((0,S.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(t,r){return this.W(t,r,!1)}async W(t,r,o){const c=this.D(t),a=this.D(r),d=!!(this.capabilities&1024);if((0,g.isEqual)(c,a,!d))return;const R=new l.DisposableStore;try{const[j,x]=await Promise.all([this.J(t),this.J(r)]);R.add(j),R.add(x),o&&await v.Promises.mkdir((0,m.dirname)(a),{recursive:!0}),await v.Promises.copyFile(c,a)}catch(j){if(j.code==="ENOENT"&&!o)return this.W(t,r,!0);throw this.ab(j)}finally{R.dispose()}}p(t,r,o){return new f.UniversalWatcherClient(c=>t(c),c=>r(c),o)}y(t,r,o){return new s.NodeJSWatcherClient(c=>t(c),c=>r(c),o)}ab(t){if(t instanceof y.FileSystemProviderError)return t;let r;switch(t.code){case"ENOENT":r=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=y.FileSystemProviderErrorCode.NoPermissions;break;default:r=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(t,r)}async bb(t,r){let o=this.ab(r);if(t&&o.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await v.SymlinkSupport.stat(this.D(t));c.mode&128||(o=(0,y.createFileSystemProviderError)(r,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return o}}e.DiskFileSystemProvider=i,i.F=!1,i.P=!0}),define(Y[118],Z([0,1,13,9]),function(W,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(k||(k={}));async function T(l,m,E,p,I){try{const v=await new Promise((y,u)=>{W(["spdlog"],y,u)});v.setFlushOn(D.LogLevel.Trace);const S=await v.createAsyncRotatingLogger(l,m,E,p);return I?S.clearFormatters():S.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),S}catch(v){console.error(v)}return null}function L(l,m,E){switch(m){case D.LogLevel.Trace:l.trace(E);break;case D.LogLevel.Debug:l.debug(E);break;case D.LogLevel.Info:l.info(E);break;case D.LogLevel.Warning:l.warn(E);break;case D.LogLevel.Error:l.error(E);break;default:throw new Error("Invalid log level")}}function P(l,m){switch(m){case D.LogLevel.Trace:l.setLevel(k.Trace);break;case D.LogLevel.Debug:l.setLevel(k.Debug);break;case D.LogLevel.Info:l.setLevel(k.Info);break;case D.LogLevel.Warning:l.setLevel(k.Warning);break;case D.LogLevel.Error:l.setLevel(k.Error);break;case D.LogLevel.Off:l.setLevel(k.Off);break;default:throw new Error("Invalid log level")}}class g extends D.AbstractMessageLogger{constructor(m,E,p,I,v){super(),this.j=[],this.setLevel(v),this.k=this.m(m,E,p,I),this.B(this.onDidChangeLogLevel(S=>{this.l&&P(this.l,S)}))}async m(m,E,p,I){const v=p?6:1,S=30/v*O.ByteSize.MB,y=await T(m,E,S,v,I);if(y){this.l=y,P(this.l,this.getLevel());for(const{level:u,message:h}of this.j)L(this.l,u,h);this.j=[]}}f(m,E){this.l?L(this.l,m,E):this.getLevel()<=m&&this.j.push({level:m,message:E})}flush(){this.l?this.l.flush():this.k.then(()=>this.flush())}dispose(){this.l?this.p():this.k.then(()=>this.p())}p(){this.l&&(this.l.drop(),this.l=void 0)}}e.SpdLogLogger=g}),define(Y[37],Z([0,1,3,64,2,7]),function(W,e,O,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class L extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const m=Object.keys(this.f).length;return this.f={...l,...this.f},m!==Object.keys(this.f).length&&await this.i(l),D.Iterable.reduce(this.g.entries(),(E,[p,I])=>({...E,[p]:I}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(l,[m,E])=>({...l,[m]:{definition:E,value:this.g.get(m)}}),{})}}e.AbstractPolicyService=L;class P{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(Y[119],Z([0,1,4,3,64,8,13,9,37]),function(W,e,O,D,k,T,L,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(E,p){const I=[];for(const v of k.Iterable.concat(E.keys(),p.keys()))E.get(v)!==p.get(v)&&I.push(v);return I}let m=class extends g.AbstractPolicyService{constructor(p,I,v){super(),this.j=p,this.k=I,this.l=v,this.c=this.B(new O.ThrottledDelayer(500));const S=D.Event.filter(I.onDidFilesChange,y=>y.affects(p));this.B(I.watch(p)),this.B(S(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const p=new Map;try{const I=await this.k.readFile(this.j),v=JSON.parse(I.value.toString());if(!(0,T.isObject)(v))throw new Error("Policy file isn't a JSON object");for(const S of Object.keys(v))this.f[S]&&p.set(S,v[S])}catch(I){I.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",I)}return p}async p(){const p=await this.n(),I=l(this.g,p);this.g=p,I.length>0&&this.h.fire(I)}};m=de([ee(1,L.IFileService),ee(2,P.ILogService)],m),e.FilePolicyService=m}),define(Y[28],Z([0,1,7]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,O.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Y[35],Z([0,1,69,8]),function(W,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(L,P){O.ok(D.isString(L)),O.ok(D.isObject(P)),O.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,P)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.Registry=new k}),define(Y[120],Z([0,1,3,35]),function(W,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this.b=new O.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,l){this.a[k(g)]=l,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const L=new T;D.Registry.add(e.Extensions.JSONContribution,L)}),define(Y[40],Z([0,1,19,3,8,82,21,120,35]),function(W,e,O,D,k,T,L,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var l;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(l=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=g.Registry.as(P.Extensions.JSONContribution);class p{constructor(){this.h=new Set,this.i=new D.Emitter,this.onDidSchemaChange=this.i.event,this.j=new D.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(i,n=!0){this.registerConfigurations([i],n)}registerConfigurations(i,n=!0){const t=this.k(i,n);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const n=this.l(i);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:i,remove:n}){const t=[];t.push(...this.l(n)),t.push(...this.k(i,!1)),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,O.distinct)(t)})}registerDefaultConfigurations(i){const n=[],t=[];for(const{overrides:r,source:o}of i)for(const c in r)if(n.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const a=this.a.get(c),d=a?.valuesSources??new Map;if(o)for(const K of Object.keys(r[c]))d.set(K,o);const R={...a?.value||{},...r[c]};this.a.set(c,{source:o,value:R,valuesSources:d});const j=(0,L.getLanguageTagSettingPlainKey)(c),x={type:"object",default:R,description:T.localize(1,null,j),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:R,source:k.isString(o)?void 0:o,defaultValueSource:o};t.push(...S(c)),this.d[c]=x,this.b.properties[c]=x}else{this.a.set(c,{value:r[c],source:o});const a=this.d[c];a&&(this.s(c,a),this.o(c,a))}this.registerOverrideIdentifiers(t),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const n=[];for(const{overrides:t,source:r}of i)for(const o in t){const c=this.a.get(o),a=k.isString(r)?r:r?.id,d=k.isString(c?.source)?c?.source:c?.source?.id;if(a===d)if(n.push(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const R=this.d[o];R&&(this.s(o,R),this.o(o,R))}}this.q(),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){for(const n of i)this.h.add(n);this.q()}k(i,n){const t=[];return i.forEach(r=>{t.push(...this.m(r,n,r.extensionInfo,r.restrictedProperties)),this.c.push(r),this.n(r)}),t}l(i){const n=[],t=r=>{if(r.properties)for(const o in r.properties){n.push(o);const c=this.d[o];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[o],this.p(o,r.properties[o])}r.allOf?.forEach(o=>t(o))};for(const r of i){t(r);const o=this.c.indexOf(r);o!==-1&&this.c.splice(o,1)}return n}m(i,n=!0,t,r,o=3){o=k.isUndefinedOrNull(i.scope)?o:i.scope;const c=[],a=i.properties;if(a)for(const R in a){const j=a[R];if(n&&w(R,j)){delete a[R];continue}if(j.source=t,j.defaultDefaultValue=a[R].default,this.s(R,j),e.OVERRIDE_PROPERTY_REGEX.test(R)?j.scope=void 0:(j.scope=k.isUndefinedOrNull(j.scope)?o:j.scope,j.restricted=k.isUndefinedOrNull(j.restricted)?!!r?.includes(R):j.restricted),a[R].hasOwnProperty("included")&&!a[R].included){this.f[R]=a[R],delete a[R];continue}else this.d[R]=a[R],a[R].policy?.name&&this.e.set(a[R].policy.name,R);!a[R].deprecationMessage&&a[R].markdownDeprecationMessage&&(a[R].deprecationMessage=a[R].markdownDeprecationMessage),c.push(R)}const d=i.allOf;if(d)for(const R of d)c.push(...this.m(R,n,t,r,o));return c}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(i){const n=t=>{const r=t.properties;if(r)for(const c in r)this.o(c,r[c]);t.allOf?.forEach(n)};n(i)}o(i,n){switch(e.allSettings.properties[i]=n,n.scope){case 1:e.applicationSettings.properties[i]=n;break;case 2:e.machineSettings.properties[i]=n;break;case 6:e.machineOverridableSettings.properties[i]=n;break;case 3:e.windowSettings.properties[i]=n;break;case 4:e.resourceSettings.properties[i]=n;break;case 5:e.resourceSettings.properties[i]=n,this.g.properties[i]=n;break}}p(i,n){switch(delete e.allSettings.properties[i],n.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}q(){for(const i of this.h.values()){const n=`[${i}]`,t={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(n,t),e.allSettings.properties[n]=t,e.applicationSettings.properties[n]=t,e.machineSettings.properties[n]=t,e.machineOverridableSettings.properties[n]=t,e.windowSettings.properties[n]=t,e.resourceSettings.properties[n]=t}this.i.fire()}r(){const i={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}s(i,n){const t=this.a.get(i);let r=t?.value,o=t?.source;k.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),k.isUndefined(r)&&(r=u(n.type)),n.default=r,n.defaultValueSource=o}}const I="\\[([^\\]]+)\\]",v=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(s){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let n=v.exec(s);for(;n?.length;){const t=n[1].trim();t&&i.push(t),n=v.exec(s)}}return(0,O.distinct)(i)}e.overrideIdentifiersFromKey=S;function y(s){return s.reduce((i,n)=>`${i}[${n}]`,"")}e.keyFromOverrideIdentifiers=y;function u(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const h=new p;g.Registry.add(e.Extensions.Configuration,h);function w(s,i){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?T.localize(7,null,s):h.getConfigurationProperties()[s]!==void 0?T.localize(8,null,s):i.policy?.name&&h.getPolicyConfigurations().get(i.policy?.name)!==void 0?T.localize(9,null,s,i.policy?.name,h.getPolicyConfigurations().get(i.policy?.name)):null:T.localize(6,null)}e.validateProperty=w;function f(){const s=[],i=h.getConfigurationProperties();for(const n of Object.keys(i))s.push([n,i[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=f}),define(Y[65],Z([0,1,19,3,50,2,34,26,8,11,21,40,35]),function(W,e,O,D,k,T,L,P,g,l,m,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class I{constructor(n={},t=[],r=[],o){this.c=n,this.d=t,this.f=r,this.raw=o,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(t=>{if(t instanceof I)return t;const r=new v("");return r.parseRaw(t),r.configurationModel});this.g=n.reduce((t,r)=>r===t?r:t.merge(r),n[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(n){return n?(0,m.getConfigurationValue)(this.contents,n):this.contents}inspect(n,t){const r=this.rawConfiguration.getValue(n),o=t?this.rawConfiguration.getOverrideValue(n,t):void 0,c=t?this.rawConfiguration.override(t).getValue(n):r;return{value:r,override:o,merged:c}}getOverrideValue(n,t){const r=this.l(t);return r?n?(0,m.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const r of this.overrides)r.identifiers.includes(n)&&t.push(...r.keys);return O.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return O.distinct(n)}override(n){let t=this.b.get(n);return t||(t=this.h(n),this.b.set(n,t)),t}merge(...n){const t=P.deepClone(this.contents),r=P.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const a of n)if(c.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.j(t,a.contents);for(const d of a.overrides){const[R]=r.filter(j=>O.equals(j.identifiers,d.identifiers));R?(this.j(R.contents,d.contents),R.keys.push(...d.keys),R.keys=O.distinct(R.keys)):r.push(P.deepClone(d))}for(const d of a.keys)o.indexOf(d)===-1&&o.push(d)}return new I(t,o,r,c.every(a=>a instanceof I)?void 0:c)}freeze(){return this.a=!0,this}clone(){return new I(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}h(n){const t=this.l(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const r={};for(const o of O.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[o];const a=t[o];a&&(typeof c=="object"&&typeof a=="object"?(c=P.deepClone(c),this.j(c,a)):c=a),r[o]=c}return new I(r,this.keys,this.overrides)}j(n,t){for(const r of Object.keys(t)){if(r in n&&g.isObject(n[r])&&g.isObject(t[r])){this.j(n[r],t[r]);continue}n[r]=P.deepClone(t[r])}}k(n){return this.a&&!Object.isFrozen(n)?P.deepFreeze(n):n}l(n){let t=null,r=null;const o=c=>{c&&(r?this.j(r,c):r=P.deepClone(c))};for(const c of this.overrides)O.equals(c.identifiers,[n])?t=c.contents:c.identifiers.includes(n)&&o(c.contents);return o(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.m(n),(0,m.addToValueTree)(this.contents,n,t,r=>{throw new Error(r)})}removeValue(n){this.n(n)&&(0,m.removeFromValueTree)(this.contents,n)}m(n){let t=this.keys.length;for(let r=0;r<t;r++)n.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,n)}n(n){const t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=I;class v{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new I}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,t){if(!g.isUndefinedOrNull(n)){const r=this.g(n);this.parseRaw(r,t)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,t){this.a=n;const{contents:r,keys:o,overrides:c,restricted:a,hasExcludedProperties:d}=this.h(n,t);this.b=new I(r,o,c,d?[n]:void 0),this.c=a||[]}g(n){let t={},r=null,o=[];const c=[],a=[];function d(j){Array.isArray(o)?o.push(j):r!==null&&(o[r]=j)}const R={onObjectBegin:()=>{const j={};d(j),c.push(o),o=j,r=null},onObjectProperty:j=>{r=j},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const j=[];d(j),c.push(o),o=j,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:d,onError:(j,x,K)=>{a.push({error:j,offset:x,length:K})}};if(n)try{k.visit(n,R),t=o[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return t}h(n,t){const r=p.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.j(n,r,!0,t);n=o.raw;const c=(0,m.toValuesTree)(n,R=>console.error(`Conflict in settings file ${this.f}: ${R}`)),a=Object.keys(n),d=this.l(n,R=>console.error(`Conflict in settings file ${this.f}: ${R}`));return{contents:c,keys:a,overrides:d,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(n,t,r,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:c};const a={},d=[];for(const R in n)if(E.OVERRIDE_PROPERTY_REGEX.test(R)&&r){const j=this.j(n[R],t,!1,o);a[R]=j.raw,c=c||j.hasExcludedProperties,d.push(...j.restricted)}else{const j=t[R],x=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&d.push(R),(x===void 0||o.scopes===void 0||o.scopes.includes(x))&&!(o.skipRestricted&&j?.restricted)?a[R]=n[R]:c=!0}return{raw:a,restricted:d,hasExcludedProperties:c}}l(n,t){const r=[];for(const o of Object.keys(n))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const a in n[o])c[a]=n[o][a];r.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,m.toValuesTree)(c,t)})}return r}}e.ConfigurationModelParser=v;class S extends T.Disposable{constructor(n,t,r,o){super(),this.f=n,this.g=t,this.h=o,this.c=this.B(new D.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(D.Event.any(D.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),D.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&r.isEqual(c.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new I}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=S;class y{constructor(n,t,r,o,c,a,d,R,j,x,K,J,ie){this.a=n,this.b=t,this.value=r,this.overrideIdentifiers=o,this.c=c,this.d=a,this.f=d,this.g=R,this.h=j,this.j=x,this.k=K,this.l=J,this.m=ie}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get A(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class u{constructor(n,t,r,o,c=new I,a=new I,d=new L.ResourceMap,R=new I,j=new L.ResourceMap,x=!0){this.c=n,this.d=t,this.f=r,this.g=o,this.h=c,this.j=a,this.l=d,this.m=R,this.n=j,this.p=x,this.a=null,this.b=new L.ResourceMap,this.q=null}getValue(n,t,r){return this.s(n,t,r).getValue(n)}updateValue(n,t,r={}){let o;r.resource?(o=this.n.get(r.resource),o||(o=new I,this.n.set(r.resource,o))):o=this.m,t===void 0?o.removeValue(n):o.setValue(n,t),r.resource||(this.a=null)}inspect(n,t,r){const o=this.s(n,t,r),c=O.distinct(o.overrides.map(R=>R.identifiers).flat()).filter(R=>o.getOverrideValue(n,R)!==void 0),a=this.w(t.resource,r),d=t.resource?this.n.get(t.resource)||this.m:this.m;return new y(n,t,o.getValue(n),c.length?c:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),r?this.j.freeze():void 0,a?a.freeze():void 0,d.inspect(n,t.overrideIdentifier))}keys(n){const t=this.w(void 0,n);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.j=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,t){this.l.set(n,t),this.b.delete(n)}deleteFolderConfiguration(n){this.r.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const r=[];if(!t){const{added:o,updated:c,removed:a}=f(this.c,n);t=[...o,...c,...a]}for(const o of t)for(const c of(0,E.overrideIdentifiersFromKey)(o)){const a=this.c.getKeysForOverrideIdentifier(c),d=n.getKeysForOverrideIdentifier(c),R=[...d.filter(j=>a.indexOf(j)===-1),...a.filter(j=>d.indexOf(j)===-1),...a.filter(j=>!P.equals(this.c.override(c).getValue(j),n.override(c).getValue(j)))];r.push([c,R])}return this.updateDefaultConfiguration(n),{keys:t,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:t,updated:r,removed:o}=f(this.d,n),c=[...t,...r,...o];return c.length&&this.updatePolicyConfiguration(n),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:t,updated:r,removed:o,overrides:c}=f(this.applicationConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateApplicationConfiguration(n),{keys:a,overrides:c}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:c}=f(this.localUserConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateLocalUserConfiguration(n),{keys:a,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:c}=f(this.remoteUserConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateRemoteUserConfiguration(n),{keys:a,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:r,removed:o,overrides:c}=f(this.workspaceConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateWorkspaceConfiguration(n),{keys:a,overrides:c}}compareAndUpdateFolderConfiguration(n,t){const r=this.r.get(n),{added:o,updated:c,removed:a,overrides:d}=f(r,t),R=[...o,...c,...a];return(R.length||!r)&&this.updateFolderConfiguration(n,t),{keys:R,overrides:d}}compareAndDeleteFolderConfiguration(n){const t=this.r.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:c,overrides:a}=f(t,void 0);return{keys:[...r,...o,...c],overrides:a}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(n,t,r){let o=this.t(t,r);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(o=o.merge(this.d)),o}t({resource:n},t){let r=this.u();if(t&&n){const o=t.getFolder(n);o&&(r=this.v(o.uri)||r);const c=this.n.get(n);c&&(r=r.merge(c))}return r}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(n){let t=this.b.get(n);if(!t){const r=this.u(),o=this.l.get(n);o?(t=r.merge(o),this.p&&(t=t.freeze()),this.b.set(n,t)):t=r}return t}w(n,t){if(t&&n){const r=t.getFolder(n);if(r)return this.l.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((n,t)=>{const{contents:r,overrides:o,keys:c}=this.l.get(t);return n.push([t,{contents:r,overrides:o,keys:c}]),n},[])}}allKeys(){const n=new Set;return this.c.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this.j.freeze().keys.forEach(t=>n.add(t)),this.l.forEach(t=>t.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}x(){const n=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.j.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.l.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}y(n){const t=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.j.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.l.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o))),[...t.values()]}static parse(n){const t=this.A(n.defaults),r=this.A(n.policy),o=this.A(n.application),c=this.A(n.user),a=this.A(n.workspace),d=n.folders.reduce((R,j)=>(R.set(l.URI.revive(j[0]),this.A(j[1])),R),new L.ResourceMap);return new u(t,r,o,c,new I,a,d,new I,new L.ResourceMap,!1)}static A(n){return new I(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=u;function h(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const n=new Set,t=new Map;for(const o of i)o.keys.forEach(c=>n.add(c)),o.overrides.forEach(([c,a])=>{const d=(0,L.getOrSet)(t,c,new Set);a.forEach(R=>d.add(R))});const r=[];return t.forEach((o,c)=>r.push([c,[...o.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=h;class w{constructor(n,t,r,o){this.change=n,this.b=t,this.c=r,this.d=o,this.f=void 0;const c=new Set;n.keys.forEach(d=>c.add(d)),n.overrides.forEach(([,d])=>d.forEach(R=>c.add(R))),this.affectedKeys=[...c.values()];const a=new I;this.affectedKeys.forEach(d=>a.setValue(d,{})),this.a=a.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=u.parse(this.b.data)),this.f}affectsConfiguration(n,t){if(this.g(this.a,n)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.b?.workspace):void 0,o=this.c.getValue(n,t,this.d);return!P.equals(r,o)}return!0}return!1}g(n,t){let r=(0,m.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=w;function f(i,n){const{added:t,removed:r,updated:o}=s(n?.rawConfiguration,i?.rawConfiguration),c=[],a=i?.getAllOverrideIdentifiers()||[],d=n?.getAllOverrideIdentifiers()||[];if(n){const R=d.filter(j=>!a.includes(j));for(const j of R)c.push([j,n.getKeysForOverrideIdentifier(j)])}if(i){const R=a.filter(j=>!d.includes(j));for(const j of R)c.push([j,i.getKeysForOverrideIdentifier(j)])}if(n&&i){for(const R of a)if(d.includes(R)){const j=s({contents:i.getOverrideValue(void 0,R)||{},keys:i.getKeysForOverrideIdentifier(R)},{contents:n.getOverrideValue(void 0,R)||{},keys:n.getKeysForOverrideIdentifier(R)});c.push([R,[...j.added,...j.removed,...j.updated]])}}return{added:t,removed:r,updated:o,overrides:c}}function s(i,n){const t=i?n?i.keys.filter(c=>n.keys.indexOf(c)===-1):[...i.keys]:[],r=n?i?n.keys.filter(c=>i.keys.indexOf(c)===-1):[...n.keys]:[],o=[];if(i&&n){for(const c of n.keys)if(i.keys.indexOf(c)!==-1){const a=(0,m.getConfigurationValue)(n.contents,c),d=(0,m.getConfigurationValue)(i.contents,c);P.equals(a,d)||o.push(c)}}return{added:t,removed:r,updated:o}}}),define(Y[121],Z([0,1,19,3,2,26,8,21,65,40,9,37,35]),function(W,e,O,D,k,T,L,P,g,l,m,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class I extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new D.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new v(this.f())),this.b}async initialize(){return this.b=void 0,this.B(p.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(({properties:h,defaultsOverrides:w})=>this.c(h,w))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(h,w){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:h})}f(){return{}}}e.DefaultConfiguration=I;class v extends g.ConfigurationModel{constructor(h={}){const w=p.Registry.as(l.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(w),s=Object.create(null),i=[];for(const n in w){const t=h[n],r=t!==void 0?t:w[n].default;(0,P.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))l.OVERRIDE_PROPERTY_REGEX.test(n)&&i.push({identifiers:(0,l.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,P.toValuesTree)(s[n],t=>console.error(`Conflict in default settings file: ${t}`))});super(s,f,i)}}e.DefaultConfigurationModel=v;class S{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new g.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let y=class extends k.Disposable{get configurationModel(){return this.b}constructor(h,w,f){super(),this.c=h,this.f=w,this.g=f,this.a=this.B(new D.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new g.ConfigurationModel}async initialize(){return this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(h=>this.i(h))),this.B(this.c.onDidChangeConfiguration(async({properties:h})=>this.j(await this.h(h),!0))),this.b}async h(h){const w={},f=[],s=p.Registry.as(l.Extensions.Configuration).getConfigurationProperties();for(const i of h){const n=s[i];if(!n){f.push(i);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.g.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}f.push(i),w[n.policy.name]={type:n.type}}}return(0,L.isEmptyObject)(w)||await this.f.updatePolicyDefinitions(w),f}i(h){const w=p.Registry.as(l.Extensions.Configuration).getPolicyConfigurations(),f=(0,O.coalesce)(h.map(s=>w.get(s)));this.j(f,!0)}j(h,w){const f=p.Registry.as(l.Extensions.Configuration).getConfigurationProperties(),s=[],i=this.b.isEmpty();for(const n of h){const t=f[n]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(i?r!==void 0:!(0,T.equals)(this.b.getValue(n),r))&&s.push([n,r])}else this.b.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this.b;this.b=new g.ConfigurationModel;for(const t of n.keys)this.b.setValue(t,n.getValue(t));for(const[t,r]of s)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);w&&this.a.fire(this.b)}}};y=de([ee(1,E.IPolicyService),ee(2,m.ILogService)],y),e.PolicyConfiguration=y}),define(Y[122],Z([0,1,4,3,2,17,21,65,121,37]),function(W,e,O,D,k,T,L,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class m extends k.Disposable{constructor(p,I,v,S){super(),this.i=p,this.h=this.B(new D.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.DefaultConfiguration),this.c=v instanceof l.NullPolicyService?new g.NullPolicyConfiguration:this.B(new g.PolicyConfiguration(this.b,v,S)),this.f=this.B(new P.UserSettings(this.i,void 0,T.extUriBiasedIgnorePathCase,I)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new O.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:y,properties:u})=>this.k(y,u))),this.B(this.c.onDidChangeConfiguration(y=>this.l(y))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,I,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(p,I,new P.ConfigurationModel,v)}getConfigurationData(){return this.a.toData()}getValue(p,I){const v=typeof p=="string"?p:void 0,S=(0,L.isConfigurationOverrides)(p)?p:(0,L.isConfigurationOverrides)(I)?I:{};return this.a.getValue(v,S,void 0)}updateValue(p,I,v,S){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.j(p)}j(p){const I=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(p);this.m(v,I,2)}k(p,I){const v=this.a.toData(),S=this.a.compareAndUpdateDefaultConfiguration(p,I);this.m(S,v,7)}l(p){const I=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(p);this.m(v,I,7)}m(p,I,v){const S=new P.ConfigurationChangeEvent(p,{data:I},this.a);S.source=v,S.sourceConfig=this.n(v),this.h.fire(S)}n(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=m}),define(Y[123],Z([0,1,16]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function D(l){return l.scheme===O.Schemas.vscodeRemote?l.authority:void 0}e.getRemoteAuthority=D;function k(l){if(!l)return;const m=l.indexOf("+");return m<0?l:l.substr(0,m)}e.getRemoteName=k;function T(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.getRemoteServerRootPath=T;function L(l){const{host:m,port:E}=g(l);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:m,port:E}}e.parseAuthorityWithPort=L;function P(l,m){let{host:E,port:p}=g(l);return typeof p>"u"&&(p=m),{host:E,port:p}}e.parseAuthorityWithOptionalPort=P;function g(l){const m=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const E=l.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const p=l.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:l,port:void 0}}}),define(Y[29],Z([0,1,27,7,123]),function(W,e,O,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=T;function L(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var g;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(g=e.TargetPlatform||(e.TargetPlatform={}));class l{constructor(S){this.value=S,this.c=S.toLowerCase()}static equals(S,y){if(typeof S>"u"||S===null)return typeof y>"u"||y===null;if(typeof y>"u"||y===null)return!1;if(typeof S=="string"||typeof y=="string"){const u=typeof S=="string"?S:S.value,h=typeof y=="string"?y:y.value;return O.equalsIgnoreCase(u,h)}return S.c===y.c}static toKey(S){return typeof S=="string"?S.toLowerCase():S.c}}e.ExtensionIdentifier=l;function m(v){return E(v)}e.isApplicationScopedExtension=m;function E(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function p(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function I(v,S){if(S){const y=`onResolveRemoteAuthority:${(0,k.getRemoteName)(S)}`;return v.activationEvents?.indexOf(y)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[24],Z([0,1,27,23,29,12,11,10,33]),function(W,e,O,D,k,T,L,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function l(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,O.compareIgnoreCase)(n.id,t.id)===0}e.areSameExtensions=l;const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{static create(t){const r=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new E(t.identifier,r,o)}static parse(t){const r=m.exec(t);return r&&r[1]&&r[2]?new E({id:r[1]},r[2],r[4]||void 0):null}constructor(t,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof E?l(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=E;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(n){const t=p.exec(n);return t&&t[1]?[S(t[1]),t[2]]:[S(n),void 0]}e.getIdAndVersion=I;function v(n,t){return`${n}.${t}`}e.getExtensionId=v;function S(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function y(n,t){return S(v(n,t))}e.getGalleryExtensionId=y;function u(n,t){const r=[],o=c=>{for(const a of r)if(a.some(d=>l(t(d),t(c))))return a;return null};for(const c of n){const a=o(c);a?a.push(c):r.push([c])}return r}e.groupByExtension=u;function h(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=h;function w(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function f(n,t){const r=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&r.every(a=>!l(a.identifier,{id:c}))){const a=n.filter(d=>l(d.identifier,{id:c}));a.length===1&&(r.push(a[0]),o.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=f;async function s(n,t){if(!T.isLinux)return!1;let r;try{r=(await n.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){t.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=s;async function i(n,t){const r=await s(n,t),o=(0,D.getTargetPlatform)(r?"alpine":T.platform,g.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=i}),define(Y[124],Z([0,1,22,10,16,17,39,11,85,23,24,29]),function(W,e,O,D,k,T,L,P,g,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const p=y=>(0,g.localize)(0,null,y),I=(0,g.localize)(1,null,"ms-dotnettools.csharp");function v(y,u){return u?`${y.publisher}.${y.name}@${y.version}`:`${y.publisher}.${y.name}`}let S=class{constructor(u,h){this.a=u,this.b=h}get d(){}async listExtensions(u,h,w,f=console){let s=await this.a.getInstalled(1,w);const i=E.EXTENSION_CATEGORIES.map(t=>t.toLowerCase());if(h&&h!==""){if(i.indexOf(h.toLowerCase())<0){f.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}s=s.filter(t=>t.manifest.categories?t.manifest.categories.map(o=>o.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){f.log("Possible Categories: "),i.forEach(t=>{f.log(t)});return}this.d&&f.log((0,g.localize)(2,null,this.d)),s=s.sort((t,r)=>t.identifier.id.localeCompare(r.identifier.id));let n;for(const t of s)n!==t.identifier.id&&(n=t.identifier.id,f.log(v(t.manifest,u)))}async installExtensions(u,h,w,f,s=console){const i=[],n=[];u.length&&s.log(this.d?(0,g.localize)(3,null,this.d):(0,g.localize)(4,null));const t=await this.a.getInstalled(1,w.profileLocation),r=(d,R)=>{const j=t.find(x=>(0,m.areSameExtensions)(x.identifier,{id:d}));if(j){if(!f&&(!R||R==="prerelease"&&j.preRelease))return s.log((0,g.localize)(5,null,d,j.manifest.version,d)),!1;if(R&&j.manifest.version===R)return s.log((0,g.localize)(6,null,`${d}@${R}`)),!1}return!0},o=(d,R,j)=>{a.push({id:d,version:R!=="prerelease"?R:void 0,installOptions:{...w,isBuiltin:j,installPreReleaseVersion:R==="prerelease"||w.installPreReleaseVersion}})},c=[],a=[];for(const d of u)if(d instanceof P.URI)c.push(d);else{const[R,j]=(0,m.getIdAndVersion)(d);r(R,j)&&o(R,j,!1)}for(const d of h){const[R,j]=(0,m.getIdAndVersion)(d);r(R,j)&&o(R,j,!0)}if(c.length&&await Promise.all(c.map(async d=>{try{const R=await this.f(d,{...w,isBuiltin:!1},f,s);R&&n.push(R)}catch(R){s.error(R.message||R.stack||R),i.push(d.toString())}})),a.length){const d=await this.g(a);await Promise.all(a.map(async R=>{const j=d.get(R.id.toLowerCase());if(j)try{const x=await this.h(R,j,t,f,s);x&&n.push(x)}catch(x){s.error(x.message||x.stack||x),i.push(R.id)}else s.error(`${p(R.version?`${R.id}@${R.version}`:R.id)}
${I}`),i.push(R.id)}))}if(i.length)throw new Error((0,g.localize)(7,null,i.join(", ")))}async f(u,h,w,f){const s=await this.a.getManifest(u);if(!s)throw new Error("Invalid vsix");if(await this.k(s,w,h.profileLocation,f))try{return await this.a.install(u,h),f.log((0,g.localize)(8,null,(0,T.basename)(u))),s}catch(n){if((0,D.isCancellationError)(n))return f.log((0,g.localize)(9,null,(0,T.basename)(u))),null;throw n}return null}async g(u){const h=new Map,w=u.some(s=>s.installOptions.installPreReleaseVersion),f=await this.b.getExtensions(u.map(s=>({...s,preRelease:w})),O.CancellationToken.None);for(const s of f)h.set(s.identifier.id.toLowerCase(),s);return h}async h({id:u,version:h,installOptions:w},f,s,i,n){const t=await this.b.getManifest(f,O.CancellationToken.None);if(t&&!this.j(t,n))return null;const r=s.find(o=>(0,m.areSameExtensions)(o.identifier,f.identifier));if(r){if(f.version===r.manifest.version)return n.log((0,g.localize)(10,null,h?`${u}@${h}`:u)),null;n.log((0,g.localize)(11,null,u,f.version))}try{w.isBuiltin?n.log(h?(0,g.localize)(12,null,u,h):(0,g.localize)(13,null,u)):n.log(h?(0,g.localize)(14,null,u,h):(0,g.localize)(15,null,u));const o=await this.a.installFromGallery(f,{...w,installGivenVersion:!!h});return n.log((0,g.localize)(16,null,u,o.manifest.version)),t}catch(o){if((0,D.isCancellationError)(o))return n.log((0,g.localize)(17,null,u)),null;throw o}}j(u,h){return!0}async k(u,h,w,f){const s={id:(0,m.getGalleryExtensionId)(u.publisher,u.name)},n=(await this.a.getInstalled(1,w)).find(t=>(0,m.areSameExtensions)(s,t.identifier)&&(0,L.gt)(t.manifest.version,u.version));return n&&!h?(f.log((0,g.localize)(18,null,n.identifier.id,n.manifest.version,u.version)),!1):this.j(u,f)}async uninstallExtensions(u,h,w,f=console){const s=async n=>{if(n instanceof P.URI){const t=await this.a.getManifest(n);return v(t)}return n},i=[];for(const n of u){const t=await s(n),o=(await this.a.getInstalled(void 0,w)).filter(c=>(0,m.areSameExtensions)(c.identifier,{id:t}));if(!o.length)throw new Error(`${this.l(t)}
${I}`);if(o.some(c=>c.type===0)){f.log((0,g.localize)(19,null,t));return}if(!h&&o.some(c=>c.isBuiltin)){f.log((0,g.localize)(20,null,t));return}f.log((0,g.localize)(21,null,t));for(const c of o)await this.a.uninstall(c,{profileLocation:w}),i.push(c);this.d?f.log((0,g.localize)(22,null,t,this.d)):f.log((0,g.localize)(23,null,t))}}async locateExtension(u,h=console){const w=await this.a.getInstalled();u.forEach(f=>{w.forEach(s=>{if(s.identifier.id===f&&s.location.scheme===k.Schemas.file){h.log(s.location.fsPath);return}})})}l(u){return this.d?(0,g.localize)(24,null,u,this.d):(0,g.localize)(25,null,u)}};S=de([ee(0,l.IExtensionManagementService),ee(1,l.IExtensionGalleryService)],S),e.ExtensionManagementCLI=S}),define(Y[41],Z([0,1,4,14,2,3,34,11,24,13,7,9]),function(W,e,O,D,k,T,L,P,g,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let p=class extends k.Disposable{constructor(v,S){super(),this.h=v,this.i=S,this.a=this.B(new T.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new T.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new T.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new T.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new L.ResourceMap}scanProfileExtensions(v){return this.j(v)}async addExtensionsToProfile(v,S){const y=[],u=[];try{return await this.j(S,h=>{const w=[];for(const f of h)v.some(([s])=>(0,g.areSameExtensions)(s.identifier,f.identifier)&&s.manifest.version!==f.version)?y.push(f):w.push(f);for(const[f,s]of v)if(!w.some(i=>(0,g.areSameExtensions)(i.identifier,f.identifier)&&i.version===f.manifest.version)){const i={identifier:f.identifier,version:f.manifest.version,location:f.location,metadata:s};u.push(i),w.push(i)}return u.length&&this.a.fire({extensions:u,profileLocation:S}),y.length&&this.c.fire({extensions:y,profileLocation:S}),w}),u.length&&this.b.fire({extensions:u,profileLocation:S}),y.length&&this.f.fire({extensions:y,profileLocation:S}),u}catch(h){throw u.length&&this.b.fire({extensions:u,error:h,profileLocation:S}),y.length&&this.f.fire({extensions:y,error:h,profileLocation:S}),h}}async removeExtensionFromProfile(v,S){const y=[];this.c.fire({extensions:y,profileLocation:S});try{await this.j(S,u=>{const h=[];for(const w of u)(0,g.areSameExtensions)(w.identifier,v.identifier)?y.push(w):h.push(w);return y.length&&this.c.fire({extensions:y,profileLocation:S}),h}),y.length&&this.f.fire({extensions:y,profileLocation:S})}catch(u){throw y.length&&this.f.fire({extensions:y,error:u,profileLocation:S}),u}}async j(v,S){return this.k(v).queue(async()=>{let y=[];try{const u=await this.h.readFile(v),h=JSON.parse(u.value.toString());for(const w of h){if(!w.identifier){this.i.info("Ignoring invalid extension while scanning. Identifier does not exist.",w);continue}if(!w.location){this.i.info("Ignoring invalid extension while scanning. Location does not exist.",w);continue}if(!w.version){this.i.info("Ignoring invalid extension while scanning. Version does not exist.",w);continue}y.push({identifier:w.identifier,location:P.URI.revive(w.location),version:w.version,metadata:w.metadata})}}catch(u){u.fileOperationResult!==1&&this.i.error(u)}if(S){y=S(y);const u=y.map(h=>({identifier:h.identifier,version:h.version,location:h.location.toJSON(),metadata:h.metadata}));await this.h.writeFile(v,D.VSBuffer.fromString(JSON.stringify(u)))}return y})}k(v){let S=this.g.get(v);return S||(S=new O.Queue,this.g.set(v,S)),S}};p=de([ee(0,l.IFileService),ee(1,E.ILogService)],p),e.ExtensionsProfileScannerService=p}),define(Y[125],Z([0,1,4,10,2,16,12,17,39,31,20,21,18,23,24,59,13,9]),function(W,e,O,D,k,T,L,P,g,l,m,E,p,I,v,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let h=class Ve extends k.Disposable{constructor(f,s,i,n,t,r){super(),this.h=s,this.i=i,this.j=n,this.k=t,this.l=r,this.extensionsDownloadDir=f.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(f,s){await this.g;const i=(0,P.joinPath)(this.extensionsDownloadDir,this.u(f));try{await this.n(f,i,t=>this.i.download(f,t,s))}catch(t){throw new I.ExtensionManagementError(t.message,I.ExtensionManagementErrorCode.Download)}let n=!1;if(f.isSigned&&this.j.getValue("extensions.verifySignature")===!0){const t=await this.m(f);try{n=await this.k.verify(i.fsPath,t.fsPath),this.l.info(`Verified extension: ${f.identifier.id}`,n)}catch(r){throw await this.delete(t),await this.delete(i),new I.ExtensionManagementError(r.code,I.ExtensionManagementErrorCode.Signature)}}return{location:i,verified:n}}async m(f){await this.g;const s=(0,P.joinPath)(this.extensionsDownloadDir,`${this.u(f)}${Ve.c}`);return await this.n(f,s,i=>this.i.downloadSignatureArchive(f,i)),s}async n(f,s,i){if(await this.h.exists(s))return;if(s.scheme!==T.Schemas.file){await i(s);return}const n=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,l.generateUuid)()}`);await this.h.exists(n)||await i(n);try{await this.r(n,s,Date.now()+2*60*1e3)}catch(t){try{await this.h.del(n)}catch{}if(t.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",f.identifier.id,s.path);else throw this.l.info(`Rename failed because of ${(0,D.getErrorMessage)(t)}. Deleted the file from downloaded location`,n.path),t}}async delete(f){await this.g,await this.h.del(f)}async r(f,s,i){try{await m.Promises.rename(f.fsPath,s.fsPath)}catch(n){if(L.isWindows&&n&&n.code==="EPERM"&&Date.now()<i)return this.l.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.r(f,s,i);throw n}}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const f=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],i=[],n=[];for(const o of f.children)if(o.name.endsWith(Ve.c))n.push(o.resource);else{const c=v.ExtensionKey.parse(o.name);c&&i.push([c,o])}const t=(0,v.groupByExtension)(i,([o])=>o),r=[];for(const o of t)o.sort((c,a)=>g.rcompare(c[0].version,a[0].version)),s.push(...o.slice(1).map(c=>c[1].resource)),r.push(o[0][1]);r.sort((o,c)=>o.mtime-c.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.f)).map(o=>o.resource)),s.push(...n),await O.Promises.settled(s.map(o=>(this.l.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(f){this.l.error(f)}}u(f){return this.f?v.ExtensionKey.create(f).toString().toLowerCase():(0,l.generateUuid)()}};h.c=".sigzip",h=de([ee(0,p.INativeEnvironmentService),ee(1,y.IFileService),ee(2,I.IExtensionGalleryService),ee(3,E.IConfigurationService),ee(4,S.IExtensionSignatureVerificationService),ee(5,u.ILogService)],h),e.ExtensionsDownloader=h}),define(Y[126],Z([0,1,2,15,20,29]),function(W,e,O,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class L extends O.Disposable{constructor(g,l){super(),this.b=g,this.a=(0,D.join)(this.b.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this.B(l.onDidInstallExtensions(m=>this.c(m))),this.B(l.onDidUninstallExtension(m=>this.f(m)))}c(g){g.some(l=>!!l.local)&&this.invalidate()}f(g){g.error||this.invalidate()}invalidate(){k.Promises.rm(this.a,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=L}),define(Y[127],Z([0,1,3,2,34,24,29]),function(W,e,O,D,k,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends D.Disposable{constructor(l,m,E,p,I,v){super(),this.f=l,this.g=m,this.h=E,this.i=p,this.j=I,this.k=v,this.a=this.B(new O.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.DisposableMap),this.l().then(null,S=>v.error(S))}async l(){await this.f.migrateDefaultProfileExtensions(),await this.n(this.g.profiles,[]),this.m(),await this.C()}m(){this.B(this.g.onDidChangeProfiles(l=>this.n(l.added,l.removed))),this.B(this.h.onAddExtensions(l=>this.p(l))),this.B(this.h.onDidAddExtensions(l=>this.r(l))),this.B(this.h.onRemoveExtensions(l=>this.s(l))),this.B(this.h.onDidRemoveExtensions(l=>this.t(l))),this.B(this.j.onDidFilesChange(l=>this.u(l)))}async n(l,m){try{await Promise.all(m.map(E=>(this.c.deleteAndDispose(E.id),this.y(E.extensionsResource))))}catch(E){this.k.error(E)}try{l.length&&await Promise.all(l.map(E=>(this.c.set(E.id,(0,D.combinedDisposable)(this.j.watch(this.i.extUri.dirname(E.extensionsResource)),this.j.watch(E.extensionsResource))),this.w(E.extensionsResource))))}catch(E){this.k.error(E)}}async p(l){for(const m of l.extensions)this.D(this.G(m.identifier,m.version),l.profileLocation)}async r(l){for(const m of l.extensions){const E=this.G(m.identifier,m.version);l.error?this.F(E,l.profileLocation):this.D(E,l.profileLocation)}}async s(l){for(const m of l.extensions)this.F(this.G(m.identifier,m.version),l.profileLocation)}async t(l){let m=!1;for(const E of l.extensions){const p=this.G(E.identifier,E.version);l.error?this.D(p,l.profileLocation):(this.F(p,l.profileLocation),m=m||!this.b.has(p))}m&&await this.C()}u(l){for(const m of this.g.profiles)l.contains(m.extensionsResource,0,1)&&this.v(m.extensionsResource)}async v(l){const m=[],E=[],p=await this.h.scanProfileExtensions(l),I=new Set,v=new Set;for(const[S,y]of this.b)y.has(l)&&v.add(S);for(const S of p){const y=this.G(S.identifier,S.version);I.add(y),v.has(y)||(m.push(S.identifier),this.D(y,l))}for(const S of v)if(!I.has(S)){const y=this.H(S);y&&(E.push(y.identifier),this.F(S,l))}(m.length||E.length)&&this.a.fire({added:m.length?{extensions:m,profileLocation:l}:void 0,removed:E.length?{extensions:E,profileLocation:l}:void 0})}async w(l){const m=await this.h.scanProfileExtensions(l);for(const E of m)this.D(this.G(E.identifier,E.version),l)}async y(l){for(const m of[...this.b.keys()])this.F(m,l);await this.C()}async C(){const m=(await this.f.getAllUserInstalled()).filter(E=>!this.b.has(this.G(E.identifier,E.manifest.version)));m.length&&await this.f.markAsUninstalled(...m)}D(l,m){let E=this.b.get(l);E||this.b.set(l,E=new k.ResourceSet(p=>this.i.extUri.getComparisonKey(p))),E.add(m)}F(l,m){const E=this.b.get(l);E&&E.delete(m),E?.size||this.b.delete(l)}G(l,m){return`${L.ExtensionIdentifier.toKey(l.id)}@${m}`}H(l){const[m,E]=(0,T.getIdAndVersion)(l);return E?{identifier:{id:m},version:E}:void 0}}e.ExtensionsWatcher=P}),define(Y[128],Z([0,1,158,19,4,2,16,15,20,18,23,24,9,63,12,11]),function(W,e,O,D,k,T,L,P,g,l,m,E,p,I,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let y=class extends I.LanguagePackBaseService{constructor(f,s,i,n){super(i),this.h=f,this.i=n,this.g=this.B(new u(s,n)),this.h.registerParticipant({postInstall:async t=>this.j(t),postUninstall:async t=>this.k(t)})}async getBuiltInExtensionTranslationsUri(f){const i=(await this.g.getLanguagePacks())[v.Language.value()];if(!i){this.i.warn(`No language pack found for ${v.Language.value()}`);return}const n=i.translations[f];return n?S.URI.file(n):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),s=Object.keys(f).map(i=>{const n=f[i];return{...this.f(i,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return s.push({...this.f("en","English"),extensionId:"default"}),s.sort((i,n)=>i.label.localeCompare(n.label)),s}async j(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",f.identifier.id),await this.update())}async k(f){const s=await this.g.getLanguagePacks();Object.keys(s).some(i=>s[i]&&s[i].extensions.some(n=>(0,E.areSameExtensions)(n.extensionIdentifier,f.identifier)))&&(this.i.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,s]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),i=await this.g.update(s);return!(0,D.equals)(Object.keys(f),Object.keys(i))}};y=de([ee(0,m.IExtensionManagementService),ee(1,l.INativeEnvironmentService),ee(2,m.IExtensionGalleryService),ee(3,p.ILogService)],y),e.NativeLanguagePackService=y;let u=class extends T.Disposable{constructor(f,s){super(),this.i=s,this.c={},this.f=(0,P.join)(f.userDataPath,"languagepacks.json"),this.g=new k.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.m(s=>{Object.keys(s).forEach(i=>delete s[i]),this.j(s,...f)}).then(()=>this.c)}j(f,...s){for(const i of s)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.k(f,i);Object.keys(f).forEach(i=>this.l(f[i]))}k(f,s){const i=s.identifier,n=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const t of n)if(s.location.scheme===L.Schemas.file&&h(t)){let r=f[t.languageId];r||(r={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},f[t.languageId]=r);const o=r.extensions.filter(c=>(0,E.areSameExtensions)(c.extensionIdentifier,i))[0];o?o.version=s.manifest.version:r.extensions.push({extensionIdentifier:i,version:s.manifest.version});for(const c of t.translations)r.translations[c.id]=(0,P.join)(s.location.fsPath,c.path)}}l(f){if(f){const s=(0,O.createHash)("md5");for(const i of f.extensions)s.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);f.hash=s.digest("hex")}}m(f=()=>null){return this.g.queue(()=>{let s=null;return g.Promises.readFile(this.f,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch{return{}}}).then(i=>(s=f(i),i)).then(i=>{for(const t of Object.keys(i))i[t]||delete i[t];this.c=i,this.h=!0;const n=JSON.stringify(this.c);return this.i.debug("Writing language packs",n),g.Promises.writeFile(this.f,n)}).then(()=>s,i=>this.i.error(i))})}};u=de([ee(0,l.INativeEnvironmentService),ee(1,p.ILogService)],u);function h(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const f of w.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}}),define(Y[47],Z([0,1,14,95,40,7,35]),function(W,e,O,D,k,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function P(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=P;function g(S){return S.res.statusCode===204}async function l(S){return g(S)?null:(await(0,O.streamToBuffer)(S.stream)).toString()}e.asText=l;async function m(S){if(!P(S))throw new Error("Server returned "+S.res.statusCode);return l(S)}e.asTextOrError=m;async function E(S){if(!P(S))throw new Error("Server returned "+S.res.statusCode);if(g(S))return null;const u=(await(0,O.streamToBuffer)(S.stream)).toString();try{return JSON.parse(u)}catch(h){throw h.message+=`:
`+u,h}}e.asJson=E;function p(S){v(S)}e.updateProxyConfigurationsScope=p;let I;function v(S){const y=L.Registry.as(k.Extensions.Configuration),u=I;I={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[I],remove:u?[u]:[]})}v(2)}),define(Y[129],Z([0,1,22,16,13,47]),function(W,e,O,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let L=class{constructor(g,l){this.a=g,this.b=l}async download(g,l,m=O.CancellationToken.None){if(g.scheme===D.Schemas.file||g.scheme===D.Schemas.vscodeRemote){await this.b.copy(g,l);return}const E={type:"GET",url:g.toString(!0)},p=await this.a.request(E,m);if(p.res.statusCode===200)await this.b.writeFile(l,p.stream);else{const I=await(0,T.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${I}`)}}};L=de([ee(0,T.IRequestService),ee(1,k.IFileService)],L),e.DownloadService=L}),define(Y[130],Z([0,1,131,8]),function(W,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(L,P){return L.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:L.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function T(L,P,g={}){const l=(0,O.parse)(L),m=g.proxyUrl||k(l,P);if(!m)return null;const E=(0,O.parse)(m);if(!/^https?:$/.test(E.protocol||""))return null;const p={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,D.isBoolean)(g.strictSSL)?g.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((I,v)=>{W(["http-proxy-agent"],I,v)}))(p):new(await new Promise((I,v)=>{W(["https-proxy-agent"],I,v)}))(p)}e.getProxyAgent=T}),define(Y[132],Z([0,1,57,15,96,22,32,10,12,31,78,159,4]),function(W,e,O,D,k,T,L,P,g,l,m,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const I=1e4;let v;async function S(u,h,w){return h["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(w)&&!h["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(w)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=p.Promises.withAsyncBody(async(f,s)=>{const i=new T.CancellationTokenSource,n=setTimeout(()=>{i.dispose(!0),s(new Error((0,k.localize)(0,null)))},I);try{f(await y(u,i.token))}catch(t){!(0,P.isCancellationError)(t)&&!i.token.isCancellationRequested?s(new Error((0,k.localize)(1,null,(0,L.toErrorMessage)(t)))):f({})}finally{clearTimeout(n),i.dispose()}})),v)}e.getResolvedShellEnv=S;async function y(u,h){const w=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",w);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",f);const s=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",n);const t=await(0,m.getSystemShell)(g.OS,n);return u.trace("getUnixShellEnvironment#shell",t),new Promise((r,o)=>{if(h.isCancellationRequested)return o((0,P.canceled)());const c=(0,D.basename)(t);let a,d;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(a=`& '${process.execPath}' ${R} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,d=["-Login","-Command"]):(a=`'${process.execPath}' ${R} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,c==="tcsh"?d=["-ic"]:d=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),a);const j=(0,O.spawn)(t,[...d,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});h.onCancellationRequested(()=>(j.kill(),o((0,P.canceled)()))),j.on("error",J=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(J)),o(J)});const x=[];j.stdout.on("data",J=>x.push(J));const K=[];j.stderr.on("data",J=>K.push(J)),j.on("close",(J,ie)=>{const se=Buffer.concat(x).toString("utf8");u.trace("getUnixShellEnvironment#raw",se);const Q=Buffer.concat(K).toString("utf8");if(Q.trim()&&u.trace("getUnixShellEnvironment#stderr",Q),J||ie)return o(new Error((0,k.localize)(2,null,J,ie)));const ge=i.exec(se),ce=ge?ge[1]:"{}";try{const oe=JSON.parse(ce);w?oe.ELECTRON_RUN_AS_NODE=w:delete oe.ELECTRON_RUN_AS_NODE,f?oe.ELECTRON_NO_ATTACH_CONSOLE=f:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",oe),r(oe)}catch(oe){u.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(oe)),o(oe)}})})}}),define(Y[66],Z([0,1,7]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,O.createDecorator)("stateService")}),define(Y[133],Z([0,1,4,14,8,18,13,9]),function(W,e,O,D,k,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class g{constructor(E,p,I){this.f=E,this.g=p,this.h=I,this.a=Object.create(null),this.b="",this.c=new O.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(E){E.fileOperationResult!==1&&this.g.error(E)}}getItem(E,p){const I=this.a[E];return(0,k.isUndefinedOrNull)(I)?p:I}setItem(E,p){this.setItems([{key:E,data:p}])}setItems(E){let p=!1;for(const{key:I,data:v}of E)this.a[I]!==v&&((0,k.isUndefinedOrNull)(v)?(0,k.isUndefined)(this.a[I])||(this.a[I]=void 0,p=!0):(this.a[I]=v,p=!0));p&&this.j()}removeItem(E){(0,k.isUndefined)(this.a[E])||(this.a[E]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const E=JSON.stringify(this.a,null,4);if(E!==this.b)try{await this.h.writeFile(this.f,D.VSBuffer.fromString(E)),this.b=E}catch(p){this.g.error(p)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=g;let l=class{constructor(E,p,I){this.a=new g(E.stateResource,p,I)}async init(){await this.a.init()}getItem(E,p){return this.a.getItem(E,p)}};l=de([ee(0,T.IEnvironmentService),ee(1,P.ILogService),ee(2,L.IFileService)],l),e.StateService=l}),define(Y[67],Z([0,1,12,33,11,31]),function(W,e,O,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(l){if(O.platform===2&&/^penguin(\.|$)/i.test(l))return"chromebook"}async function P(l,m,E,p,I,v,S,y,u,h){const w=Object.create(null);w["common.machineId"]=S,w.sessionID=(0,T.generateUuid)()+Date.now(),w.commitHash=I,w.version=v,w["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,O.PlatformToString)(O.platform),w["common.nodePlatform"]=D.platform,w["common.nodeArch"]=p,w["common.product"]=h||"desktop",y&&(w["common.msftInternal"]=y);let f=0;const s=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),O.isLinuxSnap&&(w["common.snap"]="true");const i=L(E);i&&(w["common.platformDetail"]=i);try{const n=await l.readFile(k.URI.file(u));w["common.source"]=n.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=P;function g(l){const m=D.env.USERDNSDOMAIN;if(!m)return!1;const E=m.toLowerCase();return l.some(p=>E===p)}e.verifyMicrosoftInternalDomain=g}),define(Y[36],Z([0,1,7]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,O.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,O.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(D=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Y[42],Z([0,1,26,52,8,21,67,36]),function(W,e,O,D,k,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class g{constructor(c){this.value=c}}e.TrustedTelemetryValue=g;class l{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,D.staticObservableValue)(0)}publicLog(c,a){return Promise.resolve(void 0)}publicLog2(c,a){return this.publicLog(c,a)}publicLogError(c,a){return Promise.resolve(void 0)}publicLogError2(c,a){return this.publicLogError(c,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=l,e.NullTelemetryService=new l;class m{async publicLog(c,a,d){}async publicLogError(c,a,d){}}e.NullEndpointTelemetryService=m,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(o,c){return c.onDidChangeConfiguration(a=>{a.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(a.source),configurationKeys:w(a.sourceConfig)})})}e.configurationTelemetry=E;function p(o,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!o.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=p;function I(o,c){return!(c.isBuilt||c.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=I;function v(o){const c=o.getValue(P.TELEMETRY_SETTING_ID),a=o.getValue("telemetry.enableCrashReporter");if(o.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function S(o){const c={},a={},d={};h(o,d);for(let R in d){R=R.length>150?R.substr(R.length-149):R;const j=d[R];typeof j=="number"?a[R]=j:typeof j=="boolean"?a[R]=j?1:0:typeof j=="string"?(j.length>8192&&console.warn(`Telemetry property: ${R} has been trimmed to 8192, the original length is ${j.length}`),c[R]=j.substring(0,8191)):typeof j<"u"&&j!==null&&(c[R]=j)}return{properties:c,measurements:a}}e.validateTelemetryData=S;const y=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function u(o){if(!o)return"none";for(const c of y)if(o.startsWith(`${c}+`))return c;return"other"}e.cleanRemoteAuthority=u;function h(o,c,a=0,d){if(!!o)for(const R of Object.getOwnPropertyNames(o)){const j=o[R],x=d?d+R:R;Array.isArray(j)?c[x]=(0,O.safeStringify)(j):j instanceof Date?c[x]=j.toISOString():(0,k.isObject)(j)?a<2?h(j,c,a+1,x+"."):c[x]=(0,O.safeStringify)(j):c[x]=j}}function w(o){if(!o)return[];const c=[];return f(c,"",o),c}function f(o,c,a){a&&typeof a=="object"&&!Array.isArray(a)?Object.keys(a).forEach(d=>f(o,c?`${c}.${d}`:d,a[d])):o.push(c)}function s(o,c){const a=o.msftInternalDomains||[],d=c.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(a)||d}e.isInternalTelemetry=s;function i(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=i;function n(o,c){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let a=o;const d=[];for(const K of c)for(;;){const J=K.exec(o);if(!J)break;d.push([J.index,K.lastIndex])}const R=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,j=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let x=0;for(a="";;){const K=j.exec(o);if(!K)break;const J=d.some(([ie,se])=>K.index<se&&ie<j.lastIndex);!R.test(K[0])&&!J&&(a+=o.substring(x,K.index)+"<REDACTED: user-file-path>",x=j.lastIndex)}return x<o.length&&(a+=o.substr(x)),a}function t(o){if(!o)return o;const c=o.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of a)if(d.regex.test(c))return`<REDACTED: ${d.label}>`;return o}function r(o,c){return(0,O.cloneAndChange)(o,a=>{if(a instanceof g)return a.value;if(typeof a=="string"){let d=a;d=n(d,c);for(const R of c)d=d.replace(R,"");return d=t(d),d}})}e.cleanData=r}),define(Y[134],Z([0,1,105,42]),function(W,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(T,L,P,g,l,m,E){const p={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${L.nameShort})`};if((0,D.supportsTelemetry)(L,P)&&(0,D.getTelemetryLevel)(g)===3){const I=await(0,O.getServiceMachineId)(P,l,m),{machineId:v}=await E.getTelemetryInfo();p["X-Market-User-Id"]=I,p["VSCode-SessionId"]=v}return p}e.resolveMarketplaceHeaders=k}),define(Y[135],Z([0,1,10,26,42]),function(W,e,O,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function L(g,l,m){const E=await new Promise((y,u)=>{W(["@microsoft/1ds-core-js"],y,u)}),p=await new Promise((y,u)=>{W(["@microsoft/1ds-post-js"],y,u)}),I=new E.AppInsightsCore,v=new p.PostChannel,S={instrumentationKey:g,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(m){S.extensionConfig={};const y={alwaysUseXhrOverride:!0,httpXHROverride:m};S.extensionConfig[v.identifier]=y}return I.initialize(S,[]),I.addTelemetryInitializer(y=>{l&&(y.ext=y.ext??{},y.ext.utc=y.ext.utc??{},y.ext.utc.flags=8462029)}),I}class P{constructor(l,m,E,p,I){this.d=l,this.e=m,this.f=E,this.g=I,this.c=T,this.f||(this.f={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}h(l){if(!!this.a){if(typeof this.a!="string"){l(this.a);return}this.b||(this.b=L(this.a,this.d,this.g)),this.b.then(m=>{l(m)},m=>{(0,O.onUnexpectedError)(m),console.error(m)})}}log(l,m){if(!this.a)return;m=(0,D.mixin)(m,this.f),m=(0,k.validateTelemetryData)(m);const E=this.e+"/"+l;try{this.h(p=>{p.pluginVersionString=m?.properties.version??"Unknown",p.track({name:E,baseData:{name:E,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(l=>{this.h(m=>{m.unload(!0,()=>{this.a=void 0,l(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(Y[136],Z([0,1,2,26,52,12,27,97,21,40,137,28,35,36,42]),function(W,e,O,D,k,T,L,P,g,l,m,E,p,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(h,w,f){this.j=w,this.k=f,this.d={},this.telemetryLevel=new k.MutableObservableValue(3),this.h=new O.DisposableStore,this.i=[],this.b=h.appenders,this.c=h.commonProperties||Promise.resolve({}),this.f=h.piiPaths||[],this.g=!!h.sendErrorTelemetry,this.i=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const s of this.f)this.i.push(new RegExp((0,L.escapeRegExpCharacters)(s),"gi")),s.indexOf("\\")>=0&&this.i.push(new RegExp((0,L.escapeRegExpCharacters)(s.replace(/\\/g,"/")),"gi"));this.l(),this.j.onDidChangeConfiguration(this.l,this,this.h)}setExperimentProperty(h,w){this.d[h]=w}l(){let h=(0,v.getTelemetryLevel)(this.j);const w=this.k.enabledTelemetryLevels;if(w){this.g=this.sendErrorTelemetry?w.error:!1;const f=w.usage?3:w.error?2:0;h=Math.min(h,f)}this.telemetryLevel.value=h}get sendErrorTelemetry(){return this.g}async getTelemetryInfo(){const h=await this.c,w=h.sessionID,f=h["common.machineId"],s=h["common.firstSessionDate"],i=h["common.msftInternal"];return{sessionId:w,machineId:f,firstSessionDate:s,msftInternal:i}}dispose(){this.h.dispose()}m(h,w,f){return this.telemetryLevel.value<w?Promise.resolve(void 0):this.c.then(s=>{f=(0,D.mixin)(f,this.d),f=(0,v.cleanData)(f,this.i),f=(0,D.mixin)(f,s),this.b.forEach(i=>i.log(h,f))},s=>{console.error(s)})}publicLog(h,w){return this.m(h,3,w)}publicLog2(h,w){return this.publicLog(h,w)}publicLogError(h,w){return this.g?this.m(h,2,w):Promise.resolve(void 0)}publicLogError2(h,w){return this.publicLogError(h,w)}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=de([ee(1,g.IConfigurationService),ee(2,E.IProductService)],S),e.TelemetryService=S;function y(){const u=(0,P.localize)(0,null,m.default.nameLong),h=m.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=T.isWeb?"":(0,P.localize)(3,null),f=(0,P.localize)(4,null),s=(0,P.localize)(5,null),i=(0,P.localize)(6,null),n=(0,P.localize)(7,null),t=`
|       | ${f} | ${s} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,P.localize)(8,null);return`
${u} ${h} ${w}

&nbsp;

${n}
${t}

&nbsp;

${r}
`}p.Registry.as(l.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(l.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,P.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,P.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[138],Z([0,1,160,135]),function(W,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends D.AbstractOneDataSystemAppender{constructor(L,P,g,l){const m={sendPOST:(E,p)=>{const I={method:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data)}};try{const v=O.request(E.urlString,I,S=>{S.on("data",function(y){p(S.statusCode??200,S.headers,y.toString())}),S.on("error",function(y){p(0,{})})});v.write(E.data),v.end()}catch{p(0,{})}}};super(L,P,g,l,m)}}e.OneDataSystemAppender=k}),define(Y[139],Z([0,1,15,20]),function(W,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function k(T,L){const P=Object.create(null),g=(m,E)=>{const p=JSON.parse(m);P[E]=p};if(L){const m=[],E=await D.Promises.readdir(L);for(const I of E)try{(await D.Promises.stat((0,O.join)(L,I))).isDirectory()&&m.push(I)}catch{}const p=[];for(const I of m)(await D.Promises.readdir((0,O.join)(L,I))).filter(S=>S==="telemetry.json").length===1&&p.push(I);for(const I of p){const v=(await D.Promises.readFile((0,O.join)(L,I,"telemetry.json"))).toString();g(v,I)}}let l=(await D.Promises.readFile((0,O.join)(T,"telemetry-core.json"))).toString();return g(l,"vscode-core"),l=(await D.Promises.readFile((0,O.join)(T,"telemetry-extensions.json"))).toString(),g(l,"vscode-extensions"),JSON.stringify(P,null,4)}e.buildTelemetryMessage=k}),define(Y[30],Z([0,1,7]),function(W,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,O.createDecorator)("IUriIdentityService")}),define(Y[140],Z([0,1,30,106,13,17,70,3,2]),function(W,e,O,D,k,T,L,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{constructor(p){this.uri=p,this.time=l._clock++}touch(){return this.time=l._clock++,this}}l._clock=0;let m=class{constructor(p){this.g=p,this.c=new g.DisposableStore,this.f=2**16;const I=new Map,v=S=>{let y=I.get(S.scheme);return y===void 0&&(y=p.hasProvider(S)&&!this.g.hasCapability(S,1024),I.set(S.scheme,y)),y};this.c.add(P.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(S=>{I.delete(S.scheme)})),this.extUri=new T.ExtUri(v),this.d=new L.SkipList((S,y)=>this.extUri.compare(S,y,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,T.normalizePath)(p));const I=this.d.get(p);return I?I.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new l(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((v,S)=>v[1].touch<S[1].touch?1:v[1].touch>S[1].touch?-1:0);l._clock=0,this.d.clear();const I=this.f*.5;for(let v=0;v<I;v++)this.d.set(p[v][0],p[v][1].touch())}};m=de([ee(0,k.IFileService)],m),e.UriIdentityService=m,(0,D.registerSingleton)(O.IUriIdentityService,m,1)}),define(Y[141],Z([0,1,99,15,114,17,11,7,16]),function(W,e,O,D,k,T,L,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function l(n){const t=n;return typeof t?.id=="string"&&L.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=l,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function m(n,t){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,D.basename)(n)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=n;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=m;function E(n){const t=n;return typeof t?.id=="string"&&L.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=E;function p(n){const t=n;if(t?.uri)return{id:t.id,uri:L.URI.revive(t.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:L.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=p;var I;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function v(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=v;function S(n){const t=n;return!!(t&&typeof t=="object"&&L.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=S;class y{constructor(t,r,o,c,a){this.h=t,this.j=o,this.k=c,this.l=a,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class u{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,T.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function h(n){return new u({uri:n,index:0,name:(0,T.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=h,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,O.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(n,t){return T.extUriBiasedIgnorePathCase.isEqualOrParent(n,t.untitledWorkspacesHome)}e.isUntitledWorkspace=w;function f(n){let t;return L.URI.isUri(n)?t=n:t=n.configuration,t?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=f;function s(n,t){return!w(n,t)&&!f(n)}e.isSavedWorkspace=s;function i(n){return(typeof n=="string"?(0,D.extname)(n):(0,T.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(Y[25],Z([0,1,53,3,2,17,11,98,18,13,7,9,141,34,30,4,31,27]),function(W,e,O,D,k,T,L,P,g,l,m,E,p,I,v,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function h(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&L.URI.isUri(t.location)&&L.URI.isUri(t.globalStorageHome)&&L.URI.isUri(t.settingsResource)&&L.URI.isUri(t.keybindingsResource)&&L.URI.isUri(t.tasksResource)&&L.URI.isUri(t.snippetsHome)&&L.URI.isUri(t.extensionsResource))}e.isUserDataProfile=h,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,m.createDecorator)("IUserDataProfilesService");function w(n,t){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:L.URI.revive(n.location).with({scheme:t}),globalStorageHome:L.URI.revive(n.globalStorageHome).with({scheme:t}),settingsResource:L.URI.revive(n.settingsResource).with({scheme:t}),keybindingsResource:L.URI.revive(n.keybindingsResource).with({scheme:t}),tasksResource:L.URI.revive(n.tasksResource).with({scheme:t}),snippetsHome:L.URI.revive(n.snippetsHome).with({scheme:t}),extensionsResource:L.URI.revive(n.extensionsResource)?.with({scheme:t}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=w;function f(n,t,r,o){return{id:n,name:t,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,T.joinPath)(r,"globalStorage"),settingsResource:(0,T.joinPath)(r,"settings.json"),keybindingsResource:(0,T.joinPath)(r,"keybindings.json"),tasksResource:(0,T.joinPath)(r,"tasks.json"),snippetsHome:(0,T.joinPath)(r,"snippets"),extensionsResource:(0,T.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=f;let s=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(t,r,o,c){super(),this.m=t,this.n=r,this.r=o,this.s=c,this.f=!1,this.g=this.B(new D.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new D.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new D.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new D.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new I.ResourceMap},this.profilesHome=(0,T.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(t){this.f!==t&&(this.t=void 0,this.f=t)}isEnabled(){return this.f}get u(){if(!this.t){const t=this.f?this.I().map(a=>f((0,T.basename)(a.location),a.name,a.location,{shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})):[];let r;const o=new I.ResourceMap,c=f((0,O.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(t.unshift({...c,isDefault:!0}),t.length){const a=this.L();if(a.workspaces)for(const[d,R]of Object.entries(a.workspaces)){const j=L.URI.parse(d),x=L.URI.parse(R),K=t.find(J=>this.r.extUri.isEqual(J.location,x));K&&o.set(j,K)}if(a.emptyWindow){const d=L.URI.parse(a.emptyWindow);r=t.find(R=>this.r.extUri.isEqual(R.location,d))}}this.t={profiles:t,workspaces:o,emptyWindow:r}}return this.t}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let c=0;for(const d of this.profiles){const R=o.exec(d.name),j=R?parseInt(R[1]):0;c=j>c?j:c}const a=`${r} ${c+1}`;return this.createProfile((0,O.hash)((0,y.generateUuid)()).toString(16),a,{transient:!0},t)}async createNamedProfile(t,r,o){return this.createProfile((0,O.hash)((0,y.generateUuid)()).toString(16),t,r,o)}async createProfile(t,r,o,c){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=await this.v(t,r,o);return c&&await this.setProfileForWorkspace(c,a),a}async v(t,r,o){let c=this.k.get(r);return c||(c=(async()=>{try{const a=this.profiles.find(j=>j.name===r||j.id===t);if(a)return a;const d=f(t,r,(0,T.joinPath)(this.profilesHome,t),o);await this.n.createFolder(d.location);const R=[];return this.h.fire({profile:d,join(j){R.push(j)}}),await S.Promises.settled(R),this.D([d],[],[]),d}finally{this.k.delete(r)}})(),this.k.set(r,c)),c}async updateProfile(t,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(c=>c.id===t.id);if(!o)throw new Error(`Profile '${t.name}' does not exist`);return o=f(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.D([],[],[o]),o}async removeProfile(t){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(c=>c.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this.i.fire({profile:r,join(c){o.push(c)}});try{await Promise.allSettled(o)}catch(c){this.s.error(c)}r.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const c of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(c)?.id&&this.u.workspaces.delete(c);this.H(),this.D([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(c){this.s.error(c)}}getOrSetProfileForWorkspace(t,r=this.defaultProfile){if(!this.f)return this.defaultProfile;let o=this.w(t);return o||(o=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,o)),o}async setProfileForWorkspace(t,r){this.setProfileForWorkspaceSync(t,r)}setProfileForWorkspaceSync(t,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(c=>c.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.G(t,o)}unsetWorkspace(t,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.G(t,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.H(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const t=await this.n.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.r.extUri.isEqual(o.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.l.profiles.filter(r=>!this.C(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}w(t){const r=this.y(t);return L.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindow??this.u.emptyWindow}y(t){return(0,p.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,p.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}C(t){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,t.location)||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,t.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,t.location)||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,t.location)))}D(t,r,o){const c=[...this.profiles,...t],a=[];this.l.profiles=[];for(let d of c)d.isDefault||r.some(R=>d.id===R.id)||(d=o.find(R=>d.id===R.id)??d,d.isTransient?this.l.profiles.push(d):a.push({location:d.location,name:d.name,shortName:d.shortName,useDefaultFlags:d.useDefaultFlags}));this.J(a),this.t=void 0,this.F(t,r,o)}F(t,r,o){this.g.fire({added:t,removed:r,updated:o,all:this.profiles})}G(t,r,o){o=r?.isTransient?!0:o,o||this.G(t,void 0,!0);const c=this.y(t),a=o?this.l:this.u;L.URI.isUri(c)?(a.workspaces.delete(c),r&&a.workspaces.set(c,r)):a.emptyWindow=r,o||this.H()}H(){const t={};for(const[o,c]of this.u.workspaces.entries())t[o.toString()]=c.location.toString();const r=this.u.emptyWindow?.location.toString();this.M({workspaces:t,emptyWindow:r}),this.t=void 0}I(){return[]}J(t){throw new Error("not implemented")}L(){return{}}M(t){throw new Error("not implemented")}};s.b="userDataProfiles",s.c="profileAssociations",s=de([ee(0,g.IEnvironmentService),ee(1,l.IFileService),ee(2,v.IUriIdentityService),ee(3,E.ILogService)],s),e.UserDataProfilesService=s;class i extends s{constructor(){super(...arguments),this.a=[],this.P={}}I(){return this.a}J(t){this.a=t}L(){return this.P}M(t){this.P=t}}e.InMemoryUserDataProfilesService=i}),define(Y[142],Z([0,1,19,4,22,10,3,2,12,11,83,23,24,29,9,28,36,25]),function(W,e,O,D,k,T,L,P,g,l,m,E,p,I,v,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let h=class extends P.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(t,r,o,c,a){super(),this.t=t,this.u=r,this.v=o,this.w=c,this.y=a,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new L.Emitter),this.m=this.B(new L.Emitter),this.n=this.B(new L.Emitter),this.p=this.B(new L.Emitter),this.s=[],this.B((0,P.toDisposable)(()=>{this.j.forEach(({task:d})=>d.cancel()),this.k.forEach(d=>d.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,E.isTargetPlatformCompatible)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.t.isEnabled())throw new E.ExtensionManagementError(m.localize(0,null),E.ExtensionManagementErrorCode.Internal);const o=await this.H(t,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.C(o.manifest,o.extension,r)}catch(o){throw s(this.u,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(t),error:o}),this.v.error("Failed to install extension.",t.identifier.id),this.v.error(o),f(o)}}async uninstall(t,r={}){return this.v.trace("ExtensionManagementService#uninstall",t.identifier.id),this.J(t,r)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.P(),this.h=t),this.g}registerParticipant(t){this.s.push(t)}async C(t,r,o){const c={...o,installOnlyNewlyAddedFromExtensionPack:l.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,I.isApplicationScopedExtension)(t)?this.y.defaultProfile.extensionsResource:o.profileLocation??this.Q()},a=J=>`${p.ExtensionKey.create(J).toString()}${c.profileLocation?`-${c.profileLocation.toString()}`:""}`;if(!l.URI.isUri(r)){const J=this.j.get(a(r));if(J){this.v.info("Extensions is already requested to install",r.identifier.id);const{local:ie}=await J.task.waitUntilTaskIsFinished();return ie}}const d=[],R=[],j=[],x=this.R(t,r,c);l.URI.isUri(r)||this.j.set(a(r),{task:x,waitingTasks:[]}),this.l.fire({identifier:x.identifier,source:r,profileLocation:c.profileLocation}),this.v.info("Installing extension:",x.identifier.id),d.push({task:x,manifest:t});let K=!1;try{if(c.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",x.identifier.id);else try{const ie=await this.G(x.identifier,t,!!c.installOnlyNewlyAddedFromExtensionPack,!!c.installPreReleaseVersion,c.profileLocation),se=await this.getInstalled(void 0,c.profileLocation);for(const{gallery:Q,manifest:ge}of ie){K=K||!!ge.extensionDependencies?.some(me=>(0,p.areSameExtensions)({id:me},x.identifier));const ce=a(Q),oe=this.j.get(ce);if(oe){if(this.D(x,oe.task)){this.v.info("Waiting for already requested installing extension",Q.identifier.id,x.identifier.id),oe.waitingTasks.push(x);const me=oe.task.identifier;R.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,M=>M.some(N=>(0,p.areSameExtensions)(N.identifier,me)))).then(M=>{if(!M.find(U=>(0,p.areSameExtensions)(U.identifier,me))?.local)throw new Error(`Extension ${me.id} is not installed`)}))}}else if(!se.some(({identifier:me})=>(0,p.areSameExtensions)(me,Q.identifier))){const me=this.R(ge,Q,{...c,donotIncludePackAndDependencies:!0});this.j.set(ce,{task:me,waitingTasks:[x]}),this.l.fire({identifier:me.identifier,source:Q,profileLocation:c.profileLocation}),this.v.info("Installing extension:",me.identifier.id,x.identifier.id),d.push({task:me,manifest:ge})}}}catch(ie){if(l.URI.isUri(x.source))(0,O.isNonEmptyArray)(t.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",x.identifier.id,ie.message),(0,O.isNonEmptyArray)(t.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",x.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",x.identifier.id),ie}const J=d.reduce((ie,{task:se,manifest:Q})=>(ie.set(se.identifier.id.toLowerCase(),{task:se,manifest:Q}),ie),new Map);for(;J.size;){let ie;const se=[...J.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(ge=>J.has(ge.toLowerCase())));se.length?ie=J.size===1?se:se.filter(({task:Q})=>!(Q===x&&!K)):(this.v.info("Found extensions with circular dependencies",se.map(({task:Q})=>Q.identifier.id)),ie=[...J.values()]),await this.F(ie.map(async({task:Q})=>{const ge=new Date().getTime();try{const{local:ce}=await Q.run();if(await this.F(this.s.map(oe=>oe.postInstall(ce,Q.source,c,k.CancellationToken.None))),!l.URI.isUri(Q.source)){const oe=Q.operation===3,me=oe?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(s(this.u,oe?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(Q.source),wasVerified:Q.wasVerified,duration:new Date().getTime()-ge,durationSinceUpdate:me}),g.isWeb&&Q.operation!==3)try{await this.t.reportStatistic(ce.manifest.publisher,ce.manifest.name,ce.manifest.version,"install")}catch{}}j.push({local:ce,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:c.context,profileLocation:c.profileLocation,applicationScoped:ce.isApplicationScoped})}catch(ce){throw l.URI.isUri(Q.source)||s(this.u,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(Q.source),wasVerified:Q.wasVerified,duration:new Date().getTime()-ge,error:ce}),this.v.error("Error while installing the extension:",Q.identifier.id),ce}finally{J.delete(Q.identifier.id.toLowerCase())}}))}return R.length&&await this.F(R),j.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire(j),j.filter(({identifier:ie})=>(0,p.areSameExtensions)(ie,x.identifier))[0].local}catch(J){if(d.forEach(({task:ie})=>ie.cancel()),j.length)try{const ie=await Promise.allSettled(j.map(({local:se})=>this.S(se,{versionOnly:!0,profileLocation:c.profileLocation}).run()));for(let se=0;se<ie.length;se++){const Q=ie[se],{identifier:ge}=j[se];Q.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",ge.id):this.v.warn("Rollback: Error while uninstalling extension",ge.id,(0,T.getErrorMessage)(Q.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,T.getErrorMessage)(ie),j.map(({identifier:se})=>se.id))}throw this.m.fire(d.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:c.context,profileLocation:c.profileLocation}))),J}finally{for(const[J,{task:ie,waitingTasks:se}]of this.j.entries()){const Q=se.indexOf(x);Q!==-1&&se.splice(Q,1),se.length===0&&(ie===x||Q!==-1)&&this.j.delete(J)}}}D(t,r){for(const[,{task:o,waitingTasks:c}]of this.j.entries())if(o===t&&(c.includes(r)||c.some(a=>this.D(a,r)))||o===r&&c[0]&&!this.D(t,c[0]))return!1;return!0}async F(t){const r=[],o=[],c=await Promise.allSettled(t);for(const a of c)a.status==="fulfilled"?r.push(a.value):o.push(a.reason);if(o.length)throw w(o);return r}async G(t,r,o,c,a){if(!this.t.isEnabled())return[];const d=await this.getInstalled(void 0,a),R=[t],j=[],x=async(K,J)=>{const ie=J.extensionDependencies||[],se=[...ie];if(J.extensionPack){const Q=o?d.find(ge=>(0,p.areSameExtensions)(ge.identifier,K)):void 0;for(const ge of J.extensionPack)Q&&Q.manifest.extensionPack&&Q.manifest.extensionPack.some(ce=>(0,p.areSameExtensions)({id:ce},{id:ge}))||se.every(ce=>!(0,p.areSameExtensions)({id:ce},{id:ge}))&&se.push(ge)}if(se.length){const Q=[...R,...j.map(ce=>ce.gallery.identifier)],ge=se.filter(ce=>Q.every(oe=>!(0,p.areSameExtensions)(oe,{id:ce})));if(ge.length){const ce=await this.t.getExtensions(ge.map(oe=>({id:oe,preRelease:c})),k.CancellationToken.None);for(const oe of ce){if(Q.find(N=>(0,p.areSameExtensions)(N,oe.identifier)))continue;const me=ie.some(N=>(0,p.areSameExtensions)({id:N},oe.identifier));let M;try{M=await this.H(oe,!1,c)}catch(N){if(N instanceof E.ExtensionManagementError&&N.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!me){this.v.info("Skipping the packed extension as it cannot be installed",oe.identifier.id);continue}else throw N}j.push({gallery:M.extension,manifest:M.manifest}),await x(M.extension.identifier,M.manifest)}}}};return await x(t,r),j}async H(t,r,o){if((await this.getExtensionsControlManifest()).malicious.some(R=>(0,p.areSameExtensions)(t.identifier,R)))throw new E.ExtensionManagementError(m.localize(1,null,t.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const R=await this.getTargetPlatform();throw new E.ExtensionManagementError(m.localize(2,null,t.identifier.id,this.w.nameLong,(0,E.TargetPlatformToString)(R)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.I(t,r,o);if(a){if(o&&!r&&t.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(m.localize(3,null,t.identifier.id,this.w.nameLong,this.w.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.t.getExtensions([t.identifier],k.CancellationToken.None))[0]?new E.ExtensionManagementError(m.localize(4,null,t.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(m.localize(5,null,t.identifier.id,this.w.nameLong,this.w.version),E.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",a.identifier.id);const d=await this.t.getManifest(a,k.CancellationToken.None);if(d===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(d.version!==a.version)throw new E.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:d}}async I(t,r,o){const c=await this.getTargetPlatform();let a=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(a=(await this.t.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},k.CancellationToken.None))[0]||null),!a&&await this.t.isExtensionCompatible(t,o,c)&&(a=t),a||(r?a=(await this.t.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:c,compatible:!0},k.CancellationToken.None))[0]||null:a=await this.t.getCompatibleExtension(t,o,c)),a}async J(t,r){const o={...r,profileLocation:t.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.Q()},c=K=>`${K.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,a=this.k.get(c(t.identifier));if(a)return this.v.info("Extensions is already requested to uninstall",t.identifier.id),a.waitUntilTaskIsFinished();const d=K=>{const J=this.S(K,o);return this.k.set(c(J.extension.identifier),J),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${K.identifier.id}@${K.manifest.version}`),this.n.fire({identifier:K.identifier,profileLocation:o.profileLocation,applicationScoped:K.isApplicationScoped}),J},R=(K,J)=>{J?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,o.profileLocation.toString(),J.message):this.v.error("Failed to uninstall extension:",`${K.identifier.id}@${K.manifest.version}`,J.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${K.identifier.id}@${K.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${K.identifier.id}@${K.manifest.version}`),s(this.u,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(K),error:J}),this.p.fire({identifier:K.identifier,error:J?.code,profileLocation:o.profileLocation,applicationScoped:K.isApplicationScoped})},j=[],x=[];try{j.push(d(t));const K=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const J=this.N(t,K);for(const ie of J)this.k.has(c(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):j.push(d(ie))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.L(j.map(J=>J.extension),K,t),await this.F(j.map(async J=>{try{if(await J.run(),await this.F(this.s.map(ie=>ie.postUninstall(J.extension,o,k.CancellationToken.None))),J.extension.identifier.uuid)try{await this.t.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,"uninstall")}catch{}R(J.extension)}catch(ie){const se=ie instanceof E.ExtensionManagementError?ie:new E.ExtensionManagementError((0,T.getErrorMessage)(ie),E.ExtensionManagementErrorCode.Internal);throw R(J.extension,se),se}finally{x.push(J)}}))}catch(K){const J=K instanceof E.ExtensionManagementError?K:new E.ExtensionManagementError((0,T.getErrorMessage)(K),E.ExtensionManagementErrorCode.Internal);for(const ie of j){try{ie.cancel()}catch{}x.includes(ie)||R(ie.extension,J)}throw J}finally{for(const K of j)this.k.delete(c(K.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",K.extension.identifier.id)}}L(t,r,o){for(const c of t){const a=this.O(c,r);if(a.length){const d=a.filter(R=>!t.some(j=>(0,p.areSameExtensions)(j.identifier,R.identifier)));if(d.length)throw new Error(this.M(c,d,o))}}}M(t,r,o){return o===t?r.length===1?m.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?m.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):m.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?m.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?m.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):m.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}N(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const c=t.manifest.extensionPack?t.manifest.extensionPack:[];if(c.length){const a=r.filter(R=>!R.isBuiltin&&c.some(j=>(0,p.areSameExtensions)({id:j},R.identifier))),d=[];for(const R of a)d.push(...this.N(R,r,o));return[...a,...d]}return[]}O(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,p.areSameExtensions)({id:c},t.identifier)))}async P(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const t=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};h=de([ee(0,E.IExtensionGalleryService),ee(1,y.ITelemetryService),ee(2,v.ILogService),ee(3,S.IProductService),ee(4,u.IUserDataProfilesService)],h),e.AbstractExtensionManagementService=h;function w(n){const t=Array.isArray(n)?n:[n];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=w;function f(n){if(n instanceof E.ExtensionManagementError)return n;const t=new E.ExtensionManagementError(n.message,E.ExtensionManagementErrorCode.Internal);return t.stack=n.stack,t}function s(n,t,{extensionData:r,wasVerified:o,duration:c,error:a,durationSinceUpdate:d}){let R,j;a&&(a instanceof E.ExtensionManagementError?(R=a.code,a.code===E.ExtensionManagementErrorCode.Signature&&(j=a.message)):R=E.ExtensionManagementErrorCode.Internal),n.publicLog(t,{...r,wasVerified:o,success:!a,duration:c,errorcode:R,errorcodeDetail:j,durationSinceUpdate:d})}e.reportTelemetry=s;class i{constructor(){this.d=new D.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.createCancelablePromise)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.createCancelablePromise)(t=>new Promise((r,o)=>{const c=t.onCancellationRequested(()=>{c.dispose(),o(new T.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=i}),define(Y[48],Z([0,1,19,4,26,14,10,50,75,2,16,15,12,17,39,54,8,11,87,18,24,29,45,13,7,9,28,3,44,41,25,30,103,104]),function(W,e,O,D,k,T,L,P,g,l,m,E,p,I,v,S,y,u,h,w,f,s,i,n,t,r,o,c,a,d,R,j,x,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var J;(function(me){function M(N,U){if(N===U)return!0;const V=Object.keys(N),G=new Set;for(const q of Object.keys(U))G.add(q);if(V.length!==G.size)return!1;for(const q of V){if(N[q]!==U[q])return!1;G.delete(q)}return G.size===0}me.equals=M})(J=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let ie=class extends l.Disposable{constructor(M,N,U,V,G,q,ne,F,b,A,C,B){super(),this.systemExtensionsLocation=M,this.userExtensionsLocation=N,this.l=U,this.m=V,this.n=G,this.p=q,this.r=ne,this.s=F,this.t=b,this.u=A,this.v=C,this.w=B,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,I.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(ge,(0,I.joinPath)(this.m,s.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(ge,(0,I.joinPath)(this.m,s.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(Q,this.h)),this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,f.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(M,N,U){const[V,G]=await Promise.all([this.scanSystemExtensions(M),this.scanUserExtensions(N)]),q=U?await this.scanExtensionsUnderDevelopment(M,[...V,...G]):[];return this.D(V,G,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(M){const N=[];N.push(this.F(!!M.useCache,M.language)),N.push(this.G(M.language,!!M.checkControlFile));const[U,V]=await Promise.all(N);return this.C([...U,...V],0,M,!1)}async scanUserExtensions(M){const N=M.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",N);const U=await this.I(N,!!M.profileLocation,1,!M.includeUninstalled,M.language);let G=await(M.useCache&&!U.devMode&&U.excludeObsolete?this.j:this.k).scanExtensions(U);return G=await this.C(G,1,M,!0),this.s.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(M,N){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const U=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(V=>V.scheme===m.Schemas.file).map(async V=>{const G=await this.I(V,!1,1,!0,M.language,!1);return(await this.k.scanOneOrMultipleExtensions(G)).map(ne=>(ne.type=N.find(F=>(0,f.areSameExtensions)(F.identifier,ne.identifier))?.type??ne.type,this.k.validate(ne,G)))}))).flat();return this.C(U,"development",M,!0)}return[]}async scanExistingExtension(M,N,U){const V=await this.I(M,!1,N,!0,U.language),G=await this.k.scanExtension(V);return!G||!U.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(M,N,U){const V=await this.I(M,!1,N,!0,U.language),G=await this.k.scanOneOrMultipleExtensions(V);return this.C(G,N,U,!0)}async scanMetadata(M){const N=(0,I.joinPath)(M,"package.json"),U=(await this.r.readFile(N)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(M,N){const U=(0,I.joinPath)(M,"package.json"),V=(await this.r.readFile(U)).value.toString(),G=JSON.parse(V);N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0,G.__metadata={...G.__metadata,...N},await this.r.writeFile((0,I.joinPath)(M,"package.json"),T.VSBuffer.fromString(JSON.stringify(G,null,"	")))}async C(M,N,U,V){return U.includeAllVersions||(M=this.D(N===0?M:void 0,N===1?M:void 0,N==="development"?M:void 0,await this.getTargetPlatform(),V)),U.includeInvalid||(M=M.filter(G=>G.isValid)),M.sort((G,q)=>{const ne=E.basename(G.location.fsPath),F=E.basename(q.location.fsPath);return ne<F?-1:ne>F?1:0})}D(M,N,U,V,G){const q=(F,b,A)=>{if(F.isValid&&!b.isValid)return!1;if(F.isValid===b.isValid){if(G&&v.gt(F.manifest.version,b.manifest.version))return this.s.debug(`Skipping extension ${b.location.path} with lower version ${b.manifest.version} in favour of ${F.location.path} with version ${F.manifest.version}`),!1;if(v.eq(F.manifest.version,b.manifest.version)){if(F.type===0)return this.s.debug(`Skipping extension ${b.location.path} in favour of system extension ${F.location.path} with same version`),!1;if(F.targetPlatform===V)return this.s.debug(`Skipping extension ${b.location.path} from different target platform ${b.targetPlatform}`),!1}}return A?this.s.warn(`Overwriting user extension ${F.location.path} with ${b.location.path}.`):this.s.debug(`Overwriting user extension ${F.location.path} with ${b.location.path}.`),!0},ne=new Map;return M?.forEach(F=>{const b=s.ExtensionIdentifier.toKey(F.identifier.id),A=ne.get(b);(!A||q(A,F,!1))&&ne.set(b,F)}),N?.forEach(F=>{const b=s.ExtensionIdentifier.toKey(F.identifier.id),A=ne.get(b);if(!A&&M&&F.type===0){this.s.debug(`Skipping obsolete system extension ${F.location.path}.`);return}(!A||q(A,F,!1))&&ne.set(b,F)}),U?.forEach(F=>{const b=s.ExtensionIdentifier.toKey(F.identifier.id),A=ne.get(b);(!A||q(A,F,!0))&&ne.set(b,F),ne.set(b,F)}),[...ne.values()]}async F(M,N){this.s.trace("Started scanning system extensions");const U=await this.I(this.systemExtensionsLocation,!1,0,!0,N),G=await(M&&!U.devMode?this.i:this.k).scanExtensions(U);return this.s.trace("Scanned system extensions:",G.length),G}async G(M,N){const U=this.t.isBuilt?[]:this.u.builtInExtensions;if(!U?.length)return[];this.s.trace("Started scanning dev system extensions");const V=N?await this.H():{},G=[],q=u.URI.file(E.normalize(E.join(m.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const F of U){const b=V[F.name]||"marketplace";switch(b){case"disabled":break;case"marketplace":G.push((0,I.joinPath)(q,F.name));break;default:G.push(u.URI.file(b));break}}const ne=await Promise.all(G.map(async F=>this.k.scanExtension(await this.I(F,!1,0,!0,M))));return this.s.trace("Scanned dev system extensions:",ne.length),(0,O.coalesce)(ne)}async H(){try{const M=await this.r.readFile(this.l);return JSON.parse(M.value.toString())}catch{return{}}}async I(M,N,U,V,G,q=!0){const ne=await this.f(G??p.language),F=await this.J(M),b=N&&!this.v.extUri.isEqual(M,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,A=b?await this.J(b):void 0;return new se(M,F,b,A,N,U,V,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,G,ne)}async J(M){try{const N=await this.r.stat(M);if(typeof N.mtime=="number")return N.mtime}catch{}}};ie=de([ee(4,R.IUserDataProfilesService),ee(5,d.IExtensionsProfileScannerService),ee(6,n.IFileService),ee(7,r.ILogService),ee(8,w.IEnvironmentService),ee(9,o.IProductService),ee(10,j.IUriIdentityService),ee(11,t.IInstantiationService)],ie),e.AbstractExtensionsScannerService=ie;class se{constructor(M,N,U,V,G,q,ne,F,b,A,C,B,$,_){this.location=M,this.mtime=N,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=V,this.profile=G,this.type=q,this.excludeObsolete=ne,this.validate=F,this.productVersion=b,this.productDate=A,this.productCommit=C,this.devMode=B,this.language=$,this.translations=_}static createNlsConfiguration(M){return{language:M.language,pseudo:M.language==="pseudo",devMode:M.devMode,translations:M.translations}}static equals(M,N){return(0,I.isEqual)(M.location,N.location)&&M.mtime===N.mtime&&(0,I.isEqual)(M.applicationExtensionslocation,N.applicationExtensionslocation)&&M.applicationExtensionslocationMtime===N.applicationExtensionslocationMtime&&M.profile===N.profile&&M.type===N.type&&M.excludeObsolete===N.excludeObsolete&&M.validate===N.validate&&M.productVersion===N.productVersion&&M.productDate===N.productDate&&M.productCommit===N.productCommit&&M.devMode===N.devMode&&M.language===N.language&&J.equals(M.translations,N.translations)}}let Q=class extends l.Disposable{constructor(M,N,U,V,G){super(),this.f=M,this.g=N,this.h=U,this.i=V,this.j=G}async scanExtensions(M){const N=M.profile?await this.l(M):await this.k(M);let U={};if(M.excludeObsolete&&M.type===1)try{const V=(await this.i.readFile(this.f)).value.toString();U=JSON.parse(V)}catch{}return(0,y.isEmptyObject)(U)?N:N.filter(V=>!U[f.ExtensionKey.create(V).toString()])}async k(M){const N=await this.i.resolve(M.location);if(!N.children?.length)return[];const U=await Promise.all(N.children.map(async V=>{if(!V.isDirectory||M.type===1&&(0,I.basename)(V.resource).indexOf(".")===0)return null;const G=new se(V.resource,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(G)}));return(0,O.coalesce)(U).sort((V,G)=>V.location.path<G.location.path?-1:1)}async l(M){let N=await this.m(M.location,()=>!0,M);if(M.applicationExtensionslocation&&!this.h.extUri.isEqual(M.location,M.applicationExtensionslocation)){N=N.filter(V=>!V.metadata?.isApplicationScoped);const U=await this.m(M.applicationExtensionslocation,V=>!!V.metadata?.isApplicationScoped,M);N.push(...U)}return N}async m(M,N,U){const V=await this.g.scanProfileExtensions(M);if(!V.length)return[];const G=await Promise.all(V.map(async q=>{if(N(q)){const ne=new se(q.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(ne,q.metadata)}return null}));return(0,O.coalesce)(G)}async scanOneOrMultipleExtensions(M){try{if(await this.i.exists((0,I.joinPath)(M.location,"package.json"))){const N=await this.scanExtension(M);return N?[N]:[]}else return await this.scanExtensions(M)}catch(N){return this.j.error(`Error scanning extensions at ${M.location.path}:`,(0,L.getErrorMessage)(N)),[]}}async scanExtension(M,N){try{let U=await this.scanExtensionManifest(M.location);if(U){U.publisher||(U.publisher=s.UNDEFINED_PUBLISHER),N=N??U.__metadata,delete U.__metadata;const V=(0,f.getGalleryExtensionId)(U.publisher,U.name),G=N?.id?{id:V,uuid:N.id}:{id:V},q=N?.isSystem?0:M.type,ne=q===0||!!N?.isBuiltin;K.ImplicitActivationEvents.updateManifest(U),U=await this.n(M.location,U,se.createNlsConfiguration(M));const F={type:q,identifier:G,manifest:U,location:M.location,isBuiltin:ne,targetPlatform:N?.targetPlatform??"undefined",metadata:N,isValid:!0,validations:[]};return M.validate?this.validate(F,M):F}}catch(U){M.type!==0&&this.j.error(U)}return null}validate(M,N){let U=!0;const V=(0,i.validateExtensionManifest)(N.productVersion,N.productDate,N.location,M.manifest,M.isBuiltin);for(const[G,q]of V)G===S.default.Error&&(U=!1,this.j.error(this.t(N.location,q)));return M.isValid=U,M.validations=V,M}async scanExtensionManifest(M){const N=(0,I.joinPath)(M,"package.json");let U;try{U=(await this.i.readFile(N)).value.toString()}catch(G){return(0,n.toFileOperationResult)(G)!==1&&this.j.error(this.t(M,(0,h.localize)(0,null,N.path,G.message))),null}let V;try{V=JSON.parse(U)}catch{const q=[];(0,P.parse)(U,q);for(const ne of q)this.j.error(this.t(M,(0,h.localize)(1,null,N.path,ne.offset,ne.length,(0,g.getParseErrorMessage)(ne.error))));return null}return(0,P.getNodeType)(V)!=="object"?(this.j.error(this.t(M,(0,h.localize)(2,null,N.path))),null):V}async n(M,N,U){const V=await this.p(M,N,U);if(V)try{const G=[],q=await this.r(V.default,G);if(G.length>0)return G.forEach(F=>{this.j.error(this.t(M,(0,h.localize)(3,null,V.default?.path,(0,g.getParseErrorMessage)(F.error))))}),N;if((0,P.getNodeType)(V)!=="object")return this.j.error(this.t(M,(0,h.localize)(4,null,V.default?.path))),N;const ne=V.values||Object.create(null);return(0,x.localizeManifest)(N,ne,q)}catch{}return N}async p(M,N,U){const V=(0,I.joinPath)(M,"package.nls.json"),G=(b,A)=>{A.forEach(C=>{this.j.error(this.t(M,(0,h.localize)(5,null,b?.path,(0,g.getParseErrorMessage)(C.error))))})},q=b=>{this.j.error(this.t(M,(0,h.localize)(6,null,b?.path)))},ne=`${N.publisher}.${N.name}`,F=U.translations[ne];if(F)try{const b=u.URI.file(F),A=(await this.i.readFile(b)).value.toString(),C=[],B=(0,P.parse)(A,C);return C.length>0?(G(b,C),{values:void 0,default:V}):(0,P.getNodeType)(B)!=="object"?(q(b),{values:void 0,default:V}):{values:B.contents?B.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.i.exists(V))return;let A;try{A=await this.s(M,U)}catch{return}if(!A.localized)return{values:void 0,default:A.original};try{const C=(await this.i.readFile(A.localized)).value.toString(),B=[],$=(0,P.parse)(C,B);return B.length>0?(G(A.localized,B),{values:void 0,default:A.original}):(0,P.getNodeType)($)!=="object"?(q(A.localized),{values:void 0,default:A.original}):{values:$,default:A.original}}catch{return{values:void 0,default:A.original}}}}async r(M,N){if(M)try{const U=(await this.i.readFile(M)).value.toString();return(0,P.parse)(U,N)}catch{}}s(M,N){return new Promise((U,V)=>{const G=q=>{const ne=(0,I.joinPath)(M,`package.nls.${q}.json`);this.i.exists(ne).then(F=>{F&&U({localized:ne,original:(0,I.joinPath)(M,"package.nls.json")});const b=q.lastIndexOf("-");b===-1?U({localized:(0,I.joinPath)(M,"package.nls.json"),original:null}):(q=q.substring(0,b),G(q))})};if(N.devMode||N.pseudo||!N.language)return U({localized:(0,I.joinPath)(M,"package.nls.json"),original:null});G(N.language)})}t(M,N){return`[${M.path}]: ${N}`}};Q=de([ee(1,d.IExtensionsProfileScannerService),ee(2,j.IUriIdentityService),ee(3,n.IFileService),ee(4,r.ILogService)],Q);let ge=class extends Q{constructor(M,N,U,V,G,q){super(N,U,V,G,q),this.y=M,this.v=this.B(new D.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(M){const N=await this.C();if(this.u=M,N&&N.input&&se.equals(N.input,this.u))return this.v.trigger(()=>this.F()),N.result.map(V=>(V.location=u.URI.revive(V.location),V));const U=await super.scanExtensions(M);return await this.D({input:M,result:U}),U}async C(){try{const M=await this.i.readFile(this.y),N=JSON.parse(M.value.toString());return{result:N.result,input:(0,a.revive)(N.input)}}catch(M){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,L.getErrorMessage)(M))}return null}async D(M){try{await this.i.writeFile(this.y,T.VSBuffer.fromString(JSON.stringify(M)))}catch(N){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,L.getErrorMessage)(N))}}async F(){if(!this.u)return;const M=await this.C();if(!M)return;const N=M.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!k.equals(U,N))try{await this.i.del(this.y),this.w.fire()}catch(V){this.j.error(V)}}};ge=de([ee(2,d.IExtensionsProfileScannerService),ee(3,j.IUriIdentityService),ee(4,n.IFileService),ee(5,r.ILogService)],ge);function ce(me,M){const N=(0,f.getExtensionId)(me.manifest.publisher,me.manifest.name);return{id:N,identifier:new s.ExtensionIdentifier(N),isBuiltin:me.type===0,isUserBuiltin:me.type===1&&me.isBuiltin,isUnderDevelopment:M,extensionLocation:me.location,uuid:me.identifier.uuid,targetPlatform:me.targetPlatform,...me.manifest}}e.toExtensionDescription=ce;class oe extends ie{constructor(M,N,U,V,G,q,ne,F,b,A,C,B){super(M,N,(0,I.joinPath)(U,".vscode-oss-dev","extensions","control.json"),(0,I.joinPath)(V,s.MANIFEST_CACHE_FOLDER),G,q,ne,F,b,A,C,B),this.L=(async()=>{if(p.translationsConfigFile)try{const $=await this.r.readFile(u.URI.file(p.translationsConfigFile));return JSON.parse($.value.toString())}catch{}return Object.create(null)})()}f(M){return this.L}}e.NativeExtensionsScannerService=oe}),define(Y[143],Z([0,1,57,4,32,3,2,16,15,20,9,25]),function(W,e,O,D,k,T,L,P,g,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends L.Disposable{constructor(v,S){super(),this.b=v,this.f=S,this.a=new D.Limiter(5)}async postUninstall(v){const S=this.g(v,"uninstall");return S&&(this.f.info(v.identifier.id,v.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(S.script,"uninstall",S.args,!0,v).then(()=>this.f.info(v.identifier.id,v.manifest.version,"Finished running post uninstall script"),y=>this.f.error(v.identifier.id,v.manifest.version,`Failed to run post uninstall script: ${y}`)))),l.Promises.rm(this.j(v)).then(void 0,y=>this.f.error("Error while removing extension storage path",y))}g(v,S){const y=`vscode:${S}`;if(v.location.scheme===P.Schemas.file&&v.manifest&&v.manifest.scripts&&typeof v.manifest.scripts[y]=="string"){const u=v.manifest.scripts[y].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(v.identifier.id,v.manifest.version,`${y} should be a node script`),null):{script:(0,g.join)(v.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(v,S,y,u,h){return new Promise((w,f)=>{const s=this.i(v,S,y,h);let i;const n=t=>{i&&(clearTimeout(i),i=null),t?f(t):w(void 0)};s.on("error",t=>{n((0,k.toErrorMessage)(t)||"Unknown")}),s.on("exit",(t,r)=>{n(t?`post-${S} process exited with code ${t}`:void 0)}),u&&(i=setTimeout(()=>{i=null,s.kill(),f("timed out")},5e3))})}i(v,S,y,u){const h={silent:!0,execArgv:void 0},w=(0,O.fork)(v,[`--type=extension-post-${S}`,...y],h);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const f=T.Event.fromNodeEventEmitter(w.stdout,"data"),s=T.Event.fromNodeEventEmitter(w.stderr,"data");f(t=>this.f.info(u.identifier.id,u.manifest.version,`post-${S}`,t)),s(t=>this.f.error(u.identifier.id,u.manifest.version,`post-${S}`,t));const i=T.Event.any(T.Event.map(f,t=>({data:`%c${t}`,format:[""]})),T.Event.map(s,t=>({data:`%c${t}`,format:["color: red"]})));return T.Event.debounce(i,(t,r)=>t?{data:t.data+r.data,format:[...t.format,...r.format]}:{data:r.data,format:r.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),w}j(v){return(0,g.join)(this.b.defaultProfile.globalStorageHome.fsPath,v.identifier.id.toLowerCase())}};p=de([ee(0,E.IUserDataProfilesService),ee(1,m.ILogService)],p),e.ExtensionsLifecycle=p}),define(Y[144],Z([0,1,11,18,41,48,13,7,9,28,30,25]),function(W,e,O,D,k,T,L,P,g,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends T.NativeExtensionsScannerService{constructor(v,S,y,u,h,w,f,s){super(O.URI.file(h.builtinExtensionsPath),O.URI.file(h.extensionsPath),h.userHome,O.URI.file(h.userDataPath),v,S,y,u,h,w,f,s)}};p=de([ee(0,E.IUserDataProfilesService),ee(1,k.IExtensionsProfileScannerService),ee(2,L.IFileService),ee(3,g.ILogService),ee(4,D.INativeEnvironmentService),ee(5,l.IProductService),ee(6,m.IUriIdentityService),ee(7,P.IInstantiationService)],p),e.ExtensionsScannerService=p}),define(Y[145],Z([0,1,4,3,2,115,8,80,7,25]),function(W,e,O,D,k,T,L,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var m;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(m=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var p;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));function I(h){const w=h.get(e.TARGET_KEY);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}e.loadKeyTargets=I;class v extends k.Disposable{constructor(w={flushInterval:v.a}){super(),this.j=w,this.b=this.B(new D.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new D.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new O.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new k.MutableDisposable),this.u=void 0,this.w=void 0,this.C=void 0}k(){this.i.value=(0,O.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.J()}finally{(0,T.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(w,f){if(f===e.TARGET_KEY){switch(w){case-1:this.C=void 0;break;case 0:this.w=void 0;break;case 1:this.u=void 0;break}this.c.fire({scope:w})}else this.b.fire({scope:w,key:f,target:this.F(w)[f]})}emitWillSaveState(w){this.f.fire({reason:w})}get(w,f,s){return this.L(f)?.get(w,s)}getBoolean(w,f,s){return this.L(f)?.getBoolean(w,s)}getNumber(w,f,s){return this.L(f)?.getNumber(w,s)}store(w,f,s,i){if((0,L.isUndefinedOrNull)(f)){this.remove(w,s);return}this.r(()=>{this.t(w,s,i),this.L(s)?.set(w,f)})}remove(w,f){this.r(()=>{this.t(w,f,void 0),this.L(f)?.delete(w)})}r(w){this.b.pause(),this.c.pause();try{w()}finally{this.b.resume(),this.c.resume()}}keys(w,f){const s=[],i=this.F(w);for(const n of Object.keys(i))i[n]===f&&s.push(n);return s}t(w,f,s){const i=this.F(f);typeof s=="number"?i[w]!==s&&(i[w]=s,this.L(f)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[w]=="number"&&(delete i[w],this.L(f)?.set(e.TARGET_KEY,JSON.stringify(i)))}get v(){return this.u||(this.u=this.G(1)),this.u}get y(){return this.w||(this.w=this.G(0)),this.w}get D(){return this.C||(this.C=this.G(-1)),this.C}F(w){switch(w){case-1:return this.D;case 0:return this.y;default:return this.v}}G(w){const f=this.L(w);return f?I(f):Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(w=m.NONE){this.f.fire({reason:w});const f=this.L(-1),s=this.L(0),i=this.L(1);switch(w){case m.NONE:await O.Promises.settled([f?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await O.Promises.settled([f?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.L(-1)?.items??new Map,f=this.L(0)?.items??new Map,s=this.L(1)?.items??new Map;return u(w,f,s,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(w,f){return this.emitWillSaveState(m.NONE),(0,l.isUserDataProfile)(w)?this.N(w,f):this.O(w,f)}H(w,f){return!(w.id===f.id||S(f)&&S(w))}I(w,f,s,i){this.r(()=>{if(i)for(const[n,t]of w)f.set(n,t);else{const n=new Set;for(const[t,r]of w)n.add(t),f.get(t)!==r&&this.n(s,t);for(const[t]of f.items)n.has(t)||this.n(s,t)}})}}e.AbstractStorageService=v,v.a=60*1e3;function S(h){return h.isDefault||!!h.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class y extends v{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase)),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase)),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase)),this.B(this.Q.onDidChangeStorage(w=>this.n(1,w))),this.B(this.P.onDidChangeStorage(w=>this.n(0,w))),this.B(this.p.onDidChangeStorage(w=>this.n(-1,w)))}L(w){switch(w){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(w){return!1}}e.InMemoryStorageService=y;async function u(h,w,f,s,i,n){const t=K=>{try{return JSON.parse(K)}catch{return K}},r=new Map,o=new Map;h.forEach((K,J)=>{r.set(J,K),o.set(J,t(K))});const c=new Map,a=new Map;w.forEach((K,J)=>{c.set(J,K),a.set(J,t(K))});const d=new Map,R=new Map;f.forEach((K,J)=>{d.set(J,K),R.set(J,t(K))}),console.group(s!==i?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const j=[];if(r.forEach((K,J)=>{j.push({key:J,value:K})}),console.table(j),console.groupEnd(),console.log(o),s!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const K=[];c.forEach((J,ie)=>{K.push({key:ie,value:J})}),console.table(K),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${n})`);const x=[];d.forEach((K,J)=>{x.push({key:J,value:K})}),console.table(x),console.groupEnd(),console.log(R)}e.logStorage=u}),define(Y[146],Z([0,1,19,22,10,12,33,8,11,21,18,23,24,45,13,9,28,47,134,145,36]),function(W,e,O,D,k,T,L,P,g,l,m,E,p,I,v,S,y,u,h,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=T.isWeb?"web":(0,E.getTargetPlatform)(T.platform,L.arch);var i;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished",F[F.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...F){return String(F.reduce((b,A)=>b|A,0))}var t;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class d{constructor(b=a){this.d=b}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(b,A=this.d.pageSize){return new d({...this.d,pageNumber:b,pageSize:A})}withFilter(b,...A){const C=[...this.d.criteria,...A.length?A.map(B=>({filterType:b,value:B})):[{filterType:b}]];return new d({...this.d,criteria:C})}withSortBy(b){return new d({...this.d,sortBy:b})}withSortOrder(b){return new d({...this.d,sortOrder:b})}withFlags(...b){return new d({...this.d,flags:b.reduce((A,C)=>A|C,0)})}withAssetTypes(...b){return new d({...this.d,assetTypes:b})}withSource(b){return new d({...this.d,source:b})}get raw(){const{criteria:b,pageNumber:A,pageSize:C,sortBy:B,sortOrder:$,flags:_,assetTypes:re}=this.d;return{filters:[{criteria:b,pageNumber:A,pageSize:C,sortBy:B,sortOrder:$}],assetTypes:re,flags:_}}get searchText(){const b=this.d.criteria.filter(A=>A.filterType===t.SearchText)[0];return b&&b.value?b.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(b=>String(b.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function R(F,b){const A=(F||[]).filter(C=>C.statisticName===b)[0];return A?A.value:0}function j(F){const b="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(C=>C.assetType.indexOf(b)===0).reduce((C,B)=>{const $=J(F,B.assetType);return $&&C.push([B.assetType.substring(b.length),$]),C},[])}function x(F){if(F.properties){const b=F.properties.filter(B=>B.key===r.Repository),A=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),C=b.filter(B=>A.test(B.value))[0];return C?{uri:C.value,fallbackUri:C.value}:null}return J(F,r.Repository)}function K(F){return{uri:`${F.fallbackAssetUri}/${r.VSIX}?redirect=true${F.targetPlatform?`&targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${r.VSIX}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}}function J(F,b){return F.files.filter(C=>C.assetType===b)[0]?{uri:`${F.assetUri}/${b}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${b}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}:null}function ie(F,b){const A=F.properties?F.properties.filter(B=>B.key===b):[],C=A.length>0&&A[0].value;return C?C.split(",").map(B=>(0,p.adoptToGalleryExtensionId)(B)):[]}function se(F){const b=F.properties?F.properties.filter(A=>A.key===o.Engine):[];return b.length>0&&b[0].value||""}function Q(F){const b=F.properties?F.properties.filter(A=>A.key===o.PreRelease):[];return b.length>0&&b[0].value==="true"}function ge(F){const b=F.properties?F.properties.filter(C=>C.key===o.LocalizedLanguages):[],A=b.length>0&&b[0].value||"";return A?A.split(","):[]}function ce(F){return F.properties?.find(b=>b.key===o.SponsorLink)?.value}function oe(F){return F.indexOf("preview")!==-1}function me(F){return F.targetPlatform?(0,E.toTargetPlatform)(F.targetPlatform):"undefined"}function M(F){const b=(0,O.distinct)(F.versions.map(me)),A=!!F.tags?.includes(E.WEB_EXTENSION_TAG),C=b.indexOf("web");return A?C===-1&&b.push("web"):C!==-1&&b.splice(C,1),b}function N(F,b){const A=(0,E.getFallbackTargetPlarforms)(b);for(let C=0;C<F.length;C++){const B=F[C];if(B.version===F[C-1]?.version){let $=C;const _=me(B);if(_===b)for(;$>0&&F[$-1].version===B.version;)$--;else if(A.includes(_))for(;$>0&&F[$-1].version===B.version&&me(F[$-1])!==b;)$--;$!==C&&(F.splice(C,1),F.splice($,0,B))}}return F}e.sortExtensionVersions=N;function U(F,b,A){F.telemetryData={index:b,querySource:A}}function V(F,b,A){const C=F.versions[0],B={manifest:J(b,r.Manifest),readme:J(b,r.Details),changelog:J(b,r.Changelog),license:J(b,r.License),repository:x(b),download:K(b),icon:J(b,r.Icon),signature:J(b,r.Signature),coreTranslations:j(b)};return{identifier:{id:(0,p.getGalleryExtensionId)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:b.version,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,publisherDomain:F.publisher.domain?{link:F.publisher.domain,verified:!!F.publisher.isDomainVerified}:void 0,publisherSponsorLink:ce(C),description:F.shortDescription||"",installCount:R(F.statistics,"install"),rating:R(F.statistics,"averagerating"),ratingCount:R(F.statistics,"ratingcount"),categories:F.categories||[],tags:F.tags||[],releaseDate:Date.parse(F.releaseDate),lastUpdated:Date.parse(F.lastUpdated),allTargetPlatforms:A,assets:B,properties:{dependencies:ie(b,o.Dependency),extensionPack:ie(b,o.ExtensionPack),engine:se(b),localizedLanguages:ge(b),targetPlatform:me(b),isPreReleaseVersion:Q(b)},hasPreReleaseVersion:Q(C),hasReleaseVersion:!0,preview:oe(F.flags),isSigned:!!B.signature}}let G=class{constructor(b,A,C,B,$,_,re,ue){this.k=A,this.l=C,this.n=B,this.o=$,this.q=_,this.u=re,this.w=ue;const ve=re.extensionsGallery,ae=ve?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=ae?ve.servicePPEUrl:ve?.serviceUrl,this.g=ae?void 0:ve?.searchUrl,this.h=ve?.controlUrl,this.j=(0,h.resolveMarketplaceHeaders)(re.version,re,this.n,this.w,this.q,b,this.o)}x(b=""){return`${this.d}${b}`}isEnabled(){return!!this.d}async getExtensions(b,A,C){const B=D.CancellationToken.isCancellationToken(A)?{}:A,$=D.CancellationToken.isCancellationToken(A)?A:C,_=[],re=[],ue=[],ve=[];let ae=!0;for(const le of b){le.uuid?re.push(le.uuid):_.push(le.id);const ye=!!(le.version||le.preRelease);ue.push({id:le.id,uuid:le.uuid,includePreRelease:ye}),le.version&&ve.push({id:le.id,uuid:le.uuid,version:le.version}),ae=ae&&!!le.hasPreRelease&&!ye}if(!re.length&&!_.length)return[];let te=new d().withPage(1,b.length);re.length&&(te=te.withFilter(t.ExtensionId,...re)),_.length&&(te=te.withFilter(t.ExtensionName,..._)),(B.queryAllVersions||ae)&&(te=te.withFlags(te.flags,i.IncludeVersions)),B.source&&(te=te.withSource(B.source));const{extensions:fe}=await this.A(te,{targetPlatform:B.targetPlatform??s,includePreRelease:ue,versions:ve,compatible:!!B.compatible},$);return B.source&&fe.forEach((le,ye)=>U(le,ye,B.source)),fe}async getCompatibleExtension(b,A,C){if((0,E.isNotWebExtensionInWebTargetPlatform)(b.allTargetPlatforms,C))return null;if(await this.isExtensionCompatible(b,A,C))return b;const B=new d().withFlags(i.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,b.identifier.uuid),{extensions:$}=await this.A(B,{targetPlatform:C,compatible:!0,includePreRelease:A},D.CancellationToken.None);return $[0]||null}async isExtensionCompatible(b,A,C){if(!(0,E.isTargetPlatformCompatible)(b.properties.targetPlatform,b.allTargetPlatforms,C)||!A&&b.properties.isPreReleaseVersion)return!1;let B=b.properties.engine;if(!B){const $=await this.getManifest(b,D.CancellationToken.None);if(!$)throw new Error("Manifest was not found");B=$.engines.vscode}return(0,I.isEngineValid)(B,this.u.version,this.u.date)}async y(b,A,C,B,$){if(!(0,E.isTargetPlatformCompatible)(me(b),B,$)||A!=="any"&&Q(b)!==(A==="prerelease"))return!1;if(C)try{const _=await this.F(b);if(!(0,I.isEngineValid)(_,this.u.version,this.u.date))return!1}catch(_){return this.l.error(`Error while getting the engine for the version ${b.version}.`,(0,k.getErrorMessage)(_)),!1}return!0}async query(b,A){let C=b.text||"";const B=b.pageSize??50;let $=new d().withPage(1,B);C?(C=C.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ae,te,fe)=>($=$.withFilter(t.Category,fe||te),"")),C=C.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ae,te,fe)=>($=$.withFilter(t.Tag,fe||te),"")),C=C.replace(/\bfeatured(\s+|\b|$)/g,()=>($=$.withFilter(t.Featured),"")),C=C.trim(),C&&(C=C.length<200?C:C.substring(0,200),$=$.withFilter(t.SearchText,C)),$=$.withSortBy(0)):b.ids?$=$.withFilter(t.ExtensionId,...b.ids):b.names?$=$.withFilter(t.ExtensionName,...b.names):$=$.withSortBy(4),typeof b.sortBy=="number"&&($=$.withSortBy(b.sortBy)),typeof b.sortOrder=="number"&&($=$.withSortOrder(b.sortOrder)),b.source&&($=$.withSource(b.source));const _=async(ae,te)=>{const{extensions:fe,total:le}=await this.A(ae,{targetPlatform:s,compatible:!1,includePreRelease:!!b.includePreRelease},te);return fe.forEach((ye,Re)=>U(ye,(ae.pageNumber-1)*ae.pageSize+Re,b.source)),{extensions:fe,total:le}},{extensions:re,total:ue}=await _($,A),ve=async(ae,te)=>{if(te.isCancellationRequested)throw new k.CancellationError;const{extensions:fe}=await _($.withPage(ae+1),te);return fe};return{firstPage:re,total:ue,pageSize:$.pageSize,getPage:ve}}async A(b,A,C){const B=b.flags;!!(b.flags&i.IncludeLatestVersionOnly)&&!!(b.flags&i.IncludeVersions)&&(b=b.withFlags(b.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(b.flags&i.IncludeLatestVersionOnly)&&!(b.flags&i.IncludeVersions)&&(b=b.withFlags(b.flags,i.IncludeLatestVersionOnly)),A.versions?.length&&(b=b.withFlags(b.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),b=b.withFlags(b.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:$,total:_}=await this.C(b,C);if(!(b.flags&i.IncludeLatestVersionOnly)){const ae=[];for(const te of $){const fe=await this.B(te,A);fe&&ae.push(fe)}return{extensions:ae,total:_}}const ue=[],ve=new Map;for(let ae=0;ae<$.length;ae++){const te=$[ae],fe={id:(0,p.getGalleryExtensionId)(te.publisher.publisherName,te.extensionName),uuid:te.extensionId},le=(0,P.isBoolean)(A.includePreRelease)?A.includePreRelease:!!A.includePreRelease.find(Re=>(0,p.areSameExtensions)(Re,fe))?.includePreRelease;if(A.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(M(te),A.targetPlatform))continue;const ye=await this.B(te,A);!ye||ye.properties.isPreReleaseVersion&&(!le||!ye.hasReleaseVersion)||!ye.properties.isPreReleaseVersion&&ye.properties.targetPlatform!==A.targetPlatform&&ye.hasPreReleaseVersion?ve.set(te.extensionId,ae):ue.push([ae,ye])}if(ve.size){const ae=new Date().getTime(),te=new d().withFlags(B&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ve.size).withFilter(t.ExtensionId,...ve.keys()),{extensions:fe}=await this.A(te,A,C);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ae,count:ve.size});for(const le of fe){const ye=ve.get(le.identifier.uuid);ue.push([ye,le])}}return{extensions:ue.sort((ae,te)=>ae[0]-te[0]).map(([,ae])=>ae),total:_}}async B(b,A){const C={id:(0,p.getGalleryExtensionId)(b.publisher.publisherName,b.extensionName),uuid:b.extensionId},B=A.versions?.find(ue=>(0,p.areSameExtensions)(ue,C))?.version,$=(0,P.isBoolean)(A.includePreRelease)?A.includePreRelease:!!A.includePreRelease.find(ue=>(0,p.areSameExtensions)(ue,C))?.includePreRelease,_=M(b),re=N(b.versions,A.targetPlatform);if(A.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(_,A.targetPlatform))return null;for(let ue=0;ue<re.length;ue++){const ve=re[ue];if(!(B&&ve.version!==B)){if(await this.y(ve,$?"any":"release",A.compatible,_,A.targetPlatform))return V(b,ve,_);if(B&&ve.version===B)return null}}return B||A.compatible?null:V(b,b.versions[0],_)}async C(b,A){if(!this.isEnabled())throw new Error("No extension gallery service configured.");b=b.withFlags(b.flags,i.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,n(i.Unpublished));const C=await this.j,B=JSON.stringify(b.raw),$={...C,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)},_=new Date().getTime();let re,ue,ve=0;try{if(re=await this.k.request({type:"POST",url:this.g&&b.criteria.some(te=>te.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:B,headers:$},A),re.res.statusCode&&re.res.statusCode>=400&&re.res.statusCode<500)return{galleryExtensions:[],total:ve};const ae=await(0,u.asJson)(re);if(ae){const te=ae.results[0],fe=te.extensions,le=te.resultMetadata&&te.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return ve=le&&le.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:fe,total:ve}}return{galleryExtensions:[],total:ve}}catch(ae){throw ue=ae,ae}finally{this.o.publicLog2("galleryService:query",{...b.telemetryData,requestBodySize:String(B.length),duration:new Date().getTime()-_,success:!!re&&(0,u.isSuccess)(re),responseBodySize:re?.res.headers["Content-Length"],statusCode:re?String(re.res.statusCode):void 0,errorCode:ue?(0,k.isCancellationError)(ue)?"canceled":(0,k.getErrorMessage)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(b,A,C,B){if(!this.isEnabled())return;const $=T.isWeb?this.x(`/itemName/${b}.${A}/version/${C}/statType/${B==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${b}/extensions/${A}/${C}/stats?statType=${B}`),_=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:_};try{await this.k.request({type:"POST",url:$,headers:ue},D.CancellationToken.None)}catch{}}async download(b,A,C){this.l.trace("ExtensionGalleryService#download",b.identifier.id);const B=(0,p.getGalleryExtensionTelemetryData)(b),$=new Date().getTime(),_=ae=>this.o.publicLog("galleryService:downloadVSIX",{...B,duration:ae}),re=C===2?"install":C===3?"update":"",ue=re?{uri:`${b.assets.download.uri}${g.URI.parse(b.assets.download.uri).query?"&":"?"}${re}=true`,fallbackUri:`${b.assets.download.fallbackUri}${g.URI.parse(b.assets.download.fallbackUri).query?"&":"?"}${re}=true`}:b.assets.download,ve=await this.E(ue);await this.q.writeFile(A,ve.stream),_(new Date().getTime()-$)}async downloadSignatureArchive(b,A){if(!b.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",b.identifier.id);const C=await this.E(b.assets.signature);await this.q.writeFile(A,C.stream)}async getReadme(b,A){if(b.assets.readme){const C=await this.E(b.assets.readme,{},A);return await(0,u.asTextOrError)(C)||""}return""}async getManifest(b,A){if(b.assets.manifest){const C=await this.E(b.assets.manifest,{},A),B=await(0,u.asTextOrError)(C);return B?JSON.parse(B):null}return null}async D(b,A){const C=J(b,r.Manifest);if(!C)throw new Error("Manifest was not found");const B={"Accept-Encoding":"gzip"},$=await this.E(C,{headers:B});return await(0,u.asJson)($)}async getCoreTranslation(b,A){const C=b.assets.coreTranslations.filter(B=>B[0]===A.toUpperCase())[0];if(C){const B=await this.E(C[1]),$=await(0,u.asTextOrError)(B);return $?JSON.parse($):null}return null}async getChangelog(b,A){if(b.assets.changelog){const C=await this.E(b.assets.changelog,{},A);return await(0,u.asTextOrError)(C)||""}return""}async getAllCompatibleVersions(b,A,C){let B=new d().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);b.identifier.uuid?B=B.withFilter(t.ExtensionId,b.identifier.uuid):B=B.withFilter(t.ExtensionName,b.identifier.id);const{galleryExtensions:$}=await this.C(B,D.CancellationToken.None);if(!$.length)return[];const _=M($[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(_,C))return[];const re=[];await Promise.all($[0].versions.map(async ae=>{try{await this.y(ae,A?"any":"release",!0,_,C)&&re.push(ae)}catch{}}));const ue=[],ve=new Set;for(const ae of N(re,C))ve.has(ae.version)||(ve.add(ae.version),ue.push({version:ae.version,date:ae.lastUpdated,isPreReleaseVersion:Q(ae)}));return ue}async E(b,A={},C=D.CancellationToken.None){const B=await this.j,$={type:"GET"},_={...B,...A.headers||{}};A={...A,...$,headers:_};const re=b.uri,ue=b.fallbackUri,ve={...A,url:re};try{const ae=await this.k.request(ve,C);if(ae.res.statusCode===200)return ae;const te=await(0,u.asTextOrError)(ae);throw new Error(`Expected 200, got back ${ae.res.statusCode} instead.

${te}`)}catch(ae){if((0,k.isCancellationError)(ae))throw ae;const te=(0,k.getErrorMessage)(ae);this.o.publicLog2("galleryService:cdnFallback",{url:re,message:te});const fe={...A,url:ue};return this.k.request(fe,C)}}async F(b){let A=se(b);if(!A){const C=await this.D(b,D.CancellationToken.None);if(!C)throw new Error("Manifest was not found");A=C.engines.vscode}return A}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const b=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(b.res.statusCode!==200)throw new Error("Could not get extensions report.");const A=await(0,u.asJson)(b),C=[],B={};if(A){for(const $ of A.malicious)C.push({id:$});if(A.migrateToPreRelease)for(const[$,_]of Object.entries(A.migrateToPreRelease))(!_.engine||(0,I.isEngineValid)(_.engine,this.u.version,this.u.date))&&(B[$.toLowerCase()]={disallowInstall:!0,extension:{id:_.id,displayName:_.displayName,autoMigrate:{storage:!!_.migrateStorage},preRelease:!0}});if(A.deprecated)for(const[$,_]of Object.entries(A.deprecated))_&&(B[$.toLowerCase()]=(0,P.isBoolean)(_)?{}:_)}return{malicious:C,deprecated:B}}};G=de([ee(1,u.IRequestService),ee(2,S.ILogService),ee(3,m.IEnvironmentService),ee(4,f.ITelemetryService),ee(5,v.IFileService),ee(6,y.IProductService),ee(7,l.IConfigurationService)],G);let q=class extends G{constructor(b,A,C,B,$,_,re,ue){super(b,A,C,B,$,_,re,ue)}};q=de([ee(0,w.IStorageService),ee(1,u.IRequestService),ee(2,S.ILogService),ee(3,m.IEnvironmentService),ee(4,f.ITelemetryService),ee(5,v.IFileService),ee(6,y.IProductService),ee(7,l.IConfigurationService)],q),e.ExtensionGalleryService=q;let ne=class extends G{constructor(b,A,C,B,$,_,re){super(void 0,b,A,C,B,$,_,re)}};ne=de([ee(0,u.IRequestService),ee(1,S.ILogService),ee(2,m.IEnvironmentService),ee(3,f.ITelemetryService),ee(4,v.IFileService),ee(5,y.IProductService),ee(6,l.IConfigurationService)],ne),e.ExtensionGalleryServiceWithNoStorageService=ne}),define(Y[147],Z([0,1,44,18,13,9,66,30,25]),function(W,e,O,D,k,T,L,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let l=class $e extends g.UserDataProfilesService{constructor(E,p,I,v,S){super(I,v,p,S),this.a=E}I(){return(0,O.revive)(this.a.getItem($e.b,[]))}L(){return(0,O.revive)(this.a.getItem($e.c,{}))}};l=de([ee(0,L.IStateService),ee(1,P.IUriIdentityService),ee(2,D.IEnvironmentService),ee(3,k.IFileService),ee(4,T.ILogService)],l),e.UserDataProfilesService=l}),define(Y[148],Z([0,1,37,4,161,2,9]),function(W,e,O,D,k,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=class extends O.AbstractPolicyService{constructor(l,m){super(),this.j=l,this.k=m,this.a=new D.Throttler,this.b=this.B(new T.MutableDisposable)}async i(l){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${l.length} policy definitions`),await this.a.queue(()=>new Promise((m,E)=>{try{this.b.value=(0,k.createWatcher)(this.k,l,p=>{this.m(p),m()})}catch(p){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),E(p)}}))}m(l){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${Object.keys(l).join(", ")}`);for(const m in l){const E=l[m];E===void 0?this.g.delete(m):this.g.set(m,E)}this.h.fire(Object.keys(l))}};P=de([ee(0,L.ILogService)],P),e.NativePolicyService=P}),define(Y[68],Z([0,1,117,4,15,8,20,81,162,163]),function(W,e,O,D,k,T,L,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class m extends Error{constructor(i,n){let t=n.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=n}}e.ExtractError=m;function E(s){const i=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>i&n).reduce((n,t)=>n+t,i&61440)}function p(s){if(s instanceof m)return s;let i;return/end of central directory record signature not found/.test(s.message)&&(i="CorruptZip"),new m(i,s)}function I(s,i,n,t,r,o){const c=k.dirname(i),a=k.join(t,c);if(!a.startsWith(t))return Promise.reject(new Error(P.localize(0,null,i)));const d=k.join(t,i);let R;return o.onCancellationRequested(()=>{R?.destroy()}),Promise.resolve(L.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((j,x)=>{if(!o.isCancellationRequested)try{R=(0,O.createWriteStream)(d,{mode:n}),R.once("close",()=>j()),R.once("error",x),s.once("error",x),s.pipe(R)}catch(K){x(K)}}))}function v(s,i,n,t){let r=(0,D.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((c,a)=>{const d=new D.Sequencer,R=j=>{j.isCancellationRequested||(o++,s.readEntry())};s.once("error",a),s.once("close",()=>r.then(()=>{t.isCancellationRequested||s.entryCount===o?c():a(new m("Incomplete",new Error(P.localize(1,null,o,s.entryCount))))},a)),s.readEntry(),s.on("entry",j=>{if(t.isCancellationRequested)return;if(!n.sourcePathRegex.test(j.fileName)){R(t);return}const x=j.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(x)){const ie=k.join(i,x);r=(0,D.createCancelablePromise)(se=>L.Promises.mkdir(ie,{recursive:!0}).then(()=>R(se)).then(void 0,a));return}const K=y(s,j),J=E(j);r=(0,D.createCancelablePromise)(ie=>d.queue(()=>K.then(se=>I(se,x,J,i,n,ie).then(()=>R(ie)))).then(null,a))})})}function S(s,i=!1){return new Promise((n,t)=>{(0,g.open)(s,i?{lazyEntries:!0}:void 0,(r,o)=>{r?t(p(r)):n((0,T.assertIsDefined)(o))})})}function y(s,i){return new Promise((n,t)=>{s.openReadStream(i,(r,o)=>{r?t(p(r)):n((0,T.assertIsDefined)(o))})})}function u(s,i){return new Promise((n,t)=>{const r=new l.ZipFile;i.forEach(c=>{c.contents?r.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&r.addFile(c.localPath,c.path)}),r.end();const o=(0,O.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>n(s))})}e.zip=u;function h(s,i,n={},t){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=S(s,!0);return n.overwrite&&(o=o.then(c=>L.Promises.rm(i).then(()=>c))),o.then(c=>v(c,i,{sourcePathRegex:r},t))}e.extract=h;function w(s,i){return S(s).then(n=>new Promise((t,r)=>{n.on("entry",o=>{o.fileName===i&&y(n,o).then(c=>t(c),c=>r(c))}),n.once("close",()=>r(new Error(P.localize(2,null,i))))}))}function f(s,i){return w(s,i).then(n=>new Promise((t,r)=>{const o=[];n.once("error",r),n.on("data",c=>o.push(c)),n.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=f}),define(Y[149],Z([0,1,68,89]),function(W,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(T){return(0,O.buffer)(T,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.getManifest=k}),define(Y[150],Z([0,1,4,14,22,32,10,3,2,34,16,15,12,17,39,8,11,31,20,68,88,58,18,142,23,24,41,48,125,143,149,126,127,29,45,13,7,9,28,36,30,25]),function(W,e,O,D,k,T,L,P,g,l,m,E,p,I,v,S,y,u,h,w,f,s,i,n,t,r,o,c,a,d,R,j,x,K,J,ie,se,Q,ge,ce,oe,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,se.refineServiceDecorator)(t.IExtensionManagementService);let M=class extends n.AbstractExtensionManagementService{constructor(b,A,C,B,$,_,re,ue,ve,ae,te,fe){super(b,A,C,ae,fe),this.ab=$,this.bb=_,this.cb=re,this.db=ve,this.eb=te,this.Y=new Map,this.mb=new l.ResourceSet;const le=this.B(ue.createInstance(d.ExtensionsLifecycle));this.U=this.B(ue.createInstance(N,Re=>le.postUninstall(Re))),this.W=this.B(new j.ExtensionsManifestCache(B,this)),this.X=this.B(ue.createInstance(a.ExtensionsDownloader));const ye=this.B(new x.ExtensionsWatcher(this,fe,_,te,ve,C));this.B(ye.onDidChangeExtensionsByAnotherSource(Re=>this.lb(Re))),this.nb()}getTargetPlatform(){return this.fb||(this.fb=(0,r.computeTargetPlatform)(this.db,this.v)),this.fb}async zip(b){this.v.trace("ExtensionManagementService#zip",b.identifier.id);const A=await this.kb(b),C=await(0,w.zip)((0,I.joinPath)(this.X.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,A);return y.URI.file(C)}async unzip(b){return this.v.trace("ExtensionManagementService#unzip",b.toString()),(await this.install(b)).identifier}async getManifest(b){const{location:A,cleanup:C}=await this.gb(b),B=E.resolve(A.fsPath);try{return await(0,R.getManifest)(B)}finally{await C()}}getInstalled(b,A){return this.U.scanExtensions(b??null,A)}getAllUserInstalled(){return this.U.scanAllUserExtensions(!1)}async install(b,A={}){this.v.trace("ExtensionManagementService#install",b.toString());const{location:C,cleanup:B}=await this.gb(b);try{const $=await(0,R.getManifest)(E.resolve(C.fsPath));if($.engines&&$.engines.vscode&&!(0,J.isEngineValid)($.engines.vscode,this.w.version,this.w.date))throw new Error(f.localize(0,null,(0,r.getGalleryExtensionId)($.publisher,$.name),this.w.version));return await this.C($,C,A)}finally{await B()}}getMetadata(b){return this.ab.scanMetadata(b.location)}async updateMetadata(b,A){this.v.trace("ExtensionManagementService#updateMetadata",b.identifier.id);const C={...A};return A.isPreReleaseVersion&&(C.preRelease=!0),b=await this.U.updateMetadata(b,C),this.W.invalidate(),b}async updateExtensionScope(b,A){return this.v.trace("ExtensionManagementService#updateExtensionScope",b.identifier.id),b=await this.U.updateMetadata(b,{isMachineScoped:A}),this.W.invalidate(),b}async reinstallFromGallery(b){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",b.identifier.id),!this.t.isEnabled())throw new Error(f.localize(1,null));const A=await this.getTargetPlatform(),[C]=await this.t.getExtensions([{...b.identifier,preRelease:b.preRelease}],{targetPlatform:A,compatible:!0},k.CancellationToken.None);if(!C)throw new Error(f.localize(2,null));await this.U.setUninstalled(b);try{await this.U.removeUninstalledExtension(b)}catch(B){throw new Error(f.localize(3,null,(0,T.toErrorMessage)(B)))}await this.installFromGallery(C)}markAsUninstalled(...b){return this.U.setUninstalled(...b)}removeUninstalledExtensions(){return this.U.cleanUp()}migrateDefaultProfileExtensions(){return this.U.migrateDefaultProfileExtensions()}async download(b,A){const{location:C}=await this.X.download(b,A);return C}async gb(b){if(b.scheme===m.Schemas.file)return{location:b,async cleanup(){}};this.v.trace("Downloading extension from",b.toString());const A=(0,I.joinPath)(this.X.extensionsDownloadDir,(0,u.generateUuid)());return await this.cb.download(b,A),this.v.info("Downloaded extension to",A.toString()),{location:A,cleanup:async()=>{try{await this.db.del(A)}catch(B){this.v.error(B)}}}}Q(){return this.y.defaultProfile.extensionsResource}R(b,A,C){let B;if(y.URI.isUri(A))B=new G(b,A,C,this.t,this.U,this.v);else{const $=r.ExtensionKey.create(A).toString();B=this.Y.get($),B||(this.Y.set($,B=new V(b,A,C,this.X,this.U,this.v)),B.waitUntilTaskIsFinished().then(()=>this.Y.delete($)))}return new q(B,C.profileLocation,this.bb)}S(b,A){return new ne(b,A.profileLocation,this.bb)}async kb(b){const A=async B=>{let $=await h.Promises.readdir(B);$=$.map(ue=>E.join(B,ue));const _=await Promise.all($.map(ue=>h.Promises.stat(ue)));let re=Promise.resolve([]);return _.forEach((ue,ve)=>{const ae=$[ve];ue.isFile()&&(re=re.then(te=>[...te,ae])),ue.isDirectory()&&(re=re.then(te=>A(ae).then(fe=>[...te,...fe])))}),re};return(await A(b.location.fsPath)).map(B=>({path:`extension/${E.relative(b.location.fsPath,B)}`,localPath:B}))}async lb({added:b,removed:A}){if(A)for(const C of A.extensions)this.v.info("Extensions removed from another source",C.id,A.profileLocation.toString()),this.p.fire({identifier:C,profileLocation:A.profileLocation});if(b){const B=(await this.U.scanExtensions(1,b.profileLocation)).filter($=>b.extensions.some(_=>(0,r.areSameExtensions)(_,$.identifier)));this.m.fire(B.map($=>(this.v.info("Extensions added from another source",$.identifier.id,b.profileLocation.toString()),{identifier:$.identifier,local:$,profileLocation:b.profileLocation,operation:1})))}}async nb(){this.B(this.U.onExtract(A=>this.mb.add(A)));const b=await this.db.resolve(this.ab.userExtensionsLocation);for(const A of b.children??[])A.isDirectory&&this.mb.add(A.resource);this.B(this.db.watch(this.ab.userExtensionsLocation)),this.B(this.db.onDidFilesChange(A=>this.ob(A)))}async ob(b){const A=[];for(const C of b.rawAdded){if(this.mb.has(C)||!this.eb.extUri.isEqual(this.eb.extUri.dirname(C),this.ab.userExtensionsLocation)||this.eb.extUri.isEqual(C,this.eb.extUri.joinPath(this.ab.userExtensionsLocation,".obsolete"))||this.eb.extUri.basename(C).startsWith(".")||!(await this.db.stat(C)).isDirectory)continue;const B=await this.U.scanUserExtensionAtLocation(C);B&&B.installedTimestamp===void 0&&(this.mb.add(C),A.push(B))}A.length&&(await this.bb.addExtensionsToProfile(A.map(C=>[C,void 0]),this.y.defaultProfile.extensionsResource),this.m.fire(A.map(C=>({local:C,version:C.manifest.version,identifier:C.identifier,operation:1,profileLocation:this.y.defaultProfile.extensionsResource}))))}};M=de([ee(0,t.IExtensionGalleryService),ee(1,ce.ITelemetryService),ee(2,Q.ILogService),ee(3,i.INativeEnvironmentService),ee(4,c.IExtensionsScannerService),ee(5,o.IExtensionsProfileScannerService),ee(6,s.IDownloadService),ee(7,se.IInstantiationService),ee(8,ie.IFileService),ee(9,ge.IProductService),ee(10,oe.IUriIdentityService),ee(11,me.IUserDataProfilesService)],M),e.ExtensionManagementService=M;let N=class extends g.Disposable{constructor(b,A,C,B,$,_){super(),this.j=b,this.k=A,this.l=C,this.m=B,this.n=$,this.p=_,this.h=this.B(new P.Emitter),this.onExtract=this.h.event,this.C=void 0,this.c=(0,I.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new O.Queue}async cleanUp(){await this.y()}async scanExtensions(b,A){await this.migrateDefaultProfileExtensions();const C={includeInvalid:!0,profileLocation:A};let B=[];return b===null||b===0?B.push(...await this.l.scanAllExtensions({includeInvalid:!0},C,!1)):b===1&&B.push(...await this.l.scanUserExtensions(C)),B=b!==null?B.filter($=>$.type===b):B,Promise.all(B.map($=>this.w($)))}async scanAllUserExtensions(b){const A=await this.l.scanUserExtensions({includeAllVersions:!b,includeInvalid:!0});return Promise.all(A.map(C=>this.w(C)))}async scanUserExtensionAtLocation(b){try{const A=await this.l.scanExistingExtension(b,1,{includeInvalid:!0});if(A)return await this.w(A)}catch(A){this.p.error(A)}return null}async extractUserExtension(b,A,C,B){await this.migrateDefaultProfileExtensions();const $=b.toString(),_=E.join(this.l.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),re=E.join(this.l.userExtensionsLocation.fsPath,$);try{await h.Promises.rm(re)}catch{throw new t.ExtensionManagementError(f.localize(4,null,re,b.id),t.ExtensionManagementErrorCode.Delete)}await this.t(b,A,_,B),await this.l.updateMetadata(y.URI.file(_),C);try{this.h.fire(y.URI.file(re)),await this.u(b,_,re,Date.now()+2*60*1e3),this.p.info("Renamed to",re)}catch(ue){try{await h.Promises.rm(_)}catch{}if(ue.code==="ENOTEMPTY")this.p.info("Rename failed because extension was installed by another source. So ignoring renaming.",b.id);else throw this.p.info(`Rename failed because of ${(0,L.getErrorMessage)(ue)}. Deleted from extracted location`,_),ue}return this.v(y.URI.file(re),1)}async updateMetadata(b,A){return await this.l.updateMetadata(b.location,A),this.v(b.location,b.type)}getUninstalledExtensions(){return this.s()}async setUninstalled(...b){const A=b.map(C=>r.ExtensionKey.create(C));await this.s(C=>A.forEach(B=>{C[B.toString()]=!0,this.p.info("Marked extension as uninstalled",B.toString())}))}async setInstalled(b){await this.s(B=>delete B[b.toString()]);const C=(await this.scanAllUserExtensions(!0)).find(B=>r.ExtensionKey.create(B).equals(b))||null;return C?this.updateMetadata(C,{installedTimestamp:Date.now()}):null}async removeExtension(b,A){this.p.trace(`Deleting ${A} extension from disk`,b.identifier.id,b.location.fsPath),await h.Promises.rm(b.location.fsPath),this.p.info("Deleted from disk",b.identifier.id,b.location.fsPath)}async removeUninstalledExtension(b){await this.removeExtension(b,"uninstalled"),await this.s(A=>delete A[r.ExtensionKey.create(b).toString()])}async s(b){return this.g.queue(async()=>{let A;try{A=await h.Promises.readFile(this.c,"utf8")}catch(B){if(B.code!=="ENOENT")throw B}let C={};if(A)try{C=JSON.parse(A)}catch{}return b&&(b(C),Object.keys(C).length?await h.Promises.writeFile(this.c,JSON.stringify(C)):await h.Promises.rm(this.c)),C})}async t(b,A,C,B){this.p.trace(`Started extracting the extension from ${A} to ${C}`);try{await h.Promises.rm(C)}catch($){throw new t.ExtensionManagementError(this.D($).message,t.ExtensionManagementErrorCode.Delete)}try{await(0,w.extract)(A,C,{sourcePath:"extension",overwrite:!0},B),this.p.info(`Extracted extension to ${C}:`,b.id)}catch($){try{await h.Promises.rm(C)}catch{}let _=t.ExtensionManagementErrorCode.Extract;throw $ instanceof w.ExtractError&&($.type==="CorruptZip"?_=t.ExtensionManagementErrorCode.CorruptZip:$.type==="Incomplete"&&(_=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError($.message,_)}}async u(b,A,C,B){try{await h.Promises.rename(A,C)}catch($){if(p.isWindows&&$&&$.code==="EPERM"&&Date.now()<B)return this.p.info(`Failed renaming ${A} to ${C} with 'EPERM' error. Trying again...`,b.id),this.u(b,A,C,B);throw new t.ExtensionManagementError($.message||f.localize(5,null,A,C),$.code||t.ExtensionManagementErrorCode.Rename)}}async v(b,A){const C=await this.l.scanExistingExtension(b,A,{includeInvalid:!0});if(C)return this.w(C);throw new Error(f.localize(6,null,b.path))}async w(b){const A=await this.k.resolve(b.location);let C,B;return A.children&&(C=A.children.find(({name:$})=>/^readme(\.txt|\.md|)$/i.test($))?.resource,B=A.children.find(({name:$})=>/^changelog(\.txt|\.md|)$/i.test($))?.resource),{identifier:b.identifier,type:b.type,isBuiltin:b.isBuiltin||!!b.metadata?.isBuiltin,location:b.location,manifest:b.manifest,targetPlatform:b.targetPlatform,validations:b.validations,isValid:b.isValid,readmeUrl:C,changelogUrl:B,publisherDisplayName:b.metadata?.publisherDisplayName||null,publisherId:b.metadata?.publisherId||null,isApplicationScoped:!!b.metadata?.isApplicationScoped,isMachineScoped:!!b.metadata?.isMachineScoped,isPreReleaseVersion:!!b.metadata?.isPreReleaseVersion,preRelease:!!b.metadata?.preRelease,installedTimestamp:b.metadata?.installedTimestamp,updated:!!b.metadata?.updated}}async y(){const b=await this.getUninstalledExtensions(),A=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),C=new Set;for(const _ of A)b[r.ExtensionKey.create(_).toString()]||C.add(_.identifier.id.toLowerCase());const B=(0,r.groupByExtension)(A,_=>_.identifier);await O.Promises.settled(B.map(async _=>{const re=_.sort((ue,ve)=>v.rcompare(ue.manifest.version,ve.manifest.version))[0];C.has(re.identifier.id.toLowerCase())||await this.j(await this.w(re))}));const $=A.filter(_=>b[r.ExtensionKey.create(_).toString()]);await O.Promises.settled($.map(_=>this.removeUninstalledExtension(_)))}migrateDefaultProfileExtensions(){return this.C||(this.C=(async()=>{try{const b=(0,I.joinPath)(this.m.defaultProfile.location,".migrated-default-profile");if(await this.k.exists(b))return;if(!await this.k.exists(this.m.defaultProfile.extensionsResource)){this.p.info("Started migrating default profile extensions from extensions installation folder to extensions manifest.");const A=await this.l.scanUserExtensions({includeInvalid:!0});await this.n.addExtensionsToProfile(A.map(C=>[C,C.metadata]),this.m.defaultProfile.extensionsResource),this.p.info("Completed migrating default profile extensions from extensions installation folder to extensions manifest.")}try{await this.k.createFile(b,D.VSBuffer.fromString(""))}catch(A){this.p.warn("Failed to create migration marker file for default profile extensions migration.",(0,L.getErrorMessage)(A))}}catch(b){throw this.p.error(b),b}})()),this.C}D(b){const A=Array.isArray(b)?b:[b];return A.length===1?A[0]instanceof Error?A[0]:new Error(A[0]):A.reduce((C,B)=>new Error(`${C.message}${C.message?",":""}${B instanceof Error?B.message:B}`),new Error(""))}};N=de([ee(1,ie.IFileService),ee(2,c.IExtensionsScannerService),ee(3,me.IUserDataProfilesService),ee(4,o.IExtensionsProfileScannerService),ee(5,Q.ILogService)],N),e.ExtensionsScanner=N;class U extends n.AbstractExtensionTask{get operation(){return(0,S.isUndefined)(this.k.operation)?this.j:this.k.operation}constructor(b,A,C,B,$){super(),this.identifier=b,this.source=A,this.k=C,this.l=B,this.m=$,this.wasVerified=!1,this.j=2}async n(b,A){try{const C=await this.o(b.key);if(C)return this.l.updateMetadata(C,b.metadata)}catch{throw p.isMacintosh?new t.ExtensionManagementError(f.localize(7,null),t.ExtensionManagementErrorCode.Internal):new t.ExtensionManagementError(f.localize(8,null),t.ExtensionManagementErrorCode.Internal)}return this.q(b,A)}async o(b){if(!await this.p(b))return null;this.m.trace("Removing the extension from uninstalled list:",b.id);const C=await this.l.setInstalled(b);return this.m.info("Removed the extension from uninstalled list:",b.id),C}async p(b){return!!(await this.l.getUninstalledExtensions())[b.toString()]}async q({zipPath:b,key:A,metadata:C},B){const $=await this.l.extractUserExtension(A,b,C,B);return this.m.info("Extracting completed.",A.id),$}}class V extends U{constructor(b,A,C,B,$,_){super(A.identifier,A,C,$,_),this.s=b,this.t=A,this.u=B}async h(b){const C=(await this.l.scanExtensions(null,void 0)).find(re=>(0,r.areSameExtensions)(re.identifier,this.t.identifier));C&&(this.j=3);const B={id:this.t.identifier.uuid,publisherId:this.t.publisherId,publisherDisplayName:this.t.publisherDisplayName,targetPlatform:this.t.properties.targetPlatform,isApplicationScoped:(0,K.isApplicationScopedExtension)(this.s),isMachineScoped:this.k.isMachineScoped||C?.isMachineScoped,isBuiltin:this.k.isBuiltin||C?.isBuiltin,isSystem:C?.type===0?!0:void 0,updated:!!C,isPreReleaseVersion:this.t.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.t.properties.isPreReleaseVersion||((0,S.isBoolean)(this.k.installPreReleaseVersion)?this.k.installPreReleaseVersion:C?.preRelease)};if(C?.manifest.version===this.t.version)return{local:await this.l.updateMetadata(C,B),metadata:B};const{location:$,verified:_}=await this.u.download(this.t,this.j);try{return this.wasVerified=!!_,this.w($.fsPath),{local:await this.n({zipPath:$.fsPath,key:r.ExtensionKey.create(this.t),metadata:B},b),metadata:B}}catch(re){try{await this.u.delete($)}catch(ue){this.m.warn("Error while deleting the downloaded file",$.toString(),(0,L.getErrorMessage)(ue))}throw re}}async w(b){try{await(0,R.getManifest)(b)}catch(A){throw new t.ExtensionManagementError((0,n.joinErrors)(A).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=V;class G extends U{constructor(b,A,C,B,$,_){super({id:(0,r.getGalleryExtensionId)(b.publisher,b.name)},A,C,$,_),this.s=b,this.t=A,this.u=B}async h(b){const A=new r.ExtensionKey(this.identifier,this.s.version),B=(await this.l.scanExtensions(1,void 0)).find(re=>(0,r.areSameExtensions)(this.identifier,re.identifier)),$=await this.w(this.identifier.id,this.s.version,b);if($.isApplicationScoped=(0,K.isApplicationScopedExtension)(this.s),$.isMachineScoped=this.k.isMachineScoped||B?.isMachineScoped,$.isBuiltin=this.k.isBuiltin||B?.isBuiltin,$.installedTimestamp=Date.now(),B)if(this.j=3,A.equals(new r.ExtensionKey(B.identifier,B.manifest.version)))try{await this.l.removeExtension(B,"existing")}catch{throw new Error(f.localize(9,null,this.s.displayName||this.s.name))}else!this.k.profileLocation&&v.gt(B.manifest.version,this.s.version)&&await this.l.setUninstalled(B);else{const re=await this.o(A);if(re)try{await this.l.removeExtension(re,"existing")}catch{throw new Error(f.localize(10,null,this.s.displayName||this.s.name))}}return{local:await this.n({zipPath:E.resolve(this.t.fsPath),key:A,metadata:$},b),metadata:$}}async w(b,A,C){try{let[B]=await this.u.getExtensions([{id:b,version:A}],C);if(B||([B]=await this.u.getExtensions([{id:b}],C)),B)return{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId,isPreReleaseVersion:B.properties.isPreReleaseVersion,preRelease:B.properties.isPreReleaseVersion||this.k.installPreReleaseVersion}}catch{}return{}}}class q{constructor(b,A,C){this.d=b,this.g=A,this.h=C,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.j()}async j(){const b=await this.d.waitUntilTaskIsFinished();return await this.h.addExtensionsToProfile([[b.local,b.metadata]],this.g),b}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class ne extends n.AbstractExtensionTask{constructor(b,A,C){super(),this.extension=b,this.j=A,this.k=C}async h(b){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Y[151],Z([0,1,131,4,14,10,2,8,21,18,132,9,130,164]),function(W,e,O,D,k,T,L,P,g,l,m,E,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let v=class extends L.Disposable{constructor(y,u,h){super(),this.h=u,this.i=h,this.j(y.getValue()),this.B(y.onDidChangeConfiguration(()=>this.j(y.getValue()),this))}j(y){this.a=y.http&&y.http.proxy,this.b=!!(y.http&&y.http.proxyStrictSSL),this.f=y.http&&y.http.proxyAuthorization}async request(y,u){this.i.trace("RequestService#request (node) - begin",y.url);const{a:h,b:w}=this;let f;try{f=await(0,m.getResolvedShellEnv)(this.i,this.h.args,process.env)}catch(n){this.g||(this.g=!0,this.i.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...f},i=y.agent?y.agent:await(0,p.getProxyAgent)(y.url||"",s,{proxyUrl:h,strictSSL:w});y.agent=i,y.strictSSL=w,this.f&&(y.headers={...y.headers||{},"Proxy-Authorization":this.f});try{const n=await this.l(y,u);return this.i.trace("RequestService#request (node) - success",y.url),n}catch(n){throw this.i.trace("RequestService#request (node) - error",y.url,n),n}}async k(y){return((0,O.parse)(y.url).protocol==="https:"?await new Promise((w,f)=>{W(["https"],w,f)}):await new Promise((w,f)=>{W(["http"],w,f)})).request}l(y,u){return D.Promises.withAsyncBody(async(h,w)=>{const f=(0,O.parse)(y.url),s=y.getRawRequest?y.getRawRequest(y):await this.k(y),i={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,P.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(i.auth=y.user+":"+y.password);const n=s(i,t=>{const r=(0,P.isNumber)(y.followRedirects)?y.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&r>0&&t.headers.location)this.l({...y,url:t.headers.location,followRedirects:r-1},u).then(h,w);else{let o=t;t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,I.createGunzip)())),h({res:t,stream:(0,k.streamToBufferReadableStream)(o)})}});n.on("error",w),y.timeout&&n.setTimeout(y.timeout),y.data&&typeof y.data=="string"&&n.write(y.data),n.end(),u.onCancellationRequested(()=>{n.abort(),w(new T.CancellationError)})})}async resolveProxy(y){}};v=de([ee(0,g.IConfigurationService),ee(1,l.INativeEnvironmentService),ee(2,E.ILogService)],v),e.RequestService=v}),define(Y[165],Z([0,1,38,4,14,32,10,2,16,15,12,33,11,20,21,122,58,129,18,102,146,23,59,124,41,48,150,144,13,113,116,46,111,62,63,128,9,118,119,37,148,137,28,47,151,66,133,67,36,136,42,138,139,30,140,25,147]),function(W,e,O,D,k,T,L,P,g,l,m,E,p,I,v,S,y,u,h,w,f,s,i,n,t,r,o,c,a,d,R,j,x,K,J,ie,se,Q,ge,ce,oe,me,M,N,U,V,G,q,ne,F,b,A,C,B,$,_,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ue extends P.Disposable{constructor(te){super(),this.b=te,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[te,fe]=await this.f();return te.invokeFunction(async le=>{const ye=le.get(se.ILogService),Re=le.get(a.IFileService),Le=le.get(h.INativeEnvironmentService),Me=le.get(_.IUserDataProfilesService);ye.info("CLI main",this.b),this.g(ye),await this.h(Le,Re,Me,te),await Promise.all(fe.map(Ue=>{(0,D.raceTimeout)(Ue.flush(),1e3)}))})}async f(){const te=new K.ServiceCollection,fe={_serviceBrand:void 0,...me.default};te.set(M.IProductService,fe);const le=new w.NativeEnvironmentService(this.b,fe);te.set(h.INativeEnvironmentService,le),await Promise.all([le.appSettingsHome.fsPath,le.extensionsPath].map(Oe=>Oe?I.Promises.mkdir(Oe,{recursive:!0}):void 0));const ye=(0,se.getLogLevel)(le),Re=[];Re.push(new Q.SpdLogLogger("cli",(0,l.join)(le.logsPath,"cli.log"),!0,!1,ye)),ye===se.LogLevel.Trace&&Re.push(new se.ConsoleLogger(ye));const Le=this.B(new se.MultiplexLogService(Re));te.set(se.ILogService,Le);const Me=this.B(new d.FileService(Le));te.set(a.IFileService,Me);const Ue=this.B(new R.DiskFileSystemProvider(Le));Me.registerProvider(g.Schemas.file,Ue);const z=new G.StateService(le,Le,Me);te.set(V.IStateService,z);const H=new $.UriIdentityService(Me);te.set(B.IUriIdentityService,H);const X=new re.UserDataProfilesService(z,H,le,Me,Le);te.set(_.IUserDataProfilesService,X);const he=m.isWindows&&fe.win32RegValueName?this.B(new oe.NativePolicyService(Le,fe.win32RegValueName)):le.policyFile?this.B(new ge.FilePolicyService(le.policyFile,Me,Le)):new ce.NullPolicyService;te.set(ce.IPolicyService,he);const pe=this.B(new S.ConfigurationService(X.defaultProfile.settingsResource,Me,he,Le));te.set(v.IConfigurationService,pe),await Promise.all([z.init(),pe.initialize()]),X.setEnablement(fe.quality!=="stable"||pe.getValue(_.PROFILES_ENABLEMENT_CONFIG)),te.set(B.IUriIdentityService,new $.UriIdentityService(Me)),te.set(N.IRequestService,new j.SyncDescriptor(U.RequestService,void 0,!0)),te.set(y.IDownloadService,new j.SyncDescriptor(u.DownloadService,void 0,!0)),te.set(t.IExtensionsProfileScannerService,new j.SyncDescriptor(t.ExtensionsProfileScannerService,void 0,!0)),te.set(r.IExtensionsScannerService,new j.SyncDescriptor(c.ExtensionsScannerService,void 0,!0)),te.set(i.IExtensionSignatureVerificationService,new j.SyncDescriptor(i.ExtensionSignatureVerificationService,void 0,!0)),te.set(o.INativeServerExtensionManagementService,new j.SyncDescriptor(o.ExtensionManagementService,void 0,!0)),te.set(s.IExtensionGalleryService,new j.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),te.set(J.ILanguagePackService,new j.SyncDescriptor(ie.NativeLanguagePackService,void 0,!1));const ke=[],Se=(0,b.isInternalTelemetry)(fe,pe);if((0,b.supportsTelemetry)(fe,le)){fe.aiConfig&&fe.aiConfig.ariaKey&&ke.push(new A.OneDataSystemAppender(Se,"monacoworkbench",null,fe.aiConfig.ariaKey));const{installSourcePath:Oe}=le,Ie={appenders:ke,sendErrorTelemetry:!1,commonProperties:(async()=>{let Te;try{const je=await I.Promises.readFile(le.stateResource.fsPath);Te=JSON.parse(je.toString())[ne.machineIdKey]}catch(je){je.code!=="ENOENT"&&Le.error(je)}return(0,q.resolveCommonProperties)(Me,(0,O.release)(),(0,O.hostname)(),process.arch,fe.commit,fe.version,Te,Se,Oe)})(),piiPaths:(0,b.getPiiPathsFromEnvironment)(le)};te.set(ne.ITelemetryService,new j.SyncDescriptor(F.TelemetryService,[Ie],!1))}else te.set(ne.ITelemetryService,b.NullTelemetryService);return[new x.InstantiationService(te),ke]}g(te){(0,L.setUnexpectedErrorHandler)(fe=>{const le=(0,T.toErrorMessage)(fe,!0);!le||te.error(`[uncaught exception in CLI]: ${le}`)}),process.on("uncaughtException",fe=>(0,L.onUnexpectedError)(fe)),process.on("unhandledRejection",fe=>(0,L.onUnexpectedError)(fe))}async h(te,fe,le,ye){const Re=(te.args.profile?le.profiles.find(Le=>Le.name===te.args.profile)??le.defaultProfile:le.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(te,fe,this.b["install-source"]);if(this.b["list-extensions"])return ye.createInstance(n.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,Re);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Le={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Re};return ye.createInstance(n.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],Le,!!this.b.force)}else{if(this.b["uninstall-extension"])return ye.createInstance(n.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Re);if(this.b["locate-extension"])return ye.createInstance(n.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,C.buildTelemetryMessage)(te.appRoot,te.extensionsPath))}}i(te){return te.map(fe=>/\.vsix$/i.test(fe)?p.URI.file((0,l.isAbsolute)(fe)?fe:(0,l.join)((0,E.cwd)(),fe)):fe)}async j(te,fe,le){await fe.writeFile(p.URI.file(te.installSourcePath),k.VSBuffer.fromString(le.slice(0,30)))}}async function ve(ae){const te=new ue(ae);try{await te.run()}finally{te.dispose()}}e.main=ve})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d9a70c4236a8bde4fe7435df3ecdd333c7bc939c/core/vs/code/node/cliProcessMain.js.map
